    !     Code for Anisotropies in the Microwave Background
    !     by Antony Lewis (http://cosmologist.info/) and Anthony Challinor
    !     See readme.html for documentation. This is a sample driver routine that reads
    !     in one set of parameters and produdes the corresponding output.

    program driver
    use IniFile
    use CAMB
    use LambdaGeneral
    use Lensing
    use AMLUtils
    use Transfer
    use constants
    use Bispectrum
    use CAMBmain
    use NonLinear
#ifdef NAGF95
    use F90_UNIX
#endif
    implicit none

    Type(CAMBparams) P

    character(LEN=Ini_max_string_len) numstr, VectorFileName, &
        InputFile, ScalarFileName, TensorFileName, TotalFileName, LensedFileName,&
        LensedTotFileName, LensPotentialFileName,ScalarCovFileName
    integer i
    character(LEN=Ini_max_string_len) TransferFileNames(max_transfer_redshifts), &
        MatterPowerFileNames(max_transfer_redshifts), outroot, version_check
    real(dl) output_factor, nmassive

#ifdef WRITE_FITS
    character(LEN=Ini_max_string_len) FITSfilename
#endif

    logical bad

    InputFile = ''
    if (GetParamCount() /= 0)  InputFile = GetParam(1)
    if (InputFile == '') error stop 'No parameter input file'

    call Ini_Open(InputFile, 1, bad, .false.)
    if (bad) error stop 'Error opening parameter file'

    Ini_fail_on_not_found = .false.

    outroot = Ini_Read_String('output_root')
    if (outroot /= '') outroot = trim(outroot) // '_'

    highL_unlensed_cl_template = Ini_Read_String_Default('highL_unlensed_cl_template',highL_unlensed_cl_template)

    call CAMB_SetDefParams(P)

    P%WantScalars = Ini_Read_Logical('get_scalar_cls')
    P%WantVectors = Ini_Read_Logical('get_vector_cls',.false.)
    P%WantTensors = Ini_Read_Logical('get_tensor_cls',.false.)

    P%OutputNormalization=outNone
    output_factor = Ini_Read_Double('CMB_outputscale',1.d0)

    P%WantCls= P%WantScalars .or. P%WantTensors .or. P%WantVectors

    P%PK_WantTransfer=Ini_Read_Logical('get_transfer')

    AccuracyBoost  = Ini_Read_Double('accuracy_boost',AccuracyBoost)
    lAccuracyBoost = Ini_Read_Real('l_accuracy_boost',lAccuracyBoost)
    HighAccuracyDefault = Ini_Read_Logical('high_accuracy_default',HighAccuracyDefault)

    P%NonLinear = Ini_Read_Int('do_nonlinear',NonLinear_none)

    P%DoLensing = .false.
    if (P%WantCls) then
        if (P%WantScalars  .or. P%WantVectors) then
            P%Max_l = Ini_Read_Int('l_max_scalar')
            P%Max_eta_k = Ini_Read_Double('k_eta_max_scalar',P%Max_l*2._dl)
            if (P%WantScalars) then
                P%DoLensing = Ini_Read_Logical('do_lensing',.false.)
                if (P%DoLensing) lensing_method = Ini_Read_Int('lensing_method',1)
            end if
            if (P%WantVectors) then
                if (P%WantScalars .or. P%WantTensors) error stop 'Must generate vector modes on their own'
                i = Ini_Read_Int('vector_mode')
                if (i==0) then
                    vec_sig0 = 1
                    Magnetic = 0
                else if (i==1) then
                    Magnetic = -1
                    vec_sig0 = 0
                else
                    error stop 'vector_mode must be 0 (regular) or 1 (magnetic)'
                end if
            end if
        end if

        if (P%WantTensors) then
            P%Max_l_tensor = Ini_Read_Int('l_max_tensor')
            P%Max_eta_k_tensor =  Ini_Read_Double('k_eta_max_tensor',Max(500._dl,P%Max_l_tensor*2._dl))
        end if
    endif

    !  Read initial parameters.

    call DarkEnergy_ReadParams(DefIni)

    P%h0     = Ini_Read_Double('hubble')

    if (Ini_Read_Logical('use_physical',.false.)) then
        P%omegab = Ini_Read_Double('ombh2')/(P%H0/100)**2
        P%omegac = Ini_Read_Double('omch2')/(P%H0/100)**2
        P%omegan = Ini_Read_Double('omnuh2')/(P%H0/100)**2
        P%omegav = 1- Ini_Read_Double('omk') - P%omegab-P%omegac - P%omegan
    else
        P%omegab = Ini_Read_Double('omega_baryon')
        P%omegac = Ini_Read_Double('omega_cdm')
        P%omegav = Ini_Read_Double('omega_lambda')
        P%omegan = Ini_Read_Double('omega_neutrino')
    end if

    P%tcmb   = Ini_Read_Double('temp_cmb',COBE_CMBTemp)
    P%yhe    = Ini_Read_Double('helium_fraction',0.24_dl)
    P%Num_Nu_massless  = Ini_Read_Double('massless_neutrinos')

    P%Nu_mass_eigenstates = Ini_Read_Int('nu_mass_eigenstates',1)
    if (P%Nu_mass_eigenstates > max_nu) error stop 'too many mass eigenstates'

    numstr = Ini_Read_String('massive_neutrinos')
    read(numstr, *) nmassive
    if (abs(nmassive-nint(nmassive))>1e-6) error stop 'massive_neutrinos should now be integer (or integer array)'
    read(numstr,*, end=100, err=100) P%Nu_Mass_numbers(1:P%Nu_mass_eigenstates)
    P%Num_Nu_massive = sum(P%Nu_Mass_numbers(1:P%Nu_mass_eigenstates))

    if (P%Num_Nu_massive>0) then
        P%share_delta_neff = Ini_Read_Logical('share_delta_neff', .true.)
        numstr = Ini_Read_String('nu_mass_degeneracies')
        if (P%share_delta_neff) then
            if (numstr/='') write (*,*) 'WARNING: nu_mass_degeneracies ignored when share_delta_neff'
        else
            if (numstr=='') error stop 'must give degeneracies for each eigenstate if share_delta_neff=F'
            read(numstr,*) P%Nu_mass_degeneracies(1:P%Nu_mass_eigenstates)
        end if
        numstr = Ini_Read_String('nu_mass_fractions')
        if (numstr=='') then
            if (P%Nu_mass_eigenstates >1) error stop 'must give nu_mass_fractions for the eigenstates'
            P%Nu_mass_fractions(1)=1
        else
            read(numstr,*) P%Nu_mass_fractions(1:P%Nu_mass_eigenstates)
        end if
    end if

    !JD 08/13 begin changes for nonlinear lensing of CMB + LSS compatibility
    !P%Transfer%redshifts -> P%Transfer%PK_redshifts and P%Transfer%num_redshifts -> P%Transfer%PK_num_redshifts
    !in the P%WantTransfer loop.
    if (((P%NonLinear==NonLinear_lens .or. P%NonLinear==NonLinear_both) .and. P%DoLensing) .or. P%PK_WantTransfer) then
        P%Transfer%high_precision=  Ini_Read_Logical('transfer_high_precision',.false.)
    else
        P%transfer%high_precision = .false.
    endif
    if (P%PK_WantTransfer) then
        P%Transfer%accurate_massive_neutrinos = Ini_Read_Logical('accurate_massive_neutrino_transfers',.false.)
    else
        P%Transfer%accurate_massive_neutrinos = .false.
    end if

    if (P%NonLinear/=NonLinear_none) call NonLinear_ReadParams(DefIni)

    if (P%PK_WantTransfer)  then
        P%WantTransfer  = .true.
        P%transfer%kmax          =  Ini_Read_Double('transfer_kmax')
        P%transfer%k_per_logint  =  Ini_Read_Int('transfer_k_per_logint')
        P%transfer%PK_num_redshifts =  Ini_Read_Int('transfer_num_redshifts')

        transfer_interp_matterpower = Ini_Read_Logical('transfer_interp_matterpower', transfer_interp_matterpower)
        transfer_power_var = Ini_read_int('transfer_power_var',transfer_power_var)
        if (P%transfer%PK_num_redshifts > max_transfer_redshifts) error stop 'Too many redshifts'
        do i=1, P%transfer%PK_num_redshifts
            P%transfer%PK_redshifts(i)  = Ini_Read_Double_Array('transfer_redshift',i,0._dl)
            transferFileNames(i)     = Ini_Read_String_Array('transfer_filename',i)
            MatterPowerFilenames(i)  = Ini_Read_String_Array('transfer_matterpower',i)
            if (TransferFileNames(i) == '') then
                TransferFileNames(i) =  trim(numcat('transfer_',i))//'.dat'
            end if
            if (MatterPowerFilenames(i) == '') then
                MatterPowerFilenames(i) =  trim(numcat('matterpower_',i))//'.dat'
            end if
            if (TransferFileNames(i)/= '') &
                TransferFileNames(i) = trim(outroot)//TransferFileNames(i)
            if (MatterPowerFilenames(i) /= '') &
                MatterPowerFilenames(i)=trim(outroot)//MatterPowerFilenames(i)
        end do
    else
        P%Transfer%PK_num_redshifts = 1
        P%Transfer%PK_redshifts = 0
    end if

    if ((P%NonLinear==NonLinear_lens .or. P%NonLinear==NonLinear_both) .and. P%DoLensing) then
        P%WantTransfer  = .true.
        call Transfer_SetForNonlinearLensing(P%Transfer)
    end if

    call Transfer_SortAndIndexRedshifts(P%Transfer)
    !JD 08/13 end changes

    P%transfer%kmax=P%transfer%kmax*(P%h0/100._dl)

    Ini_fail_on_not_found = .false.

    DebugParam = Ini_Read_Double('DebugParam',DebugParam)
    ALens = Ini_Read_Double('Alens',Alens)

    call Reionization_ReadParams(P%Reion, DefIni)
    call InitialPower_ReadParams(P%InitPower, DefIni, P%WantTensors)
    call Recombination_ReadParams(P%Recomb, DefIni)
    if (Ini_HasKey('recombination')) then
        i = Ini_Read_Int('recombination',1)
        if (i/=1) error stop 'recombination option deprecated'
    end if

    call Bispectrum_ReadParams(BispectrumParams, DefIni, outroot)

    if (P%WantScalars .or. P%WantTransfer) then
        P%Scalar_initial_condition = Ini_Read_Int('initial_condition',initial_adiabatic)
        if (P%Scalar_initial_condition == initial_vector) then
            P%InitialConditionVector=0
            numstr = Ini_Read_String('initial_vector',.true.)
            read (numstr,*) P%InitialConditionVector(1:initial_iso_neutrino_vel)
        end if
        if (P%Scalar_initial_condition/= initial_adiabatic) use_spline_template = .false.
    end if

    if (P%WantScalars) then
        ScalarFileName = trim(outroot)//Ini_Read_String('scalar_output_file')
        LensedFileName =  trim(outroot) //Ini_Read_String('lensed_output_file')
        LensPotentialFileName =  Ini_Read_String('lens_potential_output_file')
        if (LensPotentialFileName/='') LensPotentialFileName = concat(outroot,LensPotentialFileName)
        ScalarCovFileName =  Ini_Read_String_Default('scalar_covariance_output_file','scalCovCls.dat',.false.)
        if (ScalarCovFileName/='') then
            has_cl_2D_array = .true.
            ScalarCovFileName = concat(outroot,ScalarCovFileName)
        end if
    end if
    if (P%WantTensors) then
        TensorFileName =  trim(outroot) //Ini_Read_String('tensor_output_file')
        if (P%WantScalars)  then
            TotalFileName =  trim(outroot) //Ini_Read_String('total_output_file')
            LensedTotFileName = Ini_Read_String('lensed_total_output_file')
            if (LensedTotFileName/='') LensedTotFileName= trim(outroot) //trim(LensedTotFileName)
        end if
    end if
    if (P%WantVectors) then
        VectorFileName =  trim(outroot) //Ini_Read_String('vector_output_file')
    end if

#ifdef WRITE_FITS
    if (P%WantCls) then
        FITSfilename =  trim(outroot) //Ini_Read_String('FITS_filename',.true.)
        if (FITSfilename /='') then
            inquire(file=FITSfilename, exist=bad)
            if (bad) then
                open(unit=18,file=FITSfilename,status='old')
                close(18,status='delete')
            end if
        end if
    end if
#endif


    Ini_fail_on_not_found = .false.

    !optional parameters controlling the computation

    P%AccuratePolarization = Ini_Read_Logical('accurate_polarization',.true.)
    P%AccurateReionization = Ini_Read_Logical('accurate_reionization',.false.)
    P%AccurateBB = Ini_Read_Logical('accurate_BB',.false.)
    if (P%AccurateBB .and. P%WantCls .and. (P%Max_l < 3500 .or. &
        (P%NonLinear/=NonLinear_lens .and. P%NonLinear/=NonLinear_both) .or. P%Max_eta_k < 18000)) &
        write(*,*) 'WARNING: for accurate lensing BB you need high l_max_scalar, k_eta_max_scalar and non-linear lensing'

    P%DerivedParameters = Ini_Read_Logical('derived_parameters',.true.)

    version_check = Ini_Read_String('version_check')
    if (version_check == '') then
        !tag the output used parameters .ini file with the version of CAMB being used now
        call TNameValueList_Add(DefIni%ReadValues, 'version_check', version)
    else if (version_check /= version) then
        write(*,*) 'WARNING: version_check does not match this CAMB version'
    end if
    !Mess here to fix typo with backwards compatibility
    if (Ini_HasKey('do_late_rad_trunction')) then
        DoLateRadTruncation = Ini_Read_Logical('do_late_rad_trunction',.true.)
        if (Ini_HasKey('do_late_rad_truncation')) error stop 'check do_late_rad_xxxx'
    else
        DoLateRadTruncation = Ini_Read_Logical('do_late_rad_truncation',.true.)
    end if

    if (HighAccuracyDefault) then
        DoTensorNeutrinos = .true.
    else
        DoTensorNeutrinos = Ini_Read_Logical('do_tensor_neutrinos',DoTensorNeutrinos )
    end if
    FeedbackLevel = Ini_Read_Int('feedback_level',FeedbackLevel)

    output_file_headers = Ini_Read_Logical('output_file_headers',output_file_headers)

    P%MassiveNuMethod  = Ini_Read_Int('massive_nu_approx',Nu_best)

    ThreadNum      = Ini_Read_Int('number_of_threads',ThreadNum)
    use_spline_template = Ini_Read_Logical('use_spline_template',use_spline_template)

    if (do_bispectrum) then
        lSampleBoost   = 50
    else
        lSampleBoost   = Ini_Read_Double('l_sample_boost',lSampleBoost)
    end if
    if (outroot /= '') then
        if (InputFile /= trim(outroot) //'params.ini') then
            call Ini_SaveReadValues(trim(outroot) //'params.ini',1)
        else
            write(*,*) 'Output _params.ini not created as would overwrite input'
        end if
    end if

    call Ini_Close

    if (.not. CAMB_ValidateParams(P)) error stop 'Stopped due to parameter error'

#ifdef RUNIDLE
    call SetIdle
#endif

    if (global_error_flag==0) call CAMB_GetResults(P)
    if (global_error_flag/=0) then
        write(*,*) 'Error result '//trim(global_error_message)
        error stop
    endif

    if (P%PK_WantTransfer) then
        call Transfer_SaveToFiles(MT,TransferFileNames)
        call Transfer_SaveMatterPower(MT,MatterPowerFileNames)
        call Transfer_output_sig8(MT)
    end if

    if (P%WantCls) then
        call output_cl_files(ScalarFileName, ScalarCovFileName, TensorFileName, TotalFileName, &
            LensedFileName, LensedTotFilename, output_factor)

        call output_lens_pot_files(LensPotentialFileName, output_factor)

        if (P%WantVectors) then
            call output_veccl_files(VectorFileName, output_factor)
        end if

#ifdef WRITE_FITS
        if (FITSfilename /= '') call WriteFitsCls(FITSfilename, CP%Max_l)
#endif
    end if

    call CAMB_cleanup
    stop

100 stop 'Must give num_massive number of integer physical neutrinos for each eigenstate'
    end program driver


#ifdef RUNIDLE
    !If in Windows and want to run with low priorty so can multitask
    subroutine SetIdle
    USE DFWIN
    Integer dwPriority
    Integer CheckPriority

    dwPriority = 64 ! idle priority
    CheckPriority = SetPriorityClass(GetCurrentProcess(), dwPriority)

    end subroutine SetIdle
#endif

    !     Code for Anisotropies in the Microwave Background
    !     by Antony Lewis (http://cosmologist.info/) and Anthony Challinor
    !     This is a sample driver routine that reads
    !     in one set of parameters and produdes the corresponding output.

    program driver
    use CAMB
    implicit none
    character(len=:), allocatable :: InputFile

    InputFile = ''
    if (GetParamCount() /= 0)  InputFile = GetParam(1)
    if (InputFile == '') error stop 'No parameter input file'

    call CAMB_CommandLineRun(InputFile)
    deallocate(InputFile) ! Just so no memory leaks in valgrind

    end program driver

    ! Equations module for dark energy with constant equation of state parameter w
    ! allowing for perturbations based on a quintessence model
    ! by Antony Lewis (http://cosmologist.info/)

    ! Dec 2003, fixed (fatal) bug in tensor neutrino setup
    ! Changes to tight coupling approximation
    ! June 2004, fixed problem with large scale polarized tensors; support for vector modes
    ! Generate vector modes on their own. The power spectrum is taken from the scalar parameters.
    ! August 2004, fixed reionization term in lensing potential
    ! Nov 2004, change massive neutrino l_max to be consistent with massless if light
    ! Apr 2005, added DoLateRadTruncation option
    ! June 2006, added support for arbitary neutrino mass splittings
    ! Nov 2006, tweak to high_precision transfer function accuracy at lowish k
    ! June 2011, improved radiation approximations from arXiv: 1104.2933; Some 2nd order tight coupling terms
    !            merged fderivs and derivs so flat and non-flat use same equations; more precomputed arrays
    !            optimized neutrino sampling, and reorganised neutrino integration functions
    ! Feb 2012, updated PPF version but now only simple case for w, w_a (no anisotropic stresses etc)
    ! Feb 2013: fixed various issues with accuracy at larger neutrino masses
    ! Oct 2013: fix PPF, consistent with updated equations_cross
    ! Mar 2014: fixes for tensors with massive neutrinos

    module LambdaGeneral
    use precision
    use  ModelParams
    implicit none

    real(dl)  :: w_lam = -1_dl !p/rho for the dark energy (assumed constant)
    ! w_lam is now w0
    !comoving sound speed. Always exactly 1 for quintessence
    !(otherwise assumed constant, though this is almost certainly unrealistic)
    real(dl) :: cs2_lam = 1_dl
    !cs2_lam now is ce^2

    logical :: use_tabulated_w = .false.
    real(dl) :: wa_ppf = 0._dl
    real(dl) :: c_Gamma_ppf = 0.4_dl
    integer, parameter :: nwmax = 5000, nde = 2000
    integer :: nw_ppf
    real(dl) w_ppf(nwmax), a_ppf(nwmax), ddw_ppf(nwmax)
    real(dl) rde(nde),ade(nde),ddrde(nde)
    real(dl), parameter :: amin = 1.d-9
    logical :: is_cosmological_constant
    private nde,ddw_ppf,rde,ade,ddrde,amin

    contains

    subroutine DarkEnergy_ReadParams(Ini)
    use IniFile
    Type(TIniFile) :: Ini
    character(LEN=Ini_max_string_len) wafile
    integer i

    if (Ini_HasKey_File(Ini,'usew0wa')) then
        stop 'input variables changed from usew0wa: now use_tabulated_w or w, wa'
    end if

    use_tabulated_w = Ini_Read_Logical_File(Ini,'use_tabulated_w',.false.)
    if(.not. use_tabulated_w)then
        w_lam = Ini_Read_Double_File(Ini,'w', -1.d0)
        wa_ppf = Ini_Read_Double_File(Ini,'wa', 0.d0)
        if (Feedback >0) write(*,'("(w0, wa) = (", f8.5,", ", f8.5, ")")') w_lam,wa_ppf
    else
        wafile = Ini_Read_String_File(Ini,'wafile')
        open(unit=10,file=wafile,status='old')
        nw_ppf=0
        do i=1,nwmax+1
            read(10,*,end=100)a_ppf(i),w_ppf(i)
            a_ppf(i)=dlog(a_ppf(i))
            nw_ppf=nw_ppf+1
        enddo
        write(*,'("Note: ", a, " has more than ", I8, " data points")') trim(wafile), nwmax
        write(*,*)'Increase nwmax in LambdaGeneral'
        stop
100     close(10)
        write(*,'("read in ", I8, " (a, w) data points from ", a)') nw_ppf, trim(wafile)
        call setddwa
        call interpolrde
    endif
    cs2_lam = Ini_Read_Double_File(Ini,'cs2_lam',1.d0)
    call setcgammappf

    end subroutine DarkEnergy_ReadParams


    subroutine setddwa
    real(dl), parameter :: wlo=1.d30, whi=1.d30

    call spline(a_ppf,w_ppf,nw_ppf,wlo,whi,ddw_ppf) !a_ppf is lna here

    end subroutine setddwa


    function w_de(a)
    real(dl) :: w_de, al
    real(dl), intent(IN) :: a

    if(.not. use_tabulated_w) then
        w_de=w_lam+wa_ppf*(1._dl-a)
    else
        al=dlog(a)
        if(al.lt.a_ppf(1)) then
            w_de=w_ppf(1)                   !if a < minimum a from wa.dat
        elseif(al.gt.a_ppf(nw_ppf)) then
            w_de=w_ppf(nw_ppf)              !if a > maximus a from wa.dat
        else
            call cubicsplint(a_ppf,w_ppf,ddw_ppf,nw_ppf,al,w_de)
        endif
    endif
    end function w_de  ! equation of state of the PPF DE


    function drdlna_de(al)
    real(dl) :: drdlna_de, a
    real(dl), intent(IN) :: al

    a=dexp(al)
    drdlna_de=3._dl*(1._dl+w_de(a))

    end function drdlna_de


    subroutine interpolrde
    real(dl), parameter :: rlo=1.d30, rhi=1.d30
    real(dl) :: atol, almin, al, rombint, fint
    integer :: i
    external rombint
    atol=1.d-5
    almin=dlog(amin)
    do i=1,nde
        al=almin-almin/(nde-1)*(i-1)    !interpolate between amin and today
        fint=rombint(drdlna_de, al, 0._dl, atol)+4._dl*al
        ade(i)=al
        rde(i)=dexp(fint) !rho_de*a^4 normalize to its value at today
    enddo
    call spline(ade,rde,nde,rlo,rhi,ddrde)
    end subroutine interpolrde

    function grho_de(a)  !8 pi G a^4 rho_de
    real(dl) :: grho_de, al, fint
    real(dl), intent(IN) :: a

    if(.not. use_tabulated_w) then
        grho_de=grhov*a**(1._dl-3.*w_lam-3.*wa_ppf)*exp(-3.*wa_ppf*(1._dl-a))
    else
        if(a.eq.0.d0)then
            grho_de=0.d0      !assume rho_de*a^4-->0, when a-->0, OK if w_de always <0.
        else
            al=dlog(a)
            if(al.lt.ade(1))then
                fint=rde(1)*(a/amin)**(1.-3.*w_de(amin))    !if a<amin, assume here w=w_de(amin)
            else              !if amin is small enough, this extrapolation will be unnecessary.
                call cubicsplint(ade,rde,ddrde,nde,al,fint)
            endif
            grho_de=grhov*fint
        endif
    endif
    end function grho_de

    !-------------------------------------------------------------------
    SUBROUTINE cubicsplint(xa,ya,y2a,n,x,y)
    INTEGER n
    real(dl)x,y,xa(n),y2a(n),ya(n)
    INTEGER k,khi,klo
    real(dl)a,b,h
    klo=1
    khi=n
1   if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
            khi=k
        else
            klo=k
        endif
        goto 1
    endif
    h=xa(khi)-xa(klo)
    if (h.eq.0.) stop 'bad xa input in splint'
    a=(xa(khi)-x)/h
    b=(x-xa(klo))/h
    y=a*ya(klo)+b*ya(khi)+&
        ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.d0
    END SUBROUTINE cubicsplint
    !--------------------------------------------------------------------


    subroutine setcgammappf

    c_Gamma_ppf=0.4d0*sqrt(cs2_lam)

    end subroutine setcgammappf


    end module LambdaGeneral

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


    !Return OmegaK - modify this if you add extra fluid components
    function GetOmegak()
    use precision
    use ModelParams
    real(dl)  GetOmegak
    GetOmegak = 1 - (CP%omegab+CP%omegac+CP%omegav+CP%omegan)

    end function GetOmegak


    subroutine init_background
    use LambdaGeneral
    !This is only called once per model, and is a good point to do any extra initialization.
    !It is called before first call to dtauda, but after
    !massive neutrinos are initialized and after GetOmegak
    is_cosmological_constant = .not. use_tabulated_w .and. w_lam==-1_dl .and. wa_ppf==0._dl
    end  subroutine init_background


    !Background evolution
    function dtauda(a)
    !get d tau / d a
    use precision
    use ModelParams
    use MassiveNu
    use LambdaGeneral
    implicit none
    real(dl) dtauda
    real(dl), intent(IN) :: a
    real(dl) rhonu,grhoa2, a2
    integer nu_i

    a2=a**2

    !  8*pi*G*rho*a**4.
    grhoa2=grhok*a2+(grhoc+grhob)*a+grhog+grhornomass
    if (is_cosmological_constant) then
        grhoa2=grhoa2+grhov*a2**2
    else
        grhoa2=grhoa2+ grho_de(a)
    end if

    if (CP%Num_Nu_massive /= 0) then
        !Get massive neutrino density relative to massless
        do nu_i = 1, CP%nu_mass_eigenstates
            call Nu_rho(a*nu_masses(nu_i),rhonu)
            grhoa2=grhoa2+rhonu*grhormass(nu_i)
        end do
    end if

    dtauda=sqrt(3/grhoa2)

    end function dtauda

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    !Gauge-dependent perturbation equations

    module GaugeInterface
    use precision
    use ModelParams
    use MassiveNu
    use LambdaGeneral
    use Errors
    use Transfer
    implicit none
    public

    !Description of this file. Change if you make modifications.
    character(LEN=*), parameter :: Eqns_name = 'equations_ppf-Jan15'

    integer, parameter :: basic_num_eqns = 5

    logical :: DoTensorNeutrinos = .true.

    logical :: DoLateRadTruncation = .true.
    !if true, use smooth approx to radition perturbations after decoupling on
    !small scales, saving evolution of irrelevant osciallatory multipole equations

    logical, parameter :: second_order_tightcoupling = .true.

    real(dl) :: Magnetic = 0._dl
    !Vector mode anisotropic stress in units of rho_gamma
    real(dl) :: vec_sig0 = 1._dl
    !Vector mode shear
    integer, parameter :: max_l_evolve = 256 !Maximum l we are ever likely to propagate
    !Note higher values increase size of Evolution vars, hence memory

    !Supported scalar initial condition flags
    integer, parameter :: initial_adiabatic=1, initial_iso_CDM=2, &
        initial_iso_baryon=3,  initial_iso_neutrino=4, initial_iso_neutrino_vel=5, initial_vector = 0
    integer, parameter :: initial_nummodes =  initial_iso_neutrino_vel

    type EvolutionVars
        real(dl) q, q2
        real(dl) k_buf,k2_buf ! set in initial

        integer w_ix !Index of two quintessence equations
        integer r_ix !Index of the massless neutrino hierarchy
        integer g_ix !Index of the photon neutrino hierarchy

        integer q_ix !index into q_evolve array that gives the value q
        logical TransferOnly

        !       nvar  - number of scalar (tensor) equations for this k
        integer nvar,nvart, nvarv

        !Max_l for the various hierarchies
        integer lmaxg,lmaxnr,lmaxnu,lmaxgpol,MaxlNeeded
        integer lmaxnrt, lmaxnut, lmaxt, lmaxpolt, MaxlNeededt
        logical EvolveTensorMassiveNu(max_nu)
        integer lmaxnrv, lmaxv, lmaxpolv

        integer polind  !index into scalar array of polarization hierarchy

        !array indices for massive neutrino equations
        integer nu_ix(max_nu), nu_pert_ix
        integer nq(max_nu), lmaxnu_pert
        logical has_nu_relativistic

        !Initial values for massive neutrino v*3 variables calculated when switching
        !to non-relativistic approx
        real(dl) G11(max_nu),G30(max_nu)
        !True when using non-relativistic approximation
        logical MassiveNuApprox(max_nu)
        real(dl) MassiveNuApproxTime(max_nu)

        !True when truncating at l=2,3 when k*tau>>1 (see arXiv:1104.2933)
        logical high_ktau_neutrino_approx

        !Massive neutrino scheme being used at the moment
        integer NuMethod

        !True when using tight-coupling approximation (required for stability at early times)
        logical TightCoupling, TensTightCoupling
        real(dl) TightSwitchoffTime

        !Numer of scalar equations we are propagating
        integer ScalEqsToPropagate
        integer TensEqsToPropagate
        !beta > l for closed models
        integer FirstZerolForBeta
        !Tensor vars
        real(dl) aux_buf

        real(dl) pig, pigdot !For tight coupling
        real(dl) poltruncfac

        !PPF parameters
        real(dl) dgrho_e_ppf, dgq_e_ppf

        logical no_nu_multpoles, no_phot_multpoles
        integer lmaxnu_tau(max_nu)  !lmax for massive neutinos at time being integrated
        logical nu_nonrelativistic(max_nu)

        real(dl) denlk(max_l_evolve),denlk2(max_l_evolve), polfack(max_l_evolve)
        real(dl) Kf(max_l_evolve)

        integer E_ix, B_ix !tensor polarization indices
        real(dl) denlkt(4,max_l_evolve),Kft(max_l_evolve)
        real, pointer :: OutputTransfer(:) => null()

    end type EvolutionVars

    !precalculated arrays
    real(dl) polfac(max_l_evolve),denl(max_l_evolve),vecfac(max_l_evolve),vecfacpol(max_l_evolve)

    real(dl), parameter :: ep0=1.0d-2
    integer, parameter :: lmaxnu_high_ktau=4 !Jan2015, increased from 3 to fix mpk for mnu~6eV

    real(dl) epsw
    real(dl) nu_tau_notmassless(nqmax0+1,max_nu), nu_tau_nonrelativistic(max_nu),nu_tau_massive(max_nu)
    contains


    subroutine GaugeInterface_ScalEv(EV,y,tau,tauend,tol1,ind,c,w)
    type(EvolutionVars) EV
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar), tol1, tau, tauend
    integer ind

    call dverk(EV,EV%ScalEqsToPropagate,derivs,tau,y,tauend,tol1,ind,c,EV%nvar,w)
    if (ind==-3) then
        call GlobalError('Dverk error -3: the subroutine was unable  to  satisfy  the  error ' &
            //'requirement  with a particular step-size that is less than or * ' &
            //'equal to hmin, which may mean that tol is too small' &
            //'--- but most likely you''ve messed up the y array indexing; ' &
            //'compiling with bounds checking may (or may not) help find the problem.',error_evolution)
    end if
    end subroutine GaugeInterface_ScalEv

    function next_nu_nq(nq) result (next_nq)
    integer, intent(in) :: nq
    integer q, next_nq

    if (nq==0) then
        next_nq=1
    else
        q = nu_q(nq)
        if (q>=10) then
            next_nq = nqmax
        else
            next_nq = nq+1
        end if
    end if

    end function next_nu_nq

    recursive subroutine GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
    use ThermoData
    type(EvolutionVars) EV, EVout
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar), yout(EV%nvar), tol1, tau, tauend
    integer ind, nu_i
    real(dl) cs2, opacity, dopacity
    real(dl) tau_switch_ktau, tau_switch_nu_massless, tau_switch_nu_massive, next_switch
    real(dl) tau_switch_no_nu_multpoles, tau_switch_no_phot_multpoles,tau_switch_nu_nonrel
    real(dl) noSwitch, smallTime

    noSwitch= CP%tau0+1
    smallTime =  min(tau, 1/EV%k_buf)/100

    tau_switch_ktau = noSwitch
    tau_switch_no_nu_multpoles= noSwitch
    tau_switch_no_phot_multpoles= noSwitch

    !Massive neutrino switches
    tau_switch_nu_massless = noSwitch
    tau_switch_nu_nonrel = noSwitch
    tau_switch_nu_massive= noSwitch

    !Evolve equations from tau to tauend, performing switches in equations if necessary.

    if (.not. EV%high_ktau_neutrino_approx .and. .not. EV%no_nu_multpoles ) then
        tau_switch_ktau=  max(20, EV%lmaxnr-4)/EV%k_buf
    end if

    if (CP%Num_Nu_massive /= 0) then
        do nu_i = 1, CP%Nu_mass_eigenstates
            if (EV%nq(nu_i) /= nqmax) then
                tau_switch_nu_massless = min(tau_switch_nu_massless,nu_tau_notmassless(next_nu_nq(EV%nq(nu_i)),nu_i))
            else if (.not. EV%nu_nonrelativistic(nu_i)) then
                tau_switch_nu_nonrel = min(nu_tau_nonrelativistic(nu_i),tau_switch_nu_nonrel)
            else if (EV%NuMethod==Nu_trunc .and..not. EV%MassiveNuApprox(nu_i)) then
                tau_switch_nu_massive = min(tau_switch_nu_massive,EV%MassiveNuApproxTime(nu_i))
            end if
        end do
    end if

    if (DoLateRadTruncation) then
        if (.not. EV%no_nu_multpoles) & !!.and. .not. EV%has_nu_relativistic .and. tau_switch_nu_massless ==noSwitch)  &
            tau_switch_no_nu_multpoles=max(15/EV%k_buf*AccuracyBoost,min(taurend,matter_verydom_tau))

        if (.not. EV%no_phot_multpoles .and. (.not.CP%WantCls .or. EV%k_buf>0.03*AccuracyBoost)) &
            tau_switch_no_phot_multpoles =max(15/EV%k_buf,taurend)*AccuracyBoost
    end if

    next_switch = min(tau_switch_ktau, tau_switch_nu_massless,EV%TightSwitchoffTime, tau_switch_nu_massive, &
        tau_switch_no_nu_multpoles, tau_switch_no_phot_multpoles, tau_switch_nu_nonrel,noSwitch)

    if (next_switch < tauend) then
        if (next_switch > tau+smallTime) then
            call GaugeInterface_ScalEv(EV, y, tau,next_switch,tol1,ind,c,w)
            if (global_error_flag/=0) return
        end if

        EVout=EV

        if (next_switch == EV%TightSwitchoffTime) then
            !TightCoupling
            EVout%TightCoupling=.false.
            EVout%TightSwitchoffTime = noSwitch
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            EV=EVout
            y=yout
            ind=1
            !Set up variables with their tight coupling values
            y(EV%g_ix+2) = EV%pig
            call thermo(tau,cs2,opacity,dopacity)

            if (second_order_tightcoupling) then
                ! Francis-Yan Cyr-Racine November 2010

                y(EV%g_ix+3) = (3._dl/7._dl)*y(EV%g_ix+2)*(EV%k_buf/opacity)*(1._dl+dopacity/opacity**2) + &
                    (3._dl/7._dl)*EV%pigdot*(EV%k_buf/opacity**2)*(-1._dl)

                y(EV%polind+2) = EV%pig/4 + EV%pigdot*(1._dl/opacity)*(-5._dl/8._dl- &
                    (25._dl/16._dl)*dopacity/opacity**2) + &
                    EV%pig*(EV%k_buf/opacity)**2*(-5._dl/56._dl)
                y(EV%polind+3) = (3._dl/7._dl)*(EV%k_buf/opacity)*y(EV%polind+2)*(1._dl + &
                    dopacity/opacity**2) + (3._dl/7._dl)*(EV%k_buf/opacity**2)*((EV%pigdot/4._dl)* &
                    (1._dl+(5._dl/2._dl)*dopacity/opacity**2))*(-1._dl)
            else
                y(EV%g_ix+3) = 3./7*y(EV%g_ix+2)*EV%k_buf/opacity
                y(EV%polind+2) = EV%pig/4
                y(EV%polind+3) =y(EV%g_ix+3)/4
            end if
        else if (next_switch==tau_switch_ktau) then
            !k tau >> 1, evolve massless neutrino effective fluid up to l=2
            EVout%high_ktau_neutrino_approx=.true.
            EV%nq(1:CP%Nu_mass_eigenstates) = nqmax
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
        else if (next_switch == tau_switch_nu_massless) then
            !Mass starts to become important, start evolving next momentum mode
            do nu_i = 1, CP%Nu_mass_eigenstates
                if (EV%nq(nu_i) /= nqmax .and. &
                    next_switch == nu_tau_notmassless(next_nu_nq(EV%nq(nu_i)),nu_i)) then
                EVOut%nq(nu_i) = next_nu_nq(EV%nq(nu_i))
                call SetupScalarArrayIndices(EVout)
                call CopyScalarVariableArray(y,yout, EV, EVout)
                EV=EVout
                y=yout
                exit
                end if
            end do
        else if (next_switch == tau_switch_nu_nonrel) then
            !Neutrino becomes non-relativistic, don't need high L
            do nu_i = 1, CP%Nu_mass_eigenstates
                if (.not. EV%nu_nonrelativistic(nu_i) .and.  next_switch==nu_tau_nonrelativistic(nu_i) ) then
                    EVout%nu_nonrelativistic(nu_i)=.true.
                    call SetupScalarArrayIndices(EVout)
                    call CopyScalarVariableArray(y,yout, EV, EVout)
                    EV=EVout
                    y=yout
                    exit
                end if
            end do
        else if (next_switch == tau_switch_nu_massive) then
            !Very non-relativistic neutrinos, switch to truncated velocity-weight hierarchy
            do nu_i = 1, CP%Nu_mass_eigenstates
                if (.not. EV%MassiveNuApprox(nu_i) .and.  next_switch== EV%MassiveNuApproxTime(nu_i) ) then
                    call SwitchToMassiveNuApprox(EV,y, nu_i)
                    exit
                end if
            end do
        else if (next_switch==tau_switch_no_nu_multpoles) then
            !Turn off neutrino hierarchies at late time where slow and not needed.
            ind=1
            EVout%no_nu_multpoles=.true.
            EVOut%nq(1:CP%Nu_mass_eigenstates ) = nqmax
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
        else if (next_switch==tau_switch_no_phot_multpoles) then
            !Turn off photon hierarchies at late time where slow and not needed.
            ind=1
            EVout%no_phot_multpoles=.true.
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
        end if

        call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
        return
    end if

    call GaugeInterface_ScalEv(EV,y,tau,tauend,tol1,ind,c,w)

    end subroutine GaugeInterface_EvolveScal

    subroutine GaugeInterface_EvolveTens(EV,tau,y,tauend,tol1,ind,c,w)
    use ThermoData
    type(EvolutionVars) EV, EVOut
    real(dl) c(24),w(EV%nvart,9), y(EV%nvart),yout(EV%nvart), tol1, tau, tauend
    integer ind
    real(dl) opacity, cs2

    if (EV%TensTightCoupling .and. tauend > EV%TightSwitchoffTime) then
        if (EV%TightSwitchoffTime > tau) then
            call dverk(EV,EV%TensEqsToPropagate, derivst,tau,y,EV%TightSwitchoffTime,tol1,ind,c,EV%nvart,w)
        end if
        EVOut=EV
        EVOut%TensTightCoupling = .false.
        call SetupTensorArrayIndices(EVout)
        call CopyTensorVariableArray(y,yout,Ev, Evout)
        Ev = EvOut
        y=yout
        call thermo(tau,cs2,opacity)
        y(EV%g_ix+2)= 32._dl/45._dl*EV%k_buf/opacity*y(3)
        y(EV%E_ix+2) = y(EV%g_ix+2)/4
    end if

    call dverk(EV,EV%TensEqsToPropagate, derivst,tau,y,tauend,tol1,ind,c,EV%nvart,w)


    end subroutine GaugeInterface_EvolveTens

    function DeltaTimeMaxed(a1,a2, tol) result(t)
    real(dl) a1,a2,t
    real(dl), optional :: tol
    if (a1>1._dl) then
        t=0
    elseif (a2 > 1._dl) then
        t = DeltaTime(a1,1.01_dl, tol)
    else
        t= DeltaTime(a1,a2, tol)
    end if
    end function DeltaTimeMaxed

    subroutine GaugeInterface_Init
    !Precompute various arrays and other things independent of wavenumber
    integer j, nu_i
    real(dl) a_nonrel, a_mass,a_massive, time, nu_mass

    epsw = 100/CP%tau0

    if (CP%WantScalars) then
        do j=2,max_l_evolve
            polfac(j)=real((j+3)*(j-1),dl)/(j+1)
        end do
    end if

    if (CP%WantVectors) then
        do j=2,max_l_evolve
            vecfac(j)=real((j+2),dl)/(j+1)
            vecfacpol(j)=real((j+3)*j,dl)*(j-1)*vecfac(j)/(j+1)**2
        end do
    end if

    do j=1,max_l_evolve
        denl(j)=1._dl/(2*j+1)
    end do

    do nu_i=1, CP%Nu_Mass_eigenstates
        nu_mass = max(0.1_dl,nu_masses(nu_i))
        a_mass =  1.e-1_dl/nu_mass/lAccuracyBoost
        !if (HighAccuracyDefault) a_mass=a_mass/4
        time=DeltaTime(0._dl,nu_q(1)*a_mass)
        nu_tau_notmassless(1, nu_i) = time
        do j=2,nqmax
            !times when each momentum mode becomes signficantly nonrelativistic
            time= time + DeltaTimeMaxed(nu_q(j-1)*a_mass,nu_q(j)*a_mass, 0.01_dl)
            nu_tau_notmassless(j, nu_i) = time
        end do

        a_nonrel =  2.5d0/nu_mass*AccuracyBoost !!!Feb13tweak
        nu_tau_nonrelativistic(nu_i) =DeltaTimeMaxed(0._dl,a_nonrel)
        a_massive =  17.d0/nu_mass*AccuracyBoost
        nu_tau_massive(nu_i) =nu_tau_nonrelativistic(nu_i) + DeltaTimeMaxed(a_nonrel,a_massive)
    end do

    end subroutine GaugeInterface_Init


    subroutine SetupScalarArrayIndices(EV, max_num_eqns)
    !Set up array indices after the lmax have been decided
    use MassiveNu
    !Set the numer of equations in each hierarchy, and get total number of equations for this k
    type(EvolutionVars) EV
    integer, intent(out), optional :: max_num_eqns
    integer neq, maxeq, nu_i

    neq=basic_num_eqns
    maxeq=neq
    if (.not. EV%no_phot_multpoles) then
        !Photon multipoles
        EV%g_ix=basic_num_eqns+1
        if (EV%TightCoupling) then
            neq=neq+2
        else
            neq = neq+ (EV%lmaxg+1)
            !Polarization multipoles
            EV%polind = neq -1 !polind+2 is L=2, for polarizationthe first calculated
            neq=neq + EV%lmaxgpol-1
        end if
    end if
    if (.not. EV%no_nu_multpoles) then
        !Massless neutrino multipoles
        EV%r_ix= neq+1
        if (EV%high_ktau_neutrino_approx) then
            neq=neq + 3
        else
            neq=neq + (EV%lmaxnr+1)
        end if
    end if
    maxeq = maxeq +  (EV%lmaxg+1)+(EV%lmaxnr+1)+EV%lmaxgpol-1

    !Dark energy
    if (.not. is_cosmological_constant) then
        EV%w_ix = neq+1
        neq=neq+1 !ppf
        maxeq=maxeq+1
    else
        EV%w_ix=0
    end if

    !Massive neutrinos
    if (CP%Num_Nu_massive /= 0) then
        EV%has_nu_relativistic = any(EV%nq(1:CP%Nu_Mass_eigenstates)/=nqmax)
        if (EV%has_nu_relativistic) then
            EV%lmaxnu_pert=EV%lmaxnu
            EV%nu_pert_ix=neq+1
            neq = neq+ EV%lmaxnu_pert+1
            maxeq=maxeq+ EV%lmaxnu_pert+1
        else
            EV%lmaxnu_pert=0
        end if

        do nu_i=1, CP%Nu_Mass_eigenstates
            if (EV%high_ktau_neutrino_approx) then
                EV%lmaxnu_tau(nu_i) = lmaxnu_high_ktau *lAccuracyBoost
            else
                EV%lmaxnu_tau(nu_i) =max(min(nint(0.8_dl*EV%q*nu_tau_nonrelativistic(nu_i)*lAccuracyBoost),EV%lmaxnu),3)
                !!!Feb13tweak
                if (EV%nu_nonrelativistic(nu_i)) EV%lmaxnu_tau(nu_i)=min(EV%lmaxnu_tau(nu_i),nint(4*lAccuracyBoost))
            end if
            if (nu_masses(nu_i) > 5000 .and. CP%Transfer%high_precision) EV%lmaxnu_tau(nu_i) = EV%lmaxnu_tau(nu_i)*2 !megadamping
            EV%lmaxnu_tau(nu_i)=min(EV%lmaxnu,EV%lmaxnu_tau(nu_i))

            EV%nu_ix(nu_i)=neq+1
            if (EV%MassiveNuApprox(nu_i)) then
                neq = neq+4
            else
                neq = neq+ EV%nq(nu_i)*(EV%lmaxnu_tau(nu_i)+1)
            endif
            maxeq = maxeq + nqmax*(EV%lmaxnu+1)
        end do
    else
        EV%has_nu_relativistic = .false.
    end if

    EV%ScalEqsToPropagate = neq
    if (present(max_num_eqns)) then
        max_num_eqns=maxeq
    end if

    end subroutine SetupScalarArrayIndices

    subroutine CopyScalarVariableArray(y,yout, EV, EVout)
    type(EvolutionVars) EV, EVOut
    real(dl), intent(in) :: y(EV%nvar)
    real(dl), intent(out) :: yout(EVout%nvar)
    integer lmax,i, nq
    integer nnueq,nu_i, ix_off, ix_off2, ind, ind2
    real(dl) q, pert_scale

    yout=0
    yout(1:basic_num_eqns) = y(1:basic_num_eqns)
    if (.not. is_cosmological_constant) then
        yout(EVout%w_ix)=y(EV%w_ix)
    end if

    if (.not. EV%no_phot_multpoles .and. .not. EVout%no_phot_multpoles) then
        if (EV%TightCoupling .or. EVOut%TightCoupling) then
            lmax=1
        else
            lmax = min(EV%lmaxg,EVout%lmaxg)
        end if
        yout(EVout%g_ix:EVout%g_ix+lmax)=y(EV%g_ix:EV%g_ix+lmax)
        if (.not. EV%TightCoupling .and. .not. EVOut%TightCoupling) then
            lmax = min(EV%lmaxgpol,EVout%lmaxgpol)
            yout(EVout%polind+2:EVout%polind+lmax)=y(EV%polind+2:EV%polind+lmax)
        end if
    end if

    if (.not. EV%no_nu_multpoles .and. .not. EVout%no_nu_multpoles) then
        if (EV%high_ktau_neutrino_approx .or. EVout%high_ktau_neutrino_approx) then
            lmax=2
        else
            lmax = min(EV%lmaxnr,EVout%lmaxnr)
        end if
        yout(EVout%r_ix:EVout%r_ix+lmax)=y(EV%r_ix:EV%r_ix+lmax)
    end if

    if (CP%Num_Nu_massive /= 0) then
        do nu_i=1,CP%Nu_mass_eigenstates
            ix_off=EV%nu_ix(nu_i)
            ix_off2=EVOut%nu_ix(nu_i)
            if (EV%MassiveNuApprox(nu_i) .and. EVout%MassiveNuApprox(nu_i)) then
                nnueq=4
                yout(ix_off2:ix_off2+nnueq-1)=y(ix_off:ix_off+nnueq-1)
            else if (.not. EV%MassiveNuApprox(nu_i) .and. .not. EVout%MassiveNuApprox(nu_i)) then
                lmax=min(EV%lmaxnu_tau(nu_i),EVOut%lmaxnu_tau(nu_i))
                nq = min(EV%nq(nu_i), EVOut%nq(nu_i))
                do i=1,nq
                    ind= ix_off + (i-1)*(EV%lmaxnu_tau(nu_i)+1)
                    ind2=ix_off2+ (i-1)*(EVOut%lmaxnu_tau(nu_i)+1)
                    yout(ind2:ind2+lmax) = y(ind:ind+lmax)
                end do
                do i=nq+1, EVOut%nq(nu_i)
                    lmax = min(EVOut%lmaxnu_tau(nu_i), EV%lmaxnr)
                    ind2=ix_off2+ (i-1)*(EVOut%lmaxnu_tau(nu_i)+1)
                    yout(ind2:ind2+lmax) = y(EV%r_ix:EV%r_ix+lmax)

                    !Add leading correction for the mass
                    q=nu_q(i)
                    pert_scale=(nu_masses(nu_i)/q)**2/2
                    lmax = min(lmax,EV%lmaxnu_pert)
                    yout(ind2:ind2+lmax) = yout(ind2:ind2+lmax) &
                        + y(EV%nu_pert_ix:EV%nu_pert_ix+lmax)*pert_scale
                end do
            end if
        end do

        if (EVOut%has_nu_relativistic .and. EV%has_nu_relativistic) then
            lmax = min(EVOut%lmaxnu_pert, EV%lmaxnu_pert)
            yout(EVout%nu_pert_ix:EVout%nu_pert_ix+lmax)=  y(EV%nu_pert_ix:EV%nu_pert_ix+lmax)
        end if
    end if

    end subroutine CopyScalarVariableArray


    subroutine SetupTensorArrayIndices(EV, maxeq)
    type(EvolutionVars) EV
    integer nu_i, neq
    integer, optional, intent(out) :: maxeq
    neq=3
    EV%g_ix = neq-1 !EV%g_ix+2 is quadrupole
    if (.not. EV%TensTightCoupling) then
        EV%E_ix = EV%g_ix + (EV%lmaxt-1)
        EV%B_ix = EV%E_ix + (EV%lmaxpolt-1)
        neq = neq+ (EV%lmaxt-1)+(EV%lmaxpolt-1)*2
    end if
    if (present(maxeq)) then
        maxeq =3 + (EV%lmaxt-1)+(EV%lmaxpolt-1)*2
    end if
    EV%r_ix = neq -1
    if (DoTensorNeutrinos) then
        neq = neq + EV%lmaxnrt-1
        if (present(maxeq)) maxeq = maxeq+EV%lmaxnrt-1
        if (CP%Num_Nu_massive /= 0 ) then
            do nu_i=1, CP%nu_mass_eigenstates
                EV%EvolveTensorMassiveNu(nu_i) = nu_tau_nonrelativistic(nu_i) < 0.8*tau_maxvis*AccuracyBoost
                if (EV%EvolveTensorMassiveNu(nu_i)) then
                    EV%nu_ix(nu_i)=neq-1
                    neq = neq+ nqmax*(EV%lmaxnut-1)
                    if (present(maxeq)) maxeq = maxeq + nqmax*(EV%lmaxnut-1)
                end if
            end do
        end if
    end if

    EV%TensEqsToPropagate = neq

    end  subroutine SetupTensorArrayIndices

    subroutine CopyTensorVariableArray(y,yout, EV, EVout)
    type(EvolutionVars) EV, EVOut
    real(dl), intent(in) :: y(EV%nvart)
    real(dl), intent(out) :: yout(EVout%nvart)
    integer lmaxpolt, lmaxt, nu_i, ind, ind2, i

    yout=0
    yout(1:3) = y(1:3)
    if (.not. EVOut%TensTightCoupling .and. .not.EV%TensTightCoupling) then
        lmaxt = min(EVOut%lmaxt,EV%lmaxt)
        yout(EVout%g_ix+2:EVout%g_ix+lmaxt)=y(EV%g_ix+2:EV%g_ix+lmaxt)
        lmaxpolt = min(EV%lmaxpolt, EVOut%lmaxpolt)
        yout(EVout%E_ix+2:EVout%E_ix+lmaxpolt)=y(EV%E_ix+2:EV%E_ix+lmaxpolt)
        yout(EVout%B_ix+2:EVout%B_ix+lmaxpolt)=y(EV%B_ix+2:EV%B_ix+lmaxpolt)
    end if
    if (DoTensorNeutrinos) then
        lmaxt=min(EV%lmaxnrt,EVOut%lmaxnrt)
        yout(EVout%r_ix+2:EVout%r_ix+lmaxt)=y(EV%r_ix+2:EV%r_ix+lmaxt)
        do nu_i =1, CP%nu_mass_eigenstates
            if (EV%EvolveTensorMassiveNu(nu_i)) then
                lmaxt=min(EV%lmaxnut,EVOut%lmaxnut)
                do i=1,nqmax
                    ind= EV%nu_ix(nu_i) + (i-1)*(EV%lmaxnut-1)
                    ind2=EVOut%nu_ix(nu_i)+ (i-1)*(EVOut%lmaxnut-1)
                    yout(ind2+2:ind2+lmaxt) = y(ind+2:ind+lmaxt)
                end do
            end if
        end do
    end if

    end subroutine CopyTensorVariableArray

    subroutine GetNumEqns(EV)
    use MassiveNu
    !Set the numer of equations in each hierarchy, and get total number of equations for this k
    type(EvolutionVars) EV
    real(dl) scal, max_nu_mass
    integer nu_i,q_rel,j

    if (CP%Num_Nu_massive == 0) then
        EV%lmaxnu=0
        max_nu_mass=0
    else
        max_nu_mass = maxval(nu_masses(1:CP%Nu_mass_eigenstates))
        do nu_i = 1, CP%Nu_mass_eigenstates
            !Start with momentum modes for which t_k ~ time at which mode becomes non-relativistic
            q_rel=0
            do j=1, nqmax
                !two different q's here EV%q ~k
                if (nu_q(j) > nu_masses(nu_i)*adotrad/EV%q) exit
                q_rel = q_rel + 1
            end do

            if (q_rel>= nqmax-2 .or. CP%WantTensors) then
                EV%nq(nu_i)=nqmax
            else
                EV%nq(nu_i)=q_rel
            end if
            !q_rel = nint(nu_masses(nu_i)*adotrad/EV%q) !two dffierent q's here EV%q ~k
            !EV%nq(nu_i)=max(0,min(nqmax0,q_rel)) !number of momentum modes to evolve intitially
            EV%nu_nonrelativistic(nu_i) = .false.
        end do

        EV%NuMethod = CP%MassiveNuMethod
        if (EV%NuMethod == Nu_Best) EV%NuMethod = Nu_Trunc
        !l_max for massive neutrinos
        if (CP%Transfer%high_precision) then
            EV%lmaxnu=nint(25*lAccuracyBoost)
        else
            EV%lmaxnu=max(3,nint(10*lAccuracyBoost))
            if (max_nu_mass>700) EV%lmaxnu=max(3,nint(15*lAccuracyBoost)) !Feb13 tweak
        endif
    end if

    if (CP%closed) then
        EV%FirstZerolForBeta = nint(EV%q*CP%r)
    else
        EV%FirstZerolForBeta=l0max !a large number
    end if

    EV%high_ktau_neutrino_approx = .false.
    if (CP%WantScalars) then
        EV%TightCoupling=.true.
        EV%no_phot_multpoles =.false.
        EV%no_nu_multpoles =.false.
        EV%MassiveNuApprox=.false.

        if (HighAccuracyDefault .and. CP%AccuratePolarization) then
            EV%lmaxg  = max(nint(11*lAccuracyBoost),3)
        else
            EV%lmaxg  = max(nint(8*lAccuracyBoost),3)
        end if
        EV%lmaxnr = max(nint(14*lAccuracyBoost),3)
        if (max_nu_mass>700 .and. HighAccuracyDefault) EV%lmaxnr = max(nint(32*lAccuracyBoost),3) !Feb13 tweak

        EV%lmaxgpol = EV%lmaxg
        if (.not.CP%AccuratePolarization) EV%lmaxgpol=max(nint(4*lAccuracyBoost),3)

        if (EV%q < 0.05) then
            !Large scales need fewer equations
            scal  = 1
            if (CP%AccuratePolarization) scal = 4  !But need more to get polarization right
            EV%lmaxgpol=max(3,nint(min(8,nint(scal* 150* EV%q))*lAccuracyBoost))
            EV%lmaxnr=max(3,nint(min(7,nint(sqrt(scal)* 150 * EV%q))*lAccuracyBoost))
            EV%lmaxg=max(3,nint(min(8,nint(sqrt(scal) *300 * EV%q))*lAccuracyBoost))
            if (CP%AccurateReionization) then
                EV%lmaxg=EV%lmaxg*4
                EV%lmaxgpol=EV%lmaxgpol*2
            end if
        end if

        if (EV%TransferOnly) then
            EV%lmaxgpol = min(EV%lmaxgpol,nint(5*lAccuracyBoost))
            EV%lmaxg = min(EV%lmaxg,nint(6*lAccuracyBoost))
        end if
        if (CP%Transfer%high_precision) then
            if (HighAccuracyDefault) then
                EV%lmaxnr=max(nint(45*lAccuracyBoost),3)
            else
                EV%lmaxnr=max(nint(30*lAccuracyBoost),3)
            endif
            if (EV%q > 0.04 .and. EV%q < 0.5) then !baryon oscillation scales
                EV%lmaxg=max(EV%lmaxg,10)
            end if
        end if

        if (CP%closed) then
            EV%lmaxnu=min(EV%lmaxnu, EV%FirstZerolForBeta-1)
            EV%lmaxnr=min(EV%lmaxnr, EV%FirstZerolForBeta-1)
            EV%lmaxg=min(EV%lmaxg, EV%FirstZerolForBeta-1)
            EV%lmaxgpol=min(EV%lmaxgpol, EV%FirstZerolForBeta-1)
        end if

        EV%poltruncfac=real(EV%lmaxgpol,dl)/max(1,(EV%lmaxgpol-2))
        EV%MaxlNeeded=max(EV%lmaxg,EV%lmaxnr,EV%lmaxgpol,EV%lmaxnu)
        if (EV%MaxlNeeded > max_l_evolve) stop 'Need to increase max_l_evolve'
        call SetupScalarArrayIndices(EV,EV%nvar)
        if (CP%closed) EV%nvar=EV%nvar+1 !so can reference lmax+1 with zero coefficient
        EV%lmaxt=0
    else
        EV%nvar=0
    end if

    if (CP%WantTensors) then
        EV%TensTightCoupling = .true.
        EV%lmaxt=max(3,nint(8*lAccuracyBoost))
        EV%lmaxpolt = max(3,nint(4*lAccuracyBoost))
        ! if (EV%q < 1e-3) EV%lmaxpolt=EV%lmaxpolt+1
        if (DoTensorNeutrinos) then
            EV%lmaxnrt=nint(6*lAccuracyBoost)
            EV%lmaxnut=EV%lmaxnrt
        else
            EV%lmaxnut=0
            EV%lmaxnrt=0
        end if
        if (CP%closed) then
            EV%lmaxt=min(EV%FirstZerolForBeta-1,EV%lmaxt)
            EV%lmaxpolt=min(EV%FirstZerolForBeta-1,EV%lmaxpolt)
            EV%lmaxnrt=min(EV%FirstZerolForBeta-1,EV%lmaxnrt)
            EV%lmaxnut=min(EV%FirstZerolForBeta-1,EV%lmaxnut)
        end if
        EV%MaxlNeededt=max(EV%lmaxpolt,EV%lmaxt, EV%lmaxnrt, EV%lmaxnut)
        if (EV%MaxlNeededt > max_l_evolve) stop 'Need to increase max_l_evolve'
        call SetupTensorArrayIndices(EV, EV%nvart)
    else
        EV%nvart=0
    end if


    if (CP%WantVectors) then
        EV%lmaxv=max(10,nint(8*lAccuracyBoost))
        EV%lmaxpolv = max(5,nint(5*lAccuracyBoost))

        EV%nvarv=(EV%lmaxv)+(EV%lmaxpolv-1)*2+3

        EV%lmaxnrv=nint(30*lAccuracyBoost)

        EV%nvarv=EV%nvarv+EV%lmaxnrv
        if (CP%Num_Nu_massive /= 0 ) then
            stop 'massive neutrinos not supported for vector modes'
        end if
    else
        EV%nvarv=0
    end if

    end subroutine GetNumEqns

    !cccccccccccccccccccccccccccccccccc
    subroutine SwitchToMassiveNuApprox(EV,y, nu_i)
    !When the neutrinos are no longer highly relativistic we use a truncated
    !energy-integrated hierarchy going up to third order in velocity dispersion
    type(EvolutionVars) EV, EVout
    integer, intent(in) :: nu_i

    real(dl) a,a2,pnu,clxnu,dpnu,pinu,rhonu
    real(dl) qnu
    real(dl) y(EV%nvar), yout(EV%nvar)

    a=y(1)
    a2=a*a
    EVout=EV
    EVout%MassiveNuApprox(nu_i)=.true.
    call SetupScalarArrayIndices(EVout)
    call CopyScalarVariableArray(y,yout, EV, EVout)

    !Get density and pressure as ratio to massles by interpolation from table
    call Nu_background(a*nu_masses(nu_i),rhonu,pnu)

    !Integrate over q
    call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu,dpnu,pinu)
    !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
    dpnu=dpnu/rhonu
    qnu=qnu/rhonu
    clxnu = clxnu/rhonu
    pinu=pinu/rhonu

    yout(EVout%nu_ix(nu_i))=clxnu
    yout(EVout%nu_ix(nu_i)+1)=dpnu
    yout(EVout%nu_ix(nu_i)+2)=qnu
    yout(EVout%nu_ix(nu_i)+3)=pinu

    call Nu_Intvsq(EV,y, a, nu_i, EVout%G11(nu_i),EVout%G30(nu_i))
    !Analytic solution for higher moments, proportional to a^{-3}
    EVout%G11(nu_i)=EVout%G11(nu_i)*a2*a/rhonu
    EVout%G30(nu_i)=EVout%G30(nu_i)*a2*a/rhonu

    EV=EVout
    y=yout

    end subroutine SwitchToMassiveNuApprox

    subroutine MassiveNuVarsOut(EV,y,yprime,a,grho,gpres,dgrho,dgq,dgpi, gdpi_diff,pidot_sum,clxnu_all)
    implicit none
    type(EvolutionVars) EV
    real(dl) :: y(EV%nvar), yprime(EV%nvar),a
    real(dl), optional :: grho,gpres,dgrho,dgq,dgpi, gdpi_diff,pidot_sum,clxnu_all
    !grho = a^2 kappa rho
    !gpres = a^2 kappa p
    !dgrho = a^2 kappa \delta\rho
    !dgp =  a^2 kappa \delta p
    !dgq = a^2 kappa q (heat flux)
    !dgpi = a^2 kappa pi (anisotropic stress)
    !dgpi_diff = a^2 kappa (3*p -rho)*pi

    integer nu_i
    real(dl) pinudot,grhormass_t, rhonu, pnu,  rhonudot
    real(dl) adotoa, grhonu_t,gpnu_t
    real(dl) clxnu, qnu, pinu, dpnu, grhonu, dgrhonu
    real(dl) dtauda

    grhonu=0
    dgrhonu=0
    do nu_i = 1, CP%Nu_mass_eigenstates
        grhormass_t=grhormass(nu_i)/a**2

        !Get density and pressure as ratio to massless by interpolation from table
        call Nu_background(a*nu_masses(nu_i),rhonu,pnu)

        if (EV%MassiveNuApprox(nu_i)) then
            clxnu=y(EV%nu_ix(nu_i))
            !dpnu = y(EV%iq0+1+off_ix)
            qnu=y(EV%nu_ix(nu_i)+2)
            pinu=y(EV%nu_ix(nu_i)+3)
            pinudot=yprime(EV%nu_ix(nu_i)+3)
        else
            !Integrate over q
            call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu,dpnu,pinu)
            !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
            !dpnu=dpnu/rhonu
            qnu=qnu/rhonu
            clxnu = clxnu/rhonu
            pinu=pinu/rhonu
            adotoa = 1/(a*dtauda(a))
            rhonudot = Nu_drho(a*nu_masses(nu_i),adotoa,rhonu)

            call Nu_pinudot(EV,y, yprime, a,adotoa, nu_i,pinudot)
            pinudot=pinudot/rhonu - rhonudot/rhonu*pinu
        endif

        grhonu_t=grhormass_t*rhonu
        gpnu_t=grhormass_t*pnu

        grhonu = grhonu  + grhonu_t
        if (present(gpres)) gpres= gpres + gpnu_t

        dgrhonu= dgrhonu + grhonu_t*clxnu
        if (present(dgq)) dgq  = dgq   + grhonu_t*qnu
        if (present(dgpi)) dgpi = dgpi  + grhonu_t*pinu
        if (present(gdpi_diff)) gdpi_diff = gdpi_diff + pinu*(3*gpnu_t-grhonu_t)
        if (present(pidot_sum)) pidot_sum = pidot_sum + grhonu_t*pinudot
    end do
    if (present(grho)) grho = grho  + grhonu
    if (present(dgrho)) dgrho= dgrho + dgrhonu
    if (present(clxnu_all)) clxnu_all = dgrhonu/grhonu

    end subroutine MassiveNuVarsOut

    subroutine Nu_Integrate_L012(EV,y,a,nu_i,drhonu,fnu,dpnu,pinu)
    type(EvolutionVars) EV
    !  Compute the perturbations of density and energy flux
    !  of one eigenstate of massive neutrinos, in units of the mean
    !  density of one eigenstate of massless neutrinos, by integrating over
    !  momentum.
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a, y(EV%nvar)
    real(dl), intent(OUT) ::  drhonu,fnu
    real(dl), optional, intent(OUT) :: dpnu,pinu
    real(dl) tmp, am, aq,v, pert_scale
    integer iq, ind

    !  q is the comoving momentum in units of k_B*T_nu0/c.

    drhonu=0
    fnu=0
    if (present(dpnu)) then
        dpnu=0
        pinu=0
    end if
    am=a*nu_masses(nu_i)
    ind=EV%nu_ix(nu_i)
    do iq=1,EV%nq(nu_i)
        aq=am/nu_q(iq)
        v=1._dl/sqrt(1._dl+aq*aq)
        drhonu=drhonu+ nu_int_kernel(iq)* y(ind)/v
        fnu=fnu+nu_int_kernel(iq)* y(ind+1)
        if (present(dpnu)) then
            dpnu=dpnu+  nu_int_kernel(iq)* y(ind)*v
            pinu=pinu+ nu_int_kernel(iq)*y(ind+2)*v
        end if
        ind=ind+EV%lmaxnu_tau(nu_i)+1
    end do
    ind = EV%nu_pert_ix
    do iq=EV%nq(nu_i)+1,nqmax
        !Get the rest from perturbatively relativistic expansion
        aq=am/nu_q(iq)
        v=1._dl/sqrt(1._dl+aq*aq)
        pert_scale=(nu_masses(nu_i)/nu_q(iq))**2/2
        tmp = nu_int_kernel(iq)*(y(EV%r_ix)  + pert_scale*y(ind)  )
        drhonu=drhonu+ tmp/v
        fnu=fnu+nu_int_kernel(iq)*(y(EV%r_ix+1)+ pert_scale*y(ind+1))
        if (present(dpnu)) then
            dpnu=dpnu+ tmp*v
            pinu = pinu+ nu_int_kernel(iq)*(y(EV%r_ix+2)+ pert_scale*y(ind+2))*v
        end if
    end do

    if (present(dpnu)) then
        dpnu = dpnu/3
    end if

    end subroutine Nu_Integrate_L012

    subroutine Nu_pinudot(EV,y, ydot, a,adotoa, nu_i,pinudot)
    type(EvolutionVars) EV
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a,adotoa, y(EV%nvar), ydot(EV%nvar)

    !  Compute the time derivative of the mean density in massive neutrinos
    !  and the shear perturbation.
    real(dl) pinudot
    real(dl) aq,q,v,aqdot,vdot
    real(dl) psi2,psi2dot
    real(dl) am, pert_scale
    integer iq,ind

    !  q is the comoving momentum in units of k_B*T_nu0/c.
    pinudot=0._dl
    ind=EV%nu_ix(nu_i)+2
    am=a*nu_masses(nu_i)
    do iq=1,EV%nq(nu_i)
        q=nu_q(iq)
        aq=am/q
        aqdot=aq*adotoa
        v=1._dl/sqrt(1._dl+aq*aq)
        vdot=-aq*aqdot/(1._dl+aq*aq)**1.5d0
        pinudot=pinudot+nu_int_kernel(iq)*(ydot(ind)*v+y(ind)*vdot)
        ind=ind+EV%lmaxnu_tau(nu_i)+1
    end do
    ind = EV%nu_pert_ix+2
    do iq=EV%nq(nu_i)+1,nqmax
        q=nu_q(iq)
        aq=am/q
        aqdot=aq*adotoa
        pert_scale=(nu_masses(nu_i)/q)**2/2
        v=1._dl/sqrt(1._dl+aq*aq)
        vdot=-aq*aqdot/(1._dl+aq*aq)**1.5d0
        psi2dot=ydot(EV%r_ix+2)  + pert_scale*ydot(ind)
        psi2=y(EV%r_ix+2)  + pert_scale*y(ind)
        pinudot=pinudot+nu_int_kernel(iq)*(psi2dot*v+psi2*vdot)
    end do

    end subroutine Nu_pinudot

    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    function Nu_pi(EV, y, a, nu_i) result(pinu)
    type(EvolutionVars) EV
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a, y(EV%nvart)
    real(dl) :: am
    real(dl) pinu,q,aq,v
    integer iq, ind

    if (EV%nq(nu_i)/=nqmax) stop 'Nu_pi: nq/=nqmax'
    pinu=0
    ind=EV%nu_ix(nu_i)+2
    am=a*nu_masses(nu_i)
    do iq=1, EV%nq(nu_i)
        q=nu_q(iq)
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        pinu=pinu+nu_int_kernel(iq)*y(ind)*v
        ind =ind+EV%lmaxnut+1
    end do

    end function Nu_pi

    !cccccccccccccccccccccccccccccccccccccccccccccc
    subroutine Nu_Intvsq(EV,y, a, nu_i, G11,G30)
    type(EvolutionVars) EV
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a, y(EV%nvar)
    real(dl), intent(OUT) ::  G11,G30

    !  Compute the third order variables (in velocity dispersion)
    !by integrating over momentum.
    real(dl) aq,q,v, am
    integer iq, ind

    !  q is the comoving momentum in units of k_B*T_nu0/c.
    am=a*nu_masses(nu_i)
    ind=EV%nu_ix(nu_i)
    G11=0._dl
    G30=0._dl
    if (EV%nq(nu_i)/=nqmax) stop 'Nu_Intvsq nq/=nqmax0'
    do iq=1, EV%nq(nu_i)
        q=nu_q(iq)
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        G11=G11+nu_int_kernel(iq)*y(ind+1)*v**2
        if (EV%lmaxnu_tau(nu_i)>2) then
            G30=G30+nu_int_kernel(iq)*y(ind+3)*v**2
        end if
        ind = ind+EV%lmaxnu_tau(nu_i)+1
    end do

    end subroutine Nu_Intvsq


    subroutine MassiveNuVars(EV,y,a,grho,gpres,dgrho,dgq, wnu_arr)
    implicit none
    type(EvolutionVars) EV
    real(dl) :: y(EV%nvar), a, grho,gpres,dgrho,dgq
    real(dl), intent(out), optional :: wnu_arr(max_nu)
    !grho = a^2 kappa rho
    !gpres = a^2 kappa p
    !dgrho = a^2 kappa \delta\rho
    !dgp =  a^2 kappa \delta p
    !dgq = a^2 kappa q (heat flux)
    integer nu_i
    real(dl) grhormass_t, rhonu, qnu, clxnu, grhonu_t, gpnu_t, pnu

    do nu_i = 1, CP%Nu_mass_eigenstates
        grhormass_t=grhormass(nu_i)/a**2

        !Get density and pressure as ratio to massless by interpolation from table
        call Nu_background(a*nu_masses(nu_i),rhonu,pnu)

        if (EV%MassiveNuApprox(nu_i)) then
            clxnu=y(EV%nu_ix(nu_i))
            qnu=y(EV%nu_ix(nu_i)+2)
        else
            !Integrate over q
            call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu)
            !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
            qnu=qnu/rhonu
            clxnu = clxnu/rhonu
        endif

        grhonu_t=grhormass_t*rhonu
        gpnu_t=grhormass_t*pnu

        grho = grho  + grhonu_t
        gpres= gpres + gpnu_t
        dgrho= dgrho + grhonu_t*clxnu
        dgq  = dgq   + grhonu_t*qnu

        if (present(wnu_arr)) then
            wnu_arr(nu_i) =pnu/rhonu
        end if
    end do

    end subroutine MassiveNuVars

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine output(EV,y, tau,sources, notused_custom_sources)
    use ThermoData
    use lvalues
    use ModelData
    implicit none
    type(EvolutionVars) EV
    real(dl), target :: y(EV%nvar),yprime(EV%nvar)
    real(dl), dimension(:),pointer :: ypol,ypolprime

    real(dl) dgq,grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,sigma,polter
    real(dl) qgdot,pigdot,pirdot,vbdot,dgrho
    real(dl) a,a2,dz,z,clxc,clxb,vb,clxg,qg,pig,clxr,qr,pir

    real(dl) tau,x,divfac
    real(dl) dgpi_diff, pidot_sum
    real(dl), target :: pol(3),polprime(3)
    !dgpi_diff = sum (3*p_nu -rho_nu)*pi_nu

    real(dl) k,k2  ,adotoa, grho, gpres,etak,phi,dgpi
    real(dl)  diff_rhopi, octg, octgprime
    real(dl) sources(CTransScal%NumSources)
    !        real(dl) t4,t92
    real(dl) ISW
    real(dl) w_eff
    real(dl) hdotoh,ppiedot
    integer, intent(in) :: notused_custom_sources !must be zero in _ppf version
    real(dl) opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau, lenswindow


    call IonizationFunctionsAtTime(tau, opacity, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow)


    yprime = 0
    call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)

    if (EV%TightCoupling .or. EV%no_phot_multpoles) then
        pol=0
        polprime=0
        ypolprime => polprime
        ypol => pol
    else
        ypolprime => yprime(EV%polind+1:)
        ypol => y(EV%polind+1:)
    end if

    k=EV%k_buf
    k2=EV%k2_buf

    a   =y(1)
    a2  =a*a
    etak=y(2)
    clxc=y(3)
    clxb=y(4)
    vb  =y(5)
    vbdot =yprime(5)

    !  Compute expansion rate from: grho 8*pi*rho*a**2

    grhob_t=grhob/a
    grhoc_t=grhoc/a
    grhor_t=grhornomass/a2
    grhog_t=grhog/a2

    !  8*pi*a*a*SUM[rho_i*clx_i] add radiation later
    dgrho=grhob_t*clxb+grhoc_t*clxc

    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    dgq=grhob_t*vb

    if (is_cosmological_constant) then
        w_eff = -1_dl
        grhov_t=grhov*a2
    else
        !ppf
        w_eff=w_de(a)   !effective de
        grhov_t=grho_de(a)/a2
        dgrho=dgrho+EV%dgrho_e_ppf
        dgq=dgq+EV%dgq_e_ppf
    end if
    grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t
    gpres=(grhog_t+grhor_t)/3+grhov_t*w_eff


    dgpi= 0
    dgpi_diff = 0
    pidot_sum = 0

    if (CP%Num_Nu_Massive /= 0) then
        call MassiveNuVarsOut(EV,y,yprime,a,grho,gpres,dgrho,dgq,dgpi, dgpi_diff,pidot_sum)
    end if

    adotoa=sqrt((grho+grhok)/3)

    if (EV%no_nu_multpoles) then
        z=(0.5_dl*dgrho/k + etak)/adotoa
        dz= -adotoa*z - 0.5_dl*dgrho/k
        clxr=-4*dz/k
        qr=-4._dl/3*z
        pir=0
        pirdot=0
    else
        clxr=y(EV%r_ix)
        qr  =y(EV%r_ix+1)
        pir =y(EV%r_ix+2)
        pirdot=yprime(EV%r_ix+2)
    end if

    if (EV%no_phot_multpoles) then
        z=(0.5_dl*dgrho/k + etak)/adotoa
        dz= -adotoa*z - 0.5_dl*dgrho/k
        clxg=-4*dz/k -4/k*opacity*(vb+z)
        qg=-4._dl/3*z
        pig=0
        pigdot=0
        octg=0
        octgprime=0
        qgdot = -4*dz/3
    else
        if (EV%TightCoupling) then
            pig = EV%pig
            !pigdot=EV%pigdot
            if (second_order_tightcoupling) then
                octg = (3._dl/7._dl)*pig*(EV%k_buf/opacity)
                ypol(2) = EV%pig/4 + EV%pigdot*(1._dl/opacity)*(-5._dl/8._dl)
                ypol(3) = (3._dl/7._dl)*(EV%k_buf/opacity)*ypol(2)
            else
                ypol(2) = EV%pig/4
                octg=0
            end if
            octgprime=0
        else
            pig =y(EV%g_ix+2)
            pigdot=yprime(EV%g_ix+2)
            octg=y(EV%g_ix+3)
            octgprime=yprime(EV%g_ix+3)
        end if
        clxg=y(EV%g_ix)
        qg  =y(EV%g_ix+1)
        qgdot =yprime(EV%g_ix+1)
    end if

    dgrho = dgrho + grhog_t*clxg+grhor_t*clxr
    dgq   = dgq   + grhog_t*qg+grhor_t*qr
    dgpi  = dgpi  + grhor_t*pir + grhog_t*pig


    !  Get sigma (shear) and z from the constraints
    !  have to get z from eta for numerical stability
    z=(0.5_dl*dgrho/k + etak)/adotoa
    sigma=(z+1.5_dl*dgq/k2)/EV%Kf(1)

    if (is_cosmological_constant) then
        ppiedot=0
    else
        hdotoh=(-3._dl*grho-3._dl*gpres -2._dl*grhok)/6._dl/adotoa
        ppiedot=3._dl*EV%dgrho_e_ppf+EV%dgq_e_ppf*(12._dl/k*adotoa+k/adotoa-3._dl/k*(adotoa+hdotoh))+ &
            grhov_t*(1+w_eff)*k*z/adotoa -2._dl*k2*EV%Kf(1)*(yprime(EV%w_ix)/adotoa-2._dl*y(EV%w_ix))
        ppiedot=ppiedot*adotoa/EV%Kf(1)
    end if

    polter = 0.1_dl*pig+9._dl/15._dl*ypol(2)

    if (CP%flat) then
        x=k*(CP%tau0-tau)
        divfac=x*x
    else
        x=(CP%tau0-tau)/CP%r
        divfac=(CP%r*rofChi(x))**2*k2
    end if


    if (EV%TightCoupling) then
        if (second_order_tightcoupling) then
            pigdot = EV%pigdot
            ypolprime(2)= (pigdot/4._dl)*(1+(5._dl/2._dl)*(dopacity/opacity**2))
        else
            pigdot = -dopacity/opacity*pig + 32._dl/45*k/opacity*(-2*adotoa*sigma  &
                +etak/EV%Kf(1)-  dgpi/k +vbdot )
            ypolprime(2)= pigdot/4
        end if
    end if

    pidot_sum =  pidot_sum + grhog_t*pigdot + grhor_t*pirdot
    diff_rhopi = pidot_sum - (4*dgpi+ dgpi_diff )*adotoa + ppiedot


    !Maple's fortran output - see scal_eqs.map
    !2phi' term (\phi' + \psi' in Newtonian gauge)
    ISW = (4.D0/3.D0*k*EV%Kf(1)*sigma+(-2.D0/3.D0*sigma-2.D0/3.D0*etak/adotoa)*k &
        -diff_rhopi/k**2-1.D0/adotoa*dgrho/3.D0+(3.D0*gpres+5.D0*grho)*sigma/k/3.D0 &
        -2.D0/k*adotoa/EV%Kf(1)*etak)*exptau

    !e.g. to get only late-time ISW
    !  if (1/a-1 < 30) ISW=0

    !The rest, note y(9)->octg, yprime(9)->octgprime (octopoles)
    sources(1)= ISW +  ((-9.D0/160.D0*pig-27.D0/80.D0*ypol(2))/k**2*opacity+ &
        (11.D0/10.D0*sigma- 3.D0/8.D0*EV%Kf(2)*ypol(3)+vb-9.D0/80.D0*EV%Kf(2)*octg+3.D0/40.D0*qg)/k- &
        (-180.D0*ypolprime(2)-30.D0*pigdot)/k**2/160.D0)*dvisibility + &
        (-(9.D0*pigdot+ 54.D0*ypolprime(2))/k**2*opacity/160.D0+pig/16.D0+clxg/4.D0+3.D0/8.D0*ypol(2) + &
        (-21.D0/5.D0*adotoa*sigma-3.D0/8.D0*EV%Kf(2)*ypolprime(3) + &
        vbdot+3.D0/40.D0*qgdot- 9.D0/80.D0*EV%Kf(2)*octgprime)/k + &
        (-9.D0/160.D0*dopacity*pig-21.D0/10.D0*dgpi-27.D0/80.D0*dopacity*ypol(2))/k**2)*visibility + &
        (3.D0/16.D0*ddvisibility*pig+9.D0/8.D0*ddvisibility*ypol(2))/k**2+21.D0/10.D0/k/EV%Kf(1)*visibility*etak

    ! Doppler term
    !   sources(1)=  (sigma+vb)/k*dvisibility+((-2.D0*adotoa*sigma+vbdot)/k-1.D0/k**2*dgpi)*visibility &
    !         +1.D0/k/EV%Kf(1)*visibility*etak

    !Equivalent full result
    !    t4 = 1.D0/adotoa
    !    t92 = k**2
    !    sources(1) = (4.D0/3.D0*EV%Kf(1)*exptau*sigma+2.D0/3.D0*(-sigma-t4*etak)*exptau)*k+ &
    !        (3.D0/8.D0*ypol(2)+pig/16.D0+clxg/4.D0)*visibility
    !    sources(1) = sources(1)-t4*exptau*dgrho/3.D0+((11.D0/10.D0*sigma- &
    !         3.D0/8.D0*EV%Kf(2)*ypol(3)+vb+ 3.D0/40.D0*qg-9.D0/80.D0*EV%Kf(2)*y(9))*dvisibility+(5.D0/3.D0*grho+ &
    !        gpres)*sigma*exptau+(-2.D0*adotoa*etak*exptau+21.D0/10.D0*etak*visibility)/ &
    !        EV%Kf(1)+(vbdot-3.D0/8.D0*EV%Kf(2)*ypolprime(3)+3.D0/40.D0*qgdot-21.D0/ &
    !        5.D0*sigma*adotoa-9.D0/80.D0*EV%Kf(2)*yprime(9))*visibility)/k+(((-9.D0/160.D0*pigdot- &
    !        27.D0/80.D0*ypolprime(2))*opacity-21.D0/10.D0*dgpi -27.D0/80.D0*dopacity*ypol(2) &
    !        -9.D0/160.D0*dopacity*pig)*visibility - diff_rhopi*exptau+((-27.D0/80.D0*ypol(2)-9.D0/ &
    !        160.D0*pig)*opacity+3.D0/16.D0*pigdot+9.D0/8.D0*ypolprime(2))*dvisibility+9.D0/ &
    !        8.D0*ddvisibility*ypol(2)+3.D0/16.D0*ddvisibility*pig)/t92


    if (x > 0._dl) then
        !E polarization source
        sources(2)=visibility*polter*(15._dl/8._dl)/divfac
        !factor of four because no 1/16 later
    else
        sources(2)=0
    end if

    if (CTransScal%NumSources > 2) then
        !Get lensing sources
        !Can modify this here if you want to get power spectra for other tracer
        if (tau > tau_maxvis .and. CP%tau0-tau > 0.1_dl) then
            !phi_lens = Phi - 1/2 kappa (a/k)^2 sum_i rho_i pi_i
            phi = -(dgrho +3*dgq*adotoa/k)/(k2*EV%Kf(1)*2) - dgpi/k2/2

            sources(3) = -2*phi*f_K(tau-tau_maxvis)/(f_K(CP%tau0-tau_maxvis)*f_K(CP%tau0-tau))
            !We include the lensing factor of two here
        else
            sources(3) = 0
        end if
    end if

    end subroutine output


    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine outputt(EV,yt,n,tau,dt,dte,dtb)
    !calculate the tensor sources for open and closed case
    use ThermoData

    implicit none
    integer n
    type(EvolutionVars) :: EV
    real(dl), target :: yt(n), ytprime(n)
    real(dl) tau,dt,dte,dtb,x,polterdot,polterddot,prefac
    real(dl) pig, pigdot, octg, aux, polter, shear, adotoa,a
    real(dl) sinhxr,cothxor
    real(dl) k,k2
    real(dl), dimension(:),pointer :: E,Bprime,Eprime
    real(dl), target :: pol(3),polEprime(3), polBprime(3)
    real(dl) dtauda
    real(dl) opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau, lenswindow


    call IonizationFunctionsAtTime(tau, opacity, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow)

    call derivst(EV,EV%nvart,tau,yt,ytprime)

    k2=EV%k2_buf
    k=EV%k_buf
    aux=EV%aux_buf
    shear = yt(3)

    x=(CP%tau0-tau)/CP%r

    !  And the electric part of the Weyl.
    if (.not. EV%TensTightCoupling) then
        !  Use the full expression for pigdt
        pig=yt(EV%g_ix+2)
        pigdot=ytprime(EV%g_ix+2)
        E => yt(EV%E_ix+1:)
        Eprime=> ytprime(EV%E_ix+1:)
        Bprime => ytprime(EV%B_ix+1:)
        octg=ytprime(EV%g_ix+3)
    else
        !  Use the tight-coupling approximation
        a =yt(1)
        adotoa = 1/(a*dtauda(a))
        pigdot=32._dl/45._dl*k/opacity*(2._dl*adotoa*shear+ytprime(3))
        pig = 32._dl/45._dl*k/opacity*shear
        pol=0
        polEprime=0
        polBprime=0
        E=>pol
        EPrime=>polEPrime
        BPrime=>polBPrime
        E(2)=pig/4._dl
        EPrime(2)=pigdot/4
        octg=0
    endif

    sinhxr=rofChi(x)*CP%r

    if (EV%q*sinhxr > 1.e-8_dl) then
        prefac=sqrt(EV%q2*CP%r*CP%r-CP%Ksign)
        cothxor=cosfunc(x)/sinhxr

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)
        polterdot=9._dl/15._dl*Eprime(2) + 0.1_dl*pigdot
        polterddot = 9._dl/15._dl*(-dopacity*(E(2)-polter)-opacity*(  &
            Eprime(2)-polterdot) + k*(2._dl/3._dl*Bprime(2)*aux - 5._dl/27._dl*Eprime(3)*EV%Kft(2))) &
            +0.1_dl*(k*(-octg*EV%Kft(2)/3._dl + 8._dl/15._dl*ytprime(3)) - &
            dopacity*(pig - polter) - opacity*(pigdot-polterdot))

        dt=(shear*exptau + (15._dl/8._dl)*polter*visibility/k)*CP%r/sinhxr**2/prefac

        dte=CP%r*15._dl/8._dl/k/prefac* &
            ((ddvisibility*polter + 2._dl*dvisibility*polterdot + visibility*polterddot)  &
            + 4._dl*cothxor*(dvisibility*polter + visibility*polterdot) - &
            visibility*polter*(k2 -6*cothxor**2))

        dtb=15._dl/4._dl*EV%q*CP%r/k/prefac*(visibility*(2._dl*cothxor*polter + polterdot) + dvisibility*polter)
    else
        dt=0._dl
        dte=0._dl
        dtb=0._dl
    end if

    end subroutine outputt

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine outputv(EV,yv,n,tau,dt,dte,dtb)
    !calculate the vector sources
    use ThermoData

    implicit none
    integer n
    type(EvolutionVars) :: EV
    real(dl), target :: yv(n), yvprime(n)
    real(dl) tau,dt,dte,dtb,x,polterdot
    real(dl) vb,qg, pig, polter, sigma
    real(dl) k,k2
    real(dl), dimension(:),pointer :: E,Eprime
    real(dl) opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau, lenswindow


    call IonizationFunctionsAtTime(tau, opacity, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow)


    call derivsv(EV,EV%nvarv,tau,yv,yvprime)

    k2=EV%k2_buf
    k=EV%k_buf
    sigma = yv(2)
    vb  = yv(3)
    qg  = yv(4)
    pig = yv(5)


    x=(CP%tau0-tau)*k

    if (x > 1.e-8_dl) then
        E => yv(EV%lmaxv+3:)
        Eprime=> yvprime(EV%lmaxv+3:)

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)
        polterdot=9._dl/15._dl*Eprime(2) + 0.1_dl*yvprime(5)

        if (yv(1) < 1e-3) then
            dt = 1
        else
            dt =0
        end if
        dt= (4*(vb+sigma)*visibility + 15._dl/2/k*( visibility*polterdot + dvisibility*polter) &
            + 4*(exptau*yvprime(2)) )/x

        dte= 15._dl/2*2*polter/x**2*visibility + 15._dl/2/k*(dvisibility*polter + visibility*polterdot)/x

        dtb= -15._dl/2*polter/x*visibility
    else
        dt=0
        dte=0
        dtb=0
    end if

    end subroutine outputv


    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine initial(EV,y, tau)
    !  Initial conditions.
    use ThermoData
    implicit none

    type(EvolutionVars) EV
    real(dl) y(EV%nvar)
    real(dl) Rp15,tau,x,x2,x3,om,omtau, &
        Rc,Rb,Rv,Rg,grhonu,chi
    real(dl) k,k2
    real(dl) a,a2, iqg, rhomass,a_massive, ep
    integer l,i, nu_i, j, ind
    integer, parameter :: i_clxg=1,i_clxr=2,i_clxc=3, i_clxb=4, &
        i_qg=5,i_qr=6,i_vb=7,i_pir=8, i_eta=9, i_aj3r=10,i_clxq=11,i_vq=12
    integer, parameter :: i_max = i_vq
    real(dl) initv(6,1:i_max), initvec(1:i_max)

    nullify(EV%OutputTransfer) !Should not be needed, but avoids issues in ifort 14

    if (CP%flat) then
        EV%k_buf=EV%q
        EV%k2_buf=EV%q2
        EV%Kf(1:EV%MaxlNeeded)=1._dl
    else
        EV%k2_buf=EV%q2-CP%curv
        EV%k_buf=sqrt(EV%k2_buf)

        do l=1,EV%MaxlNeeded
            EV%Kf(l)=1._dl-CP%curv*(l*(l+2))/EV%k2_buf
        end do
    end if

    k=EV%k_buf
    k2=EV%k2_buf

    do j=1,EV%MaxlNeeded
        EV%denlk(j)=denl(j)*k*j
        EV%denlk2(j)=denl(j)*k*EV%Kf(j)*(j+1)
        EV%polfack(j)=polfac(j)*k*EV%Kf(j)*denl(j)
    end do

    !Get time to switch off tight coupling
    !The numbers here are a bit of guesswork
    !The high k increase saves time for very small loss of accuracy
    !The lower k ones are more delicate. Nead to avoid instabilities at same time
    !as ensuring tight coupling is accurate enough
    if (EV%k_buf > epsw) then
        if (EV%k_buf > epsw*5) then
            ep=ep0*5/AccuracyBoost
            if (HighAccuracyDefault) ep = ep*0.65
        else
            ep=ep0
        end if
    else
        ep=ep0
    end if
    if (second_order_tightcoupling) ep=ep*2
    EV%TightSwitchoffTime = min(tight_tau,Thermo_OpacityToTime(EV%k_buf/ep))


    y=0

    !  k*tau, (k*tau)**2, (k*tau)**3
    x=k*tau
    x2=x*x
    x3=x2*x
    rhomass =  sum(grhormass(1:CP%Nu_mass_eigenstates))
    grhonu=rhomass+grhornomass

    om = (grhob+grhoc)/sqrt(3*(grhog+grhonu))
    omtau=om*tau
    Rv=grhonu/(grhonu+grhog)

    Rg = 1-Rv
    Rc=CP%omegac/(CP%omegac+CP%omegab)
    Rb=1-Rc
    Rp15=4*Rv+15

    if (CP%Scalar_initial_condition > initial_nummodes) &
        stop 'Invalid initial condition for scalar modes'

    a=tau*adotrad*(1+omtau/4)
    a2=a*a

    initv=0

    !  Set adiabatic initial conditions

    chi=1  !Get transfer function for chi
    initv(1,i_clxg)=-chi*EV%Kf(1)/3*x2*(1-omtau/5)
    initv(1,i_clxr)= initv(1,i_clxg)
    initv(1,i_clxb)=0.75_dl*initv(1,i_clxg)
    initv(1,i_clxc)=initv(1,i_clxb)
    initv(1,i_qg)=initv(1,i_clxg)*x/9._dl
    initv(1,i_qr)=-chi*EV%Kf(1)*(4*Rv+23)/Rp15*x3/27
    initv(1,i_vb)=0.75_dl*initv(1,i_qg)
    initv(1,i_pir)=chi*4._dl/3*x2/Rp15*(1+omtau/4*(4*Rv-5)/(2*Rv+15))
    initv(1,i_aj3r)=chi*4/21._dl/Rp15*x3
    initv(1,i_eta)=-chi*2*EV%Kf(1)*(1 - x2/12*(-10._dl/Rp15 + EV%Kf(1)))

    if (CP%Scalar_initial_condition/= initial_adiabatic) then
        !CDM isocurvature

        initv(2,i_clxg)= Rc*omtau*(-2._dl/3 + omtau/4)
        initv(2,i_clxr)=initv(2,i_clxg)
        initv(2,i_clxb)=initv(2,i_clxg)*0.75_dl
        initv(2,i_clxc)=1+initv(2,i_clxb)
        initv(2,i_qg)=-Rc/9*omtau*x
        initv(2,i_qr)=initv(2,i_qg)
        initv(2,i_vb)=0.75_dl*initv(2,i_qg)
        initv(2,i_pir)=-Rc*omtau*x2/3/(2*Rv+15._dl)
        initv(2,i_eta)= Rc*omtau*(1._dl/3 - omtau/8)*EV%Kf(1)
        initv(2,i_aj3r)=0
        !Baryon isocurvature
        if (Rc==0) stop 'Isocurvature initial conditions assume non-zero dark matter'

        initv(3,:) = initv(2,:)*(Rb/Rc)
        initv(3,i_clxc) = initv(3,i_clxb)
        initv(3,i_clxb)= initv(3,i_clxb)+1

        !neutrino isocurvature density mode

        initv(4,i_clxg)=Rv/Rg*(-1 + x2/6)
        initv(4,i_clxr)=1-x2/6
        initv(4,i_clxc)=-omtau*x2/80*Rv*Rb/Rg
        initv(4,i_clxb)= Rv/Rg/8*x2
        iqg = - Rv/Rg*(x/3 - Rb/4/Rg*omtau*x)
        initv(4,i_qg) =iqg
        initv(4,i_qr) = x/3
        initv(4,i_vb)=0.75_dl*iqg
        initv(4,i_pir)=x2/Rp15
        initv(4,i_eta)=EV%Kf(1)*Rv/Rp15/3*x2

        !neutrino isocurvature velocity mode

        initv(5,i_clxg)=Rv/Rg*x - 2*x*omtau/16*Rb*(2+Rg)/Rg**2
        initv(5,i_clxr)=-x -3*x*omtau*Rb/16/Rg
        initv(5,i_clxc)=-9*omtau*x/64*Rv*Rb/Rg
        initv(5,i_clxb)= 3*Rv/4/Rg*x - 9*omtau*x/64*Rb*(2+Rg)/Rg**2
        iqg = Rv/Rg*(-1 + 3*Rb/4/Rg*omtau+x2/6 +3*omtau**2/16*Rb/Rg**2*(Rg-3*Rb))
        initv(5,i_qg) =iqg
        initv(5,i_qr) = 1 - x2/6*(1+4*EV%Kf(1)/(4*Rv+5))
        initv(5,i_vb)=0.75_dl*iqg
        initv(5,i_pir)=2*x/(4*Rv+5)+omtau*x*6/Rp15/(4*Rv+5)
        initv(5,i_eta)=2*EV%Kf(1)*x*Rv/(4*Rv+5) + omtau*x*3*EV%Kf(1)*Rv/32*(Rb/Rg - 80/Rp15/(4*Rv+5))
        initv(5,i_aj3r) = 3._dl/7*x2/(4*Rv+5)

        !quintessence isocurvature mode
    end if

    if (CP%Scalar_initial_condition==initial_vector) then
        InitVec = 0
        do i=1,initial_nummodes
            InitVec = InitVec+ initv(i,:)*CP%InitialConditionVector(i)
        end do
    else
        InitVec = initv(CP%Scalar_initial_condition,:)
        if (CP%Scalar_initial_condition==initial_adiabatic) InitVec = -InitVec
        !So we start with chi=-1 as before
    end if

    y(1)=a
    y(2)= -InitVec(i_eta)*k/2
    !get eta_s*k, where eta_s is synchronous gauge variable

    !  CDM
    y(3)=InitVec(i_clxc)

    !  Baryons
    y(4)=InitVec(i_clxb)
    y(5)=InitVec(i_vb)

    !  Photons
    y(EV%g_ix)=InitVec(i_clxg)
    y(EV%g_ix+1)=InitVec(i_qg)

    if (.not. is_cosmological_constant) then
        y(EV%w_ix) = InitVec(i_clxq) !ppf: Gamma=0, i_clxq stands for i_Gamma
    end if

    !  Neutrinos
    y(EV%r_ix)=InitVec(i_clxr)
    y(EV%r_ix+1)=InitVec(i_qr)
    y(EV%r_ix+2)=InitVec(i_pir)

    if (EV%lmaxnr>2) then
        y(EV%r_ix+3)=InitVec(i_aj3r)
    endif

    if (CP%Num_Nu_massive == 0) return

    do nu_i = 1, CP%Nu_mass_eigenstates
        EV%MassiveNuApproxTime(nu_i) = Nu_tau_massive(nu_i)
        a_massive =  20000*k/nu_masses(nu_i)*AccuracyBoost*lAccuracyBoost
        if (a_massive >=0.99) then
            EV%MassiveNuApproxTime(nu_i)=CP%tau0+1
        else if (a_massive > 17.d0/nu_masses(nu_i)*AccuracyBoost) then
            EV%MassiveNuApproxTime(nu_i)=max(EV%MassiveNuApproxTime(nu_i),DeltaTime(0._dl,a_massive, 0.01_dl))
        end if
        ind = EV%nu_ix(nu_i)
        do  i=1,EV%nq(nu_i)
            y(ind:ind+2)=y(EV%r_ix:EV%r_ix+2)
            if (EV%lmaxnu_tau(nu_i)>2) y(ind+3)=InitVec(i_aj3r)
            ind = ind + EV%lmaxnu_tau(nu_i)+1
        end do
    end do

    end subroutine initial


    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine initialt(EV,yt,tau)
    !  Initial conditions for tensors
    use ThermoData
    implicit none
    real(dl) bigR,tau,x,aj3r,elec, pir, rhomass
    integer l
    type(EvolutionVars) EV
    real(dl) k,k2 ,a, omtau
    real(dl) yt(EV%nvart)
    real(dl) tens0, ep, tensfac

    if (CP%flat) then
        EV%aux_buf=1._dl
        EV%k2_buf=EV%q2
        EV%k_buf=EV%q
        EV%Kft(1:EV%MaxlNeededt)=1._dl !initialize for flat case
    else
        EV%k2_buf=EV%q2-3*CP%curv
        EV%k_buf=sqrt(EV%k2_buf)
        EV%aux_buf=sqrt(1._dl+3*CP%curv/EV%k2_buf)
    endif

    k=EV%k_buf
    k2=EV%k2_buf

    do l=1,EV%MaxlNeededt
        if (.not. CP%flat) EV%Kft(l)=1._dl-CP%curv*((l+1)**2-3)/k2
        EV%denlkt(1,l)=k*denl(l)*l !term for L-1
        tensfac=real((l+3)*(l-1),dl)/(l+1)
        EV%denlkt(2,l)=k*denl(l)*tensfac*EV%Kft(l) !term for L+1
        EV%denlkt(3,l)=k*denl(l)*tensfac**2/(l+1)*EV%Kft(l) !term for polarization
        EV%denlkt(4,l)=k*4._dl/(l*(l+1))*EV%aux_buf !other for polarization
    end do

    if (k > 0.06_dl*epsw) then
        ep=ep0
    else
        ep=0.2_dl*ep0
    end if

    !    finished_tightcoupling = ((k/opacity > ep).or.(1._dl/(opacity*tau) > ep))
    EV%TightSwitchoffTime = min(tight_tau,Thermo_OpacityToTime(EV%k_buf/ep))

    a=tau*adotrad
    rhomass =  sum(grhormass(1:CP%Nu_mass_eigenstates))
    omtau = tau*(grhob+grhoc)/sqrt(3*(grhog+rhomass+grhornomass))

    if (DoTensorNeutrinos) then
        bigR = (rhomass+grhornomass)/(rhomass+grhornomass+grhog)
    else
        bigR = 0._dl
    end if

    x=k*tau

    yt(1)=a
    tens0 = 1

    yt(2)= tens0
    !commented things are for the compensated mode with magnetic fields; can be neglected
    !-15/28._dl*x**2*(bigR-1)/(15+4*bigR)*Magnetic*(1-5./2*omtau/(2*bigR+15))

    elec=-tens0*(1+2*CP%curv/k2)*(2*bigR+10)/(4*bigR+15) !elec, with H=1

    !shear
    yt(3)=-5._dl/2/(bigR+5)*x*elec
    !          + 15._dl/14*x*(bigR-1)/(4*bigR+15)*Magnetic*(1 - 15./2*omtau/(2*bigR+15))

    yt(4:EV%nvart)=0._dl

    !  Neutrinos
    if (DoTensorNeutrinos) then
        pir=-2._dl/3._dl/(bigR+5)*x**2*elec
        !           + (bigR-1)/bigR*Magnetic*(1-15./14*x**2/(15+4*bigR))
        aj3r=  -2._dl/21._dl/(bigR+5)*x**3*elec !&
            !           + 3._dl/7*x*(bigR-1)/bigR*Magnetic
            yt(EV%r_ix+2)=pir
        yt(EV%r_ix+3)=aj3r
        !Should set up massive too, but small anyway..
    end if

    end subroutine initialt

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine initialv(EV,yv,tau)
    !  Initial conditions for vectors

    implicit none
    real(dl) bigR,Rc,tau,x,pir
    type(EvolutionVars) EV
    real(dl) k,k2 ,a, omtau
    real(dl) yv(EV%nvarv)

    if (CP%flat) then
        EV%k2_buf=EV%q2
        EV%k_buf=EV%q
    else
        stop 'Vectors not supported in non-flat models'
    endif

    k=EV%k_buf
    k2=EV%k2_buf

    omtau = tau*(grhob+grhoc)/sqrt(3*(grhog+grhornomass))

    a=tau*adotrad*(1+omtau/4)

    x=k*tau

    bigR = (grhornomass)/(grhornomass+grhog)
    Rc=CP%omegac/(CP%omegac+CP%omegab)

    yv(1)=a


    yv(2)= vec_sig0*(1- 15._dl/2*omtau/(4*bigR+15)) + 45._dl/14*x*Magnetic*(BigR-1)/(4*BigR+15)
    !qg
    yv(4)= vec_sig0/3* (4*bigR + 5)/(1-BigR)*(1  -0.75_dl*omtau*(Rc-1)/(bigR-1)* &
        (1 - 0.25_dl*omtau*(3*Rc-2-bigR)/(BigR-1))) &
        -x/2*Magnetic
    yv(3)= 3._dl/4*yv(4)

    yv(5:EV%nvarv) = 0

    !        if (.false.) then
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1) = vec_sig0/6/bigR*x**2*(1+2*bigR*omtau/(4*bigR+15))
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+2) = -2/3._dl*vec_sig0/bigR*x*(1 +3*omtau*bigR/(4*bigR+15))
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+3) = 1/4._dl*vec_sig0/bigR*(5+4*BigR)
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+4) =1/9.*x*vec_sig0*(5+4*bigR)/bigR
    !         yv(4) = 0
    !         yv(3)= 3._dl/4*yv(4)
    !          return
    !        end if

    !  Neutrinos
    !q_r
    yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1) = -1._dl/3*vec_sig0*(4*BigR+5)/bigR &
        + x**2*vec_sig0/6/BigR +0.5_dl*x*(1/bigR-1)*Magnetic
    !pi_r
    pir=-2._dl/3._dl*x*vec_sig0/BigR - (1/bigR-1)*Magnetic
    yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1 +1)=pir
    yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1 +2)=3._dl/7*x*Magnetic*(1-1/BigR)

    end subroutine initialv


    subroutine outtransf(EV, y,tau, Arr)
    !write out clxc, clxb, clxg, clxn
    implicit none
    type(EvolutionVars) EV
    real(dl), intent(in) :: tau
    real(dl) clxc, clxb, clxg, clxr, k,k2
    real(dl) grho,gpres,dgrho,dgq,a
    real, target :: Arr(:)
    real(dl) y(EV%nvar),yprime(EV%nvar)

    yprime = 0
    EV%OutputTransfer =>  Arr
    call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)
    nullify(EV%OutputTransfer)

    Arr(Transfer_kh+1:Transfer_max) = Arr(Transfer_kh+1:Transfer_max)/EV%k2_buf

    end subroutine outtransf

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine derivs(EV,n,tau,ay,ayprime)
    !  Evaluate the time derivatives of the perturbations
    !  ayprime is not necessarily GaugeInterface.yprime, so keep them distinct
    use ThermoData
    use MassiveNu
    implicit none
    type(EvolutionVars) EV

    integer n,nu_i
    real(dl) ay(n),ayprime(n)
    real(dl) tau,w
    real(dl) k,k2

    !  Internal variables.

    real(dl) opacity
    real(dl) photbar,cs2,pb43,grho,slip,clxgdot, &
        clxcdot,clxbdot,adotdota,gpres,clxrdot,etak
    real(dl) q,aq,v
    real(dl) G11_t,G30_t, wnu_arr(max_nu)

    real(dl) dgq,grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,sigma,polter
    real(dl) qgdot,qrdot,pigdot,pirdot,vbdot,dgrho,adotoa
    real(dl) a,a2,z,clxc,clxb,vb,clxg,qg,pig,clxr,qr,pir
    real(dl) clxq, vq,  E2, dopacity
    integer l,i,ind, ind2, off_ix, ix
    real(dl) dgs,sigmadot,dz !, ddz
    real(dl) dgpi,dgrho_matter,grho_matter, clxnu_all
    !non-flat vars
    real(dl) cothxor !1/tau in flat case
    !ppf
    real(dl) Gamma,S_Gamma,ckH,Gammadot,Fa,dgqe,dgrhoe, vT
    real(dl) w_eff, grhoT

    k=EV%k_buf
    k2=EV%k2_buf

    a=ay(1)
    a2=a*a

    etak=ay(2)

    !  CDM variables
    clxc=ay(3)

    !  Baryon variables
    clxb=ay(4)
    vb=ay(5)

    !  Compute expansion rate from: grho 8*pi*rho*a**2

    grhob_t=grhob/a
    grhoc_t=grhoc/a
    grhor_t=grhornomass/a2
    grhog_t=grhog/a2
    if (is_cosmological_constant) then
        grhov_t=grhov*a2
        w_eff = -1_dl
    else
        !ppf
        w_eff=w_de(a)   !effective de
        grhov_t=grho_de(a)/a2
    end if

    !  Get sound speed and ionisation fraction.
    if (EV%TightCoupling) then
        call thermo(tau,cs2,opacity,dopacity)
    else
        call thermo(tau,cs2,opacity)
    end if

    gpres=(grhor_t+grhog_t)/3._dl
    grho_matter=grhob_t+grhoc_t

    !total perturbations: matter terms first, then add massive nu, de and radiation
    !  8*pi*a*a*SUM[rho_i*clx_i]
    dgrho_matter=grhob_t*clxb+grhoc_t*clxc
    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    dgq=grhob_t*vb

    if (CP%Num_Nu_Massive > 0) then
        call MassiveNuVars(EV,ay,a,grho_matter,gpres,dgrho_matter,dgq, wnu_arr)
    end if

    grho = grho_matter+grhor_t+grhog_t+grhov_t

    if (CP%flat) then
        adotoa=sqrt(grho/3)
        cothxor=1._dl/tau
    else
        adotoa=sqrt((grho+grhok)/3._dl)
        cothxor=1._dl/tanfunc(tau/CP%r)/CP%r
    end if

    dgrho = dgrho_matter

    ! if (w_lam /= -1 .and. w_Perturb) then
    !    clxq=ay(EV%w_ix)
    !    vq=ay(EV%w_ix+1)
    !    dgrho=dgrho + clxq*grhov_t
    !    dgq = dgq + vq*grhov_t*(1+w_lam)
    !end if

    if (EV%no_nu_multpoles) then
        !RSA approximation of arXiv:1104.2933, dropping opactity terms in the velocity
        !Approximate total density variables with just matter terms
        z=(0.5_dl*dgrho/k + etak)/adotoa
        dz= -adotoa*z - 0.5_dl*dgrho/k
        clxr=-4*dz/k
        qr=-4._dl/3*z
        pir=0
    else
        !  Massless neutrinos
        clxr=ay(EV%r_ix)
        qr  =ay(EV%r_ix+1)
        pir =ay(EV%r_ix+2)
    endif

    if (EV%no_phot_multpoles) then
        if (.not. EV%no_nu_multpoles) then
            z=(0.5_dl*dgrho/k + etak)/adotoa
            dz= -adotoa*z - 0.5_dl*dgrho/k
            clxg=-4*dz/k-4/k*opacity*(vb+z)
            qg=-4._dl/3*z
        else
            clxg=clxr-4/k*opacity*(vb+z)
            qg=qr
        end if
        pig=0
    else
        !  Photons
        clxg=ay(EV%g_ix)
        qg=ay(EV%g_ix+1)
        if (.not. EV%TightCoupling) pig=ay(EV%g_ix+2)
    end if

    !  8*pi*a*a*SUM[rho_i*clx_i] - radiation terms
    dgrho=dgrho + grhog_t*clxg+grhor_t*clxr

    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    dgq=dgq + grhog_t*qg+grhor_t*qr

    !  Photon mass density over baryon mass density
    photbar=grhog_t/grhob_t
    pb43=4._dl/3*photbar

    ayprime(1)=adotoa*a

    if (.not. is_cosmological_constant) then
        !ppf
        grhoT = grho - grhov_t
        vT= dgq/(grhoT+gpres)
        Gamma=ay(EV%w_ix)

        !sigma for ppf
        sigma = (etak + (dgrho + 3*adotoa/k*dgq)/2._dl/k)/EV%kf(1) - k*Gamma
        sigma = sigma/adotoa

        S_Gamma=grhov_t*(1+w_eff)*(vT+sigma)*k/adotoa/2._dl/k2
        ckH=c_Gamma_ppf*k/adotoa
        Gammadot=S_Gamma/(1+ckH*ckH)- Gamma -ckH*ckH*Gamma
        Gammadot=Gammadot*adotoa
        ayprime(EV%w_ix)=Gammadot

        if(ckH*ckH.gt.3.d1)then
            Gamma=0
            Gammadot=0.d0
            ayprime(EV%w_ix)=Gammadot
        endif

        Fa=1+3*(grhoT+gpres)/2._dl/k2/EV%kf(1)
        dgqe=S_Gamma - Gammadot/adotoa - Gamma
        dgqe=-dgqe/Fa*2._dl*k*adotoa + vT*grhov_t*(1+w_eff)
        dgrhoe=-2*k2*EV%kf(1)*Gamma-3/k*adotoa*dgqe
        dgrho=dgrho+dgrhoe
        dgq=dgq+dgqe

        EV%dgrho_e_ppf=dgrhoe
        EV%dgq_e_ppf=dgqe
    end if

    !  Get sigma (shear) and z from the constraints
    ! have to get z from eta for numerical stability
    z=(0.5_dl*dgrho/k + etak)/adotoa
    if (CP%flat) then
        !eta*k equation
        sigma=(z+1.5_dl*dgq/k2)
        ayprime(2)=0.5_dl*dgq
    else
        sigma=(z+1.5_dl*dgq/k2)/EV%Kf(1)
        ayprime(2)=0.5_dl*dgq + CP%curv*z
    end if

    !if (w_lam /= -1 .and. w_Perturb) then
    !
    !   ayprime(EV%w_ix)= -3*adotoa*(cs2_lam-w_lam)*(clxq+3*adotoa*(1+w_lam)*vq/k) &
    !       -(1+w_lam)*k*vq -(1+w_lam)*k*z
    !
    !   ayprime(EV%w_ix+1) = -adotoa*(1-3*cs2_lam)*vq + k*cs2_lam*clxq/(1+w_lam)
    !
    !end if
    !

    if (associated(EV%OutputTransfer)) then
        EV%OutputTransfer(Transfer_kh) = k/(CP%h0/100._dl)
        EV%OutputTransfer(Transfer_cdm) = clxc
        EV%OutputTransfer(Transfer_b) = clxb
        EV%OutputTransfer(Transfer_g) = clxg
        EV%OutputTransfer(Transfer_r) = clxr
        clxnu_all=0
        dgpi  = grhor_t*pir + grhog_t*pig
        if (CP%Num_Nu_Massive /= 0) then
            call MassiveNuVarsOut(EV,ay,ayprime,a, clxnu_all =clxnu_all, dgpi= dgpi)
        end if
        EV%OutputTransfer(Transfer_nu) = clxnu_all
        EV%OutputTransfer(Transfer_tot) =  dgrho_matter/grho_matter !includes neutrinos
        EV%OutputTransfer(Transfer_nonu) = (grhob_t*clxb+grhoc_t*clxc)/(grhob_t + grhoc_t)
        EV%OutputTransfer(Transfer_tot_de) =  dgrho/grho_matter
        !Transfer_Weyl is k^2Phi, where Phi is the Weyl potential
        EV%OutputTransfer(Transfer_Weyl) = -(dgrho +3*dgq*adotoa/k)/(EV%Kf(1)*2) - dgpi/2
        EV%OutputTransfer(Transfer_Newt_vel_cdm)=  -k*sigma/adotoa
        EV%OutputTransfer(Transfer_Newt_vel_baryon) = -k*(vb + sigma)/adotoa
        EV%OutputTransfer(Transfer_vel_baryon_cdm) = vb
    end if

    !  CDM equation of motion
    clxcdot=-k*z
    ayprime(3)=clxcdot

    !  Baryon equation of motion.
    clxbdot=-k*(z+vb)
    ayprime(4)=clxbdot
    !  Photon equation of motion
    clxgdot=-k*(4._dl/3._dl*z+qg)

    ! old comment:Small k: potential problem with stability, using full equations earlier is NOT more accurate in general
    ! Easy to see instability in k \sim 1e-3 by tracking evolution of vb

    !  Use explicit equation for vb if appropriate

    if (EV%TightCoupling) then
        !  ddota/a
        gpres=gpres + grhov_t*w_eff
        adotdota=(adotoa*adotoa-gpres)/2

        pig = 32._dl/45/opacity*k*(sigma+vb)

        !  First-order approximation to baryon-photon splip
        slip = - (2*adotoa/(1+pb43) + dopacity/opacity)* (vb-3._dl/4*qg) &
            +(-adotdota*vb-k/2*adotoa*clxg +k*(cs2*clxbdot-clxgdot/4))/(opacity*(1+pb43))

        if (second_order_tightcoupling) then
            ! by Francis-Yan Cyr-Racine simplified (inconsistently) by AL assuming flat
            !AL: First order slip seems to be fine here to 2e-4

            !  8*pi*G*a*a*SUM[rho_i*sigma_i]
            dgs = grhog_t*pig+grhor_t*pir

            ! Define shear derivative to first order
            sigmadot = -2*adotoa*sigma-dgs/k+etak

            !Once know slip, recompute qgdot, pig, pigdot
            qgdot = k*(clxg/4._dl-pig/2._dl) +opacity*slip

            pig = 32._dl/45/opacity*k*(sigma+3._dl*qg/4._dl)*(1+(dopacity*11._dl/6._dl/opacity**2)) &
                + (32._dl/45._dl/opacity**2)*k*(sigmadot+3._dl*qgdot/4._dl)*(-11._dl/6._dl)

            pigdot = -(32._dl/45._dl)*(dopacity/opacity**2)*k*(sigma+3._dl*qg/4._dl)*(1 + &
                dopacity*11._dl/6._dl/opacity**2 ) &
                + (32._dl/45._dl/opacity)*k*(sigmadot+3._dl*qgdot/4._dl)*(1+(11._dl/6._dl) &
                *(dopacity/opacity**2))

            EV%pigdot = pigdot
        end if

        !  Use tight-coupling approximation for vb
        !  zeroth order approximation to vbdot + the pig term
        vbdot=(-adotoa*vb+cs2*k*clxb  &
            +k/4*pb43*(clxg-2*EV%Kf(1)*pig))/(1+pb43)

        vbdot=vbdot+pb43/(1+pb43)*slip

        EV%pig = pig
    else
        vbdot=-adotoa*vb+cs2*k*clxb-photbar*opacity*(4._dl/3*vb-qg)
    end if

    ayprime(5)=vbdot

    if (.not. EV%no_phot_multpoles) then
        !  Photon equations of motion
        ayprime(EV%g_ix)=clxgdot
        qgdot=4._dl/3*(-vbdot-adotoa*vb+cs2*k*clxb)/pb43 &
            +EV%denlk(1)*clxg-EV%denlk2(1)*pig
        ayprime(EV%g_ix+1)=qgdot

        !  Use explicit equations for photon moments if appropriate
        if (.not. EV%tightcoupling) then
            E2=ay(EV%polind+2)
            polter = pig/10+9._dl/15*E2 !2/15*(3/4 pig + 9/2 E2)
            ix= EV%g_ix+2
            if (EV%lmaxg>2) then
                pigdot=EV%denlk(2)*qg-EV%denlk2(2)*ay(ix+1)-opacity*(pig - polter) &
                    +8._dl/15._dl*k*sigma
                ayprime(ix)=pigdot
                do  l=3,EV%lmaxg-1
                    ix=ix+1
                    ayprime(ix)=(EV%denlk(l)*ay(ix-1)-EV%denlk2(l)*ay(ix+1))-opacity*ay(ix)
                end do
                ix=ix+1
                !  Truncate the photon moment expansion
                ayprime(ix)=k*ay(ix-1)-(EV%lmaxg+1)*cothxor*ay(ix) -opacity*ay(ix)
            else !closed case
                pigdot=EV%denlk(2)*qg-opacity*(pig - polter) +8._dl/15._dl*k*sigma
                ayprime(ix)=pigdot
            endif
            !  Polarization
            !l=2
            ix=EV%polind+2
            if (EV%lmaxgpol>2) then
                ayprime(ix) = -opacity*(ay(ix) - polter) - k/3._dl*ay(ix+1)
                do l=3,EV%lmaxgpol-1
                    ix=ix+1
                    ayprime(ix)=-opacity*ay(ix) + (EV%denlk(l)*ay(ix-1)-EV%polfack(l)*ay(ix+1))
                end do
                ix=ix+1
                !truncate
                ayprime(ix)=-opacity*ay(ix) + &
                    k*EV%poltruncfac*ay(ix-1)-(EV%lmaxgpol+3)*cothxor*ay(ix)
            else !closed case
                ayprime(ix) = -opacity*(ay(ix) - polter)
            endif
        end if
    end if

    if (.not. EV%no_nu_multpoles) then
        !  Massless neutrino equations of motion.
        clxrdot=-k*(4._dl/3._dl*z+qr)
        ayprime(EV%r_ix)=clxrdot
        qrdot=EV%denlk(1)*clxr-EV%denlk2(1)*pir
        ayprime(EV%r_ix+1)=qrdot
        if (EV%high_ktau_neutrino_approx) then
            !ufa approximation for k*tau>>1, more accurate when there are reflections from lmax
            !Method from arXiv:1104.2933
            !                if (.not. EV%TightCoupling) then
            !                 gpres=gpres+ (grhog_t+grhor_t)/3 +grhov_t*w_lam
            !                 adotdota=(adotoa*adotoa-gpres)/2
            !                end if
            !                ddz=(2*adotoa**2 - adotdota)*z  &
            !                  + adotoa/(2*k)*( 6*(grhog_t*clxg+grhor_t*clxr) + 2*(grhoc_t*clxc+grhob_t*clxb) ) &
            !                   - 1._dl/(2*k)*( 2*(grhog_t*clxgdot+grhor_t*clxrdot) + grhoc_t*clxcdot + grhob_t*clxbdot )
            !                dz= -adotoa*z - 0.5_dl*dgrho/k
            !                pirdot= -3*pir*cothxor + k*(qr+4._dl/3*z)
            pirdot= -3*pir*cothxor - clxrdot
            ayprime(EV%r_ix+2)=pirdot

            !                pirdot=k*(0.4_dl*qr-0.6_dl*ay(EV%lmaxg+10)+8._dl/15._dl*sigma)
            !                ayprime(EV%lmaxg+9)=pirdot
            !                ayprime(3+EV%lmaxg+7)=k*ay(3+EV%lmaxg+6)- &
            !                                      (3+1)*cothxor*ay(3+EV%lmaxg+7)
            !               ayprime(3+EV%lmaxg+7+1:EV%lmaxnr+EV%lmaxg+7)=0
        else
            ix=EV%r_ix+2
            if (EV%lmaxnr>2) then
                pirdot=EV%denlk(2)*qr- EV%denlk2(2)*ay(ix+1)+8._dl/15._dl*k*sigma
                ayprime(ix)=pirdot
                do l=3,EV%lmaxnr-1
                    ix=ix+1
                    ayprime(ix)=(EV%denlk(l)*ay(ix-1) - EV%denlk2(l)*ay(ix+1))
                end do
                !  Truncate the neutrino expansion
                ix=ix+1
                ayprime(ix)=k*ay(ix-1)- (EV%lmaxnr+1)*cothxor*ay(ix)
            else
                pirdot=EV%denlk(2)*qr +8._dl/15._dl*k*sigma
                ayprime(ix)=pirdot
            end if
        end if
    end if ! no_nu_multpoles

    !  Massive neutrino equations of motion.
    if (CP%Num_Nu_massive == 0) return

    do nu_i = 1, CP%Nu_mass_eigenstates
        if (EV%MassiveNuApprox(nu_i)) then
            !Now EV%iq0 = clx, EV%iq0+1 = clxp, EV%iq0+2 = G_1, EV%iq0+3=G_2=pinu
            !see astro-ph/0203507
            G11_t=EV%G11(nu_i)/a/a2
            G30_t=EV%G30(nu_i)/a/a2
            off_ix = EV%nu_ix(nu_i)
            w=wnu_arr(nu_i)
            ayprime(off_ix)=-k*z*(w+1) + 3*adotoa*(w*ay(off_ix) - ay(off_ix+1))-k*ay(off_ix+2)
            ayprime(off_ix+1)=(3*w-2)*adotoa*ay(off_ix+1) - 5._dl/3*k*z*w - k/3*G11_t
            ayprime(off_ix+2)=(3*w-1)*adotoa*ay(off_ix+2) - k*(2._dl/3*EV%Kf(1)*ay(off_ix+3)-ay(off_ix+1))
            ayprime(off_ix+3)=(3*w-2)*adotoa*ay(off_ix+3) + 2*w*k*sigma - k/5*(3*EV%Kf(2)*G30_t-2*G11_t)
        else
            ind=EV%nu_ix(nu_i)
            do i=1,EV%nq(nu_i)
                q=nu_q(i)
                aq=a*nu_masses(nu_i)/q
                v=1._dl/sqrt(1._dl+aq*aq)

                ayprime(ind)=-k*(4._dl/3._dl*z + v*ay(ind+1))
                ind=ind+1
                ayprime(ind)=v*(EV%denlk(1)*ay(ind-1)-EV%denlk2(1)*ay(ind+1))
                ind=ind+1
                if (EV%lmaxnu_tau(nu_i)==2) then
                    ayprime(ind)=-ayprime(ind-2) -3*cothxor*ay(ind)
                else
                    ayprime(ind)=v*(EV%denlk(2)*ay(ind-1)-EV%denlk2(2)*ay(ind+1)) &
                        +k*8._dl/15._dl*sigma
                    do l=3,EV%lmaxnu_tau(nu_i)-1
                        ind=ind+1
                        ayprime(ind)=v*(EV%denlk(l)*ay(ind-1)-EV%denlk2(l)*ay(ind+1))
                    end do
                    !  Truncate moment expansion.
                    ind = ind+1
                    ayprime(ind)=k*v*ay(ind-1)-(EV%lmaxnu_tau(nu_i)+1)*cothxor*ay(ind)
                end if
                ind = ind+1
            end do
        end if
    end do

    if (EV%has_nu_relativistic) then
        ind=EV%nu_pert_ix
        ayprime(ind)=+k*a2*qr -k*ay(ind+1)
        ind2= EV%r_ix
        do l=1,EV%lmaxnu_pert-1
            ind=ind+1
            ind2=ind2+1
            ayprime(ind)= -a2*(EV%denlk(l)*ay(ind2-1)-EV%denlk2(l)*ay(ind2+1)) &
                +   (EV%denlk(l)*ay(ind-1)-EV%denlk2(l)*ay(ind+1))
        end do
        ind=ind+1
        ind2=ind2+1
        ayprime(ind)= k*(ay(ind-1) -a2*ay(ind2-1)) -(EV%lmaxnu_pert+1)*cothxor*ay(ind)
    end if

    end subroutine derivs



    subroutine derivsv(EV,n,tau,yv,yvprime)
    !  Evaluate the time derivatives of the vector perturbations, flat case
    use ThermoData
    use MassiveNu
    implicit none
    type(EvolutionVars) EV
    integer n,l
    real(dl), target ::  yv(n),yvprime(n)
    real(dl) ep,tau,grho,rhopi,cs2,opacity,gpres
    logical finished_tightcoupling
    real(dl), dimension(:),pointer :: neut,neutprime,E,B,Eprime,Bprime
    real(dl)  grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,polter
    real(dl) sigma, qg,pig, qr, vb, rhoq, vbdot, photbar, pb43
    real(dl) k,k2,a,a2, adotdota
    real(dl) pir,adotoa

    stop 'ppf not implemented for vectors'

    k2=EV%k2_buf
    k=EV%k_buf

    !E and B start at l=2. Set up pointers accordingly to fill in y arrays
    E => yv(EV%lmaxv+3:)
    Eprime=> yvprime(EV%lmaxv+3:)
    B => E(EV%lmaxpolv:)
    Bprime => Eprime(EV%lmaxpolv:)
    neutprime => Bprime(EV%lmaxpolv+1:)
    neut => B(EV%lmaxpolv+1:)

    a=yv(1)

    sigma=yv(2)

    a2=a*a

    !  Get sound speed and opacity, and see if should use tight-coupling

    call thermo(tau,cs2,opacity)
    if (k > 0.06_dl*epsw) then
        ep=ep0
    else
        ep=0.2_dl*ep0
    end if

    finished_tightcoupling = &
        ((k/opacity > ep).or.(1._dl/(opacity*tau) > ep .and. k/opacity > 1d-4))


    ! Compute expansion rate from: grho=8*pi*rho*a**2
    ! Also calculate gpres: 8*pi*p*a**2
    grhob_t=grhob/a
    grhoc_t=grhoc/a
    grhor_t=grhornomass/a2
    grhog_t=grhog/a2
    grhov_t=grhov*a**(-1-3*w_lam)

    grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t
    gpres=(grhog_t+grhor_t)/3._dl+grhov_t*w_lam

    adotoa=sqrt(grho/3._dl)
    adotdota=(adotoa*adotoa-gpres)/2

    photbar=grhog_t/grhob_t
    pb43=4._dl/3*photbar

    yvprime(1)=adotoa*a

    vb = yv(3)
    qg = yv(4)
    qr = neut(1)

    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    rhoq=grhob_t*vb+grhog_t*qg+grhor_t*qr
    !  sigma = 2*rhoq/k**2
    !for non-large k this expression for sigma is unstable at early times
    !so propagate sigma equation separately (near total cancellation in rhoq)
    ! print *,yv(2),2*rhoq/k**2

    if (finished_tightcoupling) then
        !  Use explicit equations:

        pig = yv(5)

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)

        vbdot = -adotoa*vb-photbar*opacity*(4._dl/3*vb-qg) - 0.5_dl*k*photbar*Magnetic

        !  Equation for the photon heat flux stress

        yvprime(4)=-0.5_dl*k*pig + opacity*(4._dl/3*vb-qg)

        !  Equation for the photon anisotropic stress
        yvprime(5)=k*(2._dl/5*qg -8/15._dl*yv(6))+8._dl/15._dl*k*sigma  &
            -opacity*(pig - polter)
        ! And for the moments
        do  l=3,EV%lmaxv-1
            yvprime(l+3)=k*denl(l)*l*(yv(l+2)-   &
                vecfac(l)*yv(l+4))-opacity*yv(l+3)
        end do
        !  Truncate the hierarchy
        yvprime(EV%lmaxv+3)=k*EV%lmaxv/(EV%lmaxv-1._dl)*yv(EV%lmaxv+2)- &
            (EV%lmaxv+2._dl)*yv(EV%lmaxv+3)/tau-opacity*yv(EV%lmaxv+3)

        !E equations

        Eprime(2) = - opacity*(E(2) - polter) + k*(1/3._dl*B(2) - 8._dl/27._dl*E(3))
        do l=3,EV%lmaxpolv-1
            Eprime(l) =-opacity*E(l) + k*(denl(l)*(l*E(l-1) - &
                vecfacpol(l)*E(l+1)) + 2._dl/(l*(l+1))*B(l))
        end do
        !truncate
        Eprime(EV%lmaxpolv)=0._dl

        !B-bar equations

        do l=2,EV%lmaxpolv-1
            Bprime(l) =-opacity*B(l) + k*(denl(l)*(l*B(l-1) - &
                vecfacpol(l)*B(l+1)) - 2._dl/(l*(l+1))*E(l))
        end do
        !truncate
        Bprime(EV%lmaxpolv)=0._dl
    else
        !Tight coupling expansion results

        pig = 32._dl/45._dl*k/opacity*(vb + sigma)

        EV%pig = pig

        vbdot=(-adotoa*vb  -3._dl/8*pb43*k*Magnetic  -3._dl/8*k*pb43*pig &
            - pb43/(1+pb43)/opacity*(0.75_dl*k*adotoa*pb43**2/(pb43+1)*Magnetic + vb*&
            ( 2*pb43*adotoa**2/(1+pb43) + adotdota)) &
            )/(1+pb43)

        !  Equation for the photon heat flux
        ! Get drag from vbdot expression
        yvprime(4)=-0.5_dl*k*pig - &
            (vbdot+adotoa*vb)/photbar - 0.5_dl*k*Magnetic

        !  Set the derivatives to zero
        yvprime(5:n)=0._dl
        yv(5)=pig
        E(2)=  pig/4
    endif

    yvprime(3) = vbdot

    !  Neutrino equations:

    !  Massless neutrino anisotropic stress
    pir=neut(2)
    neutprime(1)= -0.5_dl*k*pir
    neutprime(2)=2._dl/5*k*qr -8._dl/15._dl*k*neut(3)+ 8._dl/15._dl*k*sigma
    !  And for the moments
    do  l=3,EV%lmaxnrv-1
        neutprime(l)=k*denl(l)*l*(neut(l-1)- vecfac(l)*neut(l+1))
    end do

    !  Truncate the hierarchy
    neutprime(EV%lmaxnrv)=k*EV%lmaxnrv/(EV%lmaxnrv-1._dl)*neut(EV%lmaxnrv-1)-  &
        (EV%lmaxnrv+2._dl)*neut(EV%lmaxnrv)/tau


    !  Get the propagation equation for the shear

    rhopi=grhog_t*pig+grhor_t*pir+ grhog_t*Magnetic

    yvprime(2)=-2*adotoa*sigma -rhopi/k

    end subroutine derivsv



    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine derivst(EV,n,tau,ayt,aytprime)
    !  Evaluate the time derivatives of the tensor perturbations.
    use ThermoData
    use MassiveNu
    implicit none
    type(EvolutionVars) EV
    integer n,l,i,ind, nu_i
    real(dl), target ::  ayt(n),aytprime(n)
    real(dl) tau,grho,rhopi,cs2,opacity,pirdt
    real(dl), dimension(:),pointer :: neut,neutprime,E,B,Eprime,Bprime
    real(dl) q,aq,v
    real(dl)  grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,polter
    real(dl) Hchi,pinu, pig
    real(dl) k,k2,a,a2
    real(dl) pir, adotoa, rhonu, shear

    real(dl) cothxor

    k2=EV%k2_buf
    k= EV%k_buf

    a=ayt(1)

    Hchi=ayt(2)

    shear=ayt(3)

    a2=a*a

    ! Compute expansion rate from: grho=8*pi*rho*a**2
    ! Also calculate gpres: 8*pi*p*a**2
    grhob_t=grhob/a
    grhoc_t=grhoc/a
    grhor_t=grhornomass/a2
    grhog_t=grhog/a2
    if (is_cosmological_constant) then
        grhov_t=grhov*a2
    else
        grhov_t=grho_de(a)/a2
    end if

    grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t

    !Do massive neutrinos
    if (CP%Num_Nu_Massive >0) then
        do nu_i=1,CP%Nu_mass_eigenstates
            call Nu_rho(a*nu_masses(nu_i),rhonu)
            grho=grho+grhormass(nu_i)*rhonu/a2
        end do
    end if

    if (CP%flat) then
        cothxor=1._dl/tau
        adotoa=sqrt(grho/3._dl)
    else
        cothxor=1._dl/tanfunc(tau/CP%r)/CP%r
        adotoa=sqrt((grho+grhok)/3._dl)
    end if

    aytprime(1)=adotoa*a

    call thermo(tau,cs2,opacity)

    if (.not. EV%TensTightCoupling) then
        !  Don't use tight coupling approx - use explicit equations:
        !  Equation for the photon anisotropic stress


        !E and B start at l=2. Set up pointers accordingly to fill in ayt arrays
        E => ayt(EV%E_ix+1:)
        B => ayt(EV%B_ix+1:)
        Eprime=> aytprime(EV%E_ix+1:)
        Bprime => aytprime(EV%B_ix+1:)

        ind = EV%g_ix+2

        !  Photon anisotropic stress
        pig=ayt(ind)
        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)

        if (EV%lmaxt > 2) then
            aytprime(ind)=-EV%denlkt(2,2)*ayt(ind+1)+k*8._dl/15._dl*shear  &
                -opacity*(pig - polter)

            do l=3, EV%lmaxt -1
                ind = ind+1
                aytprime(ind)=EV%denlkt(1,L)*ayt(ind-1)-EV%denlkt(2,L)*ayt(ind+1)-opacity*ayt(ind)
            end do

            !Truncate the hierarchy
            ind=ind+1
            aytprime(ind)=k*EV%lmaxt/(EV%lmaxt-2._dl)*ayt(ind-1)- &
                (EV%lmaxt+3._dl)*cothxor*ayt(ind)-opacity*ayt(ind)

            !E and B-bar equations

            Eprime(2) = - opacity*(E(2) - polter) + EV%denlkt(4,2)*B(2) - &
                EV%denlkt(3,2)*E(3)

            do l=3, EV%lmaxpolt-1
                Eprime(l) =(EV%denlkt(1,L)*E(l-1)-EV%denlkt(3,L)*E(l+1) + EV%denlkt(4,L)*B(l)) &
                    -opacity*E(l)
            end do
            l= EV%lmaxpolt
            !truncate: difficult, but setting l+1 to zero seems to work OK
            Eprime(l) = (EV%denlkt(1,L)*E(l-1) + EV%denlkt(4,L)*B(l)) -opacity*E(l)

            Bprime(2) =-EV%denlkt(3,2)*B(3) - EV%denlkt(4,2)*E(2)  -opacity*B(2)
            do l=3, EV%lmaxpolt-1
                Bprime(l) =(EV%denlkt(1,L)*B(l-1) -EV%denlkt(3,L)*B(l+1) - EV%denlkt(4,L)*E(l)) &
                    -opacity*B(l)
            end do
            l=EV%lmaxpolt
            !truncate
            Bprime(l) =(EV%denlkt(1,L)*B(l-1) - EV%denlkt(4,L)*E(l))  -opacity*B(l)

        else !lmax=2

            aytprime(ind)=k*8._dl/15._dl*shear-opacity*(pig - polter)
            Eprime(2) = - opacity*(E(2) - polter) + EV%denlkt(4,2)*B(2)
            Bprime(2) = - EV%denlkt(4,2)*E(2)  -opacity*B(2)
        end if

    else  !Tight coupling
        pig = 32._dl/45._dl*k/opacity*shear
    endif

    rhopi=grhog_t*pig


    !  Neutrino equations:
    !  Anisotropic stress
    if (DoTensorNeutrinos) then
        neutprime => aytprime(EV%r_ix+1:)
        neut => ayt(EV%r_ix+1:)

        !  Massless neutrino anisotropic stress
        pir=neut(2)

        rhopi=rhopi+grhor_t*pir

        if (EV%lmaxnrt>2) then
            pirdt=-EV%denlkt(2,2)*neut(3) + 8._dl/15._dl*k*shear
            neutprime(2)=pirdt
            !  And for the moments
            do  l=3, EV%lmaxnrt-1
                neutprime(l)= EV%denlkt(1,L)*neut(l-1) -EV%denlkt(2,L)*neut(l+1)
            end do

            !  Truncate the hierarchy
            neutprime(EV%lmaxnrt)=k*EV%lmaxnrt/(EV%lmaxnrt-2._dl)*neut(EV%lmaxnrt-1)-  &
                (EV%lmaxnrt+3._dl)*cothxor*neut(EV%lmaxnrt)
        else
            pirdt= 8._dl/15._dl*k*shear
            neutprime(2)=pirdt
        end if

        !  Massive neutrino equations of motion and contributions to anisotropic stress.
        if (CP%Num_Nu_massive > 0) then
            do nu_i=1,CP%Nu_mass_eigenstates
                if (.not. EV%EvolveTensorMassiveNu(nu_i)) then
                    rhopi=rhopi+ grhormass(nu_i)/a2*pir !- good approx, note no rhonu weighting
                else
                    ind=EV%nu_ix(nu_i)+2

                    pinu= Nu_pi(EV, ayt, a, nu_i)
                    rhopi=rhopi+ grhormass(nu_i)/a2*pinu

                    do i=1,nqmax
                        q=nu_q(i)
                        aq=a*nu_masses(nu_i)/q
                        v=1._dl/sqrt(1._dl+aq*aq)
                        if (EV%lmaxnut>2) then
                            aytprime(ind)=-v*EV%denlkt(2,2)*ayt(ind+1)+8._dl/15._dl*k*shear
                            do l=3,EV%lmaxnut-1
                                ind=ind+1
                                aytprime(ind)=v*(EV%denlkt(1,L)*ayt(ind-1)-EV%denlkt(2,L)*ayt(ind+1))
                            end do
                            ind = ind+1
                            !Truncate moment expansion.
                            aytprime(ind)=k*v*EV%lmaxnut/(EV%lmaxnut-2._dl)*ayt(ind-1)-(EV%lmaxnut+3)*cothxor*ayt(ind)
                        else
                            aytprime(ind)=8._dl/15._dl*k*shear
                        end if
                        ind=ind+1
                    end do
                end if
            end do
        end if
    end if

    !  Get the propagation equation for the shear

    if (CP%flat) then
        aytprime(3)=-2*adotoa*shear+k*Hchi-rhopi/k
    else
        aytprime(3)=-2*adotoa*shear+k*Hchi*(1+2*CP%curv/k2)-rhopi/k
    endif

    aytprime(2)=-k*shear

    end subroutine derivst



    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    end module GaugeInterface

    module DarkEnergyPPF
    use DarkEnergyInterface
    use classes
    implicit none

    private

    type, extends(TDarkEnergyEqnOfState) :: TDarkEnergyPPF
        real(dl) :: c_Gamma_ppf = 0.4_dl
    contains
    procedure :: ReadParams => TDarkEnergyPPF_ReadParams
    procedure, nopass :: PythonClass => TDarkEnergyPPF_PythonClass
    procedure :: Init => TDarkEnergyPPF_Init
    procedure :: PerturbedStressEnergy => TDarkEnergyPPF_PerturbedStressEnergy
    procedure :: diff_rhopi_Add_Term => TDarkEnergyPPF_diff_rhopi_Add_Term
    procedure, nopass :: SelfPointer => TDarkEnergyPPF_SelfPointer
    procedure, private :: setcgammappf
    end type TDarkEnergyPPF

    public TDarkEnergyPPF
    contains

    subroutine TDarkEnergyPPF_ReadParams(this, Ini)
    use IniObjects
    class(TDarkEnergyPPF) :: this
    class(TIniFile), intent(in) :: Ini

    call this%TDarkEnergyEqnOfState%ReadParams(Ini)
    this%cs2_lam = Ini%Read_Double('cs2_lam', 1.d0)
    if (this%cs2_lam /= 1._dl) error stop 'cs2_lam not supported by PPF model'
    call this%setcgammappf

    end subroutine TDarkEnergyPPF_ReadParams

    function TDarkEnergyPPF_PythonClass()
    character(LEN=:), allocatable :: TDarkEnergyPPF_PythonClass

    TDarkEnergyPPF_PythonClass = 'DarkEnergyPPF'
    end function TDarkEnergyPPF_PythonClass


    subroutine TDarkEnergyPPF_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TDarkEnergyPPF), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TDarkEnergyPPF_SelfPointer

    subroutine TDarkEnergyPPF_Init(this, State)
    use classes
    use config
    class(TDarkEnergyPPF), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State

    call this%TDarkEnergyEqnOfState%Init(State)
    if (this%is_cosmological_constant) then
        this%num_perturb_equations = 0
    else
        this%num_perturb_equations = 1
    end if
    if (this%cs2_lam /= 1._dl) &
        call GlobalError('DarkEnergyPPF does not support varying sound speed',error_unsupported_params)

    end subroutine TDarkEnergyPPF_Init

    subroutine setcgammappf(this)
    class(TDarkEnergyPPF) :: this

    this%c_Gamma_ppf = 0.4_dl * sqrt(this%cs2_lam)

    end subroutine setcgammappf


    function TDarkEnergyPPF_diff_rhopi_Add_Term(this, dgrhoe, dgqe, grho, gpres, w,  grhok, adotoa, &
        Kf1, k, grhov_t, z, k2, yprime, y, w_ix) result(ppiedot)
    !Get derivative of anisotropic stress
    class(TDarkEnergyPPF), intent(in) :: this
    real(dl), intent(in) :: dgrhoe, dgqe, grho, gpres, w, grhok, adotoa, &
        k, grhov_t, z, k2, yprime(:), y(:), Kf1
    integer, intent(in) :: w_ix
    real(dl) :: ppiedot, hdotoh

    if (this%is_cosmological_constant .or. this%no_perturbations) then
        ppiedot = 0
    else
        hdotoh = (-3._dl * grho - 3._dl * gpres - 2._dl * grhok) / 6._dl / adotoa
        ppiedot = 3._dl * dgrhoe + dgqe * &
            (12._dl / k * adotoa + k / adotoa - 3._dl / k * (adotoa + hdotoh)) + &
            grhov_t * (1 + w) * k * z / adotoa - 2._dl * k2 * Kf1 * &
            (yprime(w_ix) / adotoa - 2._dl * y(w_ix))
        ppiedot = ppiedot * adotoa / Kf1
    end if

    end function TDarkEnergyPPF_diff_rhopi_Add_Term


    subroutine TDarkEnergyPPF_PerturbedStressEnergy(this, dgrhoe, dgqe, &
        a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1, ay, ayprime, w_ix)
    class(TDarkEnergyPPF), intent(inout) :: this
    real(dl), intent(out) :: dgrhoe, dgqe
    real(dl), intent(in) ::  a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1
    real(dl), intent(in) :: ay(*)
    real(dl), intent(inout) :: ayprime(*)
    integer, intent(in) :: w_ix
    real(dl) :: Gamma, S_Gamma, ckH, Gammadot, Fa, sigma
    real(dl) :: vT, grhoT, k2

    if (this%no_perturbations) then
        dgrhoe=0
        dgqe=0
        return
    end if

    k2=k**2
    !ppf
    grhoT = grho - grhov_t
    vT = dgq / (grhoT + gpres_noDE)
    Gamma = ay(w_ix)

    !sigma for ppf
    sigma = (etak + (dgrho + 3 * adotoa / k * dgq) / 2._dl / k) / kf1 - &
        k * Gamma
    sigma = sigma / adotoa

    S_Gamma = grhov_t * (1 + w) * (vT + sigma) * k / adotoa / 2._dl / k2
    ckH = this%c_Gamma_ppf * k / adotoa

    if (ckH * ckH .gt. 3.d1) then ! ckH^2 > 30 ?????????
        Gamma = 0
        Gammadot = 0.d0
    else
        Gammadot = S_Gamma / (1 + ckH * ckH) - Gamma - ckH * ckH * Gamma
        Gammadot = Gammadot * adotoa
    endif
    ayprime(w_ix) = Gammadot !Set this here, and don't use PerturbationEvolve

    Fa = 1 + 3 * (grhoT + gpres_noDE) / 2._dl / k2 / kf1
    dgqe = S_Gamma - Gammadot / adotoa - Gamma
    dgqe = -dgqe / Fa * 2._dl * k * adotoa + vT * grhov_t * (1 + w)
    dgrhoe = -2 * k2 * kf1 * Gamma - 3 / k * adotoa * dgqe

    end subroutine TDarkEnergyPPF_PerturbedStressEnergy



    end module DarkEnergyPPF

    module MassiveNu
    use constants
    implicit none
    private

    real(dl), parameter  :: fermi_dirac_const  = 7._dl/120*const_pi**4 ! 5.68219698_dl
    !fermi_dirac_const = int q^3 F(q) dq = 7/120*pi^4
    real(dl), parameter  :: const2 = 5._dl/7._dl/const_pi**2   !0.072372274_dl

    !Steps for spline interpolation (use series outside this range)
    integer, parameter  :: nrhopn=1400
    real(dl), parameter :: am_min = 0.3_dl
    !smallest a*m_nu to integrate distribution function rather than using series
    real(dl), parameter :: am_max = 70._dl
    !max a*m_nu to integrate

    !Actual range for using series (to avoid inaccurate ends of spline)
    real(dl), parameter :: am_minp=am_min + am_max/(nrhopn-1)*1.01_dl
    real(dl), parameter :: am_maxp=am_max*0.9_dl

    Type TNuPerturbations
        !Sample for massive neutrino momentum
        !Default settings appear to be OK for P_k accuate at 1e-3 level
        integer nqmax !actual number of q modes evolves
        real(dl), allocatable ::  nu_q(:), nu_int_kernel(:)
    contains
    procedure :: init => TNuPerturbations_init
    end type TNuPerturbations

    Type TThermalNuBackground
        !Quantities for the neutrino background momentum distribution assuming thermal
        real(dl) dam !step in a*m
        real(dl), dimension(:), allocatable ::  r1,p1,dr1,dp1,ddr1
        real(dl), private :: target_rho
    contains
    procedure :: init => ThermalNuBackground_init
    procedure :: rho_P => ThermalNuBackground_rho_P
    procedure :: rho => ThermalNuBackground_rho
    procedure :: drho => ThermalNuBackground_drho
    procedure :: find_nu_mass_for_rho => ThermalNuBackground_find_nu_mass_for_rho
    end type TThermalNuBackground

    Type(TThermalNuBackground), target :: ThermalNuBackground
    class(TThermalNuBackground), pointer :: ThermalNuBack !ifort workaround

    public fermi_dirac_const,  sum_mnu_for_m1, neutrino_mass_fac, TNuPerturbations, &
        ThermalNuBackground, ThermalNuBack
    contains

    subroutine sum_mnu_for_m1(summnu,dsummnu, m1, targ, sgn)
    use constants
    real(dl), intent(in) :: m1, targ, sgn
    real(dl), intent(out) :: summnu, dsummnu
    real(dl) :: m2,m3

    m2 = sqrt(m1**2 + delta_mnu21)
    m3 = sqrt(m1**2 + sgn*delta_mnu31)
    summnu = m1 + m2 + m3 - targ
    dsummnu = m1/m2+m1/m3 + 1

    end subroutine sum_mnu_for_m1

    subroutine TNuPerturbations_init(this,Accuracy)
    !Set up which momenta to integrate the neutrino perturbations, depending on accuracy
    !Using three optimized momenta works very well in most cases
    class(TNuPerturbations) :: this
    real(dl), intent(in) :: Accuracy
    real(dl) :: dq,dlfdlq, q
    integer i

    this%nqmax=3
    if (Accuracy>1) this%nqmax=4
    if (Accuracy>2) this%nqmax=5
    if (Accuracy>3) this%nqmax=nint(Accuracy*10)
    !note this may well be worse than the 5 optimized points

    !We evolve evolve 4F_l/dlfdlq(i), so kernel includes dlfdlnq factor
    !Integration scheme gets (Fermi-Dirac thing)*q^n exact,for n=-4, -2..2
    !see CAMB notes
    if (allocated(this%nu_q)) deallocate(this%nu_q, this%nu_int_kernel)
    allocate(this%nu_q(this%nqmax))
    allocate(this%nu_int_kernel(this%nqmax))

    if (this%nqmax==3) then
        !Accurate at 2e-4 level
        this%nu_q(1:3) = (/0.913201, 3.37517, 7.79184/)
        this%nu_int_kernel(1:3) = (/0.0687359, 3.31435, 2.29911/)
    else if (this%nqmax==4) then
        !This seems to be very accurate (limited by other numerics)
        this%nu_q(1:4) = (/0.7, 2.62814, 5.90428, 12.0/)
        this%nu_int_kernel(1:4) = (/0.0200251, 1.84539, 3.52736, 0.289427/)
    else if (this%nqmax==5) then
        !exact for n=-4,-2..3
        !This seems to be very accurate (limited by other numerics)
        this%nu_q(1:5) = (/0.583165, 2.0, 4.0, 7.26582, 13.0/)
        this%nu_int_kernel(1:5) = (/0.0081201, 0.689407, 2.8063, 2.05156, 0.126817/)
    else
        dq = (12 + this%nqmax/5)/real(this%nqmax)
        do i=1,this%nqmax
            q=(i-0.5d0)*dq
            this%nu_q(i) = q
            dlfdlq=-q/(1._dl+exp(-q))
            this%nu_int_kernel(i)=dq*q**3/(exp(q)+1._dl) * (-0.25_dl*dlfdlq) !now evolve 4F_l/dlfdlq(i)
        end do
    end if
    this%nu_int_kernel=this%nu_int_kernel/fermi_dirac_const

    end subroutine TNuPerturbations_init

    subroutine ThermalNuBackground_init(this)
    use splines
    class(TThermalNuBackground) :: this
    !  Initialize interpolation tables for massive neutrinos.
    !  Use cubic splines interpolation of log rhonu and pnu vs. log a*m.
    integer i
    real(dl) am, rhonu,pnu
    real(dl) spline_data(nrhopn)

    if (allocated(this%r1)) return
    ThermalNuBack => ThermalNuBackground !ifort bug workaround

    allocate(this%r1(nrhopn),this%p1(nrhopn),this%dr1(nrhopn),this%dp1(nrhopn),this%ddr1(nrhopn))
    this%dam=(am_max-am_min)/(nrhopn-1)

    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), &
    !$OMP& PRIVATE(am,rhonu,pnu)
    do i=1,nrhopn
        am=am_min + (i-1)*this%dam
        call nuRhoPres(am,rhonu,pnu)
        this%r1(i)=rhonu
        this%p1(i)=pnu
    end do
    !$OMP END PARALLEL DO

    call splini(spline_data,nrhopn)
    call splder(this%r1,this%dr1,nrhopn,spline_data)
    call splder(this%p1,this%dp1,nrhopn,spline_data)
    call splder(this%dr1,this%ddr1,nrhopn,spline_data)

    end subroutine ThermalNuBackground_init

    subroutine nuRhoPres(am,rhonu,pnu)
    !  Compute the density and pressure of one eigenstate of massive neutrinos,
    !  in units of the mean density of one flavor of massless neutrinos.
    use splines
    real(dl),  parameter :: qmax=30._dl
    integer, parameter :: nq=100
    real(dl) dum1(nq+1),dum2(nq+1)
    real(dl), intent(in) :: am
    real(dl), intent(out) ::  rhonu,pnu
    integer i
    real(dl) q,aq,v,aqdn,adq

    !  q is the comoving momentum in units of k_B*T_nu0/c.
    !  Integrate up to qmax and then use asymptotic expansion for remainder.
    adq=qmax/nq
    dum1(1)=0._dl
    dum2(1)=0._dl
    do  i=1,nq
        q=i*adq
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        aqdn=adq*q*q*q/(exp(q)+1._dl)
        dum1(i+1)=aqdn/v
        dum2(i+1)=aqdn*v
    end do
    call splint(dum1,rhonu,nq+1)
    call splint(dum2,pnu,nq+1)
    !  Apply asymptotic corrrection for q>qmax and normalize by relativistic
    !  energy density.
    rhonu=(rhonu+dum1(nq+1)/adq)/fermi_dirac_const
    pnu=(pnu+dum2(nq+1)/adq)/fermi_dirac_const/3._dl

    end subroutine nuRhoPres

    subroutine ThermalNuBackground_rho_P(this,am,rhonu,pnu)
    class(TThermalNuBackground) :: this
    real(dl), intent(in) :: am
    real(dl), intent(out) :: rhonu, pnu
    real(dl) d, logam, am2
    integer i
    !  Compute massive neutrino density and pressure in units of the mean
    !  density of one eigenstate of massless neutrinos.  Use cubic splines to
    !  interpolate from a table. Accuracy generally better than 1e-5.

    if (am <= am_minp) then
        if (am< 0.01_dl) then
            rhonu=1._dl + const2*am**2
            pnu=(2-rhonu)/3._dl
        else
            !Higher order expansion result less obvious, Appendix A of arXiv:0911.2714
            am2=am**2
            logam = log(am)
            rhonu = 1+am2*(const2+am2*(.1099926669d-1*logam-.3492416767d-2-.5866275571d-2*am))
            pnu = (1+am2*(-const2+am2*(-.3299780009d-1*logam-.5219952794d-3+.2346510229d-1*am)))/3
        end if
        return
    else if (am >= am_maxp) then
        !Simple series solution (expanded in 1/(a*m))
        rhonu = 3/(2*fermi_dirac_const)*(zeta3*am + ((15*zeta5)/2 - 945._dl/16*zeta7/am**2)/am)
        pnu = 900._dl/120._dl/fermi_dirac_const*(zeta5-63._dl/4*Zeta7/am**2)/am
        return
    end if

    d=(am-am_min)/this%dam+1._dl
    i=int(d)
    d=d-i

    !  Cubic spline interpolation.
    rhonu=this%r1(i)+d*(this%dr1(i)+d*(3._dl*(this%r1(i+1)-this%r1(i))-2._dl*this%dr1(i) &
        -this%dr1(i+1)+d*(this%dr1(i)+this%dr1(i+1)+2._dl*(this%r1(i)-this%r1(i+1)))))
    pnu=this%p1(i)+d*(this%dp1(i)+d*(3._dl*(this%p1(i+1)-this%p1(i))-2._dl*this%dp1(i) &
        -this%dp1(i+1)+d*(this%dp1(i)+this%dp1(i+1)+2._dl*(this%p1(i)-this%p1(i+1)))))

    end subroutine ThermalNuBackground_rho_P

    subroutine ThermalNuBackground_rho(this,am,rhonu)
    class(TThermalNuBackground) :: this
    real(dl), intent(in) :: am
    real(dl), intent(out) :: rhonu
    real(dl) d, am2
    integer i

    !  Compute massive neutrino density in units of the mean
    !  density of one eigenstate of massless neutrinos.  Use series solutions or
    !  cubic splines to interpolate from a table.

    if (am <= am_minp) then
        if (am < 0.01_dl) then
            rhonu=1._dl + const2*am**2
        else
            am2=am**2
            rhonu = 1+am2*(const2+am2*(.1099926669d-1*log(am)-.3492416767d-2-.5866275571d-2*am))
        end if
        return
    else if (am >= am_maxp) then
        rhonu = 3/(2*fermi_dirac_const)*(zeta3*am + ((15*zeta5)/2 - 945._dl/16*zeta7/am**2)/am)
        return
    end if

    d=(am-am_min)/this%dam+1._dl
    i=int(d)
    d=d-i

    !  Cubic spline interpolation.
    rhonu=this%r1(i)+d*(this%dr1(i)+d*(3._dl*(this%r1(i+1)-this%r1(i))-2._dl*this%dr1(i) &
        -this%dr1(i+1)+d*(this%dr1(i)+this%dr1(i+1)+2._dl*(this%r1(i)-this%r1(i+1)))))

    end subroutine ThermalNuBackground_rho

    function rho_err(this, nu_mass)
    class(TThermalNuBackground) :: this
    real(dl) rho_err, nu_mass, rhonu

    call this%rho(nu_mass, rhonu)
    rho_err = rhonu - this%target_rho

    end function rho_err

    function ThermalNuBackground_find_nu_mass_for_rho(this,rho) result(nu_mass)
    !  Get eigenstate mass given input density (rho is neutrino density in units of one massless)
    !  nu_mass=m_n*c**2/(k_B*T_nu0).
    !  Get number density n of neutrinos from
    !  rho_massless/n = int q^3/(1+e^q) / int q^2/(1+e^q)=7/180 pi^4/Zeta(3)
    !  then m = Omega_nu/N_nu rho_crit /n if non-relativistic
    use MathUtils
    use config
    class(TThermalNuBackground) :: this
    real(dl), intent(in) :: rho
    real(dl) nu_mass, rhonu, rhonu1, delta
    real(dl) fzero
    integer iflag

    if (rho <= 1.001_dl) then
        !energy density all accounted for by massless result
        nu_mass=0
    else
        !Get mass assuming fully non-relativistic
        nu_mass=fermi_dirac_const/(1.5d0*zeta3)*rho

        if (nu_mass>4) then
            !  perturbative correction for velocity when nearly non-relativistic
            !  Error due to velocity < 1e-5 for mnu~0.06 but can easily correct (assuming non-relativistic today)
            !  Note that python does not propagate mnu to omnuh2 consistently to the same accuracy; but this makes
            !  fortran more internally consistent between input and computed Omega_nu h^2

            !Make perturbative correction for the tiny error due to the neutrino velocity
            call this%rho(nu_mass, rhonu)
            call this%rho(nu_mass*0.9, rhonu1)
            delta = rhonu - rho
            nu_mass = nu_mass*(1 + delta/((rhonu1 - rhonu)/0.1) )
        else
            !Directly solve to avoid issues with perturbative result when no longer very relativistic
            this%target_rho = rho
            call brentq(this,rho_err,0._dl,nu_mass,0.01_dl,nu_mass,fzero,iflag)
            if (iflag/=0) call GlobalError('find_nu_mass_for_rho failed to find neutrino mass')
        end if
    end if

    end function ThermalNuBackground_find_nu_mass_for_rho


    function ThermalNuBackground_drho(this,am,adotoa) result (rhonudot)
    !  Compute the time derivative of the mean density in massive neutrinos
    class(TThermalNuBackground) :: this
    real(dl) adotoa,rhonudot
    real(dl) d, am2
    real(dl), intent(IN) :: am
    integer i

    if (am< am_minp) then
        !rhonudot = 2*const2*am**2*adotoa
        am2 = am**2
        rhonudot=  am**2*(2*const2 +am2*(0.1759882671_dl*log(am)+.3211546524d-1 -0.1466568893_dl*am))*adotoa
    else if (am>am_maxp) then
        rhonudot = 3/(2*fermi_dirac_const)*(zeta3*am +( -(15*zeta5)/2 + 2835._dl/16*zeta7/am**2)/am)*adotoa
    else
        d=(am-am_min)/this%dam+1._dl
        i=int(d)
        d=d-i
        !  Cubic spline interpolation for rhonudot.
        rhonudot=this%dr1(i)+d*(this%ddr1(i)+d*(3._dl*(this%dr1(i+1)-this%dr1(i)) &
            -2._dl*this%ddr1(i)-this%ddr1(i+1)+d*(this%ddr1(i)+this%ddr1(i+1) &
            +2._dl*(this%dr1(i)-this%dr1(i+1)))))

        rhonudot=adotoa*rhonudot/this%dam*am
    end if

    end function ThermalNuBackground_drho

    end module MassiveNu

    module FileTests
    use FileUtils
    implicit none

    character(LEN=*), parameter :: temp_file='test.tmp'

    !Some things are already tested in ObjectLists_tests

    contains

    function RunFileTests() result (fails)
    integer fails
    character(LEN=7400) :: St
    Type(TTextFile) :: T
    character(LEN=:), allocatable :: InLine, comment
    integer line
    real testval

    fails = 0

    St = 'test string'
    St(len(St):len(St)) = 'c'

    call T%CreateFile(temp_file)

    call T%Write('#comment header')
    call T%Write(' ')
    call T%Write(St)
    call T%Write('name = ',3.04)
    call T%Write(' tester values')
    call T%Close()

    line = 0
    do while (T%ReadNextContentLine(temp_file,InLine))
        line = line+1
        if (line==1) then
            if (Inline/=St) then
                fails = fails+1
                print *, 'Error reading string'
            end if
        else if (line==2) then
            read(InLine(7:),*) testval
            if (testval /= 3.04) then
                fails = fails+1
                print *, 'Error reading real'
            end if
        end if
    end do

    call T%Open(temp_file)
    if (T%ReadLineSkipEmptyAndComments(InLine, Comment)) then
        if (comment/='comment header') then
            fails = fails+1
            print *, 'Error reading header'
        end if
    else
        fails= fails+1
        print *, 'Error reading line'
    end if
    call T%Close(del=.true.)
    if (fails==0) print *,'OK file tests'

    end function RunFileTests


    end module FileTests

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! The `halofit' code models the nonlinear evolution of cold matter
    ! cosmological power spectra. The full details of the way in which
    ! this is done are presented in Smith et al. (2003), MNRAS, 341, 4
    !
    ! The code `halofit' was written by R. E. Smith & J. A. Peacock.
    ! See http://www.astro.upenn.edu/~res
    !
    ! Subsequent updates as below
    ! Only tested for basic models with power law initial power spectra
    ! References for variant versions are
    !   halofit_original: astro-ph/0207664
    !   halofit_peacock: http://www.roe.ac.uk/~jap/haloes/
    !   halofit_bird: arXiv: 1109.4416
    !   halofit_takahashi: arXiv: 1208.2701
    !   halofit_mead: arXiv:1505.07833,1602.02154
    !   halofit_casarini: arXiv:0810.0190, arXiv:1601.07230

    ! Adapted for F90 and CAMB, AL March 2005
    !!BR09 Oct 09: generalized expressions for om(z) and ol(z) to include w

    ! RT12 Oct: update some fitting parameters in the code to enhance
    !           the power spectrum at small scales (arXiv:1208.2701)

    !!JD 08/13: generalized expressions for om(z) and ol(z) to include
    !           w_0 and w_a
    ! SPB14 Feb: update the fitting parameters for neutrinos to work with RT12
    !           modifications
    ! AL Sept 14: added halofit_version parameter to change approximation used;
    !   separate halofit.f90 is no longer needed as equations.f90 defined fixed wa_ppf
    ! Jan 15: Suggested change from Simeon Bird to avoid issues with very large Omm and neutrinos
    !AM Mar 16: Added in HMcode
    !AM May 16: Fixed some small bugs and added better neutrino approximations
    !AL Jun16: put in partial openmp for HMcode (needs restructure to do properly)
    !AM Sep 16: Attempted fix of strange bug. No more modules with unallocated arrays as inputs
    !LC Oct 16: extended Halofit from w=const. models to w=w(a) with PKequal
    !AM May 17: Made the baryon feedback parameters more obvious in HMcode
    !AL Jul 17: fixed undefined z calling Tcb_Tcbnu_ratio
    !AM Jul 17: sped-up HMcode integration routines
    !AM May 18: Fixed bug in Dolag correction to c(M) power
    !AM Jul 19: Upgraded accuracy and bug fix for massive-neutrino models
    !AL Jul 19: Speedups, use linear interpolation for pk; find index using fixed spacing; precompute growth(z)
    !AL Sep 19: Propagate errors rather than stop, decrease jmax for integration time out (prevent very slow error)
    !AM Sep 20: Added HMcode-2020 model
    !AM Jan 23: Fixed HMcode-2020 feedback low-k predictions
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    module NonLinear
    use results
    use DarkEnergyInterface
    use classes
    use Transfer
    use constants
    use config
    implicit none
    private

    integer, parameter :: halofit_original=1, halofit_bird=2, halofit_peacock=3, halofit_takahashi=4
    integer, parameter :: halofit_casarini=7
    integer, parameter :: halofit_mead2016=5, halofit_halomodel=6, halofit_mead2015=8, halofit_mead2020=9
    integer, parameter :: halofit_mead2020_feedback=10
    integer, parameter :: halofit_mead=halofit_mead2016 ! AM Kept for backwards compatability
    integer, parameter :: halofit_default=halofit_mead2020

    logical :: HM_verbose = .false.

    type, extends(TNonLinearModel) :: THalofit
        integer :: halofit_version = halofit_default
        !!TT - These are the baryon parameters of HMCode
        real(dl) :: HMcode_A_baryon=3.13_dl
        real(dl) :: HMcode_eta_baryon=0.603_dl
        real(dl) :: HMcode_logT_AGN=7.8_dl
        !!AM - Added these types for HMcode
        integer, private :: imead !!AM - added these for HMcode, need to be visible to all subroutines and functions
        real(dl), private :: om_m,om_v,fnu,omm0, acur, w_hf, wa_hf
        real(dl), private :: om_c, om_b
    contains
    procedure :: ReadParams => THalofit_ReadParams
    procedure :: GetNonLinRatios => THalofit_GetNonLinRatios
    procedure :: halofit
    procedure :: HMcode
    procedure, nopass :: PythonClass => THalofit_PythonClass
    procedure, nopass :: SelfPointer => THalofit_SelfPointer
    procedure, private :: Delta_v
    procedure, private :: delta_c
    procedure, private :: eta
    procedure, private :: kstar
    procedure, private :: As
    procedure, private :: conc_bull
    procedure, private :: fdamp
    procedure, private :: p_1h
    procedure, private :: p_2h
    procedure, private :: alpha
    procedure, private :: halomod
    procedure, private :: halomod_init
    procedure, private :: write_parameters
    procedure, private :: zcoll_bull
    end type

    public THalofit, HM_verbose
    public halofit_default, halofit_original, halofit_bird, halofit_peacock, halofit_takahashi
    public halofit_mead2016, halofit_mead2015, halofit_mead2020, halofit_halomodel, halofit_casarini
    public halofit_mead2020_feedback
    public halofit_mead ! AM for backwards compatability

    TYPE HM_cosmology
        !Contains only things that do not need to be recalculated with each new z
        REAL(dl) :: om_m, om_c, om_b, om_nu, om_v, w, wa, f_nu, ns, h, Tcmb, Nnu
        REAL(dl), ALLOCATABLE :: log_r_sigma(:), log_sigma(:)
        REAL(dl), ALLOCATABLE :: a_growth(:), growth(:), agrow(:)
        REAL(dl), ALLOCATABLE :: log_k_plin(:), log_plin(:), log_plinc(:)
        REAL(dl), ALLOCATABLE :: log_k_wiggle(:), pk_wiggle(:)
        real(dl) :: kmax
        real(dl) :: gnorm
        INTEGER :: nk, ng, nsig
        real(dl) :: grow2_z, this_z !cached value at redshift being calculated
        !AM - Added feedback parameters below at fixed fiducial (DMONLY) values
        REAL(dl) :: A_baryon=3.13
        REAL(dl) :: eta_baryon=0.603
        REAL(dl) :: logT_AGN=7.8
    END TYPE HM_cosmology

    TYPE HM_tables
        !Stuff that needs to be recalculated for each new z
        REAL(dl), ALLOCATABLE :: c(:), rv(:), nu(:), sig(:), zc(:), m(:), rr(:), sigf(:)
        REAL(dl) :: sigv, sigv100, knl, rnl, neff, sig8z, z, dc, sig8z_cold
        INTEGER :: n
    END TYPE HM_tables
    !!AM - End of my additions

    ! HMcode parameters
    REAL(dl), PARAMETER :: zc_Dolag=10._dl   ! Halo collapse redshift for Dolag
    REAL(dl), PARAMETER :: fdamp_min=1e-3_dl ! Minimum value of fdamp
    REAL(dl), PARAMETER :: fdamp_max=0.99_dl ! Maximum value of fdamp
    REAL(dl), PARAMETER :: alpha_min=0.5_dl  ! Minimum value of alpha transition
    REAL(dl), PARAMETER :: alpha_max=2._dl   ! Maximum value of alpha transition
    REAL(dl), PARAMETER :: ks_limit=7._dl    ! Limit for (k/ks)^2 in one-halo term
    REAL(dl), PARAMETER :: pi_HM=const_pi    ! Lovely pi

    ! HMcode linear P(k) numerical parameters
    ! AM: Jul 19: Updated nk_pk_interpolation from 128 to 512
    ! AM: Dec 20: Calculation time and accuracy are especially sensive to these parameters
    LOGICAL, PARAMETER :: rebin_pk=.TRUE.             ! Should the linear P(k) be rebinned?
    REAL(dl), PARAMETER :: kmin_pk_interpolation=1d-3 ! Minimum wavenumber if rebinning [h/Mpc]
    REAL(dl), PARAMETER :: kmax_pk_interpolation=1d2  ! Maximum wavenumber if rebinning [h/Mpc]
    INTEGER, PARAMETER :: nk_pk_interpolation=512     ! Number of points in k if rebining
    LOGICAL, PARAMETER :: plin_extrap=.FALSE.         ! Extrapolate at high-k via thoery or simple power law
    INTEGER, PARAMETER :: iorder_pk_interpolation=1   ! Polynomial order for P(k) interpolation
    INTEGER, PARAMETER :: ifind_pk_interpolation=1    ! Finding scheme for P(k) interpolation (if rebin_pk=True)
    INTEGER, PARAMETER :: imeth_pk_interpolation=1    ! Method for P(k) interpolation

    ! HMcode dewiggle numerical parameters
    REAL, PARAMETER :: kmin_wiggle=5e-3    ! Minimum wavenumber to calulate wiggle [Mpc/h]
    REAL, PARAMETER :: kmax_wiggle=5.      ! Maximum wavenumber to calulate wiggle [Mpc/h]
    INTEGER, PARAMETER :: nk_wiggle=512    ! Number of k points to store wiggle
    INTEGER, PARAMETER :: iorder_wiggle=3  ! Order for wiggle interpolation
    INTEGER, PARAMETER :: ifind_wiggle=3   ! 3 - Mid-point finding scheme for wiggle interpolation
    INTEGER, PARAMETER :: imeth_wiggle=2   ! 2- Lagrange polynomial interpolation
    REAL, PARAMETER :: wiggle_sigma=0.25   ! Smoothing width if using Gaussian smoothing
    REAL, PARAMETER :: knorm_nowiggle=0.03 ! Wavenumber at which to force linear and nowiggle to be identical [Mpc/h]

    ! Linear growth integral numerical parameters (LCDM only; only used in Dolag correction)
    ! AM: Jul 19: Updated acc_growint from 1e-3 to 1e-4
    ! AM: Sep 20: Changed cold_growth = .FALSE. to be in line with my code
    REAL(dl), PARAMETER :: acc_growth_integration=1e-4 ! Accuracy for growth function integral
    INTEGER, PARAMETER :: iorder_growth_integration=3  ! Polynomial order for growth integral
    LOGICAL, PARAMETER :: cold_growth=.FALSE.          ! Should growth be of cold or all matter?

    ! Linear growth factor tabulation and interpolation numerical parameters
    ! AM: TODO: Change finding scheme to assume linear spacing may save time
    REAL(dl), PARAMETER :: amin_growth_interpolation=1e-3 ! Minimum scale factor for growth interpolation
    REAL(dl), PARAMETER :: amax_growth_interpolation=1.   ! Maximum scale factor for growth interpolation
    INTEGER, PARAMETER :: n_growth_interpolation=64       ! Number of entries for growth look-up table
    INTEGER, PARAMETER :: iorder_growth_interpolation=3   ! Polynomial order for growth function interpolation
    INTEGER, PARAMETER :: ifind_growth_interpolation=3    ! Finding scheme for growth function interpolation
    INTEGER, PARAMETER :: imeth_growth_interpolation=2    ! Method for growth function interpolation

    ! Growth function ODE numerical parameters
    ! AM: Jul 19: Updated acc_growth_ODE from 1e-3 to 1e-4
    ! AM: Sep 20: Changed aini from 1e-3 to 1e-4
    REAL(dl), PARAMETER :: aini_growth_ODE=1e-4             ! Initial scale factor for growth ODE
    REAL(dl), PARAMETER :: afin_growth_ODE=1.               ! Final scale factor for growth ODE
    REAL(dl), PARAMETER :: acc_growth_ODE=1e-4              ! Accuracy for growth integral or ODE
    INTEGER, PARAMETER :: imeth_growth_ODE=3                ! Method for growth function ODE solving
    INTEGER, PARAMETER :: iorder_growth_ODE_interpolation=3 ! Polynomial order for growth function ODE interpolation
    INTEGER, PARAMETER :: ifind_growth_ODE_interpolation=3  ! Finding scheme for growth function ODE interpolation
    INTEGER, PARAMETER :: imeth_growth_ODE_interpolation=2  ! Method growth function ODE interpolation

    ! Linear growth function inversion numerical parameters (used for c(M) only)
    INTEGER, PARAMETER :: iorder_growth_inversion=3 ! Polynomial order for growth function ODE inversion
    INTEGER, PARAMETER :: ifind_growth_inversion=3  ! Finding scheme for growth function ODE inversion
    INTEGER, PARAMETER :: imeth_growth_inversion=2  ! Method growth function ODE inversion

    ! Accumulated growth parameters
    INTEGER, PARAMETER :: iorder_integration_agrow=3     ! Polynomial order for accumulated growth integration
    INTEGER, PARAMETER :: iorder_agrowth_interpolation=3 ! Polynomial order for accumlated growth interpolation
    INTEGER, PARAMETER :: ifind_agrowth_interpolation=3  ! Finding scheme for accumulated growth interpolation
    INTEGER, PARAMETER :: imeth_agrowth_interpolation=2  ! Method for accumulated growth interpolation

    ! HMcode numerical parameters for sigma(R) tabulation and interpolation
    REAL(dl), PARAMETER :: rmin_sigma_interpolation=1e-4 ! Minimum scale for sigma(R) look-up tables [Mpc/h]
    REAL(dl), PARAMETER :: rmax_sigma_interpolation=1e3  ! Maximum scale for sigma(R) look-up tables [Mpc/h]
    INTEGER, PARAMETER :: n_sigma_interpolation=64       ! Number of points in look-up tables
    INTEGER, PARAMETER :: iorder_sigma_interpolation=3   ! Polynomial order for sigma(R) interpolation
    INTEGER, PARAMETER :: ifind_sigma_interpolation=3    ! Finding scheme for sigma(R) interpolation
    INTEGER, PARAMETER :: imeth_sigma_interpolation=2    ! Method sigma(R) interpolation

    ! HMcode numerical parameters for sigma(R) integration (dominates run time as of Jul 2019)
    ! AM: Jul 19: Upgraded acc_sigma from 1e-3 to 3e-4
    ! AM: Sep 20: Upgraded acc_sigma from 3e-4 to 1e-4 to fix problems for some cosmologies
    REAL(dl), PARAMETER :: acc_sigma_integration=1e-4 ! Relative accuracy of numerical integration
    REAL(dl), PARAMETER :: alpha_sigma_integration=3. ! Exponent to speed up integration
    INTEGER, PARAMETER :: iorder_sigma_integration=3  ! Polynomail order for numerical integration

    ! HMcode numerical parameters for sigmaV(R) integration
    ! AM: Jul 19: Upgraded acc_sigmaV from 1e-3 to 1e-4
    REAL(dl), PARAMETER :: acc_sigmaV_integration=1e-4 ! Relative accuracy of numerical integration
    REAL(dl), PARAMETER :: alpha_sigmaV_integration=3. ! Exponent to speed up integration
    INTEGER, PARAMETER :: iorder_sigmaV_integration=3  ! Polynomial order for numerical integration

    ! HMcode numerical parameters for neff(R) integration
    REAL(dl), PARAMETER :: acc_neff_integration=1e-4 ! Relative accuracy of numerical integration
    REAL(dl), PARAMETER :: alpha_neff_integration=2. ! Exponent to speed up integration
    INTEGER, PARAMETER :: iorder_neff_integration=3  ! Polynomial order for numerical integration

    ! HMcode numerical parameters for cold transfer function approximation
    ! AM: Sep 20: Care here, before EdS_Tcold_growth=.TRUE.
    LOGICAL, PARAMETER :: EdS_Tcold_growth=.FALSE. ! Should the EdS growth function (incorrectly) be used?

    ! HMcode numerical parameters for one-halo term
    INTEGER, PARAMETER :: iorder_integration_1h=1 ! Should be linear order (i.e., trapezium rule)

    contains

    function THalofit_PythonClass()
    character(LEN=:), allocatable :: THalofit_PythonClass

    THalofit_PythonClass = 'Halofit'

    end function THalofit_PythonClass

    subroutine THalofit_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (THalofit), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine THalofit_SelfPointer

    subroutine THalofit_ReadParams(this,Ini)
    use IniObjects
    class(THalofit) :: this
    class(TIniFile), intent(in) :: Ini

    this%halofit_version = Ini%Read_Int('halofit_version', halofit_default)
    IF(this%halofit_version == halofit_mead2020_feedback) THEN
        this%HMcode_logT_AGN = Ini%Read_Double('HMcode_logT_AGN', 7.8_dl)
    END IF

    end subroutine THalofit_ReadParams

    subroutine THalofit_GetNonLinRatios(this,State,CAMB_Pk)
    !Fill the CAMB_Pk%nonlin_scaling array with sqrt(non-linear power/linear power)
    !for each redshift and wavenumber
    !This implementation uses Halofit
    class(THalofit) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk
    integer itf
    real(dl) a,plin,pq,ph,pnl,rk
    real(dl) sig,rknl,rneff,rncur,d1,d2
    real(dl) diff,xlogr1,xlogr2,rmid, h2
    integer i

    !$ if (ThreadNum /=0) call OMP_SET_NUM_THREADS(ThreadNum)

    select type (State)
    class is (CAMBdata)
        associate(Params => State%CP)

            IF(this%halofit_version==halofit_mead2016 .OR. &
                this%halofit_version==halofit_halomodel .OR. &
                this%halofit_version==halofit_mead2015 .OR. &
                this%halofit_version==halofit_mead2020 .OR. &
                this%halofit_version==halofit_mead2020_feedback) THEN
                CALL this%HMcode(State,CAMB_Pk)
            ELSE

                !!BR09 putting neutrinos into the matter as well, not sure if this is correct, but at least one will get a consisent omk.
                h2 = (Params%H0/100)**2
                this%omm0 = (Params%omch2+Params%ombh2+Params%omnuh2)/h2
                this%fnu = Params%omnuh2/h2/this%omm0

                CAMB_Pk%nonlin_ratio = 1

                do itf = 1, CAMB_Pk%num_z

                    call Params%DarkEnergy%Effective_w_wa(this%w_hf, this%wa_hf)
                    if (this%halofit_version == halofit_casarini) then
                        ! calculate equivalent w-constant models (w_hf,0) for w_lam+wa_ppf(1-a) models
                        ! [Casarini+ (2009,2016)].
                        call PKequal(State,CAMB_Pk%Redshifts(itf),this%w_hf,this%wa_hf,this%w_hf,this%wa_hf)
                    endif

                    ! calculate nonlinear wavenumber (rknl), effective spectral index (rneff) and
                    ! curvature (rncur) of the power spectrum at the desired redshift, using method
                    ! described in Smith et al (2002).
                    a = 1/real(1+CAMB_Pk%Redshifts(itf),dl)
                    this%om_m = omega_m(a, this%omm0, State%omega_de, this%w_hf, this%wa_hf)
                    this%om_v = omega_v(a, this%omm0, State%omega_de, this%w_hf, this%wa_hf)
                    this%acur = a
                    xlogr1=-2.0
                    xlogr2=3.5
                    do
                        rmid=(xlogr2+xlogr1)/2.0
                        rmid=10**rmid
                        call wint(CAMB_Pk,itf,rmid,sig,d1,d2)
                        diff=sig-1.0
                        if (abs(diff).le.0.001) then
                            rknl=1./rmid
                            rneff=-3-d1
                            rncur=-d2
                            exit
                        elseif (diff.gt.0.001) then
                            xlogr1=log10(rmid)
                        elseif (diff.lt.-0.001) then
                            xlogr2=log10(rmid)
                        endif
                        if (xlogr2 < -1.9999) then
                            !is still linear, exit
                            goto 101
                        else if (xlogr1>3.4999) then
                            ! Totally crazy non-linear
                            call GlobalError('Error in halofit (xlogr1>3.4999)', error_nonlinear)
                            goto 101
                        end if
                    end do

                    ! now calculate power spectra for a logarithmic range of wavenumbers (rk)

                    do i=1, CAMB_PK%num_k
                        rk = exp(CAMB_Pk%log_kh(i))

                        if (rk > this%Min_kh_nonlinear) then

                            ! linear power spectrum !! Remeber => plin = k^3 * P(k) * constant
                            ! constant = 4*pi*V/(2*pi)^3

                            plin= MatterPowerData_k(CAMB_PK, rk, itf)*(rk**3/(2*const_pi**2))

                            ! calculate nonlinear power according to halofit: pnl = pq + ph,
                            ! where pq represents the quasi-linear (halo-halo) power and
                            ! where ph is represents the self-correlation halo term.

                            call this%halofit(rk,rneff,rncur,rknl,plin,pnl,pq,ph)   ! halo fitting formula
                            CAMB_Pk%nonlin_ratio(i,itf) = sqrt(pnl/plin)

                        end if

                    enddo

101                 continue
                end do

            END IF
        end associate
    end select

    end subroutine THalofit_GetNonLinRatios

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    subroutine halofit(this,rk,rn,rncur,rknl,plin,pnl,pq,ph)
    class(THalofit) :: this
    real(dl) gam,a,b,c,xmu,xnu,alpha,beta,f1,f2,f3
    real(dl) rk,rn,plin,pnl,pq,ph,plinaa
    real(dl) rknl,y,rncur
    real(dl) f1a,f2a,f3a,f1b,f2b,f3b,frac
    real(dl) extragam, peacock_fudge

    if (this%halofit_version ==halofit_original .or. this%halofit_version ==halofit_bird &
        .or. this%halofit_version == halofit_peacock) then
        ! halo model nonlinear fitting formula as described in
        ! Appendix C of Smith et al. (2002)
        !SPB11: Standard halofit underestimates the power on the smallest scales by a
        !factor of two. Add an extra correction from the simulations in Bird, Viel,
        !Haehnelt 2011 which partially accounts for this.
        if (this%halofit_version ==halofit_bird) then
            extragam = 0.3159 -0.0765*rn -0.8350*rncur
            gam=extragam+0.86485+0.2989*rn+0.1631*rncur
        else
            gam=0.86485+0.2989*rn+0.1631*rncur
        end if
        a=1.4861+1.83693*rn+1.67618*rn*rn+0.7940*rn*rn*rn+ &
            0.1670756*rn*rn*rn*rn-0.620695*rncur
        a=10**a
        b=10**(0.9463+0.9466*rn+0.3084*rn*rn-0.940*rncur)
        c=10**(-0.2807+0.6669*rn+0.3214*rn*rn-0.0793*rncur)
        xmu=10**(-3.54419+0.19086*rn)
        xnu=10**(0.95897+1.2857*rn)
        alpha=1.38848+0.3701*rn-0.1452*rn*rn
        beta=0.8291+0.9854*rn+0.3400*rn**2+this%fnu*(-6.4868+1.4373*rn**2)
    elseif (this%halofit_version == halofit_takahashi .or. this%halofit_version == halofit_casarini) then
        !RT12 Oct: the halofit in Smith+ 2003 predicts a smaller power
        !than latest N-body simulations at small scales.
        !Update the following fitting parameters of gam,a,b,c,xmu,xnu,
        !alpha & beta from the simulations in Takahashi+ 2012.
        !The improved halofit accurately provide the power spectra for WMAP
        !cosmological models with constant w.
        !LC16 Jun: Casarini+ 2009,2016 extended constant w prediction for w(a).
        gam=0.1971-0.0843*rn+0.8460*rncur
        a=1.5222+2.8553*rn+2.3706*rn*rn+0.9903*rn*rn*rn+ &
            0.2250*rn*rn*rn*rn-0.6038*rncur+0.1749*this%om_v*(1.+this%w_hf+this%wa_hf*(1-this%acur))
        a=10**a
        b=10**(-0.5642+0.5864*rn+0.5716*rn*rn-1.5474*rncur+ &
            0.2279*this%om_v*(1.+this%w_hf+this%wa_hf*(1-this%acur)))
        c=10**(0.3698+2.0404*rn+0.8161*rn*rn+0.5869*rncur)
        xmu=0.
        xnu=10**(5.2105+3.6902*rn)
        alpha=abs(6.0835+1.3373*rn-0.1959*rn*rn-5.5274*rncur)
        beta=2.0379-0.7354*rn+0.3157*rn**2+1.2490*rn**3+ &
            0.3980*rn**4-0.1682*rncur + this%fnu*(1.081 + 0.395*rn**2)
    else
        call MpiStop('Unknown halofit_version')
    end if

    if(abs(1-this%om_m).gt.0.01) then ! omega evolution
        f1a=this%om_m**(-0.0732)
        f2a=this%om_m**(-0.1423)
        f3a=this%om_m**(0.0725)
        f1b=this%om_m**(-0.0307)
        f2b=this%om_m**(-0.0585)
        f3b=this%om_m**(0.0743)
        frac=this%om_v/(1.-this%om_m)
        f1=frac*f1b + (1-frac)*f1a
        f2=frac*f2b + (1-frac)*f2a
        f3=frac*f3b + (1-frac)*f3a
    else
        f1=1.0
        f2=1.
        f3=1.
    endif

    y=(rk/rknl)


    ph=a*y**(f1*3)/(1+b*y**(f2)+(f3*c*y)**(3-gam))
    ph=ph/(1+xmu*y**(-1)+xnu*y**(-2))*(1+this%fnu*0.977)
    plinaa=plin*(1+this%fnu*47.48*rk**2/(1+1.5*rk**2))
    pq=plin*(1+plinaa)**beta/(1+plinaa*alpha)*exp(-y/4.0-y**2/8.0)

    pnl=pq+ph

    if (this%halofit_version == halofit_peacock) then
        !From http://www.roe.ac.uk/~jap/haloes/
        !(P-P_linear) -> (P-P_linear) * (1+2y^2)/(1+y^2), where y = k/10 h Mpc^(-1).
        peacock_fudge = rk/10
        pnl = plin + (pnl-plin)*(1+2*peacock_fudge**2)/(1+peacock_fudge**2)
    end if

    end subroutine halofit


    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    ! The subroutine wint, finds the effective spectral quantities
    ! rknl, rneff & rncur. This it does by calculating the radius of
    ! the Gaussian filter at which the variance is unity = rknl.
    ! rneff is defined as the first derivative of the variance, calculated
    ! at the nonlinear wavenumber and similarly the rncur is the second
    ! derivative at the nonlinear wavenumber.

    subroutine wint(CAMB_Pk,itf,r,sig,d1,d2)
    integer, intent(in) :: itf
    type(MatterPowerData) :: CAMB_Pk
    real(dl) sum1,sum2,sum3,t,y,x,w1,w2,w3
    real(dl) x2,rk, fac,r, sig, d1,d2, anorm
    integer i,nint
    integer index_cache

    index_cache = 1
    nint=3000
    sum1=0.d0
    sum2=0.d0
    sum3=0.d0
    anorm = 1/(2*const_pi**2)
    do i=1,nint
        t=(i-0.5_dl)/nint
        y=-1.d0+1.d0/t
        rk=y
        d2=MatterPowerData_k(CAMB_PK, rk, itf, index_cache)*(rk**3*anorm)
        x=y*r
        x2=x*x
        w1=exp(-x2)
        w2=2*x2*w1
        w3=4*x2*(1-x2)*w1
        fac=d2/y/t/t
        sum1=sum1+w1*fac
        sum2=sum2+w2*fac
        sum3=sum3+w3*fac
    enddo
    sum1=sum1/nint
    sum2=sum2/nint
    sum3=sum3/nint
    sig=sqrt(sum1)
    d1=-sum2/sum1
    d2=-sum2*sum2/sum1/sum1 - sum3/sum1

    end subroutine wint

    !!JD 08/13 generalize to variable w

    function omega_m(aa,om_m0,om_v0,wval,waval)
    real(dl) omega_m,omega_t,om_m0,om_v0,aa,wval,waval,Qa2
    Qa2= aa**(-1.0-3.0*(wval+waval))*dexp(-3.0*(1-aa)*waval)
    omega_t=1.0+(om_m0+om_v0-1.0)/(1-om_m0-om_v0+om_v0*Qa2+om_m0/aa)
    omega_m=omega_t*om_m0/(om_m0+om_v0*aa*Qa2)
    end function omega_m

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    ! evolution of omega lambda with expansion factor

    function omega_v(aa,om_m0,om_v0,wval,waval)
    real(dl) aa,omega_v,om_m0,om_v0,omega_t,wval,waval,Qa2
    Qa2= aa**(-1.0-3.0*(wval+waval))*dexp(-3.0*(1-aa)*waval)
    omega_t=1.0+(om_m0+om_v0-1.0)/(1-om_m0-om_v0+om_v0*Qa2+om_m0/aa)
    omega_v=omega_t*om_v0*Qa2/(om_v0*Qa2+om_m0/aa)
    end function omega_v

    !!JD end generalize to variable w

    !!AM Below is for HMcode
    SUBROUTINE HMcode(this,State,CAMB_Pk)
    !!AM - A CAMB derived type that I need
    class(THalofit) :: this
    Class(CAMBdata) :: State
    TYPE(MatterPowerData) :: CAMB_Pk
    REAL(dl) :: z, k
    REAL(dl) :: p1h, p2h, pfull, plin
    REAL(dl), ALLOCATABLE :: p_den(:,:), p_num(:,:)
    INTEGER :: i, j, ii, nk, nz
    REAL :: t1, t2
    TYPE(HM_cosmology) :: cosi
    TYPE(HM_tables) :: lut
    REAL(dl), PARAMETER :: pi=pi_HM
    LOGICAL, PARAMETER :: timing_test = .FALSE.

    !HMcode developed by Alexander Mead (alexander.j.mead@googlemail.com)
    !Please contact me if you have any questions whatsoever
    !If you use this in your work please cite the original paper: http://arxiv.org/abs/1505.07833
    !If you use the extensions (w(a) and massive neutrinos) then please cite: http://arxiv.org/abs/1602.02154
    !Also consider citing the source code at ASCL: http://ascl.net/1508.001

    IF (timing_test) CALL CPU_TIME(t1)

    !Use imead to switch between the standard and accurate halo-model calcuation
    !0 - Standard (this is just a vanilla halo model calculation with no accuracy tweaks)
    !1 - Accurate from Mead et al. (2016; arXiv 1602.02154)
    !2 - Accurate from Mead et al. (2015; arXiv 1505.07833)
    !3 - Accurate from Mead et al. (2020; arXiv 2009.01858)
    !4 - Denominator for feedback reaction model from Mead et al. (2020; arXiv 2009.01858)
    !5 - Numerator for feedback reaction from Mead et al. (2020; arXiv 2009.01858)
    IF(this%halofit_version==halofit_halomodel) this%imead=0
    IF(this%halofit_version==halofit_mead2016) this%imead=1
    IF(this%halofit_version==halofit_mead2015) this%imead=2
    IF(this%halofit_version==halofit_mead2020) this%imead=3

    HM_verbose = (FeedbackLevel>1)

    IF(HM_verbose) WRITE(*,*)
    IF(HM_verbose) WRITE(*,*) 'HMcode: Running HMcode'
    IF(HM_verbose) WRITE(*,*)

    !!AM - Translate from CAMB variables to my variables
    nz=CAMB_PK%num_z
    nk=CAMB_PK%num_k
    IF(this%halofit_version==halofit_mead2020_feedback) THEN
        ALLOCATE(p_den(nk,nz), p_num(nk,nz))
    END IF

    !!AM - Assign cosmological parameters for the halo model calculation
    CALL assign_HM_cosmology(this,State,cosi)

    !Fill growth function table (only needs to be done once)
    CALL fill_growtab(cosi)

    !Loop over redshifts
    DO j=1,nz

        !Initialise the specific HM_cosmology (fill sigma(R) and P_lin HM_tables)
        !Currently this needs to be done at each z (mainly because of scale-dependent growth with neutrinos)
        !For non-massive-neutrino models this could only be done once, which would speed things up a bit
        CALL initialise_HM_cosmology(this,j,cosi,CAMB_PK)

        !Sets the current redshift from the table
        z=CAMB_Pk%Redshifts(j)

        IF(this%halofit_version==halofit_mead2020_feedback) THEN

            ! Loop over numerator, denominator and HMcode to make feedback response model
            DO ii = 1, 3

                IF(ii==1) this%imead=3 ! HMcode 2020
                IF(ii==2) this%imead=4 ! Denominator for response
                IF(ii==3) this%imead=5 ! Numerator for response

                !Initiliasation for the halomodel calculation (needs to be done for each z)
                CALL this%halomod_init(z,lut,cosi)
                if (global_error_flag/=0) return

                !Loop over k values and calculate P(k)
                !$OMP PARALLEL DO DEFAULT(SHARED), private(k,plin,pfull,p1h,p2h)
                DO i=1,nk
                    k=exp(CAMB_Pk%log_kh(i))
                    plin=p_lin(k,z,0,cosi)
                    CALL this%halomod(k,p1h,p2h,pfull,plin,lut,cosi)
                    IF(this%imead==3) THEN
                        CAMB_Pk%nonlin_ratio(i,j)=sqrt(pfull/plin)
                    ELSE IF(this%imead==4) THEN
                        p_den(i,j)=pfull
                    ELSE IF(this%imead==5) THEN
                        p_num(i,j)=pfull
                    END IF
                END DO
                !$OMP END PARALLEL DO

            END DO

        ELSE

            !Initiliasation for the halomodel calculation (needs to be done for each z)
            CALL this%halomod_init(z,lut,cosi)
            if (global_error_flag/=0) return

            !Loop over k values and calculate P(k)
            !$OMP PARALLEL DO DEFAULT(SHARED), private(k,plin,pfull,p1h,p2h)
            DO i=1,nk
                k=exp(CAMB_Pk%log_kh(i))
                plin=p_lin(k,z,0,cosi)
                CALL this%halomod(k,p1h,p2h,pfull,plin,lut,cosi)
                CAMB_Pk%nonlin_ratio(i,j)=sqrt(pfull/plin)
            END DO
            !$OMP END PARALLEL DO

        END IF

    END DO

    ! Make the non-linear correction from the response for HMcode 2020
    IF(this%halofit_version==halofit_mead2020_feedback) THEN
        CAMB_Pk%nonlin_ratio=CAMB_Pk%nonlin_ratio*sqrt(p_num/p_den)
    END IF

    IF (timing_test) THEN
        CALL CPU_TIME(t2)
        WRITE(*, *) 'HMcode number of k:', nk
        WRITE(*, *) 'HMcode number of z:', nz
        WRITE(*, *) 'HMcode run time [s]:', t2-t1
        STOP 'HMcode timing test complete'
    END IF

    END SUBROUTINE HMcode

    FUNCTION Delta_v(this,z,cosm)
    class(THalofit) :: this
    !Function for the virialised overdensity
    REAL(dl) :: Delta_v
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    IF(this%imead==1 .OR. this%imead==2) THEN
        !Mead et al. (2015; arXiv 1505.07833) value
        Delta_v=418*Omega_m_hm(z,cosm)**(-0.352_dl)
        !Mead et al. (2016; arXiv 1602.02154) neutrino addition
        IF(this%imead==1) Delta_v=Delta_v*(1+0.916_dl*cosm%f_nu)
    ELSE IF(this%imead==0 .OR. this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
        Delta_v=Dv_Mead(z, cosm)
    END IF

    END FUNCTION Delta_v

    FUNCTION delta_c(this,z,lut,cosm)
    class(THalofit) :: this
    !Function for the linear collapse density
    REAL(dl) :: delta_c
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(this%imead==1 .or. this%imead==2) THEN
        !Mead et al. (2015; arXiv 1505.07833) value
        delta_c=1.59+0.0314*log(lut%sig8z)
        IF(this%imead==1) THEN
            delta_c=delta_c*(1.+0.262*cosm%f_nu) !Mead et al. (2016; arXiv 1602.02154) neutrino addition
            delta_c=delta_c*(1.+0.0123*log10(Omega_m_hm(z,cosm))) !Nakamura & Suto (1997) fitting formula for LCDM
        END IF
    ELSE IF(this%imead==0 .OR. this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
        delta_c=dc_Mead(z, cosm)
    END IF

    END FUNCTION delta_c

    FUNCTION eta(this,lut,cosm)
    class(THalofit) :: this
    !Function eta that puffs halo profiles
    REAL(dl) :: eta
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut
    REAL(dl) :: eta0

    IF(this%imead==0 .OR. this%imead==4 .OR. this%imead==5) THEN
        eta=0.
    ELSE IF(this%imead==1 .or. this%imead==2) THEN
        !The first parameter here is 'eta_0' in Mead et al. (2015; arXiv 1505.07833)
        !eta=0.603-0.3*lut%sig8z
        !AM - made baryon feedback parameter obvious
        eta0=cosm%eta_baryon
        !eta0=1.03-0.11*cosm%A_baryon !Original one-parameter relation from 1505.07833
        !eta0=0.98-0.12*cosm%A_baryon !Updated one-parameter relation: Section 4.1.2 of 1707.06627
        eta=eta0-0.3*lut%sig8z
    ELSE IF(this%imead==3) THEN
        eta=0.1281*lut%sig8z_cold**(-0.3644)
    END IF

    END FUNCTION eta

    FUNCTION kstar(this,lut)
    class(THalofit) :: this
    !Function k* that cuts off the 1-halo term at large scales
    REAL(dl) :: kstar
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(this%imead==0) THEN
        !Set to zero for the standard Poisson one-halo term
        kstar=0.
    ELSE IF(this%imead==1 .or. this%imead==2) THEN
        !One-halo cut-off wavenumber
        !Mead et al. (2015; arXiv 1505.07833) value
        kstar=0.584*(lut%sigv)**(-1.)
    ELSE IF(this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
        kstar=0.05618*lut%sig8z_cold**(-1.013)
    END IF

    END FUNCTION kstar

    FUNCTION As(this,lut,cosm)
    class(THalofit) :: this
    !Halo concentration pre-factor from Bullock et al. (2001) relation
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: As
    REAL(dl) :: B0, Bz, theta

    IF(this%imead==0 .OR. this%imead==4) THEN
        !Set to 4 for the standard Bullock value
        As=4.
    ELSE IF(this%imead==5) THEN
        theta=cosm%logT_AGN-7.8
        B0=3.44-0.496*theta
        Bz=-0.0671-0.0371*theta
        As=B0*10**(lut%z*Bz)
    ELSE IF(this%imead==1 .or. this%imead==2) THEN
        !This is the 'A' halo-concentration parameter in Mead et al. (2015; arXiv 1505.07833)
        !As=3.13
        !AM - added for easy modification of feedback parameter
        As=cosm%A_baryon
    ELSE IF(this%imead==3) THEN
        As=5.196
    END IF

    END FUNCTION As

    FUNCTION fdamp(this,lut)
    class(THalofit) :: this
    !Linear power damping function from Mead et al. (2015; arXiv 1505.07833)
    REAL(dl) ::fdamp
    TYPE(HM_tables), INTENT(IN) :: lut

    !Linear theory damping factor
    IF(this%imead==0 .OR. this%imead==4 .OR. this%imead==5) THEN
        !Set to 0 for the standard linear theory two halo term
        fdamp=0.
    ELSE IF(this%imead==1) THEN
        !Mead et al. (2016; arXiv 1602.02154) value
        fdamp=0.0095*lut%sigv100**1.37
    ELSE IF(this%imead==2) THEN
        !Mead et al. (2015) value
        fdamp=0.188*lut%sig8z**4.29
    ELSE IF(this%imead==3) THEN
        fdamp=0.2696*lut%sig8z_cold**0.9403
    END IF

    !Catches extreme values of fdamp
    IF(fdamp<fdamp_min) fdamp=fdamp_min
    IF(fdamp>fdamp_max) fdamp=fdamp_max

    END FUNCTION fdamp

    FUNCTION alpha(this,lut)
    class(THalofit) :: this
    !Two- to one-halo transition smoothing from Mead et al. (2015; arXiv 1505.07833)
    REAL(dl) :: alpha
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(this%imead==0 .OR. this%imead==4 .OR. this%imead==5) THEN
        !Set to 1 for the standard halomodel sum of one- and two-halo terms
        alpha=1.
    ELSE IF(this%imead==1) THEN
        !This uses the top-hat defined neff (HALOFIT uses Gaussian filtered fields instead)
        !Mead et al. (2016; arXiv 1602.02154) value
        alpha=3.24*1.85**lut%neff
    ELSE IF(this%imead==2) THEN
        !Mead et al. (2015) value
        alpha=2.93*1.77**lut%neff
    ELSE IF (this%imead==3) THEN
        alpha=1.875*(1.603)**lut%neff
    END IF

    !Catches values of alpha that are crazy
    IF(alpha>alpha_max) alpha=alpha_max
    IF(alpha<alpha_min) alpha=alpha_min

    END FUNCTION alpha

    FUNCTION r_nl(lut)
    !Calculates R_nl, defined by nu(R_nl)=1., nu=dc/sigma(R)
    TYPE(HM_tables), INTENT(IN) :: lut
    REAL(dl) :: r_nl
    INTEGER, PARAMETER :: iorder=3
    INTEGER, PARAMETER :: ifind=3
    INTEGER, PARAMETER :: imeth=2

    IF(lut%nu(1)>1.) THEN
        !This catches some very strange values that appear for odd cosmological models
        !This is a terrible fudge, but I cannot think of a better solution
        r_nl=lut%rr(1)
    ELSE
        r_nl=exp(find(log(1.d0),log(lut%nu),log(lut%rr),lut%n,iorder,ifind,imeth))
    END IF

    END FUNCTION r_nl

    SUBROUTINE halomod(this,k,p1h,p2h,pfull,plin,lut,cosm)
    class(THalofit) :: this
    !Calcuates 1-halo and 2-halo terms and combines them to form the full halomodel power
    REAL(dl), INTENT(OUT) :: p1h, p2h, pfull
    REAL(dl), INTENT(IN) :: plin, k
    REAL(dl) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    !Calls expressions for one- and two-halo terms and then combines
    !to form the full power spectrum
    IF(k==0.) THEN
        p1h=0.
        p2h=0.
    ELSE
        p1h=this%p_1h(k,lut,cosm)
        p2h=this%p_2h(k,plin,lut,cosm)
    END IF

    IF (this%imead==1 .OR. this%imead==2 .OR. this%imead==3) THEN
        a=this%alpha(lut)
        pfull=(p2h**a+p1h**a)**(1./a)
    ELSE
        pfull=p2h+p1h
    END IF

    END SUBROUTINE halomod

    SUBROUTINE fill_table(min,max,arr,n)
    !Fills array 'arr' in equally spaced intervals
    INTEGER :: i
    REAL(dl), INTENT(IN) :: min, max
    REAL(dl), ALLOCATABLE :: arr(:)
    INTEGER, INTENT(IN) :: n

    !Allocate the array, and deallocate it if it is full
    IF(ALLOCATED(arr)) DEALLOCATE(arr)
    ALLOCATE(arr(n))
    arr=0

    IF(n==1) THEN
        arr(1)=min
    ELSE IF(n>1) THEN
        DO i=1,n
            arr(i)=min+(max-min)*real(i-1,dl)/(n-1)
        END DO
    END IF

    END SUBROUTINE fill_table

    SUBROUTINE fill_plintab(iz,cosm,CAMB_PK)
    !Fills internal HMcode HM_tables for the linear power spectrum at z=0
    TYPE(MatterPowerData), INTENT(IN) :: CAMB_PK
    INTEGER, INTENT(IN) :: iz
    TYPE(HM_cosmology) :: cosm
    INTEGER :: i
    REAL(dl) :: z, g
    REAL(dl), ALLOCATABLE :: k(:), Pk(:), Pkc(:)
    REAL(dl), PARAMETER :: pi=pi_HM
    REAL(dl), PARAMETER :: kmin=kmin_pk_interpolation
    REAL(dl), PARAMETER :: kmax=kmax_pk_interpolation
    INTEGER :: nk=nk_pk_interpolation, index_cache

    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: Filling linear power HM_tables'

    !Fill arrays
    IF(ALLOCATED(cosm%log_k_plin)) DEALLOCATE(cosm%log_k_plin)
    IF(ALLOCATED(cosm%log_plin))   DEALLOCATE(cosm%log_plin)
    IF(ALLOCATED(cosm%log_plinc))  DEALLOCATE(cosm%log_plinc)

    IF(rebin_pk) THEN

        !Fill a k-table with an equal-log-spaced k range
        !Note that the minimum should be such that the linear spectrum is accurately a power-law below this wavenumber
        cosm%nk=nk
        CALL fill_table(log(kmin),log(kmax),cosm%log_k_plin,nk)

    ELSE
        if (ifind_pk_interpolation==1) error stop 'ifind_pk_interpolation=1 assumes rebin_pk'
        !Fill k-table with the same k points as in the CAMB calculation
        !If a user has specified lots of points this could make the halo-model
        !calculation chug
        nk=CAMB_PK%num_k
        cosm%nk=nk
        ALLOCATE(cosm%log_k_plin(nk))
        cosm%log_k_plin=CAMB_Pk%log_kh

    END IF

    ALLOCATE(k(nk))
    k=exp(cosm%log_k_plin)
    cosm%kmax = k(nk)

    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: k_min:', k(1)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: k_max:', k(nk)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: nk:', nk

    ALLOCATE(Pk(nk),Pkc(nk))

    !Find the redshift
    z=CAMB_Pk%Redshifts(iz)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: z of input:', z
    index_cache = 1
    !Fill power table, both cold- and all-matter
    !$OMP PARALLEL DO DEFAULT(SHARED), FIRSTPRIVATE(index_cache)
    DO i=1,nk
        !Take the power from the current redshift choice
        Pk(i)=MatterPowerData_k(CAMB_PK,k(i),iz, index_cache)*(k(i)**3/(2*pi**2))
        Pkc(i)=Pk(i)*Tcb_Tcbnu_ratio(k(i),z,cosm)**2
    END DO

    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: Delta2_min:', Pk(1)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: Delta2_max:', Pk(nk)

    !Calculate the growth factor at the redshift of interest
    g=grow(z,cosm)
    cosm%grow2_z = g**2
    cosm%this_z = z
    ALLOCATE(cosm%log_plin(nk),cosm%log_plinc(nk))

    !Grow the power to z=0
    cosm%log_plin=log(Pk/(g**2))
    cosm%log_plinc=log(Pkc/(g**2))

    !Check sigma_8 value
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: sigma_8:', sigma_integral(8.d0,0.d0,0,cosm)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: Done'
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE fill_plintab

    FUNCTION Tcb_Tcbnu_ratio(k,z,cosm)
    !Calculates the ratio of T(k) for cold vs. all matter
    !Uses approximations in Eisenstein & Hu (1999; arXiv 9710252)
    !Note that this assumes that there are exactly 3 species of neutrinos with
    !Nnu<=3 of these being massive, and with the mass split evenly between the number of massive species.

    REAL(dl) :: Tcb_Tcbnu_ratio
    REAL(dl), INTENT(IN) :: k, z
    REAL(dl) :: D, Dcb, Dcbnu, pcb, zeq, q, yfs
    REAL(dl) :: BigT
    TYPE(HM_cosmology) :: cosm

    IF(cosm%f_nu==0._dl) THEN

        Tcb_Tcbnu_ratio=1.

    ELSE

        !Growth exponent under the assumption that neutrinos are completely unclustered (equation 11)
        pcb=(5.-sqrt(1+24*(1._dl-cosm%f_nu)))/4

        !Theta for temperature (BigT=T/2.7 K)
        BigT=cosm%Tcmb/2.7

        !The matter-radiation equality redshift
        zeq=(2.5e4)*cosm%om_m*(cosm%h**2)*(BigT**(-4.))

        !The growth function normalised such that D=(1.+z_eq)/(1+z) at early times (when Omega_m \approx 1)
        IF (EdS_Tcold_growth) THEN
            D=(1.+zeq)/(1.+z) ! EdS solution
        ELSE
            D=(1.+zeq)*ungrow(z, cosm) ! General solution
        END IF

        !Wave number relative to the horizon scale at equality (equation 5)
        !Extra factor of h becauase all my k are in units of h/Mpc
        q=k*cosm%h*BigT**2/(cosm%om_m*cosm%h**2)

        !Free streaming scale (equation 14)
        !Note that Eisenstein & Hu (1999) only consider the case of 3 neutrinos
        !with Nnu of these being massve with the mass split evenly between Nnu species.
        yfs=17.2*cosm%f_nu*(1.+0.488*cosm%f_nu**(-7./6.))*(cosm%Nnu*q/cosm%f_nu)**2

        !These are (almost) the scale-dependent growth functions for each component in Eisenstein & Hu (1999)
        !Some part is missing, but this cancels when they are divided by each other, which is all I need them for.
        !Equations (12) and (13)
        Dcb=(1.+(D/(1.+yfs))**0.7)**(pcb/0.7)
        Dcbnu=((1-cosm%f_nu)**(0.7/pcb)+(D/(1.+yfs))**0.7)**(pcb/0.7)

        Tcb_Tcbnu_ratio=Dcb/Dcbnu

    END IF

    END FUNCTION Tcb_Tcbnu_ratio

    SUBROUTINE assign_HM_cosmology(this,State,cosm)
    class(THalofit) :: this
    class(CAMBdata) :: State
    !Assigns the internal HMcode cosmological parameters
    TYPE(HM_cosmology) :: cosm
    real(dl) h2

    associate(CP => State%CP)
        !Converts CAMB parameters to Meadfit parameters
        h2 = (CP%H0/100)**2
        cosm%om_m=(CP%omch2+CP%ombh2+CP%omnuh2)/h2
        cosm%om_c=CP%omch2/h2
        cosm%om_b=CP%ombh2/h2
        cosm%om_nu=CP%omnuh2/h2
        cosm%om_v=State%omega_de
        call CP%DarkEnergy%Effective_w_wa(cosm%w, cosm%wa)
        cosm%f_nu=cosm%om_nu/cosm%om_m
        cosm%h=CP%H0/100
        cosm%Tcmb=CP%tcmb
        cosm%Nnu=CP%Num_Nu_massive
        cosm%ns= CP%InitPower%Effective_ns()
    end associate

    ! Baryon feedback parameters
    IF(this%halofit_version==halofit_mead2015 .OR. this%halofit_version==halofit_mead2016)  THEN
        cosm%A_baryon = this%HMcode_A_baryon
        cosm%eta_baryon = this%HMcode_eta_baryon
    ELSE IF(this%halofit_version==halofit_mead2020_feedback) THEN
        cosm%logT_AGN = this%HMcode_logT_AGN
    END IF

    !Write out cosmological parameters if necessary
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_m:', cosm%om_m
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_c:', cosm%om_c
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_b:', cosm%om_b
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_nu:', cosm%om_nu
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_v:', cosm%om_v
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: w_0:', cosm%w
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: w_a:', cosm%wa
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: f_nu:', cosm%f_nu
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: n_s:', cosm%ns
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: h:', cosm%h
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: T_CMB [K]:', cosm%Tcmb
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: N_nu (massive):', cosm%Nnu
    IF(HM_verbose .AND. (this%halofit_version==halofit_mead2015 .OR. this%halofit_version==halofit_mead2016)) THEN
        WRITE(*,*) 'HM_cosmology: A_baryon:', cosm%A_baryon
        WRITE(*,*) 'HM_cosmology: eta_baryon:', cosm%eta_baryon
    ELSE IF(HM_verbose .AND. this%halofit_version==halofit_mead2020_feedback) THEN
        WRITE(*,*) 'HM_cosmology: log10(T_AGN/K):', cosm%logT_AGN
    END IF
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE assign_HM_cosmology

    SUBROUTINE initialise_HM_cosmology(this,iz,cosm,CAMB_PK)
    class(THalofit) :: this
    !Sets up HM_tables of sigma, growth and linear power for the HM_cosmology
    TYPE(MatterPowerData), INTENT(IN) :: CAMB_PK
    TYPE(HM_cosmology) :: cosm
    INTEGER, INTENT(IN) :: iz

    !Fill linear power table and grows it to z=0
    CALL fill_plintab(iz,cosm,CAMB_PK)

    !Fill sigma(r) table
    CALL fill_sigtab(this,cosm)

    ! Extract BAO wiggle from P(k)
    ! AM: TODO: Maybe move this so that it is not done every z
    CALL init_wiggle(cosm)

    END SUBROUTINE initialise_HM_cosmology

    SUBROUTINE allocate_LUT(lut, n)
    !Allocates memory for the HMcode look-up HM_tables
    TYPE(HM_tables) :: lut
    INTEGER, INTENT(IN) :: n

    if (.not. allocated(lut%zc)) then
        lut%n =n
        ALLOCATE(lut%zc(n),lut%m(n),lut%c(n),lut%rv(n))
        ALLOCATE(lut%nu(n),lut%rr(n),lut%sigf(n),lut%sig(n))
    end if
    lut%zc=0
    lut%m=0
    lut%c=0
    lut%rv=0
    lut%nu=0
    lut%rr=0
    lut%sigf=0
    lut%sig=0

    END SUBROUTINE allocate_LUT

    SUBROUTINE halomod_init(this,z,lut,cosm)
    class(THalofit) :: this
    !Halo-model initialisation routine
    !Computes look-up HM_tables necessary for the halo model calculations
    REAL(dl), INTENT(IN) :: z
    INTEGER :: i,nm
    REAL(dl) :: Dv, dc, m, nu, r, sig, mmin, mmax
    TYPE(HM_cosmology) :: cosm
    TYPE(HM_tables) :: lut
    REAL(dl), PARAMETER :: f_Bullock=0.01_dl**(1/3._dl)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: Filling look-up HM_tables'
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: HM_tables being filled at redshift:', z
    lut%z=z

    ! Mass range and number of points
    mmin=1e0
    mmax=1e18
    nm=256

    !Find value of sigma_v, sig8, etc.
    !$OMP PARALLEL SECTIONS DEFAULT(SHARED)
    !$OMP SECTION
    lut%sigv=sigmaV(0.d0,z,0,cosm)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sigv [Mpc/h]:', lut%sigv
    !$OMP SECTION
    if (global_error_flag==0) lut%sigv100=sigmaV(100.d0,z,0,cosm)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sigv100 [Mpc/h]:', lut%sigv100
    !$OMP SECTION
    if (global_error_flag==0) then
        lut%sig8z=sigma_integral(8.d0,z,0,cosm)
        lut%sig8z_cold=sigma_integral(8.d0,z,1,cosm)
    end if
    IF(HM_verbose) THEN
        WRITE(*,*) 'HALOMOD: sig8(z):', lut%sig8z
        WRITE(*,*) 'HALOMOD: cold sig8(z):', lut%sig8z_cold
    END IF
    !$OMP END PARALLEL SECTIONS
    if (global_error_flag/=0) return

    CALL allocate_lut(lut, nm)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: M_min [log10(Msun/h)]:', log10(mmin)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: M_max [log10(Msun/h)]:', log10(mmax)

    dc=this%delta_c(z,lut,cosm)
    lut%dc=dc

    !$OMP PARALLEL DO default(shared), private(m,r,sig,nu)
    DO i=1,lut%n

        m=exp(log(mmin)+log(mmax/mmin)*real(i-1,dl)/(lut%n-1))
        r=radius_m(m,cosm)
        sig=sigma_lut(r,z,cosm)
        nu=dc/sig

        lut%m(i)=m
        lut%rr(i)=r
        lut%sig(i)=sig
        lut%nu(i)=nu
        lut%sigf(i)=sigma_lut(r*f_Bullock,z,cosm)

    END DO
    !$OMP END PARALLEL DO
    if (global_error_flag/=0) return

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: m, r, nu, sig, sigf HM_tables filled'

    !Fill virial radius table using real radius table
    Dv=this%Delta_v(z,cosm)
    lut%rv=lut%rr/(Dv**(1/3._dl))

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: rv HM_tables filled'
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: nu min:', lut%nu(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: nu max:', lut%nu(lut%n)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sig min:', lut%sig(lut%n)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sig max:', lut%sig(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: R_v min [Mpc/h]:', lut%rv(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: R_v max [Mpc/h]:', lut%rv(lut%n)

    !Find non-linear radius and scale
    lut%rnl=r_nl(lut)
    lut%knl=1/lut%rnl

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: r_nl [Mpc/h]:', lut%rnl
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: k_nl [h/Mpc]:', lut%knl

    !Calcuate the effective spectral index at the collapse scale
    lut%neff=neff(this,lut,cosm)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: n_eff:', lut%neff

    !Get the concentration for all the haloes
    CALL this%conc_bull(z,lut,cosm)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: c HM_tables filled'
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: c min [Msun/h]:', lut%c(lut%n)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: c max [Msun/h]:', lut%c(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: Done'
    IF(HM_verbose) WRITE(*,*)
    IF(HM_verbose) CALL this%write_parameters(z,lut,cosm)

    !Switch off verbose mode if doing multiple z
    HM_verbose= .false.

    END SUBROUTINE halomod_init

    SUBROUTINE write_parameters(this,z,lut,cosm)
    class(THalofit) :: this
    !This subroutine writes out the halomodel parameters at the current redshift
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(HM_verbose) WRITE(*,*) 'WRITE_PARAMETERS: at this redshift'
    IF(HM_verbose) WRITE(*,*) '=================================='
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'z:', z
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'Dv:', this%Delta_v(z,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'dc:', this%delta_c(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'eta:', this%eta(lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'k*:', this%kstar(lut)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'A:', this%As(lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'fdamp:', this%fdamp(lut)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'alpha:', this%alpha(lut)
    IF(HM_verbose) WRITE(*,*) '=================================='
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE write_parameters

    PURE FUNCTION radius_m(m,cosm)
    !Calculates the co-moving radius that encloses a mass 'm' in the homogeneous Universe
    REAL(dl) :: radius_m
    REAL(dl), INTENT(IN) :: m
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl), PARAMETER :: pi=pi_HM

    radius_m=(3.*m/(4.*pi*cosmic_density(cosm)))**(1./3.)

    END FUNCTION radius_m

    FUNCTION neff(this,lut,cosm)
    class(THalofit) :: this
    !Finds the effective spectral index at the collapse scale r_nl, where nu(r_nl)=1.
    REAL(dl) :: neff
    REAL(dl) :: ns
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut
    REAL(dl) :: sig
    INTEGER :: itype
    REAL(dl), PARAMETER :: tmin=0.
    REAL(dl), PARAMETER :: tmax=1.
    REAL(dl), PARAMETER :: acc=acc_neff_integration
    INTEGER, PARAMETER :: iorder=iorder_neff_integration

    ! Choose type of sigma(R) to tabulate depending on HMcode version
    IF (this%imead==1 .OR. this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
        itype=1 ! 1 - Cold matter
    ELSE
        itype=0 ! 0 - All matter
    END IF

    ! Choosings sig = delta_c should be equivalent to actually calculating it again, however
    ! Do the actual calculation to be consistent with HMx. Problems with weird cosmologies with
    ! low spectral indices such that no collapse has occured. R_nl very small
    !sig=lut%dc ! Take great care here. This should be the same as below, but won't be for strange models
    sig=sigma_integral(lut%rnl,lut%z,itype,cosm)
    neff=-3.-2.*integrate(tmin,tmax,neff_integrand,lut%rnl,lut%z,itype,cosm,acc,iorder)/sig**2

    !For some bizarre cosmological models r_nl is very small, so almost no collapse has occured
    !In this case the n_eff calculation goes mad and needs to be fixed using this fudge.
    ns=cosm%ns
    IF(neff<ns-4.) neff=ns-4.
    IF(neff>ns)    neff=ns

    END FUNCTION neff

    SUBROUTINE conc_bull(this,z,lut,cosm)
    class(THalofit) :: this
    !Calculates the Bullock et al. (2001) concentration-mass relation
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology) :: cosm, cosm_lcdm
    TYPE(HM_tables) :: lut
    REAL(dl) :: A, zf, pow
    REAL(dl) :: ginf_lcdm, ginf_wcdm, g_lcdm, g_wcdm
    INTEGER :: i
    REAL(dl), PARAMETER :: zinf=zc_Dolag

    !Amplitude of relation (4. in Bullock et al. 2001)
    A=this%As(lut,cosm)

    !Fill the collapse time look-up table
    CALL this%zcoll_bull(z,cosm,lut)

    !Fill the concentration look-up table
    DO i=1,lut%n
        zf=lut%zc(i)
        lut%c(i)=A*(1.+zf)/(1.+z)
    END DO

    IF(z<zinf) THEN

        !Dolag (2004) prescription for adding DE dependence

        !This is approximately z=infinity
        ginf_wcdm=grow(zinf,cosm)

        !Make a LCDM HM_cosmology
        !Need to make sure model is flat with the same Omega_m and w=-1
        !This is *only* used for a calculation of the growth function
        cosm_lcdm=cosm
        DEALLOCATE(cosm_lcdm%growth)
        DEALLOCATE(cosm_lcdm%a_growth)
        cosm_lcdm%w=-1.
        cosm_lcdm%wa=0.
        cosm_lcdm%om_v=1.-cosm%om_m !Enforce flatness

        !Needs to use grow_int explicitly here for LCDM model to avoid growth HM_tables
        ginf_lcdm=growint(zinf,cosm_lcdm)

        !This is the Dolag et al. (2004) correction for halo concentrations
        IF(this%imead==0 .OR. this%imead==2 .OR. this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
            ! Mead et al. (2015) used the Dolag (2004) correction
            pow=1.
        ELSE IF(this%imead==1) THEN
            ! Mead et al. (2016) changed the power to 1.5 to better accomodate more extreme dark-energy models
            pow=1.5
        END IF
        lut%c=lut%c*(ginf_wcdm/ginf_lcdm)**pow

        ! This is needed for the correction to make sense at high z
        IF(this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
            g_lcdm=growint(z,cosm_lcdm)
            g_wcdm=grow(z,cosm)
            lut%c=lut%c*(g_lcdm/g_wcdm)**pow
        END IF

    END IF

    END SUBROUTINE conc_bull

    FUNCTION growint(z,cosm)
    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    REAL(dl) :: growint
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: a, b
    INTEGER :: i, j
    INTEGER :: n
    REAL(dl) :: x, dx
    REAL(dl) :: f1, f2, fx
    REAL(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=20
    REAL(dl), PARAMETER :: acc=acc_growth_integration
    INTEGER, PARAMETER :: iorder=iorder_growth_integration

    a=1./(1.+z)

    !Integration range for integration parameter
    !Note a -> 1
    b=1.d0

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        growint=exp(0.d0)

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=growint_integrand(a,cosm)
                f2=growint_integrand(b,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*REAL(i-1)/REAL(n-1)
                    fx=growint_integrand(x,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    ERROR STOP 'GROWINT: Error, iorder specified incorrectly'
                END IF

            END IF

            IF(j>=jmin .and. sum_old /= 0) THEN
                if (ABS(-1.d0+sum_new/sum_old)<acc) THEN
                    !jmin avoids spurious early convergence
                    growint=exp(sum_new)
                    EXIT
                end if
            end if
            IF(j==jmax) THEN
                growint=exp(sum_new)
                call GlobalError('HMCode GROWINT, Integration timed out', error_nonlinear)
                return
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION growint

    FUNCTION growint_integrand(a,cosm)
    !Integrand for the approximate growth integral
    REAL(dl) :: growint_integrand
    REAL(dl), INTENT(IN) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: Om_m, z, gam

    IF(cosm%w<-1.) THEN
        gam=0.55+0.02*(1.+cosm%w)
    ELSE IF(cosm%w>-1) THEN
        gam=0.55+0.05*(1.+cosm%w)
    ELSE
        gam=0.55
    END IF

    !Note the minus sign here
    !AM Jul 19: changed Omega_m to Omega_cold for massive neutrino cosmologies
    z = -1.+1./a
    IF (cold_growth) THEN
        Om_m = Omega_cold_hm(z,cosm)
    ELSE
        Om_m = Omega_m_hm(z,cosm)
    END IF
    growint_integrand=-(Om_m**gam)/a

    END FUNCTION growint_integrand

    SUBROUTINE zcoll_bull(this,z,cosm,lut)
    class(THalofit) :: this
    !Calcuates the halo collapse redshift according to the Bullock (2001) prescription
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology) :: cosm
    TYPE(HM_tables) :: lut
    REAL(dl) :: dc
    REAL(dl) :: af, zf, RHS, growz
    INTEGER :: i
    INTEGER, PARAMETER :: iorder=iorder_growth_inversion
    INTEGER, PARAMETER :: ifind=ifind_growth_inversion
    INTEGER, PARAMETER :: imeth=imeth_growth_inversion

    !This fills up the halo formation redshift table as per Bullock relations

    !Needs to interpolate g(z) which should be pretty linear for a<0.05
    !in 'g(a) vs a' space for all standard cosmologies

    dc=this%delta_c(z,lut,cosm)

    !Find the growth function at the current redshift
    growz=grow(z,cosm)

    !Do numerical inversion
    DO i=1,lut%n

        RHS=dc*growz/lut%sigf(i)

        IF(RHS>growz) THEN
            !This is the case of 'halo forms in the future'
            !in this case set formation redshift to current redshift
            zf=z
        ELSE
            af=find(RHS,cosm%growth,cosm%a_growth,cosm%ng,iorder,ifind,imeth)
            zf=-1.+1./af
        END IF

        lut%zc(i)=zf

    END DO

    END SUBROUTINE zcoll_bull

    FUNCTION mass_r(r,cosm)
    !Calcuates the average mass enclosed at co-moving radius r
    REAL(dl) :: mass_r, r
    TYPE(HM_cosmology) :: cosm
    REAL(dl), PARAMETER :: pi=pi_HM

    !Relation between mean cosmological mass and radius
    mass_r=(4*pi/3)*cosmic_density(cosm)*(r**3)

    END FUNCTION mass_r

    PURE FUNCTION cosmic_density(cosm)
    !The z=0 cosmological matter density
    REAL(dl) :: cosmic_density
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !In M_sun per Mpc^3 with h factors included. The constant does this.
    cosmic_density=(2.775d11)*cosm%om_m

    END FUNCTION cosmic_density

    FUNCTION baryonify_wk(wk, m, lut, cosm)

    ! Change halo window to account for feedback mass loss and star formation
    IMPLICIT NONE
    REAL(dl) :: baryonify_wk
    REAL(dl), INTENT(IN) :: wk
    REAL(dl), INTENT(IN) :: m
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: wkn, fs

    wkn = wk
    wkn = wkn*halo_mass_fraction(m, lut, cosm) ! Gas expulsion
    fs = f_star(lut, cosm)
    wkn = wkn+fs ! Star formation

    baryonify_wk = wkn

    END FUNCTION baryonify_wk

    FUNCTION halo_mass_fraction(m, lut, cosm)

    ! Simple baryon model where high-mass haloes have a mass fraction of 1 and low-mass haloes have Omega_c/Omega_m
    ! This also accounts for massive neutrinos since it is written in terms of Om_c and Om_b (rather than Om_m)
    ! TODO: Could just precompute this once for each M in the halomod init function
    IMPLICIT NONE
    REAL(dl) :: halo_mass_fraction
    REAL(dl), INTENT(IN) :: m
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: r, fc, fb, fs, mb, beta

    mb = m_baryon(lut, cosm) ! Feedback halo mass
    beta = 2.                ! Power-law index
    r = (m/mb)**beta         ! If m>>m0 then r becomes large, if m<<m0 then r=0
    fb = cosm%Om_b/cosm%Om_m ! Halo baryon fraction
    fc = cosm%Om_c/cosm%Om_m ! Halo CDM fraction
    fs = f_star(lut, cosm)   ! Halo star fraction
    halo_mass_fraction = fc+(fb-fs)*r/(1.+r) ! Remaining halo mass fraction

    END FUNCTION halo_mass_fraction

    FUNCTION m_baryon(lut, cosm)

    REAL(dl) :: m_baryon
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: mb0, mbz, theta

    theta=cosm%logT_AGN-7.8
    mb0=13.87+1.81*theta
    mb0=10**mb0
    mbz=-0.108+0.195*theta
    m_baryon=mb0*10**(mbz*lut%z)

    END FUNCTION m_baryon

    FUNCTION f_star(lut, cosm)

    REAL(dl) :: f_star
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: f0, fz, theta

    theta=cosm%logT_AGN-7.8
    f0=0.0201-0.003*theta
    fz=0.409+0.0224*theta
    f_star=f0*10**(fz*lut%z)

    IF(f_star > cosm%Om_b/cosm%Om_m) f_star = cosm%Om_b/cosm%Om_m

    END FUNCTION f_star

    FUNCTION find_pk(k,itype,cosm)
    !Look-up and interpolation for P(k,z=0)
    REAL(dl) :: find_pk
    REAL(dl) :: ns
    REAL(dl), INTENT(IN) :: k
    INTEGER, INTENT(IN) :: itype
    INTEGER :: n
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    INTEGER, PARAMETER :: iorder=iorder_pk_interpolation
    INTEGER, PARAMETER :: ifind=ifind_pk_interpolation
    INTEGER, PARAMETER :: imeth=imeth_pk_interpolation

    !Set number of k points as well as min and max k values
    !Note that the min k value should be set to the same as the CAMB min k value
    n=SIZE(cosm%log_k_plin)

    IF(plin_extrap .AND. k>cosm%kmax) THEN
        !Do some extrapolation here based on knowledge of things at high k
        ns=cosm%ns !Spectral index used in the high-k extrapolation
        IF(itype==0) THEN
            find_pk=exp(cosm%log_plin(n))*((log(k)/cosm%log_k_plin(n))**2)*((k/cosm%kmax)**(ns-1))
        ELSE IF(itype==1) THEN
            find_pk=exp(cosm%log_plinc(n))*((log(k)/cosm%log_k_plin(n))**2)*((k/cosm%kmax)**(ns-1))
        END IF
    ELSE
        !Otherwise use the standard find algorithm
        IF(itype==0) THEN
            find_pk=exp(find(log(k),cosm%log_k_plin,cosm%log_plin,cosm%nk,iorder,ifind,imeth))
        ELSE IF(itype==1) THEN
            find_pk=exp(find(log(k),cosm%log_k_plin,cosm%log_plinc,cosm%nk,iorder,ifind,imeth))
        END IF
    END IF

    END FUNCTION find_pk

    FUNCTION p_lin(k,z,itype,cosm)
    !Looks up the value for the linear power spectrum
    REAL(dl) :: p_lin
    REAL(dl), INTENT (IN) :: k, z
    REAL(dl) growth2
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !This gives the linear power spectrum for the model in question
    !P(k) should have been previously normalised to z=0
    if (z==0._dl) then
        growth2 = 1
    else if (z==cosm%this_z) then
        growth2 = cosm%grow2_z
    else
        growth2 = grow(z,cosm)**2 !never actually needed
    end if
    p_lin=growth2*find_pk(k,itype,cosm)

    END FUNCTION p_lin

    FUNCTION p_2h(this,k,plin,lut,cosm)
    class(THalofit) :: this
    !Calculates the 2-halo term
    REAL(dl) :: p_2h
    REAL(dl), INTENT(IN) :: k, plin
    REAL(dl) :: sigv, frac, kdamp, ndamp, x
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !Damping function
    frac=this%fdamp(lut)

    IF(this%imead==0 .OR. this%imead==4 .OR. this%imead==5 .OR. frac<1.e-3) THEN
        p_2h=plin
    ELSE IF(this%imead==1 .OR. this%imead==2) THEN
        sigv=lut%sigv
        p_2h=plin*(1.-frac*(tanh(k*sigv/sqrt(ABS(frac))))**2.)
    ELSE IF(this%imead==3) THEN
        kdamp=0.05699*lut%sig8z_cold**(-1.089)
        ndamp=2.85
        x=(k/kdamp)**ndamp
        p_2h=p_dewiggle(k, lut%z, plin, lut%sigv, cosm)*(1.-frac*x/(1.+x))
    END IF

    !For some strange cosmologies frac>1. so this must be added to prevent p_2h<0.
    IF(p_2h<0.) p_2h=0.

    END FUNCTION p_2h

    FUNCTION p_1h(this,k,lut,cosm)
    class(THalofit) :: this
    !Calculates the 1-halo term
    REAL(dl) :: p_1h
    REAL(dl), INTENT(IN) :: k
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: g, fac, et, ks, wk, x, m
    REAL(dl) :: integrand(lut%n)
    REAL(dl) :: sum
    INTEGER :: i
    REAL(dl), PARAMETER :: pi=pi_HM
    INTEGER, PARAMETER :: iorder=iorder_integration_1h

    !Only call eta once
    et=this%eta(lut,cosm)

    !Calculates the value of the integrand at all nu values!
    DO i=1,lut%n
        m=lut%m(i)
        g=gnu(lut%nu(i))
        wk=win(k*lut%nu(i)**et,lut%rv(i),lut%c(i))
        IF(this%imead==5) wk=baryonify_wk(wk, m, lut, cosm)
        integrand(i)=g*(wk**2)*lut%m(i)
    END DO

    IF(this%imead==3 .OR. this%imead==4) integrand=integrand*(1.-cosm%f_nu)**2

    !Carries out the integration
    sum=inttab(lut%nu,integrand,1,lut%n,iorder)/cosmic_density(cosm)

    !Numerical factors to convert from P(k) to Delta^2(k)
    p_1h=sum*k**3/(2.*pi**2)

    IF(this%imead==1 .OR. this%imead==2) THEN
        !Damping of the 1-halo term at very large scales
        ks=this%kstar(lut)
        IF(ks==0.) THEN
            fac=0.
        ELSE IF((k/ks)**2.>ks_limit) THEN
            fac=0. !Prevents problems if k/ks is very large
        ELSE
            fac=exp(-((k/ks)**2.))
        END IF
        !Damping of the one-halo term at very large scales
        p_1h=p_1h*(1.-fac)
    ELSE IF(this%imead==3 .OR. this%imead==4 .OR. this%imead==5) THEN
        ks=this%kstar(lut)
        x=(k/ks)**4
        p_1h=p_1h*x/(1.+x)
    END IF

    END FUNCTION p_1h

    REAL FUNCTION p_dewiggle(k, z, p_linear, sigv, cosm)
    ! Call the dewiggled power spectrum, which is linear but with damped wiggles
    REAL(dl), INTENT(IN) :: k, z, p_linear, sigv
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: p_wiggle, f, logk
    INTEGER, PARAMETER :: iorder = iorder_wiggle
    INTEGER, PARAMETER :: ifind = ifind_wiggle
    INTEGER, PARAMETER :: imeth = imeth_wiggle

    logk = log(k)
    IF (logk < cosm%log_k_wiggle(1) .OR. logk > cosm%log_k_wiggle(nk_wiggle)) THEN
        p_wiggle = 0
    ELSE
        p_wiggle = find(logk, cosm%log_k_wiggle, cosm%pk_wiggle, nk_wiggle, iorder, ifind, imeth)
    END IF
    f = exp(-(k*sigv)**2)
    p_dewiggle = p_linear+(f-1)*p_wiggle*grow(z, cosm)**2

    END FUNCTION p_dewiggle

    SUBROUTINE init_wiggle(cosm)
    ! Isolate the power spectrum wiggle
    TYPE(HM_cosmology), INTENT(INOUT) :: cosm
    REAL(dl), ALLOCATABLE :: k(:), Pk(:)
    REAL(dl), ALLOCATABLE :: Pk_smooth(:), Pk_wiggle(:)
    INTEGER :: i
    REAL(dl), PARAMETER :: kmin = kmin_wiggle
    REAL(dl), PARAMETER :: kmax = kmax_wiggle
    INTEGER, PARAMETER  :: nk = nk_wiggle
    REAL(dl), PARAMETER :: z = 0. ! Only need to run this routine for z=0
    INTEGER, PARAMETER :: itype = 0 ! Matter spectrum

    ! Words
    IF (HM_verbose) WRITE(*, *) 'INIT_WIGGLE: Starting'

    ! Allocate arrays
    ALLOCATE (Pk(nk), Pk_wiggle(nk), Pk_smooth(nk))

    ! Allocate array for k
    CALL fill_table(log(kmin), log(kmax), k, nk)
    k=exp(k)

    ! Get the linear power spectrum in an array
    DO i = 1, nk
        Pk(i) = p_lin(k(i), z, itype, cosm)
    END DO

    IF (HM_verbose) THEN
        WRITE(*, *) 'INIT_WIGGLE: kmin [h/Mpc]:', k(1)
        WRITE(*, *) 'INIT_WIGGLE: kmax [h/Mpc]:', k(nk)
        WRITE(*, *) 'INIT_WIGGLE: nk:', nk
        WRITE(*, *) 'INIT_WIGGLE: Splitting into wiggle and broad-band'
    END IF

    CALL calculate_psmooth(k, z, Pk, Pk_smooth, cosm)

    IF (HM_verbose) WRITE(*, *) 'INIT_WIGGLE: Isolating wiggle'

    ! Isolate the wiggle
    Pk_wiggle = Pk-Pk_smooth

    IF (HM_verbose) WRITE(*, *) 'INIT_WIGGLE: Initialising interpolator'

    ! Fill look-up tables
    IF(ALLOCATED(cosm%log_k_wiggle)) DEALLOCATE(cosm%log_k_wiggle)
    IF(ALLOCATED(cosm%pk_wiggle)) DEALLOCATE(cosm%pk_wiggle)
    ALLOCATE(cosm%log_k_wiggle(nk), cosm%pk_wiggle(nk))
    cosm%log_k_wiggle = log(k)
    cosm%pk_wiggle = pk_wiggle

    IF (HM_verbose) THEN
        WRITE (*, *) 'INIT_WIGGLE: Done'
        WRITE (*, *)
    END IF

    END SUBROUTINE init_wiggle

    SUBROUTINE calculate_psmooth(k, z, Pk, Pk_smt, cosm)
    ! Calculate the normalised smoothed power spectrum at a range of k
    REAL(dl), INTENT(IN) :: k(:)
    REAL(dl), INTENT(IN) :: z
    REAL(dl), INTENT(IN) :: Pk(:)
    REAL(dl), ALLOCATABLE, INTENT(OUT) :: Pk_smt(:)
    REAL(dl), ALLOCATABLE :: Pk_nw(:)
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl), PARAMETER :: sig = wiggle_sigma

    ! Reduce dynamic range
    CALL calculate_nowiggle(k, z, Pk, Pk_nw, cosm)
    Pk_smt = Pk/Pk_nw

    ! Smooth linear power
    CALL smooth_array_Gaussian(log(k), Pk_smt, sig)

    ! Return dynamic range
    Pk_smt = Pk_smt*Pk_nw

    END SUBROUTINE calculate_psmooth

    SUBROUTINE calculate_nowiggle(k, z, Pk, Pk_nw, cosm)
    ! Calculate the normalised no wiggle power spectrum at a range of k and a
    ! Comes from the Eisenstein & Hu approximation
    REAL(dl), INTENT(IN) :: k(:)
    REAL(dl), INTENT(IN) :: z
    REAL(dl), INTENT(IN) :: Pk(:)
    REAL(dl), ALLOCATABLE, INTENT(OUT) :: Pk_nw(:)
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    INTEGER :: ik, nk
    REAL(dl) :: Pk_norm, Pk_nw_norm
    REAL(dl), PARAMETER :: knorm = knorm_nowiggle
    INTEGER, PARAMETER :: type = 0 ! Matter here
    INTEGER, PARAMETER :: iorder = 3
    INTEGER, PARAMETER :: ifind = 3
    INTEGER, PARAMETER :: imeth = 2

    ! Allocate arrays
    nk = size(k)
    IF (nk /= size(Pk)) STOP 'CALCULATE_NOWIGGLE: Error, Pk should be same size as k and a'
    ALLOCATE(Pk_nw(nk))

    ! Get the no-wiggle power spectrum
    DO ik = 1, nk
        Pk_nw(ik) = Pk_nowiggle(k(ik), cosm)
    END DO

    ! Calculate the no-wiggle power spectrum and force spectra to agree at the normalisation wavenumber
    Pk_norm = p_lin(knorm, z, type, cosm)
    Pk_nw_norm = find(knorm, k, Pk_nw, nk, iorder, ifind, imeth)
    Pk_nw = Pk_nw*Pk_norm/Pk_nw_norm

    END SUBROUTINE calculate_nowiggle

    REAL FUNCTION Pk_nowiggle(k, cosm)
    ! Calculates the un-normalised no-wiggle power spectrum
    ! Comes from the Eisenstein & Hu approximation
    REAL(dl), INTENT(IN) :: k
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    Pk_nowiggle = (k**(cosm%ns+3.))*Tk_nw(k, cosm)**2

    END FUNCTION Pk_nowiggle

    REAL FUNCTION Tk_nw(k, cosm)
    ! No-wiggle transfer function from Eisenstein & Hu: astro-ph:9709112
    REAL(dl), INTENT(IN) :: k ! Wavenumber [h/Mpc]
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: q, L, C, Gamma, wm, wb, s, h, alpha, rb
    REAL(dl), PARAMETER :: e = exp(1.)

    ! Useful parameters to make equations shorter
    wm = cosm%Om_m*cosm%h**2 ! Real matter density
    wb = cosm%Om_b*cosm%h**2 ! Real baryon density
    rb = cosm%Om_b/cosm%Om_m ! Baryon ratio
    h = cosm%h               ! Hubble factor

    ! These only needs to be calculated once
    s = 44.5*log(9.83/wm)/sqrt(1.+10.*wb**0.75)              ! Equation (26)
    alpha = 1.-0.328*log(431.*wm)*rb+0.38*log(22.3*wm)*rb**2 ! Equation (31)

    ! Functions of k
    Gamma = cosm%Om_m*cosm%h*(alpha+(1.-alpha)/(1.+(0.43*k*s*h)**4)) ! Equation (30)
    q = k*(cosm%Tcmb/2.7)**2/Gamma ! Equation (28)
    L = log(2.*e+1.8*q)             ! Equation (29)
    C = 14.2+731./(1.+62.5*q)       ! Equation (29)
    Tk_nw = L/(L+C*q**2)            ! Equation (29)

    END FUNCTION Tk_nw

    SUBROUTINE smooth_array_Gaussian(x, f, sigma)
    ! Smooth an array f(x) using a Gaussian kernel
    REAL(dl), INTENT(IN) :: x(:)    ! x coordinates
    REAL(dl), INTENT(INOUT) :: f(:) ! Array to smooth
    REAL(dl), INTENT(IN) :: sigma   ! Width of smoothing Gaussian
    INTEGER :: i, j, n
    REAL(dl), ALLOCATABLE :: ff(:)
    REAL(dl) :: weight, total
    REAL(dl), PARAMETER :: nsig = 3. ! Do not smooth if point lies within this number of sigma from edge

    IF (sigma  .NE. 0.) THEN

        n = size(x)
        IF (n /= size(f)) STOP 'GAUSSIAN_SMOOTH_ARRAY: Error, x and y should be the same size'

        ! Save the original input array
        ff = f

        ! Delete the original array
        f = 0.

        ! Apply Gaussian smoothing
        DO i = 1, n
            total = 0.
            IF (abs(x(i)-x(1)) < nsig*sigma .OR. abs(x(i)-x(n)) < nsig*sigma) THEN
                f(i) = ff(i)
            ELSE
                DO j = 1, n
                    weight = exp(-(x(i)-x(j))**2/(2.*sigma**2))
                    f(i) = f(i)+ff(j)*weight
                    total = total+weight
                END DO
                f(i) = f(i)/total
            END IF
        END DO

        DEALLOCATE(ff)

    END IF

    END SUBROUTINE smooth_array_Gaussian

    SUBROUTINE fill_sigtab(this,cosm)
    class(THalofit) :: this
    !This fills up HM_tables of r vs. sigma(r) across a range in r
    !It is used only in look-up for further calculations of sigmac(r) and not otherwise
    !and prevents a large number of calls to the sigint functions
    !rmin and rmax need to be decided in advance and are chosen such that
    !R vs. sigma(R) is approximately power-law below and above these values of R
    !This wouldn't be appropriate for models with a small-scale linear spectrum cut-off (e.g., WDM)
    INTEGER :: i
    TYPE(HM_cosmology) :: cosm
    REAL(dl), ALLOCATABLE :: r(:), sig(:)
    INTEGER :: itype
    REAL(dl), PARAMETER :: rmin=rmin_sigma_interpolation
    REAL(dl), PARAMETER :: rmax=rmax_sigma_interpolation
    INTEGER, PARAMETER :: nsig=n_sigma_interpolation

    ! Choose type of sigma(R) to tabulate depending on HMcode version
    IF(this%halofit_version == halofit_mead2015) THEN
        itype=0 ! 0 - All matter
    ELSE
        itype=1 ! 1 - Cold matter
    END IF

    !Allocate arrays
    IF(ALLOCATED(cosm%log_r_sigma)) DEALLOCATE(cosm%log_r_sigma)
    IF(ALLOCATED(cosm%log_sigma))   DEALLOCATE(cosm%log_sigma)

    !These values of 'r' work fine for any power spectrum of cosmological importance
    !Having nsig as a 2** number is most efficient for the look-up routines
    ALLOCATE(r(nsig),sig(nsig))

    IF(HM_verbose) WRITE(*,*) 'SIGTAB: Filling sigma interpolation table'
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: R_min:', rmin
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: R_max:', rmax
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: Values:', nsig

    !$OMP PARALLEL DO default(shared)
    DO i=1,nsig

        !Equally spaced r in log
        r(i)=exp(log(rmin)+log(rmax/rmin)*float(i-1)/float(nsig-1))

        sig(i)=sigma_integral(r(i),0.d0,itype,cosm)

    END DO
    !$OMP END PARALLEL DO

    IF(HM_verbose) WRITE(*,*) 'SIGTAB: sigma_min:', sig(nsig)
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: sigma_max:', sig(1)

    cosm%nsig=nsig
    ALLOCATE(cosm%log_r_sigma(nsig),cosm%log_sigma(nsig))
    cosm%log_r_sigma=log(r)
    cosm%log_sigma=log(sig)

    IF(HM_verbose) WRITE(*,*) 'SIGTAB: Done'
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE fill_sigtab

    FUNCTION sigma_lut(r,z,cosm)
    !Finds sigma_cold(R) from look-up table
    REAL(dl) :: sigma_lut
    REAL(dl), INTENT(IN) :: r, z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    INTEGER, PARAMETER :: iorder=iorder_sigma_interpolation
    INTEGER, PARAMETER :: ifind=ifind_sigma_interpolation
    INTEGER, PARAMETER :: imeth=imeth_sigma_interpolation

    sigma_lut=grow(z,cosm)*exp(find(log(r),cosm%log_r_sigma,cosm%log_sigma,cosm%nsig,iorder,ifind,imeth))

    END FUNCTION sigma_lut

    FUNCTION wk_tophat(x)

    !The normlaised Fourier Transform of a top-hat
    REAL(dl) :: wk_tophat
    REAL(dl), INTENT(IN) :: x
    REAL(dl), PARAMETER :: dx=1e-3 ! Taylor expansion for |x|<dx

    !Taylor expansion used for low x to avoid cancellation problems
    IF(abs(x)<dx) THEN
        wk_tophat=1-(x**2)/10
    ELSE
        wk_tophat=3*(sin(x)-x*cos(x))/(x**3)
    END IF

    END FUNCTION wk_tophat

    FUNCTION wk_tophat_deriv(x)
    ! The derivative of a normlaised Fourier Transform of a spherical top-hat
    REAL(dl) :: wk_tophat_deriv
    REAL(dl), INTENT(IN) :: x
    REAL(dl), PARAMETER :: dx=1e-3 ! Taylor expansion for |x|<dx

    ! Taylor expansion used for low x to avoid cancelation problems
    IF (abs(x)<dx) THEN
        wk_tophat_deriv=-x/5+x**3/70
    ELSE
        wk_tophat_deriv=(3/x**4)*((x**2-3)*sin(x)+3*x*cos(x))
    END IF

    END FUNCTION wk_tophat_deriv

    FUNCTION inttab(x,y,n1,n2,iorder)
    !Integrates tables y(x)dx
    REAL(dl) :: inttab
    INTEGER, INTENT(IN) :: n1, n2
    REAL(dl), INTENT(IN) :: x(:), y(:)
    INTEGER, INTENT(IN) :: iorder
    REAL(dl) :: a, b, c, d, h
    REAL(dl) :: q1, q2, q3, qi, qf
    REAL(dl) :: x1, x2, x3, x4, y1, y2, y3, y4, xi, xf
    real(dl) :: sum
    INTEGER :: i, i1, i2, i3, i4, n

    n=size(x)

    sum=0.d0

    IF(n1==n2) THEN

        inttab=0.

    ELSE IF(iorder==1) THEN

        !Sums over all Trapezia (a+b)*h/2
        DO i=n1,n2-1
            a=y(i+1)
            b=y(i)
            h=x(i+1)-x(i)
            sum=sum+(a+b)*h/2.d0
        END DO

    ELSE IF(iorder==2) THEN

        DO i=n1,n2-2

            x1=x(i)
            x2=x(i+1)
            x3=x(i+2)

            y1=y(i)
            y2=y(i+1)
            y3=y(i+2)

            CALL fit_quadratic(a,b,c,x1,y1,x2,y2,x3,y3)

            q1=a*(x1**3.)/3.+b*(x1**2.)/2.+c*x1
            q2=a*(x2**3.)/3.+b*(x2**2.)/2.+c*x2
            q3=a*(x3**3.)/3.+b*(x3**2.)/2.+c*x3

            !Takes value for first and last sections but averages over sections where you
            !have two independent estimates of the area
            IF(n==3) THEN
                sum=sum+q3-q1
            ELSE IF(i==1) THEN
                sum=sum+(q2-q1)+(q3-q2)/2.d0
            ELSE IF(i==n-2) THEN
                sum=sum+(q2-q1)/2.d0+(q3-q2)
            ELSE
                sum=sum+(q3-q1)/2.
            END IF

        END DO

    ELSE IF(iorder==3) THEN

        DO i=n1,n2-1

            !First choose the integers used for defining cubics for each section
            !First and last are different because the section does not lie in the *middle* of a cubic

            IF(i==1) THEN

                i1=1
                i2=2
                i3=3
                i4=4

            ELSE IF(i==n-1) THEN

                i1=n-3
                i2=n-2
                i3=n-1
                i4=n

            ELSE

                i1=i-1
                i2=i
                i3=i+1
                i4=i+2

            END IF

            x1=x(i1)
            x2=x(i2)
            x3=x(i3)
            x4=x(i4)

            y1=y(i1)
            y2=y(i2)
            y3=y(i3)
            y4=y(i4)

            CALL fit_cubic(a,b,c,d,x1,y1,x2,y2,x3,y3,x4,y4)

            !These are the limits of the particular section of integral
            xi=x(i)
            xf=x(i+1)

            qi=a*(xi**4.)/4.+b*(xi**3.)/3.+c*(xi**2.)/2.+d*xi
            qf=a*(xf**4.)/4.+b*(xf**3.)/3.+c*(xf**2.)/2.+d*xf

            sum=sum+qf-qi

        END DO

    ELSE

        ERROR STOP 'INTTAB: Error, order not specified correctly'

    END IF

    inttab=REAL(sum)

    END FUNCTION inttab

    FUNCTION sigma_integral(r,z,itype,cosm)
    !Gets sigma(R)
    REAL(dl) :: sigma_integral
    REAL(dl), INTENT(IN) :: r, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl), PARAMETER :: tmin=0.
    REAL(dl), PARAMETER :: tmax=1.
    REAL(dl), PARAMETER :: acc=acc_sigma_integration
    INTEGER, PARAMETER :: iorder=iorder_sigma_integration

    sigma_integral=sqrt(integrate(tmin,tmax,sigma_integrand,r,z,itype,cosm,acc,iorder))

    END FUNCTION sigma_integral

    FUNCTION sigma_integrand(t,R,z,itype,cosm)
    !The integrand for the sigma(R) integrals
    REAL(dl) :: sigma_integrand
    REAL(dl), INTENT(IN) :: t, R, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: k, kR, w_hat
    REAL(dl), PARAMETER :: alpha=alpha_sigma_integration

    IF(t<=0. .OR. t>=1.) THEN
        !t=0 corresponds to k=infintiy when W(kR)=0.
        !t=1 corresponds to k=0. when P(k)=0.
        sigma_integrand=0.d0
    ELSE
        kR=(-1.+1./t)**alpha
        k=kR/R
        w_hat=wk_tophat(kR)
        sigma_integrand=p_lin(k,z,itype,cosm)*(w_hat**2)*alpha/(t*(1.-t))
    END IF

    END FUNCTION sigma_integrand

    FUNCTION integrate(a,b,f,y,z,itype,cosm,acc,iorder)
    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    REAL(dl) :: integrate
    REAL(dl), INTENT(IN) :: a
    REAL(dl), INTENT(IN) :: b
    REAL(dl), INTENT(IN) :: y
    REAL(dl), INTENT(IN) :: z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl), INTENT(IN) :: acc
    INTEGER, INTENT(IN) :: iorder
    INTEGER :: i, j
    INTEGER :: n
    REAL(dl) :: x, dx
    REAL(dl) :: f1, f2, fx
    real(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=20

    INTERFACE
    FUNCTION f(x, y, z, itype, cosm)
    USE precision
    IMPORT :: HM_cosmology
    REAL(dl) :: f
    REAL(dl), INTENT(IN) :: x
    REAL(dl), INTENT(IN) :: y
    REAL(dl), INTENT(IN) :: z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    END FUNCTION f
    END INTERFACE

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        integrate=0.d0

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1,dl)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=f(a,y,z,itype,cosm)
                f2=f(b,y,z,itype,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*real(i-1,dl)/real(n-1,dl)
                    fx=f(x,y,z,itype,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    ERROR STOP 'INTEGRATE: Error, iorder specified incorrectly'
                END IF

            END IF

            IF(j>=jmin .and. sum_old /= 0) THEN
                if (ABS(-1.d0+sum_new/sum_old)<acc) THEN
                    !jmin avoids spurious early convergence
                    integrate=sum_new
                    EXIT
                end if
            end if
            IF(j==jmax) THEN
                integrate=sum_new
                call GlobalError('HMCode INTEGRATE, Integration timed out', error_nonlinear)
                return
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION integrate

    FUNCTION win(k,rv,c)
    !Selects the halo window function (k-space halo profile)
    REAL(dl) :: win
    REAL(dl), INTENT(IN) :: k, rv, c

    !Choose the NFW analytic form
    win=winnfw(k,rv,c)

    !Correct for the case of disasters (a bit sloppy, not sure if this is ever used)
    IF(win>1._dl) win=1._dl
    IF(win<0._dl) win=0._dl

    END FUNCTION win

    FUNCTION winnfw(k,rv,c)
    !The analytic Fourier Transform of the NFW profile; note  W(k->0)=1
    REAL(dl) :: winnfw
    REAL(dl), INTENT(IN) :: k, rv, c
    REAL(dl) :: si1, si2, ci1, ci2, ks
    REAL(dl) :: p1, p2, p3

    !Define the scale wavenumber
    ks=k*rv/c

    !Sine and cosine integrals
    si1=Si(ks)
    si2=Si((1.+c)*ks)
    ci1=Ci(ks)
    ci2=Ci((1.+c)*ks)

    !These three parts sum to give the full W(k)
    p1=cos(ks)*(ci2-ci1)
    p2=sin(ks)*(si2-si1)
    p3=sin(ks*c)/(ks*(1.+c))

    !Create full W(k) and divide out mass factor
    winnfw=p1+p2-p3
    winnfw=winnfw/mass(c)

    END FUNCTION winnfw

    FUNCTION mass(c)
    !This calculates the (normalised) mass of a halo of concentration c
    !The 'normalised' mass is that divided by the prefactor r_s^3 4*pi rho_n
    !where rho_n is the profile normalisation [i.e, rho=rho_n/((r/r_s)*(1.+r/r_s)^2]
    REAL(dl) :: mass
    REAL(dl), INTENT(IN) :: c

    mass=log(1+c)-c/(1+c)

    END FUNCTION mass

    FUNCTION gnu(nu)
    !Select the mass function
    REAL(dl) :: gnu
    REAL(dl), INTENT(IN) :: nu

    !Sheth & Torman (1999)
    gnu=gst(nu)

    END FUNCTION gnu

    FUNCTION gst(nu)
    !Sheth & Tormen (1999) mass function!
    REAL(dl) :: gst
    REAL(dl), INTENT(IN) :: nu
    REAL(dl), PARAMETER :: p=0.3
    REAL(dl), PARAMETER :: a=0.707
    REAL(dl), PARAMETER :: bigA=0.21616

    !Note I use nu=dc/sigma whereas ST (1999) use nu=(dc/sigma)^2
    !This accounts for the different pre-factor and slighly changed nu dependence
    !f(nu^2)d(nu^2)=2*nu*f(nu)dnu

    !Full mass function. Note this is normalised such that integral f(nu)dnu = 1
    gst=bigA*(1+((a*nu*nu)**(-p)))*exp(-a*nu*nu/2)

    END FUNCTION gst

    FUNCTION Hubble2(z,cosm)
    !This calculates the dimensionless squared hubble parameter at redshift z (H/H_0)^2!
    !Ignores contributions from radiation (not accurate at high z, but consistent with simulations)!
    REAL(dl) :: Hubble2
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    Hubble2=cosm%om_m*(1+z)**3+cosm%om_v*X_de(z,cosm)+(1-cosm%om_m-cosm%om_v)*(1+z)**2

    END FUNCTION Hubble2

    FUNCTION AH(z,cosm)
    !The Hubble acceleration function \ddot{a}/a
    REAL(dl) :: AH
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    AH=cosm%om_m*(1+z)**3+cosm%om_v*(1.+3.*w_de_hm(z,cosm))*X_de(z,cosm)
    AH=-AH/2.

    END FUNCTION AH

    FUNCTION X_de(z,cosm)
    !The time evolution for dark energy: rho_de=rho_de,0 * X(a)
    !X(a)=1 for LCDM but changes for other models
    REAL(dl) :: X_de
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: a

    a=1./(1.+z)
    X_de=(a**(-3*(1+cosm%w+cosm%wa)))*exp(-3*cosm%wa*(1-a))

    END FUNCTION X_de

    FUNCTION w_de_hm(z,cosm)

    !The dark energy w(a) function
    REAL(dl) :: w_de_hm
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: a

    a=1./(1.+z)
    w_de_hm=cosm%w+(1-a)*cosm%wa

    END FUNCTION w_de_hm

    FUNCTION Omega_m_hm(z,cosm)
    !This calculates omega_m variations with z!
    REAL(dl) :: Omega_m_hm
    REAL(dl), INTENT(IN) :: z
    REAL(dl) :: om_m
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    om_m=cosm%om_m
    Omega_m_hm=(om_m*(1+z)**3)/Hubble2(z,cosm)

    END FUNCTION Omega_m_hm

    FUNCTION Omega_cold_hm(z,cosm)
    !This calculates omega_cold variations with z (no neutrinos)
    REAL(dl) :: Omega_cold_hm
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    Omega_cold_hm=((cosm%om_c+cosm%om_b)*(1+z)**3)/Hubble2(z,cosm)

    END FUNCTION Omega_cold_hm

    FUNCTION grow(z,cosm)
    !Finds the scale-independent growth fuction at redshift z
    REAL(dl) :: grow
    REAL(dl), INTENT(IN) :: z
    REAL(dl) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    INTEGER, PARAMETER :: iorder=iorder_growth_interpolation
    INTEGER, PARAMETER :: ifind=ifind_growth_interpolation
    INTEGER, PARAMETER :: imeth=imeth_growth_interpolation

    IF(z==0.) THEN
        grow=1.
    ELSE
        a=1./(1.+z)
        grow=find(a,cosm%a_growth,cosm%growth,cosm%ng,iorder,ifind,imeth)
    END IF

    END FUNCTION grow

    REAL(dl) RECURSIVE FUNCTION ungrow(z, cosm)

    ! Growth function normalised such that g(a) = a at early (matter-dominated) times
    IMPLICIT NONE
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    ungrow = cosm%gnorm*grow(z, cosm)

    END FUNCTION ungrow

    REAL(dl) RECURSIVE FUNCTION acc_growth(z, cosm)

    ! Accumulated growth function: int_0^a g(a)/a da
    IMPLICIT NONE
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: a
    INTEGER, PARAMETER :: iorder=iorder_agrowth_interpolation
    INTEGER, PARAMETER :: ifind=ifind_agrowth_interpolation
    INTEGER, PARAMETER :: imeth=imeth_agrowth_interpolation

    a=1./(1.+z)
    acc_growth = find(a, cosm%a_growth, cosm%agrow, cosm%ng, iorder, ifind, imeth)

    END FUNCTION acc_growth

    FUNCTION sigmaV(R,z,itype,cosm)
    REAL(dl) :: sigmaV
    REAL(dl), INTENT(IN) :: R
    REAL(dl), INTENT(IN) :: z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl), PARAMETER :: tmin=0._dl
    REAL(dl), PARAMETER :: tmax=1._dl
    REAL(dl), PARAMETER :: acc=acc_sigmaV_integration
    INTEGER, PARAMETER :: iorder=iorder_sigmaV_integration

    sigmaV=sqrt(integrate(tmin,tmax,sigmaV_integrand,R,z,itype,cosm,acc,iorder)/3)

    END FUNCTION sigmaV

    FUNCTION sigmaV_integrand(t,R,z,itype,cosm)
    !This is the integrand for the velocity dispersion integral
    REAL(dl) :: sigmaV_integrand
    REAL(dl), INTENT(IN) :: t
    REAL(dl), INTENT(IN) :: R
    REAL(dl), INTENT(IN) :: z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: k, kR, w_hat
    REAL(dl), PARAMETER :: alpha=alpha_sigmaV_integration !Speeds up integral for large 'R'

    IF(t<=0._dl .OR. t>=1._dl) THEN
        sigmaV_integrand=0
    ELSE
        IF(R==0.) THEN
            kR=0
            k=(-1+1/t)**alpha
        ELSE
            kR=(-1+1/t)**alpha
            k=kR/R
        END IF
        w_hat=wk_tophat(kR)
        sigmaV_integrand=(p_lin(k,z,itype,cosm)/k**2)*(w_hat**2)*alpha/(t*(1-t))
    END IF

    END FUNCTION sigmaV_integrand

    FUNCTION neff_integrand(t,R,z,itype,cosm)
    !This is the integrand for the velocity dispersion integral
    REAL(dl) :: neff_integrand
    REAL(dl), INTENT(IN) :: t
    REAL(dl), INTENT(IN) :: R
    REAL(dl), INTENT(IN) :: z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: k, kR, w_hat, w_hat_deriv
    REAL(dl), PARAMETER :: alpha=alpha_neff_integration !Speeds up integral for large 'R'

    IF(t<=0. .OR. t>=1.) THEN
        neff_integrand=0.
    ELSE
        kR=(-1.+1./t)**alpha
        k=kR/R
        w_hat=wk_tophat(kR)
        w_hat_deriv=wk_tophat_deriv(kR)
        neff_integrand=p_lin(k,z,itype,cosm)*w_hat*w_hat_deriv*alpha*kR/(t*(1.-t))
    END IF

    END FUNCTION neff_integrand

    FUNCTION Si(x)

    !Calculates the 'sine integral' function Si(x)
    REAL(dl) :: Si
    REAL(dl), INTENT(IN) :: x
    REAL(dl) :: x2, y, f, g, si8
    REAL(dl), PARAMETER :: x0=4. ! Transition between two different approximations

    !Expansions for high and low x thieved from Wikipedia, two different expansions for above and below 4.
    IF(ABS(x)<=x0) THEN

        x2=x*x

        si8 = x*(1.d0+x2*(-4.54393409816329991d-2+x2*(1.15457225751016682d-3&
            +x2*(-1.41018536821330254d-5+x2*(9.43280809438713025d-8+x2*(-3.53201978997168357d-10&
            +x2*(7.08240282274875911d-13+x2*(-6.05338212010422477d-16))))))))/ &
            (1.+x2*(1.01162145739225565d-2 +x2*(4.99175116169755106d-5+&
            x2*(1.55654986308745614d-7+x2*(3.28067571055789734d-10+x2*(4.5049097575386581d-13&
            +x2*(3.21107051193712168d-16)))))))

        Si=si8

    ELSE IF(ABS(x)>x0) THEN

        y=1.d0/(x*x)

        f = (1.d0 + y*(7.44437068161936700618d2 + y*(1.96396372895146869801d5 +&
            y*(2.37750310125431834034d7 +y*(1.43073403821274636888d9 + y*(4.33736238870432522765d10 &
            + y*(6.40533830574022022911d11 + y*(4.20968180571076940208d12 + &
            y*(1.00795182980368574617d13 + y*(4.94816688199951963482d12 +&
            y*(-4.94701168645415959931d11)))))))))))/ (x*(1. +y*(7.46437068161927678031d2 +&
            y*(1.97865247031583951450d5 +y*(2.41535670165126845144d7 + &
            y*(1.47478952192985464958d9 + y*(4.58595115847765779830d10 +&
            y*(7.08501308149515401563d11 + y*(5.06084464593475076774d12 + &
            y*(1.43468549171581016479d13 + y*(1.11535493509914254097d13)))))))))))


        g = y*(1.d0 + y*(8.1359520115168615d2 + y*(2.35239181626478200d5 + &
            y*(3.12557570795778731d7 + y*(2.06297595146763354d9 + y*(6.83052205423625007d10 +&
            y*(1.09049528450362786d12 + y*(7.57664583257834349d12 +y*(1.81004487464664575d13 +&
            y*(6.43291613143049485d12 +y*(-1.36517137670871689d12)))))))))))/&
            (1. + y*(8.19595201151451564d2 +y*(2.40036752835578777d5 + y*(3.26026661647090822d7 &
            + y*(2.23355543278099360d9 + y*(7.87465017341829930d10 + y*(1.39866710696414565d12 &
            + y*(1.17164723371736605d13 + y*(4.01839087307656620d13 +y*(3.99653257887490811d13))))))))))

        Si=pi_HM/2.d0-f*cos(x)-g*sin(x)

    END IF

    END FUNCTION Si

    FUNCTION Ci(x)

    !Calculates the 'cosine integral' function Ci(x)
    REAL(dl) :: Ci
    REAL(dl), INTENT(IN) :: x
    REAL(dl) :: x2, y, f, g, ci8
    REAL(dl), PARAMETER :: em_const=0.577215664901532861d0
    REAL(dl), PARAMETER :: x0=4. ! Transition between two different approximations

    !Expansions for high and low x thieved from Wikipedia, two different expansions for above and below 4.
    IF(ABS(x)<=x0) THEN

        x2=x*x

        ci8=em_const+log(x)+x2*(-0.25d0+x2*(7.51851524438898291d-3+x2*(-1.27528342240267686d-4&
            +x2*(1.05297363846239184d-6+x2*(-4.68889508144848019d-9+x2*(1.06480802891189243d-11&
            +x2*(-9.93728488857585407d-15)))))))/ (1.+x2*(1.1592605689110735d-2+&
            x2*(6.72126800814254432d-5+x2*(2.55533277086129636d-7+x2*(6.97071295760958946d-10+&
            x2*(1.38536352772778619d-12+x2*(1.89106054713059759d-15+x2*(1.39759616731376855d-18))))))))

        Ci=ci8

    ELSE IF(ABS(x)>x0) THEN

        y=1./(x*x)

        f = (1.d0 + y*(7.44437068161936700618d2 + y*(1.96396372895146869801d5 + &
            y*(2.37750310125431834034d7 +y*(1.43073403821274636888d9 + y*(4.33736238870432522765d10&
            + y*(6.40533830574022022911d11 + y*(4.20968180571076940208d12 + y*(1.00795182980368574617d13&
            + y*(4.94816688199951963482d12 +y*(-4.94701168645415959931d11)))))))))))/&
            (x*(1. +y*(7.46437068161927678031d2 +y*(1.97865247031583951450d5 +&
            y*(2.41535670165126845144d7 + y*(1.47478952192985464958d9 + &
            y*(4.58595115847765779830d10 +y*(7.08501308149515401563d11 + y*(5.06084464593475076774d12 &
            + y*(1.43468549171581016479d13 + y*(1.11535493509914254097d13)))))))))))

        g = y*(1.d0 + y*(8.1359520115168615d2 + y*(2.35239181626478200d5 + y*(3.12557570795778731d7&
            + y*(2.06297595146763354d9 + y*(6.83052205423625007d10 +&
            y*(1.09049528450362786d12 + y*(7.57664583257834349d12 +&
            y*(1.81004487464664575d13 + y*(6.43291613143049485d12 +y*(-1.36517137670871689d12)))))))))))&
            / (1. + y*(8.19595201151451564d2 +y*(2.40036752835578777d5 +&
            y*(3.26026661647090822d7 + y*(2.23355543278099360d9 + y*(7.87465017341829930d10 &
            + y*(1.39866710696414565d12 + y*(1.17164723371736605d13 + y*(4.01839087307656620d13 +y*(3.99653257887490811d13))))))))))

        Ci=f*sin(x)-g*cos(x)

    END IF

    END FUNCTION Ci

    recursive FUNCTION find(x,xtab,ytab,n,iorder,ifind,imeth) result(y)
    !Given two arrays x and y this routine interpolates to find the y_i value at position x_i
    REAL(dl) :: y
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(in) :: x
    REAL(dl), INTENT(IN) :: xtab(n), ytab(n)
    REAL(dl), ALLOCATABLE :: xtab_rev(:), ytab_rev(:)
    REAL(dl) :: a, b, c, d
    REAL(dl) :: xarr(4)
    REAL(dl) :: yarr(4)
    INTEGER :: i
    INTEGER, INTENT(IN) :: iorder, ifind, imeth

    !This version interpolates if the value is off either end of the array!
    !Care should be chosen to insert x, xtab, ytab as log if this might give better!
    !Results from the interpolation!

    !If the value required is off the table edge the interpolation is always linear

    !iorder = 1 => linear interpolation
    !iorder = 2 => quadratic interpolation
    !iorder = 3 => cubic interpolation

    !ifind = 1 => find x in xtab quickly assuming the table is linearly spaced
    !ifind = 2 => find x in xtab by crudely searching from x(1) to x(n)
    !ifind = 3 => find x in xtab using midpoint splitting (iterations=CEILING(log2(n)))

    !imeth = 1 => Uses cubic polynomials for interpolation
    !imeth = 2 => Uses Lagrange polynomials for interpolation

    if (xtab(1)>xtab(n)) then
        WRITE(*,*) 'WARNING: HMCODE find arrays in order. Please report this'
        WRITE(*,*) 'x = ',x, 'n=',n, 'xtab(1)=',xtab(1), 'xtab(n)=',xtab(n)
        call GlobalError('Array order error in HMCode', error_nonlinear)
        CALL reverse(xtab,n, xtab_rev)
        CALL reverse(ytab,n, ytab_rev)
        y =  find(x, xtab_rev, ytab_rev, n, iorder, ifind, imeth)
        return
    end if

    IF(x<xtab(1)) THEN

        !Do a linear interpolation beyond the table boundary
        IF(imeth==1) THEN
            CALL fit_line(a,b,xtab(1),ytab(1),xtab(2),ytab(2))
            y=a*x+b
        ELSE IF(imeth==2) THEN
            y=Lagrange_polynomial(x,1,xtab,ytab)
        ELSE
            ERROR STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE IF(x>xtab(n)) THEN

        !Do a linear interpolation beyond the table boundary

        xarr(1:2) = xtab(n-1:n)
        yarr(1:2) = ytab(n-1:n)

        IF(imeth==1) THEN
            CALL fit_line(a,b,xarr(1),yarr(1),xarr(2),yarr(2))
            y=a*x+b
        ELSE IF(imeth==2) THEN
            y=Lagrange_polynomial(x,1,xarr,yarr)
        ELSE
            ERROR STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE IF(iorder==1) THEN

        IF(n<2) ERROR STOP 'FIND: Not enough points in your table for linear interpolation'

        IF(x<=xtab(2)) THEN

            xarr(1:2) = xtab(1:2)
            yarr(1:2) = ytab(1:2)

        ELSE IF (x>=xtab(n-1)) THEN

            xarr(1:2) = xtab(n-1:n)
            yarr(1:2) = ytab(n-1:n)

        ELSE

            i=table_integer(x,xtab,n,ifind)

            xarr(1:2) = xtab(i:i+1)
            yarr(1:2) = ytab(i:i+1)

        END IF

        IF(imeth==1) THEN
            CALL fit_line(a,b,xarr(1),yarr(1),xarr(2),yarr(2))
            y=a*x+b
        ELSE IF(imeth==2) THEN
            y=Lagrange_polynomial(x,1,xarr,yarr)
        ELSE
            ERROR STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE IF(iorder==2) THEN

        IF(n<3) ERROR STOP 'FIND: Not enough points in your table'

        IF(x<=xtab(2) .OR. x>=xtab(n-1)) THEN

            IF(x<=xtab(2)) THEN

                xarr(1:3) = xtab(1:3)
                yarr(1:3) = ytab(1:3)

            ELSE IF (x>=xtab(n-1)) THEN

                xarr(1:3) = xtab(n-2:n)
                yarr(1:3) = ytab(n-2:n)

            END IF

            IF(imeth==1) THEN
                CALL fit_quadratic(a,b,c,xarr(1),yarr(1),xarr(2),yarr(2),xarr(3),yarr(3))
                y=a*(x**2)+b*x+c
            ELSE IF(imeth==2) THEN
                y=Lagrange_polynomial(x,2,xarr,yarr)
            ELSE
                ERROR STOP 'FIND: Error, method not specified correctly'
            END IF

        ELSE

            i=table_integer(x,xtab,n,ifind)

            xarr(1:4) = xtab(i-1:i+2)
            yarr(1:4) = ytab(i-1:i+2)

            IF(imeth==1) THEN
                !In this case take the average of two separate quadratic spline values
                CALL fit_quadratic(a,b,c,xarr(1),yarr(1),xarr(2),yarr(2),xarr(3),yarr(3))
                y=(a*x**2+b*x+c)/2.
                CALL fit_quadratic(a,b,c,xarr(2),yarr(2),xarr(3),yarr(3),xarr(4),yarr(4))
                y=y+(a*x**2+b*x+c)/2.
            ELSE IF(imeth==2) THEN
                !In this case take the average of two quadratic Lagrange polynomials
                y=(Lagrange_polynomial(x,2,xarr,yarr)+Lagrange_polynomial(x,2,xarr(2:),yarr(2:)))/2.
            ELSE
                ERROR STOP 'FIND: Error, method not specified correctly'
            END IF

        END IF

    ELSE IF(iorder==3) THEN

        IF(n<4) ERROR STOP 'FIND: Not enough points in your table'

        IF(x<=xtab(3)) THEN
            xarr(1:4) = xtab(1:4)
            yarr(1:4) = ytab(1:4)
        ELSE IF (x>=xtab(n-2)) THEN
            xarr(1:4) = xtab(n-3:n)
            yarr(1:4) = ytab(n-3:n)
        ELSE
            i=table_integer(x,xtab,n,ifind)

            xarr(1:4) = xtab(i-1:i+2)
            yarr(1:4) = ytab(i-1:i+2)
        END IF

        IF(imeth==1) THEN
            CALL fit_cubic(a,b,c,d,xarr(1),yarr(1),xarr(2),yarr(2),xarr(3),yarr(3),xarr(4),yarr(4))
            y=a*x**3+b*x**2+c*x+d
        ELSE IF(imeth==2) THEN
            y=Lagrange_polynomial(x,3,xarr,yarr)
        ELSE
            ERROR STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE

        ERROR STOP 'FIND: Error, interpolation order specified incorrectly'

    END IF

    END FUNCTION find

    FUNCTION table_integer(x,xtab,n,imeth)
    !Chooses between ways to find the integer location below some value in an array
    INTEGER :: table_integer
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(IN) :: x, xtab(n)
    INTEGER, INTENT(IN) :: imeth

    IF(x<xtab(1)) THEN
        table_integer=0
    ELSE IF(x>xtab(n)) THEN
        table_integer=n
    ELSE IF(imeth==1) THEN
        table_integer=linear_table_integer(x,xtab,n)
    ELSE IF(imeth==2) THEN
        table_integer=search_int(x,xtab,n)
    ELSE IF(imeth==3) THEN
        table_integer=int_split(x,xtab,n)
    ELSE
        ERROR STOP 'TABLE INTEGER: Method specified incorrectly'
    END IF

    END FUNCTION table_integer

    FUNCTION linear_table_integer(x,xtab,n)
    !Assuming the table is exactly linear this gives you the integer position
    INTEGER :: linear_table_integer
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(IN) :: x, xtab(n)
    REAL(dl) :: x1, xn

    x1=xtab(1)
    xn=xtab(n)
    linear_table_integer=1+FLOOR(float(n-1)*(x-x1)/(xn-x1))

    END FUNCTION linear_table_integer

    FUNCTION search_int(x,xtab,n)
    !Does a stupid search through the table from beginning to end to find integer
    INTEGER :: search_int
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(IN) :: x, xtab(n)
    INTEGER :: i

    IF(xtab(1)>xtab(n)) ERROR STOP 'SEARCH_INT: table in wrong order'

    DO i=1,n
        IF(x>=xtab(i) .AND. x<=xtab(i+1)) EXIT
    END DO

    search_int=i

    END FUNCTION search_int

    FUNCTION int_split(x,xtab,n)
    !Finds the position of the value in the table by continually splitting it in half
    INTEGER :: int_split
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(IN) :: x, xtab(n)
    INTEGER :: i1, i2, imid

    IF(xtab(1)>xtab(n)) ERROR STOP 'INT_SPLIT: table in wrong order'

    i1=1
    i2=n

    DO

        imid=NINT((i1+i2)/2.)

        IF(x<xtab(imid)) THEN
            i2=imid
        ELSE
            i1=imid
        END IF

        IF(i2==i1+1) EXIT

    END DO

    int_split=i1

    END FUNCTION int_split

    SUBROUTINE fit_line(a1,a0,x1,y1,x2,y2)
    !Given xi, yi i=1,2 fits a line between these points
    REAL(dl), INTENT(OUT) :: a0, a1
    REAL(dl), INTENT(IN) :: x1, y1, x2, y2

    a1=(y2-y1)/(x2-x1)
    a0=y1-a1*x1

    END SUBROUTINE fit_line

    SUBROUTINE fit_quadratic(a2,a1,a0,x1,y1,x2,y2,x3,y3)
    !Given xi, yi i=1,2,3 fits a quadratic between these points
    REAL(dl), INTENT(OUT) :: a0, a1, a2
    REAL(dl), INTENT(IN) :: x1, y1, x2, y2, x3, y3

    a2=((y2-y1)/(x2-x1)-(y3-y1)/(x3-x1))/(x2-x3)
    a1=(y2-y1)/(x2-x1)-a2*(x2+x1)
    a0=y1-a2*(x1**2)-a1*x1

    END SUBROUTINE fit_quadratic

    SUBROUTINE fit_cubic(a,b,c,d,x1,y1,x2,y2,x3,y3,x4,y4)
    !Given xi, yi i=1,2,3,4 fits a cubic between these points
    REAL(dl), INTENT(OUT) :: a, b, c, d
    REAL(dl), INTENT(IN) :: x1, y1, x2, y2, x3, y3, x4, y4
    REAL(dl) :: f1, f2, f3

    f1=(y4-y1)/((x4-x2)*(x4-x1)*(x4-x3))
    f2=(y3-y1)/((x3-x2)*(x3-x1)*(x4-x3))
    f3=(y2-y1)/((x2-x1)*(x4-x3))*(1./(x4-x2)-1./(x3-x2))

    a=f1-f2-f3

    f1=(y3-y1)/((x3-x2)*(x3-x1))
    f2=(y2-y1)/((x2-x1)*(x3-x2))
    f3=a*(x3+x2+x1)

    b=f1-f2-f3

    f1=(y4-y1)/(x4-x1)
    f2=a*(x4**2+x4*x1+x1**2)
    f3=b*(x4+x1)

    c=f1-f2-f3

    d=y1-a*x1**3-b*x1**2-c*x1

    END SUBROUTINE fit_cubic

    FUNCTION Lagrange_polynomial(x,n,xv,yv)
    !Computes the result of the nth order Lagrange polynomial at point x, L(x)
    REAL(dl) :: Lagrange_polynomial
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(IN) :: x, xv(n+1), yv(n+1)
    REAL(dl) :: l(n+1)
    INTEGER :: i, j
    real(dl) dx(n+1)

    if (n==3) then
        !Hard coded cubic for speed
        dx = x- xv
        Lagrange_polynomial =  &
            + dx(2)*dx(3)*dx(4)/(xv(1)-xv(2))/(xv(1)-xv(3))/(xv(1)-xv(4)) * yv(1) &
            + dx(1)*dx(3)*dx(4)/(xv(2)-xv(1))/(xv(2)-xv(3))/(xv(2)-xv(4)) * yv(2) &
            + dx(1)*dx(2)*dx(4)/(xv(3)-xv(1))/(xv(3)-xv(2))/(xv(3)-xv(4)) * yv(3) &
            + dx(1)*dx(2)*dx(3)/(xv(4)-xv(1))/(xv(4)-xv(2))/(xv(4)-xv(3)) * yv(4)
        return
    end if

    !Initialise variables, one for sum and one for multiplication
    Lagrange_polynomial=0
    l=1

    !Loops to find the polynomials, one is a sum and one is a multiple
    DO i=0,n
        DO j=0,n
            IF(i .NE. j) l(i+1)=l(i+1)*(x-xv(j+1))/(xv(i+1)-xv(j+1))
        END DO
        Lagrange_polynomial=Lagrange_polynomial+l(i+1)*yv(i+1)
    END DO

    END FUNCTION Lagrange_polynomial

    SUBROUTINE reverse(arry,n, output)
    !This reverses the contents of arry!
    INTEGER, INTENT(IN) :: n
    REAL(dl), INTENT(IN) :: arry(n)
    INTEGER :: i
    REAL(dl), ALLOCATABLE, intent(OUT) :: output(:)

    ALLOCATE(output(n))
    DO i=1,n
        output(i)=arry(n-i+1)
    END DO

    END SUBROUTINE reverse

    SUBROUTINE fill_growtab(cosm)
    !Fills a table of values of the scale-independent growth function
    TYPE(HM_cosmology) :: cosm
    INTEGER :: i
    REAL(dl) :: a
    REAL(dl), ALLOCATABLE :: d_tab(:), v_tab(:), a_tab(:)
    REAL(dl) :: dinit, vinit, zinit, f
    REAL(dl), PARAMETER :: aini=aini_growth_ODE
    REAL(dl), PARAMETER :: afin=afin_growth_ODE
    REAL(dl), PARAMETER :: amin=amin_growth_interpolation
    REAL(dl), PARAMETER :: amax=amax_growth_interpolation
    !REAL(dl), PARAMETER :: ainit=ainit_growth_interpolation
    !REAL(dl), PARAMETER :: amax=amax_growth_interpolation
    INTEGER, PARAMETER :: n=n_growth_interpolation
    REAL(dl), PARAMETER :: acc_ODE=acc_growth_ODE
    INTEGER, PARAMETER :: imeth_ODE=imeth_growth_ODE
    INTEGER, PARAMETER :: iorder_int=iorder_growth_ODE_interpolation
    INTEGER, PARAMETER :: ifind_int=ifind_growth_ODE_interpolation
    INTEGER, PARAMETER :: imeth_int=imeth_growth_ODE_interpolation
    INTEGER, PARAMETER :: iorder_agrow=iorder_integration_agrow

    !These set the initial conditions to be the Om_m=1. growing mode
    !AM Jul 19: changed initial conditions to be appropriate for massive neutrino cosmologies
    !AM Sep 20: changed initial conditions to assume neutrinos cluster, but changed to take into account EDE
    zinit = -1.+1./aini
    f = 1.-Omega_m_hm(zinit, cosm)
    dinit = aini**(1.-3.*f/5.)
    vinit = (1.-3.*f/5.)*aini**(-3.*f/5.)

    IF(HM_verbose) WRITE(*,*) 'GROWTH: Solving growth equation'
    CALL ode_growth(d_tab,v_tab,a_tab,aini,afin,dinit,vinit,acc_ODE,imeth_ODE,cosm)
    IF(HM_verbose) WRITE(*,*) 'GROWTH: ODE done'

    !Normalise so that g(z=0)=1
    cosm%gnorm=find(1.d0,a_tab,d_tab,SIZE(a_tab),iorder_int,ifind_int,imeth_int)
    IF(HM_verbose) WRITE(*,*) 'GROWTH: Unnormalised g(a=1):', cosm%gnorm
    d_tab=d_tab/cosm%gnorm

    !Could use some table-interpolation routine here to save time
    IF(ALLOCATED(cosm%a_growth)) DEALLOCATE(cosm%a_growth)
    IF(ALLOCATED(cosm%growth)) DEALLOCATE(cosm%growth)

    cosm%ng=n
    ALLOCATE(cosm%a_growth(n),cosm%growth(n))
    DO i=1,n
        a=amin+(amax-amin)*(i-1)/real(n-1,dl)
        cosm%a_growth(i)=a
        cosm%growth(i)=find(a,a_tab,d_tab,SIZE(a_tab),iorder_int,ifind_int,imeth_int)
    END DO

    ! Table integration to calculate G(a)=int_0^a g(a')/a' da'
    IF(ALLOCATED(cosm%agrow)) DEALLOCATE(cosm%agrow)
    ALLOCATE(cosm%agrow(n))

    ! Set to zero, because there is an x=x+y thing later on
    cosm%agrow = 0.
    DO i = 1, n
        ! Do the integral using the arrays
        IF (i > 1) THEN
            cosm%agrow(i) = inttab(cosm%a_growth, cosm%gnorm*cosm%growth/cosm%a_growth, 1, i, iorder_agrow)
        END IF
        ! Add missing section; g(a=0)/0 = 1, so you just add on a rectangle of height g*a/a=g
        cosm%agrow(i) = cosm%agrow(i)+cosm%gnorm*cosm%growth(1)
    END DO

    IF(HM_verbose) WRITE(*,*) 'GROWTH: Accumulated G(a=1):', cosm%agrow(n)
    IF(HM_verbose) WRITE(*,*) 'GROWTH: Done'
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE fill_growtab

    SUBROUTINE ode_growth(x,v,t,ti,tf,xi,vi,acc,imeth,cosm)
    !Solves 2nd order ODE x''(t) from ti to tf and writes out array of x, v, t values
    REAL(dl) :: xi, ti, tf, dt, acc, vi, x4, v4, t4
    REAL(dl) :: kx1, kx2, kx3, kx4, kv1, kv2, kv3, kv4
    REAL(dl), ALLOCATABLE :: x8(:), t8(:), v8(:), xh(:), th(:), vh(:)
    REAL(dl), ALLOCATABLE :: x(:), v(:), t(:)
    INTEGER :: i, j, k, n, np, ifail, kn, imeth
    TYPE(HM_cosmology) :: cosm
    INTEGER, PARAMETER :: jmax=30
    INTEGER, PARAMETER :: ninit=100

    !xi and vi are the initial values of x and v (i.e. x(ti), v(ti))
    !fx is what x' is equal to
    !fv is what v' is equal to
    !acc is the desired accuracy across the entire solution
    !imeth selects method

    IF(ALLOCATED(x)) DEALLOCATE(x)
    IF(ALLOCATED(v)) DEALLOCATE(v)
    IF(ALLOCATED(t)) DEALLOCATE(t)

    DO j=1,jmax

        !Set the number of points for the forward integration
        n=ninit*(2**(j-1))
        n=n+1

        !Allocate arrays
        ALLOCATE(x8(n),t8(n),v8(n))

        !Set the arrays to initialy be zeroes (is this neceseary?)
        x8=0.d0
        t8=0.d0
        v8=0.d0

        !Set the intial conditions at the intial time
        x8(1)=xi
        v8(1)=vi

        !Fill up a table for the time values
        CALL fill_table(ti,tf,t8,n)

        !Set the time interval
        dt=(tf-ti)/real(n-1,dl)

        !Intially fix this to zero. It will change to 1 if method is a 'failure'
        ifail=0

        DO i=1,n-1

            x4=real(x8(i))
            v4=real(v8(i))
            t4=real(t8(i))

            IF(imeth==1) THEN

                !Crude method
                kx1=dt*fd(v4)
                kv1=dt*fv(x4,v4,t4,cosm)

                x8(i+1)=x8(i)+kx1
                v8(i+1)=v8(i)+kv1

            ELSE IF(imeth==2) THEN

                !Mid-point method
                !2017/06/18 - There was a bug in this part before. Luckily it was not used. Thanks Dipak Munshi.
                kx1=dt*fd(v4)
                kv1=dt*fv(x4,v4,t4,cosm)
                kx2=dt*fd(v4+kv1/2.)
                kv2=dt*fv(x4+kx1/2.,v4+kv1/2.,t4+dt/2.,cosm)

                x8(i+1)=x8(i)+kx2
                v8(i+1)=v8(i)+kv2

            ELSE IF(imeth==3) THEN

                !4th order Runge-Kutta method (fast!)
                kx1=dt*fd(v4)
                kv1=dt*fv(x4,v4,t4,cosm)
                kx2=dt*fd(v4+kv1/2.)
                kv2=dt*fv(x4+kx1/2.,v4+kv1/2.,t4+dt/2.,cosm)
                kx3=dt*fd(v4+kv2/2.)
                kv3=dt*fv(x4+kx2/2.,v4+kv2/2.,t4+dt/2.,cosm)
                kx4=dt*fd(v4+kv3)
                kv4=dt*fv(x4+kx3,v4+kv3,t4+dt,cosm)

                x8(i+1)=x8(i)+(kx1+(2.*kx2)+(2.*kx3)+kx4)/6.
                v8(i+1)=v8(i)+(kv1+(2.*kv2)+(2.*kv3)+kv4)/6.

            END IF

        END DO

        IF(j==1) ifail=1

        IF(j .NE. 1) THEN

            np=1+(n-1)/2

            DO k=1,1+(n-1)/2

                kn=2*k-1

                IF(ifail==0) THEN

                    IF(xh(k)>acc .AND. x8(kn)>acc .AND. (ABS(xh(k)/x8(kn))-1.)>acc) ifail=1
                    IF(vh(k)>acc .AND. v8(kn)>acc .AND. (ABS(vh(k)/v8(kn))-1.)>acc) ifail=1

                    IF(ifail==1) THEN
                        DEALLOCATE(xh,th,vh)
                        EXIT
                    END IF

                END IF
            END DO

        END IF

        IF(ifail==0) THEN
            ALLOCATE(x(n),t(n),v(n))
            x=real(x8)
            v=real(v8)
            t=real(t8)
            EXIT
        END IF

        ALLOCATE(xh(n),th(n),vh(n))
        xh=x8
        vh=v8
        th=t8
        DEALLOCATE(x8,t8,v8)

    END DO

    END SUBROUTINE ode_growth

    FUNCTION fv(d,v,a,cosm)

    !v'=f(v) in ODE solver
    REAL(dl) :: fv
    REAL(dl), INTENT(IN) :: d, v, a
    REAL(dl) :: f1, f2, z, Om_m
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    z=-1.+(1./a)

    !AM Jul 19: changed Omega_m to Omega_cold for massive neutrino cosmologies
    IF (cold_growth) THEN
        Om_m = Omega_cold_hm(z,cosm)
    ELSE
        Om_m = Omega_m_hm(z,cosm)
    END IF
    f1=3.*Om_m*d/(2.*a**2.)
    f2=(2.+AH(z,cosm)/Hubble2(z,cosm))*(v/a)

    fv=f1-f2

    END FUNCTION fv

    FUNCTION fd(v)

    !d'=f(d) in ODE solver
    REAL(dl) :: fd
    REAL(dl), INTENT(IN) :: v

    fd=v

    END FUNCTION fd

    REAL(dl) FUNCTION dc_Mead(z, cosm)

    ! delta_c fitting function from Mead (2017; 1606.05345)
    IMPLICIT NONE
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: lg, bG, Om_m, a

    ! See Appendix A of Mead (2017) for naming convention
    REAL(dl), PARAMETER :: p10 = -0.0069
    REAL(dl), PARAMETER :: p11 = -0.0208
    REAL(dl), PARAMETER :: p12 = 0.0312
    REAL(dl), PARAMETER :: p13 = 0.0021
    INTEGER, PARAMETER :: a1 = 1
    REAL(dl), PARAMETER :: p20 = 0.0001
    REAL(dl), PARAMETER :: p21 = -0.0647
    REAL(dl), PARAMETER :: p22 = -0.0417
    REAL(dl), PARAMETER :: p23 = 0.0646
    INTEGER, PARAMETER :: a2 = 0
    REAL(dl), PARAMETER :: dc0 = (3./20.)*(12.*pi_HM)**(2./3.)

    IF (cold_growth) STOP 'DV_MEAD: Error, this will not work if you want cold growth'

    lg = ungrow(z, cosm)
    bG = acc_growth(z, cosm)
    Om_m = Omega_m_hm(z, cosm)
    a = 1./(1.+z)

    dc_Mead = 1.
    dc_Mead = dc_Mead+f_Mead(lg/a, bG/a, p10, p11, p12, p13)*log10(Om_m)**a1
    dc_Mead = dc_Mead+f_Mead(lg/a, bG/a, p20, p21, p22, p23)
    dc_Mead = dc_Mead*dc0*(1.-0.041*cosm%f_nu)

    END FUNCTION dc_Mead

    REAL(dl) FUNCTION Dv_Mead(z, cosm)

    ! Delta_v fitting function from Mead (2017; 1606.05345)
    IMPLICIT NONE
    REAL(dl), INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL(dl) :: lg, bG, Om_m, a

    ! See Appendix A of Mead (2017) for naming convention
    REAL(dl), PARAMETER :: p30 = -0.79
    REAL(dl), PARAMETER :: p31 = -10.17
    REAL(dl), PARAMETER :: p32 = 2.51
    REAL(dl), PARAMETER :: p33 = 6.51
    INTEGER, PARAMETER :: a3 = 1
    REAL(dl), PARAMETER :: p40 = -1.89
    REAL(dl), PARAMETER :: p41 = 0.38
    REAL(dl), PARAMETER :: p42 = 18.8
    REAL(dl), PARAMETER :: p43 = -15.87
    INTEGER, PARAMETER :: a4 = 2
    REAL(dl), PARAMETER :: Dv0 = 18.*pi_HM**2

    IF (cold_growth) STOP 'DV_MEAD: Error, this will not work if you want cold growth'

    lg = ungrow(z, cosm)
    bG = acc_growth(z, cosm)
    Om_m = Omega_m_hm(z, cosm)
    a = 1./(1.+z)

    Dv_Mead = 1.
    Dv_Mead = Dv_Mead+f_Mead(lg/a, bG/a, p30, p31, p32, p33)*log10(Om_m)**a3
    Dv_Mead = Dv_Mead+f_Mead(lg/a, bG/a, p40, p41, p42, p43)*log10(Om_m)**a4
    Dv_Mead = Dv_Mead*Dv0*(1.+0.763*cosm%f_nu)

    END FUNCTION Dv_Mead

    REAL(dl) FUNCTION f_Mead(x, y, p0, p1, p2, p3)

    ! Equation A3 in Mead (2017)
    IMPLICIT NONE
    REAL(dl), INTENT(IN) :: x, y
    REAL(dl), INTENT(IN) :: p0, p1, p2, p3

    f_Mead = p0+p1*(1.-x)+p2*(1.-x)**2+p3*(1.-y)

    END FUNCTION f_Mead

    !!AM End HMcode

    subroutine PKequal(State,redshift,w_lam,wa_ppf,w_hf,wa_hf)
    !used by halofit_casarini: arXiv:0810.0190, arXiv:1601.07230
    Type(CAMBdata) :: State
    real(dl) :: redshift,w_lam,wa_ppf,w_hf,wa_hf
    real(dl) :: z_star,tau_star,dlsb,dlsb_eq,w_true,wa_true,error

    z_star=State%ThermoDerivedParams( derived_zstar )
    tau_star=State%TimeOfz(z_star)
    dlsb=State%TimeOfz(redshift)-tau_star
    w_true=w_lam
    wa_true=wa_ppf
    wa_ppf=0._dl
    do
        z_star=State%ThermoDerivedParams( derived_zstar )
        tau_star=State%TimeOfz(State%ThermoData%z_star)
        dlsb_eq=State%TimeOfz(redshift)-tau_star
        error=1.d0-dlsb_eq/dlsb
        if (abs(error) <= 1d-7) exit
        w_lam=w_lam*(1+error)**10.d0
    enddo
    w_hf=w_lam
    wa_hf=0._dl
    w_lam=w_true
    wa_ppf=wa_true
    write(*,*)'at z = ',real(redshift),' equivalent w_const =', real(w_hf)

    end subroutine PKequal


    end module NonLinear

    !CAMB spherical and hyperspherical Bessel function routines
    !This version May 2006 - minor changes to bjl (http://cosmocoffee.info/viewtopic.php?t=530)
    !Feb 2007: fixed for high l, uses Ranges
    !Feb 2009: minor fix for non-flat compiled with non-smart IF evaluation
    !Dec 2011: minor tweak to DoRecurs for smoother errors across flat for L~O(30)
    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !Flat bessel function module

    module SpherBessels
    use Precision
    use results
    use RangeUtils
    use MpiUtils
    use splines
    implicit none
    private

    ! Bessel functions and their second derivatives for interpolation

    real(dl), dimension(:,:), allocatable ::  ajl, ajlpr, ddajlpr

    integer  num_xx, kmaxfile, max_ix
    Type(lSamples), save :: file_l
    ! parameters for working out where the flat Bessel functions are small
    ! Both should increase for higher accuracy
    ! real(dl), parameter :: xlimmin=15._dl  , xlimfrac = 0.05_dl
    real(dl), parameter :: xlimmin=35._dl  , xlimfrac = 0.05_dl
    real(dl) file_acc

    type(TRanges), save:: BessRanges

    public ajl, ajlpr, ddajlpr, BessRanges, InitSpherBessels, xlimmin, xlimfrac
    public USpherBesselWithDeriv, phi_recurs,phi_langer, bjl, Bessels_Free

    contains

    subroutine InitSpherBessels(lSamp, CP,max_bessels_l_index, max_bessels_etak)
    Type(lSamples) lSamp
    Type(CAMBParams) :: CP
    integer, intent(in) :: max_bessels_l_index
    real(dl), intent(in) :: max_bessels_etak

    !See if already loaded with enough (and correct) lSamp%l values and k*eta values
    if (lSamp%nl <= file_l%nl) then
        if (allocated(ajl) .and. all(file_l%l(1:lSamp%nl)==lSamp%l(1:lSamp%nl) .and. (max_bessels_l_index <= max_ix)) &
            .and. (int(min(max_bessels_etak,CP%Max_eta_k))+1 <= kmaxfile) &
            .and. (abs(CP%Accuracy%BesselBoost*CP%Accuracy%AccuracyBoost - file_acc) < 1d-2)) return
    end if

    !Haven't made them before, so make them now
    kmaxfile = int(min(CP%Max_eta_k,max_bessels_etak))+1
    max_ix = min(max_bessels_l_index,lSamp%nl)

    call GenerateBessels(lSamp, CP)

    if (DebugMsgs .and. FeedbackLevel > 0) write(*,*) 'Calculated Bessels'

    end subroutine InitSpherBessels

    subroutine GenerateBessels(lSamp, CP)
    Type(lSamples) lSamp
    Type(CAMBParams) :: CP
    real(dl) x
    real(dl) xlim
    integer i,j

    if (DebugMsgs .and. FeedbackLevel > 0) write (*,*) 'Generating flat Bessels...'

    file_l = lSamp
    if (do_bispectrum) kmaxfile = kmaxfile*2

    if (DebugMsgs .and. FeedbackLevel > 0) write (*,*) 'x_max bessels', kmaxfile

    call BessRanges%Init()

    call BessRanges%Add_delta(0._dl, 1._dl,0.01_dl/CP%Accuracy%BesselBoost)
    call BessRanges%Add_delta(1._dl, 5._dl,0.1_dl/CP%Accuracy%BesselBoost)
    call BessRanges%Add_delta(5._dl, 25._dl,0.2_dl/CP%Accuracy%BesselBoost)
    file_acc = CP%Accuracy%BesselBoost*CP%Accuracy%AccuracyBoost
    call BessRanges%Add_delta(25._dl, 150._dl,0.5_dl/file_acc)
    call BessRanges%Add_delta(150._dl, real(kmaxfile,dl),0.8_dl/file_acc)

    call BessRanges%GetArray(.false.)
    num_xx = BessRanges%npoints


    ! The three arrays are always (de-)allocated together. Therefore checking
    ! one of them for allocation is sufficient.
    if (.not. allocated(ajl) .or. any(ubound(ajl) < [num_xx, max_ix])) then
        if (allocated(ajl)) deallocate(ajl, ajlpr, ddajlpr)
        allocate(ajl(1:num_xx,1:max_ix), ajlpr(1:num_xx,1:max_ix), &
            ddajlpr(1:num_xx,1:max_ix))
    end if

    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), PRIVATE(i, x, xlim)
    do j=1,max_ix
        do  i=1,num_xx
            x=BessRanges%points(i)
            xlim=xlimfrac*lSamp%l(j)
            xlim=max(xlim,xlimmin)
            xlim=lSamp%l(j)-xlim
            if (x > xlim) then
                if ((lSamp%l(j)==3).and.(x <=0.2) .or. (lSamp%l(j) > 3).and.(x < 0.5) .or. &
                    (lSamp%l(j)>5).and.(x < 1.0)) then
                    ajl(i,j)=0
                else
                    !if ( lSamp%l(j) > 40000) then
                    ! ajl(i,j) = phi_langer(lSamp%l(j),0,1._dl,x)
                    !else
                    call bjl(lSamp%l(j),x,ajl(i,j))
                    !end if
                end if
            else
                ajl(i,j)=0
            end if
        end do

        !     get the interpolation matrix for bessel functions
        call spline_def(BessRanges%points,ajl(:,j),num_xx,ajlpr(:,j))
        call spline_def(BessRanges%points,ajlpr(:,j),num_xx,ddajlpr(:,j))
    end do
    !$OMP END PARALLEL DO

    end subroutine GenerateBessels

    subroutine Bessels_Free

    if (allocated(ajl)) deallocate(ajl)
    if (allocated(ajlpr)) deallocate(ajlpr)
    if (allocated(ddajlpr)) deallocate(ddajlpr)
    call BessRanges%Free()

    end  subroutine Bessels_Free


    SUBROUTINE BJL(L,X,JL)
    !!== MODIFIED SUBROUTINE FOR SPHERICAL BESSEL FUNCTIONS.                       ==!!
    !!== CORRECTED THE SMALL BUGS IN PACKAGE CMBFAST&CAMB(for l=4,5, x~0.001-0.002)==!!
    !!== CORRECTED THE SIGN OF J_L(X) FOR X<0 CASE                                 ==!!
    !!== WORKS FASTER AND MORE ACCURATE FOR LOW L, X<<L, AND L<<X cases            ==!!
    !!== zqhuang@astro.utoronto.ca                                                 ==!!
    IMPLICIT NONE
    INTEGER L
    real(dl) X,JL
    real(dl) AX,AX2
    real(dl),PARAMETER::LN2=0.6931471805599453094D0
    real(dl),PARAMETER::ONEMLN2=0.30685281944005469058277D0
    real(dl),PARAMETER::PID2=1.5707963267948966192313217D0
    real(dl),PARAMETER::PID4=0.78539816339744830961566084582D0
    real(dl),parameter::ROOTPI12 = 21.269446210866192327578D0
    real(dl),parameter::GAMMA1 =   2.6789385347077476336556D0 !/* Gamma function of 1/3 */
    real(dl),parameter::GAMMA2 =   1.3541179394264004169452D0 !/* Gamma function of 2/3 */
    real(dl),PARAMETER::PI=3.141592653589793238463D0
    real(dl) NU,NU2,BETA,BETA2,COSB
    real(dl) sx,sx2
    real(dl) cotb,cot3b,cot6b,secb,sec2b
    real(dl) trigarg,expterm,L3

    IF(L.LT.0)THEN
        error stop 'Can not evaluate Spherical Bessel Function with index l<0'
    ENDIF
    AX=DABS(X)
    AX2=AX**2
    IF(L.LT.7)THEN
        IF(L.EQ.0)THEN
            IF(AX.LT.1.D-1)THEN
                JL=1.D0-AX2/6.D0*(1.D0-AX2/20.D0)
            ELSE
                JL=DSIN(AX)/AX
            ENDIF

        ELSEIF(L.EQ.1)THEN
            IF(AX.LT.2.D-1)THEN
                JL=AX/3.D0*(1.D0-AX2/10.D0*(1.D0-AX2/28.D0))
            ELSE
                JL=(DSIN(AX)/AX-DCOS(AX))/AX
            ENDIF
        ELSEIF(L.EQ.2)THEN
            IF(AX.LT.3.D-1)THEN
                JL=AX2/15.D0*(1.D0-AX2/14.D0*(1.D0-AX2/36.D0))
            ELSE
                JL=(-3.0D0*DCOS(AX)/AX-DSIN(AX)*(1.D0-3.D0/AX2))/AX
            ENDIF
        ELSEIF(L.EQ.3)THEN
            IF(AX.LT.4.D-1)THEN
                JL=AX*AX2/105.D0*(1.D0-AX2/18.D0*(1.D0-AX2/44.D0))
            ELSE
                JL=(DCOS(AX)*(1.D0-15.D0/AX2)-DSIN(AX)*(6.D0-15.D0/AX2)/AX)/AX
            ENDIF
        ELSEIF(L.EQ.4)THEN
            IF(AX.LT.6.D-1)THEN
                JL=AX2**2/945.D0*(1.D0-AX2/22.D0*(1.D0-AX2/52.D0))
            ELSE
                JL=(DSIN(AX)*(1.D0-(45.D0-105.D0/AX2)/AX2)+DCOS(AX)*(10.D0-105.D0/AX2)/AX)/AX
            ENDIF
        ELSEIF(L.EQ.5)THEN
            IF(AX.LT.1.D0)THEN
                JL=AX2**2*AX/10395.D0*(1.D0-AX2/26.D0*(1.D0-AX2/60.D0))
            ELSE
                JL=(DSIN(AX)*(15.D0-(420.D0-945.D0/AX2)/AX2)/AX-DCOS(AX)*(1.D0-(105.D0-945.0d0/AX2)/AX2))/AX
            ENDIF
        ELSE
            IF(AX.LT.1.D0)THEN
                JL=AX2**3/135135.D0*(1.D0-AX2/30.D0*(1.D0-AX2/68.D0))
            ELSE
                JL=(DSIN(AX)*(-1.D0+(210.D0-(4725.D0-10395.D0/AX2)/AX2)/AX2)+ &
                    DCOS(AX)*(-21.D0+(1260.D0-10395.D0/AX2)/AX2)/AX)/AX
            ENDIF
        ENDIF
    ELSE
        NU=0.5D0+L
        NU2=NU**2
        IF(AX.LT.1.D-40)THEN
            JL=0.D0
        ELSEIF((AX2/L).LT.5.D-1)THEN
            JL=DEXP(L*DLOG(AX/NU)-LN2+NU*ONEMLN2-(1.D0-(1.D0-3.5D0/NU2)/NU2/30.D0)/12.D0/NU) &
                /NU*(1.D0-AX2/(4.D0*NU+4.D0)*(1.D0-AX2/(8.D0*NU+16.D0)*(1.D0-AX2/(12.D0*NU+36.D0))))
        ELSEIF((real(L,dl)**2/AX).LT.5.D-1)THEN
            BETA=AX-PID2*(L+1)
            JL=(DCOS(BETA)*(1.D0-(NU2-0.25D0)*(NU2-2.25D0)/8.D0/AX2*(1.D0-(NU2-6.25)*(NU2-12.25D0)/48.D0/AX2)) &
                -DSIN(BETA)*(NU2-0.25D0)/2.D0/AX* (1.D0-(NU2-2.25D0)*(NU2-6.25D0)/24.D0/AX2*(1.D0-(NU2-12.25)* &
                (NU2-20.25)/80.D0/AX2)) )/AX
        ELSE
            L3=NU**0.325
            IF(AX .LT. NU-1.31*L3) then
                COSB=NU/AX
                SX = DSQRT(NU2-AX2)
                COTB=NU/SX
                SECB=AX/NU
                BETA=DLOG(COSB+SX/AX)
                COT3B=COTB**3
                COT6B=COT3B**2
                SEC2B=SECB**2
                EXPTERM=( (2.D0+3.D0*SEC2B)*COT3B/24.D0 &
                    - ( (4.D0+SEC2B)*SEC2B*COT6B/16.D0 &
                    + ((16.D0-(1512.D0+(3654.D0+375.D0*SEC2B)*SEC2B)*SEC2B)*COT3B/5760.D0 &
                    + (32.D0+(288.D0+(232.D0+13.D0*SEC2B)*SEC2B)*SEC2B)*SEC2B*COT6B/128.D0/NU)*COT6B/NU) &
                    /NU)/NU
                JL=DSQRT(COTB*COSB)/(2.D0*NU)*DEXP(-NU*BETA+NU/COTB-EXPTERM)

                !          /**************** Region 2: x >> l ****************/

            ELSEIF (AX .GT. NU+1.48*L3) then
                COSB=NU/AX
                SX=DSQRT(AX2-NU2)
                COTB=NU/SX
                SECB=AX/NU
                BETA=DACOS(COSB)
                COT3B=COTB**3
                COT6B=COT3B**2
                SEC2B=SECB**2
                TRIGARG=NU/COTB-NU*BETA-PID4 &
                    -((2.0+3.0*SEC2B)*COT3B/24.D0  &
                    +(16.D0-(1512.D0+(3654.D0+375.D0*SEC2B)*SEC2B)*SEC2B)*COT3B*COT6B/5760.D0/NU2)/NU
                EXPTERM=( (4.D0+sec2b)*sec2b*cot6b/16.D0 &
                    -(32.D0+(288.D0+(232.D0+13.D0*SEC2B)*SEC2B)*SEC2B)*SEC2B*COT6B**2/128.D0/NU2)/NU2
                JL=DSQRT(COTB*COSB)/NU*DEXP(-EXPTERM)*DCOS(TRIGARG)

                !          /***************** Region 3: x near l ****************/

            ELSE
                BETA=AX-NU
                BETA2=BETA**2
                SX=6.D0/AX
                SX2=SX**2
                SECB=SX**0.3333333333333333d0
                SEC2B=SECB**2
                JL=( GAMMA1*SECB + BETA*GAMMA2*SEC2B &
                    -(BETA2/18.D0-1.D0/45.D0)*BETA*SX*SECB*GAMMA1 &
                    -((BETA2-1.D0)*BETA2/36.D0+1.D0/420.D0)*SX*SEC2B*GAMMA2   &
                    +(((BETA2/1620.D0-7.D0/3240.D0)*BETA2+1.D0/648.D0)*BETA2-1.D0/8100.D0)*SX2*SECB*GAMMA1 &
                    +(((BETA2/4536.D0-1.D0/810.D0)*BETA2+19.D0/11340.D0)*BETA2-13.D0/28350.D0)*BETA*SX2*SEC2B*GAMMA2 &
                    -((((BETA2/349920.D0-1.D0/29160.D0)*BETA2+71.D0/583200.D0)*BETA2-121.D0/874800.D0)* &
                    BETA2+7939.D0/224532000.D0)*BETA*SX2*SX*SECB*GAMMA1)*DSQRT(SX)/ROOTPI12
            ENDIF
        ENDIF
    ENDIF
    IF(X.LT.0.AND.MOD(L,2).NE.0)JL=-JL
    END SUBROUTINE BJL

    !    end module SpherBessels




    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !                                                                      c
    ! Calculation of ultraspherical Bessel functions.                      c
    ! Fortran version of the c program hyperjl.c by Arthur Kosowsky.       c
    ! WKB approx described in astro-ph/9805173                             c
    !                                                                      c
    ! Modifications by Anthony Challinor and Antony Lewis                  c
    ! Minor modifications to correct K=1 case outside [0,pi],              c
    ! the small chi approximations for lSamp%l=0 and lSamp%l=1, and                    c
    ! the quadratic approximation to Q(x) around Q(x)=0.                   c
    ! Bug fixed in downwards recursion (phi_recurs)                        c
    !                                                                      c
    ! The routine phi_recurs uses recursion relations to calculate         c
    ! the functions, which is accurate but relatively slow.                c
    !   ***NOT STABLE FOR K=1 or for all cases ***                         c
    !                                                                      c
    ! The routine phi_langer uses Langer's formula for a                   c
    ! uniform first-order asymptotic approximation in the open, closed     c
    ! and flat cases. This approximation is EXCELLENT for all lSamp%l >= 3.      c
    !                                                                      c
    ! The routine qintegral calculates the closed-form answer              c
    ! to the eikonal integral used in the WKB approximation.               c
    !                                                                      c
    ! The routine airy_ai returns the Airy function Ai(x) of the argument  c
    ! passed. It employs a Pade-type approximation away from zero and      c
    ! a Taylor expansion around zero. Highly accurate.                     c
    !                                                                      c
    ! The routines polevl and p1evl are auxiliary polynomial               c
    ! evaluation routines used in the airy function calculation.           c
    !                                                                      c
    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    subroutine USpherBesselWithDeriv(closed,CP,Chi,l,beta,y1,y2)
    !returns y1=ujl*sinhChi and y2=diff(y1,Chi)
    !aim for accuracy > 1% for all inputs
    real(dl) Chi,beta,y1,y2,sinhChi,cothChi
    real(dl) sin_K, cot_K
    integer l,K
    logical, intent(IN) :: closed
    Type(CAMBParams), intent(in) :: CP
    logical DoRecurs

    if (closed) then
        sin_K = sin(Chi)
        cot_K= 1._dl/tan(Chi)
        K=1
    else
        sin_K=sinh(Chi)
        cot_K = 1._dl/tanh(Chi)
        K=-1
    end if

    sinhChi = sin_K
    cothChi = cot_K

    DoRecurs = ((l<=45*CP%Accuracy%AccuracyBoost).OR.((.not.closed.or.(abs(Chi-const_pi/2)>0.2d0))&
        .and.(beta*l<750).or.closed.and.(beta*l<4000)))

    !Deep in the tails the closed recursion relation is not stable
    !Added July 2003 to prevent problems with very nearly flat models
    if (DoRecurs .and. closed) then
        if  (Chi < asin(sqrt(l*(l+1._dl))/beta) - 2/beta) then
            if (phi_langer(l,K,beta,Chi) < 1e-7) then
                call phi_small_closed_int(l,beta,chi,y1,y2)
                return
            end if
        end if
    end if

    if (DoRecurs) then
        !use recursive evaluation where WKB is poor and recurs is fast anyway.
        y1=phi_recurs(l,K,beta,Chi)*sinhChi
        y2=y1*(l+1)*cothChi
        if (.not.closed.or.(l+1<nint(beta))) y2=y2 - &
            sqrt(beta**2-(K*(l+1)**2))*phi_recurs(l+1,K,beta,Chi)*sinhChi
        !of course we could get y2 much more quickly by modifying
        !phi_recurs to return l and l+1 for each beta,Chi...


    else !WKB approx
        y1=phi_langer(l,K,beta,Chi)*sinhChi
        y2=y1*(l+1)*cothChi
        if (.not.closed.or.(l+1<nint(beta))) y2=y2 - &
            sqrt(beta**2-(K*(l+1)**2))*phi_langer(l+1,K,beta,Chi)*sinhChi

    end if

    end subroutine USpherBesselWithDeriv



    !Calculates y1,y2 (noramlized to a value near the turning point)
    !by integrating up the differential equation and normalizing to phi_recurs
    !in the region in which phi_recurs is stable
    !This allows closed functions to be computed where chi << turning point
    subroutine phi_small_closed_int(l,beta,chi,y1,y2)
    integer, intent(IN) :: l
    real(dl), intent(IN) :: beta, chi
    real(dl) y1,y2

    integer nsteps,i

    real(dl) ap1,nu2,dydchi1,dydchi2,yt1,yt2,dyt1,dyt2,dym1,dym2
    real(dl) x0, delchi,sh, h6,x
    real(dl) y1_x,y2_x, tmp,xh,hh

    nsteps = 200
    ap1 = l*(l+1)
    x0 = sqrt(ap1)/beta
    nu2 = beta**2

    if ((beta*chi)**2/l < 0.005) then
        !Series solution

        x = chi
        sh = sin(x)
        tmp=(ap1/sh**2 - nu2)
        y1=1e-20
        y2 = ((l+1)/x - (nu2-ap1/3)/(2*l+3)*x) * y1
    else

        x = max(1d-7,chi - 50._dl/l)
        y1=1e-20
        y2 = (l+1)*y1/x

        delchi = (chi-x)/nSteps
        h6=delchi/6
        hh=delchi/2
        sh = sin(x)
        tmp=(ap1/sh**2 - nu2)

        do i=1,nSteps
            ! One step in the ujl integration
            ! fourth-order Runge-Kutta method to integrate equation for ujl

            dydchi1=y2         !deriv y1
            dydchi2=tmp*y1     !deriv y2
            xh=x+hh          !midpoint of step
            yt1=y1+hh*dydchi1  !y1 at midpoint
            yt2=y2+hh*dydchi2  !y2 at midpoint
            dyt1=yt2           !deriv y1 at mid
            tmp=(ap1/sin(xh)**2 - nu2)


            dyt2=tmp*yt1       !deriv y2 at mid

            yt1=y1+hh*dyt1     !y1 at mid
            yt2=y2+hh*dyt2     !y2 at mid

            dym1=yt2           !deriv y1 at mid
            dym2=tmp*yt1       !deriv y2 at mid
            yt1=y1+delchi*dym1 !y1 at end
            dym1=dyt1+dym1
            yt2=y2+delchi*dym2 !y2 at end
            dym2=dyt2+dym2

            x=x+delchi     !end point
            sh=sin(x)
            dyt1=yt2           !deriv y1 at end
            tmp=(ap1/sh**2 - nu2)
            dyt2=tmp*yt1       !deriv y2 at end
            y1=y1+h6*(dydchi1+dyt1+2*dym1) !add up
            y2=y2+h6*(dydchi2+dyt2+2*dym2)
            if (y1 > 1d10 .or. y2> 1d10) then

                y1=y1/1d10
                y2=y2/1d10

            end if
        end do

    end if

    y1_x = y1; y2_x = y2

    delchi = (x0 - chi)/nSteps
    h6=delchi/6
    hh=delchi/2

    do i=1,nSteps
        ! One step in the ujl integration
        ! fourth-order Runge-Kutta method to integrate equation for ujl

        dydchi1=y2         !deriv y1
        dydchi2=tmp*y1     !deriv y2
        xh=x+hh          !midpoint of step
        yt1=y1+hh*dydchi1  !y1 at midpoint
        yt2=y2+hh*dydchi2  !y2 at midpoint
        dyt1=yt2           !deriv y1 at mid
        tmp=(ap1/sin(xh)**2 - nu2)


        dyt2=tmp*yt1       !deriv y2 at mid

        yt1=y1+hh*dyt1     !y1 at mid
        yt2=y2+hh*dyt2     !y2 at mid

        dym1=yt2           !deriv y1 at mid
        dym2=tmp*yt1       !deriv y2 at mid
        yt1=y1+delchi*dym1 !y1 at end
        dym1=dyt1+dym1
        yt2=y2+delchi*dym2 !y2 at end
        dym2=dyt2+dym2

        x=x+delchi     !end point
        sh=sin(x)
        dyt1=yt2           !deriv y1 at end
        tmp=(ap1/sh**2 - nu2)
        dyt2=tmp*yt1       !deriv y2 at end
        y1=y1+h6*(dydchi1+dyt1+2*dym1) !add up
        y2=y2+h6*(dydchi2+dyt2+2*dym2)
        if (y1 > 1d10 .or. y2 > 1d10) then
            y1=y1/1d10
            y2=y2/1d10
            y1_x = y1_x/1d10
            y2_x = y2_x/1d10

        end if
    end do


    tmp = phi_recurs(l,1,beta,x0)*sin(x0) / y1
    y1 = y1_x * tmp
    y2 = y2_x * tmp


    end subroutine phi_small_closed_int

    !***********************************************************************
    !                                                                      *
    ! Calculates Phi(l,beta,chi) using recursion on l.                     *
    ! See Abbot and Schaefer, ApJ 308, 546 (1986) for needed               *
    ! recursion relations and closed-form expressions for l=0,1.           *
    ! (Note: Their variable y is the same as chi here.)                    *
    !                                                                      *
    ! When the flag direction is negative, downwards recursion on l        *
    ! must be used because the upwards direction is unstable to roundoff   *
    ! errors. The downwards recursion begins with arbitrary values and     *
    ! continues downwards to l=1, where the desired l value is normalized  *
    ! using the closed form solution for l=1. (See, e.g., Numerical        *
    ! Recipes of Bessel functions for more detail)                         *
    !                                                                      *
    !***********************************************************************

    function phi_recurs(l, K, beta, chi)
    !doesn't like values which give exponentially small phi
    integer, intent(IN) :: l, K
    real(dl), intent(IN) :: beta, chi
    real(dl) phi_recurs
    integer j, direction, lstart,ibeta
    real(dl) ell, kay, arg, answer,beta2
    real(dl) root_K
    real(dl) phi0, phi1, phi_plus, phi_zero, phi_minus, b_zero, b_minus
    real(dl), parameter :: ACC=40._dl, BIG=1.d10
    real(dl) sin_K, cot_K

    ell=dble(l)


    ! Test input values

    if(l<0) call MpiStop("Bessel function index ell < 0")
    if(beta<0._dl) call MpiStop("Wavenumber beta < 0")
    if ((abs(K)/=1).and.(K/=0)) call MpiStop("K must be 1, 0 or -1")

    if(K==1) then
        ibeta=nint(beta)
        if(ibeta<3) call MpiStop("Wavenumber beta < 3 for K=1")
        if(ibeta<=l) call MpiStop("Wavenumber beta <= l")
    endif

    if (chi<1/BIG) then
        phi_recurs=0
        return
    end if

    kay = dble(K)
    arg = beta * chi
    beta2 = beta**2

    if(K == 0) then
        cot_K = 1._dl/chi
        sin_K = chi
        root_K = beta
    else
        root_K = sqrt(beta2 -kay*ell*ell)

        if(K == -1) then
            cot_K = 1._dl/tanh(chi)
            sin_K = sinh(chi)
        else
            cot_K = 1._dl/tan(chi)
            sin_K = sin(chi)
        end if

    endif


    ! Closed form solution for l=0

    if (abs(chi) < 1.d-4) then
        if (abs(arg)<1.d-4) then
            phi0 = 1._dl-chi**2*(beta*beta-kay)/6._dl
        else
            phi0=sin(arg)/arg
        end if
    else
        phi0 = sin(arg) / (beta * sin_K)
    end if

    if (l==0) then
        phi_recurs=phi0
        return
    end if


    ! Closed form solution for l=1

    if((abs(chi) < 1.d-4).and.(K/=0)) then
        if(arg < 1.d-4) then
            phi1 = chi*sqrt(beta*beta-kay)/3._dl
            !beta2 * chi / (3._dl * sqrt(1._dl+ kay * beta2))
        else
            phi1 = (sin(arg)/arg-cos(arg))/(sqrt(beta*beta-kay)*chi)
            !(sin(arg)/arg - cos(arg))/arg
        end if
    elseif ((abs(arg) < 1.d-4).and.(K == 0)) then
        phi1 = arg / 3._dl
    else
        if (K /= 0 ) then
            phi1 = sin(arg) * cot_K / (beta * sin_K) - cos(arg) / sin_K
            phi1 = phi1/sqrt(beta2 - kay)
        else
            phi1 = (sin(arg)/arg - cos(arg))/arg
        end if
    end if
    if(l==1) then
        phi_recurs=phi1
        return
    end if
    ! Find recursion direction
    !  direction = +1 for upward recursion, -1 for downward

    if(abs(cot_K) < root_K / ell) then
        direction = 1
    else
        direction = -1
    end if

    ! For K=1, must do upwards recursion:
    ! NOT STABLE for all values of chi

    if(K==1) direction = 1

    ! Do upwards recursion on l


    if(direction == 1)then
        b_minus = sqrt(beta2 - kay)
        phi_minus = phi0
        phi_zero = phi1

        do j=2,l

            if(K == 0) then
                phi_plus = ((2*j-1) * cot_K * phi_zero - beta*phi_minus)/ beta
            else
                b_zero = sqrt(beta2 - (K*j*j))
                phi_plus = ((2*j-1) * cot_K * phi_zero - b_minus * phi_minus) / b_zero
                b_minus = b_zero
            end if
            phi_minus = phi_zero
            phi_zero = phi_plus
        end do


        phi_recurs=phi_plus


        return

        ! Do downwards recursion on l

    else
        lstart = l + 2 * int(sqrt(ell*ACC))

        b_zero = sqrt(beta2 - dble(K*lstart*lstart))
        phi_plus = 0._dl
        phi_zero = 1._dl
        answer = 0._dl

        do j= lstart - 2,1,-1

            if(K == 0) then
                phi_minus = ((2*j + 3) * cot_K * phi_zero - beta * phi_plus) / beta
            else
                b_minus = sqrt(beta2 - (K*(j+1)**2))
                phi_minus = ((2*j + 3) * cot_K * phi_zero - b_zero * phi_plus) / b_minus
                b_zero = b_minus
            end if
            phi_plus = phi_zero
            phi_zero = phi_minus

            if(j == l) answer = phi_minus
            if((abs(phi_zero) > BIG).and.(j/=1)) then
                phi_plus = phi_plus/BIG
                phi_zero = phi_zero/BIG
                answer = answer/BIG
            end if
        end do

        ! Normalize answer to previously computed phi1

        answer = answer*phi1 / phi_minus
        phi_recurs=answer

    end if

    end function phi_recurs


    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !                                                                      c
    ! Calculates Phi(l,beta,chi) using the Langer uniform approximation    c
    ! to the first-order WKB approximation.                                c
    ! See C.M. Bender and S.A. Orszag,  Mathematical Methods for           c
    ! Scientists and Engineers (McGraw-Hill, 1978; LC QA371.B43),          c
    ! chapter 10.                                                          c
    !                                                                      c
    ! Differential equation for needed function can be cast into the       c
    ! Schrodinger form      \epsilon^2 y'' = Q(x) y                        c
    ! where \epsilon^2 = 1/l(l+1) and Q(x) depends on the parameter        c
    ! alpha \equiv beta * epsilon.                                         c
    !                                                                      c
    ! In the K= +1 case, the function is                                   c
    ! determined by its value on the interval [0, pi/2] and the symmetry   c
    ! conditions Phi(chi + pi) = (-1)^{beta - l - 1} Phi(chi),             c
    !            Phi(pi - chi) = (-1)^{beta - l - 1} Phi(chi).             c
    ! This interval contains one turning point, so the Langer formula      c
    ! can be used.                                                         c
    ! Note that the second condition at chi = pi/2 gives an eigenvalue     c
    ! condition on beta, which  must corrected. For the lowest             c
    ! eigenvalue(s), the region between the turning points is not large    c
    ! enough for the asymptotic solution to be valid, so the functions     c
    ! have a small discontinuity or discontinuous derivative at pi/2;      c
    ! this behavior is corrected by employing a 4-term asymptotic          c
    ! series around the regular point chi=pi/2.                            c
    ! The exact eigenvalue condition requires that beta must be an         c
    ! integer >= 3 with beta > l. Note this implies alpha > 1.             c
    !                                                                      c
    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



    function phi_langer(l,K,beta,chi)
    integer l,K,ibeta,kay
    real(dl) phi_langer
    real(dl) ell,symm, anu, alpha2
    real(dl) beta,chi,eikonal, wkb, arg, arg2, tmp
    real(dl) epsilon, alpha, chi0, x, a, b,achi

    real(dl) cot_K, sin_K
    real(dl), parameter :: PI=3.1415926536d0,ROOTPI=1.772453851d0,ROOT2PI=2.506628275d0, &
        PIOVER2=1.570796327d0

    ell=dble(l)
    achi=chi

    symm=1._dl
    !
    ! Test input values
    !
    if(l<0) call MpiStop("Bessel function index ell < 0")
    if(beta<0._dl) call MpiStop("Wavenumber beta < 0")
    if ((abs(K)/=1).and.(K/=0)) call MpiStop("K must be 1, 0 or -1")


    if(K == 1) then
        ibeta=nint(beta)
        if(ibeta<3) call MpiStop("Wavenumber beta < 3 for K=1")
        if(ibeta<=l) call MpiStop("Wavenumber beta <= l")
    endif

    kay=K


    ! For closed case, find equivalent chi in [0,pi/2]
    !
    if(K==1) then
        achi=achi-2._dl*Pi*int(achi/2._dl/PI)
        if(achi>PI) then
            achi=2._dl*PI-achi
            if(2*(l/2).eq.l) then
                symm=symm
            else
                symm=-symm
            endif
        endif
        if(achi>PI/2._dl) then
            achi=PI-achi
            if(2*((ibeta-l-1)/2).eq.(ibeta-l-1)) then
                symm=symm
            else
                symm=-symm
            endif
        endif
    endif

    ! Definitions
    if(K == 0) then
        sin_K = achi
    else
        if(K == -1) then
            sin_K = sinh(achi)
        else
            sin_K = sin(achi)
        end if
    endif

    ! Closed form solution for l=0
    !
    if(l == 0) then
        arg=beta*achi

        if((abs(achi)<1.d-4).and.(K/=0)) then
            if(abs(arg)<1.d-4) then
                wkb=1._dl-achi*achi*(beta*beta-kay)/6._dl
            else
                wkb=sin(arg)/arg
            endif
        else if((abs(arg)<1.d-4).and.(K==0)) then
            wkb=1._dl-arg*arg/6._dl
        else
            wkb=sin(arg)/(beta*sin_K)
        endif
        phi_langer=symm*wkb
        return
    endif
    !
    ! Closed form solution for l=1
    !
    if(l==1) then
        arg=beta*achi

        if((abs(achi)<1.d-4).and.(K/=0)) then
            if(abs(arg)<1.d-4) then
                wkb=achi*sqrt(beta*beta-kay)/3._dl
            else
                wkb=(sin(arg)/arg-cos(arg))/(sqrt(beta*beta-kay)*achi)
            endif
        else if((abs(arg)<1.d-4).and.(K==0)) then
            wkb=arg/3._dl
        else
            if(K/=0) then
                if(K==1) then
                    cot_K=1._dl/tan(achi)
                else
                    cot_K=1._dl/tanh(achi)
                endif
                wkb=sin(arg)*cot_K/(beta*sin_K)-cos(arg)/sin_K
                wkb=wkb/sqrt(beta*beta-kay)
            else
                wkb=(sin(arg)/arg-cos(arg))/arg
            endif
        end if
        phi_langer=symm*wkb
        return
    endif
    !
    ! Closed form solution for K=1 and beta = l+1 (lowest eigenfunction)
    !
    if((K==1).and.(ibeta == (l+1))) then
        wkb=(sin_K**ell)* &
            sqrt(sqrt(2._dl*PI/(2._dl*ell+1._dl))*ell/((ell+1._dl)*(2._dl*ell+1._dl)))
        wkb=wkb*(1+0.1875d0/ell-0.013671875/(ell*ell))
        phi_langer=symm*wkb
        return
    endif

    ! Very close to 0, return 0 (exponentially damped)
    !
    if(abs(achi)<1.d-8) then
        phi_langer=0._dl
        return
    endif


    ! For closed case, find corrected eigenvalue beta
    !
    if(K==1) then
        anu=dble(ibeta)-1._dl/(8._dl*ell)+1._dl/(16._dl*ell*ell)
    else
        anu=beta
    endif
    !
    ! Evaluate epsilon using asymptotic form for large l
    !
    if(l<20) then
        epsilon=1._dl/sqrt(ell*(ell+1._dl))
    else
        epsilon=1._dl/ell-0.5d0/(ell*ell)+0.375d0/(ell*ell*ell)
    endif

    alpha=epsilon*anu
    !
    ! Calculate the turning point where Q(x)=0.
    ! Function in question has only a single simple turning point.
    !
    if(K==-1) chi0=log((1._dl+sqrt(1._dl+alpha*alpha))/alpha)
    if(K==0) chi0=1._dl/alpha
    if(K==1) chi0=asin(1._dl/alpha)


    ! Very close to chi0, use usual wkb form to avoid dividing by zero
    !
    if(abs(achi-chi0)<1.d-5) then

        ! Calculate coefficients of linear and quadratic terms in Q(x) expansion
        ! in the neighborhood of the turning point
        ! Q(chi)=a*(chi0-chi)+b*(chi0-chi)**2
        alpha2=alpha*alpha

        if(K==-1) then
            a=2._dl*alpha2*sqrt(alpha2+1._dl)
            b=3._dl*alpha2**2+2._dl*alpha2
        endif
        if(K==0) then
            a=2._dl*alpha2*alpha
            b=3._dl*alpha2**2
        endif
        if(K==1) then
            a=2._dl*alpha2*sqrt(alpha2-1._dl)
            b=3._dl*alpha2**2-2._dl*alpha2
        endif

        ! Dependent variable x for which Q(x)=0 at x=0
        ! x>0 is the evanescent region
        !
        x=chi0-achi
        !
        ! Argument of Airy function
        !
        arg=(x+b*x*x/(5._dl*a))/(epsilon*epsilon/a)**(0.333333333d0)
        !
        ! Evaluate Airy function
        !
        wkb=airy_ai(arg)
        !
        ! Rest of functional dependence
        !
        wkb=wkb*(1._dl-b*x/(5._dl*a))/sin_K
        !  Normalization factor:

        wkb=wkb*symm*ROOTPI*((a*epsilon)**(-0.1666667d0))*sqrt(epsilon/anu)
        phi_langer=wkb

        return
    endif


    ! Langer approximation.
    !
    ! Transport factor:
    !
    tmp=sqrt(abs(1._dl/(sin_K*sin_K)-alpha*alpha))

    ! Eikonal factor
    !
    eikonal=qintegral(sin_K,alpha,K)



    arg=(1.5d0*eikonal/epsilon)**(1._dl/3._dl)

    arg2=arg*arg
    if(achi>chi0) arg2=-arg2

    ! Multiply factors together

    wkb=airy_ai(arg2)*symm*ROOTPI*sqrt(arg*epsilon/anu/tmp)/Sin_K
    phi_langer=wkb

    end function phi_langer

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !                                                                       c
    ! Evaluates the exact solution to  the integral giving the WKB          c
    ! eikonal solution,   \int^x sqrt(abs(Q(x))) dx                         c
    !                                                                       c
    ! In the open case, this integral costs 1 or 2 square roots, an atan    c
    ! and a log; its evaluation will be roughly as expensive as the rest    c
    ! of the Phi routine. An analytic fit cannot be substantially faster    c
    ! because the dependence on alpha of the y-intercept of the linear      c
    ! region of the integrand contains a log and an atan, so at best a fit  c
    ! can only save the computation of the square roots.                    c
    !                                                                       c
    ! The integrals are very bland functions of chi and alpha and could     c
    ! be precomputed and cached to save computation time; interpolation     c
    ! on a relatively small number of points should be very accurate        c
    !                                                                       c
    ! Note that for the closed case, the variable arg must be between 0     c
    ! and alpha; for arg > alpha, symmetry properties reduce the needed     c
    ! integral to this case.                                                c
    !                                                                       c
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    function qintegral(sin_K,alpha, K)
    implicit none
    real(dl) qintegral, sin_K
    integer K
    real(dl) alpha,exact,arg, root1, root2, dummyarg

    real(dl), parameter :: PI=3.1415926536d0,ROOTPI=1.772453851d0,ROOT2PI=2.506628275d0, &
        PIOVER2=1.570796327d0

    arg=alpha*sin_K

    if(K==0) then
        if(arg>1._dl) then
            exact=sqrt(arg*arg-1._dl)-acos(1._dl/arg)
            qintegral=exact
            return
        else
            root1=sqrt(1._dl-arg*arg)
            exact=log((1._dl+root1)/arg)-root1
            qintegral=exact
            return
        endif
    else if(K==-1) then
        if(arg>1._dl) then
            root1=sqrt(arg*arg-1._dl)
            root2=sqrt(arg*arg+alpha*alpha)
            exact=alpha/2._dl*log((2._dl*arg*arg+alpha*alpha-1._dl+ &
                2._dl*root1*root2)/(1._dl+alpha*alpha))+atan(root2/ &
                (alpha*root1))-PIOVER2
            qintegral=exact
            return
        else
            root1=sqrt((1._dl-arg*arg)*(arg*arg+alpha*alpha))
            exact=alpha/2._dl*atan(-2._dl*root1/(2*arg*arg+alpha*alpha- &
                1._dl))+0.5d0*log((2._dl*alpha*root1+2._dl*alpha*alpha+ &
                arg*arg*(1._dl-alpha*alpha))/(arg*arg*(1._dl+ &
                alpha*alpha)))
            if(2._dl*arg*arg+alpha*alpha-1._dl<0._dl) then
                exact=exact-alpha*PIOVER2
            endif
            qintegral=exact
            return
        endif
    else
        if(arg>1._dl) then
            root1=sqrt(arg*arg-1._dl)
            root2=sqrt(alpha*alpha-arg*arg)
            exact=alpha/2._dl*atan(-2._dl*root1*root2/ &
                (2._dl*arg*arg-alpha*alpha-1._dl))- &
                atan(-root2/(root1*alpha))-PIOVER2
            if(2._dl*arg*arg-alpha*alpha-1._dl>0._dl) then
                exact=exact+alpha*PIOVER2
            endif
        else
            root1=sqrt((1._dl-arg*arg)*(alpha*alpha-arg*arg))
            dummyarg=alpha*(1._dl-arg*arg)/root1
            exact=0.5d0*log((1._dl+dummyarg)/(1._dl-dummyarg))- &
                alpha/2._dl*log((alpha*alpha-2._dl*arg*arg+1._dl+2._dl*root1)/ &
                (alpha*alpha-1._dl))
        endif
        qintegral=exact
        return
    endif

    end function qintegral

    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !                                                                      c
    !       Airy function                                                  c
    !                                                                      c
    ! Modified from original routine by Stephen Moshier, available         c
    ! as part of the Cephes library at www.netlib.com                      c
    ! Modifications: eliminates calculation of Bi(x), Ai'(x), Bi'(x)       c
    ! and translation to Fortran                                           c
    !                                                                      c
    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !
    ! DESCRIPTION:
    !
    ! Solution of the differential equation
    !
    !       y"(x) = xy.
    !
    ! The function returns the two independent solutions Ai, Bi
    ! and their first derivatives Ai'(x), Bi'(x).
    !
    ! Evaluation is by power series summation for small x,
    ! by rational minimax approximations for large x.
    !
    !
    !
    ! ACCURACY:
    ! Error criterion is absolute when function <= 1, relative
    ! when function > 1, except * denotes relative error criterion.
    ! For large negative x, the absolute error increases as x^1.5.
    ! For large positive x, the relative error increases as x^1.5.
    !
    ! Arithmetic  domain   function  # trials      peak         rms
    ! IEEE        -10, 0     Ai        10000       1.6e-15     2.7e-16
    ! IEEE          0, 10    Ai        10000       2.3e-14*    1.8e-15*
    ! IEEE        -10, 0     Ai'       10000       4.6e-15     7.6e-16
    ! IEEE          0, 10    Ai'       10000       1.8e-14*    1.5e-15*
    ! IEEE        -10, 10    Bi        30000       4.2e-15     5.3e-16
    ! IEEE        -10, 10    Bi'       30000       4.9e-15     7.3e-16
    ! DEC         -10, 0     Ai         5000       1.7e-16     2.8e-17
    ! DEC           0, 10    Ai         5000       2.1e-15*    1.7e-16*
    ! DEC         -10, 0     Ai'        5000       4.7e-16     7.8e-17
    ! DEC           0, 10    Ai'       12000       1.8e-15*    1.5e-16*
    ! DEC         -10, 10    Bi        10000       5.5e-16     6.8e-17
    ! DEC         -10, 10    Bi'        7000       5.3e-16     8.7e-17
    !
    !
    ! Cephes Math Library Release 2.1:  January, 1989
    ! Copyright 1984, 1987, 1989 by Stephen lSamp%l. Moshier
    ! Direct inquiries to 30 Frost Street, Cambridge, MA 02140
    !

    function airy_ai(x)
    implicit none
    real(dl) airy_ai
    real(dl) x,z, zz, t, f, g, uf, ug, zeta, theta
    real(dl) ak
    real(dl) AN(8),AD(8),AFN(9),AFD(9),AGN(11),AGD(10)
    real(dl), parameter :: AMAXAIRY=25.77d0,ACC=1.d-8,PI=3.1415926536d0
    real(dl), parameter :: c1=0.35502805388781723926d0, c2=0.258819403792806798405d0
    real(dl), parameter :: sqrt3=1.732050807568877293527d0,sqpii=5.64189583547756286948d-1


    AN(1)=3.46538101525629032477d-1
    AN(2)=1.20075952739645805542d1
    AN(3)=7.62796053615234516538d1
    AN(4)=1.68089224934630576269d2
    AN(5)=1.59756391350164413639d2
    AN(6)=7.05360906840444183113d1
    AN(7)=1.40264691163389668864d1
    AN(8)=9.99999999999999995305d-1

    AD(1)=5.67594532638770212846d-1
    AD(2)=1.47562562584847203173d1
    AD(3)=8.45138970141474626562d1
    AD(4)=1.77318088145400459522d2
    AD(5)=1.64234692871529701831d2
    AD(6)=7.14778400825575695274d1
    AD(7)=1.40959135607834029598d1
    AD(8)=1.00000000000000000470d0

    AFN(1)=-1.31696323418331795333d-1
    AFN(2)=-6.26456544431912369773d-1
    AFN(3)=-6.93158036036933542233d-1
    AFN(4)=-2.79779981545119124951d-1
    AFN(5)=-4.91900132609500318020d-2
    AFN(6)=-4.06265923594885404393d-3
    AFN(7)=-1.59276496239262096340d-4
    AFN(8)=-2.77649108155232920844d-6
    AFN(9)=-1.67787698489114633780d-8

    AFD(1)=1.33560420706553243746d1
    AFD(2)=3.26825032795224613948d1
    AFD(3)=2.67367040941499554804d1
    AFD(4)=9.18707402907259625840d0
    AFD(5)=1.47529146771666414581d0
    AFD(6)=1.15687173795188044134d-1
    AFD(7)=4.40291641615211203805d-3
    AFD(8)=7.54720348287414296618d-5
    AFD(9)=4.51850092970580378464d-7

    AGN(1)=1.97339932091685679179d-2
    AGN(2)=3.91103029615688277255d-1
    AGN(3)=1.06579897599595591108d0
    AGN(4)=9.39169229816650230044d-1
    AGN(5)=3.51465656105547619242d-1
    AGN(6)=6.33888919628925490927d-2
    AGN(7)=5.85804113048388458567d-3
    AGN(8)=2.82851600836737019778d-4
    AGN(9)=6.98793669997260967291d-6
    AGN(10)=8.11789239554389293311d-8
    AGN(11)=3.41551784765923618484d-10

    AGD(1)=9.30892908077441974853d0
    AGD(2)=1.98352928718312140417d1
    AGD(3)=1.55646628932864612953d1
    AGD(4)=5.47686069422975497931d0
    AGD(5)=9.54293611618961883998d-1
    AGD(6)=8.64580826352392193095d-2
    AGD(7)=4.12656523824222607191d-3
    AGD(8)=1.01259085116509135510d-4
    AGD(9)=1.17166733214413521882d-6
    AGD(10)=4.91834570062930015649d-9
    !
    ! Exponentially tiny for large enough argument
    !
    if(x>AMAXAIRY) then
        airy_ai=0._dl
        return
    endif
    !
    ! Pade fit for large negative arguments
    !
    if(x<-2.09d0) then
        t=sqrt(-x)
        zeta=-2._dl*x*t/3._dl
        t=sqrt(t)
        ak=sqpii/t
        z=1._dl/zeta
        zz=z*z
        uf=1._dl+zz*polevl(zz,AFN,8)/p1evl(zz,AFD,9)
        ug=z*polevl(zz,AGN,10)/p1evl(zz,AGD,10)
        theta=zeta+0.25d0*PI
        f=sin(theta)
        g=cos(theta)
        airy_ai=ak*(f*uf-g*ug)
        return
    endif
    !
    ! Pade fit for large positive arguments
    !
    if(x>=2.09) then
        t=sqrt(x)
        zeta=2._dl*x*t/3._dl
        g=exp(zeta)
        t=sqrt(t)
        ak=2._dl*t*g
        z=1._dl/zeta
        f=polevl(z,AN,7)/polevl(z,AD,7)
        airy_ai=sqpii*f/ak
        return
    endif
    !
    ! Taylor series for region around x=0
    !

    f=1._dl
    g=x
    t=1._dl
    uf=1._dl
    ug=x
    ak=1._dl
    z=x*x*x
    do while (t>ACC)
        uf=uf*z
        ak=ak+1._dl
        uf=uf/ak
        ug=ug*z
        ak=ak+1._dl
        ug=ug/ak
        uf=uf/ak
        f=f+uf
        ak=ak+1._dl
        ug=ug/ak
        g=g+ug
        t=abs(uf/f)
    end do


    airy_ai=c1*f-c2*g

    end function airy_ai

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !  Evaluate polynomial                                          c
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    ! DESCRIPTION:
    !
    ! Evaluates polynomial of degree N:
    !
    !                     2          N
    ! y  =  C  + C x + C x  +...+ C x
    !        0    1     2          N
    !
    ! Coefficients are stored in reverse order:
    !
    ! coef(1) = C  , ..., coef(N+1) = C  .
    !            N                     0
    !
    ! The function p1evl() assumes that C = 1.0 and is
    !                                    N
    ! omitted from the array.  Its calling arguments are
    ! otherwise the same as polevl().
    !
    !
    ! SPEED:
    !
    ! In the interest of speed, there are no checks for out
    ! of bounds arithmetic.  This routine is used by most of
    ! the functions in the library.  Depending on available
    ! equipment features, the user may wish to rewrite the
    ! program in microcode or assembly language.
    !
    ! Cephes Math Library Release 2.1:  December, 1988
    ! Copyright 1984, 1987, 1988 by Stephen lSamp%l. Moshier
    ! Direct inquiries to 30 Frost Street, Cambridge, MA 02140
    !
    function polevl(x,coef,N)
    implicit none
    real(dl) polevl
    real(dl) x,ans
    real(dl) coef
    integer N,i

    dimension coef(N+1)

    ans=coef(1)
    do i=2,N+1
        ans=ans*x+coef(i)
    end do
    polevl=ans

    end function polevl

    !
    !
    ! Evaluate polynomial when coefficient of x  is 1.0.
    ! Otherwise same as polevl.
    !
    function p1evl(x,coef,N)
    implicit none
    real(dl) p1evl
    real(dl) x,coef,ans
    integer N,i
    dimension coef(N)

    ans=x+coef(1)
    do i=2,N
        ans=ans*x+coef(i)
    end do
    p1evl=ans

    end function p1evl



    end module SpherBessels !USpherBessels



    SUBROUTINE BJL_EXTERNAL(L,X,JL)
    use SpherBessels
    use Precision
    !!== MODIFIED SUBROUTINE FOR SPHERICAL BESSEL FUNCTIONS.                       ==!!
    !!== CORRECTED THE SMALL BUGS IN PACKAGE CMBFAST&CAMB(for l=4,5, x~0.001-0.002)==!!
    !!== CORRECTED THE SIGN OF J_L(X) FOR X<0 CASE                                 ==!!
    !!== WORKS FASTER AND MORE ACCURATE FOR LOW L, X<<L, AND L<<X cases            ==!!
    !!== zqhuang@astro.utoronto.ca                                                 ==!!
    IMPLICIT NONE
    INTEGER L
    real(dl) X,JL

    call BJL(L,X,JL)

    END SUBROUTINE BJL_EXTERNAL

    !---------------------------------------------------------------------------------------------------
    ! Recombination module for CAMB, using CosmoRec
    ! Author: Richard Shaw (CITA)
    !
    ! To use with the python wrapper add -fPIC to CCFLAGS in the CosmoRec Makefile (for gcc)
    !---------------------------------------------------------------------------------------------------
    ! 08.06.2012: added possibility to communicate Hubble (Jens Chluba)
    ! 12.06.2012: AL, changed interface to pass nnu directly; fixed spline extrapolation
    ! 09.01.2019: AL, updated for new class structure

    module CosmoRec
    use precision
    use constants
    use classes
    use MathUtils
    use results
    use config
    use Interpolation
    use MpiUtils, only : MpiStop
    implicit none
    private

    integer, parameter :: Nz = 10000
    real(dl), parameter :: zmax = 1d4
    real(dl), parameter :: zmin = 0._dl

    type, extends(TRecombinationModel) :: TCosmoRec

        integer :: runmode = 0
        real(dl) :: fdm  = 0._dl ! Dark matter annihilation efficiency

        ! Internal accuracy of CosmoRec (0 - normal, 3 - most accurate
        ! other values defined in CosmoRec.cpp source file)
        real(dl) :: accuracy = 0._dl
        !Internal data
        class(TRegularCubicSpline), allocatable :: xrec, tmrec
    contains
    procedure :: ReadParams => TCosmoRec_ReadParams
    procedure :: Validate => TCosmoRec_Validate
    procedure :: Init => TCosmoRec_init
    procedure :: x_e => TCosmoRec_xe
    procedure :: T_m => TCosmoRec_tm !baryon temperature
    procedure, nopass :: SelfPointer => TCosmoRec_SelfPointer
    end type TCosmoRec

    public TCosmoRec
    contains

    subroutine TCosmoRec_ReadParams(this, Ini)
    class(TCosmoRec) :: this
    class(TIniFile), intent(in) :: Ini

    call Ini%Read('cosmorec_runmode', this%runmode)
    call Ini%Read('cosmorec_accuracy', this%accuracy)
    call Ini%Read('cosmorec_fdm', this%fdm)

    end subroutine TCosmoRec_ReadParams


    subroutine TCosmoRec_Validate(this, OK)
    class(TCosmoRec),intent(in) :: this
    logical, intent(inout) :: OK

    if(this%runmode < 0 .or. this%runmode > 3) then
        write(*,*) "Invalid runmode for CosmoRec,"
        OK = .false.
    end if

    if(this%runmode < 2 .and. this%fdm > 1d-23) then
        write(*,*) "Dark matter annihilation rate too high. Will crash CosmoRec."
        OK = .false.
    end if

    if(this%accuracy < 0.0 .or. this%accuracy > 3.0) then
        write(*,*) "CosmoRec accuracy mode undefined."
        OK = .false.
    end if

    end subroutine TCosmoRec_Validate

    function TCosmoRec_tm(this,a)
    class(TCosmoRec) :: this
    real(dl), intent(in) :: a
    real(dl) TCosmoRec_tm
    real(dl) z

    z =1/a-1
    if (z >= this%tmrec%xmax) then
        TCosmoRec_tm = this%tmrec%F(Nz)*(1+z)/(1+this%tmrec%xmax)
    else if (z <= this%tmrec%xmin) then
        TCosmoRec_tm = this%tmrec%F(1)
    else
        TCosmoRec_tm = this%tmrec%Value(z)
    end if

    end function TCosmoRec_tm

    function TCosmoRec_xe(this,a)
    class(TCosmoRec) :: this
    real(dl), intent(in) :: a
    real(dl) TCosmoRec_xe
    real(dl) z

    z =1/a-1

    if (z >= this%xrec%xmax) then
        TCosmoRec_xe = this%xrec%F(Nz)
    else if (z <= this%xrec%xmin) then
        TCosmoRec_xe = this%xrec%F(1)
    else
        TCosmoRec_xe = this%xrec%Value(z)
    end if

    end function TCosmoRec_xe

    subroutine TCosmoRec_init(this, State, WantTSpin)
    use MiscUtils
    class(TCosmoRec), target :: this
    class(TCAMBdata), target :: State
    logical, intent(in), optional :: WantTSpin
    integer :: i, label
    real(dl), dimension(5) :: runpars
    procedure(obj_function) :: dtauda
    real(dl) OmegaB, OmegaC, OmegaK, h2
    real(dl), allocatable :: Hz(:), zrec(:), tmrec(:), xrec(:), tmp(:)
    external CosmoRec_calc_h_cpp

#ifdef MPI
    label = GetMpiRank()
#else
    label = 0
#endif
    ! Some feedback
    if (DefaultFalse(WantTSpin)) call MpiStop('CosmoRec does not support 21cm')

    select type(State)
    class is (CAMBdata)

        if (State%CP%Evolve_delta_xe) &
            call MpiStop('CosmoRec currently does not support evolving Delta x_e')
        h2 = (State%CP%H0/100)**2
        OmegaB = State%CP%ombh2/h2
        !These parameters are now redundant since using Hz array, just set to something
        Omegak = State%CP%omk
        OmegaC = State%CP%omch2/h2

        if (.not. allocated(this%xrec)) allocate(TRegularCubicSpline::this%xrec)
        if (.not. allocated(this%tmrec)) allocate(TRegularCubicSpline::this%tmrec)

        allocate(Hz(Nz), zrec(Nz), xrec(Nz), tmrec(Nz), tmp(Nz))

        ! Set runtime parameters
        runpars = 0._dl
        runpars(1) = this%fdm ! Set dark matter annihilation efficiency
        runpars(2) = this%accuracy

        ! Set redshifts to calculate at.
        do i=1,Nz
            zrec(i) = zmax - (i-1)*((zmax - zmin) / (Nz-1))
            Hz(i) = 1/dtauda(State,1/(1._dl+zrec(i))) &
                *(1._dl+zrec(i))**2/MPC_in_sec
        end do

        ! internal Hubble function of CosmoRec is used
        !call CosmoRec_calc_cpp(Recomb%runmode, runpars, &
        !     OmegaC, OmegaB, OmegaK, num_nu, h0inp, tcmb, yp, &
        !     zrec, xrec, tmrec, Nz, label)

        ! version which uses camb Hubble function
        call CosmoRec_calc_h_cpp(this%runmode, runpars, &
            OmegaC, OmegaB, OmegaK, State%CP%N_eff(), State%CP%H0, State%CP%tcmb, State%CP%yhe, &
            zrec, Hz, Nz, zrec, xrec, tmrec, Nz, label)

        !Init interpolation
        tmp =xrec(Nz:1:-1)
        call this%xrec%Init(zrec(Nz), zrec(1), Nz, tmp)
        tmp =tmrec(Nz:1:-1)
        call this%tmrec%Init(zrec(Nz), zrec(1), Nz, tmp)
    end select

    end subroutine TCosmoRec_init

    subroutine TCosmoRec_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TCosmoRec), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TCosmoRec_SelfPointer

    end module CosmoRec

    module SecondOrderPK
    !Third-order Newtonian perturbation theory results for the non-linear correction
    !Only intended for use at very high redshift (z>10) where corrections are perturbative
    !May help to demonstrate how more general non-linear model classes could be implemented
    !See Appendix F of astro-ph/0702600 for equations and references
    !
    !The code is not intended for production use and may be quite slow
    use results
    use transfer
    use MathUtils
    implicit none
    private

    type, extends(TNonLinearModel) :: TSecondOrderPK
        type(MatterPowerData), pointer :: CAMB_Pk
        real(dl) :: min_store,min_k,max_k, k, PK, r, epsilon
        integer itf
        integer term
    contains
    procedure :: Init => TSecondOrderPK_Init
    procedure :: GetNonLinRatios => TSecondOrderPK_GetNonLinRatios
    procedure :: GetNonLinRatios_All => TSecondOrderPK_GetNonLinRatios_All
    procedure :: GetRatios
    procedure, private :: Integrand
    procedure, private :: Integrand_x
    procedure, private :: Integrand_Log
    procedure, private :: Integrand_series
    procedure, nopass :: SelfPointer => TSecondOrderPK_SelfPointer
    end type TSecondOrderPK

    integer, parameter :: term_dd=1,term_vv=2,term_dv=3

    public TSecondOrderPK
    contains

    subroutine TSecondOrderPK_Init(this, State)
    class(TSecondOrderPK) :: this
    class(TCAMBdata), target :: State

    this%Min_kh_nonlinear = 0.001

    end subroutine TSecondOrderPK_Init

    subroutine TSecondOrderPK_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TSecondOrderPK), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TSecondOrderPK_SelfPointer

    function Integrand_x(this, x) result(int)
    class(TSecondOrderPK) :: this
    real(dl), intent(in) :: x
    real(dl) k, int

    associate(this_r => this%r, this_k => this%k)
        k = sqrt((1+this_r*(this_r-2*x)))*This_k
        if (k > this%min_store .and. k< this%max_k) then

            if (this%term==term_dd) then
                int = ((3*this_r + x*(7-10*this_r*x))/(1+this_r*(this_r-2*x)))**2
            elseif (this%term==term_vv) then
                int = ((this_r - x*(7-6*this_r*x))/(1+this_r*(this_r-2*x)))**2
            elseif (this%term==term_dv) then
                int = (this_r - x*(7-6*this_r*x))*(-3*this_r - x*(7-10*this_r*x))/(1+this_r*(this_r-2*x))**2

            end if
            int = int * MatterPowerData_k(this%CAMB_PK, k, this%itf)
        else
            int = 0
        end if
    end associate
    end function Integrand_x

    function Integrand_Log(this,p) result(int)
    !p = log r
    class(TSecondOrderPK) :: this
    real(dl), intent(in) ::p
    real(dl) r,r2,int, int22
    real(dl) :: xtol = 1.e-4_dl
    integer i

    r = exp(p)
    int = this%Integrand(r)*r
    end function Integrand_log

    function Integrand(this,r) result(int)
    class(TSecondOrderPK) :: this
    real(dl), intent(in) ::r
    real(dl) r2,int, int22
    real(dl) :: xtol = 1.e-4_dl
    integer i

    this%r = r
    r2=r**2
    if (this%term==term_dd) then

        Int = (12._dl/r2-158._dl+100._dl*r2-42._dl*r2**2)
        if (abs(r-1._dl) > 1e-6) then
            Int=Int  +3._dl/r2/r*(r2-1)**3*(7*r2 +2)*log((1._dl+r)/abs(1._dl-r))
        end if
        Int=Int*this%pk/252._dl

    elseif (this%term==term_vv) then

        Int = (12._dl/r2-82._dl+4._dl*r2-6._dl*r2**2)
        if (abs(r-1._dl) > 1e-6) then
            Int=Int  +3._dl/r2/r*(r2-1)**3*(r2 +2)*log((1._dl+r)/abs(1._dl-r))
        end if
        Int=Int*this%pk/84._dl

    elseif (this%term==term_dv) then

        Int = (24._dl/r2-202._dl+56._dl*r2-30._dl*r2**2)
        if (abs(r-1._dl) > 1e-6) then
            Int=Int  +3._dl/r2/r*(r2-1)**3*(5*r2 +4)*log((1._dl+r)/abs(1._dl-r))
        end if
        Int=Int*this%pk/252._dl

    end if

    if (r<this%epsilon) then
        int22=2*Integrate_Romberg(this,Integrand_x,-1._dl,1._dl, xtol)/98._dl
    else if (r >= 1-this%epsilon .and. r<= 1+this%epsilon) then
        int22=Integrate_Romberg(this,Integrand_x,-1._dl,(1._dl+r2-this%epsilon**2)/(2._dl*r), xtol)/98._dl
    else
        int22=Integrate_Romberg(this,Integrand_x,-1._dl,1._dl, xtol)/98._dl
    end if

    Int = Int+ int22
    Int=  Int * this%k**3 * MatterPowerData_k(this%CAMB_PK, r*this%k, this%itf)/(2._dl*const_pi)**2
    !put in k^3 here to keep answer sensible size
    end function Integrand


    function Integrand_series(this, p) result(int)
    class(TSecondOrderPK) :: this
    !For low r
    real(dl), intent(in) ::p
    real(dl) :: int, r
    integer i

    r = exp(p)
    Int=  r* r**2* this%pk* this%k**3 * MatterPowerData_k(this%CAMB_PK, r*this%k, this%itf)/(2._dl*const_pi)**2
    !put in k^3 here to keep answer sensible size
    !extra r because change to dr = r dp
    end function Integrand_series

    subroutine TSecondOrderPK_GetNonLinRatios(this, State, CAMB_Pk)
    !Fill the CAMB_Pk%nonlin_scaling array with sqrt(non-linear power/linear power)
    !for each redshift and wavenumber
    class(TSecondOrderPK) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk

    call this%GetRatios(CAMB_PK, .false.)

    end subroutine TSecondOrderPK_GetNonLinRatios

    subroutine TSecondOrderPK_GetNonLinRatios_all(this,State, CAMB_Pk)
    !Fill the CAMB_Pk%nonlin_scaling array with sqrt(non-linear power/linear power)
    !for each redshift and wavenumber
    class(TSecondOrderPK) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk

    call this%GetRatios(CAMB_PK, .true.)

    end subroutine TSecondOrderPK_GetNonLinRatios_all

    subroutine GetRatios(this,CAMB_Pk, DoVel)
    !Fill the CAMB_Pk%nonlin_scaling array with sqrt(non-linear power/linear power)
    !for each redshift and wavenumber
    use splines
    class(TSecondOrderPK) :: this
    type(MatterPowerData), target :: CAMB_Pk
    logical, intent(in):: DoVel
    integer i, it,j
    real(dl) tmp,pnl, max_store,t1,t2,t3
    real(dl) :: rtol = 1e-5
    real(dl), parameter :: r_series = 0.003_dl
    real(dl), allocatable, dimension(:) :: dPdLogK
    real(dl) sc
    integer term

    this%CAMB_PK => CAMB_Pk

    CAMB_Pk%nonlin_ratio = 1

    if (doVel) then
        allocate(CAMB_Pk%nonlin_ratio_vv(CAMB_Pk%num_k,CAMB_Pk%num_z))
        allocate(CAMB_Pk%nonlin_ratio_vd(CAMB_Pk%num_k,CAMB_Pk%num_z))
        CAMB_Pk%nonlin_ratio_vv = 1
        CAMB_Pk%nonlin_ratio_vd = 1
    end if

    do term = term_dd, term_dv
        this%term = term

        max_store =  exp(CAMB_Pk%log_kh(CAMB_PK%num_k))
        this%min_store =  exp(CAMB_Pk%log_kh(1))

        this%min_k = this%min_store
        this%max_k = max_store

        do it = 1, CAMB_Pk%num_z
            this%itf = it

            allocate(dPdLogK(CAMB_PK%num_k))
            !Get first derivative needed for series expansion at low r
            call spline_deriv(CAMB_Pk%log_kh, CAMB_Pk%matpower(:,it), CAMB_Pk%ddmat(:,it), dPdLogK,CAMB_PK%num_k)

            do i=1, CAMB_PK%num_k

                this%k = exp(CAMB_Pk%log_kh(i))

                if (this%k > this%Min_kh_nonlinear) then

                    this%min_k = max(this%min_store,0.4 * this%k)
                    this%max_k = min(max_store,300* this%k)

                    this%epsilon = this%min_k/this%k
                    if (this%epsilon >=0.5) stop 'epsilon >=0.5'


                    this%pk =MatterPowerData_k(CAMB_PK, this%k, this%itf)

                    if (this%min_k > this%min_store) then

                        if (this%min_store/this%k < r_series) then
                            !Series result
                            if (term==term_vv) then
                                pnl = 94./245*Integrate_romberg(this,Integrand_series,log(this%min_store/this%k), &
                                    log(r_series),rtol*this%pk,abs_tol=.true.)
                                pnl = pnl*(1 - 217._dl/141._dl*dPdLogK(i) &
                                    + 49._dl/94._dl*( CAMB_Pk%ddmat(i,it) + dPdLogK(i)**2))
                            else if (term==term_dv) then
                                pnl = 2558./2205*Integrate_romberg(this,Integrand_series, &
                                    log(this%min_store/this%k),log(r_series),rtol*this%pk,abs_tol=.true.)
                                pnl = pnl*(1 - 819._dl/1279._dl*dPdLogK(i)  &
                                    + 441._dl/2558._dl*( CAMB_Pk%ddmat(i,it) + dPdLogK(i)**2))
                            else if (term==term_dd) then
                                pnl = 5038./2205*Integrate_romberg(this,Integrand_series,&
                                    log(this%min_store/this%k),log(r_series),rtol*this%pk,abs_tol=.true.)
                                pnl = pnl*(1 - 987._dl/2519._dl*dPdLogK(i) &
                                    + 441._dl/5038._dl*( CAMB_Pk%ddmat(i,it) + dPdLogK(i)**2))
                            end if
                            !plus integral with log spacing
                            pnl = pnl+Integrate_romberg(this,Integrand_Log,log(r_series), &
                                log(this%epsilon),rtol*this%pk,20,abs_tol=.true.)
                        else
                            pnl = Integrate_romberg(this,Integrand_Log,log(this%min_store/this%k), &
                                log(this%epsilon),rtol*this%pk,20,abs_tol=.true.)
                        end if

                    else
                        pnl = 0
                    end if


                    t1 = Integrate_romberg(this,Integrand,this%epsilon,1-this%epsilon,rtol*this%pk,abs_tol=.true.)

                    if (1+this%epsilon*2<this%max_k/this%k) then
                        t2 = Integrate_romberg(this,Integrand,1+this%epsilon,1+this%epsilon*2,&
                            rtol*this%pk,abs_tol=.true.) !function falls quite rapidly
                        t2 =t2+ Integrate_romberg(this,Integrand,1+this%epsilon*2, &
                            this%max_k/this%k,rtol*this%pk,abs_tol=.true.)
                    else
                        t2 = Integrate_romberg(this,Integrand,1+this%epsilon,1+this%epsilon*2,rtol*this%pk,abs_tol=.true.)
                    end if
                    t3 = Integrate_romberg(this,Integrand,1-this%epsilon,1+this%epsilon,rtol*this%pk,abs_tol=.true.)
                    ! sc = this_K**3/(2*pi**2)
                    ! write (*,'(5e15.5)') this_k,this_PK*sc,pnl*sc, (this_PK+pnl)*sc, pnl/this_PK

                    pnl = pnl+t1+t2+t3

                    ! sc = this_K**3/(2*pi**2)
                    ! write (*,'(5e15.5)') this_k,this_PK*sc,pnl*sc, (this_PK+pnl)*sc, pnl/this_PK


                    if (term==term_dd) then
                        CAMB_Pk%nonlin_ratio(i,this%itf) = sqrt(abs(1+pnl/this%pk))
                    elseif (term==term_vv) then
                        CAMB_Pk%nonlin_ratio_vv(i,this%itf) = sqrt(abs(1+pnl/this%pk))
                    else
                        CAMB_Pk%nonlin_ratio_vd(i,this%itf) = sqrt(abs(1+pnl/this%pk))
                    end if
                end if

            enddo

            deallocate(dPdLogk)

        end do !redshifts

        if (.not. doVel) exit

    end do !terms

    end subroutine GetRatios

    end module SecondOrderPK

    module MpiUtils
    implicit none
#ifdef MPI
    ! use mpi leads to .mod compiler incompatibility errors unless you are very careful
    ! so stick to old method and add manual interface for gcc10+ compatibility
    include "mpif.h"
#if __GNUC__ > 9
    interface
    subroutine MPI_BCAST(BUFFER, COUNT, DATATYPE, ROOT, COMM, IERROR)
     !GCC$ ATTRIBUTES NO_ARG_CHECK :: BUFFER
    Type(*) BUFFER
    INTEGER COUNT, DATATYPE, ROOT, COMM, IERROR
    end subroutine
    end interface
#endif
#endif

    integer, parameter :: TTimer_dp = Kind(1.d0)

    Type TTimer
        real(TTimer_dp) start_time
    contains
    procedure :: Start => TTimer_Start
    procedure :: Time => TTimer_Time
    procedure :: WriteTime => TTimer_WriteTime
    end type TTimer

    contains

    function GetMpiRank()
    integer GetMpiRank
#ifdef MPI
    integer ierror
    call mpi_comm_rank(mpi_comm_world,GetMPIrank,ierror)
    if (ierror/=MPI_SUCCESS) call MpiStop('MPI fail')
#else
    GetMpiRank=0
#endif

    end function GetMpiRank

    function IsMainMPI()
    logical IsMainMPI

    IsMainMPI =  GetMpiRank() == 0

    end function IsMainMPI

    subroutine MpiStop(Msg)
    character(LEN=*), intent(in), optional :: Msg
    integer i
#ifdef MPI
    integer ierror, MpiRank
#endif

    if (present(Msg)) write(*,*) trim(Msg)

#ifdef MPI
    call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
    write (*,*) 'MpiStop: ', MpiRank
    call MPI_ABORT(MPI_COMM_WORLD,i, ierror)
#endif
    i=1     !put breakpoint on this line to debug
#ifndef MPI
    if (msg/='') error stop
#endif
    stop

    end subroutine MpiStop

    subroutine MpiStat(MpiID, MpiSize)
    implicit none
    integer MpiID,MpiSize
#ifdef MPI
    integer ierror
    call mpi_comm_rank(mpi_comm_world,MpiID,ierror)
    if (ierror/=MPI_SUCCESS) call MpiStop('MpiStat: MPI rank')
    call mpi_comm_size(mpi_comm_world,MpiSize,ierror)
#else
    MpiID=0
    MpiSize=1
#endif
    end subroutine MpiStat

    subroutine MpiQuietWait
    !Set MPI thread to sleep, e.g. so can run openmp on cpu instead
#ifdef MPI
    integer ierr, STATUS(MPI_STATUS_SIZE)
    logical flag
    integer i, MpiId, MpiSize

    call MpiStat(MpiID, MpiSize)
    if (MpiID/=0) then
        do
            call MPI_IPROBE(0,0,MPI_COMM_WORLD,flag, MPI_STATUS_IGNORE,ierr)
            if (flag) then
            call MPI_RECV(i,1,MPI_INTEGER, 0,0,MPI_COMM_WORLD,status,ierr)
            exit
        end if
        call sleep(1)
    end do
    end if
#endif
    end subroutine

    subroutine MpiWakeQuietWait
#ifdef MPI
    integer j, MpiId, MpiSize, ierr,r

    call MpiStat(MpiID, MpiSize)
    if (MpiID==0) then
        do j=1, MpiSize-1
            call MPI_ISSEND(MpiId,1,MPI_INTEGER, j,0,MPI_COMM_WORLD,r,ierr)
        end do
    end if
#endif
    end subroutine MpiWakeQuietWait

    subroutine MpiShareString(S, from)
    character(LEN=:), allocatable :: S
    integer from
#ifdef MPI
    integer inlen, rank, ierror

    rank = GetMpiRank()

    if (rank==from) inlen=len(S)

    CALL MPI_Bcast(inlen, 1, MPI_INTEGER, from, MPI_COMM_WORLD, ierror)
    if (ierror/=MPI_SUCCESS) call MpiStop('MpiShareString: fail')

    if (rank /= from ) allocate(character(inlen)::S)
    CALL MPI_Bcast(S, LEN(S), MPI_CHARACTER, from, MPI_COMM_WORLD, ierror)
#endif
    end subroutine MpiShareString


    function TimerTime()
    real(TTimer_dp) time
    real(TTimer_dp) :: TimerTime
    !$ real(TTimer_dp), external :: omp_get_wtime
#ifdef MPI
    TimerTime = MPI_WTime()
#else
    time = 0
    !$ time = OMP_GET_WTIME()
    if (time==0) call cpu_time(time)
    TimerTime=  time
#endif
    end function TimerTime

    subroutine TTimer_Start(this, time)
    class(TTimer) :: this
    real(TTimer_dp), intent(out), optional :: time
    this%start_time = TimerTime()
    if (present(time)) time = this%start_time
    end subroutine TTimer_Start

    real(TTimer_dp) function TTimer_Time(this)
    class(TTimer) :: this
    TTimer_Time =  TimerTime() - this%start_time
    end function TTimer_Time

    subroutine TTimer_WriteTime(this,Msg, start)
    class(TTimer) :: this
    character(LEN=*), intent(in), optional :: Msg
    real(TTimer_dp), optional :: start
    real(TTimer_dp) T, DeltaT
    character(LEN=:), allocatable :: tmp

    if (present(start)) then
        T=start
    else
        T=this%start_time
    end if

    DeltaT = TimerTime() - T
    if (present(Msg)) then
        tmp = trim(Msg)//': '
        if (DeltaT > 0.00002 .and. DeltaT < 1000 .and. len_trim(tmp)<24) then
            write (*,'(a25,f10.5)') tmp, DeltaT
        else
            write (*,*) trim(Msg)//': ', DeltaT
        end if
    end if
    if (.not. present(start)) this%start_time = TimerTime()

    end subroutine TTimer_WriteTime


    end module MpiUtils

    !Matrix utility routines. Uses BLAS/LAPACK. Mostly wrapper routines.
    !Generally (but not always) assumes that all matrix arrays are defined at exactly correct size
    !Not complete
    !Antony Lewis May 2003-2014
    !http://cosmologist.info/utils/


    module MatrixUtils
    use MpiUtils
    use FileUtils
    use StringUtils
    implicit none

    logical, parameter :: Matrix_runmsgs = .false.
#ifdef MATRIX_SINGLE
    integer, parameter :: dm = KIND(1.0)
#else
    integer, parameter :: dm = KIND(1.d0)
#endif
    !Precision of matrix operators
    !If changing also need to change prefix on LAPACK routine names
    integer, parameter :: Mat_F90=1, Mat_Norm=2, Mat_DC =3 !Normal, basic BLAS/LAPACK or divide and conquer
    integer, parameter :: matrix_method = mat_DC

    real Matrix_StartTime

    Type TMatrixType
        real(dm), dimension(:,:), pointer :: M
    end Type TMatrixType

    complex(dm), parameter :: COne = (1._dm,0._dm), CZero = (0._dm,0._dm)
    real(dm), parameter :: ROne = 1._dm, RZero = 0._dm
    real, parameter :: SOne = 1., SZero = 0.

    character(LEN=*), parameter :: Matrix_IO_fmt= '(*(1E17.7))'

    contains


    function GetMatrixTime()
    real GetMatrixTime
    real atime

    call cpu_time(atime)

    GetMatrixTime = atime


    end function GetMatrixTime

    subroutine  Matrix_start(Name)
    character(LEN=*), intent(in) :: Name

    if (Matrix_runmsgs) then
        Matrix_StartTime = GetMatrixTime()
        Write(*,*) 'Matrix_'//trim(Name) //' start'
    end if
    end subroutine  Matrix_start

    subroutine  Matrix_end(Name)
    character(LEN=*), intent(in) :: Name

    if (Matrix_runmsgs) then
        Write(*,*) 'Matrix_'//trim(Name) //' end: ', GetMatrixTime() - Matrix_StartTime
    end if
    end subroutine  Matrix_end

    subroutine Matrix_WriteFileRow(aunit, vec,n)
    integer, intent(in) :: aunit
    integer, intent(in) :: n
    real(dm) :: vec(n)

    write (aunit, Matrix_IO_fmt) vec(1:n)

    end subroutine Matrix_WriteFileRow

    subroutine Matrix_Write(aname, mat, forcetable, commentline)
    character(LEN=*), intent(in) :: aname
    character(LEN=*), intent(in), optional :: commentline
    real(dm), intent(in) :: mat(:,:)
    logical, intent(in), optional :: forcetable
    integer i,k
    integer shp(2)
    logical WriteTab
    Type(TTextFile) :: F

    shp = shape(mat)
    WriteTab = shp(2)<=50
    if (present(forcetable)) then
        if (forcetable) WriteTab = .true.
    end if
    call F%CreateFile(aname)
    if (present(commentline)) then
        call F%Write('#'//commentline)
    end if
    do i=1, shp(1)
        if (.not. WriteTab) then
            do k=1, shp(2)
                call F%Write(mat(i,k))
            end do
        else
            write(F%unit,F%RealFormat) mat(i,1:shp(2))
            !workaround for ifort 14 bug
            !call F%Write(mat(i,1:shp(2)))
        end if
    end do
    call F%Close()

    end subroutine Matrix_Write

    subroutine Matrix_Write_double(aname, mat, forcetable)
    character(LEN=*), intent(in) :: aname
    double precision, intent(in) :: mat(:,:)
    logical, intent(in), optional :: forcetable
    integer i,k
    integer shp(2)
    logical WriteTab
    Type(TTextFile) F

    shp = shape(mat)
    WriteTab = shp(2)<=50
    if (present(forcetable)) then
        if (forcetable) WriteTab = .true.
    end if
    call F%CreateFile(aname)
    do i=1, shp(1)
        if (.not. WriteTab) then
            do k=1, shp(2)
                call F%Write(mat(i,k))
            end do
        else
            call F%Write(mat(i,1:shp(2)))
        end if
    end do
    call F%Close()

    end subroutine Matrix_Write_double


    subroutine Matrix_Write_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: mat(:,:)
    Type(TBinaryFile) F

    call F%CreateFile(aname)
    Write(F%unit) mat
    call F%Close()

    end subroutine Matrix_Write_Binary


    subroutine MatrixSym_Write_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: mat(:,:)
    integer i
    integer shp(2)
    Type(TBinaryFile) F

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop('MatrixSym_Write_Binary: Not square matrix')
    if (shp(1) == 0) return

    call F%CreateFile(aname)
    do i=1,shp(1)
        write(F%unit) mat(i:shp(2),i)
    end do
    call F%Close()

    end subroutine MatrixSym_Write_Binary

    subroutine MatrixSym_Write_Binary_Single(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: mat(:,:)
    integer i
    integer shp(2)
    Type(TBinaryFile) F

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop('MatrixSym_Write_Binary_Single: Not square matrix')
    if (shp(1) == 0) return

    call F%CreateFile(aname)
    do i=1,shp(1)
        write(F%unit) real(mat(i:shp(2),i), kind(1.0))
    end do
    call F%Close()

    end subroutine MatrixSym_Write_Binary_Single



    subroutine Matrix_WriteVec(aname, vec)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(in) :: vec(:)
    integer i
    Type(TTextFile) F

    call F%CreateFile(aname)
    do i=1, size(vec)
        call F%Write(vec(i))
    end do
    call F%Close()

    end subroutine Matrix_WriteVec


    subroutine Matrix_Read_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(out) :: mat(:,:)
    Type(TBinaryFile) F

    call F%Open(aname)
    read (F%unit) mat
    call F%Close()

    end subroutine Matrix_Read_Binary


    subroutine MatrixSym_Read_Binary(aname, mat)
    character(LEN=*), intent(in) :: aname
    real(dm), intent(out) :: mat(:,:)
    integer i
    integer shp(2)
    Type(TBinaryFile) F

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop( 'MatrixSym_Read_Binary: Not square matrix')
    if (shp(1) == 0) return

    call F%Open(aname)
    do i=1,shp(1)
        read (F%unit) mat(i:shp(1),i)
        mat(i,i:shp(1)) = mat(i:shp(1),i)
    end do
    call F%Close()

    end subroutine MatrixSym_Read_Binary

    subroutine MatrixSym_Read_Binary_Single(aname, mat)
    character(LEN=*), intent(in) :: aname
    real, intent(out) :: mat(:,:)
    integer i
    integer shp(2)
    Type(TBinaryFile) F

    shp = shape(mat)
    if (shp(1) /= shp(2)) call MpiStop( 'MatrixSym_Read_Binary: Not square matrix')
    if (shp(1) == 0) return

    call F%Open(aname)
    do i=1,shp(1)
        read (F%unit) mat(i:shp(1),i)
        mat(i,i:shp(1)) = mat(i:shp(1),i)
    end do
    call F%Close()

    end subroutine MatrixSym_Read_Binary_Single



    subroutine Matrix_Read(aname, mat)
    character(LEN=*), intent(IN) :: aname
    real(dm), intent(out) :: mat(:,:)
    integer j,k
    integer shp(2)
    real(dm) tmp
    Type(TTextFile) :: F

    shp = shape(mat)

    call F%Open(aname)

    do j=1,shp(1)
        read (F%unit,*, end = 200, err=100) mat(j,1:shp(2))
    end do
    goto 120

100 rewind(F%unit)  !Try other possible format
    do j=1,shp(1)
        do k=1,shp(2)
            read (F%unit,*, end = 200) mat(j,k)
        end do
    end do

120 read (F%unit,*, err = 150, end =150) tmp
    goto 200

150 call F%Close()
    return

200 call MpiStop('Matrix_Read: file '//trim(aname)//' is the wrong size')


    end subroutine Matrix_Read

    subroutine Matrix_ReadSingle(aname, mat)
    character(LEN=*), intent(IN) :: aname
    real, intent(out) :: mat(:,:)
    integer j,k
    integer shp(2)
    real tmp
    Type(TTextFile) :: F

    shp = shape(mat)

    call F%Open(aname)

    do j=1,shp(1)
        read (F%unit,*, end = 200, err=100) mat(j,1:shp(2))
    end do
    goto 120

100 rewind(F%unit)  !Try other possible format
    do j=1,shp(1)
        do k=1,shp(2)
            read (F%unit,*, end = 200) mat(j,k)
        end do
    end do

120 read (F%unit,*, err = 150, end =150) tmp
    goto 200

150 call F%Close()
    return

200 call MpiStop('Matrix_Read:Single file '//trim(aname)//' is the wrong size')


    end subroutine Matrix_ReadSingle


    function Matrix_Diag(M, n)
    integer, intent(in) :: n
    real(dm), intent(in) :: M(:,:)
    real(dm) Matrix_Diag(n)
    integer i

    do i=1,n
        Matrix_Diag(i) = M(i,i)
    end do

    end function Matrix_Diag

    function ILAENV_wrap(i,S1,S2,a,b,c,d)
    integer ILAENV_wrap
    integer, intent(in) :: i,a,b,c,d
    character(LEN=*), intent(in) :: S1, S2
    integer, external :: ILAENV

    !If you don't have ILAENV in math library, change routine to return some positive integer
    !that is a guess at the blocksize
#ifdef MATRIX_SINGLE
    ILAENV_wrap = 16
#else
    ILAENV_wrap =  ILAENV(i,S1,S2,a,b,c,d)
#endif
    !!!IFC
    end  function ILAENV_wrap


    subroutine Matrix_Diagonalize(M, diag, n)
    !Does m = U diag U^T, returning U in M
    integer, intent(in) :: n
    real(dm), intent(inout):: m(n,n)
    real(dm), intent(out) :: diag(n)
    integer ierr, tmpsize
    real(dm), allocatable, dimension(:) :: tmp

    call Matrix_Start('Diagonalize')
#ifdef MATRIX_SINGLE
    tmpsize =  max( (ILAENV_wrap(1,'SSYTRD','U',n,n,n,n)+2)*N,max(1,3*n-1))  !3*n**2
    allocate(tmp(tmpsize));
    call SSYEV('V','U',n,m,n,diag,tmp,tmpsize,ierr) !evalues and vectors of symmetric matrix
#else
    tmpsize =  max( (ILAENV_wrap(1,'DSYTRD','U',n,n,n,n)+2)*N,max(1,3*n-1))  !3*n**2
    allocate(tmp(tmpsize));
    call DSYEV('V','U',n,m,n,diag,tmp,tmpsize,ierr) !evalues and vectors of symmetric matrix
#endif
    if (ierr /= 0) call MpiStop('Error in Matrix_Diagonalize')
    deallocate(tmp)
    call Matrix_End('Diagonalize')

    end subroutine Matrix_Diagonalize

    subroutine Matrix_Diagonalize_DC(M, diag, n)
    !Complex version. Does m = U diag U^dag, returning U in M
    integer, intent(in) :: n
    real(dm), intent(inout):: m(n,n)
    real(dm), intent(out) :: diag(n)
    integer ierr, tmpsize ,isize
    real(dm), allocatable, dimension(:) :: tmp
    integer, allocatable,dimension(:):: iwork

    call Matrix_Start('Diagonalize')

    if (matrix_method == Mat_DC) then
        !Divide and conquer
        tmpsize = 1 + 6*N + 2*N**2
        isize = 3+5*N
        allocate(tmp(tmpsize))
        allocate(iwork(isize))
#ifdef MATRIX_SINGLE
        call SSYEVD('V','U',n,M,n,diag,tmp,tmpsize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#else
        call DSYEVD('V','U',n,M,n,diag,tmp,tmpsize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#endif
        deallocate(iwork)
        deallocate(tmp)
    else
        call Matrix_Diagonalize(M, diag, n)
    end if

    if (ierr /= 0) call MpiStop('Error in Matrix_Diagonalize')

    call Matrix_End('Diagonalize')

    end subroutine Matrix_Diagonalize_DC



    subroutine Matrix_Root(M, n, pow)
    !Does M**pow for symmetric M using U D**pow U^T
    !Not optimized for large matrices
    integer, intent(in) :: n
    real(dm), intent(inout):: M(n,n)
    real(dm) :: Tmp(n,n)
    real(dm), intent(in) :: pow

    real(dm) :: diag(n)
    integer i

    call Matrix_Diagonalize(M, diag, n)
    Tmp = M
    diag = diag**pow
    do i = 1, n
        M(:,i) = M(:,i)*diag(i)
    end do
    M = matmul(M,transpose(Tmp))

    end subroutine Matrix_Root


    subroutine Matrix_Diagonalize_Partial(M, diag, n, emin,emax, nfound)
    !Real version. Does m = U diag U^dag, returning U in M
    !Assumes up to nfound values will be found. nfound set to true value on exit
    integer, intent(in) :: n
    real(dm), intent(inout):: m(:,:)
    real(dm), intent(out) :: diag(:)
    real(dm), intent(in) :: emin,emax
    integer, intent(inout) :: nfound
    integer ierr, worksize, LIWork
    real(dm), allocatable, dimension(:) :: work
    real(dm), allocatable, dimension(:,:) :: tmp
    integer, allocatable,dimension(:):: supp,iwork
    real(dm) wsize(1)
    real(dm)  atol
    integer ISize(1)

    atol = 1d-9
    call Matrix_Start('Matrix_Diagonalize_Partial')
    allocate(tmp(n,nfound))
    allocate(Supp(n))
    !Query
    WorkSize = -1
    LIWork = -1
#ifdef MATRIX_SINGLE
    call SSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,WSize,WorkSize,ISize,LIWork,ierr  )
#else
    call DSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,WSize,WorkSize,ISize,LIWork,ierr  )
#endif
    WorkSize = Real(WSize(1))
    LIWork = ISize(1)
    allocate(Work(WorkSize),IWork(LIWork))
#ifdef MATRIX_SINGLE
    call SSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,Work,WorkSize,IWork,LIWork,ierr )
#else
    call DSYEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,Work,WorkSize,IWork,LIWork,ierr )
#endif
    deallocate(Supp,Work,IWork)
    if (ierr /= 0) call MpiStop('Matrix_Diagonalize_Partial: Error')
    M(1:n,1:nfound) = tmp(1:n,1:nfound)  !nfound now different
    deallocate(tmp)
    call Matrix_End('Matrix_Diagonalize_Partial')

    end subroutine Matrix_Diagonalize_Partial


    subroutine Matrix_CDiagonalize_Partial(M, diag, n, emin,emax, nfound)
    !Complex version. Does m = U diag U^dag, returning U in M
    !Assumes up to nfound values will be found. nfound set to true value on exit
    integer, intent(in) :: n
    complex(dm), intent(inout):: m(:,:)
    real(dm), intent(out) :: diag(:)
    real(dm), intent(in) :: emin,emax
    integer, intent(inout) :: nfound
    integer ierr, worksize, LRWork, LIWork
    real(dm), allocatable, dimension(:) :: Rwork
    complex(dm), allocatable, dimension(:) :: work
    complex(dm), allocatable, dimension(:,:) :: tmp
    integer, allocatable,dimension(:):: supp,iwork
    complex(dm) wsize(1)
    real(dm) Rsize(1), atol
    integer ISize(1)

    atol = 1d-9
    call Matrix_Start('Matrix_CDiagonalize_Partial')
    allocate(tmp(n,nfound))
    allocate(Supp(n))
    !Query
    WorkSize = -1
    LRWork = -1
    LIWork = -1
#ifdef MATRIX_SINGLE
    call CHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,WSize,WorkSize,RSize,LRWork,ISize,LIWork,ierr  )
#else
    call ZHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,WSize,WorkSize,RSize,LRWork,ISize,LIWork,ierr  )
#endif
    WorkSize = Real(WSize(1))
    LRWork = RSize(1)
    LIWork = ISize(1)
    allocate(Work(WorkSize),RWork(LRWork),IWork(LIWork))
#ifdef MATRIX_SINGLE
    call CHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,Work,WorkSize,RWork,LRWork,IWork,LIWork,ierr )
#else
    call ZHEEVR('V','V','U',n,M,Size(M,DIM=1),emin,emax,0,0,atol,nfound,diag,tmp,Size(TMP,DIM=1),&
        Supp,Work,WorkSize,RWork,LRWork,IWork,LIWork,ierr )
#endif
    deallocate(Supp,Work,RWork,IWork)
    if (ierr /= 0) call MpiStop('Matrix_CDiagonalize_Partial: Error')
    M(1:n,1:nfound) = tmp(1:n,1:nfound)  !nfound now different
    deallocate(tmp)
    call Matrix_End('Matrix_CDiagonalize_Partial')


    end subroutine


    subroutine Matrix_CDiagonalize(M, diag, n)
    !Complex version. Does m = U diag U^dag, returning U in M
    integer, intent(in) :: n
    complex(dm), intent(inout):: m(n,n)
    real(dm), intent(out) :: diag(n)
    integer ierr, tmpsize ,isize, rworksize
    real(dm), allocatable, dimension(:) :: Rwork
    complex(dm), allocatable, dimension(:) :: tmp
    integer, allocatable,dimension(:):: iwork

    call Matrix_Start('CDiagonalize')

    if (matrix_method == Mat_DC) then
        !Divide and conquer
        tmpsize = 2*N + N**2
        rworksize =  1 + 4*N + 2*N*int(log(real(N))/log(2.)+1) + 3*N**2
        isize =  (2 + 5*N)*4
        allocate(tmp(tmpsize),rwork(rworksize))
        allocate(iwork(isize))
#ifdef MATRIX_SINGLE
        call CHEEVD('V','U',n,M,n,diag,tmp,tmpsize,Rwork,rworksize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#else
        call ZHEEVD('V','U',n,M,n,diag,tmp,tmpsize,Rwork,rworksize,iwork,isize,ierr) !evalues and vectors of hermitian matrix
#endif
        deallocate(iwork)
    else
        rworksize =  max(1, 3*n-2)
#ifdef MATRIX_SINGLE
        tmpsize = max( (ILAENV_wrap(1,'CHETRD','U',n,n,n,n)+1)*N,max(1,2*n-1)) !   3*n**2
        allocate(tmp(tmpsize),rwork(rworksize));
        call CHEEV('V','U',n,m,n,diag,tmp,tmpsize,Rwork,ierr) !evalues and vectors of hermitian matrix
#else
        tmpsize = max( (ILAENV_wrap(1,'ZHETRD','U',n,n,n,n)+1)*N,max(1,2*n-1)) !   3*n**2
        allocate(tmp(tmpsize),rwork(rworksize));
        call ZHEEV('V','U',n,m,n,diag,tmp,tmpsize,Rwork,ierr) !evalues and vectors of hermitian matrix
#endif
    end if

    if (ierr /= 0) call MpiStop('Error in Matrix_CDiagonalize')
    deallocate(tmp,rwork)

    call Matrix_End('CDiagonalize')

    end subroutine Matrix_CDiagonalize

    function Matrix_CTrace(M)
    complex(dm), intent(in) :: M(:,:)
    complex(dm) tmp,Matrix_CTrace
    integer i

    if (size(M,dim=1) /= size(M,dim=2)) call MpiStop('Matrix_CTrace: non-square matrix')
    tmp =0
    do i=1,size(M,dim=1)
        tmp = tmp + M(i,i)
    end do
    Matrix_CTrace = tmp

    end function Matrix_CTrace

    function Matrix_Trace(M)
    real(dm), intent(in) :: M(:,:)
    real(dm) tmp,Matrix_Trace
    integer i

    if (size(M,dim=1) /= size(M,dim=2)) call mpiStop('Matrix_Trace: non-square matrix')
    tmp =0
    do i=1,size(M,dim=1)
        tmp = tmp + M(i,i)
    end do
    Matrix_Trace = tmp

    end function Matrix_Trace


    function MatrixSym_LogDet(mat) result (logDet)
    real(dm), intent(in) :: mat(:,:)
    real(dm) logDet
    real(dm) Tmp(size(mat,dim=1),size(mat,dim=1))
    integer i

    if (size(mat,dim=1) /= size(mat,dim=2)) call mpiStop('MatrixSym_LogDet: non-square matrix')
    Tmp = mat
    call Matrix_Cholesky(tmp)
    logDet =0
    do i=1, size(mat,dim=1)
        logDet = logDet  + log(tmp(i,i))
    end do
    logDet = 2._dm*logDet

    end function MatrixSym_LogDet


    subroutine Matrix_CRotateSymm(Mat,U,m,Out,triangular)
    !Gets U^dag Mat U
    integer, intent(in) ::m
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), dimension(:,:), allocatable :: C
    integer n
    logical, intent(in), optional :: triangular
    logical :: triang

    call Matrix_Start('CRotateSymm')

    if (present(triangular)) then
        triang=triangular
    else
        triang=.false.
    end if

    n = Size(Mat,DIM=1)
    if (n /= Size(Mat,DIM=2)) call mpiStop('Matrix_CRotateSymm: Need square matrix')
    if (n /= Size(U,DIM=1)) call MpiStop('Matrix_CRotateSymm: Matrix size mismatch')
    if (Size(Out,DIM=1) < m .or. Size(Out,DIM=2) < m) &
        call MpiStop('Matrix_CRotateSymm: Wrong output size')

    if (matrix_method == Mat_F90) then
        Out = matmul(matmul(transpose(conjg(U(1:n,1:m))),Mat),U(1:n,1:m))
    else
#ifdef MATRIX_SINGLE
        if (triang) then
            if (m/=n) call MpiStop('Matrix_CRotateSymm: Matrices must be same size')
            call CHEMM('L','U',n,n,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
            call CTRMM('Left','Upper','Complex-Transpose','Not-unit',n,n,COne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else
            allocate(C(n,m))
            call CHEMM('L','U',n,m,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,C,n)
            call CGEMM('C','N',m,m,n,COne,U,Size(U,DIM=1),C,n,CZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#else
        if (triang) then
            if (m/=n) call MpiStop('Matrix_CRotateSymm: Matrices must be same size')
            call ZHEMM('L','U',n,n,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
            call ZTRMM('Left','Upper','Complex-Transpose','Not-unit',n,n,COne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else
            allocate(C(n,m))
            call ZHEMM('L','U',n,m,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,C,n)
            call ZGEMM('C','N',m,m,n,COne,U,Size(U,DIM=1),C,n,CZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#endif
    end if
    call Matrix_End('CRotateSymm')


    end subroutine Matrix_CRotateSymm

    subroutine Matrix_RotateSymm(Mat,U,m,Out, triangular)
    !Gets U^T Mat U
    !If triangular U = Upper triangular (U^T lower triangular)
    integer, intent(in) ::m
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), dimension(:,:), allocatable :: C
    logical, intent(in), optional :: triangular
    logical triang
    integer n

    call Matrix_Start('RotateSymm')

    if (present(triangular)) then
        triang=triangular
    else
        triang=.false.
    end if

    n = Size(Mat,DIM=1)
    if (n /= Size(Mat,DIM=2)) call MpiStop('Matrix_RotateSymm: Need square matrix')
    if (n /= Size(U,DIM=1)) call MpiStop('Matrix_RotateSymm: Matrix size mismatch')
    if (Size(Out,DIM=1) < m .or. Size(Out,DIM=2) < m) &
        call MpiStop('Matrix_RotateSymm: Wrong output size')

    if (matrix_method == Mat_F90) then
        Out = matmul(matmul(transpose(U(1:n,1:m)),Mat),U(1:n,1:m))
    else
#ifdef MATRIX_SINGLE
        if (triang) then
            if (m/=n) call MpiStop('Matrix_RotateSymm: Matrices must be same size')
            call SSYMM('L','U',n,n,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
            call STRMM('Left','Upper','Transpose','Not-unit',n,n,ROne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else
            allocate(C(n,m))
            call SSYMM('L','U',n,m,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,C,n)
            call SGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#else
        if (triang) then
            if (m/=n) call MpiStop('Matrix_RotateSymm: Matrices must be same size')
            call DSYMM('L','U',n,n,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
            call DTRMM('Left','Upper','Transpose','Not-unit',n,n,ROne,U,Size(U,DIM=1),Out,Size(Out,Dim=1))
        else
            allocate(C(n,m))
            call DSYMM('L','U',n,m,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,C,n)
            call DGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
            deallocate(C)
        end if
#endif
    end if
    call Matrix_End('RotateSymm')


    end subroutine Matrix_RotateSymm


    subroutine Matrix_RotateAntiSymm(Mat,U,m,Out)
    !Gets U^T Mat U
    !Where Mat = -Mat^T
    integer, intent(in) ::m
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), dimension(:,:), allocatable :: C
    integer i,j,n

    call Matrix_Start('RotateAntiSymm')

    n = Size(Mat,DIM=1)
    if (n /= Size(Mat,DIM=2)) call MpiStop('Matrix_RotateAntiSymm: Need square matrix')
    if (n /= Size(U,DIM=1)) call MpiStop('Matrix_RotateAntiSymm: Matrix size mismatch')
    if (Size(Out,DIM=1) < m .or. Size(Out,DIM=2) < m) &
        call MpiStop('Matrix_RotateAntiSymm: Wrong output size')

    if (matrix_method == Mat_F90) then
        Out = matmul(matmul(transpose(U(1:n,1:m)),Mat),U(1:n,1:m))
    else
        allocate(C(n,m))
        C = U(1:n,1:m)
#ifdef MATRIX_SINGLE
        call STRMM('Left','Lower','Not-Transpose','Not-unit',n,m,ROne,Mat,Size(Mat,DIM=1),C,Size(C,Dim=1))
        call SGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
#else
        call DTRMM('Left','Lower','Not-Transpose','Not-unit',n,m,ROne,Mat,Size(Mat,DIM=1),C,Size(C,Dim=1))
        call DGEMM('T','N',m,m,n,ROne,U,Size(U,DIM=1),C,n,RZero,Out,Size(Out,Dim=1))
#endif
        deallocate(C)
    end if

    do i=1, m
        do j=1,i
            Out(j,i) = Out(j,i) - Out(i,j)
            out(i,j) = -Out(j,i)
        end do
    end do

    call Matrix_End('RotateAntiSymm')

    end subroutine Matrix_RotateAntiSymm

    subroutine Matrix_CMult_SymmRight(Mat,U,Out,a,b)
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta
    integer n,m

    call Matrix_Start('CMult_SymmRight')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (n /= Size(Mat,DIM=2) .or. n/=Size(U,DIM=1)) &
        call MpiStop('Matrix_CMult_SymmRight: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b
    else
        beta = CZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CHEMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#else
        call ZHEMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('CMult_SymmRight')

    end subroutine Matrix_CMult_SymmRight


    subroutine Matrix_CMult_SymmLeft(Mat,U,Out,a,b)
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta
    integer n,m

    call Matrix_Start('CMult_SymmLeft')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (m /= Size(U,DIM=1) .or. m/=Size(Mat,DIM=2)) &
        call MpiStop('Matrix_CMult_SymmLeft: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b
    else
        beta = CZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CHEMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#else
        call ZHEMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('CMult_SymmLeft')

    end subroutine Matrix_CMult_SymmLeft


    subroutine Matrix_CMult(Mat,U,Out,a,b)
    ! Out = a*Mat U + b*out
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta
    integer m,n,k

    call Matrix_Start('CMult')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_Mult: Matrix size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b
    else
        beta = CZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#else
        call ZGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMult')


    end subroutine Matrix_CMult


    subroutine Matrix_MultSq_RepRight(Mat,U,a)
    !U = a*Mat*U
    real(dm), intent(in) :: Mat(:,:)
    real(dm), intent(inout) ::U(:,:)
    real(dm), intent(in), optional :: a
    real(dm) aa
    integer m,n
    real(dm), dimension(:,:), allocatable :: tmp


    m = Size(Mat,DIM=1)
    n = Size(Mat,DIM=2)
    if (m /= n) call MpiStop('Matrix_MultSq: Matrix size mismatch')
    m = Size(U,DIM=1)
    n = Size(U,DIM=2)
    if (m /= n) call MpiStop('Matrix_MultSq: Matrix size mismatch')

    allocate(tmp(n,n))
    if (present(a)) then
        aa=a
    else
        aa=ROne
    end if

    call Matrix_Mult(Mat,U,tmp,aa)
    U = tmp
    deallocate(tmp)

    end  subroutine Matrix_MultSq_RepRight

    subroutine Matrix_MultTri(Mat,L, side)
    ! Mat -> L Mat or Mat L where L is lower triangular
    real(dm), intent(inout) :: Mat(:,:)
    real(dm), intent(in) :: L(:,:)
    character(LEN=*), intent(in) :: side
    integer m,n

    call Matrix_Start('Matrix_MultTri')

    m = Size(Mat,DIM=1)
    n = Size(Mat,DIM=2)

    if (side(1:1)=='L') then
        if (Size(L,DIM=2) /= m) call MpiStop('Matrix_MultTri: Matrix size mismatch')
    else
        if (Size(L,DIM=1) /= n) call MpiStop('Matrix_MultTri: Matrix size mismatch')
    end if
#ifdef MATRIX_SINGLE
    call STRMM(side,'Lower','Not-Transpose','Not-unit',m,n,ROne,L,Size(L,DIM=1),Mat,Size(Mat,Dim=1))
#else
    call DTRMM(side,'Lower','Not-Transpose','Not-unit',m,n,ROne,L,Size(L,DIM=1),Mat,Size(Mat,Dim=1))
#endif
    call Matrix_End('Matrix_MultTri')

    end subroutine Matrix_MultTri



    subroutine Matrix_Mult(Mat,U,Out,a,b)
    ! Out = a*Mat U + b*out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) :: Out(:,:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer m,n,k

    call Matrix_Start('Mult')


    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_Mult: Matrix size mismatch')


    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= ROne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#else
        call DGEMM('N','N',m,n,k,mult,Mat,m,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('Mult')


    end subroutine Matrix_Mult

    subroutine Matrix_Mult_SymmLeft(Mat,U,Out,a,b)
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer n,m

    call Matrix_Start('Mult_SymmLeft')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (m /= Size(U,DIM=1) .or. m/=Size(Mat,DIM=2)) &
        call MpiStop('Matrix_Mult_SymmLeft: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= COne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SSYMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#else
        call DSYMM('L','U',m,n,mult,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('Mult_SymmLeft')

    end subroutine Matrix_Mult_SymmLeft


    subroutine Matrix_Mult_SymmRight(Mat,U,Out,a,b)
    ! Out = a*Mat U + b*out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer n,m

    call Matrix_Start('Mult_SymmRight')

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=2)
    if (n /= Size(Mat,DIM=2) .or. n/=Size(U,DIM=1)) &
        call MpiStop('Matrix_Mult_SymmRight: Size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,U) + beta*Out
        else
            out = MatMul(Mat,U)
            if (mult /= ROne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SSYMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#else
        call DSYMM('R','U',m,n,mult,U,Size(U,DIM=1),Mat,Size(Mat,DIM=1),beta,Out,Size(Out,DIM=1))
#endif
    end if

    call Matrix_End('Mult_SymmRight')

    end subroutine Matrix_Mult_SymmRight


    subroutine Matrix_CMultGen(Mat,m,k,U,n,Out)
    !     out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    integer, intent(in) :: m,k,n
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)

    call Matrix_Start('CMultGen')

    if (SIZE(Out,DIM=1) <m .or. Size(Out,Dim=2) < n) call MpiStop('Matrix_CMultGen: bad Out size')

    if (matrix_method == Mat_F90) then
        out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    else
#ifdef MATRIX_SINGLE
        call CGEMM('N','N',m,n,k,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
#else
        call ZGEMM('N','N',m,n,k,COne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),CZero,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMultGen')


    end subroutine Matrix_CMultGen



    subroutine Matrix_MultGen(Mat,m,k,U,n,Out)
    !     out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    integer, intent(in) :: m,k,n
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)

    call Matrix_Start('MultGen')

    if (SIZE(Out,DIM=1) <m .or. Size(Out,Dim=2) < n) call MpiStop('Matrix_MultGen: bad Out size')

    if (matrix_method == Mat_F90) then
        out(1:m,1:n) = MatMul(Mat(1:m,1:k),U(1:k,1:n))
    else
#ifdef MATRIX_SINGLE
        call SGEMM('N','N',m,n,k,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
#else
        call DGEMM('N','N',m,n,k,ROne,Mat,Size(Mat,DIM=1),U,Size(U,DIM=1),RZero,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('MultGen')


    end subroutine Matrix_MultGen


    subroutine Matrix_CMult_NT(Mat,U,Out,a,b)
    ! Out = a*Mat U^dag + b*out
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta
    integer m,n,k

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=1)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=2)) call MpiStop('Matrix_CMult_NT: Matrix size mismatch')
    call Matrix_start('CMult_NT')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b
    else
        beta = CZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            Out = beta*Out + mult*matmul(Mat,conjg(transpose(U)))
        else
            Out = matmul(Mat,conjg(transpose(U)))
            if (mult/= COne) Out=Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CGEMM('N','C',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#else
        call ZGEMM('N','C',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMult_NT')


    end subroutine Matrix_CMult_NT

    subroutine Matrix_Mult_NT(Mat,U,Out,a,b)
    ! Out = a*Mat U^T + b*out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer m,n,k

    m = Size(Mat,DIM=1)
    n = Size(U,DIM=1)
    k = Size(Mat,DIM=2)
    if (k /= Size(U,DIM=2)) call MpiStop('Matrix_Mult_NT: Matrix size mismatch')
    call Matrix_start('Mult_NT')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            Out = beta*Out + mult*matmul(Mat,transpose(U))
        else
            Out = matmul(Mat,transpose(U))
            if (mult/= ROne) Out=Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SGEMM('N','T',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#else
        call DGEMM('N','T',m,n,k,mult,Mat,m,U,n,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('Mult_NT')


    end subroutine Matrix_Mult_NT


    subroutine Matrix_CMult_TN(Mat,U,Out,a,b)
    ! Out = a*Mat^dag U + b*Out
    complex(dm), intent(in) :: Mat(:,:),U(:,:)
    complex(dm) Out(:,:)
    complex(dm), intent(in), optional :: a,b
    complex(dm)  mult, beta
    integer m,n,k

    m = Size(Mat,DIM=2)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=1)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_CMult_TN: Matrix size mismatch')

    call Matrix_Start('CMult_TN')
    if (present(a)) then
        mult = a
    else
        mult = COne
    end if
    if (present(b)) then
        beta = b
    else
        beta = CZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = mult*MatMul(conjg(transpose(Mat)),U) + beta*out
        else
            out = MatMul(conjg(transpose(Mat)),U)
            if (mult /= COne) out = out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call CGEMM('C','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#else
        call ZGEMM('C','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('CMult_TN')

    end subroutine Matrix_CMult_TN

    subroutine Matrix_Mult_TN(Mat,U,Out,a,b)
    ! Out = a*Mat^dag U + b*Out
    real(dm), intent(in) :: Mat(:,:),U(:,:)
    real(dm) Out(:,:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer m,n,k

    m = Size(Mat,DIM=2)
    n = Size(U,DIM=2)
    k = Size(Mat,DIM=1)
    if (k /= Size(U,DIM=1)) call MpiStop('Matrix_Mult_TN: Matrix size mismatch')

    call Matrix_Start('CMult_TN')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if
    if (matrix_method == Mat_F90) then
        if (beta /= CZero) then
            out = mult*MatMul(transpose(Mat),U) + beta*out
        else
            out = MatMul(transpose(Mat),U)
            if (mult /= COne) out = out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SGEMM('T','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#else
        call DGEMM('T','N',m,n,k,mult,Mat,k,U,k,beta,Out,Size(Out,Dim=1))
#endif
    end if
    call Matrix_End('Mult_TN')

    end subroutine Matrix_Mult_TN

    subroutine Matrix_Cholesky(M, err, zeroed)
    !Note upper triangular is not zeroed
    real(dm), intent(inout):: M(:,:)
    integer n, info
    integer, optional :: err
    logical, intent(in), optional :: zeroed
    integer i

    n=Size(M,DIM=1)
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_Cholesky: non-square matrix')

#ifdef MATRIX_SINGLE
    call spotrf ('L', n, M, n, info)
#else
    call dpotrf ('L', n, M, n, info)
#endif

    if (present(err)) then
        err = info
    else
        if (info/=0) &
            call MpiStop('Matrix_Cholesky: not positive definite '//trim(IntToStr(info)))
    end if

    if (info==0 .and. present(zeroed)) then
        do i=1,n
            M(1:i-1,i)=0
        end do
    end if

    end subroutine Matrix_Cholesky

    subroutine Matrix_CCholesky(M)
    !M = L L^\dag
    complex(dm), intent(inout):: M(:,:)
    integer n, info

    n=Size(M,DIM=1)
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_CCholesky: non-square matrix')

#ifdef MATRIX_SINGLE
    call cpotrf ('L', n, M, n, info)
#else
    call zpotrf ('L', n, M, n, info)
#endif

    if (info/=0) call MpiStop('Matrix_CCholesky: not positive definite '//trim(IntToStr(info)))

    end subroutine Matrix_CCholesky


    subroutine Matrix_CholeskyRootInverse(M,transpose, error)
    !M = L L^T and return L^{-1} in M  ( or [L^(-1}]^T )
    real(dm), intent(inout):: M(:,:)
    integer n, info
    integer i,j
    logical, intent(in), optional :: transpose
    integer, intent(out), optional :: error
    logical trans

    call Matrix_Cholesky(M, info)
    if (info==0) then
        n=size(M,dim=1)
#ifdef MATRIX_SINGLE
        call STRTRI( 'L', 'N', n, M, n, INFO )
#else
        call DTRTRI( 'L', 'N', n, M, n, INFO )
#endif
    end if
    if (present(error)) error=info
    if (info/=0) then
        if (present(error)) return
        call MpiStop('Matrix_CholeskyRootInverse: not positive definite '//trim(IntToStr(info)))
    end if

    if (present(transpose)) then
        trans = transpose
    else
        trans = .false.
    end if

    if (trans) then
        do i=1,n
            do j=1,i-1
                M(j,i) = M(i,j)
                M(i,j) = 0
            end do
        end do
    else
        do i=1,n
            do j=1,i-1
                M(j,i) = 0
            end do
        end do
    end if
    end subroutine Matrix_CholeskyRootInverse

    subroutine Matrix_CCholeskyRootInverse(M,dagger)
    !M = L L^\dag and return L^{-1} in M  ( or [L^(-1}]^\dag )
    complex(dm), intent(inout):: M(:,:)
    integer n, info
    integer i,j
    logical, intent(in), optional :: dagger
    logical trans

    call Matrix_CCholesky(M)
    n=size(M,dim=1)

#ifdef MATRIX_SINGLE
    call CTRTRI( 'L', 'N', n, M, n, INFO )
#else
    call ZTRTRI( 'L', 'N', n, M, n, INFO )
#endif

    if (info/=0) call MpiStop('Matrix_CCholeskyRootInverse: not positive definite '//trim(IntToStr(info)))

    if (present(dagger)) then
        trans = dagger
    else
        trans = .false.
    end if

    if (trans) then
        do i=1,n
            do j=1,i-1
                M(j,i) = conjg(M(i,j))
                M(i,j) = 0
            end do
        end do
    else
        do i=1,n
            do j=1,i-1
                M(j,i) = 0
            end do
        end do
    end if
    end subroutine Matrix_CCholeskyRootInverse


    subroutine Matrix_inverse_chol(M, err)
    !Inverse of symmetric matrix
    !This should not be used in real situations, but useful for quick testing
    real(dm), intent(inout):: M(:,:)
    integer i,j,n
    integer info
    integer, optional :: err

    n=Size(M,DIM=1)
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_Inverse: non-square matrix')
    call Matrix_Start('Inverse')
    if (present(err)) then
        call Matrix_Cholesky(M,err)
        if (err/=0) return
    else
        call Matrix_Cholesky(M)
    end if
#ifdef MATRIX_SINGLE
    call spotri ('L', n, M, n, info)
#else
    call dpotri ('L', n, M, n, info)
#endif
    if (present(err)) then
        err = info
        if (err/=0) return
    else
        if (info/=0) call MpiStop('Matrix_inverse: error '//trim(IntToStr(info)))
    end if
    do i=1,n
        do j=1,i-1
            M(j,i) = M(i,j)
        end do
    end do
    call Matrix_End('Inverse')

    end   subroutine Matrix_inverse_chol

    subroutine Matrix_Inverse(M)
    !Inverse of symmetric positive definite matrix
    real(dm), intent(inout):: M(:,:)
    integer i, n

    !     real(dm) w(Size(M,DIM=1))
    !     real(dm), dimension(:,:), allocatable :: tmp, tmp2
    !     real(dm), dimension(:), allocatable :: norm


    n = size(M,DIM=1)
    do i=1, size(M,DIM=1)
        if (abs(M(i,i)) < 1d-30) call MpiStop('Matrix_Inverse: very small diagonal'  )
    end do

    call Matrix_Inverse_Chol(M)
    !
    !     allocate(tmp(Size(M,DIM=1),Size(M,DIM=1)))
    !
    !     n=Size(M,DIM=1)
    !     if (n<=1) return
    !     if (Size(M,DIM=2)/=n) call MpiStop('Matrix_Inverse: non-square matrix')
    !     call Matrix_Start('Inverse')
    !
    !
    !     allocate(norm(n))
    !     do i=1, n
    !        norm(i) = sqrt(abs(M(i,i)))
    !        if (norm(i) < 1d-30) &
    !         call MpiStop('Matrix_Inverse: very small diagonal'  )
    !        M(i,:) = M(i,:)/norm(i)
    !        M(:,i) = M(:,i)/norm(i)
    !     end do
    !
    !     call Matrix_Diagonalize(M,w,n)
    !     write (*,*), 'min/max eigenvalues = ', minval(w), maxval(w)
    !     if (any(w<=0)) then
    !          write (*,*), 'min/max eigenvalues = ', minval(w), maxval(w)
    !          call MpiStop('Matrix_Inverse: negative or zero eigenvalues')
    !     end if
    !     do i=1, n
    !        tmp(i,:) = M(:,i)/w(i)
    !     end do
    !     allocate(tmp2(Size(M,DIM=1),Size(M,DIM=1)))
    !     call Matrix_Mult(M,tmp,tmp2)
    !     M = tmp2
    !     do i=1, n
    !        M(i,:) = M(i,:)/norm(i)
    !        M(:,i) = M(:,i)/norm(i)
    !     end do
    !     deallocate(tmp, tmp2)
    !     deallocate(norm)
    !     call Matrix_End('Inverse')

    end subroutine Matrix_Inverse

    function Matrix_GaussianLogLike(Cov, d) result(LogLike)
    !Returns -Log Likelihood for Gaussian: (d^T Cov^{-1} d + log|Cov|)/2
    !** Cov is destroyed by the function** [replaced by choleksy lower triangular]
    real(dm), intent(inout):: Cov(:,:)
    real(dm), intent(in):: d(:)
    real(dm), allocatable :: tmp(:)
    real(dm) :: LogLike
    integer info,i,n

    call Matrix_Start('GaussianLogLike')
    n = size(COV,DIM=1)
    if (Size(COV,DIM=2)/=n) call MpiStop('Matrix_GaussianLogLike: non-square matrix')
    if (Size(d)/=n) call MpiStop('Matrix_GaussianLogLike: covariance and d different size')

    call Matrix_Cholesky(Cov)
    LogLike = 0
    !Log Det term:
    do i=1, n
        LogLike = LogLike  + log(Cov(i,i))
    end do

    !Solve for Cov^{-1}d [could use faster symmetric method]
    allocate(tmp(n))
    tmp = d
#ifdef MATRIX_SINGLE
    call SPOTRS('L', N, 1, Cov, n, tmp, n, INFO )
#else
    call DPOTRS('L', N, 1, Cov, n, tmp, n, INFO )
#endif
    if (INFO/=0) call MpiStop('Matrix_GaussianLogLike: error in solving for cov^{-1}d')

    !Add together
    LogLike = LogLike + dot_product(tmp,d)/2._dm
    deallocate(tmp)

    call Matrix_End('GaussianLogLike')

    end function Matrix_GaussianLogLike

    function Matrix_GaussianLogLikeDouble(Cov, d) result(LogLike)
    !Returns -Log Likelihood for Gaussian: (d^T Cov^{-1} d + log|Cov|)/2
    !** Cov is destroyed by the function** [replaced by choleksy lower triangular]
    double precision, intent(inout):: Cov(:,:)
    double precision, intent(in):: d(:)
    double precision, allocatable :: tmp(:)
    double precision :: LogLike
    integer info,i,n

    call Matrix_Start('GaussianLogLikeDouble')
    n = size(COV,DIM=1)
    if (Size(COV,DIM=2)/=n) call MpiStop('Matrix_GaussianLogLikeDouble: non-square matrix')
    if (Size(d)/=n) call MpiStop('Matrix_GaussianLogLikeDouble: covariance and d different size')

    call dpotrf ('L', n, Cov, n, info)
    if (info/=0) call MpiStop('Matrix_GaussianLogLikeDouble: not positive definite '//trim(IntToStr(info)))

    LogLike = 0
    !Log Det term:
    do i=1, n
        LogLike = LogLike  + log(Cov(i,i))
    end do

    !Solve for Cov^{-1}d [could use faster symmetric method]
    allocate(tmp(n))
    tmp = d
    call DPOTRS('L', N, 1, Cov, n, tmp, n, INFO )
    if (INFO/=0) call MpiStop('Matrix_GaussianLogLikeDouble: error in solving for cov^{-1}d')

    !Add together
    LogLike = LogLike + dot_product(tmp,d)/2._dm
    deallocate(tmp)

    call Matrix_End('GaussianLogLikeDouble')

    end function Matrix_GaussianLogLikeDouble

    subroutine Matrix_InverseAsymm(M)
    !This should not be used in real situations, but useful for quick testing
    real(dm), intent(inout):: M(:,:)
    real(dm) w(Size(M,DIM=1))
    real(dm), dimension(:,:), allocatable :: tmp, VT
    integer i, n

    n=Size(M,DIM=1)
    if (n<=1) return
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_InverseAsymm: non-square matrix')

    allocate(tmp(n,n),VT(n,n))

    call Matrix_SVD(M,n,n,w,VT)

    do i=1, n
        tmp(i,:) = M(:,i)/w(i)
    end do

    call Matrix_Mult_TN(VT,tmp,M,1._dm,0._dm)
    !  M = matmul(transpose(VT),tmp)   //Changed for HPCF prob Sept 07

    deallocate(tmp,VT)

    end subroutine Matrix_InverseAsymm

    subroutine Matrix_SVD(Mat,m, n, D, VT)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^T
    !returns U in Mat, vector D of diagonal elements of, orthogonal matrix VT= V^T
    integer, intent(in) :: m,n
    real(dm), intent(inout) :: Mat(m,n)
    real(dm), intent(out) :: D(n), VT(n,n)

    integer WorkSize, ierr
    real(dm), allocatable, dimension (:) :: rv1


    WorkSize=3*n**2

    allocate(rv1(WorkSize))
    call Matrix_Start('SVD')
#ifdef MATRIX_SINGLE
    call SGESVD('O','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,ierr)
#else
    call DGESVD('O','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,ierr)
#endif
    if (ierr/=0) call MpiStop('error in Matrix_SVD')
    call Matrix_End('SVD')

    deallocate(rv1)

    end subroutine Matrix_SVD

    subroutine Matrix_SVD_VT(Mat,m, n, D, U)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^dag
    !returns V^dag in Mat, vector D of diagonal elements of, unitary matrix U
    integer, intent(in) :: m,n
    real(dm), intent(inout) :: Mat(m,n)
    real(dm), intent(out),optional :: U(m,m)
    real(dm), intent(out) :: D(*)

    integer WorkSize, ierr
    integer,allocatable, dimension (:) :: IWork
    real(dm), allocatable, dimension (:) :: rv1
    real(dm) OptWk(1)

    if (n<=m) call MpiStop('Matrix_SVD_VT assumed n>m. ')

    call Matrix_Start('SVD_VT')

    if (present(U) .and. Matrix_method == Mat_DC) then
        !Use divide and conquer
        allocate(IWork(8*MIN(M,N)))
        WorkSize= -1 !3*min(M,N)*min(M,N) +max(max(M,N),5*min(M,N)*min(M,N)+4*min(M,N))
#ifdef MATRIX_SINGLE
        call SGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,OptWk,WorkSize,IWork,ierr)
#else
        call DGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,OptWk,WorkSize,IWork,ierr)
#endif
        WorkSize = nint(OptWk(1))
        allocate(rv1(WorkSize))
#ifdef MATRIX_SINGLE
        call SGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,IWork,ierr)
#else
        call DGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,IWork,ierr)
#endif
        deallocate(IWOrk)
    else
        call MpiStop('Matrix_SVD_VT Not no-U non-DC case')
    end if

    if (ierr/=0) call MpiStop('error in Matrix_SVD_VT')
    deallocate(rv1)

    call Matrix_End('SVD_VT')

    end subroutine Matrix_SVD_VT


    subroutine Matrix_CSVD_VT(Mat,m, n, D, U)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^dag
    !returns V^dag in Mat, vector D of diagonal elements of, unitary matrix U
    integer, intent(in) :: m,n
    complex(dm), intent(inout) :: Mat(m,n)
    complex(dm), intent(out),optional :: U(m,m)
    real(dm), intent(out) :: D(*)

    integer WorkSize, ierr
    integer,allocatable, dimension (:) :: IWork
    complex(dm), allocatable, dimension (:) :: rv1
    real(dm), allocatable, dimension (:) :: rwork

    if (n<=m) call MpiStop('Matrix_CSVD_VT assumed n>m. If equal use SVD_U.')

    call Matrix_Start('CSVD_VT')


    if (present(U) .and. Matrix_method == Mat_DC) then
        !Use divide and conquer
        WorkSize= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N) + 5*N !Add on 5N..
        allocate(rv1(WorkSize))
        allocate(rwork(5*min(M,N)*min(M,N) + 5*min(M,N) ))
        allocate(IWork(8*MIN(M,N)))
#ifdef MATRIX_SINGLE
        call CGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,rwork,IWork,ierr)
#else
        call ZGESDD('O',m,n, Mat, m ,D,U,m,Mat,n,rv1,WorkSize,rwork,IWork,ierr)
#endif
        deallocate(IWOrk)
    else
        allocate(rwork((max(3*min(m,n),5*min(m,n)-4))))
        WorkSize= 3*max(m,n)**2
        allocate(rv1(WorkSize), STAT = ierr)
        if (ierr /=0) then
            WorkSize= MAX(3*MIN(M,N)+MAX(M,N),5*MIN(M,N))
            allocate(rv1(WorkSize))
        end if
#ifdef MATRIX_SINGLE
        if (present(U)) then
            call CGESVD('S','O',m,n, Mat, m , D,U,m,Mat,n,rv1,WorkSize,rwork,ierr)
        else
            call CGESVD('N','O',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr)
        end if
#else
        if (present(U)) then
            call ZGESVD('S','O',m,n, Mat, m , D,U,m,Mat,n,rv1,WorkSize,rwork,ierr)
        else
            call ZGESVD('N','O',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr)
        end if
#endif
    end if

    if (ierr/=0) call MpiStop('error in Matrix_SVD_VT')
    deallocate(rv1)

    call Matrix_End('SVD_VT')

    end subroutine Matrix_CSVD_VT

    subroutine Matrix_CSVD_U(Mat,m, n, D, VT)
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D VT
    !returns U in Mat, vector D of diagonal elements of, unitary matrix V
    integer, intent(in) :: m,n
    complex(dm), intent(inout) :: Mat(m,n)
    complex(dm), intent(out),optional :: VT(n,n)
    real(dm), intent(out) :: D(*)
    integer WorkSize, ierr
    integer,allocatable, dimension (:) :: IWork
    complex(dm), allocatable, dimension (:) :: rv1
    real(dm), allocatable, dimension (:) :: rwork

    call Matrix_Start('CSVD_U')

    if (m<n) call MpiStop('Matrix_CSVD_U assumed m>=n')

    if (present(VT) .and. Matrix_method == Mat_DC) then
        WorkSize= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N) + 5*N !Add on 5N..
        allocate(rv1(WorkSize))
        allocate(rwork(5*min(M,N)*min(M,N) + 5*min(M,N) ))
        allocate(IWork(8*MIN(M,N)))
#ifdef MATRIX_SINGLE
        call CGESDD('O',m,n, Mat, m ,D,Mat,m,VT,n,rv1,WorkSize,rwork,IWork,ierr)
#else
        call ZGESDD('O',m,n, Mat, m ,D,Mat,m,VT,n,rv1,WorkSize,rwork,IWork,ierr)
#endif
        deallocate(IWOrk)
    else
        allocate(rwork((max(3*min(m,n),5*min(m,n)-4))))

        WorkSize= 3*max(m,n)**2
        allocate(rv1(WorkSize), STAT = ierr)
        if (ierr /=0) then
            WorkSize= MAX(3*MIN(M,N)+MAX(M,N),5*MIN(M,N))
            allocate(rv1(WorkSize))
        end if
#ifdef MATRIX_SINGLE
        if (present(VT)) then
            call CGESVD('O','S',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr)
        else
            call CGESVD('O','N',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr)
        end if
#else
        if (present(VT)) then
            call ZGESVD('O','S',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr)
        else
            call ZGESVD('O','N',m,n, Mat, m , D,Mat,m,Mat,n,rv1,WorkSize,rwork,ierr)
        end if
#endif
    end if
    if (ierr/=0) call MpiStop('error in Matrix_SVD_U')
    call Matrix_End('CSVD_U')

    deallocate(rv1,rwork)

    end subroutine Matrix_CSVD_U


    subroutine Matrix_CSVD_AllVT(Mat,m, n, D, VT)
    !n>m
    !Do singular value decomposition of m x n matrix Mat
    !Mat =  U D V^dag
    !returns all nxn V^dag in VT, vector D of diagonal elements of
    integer, intent(in) :: m,n
    complex(dm), intent(inout) :: Mat(m,n)
    complex(dm), intent(out):: VT(n,n)
    real(dm), intent(out) :: D(m)

    integer WorkSize, ierr
    complex(dm), allocatable, dimension (:) :: rv1
    complex(dm), allocatable, dimension (:,:) :: U
    integer, allocatable, dimension(:) :: IWork
    real(dm), allocatable, dimension (:) :: rwork


    call Matrix_Start('CSVD_AllVT')

    if (Matrix_method == Mat_DC) then
        !Divide and conquer doesn't seem to provide outputs we want here
        WorkSize= 2*min(M,N)*min(M,N)+2*min(M,N)+max(M,N) + 5*N !Add on 5N..
        allocate(rv1(WorkSize))
        allocate(rwork(5*min(M,N)*min(M,N) + 5*min(M,N) ))
        allocate(IWork(8*MIN(M,N)))
        allocate(U(m,m))
#ifdef MATRIX_SINGLE
        call CGESDD('A',m,n, Mat, m ,D,U,m,VT,n,rv1,WorkSize,rwork,IWork,ierr)
#else
        call ZGESDD('A',m,n, Mat, m ,D,U,m,VT,n,rv1,WorkSize,rwork,IWork,ierr)
#endif
        deallocate(U)
        deallocate(IWork)
    else
        WorkSize=  2*m*n + 2*max(n,m)
        allocate(rwork(5*max(m,n)))
        allocate(rv1(WorkSize), STAT = ierr)
        if (ierr /=0) then
            WorkSize= MAX(3*MIN(M,N)+MAX(M,N),5*MIN(M,N))
            allocate(rv1(WorkSize))
        end if
#ifdef MATRIX_SINGLE
        call CGESVD('N','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr)
#else
        call ZGESVD('N','A',m,n, Mat, m , D,Mat,m,VT,n,rv1,WorkSize,rwork,ierr)
#endif
    end if

    if (ierr/=0) call MpiStop('error in Matrix_SVD_AllVT')
    deallocate(rv1,rwork)

    call Matrix_End('CSVD_AllVT')


    end subroutine Matrix_CSVD_allVT


    subroutine Matrix_DiagPreMul(D,M)
    ! M -> matmul(diag(D),M)
    real(dm), intent(inout) :: M(:,:)
    real(dm), intent(in) :: D(:)
    integer i

    if (Size(D) /= SiZE(M,DIM=1)) call MpiStop('Matrix_DiagPreMul: Wrong size')
    do i = 1, size(D)
        M(i,:) = M(i,:)*D(i)
    end do

    end subroutine Matrix_DiagPreMul


    subroutine Matrix_SolveSymm(M,a,soln)
    real(dm), intent(out) :: soln(:)
    real(dm), intent(in):: M(:,:),a(:)
    integer IPIV(size(a)),info
    real(dm), dimension(:,:), allocatable :: tmp
    real(dm), dimension(:), allocatable :: work
    integer n, WorkSize

    n=Size(M,DIM=1)
    if (n<=1) return
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_SolveSq: non-square matrix')
    call Matrix_Start('SolveSymm')


    WorkSize = n**2
    allocate(work(WorkSize))
    allocate(tmp(n,n))
    tmp = M
#ifdef MATRIX_SINGLE
    call SSYTRF('U',n,tmp,n,IPIV, work,WorkSize,info)
#else
    call DSYTRF('U',n,tmp,n,IPIV, work,WorkSize,info)
#endif
    deallocate(work)
    if (info/=0) call MpiStop('error in SolveSymm')
    soln(1:n) = a(1:n)
#ifdef MATRIX_SINGLE
    call SSYTRS('U',n,1,tmp,n,IPIV,soln,n,info)
#else
    call DSYTRS('U',n,1,tmp,n,IPIV,soln,n,info)
#endif
    if (info/=0) call MpiStop('error (2) in SolveSymm')
    deallocate(tmp)

    call Matrix_End('SolveSymm')


    end subroutine Matrix_SolveSymm


    subroutine Matrix_SolveASymm(M,a,soln)
    real(dm), intent(out) :: soln(:)
    real(dm), intent(in):: M(:,:),a(:)
    integer IPIV(size(a)),info
    real(dm), dimension(:,:), allocatable :: tmp
    integer n

    n=Size(M,DIM=1)
    if (n<=1) return
    if (Size(M,DIM=2)/=n) call MpiStop('Matrix_SolveSq: non-square matrix')

    call Matrix_Start('SolveASymm')

    allocate(tmp(n,n))
    tmp = M
#ifdef MATRIX_SINGLE
    call SGETRF(n,n,tmp,n,IPIV, info)
#else
    call DGETRF(n,n,tmp,n,IPIV, info)
#endif
    if (info/=0) call MpiStop('error in SolveASymm')
    soln(1:n) = a(1:n)
#ifdef MATRIX_SINGLE
    call SGETRS('N',n,1,tmp,n,IPIV,Soln,n,info)
#else
    call DGETRS('N',n,1,tmp,n,IPIV,Soln,n,info)
#endif
    if (info/=0) call MpiStop('error (2) in SolveASymm')
    deallocate(tmp)

    call Matrix_End('SolveASymm')

    end subroutine Matrix_SolveASymm

    function Matrix_vecdot(vec1,vec2)
    real(dm) vec1(:),vec2(:)
    real(dm) Matrix_vecdot
    integer n
#ifdef MATRIX_SINGLE
    real(dm) sdot
    external sdot
#else
    real(dm) ddot
    external ddot
#endif
    n=size(vec1)
    if (n/=size(vec2)) call MpiStop('Matrix_vecdot: size mismatch')
#ifdef MATRIX_SINGLE
    Matrix_vecdot = sdot(n, vec1, 1, vec2, 1)
#else
    Matrix_vecdot = ddot(n, vec1, 1, vec2, 1)
#endif
    end function Matrix_vecdot

    function Matrix_QuadForm(Mat,vec)
    !Get vec^T*Mat*vec where Mat is symmetric
    real(dm) Matrix_QuadForm
    real(dm) vec(:)
    real(dm) Mat(:,:)
    real(dm), dimension(:), allocatable :: out
    integer n

    n=size(vec)
    allocate(out(n))
    call Matrix_MulVecSymm(Mat,vec,out)
    Matrix_QuadForm = Matrix_vecdot(vec, out)
    deallocate(out)

    end function Matrix_QuadForm

    subroutine Matrix_MulVec(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real(dm), intent(in) :: Mat(:,:)
    real(dm) vec(:)
    real(dm) Out(:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer m,n

    call Matrix_Start('MulVec')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (Size(Mat,DIM=2) /= n) call MpiStop('Matrix_MulVec: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= ROne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SGEMV('N',m,n,mult,Mat,m,vec, 1,beta, Out,1)
#else
        call DGEMV('N',m,n,mult,Mat,m,vec, 1,beta, Out,1)
#endif
    end if
    call Matrix_End('MulVec')

    end subroutine Matrix_MulVec

    subroutine Matrix_MulVecSingle(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real, intent(in) :: Mat(:,:)
    real vec(:)
    real Out(:)
    real, intent(in), optional :: a,b
    real  mult, beta
    integer m,n

    call Matrix_Start('MulVecSingle')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (Size(Mat,DIM=2) /= n) call MpiStop('Matrix_MulVecSingle: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = SOne
    end if
    if (present(b)) then
        beta = b
    else
        beta = SZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= SZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= SOne) Out = Out*mult
        end if
    else
        call SGEMV('N',m,n,mult,Mat,m,vec, 1,beta, Out,1)
    end if
    call Matrix_End('MulVecSingle')

    end subroutine Matrix_MulVecSingle




    subroutine Matrix_MulVecSymm(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real(dm), intent(in) :: Mat(:,:)
    real(dm) vec(:)
    real(dm) Out(:)
    real(dm), intent(in), optional :: a,b
    real(dm)  mult, beta
    integer m,n

    call Matrix_Start('MulVecSymm')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (m /= n) call MpiStop('Matrix_MulVecSymm: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = ROne
    end if
    if (present(b)) then
        beta = b
    else
        beta = RZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= ROne) Out = Out*mult
        end if
    else
#ifdef MATRIX_SINGLE
        call SSYMV('U',m,mult,Mat,m,vec, 1,beta, Out,1)
#else
        call DSYMV('U',m,mult,Mat,m,vec, 1,beta, Out,1)
#endif
    end if
    call Matrix_End('MulVecSymm')

    end subroutine Matrix_MulVecSymm

    subroutine Matrix_MulVecSymmSingle(Mat,vec,Out,a,b)
    ! Out = a*Mat*vec + b*out
    real, intent(in) :: Mat(:,:)
    real vec(:)
    real Out(:)
    real, intent(in), optional :: a,b
    real  mult, beta
    integer m,n

    call Matrix_Start('MulVecSymm')

    m = Size(Mat,DIM=1)
    n = Size(Vec)
    if (m /= n) call MpiStop('Matrix_MulVecSymm: size mismatch')
    if (present(a)) then
        mult = a
    else
        mult = SOne
    end if
    if (present(b)) then
        beta = b
    else
        beta = SZero
    end if

    if (matrix_method == Mat_F90) then
        if (beta /= RZero) then
            out = a*MatMul(Mat,Vec) + beta*Out
        else
            out = MatMul(Mat,Vec)
            if (mult /= ROne) Out = Out*mult
        end if
    else
        call SSYMV('U',m,mult,Mat,m,vec, 1,beta, Out,1)
    end if
    call Matrix_End('MulVecSymmSingle')

    end subroutine Matrix_MulVecSymmSingle

    function Matrix_vecdotSingle(vec1,vec2)
    real vec1(:),vec2(:)
    real Matrix_vecdotSingle
    integer n
    real sdot
    external sdot

    n=size(vec1)
    if (n/=size(vec2)) call MpiStop('Matrix_vecdotSingle: size mismatch')
    Matrix_vecdotSingle = sdot(n, vec1, 1, vec2, 1)

    end function Matrix_vecdotSingle


    subroutine Matrix_InverseArrayMPI(Arr,nmat)
    !Invert array of matrices by sending each to separate CPU
    integer, intent(in) :: nmat
#ifdef __GFORTRAN__
    Type(TMatrixType), target :: Arr(:)
#else
    Type(TMatrixType), target :: Arr(*)
#endif
    Type(TMatrixType), pointer :: AM
    integer n
    integer i,MpiID, MpiSize
    integer sz
#ifdef MPI
    integer j, ierr, sid
    Type(TMatrixType), target :: tmp
#endif

    call MpiStat(MpiID, MpiSize)
    if (MpiId==0) then
        n=nmat
        sz = Size(Arr(1)%M,DIM=1)
    end if
    !    if (MpiID==0) then
    !     do i=1,nmat
    !      print *,'inverting',i
    !      call Matrix_inverse(Arr(i)%M)
    !     end do
    !    end if
    !    return
#ifdef MPI
    if (MpiID==0) print *, 'MatrixInverseArray: starting'
    call MPI_BCAST(n,1,MPI_INTEGER, 0, MPI_COMM_WORLD, ierr)
    call MPI_BCAST(sz,1,MPI_INTEGER, 0, MPI_COMM_WORLD, ierr)
    if (MpiID/=0) then
        allocate(tmp%M(sz,sz))
        AM => tmp
    end if
#endif

    do i= 1,n
        if (MpiID==0) AM => Arr(i)
#ifdef MPI
        if (mod(i,MpiSize)/=MpiID) then
            !Do nothing
            if (MpiId==0) then
                j=mod(i,MpiSize)
                call MPI_SEND(AM%M,size(AM%M),MPI_DOUBLE_PRECISION, j, 1, MPI_COMM_WORLD, ierr)
            end if
        else
            if (MpiId/=0) then
                !Get from main thread
                call MPI_RECV(AM%M,size(AM%M),MPI_DOUBLE_PRECISION, 0, 1, MPI_COMM_WORLD,MPI_STATUS_IGNORE, ierr)
            end if
#endif
            call Matrix_Inverse(AM%M)

#ifdef MPI
            if (MpiID==0) then
                do j = max(1,i-MpiSize+1),i-1
                    sid = mod(j,MpiSize)
                    call MPI_RECV(Arr(j)%M,size(Arr(j)%M),MPI_DOUBLE_PRECISION, sid, 1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr)
                end do
            else
                call MPI_SEND(AM%M,size(AM%M),MPI_DOUBLE_PRECISION, 0, 1, MPI_COMM_WORLD, ierr)
            end if
        end if
#endif
    end do


#ifdef MPI
    if (MpiID==0) then
        do j=n - mod(n,MpiSize) +1 ,n
            sid= mod(j,MpiSize)
            call MPI_RECV(ARr(j)%M,Size(ARr(j)%M),MPI_DOUBLE_PRECISION, sid, 1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, ierr)
        end do
    else
        deallocate(tmp%M)
    end if
#endif
    if (MpiID==0) print *, 'MatrixInverseArray: Done'


    end subroutine Matrix_InverseArrayMPI



    end module MatrixUtils

    module Interpolation
    use FileUtils
    use MpiUtils
    use MiscUtils
    use Stringutils
    use ObjectLists
    implicit none

#ifdef SINGLE
    integer, parameter :: sp_acc = KIND(1.0)
#else
    integer, parameter :: sp_acc = KIND(1.d0)
#endif
    real(sp_acc), parameter :: SPLINE_DANGLE=1.e30_sp_acc
    integer, parameter :: GI = sp_acc
    integer, parameter :: Interpolation_version = 1

    Type, extends(TSaveLoadStateObject) :: TInterpolator
        private
        logical :: initialized =.false.
    contains
    procedure :: FirstUse => TInterpolator_FirstUse
    procedure :: Error => TInterpolator_Error
    end Type TInterpolator

    type, extends(TInterpolator) :: TInterpolator1D
        real(sp_acc) :: Xmin_interp, Xmax_interp
        integer :: n = 0 !number of function points
        real(sp_acc), allocatable :: F(:) !function values
        real(sp_acc) :: fraction_tol =  1.e-5_sp_acc !fraction of step size allowed past end
        real(sp_acc), private :: Xmin_check, Xmax_check, Xend_tol_interp
        integer, private :: read_version = Interpolation_version
        real(sp_acc) :: start_bc = SPLINE_DANGLE
        real(sp_acc) :: end_bc = SPLINE_DANGLE
    contains
    procedure, private :: TInterpolator1D_IntValue
    procedure, private :: GetValue => TInterpolator1D_Value
    procedure :: Clear => TInterpolator1D_Clear
    procedure :: FirstUse =>  TInterpolator1D_FirstUse
    procedure :: LoadState => TInterpolator1D_LoadState
    procedure :: SaveState => TInterpolator1D_SaveState
    procedure :: InitForSize => TInterpolator1D_InitForSize
    procedure :: InitInterp => TInterpolator1D_InitInterp
    generic :: Value => GetValue, TInterpolator1D_IntValue
    end Type TInterpolator1D

    Type, extends(TInterpolator1D) :: TSpline1D
        real(sp_acc), allocatable :: ddF(:)
    contains
    procedure :: Clear => TSpline1D_Clear
    procedure :: GetValue => TSpline1D_Value
    procedure, private :: TSpline1D_ArrayValue
    procedure, private :: TSpline1D_IntRangeValue
    procedure :: Derivative => TSpline1D_Derivative
    procedure :: FindNext => TSpline1D_FindNext
    procedure :: FindValue => TSpline1D_FindValue
    generic :: Array => TSpline1D_ArrayValue, TSpline1D_IntRangeValue
    end Type TSpline1D


    Type, extends(TSpline1D) :: TCubicSpline
        ! 1D cubic spline interpolator with irregular monotonic X spacing
        real(sp_acc), allocatable :: X(:)
    contains
    procedure, private, nopass :: spline
    procedure, private :: TCubicSpline_Init
    procedure, private :: TCubicSpline_InitInt
    procedure :: InitFromFile => TCubicSpline_InitFromFile
    procedure :: InitForSize => TCubicSpline_InitForSize
    procedure :: InitInterp => TCubicSpline_InitInterp
    procedure :: Clear => TCubicSpline_Clear
    procedure :: FindNext => TCubicSpline_FindNext
    procedure :: FindValue => TCubicSpline_FindValue
    procedure :: LoadState => TCubicSpline_LoadState
    procedure :: SaveState => TCubicSpline_SaveState
    procedure :: IntegralArray => TCubicSpline_IntegralArray
    generic :: Init => TCubicSpline_Init, TCubicSpline_InitInt
    end Type

    Type, extends(TSpline1D) :: TRegularCubicSpline
        ! 1D interpolation with regular X spacing
        real(sp_acc) :: xmin, xmax, delta_x
    contains
    procedure, private, nopass :: regular_spline
    procedure :: Init => TRegularCubicSpline_Init
    procedure :: InitInterp => TRegularCubicSpline_InitInterp
    procedure :: FindNext => TRegularCubicSpline_FindNext
    procedure :: LoadState => TRegularCubicSpline_LoadState
    procedure :: SaveState => TRegularCubicSpline_SaveState
    end Type


    Type, extends(TRegularCubicSpline) :: TLogRegularCubicSpline
        ! 1D interpolation with regular log(X) spacing
    contains
    procedure :: Init => TLogRegularCubicSpline_Init
    procedure :: Derivative => TLogRegularCubicSpline_Derivative
    procedure :: GetValue => TLogRegularCubicSpline_Value
    end Type


    Type, extends(TInterpolator) :: TInterpGrid2D
        !      ALGORITHM 760, COLLECTED ALGORITHMS FROM ACM.
        !      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
        !      VOL. 22, NO. 3, September, 1996, P.  357--361.
        REAL(GI), private, allocatable :: wk(:,:,:)
        REAL(GI), allocatable :: x(:), y(:)
        REAL(GI), allocatable :: z(:,:)
        integer :: nx=0, ny=0
    contains
    procedure :: Init => TInterpGrid2D_Init
    procedure :: InitFromFile => TInterpGrid2D_InitFromFile
    procedure :: InitFromMatrixTextFile => TInterpGrid2D_InitFromMatrixTextFile
    procedure :: InitFromMatrixBinaryFile => TInterpGrid2D_InitFromMatrixBinaryFile
    procedure :: Value => TInterpGrid2D_Value !one point
    procedure :: Values => TInterpGrid2D_Values !array of points
    procedure :: Clear => TInterpGrid2D_Clear
    procedure, private :: InitInterp => TInterpGrid2D_InitInterp
    end Type TInterpGrid2D


    public TInterpolator1D, TSpline1D, TCubicSpline, TRegularCubicSpline, TInterpGrid2D, SPLINE_DANGLE

    contains

    subroutine TInterpolator_FirstUse(this)
    class(TInterpolator) this

    this%Initialized = .true.
    call this%error('TInterpolator not initialized')

    end subroutine TInterpolator_FirstUse

    subroutine TInterpolator_error(this,S,v1,v2)
    class(TInterpolator):: this
    character(LEN=*), intent(in) :: S
    class(*), intent(in), optional :: v1, v2

    call MpiStop(FormatString('Interpolation error: '//trim(S),v1,v2))

    end subroutine TInterpolator_error

    !!! 1D interpolation

    subroutine TInterpolator1D_FirstUse(this)
    class(TInterpolator1D) this

    if (.not. this%Initialized) then
        call this%InitInterp()
        this%Initialized = .true.
    end if

    end subroutine TInterpolator1D_FirstUse

    subroutine TInterpolator1D_InitInterp(this,End1,End2)
    class(TInterpolator1D):: this
    real(sp_acc), intent(in), optional :: End1, End2

    if (.not. allocated(this%F)) call this%error('Interpolator has no data')
    this%start_bc = PresentDefault(this%start_bc, End1)
    this%end_bc = PresentDefault(this%end_bc, End2)

    end subroutine TInterpolator1D_InitInterp

    subroutine TInterpolator1D_InitForSize(this, n)
    class(TInterpolator1D) :: this
    integer, intent(in) :: n

    call this%Clear()
    this%n = n
    allocate(this%F(this%n))

    end subroutine TInterpolator1D_InitForSize

    subroutine TInterpolator1D_Clear(this)
    class(TInterpolator1D) :: this

    if (allocated(this%F)) deallocate(this%F)
    this%n = 0
    this%start_bc = SPLINE_DANGLE
    this%end_bc = SPLINE_DANGLE
    this%Initialized = .false.

    end subroutine TInterpolator1D_Clear

    function TInterpolator1D_Value(this, x, error )
    class(TInterpolator1D) :: this
    real(sp_acc) :: TInterpolator1D_Value
    real(sp_acc), intent(in) :: x
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad

    TInterpolator1D_Value = 0
    call this%error('Value not implemented')

    end function TInterpolator1D_Value

    function TInterpolator1D_IntValue(this, x, error )
    class(TInterpolator1D) :: this
    real(sp_acc) :: TInterpolator1D_IntValue
    integer, intent(in) :: x
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad

    TInterpolator1D_IntValue = this%Value(real(x,sp_acc),error)

    end function TInterpolator1D_IntValue

    subroutine TInterpolator1D_LoadState(this,F)
    class(TInterpolator1D) :: this
    class(TFileStream) :: F
    integer n

    call this%Clear()
    call F%Read(n, this%read_version)
    if (n>0) then
        call this%InitForSize(n)
        call F%Read(this%F)
    end if
    end subroutine TInterpolator1D_LoadState

    subroutine TInterpolator1D_SaveState(this,F)
    class(TInterpolator1D) :: this
    class(TFileStream) :: F

    call F%Write(this%n, Interpolation_version)
    if (this%n>0) call F%Write(this%F)

    end subroutine TInterpolator1D_SaveState


    subroutine TSpline1D_FindNext(this, x, llo, xlo, xhi)
    class(TSpline1D) :: this
    real(sp_acc), intent(in) :: x
    integer, intent(inout) :: llo
    real(sp_acc), intent(out) :: xlo, xhi

    xlo = x
    xhi = 0
    llo=0
    call this%Error('FindNext not implemented')

    end subroutine TSpline1D_FindNext

    subroutine TSpline1D_FindValue(this, x, llo, xlo, xhi, error)
    class(TSpline1D) :: this
    real(sp_acc), intent(in) :: x
    integer, intent(out) :: llo
    real(sp_acc), intent(out) :: xlo, xhi
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad

    if (.not. this%Initialized) call this%FirstUse

    if (x< this%Xmin_check .or. x> this%Xmax_check) then
        if (present(error)) then
            error = -1
            return
        else
            call this%Error('Spline x = %f out of range',x)
        end if
    end if

    llo=1
    call this%FindNext(x,llo, xlo, xhi)

    end subroutine TSpline1D_FindValue


    function TSpline1D_Value(this, x, error )
    class(TSpline1D) :: this
    real(sp_acc) :: TSpline1D_Value
    real(sp_acc), intent(in) :: x
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad
    integer llo,lhi
    real(sp_acc) a0,b0,ho,xlo,xhi

    call this%FindValue(x, llo, xlo, xhi, error)

    lhi=llo+1
    ho=xhi - xlo
    a0=(xhi-x)/ho
    b0 = 1-a0
    !TSpline1D_Value = a0*this%F(llo)+ b0*this%F(lhi)+((a0**3-a0)* this%ddF(llo) +(b0**3-b0)*this%ddF(lhi))*ho**2/6
    TSpline1D_Value = b0*this%F(lhi)+a0*(this%F(llo) -b0*((a0+1)*this%ddF(llo) +(2-a0)*this%ddF(lhi))*ho**2/6)

    end function TSpline1D_Value

    ! Get derivative of spline
    function TSpline1D_Derivative(this, x, error )
    class(TSpline1D) :: this
    real(sp_acc) :: TSpline1D_Derivative
    real(sp_acc), intent(in) :: x
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad
    integer llo,lhi
    real(sp_acc) a0,b0,ho,dely, xlo, xhi

    call this%FindValue(x, llo, xlo, xhi, error)

    lhi=llo+1
    ho = xhi - xlo
    a0=(xhi-x)/ho
    b0 = 1-a0
    dely=this%F(lhi)-this%F(llo)
    TSpline1D_Derivative = dely/ho+ ((1-3*a0**2)*this%ddF(llo) + (3*b0**2-1)*this%ddF(lhi))*ho/6

    end function TSpline1D_Derivative

    subroutine TCubicSpline_IntegralArray(this, yint, first_index, last_index)
    !Array of values of integral at the original sampled points
    class(TCubicSpline) :: this
    real(sp_acc), intent(out) :: yint(*)
    integer, intent(in), optional :: first_index, last_index
    integer first, last
    real(sp_acc) dx
    integer i, ix

    First  = PresentDefault(1, first_index)
    Last = PresentDefault(this%n, last_index)
    yint(1) = 0
    ix = 2
    do i=first+1, last
        dx = (this%x(i) - this%x(i-1))
        yint(ix) = yint(ix-1) + dx*( (this%F(i)+this%F(i-1))/2 - dx**2/24*(this%ddF(i)+this%ddF(i-1)))
        ix = ix+1
    end do

    end subroutine TCubicSpline_IntegralArray

    subroutine TSpline1D_ArrayValue(this, x, y, error )
    !Get array of values y(x), assuming x is monotonically increasing
    class(TSpline1D) :: this
    real(sp_acc), intent(in) :: x(1:)
    real(sp_acc), intent(out) :: y(1:)
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad
    integer llo,lhi, i
    real(sp_acc) a0,b0,ho, xlo, xhi

    if (.not. this%Initialized) call this%FirstUse

    if (x(1)< this%Xmin_check .or. x(size(x))> this%Xmax_check) then
        if (present(error)) then
            error = -1
            return
        else
            call this%Error('Spline ArrayValue: out of range')
        end if
    end if

    llo=1
    do i=1, size(x)
        call this%FindNext(x(i),llo, xlo, xhi)
        lhi=llo+1
        ho=xhi - xlo
        a0=(xhi-x(i))/ho
        b0=1-a0
        y(i) = b0*this%F(lhi)+a0*(this%F(llo) -b0*((a0+1)*this%ddF(llo) +(2-a0)*this%ddF(lhi))*ho**2/6)
    end do

    end subroutine TSpline1D_ArrayValue

    subroutine TSpline1D_IntRangeValue(this, xmin, xmax, y, error )
    !Get array of values y(x), assuming x is monotonically increasing
    class(TSpline1D) :: this
    integer, intent(in) :: xmin, xmax
    real(sp_acc), intent(out) :: y(xmin:)
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad
    integer llo,lhi, x
    real(sp_acc) a0,b0,ho,xlo,xhi

    if (.not. this%Initialized) call this%FirstUse

    if (xmin< this%Xmin_check .or. xmax> this%Xmax_check ) then
        if (present(error)) then
            error = -1
            return
        else
            call this%Error('Array spline: limits out of range ')
        end if
    end if

    llo=1
    do x=xmin, xmax
        call this%FindNext(real(x,sp_acc),llo, xlo, xhi)
        lhi=llo+1
        ho=xhi-xlo
        a0=(xhi-x)/ho
        b0=1-a0
        y(x) = b0*this%F(lhi)+a0*(this%F(llo) -b0*((a0+1)*this%ddF(llo) +(2-a0)*this%ddF(lhi))*ho**2/6)
    end do

    end subroutine TSpline1D_IntRangeValue

    subroutine TSpline1D_Clear(this)
    class(TSpline1D) :: this

    call TInterpolator1D_Clear(this)
    if (allocated(this%ddF)) deallocate(this%ddF)

    end subroutine TSpline1D_Clear

    !Irregular Cubic spline

    subroutine TCubicSpline_InitForSize(this, n)
    class(TCubicSpline) :: this
    integer, intent(in) :: n

    call TInterpolator1D_InitForSize(this,n)
    allocate(this%X(this%n))

    end subroutine TCubicSpline_InitForSize


    subroutine TCubicSpline_Init(this, Xarr,  values, n, End1, End2 )
    class(TCubicSpline) :: this
    real(sp_acc), intent(in) :: Xarr(1:), values(1:)
    integer, intent(in), optional :: n
    real(sp_acc), intent(in), optional :: End1, End2

    call this%InitForSize(PresentDefault(size(Xarr),n))

    this%F = values(1:this%n)
    this%X = Xarr(1:this%n)
    call this%InitInterp(End1, End2)

    end subroutine TCubicSpline_Init

    subroutine TCubicSpline_InitInt(this, Xarr,  values, n, End1, End2 )
    class(TCubicSpline) :: this
    integer, intent(in) :: XArr(:)
    real(sp_acc), intent(in) :: values(:)
    real(sp_acc), allocatable :: XReal(:)
    integer, intent(in), optional :: n
    real(sp_acc), intent(in), optional :: End1, End2

    allocate(XReal(size(XArr)))
    XReal =  XArr
    call this%Init(XReal, values, n, End1, End2)

    end subroutine TCubicSpline_InitInt

    subroutine TCubicSpline_InitInterp(this,End1,End2)
    class(TCubicSpline):: this
    real(sp_acc), intent(in), optional :: End1, End2

    call this%TSpline1D%InitInterp(End1,End2)

    this%Xend_tol_interp = (this%X(2)-this%X(1))*this%fraction_tol
    this%Xmin_interp = this%X(1)
    this%Xmax_interp = this%X(this%n)
    this%Xmin_check = this%X(1) - this%Xend_tol_interp
    this%Xmax_check = this%X(this%n) + this%Xend_tol_interp
    allocate(this%ddF(this%n))
    call spline(this%X,this%F,this%n,this%start_bc,this%end_bc,this%ddF)
    this%Initialized = .true.

    end subroutine TCubicSpline_InitInterp

    subroutine TCubicSpline_InitFromFile(this, Filename, xcol, ycol)
    class(TCubicSpline):: this
    character(LEN=*), intent(in) :: Filename
    integer, intent(in), optional :: xcol, ycol
    integer :: ixcol=1,iycol=2
    integer :: nx,ny
    integer :: parse, status
    real(sp_acc), allocatable :: tmp(:)
    character(LEN=:), allocatable :: InLine
    Type(TTextFile) :: F
    if (present(xcol)) ixcol=xcol
    if (present(ycol)) iycol=ycol

    allocate(tmp(max(ixcol,iycol)))

    call F%Open(Filename)

    do parse=1,2
        ny=0
        nx=0
        do
            if (.not. F%ReadLineSkipEmptyAndComments(InLine)) exit

            read(InLine,*, iostat=status) tmp
            if (status/=0) call this%Error('Error reading line: '//trim(InLine))

            nx=nx+1
            if (parse==2) then
                this%X(nx) = tmp(ixcol)
                this%F(nx) = tmp(iycol)
            endif
        end do

        if (parse==2) exit

        if (nx<2) call this%Error('not enough values to interpolate')
        call this%InitForSize(nx)
        status=0
        call F%Rewind()
    end do

    call F%Close()

    call this%InitInterp()

    end subroutine TCubicSpline_InitFromFile

    subroutine TCubicSpline_Clear(this)
    class(TCubicSpline) :: this

    call this%TSpline1D%Clear()
    if (allocated(this%X)) deallocate(this%X)

    end subroutine TCubicSpline_Clear

    subroutine TCubicSpline_FindNext(this, x, llo, xlo, xhi)
    !No error checking, assumes x>= x at point point llo, updating llo
    class(TCubicSpline) :: this
    real(sp_acc), intent(in) :: x
    integer, intent(inout) :: llo
    real(sp_acc), intent(out) :: xlo, xhi

    do while (llo < this%n .and. this%X(llo+1) < x)  !could do binary search here if large
        llo = llo + 1
    end do
    xlo = this%X(llo)
    xhi = this%X(llo+1)

    end subroutine TCubicSpline_FindNext

    subroutine TCubicSpline_FindValue(this, x, llo, xlo, xhi, error)
    class(TCubicSpline) :: this
    real(sp_acc), intent(in) :: x
    integer, intent(out) :: llo
    integer lhi, k
    real(sp_acc), intent(out) :: xlo, xhi
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad

    if (.not. this%Initialized) call this%FirstUse
    if (x< this%Xmin_check .or. x> this%Xmax_check) then
        if (present(error)) then
            error = -1
            return
        else
            call this%Error('Spline x = %f out of range',x)
        end if
    end if

    llo=1
    lhi=this%n
    do while (lhi-llo > 1)
        k=(lhi+llo)/2
        if(this%X(k) > x)then
            lhi=k
        else
            llo=k
        endif
    end do
    xlo = this%X(llo)
    xhi = this%X(llo+1)

    end subroutine TCubicSpline_FindValue

    subroutine TCubicSpline_LoadState(this,F)
    class(TCubicSpline) :: this
    class(TFileStream) :: F

    call TInterpolator1D_LoadState(this,F)
    if (this%n>0) then
        call F%Read(this%X)
        call F%Read(this%start_bc, this%end_bc)
        call this%InitInterp(this%start_bc, this%end_bc)
    end if

    end subroutine TCubicSpline_LoadState

    subroutine TCubicSpline_SaveState(this,F)
    class(TCubicSpline) :: this
    class(TFileStream) :: F

    call TInterpolator1D_SaveState(this,F)
    if (this%n==0) return
    call F%Write(this%X)
    call F%Write(this%start_bc, this%end_bc)

    end subroutine TCubicSpline_SaveState

    !Cubic spline on regular x

    subroutine TRegularCubicSpline_Init(this, xmin, xmax, n, values, End1, End2 )
    class(TRegularCubicSpline) :: this
    real(sp_acc), intent(in) :: xmin, xmax
    integer, intent(in) :: n
    real(sp_acc), intent(in), optional :: values(1:)
    real(sp_acc), intent(in), optional :: End1, End2

    if (xmax < xmin) call this%Error('TRegularCubicSpline_Init xmax (%f) < xmin (%f)',xmax, xmin)
    if (n<2) call this%Error('TRegularCubicSpline_Init needs at at least 2 points')
    call this%InitForSize(n)
    this%xmin =xmin
    this%xmax =xmax
    this%delta_x = (xmax - xmin)/(n-1)
    this%xmin_interp = xmin
    this%xmax_interp = xmax
    if (present(values)) then
        this%F = values(1:this%n)
        call this%InitInterp(End1, End2)
    end if

    end subroutine TRegularCubicSpline_Init

    subroutine TRegularCubicSpline_InitInterp(this,End1,End2)
    class(TRegularCubicSpline):: this
    real(sp_acc), intent(in), optional :: End1, End2

    call this%TSpline1D%InitInterp(End1,End2)

    this%Xend_tol_interp = this%delta_x*this%fraction_tol
    this%xmin_check = this%xmin_interp - this%Xend_tol_interp
    this%xmax_check = this%xmax_interp + this%Xend_tol_interp
    allocate(this%ddF(this%n))
    call regular_spline(this%delta_x,this%F,this%n,this%start_bc,this%end_bc,this%ddF)
    this%Initialized = .true.

    end subroutine TRegularCubicSpline_InitInterp


    subroutine TRegularCubicSpline_FindNext(this, x, llo, xlo, xhi)
    class(TRegularCubicSpline) :: this
    real(sp_acc), intent(in) :: x
    integer, intent(inout) :: llo
    real(sp_acc), intent(out) :: xlo, xhi

    llo = min(max(0,int((x - this%xmin_interp)/this%delta_x)), this%n-2)
    xlo = this%xmin_interp + llo*this%delta_x
    llo = llo+1
    xhi = xlo + this%delta_x

    end subroutine TRegularCubicSpline_FindNext

    subroutine TRegularCubicSpline_LoadState(this,F)
    class(TRegularCubicSpline) :: this
    class(TFileStream) :: F

    call TInterpolator1D_LoadState(this,F)
    call F%Read(this%xmin, this%xmax, this%delta_x)
    this%delta_x = (this%xmax - this%xmin)/(this%n-1)
    this%xmin_interp = this%xmin
    this%xmax_interp = this%xmax

    end subroutine TRegularCubicSpline_LoadState

    subroutine TRegularCubicSpline_SaveState(this,F)
    class(TRegularCubicSpline) :: this
    class(TFileStream) :: F

    call TInterpolator1D_SaveState(this,F)
    call F%Write(this%xmin, this%xmax, this%delta_x)

    end subroutine TRegularCubicSpline_SaveState

    !Cubic spline on with regular spacing in log(x)

    subroutine TLogRegularCubicSpline_Init(this, xmin, xmax, n, values, End1, End2 )
    class(TLogRegularCubicSpline) :: this
    real(sp_acc), intent(in) :: xmin, xmax
    integer, intent(in) :: n
    real(sp_acc), intent(in), optional :: values(1:)
    real(sp_acc), intent(in), optional :: End1, End2

    if (xmin < 0) call this%Error('TLogRegularCubicSpline_Init log with xmin (%f) <0', xmin)

    call TRegularCubicSpline_Init(this,xmin,xmax,n)
    this%xmin_interp = log(xmin)
    this%xmax_interp = log(xmax)
    this%delta_x = (this%xmax_interp - this%xmin_interp)/(n-1)
    if (present(values)) then
        this%F = values(1:this%n)
        call this%InitInterp(End1, End2)
    end if

    end subroutine TLogRegularCubicSpline_Init

    function TLogRegularCubicSpline_Value(this, x, error )
    class(TLogRegularCubicSpline) :: this
    real(sp_acc) :: TLogRegularCubicSpline_Value
    real(sp_acc), intent(in) :: x
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad

    TLogRegularCubicSpline_Value = TSpline1D_Value(this, log(x), error)

    end function TLogRegularCubicSpline_Value

    function TLogRegularCubicSpline_Derivative(this, x, error )
    class(TLogRegularCubicSpline) :: this
    real(sp_acc) :: TLogRegularCubicSpline_Derivative
    real(sp_acc), intent(in) :: x
    integer, intent(inout), optional :: error !initialize to zero outside, changed if bad

    TLogRegularCubicSpline_Derivative = TSpline1D_Derivative(this, log(x), error)/x

    end function TLogRegularCubicSpline_Derivative


    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    ! calculates array of second derivatives used by cubic spline
    ! interpolation. y2 is array of second derivatives, yp1 and ypn are first
    ! derivatives at end points.

    !Thanks Martin Reinecke
    subroutine spline(x,y,n,d11,d1n,d2)
    integer, intent(in) :: n
    real(sp_acc), intent(in) :: x(n), y(n), d11, d1n
    real(sp_acc), intent(out) :: d2(n)
    integer i
    real(sp_acc) xp,qn,sig,un,xxdiv,u(n-1),d1l,d1r

    d1r= (y(2)-y(1))/(x(2)-x(1))
    if (d11==SPLINE_DANGLE) then
        d2(1)=0._sp_acc
        u(1)=0._sp_acc
    else
        d2(1)=-0.5_sp_acc
        u(1)=(3._sp_acc/(x(2)-x(1)))*(d1r-d11)
    endif

    do i=2,n-1
        d1l=d1r
        d1r=(y(i+1)-y(i))/(x(i+1)-x(i))
        xxdiv=1._sp_acc/(x(i+1)-x(i-1))
        sig=(x(i)-x(i-1))*xxdiv
        xp=1._sp_acc/(sig*d2(i-1)+2._sp_acc)

        d2(i)=(sig-1._sp_acc)*xp

        u(i)=(6._sp_acc*(d1r-d1l)*xxdiv-sig*u(i-1))*xp
    end do
    d1l=d1r

    if (d1n==SPLINE_DANGLE) then
        qn=0._sp_acc
        un=0._sp_acc
    else
        qn=0.5_sp_acc
        un=(3._sp_acc/(x(n)-x(n-1)))*(d1n-d1l)
    endif

    d2(n)=(un-qn*u(n-1))/(qn*d2(n-1)+1._sp_acc)
    do i=n-1,1,-1
        d2(i)=d2(i)*d2(i+1)+u(i)
    end do
    end subroutine spline

    subroutine regular_spline(delta,y,n,d11,d1n,d2)
    integer, intent(in) :: n
    real(sp_acc), intent(in) :: delta, y(n), d11, d1n
    real(sp_acc), intent(out) :: d2(n)
    integer i
    real(sp_acc) xp,qn,un,d1l,d1r
    real(sp_acc), allocatable :: u(:)

    allocate(u(n-1))

    d1r= (y(2)-y(1))/delta
    if (d11==SPLINE_DANGLE) then
        d2(1)=0._sp_acc
        u(1)=0._sp_acc
    else
        d2(1)=-0.5_sp_acc
        u(1)=(3._sp_acc/delta)*(d1r-d11)
    endif

    do i=2,n-1
        d1l=d1r
        d1r=(y(i+1)-y(i))/delta
        xp=1/(d2(i-1)/2+2._sp_acc)
        d2(i)=-xp/2
        u(i)=(3*(d1r-d1l)/delta  -u(i-1)/2)*xp
    end do
    d1l=d1r

    if (d1n==SPLINE_DANGLE) then
        qn=0._sp_acc
        un=0._sp_acc
    else
        qn=0.5_sp_acc
        un=(3._sp_acc/delta)*(d1n-d1l)
    endif

    d2(n)=(un-qn*u(n-1))/(qn*d2(n-1)+1._sp_acc)
    do i=n-1,1,-1
        d2(i)=d2(i)*d2(i+1)+u(i)
    end do

    end subroutine regular_spline


    subroutine TInterpGrid2D_InitInterp(this)
    class(TInterpGrid2D):: this

    allocate(this%Wk(3,this%NX,this%NY))
    CALL rgpd3p(this%nx, this%ny, this%x, this%y, this%z, this%wk)
    this%Initialized = .true.

    end subroutine TInterpGrid2D_InitInterp

    !F2003 wrappers by AL, 2013
    subroutine TInterpGrid2D_Init(this, x, y, z)
    class(TInterpGrid2D):: this
    REAL(GI), INTENT(IN)      :: x(:)
    REAL(GI), INTENT(IN)      :: y(:)
    REAL(GI), INTENT(IN)      :: z(:,:)

    call this%Clear()
    this%nx = size(x)
    this%ny = size(y)
    allocate(this%x, source = x)
    allocate(this%y, source = y)
    allocate(this%z, source = z)

    call this%InitInterp()

    end subroutine TInterpGrid2D_Init

    subroutine TInterpGrid2D_InitFromMatrixTextFile(this, Filename, colvals, rowvals, dolog)
    class(TInterpGrid2D):: this
    character(LEN=*), intent(in) :: Filename
    real(sp_acc), intent(in) :: colvals(:), rowvals(:)
    logical, intent(in), optional :: dolog

    call this%Clear()
    this%nx = size(colvals)
    this%ny = size(rowvals)
    allocate(this%z(this%nx, this%ny))
    call File%ReadTextMatrix(Filename, this%z)
    if (DefaultFalse(dolog)) this%z = log(this%z)
    allocate(this%x, source = colvals)
    allocate(this%y, source = rowvals)
    call this%InitInterp()

    end subroutine TInterpGrid2D_InitFromMatrixTextFile

    subroutine TInterpGrid2D_InitFromMatrixBinaryFile(this, Filename, colvals, rowvals)
    class(TInterpGrid2D):: this
    character(LEN=*), intent(in) :: Filename
    real(sp_acc), intent(in) :: colvals(:), rowvals(:)
    Type(TBinaryFile) :: F

    call this%Clear()
    this%nx = size(colvals)
    this%ny = size(rowvals)
    allocate(this%z(this%nx, this%ny))
    call F%OpenFile(Filename, mode='binary')
    call F%Read(this%z)
    call F%Close()
    allocate(this%x, source = colvals)
    allocate(this%y, source = rowvals)
    call this%InitInterp()

    end subroutine TInterpGrid2D_InitFromMatrixBinaryFile

    subroutine TInterpGrid2D_InitFromFile(this, Filename, xcol, ycol, zcol)
    !Load from file with rows of x, y, value
    class(TInterpGrid2D):: this
    character(LEN=*), intent(in) :: Filename
    integer, intent(in), optional :: xcol, ycol, zcol
    integer :: ixcol=1,iycol=2,izcol=3
    integer :: nx,ny
    integer :: parse, status
    real(sp_acc), allocatable :: tmp(:)
    real(sp_acc) lasty
    logical :: first
    character(LEN=:), allocatable :: InLine
    Type(TTextFile) :: F

    if (present(xcol)) ixcol=xcol
    if (present(ycol)) iycol=ycol
    if (present(zcol)) izcol=zcol

    allocate(tmp(max(ixcol,iycol,izcol)))

    call F%Open(FileName)

    do parse=1,2
        first = .true.
        ny=0
        nx=0
        do while(F%ReadLineSkipEmptyAndComments(InLine))

            read(InLine,*, iostat=status) tmp
            if (status/=0) call this%Error('Error reading line: '//trim(InLine))

            if (first .or. tmp(iycol)/=lasty) then
                lasty=tmp(iycol)
                ny=ny+1
                nx=0
                first = .false.
            end if

            nx=nx+1
            if (parse==2) then
                if (ny==1) then
                    this%x(nx) = tmp(ixcol)
                else
                    if (tmp(ixcol)/=this%x(nx)) call this%Error('Non-grid x values')
                end if
                if (nx==1) then
                    this%y(ny) = tmp(iycol)
                else
                    if (tmp(iycol)/=this%y(ny))call this%Error('Non-grid y values')
                end if
                this%z(nx, ny) = tmp(izcol)
            endif
        end do

        if (parse==2) exit

        if (nx<2 .or. ny<2) call this%Error('not enough values to interpolate')
        this%nx = nx
        this%ny = ny
        allocate(this%x(this%nx))
        allocate(this%y(this%ny))
        allocate(this%z(nx,ny))
        status=0
        call F%Rewind()
    end do

    call F%Close()

    call this%InitInterp()

    end subroutine TInterpGrid2D_InitFromFile

    subroutine TInterpGrid2D_Clear(this)
    class(TInterpGrid2D):: this

    if (allocated(this%Wk)) then
        deallocate(this%x)
        deallocate(this%y)
        deallocate(this%Wk)
        deallocate(this%z)
    end if
    this%Initialized = .false.

    end subroutine TInterpGrid2D_Clear

    function TInterpGrid2D_Value(this,x,y,error) result (res)
    !Z matrix not stored internally to save mem, so must pass again
    class(TInterpGrid2D) :: this
    real(GI) res, z(1), xx(1),yy(1)
    real(GI), intent(in) :: x,y
    integer, intent(inout), optional :: error

    xx(1)=x
    yy(1)=y
    call this%Values(1,xx,yy,z,error)
    res = z(1)

    end function TInterpGrid2D_Value

    subroutine TInterpGrid2D_Values(this, nip, x,y,z, error)
    !Z matrix not stored internally to save mem, so must pass again
    class(TInterpGrid2D) :: this
    integer, intent(in) :: nip
    real(GI), intent(out):: z(nip)
    real(GI), intent(in) :: x(nip),y(nip)
    integer, intent(inout), optional :: error
    integer md,ier

    md=2
    if (.not. this%Initialized)  call this%FirstUse

    call rgbi3p(this%Wk,md, this%nx, this%ny, this%x, this%y, this%z, nip, x, y, z, ier)
    if (present(error)) then
        error=ier
    elseif (ier/=0) then
        call this%Error('error interpolating value')
    end if

    end subroutine TInterpGrid2D_Values


    SUBROUTINE rgbi3p(Wk,md, nxd, nyd, xd, yd, zd, nip, xi, yi, zi, ier)

    ! Code converted using TO_F90 by Alan Miller
    ! Date: 2003-06-11  Time: 10:11:03

    ! Rectangular-grid bivariate interpolation
    ! (a master subroutine of the RGBI3P/RGSF3P subroutine package)

    ! Hiroshi Akima
    ! U.S. Department of Commerce, NTIA/ITS
    ! Version of 1995/08

    ! This subroutine performs interpolation of a bivariate function, z(x,y), on a
    ! rectangular grid in the x-y plane.  It is based on the revised Akima method.

    ! In this subroutine, the interpolating function is a piecewise function
    ! composed of a set of bicubic (bivariate third-degree) polynomials, each
    ! applicable to a rectangle of the input grid in the x-y plane.
    ! Each polynomial is determined locally.

    ! This subroutine has the accuracy of a bicubic polynomial, i.e., it
    ! interpolates accurately when all data points lie on a surface of a
    ! bicubic polynomial.

    ! The grid lines can be unevenly spaced.

    ! The input arguments are
    !   MD  = mode of computation
    !       = 1 for new XD, YD, or ZD data (default)
    !       = 2 for old XD, YD, and ZD data,
    !   NXD = number of the input-grid data points in the x coordinate
    !         (must be 2 or greater),
    !   NYD = number of the input-grid data points in the y coordinate
    !         (must be 2 or greater),
    !   XD  = array of dimension NXD containing the x coordinates of the
    !         input-grid data points (must be in a monotonic increasing order),
    !   YD  = array of dimension NYD containing the y coordinates of the
    !         input-grid data points (must be in a monotonic increasing order),
    !   ZD  = two-dimensional array of dimension NXD*NYD
    !         containing the z(x,y) values at the input-grid data points,
    !   NIP = number of the output points at which interpolation
    !         of the z value is desired (must be 1 or greater),
    !   XI  = array of dimension NIP containing the x coordinates
    !         of the output points,
    !   YI  = array of dimension NIP containing the y coordinates
    !         of the output points.

    ! The output arguments are
    !   ZI  = array of dimension NIP where the interpolated z
    !         values at the output points are to be stored,
    !   IER = error flag
    !       = 0 for no errors
    !       = 1 for NXD = 1 or less
    !       = 2 for NYD = 1 or less
    !       = 3 for identical XD values or XD values out of sequence
    !       = 4 for identical YD values or YD values out of sequence
    !       = 5 for NIP = 0 or less.

    ! N.B. The workspace has been removed from the argument list.
    !   WK  = three dimensional array of dimension 3*NXD*NYD used internally
    !         as a work area.

    ! The very fisrt call to this subroutine and the call with a new XD, YD, and
    ! ZD array must be made with MD=1.  The call with MD=2 must be preceded by
    ! another call with the same XD, YD, and ZD arrays.  Between the call with
    ! MD=2 and its preceding call, the WK array must not be disturbed.

    ! The constant in the PARAMETER statement below is
    !   NIPIMX = maximum number of output points to be processed at a time.
    ! The constant value has been selected empirically.

    ! This subroutine calls the RGPD3P, RGLCTN, and RGPLNL subroutines.


    ! Specification statements
    !     .. Parameters ..

    INTEGER, INTENT(IN)   :: md
    INTEGER, INTENT(IN)   :: nxd
    INTEGER, INTENT(IN)   :: nyd
    REAL(GI), INTENT(IN)      :: xd(nxd)
    REAL(GI), INTENT(IN)      :: yd(nyd)
    REAL(GI), INTENT(IN)  :: zd(nxd,nyd)
    INTEGER, INTENT(IN)   :: nip
    REAL(GI), INTENT(IN)  :: xi(nip)
    REAL(GI), INTENT(IN)  :: yi(nip)
    REAL(GI), INTENT(OUT)  :: zi(nip)
    INTEGER, INTENT(OUT)  :: ier
    REAL(GI), INTENT(INOUT)  :: wk(3,nxd,nyd)

    !     ..
    !     .. Local Scalars ..
    INTEGER, PARAMETER  :: nipimx=51

    INTEGER  :: iip, ix, iy, nipi
    !     ..
    !     .. Local Arrays ..
    INTEGER  :: inxi(nipimx), inyi(nipimx)

    !     ..
    !     .. External Subroutines ..
    ! EXTERNAL         rglctn, rgpd3p, rgplnl
    !     ..
    !     .. Intrinsic Functions ..
    ! INTRINSIC        MIN
    !     ..

    ! Preliminary processing
    ! Error check
    IF (nxd <= 1) GO TO 40
    IF (nyd <= 1) GO TO 50
    DO  ix = 2,nxd
        IF (xd(ix) <= xd(ix-1)) GO TO 60
    END DO
    DO  iy = 2,nyd
        IF (yd(iy) <= yd(iy-1)) GO TO 70
    END DO
    IF (nip <= 0) GO TO 80
    ier = 0

    ! Calculation
    ! Estimates partial derivatives at all input-grid data points (for MD=1).
    IF (md /= 2) THEN
        CALL rgpd3p(nxd, nyd, xd, yd, zd, wk)
    END IF

    ! DO-loop with respect to the output point
    ! Processes NIPIMX output points, at most, at a time.
    DO  iip = 1,nip,nipimx
        nipi = MIN(nip- (iip-1),nipimx)
        ! Locates the output points.
        CALL rglctn(nxd, nyd, xd, yd, nipi, xi(iip), yi(iip), inxi, inyi)

        ! Calculates the z values at the output points.
        CALL rgplnl(nxd, nyd, xd, yd, zd, wk, nipi, xi(iip), yi(iip), inxi, inyi, &
            zi(iip))
    END DO
    RETURN

    ! Error exit
40  WRITE (*,FMT=9000)
    ier = 1
    GO TO 90
50  WRITE (*,FMT=9010)
    ier = 2
    GO TO 90
60  WRITE (*,FMT=9020) ix,xd(ix)
    ier = 3
    GO TO 90
70  WRITE (*,FMT=9030) iy,yd(iy)
    ier = 4
    GO TO 90
80  WRITE (*,FMT=9040)
    ier = 5
90  WRITE (*,FMT=9050) nxd,nyd,nip
    RETURN

    ! Format statements for error messages
9000 FORMAT (/' *** RGBI3P Error 1: NXD = 1 or less')
9010 FORMAT (/' *** RGBI3P Error 2: NYD = 1 or less')
9020 FORMAT (/' *** RGBI3P Error 3: Identical XD values or',  &
        ' XD values out of sequence'/ '    IX =', i6, ',  XD(IX) =', e11.3)
9030 FORMAT (/' *** RGBI3P Error 4: Identical YD values or',  &
        ' YD values out of sequence',/,'    IY =',i6,',  YD(IY) =', e11.3)
9040 FORMAT (/' *** RGBI3P Error 5: NIP = 0 or less')
9050 FORMAT ('    NXD =', i5,',  NYD =', i5,',  NIP =', i5/)
    END SUBROUTINE rgbi3p



    SUBROUTINE rgsf3p(wk, md, nxd, nyd, xd, yd, zd, nxi, xi, nyi, yi, zi, ier)

    ! Rectangular-grid surface fitting
    ! (a master subroutine of the RGBI3P/RGSF3P subroutine package)

    ! Hiroshi Akima
    ! U.S. Department of Commerce, NTIA/ITS
    ! Version of 1995/08

    ! This subroutine performs surface fitting by interpolating values of a
    ! bivariate function, z(x,y), on a rectangular grid in the x-y plane.
    ! It is based on the revised Akima method.

    ! In this subroutine, the interpolating function is a piecewise function
    ! composed of a set of bicubic (bivariate third-degree) polynomials, each
    ! applicable to a rectangle of the input grid in the x-y plane.
    ! Each polynomial is determined locally.

    ! This subroutine has the accuracy of a bicubic polynomial, i.e., it fits the
    ! surface accurately when all data points lie on a surface of a bicubic
    ! polynomial.

    ! The grid lines of the input and output data can be unevenly spaced.

    ! The input arguments are
    !   MD  = mode of computation
    !       = 1 for new XD, YD, or ZD data (default)
    !       = 2 for old XD, YD, and ZD data,
    !   NXD = number of the input-grid data points in the x
    !         coordinate (must be 2 or greater),
    !   NYD = number of the input-grid data points in the y
    !         coordinate (must be 2 or greater),
    !   XD  = array of dimension NXD containing the x coordinates
    !         of the input-grid data points (must be in a
    !         monotonic increasing order),
    !   YD  = array of dimension NYD containing the y coordinates
    !         of the input-grid data points (must be in a
    !         monotonic increasing order),
    !   ZD  = two-dimensional array of dimension NXD*NYD
    !         containing the z(x,y) values at the input-grid data points,
    !   NXI = number of output grid points in the x coordinate
    !         (must be 1 or greater),
    !   XI  = array of dimension NXI containing the x coordinates
    !         of the output grid points,
    !   NYI = number of output grid points in the y coordinate
    !         (must be 1 or greater),
    !   YI  = array of dimension NYI containing the y coordinates
    !         of the output grid points.

    ! The output arguments are
    !   ZI  = two-dimensional array of dimension NXI*NYI, where the interpolated
    !         z values at the output grid points are to be stored,
    !   IER = error flag
    !       = 0 for no error
    !       = 1 for NXD = 1 or less
    !       = 2 for NYD = 1 or less
    !       = 3 for identical XD values or XD values out of sequence
    !       = 4 for identical YD values or YD values out of sequence
    !       = 5 for NXI = 0 or less
    !       = 6 for NYI = 0 or less.

    ! N.B. The workspace has been removed from the argument list.
    !   WK  = three-dimensional array of dimension 3*NXD*NYD used internally
    !         as a work area.

    ! The very first call to this subroutine and the call with a new XD, YD, or
    ! ZD array must be made with MD=1.  The call with MD=2 must be preceded by
    ! another call with the same XD, YD, and ZD arrays.  Between the call with
    ! MD=2 and its preceding call, the WK array must not be disturbed.

    ! The constant in the PARAMETER statement below is
    !   NIPIMX = maximum number of output points to be processed at a time.
    ! The constant value has been selected empirically.

    ! This subroutine calls the RGPD3P, RGLCTN, and RGPLNL subroutines.


    ! Specification statements
    !     .. Parameters ..

    INTEGER, INTENT(IN)   :: md
    INTEGER, INTENT(IN)   :: nxd
    INTEGER, INTENT(IN)   :: nyd
    REAL(GI), INTENT(IN)      :: xd(nxd)
    REAL(GI), INTENT(IN)      :: yd(nyd)
    REAL(GI), INTENT(IN OUT)  :: zd(nxd,nyd)
    INTEGER, INTENT(IN)   :: nxi
    REAL(GI), INTENT(IN OUT)  :: xi(nxi)
    INTEGER, INTENT(IN)   :: nyi
    REAL(GI), INTENT(IN)      :: yi(nyi)
    REAL(GI), INTENT(IN OUT)  :: zi(nxi,nyi)
    INTEGER, INTENT(OUT)  :: ier
    REAL(GI), INTENT(INOUT)  :: wk(3,nxd,nyd)

    !     ..
    !     .. Local Scalars ..
    INTEGER, PARAMETER  :: nipimx=51

    INTEGER  :: ix, ixi, iy, iyi, nipi
    !     ..
    !     .. Local Arrays ..
    REAL(GI)     :: yii(nipimx)
    INTEGER  :: inxi(nipimx), inyi(nipimx)

    !     ..
    !     .. External Subroutines ..
    ! EXTERNAL         rglctn,rgpd3p,rgplnl
    !     ..
    !     .. Intrinsic Functions ..
    ! INTRINSIC        MIN
    !     ..

    ! Preliminary processing
    ! Error check
    IF (nxd <= 1) GO TO 60
    IF (nyd <= 1) GO TO 70
    DO  ix = 2,nxd
        IF (xd(ix) <= xd(ix-1)) GO TO 80
    END DO
    DO  iy = 2,nyd
        IF (yd(iy) <= yd(iy-1)) GO TO 90
    END DO
    IF (nxi <= 0) GO TO 100
    IF (nyi <= 0) GO TO 110
    ier = 0

    ! Calculation
    ! Estimates partial derivatives at all input-grid data points
    ! (for MD=1).
    IF (md /= 2) THEN
        CALL rgpd3p(nxd, nyd, xd, yd, zd, wk)
    END IF

    ! Outermost DO-loop with respect to the y coordinate of the output grid points
    DO  iyi = 1,nyi
        DO  ixi = 1,nipimx
            yii(ixi) = yi(iyi)
        END DO

        ! Second DO-loop with respect to the x coordinate of the output grid points
        ! Processes NIPIMX output-grid points, at most, at a time.
        DO  ixi = 1,nxi,nipimx
            nipi = MIN(nxi- (ixi-1), nipimx)
            ! Locates the output-grid points.
            CALL rglctn(nxd, nyd, xd, yd, nipi, xi(ixi), yii, inxi, inyi)

            ! Calculates the z values at the output-grid points.
            CALL rgplnl(nxd, nyd, xd, yd, zd, wk, nipi, xi(ixi), yii, inxi, inyi,  &
                zi(ixi,iyi))
        END DO
    END DO
    RETURN

    ! Error exit
60  WRITE (*,FMT=9000)
    ier = 1
    GO TO 120
70  WRITE (*,FMT=9010)
    ier = 2
    GO TO 120
80  WRITE (*,FMT=9020) ix,xd(ix)
    ier = 3
    GO TO 120
90  WRITE (*,FMT=9030) iy,yd(iy)
    ier = 4
    GO TO 120
100 WRITE (*,FMT=9040)
    ier = 5
    GO TO 120
110 WRITE (*,FMT=9050)
    ier = 6
120 WRITE (*,FMT=9060) nxd,nyd,nxi,nyi
    RETURN

    ! Format statements for error messages
9000 FORMAT (/' *** RGSF3P Error 1: NXD = 1 or less')
9010 FORMAT (/' *** RGSF3P Error 2: NYD = 1 or less')
9020 FORMAT (/' *** RGSF3P Error 3: Identical XD values or',  &
        ' XD values out of sequence',/,'    IX =',i6,',  XD(IX) =', e11.3)
9030 FORMAT (/' *** RGSF3P Error 4: Identical YD values or',  &
        ' YD values out of sequence',/,'    IY =',i6,',  YD(IY) =', e11.3)
9040 FORMAT (/' *** RGSF3P Error 5: NXI = 0 or less')
9050 FORMAT (/' *** RGSF3P Error 6: NYI = 0 or less')
9060 FORMAT ('    NXD =', i5, ',  NYD =', i5, ',  NXI =', i5,',  NYI =', i5 /)
    END SUBROUTINE rgsf3p



    !     ..
    ! Statement Function definitions
    ! z2f(xx1,xx2,zz0,zz1) = (zz1-zz0)*xx2/xx1 + zz0
    ! z3f(xx1,xx2,xx3,zz0,zz1,zz2) = ((zz2-zz0)* (xx3-xx1)/xx2 -  &
    !    (zz1-zz0)* (xx3-xx2)/xx1)* (xx3/ (xx2-xx1)) + zz0

    FUNCTION z2f(xx1, xx2, zz0, zz1) RESULT(fn_val)

    REAL(GI), INTENT(IN)  :: xx1, xx2, zz0, zz1
    REAL(GI)              :: fn_val

    fn_val = (zz1-zz0)*xx2/xx1 + zz0
    RETURN
    END FUNCTION z2f



    FUNCTION z3f(xx1, xx2, xx3, zz0, zz1, zz2) RESULT(fn_val)

    REAL(GI), INTENT(IN)  :: xx1, xx2, xx3, zz0, zz1, zz2
    REAL(GI)              :: fn_val

    fn_val = ((zz2-zz0)*(xx3-xx1)/xx2 - (zz1-zz0)*(xx3-xx2)/xx1) *  &
        (xx3/(xx2-xx1)) + zz0
    RETURN
    END FUNCTION z3f



    SUBROUTINE rgpd3p(nxd, nyd, xd, yd, zd, pdd)

    ! Partial derivatives of a bivariate function on a rectangular grid
    ! (a supporting subroutine of the RGBI3P/RGSF3P subroutine package)

    ! Hiroshi Akima
    ! U.S. Department of Commerce, NTIA/ITS
    ! Version of 1995/08

    ! This subroutine estimates three partial derivatives, zx, zy, and
    ! zxy, of a bivariate function, z(x,y), on a rectangular grid in
    ! the x-y plane.  It is based on the revised Akima method that has
    ! the accuracy of a bicubic polynomial.

    ! The input arguments are
    !   NXD = number of the input-grid data points in the x
    !         coordinate (must be 2 or greater),
    !   NYD = number of the input-grid data points in the y
    !         coordinate (must be 2 or greater),
    !   XD  = array of dimension NXD containing the x coordinates of the
    !         input-grid data points (must be in a monotonic increasing order),
    !   YD  = array of dimension NYD containing the y coordinates of the
    !         input-grid data points (must be in a monotonic increasing order),
    !   ZD  = two-dimensional array of dimension NXD*NYD
    !         containing the z(x,y) values at the input-grid data points.

    ! The output argument is
    !   PDD = three-dimensional array of dimension 3*NXD*NYD,
    !         where the estimated zx, zy, and zxy values at the
    !         input-grid data points are to be stored.


    ! Specification statements
    !     .. Scalar Arguments ..

    INTEGER, INTENT(IN)  :: nxd
    INTEGER, INTENT(IN)  :: nyd
    REAL(GI), INTENT(IN)     :: xd(nxd)
    REAL(GI), INTENT(IN)     :: yd(nyd)
    REAL(GI), INTENT(IN)     :: zd(nxd,nyd)
    REAL(GI), INTENT(OUT)    :: pdd(3,nxd,nyd)

    !     ..
    !     .. Local Scalars ..
    REAL(GI) :: b00, b00x, b00y, b01, b10, b11, cx1, cx2, cx3, cy1, cy2,  &
        cy3, disf, dnm, dz00, dz01, dz02, dz03, dz10, dz11, dz12,  &
        dz13, dz20, dz21, dz22, dz23, dz30, dz31, dz32, dz33,  &
        dzx10, dzx20, dzx30, dzxy11, dzxy12, dzxy13, dzxy21,  &
        dzxy22, dzxy23, dzxy31, dzxy32, dzxy33, dzy01, dzy02,  &
        dzy03, epsln, pezx, pezxy, pezy, smpef, smpei, smwtf,  &
        smwti, sx, sxx, sxxy, sxxyy, sxy, sxyy, sxyz, sxz, sy, syy,  &
        syz, sz, volf, wt, x0, x1, x2, x3, y0, y1, y2,  &
        y3, z00, z01, z02, z03, z10, z11, z12, z13, z20, z21, z22,  &
        z23, z30, z31, z32, z33, zxdi, zxydi, zydi
    INTEGER :: ipex, ipey, ix0, ix1, ix2, ix3, iy0, iy1, iy2, iy3, nx0, ny0
    !     ..
    !     .. Local Arrays ..
    REAL(GI)    :: b00xa(4), b00ya(4), b01a(4), b10a(4), cxa(3,4), cya(3,4),   &
        sxa(4), sxxa(4), sya(4), syya(4), xa(3,4), ya(3,4),   &
        z0ia(3,4), zi0a(3,4)

    INTEGER, parameter :: idlt(3,4) = RESHAPE([-3, -2, -1, -2, -1, 1,-1, 1,2, 1 ,2, 3 ], [ 3, 4 ] )
    !AL Jun 14: Fixed F90 translation

    ! Calculation
    ! Initial setting of some local variables
    nx0 = MAX(4,nxd)
    ny0 = MAX(4,nyd)

    ! Double DO-loop with respect to the input grid points
    DO  iy0 = 1,nyd
        DO  ix0 = 1,nxd
            x0 = xd(ix0)
            y0 = yd(iy0)
            z00 = zd(ix0,iy0)

            ! Part 1.  Estimation of ZXDI
            ! Initial setting
            smpef = 0.0
            smwtf = 0.0
            smpei = 0.0
            smwti = 0.0
            ! DO-loop with respect to the primary estimate
            DO  ipex = 1,4
                ! Selects necessary grid points in the x direction.
                ix1 = ix0 + idlt(1,ipex)
                ix2 = ix0 + idlt(2,ipex)
                ix3 = ix0 + idlt(3,ipex)
                IF ((ix1 < 1) .OR. (ix2 < 1) .OR. (ix3 < 1) .OR.  &
                    (ix1 > nx0) .OR. (ix2 > nx0) .OR. (ix3 > nx0)) CYCLE
                ! Selects and/or supplements the x and z values.
                x1 = xd(ix1) - x0
                z10 = zd(ix1,iy0)
                IF (nxd >= 4) THEN
                    x2 = xd(ix2) - x0
                    x3 = xd(ix3) - x0
                    z20 = zd(ix2,iy0)
                    z30 = zd(ix3,iy0)
                ELSE IF (nxd == 3) THEN
                    x2 = xd(ix2) - x0
                    z20 = zd(ix2,iy0)
                    x3 = 2*xd(3) - xd(2) - x0
                    z30 = z3f(x1,x2,x3,z00,z10,z20)
                ELSE IF (nxd == 2) THEN
                    x2 = 2*xd(2) - xd(1) - x0
                    z20 = z2f(x1,x2,z00,z10)
                    x3 = 2*xd(1) - xd(2) - x0
                    z30 = z2f(x1,x3,z00,z10)
                END IF
                dzx10 = (z10-z00)/x1
                dzx20 = (z20-z00)/x2
                dzx30 = (z30-z00)/x3
                ! Calculates the primary estimate of partial derivative zx as
                ! the coefficient of the bicubic polynomial.
                cx1 = x2*x3/ ((x1-x2)* (x1-x3))
                cx2 = x3*x1/ ((x2-x3)* (x2-x1))
                cx3 = x1*x2/ ((x3-x1)* (x3-x2))
                pezx = cx1*dzx10 + cx2*dzx20 + cx3*dzx30
                ! Calculates the volatility factor and distance factor in the x
                ! direction for the primary estimate of zx.
                sx = x1 + x2 + x3
                sz = z00 + z10 + z20 + z30
                sxx = x1*x1 + x2*x2 + x3*x3
                sxz = x1*z10 + x2*z20 + x3*z30
                dnm = 4.0*sxx - sx*sx
                b00 = (sxx*sz-sx*sxz)/dnm
                b10 = (4.0*sxz-sx*sz)/dnm
                dz00 = z00 - b00
                dz10 = z10 - (b00+b10*x1)
                dz20 = z20 - (b00+b10*x2)
                dz30 = z30 - (b00+b10*x3)
                volf = dz00**2 + dz10**2 + dz20**2 + dz30**2
                disf = sxx

                ! Calculates the EPSLN value, which is used to decide whether or
                ! not the volatility factor is essentially zero.
                epsln = (z00**2+z10**2+z20**2+z30**2)*1.0E-12
                ! Accumulates the weighted primary estimates of zx and their weights.
                IF (volf > epsln) THEN
                    ! - For a finite weight.
                    wt = 1.0/ (volf*disf)
                    smpef = smpef + wt*pezx
                    smwtf = smwtf + wt
                ELSE
                    ! - For an infinite weight.
                    smpei = smpei + pezx
                    smwti = smwti + 1.0
                END IF

                ! Saves the necessary values for estimating zxy
                xa(1,ipex) = x1
                xa(2,ipex) = x2
                xa(3,ipex) = x3
                zi0a(1,ipex) = z10
                zi0a(2,ipex) = z20
                zi0a(3,ipex) = z30
                cxa(1,ipex) = cx1
                cxa(2,ipex) = cx2
                cxa(3,ipex) = cx3
                sxa(ipex) = sx
                sxxa(ipex) = sxx
                b00xa(ipex) = b00
                b10a(ipex) = b10
            END DO

            ! Calculates the final estimate of zx.
            IF (smwti < 0.5) THEN
                ! - When no infinite weights exist.
                zxdi = smpef/smwtf
            ELSE
                ! - When infinite weights exist.
                zxdi = smpei/smwti
            END IF
            ! End of Part 1.

            ! Part 2.  Estimation of ZYDI
            ! Initial setting
            smpef = 0.0
            smwtf = 0.0
            smpei = 0.0
            smwti = 0.0
            ! DO-loop with respect to the primary estimate
            DO  ipey = 1,4
                ! Selects necessary grid points in the y direction.
                iy1 = iy0 + idlt(1,ipey)
                iy2 = iy0 + idlt(2,ipey)
                iy3 = iy0 + idlt(3,ipey)
                IF ((iy1 < 1) .OR. (iy2 < 1) .OR. (iy3 < 1) .OR.  &
                    (iy1 > ny0) .OR. (iy2 > ny0) .OR. (iy3 > ny0)) CYCLE
                ! Selects and/or supplements the y and z values.
                y1 = yd(iy1) - y0
                z01 = zd(ix0,iy1)
                IF (nyd >= 4) THEN
                    y2 = yd(iy2) - y0
                    y3 = yd(iy3) - y0
                    z02 = zd(ix0,iy2)
                    z03 = zd(ix0,iy3)
                ELSE IF (nyd == 3) THEN
                    y2 = yd(iy2) - y0
                    z02 = zd(ix0,iy2)
                    y3 = 2*yd(3) - yd(2) - y0
                    z03 = z3f(y1,y2,y3,z00,z01,z02)
                ELSE IF (nyd == 2) THEN
                    y2 = 2*yd(2) - yd(1) - y0
                    z02 = z2f(y1,y2,z00,z01)
                    y3 = 2*yd(1) - yd(2) - y0
                    z03 = z2f(y1,y3,z00,z01)
                END IF
                dzy01 = (z01-z00)/y1
                dzy02 = (z02-z00)/y2
                dzy03 = (z03-z00)/y3
                ! Calculates the primary estimate of partial derivative zy as
                ! the coefficient of the bicubic polynomial.
                cy1 = y2*y3/ ((y1-y2)* (y1-y3))
                cy2 = y3*y1/ ((y2-y3)* (y2-y1))
                cy3 = y1*y2/ ((y3-y1)* (y3-y2))
                pezy = cy1*dzy01 + cy2*dzy02 + cy3*dzy03
                ! Calculates the volatility factor and distance factor in the y
                ! direction for the primary estimate of zy.
                sy = y1 + y2 + y3
                sz = z00 + z01 + z02 + z03
                syy = y1*y1 + y2*y2 + y3*y3
                syz = y1*z01 + y2*z02 + y3*z03
                dnm = 4.0*syy - sy*sy
                b00 = (syy*sz-sy*syz)/dnm
                b01 = (4.0*syz-sy*sz)/dnm
                dz00 = z00 - b00
                dz01 = z01 - (b00+b01*y1)
                dz02 = z02 - (b00+b01*y2)
                dz03 = z03 - (b00+b01*y3)
                volf = dz00**2 + dz01**2 + dz02**2 + dz03**2
                disf = syy

                ! Calculates the EPSLN value, which is used to decide whether or
                ! not the volatility factor is essentially zero.
                epsln = (z00**2+z01**2+z02**2+z03**2)*1.0E-12
                ! Accumulates the weighted primary estimates of zy and their weights.
                IF (volf > epsln) THEN
                    ! - For a finite weight.
                    wt = 1.0/ (volf*disf)
                    smpef = smpef + wt*pezy
                    smwtf = smwtf + wt
                ELSE
                    ! - For an infinite weight.
                    smpei = smpei + pezy
                    smwti = smwti + 1.0
                END IF
                ! Saves the necessary values for estimating zxy
                ya(1,ipey) = y1
                ya(2,ipey) = y2
                ya(3,ipey) = y3
                z0ia(1,ipey) = z01
                z0ia(2,ipey) = z02
                z0ia(3,ipey) = z03
                cya(1,ipey) = cy1
                cya(2,ipey) = cy2
                cya(3,ipey) = cy3
                sya(ipey) = sy
                syya(ipey) = syy
                b00ya(ipey) = b00
                b01a(ipey) = b01
            END DO

            ! Calculates the final estimate of zy.
            IF (smwti < 0.5) THEN
                ! - When no infinite weights exist.
                zydi = smpef/smwtf
            ELSE
                ! - When infinite weights exist.
                zydi = smpei/smwti
            END IF
            ! End of Part 2.

            ! Part 3.  Estimation of ZXYDI
            ! Initial setting
            smpef = 0.0
            smwtf = 0.0
            smpei = 0.0
            smwti = 0.0
            ! Outer DO-loops with respect to the primary estimates in the x direction
            DO  ipex = 1,4
                ix1 = ix0 + idlt(1,ipex)
                ix2 = ix0 + idlt(2,ipex)
                ix3 = ix0 + idlt(3,ipex)
                IF ((ix1 < 1) .OR. (ix2 < 1) .OR. (ix3 < 1) .OR.  &
                    (ix1 > nx0) .OR. (ix2 > nx0) .OR. (ix3 > nx0)) CYCLE
                ! Retrieves the necessary values for estimating zxy in the x direction.
                x1 = xa(1,ipex)
                x2 = xa(2,ipex)
                x3 = xa(3,ipex)
                z10 = zi0a(1,ipex)
                z20 = zi0a(2,ipex)
                z30 = zi0a(3,ipex)
                cx1 = cxa(1,ipex)
                cx2 = cxa(2,ipex)
                cx3 = cxa(3,ipex)
                sx = sxa(ipex)
                sxx = sxxa(ipex)
                b00x = b00xa(ipex)
                b10 = b10a(ipex)

                ! Inner DO-loops with respect to the primary estimates in the y direction
                DO  ipey = 1,4
                    iy1 = iy0 + idlt(1,ipey)
                    iy2 = iy0 + idlt(2,ipey)
                    iy3 = iy0 + idlt(3,ipey)
                    IF ((iy1 < 1) .OR. (iy2 < 1) .OR. (iy3 < 1) .OR. (iy1 > ny0) .OR.  &
                        (iy2 > ny0) .OR. (iy3 > ny0)) CYCLE
                    ! Retrieves the necessary values for estimating zxy in the y direction.
                    y1 = ya(1,ipey)
                    y2 = ya(2,ipey)
                    y3 = ya(3,ipey)
                    z01 = z0ia(1,ipey)
                    z02 = z0ia(2,ipey)
                    z03 = z0ia(3,ipey)
                    cy1 = cya(1,ipey)
                    cy2 = cya(2,ipey)
                    cy3 = cya(3,ipey)
                    sy = sya(ipey)
                    syy = syya(ipey)
                    b00y = b00ya(ipey)
                    b01 = b01a(ipey)
                    ! Selects and/or supplements the z values.
                    IF (nyd >= 4) THEN
                        z11 = zd(ix1,iy1)
                        z12 = zd(ix1,iy2)
                        z13 = zd(ix1,iy3)
                        IF (nxd >= 4) THEN
                            z21 = zd(ix2,iy1)
                            z22 = zd(ix2,iy2)
                            z23 = zd(ix2,iy3)
                            z31 = zd(ix3,iy1)
                            z32 = zd(ix3,iy2)
                            z33 = zd(ix3,iy3)
                        ELSE IF (nxd == 3) THEN
                            z21 = zd(ix2,iy1)
                            z22 = zd(ix2,iy2)
                            z23 = zd(ix2,iy3)
                            z31 = z3f(x1,x2,x3,z01,z11,z21)
                            z32 = z3f(x1,x2,x3,z02,z12,z22)
                            z33 = z3f(x1,x2,x3,z03,z13,z23)
                        ELSE IF (nxd == 2) THEN
                            z21 = z2f(x1,x2,z01,z11)
                            z22 = z2f(x1,x2,z02,z12)
                            z23 = z2f(x1,x2,z03,z13)
                            z31 = z2f(x1,x3,z01,z11)
                            z32 = z2f(x1,x3,z02,z12)
                            z33 = z2f(x1,x3,z03,z13)
                        END IF
                    ELSE IF (nyd == 3) THEN
                        z11 = zd(ix1,iy1)
                        z12 = zd(ix1,iy2)
                        z13 = z3f(y1,y2,y3,z10,z11,z12)
                        IF (nxd >= 4) THEN
                            z21 = zd(ix2,iy1)
                            z22 = zd(ix2,iy2)
                            z31 = zd(ix3,iy1)
                            z32 = zd(ix3,iy2)
                        ELSE IF (nxd == 3) THEN
                            z21 = zd(ix2,iy1)
                            z22 = zd(ix2,iy2)
                            z31 = z3f(x1,x2,x3,z01,z11,z21)
                            z32 = z3f(x1,x2,x3,z02,z12,z22)
                        ELSE IF (nxd == 2) THEN
                            z21 = z2f(x1,x2,z01,z11)
                            z22 = z2f(x1,x2,z02,z12)
                            z31 = z2f(x1,x3,z01,z11)
                            z32 = z2f(x1,x3,z02,z12)
                        END IF
                        z23 = z3f(y1,y2,y3,z20,z21,z22)
                        z33 = z3f(y1,y2,y3,z30,z31,z32)
                    ELSE IF (nyd == 2) THEN
                        z11 = zd(ix1,iy1)
                        z12 = z2f(y1,y2,z10,z11)
                        z13 = z2f(y1,y3,z10,z11)
                        IF (nxd >= 4) THEN
                            z21 = zd(ix2,iy1)
                            z31 = zd(ix3,iy1)
                        ELSE IF (nxd == 3) THEN
                            z21 = zd(ix2,iy1)
                            z31 = z3f(x1,x2,x3,z01,z11,z21)
                        ELSE IF (nxd == 2) THEN
                            z21 = z2f(x1,x2,z01,z11)
                            z31 = z2f(x1,x3,z01,z11)
                        END IF
                        z22 = z2f(y1,y2,z20,z21)
                        z23 = z2f(y1,y3,z20,z21)
                        z32 = z2f(y1,y2,z30,z31)
                        z33 = z2f(y1,y3,z30,z31)
                    END IF
                    ! Calculates the primary estimate of partial derivative zxy as
                    ! the coefficient of the bicubic polynomial.
                    dzxy11 = (z11-z10-z01+z00)/ (x1*y1)
                    dzxy12 = (z12-z10-z02+z00)/ (x1*y2)
                    dzxy13 = (z13-z10-z03+z00)/ (x1*y3)
                    dzxy21 = (z21-z20-z01+z00)/ (x2*y1)
                    dzxy22 = (z22-z20-z02+z00)/ (x2*y2)
                    dzxy23 = (z23-z20-z03+z00)/ (x2*y3)
                    dzxy31 = (z31-z30-z01+z00)/ (x3*y1)
                    dzxy32 = (z32-z30-z02+z00)/ (x3*y2)
                    dzxy33 = (z33-z30-z03+z00)/ (x3*y3)
                    pezxy = cx1* (cy1*dzxy11+cy2*dzxy12+cy3*dzxy13) +  &
                        cx2* (cy1*dzxy21+cy2*dzxy22+cy3*dzxy23) +  &
                        cx3* (cy1*dzxy31+cy2*dzxy32+cy3*dzxy33)
                    ! Calculates the volatility factor and distance factor in the x
                    ! and y directions for the primary estimate of zxy.
                    b00 = (b00x+b00y)/2.0
                    sxy = sx*sy
                    sxxy = sxx*sy
                    sxyy = sx*syy
                    sxxyy = sxx*syy
                    sxyz = x1* (y1*z11+y2*z12+y3*z13) + x2* (y1*z21+y2*z22+y3*z23) +  &
                        x3* (y1*z31+y2*z32+y3*z33)
                    b11 = (sxyz-b00*sxy-b10*sxxy-b01*sxyy)/sxxyy
                    dz00 = z00 - b00
                    dz01 = z01 - (b00+b01*y1)
                    dz02 = z02 - (b00+b01*y2)
                    dz03 = z03 - (b00+b01*y3)
                    dz10 = z10 - (b00+b10*x1)
                    dz11 = z11 - (b00+b01*y1+x1* (b10+b11*y1))
                    dz12 = z12 - (b00+b01*y2+x1* (b10+b11*y2))
                    dz13 = z13 - (b00+b01*y3+x1* (b10+b11*y3))
                    dz20 = z20 - (b00+b10*x2)
                    dz21 = z21 - (b00+b01*y1+x2* (b10+b11*y1))
                    dz22 = z22 - (b00+b01*y2+x2* (b10+b11*y2))
                    dz23 = z23 - (b00+b01*y3+x2* (b10+b11*y3))
                    dz30 = z30 - (b00+b10*x3)
                    dz31 = z31 - (b00+b01*y1+x3* (b10+b11*y1))
                    dz32 = z32 - (b00+b01*y2+x3* (b10+b11*y2))
                    dz33 = z33 - (b00+b01*y3+x3* (b10+b11*y3))
                    volf = dz00**2 + dz01**2 + dz02**2 + dz03**2 +  &
                        dz10**2 + dz11**2 + dz12**2 + dz13**2 +  &
                        dz20**2 + dz21**2 + dz22**2 + dz23**2 +  &
                        dz30**2 + dz31**2 + dz32**2 + dz33**2
                    disf = sxx*syy
                    ! Calculates EPSLN.
                    epsln = (z00**2 + z01**2 + z02**2 + z03**2 + z10**2 +   &
                        z11**2 + z12**2 + z13**2 + z20**2 + z21**2 + z22**2 +   &
                        z23**2 + z30**2 + z31**2 + z32**2 + z33**2)* 1.0E-12
                    ! Accumulates the weighted primary estimates of zxy and their weights.
                    IF (volf > epsln) THEN
                        ! - For a finite weight.
                        wt = 1.0/ (volf*disf)
                        smpef = smpef + wt*pezxy
                        smwtf = smwtf + wt
                    ELSE
                        ! - For an infinite weight.
                        smpei = smpei + pezxy
                        smwti = smwti + 1.0
                    END IF
                END DO
            END DO

            ! Calculates the final estimate of zxy.
            IF (smwti < 0.5) THEN
                ! - When no infinite weights exist.
                zxydi = smpef/smwtf
            ELSE
                ! - When infinite weights exist.
                zxydi = smpei/smwti
            END IF
            ! End of Part 3

            pdd(1,ix0,iy0) = zxdi
            pdd(2,ix0,iy0) = zydi
            pdd(3,ix0,iy0) = zxydi
        END DO
    END DO
    RETURN
    END SUBROUTINE rgpd3p



    SUBROUTINE rglctn(nxd, nyd, xd, yd, nip, xi, yi, inxi, inyi)

    ! Location of the desired points in a rectangular grid
    ! (a supporting subroutine of the RGBI3P/RGSF3P subroutine package)

    ! Hiroshi Akima
    ! U.S. Department of Commerce, NTIA/ITS
    ! Version of 1995/08

    ! This subroutine locates the desired points in a rectangular grid
    ! in the x-y plane.

    ! The grid lines can be unevenly spaced.

    ! The input arguments are
    !   NXD  = number of the input-grid data points in the x
    !          coordinate (must be 2 or greater),
    !   NYD  = number of the input-grid data points in the y
    !          coordinate (must be 2 or greater),
    !   XD   = array of dimension NXD containing the x coordinates of the
    !          input-grid data points (must be in a monotonic increasing order),
    !   YD   = array of dimension NYD containing the y coordinates of the
    !          input-grid data points (must be in a monotonic increasing order),
    !   NIP  = number of the output points to be located (must be 1 or greater),
    !   XI   = array of dimension NIP containing the x coordinates
    !          of the output points to be located,
    !   YI   = array of dimension NIP containing the y coordinates
    !          of the output points to be located.

    ! The output arguments are
    !   INXI = integer array of dimension NIP where the interval
    !          numbers of the XI array elements are to be stored,
    !   INYI = integer array of dimension NIP where the interval
    !          numbers of the YI array elements are to be stored.
    ! The interval numbers are between 0 and NXD and between 0 and NYD,
    ! respectively.


    ! Specification statements
    !     .. Scalar Arguments ..

    INTEGER, INTENT(IN)   :: nxd
    INTEGER, INTENT(IN)   :: nyd
    REAL(GI), INTENT(IN)      :: xd(nxd)
    REAL(GI), INTENT(IN)      :: yd(nyd)
    INTEGER, INTENT(IN)   :: nip
    REAL(GI), INTENT(IN)      :: xi(nip)
    REAL(GI), INTENT(IN)      :: yi(nip)
    INTEGER, INTENT(OUT)  :: inxi(nip)
    INTEGER, INTENT(OUT)  :: inyi(nip)

    !     ..
    !     .. Local Scalars ..
    REAL(GI)     :: xii, yii
    INTEGER  :: iip, imd, imn, imx, ixd, iyd, nintx, ninty

    !     ..
    ! DO-loop with respect to IIP, which is the point number of the output point
    DO  iip = 1,nip
        xii = xi(iip)
        yii = yi(iip)
        ! Checks if the x coordinate of the IIPth output point, XII, is
        ! in a new interval.  (NINTX is the new-interval flag.)
        IF (iip == 1) THEN
            nintx = 1
        ELSE
            nintx = 0
            IF (ixd == 0) THEN
                IF (xii > xd(1)) nintx = 1
            ELSE IF (ixd < nxd) THEN
                IF ((xii < xd(ixd)) .OR. (xii > xd(ixd+1))) nintx = 1
            ELSE
                IF (xii < xd(nxd)) nintx = 1
            END IF
        END IF

        ! Locates the output point by binary search if XII is in a new interval.
        ! Determines IXD for which XII lies between XD(IXD) and XD(IXD+1).
        IF (nintx == 1) THEN
            IF (xii <= xd(1)) THEN
                ixd = 0
            ELSE IF (xii < xd(nxd)) THEN
                imn = 1
                imx = nxd
                imd = (imn+imx)/2
10              IF (xii >= xd(imd)) THEN
                    imn = imd
                ELSE
                    imx = imd
                END IF
                imd = (imn+imx)/2
                IF (imd > imn) GO TO 10
                ixd = imd
            ELSE
                ixd = nxd
            END IF
        END IF
        inxi(iip) = ixd

        ! Checks if the y coordinate of the IIPth output point, YII, is
        ! in a new interval.  (NINTY is the new-interval flag.)
        IF (iip == 1) THEN
            ninty = 1
        ELSE
            ninty = 0
            IF (iyd == 0) THEN
                IF (yii > yd(1)) ninty = 1
            ELSE IF (iyd < nyd) THEN
                IF ((yii < yd(iyd)) .OR. (yii > yd(iyd+1))) ninty = 1
            ELSE
                IF (yii < yd(nyd)) ninty = 1
            END IF
        END IF

        ! Locates the output point by binary search if YII is in a new interval.
        ! Determines IYD for which YII lies between YD(IYD) and YD(IYD+1).
        IF (ninty == 1) THEN
            IF (yii <= yd(1)) THEN
                iyd = 0
            ELSE IF (yii < yd(nyd)) THEN
                imn = 1
                imx = nyd
                imd = (imn+imx)/2
20              IF (yii >= yd(imd)) THEN
                    imn = imd
                ELSE
                    imx = imd
                END IF
                imd = (imn+imx)/2
                IF (imd > imn) GO TO 20
                iyd = imd
            ELSE
                iyd = nyd
            END IF
        END IF
        inyi(iip) = iyd
    END DO
    RETURN
    END SUBROUTINE rglctn



    SUBROUTINE rgplnl(nxd, nyd, xd, yd, zd, pdd, nip, xi, yi, inxi, inyi, zi)

    ! Polynomials for rectangular-grid bivariate interpolation and surface fitting
    ! (a supporting subroutine of the RGBI3P/RGSF3P subroutine package)

    ! Hiroshi Akima
    ! U.S. Department of Commerce, NTIA/ITS
    ! Version of 1995/08

    ! This subroutine determines a polynomial in x and y for a rectangle of the
    ! input grid in the x-y plane and calculates the z value for the desired
    ! points by evaluating the polynomial for rectangular-grid bivariate
    ! interpolation and surface fitting.

    ! The input arguments are
    !   NXD  = number of the input-grid data points in the x
    !          coordinate (must be 2 or greater),
    !   NYD  = number of the input-grid data points in the y
    !          coordinate (must be 2 or greater),
    !   XD   = array of dimension NXD containing the x coordinates of the
    !          input-grid data points (must be in a monotonic increasing order),
    !   YD   = array of dimension NYD containing the y coordinates of the
    !          input-grid data points (must be in a monotonic increasing order),
    !   ZD   = two-dimensional array of dimension NXD*NYD
    !          containing the z(x,y) values at the input-grid data points,
    !   PDD  = three-dimensional array of dimension 3*NXD*NYD
    !          containing the estimated zx, zy, and zxy values
    !          at the input-grid data points,
    !   NIP  = number of the output points at which interpolation
    !          is to be performed,
    !   XI   = array of dimension NIP containing the x coordinates
    !          of the output points,
    !   YI   = array of dimension NIP containing the y coordinates
    !          of the output points,
    !   INXI = integer array of dimension NIP containing the
    !          interval numbers of the input grid intervals in the
    !          x direction where the x coordinates of the output points lie,
    !   INYI = integer array of dimension NIP containing the
    !          interval numbers of the input grid intervals in the
    !          y direction where the y coordinates of the output points lie.

    ! The output argument is
    !   ZI   = array of dimension NIP, where the interpolated z
    !          values at the output points are to be stored.


    ! Specification statements
    !     .. Scalar Arguments ..

    INTEGER, INTENT(IN)  :: nxd
    INTEGER, INTENT(IN)  :: nyd
    REAL(GI), INTENT(IN)     :: xd(nxd)
    REAL(GI), INTENT(IN)     :: yd(nyd)
    REAL(GI), INTENT(IN)     :: zd(nxd,nyd)
    REAL(GI), INTENT(IN)     :: pdd(3,nxd,nyd)
    INTEGER, INTENT(IN)  :: nip
    REAL(GI), INTENT(IN)     :: xi(nip)
    REAL(GI), INTENT(IN)     :: yi(nip)
    INTEGER, INTENT(IN)  :: inxi(nip)
    INTEGER, INTENT(IN)  :: inyi(nip)
    REAL(GI), INTENT(OUT)    :: zi(nip)

    !     ..
    !     .. Local Scalars ..
    REAL(GI) :: a, b, c, this, dx, dxsq, dy, dysq, p00, p01, p02, p03, p10, p11,  &
        p12, p13, p20, p21, p22, p23, p30, p31, p32, p33, q0, q1, q2,  &
        q3, u, v, x0, xii, y0, yii, z00, z01, z0dx, z0dy, z10, z11,  &
        z1dx, z1dy, zdxdy, zii, zx00, zx01, zx0dy, zx10, zx11,  &
        zx1dy, zxy00, zxy01, zxy10, zxy11, zy00, zy01, zy0dx, zy10, zy11, zy1dx
    INTEGER :: iip, ixd0, ixd1, ixdi, ixdipv, iyd0, iyd1, iydi, iydipv
    !     ..
    !     .. Intrinsic Functions ..
    ! INTRINSIC        MAX
    !     ..

    ! Calculation
    ! Outermost DO-loop with respect to the output point
    DO  iip = 1,nip
        xii = xi(iip)
        yii = yi(iip)
        IF (iip == 1) THEN
            ixdipv = -1
            iydipv = -1
        ELSE
            ixdipv = ixdi
            iydipv = iydi
        END IF
        ixdi = inxi(iip)
        iydi = inyi(iip)

        ! Retrieves the z and partial derivative values at the origin of
        ! the coordinate for the rectangle.
        IF (ixdi /= ixdipv .OR. iydi /= iydipv) THEN
            ixd0 = MAX(1,ixdi)
            iyd0 = MAX(1,iydi)
            x0 = xd(ixd0)
            y0 = yd(iyd0)
            z00 = zd(ixd0,iyd0)
            zx00 = pdd(1,ixd0,iyd0)
            zy00 = pdd(2,ixd0,iyd0)
            zxy00 = pdd(3,ixd0,iyd0)
        END IF

        ! Case 1.  When the rectangle is inside the data area in both the
        ! x and y directions.
        IF ((ixdi > 0 .AND. ixdi < nxd) .AND. (iydi > 0 .AND. iydi < nyd)) THEN
            ! Retrieves the z and partial derivative values at the other three
            ! vertices of the rectangle.
            IF (ixdi /= ixdipv .OR. iydi /= iydipv) THEN
                ixd1 = ixd0 + 1
                dx = xd(ixd1) - x0
                dxsq = dx*dx
                iyd1 = iyd0 + 1
                dy = yd(iyd1) - y0
                dysq = dy*dy
                z10 = zd(ixd1,iyd0)
                z01 = zd(ixd0,iyd1)
                z11 = zd(ixd1,iyd1)
                zx10 = pdd(1,ixd1,iyd0)
                zx01 = pdd(1,ixd0,iyd1)
                zx11 = pdd(1,ixd1,iyd1)
                zy10 = pdd(2,ixd1,iyd0)
                zy01 = pdd(2,ixd0,iyd1)
                zy11 = pdd(2,ixd1,iyd1)
                zxy10 = pdd(3,ixd1,iyd0)
                zxy01 = pdd(3,ixd0,iyd1)
                zxy11 = pdd(3,ixd1,iyd1)
                ! Calculates the polynomial coefficients.
                z0dx = (z10-z00)/dx
                z1dx = (z11-z01)/dx
                z0dy = (z01-z00)/dy
                z1dy = (z11-z10)/dy
                zx0dy = (zx01-zx00)/dy
                zx1dy = (zx11-zx10)/dy
                zy0dx = (zy10-zy00)/dx
                zy1dx = (zy11-zy01)/dx
                zdxdy = (z1dy-z0dy)/dx
                a = zdxdy - zx0dy - zy0dx + zxy00
                b = zx1dy - zx0dy - zxy10 + zxy00
                c = zy1dx - zy0dx - zxy01 + zxy00
                this = zxy11 - zxy10 - zxy01 + zxy00
                p00 = z00
                p01 = zy00
                p02 = (2.0* (z0dy-zy00)+z0dy-zy01)/dy
                p03 = (-2.0*z0dy+zy01+zy00)/dysq
                p10 = zx00
                p11 = zxy00
                p12 = (2.0* (zx0dy-zxy00)+zx0dy-zxy01)/dy
                p13 = (-2.0*zx0dy+zxy01+zxy00)/dysq
                p20 = (2.0* (z0dx-zx00)+z0dx-zx10)/dx
                p21 = (2.0* (zy0dx-zxy00)+zy0dx-zxy10)/dx
                p22 = (3.0* (3.0*a-b-c)+this)/ (dx*dy)
                p23 = (-6.0*a+2.0*b+3.0*c-this)/ (dx*dysq)
                p30 = (-2.0*z0dx+zx10+zx00)/dxsq
                p31 = (-2.0*zy0dx+zxy10+zxy00)/dxsq
                p32 = (-6.0*a+3.0*b+2.0*c-this)/ (dxsq*dy)
                p33 = (2.0* (2.0*a-b-c)+this)/ (dxsq*dysq)
            END IF

            ! Evaluates the polynomial.
            u = xii - x0
            v = yii - y0
            q0 = p00 + v* (p01+v* (p02+v*p03))
            q1 = p10 + v* (p11+v* (p12+v*p13))
            q2 = p20 + v* (p21+v* (p22+v*p23))
            q3 = p30 + v* (p31+v* (p32+v*p33))
            zii = q0 + u* (q1+u* (q2+u*q3))
            ! End of Case 1

            ! Case 2.  When the rectangle is inside the data area in the x
            ! direction but outside in the y direction.
        ELSE IF ((ixdi > 0.AND.ixdi < nxd) .AND.  &
            (iydi <= 0.OR.iydi >= nyd)) THEN
            ! Retrieves the z and partial derivative values at the other
            ! vertex of the semi-infinite rectangle.
            IF (ixdi /= ixdipv .OR. iydi /= iydipv) THEN
                ixd1 = ixd0 + 1
                dx = xd(ixd1) - x0
                dxsq = dx*dx
                z10 = zd(ixd1,iyd0)
                zx10 = pdd(1,ixd1,iyd0)
                zy10 = pdd(2,ixd1,iyd0)
                zxy10 = pdd(3,ixd1,iyd0)
                ! Calculates the polynomial coefficients.
                z0dx = (z10-z00)/dx
                zy0dx = (zy10-zy00)/dx
                p00 = z00
                p01 = zy00
                p10 = zx00
                p11 = zxy00
                p20 = (2.0* (z0dx-zx00)+z0dx-zx10)/dx
                p21 = (2.0* (zy0dx-zxy00)+zy0dx-zxy10)/dx
                p30 = (-2.0*z0dx+zx10+zx00)/dxsq
                p31 = (-2.0*zy0dx+zxy10+zxy00)/dxsq
            END IF
            ! Evaluates the polynomial.
            u = xii - x0
            v = yii - y0
            q0 = p00 + v*p01
            q1 = p10 + v*p11
            q2 = p20 + v*p21
            q3 = p30 + v*p31
            zii = q0 + u* (q1+u* (q2+u*q3))
            ! End of Case 2

            ! Case 3.  When the rectangle is outside the data area in the x
            ! direction but inside in the y direction.
        ELSE IF ((ixdi <= 0.OR.ixdi >= nxd) .AND.  &
            (iydi > 0 .AND. iydi < nyd)) THEN
            ! Retrieves the z and partial derivative values at the other
            ! vertex of the semi-infinite rectangle.
            IF (ixdi /= ixdipv .OR. iydi /= iydipv) THEN
                iyd1 = iyd0 + 1
                dy = yd(iyd1) - y0
                dysq = dy*dy
                z01 = zd(ixd0,iyd1)
                zx01 = pdd(1,ixd0,iyd1)
                zy01 = pdd(2,ixd0,iyd1)
                zxy01 = pdd(3,ixd0,iyd1)
                ! Calculates the polynomial coefficients.
                z0dy = (z01-z00)/dy
                zx0dy = (zx01-zx00)/dy
                p00 = z00
                p01 = zy00
                p02 = (2.0*(z0dy-zy00)+z0dy-zy01)/dy
                p03 = (-2.0*z0dy+zy01+zy00)/dysq
                p10 = zx00
                p11 = zxy00
                p12 = (2.0*(zx0dy-zxy00) + zx0dy - zxy01)/dy
                p13 = (-2.0*zx0dy + zxy01 + zxy00)/dysq
            END IF

            ! Evaluates the polynomial.
            u = xii - x0
            v = yii - y0
            q0 = p00 + v* (p01 + v*(p02+v*p03))
            q1 = p10 + v* (p11 + v*(p12+v*p13))
            zii = q0 + u*q1
            ! End of Case 3

            ! Case 4.  When the rectangle is outside the data area in both the
            ! x and y direction.
        ELSE IF ((ixdi <= 0 .OR. ixdi >= nxd) .AND.  &
            (iydi <= 0 .OR. iydi >= nyd)) THEN
            ! Calculates the polynomial coefficients.
            IF (ixdi /= ixdipv .OR. iydi /= iydipv) THEN
                p00 = z00
                p01 = zy00
                p10 = zx00
                p11 = zxy00
            END IF
            ! Evaluates the polynomial.
            u = xii - x0
            v = yii - y0
            q0 = p00 + v*p01
            q1 = p10 + v*p11
            zii = q0 + u*q1
        END IF
        ! End of Case 4
        zi(iip) = zii
    END DO

    RETURN
    END SUBROUTINE rgplnl

    end module Interpolation

    module InterpolationTests
    use Interpolation
    use FileUtils
    use FileTests
    implicit None
    integer, parameter, private :: sp= KIND(1.d0)

    contains

    function func(x)
    real(sp) func,x

    func = (x/47.2_sp)**3  + (x/5.5_sp)**2 +x*3.5_sp+4.4579_sp
    end function

    function funcderiv(x)
    real(sp) funcderiv,x

    funcderiv = 3*(x/47.2_sp)**2/47.2_sp  + 2*(x/5.5_sp)/5.5_sp +3.5_sp
    end function

    function RunInterpolationTests() result(fails)
    real(sp), allocatable :: x(:),f(:)
    integer i
    integer fails
    Type(TCubicSpline) :: Irreg, IrregLoad
    Type(TRegularCubicSpline) :: Reg, RegLoad
    Type(TLogRegularCubicSpline) :: Reglog
    real(sp) xx
    real(sP), parameter:: testval = 13.2623_sp
    real(sP), parameter:: testarrayval(3) = [7.3_sp, 9._sp,34.34643_sp]
    real(sp) :: outarray(3), funcarray(3)
    Type(TBinaryFile) :: FB
    
    fails = 0
    allocate(x(100),f(100))
    do i=1, 100
        x(i) = 0.5367_sp*real(i,sp) + 0.3_sp
        f(i) = func(x(i))
    end do
    call Irreg%Init(x,f)
    call Reg%Init(x(1),x(size(x)),100,values=f)
    call RegLog%init(x(1),x(size(x)),100)
    do i=1, 100
        xx= exp(log(x(1)) + RegLog%delta_x*(i-1))
        RegLog%F(i) = func(xx)
    end do

    if (all(abs([Reg%Value(testval), Irreg%Value(testval), RegLog%Value(testval)]-func(testval))<1e-5)) then
        print *,'Value OK'
    else
        fails = fails+1
        print *, 'error'
        print *, Reg%Value(testval), Irreg%Value(testval),RegLog%Value(testval), func(testval)
    end if

    if (all(abs([Reg%Value(x(1)), Irreg%Value(x(1)), RegLog%Value(x(1))]-func(x(1)))<1e-5)) then
        print *,'bottom end value OK'
    else
        fails = fails+1
        print *, 'end error'
        print *, Reg%Value(testval), Irreg%Value(testval),RegLog%Value(testval), func(testval)
    end if

    if (all(abs([Reg%Value(x(100)), Irreg%Value(x(100)), RegLog%Value(x(100))]-func(x(100)))<1e-5)) then
        print *,'top end value OK'
    else
        fails = fails+1
        print *, 'end error'
        print *, Reg%Value(testval), Irreg%Value(testval),RegLog%Value(testval), func(testval)
    end if

    if (all(abs([Reg%Derivative(testval), Irreg%Derivative(testval), RegLog%Derivative(testval)]-funcderiv(testval))<1e-5)) then
        print *,'Derivative OK'
    else
        fails = fails+1
        print *, 'derivative error'
        print *, Reg%Derivative(testval), Irreg%Derivative(testval),RegLog%Derivative(testval), funcderiv(testval)
    end if
    
    do i=1,3
        funcarray(i) = func(testarrayval(i))
    end do
    call Reg%Array(testarrayval, outarray)
    if (all(abs(outarray-funcarray)<1e-7)) then
        print *, 'array value OK'
    else
        fails = fails+1
        print *, 'array error'
        print *, outarray
        print *, funcarray
    end if

    call FB%CreateFile(temp_file)
    call Irreg%SaveState(FB)
    call FB%Close()
    call FB%Open(temp_file)
    call IrregLoad%loadState(FB)
    call FB%Close()
    if (abs( IrregLoad%Value(testval) -Irreg%Value(testval))<1e-8) then
        print *,'Load bin OK'
    else
        fails = fails+1
        print *, 'Load bin error'
    end if
    call FB%CreateFile(temp_file)
    call Reg%SaveState(FB)
    call FB%Close()
    call FB%Open(temp_file)
    call RegLoad%loadState(FB)
    call FB%Close()
    if (abs( RegLoad%Value(testval) -Reg%Value(testval))<1e-8) then
        print *,'Load bin2 OK'
    else
        fails = fails+1
        print *, 'Load bin2 error'
    end if
    call File%Delete(temp_file)
    
    end function RunInterpolationTests

    end module InterpolationTests

    module DarkEnergyInterface
    use precision
    use interpolation
    use classes
    implicit none

    private

    type, extends(TCambComponent) :: TDarkEnergyModel
        logical :: is_cosmological_constant = .true.
        integer :: num_perturb_equations = 0
    contains
    procedure :: Init
    procedure :: BackgroundDensityAndPressure
    procedure :: PerturbedStressEnergy !Get density perturbation and heat flux for sources
    procedure :: diff_rhopi_Add_Term
    procedure :: PerturbationInitial
    procedure :: PerturbationEvolve
    procedure :: PrintFeedback
    ! do not have to implement w_de or grho_de if BackgroundDensityAndPressure is inherited directly
    procedure :: w_de
    procedure :: grho_de
    procedure :: Effective_w_wa !Used as approximate values for non-linear corrections
    end type TDarkEnergyModel

    type, extends(TDarkEnergyModel) :: TDarkEnergyEqnOfState
        !Type supporting w, wa or general w(z) table
        real(dl) :: w_lam = -1_dl !p/rho for the dark energy (an effective value, used e.g. for halofit)
        real(dl) :: wa = 0._dl !may not be used, just for compatibility with e.g. halofit
        real(dl) :: cs2_lam = 1_dl !rest-frame sound speed, though may not be used
        logical :: use_tabulated_w = .false.  !Use interpolated table; note this is quite slow.
        logical :: no_perturbations = .false. !Don't change this, no perturbations is unphysical
        !Interpolations if use_tabulated_w=.true.
        Type(TCubicSpline) :: equation_of_state, logdensity
    contains
    procedure :: ReadParams => TDarkEnergyEqnOfState_ReadParams
    procedure :: Init => TDarkEnergyEqnOfState_Init
    procedure :: SetwTable => TDarkEnergyEqnOfState_SetwTable
    procedure :: PrintFeedback => TDarkEnergyEqnOfState_PrintFeedback
    procedure :: w_de => TDarkEnergyEqnOfState_w_de
    procedure :: grho_de => TDarkEnergyEqnOfState_grho_de
    procedure :: Effective_w_wa => TDarkEnergyEqnOfState_Effective_w_wa
    end type TDarkEnergyEqnOfState

    public TDarkEnergyModel, TDarkEnergyEqnOfState
    contains

    function w_de(this, a)
    class(TDarkEnergyModel) :: this
    real(dl) :: w_de, al
    real(dl), intent(IN) :: a

    w_de = -1._dl

    end function w_de  ! equation of state of the PPF DE

    function grho_de(this, a)  !relative density (8 pi G a^4 rho_de /grhov)
    class(TDarkEnergyModel) :: this
    real(dl) :: grho_de, al, fint
    real(dl), intent(IN) :: a

    grho_de =0._dl

    end function grho_de

    subroutine PrintFeedback(this, FeedbackLevel)
    class(TDarkEnergyModel) :: this
    integer, intent(in) :: FeedbackLevel

    end subroutine PrintFeedback


    subroutine Init(this, State)
    use classes
    class(TDarkEnergyModel), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State

    end subroutine Init

    subroutine BackgroundDensityAndPressure(this, grhov, a, grhov_t, w)
    !Get grhov_t = 8*pi*rho_de*a**2 and (optionally) equation of state at scale factor a
    class(TDarkEnergyModel), intent(inout) :: this
    real(dl), intent(in) :: grhov, a
    real(dl), intent(out) :: grhov_t
    real(dl), optional, intent(out) :: w

    if (this%is_cosmological_constant) then
        grhov_t = grhov * a * a
        if (present(w)) w = -1_dl
    else
        ! Ensure a valid result
        if (a > 1e-10) then
            grhov_t = grhov * this%grho_de(a) / (a * a)
        else
            grhov_t = 0._dl
        end if
        if (present(w)) w = this%w_de(a)
    end if

    end subroutine BackgroundDensityAndPressure

    subroutine Effective_w_wa(this, w, wa)
    class(TDarkEnergyModel), intent(inout) :: this
    real(dl), intent(out) :: w, wa

    w = -1
    wa = 0

    end subroutine Effective_w_wa


    subroutine PerturbedStressEnergy(this, dgrhoe, dgqe, &
        a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1, ay, ayprime, w_ix)
    class(TDarkEnergyModel), intent(inout) :: this
    real(dl), intent(out) :: dgrhoe, dgqe
    real(dl), intent(in) ::  a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1
    real(dl), intent(in) :: ay(*)
    real(dl), intent(inout) :: ayprime(*)
    integer, intent(in) :: w_ix

    dgrhoe=0
    dgqe=0

    end subroutine PerturbedStressEnergy


    function diff_rhopi_Add_Term(this, dgrhoe, dgqe,grho, gpres, w, grhok, adotoa, &
        Kf1, k, grhov_t, z, k2, yprime, y, w_ix) result(ppiedot)
    class(TDarkEnergyModel), intent(in) :: this
    real(dl), intent(in) :: dgrhoe, dgqe, grho, gpres, grhok, w, adotoa, &
        k, grhov_t, z, k2, yprime(:), y(:), Kf1
    integer, intent(in) :: w_ix
    real(dl) :: ppiedot

    ! Ensure, that the result is set, when the function is not implemented by
    ! subclasses
    ppiedot = 0._dl

    end function diff_rhopi_Add_Term

    subroutine PerturbationEvolve(this, ayprime, w, w_ix, a, adotoa, k, z, y)
    class(TDarkEnergyModel), intent(in) :: this
    real(dl), intent(inout) :: ayprime(:)
    real(dl), intent(in) :: a,adotoa, k, z, y(:), w
    integer, intent(in) :: w_ix
    end subroutine PerturbationEvolve

    subroutine PerturbationInitial(this, y, a, tau, k)
    class(TDarkEnergyModel), intent(in) :: this
    real(dl), intent(out) :: y(:)
    real(dl), intent(in) :: a, tau, k
    !Get intinitial values for perturbations at a (or tau)
    !For standard adiabatic perturbations can usually just set to zero to good accuracy

    y = 0

    end subroutine PerturbationInitial


    subroutine TDarkEnergyEqnOfState_SetwTable(this, a, w, n)
    class(TDarkEnergyEqnOfState) :: this
    integer, intent(in) :: n
    real(dl), intent(in) :: a(n), w(n)
    real(dl), allocatable :: integral(:)

    if (abs(a(size(a)) -1) > 1e-5) error stop 'w table must end at a=1'

    this%use_tabulated_w = .true.
    call this%equation_of_state%Init(log(a), w)

    allocate(integral(this%equation_of_state%n))
    ! log (rho) =  -3 int dlna (1+w)
    call this%equation_of_state%IntegralArray(integral)
    integral  = -3*( (this%equation_of_state%X-this%equation_of_state%X(1)) + integral) + 4*this%equation_of_state%X
    integral = integral - integral(this%equation_of_state%n) !log(a^4 rho_de)) normalized to 0 at a=1
    call this%logdensity%Init(this%equation_of_state%X, integral)
    !Set w and wa to values today (e.g. as too simple first guess for approx fittings etc).
    this%w_lam = w(size(a))
    this%wa = -this%equation_of_state%Derivative(0._dl)

    end subroutine TDarkEnergyEqnOfState_SetwTable


    function TDarkEnergyEqnOfState_w_de(this, a)
    class(TDarkEnergyEqnOfState) :: this
    real(dl) :: TDarkEnergyEqnOfState_w_de, al
    real(dl), intent(IN) :: a

    if(.not. this%use_tabulated_w) then
        TDarkEnergyEqnOfState_w_de= this%w_lam+ this%wa*(1._dl-a)
    else
        al=dlog(a)
        if(al <= this%equation_of_state%Xmin_interp) then
            TDarkEnergyEqnOfState_w_de= this%equation_of_state%F(1)
        elseif(al >= this%equation_of_state%Xmax_interp) then
            TDarkEnergyEqnOfState_w_de= this%equation_of_state%F(this%equation_of_state%n)
        else
            TDarkEnergyEqnOfState_w_de = this%equation_of_state%Value(al)
        endif
    endif

    end function TDarkEnergyEqnOfState_w_de  ! equation of state of the PPF DE


    subroutine TDarkEnergyEqnOfState_Effective_w_wa(this, w, wa)
    class(TDarkEnergyEqnOfState), intent(inout) :: this
    real(dl), intent(out) :: w, wa

    w = this%w_lam
    wa = this%wa

    end subroutine TDarkEnergyEqnOfState_Effective_w_wa

    function TDarkEnergyEqnOfState_grho_de(this, a) result(grho_de) !relative density (8 pi G a^4 rho_de /grhov)
    class(TDarkEnergyEqnOfState) :: this
    real(dl) :: grho_de, al, fint
    real(dl), intent(IN) :: a

    if(.not. this%use_tabulated_w) then
        grho_de = a ** (1._dl - 3. * this%w_lam - 3. * this%wa)
        if (this%wa/=0) grho_de=grho_de*exp(-3. * this%wa * (1._dl - a))
    else
        if(a == 0.d0)then
            grho_de = 0.d0      !assume rho_de*a^4-->0, when a-->0, OK if w_de always <0.
        else
            if (a>=1) then
                fint= 1
            else
                al = dlog(a)
                if(al <= this%logdensity%X(1)) then
                    ! assume here w=w_de(a_min)
                    fint = exp(this%logdensity%F(1) + (1. - 3. * this%equation_of_state%F(1))*(al - this%logdensity%X(1)))
                else
                    fint = exp(this%logdensity%Value(al))
                endif
            end if
            grho_de = fint
        endif
    endif

    end function TDarkEnergyEqnOfState_grho_de

    subroutine TDarkEnergyEqnOfState_PrintFeedback(this, FeedbackLevel)
    class(TDarkEnergyEqnOfState) :: this
    integer, intent(in) :: FeedbackLevel

    if (FeedbackLevel >0) write(*,'("(w0, wa) = (", f8.5,", ", f8.5, ")")') &
        &   this%w_lam, this%wa

    end subroutine TDarkEnergyEqnOfState_PrintFeedback

    subroutine TDarkEnergyEqnOfState_ReadParams(this, Ini)
    use IniObjects
    use FileUtils
    class(TDarkEnergyEqnOfState) :: this
    class(TIniFile), intent(in) :: Ini
    real(dl), allocatable :: table(:,:)

    this%use_tabulated_w = Ini%Read_Logical('use_tabulated_w', .false.)
    if(.not. this%use_tabulated_w)then
        this%w_lam = Ini%Read_Double('w', -1.d0)
        this%wa = Ini%Read_Double('wa', 0.d0)
        ! trap dark energy becoming important at high redshift 
        ! (will still work if this test is removed in some cases)
        if (this%w_lam + this%wa > 0) &
             error stop 'w + wa > 0, giving w>0 at high redshift'
    else
        call File%LoadTxt(Ini%Read_String('wafile'), table)
        call this%SetwTable(table(:,1),table(:,2), size(table(:,1)))
    endif

    end subroutine TDarkEnergyEqnOfState_ReadParams


    subroutine TDarkEnergyEqnOfState_Init(this, State)
    use classes
    class(TDarkEnergyEqnOfState), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State

    this%is_cosmological_constant = .not. this%use_tabulated_w .and. &
        &  abs(this%w_lam + 1._dl) < 1.e-6_dl .and. this%wa==0._dl

    end subroutine TDarkEnergyEqnOfState_Init


    end module DarkEnergyInterface

    module MathUtils
    use precision
    implicit none

    interface
    FUNCTION obj_function(obj, x)
    use precision
    class(*) :: obj
    real(dl) :: x, obj_function
    END FUNCTION  obj_function
    end interface

    contains

    function Integrate_Romberg(obj, fin, a, b, tol, maxit, minsteps, abs_tol)
    !  Rombint returns the integral from a to b of f(obj,x) using Romberg integration.
    !  The method converges provided that f is continuous in (a,b).
    !  f must be real(dl). The first argument is a class instance.
    !  tol indicates the desired relative accuracy in the integral.

    ! Modified by AL to specify max iterations and minimum number of steps
    ! (min steps useful to stop wrong results on periodic or sharp functions)
    use iso_c_binding
    use MiscUtils
    use config, only : global_error_flag
    class(*) :: obj
    real(dl), external :: fin !a class function
    procedure(obj_function), pointer :: f
    real(dl), intent(in) :: a,b,tol
    integer, intent(in), optional :: maxit,minsteps
    logical, intent(in), optional :: abs_tol
    integer max_it, min_steps
    real(dl) :: Integrate_Romberg
    integer, parameter :: MAXJ=5
    integer :: nint, i, k, jmax, j
    real(dl) :: h, gmax, error, g(MAXJ+1), g0, g1, fourj
    logical abstol

    !convert the class function (un-type-checked) into correct type to call correctly for class argument
    call C_F_PROCPOINTER(c_funloc(fin), f)
    Integrate_Romberg = -1
    max_it = PresentDefault(25, maxit)
    min_steps = PresentDefault(0, minsteps)
    abstol = DefaultFalse(abs_tol)
    h=0.5d0*(b-a)
    gmax=h*(f(obj,a)+f(obj,b))
    if (global_error_flag /=0) return
    g(1)=gmax
    nint=1
    error=1.0d20
    i=0
    do
        i=i+1
        if (i > max_it.or.(i > 5.and.abs(error) < tol) .and. nint > min_steps) exit
        !  Calculate next trapezoidal rule approximation to integral.
        g0=0._dl
        do k=1,nint
            g0=g0+f(obj, a+(k+k-1)*h)
            if (global_error_flag /=0) return
        end do
        g0=0.5d0*g(1)+h*g0
        h=0.5d0*h
        nint=nint+nint
        jmax=min(i,MAXJ)
        fourj=1._dl
        do j=1,jmax
            !  Use Richardson extrapolation.
            fourj=4._dl*fourj
            g1=g0+(g0-g(j))/(fourj-1._dl)
            g(j)=g0
            g0=g1
        end do
        if (abstol) then
            error=abs(gmax-g0)
        else
            if (abs(g0).gt.tol) then
                error=1._dl-gmax/g0
            else
                error=gmax
            end if
        end if
        gmax=g0
        g(jmax+1)=g0
    end do

    Integrate_Romberg=g0
    if (i > max_it .and. abs(error) > tol)  then
        write(*,*) 'Warning: Integrate_Romberg failed to converge; '
        write (*,*)'integral, error, tol:', Integrate_Romberg,error, tol
    end if

    end function Integrate_Romberg


    subroutine brentq(obj,func,ax,bx,tol,xzero,fzero,iflag,fax,fbx)
    use iso_c_binding

    !>
    !  Find a zero of the function \( f(x) \) in the given interval
    !  \( [a_x,b_x] \) to within a tolerance \( 4 \epsilon |x| + tol \),
    !  where \( \epsilon \) is the relative machine precision defined as
    !  the smallest representable number such that \( 1.0 + \epsilon > 1.0 \).
    !
    !  It is assumed that \( f(a_x) \) and \( f(b_x) \) have opposite signs.
    !
    !#References
    !  * R. P. Brent, "[An algorithm with guaranteed convergence for
    !    finding a zero of a function](http://maths-people.anu.edu.au/~brent/pd/rpb005.pdf)",
    !    The Computer Journal, Vol 14, No. 4., 1971.
    !  * R. P. Brent, "[Algorithms for minimization without derivatives](http://maths-people.anu.edu.au/~brent/pub/pub011.html)",
    !    Prentice-Hall, Inc., 1973.
    !
    !# See also
    !  1. [zeroin.f](http://www.netlib.org/go/zeroin.f) from Netlib

    use iso_fortran_env, only: error_unit
    implicit none
    class(*) :: obj
    real(dl), external :: func !a class function f(obj,x)
    procedure(obj_function), pointer :: f

    real(dl),intent(in)              :: ax      !! left endpoint of initial interval
    real(dl),intent(in)              :: bx      !! right endpoint of initial interval
    real(dl),intent(in)              :: tol     !! desired length of the interval of uncertainty of the final result (>=0)
    real(dl),intent(out)             :: xzero   !! abscissa approximating a zero of `f` in the interval `ax`,`bx`
    real(dl),intent(out)             :: fzero   !! value of `f` at the root (`f(xzero)`)
    integer,intent(out)              :: iflag   !! status flag (`-1`=error, `0`=root found)
    real(dl),intent(in),optional     :: fax     !! if `f(ax)` is already known, it can be input here
    real(dl),intent(in),optional     :: fbx     !! if `f(bx)` is already known, it can be input here
    real(dl), parameter :: one = 1._dl, zero = 0._dl, two =2._dl, three = 3._dl
    real(dl),parameter :: eps   = epsilon(one)  !! original code had d1mach(4)
    real(dl) :: a,b,c,d,e,fa,fb,fc,tol1,xm,p,q,r,s

    !convert the class function (un-type-checked) into correct type to call correctly for class argument
    call C_F_PROCPOINTER(c_funloc(func), f)

    tol1 = eps+one

    a=ax
    b=bx

    if (present(fax)) then
        fa = fax
    else
        fa=f(obj,a)
    end if
    if (present(fbx)) then
        fb = fbx
    else
        fb=f(obj,b)
    end if

    !check trivial cases first:
    if (fa==zero) then

        iflag = 0
        xzero = a
        fzero = fa

    elseif (fb==zero) then

        iflag = 0
        xzero = b
        fzero = fb

    elseif (fa*(fb/abs(fb))<zero) then  ! check that f(ax) and f(bx) have different signs

        c=a
        fc=fa
        d=b-a
        e=d

        do

            if (abs(fc)<abs(fb)) then
                a=b
                b=c
                c=a
                fa=fb
                fb=fc
                fc=fa
            end if

            tol1=two*eps*abs(b)+0.5_dl*tol
            xm = 0.5_dl*(c-b)
            if ((abs(xm)<=tol1).or.(fb==zero)) exit

            ! see if a bisection is forced
            if ((abs(e)>=tol1).and.(abs(fa)>abs(fb))) then
                s=fb/fa
                if (a/=c) then
                    ! inverse quadratic interpolation
                    q=fa/fc
                    r=fb/fc
                    p=s*(two*xm*q*(q-r)-(b-a)*(r-one))
                    q=(q-one)*(r-one)*(s-one)
                else
                    ! linear interpolation
                    p=two*xm*s
                    q=one-s
                end if
                if (p<=zero) then
                    p=-p
                else
                    q=-q
                end if
                s=e
                e=d
                if (((two*p)>=(three*xm*q-abs(tol1*q))) .or. &
                    (p>=abs(0.5_dl*s*q))) then
                    d=xm
                    e=d
                else
                    d=p/q
                end if
            else
                d=xm
                e=d
            end if

            a=b
            fa=fb
            if (abs(d)<=tol1) then
                if (xm<=zero) then
                    b=b-tol1
                else
                    b=b+tol1
                end if
            else
                b=b+d
            end if
            fb=f(obj,b)
            if ((fb*(fc/abs(fc)))>zero) then
                c=a
                fc=fa
                d=b-a
                e=d
            end if

        end do

        iflag = 0
        xzero = b
        fzero = fb

    else

        iflag = -1
        write(error_unit,'(A)')&
            'Error in zeroin: f(ax) and f(bx) do not have different signs.'

    end if

    end subroutine brentq

    function Newton_Raphson2(xxl,xxh,funcs, param, param2) result(xm)
    use Precision
    implicit none
    real(dl), intent(in) :: xxl     ! root bracket 1
    real(dl), intent(in) :: xxh     ! root bracket 2
    real(dl)  :: xl,xh, xm     ! root
    external funcs        ! subroutine for non-linear equation
    real(dl), intent(in) :: param, param2 !parameters for function
    integer  :: k                      ! iteration count
    real(dl) :: xn, f,f2,df, error
    real(dl), parameter :: half=0.5_dl
    integer, parameter :: ITERMAX=1000 ! max number of iteration
    real(dl), parameter :: tol=1.e-8_dl ! tolerance for error

    xl =xxl
    xh = xxh
    call funcs(f,df,xl, param, param2)  ! Set xm=f(xl)
    call funcs(f2,df,xh, param, param2)  ! Set xn=f(xh)
    if (f*f2 > 0._dl) then           ! check if function changes sign
        error stop 'Newton_Raphson: root is not bracketed'
    endif
    if (f > 0._dl) then               ! Rearrange so that f(xl)< 0.d0 < f(xh)
        xm = xl
        xl = xh
        xh = xm
    endif

    error = abs(xh-xl)                ! error is width of bracketing interval
    xm = half*(xl+xh)                 ! Initialize guess for root
    k = 0                             ! initialize iteration count
    do while (error > tol .and. k < ITERMAX) ! iterate
        k = k+1                         ! increment iteration count
        call funcs(f,df,xm, param, param2) ! calculate f(xm), df(xm)
        if (f > 0._dl) then              ! Update root bracketing
            xh = xm                       ! update high
        else
            xl = xm                       ! update low
        endif
        xn = xm - f/df                  ! Tentative newton-Raphson step
        if ( (xn-xl)*(xn-xh) > 0._dl ) then ! check if new root falls within bracket
            xm = half* (xh+xl)            ! if no use a Bisection step
            error = abs(xh-xl)            ! error is width of interval
        else
            error = abs(xn-xm)            ! if within bracket: error is change in root
            xm = xn                       ! update successful Newton-Raphson step
        endif
    enddo

    if (error > tol) then       ! Check if solution converged
        write(*,*) 'Newton_Raphson:solution did not converge, xn, funcs(xn),D(xn)'
        write(*,*) xn, f, error
    endif

    end function Newton_Raphson2


    subroutine Gauss_Legendre(x,w,n)
    !Get Gauss-Legendre points x and weights w, for n points
    use constants
    implicit none
    integer, intent(in) :: n
    real(dl), intent(out) :: x(n), w(n)
    real(dl), parameter :: eps=1.d-15
    integer i, j, m
    real(dl) p1, p2, p3, pp, z, z1

    m=(n+1)/2
    !$OMP PARALLEL DO DEFAULT(PRIVATE), SHARED(x,w,n,m)
    do i=1,m
        z=cos(const_pi*(i-0.25_dl)/(n+0.5_dl))
        z1 = 0._dl
        do while (abs(z-z1) > eps)
            p1=1._dl
            p2=0._dl
            do j=1,n
                p3=p2
                p2=p1
                p1=((2*j-1)*z*p2-(j-1)*p3)/j
            end do
            pp=n*(z*p1-p2)/(z**2-1._dl)
            z1=z
            z=z1-p1/pp
        end do
        x(i)=-z
        x(n+1-i)=z
        w(i)=2/((1._dl-z**2)*pp**2)
        w(n+1-i)=w(i)
    end do
    !$OMP END PARALLEL DO

    end subroutine Gauss_Legendre

    subroutine GetThreeJs(thrcof,l2in,l3in,m2in,m3in)
    !Recursive evaluation of 3j symbols. Does minimal error checking on input parameters.
    use MpiUtils, only : MpiStop
    implicit none
    integer, parameter :: dl = KIND(1.d0)
    integer, intent(in) :: l2in,l3in, m2in,m3in
    real(dl), dimension(*) :: thrcof
    INTEGER, PARAMETER :: i8 = selected_int_kind(18)
    integer(i8) :: l2,l3,m2,m3
    integer(i8) :: l1, m1, l1min,l1max, lmatch, nfin, a1, a2

    real(dl) :: newfac, oldfac, sumfor, c1,c2,c1old, dv, denom, x, sum1, sumuni
    real(dl) :: x1,x2,x3, y,y1,y2,y3,sum2,sumbac, ratio,cnorm, sign1, thresh
    integer i,ier, index, nlim, sign2
    integer nfinp1,nfinp2,nfinp3, lstep, nstep2,n
    real(dl), parameter :: zero = 0._dl, one = 1._dl
    real(dl), parameter ::  tiny = 1.0d-30, srtiny=1.0d-15, huge = 1.d30, srhuge = 1.d15

    ! routine to generate set of 3j-coeffs (l1,l2,l3\\ m1,m2,m3)

    ! by recursion from l1min = max(abs(l2-l3),abs(m1))
    !                to l1max = l2+l3
    ! the resulting 3j-coeffs are stored as thrcof(l1-l1min+1)

    ! to achieve the numerical stability, the recursion will proceed
    ! simultaneously forwards and backwards, starting from l1min and l1max
    ! respectively.
    !
    ! lmatch is the l1-value at which forward and backward recursion are matched.
    !
    ! ndim is the length of the array thrcof
    !
    ! ier = -1 for all 3j vanish(l2-abs(m2)<0, l3-abs(m3)<0 or not integer)
    ! ier = -2 if possible 3j's exceed ndim
    ! ier >= 0 otherwise

    l2=l2in
    l3=l3in
    m2=m2in
    m3=m3in
    newfac = 0
    lmatch = 0
    m1 = -(m2+m3)

    ! check relative magnitude of l and m values
    ier = 0

    if (l2 < abs(m2) .or. l3 < m3) then
        ier = -1
        call MpiStop('error ier = -1')
        return
    end if

    ! limits for l1
    l1min = max(abs(l2-l3),abs(m1))
    l1max = l2+l3

    if (l1min >= l1max) then
        if (l1min/=l1max) then
            ier = -1
            call MpiStop('error ier = -1')
            return
        end if

        ! reached if l1 can take only one value, i.e.l1min=l1max
        thrcof(1) = (-1)**abs(l2+m2-l3+m3)/sqrt(real(l1min+l2+l3+1,dl))
        return

    end if

    nfin = l1max-l1min+1

    ! starting forward recursion from l1min taking nstep1 steps
    l1 = l1min
    thrcof(1) = srtiny
    sum1 = (2*l1 + 1)*tiny

    lstep = 1

30  lstep = lstep+1
    l1 = l1+1

    oldfac = newfac
    a1 = (l1+l2+l3+1)*(l1-l2+l3)*(l1+l2-l3)
    a2 = (l1+m1)*(l1-m1)*(-l1+l2+l3+1)
    newfac = sqrt(a2*real(a1,dl))
    if (l1 == 1) then
        !IF L1 = 1  (L1-1) HAS TO BE FACTORED OUT OF DV, HENCE
        c1 = -(2*l1-1)*l1*(m3-m2)/newfac
    else

        dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 + l1*(l1-1)*(m3-m2)
        denom = (l1-1)*newfac

        if (lstep > 2) c1old = abs(c1)
        c1 = -(2*l1-1)*dv/denom

    end if

    if (lstep<= 2) then

        ! if l1=l1min+1 the third term in the recursion eqn vanishes, hence
        x = srtiny*c1
        thrcof(2) = x
        sum1 = sum1+tiny*(2*l1+1)*c1*c1
        if(lstep==nfin) then
            sumuni=sum1
            go to 230
        end if
        goto 30

    end if

    c2 = -l1*oldfac/denom

    ! recursion to the next 3j-coeff x
    x = c1*thrcof(lstep-1) + c2*thrcof(lstep-2)
    thrcof(lstep) = x
    sumfor = sum1
    sum1 = sum1 + (2*l1+1)*x*x
    if (lstep/=nfin) then

        ! see if last unnormalised 3j-coeff exceeds srhuge
        if (abs(x) >= srhuge) then

            ! REACHED IF LAST 3J-COEFFICIENT LARGER THAN SRHUGE
            ! SO THAT THE RECURSION SERIES THRCOF(1), ... , THRCOF(LSTEP)
            ! HAS TO BE RESCALED TO PREVENT OVERFLOW

            ier = ier+1
            do i = 1, lstep
                if (abs(thrcof(i)) < srtiny) thrcof(i)= zero
                thrcof(i) = thrcof(i)/srhuge
            end do

            sum1 = sum1/huge
            sumfor = sumfor/huge
            x = x/srhuge

        end if

        ! as long as abs(c1) is decreasing, the recursion proceeds towards increasing
        ! 3j-valuse and so is numerically stable. Once an increase of abs(c1) is
        ! detected, the recursion direction is reversed.

        if (c1old > abs(c1)) goto 30

    end if !lstep/=nfin

    ! keep three 3j-coeffs around lmatch for comparison with backward recursion

    lmatch = l1-1
    x1 = x
    x2 = thrcof(lstep-1)
    x3 = thrcof(lstep-2)
    nstep2 = nfin-lstep+3

    ! --------------------------------------------------------------------------
    !
    ! starting backward recursion from l1max taking nstep2 stpes, so that
    ! forward and backward recursion overlap at 3 points
    ! l1 = lmatch-1, lmatch, lmatch+1

    nfinp1 = nfin+1
    nfinp2 = nfin+2
    nfinp3 = nfin+3
    l1 = l1max
    thrcof(nfin) = srtiny
    sum2 = tiny*(2*l1+1)

    l1 = l1+2
    lstep=1

    do
        lstep = lstep + 1
        l1= l1-1

        oldfac = newfac
        a1 = (l1+l2+l3)*(l1-l2+l3-1)*(l1+l2-l3-1)
        a2 = (l1+m1-1)*(l1-m1-1)*(-l1+l2+l3+2)
        newfac = sqrt(a1*real(a2,dl))

        dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 +l1*(l1-1)*(m3-m2)

        denom = l1*newfac
        c1 = -(2*l1-1)*dv/denom
        if (lstep <= 2) then

            ! if l2=l2max+1, the third term in the recursion vanishes

            y = srtiny*c1
            thrcof(nfin-1) = y
            sumbac = sum2
            sum2 = sum2 + tiny*(2*l1-3)*c1*c1

            cycle

        end if

        c2 = -(l1-1)*oldfac/denom

        ! recursion to the next 3j-coeff y
        y = c1*thrcof(nfinp2-lstep)+c2*thrcof(nfinp3-lstep)

        if (lstep==nstep2) exit

        thrcof(nfinp1-lstep) = y
        sumbac = sum2
        sum2 = sum2+(2*l1-3)*y*y

        ! see if last unnormalised 3j-coeff exceeds srhuge
        if (abs(y) >= srhuge) then

            ! reached if 3j-coeff larger than srhuge so that the recursion series
            ! thrcof(nfin),..., thrcof(nfin-lstep+1) has to be rescaled to prevent overflow

            ier=ier+1
            do i = 1, lstep
                index=nfin-i+1
                if (abs(thrcof(index)) < srtiny) thrcof(index)=zero
                thrcof(index) = thrcof(index)/srhuge
            end do

            sum2=sum2/huge
            sumbac=sumbac/huge

        end if

    end do

    ! the forward recursion 3j-coeffs x1, x2, x3 are to be matched with the
    ! corresponding backward recursion vals y1, y2, y3

    y3 = y
    y2 = thrcof(nfinp2-lstep)
    y1 = thrcof(nfinp3-lstep)

    ! determine now ratio such that yi=ratio*xi (i=1,2,3) holds with minimal error

    ratio = (x1*y1+x2*y2+x3*y3)/(x1*x1+x2*x2+x3*x3)
    nlim = nfin-nstep2+1

    if (abs(ratio) >= 1) then

        thrcof(1:nlim) = ratio*thrcof(1:nlim)
        sumuni = ratio*ratio*sumfor + sumbac

    else

        nlim = nlim+1
        ratio = 1/ratio
        do n = nlim, nfin
            thrcof(n) = ratio*thrcof(n)
        end do
        sumuni = sumfor + ratio*ratio*sumbac

    end if
    ! normalise 3j-coeffs

230 cnorm = 1/sqrt(sumuni)

    ! sign convention for last 3j-coeff determines overall phase

    sign1 = sign(one,thrcof(nfin))
    sign2 = (-1)**(abs(l2+m2-l3+m3))
    if (sign1*sign2 <= 0) then
        cnorm = -cnorm
    end if
    if (abs(cnorm) >= one) then
        thrcof(1:nfin) = cnorm*thrcof(1:nfin)
        return
    end if

    thresh = tiny/abs(cnorm)

    do n = 1, nfin
        if (abs(thrcof(n)) < thresh) thrcof(n) = zero
        thrcof(n) = cnorm*thrcof(n)
    end do
    return

    end subroutine GetThreeJs


    function GetChiSquared(c_inv, Y, n) result(chi2)
    !get dot_product(matmul(C_inv,Y), Y) efficiently assuming c_inv symmetric
    integer, intent(in) :: n
    real(dl), intent(in) :: Y(n)
    real(dl), intent(in) :: c_inv(n,n)
    integer j
    real(dl) ztemp, chi2

    chi2 = 0
    !$OMP parallel do private(j,ztemp) reduction(+:chi2) schedule(static,16)
    do  j = 1, n
        ztemp= dot_product(Y(j+1:n), c_inv(j+1:n, j))
        chi2=chi2+ (ztemp*2 +c_inv(j, j)*Y(j))*Y(j)
    end do

    end function GetChiSquared

    subroutine integrate_3j(W,lmax_w, n, dopol, M, lmax)
    !Get coupling matrix, eg for pesudo-CL
    integer, intent(in) :: lmax, lmax_w, n
    real(dl), intent(in) :: W(0:lmax_w,n)
    logical, intent(in) :: dopol
    real(dl), intent(out) :: M(0:lmax,0:lmax, n)
    integer l1, l2, lplus, lminus, thread_ix, ix
    real(dl), allocatable :: threejj0(:,:), threejj2(:,:)

    !$ integer  OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS
    !$ external OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS

    thread_ix = 1
    !$ thread_ix = OMP_GET_MAX_THREADS()

    allocate(threejj0(0:2*lmax,thread_ix))
    if (dopol) then
        allocate(threejj2(0:2*lmax,thread_ix))
    end if

    !$OMP parallel do private(l1,l2,lminus,lplus,thread_ix,ix), schedule(dynamic)
    do l1 = 0, lmax
        thread_ix =1
        !$ thread_ix = OMP_GET_THREAD_NUM()+1
        do l2 = 0, l1
            lplus =  min(lmax_w,l1+l2)
            lminus = abs(l1-l2)

            call GetThreeJs(threejj0(lminus:,thread_ix),l1,l2,0,0)

            if (dopol .and. l1>=2 .and. l2>=2) then
                !note that lminus is correct, want max(abs(l1-l2),abs(m1)) where m1=0 here
                !(polarization coupling depends on lowest multipoles of the mask)
                call GetThreeJs(threejj2(lminus:,thread_ix),l1,l2,-2,2)
                M(l2,l1,2) = sum(W(lminus:lplus:2,2)*threejj0(lminus:lplus:2,thread_ix) &
                    *threejj2(lminus:lplus:2,thread_ix)) !TE
                M(l2,l1,3) = sum(W(lminus:lplus:2,3)*threejj2(lminus:lplus:2,thread_ix)**2) !EE
                M(l2,l1,4) = sum(W(lminus+1:lplus:2,3)*threejj2(lminus+1:lplus:2,thread_ix)**2) !EB
            end if
            if (n>1 .and. .not. dopol) then
                threejj0(lminus:lplus,thread_ix) = threejj0(lminus:lplus,thread_ix)**2
                do ix=1,n
                    M(l2,l1,ix) = sum(W(lminus:lplus,ix)* threejj0(lminus:lplus,thread_ix))
                end do
            else
                M(l2,l1,1) = sum(W(lminus:lplus,1)* threejj0(lminus:lplus,thread_ix)**2)
            end if
        end do
    end do

    do l1=0, lmax
        do l2 = l1+1,lmax
            M(l2,l1,:) = M(l1,l2,:)
        end do
    end do
    end subroutine integrate_3j

    end module MathUtils

    ! Modules used by cmbmain and other routines.

    !     Code for Anisotropies in the Microwave Background
    !     by Antony Lewis (http://cosmologist.info) and Anthony Challinor
    !     See readme.html for documentation.
    !
    !     Based on CMBFAST  by  Uros Seljak and Matias Zaldarriaga, itself based
    !     on Boltzmann code written by Edmund Bertschinger, Chung-Pei Ma and Paul Bode.
    !     Original CMBFAST copyright and disclaimer:
    !
    !     Copyright 1996 by Harvard-Smithsonian Center for Astrophysics and
    !     the Massachusetts Institute of Technology.  All rights reserved.
    !
    !     THIS SOFTWARE IS PROVIDED "AS IS", AND M.I.T. OR C.f.A. MAKE NO
    !     REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
    !     By way of example, but not limitation,
    !     M.I.T. AND C.f.A MAKE NO REPRESENTATIONS OR WARRANTIES OF
    !     MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT
    !     THE USE OF THE LICENSED SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE
    !     ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.
    !
    !     portions of this software are based on the COSMICS package of
    !     E. Bertschinger.  See the LICENSE file of the COSMICS distribution
    !     for restrictions on the modification and distribution of this software.


    module ModelParams
    use precision
    use Ranges
    use InitialPower
    use Reionization
    use Recombination
    use Errors

    implicit none
    public

    character(LEN=*), parameter :: version = 'Jan17'

    integer :: FeedbackLevel = 0 !if >0 print out useful information about the model

    logical :: output_file_headers = .true.


    logical, parameter :: DebugMsgs=.false. !Set to true to view progress and timing

    logical, parameter :: DebugEvolution = .false. !Set to true to do all the evolution for all k

    real(dl) :: DebugParam = 0._dl !not used but read in, useful for parameter-dependent tests

    logical ::  do_bispectrum  = .false.
    logical, parameter :: hard_bispectrum = .false. ! e.g. warm inflation where delicate cancellations

    logical, parameter :: full_bessel_integration = .false. !(go into the tails when calculating the sources)

    integer, parameter :: Nu_int = 0, Nu_trunc=1, Nu_approx = 2, Nu_best = 3
    !For CAMBparams%MassiveNuMethod
    !Nu_int: always integrate distribution function
    !Nu_trunc: switch to expansion in velocity once non-relativistic
    !Nu_approx: approximate scheme - good for CMB, but not formally correct and no good for matter power
    !Nu_best: automatically use mixture which is fastest and most accurate

    integer, parameter :: max_Nu = 5 !Maximum number of neutrino species
    integer, parameter :: max_transfer_redshifts = 150
    integer, parameter :: fileio_unit = 13 !Any number not used elsewhere will do
    integer, parameter :: outNone=1

    integer :: max_bessels_l_index  = 1000000
    real(dl) :: max_bessels_etak = 1000000*2

    real(dl), parameter ::  OutputDenominator =twopi
    !When using outNone the output is l(l+1)Cl/OutputDenominator

    Type(Regions) :: TimeSteps

    type TransferParams
        logical     ::  high_precision
        integer     ::  num_redshifts
        real(dl)    ::  kmax         !these are acutally q values, but same as k for flat
        integer     ::  k_per_logint ! ..
        real(dl)    ::  redshifts(max_transfer_redshifts)
        !JD 08/13 Added so both NL lensing and PK can be run at the same time
        real(dl)    ::  PK_redshifts(max_transfer_redshifts)
        real(dl)    ::  NLL_redshifts(max_transfer_redshifts)
        integer     ::  PK_redshifts_index(max_transfer_redshifts)
        integer     ::  NLL_redshifts_index(max_transfer_redshifts)
        integer     ::  PK_num_redshifts
        integer     ::  NLL_num_redshifts

    end type TransferParams

    !other variables, options, derived variables, etc.

    integer, parameter :: NonLinear_none=0, NonLinear_Pk =1, NonLinear_Lens=2
    integer, parameter :: NonLinear_both=3  !JD 08/13 added so both can be done

    ! Main parameters type
    type CAMBparams

        logical   :: WantCls, WantTransfer
        logical   :: WantScalars, WantTensors, WantVectors
        logical   :: DoLensing
        logical   :: want_zstar, want_zdrag     !!JH for updated BAO likelihood.
        logical   :: PK_WantTransfer             !JD 08/13 Added so both NL lensing and PK can be run at the same time
        integer   :: NonLinear
        logical   :: Want_CMB

        integer   :: Max_l, Max_l_tensor
        real(dl)  :: Max_eta_k, Max_eta_k_tensor
        ! _tensor settings only used in initialization,
        !Max_l and Max_eta_k are set to the tensor variables if only tensors requested

        real(dl)  :: omegab, omegac, omegav, omegan
        !Omega baryon, CDM, Lambda and massive neutrino
        real(dl)  :: H0,TCMB,yhe,Num_Nu_massless
        integer   :: Num_Nu_massive !sum of Nu_mass_numbers below
        integer   :: Nu_mass_eigenstates  !1 for degenerate masses
        logical   :: share_delta_neff !take fractional part to heat all eigenstates the same
        real(dl)  :: Nu_mass_degeneracies(max_nu)
        real(dl)  :: Nu_mass_fractions(max_nu) !The ratios of the total densities
        integer   :: Nu_mass_numbers(max_nu) !physical number per eigenstate

        integer   :: Scalar_initial_condition
        !must be one of the initial_xxx values defined in GaugeInterface

        integer   :: OutputNormalization
        !outNone, or C_OutputNormalization=1 if > 1

        logical   :: AccuratePolarization
        !Do you care about the accuracy of the polarization Cls?

        logical   :: AccurateBB
        !Do you care about BB accuracy (e.g. in lensing)

        !Reionization settings - used if Reion%Reionization=.true.
        logical   :: AccurateReionization
        !Do you care about pecent level accuracy on EE signal from reionization?

        integer   :: MassiveNuMethod

        type(InitialPowerParams) :: InitPower  !see power_tilt.f90 - you can change this
        type(ReionizationParams) :: Reion
        type(RecombinationParams):: Recomb
        type(TransferParams)     :: Transfer

        real(dl) ::  InitialConditionVector(1:10) !Allow up to 10 for future extensions
        !ignored unless Scalar_initial_condition == initial_vector

        logical OnlyTransfers !Don't use initial power spectrum data, instead get Delta_q_l array
        !If true, sigma_8 is not calculated either

        logical DerivedParameters !calculate various derived parameters  (ThermoDerivedParams)

        !Derived parameters, not set initially
        type(ReionizationHistory) :: ReionHist

        logical flat,closed,open
        real(dl) omegak
        real(dl) curv,r, Ksign !CP%r = 1/sqrt(|CP%curv|), CP%Ksign = 1,0 or -1
        real(dl) tau0,chi0 !time today and rofChi(CP%tau0/CP%r)

    end type CAMBparams

    type(CAMBparams), save :: CP  !Global collection of parameters

    real(dl) scale !relative to CP%flat. e.g. for scaling lSamp%l sampling.

    logical ::call_again = .false.
    !if being called again with same parameters to get different thing

    !     grhom =kappa*a^2*rho_m0
    !     grhornomass=grhor*number of massless neutrino species
    !     taurst,taurend - time at start/end of recombination
    !     dtaurec - dtau during recombination
    !     adotrad - a(tau) in radiation era

    real(dl) grhom,grhog,grhor,grhob,grhoc,grhov,grhornomass,grhok
    real(dl) taurst,dtaurec,taurend, tau_maxvis,adotrad

    !Neutrinos
    real(dl) grhormass(max_nu)

    !     nu_masses=m_nu*c**2/(k_B*T_nu0)
    real(dl) :: nu_masses(max_nu)

    real(dl) akthom !sigma_T * (number density of protons now)
    real(dl) fHe !n_He_tot / n_H_tot
    real(dl) Nnow


    integer :: ThreadNum = 0
    !If zero assigned automatically, obviously only used if parallelised

    !Parameters for checking/changing overall accuracy
    !If HighAccuracyDefault=.false., the other parameters equal to 1 corresponds to ~0.3% scalar C_l accuracy
    !If HighAccuracyDefault=.true., the other parameters equal to 1 corresponds to ~0.1% scalar C_l accuracy (at L>600)
    logical :: HighAccuracyDefault = .true.

    real(dl) :: lSampleBoost=1._dl
    !Increase lSampleBoost to increase sampling in lSamp%l for Cl interpolation

    real(dl) :: AccuracyBoost =1._dl

    !Decrease step sizes, etc. by this parameter. Useful for checking accuracy.
    !Can also be used to improve speed significantly if less accuracy is required.
    !or improving accuracy for extreme models.
    !Note this does not increase lSamp%l sampling or massive neutrino q-sampling

    real(sp) :: lAccuracyBoost=1.
    !Boost number of multipoles integrated in Boltzman heirarchy

    integer :: limber_phiphi = 0 !for l>limber_phiphi use limber approx for lensing potential
    integer :: num_redshiftwindows = 0
    integer :: num_extra_redshiftwindows = 0
    integer :: num_custom_sources = 0
    integer, allocatable :: custom_source_ell_scales(:)

    integer, parameter :: lmin = 2
    !must be either 1 or 2

    real(dl), parameter :: OmegaKFlat = 5e-7_dl !Value at which to use flat code

    real(dl),parameter :: tol=1.0d-4 !Base tolerance for integrations

    !     used as parameter for spline - tells it to use 'natural' end values
    real(dl), parameter :: spl_large=1.e40_dl

    integer, parameter:: l0max=4000

    !     lmax is max possible number of l's evaluated
    integer, parameter :: lmax_arr = l0max

    character(LEN=1024) :: highL_unlensed_cl_template = 'HighLExtrapTemplate_lenspotentialCls.dat'
    !fiducial high-accuracy high-L C_L used for making small cosmology-independent numerical corrections
    !to lensing and C_L interpolation. Ideally close to models of interest, but dependence is weak.
    logical :: use_spline_template = .true.
    integer, parameter :: lmax_extrap_highl = 8000
    real(dl), allocatable :: highL_CL_template(:,:)

    integer, parameter :: derived_age=1, derived_zstar=2, derived_rstar=3, derived_thetastar=4, derived_DAstar = 5, &
        derived_zdrag=6, derived_rdrag=7,derived_kD=8,derived_thetaD=9, derived_zEQ =10, derived_keq =11, &
        derived_thetaEQ=12, derived_theta_rs_EQ = 13
    integer, parameter :: nthermo_derived = 13

    real(dl) ThermoDerivedParams(nthermo_derived)

    Type TBackgroundOutputs
        real(dl), pointer :: z_outputs(:) => null()
        real(dl), allocatable :: H(:), DA(:), rs_by_D_v(:)
    end Type TBackgroundOutputs

    Type(TBackgroundOutputs), save :: BackgroundOutputs

    contains


    subroutine CAMBParams_Set(P, error, DoReion)
    use constants
    type(CAMBparams), intent(in) :: P
    real(dl) GetOmegak, fractional_number, conv
    integer, optional :: error !Zero if OK
    logical, optional :: DoReion
    logical WantReion
    integer nu_i,actual_massless
    real(dl) nu_massless_degeneracy, neff_i
    external GetOmegak
    real(dl), save :: last_tau0
    !Constants in SI units

    global_error_flag = 0

    if ((P%WantTensors .or. P%WantVectors).and. P%WantTransfer .and. .not. P%WantScalars) then
        call GlobalError( 'Cannot generate tensor C_l and transfer without scalar C_l',error_unsupported_params)
    end if

    if (present(error)) error = global_error_flag
    if (global_error_flag/=0) return

    if (present(DoReion)) then
        WantReion = DoReion
    else
        WantReion = .true.
    end if

    CP=P
    if (call_again) CP%DerivedParameters = .false.

    CP%Max_eta_k = max(CP%Max_eta_k,CP%Max_eta_k_tensor)

    if (CP%WantTransfer) then
        CP%WantScalars=.true.
        if (.not. CP%WantCls) then
            CP%AccuratePolarization = .false.
            CP%Reion%Reionization = .false.
        end if
    else
        CP%transfer%num_redshifts=0
    end if

    if (CP%Num_Nu_Massive /= sum(CP%Nu_mass_numbers(1:CP%Nu_mass_eigenstates))) then
        if (sum(CP%Nu_mass_numbers(1:CP%Nu_mass_eigenstates))/=0) call MpiStop('Num_Nu_Massive is not sum of Nu_mass_numbers')
    end if
    if (CP%Omegan == 0 .and. CP%Num_Nu_Massive /=0) then
        if (CP%share_delta_neff) then
            CP%Num_Nu_Massless = CP%Num_Nu_Massless + CP%Num_Nu_Massive
        else
            CP%Num_Nu_Massless = CP%Num_Nu_Massless + sum(CP%Nu_mass_degeneracies(1:CP%Nu_mass_eigenstates))
        end if
        CP%Num_Nu_Massive  = 0
        CP%Nu_mass_numbers = 0
    end if

    nu_massless_degeneracy = CP%Num_Nu_massless !N_eff for massless neutrinos
    if (CP%Num_nu_massive > 0) then
        if (CP%Nu_mass_eigenstates==0) call MpiStop('Have Num_nu_massive>0 but no nu_mass_eigenstates')
        if (CP%Nu_mass_eigenstates==1 .and. CP%Nu_mass_numbers(1)==0) CP%Nu_mass_numbers(1) = CP%Num_Nu_Massive
        if (all(CP%Nu_mass_numbers(1:CP%Nu_mass_eigenstates)==0)) CP%Nu_mass_numbers=1 !just assume one for all
        if (CP%share_delta_neff) then
            !default case of equal heating of all neutrinos
            fractional_number = CP%Num_Nu_massless + CP%Num_Nu_massive
            actual_massless = int(CP%Num_Nu_massless + 1e-6_dl)
            neff_i = fractional_number/(actual_massless + CP%Num_Nu_massive)
            nu_massless_degeneracy = neff_i*actual_massless
            CP%Nu_mass_degeneracies(1:CP%Nu_mass_eigenstates) = CP%Nu_mass_numbers(1:CP%Nu_mass_eigenstates)*neff_i
        end if
        if (abs(sum(CP%Nu_mass_fractions(1:CP%Nu_mass_eigenstates))-1) > 1e-4) &
            call MpiStop('Nu_mass_fractions do not add up to 1')
    else
        CP%Nu_mass_eigenstates = 0
    end if

    if ((CP%WantTransfer).and. CP%MassiveNuMethod==Nu_approx) then
        CP%MassiveNuMethod = Nu_trunc
    end if

    CP%omegak = GetOmegak()

    CP%flat = (abs(CP%omegak) <= OmegaKFlat)
    CP%closed = CP%omegak < -OmegaKFlat

    CP%open = .not.CP%flat.and..not.CP%closed
    if (CP%flat) then
        CP%curv=0
        CP%Ksign=0
        CP%r=1._dl !so we can use tau/CP%r, etc, where CP%r's cancel
    else
        CP%curv=-CP%omegak/((c/1000)/CP%h0)**2
        CP%Ksign =sign(1._dl,CP%curv)
        CP%r=1._dl/sqrt(abs(CP%curv))
    end if
    !  grho gives the contribution to the expansion rate from: (g) photons,
    !  (r) one flavor of relativistic neutrino (2 degrees of freedom),
    !  (m) nonrelativistic matter (for Omega=1).  grho is actually
    !  8*pi*G*rho/c^2 at a=1, with units of Mpc**(-2).
    !  a=tau(Mpc)*adotrad, with a=1 today, assuming 3 neutrinos.
    !  (Used only to set the initial conformal time.)

    !H0 is in km/s/Mpc

    grhom = 3*CP%h0**2/c**2*1000**2 !3*h0^2/c^2 (=8*pi*G*rho_crit/c^2)

    !grhom=3.3379d-11*h0*h0
    grhog = kappa/c**2*4*sigma_boltz/c**3*CP%tcmb**4*Mpc**2 !8*pi*G/c^2*4*sigma_B/c^3 T^4
    ! grhog=1.4952d-13*tcmb**4
    grhor = 7._dl/8*(4._dl/11)**(4._dl/3)*grhog !7/8*(4/11)^(4/3)*grhog (per neutrino species)
    !grhor=3.3957d-14*tcmb**4

    !correction for fractional number of neutrinos, e.g. 3.04 to give slightly higher T_nu hence rhor
    !for massive Nu_mass_degeneracies parameters account for heating from grhor

    grhornomass=grhor*nu_massless_degeneracy
    grhormass=0
    do nu_i = 1, CP%Nu_mass_eigenstates
        grhormass(nu_i)=grhor*CP%Nu_mass_degeneracies(nu_i)
    end do
    grhoc=grhom*CP%omegac
    grhob=grhom*CP%omegab
    grhov=grhom*CP%omegav
    grhok=grhom*CP%omegak
    !  adotrad gives the relation a(tau) in the radiation era:
    adotrad = sqrt((grhog+grhornomass+sum(grhormass(1:CP%Nu_mass_eigenstates)))/3)


    Nnow = CP%omegab*(1-CP%yhe)*grhom*c**2/kappa/m_H/Mpc**2

    akthom = sigma_thomson*Nnow*Mpc
    !sigma_T * (number density of protons now)

    fHe = CP%YHe/(mass_ratio_He_H*(1.d0-CP%YHe))  !n_He_tot / n_H_tot

    if (.not.call_again) then
        call init_massive_nu(CP%omegan /=0)
        call init_background
        if (global_error_flag==0) then
            CP%tau0=TimeOfz(0._dl)
            ! print *, 'chi = ',  (CP%tau0 - TimeOfz(0.15_dl)) * CP%h0/100
            last_tau0=CP%tau0
            if (WantReion) call Reionization_Init(CP%Reion,CP%ReionHist, CP%YHe, akthom, CP%tau0, FeedbackLevel)
        end if
    else
        CP%tau0=last_tau0
    end if

    !JD 08/13 Changes for nonlinear lensing of CMB + MPK compatibility
    !if ( CP%NonLinear==NonLinear_Lens) then
    if (CP%NonLinear==NonLinear_Lens .or. CP%NonLinear==NonLinear_both ) then
        CP%Transfer%kmax = max(CP%Transfer%kmax, CP%Max_eta_k/CP%tau0)
        if (FeedbackLevel > 0 .and. CP%Transfer%kmax== CP%Max_eta_k/CP%tau0) &
            write (*,*) 'max_eta_k changed to ', CP%Max_eta_k
    end if

    if (CP%closed .and. CP%tau0/CP%r >3.14) then
        call GlobalError('chi >= pi in closed model not supported',error_unsupported_params)
    end if

    if (global_error_flag/=0) then
        if (present(error)) error = global_error_flag
        return
    end if

    if (present(error)) then
        error = 0
    else if (FeedbackLevel > 0 .and. .not. call_again) then
        write(*,'("Om_b h^2             = ",f9.6)') CP%omegab*(CP%H0/100)**2
        write(*,'("Om_c h^2             = ",f9.6)') CP%omegac*(CP%H0/100)**2
        write(*,'("Om_nu h^2            = ",f9.6)') CP%omegan*(CP%H0/100)**2
        write(*,'("Om_Lambda            = ",f9.6)') CP%omegav
        write(*,'("Om_K                 = ",f9.6)') CP%omegak
        write(*,'("Om_m (1-Om_K-Om_L)   = ",f9.6)') 1-CP%omegak-CP%omegav
        write(*,'("100 theta (CosmoMC)  = ",f9.6)') 100*CosmomcTheta()
        if (CP%Num_Nu_Massive > 0) then
            write(*,'("N_eff (total)        = ",f9.6)') nu_massless_degeneracy + &
                sum(CP%Nu_mass_degeneracies(1:CP%Nu_mass_eigenstates))
            do nu_i=1, CP%Nu_mass_eigenstates
                conv = k_B*(8*grhor/grhog/7)**0.25*CP%tcmb/eV * &
                    (CP%nu_mass_degeneracies(nu_i)/CP%nu_mass_numbers(nu_i))**0.25 !approx 1.68e-4
                write(*,'(I2, " nu, g=",f7.4," m_nu*c^2/k_B/T_nu0= ",f9.2," (m_nu= ",f6.3," eV)")') &
                    CP%nu_mass_numbers(nu_i), CP%nu_mass_degeneracies(nu_i), nu_masses(nu_i),conv*nu_masses(nu_i)
            end do
        end if
    end if
    CP%chi0=rofChi(CP%tau0/CP%r)
    scale= CP%chi0*CP%r/CP%tau0  !e.g. change l sampling depending on approx peak spacing

    end subroutine CAMBParams_Set


    function GetTestTime()
    real(sp) GetTestTime
    real(sp) atime

    !           GetTestTime = etime(tarray)
    !Can replace this if etime gives problems
    !Or just comment out - only used if DebugMsgs = .true.
    call cpu_time(atime)
    GetTestTime = atime

    end function GetTestTime


    function rofChi(Chi) !sinh(chi) for open, sin(chi) for closed.
    real(dl) Chi,rofChi

    if (CP%closed) then
        rofChi=sin(chi)
    else if (CP%open) then
        rofChi=sinh(chi)
    else
        rofChi=chi
    endif
    end function rofChi


    function cosfunc (Chi)
    real(dl) Chi,cosfunc

    if (CP%closed) then
        cosfunc= cos(chi)
    else if (CP%open) then
        cosfunc=cosh(chi)
    else
        cosfunc = 1._dl
    endif
    end function cosfunc

    function tanfunc(Chi)
    real(dl) Chi,tanfunc
    if (CP%closed) then
        tanfunc=tan(Chi)
    else if (CP%open) then
        tanfunc=tanh(Chi)
    else
        tanfunc=Chi
    end if

    end  function tanfunc

    function invsinfunc(x)
    real(dl) invsinfunc,x

    if (CP%closed) then
        invsinfunc=asin(x)
    else if (CP%open) then
        invsinfunc=log((x+sqrt(1._dl+x**2)))
    else
        invsinfunc = x
    endif
    end function invsinfunc

    function f_K(x)
    real(dl) :: f_K
    real(dl), intent(in) :: x
    f_K = CP%r*rofChi(x/CP%r)

    end function f_K


    function DeltaTime(a1,a2, in_tol)
    implicit none
    real(dl) DeltaTime, atol
    real(dl), intent(IN) :: a1,a2
    real(dl), optional, intent(in) :: in_tol
    real(dl) dtauda, rombint !diff of tau w.r.t a and integration
    external dtauda, rombint

    if (present(in_tol)) then
        atol = in_tol
    else
        atol = tol/1000/exp(AccuracyBoost-1)
    end if
    DeltaTime=rombint(dtauda,a1,a2,atol)

    end function DeltaTime

    function TimeOfz(z)
    implicit none
    real(dl) TimeOfz
    real(dl), intent(IN) :: z

    TimeOfz=DeltaTime(0._dl,1._dl/(z+1._dl))
    end function TimeOfz

    subroutine TimeOfzArr(nz, redshifts, outputs)
    integer, intent(in) :: nz
    real(dl), intent(in) :: redshifts(nz)
    real(dl), intent(out) :: outputs(nz)
    integer i

    !Dumb slow version
    !$OMP PARALLEL DO DEFAUlT(SHARED)
    do i=1, nz
        outputs(i) = timeOfZ(redshifts(i))
    end do
    !$OMP END PARALLEL DO

    end subroutine TimeOfzArr

    function DeltaPhysicalTimeGyr(a1,a2, in_tol)
    use constants
    real(dl), intent(in) :: a1, a2
    real(dl), optional, intent(in) :: in_tol
    real(dl) rombint,DeltaPhysicalTimeGyr, atol
    external rombint

    if (present(in_tol)) then
        atol = in_tol
    else
        atol = 1d-4/exp(AccuracyBoost-1)
    end if
    DeltaPhysicalTimeGyr = rombint(dtda,a1,a2,atol)*Mpc/c/Gyr
    end function DeltaPhysicalTimeGyr

    function AngularDiameterDistance(z)
    !This is the physical (non-comoving) angular diameter distance in Mpc
    real(dl) AngularDiameterDistance
    real(dl), intent(in) :: z

    AngularDiameterDistance = CP%r/(1+z)*rofchi(ComovingRadialDistance(z) /CP%r)

    end function AngularDiameterDistance

    subroutine AngularDiameterDistanceArr(arr, z, n)
    !This is the physical (non-comoving) angular diameter distance in Mpc for array of z
    integer,intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    integer i
    !dumb version that just calls each z in turn independently

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do i=1, n
        arr(i) = AngularDiameterDistance(z(i))
    end do
    !$OMP END PARALLEL DO

    end subroutine AngularDiameterDistanceArr


    function AngularDiameterDistance2(z1, z2) ! z1 < z2
    !From http://www.slac.stanford.edu/~amantz/work/fgas14/#cosmomc
    real(dl) AngularDiameterDistance2
    real(dl), intent(in) :: z1, z2

    AngularDiameterDistance2 = CP%r/(1+z2)*rofchi(ComovingRadialDistance(z2)/CP%r - ComovingRadialDistance(z1)/CP%r)

    end function AngularDiameterDistance2

    function LuminosityDistance(z)
    real(dl) LuminosityDistance
    real(dl), intent(in) :: z

    LuminosityDistance = AngularDiameterDistance(z)*(1+z)**2

    end function LuminosityDistance

    function ComovingRadialDistance(z)
    real(dl) ComovingRadialDistance
    real(dl), intent(in) :: z

    ComovingRadialDistance = DeltaTime(1/(1+z),1._dl)

    end function ComovingRadialDistance

    function Hofz(z)
    !non-comoving Hubble in MPC units, divide by MPC_in_sec to get in SI units
    !multiply by c/1e3 to get in km/s/Mpc units
    real(dl) Hofz, dtauda,a
    real(dl), intent(in) :: z
    external dtauda

    a = 1/(1+z)
    Hofz = 1/(a**2*dtauda(a))

    end function Hofz

    subroutine HofzArr(arr, z, n)
    !non-comoving Hubble in MPC units, divide by MPC_in_sec to get in SI units
    !multiply by c/1e3 to get in km/s/Mpc units
    integer,intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    integer i

    do i=1, n
        arr(i) = Hofz(z(i))
    end do

    end subroutine HofzArr

    real(dl) function BAO_D_v_from_DA_H(z, DA, Hz)
    real(dl), intent(in) :: z, DA, Hz
    real(dl) ADD

    ADD = DA*(1.d0+z)
    BAO_D_v_from_DA_H = ((ADD)**2.d0*z/Hz)**(1.d0/3.d0)

    end function BAO_D_v_from_DA_H

    real(dl) function BAO_D_v(z)
    real(dl), intent(IN) :: z

    BAO_D_v = BAO_D_v_from_DA_H(z,AngularDiameterDistance(z), Hofz(z))

    end function BAO_D_v

    function dsound_da_exact(a)
    implicit none
    real(dl) dsound_da_exact,dtauda,a,R,cs
    external dtauda

    R = 3*grhob*a / (4*grhog)
    cs=1.0d0/sqrt(3*(1+R))
    dsound_da_exact=dtauda(a)*cs

    end function dsound_da_exact


    function dsound_da(a)
    !approximate form used e.g. by CosmoMC for theta
    implicit none
    real(dl) dsound_da,dtauda,a,R,cs
    external dtauda

    R=3.0d4*a*CP%omegab*(CP%h0/100.0d0)**2
    !          R = 3*grhob*a / (4*grhog) //above is mostly within 0.2% and used for previous consistency
    cs=1.0d0/sqrt(3*(1+R))
    dsound_da=dtauda(a)*cs

    end function dsound_da

    function dtda(a)
    real(dl) dtda,dtauda,a
    external dtauda
    dtda= dtauda(a)*a
    end function

    function CosmomcTheta()
    real(dl) zstar, astar, atol, rs, DA
    real(dl) CosmomcTheta
    real(dl) ombh2, omdmh2
    real(dl) rombint
    external rombint

    ombh2 = CP%omegab*(CP%h0/100.0d0)**2
    omdmh2 = (CP%omegac+CP%omegan)*(CP%h0/100.0d0)**2

    !!From Hu & Sugiyama
    zstar =  1048*(1+0.00124*ombh2**(-0.738))*(1+ &
        (0.0783*ombh2**(-0.238)/(1+39.5*ombh2**0.763)) * &
        (omdmh2+ombh2)**(0.560/(1+21.1*ombh2**1.81)))

    astar = 1/(1+zstar)
    atol = 1e-6
    rs = rombint(dsound_da,1d-8,astar,atol)
    DA = AngularDiameterDistance(zstar)/astar
    CosmomcTheta = rs/DA
    !       print *,'z* = ',zstar, 'r_s = ',rs, 'DA = ',DA, rs/DA

    end function CosmomcTheta

    end module ModelParams



    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module lvalues
    use precision
    use ModelParams
    implicit none
    public

    Type lSamples
        integer l0
        integer l(lmax_arr)
    end Type lSamples

    Type(lSamples) :: lSamp
    !Sources
    logical :: Log_lvalues  = .false.

    contains

    function lvalues_indexOf(lSet,l)
    type(lSamples) :: lSet
    integer, intent(in) :: l
    integer lvalues_indexOf, i

    do i=2,lSet%l0
        if (l < lSet%l(i)) then
            lvalues_indexOf = i-1
            return
        end if
    end do
    lvalues_indexOf = lSet%l0

    end function  lvalues_indexOf

    subroutine initlval(lSet,max_l)

    ! This subroutines initializes lSet%l arrays. Other values will be interpolated.

    implicit none
    type(lSamples) :: lSet

    integer, intent(IN) :: max_l
    integer lind, lvar, step,top,bot,ls(lmax_arr)
    real(dl) AScale

    Ascale=scale/lSampleBoost

    if (lSampleBoost >=50) then
        !just do all of them
        lind=0
        do lvar=lmin, max_l
            lind=lind+1
            ls(lind)=lvar
        end do
        lSet%l0=lind
        lSet%l(1:lind) = ls(1:lind)
        return
    end if

    lind=0
    do lvar=lmin, 10
        lind=lind+1
        ls(lind)=lvar
    end do

    if (CP%AccurateReionization) then
        if (lSampleBoost > 1) then
            do lvar=11, 37,1
                lind=lind+1
                ls(lind)=lvar
            end do
        else
            do lvar=11, 37,2
                lind=lind+1
                ls(lind)=lvar
            end do
        end if

        step = max(nint(5*Ascale),2)
        bot=40
        top=bot + step*10
    else
        if (lSampleBoost >1) then
            do lvar=11, 15
                lind=lind+1
                ls(lind)=lvar
            end do
        else
            lind=lind+1
            ls(lind)=12
            lind=lind+1
            ls(lind)=15
        end if
        step = max(nint(10*Ascale),3)
        bot=15+max(step/2,2)
        top=bot + step*7
    end if

    do lvar=bot, top, step
        lind=lind+1
        ls(lind)=lvar
    end do

    !Sources
    if (Log_lvalues) then
        !Useful for generating smooth things like 21cm to high l
        step=max(nint(20*Ascale),4)
        do
            lvar = lvar + step
            if (lvar > max_l) exit
            lind=lind+1
            ls(lind)=lvar
            step = nint(step*1.2) !log spacing
        end do
    else
        step=max(nint(20*Ascale),4)
        bot=ls(lind)+step
        top=bot+step*2

        do lvar = bot,top,step
            lind=lind+1
            ls(lind)=lvar
        end do

        if (ls(lind)>=max_l) then
            do lvar=lind,1,-1
                if (ls(lvar)<=max_l) exit
            end do
            lind=lvar
            if (ls(lind)<max_l) then
                lind=lind+1
                ls(lind)=max_l
            end if
        else
            step=max(nint(25*Ascale),4)
            !Get EE right around l=200 by putting extra point at 175
            bot=ls(lind)+step
            top=bot+step

            do lvar = bot,top,step
                lind=lind+1
                ls(lind)=lvar
            end do

            if (ls(lind)>=max_l) then
                do lvar=lind,1,-1
                    if (ls(lvar)<=max_l) exit
                end do
                lind=lvar
                if (ls(lind)<max_l) then
                    lind=lind+1
                    ls(lind)=max_l
                end if
            else
                if (HighAccuracyDefault .and. .not. use_spline_template) then
                    step=max(nint(42*Ascale),7)
                else
                    step=max(nint(50*Ascale),7)
                end if
                bot=ls(lind)+step
                top=min(5000,max_l)

                do lvar = bot,top,step
                    lind=lind+1
                    ls(lind)=lvar
                end do

                if (max_l > 5000) then
                    !Should be pretty smooth or tiny out here
                    step=max(nint(400*Ascale),50)
                    lvar = ls(lind)
                    do
                        lvar = lvar + step
                        if (lvar > max_l) exit
                        lind=lind+1
                        ls(lind)=lvar
                        step = nint(step*1.5) !log spacing
                    end do
                end if
                !Sources
            end if !log_lvalues

            if (ls(lind) /=max_l) then
                lind=lind+1
                ls(lind)=max_l
            end if
            if (.not. CP%flat) ls(lind-1)=int(max_l+ls(lind-2))/2
            !Not in CP%flat case so interpolation table is the same when using lower l_max
        end if
    end if
    lSet%l0=lind
    lSet%l(1:lind) = ls(1:lind)

    end subroutine initlval

    subroutine InterpolateClArr(lSet,iCl, all_Cl, max_ind)
    type (lSamples), intent(in) :: lSet
    real(dl), intent(in) :: iCl(*)
    real(dl), intent(out):: all_Cl(lmin:*)
    integer, intent(in) :: max_ind
    integer il,llo,lhi, xi
    real(dl) ddCl(lSet%l0)
    real(dl) xl(lSet%l0)

    real(dl) a0,b0,ho
    real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl

    if (max_ind > lSet%l0) call MpiStop('Wrong max_ind in InterpolateClArr')

    xl = real(lSet%l(1:lSet%l0),dl)
    call spline(xl,iCL(1),max_ind,cllo,clhi,ddCl(1))

    llo=1
    do il=lmin,lSet%l(max_ind)
        xi=il
        if ((xi > lSet%l(llo+1)).and.(llo < max_ind)) then
            llo=llo+1
        end if
        lhi=llo+1
        ho=lSet%l(lhi)-lSet%l(llo)
        a0=(lSet%l(lhi)-xi)/ho
        b0=(xi-lSet%l(llo))/ho

        all_Cl(il) = a0*iCl(llo)+ b0*iCl(lhi)+((a0**3-a0)* ddCl(llo) &
            +(b0**3-b0)*ddCl(lhi))*ho**2/6
    end do

    end subroutine InterpolateClArr

    subroutine InterpolateClArrTemplated(lSet,iCl, all_Cl, max_ind, template_index)
    type (lSamples), intent(in) :: lSet
    real(dl), intent(in) :: iCl(*)
    real(dl), intent(out):: all_Cl(lmin:*)
    integer, intent(in) :: max_ind
    integer, intent(in), optional :: template_index
    integer maxdelta, il
    real(dl) DeltaCL(lSet%l0)
    real(dl), allocatable :: tmpall(:)

    if (max_ind > lSet%l0) call MpiStop('Wrong max_ind in InterpolateClArrTemplated')

    if (use_spline_template .and. present(template_index)) then
        if (template_index<=3) then
            !interpolate only the difference between the C_l and an accurately interpolated template. Temp only for the mo.
            !Using unlensed for template, seems to be good enough
            maxdelta=max_ind
            do while (lSet%l(maxdelta) > lmax_extrap_highl)
                maxdelta=maxdelta-1
            end do
            DeltaCL(1:maxdelta)=iCL(1:maxdelta)- highL_CL_template(lSet%l(1:maxdelta), template_index)

            call InterpolateClArr(lSet,DeltaCl, all_Cl, maxdelta)

            do il=lmin,lSet%l(maxdelta)
                all_Cl(il) = all_Cl(il) +  highL_CL_template(il,template_index)
            end do

            if (maxdelta < max_ind) then
                !directly interpolate high L where no t  emplate (doesn't effect lensing spectrum much anyway)
                allocate(tmpall(lmin:lSet%l(max_ind)))
                call InterpolateClArr(lSet,iCl, tmpall, max_ind)
                !overlap to reduce interpolation artefacts
                all_cl(lSet%l(maxdelta-2):lSet%l(max_ind) ) = tmpall(lSet%l(maxdelta-2):lSet%l(max_ind))
                deallocate(tmpall)
            end if
            return
        end if
    end if

    call InterpolateClArr(lSet,iCl, all_Cl, max_ind)


    end subroutine InterpolateClArrTemplated

    end module lvalues


    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module ModelData
    use precision
    use ModelParams
    use InitialPower
    use lValues
    use Ranges
    use AMlUtils
    implicit none
    public

    Type LimberRec
        integer n1,n2 !corresponding time step array indices
        real(dl), dimension(:), pointer :: k  => NULL()
        real(dl), dimension(:), pointer :: Source  => NULL()
    end Type LimberRec

    Type ClTransferData
        !Cl transfer function variables
        !values of q for integration over q to get C_ls
        Type (lSamples) :: ls ! scalar and tensor l that are computed
        integer :: NumSources
        !Changes -scalars:  2 for just CMB, 3 for lensing
        !- tensors: T and E and phi (for lensing), and T, E, B respectively

        Type (Regions) :: q
        real(dl), dimension(:,:,:), pointer :: Delta_p_l_k => NULL()

        !The L index of the lowest L to use for Limber
        integer, dimension(:), pointer :: Limber_l_min => NULL()
        !For each l, the set of k in each limber window
        !indices LimberWindow(SourceNum,l)
        Type(LimberRec), dimension(:,:), pointer :: Limber_windows => NULL()

        !The maximum L needed for non-Limber
        integer max_index_nonlimber

    end Type ClTransferData

    Type(ClTransferData), save, target :: CTransScal, CTransTens, CTransVec

    !Computed output power spectra data

    integer, parameter :: C_Temp = 1, C_E = 2, C_Cross =3, C_Phi = 4, C_PhiTemp = 5, C_PhiE=6
    integer :: C_last = C_PhiE
    integer, parameter :: CT_Temp =1, CT_E = 2, CT_B = 3, CT_Cross=  4
    integer, parameter :: name_tag_len = 12
    character(LEN=name_tag_len), dimension(C_PhiE), parameter :: C_name_tags = ['TT','EE','TE','PP','TP','EP']
    character(LEN=name_tag_len), dimension(CT_Cross), parameter :: CT_name_tags = ['TT','EE','BB','TE']
    character(LEN=name_tag_len), dimension(7), parameter :: lens_pot_name_tags = ['TT','EE','BB','TE','PP','TP','EP']


    logical :: has_cl_2D_array = .false.

    real(dl), dimension (:,:,:), allocatable :: Cl_scalar, Cl_tensor, Cl_vector
    !Indices are Cl_xxx( l , intial_power_index, Cl_type)
    !where Cl_type is one of the above constants

    real(dl), dimension (:,:,:,:), allocatable :: Cl_Scalar_Array
    !Indices are Cl_xxx( l , intial_power_index, field1,field2)
    !where ordering of fields is T, E, \psi (CMB lensing potential), window_1, window_2...

    !The following are set only if doing lensing
    integer lmax_lensed !Only accurate to rather less than this
    real(dl) , dimension (:,:,:), allocatable :: Cl_lensed
    !Cl_lensed(l, power_index, Cl_type) are the interpolated Cls

    contains

    subroutine Init_ClTransfer(CTrans)
    !Need to set the Ranges array q before calling this
    Type(ClTransferData) :: CTrans
    integer st

    deallocate(CTrans%Delta_p_l_k, STAT = st)
    call Ranges_getArray(CTrans%q, .true.)

    allocate(CTrans%Delta_p_l_k(CTrans%NumSources,&
        min(CTrans%max_index_nonlimber,CTrans%ls%l0), CTrans%q%npoints),  STAT = st)
    if (st /= 0) call MpiStop('Init_ClTransfer: Error allocating memory for transfer functions')
    CTrans%Delta_p_l_k = 0

    end subroutine Init_ClTransfer

    subroutine Init_Limber(CTrans)
    Type(ClTransferData) :: CTrans

    allocate(CTrans%Limber_l_min(CTrans%NumSources))
    CTrans%Limber_l_min = 0
    if (num_redshiftwindows>0 .or. limber_phiphi>0) then
        allocate(CTrans%Limber_windows(CTrans%NumSources,CTrans%ls%l0))
    end if

    end subroutine Init_Limber

    subroutine Free_ClTransfer(CTrans)
    Type(ClTransferData) :: CTrans
    integer st

    deallocate(CTrans%Delta_p_l_k, STAT = st)
    nullify(CTrans%Delta_p_l_k)
    call Ranges_Free(CTrans%q)
    call Free_Limber(CTrans)

    end subroutine Free_ClTransfer

    subroutine Free_Limber(CTrans)
    Type(ClTransferData) :: CTrans
    integer st,i,j

    if (associated(CTrans%Limber_l_min)) then
        do i=1, CTrans%NumSources
            if (CTrans%Limber_l_min(i)/=0) then
                do j=CTrans%Limber_l_min(i), CTrans%ls%l0
                    deallocate(CTrans%Limber_windows(i, j)%k, STAT = st)
                    deallocate(CTrans%Limber_windows(i, j)%Source, STAT = st)
                end do
            end if
        end do
        deallocate(CTrans%Limber_l_min, STAT = st)
    end if
    deallocate(CTrans%Limber_windows, STAT = st)
    nullify(CTrans%Limber_l_min)
    nullify(CTrans%Limber_windows)

    end subroutine Free_Limber

    subroutine CheckLoadedHighLTemplate
    integer L
    real(dl) array(7)

    if (.not. allocated(highL_CL_template)) then
        allocate(highL_CL_template(lmin:lmax_extrap_highl, C_Temp:C_Phi))

        call OpenTxtFile(highL_unlensed_cl_template,fileio_unit)

        if (lmin==1) highL_CL_template(lmin,:)=0
        do
            read(fileio_unit,*, end=500) L , array
            if (L>lmax_extrap_highl) exit
            !  array = array * (2*l+1)/(4*pi) * 2*pi/(l*(l+1))
            highL_CL_template(L, C_Temp:C_E) =array(1:2)
            highL_CL_template(L, C_Cross) =array(4)
            highL_CL_template(L, C_Phi) =array(5)
        end do
500     if (L< lmax_extrap_highl) &
            call MpiStop('CheckLoadedHighLTemplate: template file does not go up to lmax_extrap_highl')
        close(fileio_unit)
    end if

    end subroutine CheckLoadedHighLTemplate


    subroutine Init_Cls

    call CheckLoadedHighLTemplate
    if (CP%WantScalars) then
        if (allocated(Cl_scalar)) deallocate(Cl_scalar)
        allocate(Cl_scalar(lmin:CP%Max_l, CP%InitPower%nn, C_Temp:C_last))
        Cl_scalar = 0
        if (has_cl_2D_array) then
            if (allocated(Cl_scalar_array)) deallocate(Cl_scalar_array)
            allocate(Cl_scalar_Array(lmin:CP%Max_l, CP%InitPower%nn, &
                3+num_redshiftwindows+num_custom_sources,3+num_redshiftwindows+num_custom_sources))
            Cl_scalar_array = 0
        end if
    end if

    if (CP%WantVectors) then
        if (allocated(Cl_vector)) deallocate(Cl_vector)
        allocate(Cl_vector(lmin:CP%Max_l, CP%InitPower%nn, CT_Temp:CT_Cross))
        Cl_vector = 0
    end if


    if (CP%WantTensors) then
        if (allocated(Cl_tensor)) deallocate(Cl_tensor)
        allocate(Cl_tensor(lmin:CP%Max_l_tensor, CP%InitPower%nn, CT_Temp:CT_Cross))
        Cl_tensor = 0
    end if

    end subroutine Init_Cls

    function open_file_header(filename, Col1, Columns, n) result(unit)
    character(LEN=*), intent(in) :: filename
    character(LEN=*), intent(in) :: col1
    character(LEN=name_tag_len), intent(in) :: Columns(:)
    integer, intent(in), optional :: n
    integer :: unit, nn

    if (present(n)) then
        nn = n
    else
        nn = 6
    end if
    open(newunit=unit,file=filename,form='formatted',status='replace')
    if (output_file_headers) then
        write(unit,'("#",1A'//Trim(IntToStr(nn-1))//'," ",*(A15))') Col1,Columns
    end if

    end function open_file_header

    function scalar_fieldname(i)
    integer, intent(in) :: i
    character(LEN=5) :: scalar_fieldname
    character(LEN=3), parameter :: scalar_fieldnames = 'TEP'

    if (i<=3) then
        scalar_fieldname = scalar_fieldnames(i:i)
    else
        scalar_fieldname = 'W'//trim(IntToStr(i-3))
    end if

    end function scalar_fieldname

    subroutine output_cl_files(ScalFile,ScalCovFile,TensFile, TotFile, LensFile, LensTotFile, factor)
    implicit none
    integer in,il, i, j
    character(LEN=*) ScalFile, TensFile, TotFile, LensFile, LensTotFile,ScalCovfile
    real(dl), intent(in), optional :: factor
    real(dl) fact
    integer last_C
    real(dl), allocatable :: outarr(:,:)
    integer unit
    character(LEN=name_tag_len) :: cov_names((3+num_redshiftwindows)**2)


    if (present(factor)) then
        fact = factor
    else
        fact =1
    end if

    if (CP%WantScalars .and. ScalFile /= '') then
        last_C=min(C_PhiTemp,C_last)
        unit = open_file_header(ScalFile, 'L', C_name_tags(:last_C))
        do in=1,CP%InitPower%nn
            do il=lmin,min(10000,CP%Max_l)
                write(unit,trim(numcat('(1I6,',last_C))//'E15.5)')il ,fact*Cl_scalar(il,in,C_Temp:last_C)
            end do
            do il=10100,CP%Max_l, 100
                write(unit,trim(numcat('(1E15.5,',last_C))//'E15.5)') real(il),&
                    fact*Cl_scalar(il,in,C_Temp:last_C)
            end do
        end do
        close(unit)
    end if

    if (CP%WantScalars .and. has_cl_2D_array .and. ScalCovFile /= '' .and. CTransScal%NumSources>2) then
        allocate(outarr(1:3+num_redshiftwindows,1:3+num_redshiftwindows))
        do i=1, 3+num_redshiftwindows
            do j=1, 3+num_redshiftwindows
                cov_names(j + (i-1)*(3+num_redshiftwindows)) = trim(scalar_fieldname(i))//'x'//trim(scalar_fieldname(j))
            end do
        end do
        unit = open_file_header(ScalCovFile, 'L', cov_names)

        do in=1,CP%InitPower%nn
            do il=lmin,min(10000,CP%Max_l)
                outarr=Cl_scalar_array(il,in,1:3+num_redshiftwindows,1:3+num_redshiftwindows)
                outarr(1:2,:)=sqrt(fact)*outarr(1:2,:)
                outarr(:,1:2)=sqrt(fact)*outarr(:,1:2)
                write(unit,trim(numcat('(1I6,',(3+num_redshiftwindows)**2))//'E15.5)') il, outarr
            end do
            do il=10100,CP%Max_l, 100
                outarr=Cl_scalar_array(il,in,1:3+num_redshiftwindows,1:3+num_redshiftwindows)
                outarr(1:2,:)=sqrt(fact)*outarr(1:2,:)
                outarr(:,1:2)=sqrt(fact)*outarr(:,1:2)
                write(unit,trim(numcat('(1E15.5,',(3+num_redshiftwindows)**2))//'E15.5)') real(il), outarr
            end do
        end do
        close(unit)
        deallocate(outarr)
    end if

    if (CP%WantTensors .and. TensFile /= '') then
        unit = open_file_header(TensFile, 'L', CT_name_tags)
        do in=1,CP%InitPower%nn
            do il=lmin,CP%Max_l_tensor
                write(unit,'(1I6,4E15.5)')il, fact*Cl_tensor(il, in, CT_Temp:CT_Cross)
            end do
        end do
        close(unit)
    end if

    if (CP%WantTensors .and. CP%WantScalars .and. TotFile /= '') then
        unit = open_file_header(TotFile, 'L', CT_name_tags)
        do in=1,CP%InitPower%nn
            do il=lmin,CP%Max_l_tensor
                write(unit,'(1I6,4E15.5)')il, fact*(Cl_scalar(il, in, C_Temp:C_E)+ Cl_tensor(il,in, C_Temp:C_E)), &
                    fact*Cl_tensor(il,in, CT_B), fact*(Cl_scalar(il, in, C_Cross) + Cl_tensor(il, in, CT_Cross))
            end do
            do il=CP%Max_l_tensor+1,CP%Max_l
                write(unit,'(1I6,4E15.5)')il ,fact*Cl_scalar(il,in,C_Temp:C_E), 0._dl, fact*Cl_scalar(il,in,C_Cross)
            end do
        end do
        close(unit)
    end if

    if (CP%WantScalars .and. CP%DoLensing .and. LensFile /= '') then
        unit = open_file_header(LensFile, 'L', CT_name_tags)
        do in=1,CP%InitPower%nn
            do il=lmin, lmax_lensed
                write(unit,'(1I6,4E15.5)')il, fact*Cl_lensed(il, in, CT_Temp:CT_Cross)
            end do
        end do
        close(unit)
    end if


    if (CP%WantScalars .and. CP%WantTensors .and. CP%DoLensing .and. LensTotFile /= '') then
        unit = open_file_header(LensTotFile, 'L', CT_name_tags)
        do in=1,CP%InitPower%nn
            do il=lmin,min(CP%Max_l_tensor,lmax_lensed)
                write(unit,'(1I6,4E15.5)')il, fact*(Cl_lensed(il, in, CT_Temp:CT_Cross)+ Cl_tensor(il,in, CT_Temp:CT_Cross))
            end do
            do il=min(CP%Max_l_tensor,lmax_lensed)+1,lmax_lensed
                write(unit,'(1I6,4E15.5)')il, fact*Cl_lensed(il, in, CT_Temp:CT_Cross)
            end do
        end do
        close(unit)
    end if
    end subroutine output_cl_files

    subroutine output_lens_pot_files(LensPotFile, factor)
    !Write out L TT EE BB TE PP PT PE where P is the lensing potential, all unlensed
    !This input supported by LensPix from 2010
    implicit none
    integer in,il
    real(dl), intent(in), optional :: factor
    real(dl) fact, scale, BB, TT, TE, EE
    character(LEN=*) LensPotFile
    integer unit
    !output file of dimensionless [l(l+1)]^2 C_phi_phi/2pi and [l(l+1)]^(3/2) C_phi_T/2pi
    !This is the format used by Planck_like but original LensPix uses scalar_output_file.

    !(Cl_scalar and scalar_output_file numbers are instead l^4 C_phi and l^3 C_phi
    ! - for historical reasons)

    if (present(factor)) then
        fact = factor
    else
        fact =1
    end if

    if (CP%WantScalars .and. CP%DoLensing .and. LensPotFile/='') then
        unit =  open_file_header(LensPotFile, 'L', lens_pot_name_tags)
        do in=1,CP%InitPower%nn
            do il=lmin,min(10000,CP%Max_l)
                TT = Cl_scalar(il, in, C_Temp)
                EE = Cl_scalar(il, in, C_E)
                TE = Cl_scalar(il, in, C_Cross)
                if (CP%WantTensors .and. il <= CP%Max_l_tensor) then
                    TT= TT+Cl_tensor(il,in, CT_Temp)
                    EE= EE+Cl_tensor(il,in, CT_E)
                    TE= TE+Cl_tensor(il,in, CT_Cross)
                    BB= Cl_tensor(il,in, CT_B)
                else
                    BB=0
                end if
                scale = (real(il+1)/il)**2/OutputDenominator !Factor to go from old l^4 factor to new

                write(unit,'(1I6,7E15.5)') il , fact*TT, fact*EE, fact*BB, fact*TE, scale*Cl_scalar(il,in,C_Phi),&
                    (real(il+1)/il)**1.5/OutputDenominator*sqrt(fact)*Cl_scalar(il,in,C_PhiTemp:C_PhiE)
            end do
            do il=10100,CP%Max_l, 100
                scale = (real(il+1)/il)**2/OutputDenominator
                write(unit,'(1E15.5,7E15.5)') real(il), fact*Cl_scalar(il,in,C_Temp:C_E),0.,fact*Cl_scalar(il,in,C_Cross), &
                    scale*Cl_scalar(il,in,C_Phi),&
                    (real(il+1)/il)**1.5/OutputDenominator*sqrt(fact)*Cl_scalar(il,in,C_PhiTemp:C_PhiE)
            end do
        end do
        close(unit)
    end if
    end subroutine output_lens_pot_files


    subroutine output_veccl_files(VecFile, factor)
    implicit none
    integer in,il
    character(LEN=*) VecFile
    real(dl), intent(in), optional :: factor
    real(dl) fact
    integer unit

    if (present(factor)) then
        fact = factor
    else
        fact =1
    end if


    if (CP%WantVectors .and. VecFile /= '') then
        unit =  open_file_header(VecFile, 'L', CT_name_tags)
        do in=1,CP%InitPower%nn
            do il=lmin,CP%Max_l
                write(unit,'(1I6,4E15.5)')il, fact*Cl_vector(il, in, CT_Temp:CT_Cross)
            end do
        end do
        close(unit)
    end if

    end subroutine output_veccl_files

    subroutine NormalizeClsAtL(lnorm)
    implicit none
    integer, intent(IN) :: lnorm
    integer in
    real(dl) Norm

    do in=1,CP%InitPower%nn
        if (CP%WantScalars) then
            Norm=1/Cl_scalar(lnorm,in, C_Temp)
            Cl_scalar(lmin:CP%Max_l, in, C_Temp:C_Cross) = Cl_scalar(lmin:CP%Max_l, in, C_Temp:C_Cross) * Norm
        end if

        if (CP%WantTensors) then
            if (.not.CP%WantScalars) Norm = 1/Cl_tensor(lnorm,in, C_Temp)
            !Otherwise Norm already set correctly
            Cl_tensor(lmin:CP%Max_l_tensor, in, CT_Temp:CT_Cross) =  &
                Cl_tensor(lmin:CP%Max_l_tensor, in, CT_Temp:CT_Cross) * Norm
        end if
    end do

    end  subroutine NormalizeClsAtL

    subroutine ModelData_Free

    call Free_ClTransfer(CTransScal)
    call Free_ClTransfer(CTransVec)
    call Free_ClTransfer(CTransTens)
    if (allocated(Cl_vector)) deallocate(Cl_vector)
    if (allocated(Cl_tensor)) deallocate(Cl_tensor)
    if (allocated(Cl_scalar)) deallocate(Cl_scalar)
    if (allocated(Cl_lensed)) deallocate(Cl_lensed)
    if (allocated(Cl_scalar_array)) deallocate(Cl_scalar_array)

    end subroutine ModelData_Free

    end module ModelData


    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    module MassiveNu
    use precision
    use ModelParams
    implicit none
    private

    real(dl), parameter  :: const  = 7._dl/120*pi**4 ! 5.68219698_dl
    !const = int q^3 F(q) dq = 7/120*pi^4
    real(dl), parameter  :: const2 = 5._dl/7/pi**2   !0.072372274_dl
    real(dl), parameter  :: zeta3  = 1.2020569031595942853997_dl
    real(dl), parameter  :: zeta5  = 1.0369277551433699263313_dl
    real(dl), parameter  :: zeta7  = 1.0083492773819228268397_dl

    ! zeta3*3/2/pi^2*4/11*((k_B*COBE_CMBTemp/hbar/c)^3* 8*pi*G/3/(100*km/s/megaparsec)^2/(c^2/eV)
    real(dl), parameter :: neutrino_mass_fac= 94.07_dl !converts omnuh2 into sum m_nu in eV

    integer, parameter  :: nrhopn=2000
    real(dl), parameter :: am_min = 0.01_dl  !0.02_dl
    !smallest a*m_nu to integrate distribution function rather than using series
    real(dl), parameter :: am_max = 600._dl
    !max a*m_nu to integrate

    real(dl),parameter  :: am_minp=am_min*1.1
    real(dl), parameter :: am_maxp=am_max*0.9

    real(dl) dlnam

    real(dl), dimension(:), allocatable ::  r1,p1,dr1,dp1,ddr1

    !Sample for massive neutrino momentum
    !These settings appear to be OK for P_k accuate at 1e-3 level
    integer, parameter :: nqmax0=80 !maximum array size of q momentum samples
    real(dl) :: nu_q(nqmax0), nu_int_kernel(nqmax0)

    integer nqmax !actual number of q modes evolves

    public const,Nu_Init,Nu_background, Nu_rho, Nu_drho,  nqmax0, nqmax, &
        nu_int_kernel, nu_q, sum_mnu_for_m1, neutrino_mass_fac
    contains
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    subroutine sum_mnu_for_m1(summnu,dsummnu, m1, targ, sgn)
    use constants
    real(dl), intent(in) :: m1, targ, sgn
    real(dl), intent(out) :: summnu, dsummnu
    real(dl) :: m2,m3

    m2 = sqrt(m1**2 + delta_mnu21)
    m3 = sqrt(m1**2 + sgn*delta_mnu31)
    summnu = m1 + m2 + m3 - targ
    dsummnu = m1/m2+m1/m3 + 1

    end subroutine sum_mnu_for_m1

    subroutine Nu_init
    !  Initialize interpolation tables for massive neutrinos.
    !  Use cubic splines interpolation of log rhonu and pnu vs. log a*m.
    integer i
    real(dl) dq,dlfdlq, q, am, rhonu,pnu
    real(dl) spline_data(nrhopn)

    !  nu_masses=m_nu(i)*c**2/(k_B*T_nu0).
    !  Get number density n of neutrinos from
    !  rho_massless/n = int q^3/(1+e^q) / int q^2/(1+e^q)=7/180 pi^4/Zeta(3)
    !  then m = Omega_nu/N_nu rho_crit /n
    !  Error due to velocity < 1e-5

    do i=1, CP%Nu_mass_eigenstates
        nu_masses(i)=const/(1.5d0*zeta3)*grhom/grhor*CP%omegan*CP%Nu_mass_fractions(i) &
            /CP%Nu_mass_degeneracies(i)
    end do

    if (allocated(r1)) return
    allocate(r1(nrhopn),p1(nrhopn),dr1(nrhopn),dp1(nrhopn),ddr1(nrhopn))


    nqmax=3
    if (AccuracyBoost >1) nqmax=4
    if (AccuracyBoost >2) nqmax=5
    if (AccuracyBoost >3) nqmax=nint(AccuracyBoost*10)
    !note this may well be worse than the 5 optimized points

    if (nqmax > nqmax0) call MpiStop('Nu_Init: qmax > nqmax0')

    !We evolve evolve 4F_l/dlfdlq(i), so kernel includes dlfdlnq factor
    !Integration scheme gets (Fermi-Dirac thing)*q^n exact,for n=-4, -2..2
    !see CAMB notes
    if (nqmax==3) then
        !Accurate at 2e-4 level
        nu_q(1:3) = (/0.913201, 3.37517, 7.79184/)
        nu_int_kernel(1:3) = (/0.0687359, 3.31435, 2.29911/)
    else if (nqmax==4) then
        !This seems to be very accurate (limited by other numerics)
        nu_q(1:4) = (/0.7, 2.62814, 5.90428, 12.0/)
        nu_int_kernel(1:4) = (/0.0200251, 1.84539, 3.52736, 0.289427/)
    else if (nqmax==5) then
        !exact for n=-4,-2..3
        !This seems to be very accurate (limited by other numerics)
        nu_q(1:5) = (/0.583165, 2.0, 4.0, 7.26582, 13.0/)
        nu_int_kernel(1:5) = (/0.0081201, 0.689407, 2.8063, 2.05156, 0.126817/)
    else
        dq = (12 + nqmax/5)/real(nqmax)
        do i=1,nqmax
            q=(i-0.5d0)*dq
            nu_q(i) = q
            dlfdlq=-q/(1._dl+exp(-q))
            nu_int_kernel(i)=dq*q**3/(exp(q)+1._dl) * (-0.25_dl*dlfdlq) !now evolve 4F_l/dlfdlq(i)
        end do
    end if
    nu_int_kernel=nu_int_kernel/const

    dlnam=-(log(am_min/am_max))/(nrhopn-1)


    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC) &
    !$OMP & PRIVATE(am, rhonu,pnu)
    do i=1,nrhopn
    am=am_min*exp((i-1)*dlnam)
    call nuRhoPres(am,rhonu,pnu)
    r1(i)=log(rhonu)
    p1(i)=log(pnu)
    end do
    !$OMP END PARALLEL DO


    call splini(spline_data,nrhopn)
    call splder(r1,dr1,nrhopn,spline_data)
    call splder(p1,dp1,nrhopn,spline_data)
    call splder(dr1,ddr1,nrhopn,spline_data)


    end subroutine Nu_init

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine nuRhoPres(am,rhonu,pnu)
    !  Compute the density and pressure of one eigenstate of massive neutrinos,
    !  in units of the mean density of one flavor of massless neutrinos.

    real(dl),  parameter :: qmax=30._dl
    integer, parameter :: nq=100
    real(dl) dum1(nq+1),dum2(nq+1)
    real(dl), intent(in) :: am
    real(dl), intent(out) ::  rhonu,pnu
    integer i
    real(dl) q,aq,v,aqdn,adq


    !  q is the comoving momentum in units of k_B*T_nu0/c.
    !  Integrate up to qmax and then use asymptotic expansion for remainder.
    adq=qmax/nq
    dum1(1)=0._dl
    dum2(1)=0._dl
    do  i=1,nq
        q=i*adq
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        aqdn=adq*q*q*q/(exp(q)+1._dl)
        dum1(i+1)=aqdn/v
        dum2(i+1)=aqdn*v
    end do
    call splint(dum1,rhonu,nq+1)
    call splint(dum2,pnu,nq+1)
    !  Apply asymptotic corrrection for q>qmax and normalize by relativistic
    !  energy density.
    rhonu=(rhonu+dum1(nq+1)/adq)/const
    pnu=(pnu+dum2(nq+1)/adq)/const/3._dl

    end subroutine nuRhoPres

    !cccccccccccccccccccccccccccccccccccccccccc
    subroutine Nu_background(am,rhonu,pnu)
    use precision
    use ModelParams
    real(dl), intent(in) :: am
    real(dl), intent(out) :: rhonu, pnu

    !  Compute massive neutrino density and pressure in units of the mean
    !  density of one eigenstate of massless neutrinos.  Use cubic splines to
    !  interpolate from a table.

    real(dl) d
    integer i

    if (am <= am_minp) then
        rhonu=1._dl + const2*am**2
        pnu=(2-rhonu)/3._dl
        return
    else if (am >= am_maxp) then
        rhonu = 3/(2*const)*(zeta3*am + (15*zeta5)/2/am)
        pnu = 900._dl/120._dl/const*(zeta5-63._dl/4*Zeta7/am**2)/am
        return
    end if


    d=log(am/am_min)/dlnam+1._dl
    i=int(d)
    d=d-i

    !  Cubic spline interpolation.
    rhonu=r1(i)+d*(dr1(i)+d*(3._dl*(r1(i+1)-r1(i))-2._dl*dr1(i) &
        -dr1(i+1)+d*(dr1(i)+dr1(i+1)+2._dl*(r1(i)-r1(i+1)))))
    pnu=p1(i)+d*(dp1(i)+d*(3._dl*(p1(i+1)-p1(i))-2._dl*dp1(i) &
        -dp1(i+1)+d*(dp1(i)+dp1(i+1)+2._dl*(p1(i)-p1(i+1)))))
    rhonu=exp(rhonu)
    pnu=exp(pnu)

    end subroutine Nu_background

    !cccccccccccccccccccccccccccccccccccccccccc
    subroutine Nu_rho(am,rhonu)
    use precision
    use ModelParams
    real(dl), intent(in) :: am
    real(dl), intent(out) :: rhonu

    !  Compute massive neutrino density in units of the mean
    !  density of one eigenstate of massless neutrinos.  Use cubic splines to
    !  interpolate from a table.

    real(dl) d
    integer i

    if (am <= am_minp) then
        rhonu=1._dl + const2*am**2
        return
    else if (am >= am_maxp) then
        rhonu = 3/(2*const)*(zeta3*am + (15*zeta5)/2/am)
        return
    end if

    d=log(am/am_min)/dlnam+1._dl
    i=int(d)
    d=d-i

    !  Cubic spline interpolation.
    rhonu=r1(i)+d*(dr1(i)+d*(3._dl*(r1(i+1)-r1(i))-2._dl*dr1(i) &
        -dr1(i+1)+d*(dr1(i)+dr1(i+1)+2._dl*(r1(i)-r1(i+1)))))
    rhonu=exp(rhonu)
    end subroutine Nu_rho

    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    function Nu_drho(am,adotoa,rhonu) result (rhonudot)
    use precision
    use ModelParams

    !  Compute the time derivative of the mean density in massive neutrinos
    !  and the shear perturbation.
    real(dl) adotoa,rhonu,rhonudot
    real(dl) d
    real(dl), intent(IN) :: am
    integer i

    if (am< am_minp) then
        rhonudot = 2*const2*am**2*adotoa
    else if (am>am_maxp) then
        rhonudot = 3/(2*const)*(zeta3*am - (15*zeta5)/2/am)*adotoa
    else
        d=log(am/am_min)/dlnam+1._dl
        i=int(d)
        d=d-i
        !  Cubic spline interpolation for rhonudot.
        rhonudot=dr1(i)+d*(ddr1(i)+d*(3._dl*(dr1(i+1)-dr1(i)) &
            -2._dl*ddr1(i)-ddr1(i+1)+d*(ddr1(i)+ddr1(i+1) &
            +2._dl*(dr1(i)-dr1(i+1)))))

        rhonudot=rhonu*adotoa*rhonudot/dlnam
    end if

    end function Nu_drho

    end module MassiveNu

    ! wrapper function to avoid cirular module references
    subroutine init_massive_nu(has_massive_nu)
    use MassiveNu
    use ModelParams
    implicit none
    logical, intent(IN) :: has_massive_nu

    if (has_massive_nu) then
        call Nu_Init
    else
        nu_masses = 0
    end if
    end subroutine init_massive_nu


    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module Transfer
    use ModelData
    use Errors
    implicit none
    public
    integer, parameter :: Transfer_kh =1, Transfer_cdm=2,Transfer_b=3,Transfer_g=4, &
        Transfer_r=5, Transfer_nu = 6,  & !massless and massive neutrino
    Transfer_tot=7, Transfer_nonu=8, Transfer_tot_de=9,  &
        ! total perturbations with and without neutrinos, with neutrinos+dark energy in the numerator
        Transfer_Weyl = 10, & ! the Weyl potential, for lensing and ISW
    Transfer_Newt_vel_cdm=11, Transfer_Newt_vel_baryon=12,   & ! -k v_Newtonian/H
    Transfer_vel_baryon_cdm = 13 !relative velocity of baryons and CDM

    integer, parameter :: Transfer_max = Transfer_vel_baryon_cdm
    character(LEN=name_tag_len) :: Transfer_name_tags(Transfer_max-1) = &
        ['CDM     ', 'baryon  ', 'photon  ', 'nu      ', 'mass_nu ', 'total   ', &
        'no_nu   ', 'total_de', 'Weyl    ', 'v_CDM   ', 'v_b     ', 'v_b-v_c ']

    logical :: transfer_interp_matterpower  = .true. !output regular grid in log k
    !set to false to output calculated values for later interpolation

    integer :: transfer_power_var = Transfer_tot
    !What to use to calulcate the output matter power spectrum and sigma_8
    !Transfer_tot uses total matter perturbation

    logical :: get_growth_sigma8 = .true.
    !gets sigma_vdelta, like sigma8 but using velocity-density cross power,
    !in late LCDM f*sigma8 = sigma_vdelta^2/sigma8

    Type MatterTransferData
        !Computed data
        integer   ::  num_q_trans   !    number of steps in k for transfer calculation
        real(dl), dimension (:), pointer :: q_trans => NULL()
        real(dl), dimension (:,:), pointer ::  sigma_8 => NULL()
        real(dl), dimension (:,:), pointer ::  sigma2_vdelta_8 => NULL() !growth from sigma_{v delta}
        real, dimension(:,:,:), pointer :: TransferData => NULL()
        !TransferData(entry,k_index,z_index) for entry=Tranfer_kh.. Transfer_tot
    end Type MatterTransferData

    Type MatterPowerData
        !everything is a function of k/h
        integer   ::  num_k, num_z
        real(dl), dimension(:), pointer :: log_kh => NULL(), redshifts => NULL()
        !matpower is log(P_k)
        real(dl), dimension(:,:), allocatable :: matpower, ddmat
        !if NonLinear, nonlin_ratio =  sqrt(P_nonlinear/P_linear)
        !function of k and redshift NonLinearScaling(k_index,z_index)
        real(dl), dimension(:,:), pointer :: nonlin_ratio => NULL()
    end Type MatterPowerData

    Type (MatterTransferData), save :: MT

    interface Transfer_GetMatterPower
    module procedure Transfer_GetMatterPowerD,Transfer_GetMatterPowerS
    end interface

    contains

    subroutine Transfer_GetUnsplinedPower(M,PK,var1,var2, hubble_units)
    !Get 2pi^2/k^3 T_1 T_2 P_R(k)
    Type(MatterTransferData) :: M
    real(dl), intent(inout):: PK(:,:)
    integer, optional, intent(in) :: var1
    integer, optional, intent(in) :: var2
    logical, optional, intent(in) :: hubble_units
    real(dl) h, k
    integer nz, nk, zix, ik
    integer s1, s2
    logical hnorm

    s1 = transfer_power_var
    if (present(var1))  s1 = var1
    s2 = transfer_power_var
    if (present(var2))  s2 = var2
    hnorm = .true.
    if (present(hubble_units)) hnorm = hubble_units

    nk=M%num_q_trans
    nz=CP%Transfer%PK_num_redshifts
    if (nk/= size(PK,1) .or. nz/=size(PK,2)) call MpiStop('Trasfer_GetUnsplinedPower wrong size')

    h = CP%H0/100

    do ik=1,nk
        k = M%TransferData(Transfer_kh,ik,1)*h
        do zix=1,nz
            PK(ik,zix) = M%TransferData(s1,ik,CP%Transfer%PK_redshifts_index(nz-zix+1))*&
                M%TransferData(s2,ik,CP%Transfer%PK_redshifts_index(nz-zix+1))*k*pi*twopi*scalarPower(k,1)
        end do
    end do
    if (hnorm) PK=  PK * h**3

    end subroutine Transfer_GetUnsplinedPower

    subroutine Transfer_GetUnsplinedNonlinearPower(M,PK,var1,var2, hubble_units)
    !Get 2pi^2/k^3 T_1 T_2 P_R(k) after re-scaling for non-linear evolution (if turned on)
    Type(MatterTransferData), intent(in) :: M
    real(dl), intent(inout):: PK(:,:)
    integer, optional, intent(in) :: var1
    integer, optional, intent(in) :: var2
    logical, optional, intent(in) :: hubble_units
    Type(MatterPowerData) :: PKdata
    integer zix

    call Transfer_GetUnsplinedPower(M,PK,var1,var2, hubble_units)
    do zix=1, CP%Transfer%PK_num_redshifts
        call Transfer_GetMatterPowerData(M, PKdata, 1, &
            CP%Transfer%PK_redshifts_index(CP%Transfer%PK_num_redshifts-zix+1))
        call NonLinear_GetRatios(PKdata)
        PK(:,zix) =  PK(:,zix) *PKdata%nonlin_ratio(:,1)**2
        call MatterPowerdata_Free(PKdata)
    end do

    end subroutine Transfer_GetUnsplinedNonlinearPower

    subroutine Transfer_GetMatterPowerData(MTrans, PK_data, power_ix, itf_only, var1, var2)
    !Does *NOT* include non-linear corrections
    !Get total matter power spectrum in units of (h Mpc^{-1})^3 ready for interpolation.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
    !spectrum is generated to beyond the CMB k_max
    Type(MatterTransferData), intent(in) :: MTrans
    Type(MatterPowerData) :: PK_data
    integer, intent(in), optional :: power_ix
    integer, intent(in), optional :: itf_only
    integer, intent(in), optional :: var1, var2
    real(dl) h, kh, k, power
    integer ik
    integer nz,itf, itf_start, itf_end
    integer :: s1,s2, p_ix


    s1 = transfer_power_var
    if (present(var1))  s1 = var1
    s2 = transfer_power_var
    if (present(var2))  s2 = var2
    p_ix = 1
    if (present(power_ix)) p_ix = power_ix

    if (present(itf_only)) then
        itf_start=itf_only
        itf_end = itf_only
        nz = 1
    else
        itf_start=1
        nz= size(MTrans%TransferData,3)
        itf_end = nz
    end if
    PK_data%num_k = MTrans%num_q_trans
    PK_Data%num_z = nz

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%nonlin_ratio(PK_data%num_k,nz))
    allocate(PK_data%log_kh(PK_data%num_k))
    allocate(PK_data%redshifts(nz))
    PK_data%redshifts = CP%Transfer%Redshifts(itf_start:itf_end)

    h = CP%H0/100

    do ik=1,MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,1)
        k = kh*h
        PK_data%log_kh(ik) = log(kh)
        power = ScalarPower(k,p_ix)
        if (global_error_flag/=0) then
            call MatterPowerdata_Free(PK_data)
            return
        end if
        do itf = 1, nz
            PK_data%matpower(ik,itf) = &
                log(MTrans%TransferData(s1,ik,itf_start+itf-1)*&
                MTrans%TransferData(s2,ik,itf_start+itf-1)*k &
                *pi*twopi*h**3*power)
        end do
    end do

    call MatterPowerdata_getsplines(PK_data)

    end subroutine Transfer_GetMatterPowerData

    subroutine MatterPowerData_Load(PK_data,fname)
    !Loads in kh, P_k from file for one redshiftr and one initial power spectrum
    !Not redshift is not stored in file, so not set correctly
    !Also note that output _matterpower file is already interpolated, so re-interpolating is probs not a good idea

    !Get total matter power spectrum in units of (h Mpc^{-1})^3 ready for interpolation.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    use AmlUtils
    character(LEN=*) :: fname
    Type(MatterPowerData) :: PK_data
    real(dl)kh, Pk
    integer ik
    integer nz


    nz = 1
    call openTxtFile(fname, fileio_unit)

    PK_data%num_k = FileLines(fileio_unit)
    PK_Data%num_z = 1

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%nonlin_ratio(PK_data%num_k,nz))
    allocate(PK_data%log_kh(PK_data%num_k))

    allocate(PK_data%redshifts(nz))
    PK_data%redshifts = 0

    do ik=1,PK_data%num_k
        read (fileio_unit,*) kh, Pk
        PK_data%matpower(ik,1) = log(Pk)
        PK_data%log_kh(ik) = log(kh)
    end do

    call MatterPowerdata_getsplines(PK_data)

    end subroutine MatterPowerData_Load


    subroutine MatterPowerdata_getsplines(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i
    real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl

    do i = 1,PK_Data%num_z
        call spline(PK_data%log_kh,PK_data%matpower(1,i),PK_data%num_k,&
            cllo,clhi,PK_data%ddmat(1,i))
    end do

    end subroutine MatterPowerdata_getsplines

    subroutine MatterPowerdata_MakeNonlinear(PK_data)
    Type(MatterPowerData) :: PK_data

    call NonLinear_GetRatios(PK_data)
    PK_data%matpower = PK_data%matpower +  2*log(PK_data%nonlin_ratio)
    call MatterPowerdata_getsplines(PK_data)

    end subroutine MatterPowerdata_MakeNonlinear

    subroutine MatterPowerdata_Free(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i

    deallocate(PK_data%log_kh,stat=i)
    deallocate(PK_data%matpower,stat=i)
    deallocate(PK_data%ddmat,stat=i)
    deallocate(PK_data%nonlin_ratio,stat=i)
    deallocate(PK_data%redshifts,stat=i)
    call MatterPowerdata_Nullify(PK_data)

    end subroutine MatterPowerdata_Free

    subroutine MatterPowerdata_Nullify(PK_data)
    Type(MatterPowerData) :: PK_data

    nullify(PK_data%log_kh)
    nullify(PK_data%nonlin_ratio)
    nullify(PK_data%redshifts)

    end subroutine MatterPowerdata_Nullify

    function MatterPowerData_k(PK,  kh, itf) result(outpower)
    !Get matter power spectrum at particular k/h by interpolation
    Type(MatterPowerData) :: PK
    integer, intent(in) :: itf
    real (dl), intent(in) :: kh
    real(dl) :: logk
    integer llo,lhi
    real(dl) outpower, dp
    real(dl) ho,a0,b0
    integer, save :: i_last = 1

    logk = log(kh)
    if (logk < PK%log_kh(1)) then
        dp = (PK%matpower(2,itf) -  PK%matpower(1,itf)) / &
            ( PK%log_kh(2)-PK%log_kh(1) )
        outpower = PK%matpower(1,itf) + dp*(logk - PK%log_kh(1))
    else if (logk > PK%log_kh(PK%num_k)) then
        !Do dodgy linear extrapolation on assumption accuracy of result won't matter

        dp = (PK%matpower(PK%num_k,itf) -  PK%matpower(PK%num_k-1,itf)) / &
            ( PK%log_kh(PK%num_k)-PK%log_kh(PK%num_k-1) )
        outpower = PK%matpower(PK%num_k,itf) + dp*(logk - PK%log_kh(PK%num_k))
    else
        llo=min(i_last,PK%num_k)
        do while (PK%log_kh(llo) > logk)
            llo=llo-1
        end do
        do while (PK%log_kh(llo+1)< logk)
            llo=llo+1
        end do
        i_last =llo
        lhi=llo+1
        ho=PK%log_kh(lhi)-PK%log_kh(llo)
        a0=(PK%log_kh(lhi)-logk)/ho
        b0=1-a0

        outpower = a0*PK%matpower(llo,itf)+ b0*PK%matpower(lhi,itf)+&
            ((a0**3-a0)* PK%ddmat(llo,itf) &
            +(b0**3-b0)*PK%ddmat(lhi,itf))*ho**2/6
    end if

    outpower = exp(outpower)

    end function MatterPowerData_k

    subroutine Transfer_GetMatterPowerS(MTrans,outpower, itf, in, minkh, dlnkh, npoints, var1, var2)
    Type(MatterTransferData), intent(in) :: MTrans
    integer, intent(in) :: itf, in, npoints
    integer, intent(in), optional :: var1, var2
    real, intent(out) :: outpower(*)
    real, intent(in) :: minkh, dlnkh
    real(dl) :: outpowerd(npoints)
    real(dl):: minkhd, dlnkhd

    minkhd = minkh; dlnkhd = dlnkh
    call Transfer_GetMatterPowerD(MTrans,outpowerd, itf, in, minkhd, dlnkhd, npoints,var1, var2)
    outpower(1:npoints) = outpowerd(1:npoints)

    end subroutine Transfer_GetMatterPowerS

    !JD 08/13 for nonlinear lensing of CMB + LSS compatibility
    !Changed input variable from itf to itf_PK because we are looking for the itf_PK'th
    !redshift in the PK_redshifts array.  The position of this redshift in the master redshift
    !array, itf, is given by itf = CP%Transfer%Pk_redshifts_index(itf_PK)
    !Also changed (CP%NonLinear/=NonLinear_None) to
    !CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens)
    subroutine Transfer_GetMatterPowerD(MTrans,outpower, itf_PK, in, minkh, dlnkh, npoints, var1, var2)
    !Allows for non-smooth priordial spectra
    !if CP%Nonlinear/ = NonLinear_none includes non-linear evolution
    !Get total matter power spectrum at logarithmically equal intervals dlnkh of k/h starting at minkh
    !in units of (h Mpc^{-1})^3.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
    !sepctrum is generated to beyond the CMB k_max
    Type(MatterTransferData), intent(in) :: MTrans
    Type(MatterPowerData) :: PK

    integer, intent(in) :: itf_PK, in, npoints
    real(dl), intent(out) :: outpower(npoints)
    real(dl), intent(in) :: minkh, dlnkh
    integer, intent(in), optional :: var1, var2

    real(dl), parameter :: cllo=1.e30_dl,clhi=1.e30_dl
    integer ik, llo,il,lhi,lastix
    real(dl) matpower(MTrans%num_q_trans), kh, kvals(MTrans%num_q_trans), ddmat(MTrans%num_q_trans)
    real(dl) atransfer,xi, a0, b0, ho, logmink,k, h
    integer itf
    integer :: s1,s2

    s1 = transfer_power_var
    if (present(var1))  s1 = var1
    s2 = transfer_power_var
    if (present(var2))  s2 = var2

    itf = CP%Transfer%PK_redshifts_index(itf_PK)

    if (npoints < 2) call MpiStop('Need at least 2 points in Transfer_GetMatterPower')

    !         if (minkh < MTrans%TransferData(Transfer_kh,1,itf)) then
    !            stop 'Transfer_GetMatterPower: kh out of computed region'
    !          end if
    if (minkh*exp((npoints-1)*dlnkh) > MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf) &
        .and. FeedbackLevel > 0 ) &
        write(*,*) 'Warning: extrapolating matter power in Transfer_GetMatterPower'


    if (CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens) then
        call Transfer_GetMatterPowerData(MTrans, PK, in, itf) ! Mar 16, changed to use default variable
        call NonLinear_GetRatios(PK)
    end if

    h = CP%H0/100
    logmink = log(minkh)
    do ik=1,MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,itf)
        k = kh*h
        kvals(ik) = log(kh)
        atransfer=MTrans%TransferData(s1,ik,itf)*MTrans%TransferData(s2,ik,itf)
        if (CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens) &
            atransfer = atransfer* PK%nonlin_ratio(ik,1)**2 !only one element, this itf
        matpower(ik) = log(atransfer*k*pi*twopi*h**3)
        !Put in power spectrum later: transfer functions should be smooth, initial power may not be
    end do

    call spline(kvals,matpower,MTrans%num_q_trans,cllo,clhi,ddmat)

    llo=1
    lastix = npoints + 1
    do il=1, npoints
        xi=logmink + dlnkh*(il-1)
        if (xi < kvals(1)) then
            outpower(il)=-30.
            cycle
        end if
        do while ((xi > kvals(llo+1)).and.(llo < MTrans%num_q_trans))
            llo=llo+1
            if (llo >= MTrans%num_q_trans) exit
        end do
        if (llo == MTrans%num_q_trans) then
            lastix = il
            exit
        end if
        lhi=llo+1
        ho=kvals(lhi)-kvals(llo)
        a0=(kvals(lhi)-xi)/ho
        b0=(xi-kvals(llo))/ho

        outpower(il) = a0*matpower(llo)+ b0*matpower(lhi)+((a0**3-a0)* ddmat(llo) &
            +(b0**3-b0)*ddmat(lhi))*ho**2/6
    end do

    do while (lastix <= npoints)
        !Do linear extrapolation in the log
        !Obviouly inaccurate, non-linear etc, but OK if only using in tails of window functions
        outpower(lastix) = 2*outpower(lastix-1) - outpower(lastix-2)
        lastix = lastix+1
    end do

    outpower = exp(max(-30.d0,outpower))

    do il = 1, npoints
        k = exp(logmink + dlnkh*(il-1))*h
        outpower(il) = outpower(il) * ScalarPower(k,in)
        if (global_error_flag /= 0) exit
    end do

    if (CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens) call MatterPowerdata_Free(PK)

    end subroutine Transfer_GetMatterPowerD

    subroutine Transfer_Get_SigmaR(MTrans, R, outvals, var1, var2, power_ix, root)
    !Calculate MTrans%sigma_8^2 = int dk/k win**2 T_k**2 P(k), where win is the FT of a spherical top hat
    !of radius R h^{-1} Mpc, for all requested redshifts
    !set va1, var2 e.g. to get the value from some combination of transfer functions rather than total
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in) :: R
    integer, intent(in), optional :: var1, var2
    integer, intent(in), optional :: power_ix
    logical, intent(in), optional :: root !if true, give sigma8, otherwise sigma8^2
    real(dl), intent(out) :: outvals(:)
    integer ik
    real(dl) kh, k, h, x, win
    real(dl) lnk, dlnk, lnko
    real(dl), dimension(CP%Transfer%PK_num_redshifts) ::  dsig8, dsig8o, sig8, sig8o
    real(dl) powers
    integer s1,s2
    integer :: ix = 1

    s1 = transfer_power_var
    if (present(var1))  s1 = var1
    s2 = transfer_power_var
    if (present(var2))  s2 = var2
    if (present(power_ix)) ix =power_ix

    H=CP%h0/100._dl
    lnko=0
    dsig8o=0
    sig8=0
    sig8o=0
    do ik=1, MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,1)
        if (kh==0) cycle
        k = kh*H

        dsig8 = MTrans%TransferData(s1,ik, &
            CP%Transfer%PK_redshifts_index(1:CP%Transfer%PK_num_redshifts))
        if (s1==s2) then
            dsig8 = dsig8**2
        else
            dsig8 = dsig8*MTrans%TransferData(s2,ik, &
                CP%Transfer%PK_redshifts_index(1:CP%Transfer%PK_num_redshifts))
        end if
        x= kh *R
        win =3*(sin(x)-x*cos(x))/x**3
        lnk=log(k)
        if (ik==1) then
            dlnk=0.5_dl
            !Approx for 2._dl/(CP%InitPower%an(in)+3)  [From int_0^k_1 dk/k k^4 P(k)]
            !Contribution should be very small in any case
        else
            dlnk=lnk-lnko
        end if
        powers = ScalarPower(k,power_ix)
        dsig8=(win*k**2)**2*powers*dsig8
        sig8=sig8+(dsig8+dsig8o)*dlnk/2
        dsig8o=dsig8
        lnko=lnk
    end do

    if (present(root)) then
        if (root) sig8 =sqrt(sig8)
    else
        sig8 =sqrt(sig8)
    end if
    outvals(1:CP%Transfer%PK_num_redshifts) = sig8

    end subroutine Transfer_Get_SigmaR

    subroutine Transfer_GetSigmaRArray(MTrans, R, sigmaR, redshift_ix, var1, var2, power_ix)
    !Get array of SigmaR at (by default) redshift zero, for all values of R
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in) :: R(:)
    real(dl), intent(out) :: SigmaR(:)
    integer, intent(in), optional :: redshift_ix, var1, var2, power_ix
    integer red_ix, ik, subk
    real(dl) kh, k, h, dkh
    real(dl) lnk, dlnk, lnko, minR
    real(dl), dimension(size(R)) ::  x, win, dsig8, dsig8o, sig8, sig8o
    type(MatterPowerData) :: PKspline
    integer, parameter :: nsub = 5

    minR = minval(R)
    red_ix =  CP%Transfer%PK_redshifts_index(CP%Transfer%PK_num_redshifts)
    if (present(redshift_ix)) red_ix = redshift_ix

    call Transfer_GetMatterPowerData(MTrans, PKspline, power_ix, red_ix, var1, var2 )

    H=CP%h0/100._dl
    lnko=0
    dsig8o=0
    sig8=0
    sig8o=0
    if (MTrans%TransferData(Transfer_kh,1,1)==0) call MpiStop('Transfer_GetSigmaRArray kh zero')
    do ik=1, MTrans%num_q_trans + 2
        if (ik < MTrans%num_q_trans) then
            dkh = (MTrans%TransferData(Transfer_kh,ik+1,1)- MTrans%TransferData(Transfer_kh,ik,1))/nsub
            !after last step just extrapolate a bit with previous size
        end if
        if (ik <= MTrans%num_q_trans) kh = MTrans%TransferData(Transfer_kh,ik,1)
        do subk = 1, nsub
            k = kh*H
            lnk=log(k)

            x= kh *R
            win =3*(sin(x)-x*cos(x))/x**3
            if (ik==1 .and. subk==1) then
                dlnk=0.5_dl
                !Approx for 2._dl/(CP%InitPower%an(in)+3)  [From int_0^k_1 dk/k k^4 P(k)]
                !Contribution should be very small in any case
            else
                dlnk=lnk-lnko
            end if
            dsig8=win**2*(MatterPowerData_k(PKspline,  kh, 1)*k**3)
            sig8=sig8+(dsig8+dsig8o)*dlnk/2
            dsig8o=dsig8
            lnko=lnk
            kh = kh + dkh
        end do
    end do
    call MatterPowerdata_Free(PKspline)

    SigmaR=sqrt(sig8/(pi*twopi*h**3 ))

    end subroutine Transfer_GetSigmaRArray

    subroutine Transfer_Get_sigma8(MTrans, R, var1, var2)
    !Calculate MTrans%sigma_8^2 = int dk/k win**2 T_k**2 P(k), where win is the FT of a spherical top hat
    !of radius R h^{-1} Mpc
    ! set va1, var2 e.g. to get the value from some combination of transfer functions rather than total
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in), optional :: R
    integer, intent(in), optional :: var1, var2
    integer ix
    real(dl) :: radius = 8._dl

    if (global_error_flag /= 0) return

    if (present(R)) radius = R

    do ix = 1, CP%InitPower%nn
        call Transfer_Get_SigmaR(MTrans, radius, MTrans%sigma_8(:,ix), var1,var2, ix)
    end do

    end subroutine Transfer_Get_sigma8

    subroutine Transfer_Get_sigmas(MTrans, R, var_delta, var_v)
    !Get sigma8 and sigma_{delta v} (for growth, like f sigma8 in LCDM)
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in), optional :: R
    integer, intent(in), optional :: var_delta,var_v
    real(dl) :: radius = 8._dl
    integer s1, s2, ix

    if (global_error_flag /= 0) return

    if (present(R)) radius = R
    s1 = transfer_power_var
    if (present(var_delta))  s1 = var_delta
    s2 = Transfer_Newt_vel_cdm
    if (present(var_v))  s2 = var_v

    do ix = 1, CP%InitPower%nn
        call Transfer_Get_SigmaR(MTrans, radius, MTrans%sigma_8(:,ix), s1,s1, ix)
        if (get_growth_sigma8) call Transfer_Get_SigmaR(MTrans, radius, &
            MTrans%sigma2_vdelta_8(:,ix), s1, s2, ix, root=.false.)
    end do

    end subroutine Transfer_Get_sigmas

    subroutine Transfer_output_Sig8(MTrans)
    Type(MatterTransferData), intent(in) :: MTrans
    integer in, j
    !JD 08/13 Changes in here to PK arrays and variables
    integer j_PK

    do in=1, CP%InitPower%nn
        if (CP%InitPower%nn>1)  write(*,*) 'Power spectrum : ', in
        do j_PK=1, CP%Transfer%PK_num_redshifts
            j = CP%Transfer%PK_redshifts_index(j_PK)
            write(*,'("at z =",f7.3," sigma8 (all matter) = ",f7.4)') &
                CP%Transfer%redshifts(j), MTrans%sigma_8(j_PK,in)
        end do
        if (get_growth_sigma8) then
            do j_PK=1, CP%Transfer%PK_num_redshifts
                j = CP%Transfer%PK_redshifts_index(j_PK)
                write(*,'("at z =",f7.3," sigma8^2_vd/sigma8  = ",f7.4)') &
                    CP%Transfer%redshifts(j), MTrans%sigma2_vdelta_8(j_PK,in)/MTrans%sigma_8(j_PK,in)
            end do
        end if
    end do

    end subroutine Transfer_output_Sig8

    subroutine Transfer_Allocate(MTrans)
    Type(MatterTransferData) :: MTrans
    integer st

    deallocate(MTrans%q_trans, STAT = st)
    deallocate(MTrans%TransferData, STAT = st)
    deallocate(MTrans%sigma_8, STAT = st)
    if (get_growth_sigma8) deallocate(MTrans%sigma2_vdelta_8, STAT = st)
    allocate(MTrans%q_trans(MTrans%num_q_trans))
    allocate(MTrans%TransferData(Transfer_max,MTrans%num_q_trans,CP%Transfer%num_redshifts))
    !JD 08/13 Changes in here to PK arrays and variables
    allocate(MTrans%sigma_8(CP%Transfer%PK_num_redshifts, CP%InitPower%nn))
    if (get_growth_sigma8) allocate(MTrans%sigma2_vdelta_8(CP%Transfer%PK_num_redshifts, CP%InitPower%nn))

    end  subroutine Transfer_Allocate

    subroutine Transfer_Nullify(Mtrans)
    Type(MatterTransferData):: MTrans

    Mtrans%num_q_trans = 0
    nullify(MTrans%q_trans)
    nullify(MTrans%TransferData)
    nullify(MTrans%sigma_8)
    nullify(MTrans%sigma2_vdelta_8)

    end subroutine Transfer_Nullify

    subroutine Transfer_Free(MTrans)
    Type(MatterTransferData):: MTrans
    integer st

    deallocate(MTrans%q_trans, STAT = st)
    deallocate(MTrans%TransferData, STAT = st)
    deallocate(MTrans%sigma_8, STAT = st)
    if (get_growth_sigma8) deallocate(MTrans%sigma2_vdelta_8, STAT = st)
    call Transfer_Nullify(MTrans)

    end subroutine Transfer_Free

    !JD 08/13 Changes for nonlinear lensing of CMB + MPK compatibility
    !Changed function below to write to only P%NLL_*redshifts* variables
    subroutine Transfer_SetForNonlinearLensing(P)
    Type(TransferParams) :: P
    integer i
    real maxRedshift

    P%kmax = max(P%kmax,5*AccuracyBoost)
    P%k_per_logint  = 0
    maxRedshift = 10
    P%NLL_num_redshifts =  nint(10*AccuracyBoost)
    if (HighAccuracyDefault .and. AccuracyBoost>=2) then
        !only notionally more accuracy, more stable for RS
        maxRedshift =15
    end if
    if (P%NLL_num_redshifts > max_transfer_redshifts) &
        call MpiStop('Transfer_SetForNonlinearLensing: Too many redshifts')
    do i=1,P%NLL_num_redshifts
        P%NLL_redshifts(i) = real(P%NLL_num_redshifts-i)/(P%NLL_num_redshifts/maxRedshift)
    end do

    end subroutine Transfer_SetForNonlinearLensing



    subroutine Transfer_SaveToFiles(MTrans,FileNames)
    use IniFile
    Type(MatterTransferData), intent(in) :: MTrans
    integer i,ik
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)
    !JD 08/13 Changes in here to PK arrays and variables
    integer i_PK
    integer unit

    do i_PK=1, CP%Transfer%PK_num_redshifts
        if (FileNames(i_PK) /= '') then
            i = CP%Transfer%PK_redshifts_index(i_PK)
            unit = open_file_header(FileNames(i_PK), 'k/h', transfer_name_tags, 14)
            do ik=1,MTrans%num_q_trans
                if (MTrans%TransferData(Transfer_kh,ik,i)/=0) then
                    write(unit,'(*(E15.6))') MTrans%TransferData(Transfer_kh:Transfer_max,ik,i)
                end if
            end do
            close(unit)
        end if
    end do

    end subroutine Transfer_SaveToFiles

    subroutine Transfer_SaveMatterPower(MTrans, FileNames)
    use IniFile
    !Export files of total  matter power spectra in h^{-1} Mpc units, against k/h.
    Type(MatterTransferData), intent(in) :: MTrans
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)
    integer itf,in,i
    integer points
    real, dimension(:,:,:), allocatable :: outpower
    real minkh,dlnkh
    Type(MatterPowerData) :: PK_data
    integer ncol
    !JD 08/13 Changes in here to PK arrays and variables
    integer itf_PK
    integer unit
    character(name_tag_len) :: columns(3)

    ncol=1
    if (CP%InitPower%nn>1 .and. output_file_headers) error stop 'InitPower%nn>1 deprecated'

    do itf=1, CP%Transfer%PK_num_redshifts
        if (FileNames(itf) /= '') then
            if (.not. transfer_interp_matterpower ) then
                itf_PK = CP%Transfer%PK_redshifts_index(itf)

                points = MTrans%num_q_trans
                allocate(outpower(points,CP%InitPower%nn,ncol))

                do in = 1, CP%InitPower%nn
                    call Transfer_GetMatterPowerData(MTrans, PK_data, in, itf_PK)
                    !JD 08/13 for nonlinear lensing of CMB + LSS compatibility
                    !Changed (CP%NonLinear/=NonLinear_None) to CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens)
                    if(CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens)&
                        call MatterPowerdata_MakeNonlinear(PK_Data)

                    outpower(:,in,1) = exp(PK_data%matpower(:,1))
                    call MatterPowerdata_Free(PK_Data)
                end do
                columns = ['P   ', 'P_vd','P_vv']
                unit = open_file_header(FileNames(itf), 'k/h', columns(:ncol), 15)
                do i=1,points
                    write (unit, '(*(E15.5))') MTrans%TransferData(Transfer_kh,i,1),outpower(i,1:CP%InitPower%nn,:)
                end do
                close(unit)
            else
                minkh = 1e-4
                dlnkh = 0.02
                points = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/dlnkh+1
                !             dlnkh = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/(points-0.999)
                allocate(outpower(points,CP%InitPower%nn,1))
                do in = 1, CP%InitPower%nn
                    call Transfer_GetMatterPowerS(MTrans,outpower(1,in,1), itf, in, minkh,dlnkh, points)
                end do

                columns(1) = 'P'
                unit = open_file_header(FileNames(itf), 'k/h', columns(:1), 15)

                do i=1,points
                    write (unit, '(*(E15.5))') minkh*exp((i-1)*dlnkh),outpower(i,1:CP%InitPower%nn,1)
                end do
                close(unit)
            end if

            deallocate(outpower)
        end if
    end do

    end subroutine Transfer_SaveMatterPower

    !JD 08/13 New function for nonlinear lensing of CMB + MPK compatibility
    !Build master redshift array from array of desired Nonlinear lensing (NLL)
    !redshifts and an array of desired Power spectrum (PK) redshifts.
    !At the same time fill arrays for NLL and PK that indicate indices
    !of their desired redshifts in the master redshift array.
    !Finally define number of redshifts in master array. This is usually given by:
    !P%num_redshifts = P%PK_num_redshifts + P%NLL_num_redshifts - 1.  The -1 comes
    !from the fact that z=0 is in both arrays (when non-linear is on)
    subroutine Transfer_SortAndIndexRedshifts(P)
    Type(TransferParams) :: P
    integer i, iPK, iNLL
    real(dl), parameter :: tol = 1.d-5

    i=0
    iPK=1
    iNLL=1
    do while (iPk<=P%PK_num_redshifts .or. iNLL<=P%NLL_num_redshifts)
        !JD write the next line like this to account for roundoff issues with ==. Preference given to PK_Redshift
        i=i+1
        if (i > max_transfer_redshifts) &
            call Mpistop('Transfer_SortAndIndexRedshifts: Too many redshifts')

        if(iNLL>P%NLL_num_redshifts .or. P%PK_redshifts(iPK)>P%NLL_redshifts(iNLL)+tol) then
            P%redshifts(i)=P%PK_redshifts(iPK)
            P%PK_redshifts_index(iPK)=i
            iPK=iPK+1
        else if(iPK>P%PK_num_redshifts .or. P%NLL_redshifts(iNLL)>P%PK_redshifts(iPK)+tol) then
            P%redshifts(i)=P%NLL_redshifts(iNLL)
            P%NLL_redshifts_index(iNLL)=i
            iNLL=iNLL+1
        else
            P%redshifts(i)=P%PK_redshifts(iPK)
            P%PK_redshifts_index(iPK)=i
            P%NLL_redshifts_index(iNLL)=i
            iPK=iPK+1
            iNLL=iNLL+1
        end if
    end do
    P%num_redshifts=i

    end subroutine Transfer_SortAndIndexRedshifts

    end module Transfer


    !ccccccccccccccccccccccccccccccccccccccccccccccccccc

    module ThermoData
    use ModelData
    implicit none
    private
    integer,parameter :: nthermo=20000

    real(dl) tb(nthermo),cs2(nthermo),xe(nthermo)
    real(dl) dcs2(nthermo)
    real(dl) dotmu(nthermo), ddotmu(nthermo)
    real(dl) sdotmu(nthermo),emmu(nthermo)
    real(dl) demmu(nthermo)
    real(dl) dddotmu(nthermo),ddddotmu(nthermo)
    real(dl) winlens(nthermo),dwinlens(nthermo), scalefactor(nthermo)
    real(dl) tauminn,dlntau,Maxtau
    logical, parameter :: dowinlens = .false.

    real(dl) :: tight_tau, actual_opt_depth
    !Times when 1/(opacity*tau) = 0.01, for use switching tight coupling approximation
    real(dl) :: matter_verydom_tau
    real(dl) :: r_drag0, z_star, z_drag  !!JH for updated BAO likelihood.

    public thermo,inithermo, tight_tau, IonizationFunctionsAtTime, &
        Thermo_OpacityToTime,matter_verydom_tau, ThermoData_Free,&
        z_star, z_drag, GetBackgroundEvolution
    contains

    subroutine thermo(tau,cs2b,opacity, dopacity)
    !Compute unperturbed sound speed squared,
    !and ionization fraction by interpolating pre-computed tables.
    !If requested also get time derivative of opacity
    implicit none
    real(dl) tau,cs2b,opacity
    real(dl), intent(out), optional :: dopacity

    integer i
    real(dl) d

    d=log(tau/tauminn)/dlntau+1._dl
    i=int(d)
    d=d-i
    if (i < 1) then
        !Linear interpolation if out of bounds (should not occur).
        cs2b=cs2(1)+(d+i-1)*dcs2(1)
        opacity=dotmu(1)+(d-1)*ddotmu(1)
        call MpiStop('thermo out of bounds')
    else if (i >= nthermo) then
        cs2b=cs2(nthermo)+(d+i-nthermo)*dcs2(nthermo)
        opacity=dotmu(nthermo)+(d-nthermo)*ddotmu(nthermo)
        if (present(dopacity)) then
            dopacity = 0
            call MpiStop('thermo: shouldn''t happen')
        end if
    else
        !Cubic spline interpolation.
        cs2b=cs2(i)+d*(dcs2(i)+d*(3*(cs2(i+1)-cs2(i))  &
            -2*dcs2(i)-dcs2(i+1)+d*(dcs2(i)+dcs2(i+1)  &
            +2*(cs2(i)-cs2(i+1)))))
        opacity=dotmu(i)+d*(ddotmu(i)+d*(3*(dotmu(i+1)-dotmu(i)) &
            -2*ddotmu(i)-ddotmu(i+1)+d*(ddotmu(i)+ddotmu(i+1) &
            +2*(dotmu(i)-dotmu(i+1)))))

        if (present(dopacity)) then
            dopacity=(ddotmu(i)+d*(dddotmu(i)+d*(3*(ddotmu(i+1)  &
                -ddotmu(i))-2*dddotmu(i)-dddotmu(i+1)+d*(dddotmu(i) &
                +dddotmu(i+1)+2*(ddotmu(i)-ddotmu(i+1))))))/(tau*dlntau)
        end if
    end if
    end subroutine thermo


    function Thermo_OpacityToTime(opacity)
    real(dl), intent(in) :: opacity
    integer j
    real(dl) Thermo_OpacityToTime
    !Do this the bad slow way for now..
    !The answer is approximate
    j =1
    do while(dotmu(j)> opacity)
        j=j+1
    end do

    Thermo_OpacityToTime = exp((j-1)*dlntau)*tauminn

    end function Thermo_OpacityToTime

    subroutine inithermo(taumin,taumax)
    !  Compute and save unperturbed baryon temperature and ionization fraction
    !  as a function of time.  With nthermo=10000, xe(tau) has a relative
    ! accuracy (numerical integration precision) better than 1.e-5.
    use constants
    use precision
    use ModelParams
    use MassiveNu
    real(dl) taumin,taumax


    real(dl) tau01,adot0,a0,a02,x1,x2,barssc,dtau
    real(dl) xe0,tau,a,a2
    real(dl) adot,tg0,ahalf,adothalf,fe,thomc,thomc0,etc,a2t
    real(dl) dtbdla,vfi,cf1,maxvis, vis
    integer ncount,i,j1,j2,iv,ns
    real(dl) spline_data(nthermo)
    real(dl) last_dotmu
    real(dl) dtauda  !diff of tau w.CP%r.t a and integration
    external dtauda
    real(dl) a_verydom
    real(dl) awin_lens1p,awin_lens2p,dwing_lens, rs, DA
    real(dl) z_eq, a_eq
    real(dl) rombint
    integer noutput
    external rombint

    call Recombination_Init(CP%Recomb, CP%omegac, CP%omegab,CP%Omegan, CP%Omegav, &
        CP%h0,CP%tcmb,CP%yhe,CP%Num_Nu_massless + CP%Num_Nu_massive)
    !almost all the time spent here
    if (global_error_flag/=0) return
    Maxtau=taumax
    tight_tau = 0
    actual_opt_depth = 0
    ncount=0
    z_star=0.d0
    z_drag=0.d0
    thomc0= Compton_CT * CP%tcmb**4
    r_drag0 = 3.d0/4.d0*CP%omegab*grhom/grhog
    !thomc0=5.0577d-8*CP%tcmb**4

    tauminn=0.05d0*taumin
    dlntau=log(CP%tau0/tauminn)/(nthermo-1)
    last_dotmu = 0

    matter_verydom_tau = 0
    a_verydom = AccuracyBoost*5*(grhog+grhornomass)/(grhoc+grhob)

    !  Initial conditions: assume radiation-dominated universe.
    tau01=tauminn
    adot0=adotrad
    a0=adotrad*tauminn
    a02=a0*a0
    !  Assume that any entropy generation occurs before tauminn.
    !  This gives wrong temperature before pair annihilation, but
    !  the error is harmless.
    tb(1)=CP%tcmb/a0
    xe0=1._dl
    x1=0._dl
    x2=1._dl
    xe(1)=xe0+0.25d0*CP%yhe/(1._dl-CP%yhe)*(x1+2*x2)
    barssc=barssc0*(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*xe(1))
    cs2(1)=4._dl/3._dl*barssc*tb(1)
    dotmu(1)=xe(1)*akthom/a02
    sdotmu(1)=0

    do i=2,nthermo
        tau=tauminn*exp((i-1)*dlntau)
        dtau=tau-tau01
        !  Integrate Friedmann equation using inverse trapezoidal rule.

        a=a0+adot0*dtau
        scaleFactor(i)=a
        a2=a*a

        adot=1/dtauda(a)

        if (matter_verydom_tau ==0 .and. a > a_verydom) then
            matter_verydom_tau = tau
        end if

        a=a0+2._dl*dtau/(1._dl/adot0+1._dl/adot)
        !  Baryon temperature evolution: adiabatic except for Thomson cooling.
        !  Use  quadrature solution.
        ! This is redundant as also calculated in REFCAST, but agrees well before reionization
        tg0=CP%tcmb/a0
        ahalf=0.5d0*(a0+a)
        adothalf=0.5d0*(adot0+adot)
        !  fe=number of free electrons divided by total number of free baryon
        !  particles (e+p+H+He).  Evaluate at timstep i-1 for convenience; if
        !  more accuracy is required (unlikely) then this can be iterated with
        !  the solution of the ionization equation.
        fe=(1._dl-CP%yhe)*xe(i-1)/(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*xe(i-1))
        thomc=thomc0*fe/adothalf/ahalf**3
        etc=exp(-thomc*(a-a0))
        a2t=a0*a0*(tb(i-1)-tg0)*etc-CP%tcmb/thomc*(1._dl-etc)
        tb(i)=CP%tcmb/a+a2t/(a*a)

        ! If there is re-ionization, smoothly increase xe to the
        ! requested value.
        if (CP%Reion%Reionization .and. tau > CP%ReionHist%tau_start) then
            if(ncount == 0) then
                ncount=i-1
            end if
            xe(i) = Reionization_xe(a, tau, xe(ncount))
            !print *,1/a-1,xe(i)
            if (CP%AccurateReionization .and. CP%DerivedParameters) then
                dotmu(i)=(Recombination_xe(a) - xe(i))*akthom/a2

                if (last_dotmu /=0) then
                    actual_opt_depth = actual_opt_depth - 2._dl*dtau/(1._dl/dotmu(i)+1._dl/last_dotmu)
                end if
                last_dotmu = dotmu(i)
            end if
        else
            xe(i)=Recombination_xe(a)
        end if

        !  Baryon sound speed squared (over c**2).
        dtbdla=-2._dl*tb(i)-thomc*adothalf/adot*(a*tb(i)-CP%tcmb)
        barssc=barssc0*(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*xe(i))
        cs2(i)=barssc*tb(i)*(1-dtbdla/tb(i)/3._dl)


        ! Calculation of the visibility function
        dotmu(i)=xe(i)*akthom/a2

        if (tight_tau==0 .and. 1/(tau*dotmu(i)) > 0.005) tight_tau = tau !0.005
        !Tight coupling switch time when k/opacity is smaller than 1/(tau*opacity)

        if (tau < 0.001) then
            sdotmu(i)=0
        else
            sdotmu(i)=sdotmu(i-1)+2._dl*dtau/(1._dl/dotmu(i)+1._dl/dotmu(i-1))
        end if

        a0=a
        tau01=tau
        adot0=adot
    end do !i

    if (CP%Reion%Reionization .and. (xe(nthermo) < 0.999d0)) then
        write(*,*)'Warning: xe at redshift zero is < 1'
        write(*,*) 'Check input parameters and Reionization_xe'
        write(*,*) 'function in the Reionization module'
    end if

    do j1=1,nthermo
        if (sdotmu(j1) - sdotmu(nthermo)< -69) then
            emmu(j1)=1.d-30
        else
            emmu(j1)=exp(sdotmu(j1)-sdotmu(nthermo))
            if (.not. CP%AccurateReionization .and. &
                actual_opt_depth==0 .and. xe(j1) < 1e-3) then
            actual_opt_depth = -sdotmu(j1)+sdotmu(nthermo)
            end if
            if (CP%AccurateReionization .and. CP%DerivedParameters .and. z_star==0.d0) then
                if (sdotmu(nthermo)-sdotmu(j1) - actual_opt_depth < 1) then
                    tau01=1-(sdotmu(nthermo)-sdotmu(j1) - actual_opt_depth)
                    tau01=tau01*(1._dl/dotmu(j1)+1._dl/dotmu(j1-1))/2
                    z_star = 1/(scaleFactor(j1)- tau01/dtauda(scaleFactor(j1))) -1
                end if
            end if
        end if
    end do

    if (CP%AccurateReionization .and. FeedbackLevel > 0 .and. CP%DerivedParameters) then
        write(*,'("Reion opt depth      = ",f7.4)') actual_opt_depth
    end if


    iv=0
    vfi=0._dl
    ! Getting the starting and finishing times for decoupling and time of maximum visibility
    if (ncount == 0) then
        cf1=1._dl
        ns=nthermo
    else
        cf1=exp(sdotmu(nthermo)-sdotmu(ncount))
        ns=ncount
    end if
    maxvis = 0
    do j1=1,ns
        vis = emmu(j1)*dotmu(j1)
        tau = tauminn*exp((j1-1)*dlntau)
        vfi=vfi+vis*cf1*dlntau*tau
        if ((iv == 0).and.(vfi > 1.0d-7/AccuracyBoost)) then
            taurst=9._dl/10._dl*tau
            iv=1
        elseif (iv == 1) then
            if (vis > maxvis) then
                maxvis=vis
                tau_maxvis = tau
            end if
            if (vfi > 0.995) then
                taurend=tau
                iv=2
                exit
            end if
        end if
    end do

    if (iv /= 2) then
        call GlobalError('inithermo: failed to find end of recombination',error_reionization)
        return
    end if

    if (dowinlens) then
        vfi=0
        awin_lens1p=0
        awin_lens2p=0
        winlens=0
        do j1=1,nthermo-1
            vis = emmu(j1)*dotmu(j1)
            tau = tauminn*exp((j1-1)*dlntau)
            vfi=vfi+vis*cf1*dlntau*tau
            if (vfi < 0.995) then
                dwing_lens =  vis*cf1*dlntau*tau / 0.995

                awin_lens1p = awin_lens1p + dwing_lens
                awin_lens2p = awin_lens2p + dwing_lens/(CP%tau0-tau)
            end if
            winlens(j1)= awin_lens1p/(CP%tau0-tau) - awin_lens2p
        end do
    end if

    ! Calculating the timesteps during recombination.

    if (CP%WantTensors) then
        dtaurec=min(dtaurec,taurst/160)/AccuracyBoost
    else
        dtaurec=min(dtaurec,taurst/40)/AccuracyBoost
        if (do_bispectrum .and. hard_bispectrum) dtaurec = dtaurec / 4
    end if

    if (CP%Reion%Reionization) taurend=min(taurend,CP%ReionHist%tau_start)

    if (DebugMsgs) then
        write (*,*) 'taurst, taurend = ', taurst, taurend
    end if

    call splini(spline_data,nthermo)
    call splder(cs2,dcs2,nthermo,spline_data)
    call splder(dotmu,ddotmu,nthermo,spline_data)
    call splder(ddotmu,dddotmu,nthermo,spline_data)
    call splder(dddotmu,ddddotmu,nthermo,spline_data)
    call splder(emmu,demmu,nthermo,spline_data)
    if (dowinlens) call splder(winlens,dwinlens,nthermo,spline_data)

    call SetTimeSteps

    if ((CP%want_zstar .or. CP%DerivedParameters) .and. z_star==0.d0) call find_z(optdepth,z_star)
    if (CP%want_zdrag .or. CP%DerivedParameters) call find_z(dragoptdepth,z_drag)

    if (CP%DerivedParameters) then
        rs =rombint(dsound_da_exact,1d-8,1/(z_star+1),1d-6)
        DA = AngularDiameterDistance(z_star)/(1/(z_star+1))

        ThermoDerivedParams( derived_Age ) = DeltaPhysicalTimeGyr(0.0_dl,1.0_dl)
        ThermoDerivedParams( derived_zstar ) = z_star
        ThermoDerivedParams( derived_rstar ) = rs
        ThermoDerivedParams( derived_thetastar ) = 100*rs/DA
        ThermoDerivedParams( derived_DAstar ) = DA/1000
        ThermoDerivedParams( derived_zdrag ) = z_drag
        rs =rombint(dsound_da_exact,1d-8,1/(z_drag+1),1d-6)
        ThermoDerivedParams( derived_rdrag ) = rs
        ThermoDerivedParams( derived_kD ) =  sqrt(1.d0/(rombint(ddamping_da, 1d-8, 1/(z_star+1), 1d-6)/6))
        ThermoDerivedParams( derived_thetaD ) =  100*pi/ThermoDerivedParams( derived_kD )/DA
        z_eq = (grhob+grhoc)/(grhog+grhornomass+sum(grhormass(1:CP%Nu_mass_eigenstates))) -1
        ThermoDerivedParams( derived_zEQ ) = z_eq
        a_eq = 1/(1+z_eq)
        ThermoDerivedParams( derived_kEQ ) = 1/(a_eq*dtauda(a_eq))
        ThermoDerivedParams( derived_thetaEQ ) = 100*timeOfz(z_eq)/DA
        ThermoDerivedParams( derived_theta_rs_EQ ) = 100*rombint(dsound_da_exact,1d-8,a_eq,1d-6)/DA

        if (associated(BackgroundOutputs%z_outputs)) then
            if (allocated(BackgroundOutputs%H)) &
                deallocate(BackgroundOutputs%H, BackgroundOutputs%DA, BackgroundOutputs%rs_by_D_v)
            noutput = size(BackgroundOutputs%z_outputs)
            allocate(BackgroundOutputs%H(noutput), BackgroundOutputs%DA(noutput), BackgroundOutputs%rs_by_D_v(noutput))
            do i=1,noutput
                BackgroundOutputs%H(i) = HofZ(BackgroundOutputs%z_outputs(i))
                BackgroundOutputs%DA(i) = AngularDiameterDistance(BackgroundOutputs%z_outputs(i))
                BackgroundOutputs%rs_by_D_v(i) = rs/BAO_D_v_from_DA_H(BackgroundOutputs%z_outputs(i), &
                    BackgroundOutputs%DA(i),BackgroundOutputs%H(i))
            end do
        end if

        if (FeedbackLevel > 0) then
            write(*,'("Age of universe/GYr  = ",f7.3)') ThermoDerivedParams( derived_Age )
            write(*,'("zstar                = ",f8.2)') ThermoDerivedParams( derived_zstar )
            write(*,'("r_s(zstar)/Mpc       = ",f7.2)') ThermoDerivedParams( derived_rstar )
            write(*,'("100*theta            = ",f9.6)') ThermoDerivedParams( derived_thetastar )
            write(*,'("DA(zstar)/Gpc        = ",f9.5)') ThermoDerivedParams( derived_DAstar )

            write(*,'("zdrag                = ",f8.2)') ThermoDerivedParams( derived_zdrag )
            write(*,'("r_s(zdrag)/Mpc       = ",f7.2)') ThermoDerivedParams( derived_rdrag )

            write(*,'("k_D(zstar) Mpc       = ",f7.4)') ThermoDerivedParams( derived_kD )
            write(*,'("100*theta_D          = ",f9.6)') ThermoDerivedParams( derived_thetaD )

            write(*,'("z_EQ (if v_nu=1)     = ",f8.2)') ThermoDerivedParams( derived_zEQ )
            write(*,'("k_EQ Mpc (if v_nu=1) = ",f9.6)') ThermoDerivedParams( derived_kEQ )
            write(*,'("100*theta_EQ         = ",f9.6)') ThermoDerivedParams( derived_thetaEQ )
            write(*,'("100*theta_rs_EQ      = ",f9.6)') ThermoDerivedParams( derived_theta_rs_EQ )

        end if
    end if

    end subroutine inithermo


    subroutine SetTimeSteps
    real(dl) dtau0
    integer nri0, nstep

    call Ranges_Init(TimeSteps)

    call Ranges_Add_delta(TimeSteps, taurst, taurend, dtaurec)

    ! Calculating the timesteps after recombination
    if (CP%WantTensors) then
        dtau0=max(taurst/40,Maxtau/2000._dl/AccuracyBoost)
    else
        dtau0=Maxtau/500._dl/AccuracyBoost
        if (do_bispectrum) dtau0 = dtau0/3
        !Don't need this since adding in Limber on small scales
        !  if (CP%DoLensing) dtau0=dtau0/2
        !  if (CP%AccurateBB) dtau0=dtau0/3 !Need to get C_Phi accurate on small scales
    end if

    call Ranges_Add_delta(TimeSteps,taurend, CP%tau0, dtau0)

    if (CP%Reion%Reionization) then
        nri0=int(Reionization_timesteps(CP%ReionHist)*AccuracyBoost)
        !Steps while reionization going from zero to maximum
        call Ranges_Add(TimeSteps,CP%ReionHist%tau_start,CP%ReionHist%tau_complete,nri0)
    end if

    !Create arrays out of the region information.
    call Ranges_GetArray(TimeSteps)
    nstep = TimeSteps%npoints

    if (DebugMsgs .and. FeedbackLevel > 0) write(*,*) 'Set ',nstep, ' time steps'

    end subroutine SetTimeSteps


    subroutine ThermoData_Free

    call Ranges_Free(TimeSteps)

    end subroutine ThermoData_Free


    subroutine IonizationFunctionsAtTime(tau, opac, dopac, ddopac, &
        vis, dvis, ddvis, expmmu, lenswin)
    real(dl), intent(in) :: tau
    real(dl), intent(out):: opac, dopac, ddopac, vis, dvis, ddvis, expmmu, lenswin
    real(dl) d
    integer i

    d=log(tau/tauminn)/dlntau+1._dl
    i=int(d)
    d=d-i

    if (i < nthermo) then
        opac=dotmu(i)+d*(ddotmu(i)+d*(3._dl*(dotmu(i+1)-dotmu(i)) &
            -2._dl*ddotmu(i)-ddotmu(i+1)+d*(ddotmu(i)+ddotmu(i+1) &
            +2._dl*(dotmu(i)-dotmu(i+1)))))
        dopac=(ddotmu(i)+d*(dddotmu(i)+d*(3._dl*(ddotmu(i+1)  &
            -ddotmu(i))-2._dl*dddotmu(i)-dddotmu(i+1)+d*(dddotmu(i) &
            +dddotmu(i+1)+2._dl*(ddotmu(i)-ddotmu(i+1))))))/(tau &
            *dlntau)
        ddopac=(dddotmu(i)+d*(ddddotmu(i)+d*(3._dl*(dddotmu(i+1) &
            -dddotmu(i))-2._dl*ddddotmu(i)-ddddotmu(i+1)  &
            +d*(ddddotmu(i)+ddddotmu(i+1)+2._dl*(dddotmu(i) &
            -dddotmu(i+1)))))-(dlntau**2)*tau*dopac) &
            /(tau*dlntau)**2
        expmmu=emmu(i)+d*(demmu(i)+d*(3._dl*(emmu(i+1)-emmu(i)) &
            -2._dl*demmu(i)-demmu(i+1)+d*(demmu(i)+demmu(i+1) &
            +2._dl*(emmu(i)-emmu(i+1)))))

        if (dowinlens) then
            lenswin=winlens(i)+d*(dwinlens(i)+d*(3._dl*(winlens(i+1)-winlens(i)) &
                -2._dl*dwinlens(i)-dwinlens(i+1)+d*(dwinlens(i)+dwinlens(i+1) &
                +2._dl*(winlens(i)-winlens(i+1)))))
        end if
        vis=opac*expmmu
        dvis=expmmu*(opac**2+dopac)
        ddvis=expmmu*(opac**3+3*opac*dopac+ddopac)
    else
        opac=dotmu(nthermo)
        dopac=ddotmu(nthermo)
        ddopac=dddotmu(nthermo)
        expmmu=emmu(nthermo)
        vis=opac*expmmu
        dvis=expmmu*(opac**2+dopac)
        ddvis=expmmu*(opac**3+3._dl*opac*dopac+ddopac)
    end if

    end subroutine IonizationFunctionsAtTime


    function ddamping_da(a)
    real(dl) :: ddamping_da
    real(dl), intent(in) :: a
    real(dl) :: R
    real(dl) :: dtauda
    external dtauda

    R=r_drag0*a
    !ignoring reionisation, not relevant for distance measures
    ddamping_da = (R**2 + 16*(1+R)/15)/(1+R)**2*dtauda(a)*a**2/(Recombination_xe(a)*akthom)

    end function ddamping_da


    !!!!!!!!!!!!!!!!!!!
    !JH: functions and subroutines for calculating z_star and z_drag

    function doptdepth_dz(z)
    real(dl) :: doptdepth_dz
    real(dl), intent(in) :: z
    real(dl) :: a
    real(dl) :: dtauda
    external dtauda

    a = 1._dl/(1._dl+z)

    !ignoring reionisation, not relevant for distance measures
    doptdepth_dz = Recombination_xe(a)*akthom*dtauda(a)

    end function doptdepth_dz

    function optdepth(z)
    real(dl) :: rombint2
    external rombint2
    real(dl) optdepth
    real(dl),intent(in) :: z

    optdepth = rombint2(doptdepth_dz, 0.d0, z, 1d-5, 20, 100)

    end function optdepth


    function ddragoptdepth_dz(z)
    real(dl) :: ddragoptdepth_dz
    real(dl), intent(in) :: z
    real(dl) :: a
    real(dl) :: dtauda
    external dtauda

    a = 1._dl/(1._dl+z)
    ddragoptdepth_dz = doptdepth_dz(z)/r_drag0/a

    end function ddragoptdepth_dz


    function dragoptdepth(z)
    real(dl) :: rombint2
    external rombint2
    real(dl) dragoptdepth
    real(dl),intent(in) :: z

    dragoptdepth =  rombint2(ddragoptdepth_dz, 0.d0, z, 1d-5, 20, 100)

    end function dragoptdepth


    subroutine find_z(func,zout)  !find redshift at which (photon/drag) optical depth = 1
    real(dl), external :: func
    real(dl), intent(out) :: zout
    real(dl) :: try1,try2,diff,avg
    integer :: i

    try1 = 0.d0
    try2 = 10000.d0

    i=0
    diff = 10.d0
    do while (diff .gt. 1d-3)
        i=i+1
        if (i .eq. 100) then
            call GlobalError('optical depth redshift finder did not converge',error_reionization)
            zout=0
            return
        end if

        diff = func(try2)-func(try1)
        avg = 0.5d0*(try2+try1)
        if (func(avg) .gt. 1.d0) then
            try2 = avg
        else
            try1 = avg
        end if
    end do

    zout = avg

    end subroutine find_z

    !!!!!!!!!!!!!!!!!!! end JH

    subroutine GetBackgroundEvolution(ntimes, times, outputs)
    integer, intent(in) :: ntimes
    real(dl), intent(in) :: times(ntimes)
    real(dl) :: outputs(4, ntimes)
    real(dl) spline_data(nthermo), ddxe(nthermo)
    real(dl) :: d, tau, cs2b, opacity, vis
    integer i, ix

    call splini(spline_data,nthermo)
    call splder(xe,ddxe,nthermo,spline_data)
    outputs = 0
    do ix = 1, ntimes
        tau = times(ix)
        if (tau < tauminn) cycle
        d=log(tau/tauminn)/dlntau+1._dl
        i=int(d)
        d=d-i
        call thermo(tau,cs2b, opacity)

        if (i < nthermo) then
            outputs(1,ix)=xe(i)+d*(ddxe(i)+d*(3._dl*(xe(i+1)-xe(i)) &
                -2._dl*ddxe(i)-ddxe(i+1)+d*(ddxe(i)+ddxe(i+1) &
                +2._dl*(xe(i)-xe(i+1)))))
            vis=emmu(i)+d*(demmu(i)+d*(3._dl*(emmu(i+1)-emmu(i)) &
                -2._dl*demmu(i)-demmu(i+1)+d*(demmu(i)+demmu(i+1) &
                +2._dl*(emmu(i)-emmu(i+1)))))

        else
            outputs(1,ix)=xe(nthermo)
            vis = emmu(nthermo)
        end if

        outputs(2, ix) = opacity
        outputs(3, ix) = opacity*vis
        outputs(4, ix) = cs2b
    end do

    end subroutine GetBackgroundEvolution

    end module ThermoData

    module RangesTests
    use RangeUtils
    implicit none
    contains


    function RunRangesTests() result (fails)
    integer fails
    Type(TRanges) R
    double precision, allocatable :: tmp(:)
    double precision, pointer :: P(:)

    fails = 0
    !Combine set of ranges with specified approx maximum spacing in each
    call R%Add(1.d0,5.d0,4) !1, 2,3, 4, 5
    call R%Add_delta(0.5d0, 2.d0,0.5d0)
    call R%Add_delta(2.d0, 4.d0, 1.1d0) !Should be ignored as wider spacing
    call R%GetArray()
    if (any(R%points /= [0.5d0, 1.d0, 1.5d0, 2.d0, 3.d0, 4.d0, 5.d0])) then
        fails = fails + 1
        print *, 'Error in Ranges', R%Points
    end if
    !Check very close points merged
    call R%Add_delta(1.39999d0, 1.800001d0, 0.1d0)
    call R%GetArray()
    if (any(R%points==1.5d0)) then
        fails=fails+1
        print *, 'Error in ranges merge', R%points
    end if
    call R%Free()
    call R%Add(1d-3, 10.d0, 4, isLog=.true.)
    call R%Add_delta(-2.d0, 3.d0, 1.d0)
    call R%GetArray()
    if (R%Points(1)/=-2.d0 .or. abs(R%Points(4)-1d-2)>1d-10) then
        fails = fails + 1
        print *, 'Error in neg range', R%Points
    end if
    call R%Free()
    call R%Add(1d-3, 10.d0, 4, isLog=.true.)
    call R%Add_delta(1.d0, 15.d0, 1.d0)
    call R%GetArray()
    if (abs(R%points(5)-2.d0) > 1d-10 .or. abs(R%Points(2)-0.01d0)>1d-10) then
        fails = fails + 1
        print *, 'Error in log range', R%Points
    end if
    !Test ordering invariance (not generally true, but is here)
    call R%Free()
    call R%Add(1d-3, 10.d0, 4, isLog=.true.)
    call R%Add_delta(0.d0, 3.d0, 1.d0)
    call R%GetArray()
    allocate(tmp, source = R%Points)
    call R%Free()
    call R%Add_delta(0.d0, 3.d0, 1.d0)
    call R%Add(1d-3, 10.d0, 4, isLog=.true.)
    call R%GetArray()
    if (size(tmp) /= size(R%Points)) then
        fails = fails + 1
        print *, 'Error in size on range add ordering'
        print *, 'arr 1', tmp
        print *, 'arr 2 ', R%Points
    elseif (any(abs(tmp-R%points)>1d-7)) then
        fails = fails + 1
        print *, 'Error in range add ordering'
        print *, 'arr 1', tmp
        print *, 'arr 2 ', R%Points
    end if

    call R%Free()
    call R%Add_delta(1.d0, 5.d0, 1.d0)
    call R%Add(1d-3, 4.d0, 4, isLog=.true.)
    call R%GetArray()
    if (abs(R%points(5)-1)>1d-10) then
        fails = fails + 1
        print *, 'error in log left of linear'
        print *, R%points
    end if
    deallocate(tmp)
    allocate(tmp, source = R%Array())
    call R%Free()
    call R%Add(1d-3, 4.d0, 4, isLog=.true.)
    call R%Add_delta(1.d0, 5.d0, 1.d0)
    if (any(abs(R%Array() - tmp)>1d-10)) then
        fails = fails + 1
        print *, 'error in linear right of log'
        print *, R%points
    end if
    call R%Free()
    call R%Add(1d-3, 4.d0, 4, isLog=.true.)
    call R%Add_delta(3.d0, 7.d0, 1.d0)
    call R%Add_delta(2.d0, 4.3d0, 0.1d0)
    P => R%Array()
    if (abs(P(size(P)-1)-6.1d0)>1d-10) then
        fails = fails + 1
        print *, 'error in intersecting arrays'
        print *, R%Array()
    end if

    if (fails==0) print *, 'Ranges OK'
    end function

    end module

    !First version AL October 2010

    !Calculates local fnl and CMB lensing bispectra
    !CMB lensing bispectra are calculated in the approximation in which the first-order
    !result is used replacing the unlensed with the lensing power spectra
    !This is non-perturbatively correct to about 1%
    !Note the lensing bispectrum only includes the linear potentials, no Rees-Sciama or SZ
    !See Lewis, Challinor & Hanson 2010 for details

    !Note that the primordial local bispectra are unlensed (see arXiv: 0905.4732)

    !Compile with LAPACK and -DFISHER if you want to get the fisher matrix outputs
    !This is disabled by default in order not to require LAPACK

    !Fisher results are with and without the cosmic variance from low L_1

    module Bispectrum
    use results
    use InitialPower
    use SpherBessels
    use constants
    use MpiUtils
    use splines
    implicit none

    integer, parameter :: max_bispectrum_deltas = 5, max_bispectrum_fields=3

    Type TBispectrumParams
        logical do_lensing_bispectrum
        logical do_primordial_bispectrum
        integer nfields
        integer Slice_Base_L, ndelta, deltas(max_bispectrum_deltas)
        logical do_parity_odd
        logical DoFisher
        logical export_alpha_beta
        real(dl) FisherNoise, FisherNoisePol, FisherNoiseFwhmArcmin
        character(LEN=Ini_max_string_len)  FullOutputFile
        logical SparseFullOutput
    end Type

    !global parameter for now, only intend for this module to be used interactively for the moment
    Type(TBispectrumParams)  :: BispectrumParams

    Type TBispectrum
        real(dl), pointer :: b(:,:)
    end Type
    Type TCov
        real(dl), pointer :: C(:,:)
    end type TCov

    Type TCov2
        real(dl) :: C(2,2)
    end type TCov2

    Type TCov3
        real(dl) :: C(3,3)
    end type TCov3

    real(dl), allocatable :: dJl(:,:), dddJl(:,:)
    real(dl), parameter :: InternalScale = 1d10
    character(LEN=1024) :: output_root =''
    integer, parameter :: shape_local = 1, shape_warm = 2, shape_warm2 = 3
    integer, parameter :: shape = shape_local

    real(dl), allocatable :: TransferPolFac(:)      !sqrt((l+2)!/(l-2)!)
    contains

    subroutine InitBesselDerivs(CTrans)
    ! j_l' array for interpolation if needed; not needed for local fnl
    Type(ClTransferData) :: CTrans
    integer i,l1,j
    real(dl) Jm, Jp

    if (allocated(dJl)) then
        deallocate(dJL, dddJl)
    end if
    allocate(dJl(BessRanges%npoints,CTrans%ls%nl),dddJl(BessRanges%npoints,CTrans%ls%nl))

    do i=1, CTrans%ls%nl
        !Spline agrees well
        !  call spline_deriv(BessRanges%points,ajl(1,i),ajlpr(1,i),dJl(1,i),BessRanges%npoints)
        !  call spline_def(BessRanges%points,dJl(1,i),BessRanges%npoints,dddJl(1,i))

        l1 = CTrans%ls%l(i)
        do j=1, BessRanges%npoints
            call BJL(l1-1,BessRanges%points(j),Jm)
            call BJL(l1+1,BessRanges%points(j),Jp)
            dJl(j,i)=  ( l1*Jm - (l1+1)*Jp)/(2*l1+1)
        end do
        call spline_def(BessRanges%points,dJl(:,i),BessRanges%npoints,dddJl(:,i))

    end do

    end subroutine InitBesselDerivs

    subroutine NonGauss_l_r_localOpt(CP,CTrans, ind, indP, res, resP, nfields, r)
    !functions of the form int dk k^2 k^i j_l(kr) Delta_l(k) [P]
    !ind and indP are arrays of required k^i powers
    !res and resP are the results without and with the power spectrum P in the integrand
    Class(CAMBPArams) :: CP
    Type(ClTransferData) :: CTrans
    integer, intent(in) :: ind(:), indP(:)
    integer :: nfields
    real(dl) res(CTrans%ls%nl,size(ind),nfields), resP(CTrans%ls%nl,size(indP),nfields)
    real(dl), intent(in) :: r
    integer q_ix, j, bes_ix
    integer n, nP, ellmax
    real(dl) xf , J_l, fac, a2, k, dlnk, term, P, kpow, kpowP

    n = size(ind)
    nP =size(indP)
    res=0
    resP = 0
    do q_ix = 1, CTrans%q%npoints
        k = CTrans%q%points(q_ix)
        xf = k*r
        bes_ix=BessRanges%IndexOf(xf)
        fac=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
        a2=(BessRanges%points(bes_ix+1)-xf)/fac
        fac=fac**2*a2/6
        dlnk = CTrans%q%dpoints(q_ix) /k
        P = CP%InitPower%ScalarPower(k)*InternalScale  !!only first index for now

        ellmax = max(xf/(1-xlimfrac), xf + xlimmin) * CP%Accuracy%AccuracyBoost
        kpow =  k**(ind(1)+3)
        kpowP = k**indP(1) * P
        do j=1,CTrans%ls%nl
            if (CTrans%ls%l(j) <= ellmax) then
                J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                    *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac) !cubic spline
                term = CTrans%Delta_p_l_k(1,j,q_ix)*J_l*dlnk
                res(j,1,1) = res(j,1,1) + term * kpow
                resP(j,1,1) = resP(j,1,1) + term * kpowP
                if (nfields>1) then
                    !E pol
                    term = CTrans%Delta_p_l_k(2,j,q_ix)*J_l*dlnk * TransferPolFac(CTrans%ls%l(j))
                    res(j,1,2) = res(j,1,2) + term * kpow
                    resP(j,1,2) = resP(j,1,2) + term * kpowP
                    if (nfields>2) then
                        !lensing potential
                        term = CTrans%Delta_p_l_k(3,j,q_ix)*J_l*dlnk
                        res(j,1,3) = res(j,1,3) + term * kpow
                        resP(j,1,3) = resP(j,1,3) + term * kpowP
                    end if
                end if

            end if
        end do
    end do
    resP = resP * const_fourpi
    res = res * 2/const_pi

    end subroutine NonGauss_l_r_localOpt

    subroutine NonGauss_l_r(CP,CTrans, ind, indP,res, resP,nfields, r)
    !functions of the form int dk k^2 k^i j_l(kr) Delta_l(k) [P]
    !ind and indP are arrays of required k^i powers
    !res and resP are the results without and with the power spectrum P in the integrand
    !Output of P scaled by 1d10 (so bispectrum by 1d20)
    Class(CAMBParams) :: CP
    Type(ClTransferData) :: CTrans
    integer:: nfields
    integer, intent(in) :: ind(:), indP(:)
    real(dl) res(CTrans%ls%nl,size(ind),nfields), resP(CTrans%ls%nl,size(indP),nfields)
    real(dl), intent(in) :: r
    integer q_ix, j, bes_ix, i
    integer n, nP, ellmax
    real(dl) xf , J_l, fac, a2, k, dlnk, term, P, kpow(size(ind)), kpow2(size(indP))

    if (shape == shape_local) then
        call NonGauss_l_r_localOpt(CP,CTrans, ind, indP,res, resP, nfields, r)
        return
    end if

    n = size(ind)
    nP =size(indP)
    res=0
    resP = 0
    do q_ix = 1, CTrans%q%npoints
        k = CTrans%q%points(q_ix)
        xf = k*r
        bes_ix=BessRanges%IndexOf(xf)
        fac=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
        a2=(BessRanges%points(bes_ix+1)-xf)/fac
        fac=fac**2*a2/6
        dlnk = CTrans%q%dpoints(q_ix) /k
        P = CP%InitPower%ScalarPower(k)*InternalScale  !!only first index for now

        ellmax = max(xf/(1-xlimfrac), xf + xlimmin) * CP%Accuracy%AccuracyBoost
        do i=1,n
            kpow(i)=k**(ind(i)+3)
        end do
        do i=1,nP
            kpow2(i)=k**indP(i) * P
        end do

        do j=1,CTrans%ls%nl
            if (CTrans%ls%l(j) <= ellmax) then

                J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                    *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac) !cubic spline
                !call BJL(CTrans%ls%l(j), xf, J_l)
                term = CTrans%Delta_p_l_k(1,j,q_ix)*J_l*dlnk
                do i=1,n
                    res(j,i,1) = res(j,i,1) + term *kpow(i)
                end do
                do i=1,nP
                    resP(j,i,1) = resP(j,i,1) + term * kpow2(i)
                end do
                !     if (CTrans%ls%l(j)==8) write (1,'(9D20.7)') &
                !      k, xf, real(term * k**3/dlnk), real(term * k**indP(1) * P), &
                !      real(res(j,1)),real(resP(j,1)), J_l, real(term), real(CTrans%Delta_p_l_k(1,j,q_ix))
                if (nfields>1) then
                    !E pol
                    term = CTrans%Delta_p_l_k(2,j,q_ix)*J_l*dlnk* TransferPolFac(CTrans%ls%l(j))
                    do i=1,n
                        res(j,i,2) = res(j,i,2) + term *kpow(i)
                    end do
                    do i=1,nP
                        resP(j,i,2) = resP(j,i,2) + term * kpow2(i)
                    end do
                    if (nfields>2) then
                        !lensing potential
                        term = CTrans%Delta_p_l_k(3,j,q_ix)*J_l*dlnk
                        do i=1,n
                            res(j,i,3) = res(j,i,3) + term *kpow(i)
                        end do
                        do i=1,nP
                            resP(j,i,3) = resP(j,i,3) + term * kpow2(i)
                        end do
                    end if
                end if

            end if
        end do
    end do
    resP = resP * const_fourpi
    res = res * 2/const_pi

    end subroutine NonGauss_l_r


    subroutine GetBispectrum(State,CTrans)
    !Note: may need high maxetak to make sure oscillatory k integrals cancel correctly
    !for accurate alpha(r), beta(r), e.g. 8000; not so important for bispectrum
    !increase accuracy_boost
    use lensing
    use constants
    use RangeUtils
    use FileUtils
    use ArrayUtils
    use MathUtils
#ifdef FISHER
    use MatrixUtils
#endif
    Class(CAMBdata), target :: State
    integer, parameter :: max_bispectra = 2  !fnl, lensing
    Type(ClTransferData) :: CTrans
    type(TRanges) :: TimeStepsNongauss
    integer, allocatable ::  ind(:), indP(:), indPd(:)
    real(dl), allocatable :: res(:,:,:), resP(:,:,:), resPd(:,:)
    real(dl), allocatable :: res_l(:,:,:), resP_l(:,:,:), resPd_l(:,:)
    real(dl) r, term
    Type(TBispectrum), target,allocatable :: Bispectra(:,:,:,:), OddBispectra (:)
    !TTT, TTE, etc; last index is bispectrum kind, default 1=fnl, 2=lensing
    !OddBispectra are parity odd terms like TEB (if do_parity_odd requested for lensing)
    Type(TBispectrum), pointer :: Bispectrum
    !For use in Fisher approximations
    real(dl) test(CTrans%ls%lmin:CTrans%ls%l(CTrans%ls%nl))
    integer i, j, l1,l2,l3, il1, n,np, npd
    integer min_l, max_l, lmin, lmax
    real(dl) tmp, tmp1, tmp2, tmp3
    real(dl) a3j(0:CTrans%ls%l(CTrans%ls%nl)*2+1)
    real(dl) a3j2(0:CTrans%ls%l(CTrans%ls%nl)*2+1,4,2)
    real(dl) CLForLensingIn(4,CTrans%ls%lmin:CTrans%ls%l(CTrans%ls%nl))
    real(dl) CPhi(3,CTrans%ls%lmin:CTrans%ls%l(CTrans%ls%nl))
    Type(lSamples) :: SampleL
    integer, allocatable :: ls(:)
    real(dl) Bscale
    integer field, field1,field2,field3, bi_ix,bix
    Type(TCov2), allocatable :: CForLensing(:)
    integer nfields, nbispectra, bispectrum_type
    integer :: fnl_bispectrum_ix = 1
    integer :: lens_bispectrum_ix = 2
    character(LEN=256) ::  file_tag = ''
    integer idelta, fileid
    character(LEN=26) :: BispectrumNames(max_bispectra)
    integer :: parities(3), oddix
    integer, parameter :: lmax_lensing_corrT = 300
    !assume C^{T\psi} zero above this for CMB lensing; also neglect lensing contributions to variance
    integer, parameter :: lmax_lensing_corrE = 40 !assume C^{E\psi} zero above this for CMB lensing

    integer, parameter :: first_order_unlensed = 1, first_order_lensed = 2
    integer, parameter :: lens_bispectrum_approx = first_order_lensed
#ifdef FISHER
    Type(TBispectrum), pointer :: Bispectrum2
    real(dl) Cl(4,lmin:CTrans%ls%l(CTrans%ls%nl))
    real(dl)  a3j_00(0:CTrans%ls%l(CTrans%ls%nl)*2+1)
    integer lstart
    real(dl) Noise, NoiseP, bias
    real(dl), allocatable:: fish_contribs(:,:,:)
    real(dl) fish_contribs_sig(lmin:CTrans%ls%l(CTrans%ls%nl))
    real(dl), allocatable :: ifish_contribs(:,:,:,:,:), Fisher(:,:), tmpFisher(:,:),OptimalFisher(:,:)
    real(dl), allocatable :: tmpBigFisher(:,:), Fisher_L1(:,:,:),tmpProjFisher(:,:)
    real(dl), allocatable :: fish_l1(:,:,:,:), fish_L_ij(:,:), fish_L_noise(:,:)
    Type(TBispectrum), target,allocatable :: SqueezedLensingKernel(:,:)
    real(dl) sigma2, xlc, tmpf(3)
    integer  f1,f2,f3, minl2,bigi,bigj, bispectrum_type2, lmaxcuti
    integer sz,corrsize
    Type(TCov), allocatable :: InvC(:)
    integer ix1,ix2
    real(dl) tmpArr(lmin:CTrans%ls%l(CTrans%ls%nl))
#endif
    type(TTextFile) :: file_alpha, file_beta, file_alpha_beta_r
    type(TTextFile), allocatable, dimension(:) :: bispectrum_files
    Type(CAMBParams), pointer :: CP
    Type(TTimer) :: Timer

    CP =>State%CP

    parities(1)=1  !T
    parities(2)=1  !E
    parities(3)=-1 !B


    if (BispectrumParams%do_primordial_bispectrum) then
        fnl_bispectrum_ix = 1
        nbispectra=1
        BispectrumNames(fnl_bispectrum_ix)='fnl'
    else
        fnl_bispectrum_ix = 0
        nbispectra=0
    end if
    if (BispectrumParams%do_lensing_bispectrum) then
        lens_bispectrum_ix = fnl_bispectrum_ix+1
        nbispectra=nbispectra+1
        BispectrumNames(lens_bispectrum_ix)='lensing'
    end if
    if (nbispectra>max_bispectra) call MpiStop('check max_bispectra')

    nfields=BispectrumParams%nfields

    if (CP%Accuracy%lSampleBoost <50) call MpiStop('Bispectrum assumes lSampleBoost=50 (all L sampled)')

    if (lens_bispectrum_approx == first_order_unlensed) file_tag='_unlens'

    lmax = CTrans%ls%l(CTrans%ls%nl)
    lmin = CTrans%ls%lmin
    if (CP%DoLensing) lmax = State%CLData%lmax_lensed
    SampleL%lmin=2
    allocate(ls(lmax))
    SampleL%nl=0
    l1=1
    do
        if (l1<=lmax_lensing_corrE) then
            l1 = l1+1
        else if (l1<120) then
            l1 =l1+nint(7/CP%Accuracy%AccuracyBoost)
        else
            l1 =l1+nint(50/CP%Accuracy%AccuracyBoost)
        end if
        if (l1>lmax) then
            l1 =lmax
        end if
        if (BispectrumParams%Slice_Base_L>0 .and. SampleL%nl>0) then
            !Make sure requested slice base is actually calculated
            if ( BispectrumParams%Slice_Base_L <l1 .and. BispectrumParams%Slice_Base_L>ls(SampleL%nl)) then
                SampleL%nl= SampleL%nl + 1
                ls(SampleL%nl) = BispectrumParams%Slice_Base_L
            end if
        end if
        SampleL%nl= SampleL%nl + 1
        ls(SampleL%nl) = l1
        if (l1 == lmax) exit
    end do
    allocate(SampleL%l, source=ls(1:SampleL%nl))

    allocate(Bispectra(nfields,nfields,nfields,nbispectra))
    do field1=1,nfields
        do field2=1,nfields
            do field3=1,nfields
                !Only store l2,l3 that are non-zero, array size is approx
                do bispectrum_type=1,nbispectra
                    allocate(Bispectra(field1,field2,field3,bispectrum_type)%b((lmax*(lmax+1))/4,SampleL%nl))
                    Bispectra(field1,field2,field3,bispectrum_type)%b=0
                end do
            end do
        end do
    end do

    if (BispectrumParams%do_lensing_bispectrum) then

        if (.not. CP%DoLensing) call MpiStop('Must turn on lensing to get lensing bispectra')
        print *,'Getting lensing reduced bispectra'

        allocate(CForLensing(lmax))

        CPhi=0
        do i=lmin,lmax
            CPhi(1,i) = State%CLData%Cl_scalar(i,C_Phi)/real(i,dl)**4 * InternalScale
            !set correlations to zero where very small to avoid numerical issues
            if (i<=lmax_lensing_corrT) then
                CPhi(2,i) = State%CLData%Cl_scalar(i,C_PhiTemp) /real(i,dl)**3 * InternalScale
            end if
            if (i<=lmax_lensing_corrE) then
                CPhi(3,i) = State%CLData%Cl_scalar(i,C_PhiE) /real(i,dl)**3 * InternalScale
            end if
            tmp = i*(i+1)/const_twopi
            CLForLensingIn(:,i) = State%CLData%CL_lensed(i,CT_Temp:CT_Cross) * InternalScale/tmp
            ! CForLensing(i)%C=0
            CForLensing(i)%C(1,1)=CLForLensingIn(1,i)
            CForLensing(i)%C(1,2)=CLForLensingIn(4,i)
            CForLensing(i)%C(2,1)=CLForLensingIn(4,i)
            CForLensing(i)%C(2,2)=CLForLensingIn(2,i)
            ! CForLensing(i)%C(3,3)=CL_lensed(i,1,CT_B) * InternalScale/tmp
        end do

#ifdef FISHER
        allocate(SqueezedLensingKernel(nfields,nfields))
        do field2=1,nfields
            do field3=1,nfields
                allocate(SqueezedLensingKernel(field2,field3)%b((lmax*(lmax+1))/4,SampleL%nl))
                SqueezedLensingKernel(field2,field3)%b=0
            end do
        end do
#endif
        if (DebugMsgs) call Timer%Start()

        !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC,3), &
        !$OMP PRIVATE(l1, l2, l3, max_l, min_l, bix, bi_ix, tmp1, tmp2, tmp3), &
        !$OMP PRIVATE(field1, field2, field3, Bispectrum, a3j, a3j2)
        do il1= 1, SampleL%nl
            l1 = SampleL%l(il1)
            if (l1 > lmax_lensing_corrT) cycle !no exit in parallel loop
            tmp1=l1*(l1+1)
            bi_ix=0
            do l2= max(lmin,l1), lmax
                tmp2= l2*(l2+1)
                min_l = max(abs(l1-l2),l2)
                if (mod(l1+l2+min_l,2)/=0) then
                    min_l = min_l+1
                end if
                max_l = min(lmax,l1+l2)
                bix=bi_ix
                a3j2(:,:,1)=0.5d0
                if (nfields>1) then
                    call GetThreeJs(a3j(abs(l2-l1)),l1,l2,0,0)
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),1,2),l1,l2,2,0)
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),2,2),l1,l2,0,2)
                    call GetThreeJs(a3j2(max(0,abs(l2-l1)),3,2),l1,l2,2,-2)
                    do l3=min_l,max_l ,2
                        a3j2(l3,:,2) = a3j2(l3,:,2)/a3j(l3)*0.5d0
                    end do
                end if
                do field1=1,nfields
                    do field2=1,nfields
                        do field3=1,nfields
                            Bispectrum=> Bispectra(field1,field2,field3, lens_bispectrum_ix)
                            bi_ix=bix
                            do l3=min_l,max_l ,2
                                bi_ix=bi_ix+1
                                tmp3=l3*(l3+1)
                                !bispectrum is the reduced bispectrum
#ifdef FISHER
                                if (field1==1) then
                                    SqueezedLensingKernel(field2,field3)%b(bi_ix,il1)=  &
                                        (-tmp2+tmp3+tmp1)*(a3j2(l3,2,field2)*CForLensing(l3)%C(field2,field3)) + &
                                        (-tmp3+tmp1+tmp2)*(a3j2(l3,2,field3)*CForLensing(l2)%C(field3,field2))
                                end if
#endif

                                Bispectrum%b(bi_ix,il1)=  &
                                    (-tmp1+tmp2+tmp3) *  &
                                    (a3j2(l3,1,field1)*CPhi(1+field2,l2)*CForLensing(l3)%C(field1,field3) + &
                                    a3j2(l3,3,field1)*CPhi(1+field3,l3)*CForLensing(l2)%C(field1,field2) ) + &
                                    (-tmp2+tmp3+tmp1)* &
                                    (a3j2(l3,3,field2)*CPhi(1+field3,l3)*CForLensing(l1)%C(field2,field1) + &
                                    a3j2(l3,2,field2)*CPhi(1+field1,l1)*CForLensing(l3)%C(field2,field3) ) + &
                                    (-tmp3+tmp1+tmp2)* &
                                    (a3j2(l3,2,field3)*CPhi(1+field1,l1)*CForLensing(l2)%C(field3,field2) + &
                                    a3j2(l3,1,field3)*CPhi(1+field2,l2)*CForLensing(l1)%C(field3,field1) )

                            end do
                        end do
                    end do
                end do
            end do
        end do
        !$OMP END PARALLEL DO

        if (DebugMsgs) call Timer%WriteTime('Time for lensing:')

        if (nfields==1) BispectrumParams%do_parity_odd=.false.

        if (BispectrumParams%do_parity_odd) then

            allocate(OddBispectra(12))
            oddix=0
            do field1=1,3
                do field2=1,3
                    do field3=1,3
                        if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                        oddix=oddix+1
                        !Only store l2,l3 that are non-zero, array size is approx
                        allocate(OddBispectra(oddix)%b((lmax*(lmax+1))/4,SampleL%nl))
                        OddBispectra(oddix)%b=0
                    end do
                end do
            end do

            !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC,3), &
            !$OMP PRIVATE(l1, l2, l3, max_l, min_l, bix, bi_ix, tmp1, tmp2, tmp3), &
            !$OMP PRIVATE(field1, field2, field3, Bispectrum, a3j2, oddix)
            do il1= 1, SampleL%nl
                l1 = SampleL%l(il1)
                if (l1 > lmax_lensing_corrT) cycle !no exit in parallel loop
                tmp1=l1*(l1+1)
                bi_ix=0
                do l2= max(lmin,l1), lmax
                    tmp2=l2*(l2+1)
                    min_l = max(abs(l1-l2),l2)
                    if (mod(l1+l2+min_l,2)/=1) then
                        min_l = min_l+1
                    end if
                    max_l = min(lmax,l1+l2)
                    bix=bi_ix

                    a3j2(:,:,1)=0.5d0
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),1,2),l1,l2,2,0)
                    call GetThreeJs(a3j2(max(2,abs(l2-l1)),2,2),l1,l2,0,2)
                    call GetThreeJs(a3j2(max(0,abs(l2-l1)),3,2),l1,l2,2,-2)
                    do l3=min_l,max_l ,2
                        a3j2(l3,:,2) = a3j2(l3,:,2)*0.5d0*sqrt(real((2*L1+1)*(2*L2+1),dl)*(2*L3+1)/(3.1415926535*4))
                    end do


                    oddix=0
                    do field1=1,3
                        do field2=1,3
                            do field3=1,3
                                !Only calculate terms with one B
                                if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                                oddix=oddix+1
                                Bispectrum=> OddBispectra(oddix)
                                bi_ix=bix
                                do l3=min_l,max_l ,2
                                    bi_ix=bi_ix+1

                                    tmp3=l3*(l3+1)
                                    !bispectrum the non-reduced bispectrum without the i
                                    if (parities(field1)==-1) then
                                        Bispectrum%b(bi_ix,il1)=  &
                                            (-tmp1+tmp2+tmp3) *  &
                                            (a3j2(l3,1,min(2,field1))*CPhi(1+field2,l2)*CForLensing(l3)%C(2,field3)  &
                                            -a3j2(l3,3,min(2,field1))*CPhi(1+field3,l3)*CForLensing(l2)%C(2,field2) )
                                    elseif (parities(field2)==-1) then
                                        Bispectrum%b(bi_ix,il1)=  &
                                            (-tmp2+tmp3+tmp1)* &
                                            (-a3j2(l3,3,min(2,field2))*CPhi(1+field3,l3)*CForLensing(l1)%C(2,field1)  &
                                            -a3j2(l3,2,min(2,field2))*CPhi(1+field1,l1)*CForLensing(l3)%C(2,field3) )
                                    else if (parities(field3)==-1) then
                                        Bispectrum%b(bi_ix,il1)=  &
                                            (-tmp3+tmp1+tmp2)* &
                                            (-a3j2(l3,2,min(2,field3))*CPhi(1+field1,l1)*CForLensing(l2)%C(2,field2) + &
                                            a3j2(l3,1,min(2,field3))*CPhi(1+field2,l2)*CForLensing(l1)%C(2,field1) )
                                    end if

                                end do
                            end do
                        end do
                    end do
                end do
            end do
            !$OMP END PARALLEL DO
        end if
    end if

    if (BispectrumParams%do_primordial_bispectrum) then

        print *,'getting reduced local fnl bispectra'

        allocate(TransferPolFac(lmax))
        do i=2,lmax
            TransferPolFac(i) =sqrt( real((i+1)*i,dl)*(i+2)*(i-1))
        end do

        if (shape /= shape_local) call MpiStop('Non-local shapes not working')

        if (shape == shape_local) then
            n=1
            np=1
            npd=0 !derivatives of function
        else if (shape == shape_warm) then
            n=2
            np=3
            npd=0
        else if (shape == shape_warm2) then
            n=1
            np=2
            npd=2
        else
            call MpiStop('unknown shape')
        end if

        allocate(ind(n))
        allocate(indP(np))

        if (npd>0) then
            call InitBesselDerivs(CTrans)
            allocate(indPd(npd))
        end if

        if (shape==shape_warm) then
            !Separable form is very unstable and unworkable probably
            ind(1) = 0
            ind(2) = 2
            indP(1) = 0
            indP(2) = 2
            indP(3) = -2
        else if (shape==shape_warm2) then
            ind(1) = 0
            indP(1) = 0
            indP(2) = -2
            indPd(1) = 0
            indPd(2) = -2
        else
            ind(1) = 0
            indP(1) = 0
        end if

        test=0
        TimeStepsNongauss = State%TimeSteps
        call TimeStepsNongauss%Add_delta(-State%taurst*10*CP%Accuracy%AccuracyBoost, State%taurst, State%dtaurec)
        call TimeStepsNongauss%getArray(.true.)

        if (BispectrumParams%export_alpha_beta) then
            !Note that all the points outside recombination are not really needed
            !And these are for curvature perturbation, so do not include 3/5 factor
            call file_alpha%CreateFile(trim(output_root)//'_alpha.txt') ! 100
            call file_beta%CreateFile(trim(output_root)//'_beta.txt')   ! 101
            call file_alpha_beta_r%CreateFile(trim(output_root)//'_alpha_beta_r.txt') ! 102
        end if

        if (DebugMsgs) call Timer%Start()

        !When writing to the files is requested, then do not OMP. This is done
        !by the IF(.not. ...).
        !$OMP PARALLEL DO DEFAUlT(SHARED), SCHEDULE(STATIC,3), &
        !$OMP IF(.not. BispectrumParams%export_alpha_beta) &
        !$OMP PRIVATE(r, res, resP, resPd, res_l, resP_l, resPd_l, term, j), &
        !$OMP PRIVATE(il1, l1, l2, l3, min_l, max_l, tmp, tmp1, tmp2, Bispectrum), &
        !$OMP PRIVATE(bi_ix, bix, field1, field2, field3, field)
        do i= TimeStepsNongauss%npoints-1, 2,-1
            r=(State%tau0-TimeStepsNongauss%points(i))

            allocate(res(CTrans%ls%nl,n,nfields))
            allocate(resP(CTrans%ls%nl,np,nfields))

            allocate(res_l(1:CTrans%ls%l(CTrans%ls%nl),n,nfields))
            allocate(resP_l(1:CTrans%ls%l(CTrans%ls%nl),np,nfields))
            if (npd>0) then
                allocate(resPd(CTrans%ls%nl,npd))
                allocate(resPd_l(1:CTrans%ls%l(CTrans%ls%nl),npd))
            end if

            call NonGauss_l_r(CP,CTrans, ind, indP,res, resP, nfields, r)
            if (npd>0) call NonGauss_deriv_l_r(CP,CTrans, indPd,resPd, r, dJl,dddJl)

            do field=1,nfields
                do j=1,n
                    call CTrans%ls%InterpolateClArr(res(1,j,field),res_l(lmin,j,field))
                end do
                do j=1,np
                    call CTrans%ls%InterpolateClArr(resP(1,j,field),resP_l(lmin,j,field))
                end do
            end do
            deallocate(res,resP)

            if (BispectrumParams%export_alpha_beta) then
                write(file_alpha%unit, concat('(',lmax-lmin+1 ,'E15.5)')) res_l(lmin:lmax,1,1)
                write(file_beta%unit, concat('(',lmax-lmin+1 ,'E15.5)')) resP_l(lmin:lmax,1,1)
                write(file_alpha_beta_r%unit, '(1E15.5)') r
            end if

            if (npd>0) then
                do j=1,npd
                    call InterpolateClArr(CTrans%ls,resPd(1,j),resPd_l(lmin,j))
                end do
                deallocate(resPd)
            end if

            term = r**2 * TimeStepsNongauss%dpoints(i) * (3./5)


            !Restrict to l1<=l2<=l3
            do il1= 1, SampleL%nl
                l1 = SampleL%l(il1)
                bi_ix=0
                do l2= max(lmin,l1), lmax
                    min_l = max(abs(l1-l2),l2)
                    if (mod(l1+l2+min_l,2)/=0) then
                        min_l = min_l+1
                    end if
                    max_l = min(lmax,l1+l2)
                    do field1=1,nfields
                        do field2=1,nfields
                            tmp1 = 2*term*(res_l(l1,1,field1)*resP_l(l2,1,field2) + &
                                res_l(l2,1,field2)*resP_l(l1,1,field1))
                            tmp2 = 2*term*(resP_l(l1,1,field1)*resP_l(l2,1,field2))
                            do field3=1,nfields
                                Bispectrum => Bispectra(field1,field2,field3,fnl_bispectrum_ix)
                                bix=bi_ix
                                do l3=min_l,max_l ,2
                                    bix=bix+1
                                    Bispectrum%b(bix,il1) = Bispectrum%b(bix,il1) + &
                                        (tmp1*resP_l(l3,1,field3) +   tmp2*res_l(l3,1,field3))
                                end do
                            end do
                        end do
                    end do
                    bi_ix=bix

                end do !l2
            end do !il1

            deallocate(res_l,resP_l)
            if (npd>0) deallocate(resPd_l)
        end do !TimeStepsNongauss
        !$OMP END PARALLEL DO

        if (BispectrumParams%export_alpha_beta) then
            call file_alpha%close()
            call file_beta%close()
            call file_alpha_beta_r%close()
        end if
        deallocate(TransferPolFac)
        call TimeStepsNongauss%Free()

        if (DebugMsgs) call Timer%WriteTime('Time for fnl bispectrum:')

    end if !DoPrimordial

    if (BispectrumParams%Slice_Base_L>0 .or. BispectrumParams%FullOutputFile/='') then
        !write out slice in (muK)^3 units
        allocate(bispectrum_files(nbispectra* max(1, BispectrumParams%ndelta)))
        Bscale=(COBE_CMBTemp*1d6)**3/InternalScale**2;
        do bispectrum_type=1,nbispectra
            if (BispectrumParams%Slice_Base_L>0) then
                do idelta=1,BispectrumParams%ndelta
                    if (mod(BispectrumParams%Slice_Base_L + BispectrumParams%deltas(idelta),2)==1 &
                        .and. bispectrum_type/=lens_bispectrum_ix) cycle
                    call bispectrum_files(BispectrumParams%ndelta*(bispectrum_type-1)+idelta)% &
                        CreateFile(concat(trim(output_root)//'bispectrum_'//&
                        trim(BispectrumNames(bispectrum_type))//'_base_', &
                        BispectrumParams%Slice_Base_L,'_delta_',BispectrumParams%deltas(idelta), &
                        trim(file_tag)//'.dat'))
                end do
            end if
            if (BispectrumParams%FullOutputFile/='') then
                call bispectrum_files(bispectrum_type)%CreateFile(concat(trim(output_root), &
                BispectrumParams%FullOutputFile, '_', BispectrumNames(bispectrum_type), &
                file_tag, '.dat'))
            end if
        end do
        do il1= 1, SampleL%nl
            l1 = SampleL%l(il1)
            bi_ix=0
            do l2= max(lmin,l1), lmax
                min_l = max(abs(l1-l2),l2)
                if (mod(l1+l2+min_l,2)/=0) then
                    min_l = min_l+1
                end if
                max_l = min(lmax,l1+l2)
                do l3=min_l, max_l ,2
                    bi_ix=bi_ix+1
                    if (l1==BispectrumParams%Slice_Base_L &
                        .and. any(l3-l2==BispectrumParams%deltas(1:BispectrumParams%ndelta))) then
                        !Particular slice
                        idelta=IndexOf(l3-l2,BispectrumParams%deltas,BispectrumParams%ndelta)
                        do bispectrum_type=1,nbispectra
                            fileid=bispectrum_files(BispectrumParams%ndelta*(bispectrum_type-1)+idelta)%unit
                            write (fileid,'(1I5)', advance='NO') L2
                            do field1=1,nfields
                                do field2=1,nfields
                                    do field3=1,nfields
                                        write(fileid,'(1E15.5)', advance='NO') &
                                            Bispectra(field1,field2,field3,bispectrum_type)%b(bi_ix,il1)*Bscale
                                    end do
                                end do
                            end do
                            write (fileid,'(a)') ''
                        end do
                    end if !slice
                    if (BispectrumParams%FullOutputFile/='') then
                        if (BispectrumParams%SparseFullOutput .and. .not. any( SampleL%l(1:SampleL%nl)==L2) .or. &
                            l1 > 30 .and. mod(l3-min_l,10)/=0 .and. l3 /= max_l) cycle

                        do bispectrum_type=1,nbispectra
                            if (bispectrum_type==lens_bispectrum_ix .and. L1 > lmax_lensing_corrT) cycle
                            write(bispectrum_files(bispectrum_type)%unit,'(3I5)', advance='NO') L1, L2, L3
                            do field1=1,nfields
                                do field2=1,nfields
                                    do field3=1,nfields
                                        write(bispectrum_files(bispectrum_type)%unit,'(1E14.5)', advance='NO') &
                                            Bispectra(field1,field2,field3,bispectrum_type)%b(bi_ix,il1)*Bscale
                                    end do
                                end do
                            end do
                            write (bispectrum_files(bispectrum_type)%unit,'(a)') ''
                        end do
                    end if

                end do
            end do
        end do
        if (BispectrumParams%do_parity_odd) then
            do il1= 1, SampleL%nl
                l1 = SampleL%l(il1)
                bi_ix=0
                do l2= max(lmin,l1), lmax
                    min_l = max(abs(l1-l2),l2)
                    if (mod(l1+l2+min_l,2)/=1) then
                        min_l = min_l+1
                    end if
                    max_l = min(lmax,l1+l2)
                    do l3=min_l, max_l ,2
                        bi_ix=bi_ix+1
                        if (l1==BispectrumParams%Slice_Base_L &
                            .and. any(l3-l2==BispectrumParams%deltas(1:BispectrumParams%ndelta))) then
                            !Particular slice
                            idelta=IndexOf(l3-l2,BispectrumParams%deltas,BispectrumParams%ndelta)
                            do bispectrum_type=1,nbispectra
                                if (bispectrum_type/=lens_bispectrum_ix) cycle
                                fileid=bispectrum_files(BispectrumParams%ndelta*(bispectrum_type-1)+idelta)%unit
                                write (fileid,'(1I5)', advance='NO') L2
                                oddix=0
                                do field1=1,3
                                    do field2=1,3
                                        do field3=1,3
                                            if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                                            oddix=oddix+1
                                            write(fileid,'(1E15.5)', advance='NO') OddBispectra(oddix)%b(bi_ix,il1)*Bscale
                                        end do
                                    end do
                                end do
                                write (fileid,'(a)') ''
                            end do
                        end if !slice

                    end do
                end do
            end do
        end if

        ! The finalizer closes the files.
        deallocate(bispectrum_files)

    end if

#ifdef FISHER
    if (BispectrumParams%DoFisher) then
        !Get stuff for Fisher etc.

        print *,'Getting Fisher for lmax = ', lmax

        Noise = BispectrumParams%FisherNoise/ (COBE_CMBTemp*1e6)**2  !Planckish, dimensionless units
        NoiseP = BispectrumParams%FisherNoisePol/ (COBE_CMBTemp*1e6)**2

        do i=lmin,lmax
            if (CP%DoLensing) then
                cl(:,i) = CL_lensed(i,1,CT_Temp:CT_Cross)
            else
                cl(1,i) = CL_Scalar(i,1,C_Temp)
                cl(2,i) = CL_Scalar(i,1,C_E)
                cl(4,i) = CL_Scalar(i,1,C_Cross)
                cl(3,i) = 0
            end if
            if (CP%WantTensors .and. i<= CP%Max_l_tensor .and. i>=2) then
                cl(:,i) = cl(:,i) + Cl_tensor(i,1,CT_Temp:CT_Cross)
            end if
        end do
        if (.false.) then
            call OpenTxtFile('CAMBdefault_lensedCls.dat',3)
            do i=lmin,lmax
                !Assume T,E,B,X ordering
                read(3,*) j, cl(1:4,i)
                if (j<lmin) read(3,*) j, cl(1:4,i)
                cl(:,i)=cl(:,i)/(COBE_CMBTemp*1e6)**2
            end do
            close(3)
        end if

        if (Noise >0) then
            file_tag = concat(file_tag,'_noise')
        end if
        xlc= 180*sqrt(8.*log(2.))/3.14159
        sigma2 = (BispectrumParams%FisherNoiseFwhmArcmin/60/xlc)**2
        allocate(InvC(lmax))
        do l1= lmin, lmax
            tmp = l1*(l1+1)/const_twopi
            Cl(1,l1) = Cl(1,l1)/tmp + Noise*exp(l1*(l1+1)*sigma2)
            Cl(2:3,l1) = Cl(2:3,l1)/tmp + NoiseP*exp(l1*(l1+1)*sigma2)
            Cl(4,l1) = Cl(4,l1)/tmp
            allocate(InvC(l1)%C(nfields,nfields))
            if (nfields > 2) call MpiStop('Not implemented nfields>2 in detail')
            if (nfields==1) then
                InvC(l1)%C(1,1)=(2*l1+1)/cl(1,l1)/InternalScale
            else
                InvC(l1)%C(1,1)=cl(2,l1)
                InvC(l1)%C(1,2)=-cl(4,l1)
                InvC(l1)%C(2,1)=-cl(4,l1)
                InvC(l1)%C(2,2)=cl(1,l1)
                InvC(l1)%C= InvC(l1)%C * (2*l1+1)/(cl(1,l1)*cl(2,l1)-cl(4,l1)**2)/InternalScale
            end if
        end do

        if (debugMsgs) call Timer%Start()
        allocate(ifish_contribs(SampleL%l0,nbispectra,nbispectra,nfields,nfields) )
        !This loop is just in case want to plot out lmax dependence
        do lmaxcuti=SampleL%l0, SampleL%l0
            !    call CreateTxtFile('TE-Planck-LensFish.txt',20)
            !   do lmaxcuti=1, SampleL%l0
            !   if (SampleL%l(lmaxcuti) < 425) cycle

            lmax= SampleL%l(lmaxcuti)

            ifish_contribs=0
            lstart = 2 !lmin
            !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC,3), &
            !$OMP PRIVATE(il1,l1,l2,l3,fish_l1,bi_ix,min_l,max_l,a3j_00,a3j), &
            !$OMP PRIVATE(Bispectrum,Bispectrum2,minl2,bix,tmp,tmp1,tmp2,tmpf), &
            !$OMP PRIVATE(field1,field2,field3,f1,f2,f3,bispectrum_type,bispectrum_type2)
            do il1= 1,  lmaxcuti !!!SampleL%l0
                allocate(fish_l1(nbispectra,nbispectra,nfields,nfields)) !last indices are field1,f1
                l1 = SampleL%l(il1)
                if (l1< lstart) cycle
                fish_l1=0
                bi_ix=0
                do l2 = l1,lmax
                    if (l2< lstart) cycle
                    min_l = max(lstart,max(abs(l1-l2),l2))
                    if (mod(l1+l2+min_l,2)/=0) then
                        min_l = min_l+1
                    end if
                    max_l = min(lmax,l1+l2)
                    call GetThreeJs(a3j(abs(l2-l1)),l1,l2,0,0)
                    do l3=min_l,max_l ,2
                        a3j_00(l3)=a3j(l3)**2
                    end do

                    tmp1= 1.d0/const_fourpi  !(2l+1) factors included in InvC
                    minl2=min_l
                    bix=bi_ix
                    do field1=1,nfields
                        do f1=1,nfields
                            tmpf(1)= InvC(l1)%C(field1,f1)*tmp1
                            do field2=1,nfields
                                do f2=1,nfields
                                    tmpf(2)= InvC(l2)%C(field2,f2)*tmpf(1)
                                    do field3=1,nfields
                                        do bispectrum_type=1,nbispectra
                                            if (bispectrum_type==lens_bispectrum_ix) then
                                                Bispectrum=>SqueezedLensingKernel(field2,field3)
                                            else
                                                Bispectrum=>bispectra(field1,field2,field3,bispectrum_type)
                                            end if
                                            do f3=1,nfields

                                                do bispectrum_type2=bispectrum_type,nbispectra
                                                    if (bispectrum_type2==lens_bispectrum_ix) then
                                                        Bispectrum2=>SqueezedLensingKernel(f2,f3)
                                                    else
                                                        Bispectrum2=>Bispectra(f1,f2,f3,bispectrum_type2)
                                                    end if


                                                    min_l=minl2
                                                    bi_ix=bix
                                                    if (min_l==l2) then
                                                        !Symmetry factors
                                                        bi_ix=bi_ix+1
                                                        l3=l2
                                                        if (l2==l1) then
                                                            !l1=l2=l3
                                                            tmp = Bispectrum%b(bi_ix,il1)*tmpf(2)*Bispectrum2%b(bi_ix,il1) &
                                                                *InvC(l3)%C(field3,f3)*a3j_00(l3)/6
                                                        else
                                                            !l3=l2 (l3=l1<>l2 can't happen because l1<=l2<=l3)
                                                            tmp = Bispectrum%b(bi_ix,il1)*tmpf(2)*Bispectrum2%b(bi_ix,il1) &
                                                                * InvC(l3)%C(field3,f3)*a3j_00(l3)/2
                                                        end if
                                                        min_l = min_l+2
                                                    else
                                                        tmp=0
                                                    end if
                                                    tmp2=0
                                                    do l3=min_l,max_l ,2
                                                        bi_ix=bi_ix+1
                                                        tmp2 = tmp2 + Bispectrum%b(bi_ix,il1)*Bispectrum2%b(bi_ix,il1) &
                                                            * InvC(l3)%C(field3,f3)*a3j_00(l3)
                                                    end do
                                                    if (l2==l1) then
                                                        tmp2=tmp2*tmpf(2)/2
                                                    else
                                                        tmp2=tmp2*tmpf(2)
                                                    end if
                                                    fish_l1(bispectrum_type,bispectrum_type2,field1,f1)= &
                                                        fish_l1(bispectrum_type,bispectrum_type2,field1,f1)+(tmp+tmp2)

                                                end do !bispectrum_type2

                                            end do
                                        end do !bispectrum_type
                                    end do !field3
                                end do !f2
                            end do !field2
                        end do !f1
                    end do  !field1

                end do !l2

                ifish_contribs(il1,:,:,:,:)=fish_l1(1:nbispectra,1:nbispectra,:,:) /InternalScale
                deallocate(fish_L1)

            end do
            !$OMP END PARALLEL DO

            if (DebugMsgs) call Timer%WriteTime('Time for Fisher:')

            allocate(fish_contribs(lmin:CTrans%ls%l(CTrans%ls%nl),nfields,nfields))
            allocate(Fisher(nbispectra,nbispectra))
            allocate(tmpFisher(nbispectra,nbispectra))
            allocate(Fisher_L1(lmin:CTrans%ls%l(CTrans%ls%nl),nbispectra*nfields,nbispectra*nfields))

            do bispectrum_type=1,nbispectra
                do bispectrum_type2=bispectrum_type,nbispectra

                    fish_contribs=0
                    do field1=1,nfields
                        do f1=1,nfields
                            call InterpolateClArr(SampleL,ifish_contribs(1,bispectrum_type,bispectrum_type2,field1,f1), &
                                fish_contribs(lmin,field1,f1),lmaxcuti)  !SampleL%l0)
                        end do
                    end do
                    Fisher(bispectrum_type,bispectrum_type2)=0
                    do i=lmin, CTrans%ls%l(CTrans%ls%nl)
                        do field1=1,nfields
                            do f1=1,nfields
                                Fisher_L1(i,(bispectrum_type-1)*nfields+field1,(bispectrum_type2-1)*nfields+f1) = fish_contribs(i,field1,f1)
                                Fisher_L1(i,(bispectrum_type2-1)*nfields+f1,(bispectrum_type-1)*nfields+field1) = fish_contribs(i,field1,f1)
                                tmp=fish_contribs(i,field1,f1)
                                if (bispectrum_type==lens_bispectrum_ix) then
                                    tmp = tmp * CPhi(1+field1,i)
                                end if
                                if (bispectrum_type2==lens_bispectrum_ix) then
                                    tmp = tmp * CPhi(1+f1,i)
                                end if
                                Fisher(bispectrum_type,bispectrum_type2)=Fisher(bispectrum_type,bispectrum_type2)+ tmp
                            end do
                        end do
                    end do
                    Fisher(bispectrum_type2,bispectrum_type) = Fisher(bispectrum_type,bispectrum_type2)

                    print *,'Zero-signal Fisher ',trim(BispectrumNames(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type2)), &
                        ':', Fisher(bispectrum_type2,bispectrum_type)

                    !!!! contribution of lensing to the fnl variance for temperature:
                    !           if (bispectrum_type == fnl_bispectrum_ix .and. bispectrum_type2 == fnl_bispectrum_ix ) then
                    !              fish_contribs_sig=0
                    !              tmpArr=0
                    !              call InterpolateClArr(SampleL,ifish_contribs(1,1,2,1,1),tmpArr(lmin),lmaxcuti)
                    !               do i=lmin, lmax_lensing_corrT
                    !               if (CPhi(1+1,i)/=0) then
                    !                 fish_contribs_sig(i) = &
                    !                  tmpArr(i)**2*(1+ CPhi(1,i)*CForLensing(i)%C(1,1)/(CPhi(1+1,i)*CPhi(1+1,i)))/(2*i+1)
                    !               end if
                    !              end do
                    !              print *,'signal contribution to fnl variance', sum(fish_contribs_sig)/Fisher(bispectrum_type,bispectrum_type2)**2
                    !           end if
                    !!! same with polarization
                    !  if (bispectrum_type == fnl_bispectrum_ix .and. bispectrum_type2 == lens_bispectrum_ix ) then
                    !            fish_contribs_sig=0
                    !            do i=lmin, lmax_lensing_corrT
                    !             corrsize = count(CPhi(2:1+nfields,i)/=0)
                    !             allocate(fish_L_ij(corrsize,corrsize))
                    !             allocate(fish_L_noise(corrsize,corrsize))
                    !             fish_L_ij=0
                    !             ix1=0
                    !             do field1=1,nfields
                    !              ix1=ix1+1
                    !              ix2=0
                    !              do f1=1,nfields
                    !                 ix2=ix2+1
                    !                 fish_L_noise(ix1,ix2)= fish_contribs(i,field1, f1)
                    !                 fish_L_ij(ix1,ix2) = (CPhi(1+f1,i)*CPhi(1+field1,i) + &
                    !                     CPhi(1,i)*CForLensing(i)%C(field1,f1) )/(2*i+1)
                    !              end do
                    !             end do
                    !             fish_L_ij=matmul(matmul((fish_L_noise(:,:)),fish_L_ij),transpose(fish_L_noise(:,:)))
                    !             fish_contribs_sig(i) = sum(fish_L_ij)!Matrix_trace(fish_L_ij)
                    !             deallocate(fish_L_ij)
                    !             deallocate(fish_L_noise)
                    !            end do
                    !            print *,'fnl signal factor', sum(fish_contribs_sig)
                    !       end if


                    if (bispectrum_type == lens_bispectrum_ix .and. bispectrum_type2 == lens_bispectrum_ix ) then
                        print *,'doing signal part of the lensing variance'
                        fish_contribs_sig=0
                        do i=lmin, lmax_lensing_corrT
                            corrsize = count(CPhi(2:1+nfields,i)/=0)
                            allocate(fish_L_ij(corrsize,corrsize))
                            allocate(fish_L_noise(corrsize,corrsize))
                            fish_L_ij=0
                            ix1=0
                            do field1=1,nfields
                                if (CPhi(1+field1,i)/=0) then
                                    ix1=ix1+1
                                    ix2=0
                                    do f1=1,nfields
                                        if (CPhi(1+f1,i)/=0) then
                                            ix2=ix2+1
                                            fish_L_noise(ix1,ix2)= fish_contribs(i,field1, f1)*CPhi(1+f1,i)*CPhi(1+field1,i)
                                            fish_L_ij(ix1,ix2) =  (1 + &
                                                CPhi(1,i)*CForLensing(i)%C(field1,f1)/(CPhi(1+f1,i)*CPhi(1+field1,i)))/(2*i+1)

                                        end if
                                    end do
                                end if
                            end do
                            call Matrix_Inverse(fish_L_noise)
                            fish_L_ij=fish_L_ij+fish_L_noise
                            call Matrix_Inverse(fish_L_ij)
                            fish_contribs_sig(i) = sum(fish_L_ij)
                            deallocate(fish_L_ij)
                            deallocate(fish_L_noise)
                        end do
                        print *,'Lensing Fisher including lensing variance ', sum(fish_contribs_sig)

                    end if

                end do
            end do
            deallocate(fish_contribs)

            print *, 'Results assuming zero fiducial bispectra'
            do bispectrum_type=1,nbispectra
                print *,trim(IntToStr(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type)), &
                    ': 1/sqrt(F_ii) = ',1/sqrt(Fisher(bispectrum_type,bispectrum_type))
            end do

            do bispectrum_type=1,nbispectra
                do bispectrum_type2=bispectrum_type+1,nbispectra
                    bias = Fisher(bispectrum_type2,bispectrum_type)/Fisher(bispectrum_type,bispectrum_type)
                    print *,'Bias of ',trim(BispectrumNames(bispectrum_type2)),' on ', &
                        trim(BispectrumNames(bispectrum_type)),':', bias
                end do
                !           if (bispectrum_type==1) write(1,concat('(1I10,',nbispectra,'E15.5)')) lmax, Fisher(1,1), &
                !                                  Fisher(2:nbispectra,1)/Fisher(1,1)
            end do

            tmpFisher=Fisher
            do bispectrum_type=1,nbispectra
                tmp = sqrt(tmpFisher(bispectrum_type,bispectrum_type))
                tmpFisher(bispectrum_type,:)=tmpFisher(bispectrum_type,:)/tmp
                tmpFisher(:,bispectrum_type)=tmpFisher(:,bispectrum_type)/tmp
            end do
            if (nbispectra>1) then
                print *,'Zero-signal Bispectrum correlation matrix:'
                do bispectrum_type=1,nbispectra
                    print *,tmpFisher(:,bispectrum_type)
                end do

                if (nbispectra > 1) then
                    allocate(OptimalFisher(nbispectra,nbispectra))
                    allocate(tmpBigFisher(nbispectra*nfields,nbispectra*nfields))
                    !              allocate(diag(nbispectra*nfields))
                    OptimalFisher=0
                    do i=lmin, lmax
                        tmpBigFisher=Fisher_L1(i,:,:)
                        if (lens_bispectrum_ix/=0 .and. i<=lmax_lensing_corrT) then

                            call Matrix_Inverse(tmpBigFisher)
                            do field1 = 1,nfields
                                do field2 =1, nfields
                                    tmpBigFisher((lens_bispectrum_ix-1)*nfields+field1, &
                                        (lens_bispectrum_ix-1)*nfields+field2) = &
                                        tmpBigFisher((lens_bispectrum_ix-1)*nfields+field1, &
                                        (lens_bispectrum_ix-1)*nfields+field2) + &
                                        (CPhi(1+field1,i)*CPhi(1+field2,i) + CPhi(1,i)*CForLensing(i)%C(field1,field2))/(2*i+1)
                                end do
                            end do
                            call Matrix_Inverse(tmpBigFisher)

                        end if

                        do field1=1,nfields
                            do field2=1,nfields
                                do bispectrum_type=1,nbispectra
                                    do bispectrum_type2=1,nbispectra
                                        if (bispectrum_type==lens_bispectrum_ix) then
                                            tmp=CPhi(1+field1,i)
                                        else
                                            tmp=1
                                        end if
                                        if (bispectrum_type2==lens_bispectrum_ix) then
                                            tmp=tmp*CPhi(1+field2,i)
                                        end if
                                        OptimalFisher(bispectrum_type,bispectrum_type2)=OptimalFisher(bispectrum_type,bispectrum_type2)+ &
                                            tmp*tmpBigFisher((bispectrum_type-1)*nfields+field1,(bispectrum_type2-1)*nfields+field2)
                                    end do
                                end do
                            end do
                        end do
                    end do
                    deallocate(tmpBigFisher)
                end if

                do bispectrum_type=1,nbispectra
                    print *,'Optimal Inc. lensing:', trim(IntToStr(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type)), &
                        ': 1/sqrt(F_ii) = ',1/sqrt(OptimalFisher(bispectrum_type,bispectrum_type))
                end do
                tmpFisher=OptimalFisher
                call Matrix_Inverse(tmpFIsher)
                do bispectrum_type=1,nbispectra
                    print *,'Optimal Inc. lensing:', trim(IntToStr(bispectrum_type))//'-'//trim(BispectrumNames(bispectrum_type)), &
                        ': Cov_ii = ', sqrt(tmpFIsher(bispectrum_type,bispectrum_type))
                end do
                tmpFisher=OptimalFisher
                do bispectrum_type=1,nbispectra
                    tmp = sqrt(tmpFisher(bispectrum_type,bispectrum_type))
                    tmpFisher(bispectrum_type,:)=tmpFisher(bispectrum_type,:)/tmp
                    tmpFisher(:,bispectrum_type)=tmpFisher(:,bispectrum_type)/tmp
                end do
                print *,'Optimal Bispectrum correlation matrix with lensing variance:'
                do bispectrum_type=1,nbispectra
                    print *,tmpFisher(:,bispectrum_type)
                end do
            end if

            deallocate(Fisher, tmpFisher)

        end do

        deallocate(ifish_contribs)
        deallocate(InvC)

    end if !DoFIsher
#else
    if (BispectrumParams%DoFisher) call MpiStop('compile with FISHER defined')
#endif

    !Tidy up a bit
    do field1=1,nfields
        do field2=1,nfields
            do field3=1,nfields
                do bispectrum_type=1,nbispectra
                    deallocate(Bispectra(field1,field2,field3,bispectrum_type)%b)
                end do
            end do
        end do
    end do
    deallocate(Bispectra)
    if (allocated(CForLensing)) deallocate(CForLensing)

    if (allocated(OddBispectra)) then
        oddix=0
        do field1=1,3
            do field2=1,3
                do field3=1,3
                    if (parities(field1)+parities(field2)+parities(field3)/=1) cycle
                    oddix=oddix+1
                    deallocate(OddBispectra(oddix)%b)
                end do
            end do
        end do
        deallocate(OddBispectra)
    end if

    end subroutine GetBispectrum


    !not needed for local NG
    subroutine NonGauss_deriv_l_r(CP,CTrans, indP,resP, r, dJl, dddJl)
    !As above, but integral against derivative of bessel function to get derivative of function
    Class(CAMBParams) :: CP
    Type(ClTransferData) :: CTrans
    real(dl), intent(in) :: dJl(BessRanges%npoints,CTrans%ls%nl), dddJl(BessRanges%npoints,CTrans%ls%nl)
    integer, intent(in) :: indP(:)
    real(dl) resP(CTrans%ls%nl,size(indP))
    real(dl), intent(in) :: r
    integer q_ix, j, bes_ix, i
    integer nP, ellmax
    real(dl) xf , dJ_l, fac, a2,  k, dlnk, term, P

    nP =size(indP)
    resP = 0
    do q_ix = 1, CTrans%q%npoints

        k = CTrans%q%points(q_ix)
        xf = k*r  !kr
        bes_ix= BessRanges%indexOf(xf)
        fac=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
        a2=(BessRanges%points(bes_ix+1)-xf)/fac
        fac=fac**2*a2/6
        dlnk = CTrans%q%dpoints(q_ix) /k
        P = CP%InitPower%ScalarPower(k)  !!only first index for now
        ellmax = max(xf/(1-xlimfrac), xf + xlimmin) * CP%Accuracy%AccuracyBoost

        do j=1,CTrans%ls%nl
            if (CTrans%ls%l(j) <= ellmax) then
                dJ_l=a2*djl(bes_ix,j)+(1-a2)*(djl(bes_ix+1,j) - ((a2+1) &
                    *dddjl(bes_ix,j)+(2-a2)*dddjl(bes_ix+1,j))* fac) !cubic spline

                term = CTrans%Delta_p_l_k(1,j,q_ix)*dJ_l*dlnk *k
                do i=1,nP
                    resP(j,i) = resP(j,i) + term * k**indP(i) * P
                end do

            end if
        end do
    end do
    resP = resP * const_fourpi

    end subroutine NonGauss_deriv_l_r

    subroutine Bispectrum_SetDefParams(B)
    Type(TBispectrumParams) :: B

    B%nfields=2
    B%Slice_Base_L=0
    B%ndelta=0
    B%DoFisher = .true.
    B%FisherNoise = 0 !2d-4 !Planckish
    B%FisherNoisePol = 4*B%FisherNoise
    B%FisherNoiseFwhmArcmin = 7
    B%FullOutputFile='' !quite large
    B%SparseFullOutput = .false.
    B%do_lensing_bispectrum = .true.
    B%do_primordial_bispectrum = .true.
    B%do_parity_odd = .false.
    B%export_alpha_beta = .false.

    end subroutine Bispectrum_SetDefParams


    subroutine Bispectrum_ReadParams(B, Ini, outroot)
    use IniObjects
    Type(TBispectrumParams) :: B
    character(LEN=*), intent(in) :: outroot
    Type(TIniFile) :: Ini
    integer i

    call Bispectrum_SetDefParams(B)

    B%do_lensing_bispectrum = Ini%Read_Logical('do_lensing_bispectrum', .false.)
    B%do_primordial_bispectrum = Ini%Read_Logical('do_primordial_bispectrum', .false.)

    do_bispectrum= B%do_lensing_bispectrum .or. B%do_primordial_bispectrum

    if (do_bispectrum) then

        output_root = outroot

        call Ini%Read('bispectrum_nfields', B%nfields)
        if (B%nfields /= 2 .and. B%nfields/=1) call MpiStop('Bispectrum: nfields=1 for T only or 2 for polarization')
        B%do_parity_odd = Ini%Read_Logical('do_parity_odd', .false.)
        if (B%do_parity_odd .and. (.not.  B%do_lensing_bispectrum .or. B%nfields==1)) then
            B%do_parity_odd = .false.
            write(*,*) 'Ignoring do_parity_odd since do_lensing_bispectrum=F or no polarization'
        end if
        call Ini%Read('bispectrum_slice_base_L', B%Slice_Base_L)
        if (B%Slice_Base_L>0) then
            call Ini%Read('bispectrum_ndelta', B%ndelta)
            if (B%ndelta > max_bispectrum_deltas) call MpiStop('Bispectrum : increase max_bispectrum_deltas')
            do i=1, B%ndelta
                B%deltas(i) = Ini%Read_Int_Array('bispectrum_delta', i)
            end do
            if (.not. B%do_parity_odd .and. B%Slice_Base_L>0 .and. &
                any(mod(B%Slice_Base_L + B%deltas(1:B%ndelta),2) /= 0)) &
                stop 'Slice is zero for even parity with L1+L2+L3 odd, i.e. Base+DeltaL3 odd'

        end if
        call Ini%Read('bispectrum_do_fisher', B%DoFisher)
        if (B%DoFisher) then
            call Ini%Read('bispectrum_fisher_noise', B%FisherNoise)
            call Ini%Read('bispectrum_fisher_noise_pol', B%FisherNoisePol)
            call Ini%Read('bispectrum_fisher_fwhm_arcmin', B%FisherNoiseFwhmArcmin)
        end if
        B%FullOutputFile = Ini%Read_String('bispectrum_full_output_file')
        if (B%FullOutputFile /='') then
            call Ini%Read('bispectrum_full_output_sparse', B%SparseFullOutput)
        end if

        if (B%do_primordial_bispectrum) then
            call Ini%Read('bispectrum_export_alpha_beta', B%export_alpha_beta)
        end if

    end if

    end subroutine Bispectrum_ReadParams

    end module Bispectrum

    ! Equations module allowing for fairly general quintessence models
    !
    ! by Antony Lewis (http://cosmologist.info/)

    !!FIX March 2005: corrected update to next treatment of tight coupling
    !!Fix Oct 2011: a^2 factor in ayprime(EV%w_ix+1) [thanks Raphael Flauger]
    ! Oct 2013: update for latest CAMB, thanks Nelson Lima, Martina Schwind
    ! May 2020: updated for CAMB 1.x+

    ! Notes at http://antonylewis.com/notes/CAMB.pdf

    !This module is not well tested, use at your own risk!

    !Need to specify Vofphi function, and also initial_phi
    !You may also need to change other things to get it to work with different types of quintessence model

    !It works backwards, in that it assumes Omega_de is Omega_Q today, then does a binary search on the
    !initial conditions to find what is required to give that Omega_Q today after evolution.

    module Quintessence
    use DarkEnergyInterface
    use results
    use constants
    use classes
    use Interpolation
    implicit none
    private

    real(dl), parameter :: Tpl= sqrt(kappa*hbar/c**5)  ! sqrt(8 pi G hbar/c^5), reduced planck time

    ! General base class. Specific implemenetations should inherit, defining Vofphi and setting up
    ! initial conditions and interpolation tables
    type, extends(TDarkEnergyModel) :: TQuintessence
        integer :: DebugLevel = 0 !higher then zero for some debug output to console
        real(dl) :: astart = 1e-7_dl
        real(dl) :: integrate_tol = 1e-6_dl
        real(dl), dimension(:), allocatable :: sampled_a, phi_a, phidot_a
        ! Steps for log a and linear spacing, switching at max_a_log (set by Init)
        integer, private :: npoints_linear, npoints_log
        real(dl), private :: dloga, da, log_astart, max_a_log
        real(dl), private, dimension(:), allocatable :: ddphi_a, ddphidot_a
        class(CAMBdata), pointer, private :: State
    contains
    procedure :: Vofphi !V(phi) potential [+ any cosmological constant]
    procedure :: ValsAta !get phi and phi' at scale factor a, e.g. by interpolation in precomputed table
    procedure :: Init => TQuintessence_Init
    procedure :: PerturbedStressEnergy => TQuintessence_PerturbedStressEnergy
    procedure :: PerturbationEvolve => TQuintessence_PerturbationEvolve
    procedure :: BackgroundDensityAndPressure => TQuintessence_BackgroundDensityAndPressure
    procedure :: EvolveBackground
    procedure :: EvolveBackgroundLog
    procedure, private :: phidot_start => TQuintessence_phidot_start
    end type TQuintessence

    ! Specific implementation for early quintessence + cosmologial constant, assuming the early component
    ! energy density fraction is negligible at z=0.
    ! The specific parameterization of the potential implemented is the axion model of arXiv:1908.06995
    type, extends(TQuintessence) :: TEarlyQuintessence
        real(dl) :: n = 3._dl
        real(dl) :: f =0.05 ! sqrt(8*pi*G)*f
        real(dl) :: m = 5d-54 !m in reduced Planck mass units
        real(dl) :: theta_i = 3.1_dl !initial value of phi/f
        real(dl) :: frac_lambda0 = 1._dl !fraction of dark energy density that is cosmological constant today
        logical :: use_zc = .true. !adjust m to fit zc
        real(dl) :: zc, fde_zc !readshift for peak f_de and f_de at that redshift
        integer :: npoints = 5000 !baseline number of log a steps; will be increased if needed when there are oscillations
        integer :: min_steps_per_osc = 10
        real(dl), dimension(:), allocatable :: fde, ddfde
    contains
    procedure :: Vofphi => TEarlyQuintessence_VofPhi
    procedure :: Init => TEarlyQuintessence_Init
    procedure :: ReadParams =>  TEarlyQuintessence_ReadParams
    procedure, nopass :: PythonClass => TEarlyQuintessence_PythonClass
    procedure, nopass :: SelfPointer => TEarlyQuintessence_SelfPointer
    procedure, private :: fdeAta
    procedure, private :: fde_peak
    procedure, private :: check_error
    procedure :: calc_zc_fde

    end type TEarlyQuintessence

    procedure(TClassDverk) :: dverk

    public TQuintessence, TEarlyQuintessence
    contains

    function VofPhi(this, phi, deriv)
    !Get the quintessence potential as function of phi
    !The input variable phi is sqrt(8*Pi*G)*psi, where psi is the field
    !Returns (8*Pi*G)^(1-deriv/2)*d^{deriv}V(psi)/d^{deriv}psi evaluated at psi
    !return result is in 1/Mpc^2 units [so times (Mpc/c)^2 to get units in 1/Mpc^2]
    class(TQuintessence) :: this
    real(dl) phi,Vofphi
    integer deriv

    call MpiStop('Quintessence classes must override to provide VofPhi')
    VofPhi = 0
    !if (deriv==0) then
    !    Vofphi= norm*this%m*exp(-this%sigma_model*phi)
    !else if (deriv ==1) then
    !    Vofphi=-norm*this%m*sigma_model*exp(-this%sigma_model*phi)
    !else if (deriv ==2) then
    !    Vofphi=norm*this%m*sigma_model**2*exp(-this%sigma_model*phi)
    !else
    !    stop 'Invalid deriv in Vofphi'
    !end if
    !VofPhi = VOfPhi* MPC_in_sec**2 /Tpl**2  !convert to units of 1/Mpc^2


    end function VofPhi


    subroutine TQuintessence_Init(this, State)
    class(TQuintessence), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State

    !Make interpolation table, etc,
    !At this point massive neutrinos have been initialized
    !so grho_no_de can be used to get density and pressure of other components at scale factor a

    select type(State)
    class is (CAMBdata)
        this%State => State
    end select

    this%is_cosmological_constant = .false.
    this%num_perturb_equations = 2

    this%log_astart = log(this%astart)

    end subroutine  TQuintessence_Init

    subroutine TQuintessence_BackgroundDensityAndPressure(this, grhov, a, grhov_t, w)
    !Get grhov_t = 8*pi*rho_de*a**2 and (optionally) equation of state at scale factor a
    class(TQuintessence), intent(inout) :: this
    real(dl), intent(in) :: grhov, a
    real(dl), intent(out) :: grhov_t
    real(dl), optional, intent(out) :: w
    real(dl) V, a2, grhov_lambda, phi, phidot

    if (this%is_cosmological_constant) then
        grhov_t = grhov * a * a
        if (present(w)) w = -1_dl
    elseif (a >= this%astart) then
        a2 = a**2
        call this%ValsAta(a,phi,phidot)
        V = this%Vofphi(phi,0)
        grhov_t = phidot**2/2 + a2*V
        if (present(w)) then
            w = (phidot**2/2 - a2*V)/grhov_t
        end if
    else
        grhov_t=0
        if (present(w)) w = -1
    end if

    end subroutine TQuintessence_BackgroundDensityAndPressure

    subroutine EvolveBackgroundLog(this,num,loga,y,yprime)
    ! Evolve the background equation in terms of loga.
    ! Variables are phi=y(1), a^2 phi' = y(2)
    ! Assume otherwise standard background components
    class(TQuintessence) :: this
    integer num
    real(dl) y(num),yprime(num)
    real(dl) loga, a

    a = exp(loga)
    call this%EvolveBackground(num, a, y, yprime)
    yprime = yprime*a

    end subroutine EvolveBackgroundLog

    subroutine EvolveBackground(this,num,a,y,yprime)
    ! Evolve the background equation in terms of a.
    ! Variables are phi=y(1), a^2 phi' = y(2)
    ! Assume otherwise standard background components
    class(TQuintessence) :: this
    integer num
    real(dl) y(num),yprime(num)
    real(dl) a, a2, tot
    real(dl) phi, grhode, phidot, adot

    a2=a**2
    phi = y(1)
    phidot = y(2)/a2

    grhode=a2*(0.5d0*phidot**2 + a2*this%Vofphi(phi,0))
    tot = this%state%grho_no_de(a) + grhode

    adot=sqrt(tot/3.0d0)
    yprime(1)=phidot/adot !d phi /d a
    yprime(2)= -a2**2*this%Vofphi(phi,1)/adot

    end subroutine EvolveBackground


    real(dl) function TQuintessence_phidot_start(this,phi)
    class(TQuintessence) :: this
    real(dl) :: phi

    TQuintessence_phidot_start = 0

    end function TQuintessence_phidot_start

    subroutine ValsAta(this,a,aphi,aphidot)
    class(TQuintessence) :: this
    !Do interpolation for background phi and phidot at a (precomputed in Init)
    real(dl) a, aphi, aphidot
    real(dl) a0,b0,ho2o6,delta,da
    integer ix

    if (a >= 0.9999999d0) then
        aphi= this%phi_a(this%npoints_linear+this%npoints_log)
        aphidot= this%phidot_a(this%npoints_linear+this%npoints_log)
        return
    elseif (a < this%astart) then
        aphi = this%phi_a(1)
        aphidot = 0
        return
    elseif (a > this%max_a_log) then
        delta= a-this%max_a_log
        ix = this%npoints_log + int(delta/this%da)
    else
        delta= log(a)-this%log_astart
        ix = int(delta/this%dloga)+1
    end if
    da = this%sampled_a(ix+1) - this%sampled_a(ix)
    a0 = (this%sampled_a(ix+1) - a)/da
    b0 = 1 - a0
    ho2o6 = da**2/6._dl
    aphi=b0*this%phi_a(ix+1) + a0*(this%phi_a(ix)-b0*((a0+1)*this%ddphi_a(ix)+(2-a0)*this%ddphi_a(ix+1))*ho2o6)
    aphidot=b0*this%phidot_a(ix+1) + a0*(this%phidot_a(ix)-b0*((a0+1)*this%ddphidot_a(ix)+(2-a0)*this%ddphidot_a(ix+1))*ho2o6)

    end subroutine ValsAta

    subroutine TQuintessence_PerturbedStressEnergy(this, dgrhoe, dgqe, &
        a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1, ay, ayprime, w_ix)
    !Get density perturbation and heat flux
    class(TQuintessence), intent(inout) :: this
    real(dl), intent(out) :: dgrhoe, dgqe
    real(dl), intent(in) ::  a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1
    real(dl), intent(in) :: ay(*)
    real(dl), intent(inout) :: ayprime(*)
    integer, intent(in) :: w_ix
    real(dl) phi, phidot, clxq, vq

    call this%ValsAta(a,phi,phidot)
    clxq=ay(w_ix)
    vq=ay(w_ix+1)
    dgrhoe= phidot*vq +clxq*a**2*this%Vofphi(phi,1)
    dgqe= k*phidot*clxq

    end subroutine TQuintessence_PerturbedStressEnergy


    subroutine TQuintessence_PerturbationEvolve(this, ayprime, w, w_ix, &
        a, adotoa, k, z, y)
    !Get conformal time derivatives of the density perturbation and velocity
    class(TQuintessence), intent(in) :: this
    real(dl), intent(inout) :: ayprime(:)
    real(dl), intent(in) :: a, adotoa, w, k, z, y(:)
    integer, intent(in) :: w_ix
    real(dl) clxq, vq, phi, phidot

    call this%ValsAta(a,phi,phidot) !wasting time calling this again..
    clxq=y(w_ix)
    vq=y(w_ix+1)
    ayprime(w_ix)= vq
    ayprime(w_ix+1) = - 2*adotoa*vq - k*z*phidot - k**2*clxq - a**2*clxq*this%Vofphi(phi,2)

    end subroutine TQuintessence_PerturbationEvolve

    ! Early Quintessence example, axion potential from e.g. arXiv: 1908.06995

    function TEarlyQuintessence_VofPhi(this, phi, deriv) result(VofPhi)
    !The input variable phi is sqrt(8*Pi*G)*psi
    !Returns (8*Pi*G)^(1-deriv/2)*d^{deriv}V(psi)/d^{deriv}psi evaluated at psi
    !return result is in 1/Mpc^2 units [so times (Mpc/c)^2 to get units in 1/Mpc^2]
    class(TEarlyQuintessence) :: this
    real(dl) phi,Vofphi
    integer deriv
    real(dl) theta, costheta
    real(dl), parameter :: units = MPC_in_sec**2 /Tpl**2  !convert to units of 1/Mpc^2

    ! Assume f = sqrt(kappa)*f_theory = f_theory/M_pl
    ! m = m_theory/M_Pl
    theta = phi/this%f
    if (deriv==0) then
        Vofphi = units*this%m**2*this%f**2*(1 - cos(theta))**this%n + this%frac_lambda0*this%State%grhov
    else if (deriv ==1) then
        Vofphi = units*this%m**2*this%f*this%n*(1 - cos(theta))**(this%n-1)*sin(theta)
    else if (deriv ==2) then
        costheta = cos(theta)
        Vofphi = units*this%m**2*this%n*(1 - costheta)**(this%n-1)*(this%n*(1+costheta) -1)
    end if

    end function TEarlyQuintessence_VofPhi


    subroutine TEarlyQuintessence_Init(this, State)
    use Powell
    class(TEarlyQuintessence), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State
    real(dl) aend, afrom
    integer, parameter ::  NumEqs=2
    real(dl) c(24),w(NumEqs,9), y(NumEqs)
    integer ind, i, ix
    real(dl), parameter :: splZero = 0._dl
    real(dl) lastsign, da_osc, last_a, a_c
    real(dl) initial_phi, initial_phidot, a2
    real(dl), dimension(:), allocatable :: sampled_a, phi_a, phidot_a, fde
    integer npoints, tot_points, max_ix
    logical has_peak
    real(dl) fzero, xzero
    integer iflag, iter
    Type(TTimer) :: Timer
    Type(TNEWUOA) :: Minimize
    real(dl) log_params(2), param_min(2), param_max(2)

    !Make interpolation table, etc,
    !At this point massive neutrinos have been initialized
    !so grho_no_de can be used to get density and pressure of other components at scale factor a

    call this%TQuintessence%Init(State)

    if (this%use_zc) then
        !Find underlying parameters m,f to give specified zc and fde_zc (peak early dark energy fraction)
        !Input m,f are used as starting values for search, which is done by brute force
        !(so should generalize easily, but not optimized for this specific potential)
        log_params(1) = log(this%f)
        log_params(2) = log(this%m)

        if (.false.) then
            ! Can just iterate linear optimizations when nearly orthogonal
            call Timer%Start()
            do iter = 1, 2
                call brentq(this,match_fde,log(0.01_dl),log(10._dl), 1d-3,xzero,fzero,iflag)
                if (iflag/=0) print *, 'BRENTQ FAILED f'
                this%f = exp(xzero)
                print *, 'match to m, f =', this%m, this%f, fzero
                call brentq(this,match_zc,log(1d-55),log(1d-52), 1d-3,xzero,fzero,iflag)
                if (iflag/=0) print *, 'BRENTQ FAILED m'
                this%m = exp(xzero)
                print *, 'match to m, f =', this%m, this%f, fzero
                call this%calc_zc_fde(fzero, xzero)
                print *, 'matched outputs', fzero, xzero
            end do
            call Timer%WriteTime('Timing for fitting')
        end if
        if (this%DebugLevel>0) call Timer%Start()
        !Minimize in log f, log m
        ! param_min(1) = log(0.001_dl)
        ! param_min(2) = log(1d-58)
        ! param_max(1) = log(1e5_dl)
        ! param_max(2) = log(1d-50)
        ! if (Minimize%BOBYQA(this, match_fde_zc, 2, 5, log_params,param_min, &
        !           param_max, 0.8_dl,1e-4_dl,this%DebugLevel,2000)) then

        if (Minimize%NEWUOA(this, match_fde_zc, 2, 5, log_params,&
            0.8_dl,1e-4_dl,this%DebugLevel,500)) then

            if (Minimize%Last_bestfit > 1e-3) then
                global_error_flag = error_darkenergy
                global_error_message= 'TEarlyQuintessence ERROR converging solution for fde, zc'
                write(*,*) 'last-bestfit= ', Minimize%Last_bestfit
                return
            end if
            this%f = exp(log_params(1))
            this%m = exp(log_params(2))
            if (this%DebugLevel>0) then
                call this%calc_zc_fde(fzero, xzero)
                write(*,*) 'matched outputs Bobyqa zc, fde = ', fzero, xzero
            end if
        else
            global_error_flag = error_darkenergy
            global_error_message= 'TEarlyQuintessence ERROR finding solution for fde, zc'
            return
        end if
        if (this%DebugLevel>0) call Timer%WriteTime('Timing for parameter fitting')
    end if

    this%dloga = (-this%log_astart)/(this%npoints-1)

    !use log spacing in a up to max_a_log, then linear. Switch where step matches
    this%max_a_log = 1.d0/this%npoints/(exp(this%dloga)-1)
    npoints = (log(this%max_a_log)-this%log_astart)/this%dloga + 1

    if (allocated(this%phi_a)) then
        deallocate(this%phi_a,this%phidot_a)
        deallocate(this%ddphi_a,this%ddphidot_a, this%sampled_a)
    end if
    allocate(phi_a(npoints),phidot_a(npoints), sampled_a(npoints), fde(npoints))

    !initial_phi  = 10  !  0.3*grhom/m**3
    !initial_phi2 = 100 !   6*grhom/m**3
    !
    !!           initial_phi  = 65 !  0.3*grhom/m**3
    !!           initial_phi2 = 65 !   6*grhom/m**3
    !
    !astart=1d-9
    !
    !!See if initial conditions are giving correct omega_de now
    !atol=1d-8
    !initial_phidot =  astart*this%phidot_start(this%initial_phi)
    !om1= this%GetOmegaFromInitial(astart,initial_phi,initial_phidot, atol)
    !
    !print*, State%omega_de, 'first trial:', om1
    !if (abs(om1-State%omega_de > this%omega_tol)) then
    !    !if not, do binary search in the interval
    !    OK=.false.
    !    initial_phidot = astart*this%phidot_start(initial_phi2)
    !    om2= this%GetOmegaFromInitial(astart,initial_phi2,initial_phidot, atol)
    !    if (om1 > State%omega_de .or. om2 < State%omega_de) then
    !        write (*,*) 'initial phi values must bracket required value.  '
    !        write (*,*) 'om1, om2 = ', real(om1), real(om2)
    !        stop
    !    end if
    !    do iter=1,100
    !        deltaphi=initial_phi2-initial_phi
    !        phi =initial_phi + deltaphi/2
    !        initial_phidot =  astart*Quint_phidot_start(phi)
    !        om = this%GetOmegaFromInitial(astart,phi,initial_phidot,atol)
    !        if (om < State%omega_de) then
    !            om1=om
    !            initial_phi=phi
    !        else
    !            om2=om
    !            initial_phi2=phi
    !        end if
    !        if (om2-om1 < 1d-3) then
    !            OK=.true.
    !            initial_phi = (initial_phi2+initial_phi)/2
    !            if (FeedbackLevel > 0) write(*,*) 'phi_initial = ',initial_phi
    !            exit
    !        end if
    !
    !    end do !iterations
    !    if (.not. OK) stop 'Search for good intial conditions did not converge' !this shouldn't happen
    !
    !end if !Find initial

    initial_phi = this%theta_i*this%f

    y(1)=initial_phi
    initial_phidot =  this%astart*this%phidot_start(initial_phi)
    y(2)= initial_phidot*this%astart**2

    phi_a(1)=y(1)
    phidot_a(1)=y(2)/this%astart**2
    sampled_a(1)=this%astart
    da_osc = 1
    last_a = this%astart
    max_ix =0

    ind=1
    afrom=this%log_astart
    do i=1, npoints-1
        aend = this%log_astart + this%dloga*i
        ix = i+1
        sampled_a(ix)=exp(aend)
        a2 = sampled_a(ix)**2
        call dverk(this,NumEqs,EvolveBackgroundLog,afrom,y,aend,this%integrate_tol,ind,c,NumEqs,w)
        if (.not. this%check_error(exp(afrom), exp(aend))) return
        call EvolveBackgroundLog(this,NumEqs,aend,y,w(:,1))
        phi_a(ix)=y(1)
        phidot_a(ix)=y(2)/a2
        if (i==1) then
            lastsign = y(2)
        elseif (y(2)*lastsign < 0) then
            !derivative has changed sign. Use to probe any oscillation scale:
            da_osc = min(da_osc, exp(aend) - last_a)
            last_a = exp(aend)
            lastsign= y(2)
        end if

        !Define fde as ratio of early dark energy density to total
        fde(ix) = 1/((this%state%grho_no_de(sampled_a(ix)) +  this%frac_lambda0*this%State%grhov*a2**2) &
            /(a2*(0.5d0* phidot_a(ix)**2 + a2*this%Vofphi(y(1),0))) + 1)
        if (max_ix==0 .and. ix > 2 .and. fde(ix)< fde(ix-1)) then
            max_ix = ix-1
        end if
        if (sampled_a(ix)*(exp(this%dloga)-1)*this%min_steps_per_osc > da_osc) then
            !Step size getting too big to sample oscillations well
            exit
        end if
    end do

    ! Do remaining steps with linear spacing in a, trying to be small enough
    this%npoints_log = ix
    this%max_a_log = sampled_a(ix)
    this%da = min(this%max_a_log *(exp(this%dloga)-1), &
        da_osc/this%min_steps_per_osc, (1- this%max_a_log)/(this%npoints-this%npoints_log))
    this%npoints_linear = int((1- this%max_a_log)/ this%da)+1
    this%da = (1- this%max_a_log)/this%npoints_linear

    tot_points = this%npoints_log+this%npoints_linear
    allocate(this%phi_a(tot_points),this%phidot_a(tot_points))
    allocate(this%ddphi_a(tot_points),this%ddphidot_a(tot_points))
    allocate(this%sampled_a(tot_points), this%fde(tot_points), this%ddfde(tot_points))
    this%sampled_a(1:ix) = sampled_a(1:ix)
    this%phi_a(1:ix) = phi_a(1:ix)
    this%phidot_a(1:ix) = phidot_a(1:ix)
    this%sampled_a(1:ix) = sampled_a(1:ix)
    this%fde(1:ix) = fde(1:ix)

    ind=1
    afrom = this%max_a_log
    do i=1, this%npoints_linear
        ix = this%npoints_log + i
        aend = this%max_a_log + this%da*i
        a2 =aend**2
        this%sampled_a(ix)=aend
        call dverk(this,NumEqs,EvolveBackground,afrom,y,aend,this%integrate_tol,ind,c,NumEqs,w)
        if (.not. this%check_error(afrom, aend)) return
        call EvolveBackground(this,NumEqs,aend,y,w(:,1))
        this%phi_a(ix)=y(1)
        this%phidot_a(ix)=y(2)/a2

        this%fde(ix) = 1/((this%state%grho_no_de(aend) +  this%frac_lambda0*this%State%grhov*a2**2) &
            /(a2*(0.5d0* this%phidot_a(ix)**2 + a2*this%Vofphi(y(1),0))) + 1)
        if (max_ix==0 .and. this%fde(ix)< this%fde(ix-1)) then
            max_ix = ix-1
        end if
    end do

    call spline(this%sampled_a,this%phi_a,tot_points,splZero,splZero,this%ddphi_a)
    call spline(this%sampled_a,this%phidot_a,tot_points,splZero,splZero,this%ddphidot_a)
    call spline(this%sampled_a,this%fde,tot_points,splZero,splZero,this%ddfde)
    has_peak = .false.
    if (max_ix >0) then
        ix = max_ix
        has_peak = this%fde_peak(a_c, this%sampled_a(ix), this%sampled_a(ix+1), this%fde(ix), &
            this%fde(ix+1), this%ddfde(ix), this%ddfde(ix+1))
        if (.not. has_peak) then
            has_peak = this%fde_peak(a_c, this%sampled_a(ix-1), this%sampled_a(ix), &
                this%fde(ix-1), this%fde(ix), this%ddfde(ix-1), this%ddfde(ix))
        end if
    end if
    if (has_peak) then
        this%zc = 1/a_c-1
        this%fde_zc = this%fdeAta(a_c)
    else
        if (this%DebugLevel>0) write(*,*) 'TEarlyQuintessence: NO PEAK '
        this%zc = -1
    end if
    if (this%DebugLevel>0) then
        write(*,*) 'TEarlyQuintessence zc, fde used', this%zc, this%fde_zc
    end if

    end subroutine TEarlyQuintessence_Init

    logical function check_error(this, afrom, aend)
    class(TEarlyQuintessence) :: this
    real(dl) afrom, aend

    if (global_error_flag/=0) then
        write(*,*) 'TEarlyQuintessence error integrating', afrom, aend
        write(*,*) this%n, this%f, this%m, this%theta_i
        stop
        check_error = .false.
        return
    end if
    check_error= .true.
    end function check_error

    logical function fde_peak(this, peak, xlo, xhi, Flo, Fhi, ddFlo, ddFhi)
    class(TEarlyQuintessence) :: this
    real(dl), intent(out) :: peak
    real(dl) Delta
    real(dl), intent(in) :: xlo, xhi, ddFlo, ddFhi,Flo, Fhi
    real(dl) a, b, c, fac

    !See if derivative has zero in spline interval xlo .. xhi

    Delta = xhi - xlo

    a = 0.5_dl*(ddFhi-ddFlo)/Delta
    b = (xhi*ddFlo-xlo*ddFhi)/Delta
    c = (Fhi-Flo)/Delta+ Delta/6._dl*((1-3*xhi**2/Delta**2)*ddFlo+(3*xlo**2/Delta**2-1)*ddFhi)
    fac = b**2-4*a*c
    if (fac>=0) then
        fac = sqrt(fac)
        peak = (-b + fac)/2/a
        if (peak >= xlo .and. peak <= xhi) then
            fde_peak = .true.
            return
        else
            peak = (-b - fac)/2/a
            if (peak >= xlo .and. peak <= xhi) then
                fde_peak = .true.
                return
            end if
        end if
    end if
    fde_peak = .false.

    end function fde_peak

    function match_zc(this, logm)
    class(TEarlyQuintessence), intent(inout) :: this
    real(dl), intent(in) :: logm
    real(dl) match_zc, zc, fde_zc

    this%m = exp(logm)
    call this%calc_zc_fde(zc, fde_zc)
    match_zc = zc - this%zc

    end function match_zc

    function match_fde(this, logf)
    class(TEarlyQuintessence), intent(inout) :: this
    real(dl), intent(in) :: logf
    real(dl) match_fde, zc, fde_zc

    this%f = exp(logf)
    call this%calc_zc_fde(zc, fde_zc)
    match_fde = fde_zc - this%fde_zc

    end function match_fde

    function match_fde_zc(this, x)
    class(TEarlyQuintessence) :: this
    real(dl), intent(in) :: x(:)
    real(dl) match_fde_zc, zc, fde_zc

    this%f = exp(x(1))
    this%m = exp(x(2))
    call this%calc_zc_fde(zc, fde_zc)

    match_fde_zc = (log(this%fde_zc)-log(fde_zc))**2 + (log(zc)-log(this%zc))**2
    if (this%DebugLevel>1) then
        write(*,*) 'search f, m, zc, fde_zc, chi2', this%f, this%m, zc, fde_zc, match_fde_zc
    end if

    end function match_fde_zc

    subroutine calc_zc_fde(this, z_c, fde_zc)
    class(TEarlyQuintessence), intent(inout) :: this
    real(dl), intent(out) :: z_c, fde_zc
    real(dl) aend, afrom
    integer, parameter ::  NumEqs=2
    real(dl) c(24),w(NumEqs,9), y(NumEqs)
    integer ind, i, ix
    real(dl), parameter :: splZero = 0._dl
    real(dl) a_c
    real(dl) initial_phi, initial_phidot, a2
    real(dl), dimension(:), allocatable :: sampled_a, fde, ddfde
    integer npoints, max_ix
    logical has_peak
    real(dl) a0, b0, da

    ! Get z_c and f_de(z_c) where z_c is the redshift of (first) peak of f_de (de energy fraction)
    ! Do this by forward propagating until peak, then get peak values by cubic interpolation

    initial_phi = this%theta_i*this%f
    this%log_astart = log(this%astart)
    this%dloga = (-this%log_astart)/(this%npoints-1)

    npoints = (-this%log_astart)/this%dloga + 1
    allocate(sampled_a(npoints), fde(npoints), ddfde(npoints))

    y(1)=initial_phi
    initial_phidot =  this%astart*this%phidot_start(initial_phi)
    y(2)= initial_phidot*this%astart**2
    sampled_a(1)=this%astart
    max_ix =0
    ind=1
    afrom=this%log_astart
    do i=1, npoints-1
        aend = this%log_astart + this%dloga*i
        ix = i+1
        sampled_a(ix)=exp(aend)
        a2 = sampled_a(ix)**2
        call dverk(this,NumEqs,EvolveBackgroundLog,afrom,y,aend,this%integrate_tol,ind,c,NumEqs,w)
        if (.not. this%check_error(exp(afrom), exp(aend))) return
        call EvolveBackgroundLog(this,NumEqs,aend,y,w(:,1))
        fde(ix) = 1/((this%state%grho_no_de(sampled_a(ix)) +  this%frac_lambda0*this%State%grhov*a2**2) &
            /((0.5d0*y(2)**2/a2 + a2**2*this%Vofphi(y(1),0))) + 1)
        if (max_ix==0 .and. ix > 2 .and. fde(ix)< fde(ix-1)) then
            max_ix = ix-1
        end if
        if (max_ix/=0 .and. ix > max_ix+4) exit
    end do

    call spline(sampled_a,fde,ix,splZero,splZero,ddfde)
    has_peak = .false.
    if (max_ix >0) then
        has_peak = this%fde_peak(a_c, sampled_a(max_ix), sampled_a(max_ix+1), fde(max_ix), &
            fde(max_ix+1), ddfde(max_ix), ddfde(max_ix+1))
        if (.not. has_peak) then
            has_peak = this%fde_peak(a_c, sampled_a(max_ix-1), sampled_a(max_ix), &
                fde(max_ix-1), fde(max_ix), ddfde(max_ix-1), ddfde(max_ix))
        end if
    end if
    if (has_peak) then
        z_c = 1/a_c-1
        ix = int((log(a_c)-this%log_astart)/this%dloga)+1
        da = sampled_a(ix+1) - sampled_a(ix)
        a0 = (sampled_a(ix+1) - a_c)/da
        b0 = 1 - a0
        fde_zc=b0*fde(ix+1) + a0*(fde(ix)-b0*((a0+1)*ddfde(ix)+(2-a0)*ddfde(ix+1))*da**2/6._dl)
    else
        write(*,*) 'calc_zc_fde: NO PEAK'
        z_c = -1
        fde_zc = 0
    end if

    end subroutine calc_zc_fde

    function fdeAta(this,a)
    class(TEarlyQuintessence) :: this
    real(dl), intent(in) :: a
    real(dl) fdeAta, aphi, aphidot, a2

    call this%ValsAta(a, aphi, aphidot)
    a2 = a**2
    fdeAta = 1/((this%state%grho_no_de(a) +  this%frac_lambda0*this%State%grhov*a2**2) &
        /(a2*(0.5d0* aphidot**2 + a2*this%Vofphi(aphi,0))) + 1)
    end function fdeAta

    subroutine TEarlyQuintessence_ReadParams(this, Ini)
    use IniObjects
    class(TEarlyQuintessence) :: this
    class(TIniFile), intent(in) :: Ini

    call this%TDarkEnergyModel%ReadParams(Ini)

    end subroutine TEarlyQuintessence_ReadParams


    function TEarlyQuintessence_PythonClass()
    character(LEN=:), allocatable :: TEarlyQuintessence_PythonClass

    TEarlyQuintessence_PythonClass = 'EarlyQuintessence'

    end function TEarlyQuintessence_PythonClass

    subroutine TEarlyQuintessence_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TEarlyQuintessence), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TEarlyQuintessence_SelfPointer


    !real(dl) function GetOmegaFromInitial(this, astart,phi,phidot,atol)
    !!Get omega_de today given particular conditions phi and phidot at a=astart
    !class(TQuintessence) :: this
    !real(dl), intent(IN) :: astart, phi,phidot, atol
    !integer, parameter ::  NumEqs=2
    !real(dl) c(24),w(NumEqs,9), y(NumEqs), ast
    !integer ind, i
    !
    !ast=astart
    !ind=1
    !y(1)=phi
    !y(2)=phidot*astart**2
    !call dverk(this,NumEqs,EvolveBackground,ast,y,1._dl,atol,ind,c,NumEqs,w)
    !call EvolveBackground(this,NumEqs,1._dl,y,w(:,1))
    !
    !GetOmegaFromInitial=(0.5d0*y(2)**2 + Vofphi(y(1),0))/this%State%grhocrit !(3*adot**2)
    !
    !end function GetOmegaFromInitial
    end module Quintessence

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! The `halofit' code models the nonlinear evolution of cold matter
    ! cosmological power spectra. The full details of the way in which
    ! this is done are presented in Smith et al. (2002), MNRAS, ?, ?.
    !
    ! The code `halofit' was written by R. E. Smith & J. A. Peacock.
    ! See http://www.astro.upenn.edu/~res,
    !
    ! Subsequent updates as below
    ! Only tested for basic models with power law initial power spectra
    ! References for variant versions are
    !   halofit_original: astro-ph/0207664
    !   halofit_peacock: http://www.roe.ac.uk/~jap/haloes/
    !   halofit_bird: arXiv: 1109.4416
    !   halofit_takahashi: arXiv: 1208.2701
    !   halofit_mead: arXiv:1505.07833,1602.02154
    !   halofit_casarini: arXiv:0810.0190, arXiv:1601.07230

    ! Adapted for F90 and CAMB, AL March 2005
    !!BR09 Oct 09: generalized expressions for om(z) and ol(z) to include w

    ! RT12 Oct: update some fitting parameters in the code to enhance
    !           the power spectrum at small scales (arXiv:1208.2701)

    !!JD 08/13: generalized expressions for om(z) and ol(z) to include
    !           w_0 and w_a
    ! SPB14 Feb: update the fitting parameters for neutrinos to work with RT12
    !           modifications
    ! AL Sept 14: added halofit_version parameter to change approximation used;
    !   separate halofit.f90 is no longer needed as equations.f90 defined fixed wa_ppf
    ! Jan 15: Suggested change from Simeon Bird to avoid issues with very large Omm and neutrinos
    !AM Mar 16: Added in HMcode
    !AM May 16: Fixed some small bugs and added better neutrino approximations
    !AL Jun16: put in partial openmp for HMcode (needs restructure to do properly)
    !AM Sep 16: Attempted fix of strange bug. No more modules with unallocated arrays as inputs
    !LC Oct 16: extended Halofit from w=const. models to w=w(a) with PKequal
    !AM May 17: Made the baryon feedback parameters more obvious in HMcode
    !AL Jul 17: fixed undefined z calling Tcb_Tcbnu_ratio
    !AM Jul 17: sped-up HMcode integration routines


    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    module NonLinear
    use ModelParams
    use transfer
    use LambdaGeneral
    implicit none
    private

    real, parameter :: Min_kh_nonlinear = 0.005
    real(dl):: om_m,om_v,fnu,omm0, acur, w_hf,wa_hf

    integer, parameter :: halofit_original = 1, halofit_bird=2, halofit_peacock=3, halofit_takahashi=4
    integer, parameter :: halofit_mead=5, halofit_halomodel=6, halofit_casarini=7, halofit_mead2015=8
    integer, parameter :: halofit_default = halofit_takahashi
    integer :: halofit_version = halofit_default
    public Min_kh_nonlinear, NonLinear_GetNonLinRatios, NonLinear_ReadParams
    public halofit_version, halofit_default, halofit_original, halofit_bird, halofit_peacock, halofit_takahashi
    public halofit_mead, halofit_halomodel, halofit_casarini

    !!AM - Added these types for HMcode
    INTEGER :: imead !!AM - added these for HMcode, need to be visible to all subroutines and functions
    logical :: HM_verbose = .false.

    TYPE HM_cosmology
        !Contains only things that do not need to be recalculated with each new z
        REAL :: om_m, om_v, w, wa, f_nu, ns, h, Tcmb, Nnu
        REAL, ALLOCATABLE :: r_sigma(:), sigma(:)
        REAL, ALLOCATABLE :: growth(:), a_growth(:)
        REAL, ALLOCATABLE :: k_plin(:), plin(:), plinc(:)
        INTEGER :: nk, ng, nsig
        !AM - Added feedback parameters below at fixed fiducial (DMONLY) values
        REAL :: A_baryon=3.13
        REAL :: eta_baryon=0.603
    END TYPE HM_cosmology

    TYPE HM_tables
        !Stuff that needs to be recalculated for each new z
        REAL, ALLOCATABLE :: c(:), rv(:), nu(:), sig(:), zc(:), m(:), rr(:), sigf(:)
        REAL :: sigv, sigv100, c3, knl, rnl, neff, sig8z
        INTEGER :: n
    END TYPE HM_tables
    !!AM - End of my additions

    contains

    subroutine NonLinear_ReadParams(Ini)
    use IniFile
    Type(TIniFile) :: Ini

    halofit_version = Ini_Read_Int_File(Ini, 'halofit_version', halofit_default)

    end subroutine NonLinear_ReadParams

    subroutine NonLinear_GetNonLinRatios(CAMB_Pk)
    !Fill the CAMB_Pk%nonlin_scaling array with sqrt(non-linear power/linear power)
    !for each redshift and wavenumber
    !This implementation uses Halofit
    type(MatterPowerData) :: CAMB_Pk
    integer itf
    real(dl) a,plin,pq,ph,pnl,rk
    real(dl) sig,rknl,rneff,rncur,d1,d2
    real(dl) diff,xlogr1,xlogr2,rmid
    integer i

    IF(halofit_version==halofit_mead .OR. halofit_version==halofit_halomodel .OR. halofit_version==halofit_mead2015) THEN

        !AM - Call HMcode here
        CALL HMcode(CAMB_Pk)

    ELSE

        !!BR09 putting neutrinos into the matter as well, not sure if this is correct, but at least one will get a consisent omk.
        omm0 = CP%omegac+CP%omegab+CP%omegan
        fnu = CP%omegan/omm0

        CAMB_Pk%nonlin_ratio = 1

        do itf = 1, CAMB_Pk%num_z

            w_hf=w_lam
            wa_hf=wa_ppf
            if (halofit_version == halofit_casarini) then
                ! calculate equivalent w-constant models (w_hf,0) for w_lam+wa_ppf(1-a) models
                ! [Casarini+ (2009,2016)].
                call PKequal(CAMB_Pk%Redshifts(itf),w_lam,wa_ppf,w_hf,wa_hf)
            endif

            ! calculate nonlinear wavenumber (rknl), effective spectral index (rneff) and
            ! curvature (rncur) of the power spectrum at the desired redshift, using method
            ! described in Smith et al (2002).
            a = 1/real(1+CAMB_Pk%Redshifts(itf),dl)
            om_m = omega_m(a, omm0, CP%omegav, w_hf,wa_hf)
            om_v = omega_v(a, omm0, CP%omegav, w_hf,wa_hf)
            acur = a
            xlogr1=-2.0
            xlogr2=3.5
            do
                rmid=(xlogr2+xlogr1)/2.0
                rmid=10**rmid
                call wint(CAMB_Pk,itf,rmid,sig,d1,d2)
                diff=sig-1.0
                if (abs(diff).le.0.001) then
                    rknl=1./rmid
                    rneff=-3-d1
                    rncur=-d2
                    exit
                elseif (diff.gt.0.001) then
                    xlogr1=log10(rmid)
                elseif (diff.lt.-0.001) then
                    xlogr2=log10(rmid)
                endif
                if (xlogr2 < -1.9999) then
                    !is still linear, exit
                    goto 101
                else if (xlogr2>3.4999) then
                    ! Totally crazy non-linear
                    global_error_flag=349
                    write(*,*) 'Error in halofit'
                    goto 101
                end if
            end do

            ! now calculate power spectra for a logarithmic range of wavenumbers (rk)

            do i=1, CAMB_PK%num_k
                rk = exp(CAMB_Pk%log_kh(i))

                if (rk > Min_kh_nonlinear) then

                    ! linear power spectrum !! Remeber => plin = k^3 * P(k) * constant
                    ! constant = 4*pi*V/(2*pi)^3

                    plin= MatterPowerData_k(CAMB_PK, rk, itf)*(rk**3/(2*pi**2))

                    ! calculate nonlinear power according to halofit: pnl = pq + ph,
                    ! where pq represents the quasi-linear (halo-halo) power and
                    ! where ph is represents the self-correlation halo term.

                    call halofit(rk,rneff,rncur,rknl,plin,pnl,pq,ph)   ! halo fitting formula
                    CAMB_Pk%nonlin_ratio(i,itf) = sqrt(pnl/plin)

                end if

            enddo

101         continue
        end do

    END IF

    end subroutine NonLinear_GetNonLinRatios

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    subroutine halofit(rk,rn,rncur,rknl,plin,pnl,pq,ph)

    real(dl) gam,a,b,c,xmu,xnu,alpha,beta,f1,f2,f3
    real(dl) rk,rn,plin,pnl,pq,ph,plinaa
    real(dl) rknl,y,rncur
    real(dl) f1a,f2a,f3a,f1b,f2b,f3b,frac
    real(dl) extragam, peacock_fudge

    if (halofit_version ==halofit_original .or. halofit_version ==halofit_bird &
        .or. halofit_version == halofit_peacock) then
        ! halo model nonlinear fitting formula as described in
        ! Appendix C of Smith et al. (2002)
        !SPB11: Standard halofit underestimates the power on the smallest scales by a
        !factor of two. Add an extra correction from the simulations in Bird, Viel,
        !Haehnelt 2011 which partially accounts for this.
        if (halofit_version ==halofit_bird) then
            extragam = 0.3159 -0.0765*rn -0.8350*rncur
            gam=extragam+0.86485+0.2989*rn+0.1631*rncur
        else
            gam=0.86485+0.2989*rn+0.1631*rncur
        end if
        a=1.4861+1.83693*rn+1.67618*rn*rn+0.7940*rn*rn*rn+ &
            0.1670756*rn*rn*rn*rn-0.620695*rncur
        a=10**a
        b=10**(0.9463+0.9466*rn+0.3084*rn*rn-0.940*rncur)
        c=10**(-0.2807+0.6669*rn+0.3214*rn*rn-0.0793*rncur)
        xmu=10**(-3.54419+0.19086*rn)
        xnu=10**(0.95897+1.2857*rn)
        alpha=1.38848+0.3701*rn-0.1452*rn*rn
        beta=0.8291+0.9854*rn+0.3400*rn**2+fnu*(-6.4868+1.4373*rn**2)
    elseif (halofit_version == halofit_takahashi .or. halofit_version == halofit_casarini) then
        !RT12 Oct: the halofit in Smith+ 2003 predicts a smaller power
        !than latest N-body simulations at small scales.
        !Update the following fitting parameters of gam,a,b,c,xmu,xnu,
        !alpha & beta from the simulations in Takahashi+ 2012.
        !The improved halofit accurately provide the power spectra for WMAP
        !cosmological models with constant w.
        !LC16 Jun: Casarini+ 2009,2016 extended constant w prediction for w(a).
        gam=0.1971-0.0843*rn+0.8460*rncur
        a=1.5222+2.8553*rn+2.3706*rn*rn+0.9903*rn*rn*rn+ &
            0.2250*rn*rn*rn*rn-0.6038*rncur+0.1749*om_v*(1.+w_hf+wa_hf*(1-acur))
        a=10**a
        b=10**(-0.5642+0.5864*rn+0.5716*rn*rn-1.5474*rncur+ &
            0.2279*om_v*(1.+w_hf+wa_hf*(1-acur)))
        c=10**(0.3698+2.0404*rn+0.8161*rn*rn+0.5869*rncur)
        xmu=0.
        xnu=10**(5.2105+3.6902*rn)
        alpha=abs(6.0835+1.3373*rn-0.1959*rn*rn-5.5274*rncur)
        beta=2.0379-0.7354*rn+0.3157*rn**2+1.2490*rn**3+ &
            0.3980*rn**4-0.1682*rncur + fnu*(1.081 + 0.395*rn**2)
    else
        call MpiStop('Unknown halofit_version')
    end if

    if(abs(1-om_m).gt.0.01) then ! omega evolution
        f1a=om_m**(-0.0732)
        f2a=om_m**(-0.1423)
        f3a=om_m**(0.0725)
        f1b=om_m**(-0.0307)
        f2b=om_m**(-0.0585)
        f3b=om_m**(0.0743)
        frac=om_v/(1.-om_m)
        f1=frac*f1b + (1-frac)*f1a
        f2=frac*f2b + (1-frac)*f2a
        f3=frac*f3b + (1-frac)*f3a
    else
        f1=1.0
        f2=1.
        f3=1.
    endif

    y=(rk/rknl)


    ph=a*y**(f1*3)/(1+b*y**(f2)+(f3*c*y)**(3-gam))
    ph=ph/(1+xmu*y**(-1)+xnu*y**(-2))*(1+fnu*0.977)
    plinaa=plin*(1+fnu*47.48*rk**2/(1+1.5*rk**2))
    pq=plin*(1+plinaa)**beta/(1+plinaa*alpha)*exp(-y/4.0-y**2/8.0)

    pnl=pq+ph

    if (halofit_version == halofit_peacock) then
        !From http://www.roe.ac.uk/~jap/haloes/
        !(P-P_linear) -> (P-P_linear) * (1+2y^2)/(1+y^2), where y = k/10 h Mpc^(-1).
        peacock_fudge = rk/10
        pnl = plin + (pnl-plin)*(1+2*peacock_fudge**2)/(1+peacock_fudge**2)
    end if

    end subroutine halofit


    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    ! The subroutine wint, finds the effective spectral quantities
    ! rknl, rneff & rncur. This it does by calculating the radius of
    ! the Gaussian filter at which the variance is unity = rknl.
    ! rneff is defined as the first derivative of the variance, calculated
    ! at the nonlinear wavenumber and similarly the rncur is the second
    ! derivative at the nonlinear wavenumber.

    subroutine wint(CAMB_Pk,itf,r,sig,d1,d2)
    integer, intent(in) :: itf
    type(MatterPowerData) :: CAMB_Pk
    real(dl) sum1,sum2,sum3,t,y,x,w1,w2,w3
    real(dl) x2,rk, fac,r, sig, d1,d2, anorm
    integer i,nint

    nint=3000
    sum1=0.d0
    sum2=0.d0
    sum3=0.d0
    anorm = 1/(2*pi**2)
    do i=1,nint
        t=(i-0.5_dl)/nint
        y=-1.d0+1.d0/t
        rk=y
        d2=MatterPowerData_k(CAMB_PK, rk, itf)*(rk**3*anorm)
        x=y*r
        x2=x*x
        w1=exp(-x2)
        w2=2*x2*w1
        w3=4*x2*(1-x2)*w1
        fac=d2/y/t/t
        sum1=sum1+w1*fac
        sum2=sum2+w2*fac
        sum3=sum3+w3*fac
    enddo
    sum1=sum1/nint
    sum2=sum2/nint
    sum3=sum3/nint
    sig=sqrt(sum1)
    d1=-sum2/sum1
    d2=-sum2*sum2/sum1/sum1 - sum3/sum1

    end subroutine wint

    !!JD 08/13 generalize to variable w

    function omega_m(aa,om_m0,om_v0,wval,waval)
    real(dl) omega_m,omega_t,om_m0,om_v0,aa,wval,waval,Qa2
    Qa2= aa**(-1.0-3.0*(wval+waval))*dexp(-3.0*(1-aa)*waval)
    omega_t=1.0+(om_m0+om_v0-1.0)/(1-om_m0-om_v0+om_v0*Qa2+om_m0/aa)
    omega_m=omega_t*om_m0/(om_m0+om_v0*aa*Qa2)
    end function omega_m

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    ! evolution of omega lambda with expansion factor

    function omega_v(aa,om_m0,om_v0,wval,waval)
    real(dl) aa,omega_v,om_m0,om_v0,omega_t,wval,waval,Qa2
    Qa2= aa**(-1.0-3.0*(wval+waval))*dexp(-3.0*(1-aa)*waval)
    omega_t=1.0+(om_m0+om_v0-1.0)/(1-om_m0-om_v0+om_v0*Qa2+om_m0/aa)
    omega_v=omega_t*om_v0*Qa2/(om_v0*Qa2+om_m0/aa)
    end function omega_v

    !!JD end generalize to variable w

    !!AM Below is for HMcode
    SUBROUTINE HMcode(CAMB_Pk)
    !!AM - A CAMB derived type that I need
    TYPE(MatterPowerData) :: CAMB_Pk
    REAL :: z, k
    REAL :: p1h, p2h, pfull, plin
    INTEGER :: i, j, nk, nz
    TYPE(HM_cosmology) :: cosi
    TYPE(HM_tables) :: lut
    REAL, PARAMETER :: pi=3.141592654

    !HMcode developed by Alexander Mead (alexander.j.mead@googlemail.com)
    !Please contact me if you have any questions whatsoever
    !If you use this in your work please cite the original paper: http://arxiv.org/abs/1505.07833
    !If you use the extensions (w(a) and massive neutrinos) then please cite: http://arxiv.org/abs/1602.02154
    !Also consider citing the source code at ASCL: http://ascl.net/1508.001

    !Use imead to switch between the standard and accurate halo-model calcuation
    !0 - Standard (this is just a vanilla halo model calculation with no accuracy tweaks)
    !1 - Accurate from Mead et al. (2016; arXiv 1602.02154; covers massive neutrinos)
    !2 - Accurate from Mead et al. (2015; arXiv 1505.07833; no calibration for massive neutrinos)
    IF(halofit_version==halofit_halomodel) imead=0
    IF(halofit_version==halofit_mead) imead=1
    IF(halofit_version==halofit_mead2015) imead=2

    IF(FeedbackLevel>0) HM_verbose = .true.

    IF(HM_verbose) WRITE(*,*)
    IF(HM_verbose) WRITE(*,*) 'HMcode: Running HMcode'
    IF(HM_verbose) WRITE(*,*)

    !!AM - Translate from CAMB variables to my variables
    nz=CAMB_PK%num_z
    nk=CAMB_PK%num_k

    !!AM - Assign cosmological parameters for the halo model calculation
    CALL assign_HM_cosmology(cosi)

    !Fill growth function table (only needs to be done once)
    CALL fill_growtab(cosi)

    !Loop over redshifts
    DO j=1,nz

        !Initialise the specific HM_cosmology (fill sigma(R) and P_lin HM_tables)
        !Currently this needs to be done at each z (mainly because of scale-dependent growth with neutrinos)
        !For non-massive-neutrino models this could only be done once, which would speed things up a bit
        CALL initialise_HM_cosmology(j,cosi,CAMB_PK)

        !Sets the current redshift from the table
        z=CAMB_Pk%Redshifts(j)

        !Initiliasation for the halomodel calcualtion (needs to be done for each z)
        CALL halomod_init(z,lut,cosi)

        !Loop over k values and calculate P(k)
        !$OMP PARALLEL DO DEFAULT(SHARED), private(k,plin, pfull,p1h,p2h)
        DO i=1,nk
            k=exp(CAMB_Pk%log_kh(i))
            plin=p_lin(k,z,0,cosi)
            CALL halomod(k,z,p1h,p2h,pfull,plin,lut,cosi)
            CAMB_Pk%nonlin_ratio(i,j)=sqrt(pfull/plin)
        END DO
        !$OMP END PARALLEL DO

    END DO

    END SUBROUTINE HMcode

    FUNCTION Delta_v(z,lut,cosm)

    !Function for the virialised overdensity
    REAL :: Delta_v
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(imead==0) THEN
        !Value that is normally used in halo model predictions
        Delta_v=200.
    ELSE IF(imead==1 .OR. imead==2) THEN
        !Mead et al. (2015; arXiv 1505.07833) value
        Delta_v=418.*(Omega_m_hm(z,cosm)**(-0.352))
        !Mead et al. (2016; arXiv 1602.02154) neutrino addition
        IF(imead==1) Delta_v=Delta_v*(1.+0.916*cosm%f_nu)
    END IF

    END FUNCTION Delta_v

    FUNCTION delta_c(z,lut,cosm)

    !Function for the linear collapse density
    REAL :: delta_c
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(imead==0) THEN
        delta_c=1.686
    ELSE IF(imead==1 .OR. imead==2) THEN
        !Mead et al. (2015; arXiv 1505.07833) value
        delta_c=1.59+0.0314*log(lut%sig8z)
        IF(imead==1) THEN
            delta_c=delta_c*(1.+0.262*cosm%f_nu) !Mead et al. (2016; arXiv 1602.02154) neutrino addition
            delta_c=delta_c*(1.+0.0123*log10(Omega_m_hm(z,cosm))) !Nakamura & Suto (1997) fitting formula for LCDM
        END IF
    END IF

    END FUNCTION delta_c

    FUNCTION eta(z,lut,cosm)

    !Function eta that puffs halo profiles
    REAL :: eta
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut
    REAL :: eta0

    IF(imead==0) THEN
        eta=0.
    ELSE IF(imead==1 .OR. imead==2) THEN
        !The first parameter here is 'eta_0' in Mead et al. (2015; arXiv 1505.07833)
        !eta=0.603-0.3*lut%sig8z
        !AM - made baryon feedback parameter obvious
        eta0=cosm%eta_baryon
        !eta0=0.98-0.12*cosm%A_baryon !This is an (updated) one-parameter relation that could be used
        eta=eta0-0.3*lut%sig8z
    END IF

    END FUNCTION eta

    FUNCTION kstar(z,lut,cosm)

    !Function k* that cuts off the 1-halo term at large scales
    REAL :: kstar
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(imead==0) THEN
        !Set to zero for the standard Poisson one-halo term
        kstar=0.
    ELSE IF(imead==1 .OR. imead==2) THEN
        !One-halo cut-off wavenumber
        !Mead et al. (2015; arXiv 1505.07833) value
        kstar=0.584*(lut%sigv)**(-1.)
    END IF

    END FUNCTION kstar

    FUNCTION As(z,lut,cosm)

    !Halo concentration pre-factor from Bullock et al. (2001) relation
    REAL :: As
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(imead==0) THEN
        !Set to 4 for the standard Bullock value
        As=4.
    ELSE IF(imead==1 .OR. imead==2) THEN
        !This is the 'A' halo-concentration parameter in Mead et al. (2015; arXiv 1505.07833)
        !As=3.13
        !AM - added for easy modification of feedback parameter
        As=cosm%A_baryon
    END IF

    END FUNCTION As

    FUNCTION fdamp(z,lut,cosm)

    !Linear power damping function from Mead et al. (2015; arXiv 1505.07833)
    REAL ::fdamp
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    !Linear theory damping factor
    IF(imead==0) THEN
        !Set to 0 for the standard linear theory two halo term
        fdamp=0.
    ELSE IF(imead==1) THEN
        !Mead et al. (2016; arXiv 1602.02154) value
        fdamp=0.0095*lut%sigv100**1.37
    ELSE IF(imead==2) THEN
        !Mead et al. (2015) value
        fdamp=0.188*lut%sig8z**4.29
    END IF

    !Catches extreme values of fdamp
    IF(fdamp<1.e-3) fdamp=1.e-3
    IF(fdamp>0.99)  fdamp=0.99

    END FUNCTION fdamp

    FUNCTION alpha(z,lut,cosm)

    !Two- to one-halo transition smoothing from Mead et al. (2015; arXiv 1505.07833)
    REAL :: alpha
    REAL, INTENT(IN) :: z
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    IF(imead==0) THEN
        !Set to 1 for the standard halomodel sum of one- and two-halo terms
        alpha=1.
    ELSE IF(imead==1) THEN
        !This uses the top-hat defined neff (HALOFIT uses Gaussian filtered fields instead)
        !Mead et al. (2016; arXiv 1602.02154) value
        alpha=3.24*1.85**lut%neff
    ELSE IF(imead==2) THEN
        !Mead et al. (2015) value
        alpha=2.93*1.77**lut%neff
    END IF

    !Catches values of alpha that are crazy
    IF(alpha>2.)  alpha=2.
    IF(alpha<0.5) alpha=0.5

    END FUNCTION alpha

    FUNCTION r_nl(lut)

    !Calculates R_nl, defined by nu(R_nl)=1., nu=dc/sigma(R)
    TYPE(HM_tables), INTENT(IN) :: lut
    REAL :: r_nl

    IF(lut%nu(1)>1.) THEN
        !This catches some very strange values that appear for odd cosmological models
        r_nl=lut%rr(1)
    ELSE
        r_nl=exp(find(log(1.),log(lut%nu),log(lut%rr),lut%n,3,3,2))
    END IF

    END FUNCTION r_nl

    SUBROUTINE halomod(k,z,p1h,p2h,pfull,plin,lut,cosm)

    !Calcuates 1-halo and 2-halo terms and combines them to form the full halomodel power
    REAL, INTENT(OUT) :: p1h, p2h, pfull
    REAL, INTENT(IN) :: plin, k, z
    REAL :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    !Calls expressions for one- and two-halo terms and then combines
    !to form the full power spectrum
    IF(k==0.) THEN
        p1h=0.
        p2h=0.
    ELSE
        p1h=p_1h(k,z,lut,cosm)
        p2h=p_2h(k,z,plin,lut,cosm)
    END IF

    a=alpha(z,lut,cosm)
    pfull=(p2h**a+p1h**a)**(1./a)

    END SUBROUTINE halomod

    SUBROUTINE fill_table(min,max,arr,n)

    !Fills array 'arr' in equally spaced intervals
    IMPLICIT NONE
    INTEGER :: i
    REAL, INTENT(IN) :: min, max
    REAL, ALLOCATABLE :: arr(:)
    INTEGER, INTENT(IN) :: n

    !Allocate the array, and deallocate it if it is full
    IF(ALLOCATED(arr)) DEALLOCATE(arr)
    ALLOCATE(arr(n))
    arr=0.

    IF(n==1) THEN
        arr(1)=min
    ELSE IF(n>1) THEN
        DO i=1,n
            arr(i)=min+(max-min)*float(i-1)/float(n-1)
        END DO
    END IF

    END SUBROUTINE fill_table

    SUBROUTINE fill_table8(min,max,arr,n)

    !Fills array 'arr' in equally spaced intervals
    IMPLICIT NONE
    INTEGER :: i
    real(dl), INTENT(IN) :: min, max
    real(dl), ALLOCATABLE :: arr(:)
    INTEGER, INTENT(IN) :: n

    !Allocate the array, and deallocate it if it is full
    IF(ALLOCATED(arr)) DEALLOCATE(arr)
    ALLOCATE(arr(n))
    arr=0.

    IF(n==1) THEN
        arr(1)=min
    ELSE IF(n>1) THEN
        DO i=1,n
            arr(i)=min+(max-min)*float(i-1)/float(n-1)
        END DO
    END IF

    END SUBROUTINE fill_table8

    SUBROUTINE fill_plintab(iz,cosm,CAMB_PK)

    !Fills internal HMcode HM_tables for the linear power spectrum at z=0
    TYPE(MatterPowerData), INTENT(IN) :: CAMB_PK
    INTEGER, INTENT(IN) :: iz
    TYPE(HM_cosmology) :: cosm
    INTEGER :: i
    REAL :: z, g
    INTEGER, PARAMETER :: imeth=2
    REAL, PARAMETER :: pi=3.141592654
    REAL, PARAMETER :: kmin=1e-3
    REAL, PARAMETER :: kmax=1e2
    INTEGER, PARAMETER :: nk=128

    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: Filling linear power HM_tables'

    !Fill arrays
    IF(ALLOCATED(cosm%k_plin)) DEALLOCATE(cosm%k_plin)
    IF(ALLOCATED(cosm%plin))   DEALLOCATE(cosm%plin)
    IF(ALLOCATED(cosm%plinc))  DEALLOCATE(cosm%plinc)

    IF(imeth==1) THEN

        !Fill k-table with the same k points as in the CAMB calculation
        !If a user has specified lots of points this could make the halo-model
        !calculation chug
        cosm%nk=CAMB_PK%num_k
        ALLOCATE(cosm%k_plin(nk))
        DO i=1,cosm%nk
            cosm%k_plin(i)=exp(CAMB_Pk%log_kh(i))
        END DO

    ELSE IF(imeth==2) THEN

        !Fill a k-table with an equal-log-spaced k range
        !Note that the minimum should be such that the linear spectrum is accurately a power-law below this wavenumber
        cosm%nk=nk
        CALL fill_table(log(kmin),log(kmax),cosm%k_plin,cosm%nk)
        cosm%k_plin=exp(cosm%k_plin)

    END IF

    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: k_min:', cosm%k_plin(1)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: k_max:', cosm%k_plin(nk)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: nk:', nk

    ALLOCATE(cosm%plin(nk),cosm%plinc(nk))

    !Find the redshift
    z=CAMB_Pk%Redshifts(iz)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: z of input:', z

    !Fill power table, both cold- and all-matter
    DO i=1,nk
        !Take the power from the current redshift choice
        cosm%plin(i)=MatterPowerData_k(CAMB_PK,DBLE(cosm%k_plin(i)),iz)*(cosm%k_plin(i)**3/(2.*pi**2))
        cosm%plinc(i)=cosm%plin(i)*(Tcb_Tcbnu_ratio(cosm%k_plin(i),z,cosm))**2
    END DO

    !Calculate the growth factor at the redshift of interest
    g=grow(z,cosm)

    !Grow the power to z=0
    cosm%plin=cosm%plin/(g**2.)
    cosm%plinc=cosm%plinc/(g**2.)

    !Check sigma_8 value
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: sigma_8:', sigma(8.,0.,0,cosm)
    IF(HM_verbose) WRITE(*,*) 'LINEAR POWER: Done'
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE fill_plintab

    FUNCTION Tcb_Tcbnu_ratio(k,z,cosm)

    !Calculates the ratio of T(k) for cold vs. all matter
    !Uses approximations in Eisenstein & Hu (1999; arXiv 9710252)
    !Note that this assumes that there are exactly 3 species of neutrinos with
    !Nnu<=3 of these being massive, and with the mass split evenly between the number of massive species.

    REAL :: Tcb_Tcbnu_ratio
    REAL, INTENT(IN) :: k, z
    REAL :: D, Dcb, Dcbnu, pcb, zeq, q, yfs
    REAL :: BigT
    TYPE(HM_cosmology) :: cosm

    IF(cosm%f_nu==0.) THEN

        Tcb_Tcbnu_ratio=1.

    ELSE

        !Growth exponent under the assumption that neutrinos are completely unclustered (equation 11)
        pcb=(5.-sqrt(1.+24.*(1.-cosm%f_nu)))/4.

        !Theta for temperature (BigT=T/2.7 K)
        BigT=cosm%Tcmb/2.7

        !The matter-radiation equality redshift
        zeq=(2.5e4)*cosm%om_m*(cosm%h**2.)*(BigT**(-4.))

        !The growth function normalised such that D=(1.+z_eq)/(1+z) at early times (when Omega_m \approx 1)
        !For my purpose (just the ratio) seems to work better using the EdS growth function result, \propto a .
        !In any case, can't use grow at the moment because that is normalised by default.
        D=(1.+zeq)/(1.+z)

        !Wave number relative to the horizon scale at equality (equation 5)
        !Extra factor of h becauase all my k are in units of h/Mpc
        q=k*cosm%h*BigT**2./(cosm%om_m*cosm%h**2.)

        !Free streaming scale (equation 14)
        !Note that Eisenstein & Hu (1999) only consider the case of 3 neutrinos
        !with Nnu of these being massve with the mass split evenly between Nnu species.
        yfs=17.2*cosm%f_nu*(1.+0.488*cosm%f_nu**(-7./6.))*(cosm%Nnu*q/cosm%f_nu)**2.

        !These are (almost) the scale-dependent growth functions for each component in Eisenstein & Hu (1999)
        !Some part is missing, but this cancels when they are divided by each other, which is all I need them for.
        !Equations (12) and (13)
        Dcb=(1.+(D/(1.+yfs))**0.7)**(pcb/0.7)
        Dcbnu=((1.-cosm%f_nu)**(0.7/pcb)+(D/(1.+yfs))**0.7)**(pcb/0.7)

        Tcb_Tcbnu_ratio=Dcb/Dcbnu

    END IF

    END FUNCTION Tcb_Tcbnu_ratio

    SUBROUTINE assign_HM_cosmology(cosm)

    !Assigns the internal HMcode cosmological parameters
    TYPE(HM_cosmology) :: cosm

    !Converts CAMB parameters to Meadfit parameters
    cosm%om_m=CP%omegac+CP%omegab+CP%omegan
    cosm%om_v=CP%omegav
    cosm%w=w_lam
    cosm%wa=wa_ppf
    cosm%f_nu=CP%omegan/cosm%om_m
    cosm%h=CP%H0/100.
    cosm%Tcmb=CP%tcmb
    cosm%Nnu=CP%Num_Nu_massive

    !n_s is read in here. The non-linear CAMB module does not work if there is more than
    !one value in this array, so explicitly setting '1' here is fine.
    cosm%ns=CP%InitPower%an(1)

    !Write out cosmological parameters if necessary
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_m:', cosm%om_m
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: Om_v:', cosm%om_v
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: w_0:', cosm%w
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: w_a:', cosm%wa
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: f_nu:', cosm%f_nu
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: n_s:', cosm%ns
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: h:', cosm%h
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: T_CMB [K]:', cosm%Tcmb
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: N_nu (massive):', cosm%Nnu
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: A_baryon:', cosm%A_baryon
    IF(HM_verbose) WRITE(*,*) 'HM_cosmology: eta_baryon:', cosm%eta_baryon
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE assign_HM_cosmology

    SUBROUTINE initialise_HM_cosmology(iz,cosm,CAMB_PK)

    !Sets up HM_tables of sigma, growth and linear power for the HM_cosmology
    TYPE(MatterPowerData), INTENT(IN) :: CAMB_PK
    TYPE(HM_cosmology) :: cosm
    INTEGER, INTENT(IN) :: iz

    !Fill linear power table and grows it to z=0
    CALL fill_plintab(iz,cosm,CAMB_PK)

    !Fill sigma(r) table
    CALL fill_sigtab(cosm)

    END SUBROUTINE initialise_HM_cosmology

    SUBROUTINE allocate_LUT(lut)

    !Allocates memory for the HMcode look-up HM_tables
    TYPE(HM_tables) :: lut
    INTEGER :: n

    n=lut%n
    ALLOCATE(lut%zc(n),lut%m(n),lut%c(n),lut%rv(n))
    ALLOCATE(lut%nu(n),lut%rr(n),lut%sigf(n),lut%sig(n))

    lut%zc=0.
    lut%m=0.
    lut%c=0.
    lut%rv=0.
    lut%nu=0.
    lut%rr=0.
    lut%sigf=0.
    lut%sig=0.

    END SUBROUTINE allocate_LUT

    SUBROUTINE deallocate_LUT(lut)

    !Deallocates HMcode look-up HM_tables
    TYPE(HM_tables) :: lut

    DEALLOCATE(lut%zc,lut%m,lut%c,lut%rv,lut%nu,lut%rr,lut%sigf,lut%sig)

    END SUBROUTINE deallocate_LUT

    SUBROUTINE halomod_init(z,lut,cosm)

    !Halo-model initialisation routine
    !Computes look-up HM_tables necessary for the halo model calculations
    REAL, INTENT(IN) :: z
    INTEGER :: i
    REAL :: Dv, dc, f, m, nu, r, sig
    TYPE(HM_cosmology) :: cosm
    TYPE(HM_tables) :: lut
    REAL, PARAMETER :: mmin=1e0 !Lower mass limit
    REAL, PARAMETER :: mmax=1e18 !Upper mass limit
    INTEGER, PARAMETER :: n=256 !Number of entries in look-up HM_tables.

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: Filling look-up HM_tables'
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: HM_tables being filled at redshift:', z

    !Find value of sigma_v, sig8, etc.

    lut%sigv=sqrt(dispint(0.,z,cosm)/3.)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sigv [Mpc/h]:', lut%sigv
    lut%sigv100=sqrt(dispint(100.,z,cosm)/3.)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sigv100 [Mpc/h]:', lut%sigv100
    lut%sig8z=sigma(8.,z,0,cosm)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sig8(z):', lut%sig8z

    IF(ALLOCATED(lut%rr)) CALL deallocate_LUT(lut)

    lut%n=n
    CALL allocate_lut(lut)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: M_min:', mmin
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: M_max:', mmax

    dc=delta_c(z,lut,cosm)

    !$OMP PARALLEL DO default(shared), private(m,r,sig,nu)
    DO i=1,n

        m=exp(log(mmin)+log(mmax/mmin)*float(i-1)/float(n-1))
        r=radius_m(m,cosm)
        sig=sigmac(r,z,cosm)
        nu=dc/sig

        lut%m(i)=m
        lut%rr(i)=r
        lut%sig(i)=sig
        lut%nu(i)=nu

    END DO
    !$OMP END PARALLEL DO

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: m, r, nu, sig HM_tables filled'

    !Fills up a table for sigma(fM) for Bullock c(m) relation
    !This is the f=0.01 parameter in the Bullock realtion sigma(fM,z)
    f=0.01**(1./3.)
    DO i=1,lut%n
        lut%sigf(i)=sigmac(lut%rr(i)*f,z,cosm)
    END DO
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: sigf HM_tables filled'

    !Fill virial radius table using real radius table
    Dv=Delta_v(z,lut,cosm)
    lut%rv=lut%rr/(Dv**(1./3.))

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: rv HM_tables filled'
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: nu min:', lut%nu(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: nu max:', lut%nu(lut%n)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: R_v min [Mpc/h]:', lut%rv(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: R_v max [Mpc/h]:', lut%rv(lut%n)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: M min [Msun/h]:', lut%m(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: M max [Msun/h]:', lut%m(lut%n)

    !Find non-linear radius and scale
    lut%rnl=r_nl(lut)
    lut%knl=1./lut%rnl

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: r_nl [Mpc/h]:', lut%rnl
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: k_nl [h/Mpc]:', lut%knl

    !Calcuate the effective spectral index at the collapse scale
    lut%neff=neff(lut,cosm)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: n_eff:', lut%neff

    !Get the concentration for all the haloes
    CALL conc_bull(z,lut,cosm)

    IF(HM_verbose) WRITE(*,*) 'HALOMOD: c HM_tables filled'
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: c min [Msun/h]:', lut%c(lut%n)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: c max [Msun/h]:', lut%c(1)
    IF(HM_verbose) WRITE(*,*) 'HALOMOD: Done'
    IF(HM_verbose) WRITE(*,*)
    IF(HM_verbose) CALL write_parameters(z,lut,cosm)

    !Switch off verbose mode if doing multiple z
    HM_verbose= .false.

    END SUBROUTINE halomod_init

    SUBROUTINE write_parameters(z,lut,cosm)

    !This subroutine writes out the halomodel parameters at the current redshift
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    IF(HM_verbose) WRITE(*,*) 'WRITE_PARAMETERS: at this redshift'
    IF(HM_verbose) WRITE(*,*) '=================================='
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'z:', z
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'Dv:', Delta_v(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'dc:', delta_c(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'eta:', eta(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'k*:', kstar(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'A:', As(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'fdamp:', fdamp(z,lut,cosm)
    IF(HM_verbose) WRITE(*,fmt='(A10,F10.5)') 'alpha:', alpha(z,lut,cosm)
    IF(HM_verbose) WRITE(*,*) '=================================='
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE write_parameters

    PURE FUNCTION radius_m(m,cosm)

    !Calculates the co-moving radius that encloses a mass 'm' in the homogeneous Universe
    REAL :: radius_m
    REAL, INTENT(IN) :: m
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL, PARAMETER :: pi=3.141592654

    radius_m=(3.*m/(4.*pi*cosmic_density(cosm)))**(1./3.)

    END FUNCTION radius_m

    FUNCTION neff(lut,cosm)

    !Finds the effective spectral index at the collapse scale r_nl
    !Where nu(r_nl)=1.
    REAL :: neff
    REAL :: ns
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    TYPE(HM_tables), INTENT(IN) :: lut

    !Numerical differentiation to find effective index at collapse
    neff=-3.-derivative_table(log(lut%rnl),log(lut%rr),log(lut%sig**2.),lut%n,3,3)

    !For some bizarre cosmological models r_nl is very small, so almost no collapse has occured
    !In this case the n_eff calculation goes mad and needs to be fixed using this fudge.
    ns=cosm%ns
    IF(neff<ns-4.) neff=ns-4.
    IF(neff>ns)    neff=ns

    END FUNCTION neff

    SUBROUTINE conc_bull(z,lut,cosm)

    !Calculates the Bullock et al. (2001) concentration-mass relation
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology) :: cosm, cos_lcdm
    TYPE(HM_tables) :: lut
    REAL :: A, zf, ainf, zinf, g_lcdm, g_wcdm, pow
    INTEGER :: i

    !Amplitude of relation (4. in Bullock et al. 2001)
    A=As(z,lut,cosm)

    !Fill the collapse time look-up table
    CALL zcoll_bull(z,cosm,lut)

    !Fill the concentration look-up table
    DO i=1,lut%n
        zf=lut%zc(i)
        lut%c(i)=A*(1.+zf)/(1.+z)
    END DO

    !Dolag (2004) prescription for adding DE dependence

    !This is approximately z=infinity
    zinf=10.
    g_wcdm=grow(zinf,cosm)

    !Make a LCDM HM_cosmology
    !Only need to make sure model is flat with the same Omega_m and w=-1
    !This is *only* used for a calculation of the growth function
    cos_lcdm=cosm
    DEALLOCATE(cos_lcdm%growth)
    DEALLOCATE(cos_lcdm%a_growth)
    cos_lcdm%w=-1.
    cos_lcdm%wa=0.
    cos_lcdm%om_v=1.-cosm%om_m !Added this so that 'making a LCDM cosmology' works for curved models.

    ainf=1./(1.+zinf)

    !Needs to use grow_int explicitly here for LCDM model to avoid growth HM_tables
    g_lcdm=growint(ainf,cos_lcdm)

    !This is the Dolag et al. (2004) correction for halo concentrations
    IF(imead==0 .OR. imead==1) THEN
        pow=1.
    ELSE IF(imead==2) THEN
        pow=1.5
    END IF
    lut%c=lut%c*((g_wcdm/g_lcdm)**pow)

    END SUBROUTINE conc_bull

    FUNCTION growint(a,cosm)

    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    IMPLICIT NONE
    REAL :: growint
    REAL, INTENT(IN) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: b
    INTEGER :: i, j
    INTEGER :: n
    REAL :: x, dx
    REAL :: f1, f2, fx
    real(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=30
    real(dl), PARAMETER :: acc=1d-3
    INTEGER, PARAMETER :: iorder=3

    !Integration range for integration parameter
    !Note a -> 1
    b=1.d0

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        growint=exp(0.d0)

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=growint_integrand(a,cosm)
                f2=growint_integrand(b,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*REAL(i-1)/REAL(n-1)
                    fx=growint_integrand(x,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    STOP 'GROWINT: Error, iorder specified incorrectly'
                END IF

            END IF

            IF((j>=jmin) .AND. (ABS(-1.d0+sum_new/sum_old)<acc)) THEN
                !jmin avoids spurious early convergence
                growint=exp(sum_new)
                EXIT
            ELSE IF(j==jmax) THEN
                STOP 'GROWINT: Integration timed out'
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION growint

    FUNCTION growint_integrand(a,cosm)

    !Integrand for the approximate growth integral
    IMPLICIT NONE
    REAL :: growint_integrand
    REAL, INTENT(IN) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: gam

    IF(cosm%w<-1.) THEN
        gam=0.55+0.02*(1.+cosm%w)
    ELSE IF(cosm%w>-1) THEN
        gam=0.55+0.05*(1.+cosm%w)
    ELSE
        gam=0.55
    END IF

    !Note the minus sign here
    growint_integrand=-(Omega_m_hm(-1.+1./a,cosm)**gam)/a

    END FUNCTION growint_integrand

    SUBROUTINE zcoll_bull(z,cosm,lut)

    !Calcuates the halo collapse redshift according to the Bullock (2001) prescription
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology) :: cosm
    TYPE(HM_tables) :: lut
    REAL :: dc
    REAL :: af, zf, RHS, a, growz
    INTEGER :: i

    !This fills up the halo formation redshift table as per Bullock relations

    !Needs to interpolate g(z) which should be pretty linear for a<0.05
    !in 'g(a) vs a' space for all standard cosmologies

    dc=delta_c(z,lut,cosm)

    !Find the growth function at the current redshift
    a=1./(1.+z)
    growz=find(a,cosm%a_growth,cosm%growth,cosm%ng,3,3,2)

    !Do numerical inversion
    DO i=1,lut%n

        RHS=dc*grow(z,cosm)/lut%sigf(i)

        IF(RHS>growz) THEN
            !This is the case of 'halo forms in the future'
            !in this case set formation redshift to current redshift
            zf=z
        ELSE
            af=find(RHS,cosm%growth,cosm%a_growth,cosm%ng,3,3,2)
            zf=-1.+1./af
        END IF

        lut%zc(i)=zf

    END DO

    END SUBROUTINE zcoll_bull

    FUNCTION mass_r(r,cosm)

    !Calcuates the average mass enclosed at co-moving radius r
    REAL :: mass_r, r
    TYPE(HM_cosmology) :: cosm
    REAL, PARAMETER :: pi=3.141592654

    !Relation between mean cosmological mass and radius
    mass_r=(4.*pi/3.)*cosmic_density(cosm)*(r**3.)

    END FUNCTION mass_r

    PURE FUNCTION cosmic_density(cosm)

    !The z=0 cosmological matter density
    REAL :: cosmic_density
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !In M_sun per Mpc^3 with h factors included. The constant does this.
    cosmic_density=(2.775e11)*cosm%om_m

    END FUNCTION cosmic_density

    FUNCTION find_pk(k,itype,cosm)

    !Look-up and interpolation for P(k,z=0)
    REAL :: find_pk
    REAL :: kmax, ns
    REAL, INTENT(IN) :: k
    INTEGER, INTENT(IN) :: itype
    INTEGER :: n
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !Set number of k points as well as min and max k values
    !Note that the min k value should be set to the same as the CAMB min k value
    n=SIZE(cosm%k_plin)
    kmax=cosm%k_plin(n)

    !Spectral index used in the high-k extrapolation
    ns=cosm%ns

    IF(k>kmax) THEN
        !Do some interpolation here based on knowledge of things at high k
        IF(itype==0) THEN
            find_pk=cosm%plin(n)*((log(k)/log(kmax))**2.)*((k/kmax)**(ns-1.))
        ELSE IF(itype==1) THEN
            find_pk=cosm%plinc(n)*((log(k)/log(kmax))**2.)*((k/kmax)**(ns-1.))
        END IF
    ELSE
        !Otherwise use the standard find algorithm
        IF(itype==0) THEN
            find_pk=exp(find(log(k),log(cosm%k_plin),log(cosm%plin),cosm%nk,3,3,2))
        ELSE IF(itype==1) THEN
            find_pk=exp(find(log(k),log(cosm%k_plin),log(cosm%plinc),cosm%nk,3,3,2))
        END IF
    END IF

    !Old method, works fine for m_nu<0.5 eV
    !IF(itype==1) find_pk=find_pk/(1.-cosm%f_nu)**2.

    END FUNCTION find_pk

    FUNCTION p_lin(k,z,itype,cosm)

    !Looks up the value for the linear power spectrum
    REAL :: p_lin
    REAL, INTENT (IN) :: k, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !This gives the linear power spectrum for the model in question
    !P(k) should have been previously normalised to z=0

    p_lin=(grow(z,cosm)**2.)*find_pk(k,itype,cosm)

    END FUNCTION p_lin

    FUNCTION p_2h(k,z,plin,lut,cosm)

    !Calculates the 2-halo term
    REAL :: p_2h
    REAL, INTENT(IN) :: k, plin
    REAL :: sigv, frac
    REAL, INTENT(IN) :: z
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !Damping function
    frac=fdamp(z,lut,cosm)

    IF(imead==0 .OR. frac<1.e-3) THEN
        p_2h=plin
    ELSE
        sigv=lut%sigv
        p_2h=plin*(1.-frac*(tanh(k*sigv/sqrt(ABS(frac))))**2.)
    END IF

    !For some strange cosmologies frac>1. so this must be added to prevent p_2h<0.
    IF(p_2h<0.) p_2h=0.

    END FUNCTION p_2h

    FUNCTION p_1h(k,z,lut,cosm)

    !Calculates the 1-halo term
    REAL :: p_1h
    REAL, INTENT(IN) :: k, z
    TYPE(HM_tables), INTENT(IN) :: lut
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: Dv, g, fac, et, ks, wk
    REAL, ALLOCATABLE :: integrand(:)
    REAL :: sum
    INTEGER :: i
    REAL, PARAMETER :: pi=3.141592654

    !Does the one-halo power integral

    !Allocates arrays for the integration HM_tables
    ALLOCATE(integrand(lut%n))
    integrand=0.

    !Only call eta once
    et=eta(z,lut,cosm)

    !Calculates the value of the integrand at all nu values!
    DO i=1,lut%n
        g=gnu(lut%nu(i))
        wk=win(k*(lut%nu(i)**et),lut%rv(i),lut%c(i))
        integrand(i)=(lut%rv(i)**3.)*g*(wk**2.)
    END DO

    !Carries out the integration
    sum=REAL(inttab(lut%nu,REAL(integrand),lut%n,1))

    !Deallocate arrays
    DEALLOCATE(integrand)

    !Virial density
    Dv=Delta_v(z,lut,cosm)

    !These are just numerical factors from the 1-halo integral in terms of nu!
    p_1h=sum*2.*Dv*(k**3.)/(3.*pi)

    !Damping of the 1-halo term at very large scales
    ks=kstar(z,lut,cosm)

    !Prevents problems if k/ks is very large
    IF(ks==0.) THEN
        fac=0.
    ELSE IF((k/ks)**2.>7.) THEN
        fac=0.
    ELSE
        fac=exp(-((k/ks)**2.))
    END IF

    !Damping of the one-halo term at very large scales
    p_1h=p_1h*(1.-fac)

    END FUNCTION p_1h

    SUBROUTINE fill_sigtab(cosm)

    !Fills look-up HM_tables for sigma(R)
    REAL :: r, sig
    INTEGER :: i
    TYPE(HM_cosmology) :: cosm
    REAL, PARAMETER :: rmin=1e-4
    REAL, PARAMETER :: rmax=1e3
    INTEGER, PARAMETER :: nsig=64

    !This fills up HM_tables of r vs. sigma(r) across a range in r!
    !It is used only in look-up for further calculations of sigmac(r) and not otherwise!
    !and prevents a large number of calls to the sigint functions
    !rmin and rmax need to be decided in advance and are chosen such that
    !R vs. sigma(R) is approximately power-law below and above these values of R
    !This wouldn't be appropriate for models with a small-scale linear spectrum cut-off (e.g., WDM)

    !Allocate arrays
    IF(ALLOCATED(cosm%r_sigma)) DEALLOCATE(cosm%r_sigma)
    IF(ALLOCATED(cosm%sigma))   DEALLOCATE(cosm%sigma)

    !These values of 'r' work fine for any power spectrum of cosmological importance
    !Having nsig as a 2** number is most efficient for the look-up routines
    cosm%nsig=nsig
    ALLOCATE(cosm%r_sigma(nsig),cosm%sigma(nsig))

    IF(HM_verbose) WRITE(*,*) 'SIGTAB: Filling sigma interpolation table'
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: R_min:', rmin
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: R_max:', rmax
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: Values:', nsig

    !$OMP PARALLEL DO default(shared), private(sig, r)
    DO i=1,nsig

        !Equally spaced r in log
        r=exp(log(rmin)+log(rmax/rmin)*float(i-1)/float(nsig-1))

        sig=sigma(r,0.,1,cosm)

        cosm%r_sigma(i)=r
        cosm%sigma(i)=sig

    END DO
    !$OMP END PARALLEL DO

    IF(HM_verbose) WRITE(*,*) 'SIGTAB: sigma_min:', cosm%sigma(nsig)
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: sigma_max:', cosm%sigma(1)
    IF(HM_verbose) WRITE(*,*) 'SIGTAB: Done'
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE fill_sigtab

    FUNCTION sigmac(r,z,cosm)

    !Finds sigma_cold(R) from look-up table
    REAL :: sigmac
    REAL, INTENT(IN) :: r, z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    !Assumes scale-independet growth for the cold matter
    !Uses the approximation sigma(R,z)=g(z)*sigma(R,z=0)

    sigmac=grow(z,cosm)*exp(find(log(r),log(cosm%r_sigma),log(cosm%sigma),cosm%nsig,3,3,2))

    END FUNCTION sigmac

    FUNCTION wk_tophat(x)

    !The normlaised Fourier Transform of a top-hat
    REAL :: wk_tophat, x

    !Taylor expansion used for low x to avoid cancellation problems
    IF(x<0.01) THEN
        wk_tophat=1.-(x**2.)/10.
    ELSE
        wk_tophat=3.*(sin(x)-x*cos(x))/(x**3.)
    END IF

    END FUNCTION wk_tophat

    FUNCTION inttab(x,y,n,iorder)

    !Integrates tables y(x)dx
    REAL :: inttab
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x(n), y(n)
    REAL :: a, b, c, d, h
    REAL :: q1, q2, q3, qi, qf
    REAL :: x1, x2, x3, x4, y1, y2, y3, y4, xi, xf
    real(dl) :: sum
    INTEGER :: i, i1, i2, i3, i4
    INTEGER, INTENT(IN) :: iorder

    sum=0.d0

    IF(iorder==1) THEN

        !Sums over all Trapezia (a+b)*h/2
        DO i=1,n-1
            a=y(i+1)
            b=y(i)
            h=x(i+1)-x(i)
            sum=sum+(a+b)*h/2.d0
        END DO

    ELSE IF(iorder==2) THEN

        DO i=1,n-2

            x1=x(i)
            x2=x(i+1)
            x3=x(i+2)

            y1=y(i)
            y2=y(i+1)
            y3=y(i+2)

            CALL fit_quadratic(a,b,c,x1,y1,x2,y2,x3,y3)

            q1=a*(x1**3.)/3.+b*(x1**2.)/2.+c*x1
            q2=a*(x2**3.)/3.+b*(x2**2.)/2.+c*x2
            q3=a*(x3**3.)/3.+b*(x3**2.)/2.+c*x3

            !Takes value for first and last sections but averages over sections where you
            !have two independent estimates of the area
            IF(n==3) THEN
                sum=sum+q3-q1
            ELSE IF(i==1) THEN
                sum=sum+(q2-q1)+(q3-q2)/2.d0
            ELSE IF(i==n-2) THEN
                sum=sum+(q2-q1)/2.d0+(q3-q2)
            ELSE
                sum=sum+(q3-q1)/2.
            END IF

        END DO

    ELSE IF(iorder==3) THEN

        DO i=1,n-1

            !First choose the integers used for defining cubics for each section
            !First and last are different because the section does not lie in the *middle* of a cubic

            IF(i==1) THEN

                i1=1
                i2=2
                i3=3
                i4=4

            ELSE IF(i==n-1) THEN

                i1=n-3
                i2=n-2
                i3=n-1
                i4=n

            ELSE

                i1=i-1
                i2=i
                i3=i+1
                i4=i+2

            END IF

            x1=x(i1)
            x2=x(i2)
            x3=x(i3)
            x4=x(i4)

            y1=y(i1)
            y2=y(i2)
            y3=y(i3)
            y4=y(i4)

            CALL fit_cubic(a,b,c,d,x1,y1,x2,y2,x3,y3,x4,y4)

            !These are the limits of the particular section of integral
            xi=x(i)
            xf=x(i+1)

            qi=a*(xi**4.)/4.+b*(xi**3.)/3.+c*(xi**2.)/2.+d*xi
            qf=a*(xf**4.)/4.+b*(xf**3.)/3.+c*(xf**2.)/2.+d*xf

            sum=sum+qf-qi

        END DO

    ELSE

        ERROR STOP 'INTTAB: Error, order not specified correctly'

    END IF

    inttab=REAL(sum)

    END FUNCTION inttab

    FUNCTION sigma(r,z,itype,cosm)

    !Gets sigma(R)
    IMPLICIT NONE
    REAL :: sigma
    REAL, INTENT(IN) :: r, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL, PARAMETER :: acc=1d-3
    INTEGER, PARAMETER :: iorder=3
    REAL, PARAMETER :: rsplit=1d-2

    IF(r>=rsplit) THEN
        sigma=sqrt(sigint0(r,z,itype,cosm,acc,iorder))
    ELSE IF(r<rsplit) THEN
        sigma=sqrt(sigint1(r,z,itype,cosm,acc,iorder)+sigint2(r,z,itype,cosm,acc,iorder))
    ELSE
        STOP 'SIGMA: Error, something went wrong'
    END IF

    END FUNCTION sigma

    FUNCTION sigma_integrand(k,R,z,itype,cosm)

    !The integrand for the sigma(R) integrals
    IMPLICIT NONE
    REAL :: sigma_integrand
    REAL, INTENT(IN) :: k, R, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: y, w_hat

    IF(k==0.d0) THEN
        sigma_integrand=0.d0
    ELSE
        y=k*R
        w_hat=wk_tophat(y)
        sigma_integrand=p_lin(k,z,itype,cosm)*(w_hat**2)/k
    END IF

    END FUNCTION sigma_integrand

    FUNCTION sigma_integrand_transformed(t,R,f,z,itype,cosm)

    !The integrand for the sigma(R) integrals
    IMPLICIT NONE
    REAL :: sigma_integrand_transformed
    REAL, INTENT(IN) :: t, R, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: k, y, w_hat

    INTERFACE
    FUNCTION f(x)
    REAL :: f
    REAL, INTENT(IN) :: x
    END FUNCTION f
    END INTERFACE

    !Integrand to the sigma integral in terms of t. Defined by k=(1/t-1)/f(R) where f(R) is *any* function

    IF(t==0.d0) THEN
        !t=0 corresponds to k=infintiy when W(kR)=0.
        sigma_integrand_transformed=0.d0
    ELSE IF(t==1.d0) THEN
        !t=1 corresponds to k=0. when P(k)=0.
        sigma_integrand_transformed=0.d0
    ELSE
        !f(R) can be *any* function of R here to improve integration speed
        k=(-1.d0+1.d0/t)/f(R)
        y=k*R
        w_hat=wk_tophat(y)
        sigma_integrand_transformed=p_lin(k,z,itype,cosm)*(w_hat**2)/(t*(1.d0-t))
    END IF

    END FUNCTION sigma_integrand_transformed

    FUNCTION sigint0(r,z,itype,cosm,acc,iorder)

    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    IMPLICIT NONE
    REAL :: sigint0
    REAL, INTENT(IN) :: r, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL, INTENT(IN) :: acc
    INTEGER, INTENT(IN) :: iorder
    INTEGER :: i, j
    INTEGER :: n
    REAL :: x, dx
    REAL :: f1, f2, fx
    real(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=30
    REAL, PARAMETER :: a=0.d0 !Integration lower limit (corresponts to k=inf)
    REAL, PARAMETER :: b=1.d0 !Integration upper limit (corresponds to k=0)

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        sigint0=0.d0

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=sigma_integrand_transformed(a,r,f0_rapid,z,itype,cosm)
                f2=sigma_integrand_transformed(b,r,f0_rapid,z,itype,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*REAL(i-1)/REAL(n-1)
                    fx=sigma_integrand_transformed(x,r,f0_rapid,z,itype,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    STOP 'SIGINT0: Error, iorder specified incorrectly'
                END IF

            END IF

            IF((j>=jmin) .AND. (ABS(-1.d0+sum_new/sum_old)<acc)) THEN
                !jmin avoids spurious early convergence
                sigint0=REAL(sum_new)
                EXIT
            ELSE IF(j==jmax) THEN
                STOP 'SIGINT0: Integration timed out'
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION sigint0

    FUNCTION f0_rapid(r)

    !This is the 'rapidising' function to increase integration speed
    !for sigma(R). Found by trial-and-error
    IMPLICIT NONE
    REAL :: f0_rapid
    REAL, INTENT(IN) :: r
    REAL :: alpha
    REAL, PARAMETER :: rsplit=1d-2

    IF(r>rsplit) THEN
        !alpha 0.3-0.5 works well
        alpha=0.5d0
    ELSE
        !If alpha=1 this goes tits up
        !alpha 0.7-0.9 works well
        alpha=0.8d0
    END IF

    f0_rapid=r**alpha

    END FUNCTION f0_rapid

    FUNCTION sigint1(r,z,itype,cosm,acc,iorder)

    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    IMPLICIT NONE
    REAL :: sigint1
    REAL, INTENT(IN) :: r, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL, INTENT(IN) :: acc
    INTEGER, INTENT(IN) :: iorder
    REAL :: a, b
    INTEGER :: i, j
    INTEGER :: n
    REAL :: x, dx
    REAL :: f1, f2, fx
    real(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=30

    a=r/(r+r**.5d0)
    b=1.d0

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        sigint1=0.d0

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=sigma_integrand_transformed(a,r,f1_rapid,z,itype,cosm)
                f2=sigma_integrand_transformed(b,r,f1_rapid,z,itype,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*REAL(i-1)/REAL(n-1)
                    fx=sigma_integrand_transformed(x,r,f1_rapid,z,itype,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    STOP 'SIGINT1: Error, iorder specified incorrectly'
                END IF

            END IF

            IF((j>=jmin) .AND. (ABS(-1.d0+sum_new/sum_old)<acc)) THEN
                !jmin avoids spurious early convergence
                sigint1=REAL(sum_new)
                EXIT
            ELSE IF(j==jmax) THEN
                STOP 'SIGINT1: Integration timed out'
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION sigint1

    FUNCTION f1_rapid(r)

    !This is the 'rapidising' function to increase integration speed
    !for sigma(R). Found by trial-and-error
    IMPLICIT NONE
    REAL :: f1_rapid
    REAL, INTENT(IN) :: r
    REAL, PARAMETER :: alpha=0.5d0

    f1_rapid=r**alpha

    END FUNCTION f1_rapid

    FUNCTION sigint2(r,z,itype,cosm,acc,iorder)

    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    IMPLICIT NONE
    REAL :: sigint2
    REAL, INTENT(IN) :: r, z
    INTEGER, INTENT(IN) :: itype
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL, INTENT(IN) :: acc
    INTEGER, INTENT(IN) :: iorder
    REAL :: a, b
    INTEGER :: i, j
    INTEGER :: n
    REAL :: x, dx
    REAL :: f1, f2, fx
    real(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=30
    REAL, PARAMETER :: C=10.d0 !How far to go out in 1/r units for integral

    a=1.d0/r
    b=C/r

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        sigint2=0.d0

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=sigma_integrand(a,r,z,itype,cosm)
                f2=sigma_integrand(b,r,z,itype,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*REAL(i-1)/REAL(n-1)
                    fx=sigma_integrand(x,r,z,itype,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    STOP 'SIGINT2: Error, iorder specified incorrectly'
                END IF

            END IF

            IF((j>=jmin) .AND. (ABS(-1.d0+sum_new/sum_old)<acc)) THEN
                !jmin avoids spurious early convergence
                sigint2=REAL(sum_new)
                !WRITE(*,*) 'INTEGRATE_STORE: Nint:', n
                EXIT
            ELSE IF(j==jmax) THEN
                STOP 'SIGINT2: Integration timed out'
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION sigint2

    FUNCTION win(k,rv,c)

    !Selects the halo window function (k-space halo profile)
    REAL :: win
    REAL, INTENT(IN) :: k, rv, c

    !Choose the NFW analytic form
    win=winnfw(k,rv,c)

    !Correct for the case of disasters (a bit sloppy, not sure if this is ever used)
    IF(win>1.) win=1.
    IF(win<0.) win=0.

    END FUNCTION win

    FUNCTION winnfw(k,rv,c)

    !The analytic Fourier Transform of the NFW profile
    REAL :: winnfw
    REAL, INTENT(IN) :: k, rv, c
    REAL :: si1, si2, ci1, ci2, ks
    REAL :: p1, p2, p3

    !Define the scale wavenumber
    ks=k*rv/c

    !Sine and cosine integrals
    si1=Si(ks)
    si2=Si((1.+c)*ks)
    ci1=Ci(ks)
    ci2=Ci((1.+c)*ks)

    !These three parts sum to give the full W(k)
    p1=cos(ks)*(ci2-ci1)
    p2=sin(ks)*(si2-si1)
    p3=sin(ks*c)/(ks*(1.+c))

    !Create full W(k) and divide out mass factor
    winnfw=p1+p2-p3
    winnfw=winnfw/mass(c)

    END FUNCTION winnfw

    FUNCTION mass(c)

    !This calculates the (normalised) mass of a halo of concentration c
    !The 'normalised' mass is that divided by the prefactor r_s^3 4*pi rho_n
    !where rho_n is the profile normalisation [i.e, rho=rho_n/((r/r_s)*(1.+r/r_s)^2]
    REAL :: mass
    REAL, INTENT(IN) :: c

    mass=log(1.+c)-c/(1.+c)

    END FUNCTION mass

    FUNCTION gnu(nu)

    !Select the mass function
    REAL :: gnu
    REAL, INTENT(IN) :: nu

    !Sheth & Torman (1999)
    gnu=gst(nu)

    END FUNCTION gnu

    FUNCTION gst(nu)

    !Sheth & Tormen (1999) mass function!
    REAL :: gst
    REAL, INTENT(IN) :: nu
    REAL :: p, a, bigA

    !Note I use nu=dc/sigma whereas ST (1999) use nu=(dc/sigma)^2
    !This accounts for the different pre-factor and slighly changed nu dependence
    !f(nu^2)d(nu^2)=2*nu*f(nu)dnu

    !Sheth & Tormen fitting numbers
    p=0.3
    a=0.707
    bigA=0.21616

    !Full mass function. Note this is normalised such that integral f(nu)dnu = 1
    gst=bigA*(1.+((a*nu*nu)**(-p)))*exp(-a*nu*nu/2.)

    END FUNCTION gst

    FUNCTION Hubble2(z,cosm)

    !This calculates the dimensionless squared hubble parameter at redshift z (H/H_0)^2!
    !Ignores contributions from radiation (not accurate at high z, but consistent with simulations)!
    REAL :: Hubble2
    REAL, INTENT(IN) :: z
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: a

    a=1./(1.+z)

    Hubble2=cosm%om_m*(1.+z)**3+cosm%om_v*X_de(a,cosm)+(1.-cosm%om_m-cosm%om_v)*(1.+z)**2

    END FUNCTION Hubble2

    FUNCTION X_de(a,cosm)

    !The time evolution for dark energy: rho_de=rho_de,0 * X(a)
    !X(a)=1 for LCDM but changes for other models
    REAL :: X_de
    REAL, INTENT(IN) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    X_de=(a**(-3.*(1.+cosm%w+cosm%wa)))*exp(-3.*cosm%wa*(1.-a))

    END FUNCTION X_de

    FUNCTION w_de_hm(a,cosm)

    !The dark energy w(a) function
    REAL :: w_de_hm
    REAL, INTENT(IN) :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    w_de_hm=cosm%w+(1.-a)*cosm%wa

    END FUNCTION w_de_hm

    FUNCTION Omega_m_hm(z,cosm)

    !This calculates omega_m variations with z!
    REAL :: Omega_m_hm
    REAL, INTENT(IN) :: z
    REAL :: om_m, a
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    om_m=cosm%om_m
    Omega_m_hm=(om_m*(1.+z)**3.)/Hubble2(z,cosm)

    END FUNCTION Omega_m_hm

    FUNCTION grow(z,cosm)

    !Finds the scale-independent growth fuction at redshift z
    REAL :: grow
    REAL, INTENT(IN) :: z
    REAL :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    IF(z==0.) THEN
        grow=1.
    ELSE
        a=1./(1.+z)
        grow=find(a,cosm%a_growth,cosm%growth,cosm%ng,3,3,2)
    END IF

    END FUNCTION grow

    FUNCTION dispint(R,z,cosm)

    !Integrates between a and b until desired accuracy is reached
    !Stores information to reduce function calls
    IMPLICIT NONE
    REAL :: dispint
    REAL, INTENT(IN) :: z, R
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: a, b
    INTEGER :: i, j
    INTEGER :: n
    REAL :: x, dx
    REAL :: f1, f2, fx
    real(dl) :: sum_n, sum_2n, sum_new, sum_old
    INTEGER, PARAMETER :: jmin=5
    INTEGER, PARAMETER :: jmax=30
    REAL, PARAMETER :: acc=1d-3
    INTEGER, PARAMETER :: iorder=3

    !Integration range for integration parameter
    !Note 0 -> infinity in k has changed to 0 -> 1 in x
    a=0.d0
    b=1.d0

    IF(a==b) THEN

        !Fix the answer to zero if the integration limits are identical
        dispint=0.

    ELSE

        !Reset the sum variable for the integration
        sum_2n=0.d0
        sum_n=0.d0
        sum_old=0.d0
        sum_new=0.d0

        DO j=1,jmax

            !Note, you need this to be 1+2**n for some integer n
            !j=1 n=2; j=2 n=3; j=3 n=5; j=4 n=9; ...'
            n=1+2**(j-1)

            !Calculate the dx interval for this value of 'n'
            dx=(b-a)/REAL(n-1)

            IF(j==1) THEN

                !The first go is just the trapezium of the end points
                f1=dispint_integrand(a,R,z,cosm)
                f2=dispint_integrand(b,R,z,cosm)
                sum_2n=0.5d0*(f1+f2)*dx
                sum_new=sum_2n

            ELSE

                !Loop over only new even points to add these to the integral
                DO i=2,n,2
                    x=a+(b-a)*REAL(i-1)/REAL(n-1)
                    fx=dispint_integrand(x,R,z,cosm)
                    sum_2n=sum_2n+fx
                END DO

                !Now create the total using the old and new parts
                sum_2n=sum_n/2.d0+sum_2n*dx

                !Now calculate the new sum depending on the integration order
                IF(iorder==1) THEN
                    sum_new=sum_2n
                ELSE IF(iorder==3) THEN
                    sum_new=(4.d0*sum_2n-sum_n)/3.d0 !This is Simpson's rule and cancels error
                ELSE
                    STOP 'DISPINT: Error, iorder specified incorrectly'
                END IF

            END IF

            IF((j>=jmin) .AND. (ABS(-1.d0+sum_new/sum_old)<acc)) THEN
                !jmin avoids spurious early convergence
                dispint=REAL(sum_new)
                EXIT
            ELSE IF(j==jmax) THEN
                STOP 'DISPINT: Integration timed out'
            ELSE
                !Integral has not converged so store old sums and reset sum variables
                sum_old=sum_new
                sum_n=sum_2n
                sum_2n=0.d0
            END IF

        END DO

    END IF

    END FUNCTION dispint

    FUNCTION dispint_integrand(theta,R,z,cosm)

    !This is the integrand for the velocity dispersion integral
    IMPLICIT NONE
    REAL :: dispint_integrand
    REAL, INTENT(IN) :: theta, z, R
    TYPE(HM_cosmology), INTENT(IN) :: cosm
    REAL :: k
    REAL, PARAMETER :: alpha=1.65 !Speeds up integral for large 'R'
    REAL, PARAMETER :: Rsplit=10. !Value to impliment speed up

    !Note that I have not included the speed up alpha and Rsplit
    !The choice of alpha=1.65 seemed to work well for R=100.
    !Rsplit=10 is thoughlessly chosen (only because 100.>10.)
    !Including this seems to make things slower (faster integration but slower IF statements?)

    IF(theta==0. .OR. theta==1.) THEN
        dispint_integrand=0.
    ELSE
        !IF(r>Rsplit) THEN
        !   k=(-1.d0+1.d0/theta)/r**alpha
        !ELSE
        k=(-1.+1./theta)
        !END IF
        dispint_integrand=(p_lin(k,z,0,cosm)/k**2)*(wk_tophat(k*r)**2)/(theta*(1.-theta))
    END IF

    END FUNCTION dispint_integrand

    FUNCTION Si(x)

    !Calculates the 'sine integral' function Si(x)
    REAL :: Si
    REAL, INTENT(IN) :: x
    REAL(dl) :: x2, y, f, g, si8
    REAL(dl), PARAMETER :: pi=3.1415926535897932384626433d0

    !Expansions for high and low x thieved from Wikipedia, two different expansions for above and below 4.
    IF(ABS(x)<=4.) THEN

        x2=x*x

        si8 = x*(1.d0+x2*(-4.54393409816329991d-2+x2*(1.15457225751016682d-3&
            +x2*(-1.41018536821330254d-5+x2*(9.43280809438713025d-8+x2*(-3.53201978997168357d-10&
            +x2*(7.08240282274875911d-13+x2*(-6.05338212010422477d-16))))))))/ &
            (1.+x2*(1.01162145739225565d-2 +x2*(4.99175116169755106d-5+&
            x2*(1.55654986308745614d-7+x2*(3.28067571055789734d-10+x2*(4.5049097575386581d-13&
            +x2*(3.21107051193712168d-16)))))))

        Si=si8

    ELSE IF(ABS(x)>4.) THEN

        y=1.d0/(x*x)

        f = (1.d0 + y*(7.44437068161936700618d2 + y*(1.96396372895146869801d5 +&
            y*(2.37750310125431834034d7 +y*(1.43073403821274636888d9 + y*(4.33736238870432522765d10 &
            + y*(6.40533830574022022911d11 + y*(4.20968180571076940208d12 + &
            y*(1.00795182980368574617d13 + y*(4.94816688199951963482d12 +&
            y*(-4.94701168645415959931d11)))))))))))/ (x*(1. +y*(7.46437068161927678031d2 +&
            y*(1.97865247031583951450d5 +y*(2.41535670165126845144d7 + &
            y*(1.47478952192985464958d9 + y*(4.58595115847765779830d10 +&
            y*(7.08501308149515401563d11 + y*(5.06084464593475076774d12 + &
            y*(1.43468549171581016479d13 + y*(1.11535493509914254097d13)))))))))))


        g = y*(1.d0 + y*(8.1359520115168615d2 + y*(2.35239181626478200d5 + &
            y*(3.12557570795778731d7 + y*(2.06297595146763354d9 + y*(6.83052205423625007d10 +&
            y*(1.09049528450362786d12 + y*(7.57664583257834349d12 +y*(1.81004487464664575d13 +&
            y*(6.43291613143049485d12 +y*(-1.36517137670871689d12)))))))))))/&
            (1. + y*(8.19595201151451564d2 +y*(2.40036752835578777d5 + y*(3.26026661647090822d7 &
            + y*(2.23355543278099360d9 + y*(7.87465017341829930d10 + y*(1.39866710696414565d12 &
            + y*(1.17164723371736605d13 + y*(4.01839087307656620d13 +y*(3.99653257887490811d13))))))))))

        Si=pi/2.d0-f*cos(x)-g*sin(x)

    END IF

    END FUNCTION Si

    FUNCTION Ci(x)

    !Calculates the 'cosine integral' function Ci(x)
    REAL :: Ci
    REAL, INTENT(IN) :: x
    REAL(dl) :: x2, y, f, g, ci8
    REAL(dl), PARAMETER :: em_const=0.577215664901532861d0

    !Expansions for high and low x thieved from Wikipedia, two different expansions for above and below 4.
    IF(ABS(x)<=4.) THEN

        x2=x*x

        ci8=em_const+log(x)+x2*(-0.25d0+x2*(7.51851524438898291d-3+x2*(-1.27528342240267686d-4&
            +x2*(1.05297363846239184d-6+x2*(-4.68889508144848019d-9+x2*(1.06480802891189243d-11&
            +x2*(-9.93728488857585407d-15)))))))/ (1.+x2*(1.1592605689110735d-2+&
            x2*(6.72126800814254432d-5+x2*(2.55533277086129636d-7+x2*(6.97071295760958946d-10+&
            x2*(1.38536352772778619d-12+x2*(1.89106054713059759d-15+x2*(1.39759616731376855d-18))))))))

        Ci=ci8

    ELSE IF(ABS(x)>4.) THEN

        y=1./(x*x)

        f = (1.d0 + y*(7.44437068161936700618d2 + y*(1.96396372895146869801d5 + &
            y*(2.37750310125431834034d7 +y*(1.43073403821274636888d9 + y*(4.33736238870432522765d10&
            + y*(6.40533830574022022911d11 + y*(4.20968180571076940208d12 + y*(1.00795182980368574617d13&
            + y*(4.94816688199951963482d12 +y*(-4.94701168645415959931d11)))))))))))/&
            (x*(1. +y*(7.46437068161927678031d2 +y*(1.97865247031583951450d5 +&
            y*(2.41535670165126845144d7 + y*(1.47478952192985464958d9 + &
            y*(4.58595115847765779830d10 +y*(7.08501308149515401563d11 + y*(5.06084464593475076774d12 &
            + y*(1.43468549171581016479d13 + y*(1.11535493509914254097d13)))))))))))

        g = y*(1.d0 + y*(8.1359520115168615d2 + y*(2.35239181626478200d5 + y*(3.12557570795778731d7&
            + y*(2.06297595146763354d9 + y*(6.83052205423625007d10 +&
            y*(1.09049528450362786d12 + y*(7.57664583257834349d12 +&
            y*(1.81004487464664575d13 + y*(6.43291613143049485d12 +y*(-1.36517137670871689d12)))))))))))&
            / (1. + y*(8.19595201151451564d2 +y*(2.40036752835578777d5 +&
            y*(3.26026661647090822d7 + y*(2.23355543278099360d9 + y*(7.87465017341829930d10 &
            + y*(1.39866710696414565d12 + y*(1.17164723371736605d13 + y*(4.01839087307656620d13 +y*(3.99653257887490811d13))))))))))

        Ci=f*sin(x)-g*cos(x)

    END IF

    END FUNCTION Ci

    FUNCTION derivative_table(x,xin,yin,n,iorder,imeth)

    !Takes the derivative y'(x) at point x
    REAL :: derivative_table
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x, xin(n), yin(n)
    REAL, ALLOCATABLE ::  xtab(:), ytab(:)
    REAL :: a, b, c, d
    REAL :: x1, x2, x3, x4
    REAL :: y1, y2, y3, y4
    INTEGER :: i
    INTEGER, INTENT(IN) :: imeth, iorder

    !This version interpolates if the value is off either end of the array!
    !Care should be chosen to insert x, xtab, ytab as log if this might give better!
    !Results from the interpolation!

    !imeth = 1 => find x in xtab by crudely searching
    !imeth = 2 => find x in xtab quickly assuming the table is linearly spaced
    !imeth = 3 => find x in xtab using midpoint splitting (iterations=CEILING(log2(n)))

    !iorder = 1 => linear interpolation
    !iorder = 2 => quadratic interpolation
    !iorder = 3 => cubic interpolation

    ALLOCATE(xtab(n),ytab(n))

    xtab=xin
    ytab=yin

    IF(xtab(1)>xtab(n)) THEN
        !Reverse the arrays in this case
        CALL reverse(xtab,n)
        CALL reverse(ytab,n)
    END IF

    IF(iorder==1) THEN

        IF(n<2) ERROR STOP 'DERIVATIVE_TABLE: Not enough points in your table for linear interpolation'

        IF(x<=xtab(2)) THEN

            x2=xtab(2)
            x1=xtab(1)

            y2=ytab(2)
            y1=ytab(1)

        ELSE IF (x>=xtab(n-1)) THEN

            x2=xtab(n)
            x1=xtab(n-1)

            y2=ytab(n)
            y1=ytab(n-1)

        ELSE

            i=table_integer(x,xtab,n,imeth)

            x2=xtab(i+1)
            x1=xtab(i)

            y2=ytab(i+1)
            y1=ytab(i)

        END IF

        CALL fit_line(a,b,x1,y1,x2,y2)
        derivative_table=a

    ELSE IF(iorder==2) THEN

        IF(n<3) ERROR STOP 'DERIVATIVE_TABLE_QUADRATIC: Not enough points in your table'

        IF(x<=xtab(2) .OR. x>=xtab(n-1)) THEN

            IF(x<=xtab(2)) THEN

                x3=xtab(3)
                x2=xtab(2)
                x1=xtab(1)

                y3=ytab(3)
                y2=ytab(2)
                y1=ytab(1)

            ELSE IF (x>=xtab(n-1)) THEN

                x3=xtab(n)
                x2=xtab(n-1)
                x1=xtab(n-2)

                y3=ytab(n)
                y2=ytab(n-1)
                y1=ytab(n-2)

            END IF

            CALL fit_quadratic(a,b,c,x1,y1,x2,y2,x3,y3)

            derivative_table=2.*a*x+b

        ELSE

            i=table_integer(x,xtab,n,imeth)

            x1=xtab(i-1)
            x2=xtab(i)
            x3=xtab(i+1)
            x4=xtab(i+2)

            y1=ytab(i-1)
            y2=ytab(i)
            y3=ytab(i+1)
            y4=ytab(i+2)

            !In this case take the average of two separate quadratic spline values

            derivative_table=0.

            CALL fit_quadratic(a,b,c,x1,y1,x2,y2,x3,y3)
            derivative_table=derivative_table+(2.*a*x+b)/2.

            CALL fit_quadratic(a,b,c,x2,y2,x3,y3,x4,y4)
            derivative_table=derivative_table+(2.*a*x+b)/2.

        END IF

    ELSE IF(iorder==3) THEN

        IF(n<4) ERROR STOP 'DERIVATIVE_TABLE_CUBIC: Not enough points in your table'

        IF(x<=xtab(3)) THEN

            x4=xtab(4)
            x3=xtab(3)
            x2=xtab(2)
            x1=xtab(1)

            y4=ytab(4)
            y3=ytab(3)
            y2=ytab(2)
            y1=ytab(1)

        ELSE IF (x>=xtab(n-2)) THEN

            x4=xtab(n)
            x3=xtab(n-1)
            x2=xtab(n-2)
            x1=xtab(n-3)

            y4=ytab(n)
            y3=ytab(n-1)
            y2=ytab(n-2)
            y1=ytab(n-3)

        ELSE

            i=table_integer(x,xtab,n,imeth)

            x1=xtab(i-1)
            x2=xtab(i)
            x3=xtab(i+1)
            x4=xtab(i+2)

            y1=ytab(i-1)
            y2=ytab(i)
            y3=ytab(i+1)
            y4=ytab(i+2)

        END IF

        CALL fit_cubic(a,b,c,d,x1,y1,x2,y2,x3,y3,x4,y4)
        derivative_table=3.*a*(x**2.)+2.*b*x+c

    ELSE

        ERROR STOP 'DERIVATIVE_TABLE: Error, order not specified correctly'

    END IF

    END FUNCTION derivative_table

    FUNCTION find(x,xin,yin,n,iorder,ifind,imeth)

    !Given two arrays x and y this routine interpolates to find the y_i value at position x_i
    IMPLICIT NONE
    REAL :: find
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x, xin(n), yin(n)
    REAL, ALLOCATABLE ::  xtab(:), ytab(:)
    REAL :: a, b, c, d
    REAL :: x1, x2, x3, x4
    REAL :: y1, y2, y3, y4
    INTEGER :: i
    INTEGER, INTENT(IN) :: iorder, ifind, imeth

    !This version interpolates if the value is off either end of the array!
    !Care should be chosen to insert x, xtab, ytab as log if this might give better!
    !Results from the interpolation!

    !If the value required is off the table edge the interpolation is always linear

    !iorder = 1 => linear interpolation
    !iorder = 2 => quadratic interpolation
    !iorder = 3 => cubic interpolation

    !ifind = 1 => find x in xtab quickly assuming the table is linearly spaced
    !ifind = 2 => find x in xtab by crudely searching from x(1) to x(n)
    !ifind = 3 => find x in xtab using midpoint splitting (iterations=CEILING(log2(n)))

    !imeth = 1 => Uses cubic polynomials for interpolation
    !imeth = 2 => Uses Lagrange polynomials for interpolation

    ALLOCATE(xtab(n),ytab(n))

    xtab=xin
    ytab=yin

    IF(xtab(1)>xtab(n)) THEN
        !Reverse the arrays in this case
        CALL reverse(xtab,n)
        CALL reverse(ytab,n)
    END IF

    IF(x<xtab(1)) THEN

        !Do a linear interpolation beyond the table boundary

        x1=xtab(1)
        x2=xtab(2)

        y1=ytab(1)
        y2=ytab(2)

        IF(imeth==1) THEN
            CALL fit_line(a,b,x1,y1,x2,y2)
            find=a*x+b
        ELSE IF(imeth==2) THEN
            find=Lagrange_polynomial(x,1,(/x1,x2/),(/y1,y2/))
        ELSE
            STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE IF(x>xtab(n)) THEN

        !Do a linear interpolation beyond the table boundary

        x1=xtab(n-1)
        x2=xtab(n)

        y1=ytab(n-1)
        y2=ytab(n)

        IF(imeth==1) THEN
            CALL fit_line(a,b,x1,y1,x2,y2)
            find=a*x+b
        ELSE IF(imeth==2) THEN
            find=Lagrange_polynomial(x,1,(/x1,x2/),(/y1,y2/))
        ELSE
            STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE IF(iorder==1) THEN

        IF(n<2) STOP 'FIND: Not enough points in your table for linear interpolation'

        IF(x<=xtab(2)) THEN

            x1=xtab(1)
            x2=xtab(2)

            y1=ytab(1)
            y2=ytab(2)

        ELSE IF (x>=xtab(n-1)) THEN

            x1=xtab(n-1)
            x2=xtab(n)

            y1=ytab(n-1)
            y2=ytab(n)

        ELSE

            i=table_integer(x,xtab,n,ifind)

            x1=xtab(i)
            x2=xtab(i+1)

            y1=ytab(i)
            y2=ytab(i+1)

        END IF

        IF(imeth==1) THEN
            CALL fit_line(a,b,x1,y1,x2,y2)
            find=a*x+b
        ELSE IF(imeth==2) THEN
            find=Lagrange_polynomial(x,1,(/x1,x2/),(/y1,y2/))
        ELSE
            STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE IF(iorder==2) THEN

        IF(n<3) STOP 'FIND: Not enough points in your table'

        IF(x<=xtab(2) .OR. x>=xtab(n-1)) THEN

            IF(x<=xtab(2)) THEN

                x1=xtab(1)
                x2=xtab(2)
                x3=xtab(3)

                y1=ytab(1)
                y2=ytab(2)
                y3=ytab(3)

            ELSE IF (x>=xtab(n-1)) THEN

                x1=xtab(n-2)
                x2=xtab(n-1)
                x3=xtab(n)

                y1=ytab(n-2)
                y2=ytab(n-1)
                y3=ytab(n)

            END IF

            IF(imeth==1) THEN
                CALL fit_quadratic(a,b,c,x1,y1,x2,y2,x3,y3)
                find=a*(x**2)+b*x+c
            ELSE IF(imeth==2) THEN
                find=Lagrange_polynomial(x,2,(/x1,x2,x3/),(/y1,y2,y3/))
            ELSE
                STOP 'FIND: Error, method not specified correctly'
            END IF

        ELSE

            i=table_integer(x,xtab,n,ifind)

            x1=xtab(i-1)
            x2=xtab(i)
            x3=xtab(i+1)
            x4=xtab(i+2)

            y1=ytab(i-1)
            y2=ytab(i)
            y3=ytab(i+1)
            y4=ytab(i+2)

            IF(imeth==1) THEN
                !In this case take the average of two separate quadratic spline values
                CALL fit_quadratic(a,b,c,x1,y1,x2,y2,x3,y3)
                find=(a*x**2+b*x+c)/2.
                CALL fit_quadratic(a,b,c,x2,y2,x3,y3,x4,y4)
                find=find+(a*x**2+b*x+c)/2.
            ELSE IF(imeth==2) THEN
                !In this case take the average of two quadratic Lagrange polynomials
                find=(Lagrange_polynomial(x,2,(/x1,x2,x3/),(/y1,y2,y3/))+Lagrange_polynomial(x,2,(/x2,x3,x4/),(/y2,y3,y4/)))/2.
            ELSE
                STOP 'FIND: Error, method not specified correctly'
            END IF

        END IF

    ELSE IF(iorder==3) THEN

        IF(n<4) STOP 'FIND: Not enough points in your table'

        IF(x<=xtab(3)) THEN

            x1=xtab(1)
            x2=xtab(2)
            x3=xtab(3)
            x4=xtab(4)

            y1=ytab(1)
            y2=ytab(2)
            y3=ytab(3)
            y4=ytab(4)

        ELSE IF (x>=xtab(n-2)) THEN

            x1=xtab(n-3)
            x2=xtab(n-2)
            x3=xtab(n-1)
            x4=xtab(n)

            y1=ytab(n-3)
            y2=ytab(n-2)
            y3=ytab(n-1)
            y4=ytab(n)

        ELSE

            i=table_integer(x,xtab,n,ifind)

            x1=xtab(i-1)
            x2=xtab(i)
            x3=xtab(i+1)
            x4=xtab(i+2)

            y1=ytab(i-1)
            y2=ytab(i)
            y3=ytab(i+1)
            y4=ytab(i+2)

        END IF

        IF(imeth==1) THEN
            CALL fit_cubic(a,b,c,d,x1,y1,x2,y2,x3,y3,x4,y4)
            find=a*x**3+b*x**2+c*x+d
        ELSE IF(imeth==2) THEN
            find=Lagrange_polynomial(x,3,(/x1,x2,x3,x4/),(/y1,y2,y3,y4/))
        ELSE
            STOP 'FIND: Error, method not specified correctly'
        END IF

    ELSE

        STOP 'FIND: Error, interpolation order specified incorrectly'

    END IF

    END FUNCTION find

    FUNCTION table_integer(x,xtab,n,imeth)

    !Chooses between ways to find the integer location below some value in an array
    IMPLICIT NONE
    INTEGER :: table_integer
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x, xtab(n)
    INTEGER, INTENT(IN) :: imeth

    IF(imeth==1) THEN
        table_integer=linear_table_integer(x,xtab,n)
    ELSE IF(imeth==2) THEN
        table_integer=search_int(x,xtab,n)
    ELSE IF(imeth==3) THEN
        table_integer=int_split(x,xtab,n)
    ELSE
        STOP 'TABLE INTEGER: Method specified incorrectly'
    END IF

    END FUNCTION table_integer

    FUNCTION linear_table_integer(x,xtab,n)

    !Assuming the table is exactly linear this gives you the integer position
    IMPLICIT NONE
    INTEGER :: linear_table_integer
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x, xtab(n)
    REAL :: x1, x2, xn
    REAL, PARAMETER :: acc=1d-3 !Test for linear table

    !Returns the integer (table position) below the value of x
    !eg. if x(3)=6. and x(4)=7. and x=6.5 this will return 6
    !Assumes table is organised linearly (care for logs)

    !n=SIZE(xtab)
    x1=xtab(1)
    x2=xtab(2)
    xn=xtab(n)

    IF(x1>xn) STOP 'LINEAR_TABLE_INTEGER :: table in the wrong order'
    IF(ABS(-1.+float(n-1)*(x2-x1)/(xn-x1))>acc) STOP 'LINEAR_TABLE_INTEGER :: table does not seem to be linear'

    linear_table_integer=1+FLOOR(float(n-1)*(x-x1)/(xn-x1))

    END FUNCTION linear_table_integer

    FUNCTION search_int(x,xtab,n)

    !Does a stupid search through the table from beginning to end to find integer
    IMPLICIT NONE
    INTEGER :: search_int
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x, xtab(n)
    INTEGER :: i

    IF(xtab(1)>xtab(n)) STOP 'SEARCH_INT: table in wrong order'

    DO i=1,n
        IF(x>=xtab(i) .AND. x<=xtab(i+1)) EXIT
    END DO

    search_int=i

    END FUNCTION search_int

    FUNCTION int_split(x,xtab,n)

    !Finds the position of the value in the table by continually splitting it in half
    IMPLICIT NONE
    INTEGER :: int_split
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(IN) :: x, xtab(n)
    INTEGER :: i1, i2, imid

    IF(xtab(1)>xtab(n)) STOP 'INT_SPLIT: table in wrong order'

    i1=1
    i2=n

    DO

        imid=NINT((i1+i2)/2.)

        IF(x<xtab(imid)) THEN
            i2=imid
        ELSE
            i1=imid
        END IF

        IF(i2==i1+1) EXIT

    END DO

    int_split=i1

    END FUNCTION int_split

    SUBROUTINE fit_line(a1,a0,x1,y1,x2,y2)

    !Given xi, yi i=1,2 fits a line between these points
    IMPLICIT NONE
    REAL, INTENT(OUT) :: a0, a1
    REAL, INTENT(IN) :: x1, y1, x2, y2

    a1=(y2-y1)/(x2-x1)
    a0=y1-a1*x1

    END SUBROUTINE fit_line

    SUBROUTINE fit_quadratic(a2,a1,a0,x1,y1,x2,y2,x3,y3)

    !Given xi, yi i=1,2,3 fits a quadratic between these points
    IMPLICIT NONE
    REAL, INTENT(OUT) :: a0, a1, a2
    REAL, INTENT(IN) :: x1, y1, x2, y2, x3, y3

    a2=((y2-y1)/(x2-x1)-(y3-y1)/(x3-x1))/(x2-x3)
    a1=(y2-y1)/(x2-x1)-a2*(x2+x1)
    a0=y1-a2*(x1**2)-a1*x1

    END SUBROUTINE fit_quadratic

    SUBROUTINE fit_cubic(a,b,c,d,x1,y1,x2,y2,x3,y3,x4,y4)

    !Given xi, yi i=1,2,3,4 fits a cubic between these points
    IMPLICIT NONE
    REAL, INTENT(OUT) :: a, b, c, d
    REAL, INTENT(IN) :: x1, y1, x2, y2, x3, y3, x4, y4
    REAL :: f1, f2, f3

    f1=(y4-y1)/((x4-x2)*(x4-x1)*(x4-x3))
    f2=(y3-y1)/((x3-x2)*(x3-x1)*(x4-x3))
    f3=(y2-y1)/((x2-x1)*(x4-x3))*(1./(x4-x2)-1./(x3-x2))

    a=f1-f2-f3

    f1=(y3-y1)/((x3-x2)*(x3-x1))
    f2=(y2-y1)/((x2-x1)*(x3-x2))
    f3=a*(x3+x2+x1)

    b=f1-f2-f3

    f1=(y4-y1)/(x4-x1)
    f2=a*(x4**2+x4*x1+x1**2)
    f3=b*(x4+x1)

    c=f1-f2-f3

    d=y1-a*x1**3-b*x1**2-c*x1

    END SUBROUTINE fit_cubic

    FUNCTION Lagrange_polynomial(x,n,xv,yv)

    !Computes the result of the nth order Lagrange polynomial at point x, L(x)
    IMPLICIT NONE
    REAL :: Lagrange_polynomial
    REAL, INTENT(IN) :: x, xv(n+1), yv(n+1)
    REAL :: l(n+1)
    INTEGER, INTENT(IN) :: n
    INTEGER :: i, j

    !Initialise variables, one for sum and one for multiplication
    Lagrange_polynomial=0.
    l=1.

    !Loops to find the polynomials, one is a sum and one is a multiple
    DO i=0,n
        DO j=0,n
            IF(i .NE. j) l(i+1)=l(i+1)*(x-xv(j+1))/(xv(i+1)-xv(j+1))
        END DO
        Lagrange_polynomial=Lagrange_polynomial+l(i+1)*yv(i+1)
    END DO

    END FUNCTION Lagrange_polynomial

    SUBROUTINE reverse(arry,n)

    !This reverses the contents of arry!
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: n
    REAL, INTENT(INOUT) :: arry(n)
    INTEGER :: i
    REAL, ALLOCATABLE :: hold(:)

    ALLOCATE(hold(n))

    hold=arry

    DO i=1,n
        arry(i)=hold(n-i+1)
    END DO

    DEALLOCATE(hold)

    END SUBROUTINE reverse

    SUBROUTINE fill_growtab(cosm)

    !Fills a table of values of the scale-independent growth function
    TYPE(HM_cosmology) :: cosm
    INTEGER :: i
    REAL :: a, norm
    REAL, ALLOCATABLE :: d_tab(:), v_tab(:), a_tab(:)
    REAL :: ainit, amax, dinit, vinit
    REAL :: acc
    INTEGER, PARAMETER :: n=64

    !The calculation should start at a z when Om_m(z)=1., so that the assumption
    !of starting in the g\propto a growing mode is valid (this will not work for early DE)
    ainit=0.001
    !Final should be a=1. unless considering models in the future
    amax=1.

    !These set the initial conditions to be the Om_m=1. growing mode
    dinit=ainit
    vinit=1.

    !Overall accuracy for the ODE solver
    acc=1d-3

    IF(HM_verbose) WRITE(*,*) 'GROWTH: Solving growth equation'
    CALL ode_growth(d_tab,v_tab,a_tab,0.,ainit,amax,dinit,vinit,acc,3,cosm)
    IF(HM_verbose) WRITE(*,*) 'GROWTH: ODE done'

    !Normalise so that g(z=0)=1
    norm=find(1.,a_tab,d_tab,SIZE(a_tab),3,3,2)
    IF(HM_verbose) WRITE(*,*) 'GROWTH: Unnormalised g(a=1):', norm
    d_tab=d_tab/norm

    !Could use some table-interpolation routine here to save time
    IF(ALLOCATED(cosm%a_growth)) DEALLOCATE(cosm%a_growth)
    IF(ALLOCATED(cosm%growth)) DEALLOCATE(cosm%growth)

    cosm%ng=n
    ALLOCATE(cosm%a_growth(n),cosm%growth(n))
    DO i=1,n
        a=ainit+(amax-ainit)*float(i-1)/float(n-1)
        cosm%a_growth(i)=a
        cosm%growth(i)=find(a,a_tab,d_tab,SIZE(a_tab),3,3,2)
    END DO

    IF(HM_verbose) WRITE(*,*) 'GROWTH: Done'
    IF(HM_verbose) WRITE(*,*)

    END SUBROUTINE fill_growtab

    SUBROUTINE ode_growth(x,v,t,kk,ti,tf,xi,vi,acc,imeth,cosm)

    !Solves 2nd order ODE x''(t) from ti to tf and writes out array of x, v, t values
    IMPLICIT NONE
    REAL :: xi, ti, tf, dt, acc, vi, x4, v4, t4, kk
    REAL :: kx1, kx2, kx3, kx4, kv1, kv2, kv3, kv4
    REAL(dl), ALLOCATABLE :: x8(:), t8(:), v8(:), xh(:), th(:), vh(:)
    REAL, ALLOCATABLE :: x(:), v(:), t(:)
    INTEGER :: i, j, k, n, np, ifail, kn, imeth
    TYPE(HM_cosmology) :: cosm
    INTEGER, PARAMETER :: jmax=30
    INTEGER, PARAMETER :: ninit=100

    !xi and vi are the initial values of x and v (i.e. x(ti), v(ti))
    !fx is what x' is equal to
    !fv is what v' is equal to
    !acc is the desired accuracy across the entire solution
    !imeth selects method

    IF(ALLOCATED(x)) DEALLOCATE(x)
    IF(ALLOCATED(v)) DEALLOCATE(v)
    IF(ALLOCATED(t)) DEALLOCATE(t)

    DO j=1,jmax

        !Set the number of points for the forward integration
        n=ninit*(2**(j-1))
        n=n+1

        !Allocate arrays
        ALLOCATE(x8(n),t8(n),v8(n))

        !Set the arrays to initialy be zeroes (is this neceseary?)
        x8=0.d0
        t8=0.d0
        v8=0.d0

        !Set the intial conditions at the intial time
        x8(1)=xi
        v8(1)=vi

        !Fill up a table for the time values
        CALL fill_table8(DBLE(ti),DBLE(tf),t8,n)

        !Set the time interval
        dt=(tf-ti)/float(n-1)

        !Intially fix this to zero. It will change to 1 if method is a 'failure'
        ifail=0

        DO i=1,n-1

            x4=real(x8(i))
            v4=real(v8(i))
            t4=real(t8(i))

            IF(imeth==1) THEN

                !Crude method
                kx1=dt*fd(x4,v4,kk,t4,cosm)
                kv1=dt*fv(x4,v4,kk,t4,cosm)

                x8(i+1)=x8(i)+kx1
                v8(i+1)=v8(i)+kv1

            ELSE IF(imeth==2) THEN

                !Mid-point method
                !2017/06/18 - There was a bug in this part before. Luckily it was not used. Thanks Dipak Munshi.
                kx1=dt*fd(x4,v4,kk,t4,cosm)
                kv1=dt*fv(x4,v4,kk,t4,cosm)
                kx2=dt*fd(x4+kx1/2.,v4+kv1/2.,kk,t4+dt/2.,cosm)
                kv2=dt*fv(x4+kx1/2.,v4+kv1/2.,kk,t4+dt/2.,cosm)

                x8(i+1)=x8(i)+kx2
                v8(i+1)=v8(i)+kv2

            ELSE IF(imeth==3) THEN

                !4th order Runge-Kutta method (fast!)
                kx1=dt*fd(x4,v4,kk,t4,cosm)
                kv1=dt*fv(x4,v4,kk,t4,cosm)
                kx2=dt*fd(x4+kx1/2.,v4+kv1/2.,kk,t4+dt/2.,cosm)
                kv2=dt*fv(x4+kx1/2.,v4+kv1/2.,kk,t4+dt/2.,cosm)
                kx3=dt*fd(x4+kx2/2.,v4+kv2/2.,kk,t4+dt/2.,cosm)
                kv3=dt*fv(x4+kx2/2.,v4+kv2/2.,kk,t4+dt/2.,cosm)
                kx4=dt*fd(x4+kx3,v4+kv3,kk,t4+dt,cosm)
                kv4=dt*fv(x4+kx3,v4+kv3,kk,t4+dt,cosm)

                x8(i+1)=x8(i)+(kx1+(2.*kx2)+(2.*kx3)+kx4)/6.
                v8(i+1)=v8(i)+(kv1+(2.*kv2)+(2.*kv3)+kv4)/6.

            END IF

            !t8(i+1)=t8(i)+dt

        END DO

        IF(j==1) ifail=1

        IF(j .NE. 1) THEN

            np=1+(n-1)/2

            DO k=1,1+(n-1)/2

                kn=2*k-1

                IF(ifail==0) THEN

                    IF(xh(k)>acc .AND. x8(kn)>acc .AND. (ABS(xh(k)/x8(kn))-1.)>acc) ifail=1
                    IF(vh(k)>acc .AND. v8(kn)>acc .AND. (ABS(vh(k)/v8(kn))-1.)>acc) ifail=1

                    IF(ifail==1) THEN
                        DEALLOCATE(xh,th,vh)
                        EXIT
                    END IF

                END IF
            END DO

        END IF

        IF(ifail==0) THEN
            ALLOCATE(x(n),t(n),v(n))
            x=real(x8)
            v=real(v8)
            t=real(t8)
            EXIT
        END IF

        ALLOCATE(xh(n),th(n),vh(n))
        xh=x8
        vh=v8
        th=t8
        DEALLOCATE(x8,t8,v8)

    END DO

    END SUBROUTINE ode_growth

    FUNCTION fv(d,v,k,a,cosm)

    !v'=f(v) in ODE solver
    REAL :: fv
    REAL, INTENT(IN) :: d, v, k, a
    REAL :: f1, f2, z
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    z=-1.+(1./a)

    f1=3.*Omega_m_hm(z,cosm)*d/(2.*(a**2.))
    f2=(2.+AH(z,cosm)/Hubble2(z,cosm))*(v/a)

    fv=f1-f2

    END FUNCTION fv

    FUNCTION fd(d,v,k,a,cosm)

    !d'=f(d) in ODE solver
    REAL :: fd
    REAL, INTENT(IN) :: d, v, k, a
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    fd=v

    END FUNCTION fd

    FUNCTION AH(z,cosm)

    !The Hubble acceleration function \ddot{a}/a
    REAL :: AH
    REAL, INTENT(IN) :: z
    REAL :: a
    TYPE(HM_cosmology), INTENT(IN) :: cosm

    a=1./(1.+z)
    AH=cosm%om_m*(a**(-3.))+cosm%om_v*(1.+3.*w_de_hm(a,cosm))*x_de(a,cosm)
    AH=-AH/2.

    END FUNCTION AH

    !!AM End HMcode

    subroutine PKequal(redshift,w_lam,wa_ppf,w_hf,wa_hf)
    !used by halofit_casarini: arXiv:0810.0190, arXiv:1601.07230
    implicit none
    real(dl) :: redshift,w_lam,wa_ppf,w_hf,wa_hf
    real(dl) :: z_star,tau_star,dlsb,dlsb_eq,w_true,wa_true,error

    z_star=ThermoDerivedParams( derived_zstar )
    tau_star=TimeOfz(z_star)
    dlsb=TimeOfz(redshift)-tau_star
    w_true=w_lam
    wa_true=wa_ppf
    wa_ppf=0._dl
    do
        z_star=ThermoDerivedParams( derived_zstar )
        tau_star=TimeOfz(z_star)
        dlsb_eq=TimeOfz(redshift)-tau_star
        error=1.d0-dlsb_eq/dlsb
        if (abs(error).le.1e-7) exit
        w_lam=w_lam*(1+error)**10.d0
    enddo
    w_hf=w_lam
    wa_hf=0._dl
    w_lam=w_true
    wa_ppf=wa_true
    write(*,*)'at z = ',real(redshift),' equivalent w_const =', real(w_hf)

    end subroutine PKequal


    end module NonLinear


    !workaround for f90 circular-module reference
    subroutine NonLinear_GetRatios(CAMB_Pk)
    use Transfer
    use NonLinear
    type(MatterPowerData) :: CAMB_Pk

    call NonLinear_GetNonLinRatios(CAMB_Pk)

    end subroutine NonLinear_GetRatios



    subroutine NonLinear_GetRatios_all(CAMB_Pk)
    use Transfer
    use NonLinear
    type(MatterPowerData) :: CAMB_Pk

    call MpiStop('Halofit module doesn''t support non-linear velocities')

    end subroutine NonLinear_GetRatios_All

    !Module of generally useful routines and definitions
    !Antony Lewis, http://cosmologist.info/

    !April 2006: fix to TList_RealArr_Thin
    !March 2008: fix to Ranges
    !June 2010: fixed bug in  DeleteFile gradually using up file units

    module Ranges
    !A collection of ranges, consisting of sections of minimum step size
    implicit none

    integer, parameter :: Max_Ranges = 100
    double precision, parameter :: RangeTol = 0.1d0
    !fraction of bin width we are prepared for merged bin widths to increase by

    Type Region
        integer start_index
        integer steps
        logical :: IsLog
        double precision Low, High
        double precision delta
        double precision delta_max, delta_min !for log spacing, the non-log max and min step size
    end Type Region

    Type Regions

        integer count
        integer npoints
        double precision Lowest, Highest
        Type(Region) :: R(Max_ranges)
        logical :: has_dpoints
        double precision, dimension(:), pointer :: points => null(), dpoints => null()
        !dpoints is (points(i+1)-points(i-1))/2

    end Type Regions

    contains

    subroutine Ranges_Init(R)
    Type(Regions) R

    call Ranges_Free(R)

    end  subroutine Ranges_Init

    subroutine Ranges_Free(R)
    Type(Regions) R
    integer status

    deallocate(R%points,stat = status)
    deallocate(R%dpoints,stat = status)
    call Ranges_Nullify(R)

    end  subroutine Ranges_Free


    subroutine Ranges_Nullify(R)
    Type(Regions) R

    nullify(R%points)
    nullify(R%dpoints)
    R%count = 0
    R%npoints = 0
    R%has_dpoints = .false.


    end subroutine Ranges_Nullify

    subroutine Ranges_Assign(R,Rin)
    Type(Regions) R, Rin

    call Ranges_Init(R)
    R = Rin
    nullify(R%points,R%dpoints)
    if (associated(Rin%points)) then
        call Ranges_GetArray(R, associated(Rin%dpoints))
    end if

    end subroutine Ranges_Assign

    function Ranges_IndexOf(Reg, tau) result(pointstep)
    Type(Regions), intent(in), target :: Reg
    Type(Region), pointer :: AReg
    double precision :: tau
    integer pointstep
    integer i


    pointstep=0
    do i=1,Reg%count
        AReg => Reg%R(i)

        if (tau < AReg%High .and. tau >= AReg%Low) then
            if (AReg%IsLog) then
                pointstep = AReg%start_index + int( log(tau/AReg%Low)/AReg%delta)
            else
                pointstep = AReg%start_index + int(( tau - AReg%Low)/AReg%delta)
            end if
            return
        end if

    end do

    if (tau >= Reg%Highest) then
        pointstep = Reg%npoints
    else
        write (*,*) 'Ranges_IndexOf: value out of range'
        stop
    end if

    end function Ranges_IndexOf


    subroutine Ranges_GetArray(Reg, want_dpoints)
    Type(Regions), target :: Reg
    Type(Region), pointer :: AReg
    logical, intent(in), optional :: want_dpoints
    integer status,i,j,ix


    if (present(want_dpoints)) then
        Reg%has_dpoints = want_dpoints
    else
        Reg%has_dpoints = .true.
    end if

    deallocate(Reg%points,stat = status)
    allocate(Reg%points(Reg%npoints))

    ix=0
    do i=1, Reg%count
        AReg => Reg%R(i)
        do j = 0, AReg%steps-1
            ix=ix+1
            if (AReg%IsLog) then
                Reg%points(ix) = AReg%Low*exp(j*AReg%delta)
            else
                Reg%points(ix) = AReg%Low + AReg%delta*j
            end if
        end do
    end do
    ix =ix+1
    Reg%points(ix) = Reg%Highest
    if (ix /= Reg%npoints) stop 'Ranges_GetArray: ERROR'

    if (Reg%has_dpoints) call Ranges_Getdpoints(Reg)

    end subroutine Ranges_GetArray


    subroutine Ranges_Getdpoints(Reg, half_ends)
    Type(Regions), target :: Reg
    logical, intent(in), optional :: half_ends
    integer i, status
    logical halfs

    if (present(half_ends)) then
        halfs = half_ends
    else
        halfs = .true.
    end if

    deallocate(Reg%dpoints,stat = status)
    allocate(Reg%dpoints(Reg%npoints))

    do i=2, Reg%npoints-1
        Reg%dpoints(i) = (Reg%points(i+1) - Reg%points(i-1))/2
    end do
    if (halfs) then
        Reg%dpoints(1) = (Reg%points(2) - Reg%points(1))/2
        Reg%dpoints(Reg%npoints) = (Reg%points(Reg%npoints) - Reg%points(Reg%npoints-1))/2
    else
        Reg%dpoints(1) = (Reg%points(2) - Reg%points(1))
        Reg%dpoints(Reg%npoints) = (Reg%points(Reg%npoints) - Reg%points(Reg%npoints-1))
    end if
    end subroutine Ranges_Getdpoints


    subroutine Ranges_Add_delta(Reg, t_start, t_end, t_approx_delta, IsLog)
    Type(Regions), target :: Reg
    logical, intent(in), optional :: IsLog
    double precision, intent(in) :: t_start, t_end, t_approx_delta
    integer n
    logical :: WantLog

    if (present(IsLog)) then
        WantLog = IsLog
    else
        WantLog = .false.
    end if

    if (t_end <= t_start) &
        stop 'Ranges_Add_delta: end must be larger than start'
    if (t_approx_delta <=0) stop 'Ranges_Add_delta: delta must be > 0'

    if (WantLog) then
        n  = max(1,int(log(t_end/t_start)/t_approx_delta + 1.d0 - RangeTol))
    else
        n  = max(1,int((t_end-t_start)/t_approx_delta + 1.d0 - RangeTol))
    end if
    call Ranges_Add(Reg,t_start, t_end, n, WantLog)

    end subroutine Ranges_Add_delta


    subroutine Ranges_Add(Reg, t_start, t_end, nstep, IsLog)
    Type(Regions), target :: Reg
    logical, intent(in), optional :: IsLog
    double precision, intent(in) :: t_start, t_end
    integer, intent(in) :: nstep
    Type(Region), pointer :: AReg, LastReg
    Type(Region), target :: NewRegions(Max_Ranges)
    double precision EndPoints(0:Max_Ranges*2)
    integer ixin, nreg, ix, i,j, nsteps
    double precision delta
    logical WantLog
    double precision min_request, max_request, min_log_step, max_log_step, diff, max_delta
    double precision RequestDelta(Max_Ranges)

    if (present(IsLog)) then
        WantLog = IsLog
    else
        WantLog = .false.
    end if

    if (WantLog) then
        delta = log(t_end/t_start) / nstep
    else
        delta = (t_end - t_start) / nstep
    end if

    if (t_end <= t_start) stop 'Ranges_Add: end must be larger than start'
    if (nstep <=0) stop 'Ranges_Add: nstep must be > 0'
    if (Reg%Count>= Max_Ranges) stop 'Ranges_Add: Increase Max_Ranges'

    !avoid IBM compiler bug, from Angel de Vicente
    !    if (Reg%count > 0) NewRegions(1:Reg%count) = Reg%R(1:Reg%count)
    if (Reg%count > 0) THEN
        DO i=1,Reg%count
            NewRegions(i) = Reg%R(i)
        END DO
    END IF
    nreg = Reg%count + 1
    AReg=> NewRegions(nreg)
    AReg%Low = t_start
    AReg%High = t_end
    AReg%delta = delta
    AReg%steps = nstep
    AReg%IsLog = WantLog

    !Get end point in order
    ix = 0
    do i=1, nreg

        AReg => NewRegions(i)
        if (ix==0) then
            ix = 1
            EndPoints(ix) = AReg%Low
            ix = 2
            EndPoints(ix) = AReg%High
        else
            ixin = ix
            do j=1,ixin
                if (AReg%Low < EndPoints(j)) then
                    EndPoints(j+1:ix+1) = EndPoints(j:ix)
                    EndPoints(j) = AReg%Low
                    ix=ix+1
                    exit
                end if
            end do
            if (ixin == ix) then
                ix = ix+1
                EndPoints(ix) = AReg%Low
                ix = ix+1
                EndPoints(ix) = AReg%High
            else
                ixin = ix
                do j=1,ixin
                    if (AReg%High < EndPoints(j)) then
                        EndPoints(j+1:ix+1) = EndPoints(j:ix)
                        EndPoints(j) = AReg%High
                        ix=ix+1
                        exit
                    end if
                end do
                if (ixin == ix) then
                    ix = ix+1
                    EndPoints(ix) = AReg%High
                end if

            end if
        end if

    end do

    !remove duplicate points
    ixin = ix
    ix = 1
    do i=2, ixin
        if (EndPoints(i) /= EndPoints(ix)) then
            ix=ix+1
            EndPoints(ix) = EndPoints(i)
        end if
    end do


    !ix is the number of end points
    Reg%Lowest = EndPoints(1)
    Reg%Highest = EndPoints(ix)
    Reg%count = 0

    max_delta = Reg%Highest - Reg%Lowest

    do i=1, ix - 1
        AReg => Reg%R(i)
        AReg%Low = EndPoints(i)
        AReg%High = EndPoints(i+1)

        !          max_delta = EndPoints(i+1) - EndPoints(i)
        delta = max_delta
        AReg%IsLog = .false.

        do j=1, nreg
            if (AReg%Low >= NewRegions(j)%Low .and. Areg%Low < NewRegions(j)%High) then
                if (NewRegions(j)%IsLog) then
                    if (AReg%IsLog) then
                        delta = min(delta,NewRegions(j)%delta)
                    else
                        min_log_step = AReg%Low*(exp(NewRegions(j)%delta)-1)
                        if (min_log_step < delta) then
                            max_log_step = AReg%High*(1-exp(-NewRegions(j)%delta))
                            if  (delta < max_log_step) then
                                delta = min_log_step
                            else
                                AReg%IsLog = .true.
                                delta = NewRegions(j)%delta
                            end if
                        end if
                    end if
                else !NewRegion is not log
                    if (AReg%IsLog) then
                        max_log_step = AReg%High*(1-exp(-delta))
                        if (NewRegions(j)%delta < max_log_step) then
                            min_log_step = AReg%Low*(exp(delta)-1)
                            if (min_log_step <  NewRegions(j)%delta) then
                                AReg%IsLog = .false.
                                delta =  min_log_step
                            else
                                delta = - log(1- NewRegions(j)%delta/AReg%High)
                            end if
                        end if
                    else
                        delta = min(delta, NewRegions(j)%delta)
                    end if
                end if
            end if
        end do

        if (AReg%IsLog) then
            Diff = log(AReg%High/AReg%Low)
        else
            Diff = AReg%High - AReg%Low
        endif
        if (delta >= Diff) then
            AReg%delta = Diff
            AReg%steps = 1
        else
            AReg%steps  = max(1,int(Diff/delta + 1.d0 - RangeTol))
            AReg%delta = Diff / AReg%steps
        end if

        Reg%count = Reg%count + 1
        RequestDelta(Reg%Count) = delta

        if (AReg%IsLog) then
            if (AReg%steps ==1) then
                AReg%Delta_min = AReg%High - AReg%Low
                AReg%Delta_max = AReg%Delta_min
            else
                AReg%Delta_min = AReg%Low*(exp(AReg%delta)-1)
                AReg%Delta_max = AReg%High*(1-exp(-AReg%delta))
            end if
        else
            AReg%Delta_max = AReg%delta
            AReg%Delta_min = AReg%delta
        end if
    end do


    !Get rid of tiny regions
    ix = Reg%Count
    do i=ix, 1, -1
        AReg => Reg%R(i)
        if (AReg%steps ==1) then
            Diff = AReg%High - AReg%Low
            if (AReg%IsLog) then
                min_request = AReg%Low*(exp(RequestDelta(i))-1)
                max_request = AReg%High*(1-exp(-RequestDelta(i)))
            else
                min_request = RequestDelta(i)
                max_request = min_request
            end if
            if (i/= Reg%Count) then  !from i/= ix Mar08
                LastReg => Reg%R(i+1)
                if (RequestDelta(i) >= AReg%delta .and. Diff <= LastReg%Delta_min &
                    .and. LastReg%Delta_min <= max_request) then

                    LastReg%Low = AReg%Low
                    if (Diff > LastReg%Delta_min*RangeTol) then
                        LastReg%steps =  LastReg%steps + 1
                    end if
                    if (LastReg%IsLog) then
                        LastReg%delta = log(LastReg%High/LastReg%Low) / LastReg%steps
                    else
                        LastReg%delta = (LastReg%High -LastReg%Low) / LastReg%steps
                    end if
                    Reg%R(i:Reg%Count-1) = Reg%R(i+1:Reg%Count)
                    Reg%Count = Reg%Count -1
                    cycle
                end if
            end if
            if (i/=1) then
                LastReg => Reg%R(i-1)
                if (RequestDelta(i) >= AReg%delta .and. Diff <= LastReg%Delta_max &
                    .and. LastReg%Delta_max <= min_request) then
                    LastReg%High = AReg%High
                    !AlMat08 LastReg%Low = AReg%Low
                    if (Diff > LastReg%Delta_max*RangeTol) then
                        LastReg%steps =  LastReg%steps + 1
                    end if
                    if (LastReg%IsLog) then
                        LastReg%delta = log(LastReg%High/LastReg%Low) / LastReg%steps
                    else
                        LastReg%delta = (LastReg%High -LastReg%Low) / LastReg%steps
                    end if
                    Reg%R(i:Reg%Count-1) = Reg%R(i+1:Reg%Count)
                    Reg%Count = Reg%Count -1
                end if
            end if
        end if
    end do


    !Set up start indices and get total number of steps
    nsteps = 1
    do i = 1, Reg%Count
        AReg => Reg%R(i)
        AReg%Start_index = nsteps
        nsteps = nsteps + AReg%steps
        if (AReg%IsLog) then
            if (AReg%steps ==1) then
                AReg%Delta_min = AReg%High - AReg%Low
                AReg%Delta_max = AReg%Delta_min
            else
                AReg%Delta_min = AReg%Low*(exp(AReg%delta)-1)
                AReg%Delta_max = AReg%High*(1-exp(-AReg%delta))
            end if
        else
            AReg%Delta_max = AReg%delta
            AReg%Delta_min = AReg%delta
        end if
    end do

    Reg%npoints = nsteps

    end subroutine Ranges_Add


    subroutine Ranges_Write(Reg)
    Type(Regions), intent(in), target :: Reg
    Type(Region), pointer :: AReg
    integer i

    do i=1,Reg%count
        AReg => Reg%R(i)
        if (AReg%IsLog) then
            Write (*,'("Range ",I3,":", 3E14.4," log")') i, AReg%Low, AReg%High, AReg%delta
        else
            Write (*,'("Range ",I3,":", 3E14.4," linear")') i, AReg%Low, AReg%High, AReg%delta
        end if
    end do
    end subroutine Ranges_Write


    end module Ranges


    module Lists
    !Currently implements lists of strings and lists of arrays of reals
    implicit none

    type real_pointer
        real, dimension(:), pointer :: p
    end type real_pointer

    type double_pointer
        double precision, dimension(:), pointer :: p
    end type double_pointer

    type String_pointer
        character, dimension(:), pointer :: p
    end type String_pointer


    Type TList_RealArr
        integer Count
        integer Delta
        integer Capacity
        type(Real_Pointer), dimension(:), pointer :: Items
    end Type TList_RealArr

    Type TStringList
        integer Count
        integer Delta
        integer Capacity
        type(String_Pointer), dimension(:), pointer :: Items
    end Type TStringList

    contains

    subroutine TList_RealArr_Init(L)
    Type (TList_RealArr) :: L

    L%Count = 0
    L%Capacity = 0
    L%Delta = 1024
    nullify(L%items)

    end subroutine TList_RealArr_Init

    subroutine TList_RealArr_Clear(L)
    Type (TList_RealArr) :: L
    integer i, status

    do i=L%Count,1,-1
        deallocate (L%Items(i)%P, stat = status)
    end do
    deallocate (L%Items, stat = status)
    nullify(L%Items)
    L%Count = 0
    L%Capacity = 0

    end subroutine TList_RealArr_Clear


    subroutine TList_RealArr_Add(L, P)
    Type (TList_RealArr) :: L
    real, intent(in) :: P(:)
    integer s

    if (L%Count == L%Capacity) call TList_RealArr_SetCapacity(L, L%Capacity + L%Delta)
    s = size(P)
    L%Count = L%Count + 1
    allocate(L%Items(L%Count)%P(s))
    L%Items(L%Count)%P = P

    end subroutine TList_RealArr_Add

    subroutine TList_RealArr_SetCapacity(L, C)
    Type (TList_RealArr) :: L
    integer C
    type(Real_Pointer), dimension(:), pointer :: TmpItems

    if (L%Count > 0) then
        if (C < L%Count) stop 'TList_RealArr_SetCapacity: smaller than Count'
        allocate(TmpItems(L%Count))
        TmpItems = L%Items(1:L%Count)
        deallocate(L%Items)
        allocate(L%Items(C))
        L%Items(1:L%Count) = TmpItems
        deallocate(TmpItems)
    else
        allocate(L%Items(C))
    end if
    L%Capacity = C
    end subroutine TList_RealArr_SetCapacity

    subroutine TList_RealArr_Delete(L, i)
    Type (TList_RealArr) :: L
    integer, intent(in) :: i
    integer status

    deallocate(L%items(i)%P, stat = status)
    if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
    L%Count = L%Count -1

    end subroutine TList_RealArr_Delete

    subroutine TList_RealArr_SaveBinary(L,fid)
    Type (TList_RealArr) :: L
    integer, intent(in) :: fid
    integer i

    write (fid) L%Count
    do i=1,L%Count
        write(fid) size(L%Items(i)%P)
        write(fid) L%Items(i)%P
    end do

    end subroutine TList_RealArr_SaveBinary

    subroutine TList_RealArr_ReadBinary(L,fid)
    Type (TList_RealArr) :: L
    integer, intent(in) :: fid
    integer num,i,sz

    call TList_RealArr_Clear(L)
    read (fid) num
    call TList_RealArr_SetCapacity(L, num)
    do i=1,num
        read(fid) sz
        allocate(L%Items(i)%P(sz))
        read(fid) L%Items(i)%P
    end do
    L%Count = num

    end subroutine TList_RealArr_ReadBinary


    subroutine TList_RealArr_Thin(L, i)
    Type (TList_RealArr) :: L
    integer, intent(in) :: i
    integer newCount
    type(Real_Pointer), dimension(:), pointer :: TmpItems

    if (L%Count > 1) then
        newCount = (L%Count-1)/i+1
        allocate(TmpItems(newCount))
        TmpItems = L%Items(1:L%Count:i)
        deallocate(L%Items)
        L%Capacity = newCount
        allocate(L%Items(L%Capacity))
        L%Items = TmpItems
        L%Count = newCount
        deallocate(TmpItems)
    end if
    end subroutine TList_RealArr_Thin

    subroutine TList_RealArr_ConfidVal(L, ix, limfrac, ix1, ix2, Lower, Upper)
    !Taking the ix'th entry in each array to be a sample, value for which
    !limfrac of the items between ix1 and ix2 (inc) are above or below
    !e.g. if limfrac = 0.05 get two tail 90% confidence limits
    Type (TList_RealArr) :: L
    integer, intent(IN) :: ix
    real, intent(IN) :: limfrac
    real, intent(OUT), optional :: Lower, Upper
    integer, intent(IN), optional :: ix1,ix2
    integer b,t,samps
    real pos, d
    type(Real_Pointer), dimension(:), pointer :: SortItems

    b=1
    t=L%Count
    if (present(ix1)) b = ix1
    if (present(ix2)) t = ix2
    samps = t - b + 1

    allocate(SortItems(samps))
    SortItems = L%Items(b:t)
    call QuickSortArr_Real(SortItems, 1, samps, ix)
    if (present(Lower)) then
        pos = (samps-1)*limfrac + 1
        b = max(int(pos),1)
        Lower = SortItems(b)%P(ix)
        if (b < samps .and. pos>b) then
            d = pos - b
            Lower = Lower*(1 - d) + d * SortItems(b+1)%P(ix)
        end if
    end if
    if (present(Upper)) then
        pos = (samps-1)*(1.-limfrac) + 1
        b = max(int(pos),1)
        Upper = SortItems(b)%P(ix)
        if (b < samps .and. pos>b) then
            d = pos - b
            Upper = Upper*(1 - d) + d * SortItems(b+1)%P(ix)
        end if
    end if

    deallocate(SortItems)

    end subroutine TList_RealArr_ConfidVal

    subroutine TStringList_Init(L)
    Type (TStringList) :: L

    L%Count = 0
    L%Capacity = 0
    L%Delta = 128
    nullify(L%items)

    end subroutine TStringList_Init

    subroutine TStringList_Clear(L)
    Type (TStringList) :: L
    integer i, status

    do i=L%Count,1,-1
        deallocate (L%Items(i)%P, stat = status)
    end do
    deallocate (L%Items, stat = status)
    call TStringList_Init(L)

    end subroutine TStringList_Clear

    subroutine TStringList_SetFromString(L, S, valid_chars_in)
    Type (TStringList) :: L
    character(Len=*), intent(in) :: S
    character(Len=*), intent(in), optional :: valid_chars_in
    character(LEN=1024) item
    integer i,j
    character(LEN=256) valid_chars

    if (present(valid_chars_in)) then
        valid_chars = valid_chars_in
    else
        valid_chars='abcdefghijklmopqrstuvwxyzABCDEFGHIJKLMOPQRSTUVWXYZ0123456789_-.'
    endif

    call TStringList_Clear(L)
    item =''
    j=0
    do i=1, len_trim(S)
        if (verify(S(i:i),trim(valid_chars)) == 0) then
            j=j+1
            item(j:j) = S(i:i)
        else
            if (trim(S(i:i))/='') then
                write (*,*) 'Invalid character in: '//trim(S)
            end if
            if (j>0) call TStringList_Add(L, item(1:j))
            j=0
        end if
    end do
    if (j>0) call TStringList_Add(L, item(1:j))

    end subroutine TStringList_SetFromString



    subroutine TStringList_Add(L, P)
    Type (TStringList) :: L
    character(LEN=*), intent(in) :: P
    integer s,i

    if (L%Count == L%Capacity) call TStringList_SetCapacity(L, L%Capacity + L%Delta)
    s = len_trim(P)
    L%Count = L%Count + 1
    allocate(L%Items(L%Count)%P(s))
    do i=1,s
        L%Items(L%Count)%P(i) = P(i:i)
    end do
    end subroutine TStringList_Add

    function TStringList_Item(L, i) result(S)
    Type (TStringList) :: L
    integer, intent(in) :: i
    integer j
    character(LEN=1024) S

    S=''
    if (i<=L%Count .and. i>0) then
        do j=1,size(L%Items(i)%P)
            S(j:j)=L%Items(i)%P(j)
        end do
    end if
    end function TStringList_Item

    subroutine TStringList_SetCapacity(L, C)
    Type (TStringList) :: L
    integer C
    type(String_Pointer), dimension(:), pointer :: TmpItems

    if (L%Count > 0) then
        if (C < L%Count) stop 'TStringList_SetCapacity: smaller than Count'
        allocate(TmpItems(L%Count))
        TmpItems = L%Items(1:L%Count)
        deallocate(L%Items)
        allocate(L%Items(C))
        L%Items(1:L%Count) = TmpItems
        deallocate(TmpItems)
    else
        allocate(L%Items(C))
    end if
    L%Capacity = C

    end subroutine TStringList_SetCapacity

    subroutine TStringList_Delete(L, i)
    Type (TStringList) :: L
    integer, intent(in) :: i
    integer status

    deallocate(L%items(i)%P, stat = status)
    if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
    L%Count = L%Count -1

    end subroutine TStringList_Delete

    function TStringList_IndexOf(L, S)
    Type (TStringList) :: L
    character(LEN=*), intent(in) :: S
    integer TStringList_IndexOf, i, j,slen

    slen = len_trim(S)
    do i=1,L%Count
        if ( size(L%Items(i)%P)==slen) then
            !Yes, comparing strings and pointer strings really is this horrible...
            j=1
            do while (L%Items(i)%P(j)==S(j:j))
                j=j+1
                if (j>slen) then
                    TStringList_IndexOf = i
                    return
                end if
            end do
        end if
    end do
    TStringList_IndexOf=-1

    end function TStringList_IndexOf


    recursive subroutine QuickSortArr_Real(Arr, Lin, R, index)
    !Sorts an array of pointers to arrays of reals by the value of the index'th entry
    integer, intent(in) :: Lin, R, index
#ifdef __GFORTRAN__
    type(real_pointer), dimension(:) :: Arr
#else
    type(real_pointer), dimension(*) :: Arr
#endif
    integer I, J, L
    real P
    type(real_pointer) :: temp

    L = Lin
    do

        I = L
        J = R
        P = Arr((L + R)/2)%p(index)

        do
            do while (Arr(I)%p(index) <  P)
                I = I + 1
            end do

            do while (Arr(J)%p(index) > P)
                J = J - 1
            end do

            if (I <= J) then

                Temp%p => Arr(I)%p
                Arr(I)%p => Arr(J)%p
                Arr(J)%p => Temp%p
                I = I + 1
                J = J - 1
            end if
            if (I > J) exit

        end do
        if (L < J) call QuickSortArr_Real(Arr, L, J, index);
        L = I
        if (I >= R) exit
    end do

    end subroutine QuickSortArr_Real



    recursive subroutine QuickSortArr(Arr, Lin, R, index)
    !Sorts an array of pointers to arrays of reals by the value of the index'th entry
    integer, intent(in) :: Lin, R, index
#ifdef __GFORTRAN__
    type(double_pointer), dimension(:) :: Arr
#else
    type(double_pointer), dimension(*) :: Arr
#endif
    integer I, J, L
    double precision P
    type(double_pointer) :: temp

    L = Lin
    do

        I = L
        J = R
        P = Arr((L + R)/2)%p(index)

        do
            do while (Arr(I)%p(index) <  P)
                I = I + 1
            end do

            do while (Arr(J)%p(index) > P)
                J = J - 1
            end do

            if (I <= J) then

                Temp%p => Arr(I)%p
                Arr(I)%p => Arr(J)%p
                Arr(J)%p => Temp%p
                I = I + 1
                J = J - 1
            end if
            if (I > J) exit

        end do
        if (L < J) call QuickSortArr(Arr, L, J, index);
        L = I
        if (I >= R) exit
    end do

    end subroutine QuickSortArr


    end module Lists

    module AMLutils
    use Lists

#ifdef DECONLY
    !Comment out if linking to LAPACK/MKL separetly
    !CXML only has LAPACK 2.0
    include 'CXML_INCLUDE.F90'
#endif


#ifdef NAGF95
    use F90_UNIX
#endif

    implicit none

#ifndef NAGF95
#ifndef GFC
#ifndef __INTEL_COMPILER_BUILD_DATE
#ifndef __GFORTRAN__
    integer iargc
    external iargc
#endif        
#endif
#endif
#endif


#ifdef MPI
    include "mpif.h"
#endif

    integer :: Feedback = 1
    integer, parameter :: tmp_file_unit = 50


    double precision, parameter :: pi=3.14159265358979323846264338328d0, &
        twopi=2*pi, fourpi=4*pi
    double precision, parameter :: root2 = 1.41421356237309504880168872421d0, sqrt2 = root2
    double precision, parameter :: log2 = 0.693147180559945309417232121458d0

    real, parameter :: pi_r = 3.141592653, twopi_r = 2*pi_r, fourpi_r = twopi_r*2

    logical :: flush_write = .true.
    !True means no data lost on crashes, but may make it slower

    integer, parameter :: file_units_start = 20
    integer, parameter :: file_units_end = 100

    logical file_units(file_units_start:file_units_end)

    INTERFACE CONCAT
    module procedure concat_s, concat_s_n
    END INTERFACE

    INTERFACE RealToStr
    module procedure SingleToStr, DoubleToStr
    END INTERFACE RealToStr

    contains

    function new_file_unit()
    integer i, new_file_unit
    logical, save :: file_units_inited = .false.
    logical notfree

    if (.not. file_units_inited) then
        file_units = .false.
        file_units_inited = .true.
    end if

    do i=file_units_start, file_units_end
        if (.not. file_units(i) .and. i/=tmp_file_unit) then
            inquire(i,opened=notfree)
            if (notfree) cycle
            file_units(i)=.true.
            new_file_unit = i
            return
        end if
    end do

    call mpiStop('No unused file unit numbers')

    end function new_file_unit


    subroutine CloseFile(i)
    integer, intent(in) :: i

    close(i)
    file_units(i) = .false.

    end subroutine CloseFile

    subroutine ClearFileUnit(i)
    integer, intent(in) :: i

    file_units(i) = .false.

    end subroutine ClearFileUnit

    function GetParamCount()
    integer GetParamCount

    GetParamCount = iargc()

    end function GetParamCount

    function GetMpiRank()
    integer GetMpiRank
#ifdef MPI 
    integer ierror
    call mpi_comm_rank(mpi_comm_world,GetMPIrank,ierror)
#else
    GetMpiRank=0
#endif    

    end function GetMpiRank

    function IsMainMPI()
    logical IsMainMPI

    IsMainMPI =  GetMpiRank() == 0

    end function IsMainMPI

    subroutine MpiStop(Msg)
    character(LEN=*), intent(in), optional :: Msg
    integer i
#ifdef MPI 
    integer ierror, MpiRank
#endif

    if (present(Msg)) write(*,*) trim(Msg)

#ifdef MPI
    call mpi_comm_rank(mpi_comm_world,MPIrank,ierror)
    write (*,*) 'MpiStop: ', MpiRank
    call MPI_ABORT(MPI_COMM_WORLD,i)
#endif
    i=1     !put breakpoint on this line to debug
    error stop

    end subroutine MpiStop

    subroutine MpiStat(MpiID, MpiSize)
    implicit none
    integer MpiID,MpiSize
#ifdef MPI  
    integer ierror
    call mpi_comm_rank(mpi_comm_world,MpiID,ierror)
    if (ierror/=MPI_SUCCESS) stop 'MpiStat: MPI rank'
    call mpi_comm_size(mpi_comm_world,MpiSize,ierror)
#else
    MpiID=0
    MpiSize=1
#endif
    end subroutine MpiStat

    subroutine MpiQuietWait
    !Set MPI thread to sleep, e.g. so can run openmp on cpu instead
#ifdef MPI  
    integer flag, ierr, STATUS(MPI_STATUS_SIZE)
    integer i, MpiId, MpiSize

    call MpiStat(MpiID, MpiSize)
    if (MpiID/=0) then
        do
            call MPI_IPROBE(0,0,MPI_COMM_WORLD,flag, MPI_STATUS_IGNORE,ierr)
            if (flag/=0) then
                call MPI_RECV(i,1,MPI_INTEGER, 0,0,MPI_COMM_WORLD,status,ierr)
                exit
            end if
            call sleep(1)
        end do
    end if
#endif
    end subroutine

    subroutine MpiWakeQuietWait
#ifdef MPI  
    integer j, MpiId, MpiSize, ierr,r

    call MpiStat(MpiID, MpiSize)
    if (MpiID==0) then
        do j=1, MpiSize-1
            call MPI_ISSEND(MpiId,1,MPI_INTEGER, j,0,MPI_COMM_WORLD,r,ierr)
        end do
    end if
#endif
    end subroutine MpiWakeQuietWait

#ifdef __GFORTRAN__

    ! ===========================================================
    function iargc ()
    ! ===========================================================
    integer iargc
    ! ===========================================================

    iargc=command_argument_count()
    end function iargc

    ! ===========================================================
    subroutine getarg(num, res)
    ! ===========================================================
    integer, intent(in) :: num
    character(len=*), intent(out) :: res
    integer l, err
    ! ===========================================================
    call get_command_argument(num,res,l,err)
    end subroutine getarg

#endif


    function GetParam(i)

    character(LEN=512) GetParam
    integer, intent(in) :: i

    if (iargc() < i) then
        GetParam = ''
    else
        call getarg(i,GetParam)
    end if
    end function GetParam

    function concat_s(S1,S2,S3,S4,S5,S6,S7,S8) result(concat)
    character(LEN=*), intent(in) :: S1, S2
    character(LEN=*), intent(in) , optional :: S3, S4, S5, S6,S7,S8
    character(LEN = 1000) concat

    concat = trim(S1) // S2
    if (present(S3)) then
        concat = trim(concat) // S3
        if (present(S4)) then
            concat = trim(concat) // S4
            if (present(S5)) then
                concat = trim(concat) // S5
                if (present(S6)) then
                    concat = trim(concat) // S6
                    if (present(S7)) then
                        concat = trim(concat) // S7
                        if (present(S8)) then
                            concat = trim(concat) // S8
                        end if
                    end if
                end if
            end if
        end if
    end if

    end function concat_s

    function concat_s_n(SS1,N2,SS3,N4,SS5,N6,SS7,N8,SS9,N10,SS11) result(concat)
    character(LEN=*), intent(in) :: SS1
    integer, intent(in) :: N2
    character(LEN=*), intent(in) , optional :: SS3, SS5, SS7, SS9,SS11
    integer, intent(in), optional ::N4,N6,N8, N10
    character(LEN = 1000) concat

    concat = trim(SS1) //trim(IntToStr(N2))
    if (present(SS3)) then
        concat = trim(concat) // SS3
        if (present(N4)) then
            concat = trim(concat) // trim(IntToStr(N4))
            if (present(SS5)) then
                concat = trim(concat) // SS5
                if (present(N6)) then
                    concat = trim(concat) // trim(intToStr(N6))
                    if (present(SS7)) then
                        concat = trim(concat) // SS7
                        if (present(N8)) then
                            concat = trim(concat) // trim(intToStr(N8))
                            if (present(SS9)) then
                                concat = trim(concat) // SS9
                                if (present(N10)) then
                                    concat = trim(concat) // trim(intToStr(N10))
                                    if (present(SS11)) then
                                        concat = trim(concat) // SS11
                                    end if
                                end if
                            end if
                        end if
                    end if
                end if
            end if
        end if
    end if

    end  function concat_s_n

    subroutine Exchange(i1,i2)
    integer i1,i2,tmp

    tmp=i1
    i1=i2
    i2=tmp

    end subroutine Exchange

    subroutine WriteS(S)
    character(LEN=*), intent(in) :: S

    write (*,*) trim(S)

    end subroutine WriteS

    subroutine StringReplace(FindS, RepS, S)
    character(LEN=*), intent(in) :: FindS, RepS
    character(LEN=*), intent(inout) :: S
    integer i

    i = index(S,FindS)
    if (i>0) then
        S = S(1:i-1)//trim(RepS)//S(i+len_trim(FindS):len_trim(S))
    end if

    end subroutine StringReplace

    function numcat(S, num)
    character(LEN=*) S
    character(LEN=1024) numcat, numstr
    integer num

    write (numstr, *) num
    numcat = trim(S) // trim(adjustl(numstr))
    !OK, so can probably do with with a format statement too...
    end function numcat

    function LogicalToint(B)
    integer LogicalToint
    logical, intent(in) :: B

    if (B) then
        LogicalToInt=1
    else
        LogicalToint=0
    end if

    end function LogicalToInt

    function IntToLogical(I)
    integer, intent(in) :: I
    logical IntToLogical

    IntToLogical = I /= 0

    end  function IntToLogical

    function IntToStr(I, minlen)
    integer , intent(in) :: I
    character(LEN=30) IntToStr
    integer, intent(in), optional :: minlen
    integer n
    character (LEN=20) :: form

    if (present(minlen)) then
        n = minlen
        if (I<0) n=n+1
        form = concat('(I',n,'.',minlen,')')
        write (IntToStr,form) i
    else
        write (IntToStr,*) i
        IntToStr = adjustl(IntToStr)
    end if


    end function IntToStr

    function StrToInt(S)
    integer :: StrToInt
    character(LEN=30), intent(in) :: S

    read (S,*) StrToInt
    end function StrToInt

    function DoubleToStr(R, figs)
    double precision, intent(in) :: R
    integer, intent(in), optional :: figs
    character(LEN=30) DoubleToStr

    DoubleToStr = SingleToStr(real(R),figs)

    end function DoubleToStr

    function SingleToStr(R, figs)
    real, intent(in) :: R
    integer, intent(in), optional :: figs
    character(LEN=30) SingleToStr

    if (abs(R)>=0.001 .or. R==0.) then
        write (SingleToStr,'(f12.6)') R

        SingleToStr = adjustl(SingleToStr)
        if (present(figs)) then
            SingleToStr = SingleToStr(1:figs)
        else
            SingleToStr = SingleToStr(1:6)
        end if

    else
        if (present(figs)) then
            write (SingleToStr,trim(numcat('(E',figs))//'.2)') R
        else
            write (SingleToStr,'(G9.2)') R
        end if
        SingleToStr = adjustl(SingleToStr)
    end if

    end function SingleToStr

    subroutine WriteFormatInts(unit, formatst, i1,i2,i3,i4)
    integer, intent(in) :: unit
    character(LEN=*), intent(in) :: formatst
    integer, intent(in) :: i1
    integer, intent(in),optional :: i2,i3,i4
    character(LEN=1024*16) S

    S = formatst
    call StringReplace('%u', IntToStr(i1), S)
    if (present(i2)) call StringReplace('%u', IntToStr(i2), S)
    if (present(i3)) call StringReplace('%u', IntToStr(i3), S)
    if (present(i4)) call StringReplace('%u', IntToStr(i4), S)

    write(unit,'(a)') trim(S)
    end subroutine WriteFormatInts

    function IndexOf(aval,arr, n)
    integer, intent(in) :: n, arr(n), aval
    integer IndexOf, i

    do i=1,n
        if (arr(i)==aval) then
            IndexOf= i
            return
        end if
    end do
    IndexOf = 0

    end function IndexOf

    function MaxIndex(arr, n)
    integer, intent(in) :: n
    real, intent(in) :: arr(n)
    integer locs(1:1), MaxIndex

    locs = maxloc(arr(1:n))
    MaxIndex = locs(1)

    end function MaxIndex


    function MinIndex(arr, n)
    integer, intent(in) :: n
    real, intent(in) :: arr(n)
    integer locs(1:1), MinIndex

    locs = minloc(arr(1:n))
    MinIndex = locs(1)

    end function MinIndex


    subroutine TList_RealArr_SaveToFile(L,fname)
    character(LEN=*), intent(IN) :: fname
    Type (TList_RealArr) :: L
    character(LEN=20) aform
    integer i
    integer :: Plen = -1
    integer :: file_id

    file_id = new_file_unit()
    call CreateTxtFile(fname,file_id)
    do i=1, L%Count
        if (PLen /= size(L%Items(i)%P)) then
            PLen = size(L%Items(i)%P)
            aform = '('//trim(IntToStr(PLen))//'E16.8)'
        end if
        write (file_id,aform) L%Items(i)%P
    end do
    call CloseFile(file_id)

    end subroutine TList_RealArr_SaveToFile


    function ExtractFilePath(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=1024) ExtractFilePath
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (aname(i:i)=='/') then
            ExtractFilePath = aname(1:i)
            return
        end if
    end do
    ExtractFilePath = ''

    end function ExtractFilePath

    function ExtractFileExt(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=120) ExtractFileExt
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (aname(i:i)=='/') then
            ExtractFileExt = ''
            return
        else if (aname(i:i)=='.') then
            ExtractFileExt= aname(i:len)
            return
        end if
    end do
    ExtractFileExt = ''

    end function ExtractFileExt


    function ExtractFileName(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=1024) ExtractFileName
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (aname(i:i)=='/') then
            ExtractFileName = aname(i+1:len)
            return
        end if
    end do
    ExtractFileName = aname

    end function ExtractFileName

    function ChangeFileExt(aname,ext)
    character(LEN=*), intent(IN) :: aname,ext
    character(LEN=1024) ChangeFileExt
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (aname(i:i)=='.') then
            ChangeFileExt = aname(1:i) // trim(ext)
            return
        end if
    end do
    ChangeFileExt = trim(aname) // '.' // trim(ext)

    end function ChangeFileExt


    function CheckTrailingSlash(aname)
    character(LEN=*), intent(in) :: aname
    character(LEN=1024) CheckTrailingSlash
    integer len

    len = len_trim(aname)
#ifdef IBMXL
    if (aname(len:len) /= '\\' .and. aname(len:len) /= '/') then
#else
#ifdef ESCAPEBACKSLASH
        if (aname(len:len) /= '\\' .and. aname(len:len) /= '/') then
#else
            if (aname(len:len) /= '\' .and. aname(len:len) /= '/') then
#endif
#endif
                CheckTrailingSlash = trim(aname)//'/'
            else
                CheckTrailingSlash = aname
            end if


        end  function CheckTrailingSlash


        subroutine DeleteFile(aname)
        character(LEN=*), intent(IN) :: aname
        integer file_id

        if (FileExists(aname)) then
            file_id = new_file_unit()
            open(unit = file_id, file = aname, err = 2)
            close(unit = file_id, status = 'DELETE')
2           file_units(file_id) = .false.
        end if

        end subroutine DeleteFile


        subroutine FlushFile(aunit)
#ifdef __INTEL_COMPILER_BUILD_DATE
        USE IFPORT
#endif
        integer, intent(IN) :: aunit


#ifdef IBMXL
        call flush_(aunit)
#else
        call flush(aunit)
#endif

        end subroutine FlushFile


        function FileExists(aname)
        character(LEN=*), intent(IN) :: aname
        logical FileExists

        inquire(file=aname, exist = FileExists)

        end function FileExists

        subroutine OpenFile(aname, aunit,mode)
        character(LEN=*), intent(IN) :: aname,mode
        integer, intent(in) :: aunit

        open(unit=aunit,file=aname,form=mode,status='old', action='read', err=500)
        return

500     call MpiStop('File not found: '//trim(aname))


        end subroutine OpenFile


        subroutine OpenTxtFile(aname, aunit)
        character(LEN=*), intent(IN) :: aname
        integer, intent(in) :: aunit

        call OpenFile(aname,aunit,'formatted')

        end subroutine OpenTxtFile

        subroutine CreateOpenTxtFile(aname, aunit, append)
        character(LEN=*), intent(IN) :: aname
        integer, intent(in) :: aunit
        logical, optional, intent(in) :: append
        logical A

        if (present(append)) then
            A=append
        else
            A = .false.
        endif

        call CreateOpenFile(aname,aunit,'formatted',A)

        end subroutine CreateOpenTxtFile


        subroutine CreateTxtFile(aname, aunit)
        character(LEN=*), intent(IN) :: aname
        integer, intent(in) :: aunit

        call CreateFile(aname,aunit,'formatted')

        end subroutine CreateTxtFile


        subroutine CreateFile(aname, aunit,mode)
        character(LEN=*), intent(IN) :: aname,mode
        integer, intent(in) :: aunit

        open(unit=aunit,file=aname,form=mode,status='replace', err=500)

        return

500     call MpiStop('Error creating file '//trim(aname))


        end subroutine CreateFile

        subroutine CreateOpenFile(aname, aunit,mode, append)
        character(LEN=*), intent(IN) :: aname,mode
        integer, intent(in) :: aunit
        logical, optional, intent(in) :: append
        logical A

        if (present(append)) then
            A=append
        else
            A = .false.
        endif

        if (A) then
            open(unit=aunit,file=aname,form=mode,status='unknown', err=500, position='append')
        else
            open(unit=aunit,file=aname,form=mode,status='replace', err=500)
        end if

        return

500     call MpiStop('Error creatinging or opening '//trim(aname))


        end subroutine CreateOpenFile

        function TxtNumberColumns(InLine) result(n)
        character(LEN=*) :: InLine
        integer n,i
        logical isNum

        n=0
        isNum=.false.
        do i=1, len_trim(InLIne)
            if (verify(InLine(i:i),'-+eE.0123456789') == 0) then
                if (.not. IsNum) n=n+1
                IsNum=.true.
            else
                IsNum=.false.
            end if
        end do

        end function TxtNumberColumns

        function TxtColumns(InLine) result(n)
        character(LEN=*) :: InLine
        integer n,i
        logical isNum

        n=0
        isNum=.false.
        do i=1, len_trim(InLine)
            if (InLine(i:i) > char(32)) then
                if (.not. IsNum) n=n+1
                IsNum=.true.
            else
                IsNum=.false.
            end if
        end do

        end function TxtColumns

        function FileColumns(aunit) result(n)
        integer, intent(in) :: aunit
        integer n
        character(LEN=4096*32) :: InLine

        n=0
        read(aunit,'(a)', end = 10) InLine
        n = TxtNumberColumns(InLine)
10      rewind aunit

        end function FileColumns

        function FileLines(aunit) result(n)
        integer, intent(in) :: aunit
        integer n
        character(LEN=4096) :: InLine

        n=0
        do

            read(aunit,'(a)', end = 200) InLine
            n = n+1
        end do

200     rewind aunit


        end function FileLines


        function TopCommentLine(aname) result(res)
        character(LEN=*), intent(IN) :: aname
        integer file_id
        character(LEN=1024) :: InLine, res

        res = ''
        file_id = new_file_unit()
        call OpenTxtFile(aname, file_id)
        InLine=''
        do while (InLine /= '')
            read(file_id,'(a)', end = 10) InLine
        end do
        If (InLIne(1:1)=='#') then
            res = InLine
        end if

10      call CloseFile(file_id)

        end function TopCommentLine


        function TxtFileColumns(aname) result(n)
        character(LEN=*), intent(IN) :: aname
        integer n, file_id


        file_id = new_file_unit()

        call OpenTxtFile(aname, file_id)
        n = FileColumns(file_id)
        call CloseFile(file_id)

        end function TxtFileColumns


        function LastFileLine(aname)
        character(LEN=*), intent(IN) :: aname
        character(LEN = 5000) LastFileLine, InLine
        integer  file_id

        file_id = new_file_unit()

        InLine = ''
        call OpenTxtFile(aname,file_id)
        do
            read(file_id,'(a)', end = 200) InLine
        end do

200     call CloseFile(file_id)

        LastFileLine = InLine

        end function LastFileLine

        subroutine writeArrayLine(unit, arr)
        real, intent(in) :: arr(:)
        integer, intent(in) :: unit

        write(unit,concat('(',size(arr),'E16.6)')) arr

        end subroutine writeArrayLine


        subroutine spline_real(x,y,n,d2)
        integer, intent(in) :: n
        integer, parameter :: dp=KIND(1.0)
        real(dp), intent(in) :: x(n), y(n)
        real(dp), intent(out) :: d2(n)
        real(dp), dimension(:), allocatable :: u
        integer i
        real(dp) xp,sig,xxdiv,d1l,d1r

        allocate(u(1:n-1))

        d2(1)=0._dp
        u(1)=0._dp

        d1r= (y(2)-y(1))/(x(2)-x(1))
        do i=2,n-1
            d1l=d1r
            d1r=(y(i+1)-y(i))/(x(i+1)-x(i))
            xxdiv=1._dp/(x(i+1)-x(i-1))
            sig=(x(i)-x(i-1))*xxdiv
            xp=1._dp/(sig*d2(i-1)+2._dp)
            d2(i)=(sig-1._dp)*xp
            u(i)=(6._dp*(d1r-d1l)*xxdiv-sig*u(i-1))*xp
        end do

        d2(n)=0._dp
        do i=n-1,1,-1
            d2(i)=d2(i)*d2(i+1)+u(i)
        end do

        deallocate(u)
        end subroutine spline_real

        subroutine spline_double(x,y,n,d2)
        integer, intent(in) :: n
        integer, parameter :: dp=KIND(1.d0)
        real(dp), intent(in) :: x(n), y(n)
        real(dp), intent(out) :: d2(n)
        real(dp), dimension(:), allocatable :: u
        integer i
        real(dp) xp,sig,xxdiv,d1l,d1r

        allocate(u(1:n-1))

        d2(1)=0._dp
        u(1)=0._dp

        d1r= (y(2)-y(1))/(x(2)-x(1))
        do i=2,n-1
            d1l=d1r
            d1r=(y(i+1)-y(i))/(x(i+1)-x(i))
            xxdiv=1._dp/(x(i+1)-x(i-1))
            sig=(x(i)-x(i-1))*xxdiv
            xp=1._dp/(sig*d2(i-1)+2._dp)
            d2(i)=(sig-1._dp)*xp
            u(i)=(6._dp*(d1r-d1l)*xxdiv-sig*u(i-1))*xp
        end do

        d2(n)=0._dp
        do i=n-1,1,-1
            d2(i)=d2(i)*d2(i+1)+u(i)
        end do

        deallocate(u)
        end subroutine spline_double


        function DLGAMMA(x)
        !Use Stirling generalization for large x
        !See e.g. http://en.wikipedia.org/wiki/Stirling's_approximation
        !Is accurate to at least 10 decimals, worse just about 30
        double precision :: x
        double precision:: DLGAMMA !approx log gamma
        double precision, parameter :: const = .91893853320467274180d0 !log(2pi)/2

        if (x<32.d0) then
            DLGAMMA = log(GAMMA(x))
        else
            DLGAMMA = (x-0.5d0)*log(x) - x + const +  &
                1/12.d0/(1+x)*(1+1/(x+2)*(1+59.d0/30/(x+3)*(1+2.9491525423728813559d0/(x+4))))
        end if
        end function DLGAMMA


        function LogGamma(x)
        real LogGamma
        real, intent(in) :: x
        integer i, j
        real r

        i = nint(x*2)
        if (abs(i-x*2) > 1e-4) call MpiStop('LogGamma function for half integral only')
        if (mod(i,2) == 0) then
            r=0
            do j = 2, i/2-1
                r = r + log(real(j))
            end do
            LogGamma = r
        else
            r = log(pi)/2
            do j = 1, i-2 , 2
                r = r+ log(j/2.0)
            end do
            LogGamma = r
        end if

        end function LogGamma

        DOUBLE PRECISION FUNCTION GAMMA(X)
        !----------------------------------------------------------------------
        !
        ! This routine calculates the GAMMA function for a real argument X.
        !   Computation is based on an algorithm outlined in reference 1.
        !   The program uses rational functions that approximate the GAMMA
        !   function to at least 20 significant decimal digits.  Coefficients
        !   for the approximation over the interval (1,2) are unpublished.
        !   Those for the approximation for X .GE. 12 are from reference 2.
        !   The accuracy achieved depends on the arithmetic system, the
        !   compiler, the intrinsic functions, and proper selection of the
        !   machine-dependent constants.
        !*******************************************************************
        !
        ! Explanation of machine-dependent constants
        !
        ! beta   - radix for the floating-point representation
        ! maxexp - the smallest positive power of beta that overflows
        ! XBIG   - the largest argument for which GAMMA(X) is representable
        !          in the machine, i.e., the solution to the equation
        !                  GAMMA(XBIG) = beta**maxexp
        ! XINF   - the largest machine representable floating-point number;
        !          approximately beta**maxexp
        ! EPS    - the smallest positive floating-point number such that
        !          1.0+EPS .GT. 1.0
        ! XMININ - the smallest positive floating-point number such that
        !          1/XMININ is machine representable
        !
        !     Approximate values for some important machines are:
        !
        !                            beta       maxexp        XBIG
        !
        ! CRAY-1         (S.P.)        2         8191        966.961
        ! Cyber 180/855
        !   under NOS    (S.P.)        2         1070        177.803
        ! IEEE (IBM/XT,
        !   SUN, etc.)   (S.P.)        2          128        35.040
        ! IEEE (IBM/XT,
        !   SUN, etc.)   (D.P.)        2         1024        171.624
        ! IBM 3033       (D.P.)       16           63        57.574
        ! VAX D-Format   (D.P.)        2          127        34.844
        ! VAX G-Format   (D.P.)        2         1023        171.489
        !
        !                            XINF         EPS        XMININ
        !
        ! CRAY-1         (S.P.)   5.45E+2465   7.11E-15    1.84E-2466
        ! Cyber 180/855
        !   under NOS    (S.P.)   1.26E+322    3.55E-15    3.14E-294
        ! IEEE (IBM/XT,
        !   SUN, etc.)   (S.P.)   3.40E+38     1.19E-7     1.18E-38
        ! IEEE (IBM/XT,
        !   SUN, etc.)   (D.P.)   1.79D+308    2.22D-16    2.23D-308
        ! IBM 3033       (D.P.)   7.23D+75     2.22D-16    1.39D-76
        ! VAX D-Format   (D.P.)   1.70D+38     1.39D-17    5.88D-39
        ! VAX G-Format   (D.P.)   8.98D+307    1.11D-16    1.12D-308
        !
        !*******************************************************************
        !*******************************************************************
        !
        ! Error returns
        !
        !  The program returns the value XINF for singularities or
        !     when overflow would occur.  The computation is believed
        !     to be free of underflow and overflow.
        !
        !
        !  Intrinsic functions required are:
        !
        !     INT, DBLE, EXP, LOG, REAL, SIN
        !
        !
        ! References: "An Overview of Software Development for Special
        !              Functions", W. J. Cody, Lecture Notes in Mathemati,
        !              506, Numerical Analysis Dundee, 1975, G. A. Watson
        !              (ed.), Springer Verlag, Berlin, 1976.
        !
        !              Computer Approximations, Hart, Et. Al., Wiley and
        !              sons, New York, 1968.
        !
        !  Latest modification: October 12, 1989
        !
        !  Authors: W. J. Cody and L. Stoltz
        !           Applied Mathemati Division
        !           Argonne National Laboratory
        !           Argonne, IL 60439
        !
        !----------------------------------------------------------------------
        INTEGER I,N
        LOGICAL PARITY
        DOUBLE PRECISION C,EPS,FACT,HALF,ONE,P,PI,Q,RES,SQRTPI,SUM,TWELVE, &
            TWO,X,XBIG,XDEN,XINF,XMININ,XNUM,Y,Y1,YSQ,Z,ZERO
        DIMENSION C(7),P(8),Q(8)
        !----------------------------------------------------------------------
        !  Mathematical constants
        !----------------------------------------------------------------------
        DATA ONE,HALF,TWELVE,TWO,ZERO/1.0D0,0.5D0,12.0D0,2.0D0,0.0D0/, &
            SQRTPI/0.9189385332046727417803297D0/, &
            PI/3.1415926535897932384626434D0/
        !----------------------------------------------------------------------
        !  Machine dependent parameters
        !----------------------------------------------------------------------
        DATA XBIG,XMININ,EPS/35.040D0,1.18D-38,1.19D-7/, &
            XINF/3.4E38/
        !----------------------------------------------------------------------
        !  Numerator and denominator coefficients for rational minimax
        !     approximation over (1,2).
        !----------------------------------------------------------------------
        DATA P/-1.71618513886549492533811E+0,2.47656508055759199108314E+1, &
            -3.79804256470945635097577E+2,6.29331155312818442661052E+2, &
            8.66966202790413211295064E+2,-3.14512729688483675254357E+4, &
            -3.61444134186911729807069E+4,6.64561438202405440627855E+4/
        DATA Q/-3.08402300119738975254353E+1,3.15350626979604161529144E+2, &
            -1.01515636749021914166146E+3,-3.10777167157231109440444E+3, &
            2.25381184209801510330112E+4,4.75584627752788110767815E+3, &
            -1.34659959864969306392456E+5,-1.15132259675553483497211E+5/
        !----------------------------------------------------------------------
        ! Coefficients for minimax approximation over (12, INF).
        !----------------------------------------------------------------------
        DATA C/-1.910444077728D-03,8.4171387781295D-04, &
            -5.952379913043012D-04,7.93650793500350248D-04, &
            -2.777777777777681622553D-03,8.333333333333333331554247D-02, &
            5.7083835261D-03/
        !----------------------------------------------------------------------
        !  Statement functions for conversion between integer and float
        !----------------------------------------------------------------------
        PARITY = .FALSE.
        FACT = ONE
        N = 0
        Y = X
        IF (Y .LE. ZERO) THEN
            !----------------------------------------------------------------------
            !  Argument is negative
            !----------------------------------------------------------------------
            Y = -X
            Y1 = AINT(Y)
            RES = Y - Y1
            IF (RES .NE. ZERO) THEN
                IF (Y1 .NE. AINT(Y1*HALF)*TWO) PARITY = .TRUE.
                FACT = -PI / SIN(PI*RES)
                Y = Y + ONE
            ELSE
                RES = XINF
                GO TO 900
            END IF
        END IF
        !----------------------------------------------------------------------
        !  Argument is positive
        !----------------------------------------------------------------------
        IF (Y .LT. EPS) THEN
            !----------------------------------------------------------------------
            !  Argument .LT. EPS
            !----------------------------------------------------------------------
            IF (Y .GE. XMININ) THEN
                RES = ONE / Y
            ELSE
                RES = XINF
                GO TO 900
            END IF
        ELSE IF (Y .LT. TWELVE) THEN
            Y1 = Y
            IF (Y .LT. ONE) THEN
                !----------------------------------------------------------------------
                !  0.0 .LT. argument .LT. 1.0
                !----------------------------------------------------------------------
                Z = Y
                Y = Y + ONE
            ELSE
                !----------------------------------------------------------------------
                !  1.0 .LT. argument .LT. 12.0, reduce argument if necessary
                !----------------------------------------------------------------------
                N = INT(Y) - 1
                Y = Y - REAL(N)
                Z = Y - ONE
            END IF
            !----------------------------------------------------------------------
            !  Evaluate approximation for 1.0 .LT. argument .LT. 2.0
            !----------------------------------------------------------------------
            XNUM = ZERO
            XDEN = ONE
            DO 260 I = 1, 8
                XNUM = (XNUM + P(I)) * Z
                XDEN = XDEN * Z + Q(I)
260         CONTINUE
            RES = XNUM / XDEN + ONE
            IF (Y1 .LT. Y) THEN
                !----------------------------------------------------------------------
                !  Adjust result for case  0.0 .LT. argument .LT. 1.0
                !----------------------------------------------------------------------
                RES = RES / Y1
            ELSE IF (Y1 .GT. Y) THEN
                !----------------------------------------------------------------------
                !  Adjust result for case  2.0 .LT. argument .LT. 12.0
                !----------------------------------------------------------------------
                DO 290 I = 1, N
                    RES = RES * Y
                    Y = Y + ONE
290             CONTINUE
            END IF
        ELSE
            !----------------------------------------------------------------------
            !  Evaluate for argument .GE. 12.0,
            !----------------------------------------------------------------------
            IF (Y .LE. XBIG) THEN
                YSQ = Y * Y
                SUM = C(7)
                DO 350 I = 1, 6
                    SUM = SUM / YSQ + C(I)
350             CONTINUE
                SUM = SUM/Y - Y + SQRTPI
                SUM = SUM + (Y-HALF)*LOG(Y)
                RES = EXP(SUM)
            ELSE
                RES = XINF
                GO TO 900
            END IF
        END IF
        !----------------------------------------------------------------------
        !  Final adjustments and return
        !----------------------------------------------------------------------
        IF (PARITY) RES = -RES
        IF (FACT .NE. ONE) RES = FACT / RES
900     GAMMA = RES

        END FUNCTION GAMMA

        subroutine SetIdlePriority
#ifdef RUNIDLE
        USE DFWIN
        Integer dwPriority
        Integer CheckPriority

        dwPriority = 64 ! idle priority
        CheckPriority = SetPriorityClass(GetCurrentProcess(), dwPriority)
#endif
        end subroutine SetIdlePriority


        subroutine GetThreeJs(thrcof,l2in,l3in,m2in,m3in)
        !Recursive evaluation of 3j symbols. Does minimal error checking on input parameters.
        implicit none
        integer, parameter :: dl = KIND(1.d0)
        integer, intent(in) :: l2in,l3in, m2in,m3in
        real(dl), dimension(*) :: thrcof
        INTEGER, PARAMETER :: i8 = selected_int_kind(18)
        integer(i8) :: l2,l3,m2,m3
        integer(i8) :: l1, m1, l1min,l1max, lmatch, nfin, a1, a2

        real(dl) :: newfac, oldfac, sumfor, c1,c2,c1old, dv, denom, x, sum1, sumuni
        real(dl) :: x1,x2,x3, y,y1,y2,y3,sum2,sumbac, ratio,cnorm, sign1, thresh
        integer i,ier, index, nlim, sign2
        integer nfinp1,nfinp2,nfinp3, lstep, nstep2,n
        real(dl), parameter :: zero = 0._dl, one = 1._dl
        real(dl), parameter ::  tiny = 1.0d-30, srtiny=1.0d-15, huge = 1.d30, srhuge = 1.d15

        ! routine to generate set of 3j-coeffs (l1,l2,l3\\ m1,m2,m3)

        ! by recursion from l1min = max(abs(l2-l3),abs(m1))
        !                to l1max = l2+l3
        ! the resulting 3j-coeffs are stored as thrcof(l1-l1min+1)

        ! to achieve the numerical stability, the recursion will proceed
        ! simultaneously forwards and backwards, starting from l1min and l1max
        ! respectively.
        !
        ! lmatch is the l1-value at which forward and backward recursion are matched.
        !
        ! ndim is the length of the array thrcof
        !
        ! ier = -1 for all 3j vanish(l2-abs(m2)<0, l3-abs(m3)<0 or not integer)
        ! ier = -2 if possible 3j's exceed ndim
        ! ier >= 0 otherwise

        l2=l2in
        l3=l3in
        m2=m2in
        m3=m3in
        newfac = 0
        lmatch = 0
        m1 = -(m2+m3)

        ! check relative magnitude of l and m values
        ier = 0

        if (l2 < abs(m2) .or. l3 < m3) then
            ier = -1
            call MpiStop('error ier = -1')
            return
        end if

        ! limits for l1
        l1min = max(abs(l2-l3),abs(m1))
        l1max = l2+l3

        if (l1min >= l1max) then
            if (l1min/=l1max) then
                ier = -1
                call MpiStop('error ier = -1')
                return
            end if

            ! reached if l1 can take only one value, i.e.l1min=l1max
            thrcof(1) = (-1)**abs(l2+m2-l3+m3)/sqrt(real(l1min+l2+l3+1,dl))
            return

        end if

        nfin = l1max-l1min+1

        ! starting forward recursion from l1min taking nstep1 steps
        l1 = l1min
        thrcof(1) = srtiny
        sum1 = (2*l1 + 1)*tiny

        lstep = 1

30      lstep = lstep+1
        l1 = l1+1

        oldfac = newfac
        a1 = (l1+l2+l3+1)*(l1-l2+l3)*(l1+l2-l3)
        a2 = (l1+m1)*(l1-m1)*(-l1+l2+l3+1)
        newfac = sqrt(a2*real(a1,dl))
        if (l1 == 1) then
            !IF L1 = 1  (L1-1) HAS TO BE FACTORED OUT OF DV, HENCE
            c1 = -(2*l1-1)*l1*(m3-m2)/newfac
        else

            dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 + l1*(l1-1)*(m3-m2)
            denom = (l1-1)*newfac

            if (lstep > 2) c1old = abs(c1)
            c1 = -(2*l1-1)*dv/denom

        end if

        if (lstep<= 2) then

            ! if l1=l1min+1 the third term in the recursion eqn vanishes, hence
            x = srtiny*c1
            thrcof(2) = x
            sum1 = sum1+tiny*(2*l1+1)*c1*c1
            if(lstep==nfin) then
                sumuni=sum1
                go to 230
            end if
            goto 30

        end if

        c2 = -l1*oldfac/denom

        ! recursion to the next 3j-coeff x
        x = c1*thrcof(lstep-1) + c2*thrcof(lstep-2)
        thrcof(lstep) = x
        sumfor = sum1
        sum1 = sum1 + (2*l1+1)*x*x
        if (lstep/=nfin) then

            ! see if last unnormalised 3j-coeff exceeds srhuge
            if (abs(x) >= srhuge) then

                ! REACHED IF LAST 3J-COEFFICIENT LARGER THAN SRHUGE
                ! SO THAT THE RECURSION SERIES THRCOF(1), ... , THRCOF(LSTEP)
                ! HAS TO BE RESCALED TO PREVENT OVERFLOW

                ier = ier+1
                do i = 1, lstep
                    if (abs(thrcof(i)) < srtiny) thrcof(i)= zero
                    thrcof(i) = thrcof(i)/srhuge
                end do

                sum1 = sum1/huge
                sumfor = sumfor/huge
                x = x/srhuge

            end if

            ! as long as abs(c1) is decreasing, the recursion proceeds towards increasing
            ! 3j-valuse and so is numerically stable. Once an increase of abs(c1) is
            ! detected, the recursion direction is reversed.

            if (c1old > abs(c1)) goto 30

        end if !lstep/=nfin

        ! keep three 3j-coeffs around lmatch for comparison with backward recursion

        lmatch = l1-1
        x1 = x
        x2 = thrcof(lstep-1)
        x3 = thrcof(lstep-2)
        nstep2 = nfin-lstep+3

        ! --------------------------------------------------------------------------
        !
        ! starting backward recursion from l1max taking nstep2 stpes, so that
        ! forward and backward recursion overlap at 3 points
        ! l1 = lmatch-1, lmatch, lmatch+1

        nfinp1 = nfin+1
        nfinp2 = nfin+2
        nfinp3 = nfin+3
        l1 = l1max
        thrcof(nfin) = srtiny
        sum2 = tiny*(2*l1+1)

        l1 = l1+2
        lstep=1

        do
            lstep = lstep + 1
            l1= l1-1

            oldfac = newfac
            a1 = (l1+l2+l3)*(l1-l2+l3-1)*(l1+l2-l3-1)
            a2 = (l1+m1-1)*(l1-m1-1)*(-l1+l2+l3+2)
            newfac = sqrt(a1*real(a2,dl))

            dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 +l1*(l1-1)*(m3-m2)

            denom = l1*newfac
            c1 = -(2*l1-1)*dv/denom
            if (lstep <= 2) then

                ! if l2=l2max+1, the third term in the recursion vanishes

                y = srtiny*c1
                thrcof(nfin-1) = y
                sumbac = sum2
                sum2 = sum2 + tiny*(2*l1-3)*c1*c1

                cycle

            end if

            c2 = -(l1-1)*oldfac/denom

            ! recursion to the next 3j-coeff y
            y = c1*thrcof(nfinp2-lstep)+c2*thrcof(nfinp3-lstep)

            if (lstep==nstep2) exit

            thrcof(nfinp1-lstep) = y
            sumbac = sum2
            sum2 = sum2+(2*l1-3)*y*y

            ! see if last unnormalised 3j-coeff exceeds srhuge
            if (abs(y) >= srhuge) then

                ! reached if 3j-coeff larger than srhuge so that the recursion series
                ! thrcof(nfin),..., thrcof(nfin-lstep+1) has to be rescaled to prevent overflow

                ier=ier+1
                do i = 1, lstep
                    index=nfin-i+1
                    if (abs(thrcof(index)) < srtiny) thrcof(index)=zero
                    thrcof(index) = thrcof(index)/srhuge
                end do

                sum2=sum2/huge
                sumbac=sumbac/huge

            end if

        end do

        ! the forward recursion 3j-coeffs x1, x2, x3 are to be matched with the
        ! corresponding backward recursion vals y1, y2, y3

        y3 = y
        y2 = thrcof(nfinp2-lstep)
        y1 = thrcof(nfinp3-lstep)

        ! determine now ratio such that yi=ratio*xi (i=1,2,3) holds with minimal error

        ratio = (x1*y1+x2*y2+x3*y3)/(x1*x1+x2*x2+x3*x3)
        nlim = nfin-nstep2+1

        if (abs(ratio) >= 1) then

            thrcof(1:nlim) = ratio*thrcof(1:nlim)
            sumuni = ratio*ratio*sumfor + sumbac

        else

            nlim = nlim+1
            ratio = 1/ratio
            do n = nlim, nfin
                thrcof(n) = ratio*thrcof(n)
            end do
            sumuni = sumfor + ratio*ratio*sumbac

        end if
        ! normalise 3j-coeffs

230     cnorm = 1/sqrt(sumuni)

        ! sign convention for last 3j-coeff determines overall phase

        sign1 = sign(one,thrcof(nfin))
        sign2 = (-1)**(abs(l2+m2-l3+m3))
        if (sign1*sign2 <= 0) then
            cnorm = -cnorm
        end if
        if (abs(cnorm) >= one) then
            thrcof(1:nfin) = cnorm*thrcof(1:nfin)
            return
        end if

        thresh = tiny/abs(cnorm)

        do n = 1, nfin
            if (abs(thrcof(n)) < thresh) thrcof(n) = zero
            thrcof(n) = cnorm*thrcof(n)
        end do
        return

        end subroutine GetThreeJs



    end module AMLutils


#ifdef ZIGGURAT
    MODULE Ziggurat
    ! Marsaglia & Tsang generator for random normals & random exponentials.
    ! Translated from C by Alan Miller (amiller@bigpond.net.au)

    ! Marsaglia, G. & Tsang, W.W. (2000) `The ziggurat method for generating
    ! random variables', J. Statist. Software, v5(8).

    ! This is an electronic journal which can be downloaded from:
    ! http://www.jstatsoft.org/v05/i08

    ! N.B. It is assumed that all integers are 32-bit.
    ! N.B. The value of M2 has been halved to compensate for the lack of
    !      unsigned integers in Fortran.

    ! Latest version - 1 January 2001
    !
    ! AL: useful material at http://en.wikipedia.org/wiki/Ziggurat_algorithm
    IMPLICIT NONE

    PRIVATE

    INTEGER,  PARAMETER  ::  DP=SELECTED_REAL_KIND( 12, 60 )
    REAL(DP), PARAMETER  ::  m1=2147483648.0_DP,   m2=2147483648.0_DP,      &
        half=0.5_DP
    REAL(DP)             ::  dn=3.442619855899_DP, tn=3.442619855899_DP,    &
        vn=0.00991256303526217_DP,                     &
        q,                    de=7.697117470131487_DP, &
        te=7.697117470131487_DP,                       &
        ve=0.003949659822581572_DP
    INTEGER,  SAVE       ::  iz, jz, jsr=123456789, kn(0:127),              &
        ke(0:255), hz
    REAL(DP), SAVE       ::  wn(0:127), fn(0:127), we(0:255), fe(0:255)
    LOGICAL,  SAVE       ::  initialized=.FALSE.

    PUBLIC  :: zigset, shr3, uni, rnor, rexp


    CONTAINS


    SUBROUTINE zigset( jsrseed )

    INTEGER, INTENT(IN)  :: jsrseed

    INTEGER  :: i

    !  Set the seed
    jsr = jsrseed

    !  Tables for RNOR
    q = vn*EXP(half*dn*dn)
    kn(0) = (dn/q)*m1
    kn(1) = 0
    wn(0) = q/m1
    wn(127) = dn/m1
    fn(0) = 1.0_DP
    fn(127) = EXP( -half*dn*dn )
    DO  i = 126, 1, -1
        dn = SQRT( -2.0_DP * LOG( vn/dn + EXP( -half*dn*dn ) ) )
        kn(i+1) = (dn/tn)*m1
        tn = dn
        fn(i) = EXP(-half*dn*dn)
        wn(i) = dn/m1
    END DO

    !  Tables for REXP
    q = ve*EXP( de )
    ke(0) = (de/q)*m2
    ke(1) = 0
    we(0) = q/m2
    we(255) = de/m2
    fe(0) = 1.0_DP
    fe(255) = EXP( -de )
    DO  i = 254, 1, -1
        de = -LOG( ve/de + EXP( -de ) )
        ke(i+1) = m2 * (de/te)
        te = de
        fe(i) = EXP( -de )
        we(i) = de/m2
    END DO
    initialized = .TRUE.
    RETURN
    END SUBROUTINE zigset



    !  Generate random 32-bit integers
    FUNCTION shr3( ) RESULT( ival )
    INTEGER  ::  ival

    jz = jsr
    jsr = IEOR( jsr, ISHFT( jsr,  13 ) )
    jsr = IEOR( jsr, ISHFT( jsr, -17 ) )
    jsr = IEOR( jsr, ISHFT( jsr,   5 ) )
    ival = jz + jsr
    RETURN
    END FUNCTION shr3



    !  Generate uniformly distributed random numbers
    FUNCTION uni( ) RESULT( fn_val )
    REAL(DP)  ::  fn_val

    fn_val = half + 0.2328306e-9_DP * shr3( )
    RETURN
    END FUNCTION uni



    !  Generate random normals
    FUNCTION rnor( ) RESULT( fn_val )
    REAL(DP)             ::  fn_val

    REAL(DP), PARAMETER  ::  r = 3.442620_DP
    REAL(DP)             ::  x, y

    IF( .NOT. initialized ) CALL zigset( jsr )
    hz = shr3( )
    iz = IAND( hz, 127 )
    IF( ABS( hz ) < kn(iz) ) THEN
        fn_val = hz * wn(iz)
    ELSE
        DO
            IF( iz == 0 ) THEN
                DO
                    x = -0.2904764_DP* LOG( uni( ) )
                    y = -LOG( uni( ) )
                    IF( y+y >= x*x ) EXIT
                END DO
                fn_val = r+x
                IF( hz <= 0 ) fn_val = -fn_val
                RETURN
            END IF
            x = hz * wn(iz)
            IF( fn(iz) + uni( )*(fn(iz-1)-fn(iz)) < EXP(-half*x*x) ) THEN
                fn_val = x
                RETURN
            END IF
            hz = shr3( )
            iz = IAND( hz, 127 )
            IF( ABS( hz ) < kn(iz) ) THEN
                fn_val = hz * wn(iz)
                RETURN
            END IF
        END DO
    END IF
    RETURN
    END FUNCTION rnor



    !  Generate random exponentials
    FUNCTION rexp( ) RESULT( fn_val )
    REAL(DP)  ::  fn_val

    REAL(DP)  ::  x

    IF( .NOT. initialized ) CALL Zigset( jsr )
    jz = shr3( )
    iz = IAND( jz, 255 )
    IF( ABS( jz ) < ke(iz) ) THEN
        fn_val = ABS(jz) * we(iz)
        RETURN
    END IF
    DO
        IF( iz == 0 ) THEN
            fn_val = 7.69711 - LOG( uni( ) )
            RETURN
        END IF
        x = ABS( jz ) * we(iz)
        IF( fe(iz) + uni( )*(fe(iz-1) - fe(iz)) < EXP( -x ) ) THEN
            fn_val = x
            RETURN
        END IF
        jz = shr3( )
        iz = IAND( jz, 255 )
        IF( ABS( jz ) < ke(iz) ) THEN
            fn_val = ABS( jz ) * we(iz)
            RETURN
        END IF
    END DO
    RETURN
    END FUNCTION rexp

    END MODULE ziggurat
#endif 



    module Random
    integer :: rand_inst = 0
    logical, parameter :: use_ziggurat = .false.
    integer, parameter :: krand = KIND(1.d0)
    !Ziggurat is significantly (3-4x) faster, see Wikipedia for details
    !Have seem some suspicious things, though couldn't replicate; may be OK..

    INTERFACE RandRotation
    MODULE PROCEDURE RandRotationS, RandRotationD
    END INTERFACE

    contains

    subroutine initRandom(i, i2)
    use AMLUtils
#ifdef ZIGGURAT
    use Ziggurat
#endif
    implicit none
    integer, optional, intent(IN) :: i
    integer, optional, intent(IN) :: i2
    integer seed_in,kl,ij
    character(len=10) :: fred
    real(krand) :: klr

    if (present(i)) then
        seed_in = i
    else
        seed_in = -1
    end if
    if (seed_in /=-1) then
        if (present(i2)) then
            kl=i2
            if (i2 > 30081) call MpiStop('initRandom:second seed too large')
        else
            kl = 9373
        end if
        ij = i
    else
        call system_clock(count=ij)
        ij = mod(ij + rand_inst*100, 31328)
        call date_and_time(time=fred)
        read (fred,'(e10.3)') klr
        kl = mod(int(klr*1000), 30081)
    end if

    if (Feedback > 0 ) write(*,'(" Random seeds:",1I6,",",1I6," rand_inst:",1I4)') ij,kl,rand_inst
    call rmarin(ij,kl)
#ifdef ZIGGURAT
    if (use_ziggurat) call zigset(ij)
#endif
    end subroutine initRandom

    subroutine RandIndices(indices, nmax, n)
    use AMLUtils
    integer, intent(in) :: nmax, n
    integer indices(n),i, ix
    integer tmp(nmax)

    if (n> nmax) call MpiStop('Error in RandIndices, n > nmax')
    do i=1, nmax
        tmp(i)=i
    end do
    do i=1, n
        ix = int(ranmar()*(nmax +1 -i)) + 1
        indices(i) = tmp(ix)
        tmp(ix) = tmp(nmax+1-i)
    end do

    end subroutine RandIndices

    subroutine RandRotationS(R, N)
    !this is most certainly not the world's most efficient or robust random rotation generator
    integer, intent(in) :: N
    real R(N,N), vec(N), norm
    integer i,j

    do j = 1, N
        do
            do i = 1, N
                vec(i) = Gaussian1()
            end do
            do i = 1, j-1
                vec = vec - sum(vec*R(i,:))*R(i,:)
            end do
            norm = sum(vec**2)
            if (norm > 1e-3) exit
        end do
        R(j,:) = vec / sqrt(norm)
    end do

    end subroutine RandRotationS


    subroutine RandRotationD(R, N)
    !this is most certainly not the world's most efficient or robust random rotation generator
    integer, intent(in) :: N
    double precision R(N,N), vec(N), norm
    integer i,j

    do j = 1, N
        do
            do i = 1, N
                vec(i) = Gaussian1()
            end do
            do i = 1, j-1
                vec = vec - sum(vec*R(i,:))*R(i,:)
            end do
            norm = sum(vec**2)
            if (norm > 1e-3) exit
        end do
        R(j,:) = vec / sqrt(norm)
    end do

    end subroutine RandRotationD


    double precision function GAUSSIAN1()
#ifdef ZIGGURAT
    use Ziggurat
#endif
    implicit none
    double precision R, V1, V2, FAC
    integer, save :: iset = 0
    double precision, save :: gset

    if (use_ziggurat) then
#ifdef ZIGGURAT
        Gaussian1 = rnor( )
#endif
    else
        !Box muller
        if (ISET==0) then
            R=2
            do while (R >= 1.d0)
                V1=2.d0*ranmar()-1.d0
                V2=2.d0*ranmar()-1.d0
                R=V1**2+V2**2
            end do
            FAC=sqrt(-2.d0*log(R)/R)
            GSET=V1*FAC
            GAUSSIAN1=V2*FAC
            ISET=1
        else
            GAUSSIAN1=GSET
            ISET=0
        endif
    end if
    end function GAUSSIAN1


    double precision function CAUCHY1()
    implicit none

    Cauchy1 = Gaussian1()/max(1d-15,abs(Gaussian1()))

    end function CAUCHY1


    real FUNCTION RANDEXP1()
    !
    !     Random-number generator for the exponential distribution
    !     Algorithm EA from J. H. Ahrens and U. Dieter,
    !     Communications of the ACM, 31 (1988) 1330--1337.
    !     Coded by K. G. Hamilton, December 1996, with corrections.
    !
    real u, up, g, y

    real, parameter ::   alog2= 0.6931471805599453
    real, parameter ::      a = 5.7133631526454228
    real, parameter ::      b = 3.4142135623730950
    real, parameter ::     c = -1.6734053240284925
    real, parameter ::      p = 0.9802581434685472
    real, parameter ::     aa = 5.6005707569738080
    real, parameter ::     bb = 3.3468106480569850
    real, parameter ::     hh = 0.0026106723602095
    real, parameter ::     dd = 0.0857864376269050

    u = ranmar()
    do while (u.le.0)                 ! Comment out this block
        u = ranmar()                    ! if your RNG can never
    enddo                             ! return exact zero
    g = c
    u = u+u
    do while (u.lt.1.0)
        g = g + alog2
        u = u+u
    enddo
    u = u-1.0
    if (u.le.p) then
        randexp1 = g + aa/(bb-u)
        return
    endif
    do
        u = ranmar()
        y = a/(b-u)
        up = ranmar()
        if ((up*hh+dd)*(b-u)**2 .le. exp(-(y+c))) then
            randexp1 = g+y
            return
        endif
    enddo

    end function randexp1


    ! This random number generator originally appeared in ''Toward a Universal
    ! Random Number Generator'' by George Marsaglia and Arif Zaman.
    ! Florida State University Report: FSU-SCRI-87-50 (1987)
    !
    ! It was later modified by F. James and published in ''A Review of Pseudo-
    ! random Number Generators''
    !
    ! THIS IS THE BEST KNOWN RANDOM NUMBER GENERATOR AVAILABLE.
    !    (However, a newly discovered technique can yield
    !        a period of 10^600. But that is still in the development stage.)
    !
    ! It passes ALL of the tests for random number generators and has a period
    !   of 2^144, is completely portable (gives bit identical results on all
    !   machines with at least 24-bit mantissas in the floating point
    !   representation).
    !
    ! The algorithm is a combination of a Fibonacci sequence (with lags of 97
    !   and 33, and operation "subtraction plus one, modulo one") and an
    !   "arithmetic sequence" (using subtraction).
    !
    ! On a Vax 11/780, this random number generator can produce a number in
    !    13 microseconds.
    !========================================================================
    !
    !      PROGRAM TstRAN
    !     INTEGER IJ, KL, I
    ! Thee are the seeds needed to produce the test case results
    !      IJ = 1802
    !      KL = 9373
    !
    !
    ! Do the initialization
    !      call rmarin(ij,kl)
    !
    ! Generate 20000 random numbers
    !      do 10 I = 1, 20000
    !         x = RANMAR()
    !10    continue
    !
    ! If the random number generator is working properly, the next six random
    !    numbers should be:
    !          6533892.0  14220222.0  7275067.0
    !    6172232.0  8354498.0   10633180.0
    !
    !
    !
    !      write(6,20) (4096.0*4096.0*RANMAR(), I=1,6)
    !20    format (3f12.1)
    !      end
    !
    subroutine RMARIN(IJ,KL)
    ! This is the initialization routine for the random number generator RANMAR()
    ! NOTE: The seed variables can have values between:    0 <= IJ <= 31328
    !                                                      0 <= KL <= 30081
    !The random number sequences created by these two seeds are of sufficient
    ! length to complete an entire calculation with. For example, if sveral
    ! different groups are working on different parts of the same calculation,
    ! each group could be assigned its own IJ seed. This would leave each group
    ! with 30000 choices for the second seed. That is to say, this random
    ! number generator can create 900 million different subsequences -- with
    ! each subsequence having a length of approximately 10^30.
    !
    ! Use IJ = 1802 & KL = 9373 to test the random number generator. The
    ! subroutine RANMAR should be used to generate 20000 random numbers.
    ! Then display the next six random numbers generated multiplied by 4096*4096
    ! If the random number generator is working properly, the random numbers
    !    should be:
    !           6533892.0  14220222.0  7275067.0
    !           6172232.0  8354498.0   10633180.0
    double precision U(97), C, CD, CM, S, T
    integer I97, J97,i,j,k,l,m
    integer ij,kl
    integer ii,jj


    !      INTEGER IRM(103)

    common /RASET1/ U, C, CD, CM, I97, J97
    if( IJ .lt. 0  .or.  IJ .gt. 31328  .or. &
        KL .lt. 0  .or.  KL .gt. 30081 ) then
        print '(A)', ' The first random number seed must have a value  between 0 and 31328'
        print '(A)',' The second seed must have a value between 0 and   30081'
        stop
    endif
    I = mod(IJ/177, 177) + 2
    J = mod(IJ    , 177) + 2
    K = mod(KL/169, 178) + 1
    L = mod(KL,     169)
    do 2 II = 1, 97
        S = 0.0
        T = 0.5
        do 3 JJ = 1, 24
            M = mod(mod(I*J, 179)*K, 179)
            I = J
            J = K
            K = M
            L = mod(53*L+1, 169)
            if (mod(L*M, 64) .ge. 32) then
                S = S + T
            endif
            T = 0.5 * T
3       continue
        U(II) = S
2   continue
    C = 362436.0 / 16777216.0
    CD = 7654321.0 / 16777216.0
    CM = 16777213.0 /16777216.0
    I97 = 97
    J97 = 33

    end subroutine RMARIN

    double precision function RANMAR()
    ! This is the random number generator proposed by George Marsaglia in
    ! Florida State University Report: FSU-SCRI-87-50
    ! It was slightly modified by F. James to produce an array of pseudorandom
    ! numbers.
    double precision U(97), C, CD, CM
    integer I97, J97
    double precision uni

    common /RASET1/ U, C, CD, CM, I97, J97
    !      INTEGER IVEC
    UNI = U(I97) - U(J97)
    if( UNI .lt. 0.0 ) UNI = UNI + 1.0
    U(I97) = UNI
    I97 = I97 - 1
    if(I97 .eq. 0) I97 = 97
    J97 = J97 - 1
    if(J97 .eq. 0) J97 = 97
    C = C - CD
    if( C .lt. 0.d0 ) C = C + CM
    UNI = UNI - C
    if( UNI .lt. 0.d0 ) UNI = UNI + 1.0 ! bug?
    RANMAR = UNI

    end function RANMAR


    end module Random

    !A collection of ranges, consisting of sections of minimum step size
    !Useful for getting piecewise uniform point samplings for numerical integration
    !(with possible mix of log and linear spacing)
    !Antony Lewis, http://cosmologist.info/

    module RangeUtils
    use MiscUtils
    use MpiUtils
    use ArrayUtils
    implicit none
    private

    type, public :: TRange
        integer :: start_index
        integer :: steps
        logical :: IsLog
        double precision :: Low, High
        double precision :: delta
        double precision :: delta_max, delta_min !for log spacing, the non-log max and min step size
    contains

    end type TRange

    type, public :: TRanges
        integer :: count = 0
        integer :: npoints = 0
        double precision :: Lowest, Highest
        type(TRange), allocatable :: R(:)
        logical :: has_dpoints = .false.
        double precision, dimension(:), allocatable :: points, dpoints
        !dpoints is (points(i+1)-points(i-1))/2
        double precision :: RangeTol = 0.1d0
        !fraction of bin width we are prepared for merged bin widths to increase by
        logical, private :: changed = .true.
    contains
    procedure :: Init => TRanges_Free
    procedure :: Free => TRanges_Free
    procedure :: IndexOf => TRanges_IndexOf
    procedure :: Array => TRanges_Array
    procedure :: dArray => TRanges_dArray
    procedure :: GetArray => TRanges_GetArray
    procedure :: Getdpoints => TRanges_Getdpoints
    procedure :: Add_delta => TRanges_Add_delta
    procedure :: Add => TRanges_Add
    procedure :: Write => TRanges_Write
    end type TRanges

    contains

#ifdef __GFORTRAN__
    impure elemental subroutine TRanges_Free(this)
#else
    subroutine TRanges_Free(this)
#endif
    class(TRanges), intent(inout) :: this

    if (allocated(this%R)) deallocate(this%R)
    if (allocated(this%points)) deallocate(this%points)
    if (allocated(this%dpoints)) deallocate(this%dpoints)
    this%count = 0
    this%npoints = 0
    this%has_dpoints = .false.
    this%changed = .true.
    end subroutine TRanges_Free


    function TRanges_IndexOf(this, tau) result(pointstep)
    class(TRanges), intent(in) :: this
    double precision, intent(in) :: tau
    integer :: pointstep, i

    pointstep=0
    do i=1, this%count
        associate(AReg => this%R(i))
            if (tau < AReg%High .and. tau >= AReg%Low) then
                if (AReg%IsLog) then
                    pointstep = AReg%start_index + int(log(tau / AReg%Low) / AReg%delta)
                else
                    pointstep = AReg%start_index + int((tau - AReg%Low) / AReg%delta)
                end if
                return
            end if
        end associate
    end do

    if (tau >= this%Highest) then
        pointstep = this%npoints
    else
        print *, "tau=", tau, ",this%Highest=", this%Highest
        call MpiStop('TRanges_IndexOf: value out of range')
    end if
    end function TRanges_IndexOf

    function TRanges_Array(this)
    class(TRanges), intent(inout), target :: this
    double precision, pointer :: TRanges_Array(:)

    if (this%changed) call this%GetArray(this%has_dpoints)
    TRanges_Array => this%points

    end function TRanges_Array

    function TRanges_dArray(this)
    class(TRanges), intent(inout), target :: this
    double precision, pointer :: TRanges_dArray(:)

    if (this%changed) then
        call this%GetArray(.true.)
    else if (.not. this%has_dpoints) then
        call this%Getdpoints()
        this%has_dpoints = .true.
    end if
    TRanges_dArray => this%dpoints

    end function TRanges_dArray

    subroutine TRanges_GetArray(this, want_dpoints)
    class(TRanges), intent(inout) :: this
    logical, intent(in), optional :: want_dpoints
    integer :: i,j,ix

    this%has_dpoints = DefaultTrue(want_dpoints)

    call reallocate(this%points, this%npoints)

    ix=0
    do i=1, this%count
        associate (AReg => this%R(i))
            do j = 0, AReg%steps-1
                ix=ix+1
                if (AReg%IsLog) then
                    this%points(ix) = AReg%Low*exp(j*AReg%delta)
                else
                    this%points(ix) = AReg%Low + AReg%delta*j
                end if
            end do
        end associate
    end do
    ix =ix+1
    this%points(ix) = this%Highest
    if (ix /= this%npoints) call MpiStop('TRanges_GetArray: ERROR')
    this%changed= .false.
    if (this%has_dpoints) call this%Getdpoints()
    end subroutine TRanges_GetArray


    subroutine TRanges_Getdpoints(this, half_ends)
    class(TRanges), intent(inout) :: this
    logical, intent(in), optional :: half_ends
    integer :: i
    logical :: halfs

    halfs = DefaultTrue(half_ends)

    call reallocate(this%dpoints, this%npoints)
    do i=2, this%npoints-1
        this%dpoints(i) = (this%points(i+1) - this%points(i-1))/2
    end do
    if (halfs) then
        this%dpoints(1) = (this%points(2) - this%points(1))/2
        this%dpoints(this%npoints) = (this%points(this%npoints) - this%points(this%npoints-1))/2
    else
        this%dpoints(1) = (this%points(2) - this%points(1))
        this%dpoints(this%npoints) = (this%points(this%npoints) - this%points(this%npoints-1))
    end if
    end subroutine TRanges_Getdpoints


    subroutine TRanges_Add_delta(this, t_start, t_end, t_approx_delta, IsLog)
    class(TRanges), intent(inout) :: this
    logical, intent(in), optional :: IsLog
    double precision, intent(in) :: t_start, t_end, t_approx_delta
    integer :: n
    logical :: WantLog

    WantLog = DefaultFalse(IsLog)

    if (t_end <= t_start) &
        call MpiStop('TRanges_Add_delta: end must be larger than start')
    if (t_approx_delta <=0) call MpiStop('TRanges_Add_delta: delta must be > 0')

    if (WantLog) then
        n  = max(1,int(log(t_end/t_start)/t_approx_delta + 1.d0 - this%RangeTol))
    else
        n  = max(1,int((t_end-t_start)/t_approx_delta + 1.d0 - this%RangeTol))
    end if
    call this%Add(t_start, t_end, n, WantLog)
    end subroutine TRanges_Add_delta


    subroutine TRanges_Add(this, t_start, t_end, nstep, IsLog)
    class(TRanges), intent(inout) :: this
    logical, intent(in), optional :: IsLog
    double precision, intent(in) :: t_start, t_end
    integer, intent(in) :: nstep
    type(TRange), allocatable, target :: NewRanges(:)
    double precision, allocatable :: EndPoints(:), RequestDelta(:)
    integer :: ixin, nreg, ix, i,j, nsteps
    double precision :: min_request, max_request, min_log_step, max_log_step
    double precision :: delta, diff, max_delta, splitpt
    logical :: WantLog
    type(TRange) :: NewR, TmpR

    WantLog = DefaultFalse(IsLog)

    if (WantLog) then
        delta = log(t_end / t_start) / nstep
    else
        delta = (t_end - t_start) / nstep
    end if

    if (t_end <= t_start) call MpiStop('TRanges_Add: end must be larger than start')
    if (nstep <= 0) call MpiStop('TRanges_Add: nstep must be > 0')

    nreg = 0
    allocate(NewRanges(this%count+1))
    NewR%Low   = t_start
    NewR%High  = t_end
    NewR%delta = delta
    NewR%steps = nstep
    NewR%IsLog = WantLog
    call Setmins(NewR)

    !Add existing ranges adjusting existing bounds if overlapping non-trivially
    do i=1, this%count
        associate(R => this%R(i))
            if (NewR%Low >= R%Low .and. NewR%High <= R%High .and. &
                (NewR%Delta_min >= R%Delta_max .or. (NewR%IsLog .eqv. R%IsLog)  .and. NewR%delta >= R%delta)) then
                !New range narrower than existing range and with wider spacing
                return
            else if (NewR%Low <= R%Low .and. NewR%High >= R%High .and. &
                (NewR%Delta_min <= R%Delta_min .or. (NewR%IsLog .eqv. R%IsLog)  .and. NewR%delta <= R%delta)) then
                !R is completely inside and wider than new one
                cycle
            else if (NewR%Delta_min < R%Delta_max .and. NewR%High > R%Low .and. NewR%Low < R%High) then
                if (R%isLog .and. .not. NewR%isLog) then
                    !Find point where log and linear spacing become equally fine
                    nsteps = int(log(NewR%delta/(exp(R%delta)-1)/R%Low)/R%delta+1)
                    splitpt = R%Low*exp(R%delta*nsteps)
                    if (splitpt*(1-exp(-R%delta)) > NewR%delta*(1+this%RangeTol)) then
                        splitpt = NewR%delta/(1-exp(-R%delta))
                    end if

                    if (splitpt < R%High) then
                        if (R%High > NewR%High) then
                            TmpR%Low = NewR%High
                            TmpR%High = R%High
                            TmpR%IsLog = R%IsLog
                            call SetDelta(TmpR, R%Delta)
                            call AddRange(TmpR)
                        end if
                        R%High = max(NewR%Low, splitpt)
                        call SetDelta(R, R%delta)
                    end if
                else if (.not. R%IsLog .and. NewR%IsLog) then
                    nsteps = int(log(R%delta/(exp(NewR%delta)-1)/NewR%Low)/NewR%delta+1)
                    splitpt = NewR%Low*exp(NewR%delta*nsteps)
                    if (splitpt*(1-exp(-NewR%delta)) > R%delta*(1+this%RangeTol)) then
                        splitpt = R%delta/(1-exp(-NewR%delta))
                    end if
                    if (splitpt < R%High .and. splitpt > R%Low) then
                        if (R%Low < NewR%Low) then
                            TmpR%Low = R%Low
                            TmpR%High = NewR%Low
                            TmpR%IsLog = R%IsLog
                            call SetDelta(TmpR, R%delta)
                            call AddRange(TmpR)
                        end if
                        R%Low = min(NewR%High, splitpt)
                        call SetDelta(R, R%delta)
                    end if
                end if
            end if
            call AddRange(R)
        end associate
    end do
    this%changed = .true.
    if (allocated(this%R)) deallocate(this%R)
    if (nreg>0) allocate(this%R, source = NewRanges(1:nreg))
    this%count = nreg
    call AddRange(NewR)

    allocate(EndPoints(0:nreg * 2))

    !Get end points in order
    ix = 0
    do i=1, nreg
        associate (AReg => NewRanges(i))
            if (ix==0) then
                EndPoints(1) = AReg%Low
                EndPoints(2) = AReg%High
                ix = 2
            else
                ixin = ix
                do j=1,ixin
                    if (AReg%Low < EndPoints(j)) then
                        EndPoints(j+1:ix+1) = EndPoints(j:ix)
                        EndPoints(j) = AReg%Low
                        ix=ix+1
                        exit
                    end if
                end do
                if (ixin == ix) then
                    ix = ix+1
                    EndPoints(ix) = AReg%Low
                    ix = ix+1
                    EndPoints(ix) = AReg%High
                else
                    ixin = ix
                    do j=1,ixin
                        if (AReg%High < EndPoints(j)) then
                            EndPoints(j+1:ix+1) = EndPoints(j:ix)
                            EndPoints(j) = AReg%High
                            ix=ix+1
                            exit
                        end if
                    end do
                    if (ixin == ix) then
                        ix = ix+1
                        EndPoints(ix) = AReg%High
                    end if
                end if
            end if
        end associate
    end do

    !remove duplicate points
    ixin = ix
    ix = 1
    do i=2, ixin
        if (EndPoints(i) /= EndPoints(ix)) then
            ix=ix+1
            EndPoints(ix) = EndPoints(i)
        end if
    end do

    !ix is the number of end points
    this%Lowest = EndPoints(1)
    this%Highest = EndPoints(ix)
    this%count = 0

    max_delta = this%Highest - this%Lowest

    if (.not. allocated(this%R) .or. size(this%R) < ix) then
        if (allocated (this%R)) deallocate (this%R)
        allocate (this%R(ix))
    end if

    allocate(RequestDelta(ix))

    do i=1, ix - 1
        associate (AReg => this%R(i))
            AReg%Low = EndPoints(i)
            AReg%High = EndPoints(i+1)

            delta = max_delta  ! max_delta = EndPoints(i+1) - EndPoints(i)
            AReg%IsLog = .false.
            !Loop over requested ranges to find step size "delta" required to satisfy requirements for this AReg
            do j=1, nreg
                if (AReg%Low >= NewRanges(j)%Low .and. AReg%Low < NewRanges(j)%High) then
                    if (NewRanges(j)%IsLog) then
                        if (AReg%IsLog) then
                            delta = min(delta,NewRanges(j)%delta)
                        else
                            min_log_step = AReg%Low*(exp(NewRanges(j)%delta)-1)
                            if (min_log_step < delta) then
                                max_log_step = AReg%High*(1-exp(-NewRanges(j)%delta))
                                AReg%IsLog = .true.
                                if (max_log_step <= delta) then
                                    delta = NewRanges(j)%delta
                                else
                                    delta = -log(1-delta/AReg%High)
                                end if
                            end if
                        end if
                    else !New Range is not log
                        if (AReg%IsLog) then
                            max_log_step = AReg%High*(1-exp(-delta))
                            if (NewRanges(j)%delta < max_log_step) then
                                min_log_step = AReg%Low*(exp(delta)-1)
                                if (min_log_step <  NewRanges(j)%delta) then
                                    !This is obviously not as good as splitting up the range
                                    delta = -log(1-NewRanges(j)%delta/AReg%High)
                                else
                                    AReg%IsLog = .false.
                                    delta = NewRanges(j)%delta
                                end if
                            end if
                        else
                            delta = min(delta, NewRanges(j)%delta)
                        end if
                    end if
                end if
            end do
            call SetDelta(AReg, delta)
            this%count = this%count + 1
            RequestDelta(this%count) = delta
        end associate
    end do


    !Get rid of tiny TRanges
    ix = this%count
    do i=ix, 1, -1
        associate (AReg => this%R(i))
            if (AReg%steps ==1) then
                Diff = AReg%High - AReg%Low
                if (AReg%IsLog) then
                    min_request = AReg%Low*(exp(RequestDelta(i))-1)
                    max_request = AReg%High*(1-exp(-RequestDelta(i)))
                else
                    min_request = RequestDelta(i)
                    max_request = min_request
                end if
                if (i/= this%count) then
                    associate (LastReg => this%R(i+1))
                        if (RequestDelta(i) >= AReg%delta .and. Diff <= LastReg%Delta_min &
                            .and. LastReg%Delta_min <= max_request .and. &
                            (.not. LastReg%IsLog .or. AReg%Low > LastReg%Low*exp(-LastReg%delta))) then

                            LastReg%Low = AReg%Low
                            if (Diff > LastReg%Delta_min*this%RangeTol) then
                                LastReg%steps =  LastReg%steps + 1
                            end if
                            if (LastReg%IsLog) then
                                LastReg%delta = log(LastReg%High/LastReg%Low) / LastReg%steps
                            else
                                LastReg%delta = (LastReg%High -LastReg%Low) / LastReg%steps
                            end if
                            this%R(i:this%Count-1) = this%R(i+1:this%Count)
                            this%Count = this%Count -1
                            cycle
                        end if
                    end associate
                end if
                if (i/=1) then
                    associate (LastReg => this%R(i-1))
                        if (RequestDelta(i) >= AReg%delta .and. Diff <= LastReg%Delta_max &
                            .and. (LastReg%Delta_max <= min_request .or. diff < LastReg%Delta_min*this%RangeTol)) then
                            LastReg%High = AReg%High
                            if (Diff > LastReg%Delta_max*this%RangeTol) then
                                LastReg%steps =  LastReg%steps + 1
                            end if
                            if (LastReg%IsLog) then
                                LastReg%delta = log(LastReg%High/LastReg%Low) / LastReg%steps
                            else
                                LastReg%delta = (LastReg%High -LastReg%Low) / LastReg%steps
                            end if
                            this%R(i:this%Count-1) = this%R(i+1:this%Count)
                            this%Count = this%Count -1
                        end if
                    end associate
                end if
            end if
        end associate
    end do


    !Set up start indices and get total number of steps
    nsteps = 1
    do i = 1, this%Count
        associate (AReg => this%R(i))
            AReg%Start_index = nsteps
            nsteps = nsteps + AReg%steps
            if (AReg%IsLog) then
                if (AReg%steps ==1) then
                    AReg%Delta_min = AReg%High - AReg%Low
                    AReg%Delta_max = AReg%Delta_min
                else
                    AReg%Delta_min = AReg%Low*(exp(AReg%delta)-1)
                    AReg%Delta_max = AReg%High*(1-exp(-AReg%delta))
                end if
            else
                AReg%Delta_max = AReg%delta
                AReg%Delta_min = AReg%delta
            end if
        end associate
    end do

    this%npoints = nsteps

    contains

    subroutine Setmins(AReg)
    type(TRange), intent(inout) :: Areg

    if (AReg%IsLog) then
        if (AReg%steps ==1) then
            AReg%Delta_min = AReg%High - AReg%Low
            AReg%Delta_max = AReg%Delta_min
        else
            AReg%Delta_min = AReg%Low*(exp(AReg%delta)-1)
            AReg%Delta_max = AReg%High*(1-exp(-AReg%delta))
        end if
    else
        AReg%Delta_max = AReg%delta
        AReg%Delta_min = AReg%delta
    end if
    end subroutine

    subroutine SetDelta(AReg, delta)
    Type(TRange) :: AReg
    double precision, intent(in) :: delta
    double precision Diff

    if (AReg%IsLog) then
        Diff = log(AReg%High/AReg%Low)
    else
        Diff = AReg%High - AReg%Low
    endif
    if (delta >= Diff) then
        AReg%delta = Diff
        AReg%steps = 1
    else
        AReg%steps  = max(1,int(Diff/delta + 1.d0 - this%RangeTol))
        AReg%delta = Diff / AReg%steps
    end if
    call Setmins(AReg)

    end subroutine SetDelta


    subroutine AddRange(R)
    Type(TRange), intent(in) :: R
    Type(TRange), allocatable :: Tmp(:)

    nreg = nreg +1
    if (nreg> size(NewRanges)) then
        allocate(tmp(nreg+3))
        tmp(:nreg-1) = NewRanges(:nreg-1)
        call move_alloc(tmp, NewRanges)
    end if
    NewRanges(nreg) = R
    end subroutine

    end subroutine TRanges_Add


    subroutine TRanges_Write(this)
    class(TRanges), intent(in), target :: this
    integer :: i

    do i=1,this%count
        associate (AReg => this%R(i))
            if (AReg%IsLog) then
                Write (*,'("Range ",I3,":", 3E14.4," log")') i, AReg%Low, AReg%High, AReg%delta
            else
                Write (*,'("Range ",I3,":", 3E14.4," linear")') i, AReg%Low, AReg%High, AReg%delta
            end if
        end associate
    end do
    end subroutine TRanges_Write


    end module RangeUtils

    !####### constrained and unconstrained minimization ######
    !F90 translated version of plato.asu.edu/ftp/other_software/bobyqa.zip and newuoa
    !Powell 2009 Method http://www.damtp.cam.ac.uk/user/na/NA_papers/NA2009_06.pdf

    !AL Sept 2012/2020: translated to F90, changed to input "funkk" class function argument
    !to minimize rather than calfun subroutine as original

    !Typical Usage (typically Npt= 2*dimension+1), to get best fit in params(:) starting from guess

    ! Type(TBOBYQA) :: Minimize !bounded minimization

    ! if (Minimize%BOBYQA(this_class, class_function, dimension, Npt, params,param_min, &
    !           param_max, step_radius, tolerance, DebugLevel, max_eval)) ...
    !

    !Type(TNEWUOA) :: Minimize !unbounded minimization

    ! if (Minimize%NEWUOA(this_class, class_function, dimension, Npt, param_guess, step_radius, &
    !           tolerance, DebugLevel, max_eval)) ...
    !
    ! The class_function is of the form
    !
    ! real(dp) function func(this, x)
    ! class(TMyType) :: this
    ! real(dp), intent(in) :: x(:)
    ! func = ...f(x)...
    ! end function func

    MODULE Powell
    implicit none
    private

    INTEGER, PARAMETER  :: dp = KIND(1.d0) !SELECTED_REAL_KIND(12, 60)
    INTEGER, PARAMETER  :: func_dp = dp  !SELECTED_REAL_KIND(12, 60)
    INTEGER, PARAMETER :: Powell_CO_prec = dp

    ! the type of function minimized, a class procedure taking in an array of values
    interface
    FUNCTION obj_vec_function(obj, x)
    use precision
    class(*) :: obj
    real(dl) :: obj_vec_function
    real(dl) :: x(:)
    END FUNCTION  obj_vec_function
    end interface

    type TMinimizer
        REAL(dp) :: Last_bestfit
        procedure(obj_vec_function), pointer, nopass :: funkk
        class(*), pointer :: obj
    end type

    type, extends(TMinimizer) :: TBOBYQA
        REAL(dp) :: FVAL_Converge_difference = 0._dp
    contains
    procedure :: BOBYQA
    end type

    type, extends(TMinimizer) :: TNEWUOA
    contains
    procedure :: NEWUOA
    procedure, private :: newuob
    end type

    PUBLIC  :: TBOBYQA , TNEWUOA, Powell_CO_prec
    CONTAINS


    function BOBYQA (this, obj, funk, N,NPT,X,XL,XU,RHOBEG,RHOEND,IPRINT,MAXFUN)
    !Main function for bounded minimization
    use iso_c_binding
    class(TBOBYQA) this
    class(*), target :: obj
    real(dp), external :: funk !a class function f(obj,x) where obj is any class instance
    integer, intent(in)::n, npt, maxfun, iPrint
    real(dp), intent(in) :: RHOBEG, RHOEND
    logical BOBYQA
    INTEGER ibmat , id , ifv , igo , ihq , ipq , isl , isu , &
        & ivl , iw , ixa , ixb , ixn , ixo , ixp , izmat , j , jsl ,&
        & jsu, ndim , np
    REAL(dp) temp ,  zero
    REAL(dp) X(*),XL(*),XU(*)
    real(dp), allocatable :: W(:)
    !   This subroutine seeks the least value of a function of many variables,
    !   by applying a trust region method that forms quadratic models by
    !   interpolation. There is usually some freedom in the interpolation
    !   conditions, which is taken up by minimizing the Frobenius norm of
    !   the change to the second derivative of the model, beginning with the
    !   zero matrix. The values of the variables are constrained by upper and
    !   lower bounds. The arguments of the subroutine are as follows.
    !
    !   N must be set to the number of variables and must be at least two.
    !   NPT is the number of interpolation conditions. Its value must be in
    !     the interval [N+2,(N+1)(N+2)/2]. Choices that exceed 2*N+1 are not
    !     recommended.
    !   Initial values of the variables must be set in X(1),X(2),...,X(N). They
    !     will be changed to the values that give the least calculated F.
    !   For I=1,2,...,N, XL(I) and XU(I) must provide the lower and upper
    !     bounds, respectively, on X(I). The construction of quadratic models
    !     requires XL(I) to be strictly less than XU(I) for each I. Further,
    !     the contribution to a model from changes to the I-th variable is
    !     damaged severely by rounding errors if XU(I)-XL(I) is too small.
    !   RHOBEG and RHOEND must be set to the initial and final values of a trust
    !     region radius, so both must be positive with RHOEND no greater than
    !     RHOBEG. Typically, RHOBEG should be about one tenth of the greatest
    !     expected change to a variable, while RHOEND should indicate the
    !     accuracy that is required in the final values of the variables. An
    !     error return occurs if any of the differences XU(I)-XL(I), I=1,...,N,
    !     is less than 2*RHOBEG.
    !   The value of IPRINT should be set to 0, 1, 2 or 3, which controls the
    !     amount of printing. Specifically, there is no output if IPRINT=0 and
    !     there is output only at the return if IPRINT=1. Otherwise, each new
    !     value of RHO is printed, with the best vector of variables so far and
    !     the corresponding value of the objective function. Further, each new
    !     value of F with its variables are output if IPRINT=3.
    !   MAXFUN must be set to an upper bound on the number of calls of CALFUN.
    !   The array W will be used for working space. Its length must be at least
    !     (NPT+5)*(NPT+N)+3*N*(N+5)/2.
    !
    !   funkk(N,X) has to be provided by the user. It must set
    !   F to the value of the objective function for the current values of the
    !   variables X(1),X(2),...,X(N), which are generated automatically in a
    !   way that satisfies the bounds given in XL and XU.
    !
    !   Return if the value of NPT is unacceptable.

    call C_F_PROCPOINTER(c_funloc(funk), this%funkk)
    this%obj => obj

    BOBYQA = .false.
    this%Last_bestfit = 1d30

    NP=N+1
    IF (NPT  <  N+2 .OR. NPT  >  ((N+2)*NP)/2) THEN
        PRINT 10
10      FORMAT (/4X,'Return from BOBYQA because NPT is not in',&
            &      ' the required interval')
        return
    END IF

    allocate(W((NPT+5)*(NPT+N)+3*N*(N+5)/2))

    !  Partition the working space array, so that different parts of it can
    !  be treated separately during the calculation of BOBYQB. The partition
    !  requires the first (NPT+2)*(NPT+N)+3*N*(N+5)/2 elements of W plus the
    !  space that is taken by the last array in the argument list of BOBYQB.
    !
    NDIM=NPT+N
    IXB=1
    IXP=IXB+N
    IFV=IXP+N*NPT
    IXO=IFV+NPT
    IGO=IXO+N
    IHQ=IGO+N
    IPQ=IHQ+(N*NP)/2
    IBMAT=IPQ+NPT
    IZMAT=IBMAT+NDIM*N
    ISL=IZMAT+NPT*(NPT-NP)
    ISU=ISL+N
    IXN=ISU+N
    IXA=IXN+N
    ID=IXA+N
    IVL=ID+N
    IW=IVL+NDIM
    !
    !  Return if there is insufficient space between the bounds. Modify the
    !  initial X if necessary in order to avoid conflicts between the bounds
    !  and the construction of the first quadratic model. The lower and upper
    !  bounds on moves from the updated X are set now, in the ISL and ISU
    !  partitions of W, in order to provide useful and exact information about
    !  components of X that become within distance RHOBEG from their bounds.
    !
    ZERO=0.0D0
    DO J=1,N
        TEMP=XU(J)-XL(J)
        IF (TEMP  <  RHOBEG+RHOBEG) THEN
            PRINT 20
20          FORMAT (/4X,'Return from BOBYQA because one of the',&
                &      ' differences XU(I)-XL(I)'/6X,' is less than 2*RHOBEG.')
            return
        END IF
        JSL=ISL+J-1
        JSU=JSL+N
        W(JSL)=XL(J)-X(J)
        W(JSU)=XU(J)-X(J)
        IF (W(JSL)  >=  -RHOBEG) THEN
            IF (W(JSL)  >=  ZERO) THEN
                X(J)=XL(J)
                W(JSL)=ZERO
                W(JSU)=TEMP
            ELSE
                X(J)=XL(J)+RHOBEG
                W(JSL)=-RHOBEG
                W(JSU)=DMAX1(XU(J)-X(J),RHOBEG)
            END IF
        ELSE IF (W(JSU)  <=  RHOBEG) THEN
            IF (W(JSU)  <=  ZERO) THEN
                X(J)=XU(J)
                W(JSL)=-TEMP
                W(JSU)=ZERO
            ELSE
                X(J)=XU(J)-RHOBEG
                W(JSL)=DMIN1(XL(J)-X(J),-RHOBEG)
                W(JSU)=RHOBEG
            END IF
        END IF
    END DO
    !
    !     Make the call of BOBYQB.
    !
    BOBYQA = BOBYQB (this,N,NPT,X,XL,XU,RHOBEG,RHOEND,IPRINT,MAXFUN,W(IXB),&
        &  W(IXP),W(IFV),W(IXO),W(IGO),W(IHQ),W(IPQ),W(IBMAT),W(IZMAT),&
        &  NDIM,W(ISL),W(ISU),W(IXN),W(IXA),W(ID),W(IVL),W(IW))

    end function BOBYQA


    function BOBYQB (this, N,NPT,X,XL,XU,RHOBEG,RHOEND,IPRINT,&
        &  MAXFUN,XBASE,XPT,FVAL,XOPT,GOPT,HQ,PQ,BMAT,ZMAT,NDIM,&
        &  SL,SU,XNEW,XALT,D,VLAG,W)
    class(TBOBYQA) this
    integer NDIM, NPT
    REAL(dp) X(*),XL(*),XU(*),XBASE(*),XPT(NPT,*),FVAL(*),&
        &  XOPT(*),GOPT(*),HQ(*),PQ(*),BMAT(NDIM,*),ZMAT(NPT,*),&
        &  SL(*),SU(*),XNEW(*),XALT(*),D(*),VLAG(*),W(*)
    logical BOBYQB
    REAL(dp) adelt , alpha , bdtest , bdtol , beta , biglsq ,    &
        & bsum , cauchy , crvmin , curv , delsq , delta , den ,  &
        & denom , densav , diff , diffa , diffb
    REAL(dp) diffc , dist , distsq , dnorm , dsq , dx , errbig , f , &
        & fopt , fracsq , frhosq , fsave , gisq , &
        & gqsq , half , hdiag , one
    REAL(dp) pqold , ratio , rho , Rhobeg , Rhoend , scaden ,  &
        & sum , suma , sumb , sumpq , sumw , sumz , temp , ten ,&
        & tenth , two
    REAL(dp) vquad , xoptsq , zero
    INTEGER i , ih , ip , Iprint , itest , j , jj , jp , k , kbase ,  &
        & knew , kopt , ksav , Maxfun , N , nf , nfsav , nh , np
    INTEGER nptm , nresc , ntrits


    !  The arguments N, NPT, X, XL, XU, RHOBEG, RHOEND, IPRINT and MAXFUN
    !    are identical to the corresponding arguments in SUBROUTINE BOBYQA.
    !  XBASE holds a shift of origin that should reduce the contributions
    !    from rounding errors to values of the model and Lagrange functions.
    !  XPT is a two-dimensional array that holds the coordinates of the
    !    interpolation points relative to XBASE.
    !  FVAL holds the values of F at the interpolation points.
    !  XOPT is set to the displacement from XBASE of the trust region centre.
    !  GOPT holds the gradient of the quadratic model at XBASE+XOPT.
    !  HQ holds the explicit second derivatives of the quadratic model.
    !  PQ contains the parameters of the implicit second derivatives of the
    !    quadratic model.
    !  BMAT holds the last N columns of H.
    !  ZMAT holds the factorization of the leading NPT by NPT submatrix of H,
    !    this factorization being ZMAT times ZMAT^T, which provides both the
    !    correct rank and positive semi-definiteness.
    !  NDIM is the first dimension of BMAT and has the value NPT+N.
    !  SL and SU hold the differences XL-XBASE and XU-XBASE, respectively.
    !    All the components of every XOPT are going to satisfy the bounds
    !    SL(I) .LEQ. XOPT(I) .LEQ. SU(I), with appropriate equalities when
    !    XOPT is on a constraint boundary.
    !  XNEW is chosen by SUBROUTINE TRSBOX or ALTMOV. Usually XBASE+XNEW is the
    !    vector of variables for the next call of CALFUN. XNEW also satisfies
    !    the SL and SU constraints in the way that has just been mentioned.
    !  XALT is an alternative to XNEW, chosen by ALTMOV, that may replace XNEW
    !    in order to increase the denominator in the updating of UPDATE.
    !  D is reserved for a trial step from XOPT, which is usually XNEW-XOPT.
    !  VLAG contains the values of the Lagrange functions at a new point X.
    !    They are part of a product that requires VLAG to be of length NDIM.
    !  W is a one-dimensional array that is used for working space. Its length
    !    must be at least 3*NDIM = 3*(NPT+N).
    !
    !     Set some constants.
    !
    HALF=0.5D0
    ONE=1.0D0
    TEN=10.0D0
    TENTH=0.1D0
    TWO=2.0D0
    ZERO=0.0D0
    NP=N+1
    NPTM=NPT-NP
    NH=(N*NP)/2
    BOBYQB = .true.
    !
    !  The call of PRELIM sets the elements of XBASE, XPT, FVAL, GOPT, HQ, PQ,
    !  BMAT and ZMAT for the first iteration, with the corresponding values of
    !  of NF and KOPT, which are the number of calls of CALFUN so far and the
    !  index of the interpolation point at the trust region centre. Then the
    !  initial XOPT is set too. The branch to label 720 occurs if MAXFUN is
    !  less than NPT. GOPT will be updated if KOPT is different from KBASE.
    !
    CALL PRELIM (this,N,NPT,X,XL,XU,RHOBEG,IPRINT,MAXFUN,XBASE,XPT,&
        &  FVAL,GOPT,HQ,PQ,BMAT,ZMAT,NDIM,SL,SU,NF,KOPT)
    XOPTSQ=ZERO
    DO I=1,N
        XOPT(I)=XPT(KOPT,I)
        XOPTSQ=XOPTSQ+XOPT(I)**2
    END DO
    FSAVE=FVAL(1)
    IF (NF  <  NPT) THEN
        IF (IPRINT  >  0) PRINT 390
        GOTO 720
    END IF
    KBASE=1
    !
    !     Complete the settings that are required for the iterative procedure
    !
    RHO=RHOBEG
    DELTA=RHO
    NRESC=NF
    NTRITS=0
    DIFFA=ZERO
    DIFFB=ZERO
    ITEST=0
    NFSAV=NF
    !
    !     Update GOPT if necessary before the first iteration and after each
    !     call of RESCUE that makes a call of CALFUN.
    !
20  IF (KOPT .NE. KBASE) THEN
        IH=0
        DO J=1,N
            DO I=1,J
                IH=IH+1
                IF (I  <  J) GOPT(J)=GOPT(J)+HQ(IH)*XOPT(I)
                GOPT(I)=GOPT(I)+HQ(IH)*XOPT(J)
            END DO
        END DO
        IF (NF  >  NPT) THEN
            DO K=1,NPT
                TEMP=ZERO
                DO J=1,N
                    TEMP=TEMP+XPT(K,J)*XOPT(J)
                END DO
                TEMP=PQ(K)*TEMP
                DO I=1,N
                    GOPT(I)=GOPT(I)+TEMP*XPT(K,I)
                END DO
            END DO
        END IF
    END IF
    !
    !  Generate the next point in the trust region that provides a small value
    !  of the quadratic model subject to the constraints on the variables.
    !  The integer NTRITS is set to the number "trust region" iterations that
    !  have occurred since the last "alternative" iteration. If the length
    !  of XNEW-XOPT is less than HALF*RHO, however, then there is a branch to
    !  label 650 or 680 with NTRITS=-1, instead of calculating F at XNEW.
    !
60  CALL TRSBOX (N,NPT,XPT,XOPT,GOPT,HQ,PQ,SL,SU,DELTA,XNEW,D,&
        &  W,W(NP),W(NP+N),W(NP+2*N),W(NP+3*N),DSQ,CRVMIN)
    DNORM=DMIN1(DELTA,DSQRT(DSQ))
    IF (DNORM  <  HALF*RHO) THEN
        NTRITS=-1
        DISTSQ=(TEN*RHO)**2
        IF (NF  <=  NFSAV+2) GOTO 650
        !
        !  The following choice between labels 650 and 680 depends on whether or
        !  not our work with the current RHO seems to be complete. Either RHO is
        !  decreased or termination occurs if the errors in the quadratic model at
        !  the last three interpolation points compare favourably with predictions
        !  of likely improvements to the model within distance HALF*RHO of XOPT.
        !
        ERRBIG=DMAX1(DIFFA,DIFFB,DIFFC)
        FRHOSQ=0.125D0*RHO*RHO
        IF (CRVMIN  >  ZERO .AND. ERRBIG  >  FRHOSQ*CRVMIN)&
            &       GOTO 650
        BDTOL=ERRBIG/RHO
        DO J=1,N
            BDTEST=BDTOL
            IF (XNEW(J) .EQ. SL(J)) BDTEST=W(J)
            IF (XNEW(J) .EQ. SU(J)) BDTEST=-W(J)
            IF (BDTEST  <  BDTOL) THEN
                CURV=HQ((J+J*J)/2)
                DO K=1,NPT
                    CURV=CURV+PQ(K)*XPT(K,J)**2
                END DO
                BDTEST=BDTEST+HALF*CURV*RHO
                IF (BDTEST  <  BDTOL) GOTO 650
            END IF
        END DO
        GOTO 680
    END IF
    NTRITS=NTRITS+1
    !
    !  Severe cancellation is likely to occur if XOPT is too far from XBASE.
    !  If the following test holds, then XBASE is shifted so that XOPT becomes
    !  zero. The appropriate changes are made to BMAT and to the second
    !  derivatives of the current model, beginning with the changes to BMAT
    !  that do not depend on ZMAT. VLAG is used temporarily for working space.
    !
90  IF (DSQ  <=  1.0D-3*XOPTSQ) THEN
        FRACSQ=0.25D0*XOPTSQ
        SUMPQ=ZERO
        DO K=1,NPT
            SUMPQ=SUMPQ+PQ(K)
            SUM=-HALF*XOPTSQ
            DO I=1,N
                SUM=SUM+XPT(K,I)*XOPT(I)
            END DO
            W(NPT+K)=SUM
            TEMP=FRACSQ-HALF*SUM
            DO I=1,N
                W(I)=BMAT(K,I)
                VLAG(I)=SUM*XPT(K,I)+TEMP*XOPT(I)
                IP=NPT+I
                DO J=1,I
                    BMAT(IP,J)=BMAT(IP,J)+W(I)*VLAG(J)+VLAG(I)*W(J)
                END DO
            END DO
        END DO
        !
        !     Then the revisions of BMAT that depend on ZMAT are calculated.
        !
        DO JJ=1,NPTM
            SUMZ=ZERO
            SUMW=ZERO
            DO K=1,NPT
                SUMZ=SUMZ+ZMAT(K,JJ)
                VLAG(K)=W(NPT+K)*ZMAT(K,JJ)
                SUMW=SUMW+VLAG(K)
            END DO
            DO J=1,N
                SUM=(FRACSQ*SUMZ-HALF*SUMW)*XOPT(J)
                DO K=1,NPT
                    SUM=SUM+VLAG(K)*XPT(K,J)
                END DO
                W(J)=SUM
                DO K=1,NPT
                    BMAT(K,J)=BMAT(K,J)+SUM*ZMAT(K,JJ)
                END DO
            END DO
            DO I=1,N
                IP=I+NPT
                TEMP=W(I)
                DO J=1,I
                    BMAT(IP,J)=BMAT(IP,J)+TEMP*W(J)
                END DO
            END DO
        END DO
        !
        !  The following instructions complete the shift, including the changes
        !  to the second derivative parameters of the quadratic model.
        !
        IH=0
        DO J=1,N
            W(J)=-HALF*SUMPQ*XOPT(J)
            DO K=1,NPT
                W(J)=W(J)+PQ(K)*XPT(K,J)
                XPT(K,J)=XPT(K,J)-XOPT(J)
            END DO
            DO I=1,J
                IH=IH+1
                HQ(IH)=HQ(IH)+W(I)*XOPT(J)+XOPT(I)*W(J)
                BMAT(NPT+I,J)=BMAT(NPT+J,I)
            END DO
        END DO
        DO I=1,N
            XBASE(I)=XBASE(I)+XOPT(I)
            XNEW(I)=XNEW(I)-XOPT(I)
            SL(I)=SL(I)-XOPT(I)
            SU(I)=SU(I)-XOPT(I)
            XOPT(I)=ZERO
        END DO
        XOPTSQ=ZERO
    END IF
    IF (NTRITS .EQ. 0) GOTO 210
    GOTO 230
    !
    !  XBASE is also moved to XOPT by a call of RESCUE. This calculation is
    !  more expensive than the previous shift, because new matrices BMAT and
    !  ZMAT are generated from scratch, which may include the replacement of
    !  interpolation points whose positions seem to be causing near linear
    !  dependence in the interpolation conditions. Therefore RESCUE is called
    !  only if rounding errors have reduced by at least a factor of two the
    !  denominator of the formula for updating the H matrix. It provides a
    !  useful safeguard, but is not invoked in most applications of BOBYQA.
    !
190 NFSAV=NF
    KBASE=KOPT
    CALL RESCUE (this, N,NPT,XL,XU,IPRINT,MAXFUN,XBASE,XPT,FVAL,&
        &  XOPT,GOPT,HQ,PQ,BMAT,ZMAT,NDIM,SL,SU,NF,DELTA,KOPT,&
        &  VLAG,W,W(N+NP),W(NDIM+NP))
    !
    !  XOPT is updated now in case the branch below to label 720 is taken.
    !  Any updating of GOPT occurs after the branch below to label 20, which
    !  leads to a trust region iteration as does the branch to label 60.
    !
    XOPTSQ=ZERO
    IF (KOPT .NE. KBASE) THEN
        DO I=1,N
            XOPT(I)=XPT(KOPT,I)
            XOPTSQ=XOPTSQ+XOPT(I)**2
        END DO
    END IF
    IF (NF  <  0) THEN
        NF=MAXFUN
        IF (IPRINT  >  0) PRINT 390
        GOTO 720
    END IF
    NRESC=NF
    IF (NFSAV  <  NF) THEN
        NFSAV=NF
        GOTO 20
    END IF
    IF (NTRITS  >  0) GOTO 60
    !
    !  Pick two alternative vectors of variables, relative to XBASE, that
    !  are suitable as new positions of the KNEW-th interpolation point.
    !  Firstly, XNEW is set to the point on a line through XOPT and another
    !  interpolation point that minimizes the predicted value of the next
    !  denominator, subject to ||XNEW - XOPT|| .LEQ. ADELT and to the SL
    !  and SU bounds. Secondly, XALT is set to the best feasible point on
    !  a constrained version of the Cauchy step of the KNEW-th Lagrange
    !  function, the corresponding value of the square of this function
    !  being returned in CAUCHY. The choice between these alternatives is
    !  going to be made when the denominator is calculated.
    !
210 CALL ALTMOV (N,NPT,XPT,XOPT,BMAT,ZMAT,NDIM,SL,SU,KOPT,&
        &  KNEW,ADELT,XNEW,XALT,ALPHA,CAUCHY,W,W(NP),W(NDIM+1))
    DO I=1,N
        D(I)=XNEW(I)-XOPT(I)
    END DO
    !
    !  Calculate VLAG and BETA for the current choice of D. The scalar
    !  product of D with XPT(K,.) is going to be held in W(NPT+K) for
    !  use when VQUAD is calculated.
    !
230 DO K=1,NPT
        SUMA=ZERO
        SUMB=ZERO
        SUM=ZERO
        DO J=1,N
            SUMA=SUMA+XPT(K,J)*D(J)
            SUMB=SUMB+XPT(K,J)*XOPT(J)
            SUM=SUM+BMAT(K,J)*D(J)
        END DO
        W(K)=SUMA*(HALF*SUMA+SUMB)
        VLAG(K)=SUM
        W(NPT+K)=SUMA
    END DO
    BETA=ZERO
    DO JJ=1,NPTM
        SUM=ZERO
        DO K=1,NPT
            SUM=SUM+ZMAT(K,JJ)*W(K)
        END DO
        BETA=BETA-SUM*SUM
        DO K=1,NPT
            VLAG(K)=VLAG(K)+SUM*ZMAT(K,JJ)
        END DO
    END DO
    DSQ=ZERO
    BSUM=ZERO
    DX=ZERO
    DO J=1,N
        DSQ=DSQ+D(J)**2
        SUM=ZERO
        DO K=1,NPT
            SUM=SUM+W(K)*BMAT(K,J)
        END DO
        BSUM=BSUM+SUM*D(J)
        JP=NPT+J
        DO I=1,N
            SUM=SUM+BMAT(JP,I)*D(I)
        END DO
        VLAG(JP)=SUM
        BSUM=BSUM+SUM*D(J)
        DX=DX+D(J)*XOPT(J)
    END DO
    BETA=DX*DX+DSQ*(XOPTSQ+DX+DX+HALF*DSQ)+BETA-BSUM
    VLAG(KOPT)=VLAG(KOPT)+ONE
    !
    !  If NTRITS is zero, the denominator may be increased by replacing
    !  the step D of ALTMOV by a Cauchy step. Then RESCUE may be called if
    !  rounding errors have damaged the chosen denominator.
    !
    IF (NTRITS .EQ. 0) THEN
        DENOM=VLAG(KNEW)**2+ALPHA*BETA
        IF (DENOM  <  CAUCHY .AND. CAUCHY  >  ZERO) THEN
            DO I=1,N
                XNEW(I)=XALT(I)
                D(I)=XNEW(I)-XOPT(I)
            END DO
            CAUCHY=ZERO
            GO TO 230
        END IF
        IF (DENOM  <=  HALF*VLAG(KNEW)**2) THEN
            IF (NF  >  NRESC) GOTO 190
            IF (IPRINT  >  0) PRINT 320
320         FORMAT (/5X,'Return from BOBYQA because of much',&
                &          ' cancellation in a denominator.')
            GOTO 720
        END IF
        !
        !  Alternatively, if NTRITS is positive, then set KNEW to the index of
        !  the next interpolation point to be deleted to make room for a trust
        !  region step. Again RESCUE may be called if rounding errors have damaged
        !  the chosen denominator, which is the reason for attempting to select
        !  KNEW before calculating the next value of the objective function.
        !
    ELSE
        DELSQ=DELTA*DELTA
        SCADEN=ZERO
        BIGLSQ=ZERO
        KNEW=0
        DO K=1,NPT
            IF (K .EQ. KOPT) continue
            HDIAG=ZERO
            DO JJ=1,NPTM
                HDIAG=HDIAG+ZMAT(K,JJ)**2
            END DO
            DEN=BETA*HDIAG+VLAG(K)**2
            DISTSQ=ZERO
            DO J=1,N
                DISTSQ=DISTSQ+(XPT(K,J)-XOPT(J))**2
            END DO
            TEMP=DMAX1(ONE,(DISTSQ/DELSQ)**2)
            IF (TEMP*DEN  >  SCADEN) THEN
                SCADEN=TEMP*DEN
                KNEW=K
                DENOM=DEN
            END IF
            BIGLSQ=DMAX1(BIGLSQ,TEMP*VLAG(K)**2)
        END DO
        IF (SCADEN  <=  HALF*BIGLSQ) THEN
            IF (NF  >  NRESC) GOTO 190
            IF (IPRINT  >  0) PRINT 320
            GOTO 720
        END IF
    END IF
    !
    !  Put the variables for the next calculation of the objective function
    !    in XNEW, with any adjustments for the bounds.
    !
    !
    !  Calculate the value of the objective function at XBASE+XNEW, unless
    !    the limit on the number of calculations of F has been reached.
    !
360 DO I=1,N
        X(I)=DMIN1(DMAX1(XL(I),XBASE(I)+XNEW(I)),XU(I))
        IF (XNEW(I) .EQ. SL(I)) X(I)=XL(I)
        IF (XNEW(I) .EQ. SU(I)) X(I)=XU(I)
    END DO
    IF (NF  >=  MAXFUN) THEN
        IF (IPRINT  >  0) PRINT 390
390     FORMAT (/4X,'Return from BOBYQA because funkk has been',&
            &      ' called MAXFUN times.')
        BOBYQB = .false.
        GOTO 720
    END IF
    NF=NF+1
    F = this%funkk(this%obj, X(1:N))
    IF (IPRINT .EQ. 3) THEN
        PRINT 400, NF,F,(X(I),I=1,N)
400     FORMAT (/4X,'Function number',I6,'    F =',1PD18.10,&
            &       '    The corresponding X is:'/(2X,5D15.6))
    END IF
    IF (NTRITS .EQ. -1) THEN
        FSAVE=F
        GOTO 720
    END IF
    !
    !  Use the quadratic model to predict the change in F due to the step D,
    !    and set DIFF to the error of this prediction.
    !
    FOPT=FVAL(KOPT)
    VQUAD=ZERO
    IH=0
    DO J=1,N
        VQUAD=VQUAD+D(J)*GOPT(J)
        DO I=1,J
            IH=IH+1
            TEMP=D(I)*D(J)
            IF (I .EQ. J) TEMP=HALF*TEMP
            VQUAD=VQUAD+HQ(IH)*TEMP
        END DO
    END DO
    DO K=1,NPT
        VQUAD=VQUAD+HALF*PQ(K)*W(NPT+K)**2
    END DO
    DIFF=F-FOPT-VQUAD
    DIFFC=DIFFB
    DIFFB=DIFFA
    DIFFA=DABS(DIFF)
    IF (DNORM  >  RHO) NFSAV=NF
    !
    !     Pick the next value of DELTA after a trust region step.
    !
    IF (NTRITS  >  0) THEN
        IF (VQUAD  >=  ZERO) THEN
            IF (IPRINT  >  0) PRINT 430
430         FORMAT (/4X,'Return from BOBYQA because a trust',&
                &          ' region step has failed to reduce Q.')
            BOBYQB = .false.
            GOTO 720
        END IF
        RATIO=(F-FOPT)/VQUAD
        IF (RATIO  <=  TENTH) THEN
            DELTA=DMIN1(HALF*DELTA,DNORM)
        ELSEIF (RATIO  <=  0.7D0) THEN
            DELTA=DMAX1(HALF*DELTA,DNORM)
        ELSE
            DELTA=DMAX1(HALF*DELTA,DNORM+DNORM)
        END IF
        IF (DELTA  <=  1.5D0*RHO) DELTA=RHO
        !
        !     Recalculate KNEW and DENOM if the new F is less than FOPT.
        !
        IF (F  <  FOPT) THEN
            KSAV=KNEW
            DENSAV=DENOM
            DELSQ=DELTA*DELTA
            SCADEN=ZERO
            BIGLSQ=ZERO
            KNEW=0
            DO K=1,NPT
                HDIAG=ZERO
                DO JJ=1,NPTM
                    HDIAG=HDIAG+ZMAT(K,JJ)**2
                END DO
                DEN=BETA*HDIAG+VLAG(K)**2
                DISTSQ=ZERO
                DO J=1,N
                    DISTSQ=DISTSQ+(XPT(K,J)-XNEW(J))**2
                END DO
                TEMP=DMAX1(ONE,(DISTSQ/DELSQ)**2)
                IF (TEMP*DEN  >  SCADEN) THEN
                    SCADEN=TEMP*DEN
                    KNEW=K
                    DENOM=DEN
                END IF
                BIGLSQ=DMAX1(BIGLSQ,TEMP*VLAG(K)**2)
            END DO
            IF (SCADEN  <=  HALF*BIGLSQ) THEN
                KNEW=KSAV
                DENOM=DENSAV
            END IF
        END IF
    END IF
    !
    !  Update BMAT and ZMAT, so that the KNEW-th interpolation point can be
    !  moved. Also update the second derivative terms of the model.
    !
    CALL UPDATE (N,NPT,BMAT,ZMAT,NDIM,VLAG,BETA,DENOM,KNEW,W)
    IH=0
    PQOLD=PQ(KNEW)
    PQ(KNEW)=ZERO
    DO I=1,N
        TEMP=PQOLD*XPT(KNEW,I)
        DO J=1,I
            IH=IH+1
            HQ(IH)=HQ(IH)+TEMP*XPT(KNEW,J)
        END DO
    END DO
    DO  JJ=1,NPTM
        TEMP=DIFF*ZMAT(KNEW,JJ)
        DO  K=1,NPT
            PQ(K)=PQ(K)+TEMP*ZMAT(K,JJ)
        END DO
    END DO
    !
    !  Include the new interpolation point, and make the changes to GOPT at
    !  the old XOPT that are caused by the updating of the quadratic model.
    !
    FVAL(KNEW)=F
    DO  I=1,N
        XPT(KNEW,I)=XNEW(I)
        W(I)=BMAT(KNEW,I)
    END DO
    DO K=1,NPT
        SUMA=ZERO
        DO JJ=1,NPTM
            SUMA=SUMA+ZMAT(KNEW,JJ)*ZMAT(K,JJ)
        END DO
        SUMB=ZERO
        DO J=1,N
            SUMB=SUMB+XPT(K,J)*XOPT(J)
        END DO
        TEMP=SUMA*SUMB
        DO I=1,N
            W(I)=W(I)+TEMP*XPT(K,I)
        END DO
    END DO
    DO I=1,N
        GOPT(I)=GOPT(I)+DIFF*W(I)
    END DO
    !
    !     Update XOPT, GOPT and KOPT if the new calculated F is less than FO
    !
    IF (F  <  FOPT) THEN
        KOPT=KNEW
        XOPTSQ=ZERO
        IH=0
        DO J=1,N
            XOPT(J)=XNEW(J)
            XOPTSQ=XOPTSQ+XOPT(J)**2
            DO I=1,J
                IH=IH+1
                IF (I  <  J) GOPT(J)=GOPT(J)+HQ(IH)*D(I)
                GOPT(I)=GOPT(I)+HQ(IH)*D(J)
            END DO
        END DO
        DO K=1,NPT
            TEMP=ZERO
            DO J=1,N
                TEMP=TEMP+XPT(K,J)*D(J)
            END DO
            TEMP=PQ(K)*TEMP
            DO I=1,N
                GOPT(I)=GOPT(I)+TEMP*XPT(K,I)
            END DO
        END DO
    END IF
    !
    !  Calculate the parameters of the least Frobenius norm interpolant to
    !  the current data, the gradient of this interpolant at XOPT being put
    !  into VLAG(NPT+I), I=1,2,...,N.
    !
    IF (NTRITS  >  0) THEN
        DO K=1,NPT
            VLAG(K)=FVAL(K)-FVAL(KOPT)
            W(K)=ZERO
        END DO
        DO J=1,NPTM
            SUM=ZERO
            DO K=1,NPT
                SUM=SUM+ZMAT(K,J)*VLAG(K)
            END DO
            DO K=1,NPT
                W(K)=W(K)+SUM*ZMAT(K,J)
            END DO
        END DO
        DO  K=1,NPT
            SUM=ZERO
            DO J=1,N
                SUM=SUM+XPT(K,J)*XOPT(J)
            END DO
            W(K+NPT)=W(K)
            W(K)=SUM*W(K)
        END DO
        GQSQ=ZERO
        GISQ=ZERO
        DO I=1,N
            SUM=ZERO
            DO K=1,NPT
                SUM=SUM+BMAT(K,I)*VLAG(K)+XPT(K,I)*W(K)
            END DO
            IF (XOPT(I) .EQ. SL(I)) THEN
                GQSQ=GQSQ+DMIN1(ZERO,GOPT(I))**2
                GISQ=GISQ+DMIN1(ZERO,SUM)**2
            ELSE IF (XOPT(I) .EQ. SU(I)) THEN
                GQSQ=GQSQ+DMAX1(ZERO,GOPT(I))**2
                GISQ=GISQ+DMAX1(ZERO,SUM)**2
            ELSE
                GQSQ=GQSQ+GOPT(I)**2
                GISQ=GISQ+SUM*SUM
            END IF
            VLAG(NPT+I)=SUM
        END DO
        !
        !  Test whether to replace the new quadratic model by the least Frobenius
        !  norm interpolant, making the replacement if the test is satisfied.
        !
        ITEST=ITEST+1
        IF (GQSQ  <  TEN*GISQ) ITEST=0
        IF (ITEST  >=  3) THEN
            DO I=1,MAX0(NPT,NH)
                IF (I  <=  N) GOPT(I)=VLAG(NPT+I)
                IF (I  <=  NPT) PQ(I)=W(NPT+I)
                IF (I  <=  NH) HQ(I)=ZERO
                ITEST=0
            END DO
        END IF
    END IF
    !
    !  If a trust region step has provided a sufficient decrease in F, then
    !  branch for another trust region calculation. The case NTRITS=0 occurs
    !  when the new interpolation point was reached by an alternative step.
    !
    IF (NTRITS .EQ. 0) GOTO 60
    IF (F  <=  FOPT+TENTH*VQUAD) GOTO 60
    !
    !     Alternatively, find out if the interpolation points are close enough
    !       to the best point so far.
    !
    DISTSQ=DMAX1((TWO*DELTA)**2,(TEN*RHO)**2)
650 KNEW=0
    DO K=1,NPT
        SUM=ZERO
        DO J=1,N
            SUM=SUM+(XPT(K,J)-XOPT(J))**2
        END DO
        IF (SUM  >  DISTSQ) THEN
            KNEW=K
            DISTSQ=SUM
        END IF
    END DO
    !
    !  If KNEW is positive, then ALTMOV finds alternative new positions for
    !  the KNEW-th interpolation point within distance ADELT of XOPT. It is
    !  reached via label 90. Otherwise, there is a branch to label 60 for
    !  another trust region iteration, unless the calculations with the
    !  current RHO are complete.
    !
    IF (KNEW  >  0) THEN
        DIST=DSQRT(DISTSQ)
        IF (NTRITS .EQ. -1) THEN
            DELTA=DMIN1(TENTH*DELTA,HALF*DIST)
            IF (DELTA  <=  1.5D0*RHO) DELTA=RHO
        END IF
        NTRITS=0
        ADELT=DMAX1(DMIN1(TENTH*DIST,DELTA),RHO)
        DSQ=ADELT*ADELT
        GOTO 90
    END IF
    IF (NTRITS .EQ. -1) GOTO 680
    IF (RATIO  >  ZERO) GOTO 60
    IF (DMAX1(DELTA,DNORM)  >  RHO) GOTO 60
    !
    !  The calculations with the current value of RHO are complete. Pick the
    !    next values of RHO and DELTA.
    !
680 IF (RHO  >  RHOEND .and. (this%FVAL_Converge_difference==0._dp .or. &
        abs(FVAL(KOPT)-this%Last_bestfit) > this%FVAL_Converge_difference)) THEN
        DELTA=HALF*RHO
        RATIO=RHO/RHOEND
        IF (RATIO  <=  16.0D0) THEN
            RHO=RHOEND
        ELSE IF (RATIO  <=  250.0D0) THEN
            RHO=DSQRT(RATIO)*RHOEND
        ELSE
            RHO=TENTH*RHO
        END IF
        DELTA=DMAX1(DELTA,RHO)
        this%Last_bestfit = FVAL(KOPT)
        IF (IPRINT  >=  2) THEN
            IF (IPRINT  >=  3) PRINT 690
690         FORMAT (5X)
            PRINT 700, RHO,NF
700         FORMAT (/4X,'New RHO =',1PD11.4,5X,'Number of',&
                &          ' function values =',I6)
            PRINT 710, FVAL(KOPT),(XBASE(I)+XOPT(I),I=1,N)
710         FORMAT (4X,'Least value of F =',1PD23.15,9X,&
                &          'The corresponding X is:'/(2X,5D15.6))
        END IF
        NTRITS=0
        NFSAV=NF
        GOTO 60
    END IF
    !
    !     Return from the calculation, after another Newton-Raphson step, if
    !       it is too short to have been tried before.
    !
    IF (NTRITS .EQ. -1) GOTO 360
720 IF (FVAL(KOPT)  <=  FSAVE) THEN
        DO I=1,N
            X(I)=DMIN1(DMAX1(XL(I),XBASE(I)+XOPT(I)),XU(I))
            IF (XOPT(I) .EQ. SL(I)) X(I)=XL(I)
            IF (XOPT(I) .EQ. SU(I)) X(I)=XU(I)
        END DO
        F=FVAL(KOPT)
    END IF
    IF (IPRINT  >=  1) THEN
        if (RHO  >  RHOEND) write(*,*) '    FVAL_Converge_difference reached'
        PRINT 740, NF
740     FORMAT (/4X,'At the return from BOBYQA',5X,&
            &      'Number of function values =',I6)
        PRINT 710, F,(X(I),I=1,N)
    END IF
    end function BOBYQB


    SUBROUTINE ALTMOV (N,NPT,XPT,XOPT,BMAT,ZMAT,NDIM,SL,SU,KOPT,&
        &  KNEW,ADELT,XNEW,XALT,ALPHA,CAUCHY,GLAG,HCOL,W)
    REAL(dp) Adelt , Alpha , bigstp , Cauchy , const , csave ,   &
        & curv , dderiv , diff , distsq , ggfree , gw , ha ,  &
        & half , one , predsq , presav
    REAL(dp) scale , slbd , step , stpsav , subd , sumin ,    &
        & temp , tempa , tempb , tempd , vlag , wfixsq , wsqsav, zero
    INTEGER i , ibdsav , iflag , ilbd , isbd , iubd , j , k , Knew ,  &
        & Kopt , ksav , N , Ndim , Npt
    REAL(dp) XPT(NPT,*),XOPT(*),BMAT(NDIM,*),ZMAT(NPT,*),SL(*),&
        &  SU(*),XNEW(*),XALT(*),GLAG(*),HCOL(*),W(*)
    !
    !  The arguments N, NPT, XPT, XOPT, BMAT, ZMAT, NDIM, SL and SU all have
    !    the same meanings as the corresponding arguments of BOBYQB.
    !  KOPT is the index of the optimal interpolation point.
    !  KNEW is the index of the interpolation point that is going to be moved.
    !  ADELT is the current trust region bound.
    !  XNEW will be set to a suitable new position for the interpolation point
    !    XPT(KNEW,.). Specifically, it satisfies the SL, SU and trust region
    !    bounds and it should provide a large denominator in the next call of
    !    UPDATE. The step XNEW-XOPT from XOPT is restricted to moves along the
    !    straight lines through XOPT and another interpolation point.
    !  XALT also provides a large value of the modulus of the KNEW-th Lagrange
    !    function subject to the constraints that have been mentioned, its main
    !    difference from XNEW being that XALT-XOPT is a constrained version of
    !    the Cauchy step within the trust region. An exception is that XALT is
    !    not calculated if all components of GLAG (see below) are zero.
    !  ALPHA will be set to the KNEW-th diagonal element of the H matrix.
    !  CAUCHY will be set to the square of the KNEW-th Lagrange function at
    !    the step XALT-XOPT from XOPT for the vector XALT that is returned,
    !    except that CAUCHY is set to zero if XALT is not calculated.
    !  GLAG is a working space vector of length N for the gradient of the
    !    KNEW-th Lagrange function at XOPT.
    !  HCOL is a working space vector of length NPT for the second derivative
    !    coefficients of the KNEW-th Lagrange function.
    !  W is a working space vector of length 2N that is going to hold the
    !    constrained Cauchy step from XOPT of the Lagrange function, followed
    !    by the downhill version of XALT when the uphill step is calculated.
    !
    !  Set the first NPT components of W to the leading elements of the
    !  KNEW-th column of the H matrix.
    !
    HALF=0.5D0
    ONE=1.0D0
    ZERO=0.0D0
    CONST=ONE+DSQRT(2.0D0)
    DO K=1,NPT
        HCOL(K)=ZERO
    END DO
    DO J=1,NPT-N-1
        TEMP=ZMAT(KNEW,J)
        DO K=1,NPT
            HCOL(K)=HCOL(K)+TEMP*ZMAT(K,J)
        END DO
    END DO
    ALPHA=HCOL(KNEW)
    HA=HALF*ALPHA
    !
    !     Calculate the gradient of the KNEW-th Lagrange function at XOPT.
    !
    DO I=1,N
        GLAG(I)=BMAT(KNEW,I)
    END DO
    DO  K=1,NPT
        TEMP=ZERO
        DO J=1,N
            TEMP=TEMP+XPT(K,J)*XOPT(J)
        END DO
        TEMP=HCOL(K)*TEMP
        DO I=1,N
            GLAG(I)=GLAG(I)+TEMP*XPT(K,I)
        END DO
    END DO
    !
    !  Search for a large denominator along the straight lines through XOPT
    !  and another interpolation point. SLBD and SUBD will be lower and upper
    !  bounds on the step along each of these lines in turn. PREDSQ will be
    !  set to the square of the predicted denominator for each line. PRESAV
    !  will be set to the largest admissible value of PREDSQ that occurs.
    PRESAV=ZERO
    DO K=1,NPT
        IF (K .EQ. KOPT) continue
        DDERIV=ZERO
        DISTSQ=ZERO
        DO I=1,N
            TEMP=XPT(K,I)-XOPT(I)
            DDERIV=DDERIV+GLAG(I)*TEMP
            DISTSQ=DISTSQ+TEMP*TEMP
        END DO
        SUBD=ADELT/DSQRT(DISTSQ)
        SLBD=-SUBD
        ILBD=0
        IUBD=0
        SUMIN=DMIN1(ONE,SUBD)
        !
        !     Revise SLBD and SUBD if necessary because of the bounds in SL and
        !
        DO I=1,N
            TEMP=XPT(K,I)-XOPT(I)
            IF (TEMP  >  ZERO) THEN
                IF (SLBD*TEMP  <  SL(I)-XOPT(I)) THEN
                    SLBD=(SL(I)-XOPT(I))/TEMP
                    ILBD=-I
                END IF
                IF (SUBD*TEMP  >  SU(I)-XOPT(I)) THEN
                    SUBD=DMAX1(SUMIN,(SU(I)-XOPT(I))/TEMP)
                    IUBD=I
                END IF
            ELSE IF (TEMP  <  ZERO) THEN
                IF (SLBD*TEMP  >  SU(I)-XOPT(I)) THEN
                    SLBD=(SU(I)-XOPT(I))/TEMP
                    ILBD=I
                END IF
                IF (SUBD*TEMP  <  SL(I)-XOPT(I)) THEN
                    SUBD=DMAX1(SUMIN,(SL(I)-XOPT(I))/TEMP)
                    IUBD=-I
                END IF
            END IF
        END DO
        !
        !  Seek a large modulus of the KNEW-th Lagrange function when the index
        !  of the other interpolation point on the line through XOPT is KNEW.
        !
        IF (K .EQ. KNEW) THEN
            DIFF=DDERIV-ONE
            STEP=SLBD
            VLAG=SLBD*(DDERIV-SLBD*DIFF)
            ISBD=ILBD
            TEMP=SUBD*(DDERIV-SUBD*DIFF)
            IF (DABS(TEMP)  >  DABS(VLAG)) THEN
                STEP=SUBD
                VLAG=TEMP
                ISBD=IUBD
            END IF
            TEMPD=HALF*DDERIV
            TEMPA=TEMPD-DIFF*SLBD
            TEMPB=TEMPD-DIFF*SUBD
            IF (TEMPA*TEMPB  <  ZERO) THEN
                TEMP=TEMPD*TEMPD/DIFF
                IF (DABS(TEMP)  >  DABS(VLAG)) THEN
                    STEP=TEMPD/DIFF
                    VLAG=TEMP
                    ISBD=0
                END IF
            END IF
            !
            !     Search along each of the other lines through XOPT and another point
            !
        ELSE
            STEP=SLBD
            VLAG=SLBD*(ONE-SLBD)
            ISBD=ILBD
            TEMP=SUBD*(ONE-SUBD)
            IF (DABS(TEMP)  >  DABS(VLAG)) THEN
                STEP=SUBD
                VLAG=TEMP
                ISBD=IUBD
            END IF
            IF (SUBD  >  HALF) THEN
                IF (DABS(VLAG)  <  0.25D0) THEN
                    STEP=HALF
                    VLAG=0.25D0
                    ISBD=0
                END IF
            END IF
            VLAG=VLAG*DDERIV
        END IF
        !
        !     Calculate PREDSQ for the current line search and maintain PRESAV.
        !
        TEMP=STEP*(ONE-STEP)*DISTSQ
        PREDSQ=VLAG*VLAG*(VLAG*VLAG+HA*TEMP*TEMP)
        IF (PREDSQ  >  PRESAV) THEN
            PRESAV=PREDSQ
            KSAV=K
            STPSAV=STEP
            IBDSAV=ISBD
        END IF
    END DO
    !
    !     Construct XNEW in a way that satisfies the bound constraints exact
    !
    DO I=1,N
        TEMP=XOPT(I)+STPSAV*(XPT(KSAV,I)-XOPT(I))
        XNEW(I)=DMAX1(SL(I),DMIN1(SU(I),TEMP))
    END DO
    IF (IBDSAV  <  0) XNEW(-IBDSAV)=SL(-IBDSAV)
    IF (IBDSAV  >  0) XNEW(IBDSAV)=SU(IBDSAV)
    !
    !  Prepare for the iterative method that assembles the constrained Cauchy
    !  step in W. The sum of squares of the fixed components of W is formed in
    !  WFIXSQ, and the free components of W are set to BIGSTP.
    !
    BIGSTP=ADELT+ADELT
    IFLAG=0
100 WFIXSQ=ZERO
    GGFREE=ZERO
    DO I=1,N
        W(I)=ZERO
        TEMPA=DMIN1(XOPT(I)-SL(I),GLAG(I))
        TEMPB=DMAX1(XOPT(I)-SU(I),GLAG(I))
        IF (TEMPA  >  ZERO .OR. TEMPB  <  ZERO) THEN
            W(I)=BIGSTP
            GGFREE=GGFREE+GLAG(I)**2
        END IF
    END DO
    IF (GGFREE .EQ. ZERO) THEN
        CAUCHY=ZERO
        return
    END IF
    !
    !     Investigate whether more components of W can be fixed.
    !
120 TEMP=ADELT*ADELT-WFIXSQ
    IF (TEMP  >  ZERO) THEN
        WSQSAV=WFIXSQ
        STEP=DSQRT(TEMP/GGFREE)
        GGFREE=ZERO
        DO I=1,N
            IF (W(I) .EQ. BIGSTP) THEN
                TEMP=XOPT(I)-STEP*GLAG(I)
                IF (TEMP  <=  SL(I)) THEN
                    W(I)=SL(I)-XOPT(I)
                    WFIXSQ=WFIXSQ+W(I)**2
                ELSE IF (TEMP  >=  SU(I)) THEN
                    W(I)=SU(I)-XOPT(I)
                    WFIXSQ=WFIXSQ+W(I)**2
                ELSE
                    GGFREE=GGFREE+GLAG(I)**2
                END IF
            END IF
        END DO
        IF (WFIXSQ  >  WSQSAV .AND. GGFREE  >  ZERO) GOTO 120
    END IF
    !
    !     Set the remaining free components of W and all components of XALT,
    !     except that W may be scaled later.
    !
    GW=ZERO
    DO I=1,N
        IF (W(I) .EQ. BIGSTP) THEN
            W(I)=-STEP*GLAG(I)
            XALT(I)=DMAX1(SL(I),DMIN1(SU(I),XOPT(I)+W(I)))
        ELSE IF (W(I) .EQ. ZERO) THEN
            XALT(I)=XOPT(I)
        ELSE IF (GLAG(I)  >  ZERO) THEN
            XALT(I)=SL(I)
        ELSE
            XALT(I)=SU(I)
        END IF
        GW=GW+GLAG(I)*W(I)
    END DO
    !
    !  Set CURV to the curvature of the KNEW-th Lagrange function along W.
    !  Scale W by a factor less than one if that can reduce the modulus of
    !  the Lagrange function at XOPT+W. Set CAUCHY to the final value of
    !  the square of this function.
    !
    CURV=ZERO
    DO K=1,NPT
        TEMP=ZERO
        DO  J=1,N
            TEMP=TEMP+XPT(K,J)*W(J)
        END DO
        CURV=CURV+HCOL(K)*TEMP*TEMP
    END DO
    IF (IFLAG .EQ. 1) CURV=-CURV
    IF (CURV  >  -GW .AND. CURV  <  -CONST*GW) THEN
        SCALE=-GW/CURV
        DO I=1,N
            TEMP=XOPT(I)+SCALE*W(I)
            XALT(I)=DMAX1(SL(I),DMIN1(SU(I),TEMP))
        END DO
        CAUCHY=(HALF*GW*SCALE)**2
    ELSE
        CAUCHY=(GW+HALF*CURV)**2
    END IF
    !
    !  If IFLAG is zero, then XALT is calculated as before after reversing
    !  the sign of GLAG. Thus two XALT vectors become available. The one that
    !  is chosen is the one that gives the larger value of CAUCHY.
    !
    IF (IFLAG .EQ. 0) THEN
        DO I=1,N
            GLAG(I)=-GLAG(I)
            W(N+I)=XALT(I)
        END DO
        CSAVE=CAUCHY
        IFLAG=1
        GOTO 100
    END IF
    IF (CSAVE  >  CAUCHY) THEN
        DO I=1,N
            XALT(I)=W(N+I)
        END DO
        CAUCHY=CSAVE
    END IF

    END SUBROUTINE ALTMOV


    SUBROUTINE PRELIM (this,N,NPT,X,XL,XU,RHOBEG,IPRINT,MAXFUN,XBASE,&
        &  XPT,FVAL,GOPT,HQ,PQ,BMAT,ZMAT,NDIM,SL,SU,NF,KOPT)
    class(TBOBYQA) this
    REAL(dp) diff , f , fbeg , half , one ,   &
        & recip , Rhobeg , rhosq , stepa , stepb, temp , two,  zero
    INTEGER i , ih , Iprint , ipt , itemp , j , jpt , k , Kopt ,      &
        & Maxfun , N , Ndim , Nf , nfm , nfx , np , Npt
    REAL(DP) X(*),XL(*),XU(*),XBASE(*),XPT(NPT,*),FVAL(*),GOPT(*),&
        &  HQ(*),PQ(*),BMAT(NDIM,*),ZMAT(NPT,*),SL(*),SU(*)

    !
    !  The arguments N, NPT, X, XL, XU, RHOBEG, IPRINT and MAXFUN are the
    !    same as the corresponding arguments in SUBROUTINE BOBYQA.
    !  The arguments XBASE, XPT, FVAL, HQ, PQ, BMAT, ZMAT, NDIM, SL and SU
    !    are the same as the corresponding arguments in BOBYQB, the elements
    !    of SL and SU being set in BOBYQA.
    !  GOPT is usually the gradient of the quadratic model at XOPT+XBASE, but
    !    it is set by PRELIM to the gradient of the quadratic model at XBASE.
    !    If XOPT is nonzero, BOBYQB will change it to its usual value later.
    !  NF is maintaned as the number of calls of CALFUN so far.
    !  KOPT will be such that the least calculated value of F so far is at
    !    the point XPT(KOPT,.)+XBASE in the space of the variables.
    !
    !  SUBROUTINE PRELIM sets the elements of XBASE, XPT, FVAL, GOPT, HQ, PQ,
    !  BMAT and ZMAT for the first iteration, and it maintains the values of
    !  NF and KOPT. The vector X is also changed by PRELIM.
    !
    !  Set some constants.
    !
    HALF=0.5D0
    ONE=1.0D0
    TWO=2.0D0
    ZERO=0.0D0
    RHOSQ=RHOBEG*RHOBEG
    RECIP=ONE/RHOSQ
    NP=N+1
    !
    !     Set XBASE to the initial vector of variables, and set the initial
    !     elements of XPT, BMAT, HQ, PQ and ZMAT to zero.
    !
    DO J=1,N
        XBASE(J)=X(J)
        DO K=1,NPT
            XPT(K,J)=ZERO
        END DO
        DO I=1,NDIM
            BMAT(I,J)=ZERO
        END DO
    END DO
    DO IH=1,(N*NP)/2
        HQ(IH)=ZERO
    END DO
    DO K=1,NPT
        PQ(K)=ZERO
        DO J=1,NPT-NP
            ZMAT(K,J)=ZERO
        END DO
    END DO
    !
    !  Begin the initialization procedure. NF becomes one more than the number
    !  of function values so far. The coordinates of the displacement of the
    !  next initial interpolation point from XBASE are set in XPT(NF+1,.).
    !
    NF=0
50  NFM=NF
    NFX=NF-N
    NF=NF+1
    IF (NFM  <=  2*N) THEN
        IF (NFM  >=  1 .AND. NFM  <=  N) THEN
            STEPA=RHOBEG
            IF (SU(NFM) .EQ. ZERO) STEPA=-STEPA
            XPT(NF,NFM)=STEPA
        ELSE IF (NFM  >  N) THEN
            STEPA=XPT(NF-N,NFX)
            STEPB=-RHOBEG
            IF (SL(NFX) .EQ. ZERO) STEPB=DMIN1(TWO*RHOBEG,SU(NFX))
            IF (SU(NFX) .EQ. ZERO) STEPB=DMAX1(-TWO*RHOBEG,SL(NFX))
            XPT(NF,NFX)=STEPB
        END IF
    ELSE
        ITEMP=(NFM-NP)/N
        JPT=NFM-ITEMP*N-N
        IPT=JPT+ITEMP
        IF (IPT  >  N) THEN
            ITEMP=JPT
            JPT=IPT-N
            IPT=ITEMP
        END IF
        XPT(NF,IPT)=XPT(IPT+1,IPT)
        XPT(NF,JPT)=XPT(JPT+1,JPT)
    END IF
    !
    !     Calculate the next value of F. The least function value so far and
    !     its index are required.
    !
    DO J=1,N
        X(J)=DMIN1(DMAX1(XL(J),XBASE(J)+XPT(NF,J)),XU(J))
        IF (XPT(NF,J) .EQ. SL(J)) X(J)=XL(J)
        IF (XPT(NF,J) .EQ. SU(J)) X(J)=XU(J)
    END DO
    F = this%funkk(this%obj,X(1:N))
    IF (IPRINT .EQ. 3) THEN
        PRINT 70, NF,F,(X(I),I=1,N)
70      FORMAT (/4X,'Function number',I6,'    F =',1PD18.10,&
            &       '    The corresponding X is:'/(2X,5D15.6))
    END IF
    FVAL(NF)=F
    IF (NF .EQ. 1) THEN
        FBEG=F
        KOPT=1
    ELSE IF (F  <  FVAL(KOPT)) THEN
        KOPT=NF
    END IF
    !
    !  Set the nonzero initial elements of BMAT and the quadratic model in the
    !  cases when NF is at most 2*N+1. If NF exceeds N+1, then the positions
    !  of the NF-th and (NF-N)-th interpolation points may be switched, in
    !  order that the function value at the first of them contributes to the
    !  off-diagonal second derivative terms of the initial quadratic model.
    !
    IF (NF  <=  2*N+1) THEN
        IF (NF  >=  2 .AND. NF  <=  N+1) THEN
            GOPT(NFM)=(F-FBEG)/STEPA
            IF (NPT  <  NF+N) THEN
                BMAT(1,NFM)=-ONE/STEPA
                BMAT(NF,NFM)=ONE/STEPA
                BMAT(NPT+NFM,NFM)=-HALF*RHOSQ
            END IF
        ELSE IF (NF  >=  N+2) THEN
            IH=(NFX*(NFX+1))/2
            TEMP=(F-FBEG)/STEPB
            DIFF=STEPB-STEPA
            HQ(IH)=TWO*(TEMP-GOPT(NFX))/DIFF
            GOPT(NFX)=(GOPT(NFX)*STEPB-TEMP*STEPA)/DIFF
            IF (STEPA*STEPB  <  ZERO) THEN
                IF (F  <  FVAL(NF-N)) THEN
                    FVAL(NF)=FVAL(NF-N)
                    FVAL(NF-N)=F
                    IF (KOPT .EQ. NF) KOPT=NF-N
                    XPT(NF-N,NFX)=STEPB
                    XPT(NF,NFX)=STEPA
                END IF
            END IF
            BMAT(1,NFX)=-(STEPA+STEPB)/(STEPA*STEPB)
            BMAT(NF,NFX)=-HALF/XPT(NF-N,NFX)
            BMAT(NF-N,NFX)=-BMAT(1,NFX)-BMAT(NF,NFX)
            ZMAT(1,NFX)=DSQRT(TWO)/(STEPA*STEPB)
            ZMAT(NF,NFX)=DSQRT(HALF)/RHOSQ
            ZMAT(NF-N,NFX)=-ZMAT(1,NFX)-ZMAT(NF,NFX)
        END IF
        !
        !     Set the off-diagonal second derivatives of the Lagrange functions
        !     the initial quadratic model.
        !
    ELSE
        IH=(IPT*(IPT-1))/2+JPT
        ZMAT(1,NFX)=RECIP
        ZMAT(NF,NFX)=RECIP
        ZMAT(IPT+1,NFX)=-RECIP
        ZMAT(JPT+1,NFX)=-RECIP
        TEMP=XPT(NF,IPT)*XPT(NF,JPT)
        HQ(IH)=(FBEG-FVAL(IPT+1)-FVAL(JPT+1)+F)/TEMP
    END IF
    IF (NF  <  NPT .AND. NF  <  MAXFUN) GOTO 50

    END SUBROUTINE PRELIM


    SUBROUTINE RESCUE (this,N,NPT,XL,XU,IPRINT,MAXFUN,XBASE,XPT,&
        &  FVAL,XOPT,GOPT,HQ,PQ,BMAT,ZMAT,NDIM,SL,SU,NF,DELTA,&
        &  KOPT,VLAG,PTSAUX,PTSID,W)
    class(TBOBYQA) this

    REAL(dp) beta , bsum , Delta , den , denom , diff , distsq , &
        & dsqmin , f , fbase , half , hdiag , one
    REAL(dp) sfrac , sum , sumpq , temp , vlmxsq ,     &
        & vquad , winc , xp , xq , zero
    INTEGER i , ih , ihp , ihq , ip , Iprint , iq , iw , j , jp ,     &
        & jpn , k , knew , kold , Kopt , kpt , Maxfun , N , Ndim ,  &
        & Nf
    INTEGER np , Npt , nptm , nrem
    REAL(dp) XL(*),XU(*),XBASE(*),XPT(NPT,*),FVAL(*),XOPT(*),&
        &  GOPT(*),HQ(*),PQ(*),BMAT(NDIM,*),ZMAT(NPT,*),SL(*),SU(*),&
        &  VLAG(*),PTSAUX(2,*),PTSID(*),W(*)
    !  The arguments N, NPT, XL, XU, IPRINT, MAXFUN, XBASE, XPT, FVAL, XOPT,
    !    GOPT, HQ, PQ, BMAT, ZMAT, NDIM, SL and SU have the same meanings as
    !    the corresponding arguments of BOBYQB on the entry to RESCUE.
    !  NF is maintained as the number of calls of CALFUN so far, except that
    !    NF is set to -1 if the value of MAXFUN prevents further progress.
    !  KOPT is maintained so that FVAL(KOPT) is the least calculated function
    !    value. Its correct value must be given on entry. It is updated if a
    !    new least function value is found, but the corresponding changes to
    !    XOPT and GOPT have to be made later by the calling program.
    !  DELTA is the current trust region radius.
    !  VLAG is a working space vector that will be used for the values of the
    !    provisional Lagrange functions at each of the interpolation points.
    !    They are part of a product that requires VLAG to be of length NDIM.
    !  PTSAUX is also a working space array. For J=1,2,...,N, PTSAUX(1,J) and
    !    PTSAUX(2,J) specify the two positions of provisional interpolation
    !    points when a nonzero step is taken along e_J (the J-th coordinate
    !    direction) through XBASE+XOPT, as specified below. Usually these
    !    steps have length DELTA, but other lengths are chosen if necessary
    !    in order to satisfy the given bounds on the variables.
    !  PTSID is also a working space array. It has NPT components that denote
    !    provisional new positions of the original interpolation points, in
    !    case changes are needed to restore the linear independence of the
    !    interpolation conditions. The K-th point is a candidate for change
    !    if and only if PTSID(K) is nonzero. In this case let p and q be the
    !    integer parts of PTSID(K) and (PTSID(K)-p) multiplied by N+1. If p
    !    and q are both positive, the step from XBASE+XOPT to the new K-th
    !    interpolation point is PTSAUX(1,p)*e_p + PTSAUX(1,q)*e_q. Otherwise
    !    the step is PTSAUX(1,p)*e_p or PTSAUX(2,q)*e_q in the cases q=0 or
    !    p=0, respectively.
    !  The first NDIM+NPT elements of the array W are used for working space.
    !  The final elements of BMAT and ZMAT are set in a well-conditioned way
    !    to the values that are appropriate for the new interpolation points.
    !  The elements of GOPT, HQ and PQ are also revised to the values that are
    !    appropriate to the final quadratic model.
    !
    !     Set some constants.
    !
    HALF=0.5D0
    ONE=1.0D0
    ZERO=0.0D0
    NP=N+1
    SFRAC=HALF/NP
    NPTM=NPT-NP
    !
    !  Shift the interpolation points so that XOPT becomes the origin, and set
    !  the elements of ZMAT to zero. The value of SUMPQ is required in the
    !  updating of HQ below. The squares of the distances from XOPT to the
    !  other interpolation points are set at the end of W. Increments of WINC
    !  may be added later to these squares to balance the consideration of
    !  the choice of point that is going to become current.
    !
    SUMPQ=ZERO
    WINC=ZERO
    DO K=1,NPT
        DISTSQ=ZERO
        DO J=1,N
            XPT(K,J)=XPT(K,J)-XOPT(J)
            DISTSQ=DISTSQ+XPT(K,J)**2
        END DO
        SUMPQ=SUMPQ+PQ(K)
        W(NDIM+K)=DISTSQ
        WINC=DMAX1(WINC,DISTSQ)
        DO J=1,NPTM
            ZMAT(K,J)=ZERO
        END DO
    END DO
    !
    !     Update HQ so that HQ and PQ define the second derivatives of the model
    !     after XBASE has been shifted to the trust region centre.
    !
    IH=0
    DO J=1,N
        W(J)=HALF*SUMPQ*XOPT(J)
        DO K=1,NPT
            W(J)=W(J)+PQ(K)*XPT(K,J)
        END DO
        DO I=1,J
            IH=IH+1
            HQ(IH)=HQ(IH)+W(I)*XOPT(J)+W(J)*XOPT(I)
        END DO
    END DO
    !
    !     Shift XBASE, SL, SU and XOPT. Set the elements of BMAT to zero, and
    !     also set the elements of PTSAUX.
    !
    DO J=1,N
        XBASE(J)=XBASE(J)+XOPT(J)
        SL(J)=SL(J)-XOPT(J)
        SU(J)=SU(J)-XOPT(J)
        XOPT(J)=ZERO
        PTSAUX(1,J)=DMIN1(DELTA,SU(J))
        PTSAUX(2,J)=DMAX1(-DELTA,SL(J))
        IF (PTSAUX(1,J)+PTSAUX(2,J)  <  ZERO) THEN
            TEMP=PTSAUX(1,J)
            PTSAUX(1,J)=PTSAUX(2,J)
            PTSAUX(2,J)=TEMP
        END IF
        IF (DABS(PTSAUX(2,J))  <  HALF*DABS(PTSAUX(1,J))) THEN
            PTSAUX(2,J)=HALF*PTSAUX(1,J)
        END IF
        DO I=1,NDIM
            BMAT(I,J)=ZERO
        END DO
    END DO
    FBASE=FVAL(KOPT)
    !
    !     Set the identifiers of the artificial interpolation points that ard
    !     along a coordinate direction from XOPT, and set the corresponding
    !     nonzero elements of BMAT and ZMAT.
    !
    PTSID(1)=SFRAC
    DO J=1,N
        JP=J+1
        JPN=JP+N
        PTSID(JP)=J+SFRAC
        IF (JPN  <=  NPT) THEN
            PTSID(JPN)=real(J,dp)/NP+SFRAC
            TEMP=ONE/(PTSAUX(1,J)-PTSAUX(2,J))
            BMAT(JP,J)=-TEMP+ONE/PTSAUX(1,J)
            BMAT(JPN,J)=TEMP+ONE/PTSAUX(2,J)
            BMAT(1,J)=-BMAT(JP,J)-BMAT(JPN,J)
            ZMAT(1,J)=DSQRT(2.0D0)/DABS(PTSAUX(1,J)*PTSAUX(2,J))
            ZMAT(JP,J)=ZMAT(1,J)*PTSAUX(2,J)*TEMP
            ZMAT(JPN,J)=-ZMAT(1,J)*PTSAUX(1,J)*TEMP
        ELSE
            BMAT(1,J)=-ONE/PTSAUX(1,J)
            BMAT(JP,J)=ONE/PTSAUX(1,J)
            BMAT(J+NPT,J)=-HALF*PTSAUX(1,J)**2
        END IF
    END DO
    !
    !     Set any remaining identifiers with their nonzero elements of ZMAT.
    !
    IF (NPT  >=  N+NP) THEN
        DO K=2*NP,NPT
            IW=(real(K-NP,dp)-HALF)/N
            IP=K-NP-IW*N
            IQ=IP+IW
            IF (IQ  >  N) IQ=IQ-N
            PTSID(K)=IP+real(IQ,dp)/NP+SFRAC
            TEMP=ONE/(PTSAUX(1,IP)*PTSAUX(1,IQ))
            ZMAT(1,K-NP)=TEMP
            ZMAT(IP+1,K-NP)=-TEMP
            ZMAT(IQ+1,K-NP)=-TEMP
            ZMAT(K,K-NP)=TEMP
        END DO
    END IF
    NREM=NPT
    KOLD=1
    KNEW=KOPT
    !
    !     Reorder the provisional points in the way that exchanges PTSID(KOL
    !     with PTSID(KNEW).
    !
80  DO J=1,N
        TEMP=BMAT(KOLD,J)
        BMAT(KOLD,J)=BMAT(KNEW,J)
        BMAT(KNEW,J)=TEMP
    END DO
    DO J=1,NPTM
        TEMP=ZMAT(KOLD,J)
        ZMAT(KOLD,J)=ZMAT(KNEW,J)
        ZMAT(KNEW,J)=TEMP
    END DO
    PTSID(KOLD)=PTSID(KNEW)
    PTSID(KNEW)=ZERO
    W(NDIM+KNEW)=ZERO
    NREM=NREM-1
    IF (KNEW .NE. KOPT) THEN
        TEMP=VLAG(KOLD)
        VLAG(KOLD)=VLAG(KNEW)
        VLAG(KNEW)=TEMP
        !
        !  Update the BMAT and ZMAT matrices so that the status of the KNEW-th
        !  interpolation point can be changed from provisional to original. The
        !  return occurs if all the original points are reinstated.
        !  The nonnegative values of W(NDIM+K) are required in the search below.
        !
        CALL UPDATE (N,NPT,BMAT,ZMAT,NDIM,VLAG,BETA,DENOM,KNEW,W)
        IF (NREM .EQ. 0) return
        DO K=1,NPT
            W(NDIM+K)=DABS(W(NDIM+K))
        END DO
    END IF
    !
    !  Pick the index KNEW of an original interpolation point that has not
    !  yet replaced one of the provisional interpolation points, giving
    !  attention to the closeness to XOPT and to previous tries with KNEW.
    !
120 DSQMIN=ZERO
    DO  K=1,NPT
        IF (W(NDIM+K)  >  ZERO) THEN
            IF (DSQMIN .EQ. ZERO .OR. W(NDIM+K)  <  DSQMIN) THEN
                KNEW=K
                DSQMIN=W(NDIM+K)
            END IF
        END IF
    END DO
    IF (DSQMIN .EQ. ZERO) GOTO 260
    !
    !     Form the W-vector of the chosen original interpolation point.
    !
    DO J=1,N
        W(NPT+J)=XPT(KNEW,J)
    END DO
    DO K=1,NPT
        SUM=ZERO
        IF (K .EQ. KOPT) THEN
            CONTINUE
        ELSE IF (PTSID(K) .EQ. ZERO) THEN
            DO  J=1,N
                SUM=SUM+W(NPT+J)*XPT(K,J)
            END DO
        ELSE
            IP=PTSID(K)
            IF (IP  >  0) SUM=W(NPT+IP)*PTSAUX(1,IP)
            IQ=NP*PTSID(K)-IP*NP
            IF (IQ  >  0) THEN
                IW=1
                IF (IP .EQ. 0) IW=2
                SUM=SUM+W(NPT+IQ)*PTSAUX(IW,IQ)
            END IF
        END IF
        W(K)=HALF*SUM*SUM
    END DO
    !
    !     Calculate VLAG and BETA for the required updating of the H matrix
    !     XPT(KNEW,.) is reinstated in the set of interpolation points.
    !
    DO K=1,NPT
        SUM=ZERO
        DO  J=1,N
            SUM=SUM+BMAT(K,J)*W(NPT+J)
        END DO
        VLAG(K)=SUM
    END DO
    BETA=ZERO
    DO J=1,NPTM
        SUM=ZERO
        DO K=1,NPT
            SUM=SUM+ZMAT(K,J)*W(K)
        END DO
        BETA=BETA-SUM*SUM
        DO K=1,NPT
            VLAG(K)=VLAG(K)+SUM*ZMAT(K,J)
        END DO
    END DO
    BSUM=ZERO
    DISTSQ=ZERO
    DO J=1,N
        SUM=ZERO
        DO K=1,NPT
            SUM=SUM+BMAT(K,J)*W(K)
        END DO
        JP=J+NPT
        BSUM=BSUM+SUM*W(JP)
        DO IP=NPT+1,NDIM
            SUM=SUM+BMAT(IP,J)*W(IP)
        END DO
        BSUM=BSUM+SUM*W(JP)
        VLAG(JP)=SUM
        DISTSQ=DISTSQ+XPT(KNEW,J)**2
    END DO
    BETA=HALF*DISTSQ*DISTSQ+BETA-BSUM
    VLAG(KOPT)=VLAG(KOPT)+ONE
    !
    !  KOLD is set to the index of the provisional interpolation point that is
    !  going to be deleted to make way for the KNEW-th original interpolation
    !  point. The choice of KOLD is governed by the avoidance of a small value
    !  of the denominator in the updating calculation of UPDATE.
    !
    DENOM=ZERO
    VLMXSQ=ZERO
    DO K=1,NPT
        IF (PTSID(K) .NE. ZERO) THEN
            HDIAG=ZERO
            DO J=1,NPTM
                HDIAG=HDIAG+ZMAT(K,J)**2
            END DO
            DEN=BETA*HDIAG+VLAG(K)**2
            IF (DEN  >  DENOM) THEN
                KOLD=K
                DENOM=DEN
            END IF
        END IF
        VLMXSQ=DMAX1(VLMXSQ,VLAG(K)**2)
    END DO
    IF (DENOM  <=  1.0D-2*VLMXSQ) THEN
        W(NDIM+KNEW)=-W(NDIM+KNEW)-WINC
        GOTO 120
    END IF
    GOTO 80
    !
    !  When label 260 is reached, all the final positions of the interpolation
    !  points have been chosen although any changes have not been included yet
    !  in XPT. Also the final BMAT and ZMAT matrices are complete, but, apart
    !  from the shift of XBASE, the updating of the quadratic model remains to
    !  be done. The following cycle through the new interpolation points begins
    !  by putting the new point in XPT(KPT,.) and by setting PQ(KPT) to zero,
    !  except that a RETURN occurs if MAXFUN prohibits another value of F.
    !
260 DO KPT=1,NPT
        IF (PTSID(KPT) .EQ. ZERO) continue
        IF (NF  >=  MAXFUN) THEN
            NF=-1
            return
        END IF
        IH=0
        DO J=1,N
            W(J)=XPT(KPT,J)
            XPT(KPT,J)=ZERO
            TEMP=PQ(KPT)*W(J)
            DO I=1,J
                IH=IH+1
                HQ(IH)=HQ(IH)+TEMP*W(I)
            END DO
        END DO
        PQ(KPT)=ZERO
        IP=PTSID(KPT)
        IQ=NP*PTSID(KPT)-IP*NP
        IF (IP  >  0) THEN
            XP=PTSAUX(1,IP)
            XPT(KPT,IP)=XP
        END IF
        IF (IQ  >  0) THEN
            XQ=PTSAUX(1,IQ)
            IF (IP .EQ. 0) XQ=PTSAUX(2,IQ)
            XPT(KPT,IQ)=XQ
        END IF
        !
        !     Set VQUAD to the value of the current model at the new point.
        !
        VQUAD=FBASE
        IF (IP  >  0) THEN
            IHP=(IP+IP*IP)/2
            VQUAD=VQUAD+XP*(GOPT(IP)+HALF*XP*HQ(IHP))
        END IF
        IF (IQ  >  0) THEN
            IHQ=(IQ+IQ*IQ)/2
            VQUAD=VQUAD+XQ*(GOPT(IQ)+HALF*XQ*HQ(IHQ))
            IF (IP  >  0) THEN
                IW=MAX0(IHP,IHQ)-IABS(IP-IQ)
                VQUAD=VQUAD+XP*XQ*HQ(IW)
            END IF
        END IF
        DO K=1,NPT
            TEMP=ZERO
            IF (IP  >  0) TEMP=TEMP+XP*XPT(K,IP)
            IF (IQ  >  0) TEMP=TEMP+XQ*XPT(K,IQ)
            VQUAD=VQUAD+HALF*PQ(K)*TEMP*TEMP
        END DO
        !
        !  Calculate F at the new interpolation point, and set DIFF to the factor
        !  that is going to multiply the KPT-th Lagrange function when the model
        !  is updated to provide interpolation to the new function value.
        !
        DO I=1,N
            W(I)=DMIN1(DMAX1(XL(I),XBASE(I)+XPT(KPT,I)),XU(I))
            IF (XPT(KPT,I) .EQ. SL(I)) W(I)=XL(I)
            IF (XPT(KPT,I) .EQ. SU(I)) W(I)=XU(I)
        END DO
        NF=NF+1
        F = this%funkk(this%obj, W(1:N))
        IF (IPRINT .EQ. 3) THEN
            PRINT 300, NF,F,(W(I),I=1,N)
300         FORMAT (/4X,'Function number',I6,'    F =',1PD18.10,&
                &      '    The corresponding X is:'/(2X,5D15.6))
        END IF
        FVAL(KPT)=F
        IF (F  <  FVAL(KOPT)) KOPT=KPT
        DIFF=F-VQUAD
        !
        !     Update the quadratic model. The RETURN from the subroutine occurs when
        !     all the new interpolation points are included in the model.
        !
        DO I=1,N
            GOPT(I)=GOPT(I)+DIFF*BMAT(KPT,I)
        END DO
        DO K=1,NPT
            SUM=ZERO
            DO J=1,NPTM
                SUM=SUM+ZMAT(K,J)*ZMAT(KPT,J)
            END DO
            TEMP=DIFF*SUM
            IF (PTSID(K) .EQ. ZERO) THEN
                PQ(K)=PQ(K)+TEMP
            ELSE
                IP=PTSID(K)
                IQ=NP*PTSID(K)-IP*NP
                IHQ=(IQ*IQ+IQ)/2
                IF (IP .EQ. 0) THEN
                    HQ(IHQ)=HQ(IHQ)+TEMP*PTSAUX(2,IQ)**2
                ELSE
                    IHP=(IP*IP+IP)/2
                    HQ(IHP)=HQ(IHP)+TEMP*PTSAUX(1,IP)**2
                    IF (IQ  >  0) THEN
                        HQ(IHQ)=HQ(IHQ)+TEMP*PTSAUX(1,IQ)**2
                        IW=MAX0(IHP,IHQ)-IABS(IQ-IP)
                        HQ(IW)=HQ(IW)+TEMP*PTSAUX(1,IP)*PTSAUX(1,IQ)
                    END IF
                END IF
            END IF
        END DO
        PTSID(KPT)=ZERO
    END DO
    END SUBROUTINE RESCUE


    SUBROUTINE TRSBOX (N,NPT,XPT,XOPT,GOPT,HQ,PQ,SL,SU,DELTA,&
        &  XNEW,D,GNEW,XBDI,S,HS,HRED,DSQ,CRVMIN)
    REAL(dp) angbd , angt , beta , blen , Crvmin , cth , delsq ,    &
        & Delta , dhd , dhs , dredg , dredsq , ds , Dsq , ggsav ,    &
        & gredsq , half
    REAL(dp) one , onemin , qred , ratio ,        &
        & rdnext , rdprev , redmax , rednew , redsav , resid ,  &
        & sdec , shs , sqstp , sredg
    REAL(dp) ssq , stepsq , sth , stplen , temp , tempa , tempb ,  &
        & xsav , xsum , zero
    INTEGER i , iact , ih , isav , itcsav , iterc , itermax , iu , j ,&
        & k , N , nact , Npt
    REAL(DP) XPT(NPT,*),XOPT(*),GOPT(*),HQ(*),PQ(*),SL(*),SU(*),&
        &  XNEW(*),D(*),GNEW(*),XBDI(*),S(*),HS(*),HRED(*)
    !
    !  The arguments N, NPT, XPT, XOPT, GOPT, HQ, PQ, SL and SU have the same
    !    meanings as the corresponding arguments of BOBYQB.
    !  DELTA is the trust region radius for the present calculation, which
    !    seeks a small value of the quadratic model within distance DELTA of
    !    XOPT subject to the bounds on the variables.
    !  XNEW will be set to a new vector of variables that is approximately
    !    the one that minimizes the quadratic model within the trust region
    !    subject to the SL and SU constraints on the variables. It satisfies
    !    as equations the bounds that become active during the calculation.
    !  D is the calculated trial step from XOPT, generated iteratively from an
    !    initial value of zero. Thus XNEW is XOPT+D after the final iteration.
    !  GNEW holds the gradient of the quadratic model at XOPT+D. It is updated
    !    when D is updated.
    !  XBDI is a working space vector. For I=1,2,...,N, the element XBDI(I) is
    !    set to -1.0, 0.0, or 1.0, the value being nonzero if and only if the
    !    I-th variable has become fixed at a bound, the bound being SL(I) or
    !    SU(I) in the case XBDI(I)=-1.0 or XBDI(I)=1.0, respectively. This
    !    information is accumulated during the construction of XNEW.
    !  The arrays S, HS and HRED are also used for working space. They hold the
    !    current search direction, and the changes in the gradient of Q along S
    !    and the reduced D, respectively, where the reduced D is the same as D,
    !    except that the components of the fixed variables are zero.
    !  DSQ will be set to the square of the length of XNEW-XOPT.
    !  CRVMIN is set to zero if D reaches the trust region boundary. Otherwise
    !    it is set to the least curvature of H that occurs in the conjugate
    !    gradient searches that are not restricted by any constraints. The
    !    value CRVMIN=-1.0D0 is set, however, if all of these searches are
    !    constrained.
    !
    !  A version of the truncated conjugate gradient is applied. If a line
    !  search is restricted by a constraint, then the procedure is restarted,
    !  the values of the variables that are at their bounds being fixed. If
    !  the trust region boundary is reached, then further changes may be made
    !  to D, each one being in the two dimensional space that is spanned
    !  by the current D and the gradient of Q at XOPT+D, staying on the trust
    !  region boundary. Termination occurs when the reduction in Q seems to
    !  be close to the greatest reduction that can be achieved.
    !
    !     Set some constants.
    !
    HALF=0.5D0
    ONE=1.0D0
    ONEMIN=-1.0D0
    ZERO=0.0D0
    !
    !  The sign of GOPT(I) gives the sign of the change to the I-th variable
    !  that will reduce Q from its value at XOPT. Thus XBDI(I) shows whether
    !  or not to fix the I-th variable at one of its bounds initially, with
    !  NACT being set to the number of fixed variables. D and GNEW are also
    !  set for the first iteration. DELSQ is the upper bound on the sum of
    !  squares of the free variables. QRED is the reduction in Q so far.
    !
    ITERC=0
    NACT=0
    SQSTP=ZERO
    DO I=1,N
        XBDI(I)=ZERO
        IF (XOPT(I)  <=  SL(I)) THEN
            IF (GOPT(I)  >=  ZERO) XBDI(I)=ONEMIN
        ELSE IF (XOPT(I)  >=  SU(I)) THEN
            IF (GOPT(I)  <=  ZERO) XBDI(I)=ONE
        END IF
        IF (XBDI(I) .NE. ZERO) NACT=NACT+1
        D(I)=ZERO
        GNEW(I)=GOPT(I)
    END DO
    DELSQ=DELTA*DELTA
    QRED=ZERO
    CRVMIN=ONEMIN
    !
    !  Set the next search direction of the conjugate gradient method. It is
    !  the steepest descent direction initially and when the iterations are
    !  restarted because a variable has just been fixed by a bound, and of
    !  course the components of the fixed variables are zero. ITERMAX is an
    !  upper bound on the indices of the conjugate gradient iterations.
    !
20  BETA=ZERO
30  STEPSQ=ZERO
    DO I=1,N
        IF (XBDI(I) .NE. ZERO) THEN
            S(I)=ZERO
        ELSE IF (BETA .EQ. ZERO) THEN
            S(I)=-GNEW(I)
        ELSE
            S(I)=BETA*S(I)-GNEW(I)
        END IF
        STEPSQ=STEPSQ+S(I)**2
    END DO
    IF (STEPSQ .EQ. ZERO) GOTO 190
    IF (BETA .EQ. ZERO) THEN
        GREDSQ=STEPSQ
        ITERMAX=ITERC+N-NACT
    END IF
    IF (GREDSQ*DELSQ  <=  1.0D-4*QRED*QRED) GO TO 190
    !
    !  Multiply the search direction by the second derivative matrix of Q and
    !  calculate some scalars for the choice of steplength. Then set BLEN to
    !  the length of the the step to the trust region boundary and STPLEN to
    !  the steplength, ignoring the simple bounds.
    !
    GOTO 210
50  RESID=DELSQ
    DS=ZERO
    SHS=ZERO
    DO 60 I=1,N
        IF (XBDI(I) .EQ. ZERO) THEN
            RESID=RESID-D(I)**2
            DS=DS+S(I)*D(I)
            SHS=SHS+S(I)*HS(I)
        END IF
60  CONTINUE
    IF (RESID  <=  ZERO) GOTO 90
    TEMP=DSQRT(STEPSQ*RESID+DS*DS)
    IF (DS  <  ZERO) THEN
        BLEN=(TEMP-DS)/STEPSQ
    ELSE
        BLEN=RESID/(TEMP+DS)
    END IF
    STPLEN=BLEN
    IF (SHS  >  ZERO) THEN
        STPLEN=DMIN1(BLEN,GREDSQ/SHS)
    END IF

    !
    !     Reduce STPLEN if necessary in order to preserve the simple bounds,
    !     letting IACT be the index of the new constrained variable.
    !
    IACT=0
    DO 70 I=1,N
        IF (S(I) .NE. ZERO) THEN
            XSUM=XOPT(I)+D(I)
            IF (S(I)  >  ZERO) THEN
                TEMP=(SU(I)-XSUM)/S(I)
            ELSE
                TEMP=(SL(I)-XSUM)/S(I)
            END IF
            IF (TEMP  <  STPLEN) THEN
                STPLEN=TEMP
                IACT=I
            END IF
        END IF
70  CONTINUE
    !
    !     Update CRVMIN, GNEW and D. Set SDEC to the decrease that occurs in
    !
    SDEC=ZERO
    IF (STPLEN  >  ZERO) THEN
        ITERC=ITERC+1
        TEMP=SHS/STEPSQ
        IF (IACT .EQ. 0 .AND. TEMP  >  ZERO) THEN
            CRVMIN=DMIN1(CRVMIN,TEMP)
            IF (CRVMIN .EQ. ONEMIN) CRVMIN=TEMP
        END IF
        GGSAV=GREDSQ
        GREDSQ=ZERO
        DO I=1,N
            GNEW(I)=GNEW(I)+STPLEN*HS(I)
            IF (XBDI(I) .EQ. ZERO) GREDSQ=GREDSQ+GNEW(I)**2
            D(I)=D(I)+STPLEN*S(I)
        END DO
        SDEC=DMAX1(STPLEN*(GGSAV-HALF*STPLEN*SHS),ZERO)
        QRED=QRED+SDEC
    END IF
    !
    !     Restart the conjugate gradient method if it has hit a new bound.
    !
    IF (IACT  >  0) THEN
        NACT=NACT+1
        XBDI(IACT)=ONE
        IF (S(IACT)  <  ZERO) XBDI(IACT)=ONEMIN
        DELSQ=DELSQ-D(IACT)**2
        IF (DELSQ  <=  ZERO) GOTO 90
        GOTO 20
    END IF
    !
    !     If STPLEN is less than BLEN, then either apply another conjugate
    !     gradient iteration or RETURN.
    !
    IF (STPLEN  <  BLEN) THEN
        IF (ITERC .EQ. ITERMAX) GOTO 190
        IF (SDEC  <=  0.01D0*QRED) GOTO 190
        BETA=GREDSQ/GGSAV
        GOTO 30
    END IF
90  CRVMIN=ZERO
    !
    !  Prepare for the alternative iteration by calculating some scalars
    !  and by multiplying the reduced D by the second derivative matrix of
    !  Q, where S holds the reduced D in the call of GGMULT.
    !
100 IF (NACT  >=  N-1) GOTO 190
    DREDSQ=ZERO
    DREDG=ZERO
    GREDSQ=ZERO
    DO I=1,N
        IF (XBDI(I) .EQ. ZERO) THEN
            DREDSQ=DREDSQ+D(I)**2
            DREDG=DREDG+D(I)*GNEW(I)
            GREDSQ=GREDSQ+GNEW(I)**2
            S(I)=D(I)
        ELSE
            S(I)=ZERO
        END IF
    END DO
    ITCSAV=ITERC
    GOTO 210
    !
    !     Let the search direction S be a linear combination of the reduced
    !     and the reduced G that is orthogonal to the reduced D.
    !
120 ITERC=ITERC+1
    TEMP=GREDSQ*DREDSQ-DREDG*DREDG
    IF (TEMP  <=  1.0D-4*QRED*QRED) GOTO 190
    TEMP=DSQRT(TEMP)
    DO I=1,N
        IF (XBDI(I) .EQ. ZERO) THEN
            S(I)=(DREDG*D(I)-DREDSQ*GNEW(I))/TEMP
        ELSE
            S(I)=ZERO
        END IF
    END DO
    SREDG=-TEMP
    !
    !  By considering the simple bounds on the variables, calculate an upper
    !  bound on the tangent of half the angle of the alternative iteration,
    !  namely ANGBD, except that, if already a free variable has reached a
    !  bound, there is a branch back to label 100 after fixing that variable.
    !
    ANGBD=ONE
    IACT=0
    DO I=1,N
        IF (XBDI(I) .EQ. ZERO) THEN
            TEMPA=XOPT(I)+D(I)-SL(I)
            TEMPB=SU(I)-XOPT(I)-D(I)
            IF (TEMPA  <=  ZERO) THEN
                NACT=NACT+1
                XBDI(I)=ONEMIN
                GOTO 100
            ELSE IF (TEMPB  <=  ZERO) THEN
                NACT=NACT+1
                XBDI(I)=ONE
                GOTO 100
            END IF
            RATIO=ONE
            SSQ=D(I)**2+S(I)**2
            TEMP=SSQ-(XOPT(I)-SL(I))**2
            IF (TEMP  >  ZERO) THEN
                TEMP=DSQRT(TEMP)-S(I)
                IF (ANGBD*TEMP  >  TEMPA) THEN
                    ANGBD=TEMPA/TEMP
                    IACT=I
                    XSAV=ONEMIN
                END IF
            END IF
            TEMP=SSQ-(SU(I)-XOPT(I))**2
            IF (TEMP  >  ZERO) THEN
                TEMP=DSQRT(TEMP)+S(I)
                IF (ANGBD*TEMP  >  TEMPB) THEN
                    ANGBD=TEMPB/TEMP
                    IACT=I
                    XSAV=ONE
                END IF
            END IF
        END IF
    END DO
    !
    !     Calculate HHD and some curvatures for the alternative iteration.
    !
    GOTO 210
150 SHS=ZERO
    DHS=ZERO
    DHD=ZERO
    DO I=1,N
        IF (XBDI(I) .EQ. ZERO) THEN
            SHS=SHS+S(I)*HS(I)
            DHS=DHS+D(I)*HS(I)
            DHD=DHD+D(I)*HRED(I)
        END IF
    END DO
    !
    !  Seek the greatest reduction in Q for a range of equally spaced values
    !  of ANGT in [0,ANGBD], where ANGT is the tangent of half the angle of
    !  the alternative iteration.
    !
    REDMAX=ZERO
    ISAV=0
    REDSAV=ZERO
    IU=17.0D0*ANGBD+3.1D0
    DO I=1,IU
        ANGT=ANGBD*real(I,dp)/IU
        STH=(ANGT+ANGT)/(ONE+ANGT*ANGT)
        TEMP=SHS+ANGT*(ANGT*DHD-DHS-DHS)
        REDNEW=STH*(ANGT*DREDG-SREDG-HALF*STH*TEMP)
        IF (REDNEW  >  REDMAX) THEN
            REDMAX=REDNEW
            ISAV=I
            RDPREV=REDSAV
        ELSE IF (I .EQ. ISAV+1) THEN
            RDNEXT=REDNEW
        END IF
        REDSAV=REDNEW
    END DO
    !
    !  Return if the reduction is zero. Otherwise, set the sine and cosine
    !  of the angle of the alternative iteration, and calculate SDEC.
    !
    IF (ISAV .EQ. 0) GOTO 190
    IF (ISAV  <  IU) THEN
        TEMP=(RDNEXT-RDPREV)/(REDMAX+REDMAX-RDPREV-RDNEXT)
        ANGT=ANGBD*(ISAV+HALF*TEMP)/IU
    END IF
    CTH=(ONE-ANGT*ANGT)/(ONE+ANGT*ANGT)
    STH=(ANGT+ANGT)/(ONE+ANGT*ANGT)
    TEMP=SHS+ANGT*(ANGT*DHD-DHS-DHS)
    SDEC=STH*(ANGT*DREDG-SREDG-HALF*STH*TEMP)
    IF (SDEC  <=  ZERO) GOTO 190
    !
    !  Update GNEW, D and HRED. If the angle of the alternative iteration
    !  is restricted by a bound on a free variable, that variable is fixed
    !  at the bound.
    !
    DREDG=ZERO
    GREDSQ=ZERO
    DO I=1,N
        GNEW(I)=GNEW(I)+(CTH-ONE)*HRED(I)+STH*HS(I)
        IF (XBDI(I) .EQ. ZERO) THEN
            D(I)=CTH*D(I)+STH*S(I)
            DREDG=DREDG+D(I)*GNEW(I)
            GREDSQ=GREDSQ+GNEW(I)**2
        END IF
        HRED(I)=CTH*HRED(I)+STH*HS(I)
    END DO
    QRED=QRED+SDEC
    IF (IACT  >  0 .AND. ISAV .EQ. IU) THEN
        NACT=NACT+1
        XBDI(IACT)=XSAV
        GOTO 100
    END IF
    !  If SDEC is sufficiently small, then RETURN after setting XNEW to
    !  XOPT+D, giving careful attention to the bounds.
    !
    IF (SDEC  >  0.01D0*QRED) GOTO 120
190 DSQ=ZERO
    DO I=1,N
        XNEW(I)=DMAX1(DMIN1(XOPT(I)+D(I),SU(I)),SL(I))
        IF (XBDI(I) .EQ. ONEMIN) XNEW(I)=SL(I)
        IF (XBDI(I) .EQ. ONE) XNEW(I)=SU(I)
        D(I)=XNEW(I)-XOPT(I)
        DSQ=DSQ+D(I)**2
    END DO
    RETURN

    !  The following instructions multiply the current S-vector by the second
    !  derivative matrix of the quadratic model, putting the product in HS.
    !  They are reached from three different parts of the software above and
    !  they can be regarded as an external subroutine.
    !
210 IH=0
    DO J=1,N
        HS(J)=ZERO
        DO I=1,J
            IH=IH+1
            IF (I  <  J) HS(J)=HS(J)+HQ(IH)*S(I)
            HS(I)=HS(I)+HQ(IH)*S(J)
        END DO
    END DO
    DO K=1,NPT
        IF (PQ(K) .NE. ZERO) THEN
            TEMP=ZERO
            DO J=1,N
                TEMP=TEMP+XPT(K,J)*S(J)
            END DO
            TEMP=TEMP*PQ(K)
            DO I=1,N
                HS(I)=HS(I)+TEMP*XPT(K,I)
            END DO
        END IF
    END DO
    IF (CRVMIN .NE. ZERO) GOTO 50
    IF (ITERC  >  ITCSAV) GOTO 150
    DO I=1,N
        HRED(I)=HS(I)
    END DO
    GOTO 120
    END SUBROUTINE TRSBOX


    SUBROUTINE UPDATE (N,NPT,BMAT,ZMAT,NDIM,VLAG,BETA,DENOM,KNEW,W)
    REAL(dp) alpha , Beta ,  Denom , one , tau , temp , tempa ,   &
        & tempb , zero , ztest
    INTEGER i , j , jl , jp , k , Knew , N , Ndim , Npt , nptm
    REAL(dp) BMAT(NDIM,*),ZMAT(NPT,*),VLAG(*),W(*)
    !
    !  The arrays BMAT and ZMAT are updated, as required by the new position
    !  of the interpolation point that has the index KNEW. The vector VLAG has
    !  N+NPT components, set on entry to the first NPT and last N components
    !  of the product Hw in equation (4.11) of the Powell (2006) paper on
    !  NEWUOA. Further, BETA is set on entry to the value of the parameter
    !  with that name, and DENOM is set to the denominator of the updating
    !  formula. Elements of ZMAT may be treated as zero if their moduli are
    !  at most ZTEST. The first NDIM elements of W are used for working space.
    !
    !     Set some constants.
    !
    ONE=1.0D0
    ZERO=0.0D0
    NPTM=NPT-N-1
    ZTEST=ZERO
    DO K=1,NPT
        DO J=1,NPTM
            ZTEST=DMAX1(ZTEST,DABS(ZMAT(K,J)))
        END DO
    END DO
    ZTEST=1.0D-20*ZTEST
    !
    !     Apply the rotations that put zeros in the KNEW-th row of ZMAT.
    !
    JL=1
    DO J=2,NPTM
        IF (DABS(ZMAT(KNEW,J))  >  ZTEST) THEN
            TEMP=DSQRT(ZMAT(KNEW,1)**2+ZMAT(KNEW,J)**2)
            TEMPA=ZMAT(KNEW,1)/TEMP
            TEMPB=ZMAT(KNEW,J)/TEMP
            DO I=1,NPT
                TEMP=TEMPA*ZMAT(I,1)+TEMPB*ZMAT(I,J)
                ZMAT(I,J)=TEMPA*ZMAT(I,J)-TEMPB*ZMAT(I,1)
                ZMAT(I,1)=TEMP
            END DO
        END IF
        ZMAT(KNEW,J)=ZERO
    END DO
    !
    !     Put the first NPT components of the KNEW-th column of HLAG into W,
    !     and calculate the parameters of the updating formula.
    !
    DO I=1,NPT
        W(I)=ZMAT(KNEW,1)*ZMAT(I,1)
    END DO
    ALPHA=W(KNEW)
    TAU=VLAG(KNEW)
    VLAG(KNEW)=VLAG(KNEW)-ONE
    !
    !     Complete the updating of ZMAT.
    !
    TEMP=DSQRT(DENOM)
    TEMPB=ZMAT(KNEW,1)/TEMP
    TEMPA=TAU/TEMP
    DO I=1,NPT
        ZMAT(I,1)=TEMPA*ZMAT(I,1)-TEMPB*VLAG(I)
    END DO
    !
    !     Finally, update the matrix BMAT.
    !
    DO J=1,N
        JP=NPT+J
        W(JP)=BMAT(KNEW,J)
        TEMPA=(ALPHA*VLAG(JP)-TAU*W(JP))/DENOM
        TEMPB=(-BETA*W(JP)-TAU*VLAG(JP))/DENOM
        DO I=1,JP
            BMAT(I,J)=BMAT(I,J)+TEMPA*VLAG(I)+TEMPB*W(I)
            IF (I  >  NPT) BMAT(JP,I-NPT)=BMAT(I,J)
        END DO
    END DO
    END SUBROUTINE UPDATE



    !*****************************************************************************************
    !>
    !  This subroutine seeks the least value of a function of many variables,
    !  by a trust region method that forms quadratic models by interpolation.
    !  There can be some freedom in the interpolation conditions, which is
    !  taken up by minimizing the Frobenius norm of the change to the second
    !  derivative of the quadratic model, beginning with a zero matrix.

    logical function newuoa (this, obj, funk, n, npt, x, rhobeg, rhoend, iprint, maxfun)
    use iso_c_binding
    class(TNEWUOA) this
    class(*), target :: obj
    real(dp), external :: funk !a class function f(obj,x) where obj is any class instance

    integer,intent(in)                  :: n       !! the number of variables. must be at least 2.
    integer,intent(in)                  :: npt     !! The number of interpolation conditions.
    !! Its value must be in the interval `[N+2,(N+1)(N+2)/2]`.
    real(dp),dimension(*),intent(inout) :: x       !! Initial values of the variables must be set in X(1),X(2),...,X(N). They
    !! will be changed to the values that give the least calculated F.
    real(dp),intent(in)                 :: rhobeg  !! RHOBEG and RHOEND must be set to the initial and final values of a trust
    !! region radius, so both must be positive with RHOEND<=RHOBEG. Typically
    !! RHOBEG should be about one tenth of the greatest expected change to a
    !! variable, and RHOEND should indicate the accuracy that is required in
    !! the final values of the variables.
    real(dp),intent(in)                 :: rhoend  !! RHOBEG and RHOEND must be set to the initial and final values of a trust
    !! region radius, so both must be positive with RHOEND<=RHOBEG. Typically
    !! RHOBEG should be about one tenth of the greatest expected change to a
    !! variable, and RHOEND should indicate the accuracy that is required in
    !! the final values of the variables.
    integer,intent(in)                  :: iprint  !! The value of IPRINT should be set to 0, 1, 2 or 3, which controls the
    !! amount of printing. Specifically, there is no output if IPRINT=0 and
    !! there is output only at the return if IPRINT=1. Otherwise, each new
    !! value of RHO is printed, with the best vector of variables so far and
    !! the corresponding value of the objective function. Further, each new
    !! value of F with its variables are output if IPRINT=3.
    integer,intent(in)                  :: maxfun  !! an upper bound on the number of calls of CALFUN.
    !! for the variables `X(1),X(2),...,X(N)`.

    real(dp),dimension(:),allocatable :: w
    integer :: np,nptm,ndim,ixb,ixo,ixn,ixp,ifv,igq,ihq,ipq,ibmat,izmat,id,ivl,iw

    ! Partition the working space array, so that different parts of it can be
    ! treated separately by the subroutine that performs the main calculation.

    call C_F_PROCPOINTER(c_funloc(funk), this%funkk)
    this%obj => obj
    this%Last_bestfit = 1d30

    np = n + 1
    nptm = npt - np
    if (npt < n+2 .or. npt > ((n+2)*np)/2) then
        write(*,*) 'Return from NEWUOA because NPT is not in the required interval'
        newuoa = .false.
        return
    end if

    ! The array W will be used for working space
    allocate(w((NPT+13)*(NPT+N)+3*N*(N+3)/2))

    ndim = npt + n
    ixb = 1
    ixo = ixb + n
    ixn = ixo + n
    ixp = ixn + n
    ifv = ixp + n * npt
    igq = ifv + npt
    ihq = igq + n
    ipq = ihq + (n*np) / 2
    ibmat = ipq + npt
    izmat = ibmat + ndim * n
    id = izmat + npt * nptm
    ivl = id + n
    iw = ivl + ndim

    ! The above settings provide a partition of W for subroutine NEWUOB.
    ! The partition requires the first NPT*(NPT+N)+5*N*(N+3)/2 elements of
    ! W plus the space that is needed by the last array of NEWUOB.

    newuoa = this%newuob (n, npt, x, rhobeg, rhoend, iprint, maxfun, w(ixb), w(ixo), w(ixn), &
        w(ixp), w(ifv), w(igq), w(ihq), w(ipq), w(ibmat), w(izmat), ndim, &
        w(id), w(ivl), w(iw))


    deallocate(w)

    end function newuoa
    !*****************************************************************************************

    logical function newuob (this, n, npt, x, rhobeg, rhoend, iprint, maxfun, xbase, xopt, &
        xnew, xpt, fval, gq, hq, pq, bmat, zmat, ndim, d, vlag, w)
    class(TNEWUOA) this

    real(dp) alpha , beta , bsum , crvmin , delta , detrat , &
        & diff , diffa , diffb , diffc , distsq , dnorm , dsq ,      &
        & dstep , dx , f , fbeg , fopt
    real(dp) fsave , gisq , gqsq , half , hdiag , one , ratio , recip , reciq , &
        rho , Rhobeg , Rhoend , rhosq , sum , suma , sumb
    real(dp) sumz , temp , tempq , tenth , vquad , xjpt , xoptsq , zero, xipt
    INTEGER i , idz , ih , ip , Iprint , ipt , itemp , itest , &
        & j , jp , jpt , k , knew , kopt , ksave , ktemp , Maxfun , &
        & N , Ndim
    INTEGER nf , nfm , nfmm , nfsav , nftest , nh , np , Npt , nptm
    real(dp) x (*), xbase (*), xopt (*), xnew (*), xpt (npt,*), fval (*), gq (*), hq(*), &
        pq (*), bmat (ndim,*), zmat (npt,*), d (*), vlag (*), w (*)
    !
    !     The arguments N, NPT, X, RHOBEG, RHOEND, IPRINT and MAXFUN are identical
    !       to the corresponding arguments in SUBROUTINE NEWUOA.
    !     XBASE will hold a shift of origin that should reduce the contributions
    !       from rounding errors to values of the model and Lagrange functions.
    !     XOPT will be set to the displacement from XBASE of the vector of
    !       variables that provides the least calculated F so far.
    !     XNEW will be set to the displacement from XBASE of the vector of
    !       variables for the current calculation of F.
    !     XPT will contain the interpolation point coordinates relative to XBASE.
    !     FVAL will hold the values of F at the interpolation points.
    !     GQ will hold the gradient of the quadratic model at XBASE.
    !     HQ will hold the explicit second derivatives of the quadratic model.
    !     PQ will contain the parameters of the implicit second derivatives of
    !       the quadratic model.
    !     BMAT will hold the last N columns of H.
    !     ZMAT will hold the factorization of the leading NPT by NPT submatrix of
    !       H, this factorization being ZMAT times Diag(DZ) times ZMAT^T, where
    !       the elements of DZ are plus or minus one, as specified by IDZ.
    !     NDIM is the first dimension of BMAT and has the value NPT+N.
    !     D is reserved for trial steps from XOPT.
    !     VLAG will contain the values of the Lagrange functions at a new point X.
    !       They are part of a product that requires VLAG to be of length NDIM.
    !     The array W will be used for working space. Its length must be at least
    !       10*NDIM = 10*(NPT+N).
    !
    !     Set some constants.
    !
    newuob = .true.
    half = 0.5_dp
    one = 1.0_dp
    tenth = 0.1_dp
    zero = 0.0_dp
    np = n + 1
    nh = (n*np) / 2
    nptm = npt - np
    nftest = max (maxfun, 1)
    !
    !     Set the initial elements of XPT, BMAT, HQ, PQ and ZMAT to zero.
    !
    do j = 1, n
        xbase (j) = x (j)
        do k = 1, npt
            xpt (k, j) = zero
        end do
        do i = 1, ndim
            bmat (i, j) = zero
        end do
    end do
    do ih = 1, nh
        hq (ih) = zero
    end do
    do k = 1, npt
        pq (k) = zero
        do j = 1, nptm
            zmat (k, j) = zero
        end do
    end do
    !
    !     Begin the initialization procedure. NF becomes one more than the number
    !     of function values so far. The coordinates of the displacement of the
    !     next initial interpolation point from XBASE are set in XPT(NF,.).
    !
    rhosq = rhobeg * rhobeg
    recip = one / rhosq
    reciq = sqrt (half) / rhosq
    nf = 0
50  nfm = nf
    nfmm = nf - n
    nf = nf + 1
    if (nfm <= 2*n) then
        if (nfm >= 1 .and. nfm <= n) then
            xpt (nf, nfm) = rhobeg
        else if (nfm > n) then
            xpt (nf, nfmm) = - rhobeg
        end if
    else
        itemp = (nfmm-1) / n
        jpt = nfm - itemp * n - n
        ipt = jpt + itemp
        if (ipt > n) then
            itemp = jpt
            jpt = ipt - n
            ipt = itemp
        end if
        xipt = rhobeg
        if (fval(ipt+np) < fval(ipt+1)) xipt = - xipt
        xjpt = rhobeg
        if (fval(jpt+np) < fval(jpt+1)) xjpt = - xjpt
        xpt (nf, ipt) = xipt
        xpt (nf, jpt) = xjpt
    end if
    !
    !     Calculate the next value of F, label 70 being reached immediately
    !     after this calculation. The least function value so far and its index
    !     are required.
    !
    do j = 1, n
        x (j) = xpt (nf, j) + xbase (j)
    end do
    go to 310
70  fval (nf) = f
    if (nf == 1) then
        fbeg = f
        fopt = f
        kopt = 1
    else if (f < fopt) then
        fopt = f
        kopt = nf
    end if
    !
    !     Set the nonzero initial elements of BMAT and the quadratic model in
    !     the cases when NF is at most 2*N+1.
    !
    if (nfm <= 2*n) then
        if (nfm >= 1 .and. nfm <= n) then
            gq (nfm) = (f-fbeg) / rhobeg
            if (npt < nf+n) then
                bmat (1, nfm) = - one / rhobeg
                bmat (nf, nfm) = one / rhobeg
                bmat (npt+nfm, nfm) = - half * rhosq
            end if
        else if (nfm > n) then
            bmat (nf-n, nfmm) = half / rhobeg
            bmat (nf, nfmm) = - half / rhobeg
            zmat (1, nfmm) = - reciq - reciq
            zmat (nf-n, nfmm) = reciq
            zmat (nf, nfmm) = reciq
            ih = (nfmm*(nfmm+1)) / 2
            temp = (fbeg-f) / rhobeg
            hq (ih) = (gq(nfmm)-temp) / rhobeg
            gq (nfmm) = half * (gq(nfmm)+temp)
        end if
        !
        !     Set the off-diagonal second derivatives of the Lagrange functions and
        !     the initial quadratic model.
        !
    else
        ih = (ipt*(ipt-1)) / 2 + jpt
        if (xipt < zero) ipt = ipt + n
        if (xjpt < zero) jpt = jpt + n
        zmat (1, nfmm) = recip
        zmat (nf, nfmm) = recip
        zmat (ipt+1, nfmm) = - recip
        zmat (jpt+1, nfmm) = - recip
        hq (ih) = (fbeg-fval(ipt+1)-fval(jpt+1)+f) / (xipt*xjpt)
    end if
    if (nf < npt) go to 50
    !
    !     Begin the iterative procedure, because the initial model is complete.
    !
    rho = rhobeg
    delta = rho
    idz = 1
    diffa = zero
    diffb = zero
    itest = 0
    xoptsq = zero
    do i = 1, n
        xopt (i) = xpt (kopt, i)
        xoptsq = xoptsq + xopt (i) ** 2
    end do
90  nfsav = nf
    !
    !     Generate the next trust region step and test its length. Set KNEW
    !     to -1 if the purpose of the next F will be to improve the model.
    !
100 knew = 0
    call trsapp (n, npt, xopt, xpt, gq, hq, pq, delta, d, w, w(np), w(np+n), &
        w(np+2*n), crvmin)
    dsq = zero
    do i = 1, n
        dsq = dsq + d (i) ** 2
    end do
    dnorm = min (delta, sqrt(dsq))
    if (dnorm < half*rho) then
        knew = - 1
        delta = tenth * delta
        ratio = - 1.0_dp
        if (delta <= 1.5_dp*rho) delta = rho
        if (nf <= nfsav+2) go to 460
        temp = 0.125_dp * crvmin * rho * rho
        if (temp <= max(diffa, diffb, diffc)) go to 460
        go to 490
    end if
    !
    !     Shift XBASE if XOPT may be too far from XBASE. First make the changes
    !     to BMAT that do not depend on ZMAT.
    !
120 if (dsq <= 1.0e-3_dp*xoptsq) then
        tempq = 0.25_dp * xoptsq
        do k = 1, npt
            sum = zero
            do i = 1, n
                sum = sum + xpt (k, i) * xopt (i)
            end do
            temp = pq (k) * sum
            sum = sum - half * xoptsq
            w (npt+k) = sum
            do i = 1, n
                gq (i) = gq (i) + temp * xpt (k, i)
                xpt (k, i) = xpt (k, i) - half * xopt (i)
                vlag (i) = bmat (k, i)
                w (i) = sum * xpt (k, i) + tempq * xopt (i)
                ip = npt + i
                do j = 1, i
                    bmat (ip, j) = bmat (ip, j) + vlag (i) * w (j) + w (i) * vlag (j)
                end do
            end do
        end do
        !
        !     Then the revisions of BMAT that depend on ZMAT are calculated.
        !
        do k = 1, nptm
            sumz = zero
            do i = 1, npt
                sumz = sumz + zmat (i, k)
                w (i) = w (npt+i) * zmat (i, k)
            end do
            do j = 1, n
                sum = tempq * sumz * xopt (j)
                do i = 1, npt
                    sum = sum + w (i) * xpt (i, j)
                end do
                vlag (j) = sum
                if (k < idz) sum = - sum
                do i = 1, npt
                    bmat (i, j) = bmat (i, j) + sum * zmat (i, k)
                end do
            end do
            do i = 1, n
                ip = i + npt
                temp = vlag (i)
                if (k < idz) temp = - temp
                do j = 1, i
                    bmat (ip, j) = bmat (ip, j) + temp * vlag (j)
                end do
            end do
        end do
        !
        !     The following instructions complete the shift of XBASE, including
        !     the changes to the parameters of the quadratic model.
        !
        ih = 0
        do j = 1, n
            w (j) = zero
            do k = 1, npt
                w (j) = w (j) + pq (k) * xpt (k, j)
                xpt (k, j) = xpt (k, j) - half * xopt (j)
            end do
            do i = 1, j
                ih = ih + 1
                if (i < j) gq (j) = gq (j) + hq (ih) * xopt (i)
                gq (i) = gq (i) + hq (ih) * xopt (j)
                hq (ih) = hq (ih) + w (i) * xopt (j) + xopt (i) * w (j)
                bmat (npt+i, j) = bmat (npt+j, i)
            end do
        end do
        do j = 1, n
            xbase (j) = xbase (j) + xopt (j)
            xopt (j) = zero
        end do
        xoptsq = zero
    end if
    !
    !     Pick the model step if KNEW is positive. A different choice of D
    !     may be made later, if the choice of D by BIGLAG causes substantial
    !     cancellation in DENOM.
    !
    if (knew > 0) then
        call biglag (n, npt, xopt, xpt, bmat, zmat, idz, ndim, knew, dstep, d, alpha, &
            vlag, vlag(npt+1), w, w(np), w(np+n))
    end if
    !
    !     Calculate VLAG and BETA for the current choice of D. The first NPT
    !     components of W_check will be held in W.
    !
    do k = 1, npt
        suma = zero
        sumb = zero
        sum = zero
        do j = 1, n
            suma = suma + xpt (k, j) * d (j)
            sumb = sumb + xpt (k, j) * xopt (j)
            sum = sum + bmat (k, j) * d (j)
        end do
        w (k) = suma * (half*suma+sumb)
        vlag (k) = sum
    end do
    beta = zero
    do k = 1, nptm
        sum = zero
        do i = 1, npt
            sum = sum + zmat (i, k) * w (i)
        end do
        if (k < idz) then
            beta = beta + sum * sum
            sum = - sum
        else
            beta = beta - sum * sum
        end if
        do i = 1, npt
            vlag (i) = vlag (i) + sum * zmat (i, k)
        end do
    end do
    bsum = zero
    dx = zero
    do j = 1, n
        sum = zero
        do i = 1, npt
            sum = sum + w (i) * bmat (i, j)
        end do
        bsum = bsum + sum * d (j)
        jp = npt + j
        do k = 1, n
            sum = sum + bmat (jp, k) * d (k)
        end do
        vlag (jp) = sum
        bsum = bsum + sum * d (j)
        dx = dx + d (j) * xopt (j)
    end do
    beta = dx * dx + dsq * (xoptsq+dx+dx+half*dsq) + beta - bsum
    vlag (kopt) = vlag (kopt) + one
    !
    !     If KNEW is positive and if the cancellation in DENOM is unacceptable,
    !     then BIGDEN calculates an alternative model step, XNEW being used for
    !     working space.
    !
    if (knew > 0) then
        temp = one + alpha * beta / vlag (knew) ** 2
        if (abs(temp) <= 0.8_dp) then
            call bigden (n, npt, xopt, xpt, bmat, zmat, idz, ndim, kopt, knew, d, w, &
                vlag, beta, xnew, w(ndim+1), w(6*ndim+1))
        end if
    end if
    !
    !     Calculate the next value of the objective function.
    !
290 do i = 1, n
        xnew (i) = xopt (i) + d (i)
        x (i) = xbase (i) + xnew (i)
    end do
    nf = nf + 1
310 if (nf > nftest) then
        nf = nf - 1
        if (iprint > 0) print 320
320     format (/ 4 x, 'Return from NEWUOA because CALFUN has been',&
            ' called MAXFUN times.')
        newuob = .false.
        go to 530
    end if
    f = this%funkk(this%obj, X(1:N))
    if (iprint == 3) then
        print 330, nf, f, (x(i), i=1, n)
330     format (/ 4 x, 'Function number', i6, '    F =', 1 pd18.10,&
            '    The corresponding X is:' / (2 x, 5d15.6))
    end if
    if (nf <= npt) go to 70
    if (knew ==-1) go to 530
    !
    !     Use the quadratic model to predict the change in F due to the step D,
    !     and set DIFF to the error of this prediction.
    !
    vquad = zero
    ih = 0
    do j = 1, n
        vquad = vquad + d (j) * gq (j)
        do i = 1, j
            ih = ih + 1
            temp = d (i) * xnew (j) + d (j) * xopt (i)
            if (i == j) temp = half * temp
            vquad = vquad + temp * hq (ih)
        end do
    end do
    do k = 1, npt
        vquad = vquad + pq (k) * w (k)
    end do
    diff = f - fopt - vquad
    diffc = diffb
    diffb = diffa
    diffa = abs (diff)
    if (dnorm > rho) nfsav = nf
    !
    !     Update FOPT and XOPT if the new F is the least value of the objective
    !     function so far. The branch when KNEW is positive occurs if D is not
    !     a trust region step.
    !
    fsave = fopt
    if (f < fopt) then
        fopt = f
        xoptsq = zero
        do i = 1, n
            xopt (i) = xnew (i)
            xoptsq = xoptsq + xopt (i) ** 2
        end do
    end if
    ksave = knew
    if (knew > 0) go to 410
    !
    !     Pick the next value of DELTA after a trust region step.
    !
    if (vquad >= zero) then
        if (iprint > 0) print 370
370     format (/ 4 x, 'Return from NEWUOA because a trust',&
            ' region step has failed to reduce Q.')
        newuob = .false.
        go to 530
    end if
    ratio = (f-fsave) / vquad
    if (ratio <= tenth) then
        delta = half * dnorm
    else if (ratio <= 0.7_dp) then
        delta = max (half*delta, dnorm)
    else
        delta = max (half*delta, dnorm+dnorm)
    end if
    if (delta <= 1.5_dp*rho) delta = rho
    !
    !     Set KNEW to the index of the next interpolation point to be deleted.
    !
    rhosq = max (tenth*delta, rho) ** 2
    ktemp = 0
    detrat = zero
    if (f >= fsave) then
        ktemp = kopt
        detrat = one
    end if
    do k = 1, npt
        hdiag = zero
        do j = 1, nptm
            temp = one
            if (j < idz) temp = - one
            hdiag = hdiag + temp * zmat (k, j) ** 2
        end do
        temp = abs (beta*hdiag+vlag(k)**2)
        distsq = zero
        do j = 1, n
            distsq = distsq + (xpt(k, j)-xopt(j)) ** 2
        end do
        if (distsq > rhosq) temp = temp * (distsq/rhosq) ** 3
        if (temp > detrat .and. k /= ktemp) then
            detrat = temp
            knew = k
        end if
    end do
    if (knew == 0) go to 460
    !
    !     Update BMAT, ZMAT and IDZ, so that the KNEW-th interpolation point
    !     can be moved. Begin the updating of the quadratic model, starting
    !     with the explicit second derivative term.
    !
410 call update_newuoa (n, npt, bmat, zmat, idz, ndim, vlag, beta, knew, w)
    fval (knew) = f
    ih = 0
    do i = 1, n
        temp = pq (knew) * xpt (knew, i)
        do j = 1, i
            ih = ih + 1
            hq (ih) = hq (ih) + temp * xpt (knew, j)
        end do
    end do
    pq (knew) = zero
    !
    !     Update the other second derivative parameters, and then the gradient
    !     vector of the model. Also include the new interpolation point.
    !
    do j = 1, nptm
        temp = diff * zmat (knew, j)
        if (j < idz) temp = - temp
        do k = 1, npt
            pq (k) = pq (k) + temp * zmat (k, j)
        end do
    end do
    gqsq = zero
    do i = 1, n
        gq (i) = gq (i) + diff * bmat (knew, i)
        gqsq = gqsq + gq (i) ** 2
        xpt (knew, i) = xnew (i)
    end do
    !
    !     If a trust region step makes a small change to the objective function,
    !     then calculate the gradient of the least Frobenius norm interpolant at
    !     XBASE, and store it in W, using VLAG for a vector of right hand sides.
    !
    if (ksave == 0 .and. delta == rho) then
        if (abs(ratio) > 1.0e-2_dp) then
            itest = 0
        else
            do k = 1, npt
                vlag (k) = fval (k) - fval (kopt)
            end do
            gisq = zero
            do i = 1, n
                sum = zero
                do k = 1, npt
                    sum = sum + bmat (k, i) * vlag (k)
                end do
                gisq = gisq + sum * sum
                w (i) = sum
            end do
            !
            !     Test whether to replace the new quadratic model by the least Frobenius
            !     norm interpolant, making the replacement if the test is satisfied.
            !
            itest = itest + 1
            if (gqsq < 100.0_dp*gisq) itest = 0
            if (itest >= 3) then
                do i = 1, n
                    gq (i) = w (i)
                end do
                do ih = 1, nh
                    hq (ih) = zero
                end do
                do j = 1, nptm
                    w (j) = zero
                    do k = 1, npt
                        w (j) = w (j) + vlag (k) * zmat (k, j)
                    end do
                    if (j < idz) w (j) = - w (j)
                end do
                do k = 1, npt
                    pq (k) = zero
                    do j = 1, nptm
                        pq (k) = pq (k) + zmat (k, j) * w (j)
                    end do
                end do
                itest = 0
            end if
        end if
    end if
    if (f < fsave) kopt = knew
    !
    !     If a trust region step has provided a sufficient decrease in F, then
    !     branch for another trust region calculation. The case KSAVE>0 occurs
    !     when the new function value was calculated by a model step.
    !
    if (f <= fsave+tenth*vquad) go to 100
    if (ksave > 0) go to 100
    !
    !     Alternatively, find out if the interpolation points are close enough
    !     to the best point so far.
    !
    knew = 0
460 distsq = 4.0_dp * delta * delta
    do k = 1, npt
        sum = zero
        do j = 1, n
            sum = sum + (xpt(k, j)-xopt(j)) ** 2
        end do
        if (sum > distsq) then
            knew = k
            distsq = sum
        end if
    end do
    !
    !     If KNEW is positive, then set DSTEP, and branch back for the next
    !     iteration, which will generate a "model step".
    !
    if (knew > 0) then
        dstep = max (min(tenth*sqrt(distsq), half*delta), rho)
        dsq = dstep * dstep
        go to 120
    end if
    if (ratio > zero) go to 100
    if (max(delta, dnorm) > rho) go to 100
    !
    !     The calculations with the current value of RHO are complete. Pick the
    !     next values of RHO and DELTA.
    !
490 if (rho > rhoend) then
        delta = half * rho
        ratio = rho / rhoend
        if (ratio <= 16.0_dp) then
            rho = rhoend
        else if (ratio <= 250.0_dp) then
            rho = sqrt (ratio) * rhoend
        else
            rho = tenth * rho
        end if
        delta = max (delta, rho)
        this%Last_bestfit = fopt
        if (iprint >= 2) then
            if (iprint >= 3) print 500
500         format (5 x)
            print 510, rho, nf
510         format (/ 4 x, 'New RHO =', 1 pd11.4, 5 x, 'Number of',&
                ' function values =', i6)
            print 520, fopt, (xbase(i)+xopt(i), i=1, n)
520         format (4 x, 'Least value of F =', 1 pd23.15, 9 x,&
                'The corresponding X is:'/(2 x, 5d15.6))
        end if
        go to 90
    end if
    !
    !     Return from the calculation, after another Newton-Raphson step, if
    !     it is too short to have been tried before.
    !
    if (knew ==-1) go to 290
530 if (fopt <= f) then
        do i = 1, n
            x (i) = xbase (i) + xopt (i)
        end do
        f = fopt
    end if
    if (iprint >= 1) then
        print 550, nf
550     format (/ 4 x, 'At the return from NEWUOA', 5 x,&
            'Number of function values =', i6)
        print 520, f, (x(i), i=1, n)
    end if

    end function newuob

    subroutine bigden (n, npt, xopt, xpt, bmat, zmat, idz, ndim, kopt, knew, d, w, vlag, &
        beta, s, wvec, prod)
    real(dp) alpha , angle , Beta , dd , denmax , denold , densav , diff , ds , dstemp , &
        dtest , half , one , quart
    real(dp) ss , ssden , sstemp , step , sum , sumold , tau ,      &
        & temp , tempa , tempb , tempc , two , twopi , xoptd , xopts
    real(dp) xoptsq , zero
    INTEGER i , Idz , ip , isave , iterc , iu , j , jc , k , Knew ,   &
        & Kopt , ksav , N , Ndim , Npt , nptm , nw
    real(dp) xopt (*), xpt (npt,*), bmat (ndim,*), zmat (npt,*), d (*), w (*), vlag &
        (*), s (*), wvec (ndim,*), prod (ndim,*)
    real(dp) den (9), denex (9), par (9)
    !
    !     N is the number of variables.
    !     NPT is the number of interpolation equations.
    !     XOPT is the best interpolation point so far.
    !     XPT contains the coordinates of the current interpolation points.
    !     BMAT provides the last N columns of H.
    !     ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
    !     NDIM is the first dimension of BMAT and has the value NPT+N.
    !     KOPT is the index of the optimal interpolation point.
    !     KNEW is the index of the interpolation point that is going to be moved.
    !     D will be set to the step from XOPT to the new point, and on entry it
    !       should be the D that was calculated by the last call of BIGLAG. The
    !       length of the initial D provides a trust region bound on the final D.
    !     W will be set to Wcheck for the final choice of D.
    !     VLAG will be set to Theta*Wcheck+e_b for the final choice of D.
    !     BETA will be set to the value that will occur in the updating formula
    !       when the KNEW-th interpolation point is moved to its new position.
    !     S, WVEC, PROD and the private arrays DEN, DENEX and PAR will be used
    !       for working space.
    !
    !     D is calculated in a way that should provide a denominator with a large
    !     modulus in the updating formula when the KNEW-th interpolation point is
    !     shifted to the new position XOPT+D.
    !
    !     Set some constants.
    !
    half = 0.5_dp
    one = 1.0_dp
    quart = 0.25_dp
    two = 2.0_dp
    zero = 0.0_dp
    twopi = 8.0_dp * atan (one)
    nptm = npt - n - 1
    !
    !     Store the first NPT elements of the KNEW-th column of H in W(N+1)
    !     to W(N+NPT).
    !
    do k = 1, npt
        w (n+k) = zero
    end do
    do j = 1, nptm
        temp = zmat (knew, j)
        if (j < idz) temp = - temp
        do k = 1, npt
            w (n+k) = w (n+k) + temp * zmat (k, j)
        end do
    end do
    alpha = w (n+knew)
    !
    !     The initial search direction D is taken from the last call of BIGLAG,
    !     and the initial S is set below, usually to the direction from X_OPT
    !     to X_KNEW, but a different direction to an interpolation point may
    !     be chosen, in order to prevent S from being nearly parallel to D.
    !
    dd = zero
    ds = zero
    ss = zero
    xoptsq = zero
    do i = 1, n
        dd = dd + d (i) ** 2
        s (i) = xpt (knew, i) - xopt (i)
        ds = ds + d (i) * s (i)
        ss = ss + s (i) ** 2
        xoptsq = xoptsq + xopt (i) ** 2
    end do
    if (ds*ds > 0.99_dp*dd*ss) then
        ksav = knew
        dtest = ds * ds / ss
        do k = 1, npt
            if (k /= kopt) then
                dstemp = zero
                sstemp = zero
                do i = 1, n
                    diff = xpt (k, i) - xopt (i)
                    dstemp = dstemp + d (i) * diff
                    sstemp = sstemp + diff * diff
                end do
                if (dstemp*dstemp/sstemp < dtest) then
                    ksav = k
                    dtest = dstemp * dstemp / sstemp
                    ds = dstemp
                    ss = sstemp
                end if
            end if
        end do
        do i = 1, n
            s (i) = xpt (ksav, i) - xopt (i)
        end do
    end if
    ssden = dd * ss - ds * ds
    iterc = 0
    densav = zero
    !
    !     Begin the iteration by overwriting S with a vector that has the
    !     required length and direction.
    !
70  iterc = iterc + 1
    temp = one / sqrt (ssden)
    xoptd = zero
    xopts = zero
    do i = 1, n
        s (i) = temp * (dd*s(i)-ds*d(i))
        xoptd = xoptd + xopt (i) * d (i)
        xopts = xopts + xopt (i) * s (i)
    end do
    !
    !     Set the coefficients of the first two terms of BETA.
    !
    tempa = half * xoptd * xoptd
    tempb = half * xopts * xopts
    den (1) = dd * (xoptsq+half*dd) + tempa + tempb
    den (2) = two * xoptd * dd
    den (3) = two * xopts * dd
    den (4) = tempa - tempb
    den (5) = xoptd * xopts
    do i = 6, 9
        den (i) = zero
    end do
    !
    !     Put the coefficients of Wcheck in WVEC.
    !
    do k = 1, npt
        tempa = zero
        tempb = zero
        tempc = zero
        do i = 1, n
            tempa = tempa + xpt (k, i) * d (i)
            tempb = tempb + xpt (k, i) * s (i)
            tempc = tempc + xpt (k, i) * xopt (i)
        end do
        wvec (k, 1) = quart * (tempa*tempa+tempb*tempb)
        wvec (k, 2) = tempa * tempc
        wvec (k, 3) = tempb * tempc
        wvec (k, 4) = quart * (tempa*tempa-tempb*tempb)
        wvec (k, 5) = half * tempa * tempb
    end do
    do i = 1, n
        ip = i + npt
        wvec (ip, 1) = zero
        wvec (ip, 2) = d (i)
        wvec (ip, 3) = s (i)
        wvec (ip, 4) = zero
        wvec (ip, 5) = zero
    end do
    !
    !     Put the coefficents of THETA*Wcheck in PROD.
    !
    do jc = 1, 5
        nw = npt
        if (jc == 2 .or. jc == 3) nw = ndim
        do k = 1, npt
            prod (k, jc) = zero
        end do
        do j = 1, nptm
            sum = zero
            do k = 1, npt
                sum = sum + zmat (k, j) * wvec (k, jc)
            end do
            if (j < idz) sum = - sum
            do k = 1, npt
                prod (k, jc) = prod (k, jc) + sum * zmat (k, j)
            end do
        end do
        if (nw == ndim) then
            do k = 1, npt
                sum = zero
                do j = 1, n
                    sum = sum + bmat (k, j) * wvec (npt+j, jc)
                end do
                prod (k, jc) = prod (k, jc) + sum
            end do
        end if
        do j = 1, n
            sum = zero
            do i = 1, nw
                sum = sum + bmat (i, j) * wvec (i, jc)
            end do
            prod (npt+j, jc) = sum
        end do
    end do
    !
    !     Include in DEN the part of BETA that depends on THETA.
    !
    do k = 1, ndim
        sum = zero
        do i = 1, 5
            par (i) = half * prod (k, i) * wvec (k, i)
            sum = sum + par (i)
        end do
        den (1) = den (1) - par (1) - sum
        tempa = prod (k, 1) * wvec (k, 2) + prod (k, 2) * wvec (k, 1)
        tempb = prod (k, 2) * wvec (k, 4) + prod (k, 4) * wvec (k, 2)
        tempc = prod (k, 3) * wvec (k, 5) + prod (k, 5) * wvec (k, 3)
        den (2) = den (2) - tempa - half * (tempb+tempc)
        den (6) = den (6) - half * (tempb-tempc)
        tempa = prod (k, 1) * wvec (k, 3) + prod (k, 3) * wvec (k, 1)
        tempb = prod (k, 2) * wvec (k, 5) + prod (k, 5) * wvec (k, 2)
        tempc = prod (k, 3) * wvec (k, 4) + prod (k, 4) * wvec (k, 3)
        den (3) = den (3) - tempa - half * (tempb-tempc)
        den (7) = den (7) - half * (tempb+tempc)
        tempa = prod (k, 1) * wvec (k, 4) + prod (k, 4) * wvec (k, 1)
        den (4) = den (4) - tempa - par (2) + par (3)
        tempa = prod (k, 1) * wvec (k, 5) + prod (k, 5) * wvec (k, 1)
        tempb = prod (k, 2) * wvec (k, 3) + prod (k, 3) * wvec (k, 2)
        den (5) = den (5) - tempa - half * tempb
        den (8) = den (8) - par (4) + par (5)
        tempa = prod (k, 4) * wvec (k, 5) + prod (k, 5) * wvec (k, 4)
        den (9) = den (9) - half * tempa
    end do
    !
    !     Extend DEN so that it holds all the coefficients of DENOM.
    !
    sum = zero
    do i = 1, 5
        par (i) = half * prod (knew, i) ** 2
        sum = sum + par (i)
    end do
    denex (1) = alpha * den (1) + par (1) + sum
    tempa = two * prod (knew, 1) * prod (knew, 2)
    tempb = prod (knew, 2) * prod (knew, 4)
    tempc = prod (knew, 3) * prod (knew, 5)
    denex (2) = alpha * den (2) + tempa + tempb + tempc
    denex (6) = alpha * den (6) + tempb - tempc
    tempa = two * prod (knew, 1) * prod (knew, 3)
    tempb = prod (knew, 2) * prod (knew, 5)
    tempc = prod (knew, 3) * prod (knew, 4)
    denex (3) = alpha * den (3) + tempa + tempb - tempc
    denex (7) = alpha * den (7) + tempb + tempc
    tempa = two * prod (knew, 1) * prod (knew, 4)
    denex (4) = alpha * den (4) + tempa + par (2) - par (3)
    tempa = two * prod (knew, 1) * prod (knew, 5)
    denex (5) = alpha * den (5) + tempa + prod (knew, 2) * prod (knew, 3)
    denex (8) = alpha * den (8) + par (4) - par (5)
    denex (9) = alpha * den (9) + prod (knew, 4) * prod (knew, 5)
    !
    !     Seek the value of the angle that maximizes the modulus of DENOM.
    !
    sum = denex (1) + denex (2) + denex (4) + denex (6) + denex (8)
    denold = sum
    denmax = sum
    isave = 0
    iu = 49
    temp = twopi / real (iu+1, dp)
    par (1) = one
    do i = 1, iu
        angle = real (i, dp) * temp
        par (2) = cos (angle)
        par (3) = sin (angle)
        do j = 4, 8, 2
            par (j) = par (2) * par (j-2) - par (3) * par (j-1)
            par (j+1) = par (2) * par (j-1) + par (3) * par (j-2)
        end do
        sumold = sum
        sum = zero
        do j = 1, 9
            sum = sum + denex (j) * par (j)
        end do
        if (abs(sum) > abs(denmax)) then
            denmax = sum
            isave = i
            tempa = sumold
        else if (i == isave+1) then
            tempb = sum
        end if
    end do
    if (isave == 0) tempa = sum
    if (isave == iu) tempb = denold
    step = zero
    if (tempa /= tempb) then
        tempa = tempa - denmax
        tempb = tempb - denmax
        step = half * (tempa-tempb) / (tempa+tempb)
    end if
    angle = temp * (real(isave, dp)+step)
    !
    !     Calculate the new parameters of the denominator, the new VLAG vector
    !     and the new D. Then test for convergence.
    !
    par (2) = cos (angle)
    par (3) = sin (angle)
    do j = 4, 8, 2
        par (j) = par (2) * par (j-2) - par (3) * par (j-1)
        par (j+1) = par (2) * par (j-1) + par (3) * par (j-2)
    end do
    beta = zero
    denmax = zero
    do j = 1, 9
        beta = beta + den (j) * par (j)
        denmax = denmax + denex (j) * par (j)
    end do
    do k = 1, ndim
        vlag (k) = zero
        do j = 1, 5
            vlag (k) = vlag (k) + prod (k, j) * par (j)
        end do
    end do
    tau = vlag (knew)
    dd = zero
    tempa = zero
    tempb = zero
    do i = 1, n
        d (i) = par (2) * d (i) + par (3) * s (i)
        w (i) = xopt (i) + d (i)
        dd = dd + d (i) ** 2
        tempa = tempa + d (i) * w (i)
        tempb = tempb + w (i) * w (i)
    end do
    if (iterc >= n) go to 340
    if (iterc > 1) densav = max (densav, denold)
    if (abs(denmax) <= 1.1_dp*abs(densav)) go to 340
    densav = denmax
    !
    !     Set S to half the gradient of the denominator with respect to D.
    !     Then branch for the next iteration.
    !
    do i = 1, n
        temp = tempa * xopt (i) + tempb * d (i) - vlag (npt+i)
        s (i) = tau * bmat (knew, i) + alpha * temp
    end do
    do k = 1, npt
        sum = zero
        do j = 1, n
            sum = sum + xpt (k, j) * w (j)
        end do
        temp = (tau*w(n+k)-alpha*vlag(k)) * sum
        do i = 1, n
            s (i) = s (i) + temp * xpt (k, i)
        end do
    end do
    ss = zero
    ds = zero
    do i = 1, n
        ss = ss + s (i) ** 2
        ds = ds + d (i) * s (i)
    end do
    ssden = dd * ss - ds * ds
    if (ssden >= 1.0e-8_dp*dd*ss) go to 70
    !
    !     Set the vector W before the RETURN from the subroutine.
    !
340 do k = 1, ndim
        w (k) = zero
        do j = 1, 5
            w (k) = w (k) + wvec (k, j) * par (j)
        end do
    end do
    vlag (kopt) = vlag (kopt) + one

    end subroutine bigden

    subroutine biglag (n, npt, xopt, xpt, bmat, zmat, idz, ndim, knew, delta, d, alpha, &
        hcol, gc, gd, s, w)

    real(dp) Alpha , angle , cf1 , cf2 , cf3 , cf4 , cf5 , cth , &
        & dd , delsq , Delta , denom , dhd , gg , half
    INTEGER i , Idz , isave , iterc , iu , j , k , Knew , N , Ndim ,  &
        & Npt , nptm
    real(dp) one , scale , sp , ss , step , sth , sum , tau ,       &
        & taubeg , taumax , tauold , temp , tempa , tempb , twopi ,  zero
    real(dp) xopt (*), xpt (npt,*), bmat (ndim,*), zmat (npt,*), d (*), hcol (*), &
        gc(*), gd (*), s (*), w (*)
    !
    !     N is the number of variables.
    !     NPT is the number of interpolation equations.
    !     XOPT is the best interpolation point so far.
    !     XPT contains the coordinates of the current interpolation points.
    !     BMAT provides the last N columns of H.
    !     ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
    !     NDIM is the first dimension of BMAT and has the value NPT+N.
    !     KNEW is the index of the interpolation point that is going to be moved.
    !     DELTA is the current trust region bound.
    !     D will be set to the step from XOPT to the new point.
    !     ALPHA will be set to the KNEW-th diagonal element of the H matrix.
    !     HCOL, GC, GD, S and W will be used for working space.
    !
    !     The step D is calculated in a way that attempts to maximize the modulus
    !     of LFUNC(XOPT+D), subject to the bound ||D|| .LE. DELTA, where LFUNC is
    !     the KNEW-th Lagrange function.
    !
    !     Set some constants.
    !
    half = 0.5_dp
    one = 1.0_dp
    zero = 0.0_dp
    twopi = 8.0_dp * atan (one)
    delsq = delta * delta
    nptm = npt - n - 1
    !
    !     Set the first NPT components of HCOL to the leading elements of the
    !     KNEW-th column of H.
    !
    iterc = 0
    do k = 1, npt
        hcol (k) = zero
    end do
    do j = 1, nptm
        temp = zmat (knew, j)
        if (j < idz) temp = - temp
        do k = 1, npt
            hcol (k) = hcol (k) + temp * zmat (k, j)
        end do
    end do
    alpha = hcol (knew)
    !
    !     Set the unscaled initial direction D. Form the gradient of LFUNC at
    !     XOPT, and multiply D by the second derivative matrix of LFUNC.
    !
    dd = zero
    do i = 1, n
        d (i) = xpt (knew, i) - xopt (i)
        gc (i) = bmat (knew, i)
        gd (i) = zero
        dd = dd + d (i) ** 2
    end do
    do k = 1, npt
        temp = zero
        sum = zero
        do j = 1, n
            temp = temp + xpt (k, j) * xopt (j)
            sum = sum + xpt (k, j) * d (j)
        end do
        temp = hcol (k) * temp
        sum = hcol (k) * sum
        do i = 1, n
            gc (i) = gc (i) + temp * xpt (k, i)
            gd (i) = gd (i) + sum * xpt (k, i)
        end do
    end do
    !
    !     Scale D and GD, with a sign change if required. Set S to another
    !     vector in the initial two dimensional subspace.
    !
    gg = zero
    sp = zero
    dhd = zero
    do i = 1, n
        gg = gg + gc (i) ** 2
        sp = sp + d (i) * gc (i)
        dhd = dhd + d (i) * gd (i)
    end do
    scale = delta / sqrt (dd)
    if (sp*dhd < zero) scale = - scale
    temp = zero
    if (sp*sp > 0.99_dp*dd*gg) temp = one
    tau = scale * (abs(sp)+half*scale*abs(dhd))
    if (gg*delsq < 0.01_dp*tau*tau) temp = one
    do i = 1, n
        d (i) = scale * d (i)
        gd (i) = scale * gd (i)
        s (i) = gc (i) + temp * gd (i)
    end do
    !
    !     Begin the iteration by overwriting S with a vector that has the
    !     required length and direction, except that termination occurs if
    !     the given D and S are nearly parallel.
    !
80  iterc = iterc + 1
    dd = zero
    sp = zero
    ss = zero
    do i = 1, n
        dd = dd + d (i) ** 2
        sp = sp + d (i) * s (i)
        ss = ss + s (i) ** 2
    end do
    temp = dd * ss - sp * sp
    if (temp <= 1.0e-8_dp*dd*ss) go to 160
    denom = sqrt (temp)
    do i = 1, n
        s (i) = (dd*s(i)-sp*d(i)) / denom
        w (i) = zero
    end do
    !
    !     Calculate the coefficients of the objective function on the circle,
    !     beginning with the multiplication of S by the second derivative matrix.
    !
    do k = 1, npt
        sum = zero
        do j = 1, n
            sum = sum + xpt (k, j) * s (j)
        end do
        sum = hcol (k) * sum
        do i = 1, n
            w (i) = w (i) + sum * xpt (k, i)
        end do
    end do
    cf1 = zero
    cf2 = zero
    cf3 = zero
    cf4 = zero
    cf5 = zero
    do i = 1, n
        cf1 = cf1 + s (i) * w (i)
        cf2 = cf2 + d (i) * gc (i)
        cf3 = cf3 + s (i) * gc (i)
        cf4 = cf4 + d (i) * gd (i)
        cf5 = cf5 + s (i) * gd (i)
    end do
    cf1 = half * cf1
    cf4 = half * cf4 - cf1
    !
    !     Seek the value of the angle that maximizes the modulus of TAU.
    !
    taubeg = cf1 + cf2 + cf4
    taumax = taubeg
    tauold = taubeg
    isave = 0
    iu = 49
    temp = twopi / real (iu+1, dp)
    do i = 1, iu
        angle = real (i, dp) * temp
        cth = cos (angle)
        sth = sin (angle)
        tau = cf1 + (cf2+cf4*cth) * cth + (cf3+cf5*cth) * sth
        if (abs(tau) > abs(taumax)) then
            taumax = tau
            isave = i
            tempa = tauold
        else if (i == isave+1) then
            tempb = tau
        end if
        tauold = tau
    end do
    if (isave == 0) tempa = tau
    if (isave == iu) tempb = taubeg
    step = zero
    if (tempa /= tempb) then
        tempa = tempa - taumax
        tempb = tempb - taumax
        step = half * (tempa-tempb) / (tempa+tempb)
    end if
    angle = temp * (real(isave, dp)+step)
    !
    !     Calculate the new D and GD. Then test for convergence.
    !
    cth = cos (angle)
    sth = sin (angle)
    tau = cf1 + (cf2+cf4*cth) * cth + (cf3+cf5*cth) * sth
    do i = 1, n
        d (i) = cth * d (i) + sth * s (i)
        gd (i) = cth * gd (i) + sth * w (i)
        s (i) = gc (i) + gd (i)
    end do
    if (abs(tau) <= 1.1_dp*abs(taubeg)) go to 160
    if (iterc < n) go to 80
160 return
    end subroutine biglag

    subroutine trsapp (n, npt, xopt, xpt, gq, hq, pq, delta, step, d, g, hd, hs, crvmin)
    real(dp) alpha , angle , angtest , bstep , cf , Crvmin , cth , &
        & dd , delsq , Delta , dg , dhd , dhs , ds , gg , ggbeg ,&
        & ggsav
    real(dp) half , qadd , qbeg , qmin , qnew , qred , qsav , ratio , reduc , &
        sg , sgk , shs , ss , sth , temp, tempa , tempb , twopi , zero
    INTEGER i , ih , isave , iterc , itermax , itersw , iu , j , k ,  &
        & N , Npt
    real(dp) xopt (*), xpt (npt,*), gq (*), hq (*), pq (*), step (*), d (*), g (*), &
        hd (*), hs (*)
    !
    !     N is the number of variables of a quadratic objective function, Q say.
    !     The arguments NPT, XOPT, XPT, GQ, HQ and PQ have their usual meanings,
    !       in order to define the current quadratic model Q.
    !     DELTA is the trust region radius, and has to be positive.
    !     STEP will be set to the calculated trial step.
    !     The arrays D, G, HD and HS will be used for working space.
    !     CRVMIN will be set to the least curvature of H along the conjugate
    !       directions that occur, except that it is set to zero if STEP goes
    !       all the way to the trust region boundary.
    !
    !     The calculation of STEP begins with the truncated conjugate gradient
    !     method. If the boundary of the trust region is reached, then further
    !     changes to STEP may be made, each one being in the 2D space spanned
    !     by the current STEP and the corresponding gradient of Q. Thus STEP
    !     should provide a substantial reduction to Q within the trust region.
    !
    !     Initialization, which includes setting HD to H times XOPT.
    !
    half = 0.5_dp
    zero = 0.0_dp
    twopi = 8.0_dp * atan (1.0_dp)
    delsq = delta * delta
    iterc = 0
    itermax = n
    itersw = itermax
    do i = 1, n
        d (i) = xopt (i)
    end do
    go to 170
    !
    !     Prepare for the first line search.
    !
20  qred = zero
    dd = zero
    do i = 1, n
        step (i) = zero
        hs (i) = zero
        g (i) = gq (i) + hd (i)
        d (i) = - g (i)
        dd = dd + d (i) ** 2
    end do
    crvmin = zero
    if (dd == zero) go to 160
    ds = zero
    ss = zero
    gg = dd
    ggbeg = gg
    !
    !     Calculate the step to the trust region boundary and the product HD.
    !
40  iterc = iterc + 1
    temp = delsq - ss
    bstep = temp / (ds+sqrt(ds*ds+dd*temp))
    go to 170
50  dhd = zero
    do j = 1, n
        dhd = dhd + d (j) * hd (j)
    end do
    !
    !     Update CRVMIN and set the step-length ALPHA.
    !
    alpha = bstep
    if (dhd > zero) then
        temp = dhd / dd
        if (iterc == 1) crvmin = temp
        crvmin = min (crvmin, temp)
        alpha = min (alpha, gg/dhd)
    end if
    qadd = alpha * (gg-half*alpha*dhd)
    qred = qred + qadd
    !
    !     Update STEP and HS.
    !
    ggsav = gg
    gg = zero
    do i = 1, n
        step (i) = step (i) + alpha * d (i)
        hs (i) = hs (i) + alpha * hd (i)
        gg = gg + (g(i)+hs(i)) ** 2
    end do
    !
    !     Begin another conjugate direction iteration if required.
    !
    if (alpha < bstep) then
        if (qadd <= 0.01_dp*qred) go to 160
        if (gg <= 1.0e-4_dp*ggbeg) go to 160
        if (iterc == itermax) go to 160
        temp = gg / ggsav
        dd = zero
        ds = zero
        ss = zero
        do i = 1, n
            d (i) = temp * d (i) - g (i) - hs (i)
            dd = dd + d (i) ** 2
            ds = ds + d (i) * step (i)
            ss = ss + step (i) ** 2
        end do
        if (ds <= zero) go to 160
        if (ss < delsq) go to 40
    end if
    crvmin = zero
    itersw = iterc
    !
    !     Test whether an alternative iteration is required.
    !
90  if (gg <= 1.0e-4_dp*ggbeg) go to 160
    sg = zero
    shs = zero
    do i = 1, n
        sg = sg + step (i) * g (i)
        shs = shs + step (i) * hs (i)
    end do
    sgk = sg + shs
    angtest = sgk / sqrt (gg*delsq)
    if (angtest <=-0.99_dp) go to 160
    !
    !     Begin the alternative iteration by calculating D and HD and some
    !     scalar products.
    !
    iterc = iterc + 1
    temp = sqrt (delsq*gg-sgk*sgk)
    tempa = delsq / temp
    tempb = sgk / temp
    do i = 1, n
        d (i) = tempa * (g(i)+hs(i)) - tempb * step (i)
    end do
    go to 170
120 dg = zero
    dhd = zero
    dhs = zero
    do i = 1, n
        dg = dg + d (i) * g (i)
        dhd = dhd + hd (i) * d (i)
        dhs = dhs + hd (i) * step (i)
    end do
    !
    !     Seek the value of the angle that minimizes Q.
    !
    cf = half * (shs-dhd)
    qbeg = sg + cf
    qsav = qbeg
    qmin = qbeg
    isave = 0
    iu = 49
    temp = twopi / real (iu+1, dp)
    do i = 1, iu
        angle = real (i, dp) * temp
        cth = cos (angle)
        sth = sin (angle)
        qnew = (sg+cf*cth) * cth + (dg+dhs*cth) * sth
        if (qnew < qmin) then
            qmin = qnew
            isave = i
            tempa = qsav
        else if (i == isave+1) then
            tempb = qnew
        end if
        qsav = qnew
    end do
    if (isave == zero) tempa = qnew
    if (isave == iu) tempb = qbeg
    angle = zero
    if (tempa /= tempb) then
        tempa = tempa - qmin
        tempb = tempb - qmin
        angle = half * (tempa-tempb) / (tempa+tempb)
    end if
    angle = temp * (real(isave, dp)+angle)
    !
    !     Calculate the new STEP and HS. Then test for convergence.
    !
    cth = cos (angle)
    sth = sin (angle)
    reduc = qbeg - (sg+cf*cth) * cth - (dg+dhs*cth) * sth
    gg = zero
    do i = 1, n
        step (i) = cth * step (i) + sth * d (i)
        hs (i) = cth * hs (i) + sth * hd (i)
        gg = gg + (g(i)+hs(i)) ** 2
    end do
    qred = qred + reduc
    ratio = reduc / qred
    if (iterc < itermax .and. ratio > 0.01_dp) go to 90
160 return
    !
    !     The following instructions act as a subroutine for setting the vector
    !     HD to the vector D multiplied by the second derivative matrix of Q.
    !     They are called from three different places, which are distinguished
    !     by the value of ITERC.
    !
170 do i = 1, n
        hd (i) = zero
    end do
    do k = 1, npt
        temp = zero
        do j = 1, n
            temp = temp + xpt (k, j) * d (j)
        end do
        temp = temp * pq (k)
        do i = 1, n
            hd (i) = hd (i) + temp * xpt (k, i)
        end do
    end do
    ih = 0
    do j = 1, n
        do i = 1, j
            ih = ih + 1
            if (i < j) hd (j) = hd (j) + hq (ih) * d (i)
            hd (i) = hd (i) + hq (ih) * d (j)
        end do
    end do
    if (iterc == 0) go to 20
    if (iterc <= itersw) go to 50
    go to 120
    end subroutine trsapp

    subroutine update_newuoa (n, npt, bmat, zmat, idz, ndim, vlag, beta, knew, w)
    real(dp) alpha , Beta , denom , one , scala , scalb , tau ,  &
        & tausq , temp , tempa , tempb , zero
    INTEGER i , Idz , iflag , j , ja , jb , jl , jp , Knew , N ,      &
        & Ndim , Npt , nptm
    real(dp) bmat (ndim,*), zmat (npt,*), vlag (*), w (*)
    !
    !     The arrays BMAT and ZMAT with IDZ are updated, in order to shift the
    !     interpolation point that has index KNEW. On entry, VLAG contains the
    !     components of the vector Theta*Wcheck+e_b of the updating formula
    !     (6.11), and BETA holds the value of the parameter that has this name.
    !     The vector W is used for working space.
    !
    !     Set some constants.
    !
    one = 1.0_dp
    zero = 0.0_dp
    nptm = npt - n - 1
    !
    !     Apply the rotations that put zeros in the KNEW-th row of ZMAT.
    !
    jl = 1
    do j = 2, nptm
        if (j == idz) then
            jl = idz
        else if (zmat(knew, j) /= zero) then
            temp = sqrt (zmat(knew, jl)**2+zmat(knew, j)**2)
            tempa = zmat (knew, jl) / temp
            tempb = zmat (knew, j) / temp
            do i = 1, npt
                temp = tempa * zmat (i, jl) + tempb * zmat (i, j)
                zmat (i, j) = tempa * zmat (i, j) - tempb * zmat (i, jl)
                zmat (i, jl) = temp
            end do
            zmat (knew, j) = zero
        end if
    end do
    !
    !     Put the first NPT components of the KNEW-th column of HLAG into W,
    !     and calculate the parameters of the updating formula.
    !
    tempa = zmat (knew, 1)
    if (idz >= 2) tempa = - tempa
    if (jl > 1) tempb = zmat (knew, jl)
    do i = 1, npt
        w (i) = tempa * zmat (i, 1)
        if (jl > 1) w (i) = w (i) + tempb * zmat (i, jl)
    end do
    alpha = w (knew)
    tau = vlag (knew)
    tausq = tau * tau
    denom = alpha * beta + tausq
    vlag (knew) = vlag (knew) - one
    !
    !     Complete the updating of ZMAT when there is only one nonzero element
    !     in the KNEW-th row of the new matrix ZMAT, but, if IFLAG is set to one,
    !     then the first column of ZMAT will be exchanged with another one later.
    !
    iflag = 0
    if (jl == 1) then
        temp = sqrt (abs(denom))
        tempb = tempa / temp
        tempa = tau / temp
        do i = 1, npt
            zmat (i, 1) = tempa * zmat (i, 1) - tempb * vlag (i)
        end do
        if (idz == 1 .and. temp < zero) idz = 2
        if (idz >= 2 .and. temp >= zero) iflag = 1
    else
        !
        !     Complete the updating of ZMAT in the alternative case.
        !
        ja = 1
        if (beta >= zero) ja = jl
        jb = jl + 1 - ja
        temp = zmat (knew, jb) / denom
        tempa = temp * beta
        tempb = temp * tau
        temp = zmat (knew, ja)
        scala = one / sqrt (abs(beta)*temp*temp+tausq)
        scalb = scala * sqrt (abs(denom))
        do i = 1, npt
            zmat (i, ja) = scala * (tau*zmat(i, ja)-temp*vlag(i))
            zmat (i, jb) = scalb * (zmat(i, jb)-tempa*w(i)-tempb*vlag(i))
        end do
        if (denom <= zero) then
            if (beta < zero) idz = idz + 1
            if (beta >= zero) iflag = 1
        end if
    end if
    !
    !     IDZ is reduced in the following case, and usually the first column
    !     of ZMAT is exchanged with a later one.
    !
    if (iflag == 1) then
        idz = idz - 1
        do i = 1, npt
            temp = zmat (i, 1)
            zmat (i, 1) = zmat (i, idz)
            zmat (i, idz) = temp
        end do
    end if
    !
    !     Finally, update the matrix BMAT.
    !
    do j = 1, n
        jp = npt + j
        w (jp) = bmat (knew, j)
        tempa = (alpha*vlag(jp)-tau*w(jp)) / denom
        tempb = (-beta*w(jp)-tau*vlag(jp)) / denom
        do i = 1, jp
            bmat (i, j) = bmat (i, j) + tempa * vlag (i) + tempb * w (i)
            if (i > npt) bmat (jp, i-npt) = bmat (i, j)
        end do
    end do

    end subroutine update_newuoa

    END MODULE Powell

    !Module to read in name/value pairs from a file, with each line of the form line 'name = value'
    !Should correctly interpret FITS headers
    !Antony Lewis (http://cosmologist.info/). Released to the public domain.
    !Apr 11, added support for INCLUDE(file); check for duplicate keys
    !Jun 12, added support for DEFAULT(file), provides default values for keys not defined in the read file

    module IniFile
    implicit none
    public

    integer, parameter :: Ini_max_name_len = 128

    integer, parameter :: Ini_max_string_len = 1024
    logical :: Ini_fail_on_not_found = .false.

    logical :: Ini_Echo_Read = .false.

    logical :: Ini_AllowDuplicateKeys = .false.

    type TNameValue
        !no known way to make character string pointers..
        character(Ini_max_name_len)  :: Name
        character(Ini_max_string_len):: Value
    end type TNameValue

    type TNameValue_pointer
        Type(TNameValue), pointer :: P
    end type TNameValue_pointer

    Type TNameValueList
        integer Count
        integer Delta
        integer Capacity
        logical ignoreDuplicates
        type(TNameValue_pointer), dimension(:), pointer :: Items
    end Type TNameValueList

    Type TIniFile
        logical SlashComments
        Type (TNameValueList) :: L, ReadValues
    end Type TIniFile

    Type(TIniFile) :: DefIni

    contains

    subroutine TNameValueList_Init(L, ignoreDuplicates)
    Type (TNameValueList) :: L
    logical, intent(in), optional :: ignoreDuplicates

    L%Count = 0
    L%Capacity = 0
    L%Delta = 128
    L%ignoreDuplicates = .false.
    if (present(ignoreDuplicates)) L%ignoreDuplicates=ignoreDuplicates
    nullify(L%Items)

    end subroutine TNameValueList_Init

    subroutine TNameValueList_Clear(L)
    Type (TNameValueList) :: L
    integer i, status

    do i=L%count,1,-1
        deallocate (L%Items(i)%P, stat = status)
    end do
    deallocate (L%Items, stat = status)
    call TNameValueList_Init(L)

    end subroutine TNameValueList_Clear

    subroutine TNameValueList_ValueOf(L, AName, AValue)
    Type (TNameValueList), intent(in) :: L
    character(LEN=*), intent(in) :: AName
    CHARACTER(LEN=*), intent(out) :: AValue
    integer i

    do i=1, L%Count
        if (L%Items(i)%P%Name == AName) then
            AValue = L%Items(i)%P%Value
            return
        end if
    end do
    AValue = ''

    end subroutine TNameValueList_ValueOf


    function TNameValueList_IndexOf(L, AName) result (AValue)
    Type (TNameValueList), intent(in) :: L
    character(LEN=*), intent(in) :: AName
    integer :: AValue
    integer i

    do i=1, L%Count
        if (L%Items(i)%P%Name == AName) then
            AValue = i
            return
        end if
    end do
    AValue = -1

    end function TNameValueList_IndexOf

    function TNameValueList_HasKey(L, AName) result (AValue)
    Type (TNameValueList), intent(in) :: L
    character(LEN=*), intent(in) :: AName
    logical :: AValue

    AValue = TNameValueList_IndexOf(L,AName) /= -1

    end function TNameValueList_HasKey

    subroutine TNameValueList_Add(L, AName, AValue, only_if_undefined)
    Type (TNameValueList) :: L
    character(LEN=*), intent(in) :: AName, AValue
    logical, optional, intent(in) :: only_if_undefined
    logical isDefault

    if (present(only_if_undefined)) then
        isDefault = only_if_undefined
    else
        isDefault = .true.
    end if
    if ((.not. Ini_AllowDuplicateKeys .or. isDefault) .and. TNameValueList_HasKey(L,AName)) then
        if (L%ignoreDuplicates .or. isDefault) return
        write (*,*) 'IniFile,TNameValueList_Add: duplicate key name in file: '//trim(AName)
        stop
    end if
    if (L%Count == L%Capacity) call TNameValueList_SetCapacity(L, L%Capacity + L%Delta)
    L%Count = L%Count + 1
    allocate(L%Items(L%Count)%P)
    L%Items(L%Count)%P%Name = AName
    L%Items(L%Count)%P%Value = AValue

    end subroutine TNameValueList_Add

    subroutine TNameValueList_SetCapacity(L, C)
    Type (TNameValueList) :: L
    integer C
    type(TNameValue_pointer), dimension(:), pointer :: TmpItems

    if (L%Count > 0) then
        if (C < L%Count) stop 'TNameValueList_SetCapacity: smaller than Count'
        allocate(TmpItems(L%Count))
        TmpItems = L%Items(1:L%Count)
        deallocate(L%Items)
        allocate(L%Items(C))
        L%Items(1:L%Count) = TmpItems
        deallocate(TmpItems)
    else
        allocate(L%Items(C))
    end if
    L%Capacity = C

    end subroutine TNameValueList_SetCapacity

    subroutine TNameValueList_Delete(L, i)
    Type (TNameValueList) :: L
    integer, intent(in) :: i

    deallocate(L%Items(i)%P)
    if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
    L%Count = L%Count -1

    end subroutine TNameValueList_Delete

    subroutine Ini_NameValue_Add(Ini,AInLine,only_if_undefined)
    Type(TIniFile) :: Ini
    character (LEN=*), intent(IN) :: AInLine
    integer EqPos, slashpos, lastpos
    logical, optional, intent(in) :: only_if_undefined
    logical isDefault
    character (LEN=len(AInLine)) :: AName, S, InLine

    if (present(only_if_undefined)) then
        isDefault = only_if_undefined
    else
        isDefault = .false.
    end if
    InLine=trim(adjustl(AInLine))
    EqPos = scan(InLine,'=')
    if (EqPos/=0 .and. InLine(1:1)/='#' .and. InLine(1:7) /= 'COMMENT' ) then

        AName = trim(InLine(1:EqPos-1))

        S = adjustl(InLine(EqPos+1:))
        if (Ini%SlashComments) then
            slashpos=scan(S,'/')
            if (slashpos /= 0) then
                S  = S(1:slashpos-1)
            end if
        end if
        lastpos=len_trim(S)
        if (lastpos>1) then
            if (S(1:1)=='''' .and. S(lastpos:lastpos)=='''') then
                S = S(2:lastpos-1)
            end if
        end if
        call TNameValueList_Add(Ini%L, AName, S,only_if_undefined = isDefault )

    end if

    end subroutine Ini_NameValue_Add

    subroutine Ini_Open(filename, unit_id,  error, slash_comments)
    character (LEN=*), intent(IN) :: filename
    integer, intent(IN) :: unit_id
    logical, optional, intent(OUT) :: error
    logical, optional, intent(IN) :: slash_comments
    logical aerror

    call TNameValueList_Init(DefIni%L)
    call TNameValueList_Init(DefIni%ReadValues, .true.)

    if (present(slash_comments)) then
        call Ini_Open_File(DefIni,filename,unit_id,aerror,slash_comments)
    else
        call Ini_Open_File(DefIni,filename,unit_id,aerror)
    end if

    if (present(error)) then
        error = aerror
    else
        if (aerror) then
            write (*,*) 'Ini_Open: Error opening file ' // trim(filename)
            stop
        end if
    end if

    end subroutine Ini_Open

    function Ini_ExtractFilePath(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=Ini_max_string_len) Ini_ExtractFilePath
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (aname(i:i)=='/') then
            Ini_ExtractFilePath = aname(1:i)
            return
        end if
    end do
    Ini_ExtractFilePath = ''

    end function Ini_ExtractFilePath

    recursive subroutine Ini_Open_File(Ini, filename, unit_id,  &
        error, slash_comments, append,only_if_undefined)
    Type(TIniFile) :: Ini

    character (LEN=*), intent(IN) :: filename
    integer, intent(IN) :: unit_id
    logical, intent(OUT) :: error
    logical, optional, intent(IN) :: slash_comments
    logical, optional, intent(in) :: append, only_if_undefined
    character (LEN=Ini_max_string_len) :: InLine, IncludeFile
    integer lastpos, i
    Type (TNameValueList) IncudeFiles, DefaultValueFiles
    logical doappend, FileExists, isDefault

    if (present(append)) then
        doappend=append
    else
        doappend=.false.
    end if

    if (present(only_if_undefined)) then
        isDefault = only_if_undefined
    else
        isDefault = .false.
    end if

    if (.not. doappend) then
        call TNameValueList_Init(Ini%L)
        call TNameValueList_Init(Ini%ReadValues, .true.)
    end if

    call TNameValueList_Init(IncudeFiles)
    call TNameValueList_Init(DefaultValueFiles)

    if (present(slash_comments)) then
        Ini%SlashComments = slash_comments
    else
        Ini%SlashComments = .false.
    end if

    open(unit=unit_id,file=filename,form='formatted',status='old', err=500)

    do
        read (unit_id,'(a)',end=400) InLine
        if (InLine == 'END') exit;
        if (InLine(1:8) == 'INCLUDE(') then
            lastpos = scan(InLine,')')
            if (lastpos/=0) then
                call TNameValueList_Add(IncudeFiles, trim(adjustl(InLine(9:lastpos-1))),'')
            else
                stop 'Ini_Open_File: error in INCLUDE line'
            end if
        elseif (InLine(1:8) == 'DEFAULT(') then
            !Settings to read in as defaults, overridden by subsequent re-definitions
            lastpos = scan(InLine,')')
            if (lastpos/=0) then
                call TNameValueList_Add(DefaultValueFiles, trim(adjustl(InLine(9:lastpos-1))),'')
            else
                stop 'Ini_Open_File: error in DEFAULT line'
            end if
        elseif (InLine /= '') then
            call Ini_NameValue_Add(Ini,InLine, only_if_undefined=isDefault)
        end if
    end do

400 close(unit_id)
    error=.false.

    do i=1, IncudeFiles%Count
        if (error) exit
        IncludeFile=IncudeFiles%Items(i)%P%Name
        inquire(file=IncludeFile, exist = FileExists)
        if (.not. FileExists) then
            IncludeFile=trim(Ini_ExtractFilePath(filename))//trim(IncludeFile)
            inquire(file=IncludeFile, exist = FileExists)
            if (.not. FileExists) then
                write(*,*) 'Ini_Open_File: INCLUDE file not found: '//trim(IncudeFiles%Items(i)%P%Name)
                stop
            end if
        end if
        call Ini_Open_File(Ini, IncludeFile, unit_id,  &
            error, slash_comments, append=.true.,only_if_undefined=isDefault)
    end do
    do i=1, DefaultValueFiles%Count
        if (error) exit
        IncludeFile=DefaultValueFiles%Items(i)%P%Name
        inquire(file=IncludeFile, exist = FileExists)
        if (.not. FileExists) then
            IncludeFile=trim(Ini_ExtractFilePath(filename))//trim(IncludeFile)
            inquire(file=IncludeFile, exist = FileExists)
            if (.not. FileExists) then
                write(*,*) 'Ini_Open_File: DEFAULT file not found:' //trim(DefaultValueFiles%Items(i)%P%Name)
                stop
            end if
        end if
        call Ini_Open_File(Ini, IncludeFile, unit_id,  &
            error, slash_comments, append=.true., only_if_undefined=.true.)
    end do

    call TNameValueList_Clear(IncudeFiles)
    call TNameValueList_Clear(DefaultValueFiles)

    return

500 error=.true.
    call TNameValueList_Clear(IncudeFiles)
    call TNameValueList_Clear(DefaultValueFiles)

    end subroutine Ini_Open_File

    subroutine Ini_Open_Fromlines(Ini, Lines, NumLines, slash_comments)
    Type(TIniFile) :: Ini

    integer, intent(IN) :: NumLines
    character (LEN=*), dimension(NumLines), intent(IN) :: Lines
    logical, intent(IN) :: slash_comments
    integer i

    call TNameValueList_Init(Ini%L)
    call TNameValueList_Init(Ini%ReadValues, .true.)

    Ini%SlashComments = slash_comments

    do i=1,NumLines
        call Ini_NameValue_Add(Ini,Lines(i))
    end do

    end  subroutine Ini_Open_Fromlines

    subroutine Ini_Close

    call Ini_close_File(DefIni)

    end subroutine Ini_Close


    subroutine Ini_Close_File(Ini)
    Type(TIniFile) :: Ini

    call TNameValueList_Clear(Ini%L)
    call TNameValueList_Clear(Ini%ReadValues)

    end  subroutine Ini_Close_File



    function Ini_Read_String(Key, NotFoundFail) result(AValue)
    character (LEN=*), intent(IN) :: Key
    logical, optional, intent(IN) :: NotFoundFail
    character(LEN=Ini_max_string_len) :: AValue

    if (present(NotFoundFail)) then
        AValue = Ini_Read_String_File(DefIni, Key, NotFoundFail)
    else
        AValue = Ini_Read_String_File(DefIni, Key)
    end if

    end function Ini_Read_String

    function Ini_Read_String_Default(Key, Default,AllowBlank) result(AValue)
    character (LEN=*), intent(IN) :: Key, Default
    character(LEN=Ini_max_string_len) :: AValue
    logical, intent(in), optional :: AllowBlank

    if (present(AllowBlank)) then
        AValue = Ini_Read_String_Default_File(DefIni, Key, Default, AllowBlank)
    else
        AValue = Ini_Read_String_Default_File(DefIni, Key, Default)
    end if

    end function Ini_Read_String_Default


    function Ini_Read_String_File(Ini, Key, NotFoundFail) result(AValue)
    Type(TIniFile) :: Ini
    character (LEN=*), intent(IN) :: Key
    logical, optional, intent(IN) :: NotFoundFail
    character(LEN=Ini_max_string_len) :: AValue

    call TNameValueList_ValueOf(Ini%L, Key, AValue)

    if (AValue/='') then

        call  TNameValueList_Add(Ini%ReadValues, Key, AValue)
        if (Ini_Echo_Read) write (*,*) trim(Key)//' = ',trim(AValue)
        return

    end if
    if (present(NotFoundFail)) then
        if (NotFoundFail) then
            write(*,*) 'key not found : '//trim(Key)
            stop
        end if
    else if (Ini_fail_on_not_found) then
        write(*,*) 'key not found : '//trim(Key)
        stop
    end if

    end function Ini_Read_String_File

    function Ini_Read_String_Default_File(Ini, Key, Default, AllowBlank) result(AValue)
    Type(TIniFile) :: Ini
    character (LEN=*), intent(IN) :: Key, Default
    character(LEN=Ini_max_string_len) :: AValue
    logical, intent(in), optional :: AllowBlank

    if (Ini_HasKey_File(Ini,Key)) then
        AValue = Ini_Read_String_file(Ini, Key, .false.)
        if (present(AllowBlank)) then
            if (AllowBlank) return
        end if
        if (AValue=='') AValue = Default
    else
        AValue = Default
    end if

    end function Ini_Read_String_Default_File

    function Ini_HasKey(Key) result(AValue)
    character (LEN=*), intent(IN) :: Key
    logical AValue

    AValue = Ini_HasKey_File(DefIni, Key)

    end function Ini_HasKey

    function Ini_HasKey_File(Ini, Key) result(AValue)
    type(TIniFile), intent(in) :: Ini
    character (LEN=*), intent(IN) :: Key
    logical AValue

    Avalue = TNameValueList_HasKey(Ini%L, Key)

    end function Ini_HasKey_File

    function Ini_Key_To_Arraykey(Key, index)  result(AValue)
    character (LEN=*), intent(IN) :: Key
    integer, intent(in) :: index
    character(LEN=Ini_max_string_len) :: AValue

    character(LEN=32) :: numstr
    write (numstr,*) index
    numstr=adjustl(numstr)
    AValue = trim(Key) // '(' // trim(numStr) // ')'

    end function Ini_Key_To_Arraykey

    function Ini_Read_String_Array(Key, index, NotFoundFail) result(AValue)
    character (LEN=*), intent(IN) :: Key
    integer, intent(in) :: index
    logical, optional, intent(IN) :: NotFoundFail
    character(LEN=Ini_max_string_len) :: AValue

    if (present(NotFoundFail)) then
        AValue = Ini_Read_String_Array_File(DefIni, Key, index, NotFoundFail)
    else
        AValue = Ini_Read_String_Array_File(DefIni, Key, index)
    end if

    end function Ini_Read_String_Array

    function Ini_Read_String_Array_File(Ini, Key, index, NotFoundFail) result(AValue)
    Type(TIniFile) :: Ini
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    logical, optional, intent(IN) :: NotFoundFail
    character(LEN=Ini_max_string_len) :: AValue
    character(LEN=Ini_max_string_len) :: ArrayKey

    ArrayKey = Ini_Key_To_Arraykey(Key,index)
    if (present(NotFoundFail)) then
        AValue = Ini_Read_String_File(Ini, ArrayKey, NotFoundFail)
    else
        AValue = Ini_Read_String_File(Ini, ArrayKey)
    end if

    end function Ini_Read_String_Array_File

    function Ini_Read_Int_Array(Key, index, Default)
    integer, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    integer Ini_Read_Int_Array

    if (present(Default)) then
        Ini_Read_Int_Array = Ini_Read_Int_Array_File(DefIni, Key, index, Default)
    else
        Ini_Read_Int_Array = Ini_Read_Int_Array_File(DefIni, Key, index)
    end if

    end function Ini_Read_Int_Array

    function Ini_Read_Int_Array_File(Ini,Key, index, Default)
    !Reads Key(1), Key(2), etc.
    Type(TIniFile) :: Ini
    integer Ini_Read_Int_Array_File
    integer, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) :: ArrrayKey
    ArrrayKey = Ini_Key_To_Arraykey(Key,index)
    if (present(Default)) then
        Ini_Read_Int_Array_File = Ini_Read_Int_File(Ini, ArrrayKey, Default)
    else
        Ini_Read_Int_Array_File = Ini_Read_Int_File(Ini, ArrrayKey)
    end if
    end function Ini_Read_Int_Array_File


    function Ini_Read_Int(Key, Default)
    integer, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    integer Ini_Read_Int

    if (present(Default)) then
        Ini_Read_Int = Ini_Read_Int_File(DefIni, Key, Default)
    else
        Ini_Read_Int = Ini_Read_Int_File(DefIni, Key)
    end if
    end function Ini_Read_Int

    function Ini_Read_Int_File(Ini, Key, Default)
    Type(TIniFile) :: Ini
    integer Ini_Read_Int_File
    integer, optional, intent(IN) :: Default
    character  (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) :: S

    S = Ini_Read_String_File(Ini, Key,.not. present(Default))
    if (S == '') then
        if (.not. present(Default)) then
            write(*,*) 'no value for key: '//Key
            stop
        end if
        Ini_Read_Int_File = Default
        write (S,*) Default
        call  TNameValueList_Add(Ini%ReadValues, Key, S)
    else
        if (verify(trim(S),'-+0123456789') /= 0) goto 10
        read (S,*, err = 10) Ini_Read_Int_File
    end if
    return
10  write (*,*) 'error reading integer for key: '//Key
    stop

    end function Ini_Read_Int_File

    function Ini_Read_Double(Key, Default)
    double precision, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    double precision Ini_Read_Double

    if (present(Default)) then
        Ini_Read_Double = Ini_Read_Double_File(DefIni, Key, Default)
    else
        Ini_Read_Double = Ini_Read_Double_File(DefIni, Key)
    end if

    end function Ini_Read_Double

    function Ini_Read_Double_File(Ini,Key, Default)
    Type(TIniFile) :: Ini
    double precision Ini_Read_Double_File
    double precision, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) :: S

    S = Ini_Read_String_File(Ini,Key,.not. present(Default))
    if (S == '') then
        if (.not. present(Default)) then
            write(*,*) 'no value for key: '//Key
            stop
        end if
        Ini_Read_Double_File = Default
        write (S,*) Default

        call  TNameValueList_Add(Ini%ReadValues, Key, S)

    else
        read (S,*, err=10) Ini_Read_Double_File
    end if

    return

10  write (*,*) 'error reading double for key: '//Key
    stop

    end function Ini_Read_Double_File



    function Ini_Read_Double_Array(Key, index, Default)
    double precision, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    double precision Ini_Read_Double_Array

    if (present(Default)) then
        Ini_Read_Double_Array = Ini_Read_Double_Array_File(DefIni, Key, index, Default)
    else
        Ini_Read_Double_Array = Ini_Read_Double_Array_File(DefIni, Key, index)
    end if

    end function Ini_Read_Double_Array


    function Ini_Read_Double_Array_File(Ini,Key, index, Default)

    !Reads Key(1), Key(2), etc.

    Type(TIniFile) :: Ini

    double precision Ini_Read_Double_Array_File
    double precision, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) ::  ArrrayKey

    ArrrayKey = Ini_Key_To_Arraykey(Key,index)
    if (present(Default)) then

        Ini_Read_Double_Array_File = Ini_Read_Double_File(Ini, ArrrayKey, Default)
    else
        Ini_Read_Double_Array_File = Ini_Read_Double_File(Ini, ArrrayKey)
    end if
    end function Ini_Read_Double_Array_File

    function Ini_Read_Real(Key, Default)
    real, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    real Ini_Read_Real

    if (present(Default)) then
        Ini_Read_Real = Ini_Read_Real_File(DefIni, Key, Default)
    else
        Ini_Read_Real = Ini_Read_Real_File(DefIni, Key)
    end if

    end function Ini_Read_Real

    function Ini_Read_Real_File(Ini,Key, Default)
    Type(TIniFile) :: Ini
    real Ini_Read_Real_File
    real, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) :: S

    S = Ini_Read_String_File(Ini,Key,.not. present(Default))
    if (S == '') then
        if (.not. present(Default)) then
            write(*,*) 'no value for key: '//Key
            stop
        end if
        Ini_Read_Real_File = Default
        write (S,*) Default
        call  TNameValueList_Add(Ini%ReadValues, Key, S)

    else
        read (S,*, err=10) Ini_Read_Real_File
    end if

    return

10  write (*,*) 'error reading double for key: '//Key
    stop

    end function Ini_Read_Real_File



    function Ini_Read_Real_Array(Key, index, Default)
    real, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    real Ini_Read_Real_Array

    if (present(Default)) then
        Ini_Read_Real_Array = Ini_Read_Real_Array_File(DefIni, Key, index, Default)
    else
        Ini_Read_Real_Array = Ini_Read_Real_Array_File(DefIni, Key, index)
    end if
    end function Ini_Read_Real_Array

    function Ini_Read_Real_Array_File(Ini,Key, index, Default)
    !Reads Key(1), Key(2), etc.
    Type(TIniFile) :: Ini
    real Ini_Read_Real_Array_File
    real, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    character(LEN=Ini_max_string_len) :: ArrrayKey

    ArrrayKey = Ini_Key_To_Arraykey(Key,index)
    if (present(Default)) then
        Ini_Read_Real_Array_File = Ini_Read_Real_File(Ini, ArrrayKey, Default)
    else
        Ini_Read_Real_Array_File = Ini_Read_Real_File(Ini, ArrrayKey)
    end if
    end function Ini_Read_Real_Array_File

    function Ini_Read_Logical(Key, Default)
    Logical, optional, intent(IN) :: Default
    character (LEN=*), intent(IN) :: Key
    logical Ini_Read_Logical

    if (present(Default)) then
        Ini_Read_Logical = Ini_Read_Logical_File(DefIni, Key, Default)
    else
        Ini_Read_Logical = Ini_Read_Logical_File(DefIni, Key)
    end if
    end function Ini_Read_Logical

    function Ini_Read_Logical_File(Ini, Key, Default)
    Type(TIniFile) :: Ini

    logical Ini_Read_Logical_File
    logical, optional, intent(IN) :: Default
    character  (LEN=*), intent(IN) :: Key

    character(LEN=Ini_max_string_len) :: S

    S = Ini_Read_String_File(Ini,Key,.not. present(Default))
    if (S == '') then
        if (.not. present(Default)) then
            write(*,*) 'no value for key: '//Key
            stop
        end if
        Ini_Read_Logical_File = Default
        write (S,*) Default

        call  TNameValueList_Add(Ini%ReadValues, Key, S)

    else

        if (verify(trim(S),'10TF') /= 0) goto 10
        read (S,*, err = 10) Ini_Read_Logical_File
    end if

    return

10  write (*,*) 'error reading logical for key: '//Key
    stop
    end function Ini_Read_Logical_File



    subroutine Ini_SaveReadValues(afile,unit_id)
    character(LEN=*)  :: afile
    integer, intent(in) :: unit_id

    call Ini_SaveReadValues_File(DefIni, afile, unit_id)

    end subroutine Ini_SaveReadValues



    subroutine Ini_SaveReadValues_File(Ini, afile, unit_id)
    Type(TIniFile) :: Ini
    character(LEN=*), intent(in) :: afile
    integer, intent(in) :: unit_id
    integer i

    open(unit=unit_id,file=afile,form='formatted',status='replace', err=500)

    do i=1, Ini%ReadValues%Count

        write (unit_id,'(a)') trim(Ini%ReadValues%Items(i)%P%Name) // ' = ' &
            //trim(Ini%ReadValues%Items(i)%P%Value)

    end do

    close(unit_id)
    return

500 write(*,*) 'Ini_SaveReadValues_File: Error creating '//trim(afile)

    end subroutine Ini_SaveReadValues_File

    end module IniFile

    module ArrayUtils
    use MiscUtils
    use MpiUtils
    implicit none

    INTERFACE Reallocate
    module procedure Realloc_R, Realloc_D, Realloc_I
    END INTERFACE Reallocate

    contains

    subroutine realloc_R(arr, new_size, keep)
    real, allocatable, intent(inout) :: arr(:)
    integer, intent(in) :: new_size
    logical, intent(in), optional :: keep
    integer sz
    real, allocatable :: tmp(:)

    if (.not. allocated(arr)) then
        allocate(arr(new_size))
        return
    end if
    if (LBOUND(arr,1)/=1) call MpiStop('Realloc only works on arrays starting at 1')
    if (new_size/=size(arr)) then
        allocate(tmp(new_size))
        if (DefaultTrue(keep)) then
            sz = min(new_size, size(arr))
            tmp(:sz) = arr(:sz)
        end if
        call move_alloc(tmp, arr)
    end if

    end subroutine realloc_R

    subroutine realloc_D(arr, new_size, keep)
    double precision, allocatable, intent(inout) :: arr(:)
    integer, intent(in) :: new_size
    logical, intent(in), optional :: keep
    integer sz
    double precision, allocatable :: tmp(:)

    if (.not. allocated(arr)) then
        allocate(arr(new_size))
        return
    end if
    if (LBOUND(arr,1)/=1) call MpiStop('Realloc only works on arrays starting at 1')
    if (new_size/=size(arr)) then
        allocate(tmp(new_size))
        if (DefaultTrue(keep)) then
            sz = min(new_size, size(arr))
            tmp(:sz) = arr(:sz)
        end if
        call move_alloc(tmp, arr)
    end if

    end subroutine realloc_D

    subroutine realloc_I(arr, new_size, keep)
    integer, allocatable, intent(inout) :: arr(:)
    integer, intent(in) :: new_size
    logical, intent(in), optional :: keep
    integer sz
    integer, allocatable :: tmp(:)

    if (.not. allocated(arr)) then
        allocate(arr(new_size))
        return
    end if
    if (LBOUND(arr,1)/=1) call MpiStop('Realloc only works on arrays starting at 1')
    if (new_size/=size(arr)) then
        allocate(tmp(new_size))
        if (DefaultTrue(keep)) then
            sz = min(new_size, size(arr))
            tmp(:sz) = arr(:sz)
        end if
        call move_alloc(tmp, arr)
    end if

    end subroutine realloc_I

    function IndexOf(aval,arr, n)
    integer, intent(in) :: n, arr(n), aval
    integer IndexOf, i

    do i=1,n
        if (arr(i)==aval) then
            IndexOf= i
            return
        end if
    end do
    IndexOf = 0

    end function IndexOf

    function MaxIndex(arr, n)
    integer, intent(in) :: n
    real, intent(in) :: arr(n)
    integer locs(1:1), MaxIndex

    locs = maxloc(arr(1:n))
    MaxIndex = locs(1)

    end function MaxIndex


    function MinIndex(arr, n)
    integer, intent(in) :: n
    real, intent(in) :: arr(n)
    integer locs(1:1), MinIndex

    locs = minloc(arr(1:n))
    MinIndex = locs(1)

    end function MinIndex

    end module ArrayUtils

    module DarkEnergyFluid
    use DarkEnergyInterface
    use results
    use constants
    use classes
    implicit none

    type, extends(TDarkEnergyEqnOfState) :: TDarkEnergyFluid
        !comoving sound speed is always exactly 1 for quintessence
        !(otherwise assumed constant, though this is almost certainly unrealistic)
    contains
    procedure :: ReadParams => TDarkEnergyFluid_ReadParams
    procedure, nopass :: PythonClass => TDarkEnergyFluid_PythonClass
    procedure, nopass :: SelfPointer => TDarkEnergyFluid_SelfPointer
    procedure :: Init =>TDarkEnergyFluid_Init
    procedure :: PerturbedStressEnergy => TDarkEnergyFluid_PerturbedStressEnergy
    procedure :: PerturbationEvolve => TDarkEnergyFluid_PerturbationEvolve
    end type TDarkEnergyFluid

    !Example implementation of fluid model using specific analytic form
    !(approximate effective axion fluid model from arXiv:1806.10608, with c_s^2=1 if n=infinity (w_n=1))
    !This is an example, it's not supposed to be a rigorous model!  (not very well tested)
    type, extends(TDarkEnergyModel) :: TAxionEffectiveFluid
        real(dl) :: w_n = 1._dl !Effective equation of state when oscillating
        real(dl) :: fde_zc = 0._dl ! energy density fraction at a_c (not the same as peak dark energy fraction)
        real(dl) :: zc  !transition redshift (scale factor a_c)
        real(dl) :: theta_i = const_pi/2 !Initial value
        !om is Omega of the early DE component today (assumed to be negligible compared to omega_lambda)
        !omL is the lambda component of the total dark energy omega
        real(dl), private :: a_c, pow, om, omL, acpow, freq, n !cached internally
    contains
    procedure :: ReadParams =>  TAxionEffectiveFluid_ReadParams
    procedure, nopass :: PythonClass => TAxionEffectiveFluid_PythonClass
    procedure, nopass :: SelfPointer => TAxionEffectiveFluid_SelfPointer
    procedure :: Init => TAxionEffectiveFluid_Init
    procedure :: w_de => TAxionEffectiveFluid_w_de
    procedure :: grho_de => TAxionEffectiveFluid_grho_de
    procedure :: PerturbedStressEnergy => TAxionEffectiveFluid_PerturbedStressEnergy
    procedure :: PerturbationEvolve => TAxionEffectiveFluid_PerturbationEvolve
    end type TAxionEffectiveFluid

    contains


    subroutine TDarkEnergyFluid_ReadParams(this, Ini)
    use IniObjects
    class(TDarkEnergyFluid) :: this
    class(TIniFile), intent(in) :: Ini

    call this%TDarkEnergyEqnOfState%ReadParams(Ini)
    this%cs2_lam = Ini%Read_Double('cs2_lam', 1.d0)

    end subroutine TDarkEnergyFluid_ReadParams


    function TDarkEnergyFluid_PythonClass()
    character(LEN=:), allocatable :: TDarkEnergyFluid_PythonClass

    TDarkEnergyFluid_PythonClass = 'DarkEnergyFluid'

    end function TDarkEnergyFluid_PythonClass

    subroutine TDarkEnergyFluid_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TDarkEnergyFluid), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TDarkEnergyFluid_SelfPointer

    subroutine TDarkEnergyFluid_Init(this, State)
    use classes
    class(TDarkEnergyFluid), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State

    call this%TDarkEnergyEqnOfState%Init(State)

    if (this%is_cosmological_constant) then
        this%num_perturb_equations = 0
    else
        if (this%use_tabulated_w) then
            if (any(this%equation_of_state%F<-1) .and. any(this%equation_of_state%F>-1)) &
                error stop 'Fluid dark energy model does not allow w crossing -1'
        elseif (this%wa/=0 .and. &
            ((1+this%w_lam < -1.e-6_dl) .or. 1+this%w_lam + this%wa < -1.e-6_dl)) then
            error stop 'Fluid dark energy model does not allow w crossing -1'
        end if
        this%num_perturb_equations = 2
    end if

    end subroutine TDarkEnergyFluid_Init


    subroutine TDarkEnergyFluid_PerturbedStressEnergy(this, dgrhoe, dgqe, &
        a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1, ay, ayprime, w_ix)
    class(TDarkEnergyFluid), intent(inout) :: this
    real(dl), intent(out) :: dgrhoe, dgqe
    real(dl), intent(in) ::  a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1
    real(dl), intent(in) :: ay(*)
    real(dl), intent(inout) :: ayprime(*)
    integer, intent(in) :: w_ix

    if (this%no_perturbations) then
        dgrhoe=0
        dgqe=0
    else
        dgrhoe = ay(w_ix) * grhov_t
        dgqe = ay(w_ix + 1) * grhov_t * (1 + w)
    end if
    end subroutine TDarkEnergyFluid_PerturbedStressEnergy


    subroutine TDarkEnergyFluid_PerturbationEvolve(this, ayprime, w, w_ix, &
        a, adotoa, k, z, y)
    class(TDarkEnergyFluid), intent(in) :: this
    real(dl), intent(inout) :: ayprime(:)
    real(dl), intent(in) :: a, adotoa, w, k, z, y(:)
    integer, intent(in) :: w_ix
    real(dl) Hv3_over_k, loga

    Hv3_over_k =  3*adotoa* y(w_ix + 1) / k
    !density perturbation
    ayprime(w_ix) = -3 * adotoa * (this%cs2_lam - w) *  (y(w_ix) + (1 + w) * Hv3_over_k) &
        -  (1 + w) * k * y(w_ix + 1) - (1 + w) * k * z
    if (this%use_tabulated_w) then
        !account for derivatives of w
        loga = log(a)
        if (loga > this%equation_of_state%Xmin_interp .and. loga < this%equation_of_state%Xmax_interp) then
            ayprime(w_ix) = ayprime(w_ix) - adotoa*this%equation_of_state%Derivative(loga)* Hv3_over_k
        end if
    elseif (this%wa/=0) then
        ayprime(w_ix) = ayprime(w_ix) + Hv3_over_k*this%wa*adotoa*a
    end if
    !velocity
    if (abs(w+1) > 1e-6) then
        ayprime(w_ix + 1) = -adotoa * (1 - 3 * this%cs2_lam) * y(w_ix + 1) + &
            k * this%cs2_lam * y(w_ix) / (1 + w)
    else
        ayprime(w_ix + 1) = 0
    end if

    end subroutine TDarkEnergyFluid_PerturbationEvolve



    subroutine TAxionEffectiveFluid_ReadParams(this, Ini)
    use IniObjects
    class(TAxionEffectiveFluid) :: this
    class(TIniFile), intent(in) :: Ini

    call this%TDarkEnergyModel%ReadParams(Ini)
    if (Ini%HasKey('AxionEffectiveFluid_a_c')) then
        error stop 'AxionEffectiveFluid inputs changed to AxionEffectiveFluid_fde_zc and AxionEffectiveFluid_zc'
    end if
    this%w_n  = Ini%Read_Double('AxionEffectiveFluid_w_n')
    this%fde_zc  = Ini%Read_Double('AxionEffectiveFluid_fde_zc')
    this%zc  = Ini%Read_Double('AxionEffectiveFluid_zc')
    call Ini%Read('AxionEffectiveFluid_theta_i', this%theta_i)

    end subroutine TAxionEffectiveFluid_ReadParams


    function TAxionEffectiveFluid_PythonClass()
    character(LEN=:), allocatable :: TAxionEffectiveFluid_PythonClass

    TAxionEffectiveFluid_PythonClass = 'AxionEffectiveFluid'
    end function TAxionEffectiveFluid_PythonClass

    subroutine TAxionEffectiveFluid_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TAxionEffectiveFluid), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TAxionEffectiveFluid_SelfPointer

    subroutine TAxionEffectiveFluid_Init(this, State)
    use classes
    class(TAxionEffectiveFluid), intent(inout) :: this
    class(TCAMBdata), intent(in), target :: State
    real(dl) :: grho_rad, F, p, mu, xc, n

    select type(State)
    class is (CAMBdata)
        this%is_cosmological_constant = this%fde_zc==0
        this%pow = 3*(1+this%w_n)
        this%a_c = 1/(1+this%zc)
        this%acpow = this%a_c**this%pow
        !Omega in early de at z=0
        this%om = 2*this%fde_zc/(1-this%fde_zc)*&
            (State%grho_no_de(this%a_c)/this%a_c**4/State%grhocrit + State%Omega_de)/(1 + 1/this%acpow)
        this%omL = State%Omega_de - this%om !Omega_de is total dark energy density today
        this%num_perturb_equations = 2
        if (this%w_n < 0.9999) then
            ! n <> infinity
            !get (very) approximate result for sound speed parameter; arXiv:1806.10608  Eq 30 (but mu may not exactly agree with what they used)
            n = nint((1+this%w_n)/(1-this%w_n))
            !Assume radiation domination, standard neutrino model; H0 factors cancel
            grho_rad = (kappa/c**2*4*sigma_boltz/c**3*State%CP%tcmb**4*Mpc**2*(1+default_nnu*7._dl/8*(4._dl/11)**(4._dl/3)))
            xc = this%a_c**2/2/sqrt(grho_rad/3)
            F=7./8
            p=1./2
            mu = 1/xc*(1-cos(this%theta_i))**((1-n)/2.)*sqrt((1-F)*(6*p+2)*this%theta_i/n/sin(this%theta_i))
            this%freq =  mu*(1-cos(this%theta_i))**((n-1)/2.)* &
                sqrt(const_pi)*Gamma((n+1)/(2.*n))/Gamma(1+0.5/n)*2.**(-(n**2+1)/(2.*n))*3.**((1./n-1)/2)*this%a_c**(-6./(n+1)+3) &
                *( this%a_c**(6*n/(n+1.))+1)**(0.5*(1./n-1))
            this%n = n
        end if
    end select

    end subroutine TAxionEffectiveFluid_Init


    function TAxionEffectiveFluid_w_de(this, a)
    class(TAxionEffectiveFluid) :: this
    real(dl) :: TAxionEffectiveFluid_w_de
    real(dl), intent(IN) :: a
    real(dl) :: rho, apow, acpow

    apow = a**this%pow
    acpow = this%acpow
    rho = this%omL+ this%om*(1+acpow)/(apow+acpow)
    TAxionEffectiveFluid_w_de = this%om*(1+acpow)/(apow+acpow)**2*(1+this%w_n)*apow/rho - 1

    end function TAxionEffectiveFluid_w_de

    function TAxionEffectiveFluid_grho_de(this, a)  !relative density (8 pi G a^4 rho_de /grhov)
    class(TAxionEffectiveFluid) :: this
    real(dl) :: TAxionEffectiveFluid_grho_de, apow
    real(dl), intent(IN) :: a

    if(a == 0.d0)then
        TAxionEffectiveFluid_grho_de = 0.d0
    else
        apow = a**this%pow
        TAxionEffectiveFluid_grho_de = (this%omL*(apow+this%acpow)+this%om*(1+this%acpow))*a**4 &
            /((apow+this%acpow)*(this%omL+this%om))
    endif

    end function TAxionEffectiveFluid_grho_de

    subroutine TAxionEffectiveFluid_PerturbationEvolve(this, ayprime, w, w_ix, &
        a, adotoa, k, z, y)
    class(TAxionEffectiveFluid), intent(in) :: this
    real(dl), intent(inout) :: ayprime(:)
    real(dl), intent(in) :: a, adotoa, w, k, z, y(:)
    integer, intent(in) :: w_ix
    real(dl) Hv3_over_k, deriv, apow, acpow, cs2, fac

    if (this%w_n < 0.9999) then
        fac = 2*a**(2-6*this%w_n)*this%freq**2
        cs2 = (fac*(this%n-1) + k**2)/(fac*(this%n+1) + k**2)
    else
        cs2 = 1
    end if
    apow = a**this%pow
    acpow = this%acpow
    Hv3_over_k =  3*adotoa* y(w_ix + 1) / k
    ! dw/dlog a/(1+w)
    deriv  = (acpow**2*(this%om+this%omL)+this%om*acpow-apow**2*this%omL)*this%pow &
        /((apow+acpow)*(this%omL*(apow+acpow)+this%om*(1+acpow)))
    !density perturbation
    ayprime(w_ix) = -3 * adotoa * (cs2 - w) *  (y(w_ix) + Hv3_over_k) &
        -   k * y(w_ix + 1) - (1 + w) * k * z  - adotoa*deriv* Hv3_over_k
    !(1+w)v
    ayprime(w_ix + 1) = -adotoa * (1 - 3 * cs2 - deriv) * y(w_ix + 1) + &
        k * cs2 * y(w_ix)

    end subroutine TAxionEffectiveFluid_PerturbationEvolve


    subroutine TAxionEffectiveFluid_PerturbedStressEnergy(this, dgrhoe, dgqe, &
        a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1, ay, ayprime, w_ix)
    class(TAxionEffectiveFluid), intent(inout) :: this
    real(dl), intent(out) :: dgrhoe, dgqe
    real(dl), intent(in) :: a, dgq, dgrho, grho, grhov_t, w, gpres_noDE, etak, adotoa, k, kf1
    real(dl), intent(in) :: ay(*)
    real(dl), intent(inout) :: ayprime(*)
    integer, intent(in) :: w_ix

    dgrhoe = ay(w_ix) * grhov_t
    dgqe = ay(w_ix + 1) * grhov_t

    end subroutine TAxionEffectiveFluid_PerturbedStressEnergy

    end module DarkEnergyFluid

    module ArrayTests
    use ArrayUtils
    implicit none
    contains


    function RunArrayTests() result (fails)
    integer fails
    character(LEN=:), allocatable :: S, S2
    real, allocatable :: arr(:)
    integer, allocatable :: arrI(:)

    fails = 0

    allocate(arr(3), source = [1.,2.,3.])
    call reallocate(arr,2)
    call reallocate(arr,5)
    call reallocate(arrI,5)
    arrI(3)=4
    call reallocate(arrI,8)
    if (arr(2)/=2. .or. arrI(3)/=4) then
        fails = fails+1
        print *, 'Error in realloc'
    end if
    call reallocate(arrI,0)
    if (fails==0) print *, 'OK array tests'


    end function

    end module

    ! Modules used by cmbmain and other routines.

    !     Code for Anisotropies in the Microwave Background
    !     by Antony Lewis (http://cosmologist.info) and Anthony Challinor
    !     See readme.html for documentation.
    !
    !     Based on CMBFAST  by  Uros Seljak and Matias Zaldarriaga, itself based
    !     on Boltzmann code written by Edmund Bertschinger, Chung-Pei Ma and Paul Bode.
    !     Original CMBFAST copyright and disclaimer:
    !
    !     Copyright 1996 by Harvard-Smithsonian Center for Astrophysics and
    !     the Massachusetts Institute of Technology.  All rights reserved.
    !
    !     THIS SOFTWARE IS PROVIDED "AS IS", AND M.I.T. OR C.f.A. MAKE NO
    !     REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
    !     By way of example, but not limitation,
    !     M.I.T. AND C.f.A MAKE NO REPRESENTATIONS OR WARRANTIES OF
    !     MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT
    !     THE USE OF THE LICENSED SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE
    !     ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.
    !
    !     portions of this software are based on the COSMICS package of
    !     E. Bertschinger.  See the LICENSE file of the COSMICS distribution
    !     for restrictions on the modification and distribution of this software.

    module results
    use constants, only : const_pi, const_twopi
    use MiscUtils
    use RangeUtils
    use StringUtils
    use MathUtils
    use config
    use model
    use splines
    implicit none
    public

    Type TBackgroundOutputs
        real(dl), allocatable :: H(:), DA(:), rs_by_D_v(:)
    end Type TBackgroundOutputs

    integer, parameter :: derived_age=1, derived_zstar=2, derived_rstar=3, derived_thetastar=4, derived_DAstar = 5, &
        derived_zdrag=6, derived_rdrag=7,derived_kD=8,derived_thetaD=9, derived_zEQ =10, derived_keq =11, &
        derived_thetaEQ=12, derived_theta_rs_EQ = 13
    integer, parameter :: nthermo_derived = 13

    Type lSamples
        integer :: nl = 0
        integer :: lmin = 2
        integer, allocatable :: l(:)
        logical :: use_spline_template = .true.
    contains
    procedure :: Init => lSamples_init
    procedure :: IndexOf => lSamples_indexOf
    procedure :: InterpolateClArr
    procedure :: InterpolateClArrTemplated
    end Type lSamples

    logical, parameter :: dowinlens = .false. !not used, test getting CMB lensing using visibility
    integer, parameter :: thermal_history_def_timesteps = 20000

    Type TThermoData
        logical :: HasThermoData = .false. !Has it been computed yet for current parameters?
        !Background thermal history, interpolated from precomputed tables
        integer :: nthermo !Number of table steps
        !baryon temperature, sound speed, ionization fractions, and opacity
        real(dl), dimension(:), allocatable :: tb, cs2, xe, dotmu
        ! e^(-tau) and derivatives
        real(dl), dimension(:), allocatable :: emmu, dcs2,demmu, ddotmu, dddotmu, ddddotmu
        real(dl), dimension(:), allocatable :: ScaleFactor, dScaleFactor, adot, dadot
        real(dl), dimension(:), allocatable :: winlens, dwinlens
        real(dl) tauminn,dlntau
        real(dl) :: tight_tau, actual_opt_depth
        !Times when 1/(opacity*tau) = 0.01, for use switching tight coupling approximation
        real(dl) :: matter_verydom_tau
        real(dl) :: recombination_saha_tau
        !sound horizon and recombination redshifts
        real(dl) :: r_drag0, z_star, z_drag  !!JH for updated BAO likelihood.
        real(dl), dimension(:), allocatable :: step_redshift, rhos_fac, drhos_fac
        real(dl) :: tau_start_redshiftwindows,tau_end_redshiftwindows
        logical :: has_lensing_windows = .false.
        real(dl) recombination_Tgas_tau
        Type(TCubicSpline) :: ScaleFactorAtTime
        !Mapping between redshift and time
        real(dl), private,dimension(:), allocatable :: redshift_time, dredshift_time
        real(dl), private, dimension(:), allocatable :: arhos_fac, darhos_fac, ddarhos_fac
    contains
    procedure :: Init => Thermo_Init
    procedure :: OpacityToTime => Thermo_OpacityToTime
    procedure :: values => Thermo_values
    procedure :: expansion_values => Thermo_expansion_values
    procedure :: IonizationFunctionsAtTime
    procedure, private :: DoWindowSpline
    procedure, private :: SetTimeSteps
    procedure, private :: SetTimeStepWindows
    end type TThermoData

    !Sources
    Type CalWins
        real(dl), allocatable :: awin_lens(:), dawin_lens(:)
    end Type CalWins

    Type LimberRec
        integer n1,n2 !corresponding time step array indices
        real(dl), dimension(:), allocatable :: k
        real(dl), dimension(:), allocatable :: Source
    end Type LimberRec

    Type ClTransferData
        !Cl transfer function variables
        !values of q for integration over q to get C_ls
        Type (lSamples) :: ls ! l that are computed
        integer :: NumSources
        !Changes -scalars:  2 for just CMB, 3 for lensing
        !- tensors: T and E and phi (for lensing), and T, E, B respectively

        type (TRanges) :: q
        real(dl), dimension(:,:,:), allocatable :: Delta_p_l_k

        !The L index of the lowest L to use for Limber
        integer, dimension(:), allocatable :: Limber_l_min
        !For each l, the set of k in each limber window
        !indices LimberWindow(SourceNum,l)
        Type(LimberRec), dimension(:,:), allocatable :: Limber_windows

        !The maximum L needed for non-Limber
        integer max_index_nonlimber

    end Type ClTransferData

    type TCLdata
        Type(ClTransferData) :: CTransScal, CTransTens, CTransVec

        real(dl), dimension (:,:), allocatable :: Cl_scalar, Cl_tensor, Cl_vector
        !Indices are Cl_xxx( l , Cl_type)
        !where Cl_type is one of the above constants

        real(dl), dimension (:,:,:), allocatable :: Cl_Scalar_Array
        !Indices are Cl_xxx( l , field1,field2)
        !where ordering of fields is T, E, \psi (CMB lensing potential), window_1, window_2...

        !The following are set only if doing lensing
        integer lmax_lensed !Only accurate to rather less than this
        real(dl) , dimension (:,:), allocatable :: Cl_lensed
        !Cl_lensed(l, Cl_type) are the interpolated Cls
    contains
    procedure :: InitCls => TCLdata_InitCls
    procedure :: output_cl_files => TCLdata_output_cl_files
    procedure :: output_lens_pot_files => TCLdata_output_lens_pot_files
    procedure :: NormalizeClsAtL => TCLdata_NormalizeClsAtL
    procedure :: output_veccl_files => TCLdata_output_veccl_files
    end type TCLdata

    Type TTimeSources
        ! values of q to evolve the propagation equations to compute the sources
        type(TRanges) :: Evolve_q
        real(dl), dimension(:,:,:), allocatable :: LinearSrc !Sources and second derivs
        !LinearSrc indices  ( k_index, source_index, time_step_index )
        integer SourceNum, NonCustomSourceNum
        !SourceNum is total number sources (2 or 3 for scalars, 3 for tensors).
    end type TTimeSources

    type, extends(TCAMBdata) :: CAMBdata

        type(CAMBparams) :: CP

        real(dl) ThermoDerivedParams(nthermo_derived)

        logical flat,closed

        !     grhocrit =kappa*a^2*rho_crit(0)
        !     grhornomass=grhor*number of massless neutrino species
        !     taurst,taurend - time at start/end of recombination
        !     dtaurec - dtau during recombination
        !     adotrad - a(tau) in radiation era
        real(dl) grhocrit,grhog,grhor,grhob,grhoc,grhov,grhornomass,grhok
        real(dl) taurst,dtaurec,taurend,tau_maxvis,adotrad

        real(dl) Omega_de
        real(dl) curv, curvature_radius, Ksign !curvature_radius = 1/sqrt(|curv|), Ksign = 1,0 or -1
        real(dl) tau0,chi0 !time today and rofChi(tau0/curvature_radius)
        real(dl) scale !relative to flat. e.g. for scaling lSamp%l sampling.

        real(dl) akthom !sigma_T * (number density of protons now)
        real(dl) fHe !n_He_tot / n_H_tot
        real(dl) Nnow
        real(dl) z_eq !defined assuming all neutrinos massless
        !Neutrinos
        real(dl) grhormass(max_nu)
        !     nu_masses=m_nu*c**2/(k_B*T_nu0)
        real(dl) nu_masses(max_nu)
        integer ::  num_transfer_redshifts = 1
        real(dl), allocatable  ::  transfer_redshifts(:)
        integer  ::  PK_redshifts_index(max_transfer_redshifts)

        logical :: OnlyTransfer = .false. !C_L/PK not computed; initial power spectrum data, instead get Delta_q_l array
        !If true, sigma_8 is not calculated either]]
        logical :: HasScalarTimeSources = .false. !No power spectra, only time transfer functions

        logical :: get_growth_sigma8 = .true.
        !gets sigma_vdelta, like sigma8 but using velocity-density cross power,
        !in late LCDM f*sigma8 = sigma_vdelta^2/sigma8

        logical :: needs_good_pk_sampling = .false.

        logical ::call_again = .false.
        !if being called again with same parameters to get different thing

        real(dl) :: reion_tau_start, reion_tau_complete
        integer :: reion_n_steps

        Type(TNuPerturbations) :: NuPerturbations

        Type(TBackgroundOutputs) :: BackgroundOutputs

        !Time steps for sampling sources
        Type(TRanges) :: TimeSteps
        !Background interpolation tables for thermal history etc.
        Type(TThermoData) :: ThermoData

        real(dl), allocatable :: transfer_times(:)

        !Matter transfer data
        Type (MatterTransferData):: MT

        !Matter power spectrum for default variable (used for non-linear corrections)
        Type(MatterPowerData), allocatable :: CAMB_PK

        Type(TClData) :: CLdata

        integer :: num_redshiftwindows = 0
        integer :: num_extra_redshiftwindows = 0
        Type(TRedWin), allocatable :: Redshift_W(:)
        real(dl), dimension(:), allocatable :: optical_depths_for21cm

        Type(TTimeSources), allocatable :: ScalarTimeSources
        integer :: Scalar_C_last = C_PhiE


    contains
    procedure :: DeltaTime => CAMBdata_DeltaTime
    procedure :: DeltaTimeArr => CAMBdata_DeltaTimeArr
    procedure :: TimeOfz => CAMBdata_TimeOfz
    procedure :: TimeOfzArr => CAMBdata_TimeOfzArr
    procedure :: DeltaPhysicalTimeGyr => CAMBdata_DeltaPhysicalTimeGyr
    procedure :: DeltaPhysicalTimeGyrArr => CAMBdata_DeltaPhysicalTimeGyrArr
    procedure :: AngularDiameterDistance => CAMBdata_AngularDiameterDistance
    procedure :: AngularDiameterDistanceArr => CAMBdata_AngularDiameterDistanceArr
    procedure :: AngularDiameterDistance2 => CAMBdata_AngularDiameterDistance2
    procedure :: AngularDiameterDistance2Arr => CAMBdata_AngularDiameterDistance2Arr
    procedure :: LuminosityDistance => CAMBdata_LuminosityDistance
    procedure :: ComovingRadialDistance => CAMBdata_ComovingRadialDistance
    procedure :: ComovingRadialDistanceArr => CAMBdata_ComovingRadialDistanceArr
    procedure :: GetBackgroundDensities => CAMBdata_GetBackgroundDensities
    procedure :: Hofz => CAMBdata_Hofz
    procedure :: HofzArr => CAMBdata_HofzArr
    procedure :: sound_horizon => CAMBdata_sound_horizon
    procedure :: sound_horizon_zArr => CAMBdata_sound_horizon_zArr
    procedure :: RedshiftAtTimeArr => CAMBdata_RedshiftAtTimeArr
    procedure :: BAO_D_v => CAMBdata_BAO_D_v
    procedure :: CosmomcTheta => CAMBdata_CosmomcTheta
    procedure :: get_lmax_lensed => CAMBdata_get_lmax_lensed
    procedure :: get_zstar => CAMBdata_get_zstar
    procedure :: DarkEnergyStressEnergy => CAMBdata_DarkEnergyStressEnergy
    procedure :: SetParams => CAMBdata_SetParams
    procedure :: Free => CAMBdata_Free
    procedure :: grho_no_de
    procedure :: GetReionizationOptDepth
    procedure :: rofChi
    procedure :: cosfunc
    procedure :: tanfunc
    procedure :: invsinfunc
    procedure :: GetComputedPKRedshifts
    procedure :: binary_search
    procedure, nopass :: PythonClass => CAMBdata_PythonClass
    procedure, nopass :: SelfPointer => CAMBdata_SelfPointer
    end type CAMBdata

    interface
    FUNCTION state_function(obj, a)
    use precision
    import
    class(CAMBdata) :: obj
    real(dl), intent(in) :: a
    real(dl) :: state_function
    END FUNCTION  state_function
    end interface

    procedure(obj_function), private :: dtauda

    contains

    function CAMBdata_PythonClass()
    character(LEN=:), allocatable :: CAMBdata_PythonClass
    CAMBdata_PythonClass = 'CAMBdata'
    end function CAMBdata_PythonClass

    subroutine CAMBdata_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (CAMBdata), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine CAMBdata_SelfPointer

    subroutine CAMBdata_SetParams(this, P, error, DoReion, call_again, background_only)
    !Initialize background variables; does not yet calculate thermal history
    use constants
    class(CAMBdata), target :: this
    type(CAMBparams), intent(in) :: P
    real(dl) fractional_number, conv
    integer, optional :: error !Zero if OK
    logical, optional :: DoReion
    logical, optional :: call_again, background_only
    logical WantReion, calling_again
    integer nu_i,actual_massless
    real(dl) nu_massless_degeneracy, neff_i, eta_k, h2
    real(dl) zpeak, sigma_z, zpeakstart, zpeakend
    Type(TRedWin), pointer :: Win
    logical back_only
    !Constants in SI units

    global_error_flag = 0

    if ((P%WantTensors .or. P%WantVectors).and. P%WantTransfer .and. .not. P%WantScalars) then
        call GlobalError( 'Cannot generate tensor C_l and transfer without scalar C_l',error_unsupported_params)
    end if

    if (.not. allocated(P%DarkEnergy)) then
        call GlobalError('DarkEnergy not set', error_darkenergy)
    end if

    if (present(error)) error = global_error_flag
    if (global_error_flag/=0) return

    WantReion = DefaultTrue(DoReion)
    calling_again= DefaultFalse(call_again)
    back_only = DefaultFalse(background_only)

    if (calling_again) then
        this%CP%WantDerivedParameters = .false.
        this%CP%Accuracy = P%Accuracy
        this%CP%Transfer%high_precision = P%Transfer%high_precision
        this%CP%Reion%Reionization = P%Reion%Reionization
        this%CP%WantTransfer =P%WantTransfer
        this%CP%WantScalars =P%WantScalars
        this%CP%WantTensors =P%WantTensors
        this%CP%WantVectors =P%WantVectors
        this%CP%WantCls = P%WantCls
    else
        this%CP=P
        this%CP%Max_eta_k = max(this%CP%Max_eta_k,this%CP%Max_eta_k_tensor)
    end if

    if (P%WantTransfer .and. .not. back_only) then
        this%CP%WantScalars=.true.
        if (.not. P%WantCls) then
            this%CP%Accuracy%AccuratePolarization = .false.
            !Sources
            this%CP%Reion%Reionization = this%CP%transfer_21cm_cl
        end if
        call this%GetComputedPKRedshifts(this%CP)
    end if
    if (this%CP%WantTransfer.and. this%CP%MassiveNuMethod==Nu_approx) then
        this%CP%MassiveNuMethod = Nu_trunc
    end if

    if (.not. calling_again) then
        this%ThermoData%HasThermoData = .false.
        if (this%CP%Num_Nu_Massive /= sum(this%CP%Nu_mass_numbers(1:this%CP%Nu_mass_eigenstates))) then
            if (sum(this%CP%Nu_mass_numbers(1:this%CP%Nu_mass_eigenstates))/=0) &
                call GlobalError('Num_Nu_Massive is not sum of Nu_mass_numbers', error_unsupported_params)
        end if
10      if (this%CP%Omnuh2 < 1.e-7_dl) this%CP%Omnuh2 = 0
        if (this%CP%Omnuh2==0 .and. this%CP%Num_Nu_Massive /=0) then
            if (this%CP%share_delta_neff) then
                this%CP%Num_Nu_Massless = this%CP%Num_Nu_Massless + this%CP%Num_Nu_Massive
            else
                this%CP%Num_Nu_Massless = this%CP%Num_Nu_Massless + sum(this%CP%Nu_mass_degeneracies(1:this%CP%Nu_mass_eigenstates))
            end if
            this%CP%Num_Nu_Massive  = 0
            this%CP%Nu_mass_numbers = 0
        end if

        nu_massless_degeneracy = this%CP%Num_Nu_massless !N_eff for massless neutrinos
        if (this%CP%Num_nu_massive > 0) then
            if (this%CP%Nu_mass_eigenstates==0) &
                call GlobalError('Have Num_nu_massive>0 but no nu_mass_eigenstates', error_unsupported_params)
            if (this%CP%Nu_mass_eigenstates==1 .and. this%CP%Nu_mass_numbers(1)==0) &
                this%CP%Nu_mass_numbers(1) = this%CP%Num_Nu_Massive
            if (all(this%CP%Nu_mass_numbers(1:this%CP%Nu_mass_eigenstates)==0)) this%CP%Nu_mass_numbers=1 !just assume one for all
            if (this%CP%share_delta_neff) then
                !default case of equal heating of all neutrinos
                fractional_number = this%CP%Num_Nu_massless + this%CP%Num_Nu_massive
                actual_massless = int(this%CP%Num_Nu_massless + 1e-6_dl)
                neff_i = fractional_number/(actual_massless + this%CP%Num_Nu_massive)
                nu_massless_degeneracy = neff_i*actual_massless
                this%CP%Nu_mass_degeneracies(1:this%CP%Nu_mass_eigenstates) = &
                    this%CP%Nu_mass_numbers(1:this%CP%Nu_mass_eigenstates)*neff_i
            end if
            if (abs(sum(this%CP%Nu_mass_fractions(1:this%CP%Nu_mass_eigenstates))-1) > 1e-4) &
                call GlobalError('Nu_mass_fractions do not add up to 1', error_unsupported_params)
        else
            this%CP%Nu_mass_eigenstates = 0
        end if

        if (global_error_flag/=0) then
            if (present(error)) error = global_error_flag
            return
        end if


        call This%ThermoData%ScaleFactorAtTime%Clear()

        this%flat = (abs(this%CP%omk) <= OmegaKFlat)
        this%closed = this%CP%omk < -OmegaKFlat

        if (this%flat) then
            this%curv=0
            this%Ksign=0
            this%curvature_radius=1._dl !so we can use tau/curvature_radius, etc, where r's cancel
        else
            this%curv=-this%CP%omk/((c/1000)/this%CP%h0)**2
            this%Ksign =sign(1._dl,this%curv)
            this%curvature_radius=1._dl/sqrt(abs(this%curv))
        end if
        !  grho gives the contribution to the expansion rate from: (g) photons,
        !  (r) one flavor of relativistic neutrino (2 degrees of freedom),
        !  (m) nonrelativistic matter (for Omega=1).  grho is actually
        !  8*pi*G*rho/c^2 at a=1, with units of Mpc**(-2).
        !  a=tau(Mpc)*adotrad, with a=1 today, assuming 3 neutrinos.
        !  (Used only to set the initial conformal time.)

        !H0 is in km/s/Mpc

        this%grhocrit = 3*this%CP%h0**2/c**2*1000**2 !3*h0^2/c^2 (=8*pi*G*rho_crit/c^2)

        this%grhog = kappa/c**2*4*sigma_boltz/c**3*this%CP%tcmb**4*Mpc**2 !8*pi*G/c^2*4*sigma_B/c^3 T^4
        ! grhog=1.4952d-13*tcmb**4
        this%grhor = 7._dl/8*(4._dl/11)**(4._dl/3)*this%grhog !7/8*(4/11)^(4/3)*grhog (per neutrino species)
        !grhor=3.3957d-14*tcmb**4

        !correction for fractional number of neutrinos, e.g. 3.04 to give slightly higher T_nu hence rhor
        !for massive Nu_mass_degeneracies parameters account for heating from grhor

        this%grhornomass=this%grhor*nu_massless_degeneracy
        this%grhormass=0
        do nu_i = 1, this%CP%Nu_mass_eigenstates
            this%grhormass(nu_i)=this%grhor*this%CP%Nu_mass_degeneracies(nu_i)
        end do
        h2 = (this%CP%H0/100)**2
        this%grhoc=this%grhocrit*this%CP%omch2/h2
        this%grhob=this%grhocrit*this%CP%ombh2/h2
        this%grhok=this%grhocrit*this%CP%omk
        this%Omega_de = 1 -(this%CP%omch2 + this%CP%ombh2 + this%CP%omnuh2)/h2 - this%CP%omk  &
            - (this%grhornomass + this%grhog)/this%grhocrit
        this%grhov=this%grhocrit*this%Omega_de

        !  adotrad gives da/dtau in the asymptotic radiation-dominated era:
        this%adotrad = sqrt((this%grhog+this%grhornomass+sum(this%grhormass(1:this%CP%Nu_mass_eigenstates)))/3)

        this%Nnow = this%CP%ombh2/h2*(1-this%CP%yhe)*this%grhocrit*c**2/kappa/m_H/Mpc**2

        this%akthom = sigma_thomson*this%Nnow*Mpc
        !sigma_T * (number density of protons now)

        this%fHe = this%CP%YHe/(mass_ratio_He_H*(1.d0-this%CP%YHe))  !n_He_tot / n_H_tot

        this%z_eq = (this%grhob+this%grhoc)/(this%grhog+this%grhornomass+sum(this%grhormass(1:this%CP%Nu_mass_eigenstates))) -1

        if (this%CP%omnuh2/=0) then
            !Initialize things for massive neutrinos
            call ThermalNuBackground%Init()
            call this%NuPerturbations%Init(P%Accuracy%AccuracyBoost*P%Accuracy%neutrino_q_boost)
            !  nu_masses=m_nu(i)*c**2/(k_B*T_nu0)
            do nu_i=1, this%CP%Nu_mass_eigenstates
                this%nu_masses(nu_i)= ThermalNuBackground%find_nu_mass_for_rho(this%CP%omnuh2/h2*this%CP%Nu_mass_fractions(nu_i)&
                    *this%grhocrit/this%grhormass(nu_i))
            end do
            if (all(this%nu_masses(1:this%CP%Nu_mass_eigenstates)==0)) then
                !All density accounted for by massless, so just use massless
                this%CP%Omnuh2 = 0
                goto 10
            end if
            !Just prevent divide by zero
            this%nu_masses(1:this%CP%Nu_mass_eigenstates) = max(this%nu_masses(1:this%CP%Nu_mass_eigenstates),1e-3_dl)
        else
            this%nu_masses = 0
        end if
        call this%CP%DarkEnergy%Init(this)
        if (global_error_flag==0) this%tau0=this%TimeOfz(0._dl)
        if (global_error_flag==0) then
            this%chi0=this%rofChi(this%tau0/this%curvature_radius)
            this%scale= this%chi0*this%curvature_radius/this%tau0  !e.g. change l sampling depending on approx peak spacing
            if (this%closed .and. this%tau0/this%curvature_radius >3.14) then
                call GlobalError('chi >= pi in closed model not supported',error_unsupported_params)
            end if
            if (WantReion) call this%CP%Reion%Init(this)
            if (this%CP%NonLinear/=NonLinear_None .and. .not. back_only) &
                call this%CP%NonLinearModel%Init(this)
        end if
    end if
    if (allocated(this%CP%SourceWindows) .and. .not. back_only) then
        if (.not. this%CP%WantScalars) then
            this%num_redshiftwindows=0
        else
            this%num_redshiftwindows = size(this%CP%SourceWindows)
        end if
    else
        this%num_redshiftwindows = 0
        this%CP%SourceTerms%limber_windows = .false.
    endif

    if (this%CP%WantScalars .and. this%CP%WantCls .and. this%num_redshiftwindows>0) then
        eta_k = this%CP%Max_eta_k
        if (allocated(this%Redshift_W)) deallocate(this%Redshift_W)
        allocate(this%Redshift_W(this%num_redshiftwindows))
        this%num_extra_redshiftwindows = 0
        !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), PRIVATE(zpeak, sigma_z, zpeakstart, zpeakend, nu_i, Win)
        do nu_i = 1, this%num_redshiftwindows
            Win => this%Redshift_w(nu_i)
            Win%Window => this%CP%SourceWindows(nu_i)%Window
            Win%kind = Win%Window%source_type
            call Win%Window%GetScales(zpeak, sigma_z, zpeakstart, zpeakend)
            if (FeedbackLevel > 1) then
                write(*,*) FormatString('Window scales: %d peak: %f, sigma: %f, start:%f, end %f', &
                    nu_i, zpeak, sigma_z, zpeakstart, zpeakend)
            end if
            Win%Redshift = zpeak
            Win%tau = this%TimeOfz(zpeak, tol=1e-4_dl)
            Win%sigma_tau = sigma_z*dtauda(this,1/(1+zpeak))/(1+zpeak)**2
            Win%tau_peakstart=this%TimeOfZ(zpeakstart, tol=1e-4_dl)
            Win%tau_peakend = this%TimeOfZ(max(0._dl,zpeakend), tol=1e-4_dl)
            Win%chi0 = this%tau0-Win%tau
            Win%chimin = min(Win%chi0,this%tau0 - this%TimeOfz(max(0.05_dl,zpeakend), tol=1e-4_dl))
            !$OMP CRITICAL
            this%CP%Max_eta_k = max(this%CP%Max_eta_k, this%tau0*WindowKmaxForL(Win,this%CP,this%CP%max_l))
            if (Win%Window%source_type==window_21cm) this%CP%Do21cm = .true.
            if (Win%Window%source_type==window_counts .and. P%SourceTerms%counts_lensing) then
                this%num_extra_redshiftwindows = this%num_extra_redshiftwindows + 1
                Win%mag_index = this%num_extra_redshiftwindows
            end if
            !$OMP END CRITICAL
        end do
        if (eta_k /= this%CP%Max_eta_k .and. FeedbackLevel>0) &
            write (*,*) 'source max_eta_k: ', this%CP%Max_eta_k,'kmax = ', this%CP%Max_eta_k/this%tau0
    end if

    if ((this%CP%NonLinear==NonLinear_Lens .or. this%CP%NonLinear==NonLinear_both) .and. &
        this%CP%Max_eta_k/this%tau0 > this%CP%Transfer%kmax) then
        this%CP%Transfer%kmax =this%CP%Max_eta_k/this%tau0
        if (FeedbackLevel > 0) write (*,*) 'kmax changed to ', this%CP%Transfer%kmax
    end if

    if (global_error_flag/=0) then
        if (present(error)) error = global_error_flag
        return
    end if

    if (present(error)) then
        error = 0
    else if (FeedbackLevel > 0 .and. .not. calling_again) then
        write(*,'("Om_b h^2             = ",f9.6)') P%ombh2
        write(*,'("Om_c h^2             = ",f9.6)') P%omch2
        write(*,'("Om_nu h^2            = ",f9.6)') P%omnuh2
        write(*,'("Om_darkenergy        = ",f9.6)') this%Omega_de
        write(*,'("Om_K                 = ",f9.6)') P%omk
        write(*,'("Om_m (inc Om_u)      = ",f9.6)') (P%ombh2+P%omch2+P%omnuh2)/h2
        write(*,'("100 theta (CosmoMC)  = ",f9.6)') 100*this%CosmomcTheta()
        if (this%CP%Num_Nu_Massive > 0) then
            write(*,'("N_eff (total)        = ",f9.6)') nu_massless_degeneracy + &
                sum(this%CP%Nu_mass_degeneracies(1:this%CP%Nu_mass_eigenstates))
            do nu_i=1, this%CP%Nu_mass_eigenstates
                conv = k_B*(8*this%grhor/this%grhog/7)**0.25*this%CP%tcmb/eV * &
                    (this%CP%nu_mass_degeneracies(nu_i)/this%CP%nu_mass_numbers(nu_i))**0.25 !approx 1.68e-4
                write(*,'(I2, " nu, g=",f7.4," m_nu*c^2/k_B/T_nu0= ",f9.2," (m_nu= ",f6.3," eV)")') &
                    this%CP%nu_mass_numbers(nu_i), this%CP%nu_mass_degeneracies(nu_i), &
                    this%nu_masses(nu_i),conv*this%nu_masses(nu_i)
            end do
        end if
    end if

    end subroutine CAMBdata_SetParams

    subroutine CAMBdata_Free(this)
    class(CAMBdata) :: this

    call Free_ClTransfer(this%CLdata%CTransScal)
    call Free_ClTransfer(this%ClData%CTransVec)
    call Free_ClTransfer(this%ClData%CTransTens)
    call this%MT%Free()
    if (allocated(this%CAMB_Pk)) deallocate(this%CAMB_PK)

    end subroutine CAMBdata_Free

    function CAMBdata_DeltaTime(this, a1,a2, in_tol)
    class(CAMBdata) :: this
    real(dl) CAMBdata_DeltaTime, atol
    real(dl), intent(IN) :: a1,a2
    real(dl), optional, intent(in) :: in_tol

    atol = PresentDefault(tol/1000/exp(this%CP%Accuracy%AccuracyBoost*this%CP%Accuracy%IntTolBoost-1), in_tol)
    CAMBdata_DeltaTime = Integrate_Romberg(this, dtauda,a1,a2,atol)

    end function CAMBdata_DeltaTime

    subroutine CAMBdata_DeltaTimeArr(this, arr, a1, a2, n, tol)
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: a1(n), a2(n)
    real(dl), intent(in), optional :: tol
    integer i

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do i = 1, n
        arr(i) = this%DeltaTime(a1(i), a2(i), tol)
    end do

    end subroutine CAMBdata_DeltaTimeArr

    function CAMBdata_TimeOfz(this, z, tol)
    class(CAMBdata) :: this
    real(dl) CAMBdata_TimeOfz
    real(dl), intent(in), optional :: tol
    real(dl), intent(IN) :: z

    CAMBdata_TimeOfz= this%DeltaTime(0._dl,1._dl/(z+1._dl), tol)
    end function CAMBdata_TimeOfz

    subroutine CAMBdata_TimeOfzArr(this, arr, z, n, tol)
    !z array must be monotonically *decreasing* so times increasing
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    real(dl), intent(in), optional :: tol
    integer i

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do i = 1, n
        if (i==1) then
            arr(i) = this%DeltaTime(0._dl, 1/(1+z(1)), tol)
        else
            if (z(i) < z(i-1)) then
                arr(i) = this%DeltaTime(1/(1+z(i-1)),1/(1+z(i)),tol)
            elseif (z(i) < z(i-1) + 1e-6_dl) then
                arr(i)=0
            else
                error stop 'CAMBdata_TimeOfzArr redshifts must be decreasing'
            end if
        end if
    end do
    !$OMP END PARALLEL DO
    do i = 2, n
        arr(i) = arr(i)  + arr(i-1)
    end do

    end subroutine CAMBdata_TimeOfzArr

    function CAMBdata_DeltaPhysicalTimeGyr(this, a1,a2, in_tol)
    use constants
    class(CAMBdata) :: this
    real(dl), intent(in) :: a1, a2
    real(dl), optional, intent(in) :: in_tol
    real(dl) CAMBdata_DeltaPhysicalTimeGyr, atol

    atol = PresentDefault(1d-4/exp(this%CP%Accuracy%AccuracyBoost-1), in_tol)
    CAMBdata_DeltaPhysicalTimeGyr = Integrate_Romberg(this, dtda,a1,a2,atol)*Mpc/c/Gyr
    end function CAMBdata_DeltaPhysicalTimeGyr

    subroutine CAMBdata_DeltaPhysicalTimeGyrArr(this, arr, a1, a2, n, tol)
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: a1(n), a2(n)
    real(dl), intent(in), optional :: tol
    integer i

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do i = 1, n
        arr(i) = this%DeltaPhysicalTimeGyr(a1(i), a2(i), tol)
    end do

    end subroutine CAMBdata_DeltaPhysicalTimeGyrArr


    function CAMBdata_AngularDiameterDistance(this,z)
    class(CAMBdata) :: this
    !This is the physical (non-comoving) angular diameter distance in Mpc
    real(dl) CAMBdata_AngularDiameterDistance
    real(dl), intent(in) :: z

    CAMBdata_AngularDiameterDistance = this%curvature_radius/(1+z)* &
        this%rofchi(this%ComovingRadialDistance(z) /this%curvature_radius)

    end function CAMBdata_AngularDiameterDistance

    subroutine CAMBdata_AngularDiameterDistanceArr(this, arr, z, n)
    class(CAMBdata) :: this
    !This is the physical (non-comoving) angular diameter distance in Mpc for array of z
    !z array must be monotonically increasing
    integer,intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    integer i

    call this%ComovingRadialDistanceArr(arr, z, n, 1e-4_dl)
    if (this%flat) then
        arr = arr/(1+z)
    else
        do i=1, n
            arr(i) =  this%curvature_radius/(1+z(i))*this%rofchi(arr(i)/this%curvature_radius)
        end do
    end if

    end subroutine CAMBdata_AngularDiameterDistanceArr


    function CAMBdata_AngularDiameterDistance2(this,z1, z2)
    ! z1 < z2, otherwise returns zero
    !From http://www.slac.stanford.edu/~amantz/work/fgas14/#cosmomc
    class(CAMBdata) :: this
    real(dl) CAMBdata_AngularDiameterDistance2
    real(dl), intent(in) :: z1, z2

    if (z2 < z1 + 1e-4) then
        CAMBdata_AngularDiameterDistance2=0
    else
        CAMBdata_AngularDiameterDistance2 = this%curvature_radius/(1+z2)* &
            this%rofchi( this%DeltaTime(1/(1+z2),1/(1+z1))/this%curvature_radius)
    end if

    end function CAMBdata_AngularDiameterDistance2

    subroutine CAMBdata_AngularDiameterDistance2Arr(this, arr, z1, z2, n)
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z1(n), z2(n)
    integer i

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do i = 1, n
        arr(i) = this%AngularDiameterDistance2(z1(i),z2(i))
    end do
    !$OMP END PARALLEL DO

    end subroutine CAMBdata_AngularDiameterDistance2Arr


    function CAMBdata_LuminosityDistance(this,z)
    class(CAMBdata) :: this
    real(dl) CAMBdata_LuminosityDistance
    real(dl), intent(in) :: z

    CAMBdata_LuminosityDistance = this%AngularDiameterDistance(z)*(1+z)**2

    end function CAMBdata_LuminosityDistance

    function CAMBdata_ComovingRadialDistance(this, z)
    class(CAMBdata) :: this
    real(dl) CAMBdata_ComovingRadialDistance
    real(dl), intent(in) :: z

    CAMBdata_ComovingRadialDistance = this%DeltaTime(1/(1+z),1._dl)

    end function CAMBdata_ComovingRadialDistance

    subroutine CAMBdata_ComovingRadialDistanceArr(this, arr, z, n, tol)
    !z array must be monotonically increasing
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    real(dl), intent(in) :: tol
    integer i

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
    do i = 1, n
        if (i==1) then
            if (z(i) < 1e-6_dl) then
                arr(i) = 0
            else
                arr(i) = this%DeltaTime(1/(1+z(i)),1._dl, tol)
            end if
        else
            if (z(i) < z(i-1)) error stop 'ComovingRadialDistanceArr redshifts out of order'
            arr(i) = this%DeltaTime(1/(1+z(i)),1/(1+z(i-1)),tol)
        end if
    end do
    !$OMP END PARALLEL DO
    do i = 2, n
        arr(i) = arr(i)  + arr(i-1)
    end do

    end subroutine CAMBdata_ComovingRadialDistanceArr

    function CAMBdata_Hofz(this,z)
    !non-comoving Hubble in MPC units, divide by MPC_in_sec to get in SI units
    !multiply by c/1e3 to get in km/s/Mpc units
    class(CAMBdata) :: this
    real(dl) CAMBdata_Hofz, a
    real(dl), intent(in) :: z

    a = 1/(1+z)
    CAMBdata_Hofz = 1/(a**2*dtauda(this,a))

    end function CAMBdata_Hofz

    subroutine CAMBdata_HofzArr(this, arr, z, n)
    !non-comoving Hubble in MPC units, divide by MPC_in_sec to get in SI units
    !multiply by c/1e3 to get in km/s/Mpc units
    class(CAMBdata) :: this
    integer,intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    integer i
    real(dl) :: a

    do i=1, n
        a = 1/(1+z(i))
        arr(i) = 1/(a**2*dtauda(this,a))
    end do

    end subroutine CAMBdata_HofzArr

    real(dl) function CAMBdata_sound_horizon(this, z)
    class(CAMBdata) :: this
    real(dl), intent(in) :: z

    CAMBdata_sound_horizon = Integrate_Romberg(this,dsound_da_exact,1d-9,1/(z+1),1e-6_dl)

    end function CAMBdata_sound_horizon

    subroutine CAMBdata_sound_horizon_zArr(this,arr, z,n)
    class(CAMBdata) :: this
    integer,intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: z(n)
    integer i

    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), IF(n>4)
    do i=1,n
        arr(i) = this%sound_horizon(z(i))
    end do

    end subroutine CAMBdata_sound_horizon_zArr

    subroutine CAMBdata_RedshiftAtTimeArr(this, arr, tau, n)
    class(CAMBdata) :: this
    integer,intent(in) :: n
    real(dl), intent(out) :: arr(n)
    real(dl), intent(in) :: tau(n)
    integer i
    real(dl) om

    if (this%ThermoData%ScaleFactorAtTime%n==0) &
        call GlobalError('RedshiftAtTimeArr: background history not calculated', error_unsupported_params)
    if (global_error_flag/=0) return
    !$OMP PARALLEL DO DEFAULT(SHARED), private(om, i)
    do i=1, n
        if (tau(i) < this%ThermoData%tauminn*1.1) then
            om = (this%grhob+this%grhoc)/&
                sqrt(3*(this%grhog+sum(this%grhormass(1:this%CP%Nu_mass_eigenstates))+this%grhornomass))
            arr(i) = 1/(this%adotrad*tau(i)*(1+om*tau(i)/4))-1
        else
            arr(i) = 1/this%ThermoData%ScaleFactorAtTime%Value(tau(i))-1
        end if
    end do

    end subroutine CAMBdata_RedshiftAtTimeArr

    real(dl) function BAO_D_v_from_DA_H(z, DA, Hz)
    real(dl), intent(in) :: z, DA, Hz
    real(dl) ADD

    ADD = DA*(1.d0+z)
    BAO_D_v_from_DA_H = ((ADD)**2.d0*z/Hz)**(1.d0/3.d0)

    end function BAO_D_v_from_DA_H

    real(dl) function CAMBdata_BAO_D_v(this,z)
    class(CAMBdata) :: this
    real(dl), intent(IN) :: z

    CAMBdata_BAO_D_v = BAO_D_v_from_DA_H(z,this%AngularDiameterDistance(z), this%Hofz(z))

    end function CAMBdata_BAO_D_v

    function CAMBdata_get_zstar(this)
    class(CAMBdata) :: this
    real(dl) CAMBdata_get_zstar
    real(dl) z_scale

    call this%CP%Recomb%Init(this)
    z_scale =  COBE_CMBTemp/this%CP%TCMB
    CAMBdata_get_zstar=this%binary_search(noreion_optdepth, 1.d0, 700.d0*z_scale, &
        2000.d0*z_scale, 1d-3*z_scale,100.d0*z_scale,5000.d0*z_scale)

    end function CAMBdata_get_zstar

    function CAMBdata_CosmomcTheta(this)
    class(CAMBdata) :: this
    real(dl) zstar, astar, atol, rs, DA
    real(dl) CAMBdata_CosmomcTheta
    real(dl) ombh2, omdmh2

    ombh2 = this%CP%ombh2
    omdmh2 = (this%CP%omch2+this%CP%omnuh2)

    !!From Hu & Sugiyama
    zstar =  1048*(1+0.00124*ombh2**(-0.738))*(1+ &
        (0.0783*ombh2**(-0.238)/(1+39.5*ombh2**0.763)) * &
        (omdmh2+ombh2)**(0.560/(1+21.1*ombh2**1.81)))

    astar = 1/(1+zstar)
    atol = 1e-6
    rs = Integrate_Romberg(this,dsound_da_approx,1d-8,astar,atol)
    DA = this%AngularDiameterDistance(zstar)/astar
    CAMBdata_CosmomcTheta = rs/DA

    end function CAMBdata_CosmomcTheta


    subroutine CAMBdata_GetBackgroundDensities(this, n, a_arr, densities)
    ! return array of 8*pi*G*rho*a**4 for each species
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(in) :: a_arr(n)
    real(dl) :: grhov_t, rhonu, grhonu, a
    real(dl), intent(out) :: densities(8,n)
    integer nu_i,i

    do i=1, n
        a = a_arr(i)
        call this%CP%DarkEnergy%BackgroundDensityAndPressure(this%grhov, a, grhov_t)
        grhonu = 0

        if (this%CP%Num_Nu_massive /= 0) then
            !Get massive neutrino density relative to massless
            do nu_i = 1, this%CP%nu_mass_eigenstates
                call ThermalNuBackground%rho(a * this%nu_masses(nu_i), rhonu)
                grhonu = grhonu + rhonu * this%grhormass(nu_i)
            end do
        end if

        densities(2,i) = this%grhok * a**2
        densities(3,i) = this%grhoc * a
        densities(4,i) = this%grhob * a
        densities(5,i) = this%grhog
        densities(6,i) = this%grhornomass
        densities(7,i) = grhonu
        densities(8,i) = grhov_t*a**2
        densities(1,i) = sum(densities(2:8,i))
    end do

    end subroutine CAMBdata_GetBackgroundDensities

    integer function CAMBdata_get_lmax_lensed(this)
    class(CAMBdata) :: this
    CAMBdata_get_lmax_lensed = this%CLdata%lmax_lensed
    end function CAMBdata_get_lmax_lensed

    !JD 08/13 New function for nonlinear lensing of CMB + MPK compatibility
    !Build master redshift array from array of desired Nonlinear lensing (NLL)
    !redshifts and an array of desired Power spectrum (PK) redshifts.
    !At the same time fill arrays for NLL and PK that indicate indices
    !of their desired redshifts in the master redshift array.
    !Finally define number of redshifts in master array. This is usually given by:
    !P%num_redshifts = P%PK_num_redshifts + NLL_num_redshifts - 1.  The -1 comes
    !from the fact that z=0 is in both arrays (when non-linear is on)
    subroutine GetComputedPKRedshifts(this, Params,eta_k_max)
    use MpiUtils, only : MpiStop
    class(CAMBdata) :: this
    Type(CAMBParams) :: Params
    integer i, iPK, iNLL
    real(dl), parameter :: tol = 1.d-5
    real(dl) maxRedshift, NL_Boost
    integer   ::  NLL_num_redshifts
    real(dl), allocatable    ::  NLL_redshifts(:), redshifts(:)
    !Sources, but unused currently
    real(dl), intent(in), optional :: eta_k_max

    NLL_num_redshifts = 0
    this%needs_good_pk_sampling = .false.
    associate(P => Params%Transfer)
        if ((Params%NonLinear==NonLinear_lens .or. Params%NonLinear==NonLinear_both) .and. &
            (Params%DoLensing .or. this%num_redshiftwindows > 0)) then
            ! Want non-linear lensing or other sources
            this%needs_good_pk_sampling = .false.
            NL_Boost = Params%Accuracy%AccuracyBoost*Params%Accuracy%NonlinSourceBoost
            if (Params%Do21cm) then
                !Sources
                if (maxval(this%Redshift_w(1:this%num_redshiftwindows)%Redshift) &
                    /= minval(this%Redshift_w(1:this%num_redshiftwindows)%Redshift))  &
                    stop 'Non-linear 21cm currently only for narrow window at one redshift'
                if (.not. present(eta_k_max)) stop 'bad call to GetComputedPKRedshifts'
                P%kmax = eta_k_max/10000.
                NLL_num_redshifts =  1
                allocate(NLL_redshifts(NLL_num_redshifts+1))
                NLL_redshifts(1) = this%Redshift_w(1)%Redshift
            else
                P%kmax = max(P%kmax,5*NL_Boost)
                maxRedshift = 10
                NLL_num_redshifts =  nint(10*5*NL_Boost)
                if (NL_Boost>=2.5) then
                    !only notionally more accuracy, more stable for RS
                    maxRedshift =15
                end if
                allocate(NLL_redshifts(NLL_num_redshifts+1)) !+1 to stop access issues below
                do i=1,NLL_num_redshifts
                    NLL_redshifts(i) = real(NLL_num_redshifts-i)/(NLL_num_redshifts/maxRedshift)
                end do
            end if
        end if
        if (allocated(this%transfer_redshifts)) deallocate(this%transfer_redshifts)
        if (NLL_num_redshifts==0) then
            this%num_transfer_redshifts=P%PK_num_redshifts
            allocate(this%transfer_redshifts(this%num_transfer_redshifts))
            this%transfer_redshifts = P%PK_redshifts(:this%num_transfer_redshifts)
            this%PK_redshifts_index(:this%num_transfer_redshifts) = (/ (i, i=1, this%num_transfer_redshifts ) /)
        else
            i=0
            iPK=1
            iNLL=1
            allocate(redshifts(NLL_num_redshifts+P%PK_num_redshifts))
            do while (iPk<=P%PK_num_redshifts .or. iNLL<=NLL_num_redshifts)
                !JD write the next line like this to account for roundoff issues with ==. Preference given to PK_Redshift
                i=i+1
                if(iNLL>NLL_num_redshifts .or. P%PK_redshifts(iPK)>NLL_redshifts(iNLL)+tol) then
                    redshifts(i)=P%PK_redshifts(iPK)
                    this%PK_redshifts_index(iPK)=i
                    iPK=iPK+1
                else if(iPK>P%PK_num_redshifts .or. NLL_redshifts(iNLL)>P%PK_redshifts(iPK)+tol) then
                    redshifts(i)=NLL_redshifts(iNLL)
                    iNLL=iNLL+1
                else
                    redshifts(i)=P%PK_redshifts(iPK)
                    this%PK_redshifts_index(iPK)=i
                    iPK=iPK+1
                    iNLL=iNLL+1
                end if
            end do
            this%num_transfer_redshifts=i
            allocate(this%transfer_redshifts(this%num_transfer_redshifts))
            this%transfer_redshifts = redshifts(:this%num_transfer_redshifts)
        end if
    end associate

    end subroutine GetComputedPKRedshifts

    subroutine CAMBdata_DarkEnergyStressEnergy(this, a, grhov_t, w, n)
    class(CAMBdata) :: this
    integer, intent(in) :: n
    real(dl), intent(in) :: a(n)
    real(dl), intent(out) :: grhov_t(n), w(n)
    integer i

    do i=1, n
        call this%CP%DarkEnergy%BackgroundDensityAndPressure(1._dl, a(i), grhov_t(i), w(i))
    end do
    grhov_t = grhov_t/a**2

    end subroutine CAMBdata_DarkEnergyStressEnergy

    function rofChi(this,Chi) !sinh(chi) for open, sin(chi) for closed.
    class(CAMBdata) :: this
    real(dl) Chi,rofChi

    if (this%flat) then
        rofChi=chi
    else if (this%closed) then
        rofChi=sin(chi)
    else
        rofChi=sinh(chi)
    endif
    end function rofChi


    function cosfunc (this,Chi)
    class(CAMBdata) :: this
    real(dl) Chi,cosfunc

    if (this%flat) then
        cosfunc = 1._dl
    else if (this%closed) then
        cosfunc= cos(chi)
    else
        cosfunc=cosh(chi)
    endif
    end function cosfunc

    function tanfunc(this,Chi)
    class(CAMBdata) :: this
    real(dl) Chi,tanfunc
    if (this%flat) then
        tanfunc=Chi
    else if (this%closed) then
        tanfunc=tan(Chi)
    else
        tanfunc=tanh(Chi)
    end if

    end function tanfunc

    function invsinfunc(this,x)
    class(CAMBdata) :: this
    real(dl) invsinfunc,x

    if (this%flat) then
        invsinfunc = x
    else if (this%closed) then
        invsinfunc=asin(x)
    else
        invsinfunc=log((x+sqrt(1._dl+x**2)))
    endif
    end function invsinfunc

    function dsound_da_exact(this,a)
    class(CAMBdata) :: this
    real(dl) dsound_da_exact,a,R,cs

    R = 3*this%grhob*a / (4*this%grhog)
    cs=1.0d0/sqrt(3*(1+R))
    dsound_da_exact=dtauda(this,a)*cs

    end function dsound_da_exact

    function dsound_da_approx(this,a)
    !approximate form used e.g. by CosmoMC for theta
    class(CAMBdata) :: this
    real(dl) dsound_da_approx,a,R,cs

    R=3.0d4*a*this%CP%ombh2
    !          R = 3*grhob*a / (4*grhog) //above is mostly within 0.2% and used for previous consistency
    cs=1.0d0/sqrt(3*(1+R))
    dsound_da_approx=dtauda(this,a)*cs

    end function dsound_da_approx

    function dtda(this,a)
    class(CAMBdata) :: this
    real(dl) dtda,a

    dtda= dtauda(this,a)*a
    end function

    function ddamping_da(this, a)
    class(CAMBdata) :: this
    real(dl) :: ddamping_da
    real(dl), intent(in) :: a
    real(dl) :: R

    R=this%ThermoData%r_drag0*a
    !ignoring reionisation, not relevant for distance measures
    ddamping_da = (R**2 + 16*(1+R)/15)/(1+R)**2*dtauda(this,a)*a**2/(this%CP%Recomb%x_e(a)*this%akthom)

    end function ddamping_da

    function noreion_doptdepth_dz(this,z)
    class(CAMBdata) :: this
    real(dl) :: noreion_doptdepth_dz
    real(dl), intent(in) :: z
    real(dl) :: a

    a = 1._dl/(1._dl+z)

    !ignoring reionisation, not relevant for distance measures
    noreion_doptdepth_dz = this%CP%Recomb%x_e(a)*this%akthom*dtauda(this,a)

    end function noreion_doptdepth_dz

    function noreion_optdepth(this,z)
    class(CAMBdata) :: this
    real(dl) noreion_optdepth
    real(dl),intent(in) :: z

    noreion_optdepth = Integrate_Romberg(this, noreion_doptdepth_dz, 0.d0, z, 1d-5, 20, 100)

    end function noreion_optdepth

    function ddragoptdepth_dz(this,z)
    class(CAMBdata) :: this
    real(dl) :: ddragoptdepth_dz
    real(dl), intent(in) :: z
    real(dl) :: a

    a = 1._dl/(1._dl+z)
    ddragoptdepth_dz = noreion_doptdepth_dz(this,z)/this%ThermoData%r_drag0/a

    end function ddragoptdepth_dz

    function dragoptdepth(this,z)
    class(CAMBdata) :: this
    real(dl) dragoptdepth
    real(dl),intent(in) :: z

    dragoptdepth =  Integrate_Romberg(this,ddragoptdepth_dz, 0.d0, z, 1d-5, 20, 100)

    end function dragoptdepth

    function reion_doptdepth_dz(this,z)
    class(CAMBdata) :: this
    real(dl) :: reion_doptdepth_dz
    real(dl), intent(in) :: z

    reion_doptdepth_dz = this%CP%Reion%x_e(z)*this%akthom*dtauda(this,1._dl/(1._dl+z))

    end function reion_doptdepth_dz

    function grho_no_de(this, a) result(grhoa2)
    !  Return 8*pi*G*rho_no_de*a**4 where rho_no_de includes everything except dark energy.
    class(CAMBdata) :: this
    real(dl), intent(in) :: a
    real(dl) grhoa2, rhonu
    integer nu_i

    grhoa2 = this%grhok * a**2 + (this%grhoc + this%grhob) * a + this%grhog + this%grhornomass

    if (this%CP%Num_Nu_massive /= 0) then
        !Get massive neutrino density relative to massless
        do nu_i = 1, this%CP%nu_mass_eigenstates
            call ThermalNuBack%rho(a * this%nu_masses(nu_i), rhonu)
            grhoa2 = grhoa2 + rhonu * this%grhormass(nu_i)
        end do
    end if

    end function grho_no_de

    function GetReionizationOptDepth(this)
    class(CAMBdata) :: this
    real(dl) GetReionizationOptDepth
    integer n
    real(dl) zstart, zend

    call this%CP%Reion%get_timesteps(n, zstart, zend)
    GetReionizationOptDepth = Integrate_Romberg(this, reion_doptdepth_dz,0.d0,zstart,&
        1d-5/this%CP%Accuracy%AccuracyBoost)

    end function GetReionizationOptDepth

    real(dl) function binary_search(this,func, goal, x1, x2, tol, widex1, widex2)
    !This is about twice as inefficient as Brent
    class(CAMBdata) :: this
    procedure(state_function) :: func
    real(dl), intent(in) :: goal,x1,x2,tol
    real(dl), intent(in), optional :: widex1, widex2 !Wider range in case of failure
    real(dl) try_t, try_b, avg, D_try, last_bot, last_top, diff
    integer count
    logical wide

    try_b = x1
    try_t = x2
    diff = tol*2
    count = 0
    wide = .false.
    do while (diff > tol)
        if (count>100) then
            if (.not. wide .and. present(widex1)) then
                count=0
                wide=.true.
                try_b=widex1
                try_t=widex2
            else
                call GlobalError(FormatString('binary_search (e.g for optical depth) did not converge: ' //&
                    'Base range %f-%f.',x1,x2),error_reionization)
                binary_search = 0
                return
            end if
        end if
        avg = (try_b+try_t)/2
        D_try = func(this,avg)
        count = count+1
        if (D_try < goal) then
            try_b = avg
            last_bot = D_try
        else
            try_t = avg
            last_top = D_try
        end if
        diff = abs(D_try - goal)
    end do
    if (try_b==x1) last_bot = func(this,x1)
    if (try_t==x2) last_top = func(this,x2)
    binary_search =  (try_t*(goal-last_bot) + try_b*(last_top-goal))/(last_top-last_bot)

    end function binary_search

    !Sources
    function WindowKmaxForL(W,CP, ell) result(res)
    class(CAMBparams), intent(in) :: CP
    Type(TRedWin), intent(in) :: W
    real(dl) res
    integer, intent(in)::  ell

    if (W%kind == window_lensing) then
        res = CP%Accuracy%AccuracyBoost*18*ell/W%chi0
    else
        !On large scales power can be aliased from smaller, so make sure k goes up until at least the turnover
        !in the matter power spectrum
        res = CP%Accuracy%AccuracyBoost*max(0.05_dl,2.5*ell/W%chimin)
    end if

    res = res* CP%Accuracy%KmaxBoost
    end function WindowKmaxForL


    function lSamples_indexOf(lSet,l)
    class(lSamples) :: lSet
    integer, intent(in) :: l
    integer lSamples_indexOf, i

    do i=2,lSet%nl
        if (l < lSet%l(i)) then
            lSamples_indexOf = i-1
            return
        end if
    end do
    lSamples_indexOf = lSet%nl

    end function  lSamples_indexOf

    subroutine lSamples_init(this, State, lmin, max_l)
    ! This subroutines initializes lSet%l arrays. Other values will be interpolated.
    class(lSamples) :: this
    class(CAMBdata), target :: State
    integer, intent(IN) :: lmin,max_l
    integer lind, lvar, step, top, bot, lmin_log
    integer, allocatable :: ls(:)
    real(dl) AScale

    allocate(ls(max_l))
    if (allocated(this%l)) deallocate(this%l)
    this%lmin = lmin
    this%use_spline_template = State%CP%use_cl_spline_template
    lmin_log = State%CP%min_l_logl_sampling
    associate(Accuracy => State%CP%Accuracy)
        Ascale=State%scale/Accuracy%lSampleBoost

        if (Accuracy%lSampleBoost >=50) then
            !just do all of them
            lind=0
            do lvar=lmin, max_l
                lind=lind+1
                ls(lind)=lvar
            end do
            this%nl=lind
            allocate(this%l(lind))
            this%l = ls(1:lind)
            return
        end if

        lind=0
        do lvar=lmin, 10
            lind=lind+1
            ls(lind)=lvar
        end do

        if (Accuracy%AccurateReionization) then
            do lvar=11, 14
                lind=lind+1
                ls(lind)=lvar
            end do
            if (Accuracy%lSampleBoost > 1) then
                do lvar=15, 37, 1
                    lind=lind+1
                    ls(lind)=lvar
                end do
            else
                do lvar=15, 37, 2
                    lind=lind+1
                    ls(lind)=lvar
                end do
            end if

            step = max(nint(5*Ascale),2)
            bot=40
            top=bot + step*10
        else
            if (Accuracy%lSampleBoost >1) then
                do lvar=11, 15
                    lind=lind+1
                    ls(lind)=lvar
                end do
            else
                lind=lind+1
                ls(lind)=12
                lind=lind+1
                ls(lind)=15
            end if
            step = max(nint(10*Ascale),3)
            bot=15+max(step/2,2)
            top=bot + step*7
        end if

        do lvar=bot, top, step
            lind=lind+1
            ls(lind)=lvar
        end do

        if (State%CP%Log_lvalues) then
            !Useful for generating smooth things like 21cm to high l
            step=max(nint(20*Ascale),4)
            do
                lvar = lvar + step
                if (lvar > max_l) exit
                lind=lind+1
                ls(lind)=lvar
                step = nint(step*1.2) !log spacing
            end do
        else
            step=max(nint(20*Ascale),4)
            bot=ls(lind)+step
            top=bot+step*2

            do lvar = bot,top,step
                lind=lind+1
                ls(lind)=lvar
            end do

            if (ls(lind)>=max_l) then
                do lvar=lind,1,-1
                    if (ls(lvar)<=max_l) exit
                end do
                lind=lvar
                if (ls(lind)<max_l) then
                    lind=lind+1
                    ls(lind)=max_l
                end if
            else
                step=max(nint(25*Ascale),4)
                !Get EE right around l=200 by putting extra point at 175
                bot=ls(lind)+step
                top=bot+step

                do lvar = bot,top,step
                    lind=lind+1
                    ls(lind)=lvar
                end do

                if (ls(lind)>=max_l) then
                    do lvar=lind,1,-1
                        if (ls(lvar)<=max_l) exit
                    end do
                    lind=lvar
                    if (ls(lind)<max_l) then
                        lind=lind+1
                        ls(lind)=max_l
                    end if
                else
                    if (.not. this%use_spline_template) then
                        step=max(nint(42*Ascale),7)
                    else
                        step=max(nint(50*Ascale),7)
                    end if
                    bot=ls(lind)+step
                    top=min(lmin_log,max_l)

                    do lvar = bot,top,step
                        lind=lind+1
                        ls(lind)=lvar
                    end do

                    if (max_l > lmin_log) then
                        !Should be pretty smooth or tiny out here
                        step=max(nint(400*Ascale),50)
                        lvar = ls(lind)
                        do
                            lvar = lvar + step
                            if (lvar > max_l) exit
                            lind=lind+1
                            ls(lind)=lvar
                            step = nint(step*1.5) !log spacing
                        end do
                        if (ls(lind) < max_l - 100) then
                            !Try to keep lensed spectra up to specified lmax
                            lind=lind+1
                            ls(lind)=max_l - lensed_convolution_margin
                        else if (ls(lind) - ls(lind-1) > lensed_convolution_margin) then
                            ls(lind)=max_l - lensed_convolution_margin
                        end if
                    end if
                end if !log_lvalues
                if (ls(lind) /=max_l) then
                    lind=lind+1
                    ls(lind)=max_l
                end if
                if (.not. State%flat .and. max_l<=lmin_log) ls(lind-1)=int(max_l+ls(lind-2))/2
                !Not in flat case so interpolation table is the same when using lower l_max
            end if
        end if
    end associate
    this%nl=lind
    allocate(this%l, source=ls(1:lind))

    end subroutine lSamples_init

    subroutine InterpolateClArr(lSet,iCl, all_Cl, max_index)
    class(lSamples), intent(in) :: lSet
    real(dl), intent(in) :: iCl(1:*)
    real(dl), intent(out):: all_Cl(lSet%lmin:*)
    integer, intent(in), optional :: max_index
    integer il,llo,lhi, xi
    real(dl) ddCl(lSet%nl)
    real(dl) xl(lSet%nl)
    real(dl) a0,b0,ho
    integer max_ind

    max_ind = PresentDefault(lSet%nl, max_index)

    if (max_ind > lSet%nl) call MpiStop('Wrong max_ind in InterpolateClArr')

    xl = real(lSet%l(1:lSet%nl),dl)
    call spline_def(xl,iCL,max_ind,ddCl)

    llo=1
    do il=lSet%lmin,lSet%l(max_ind)
        xi=il
        if ((xi > lSet%l(llo+1)).and.(llo < max_ind)) then
            llo=llo+1
        end if
        lhi=llo+1
        ho=lSet%l(lhi)-lSet%l(llo)
        a0=(lSet%l(lhi)-xi)/ho
        b0=(xi-lSet%l(llo))/ho

        all_Cl(il) = a0*iCl(llo)+ b0*iCl(lhi)+((a0**3-a0)* ddCl(llo) &
            +(b0**3-b0)*ddCl(lhi))*ho**2/6
    end do

    end subroutine InterpolateClArr

    subroutine InterpolateClArrTemplated(lSet,iCl, all_Cl, max_ind, template_index)
    class(lSamples), intent(in) :: lSet
    real(dl), intent(in) :: iCl(*)
    real(dl), intent(out):: all_Cl(lSet%lmin:*)
    integer, intent(in) :: max_ind
    integer, intent(in), optional :: template_index
    integer maxdelta, il
    real(dl) DeltaCL(lSet%nl)
    real(dl), allocatable :: tmpall(:)

    if (max_ind > lSet%nl) call MpiStop('Wrong max_ind in InterpolateClArrTemplated')
    if (lSet%use_spline_template .and. present(template_index)) then
        if (template_index<=3) then
            !interpolate only the difference between the C_l and an accurately interpolated template.
            !Using unlensed for template, seems to be good enough
            maxdelta=max_ind
            do while (lSet%l(maxdelta) > lmax_extrap_highl)
                maxdelta=maxdelta-1
            end do
            DeltaCL(1:maxdelta)=iCL(1:maxdelta)- highL_CL_template(lSet%l(1:maxdelta), template_index)

            call lSet%InterpolateClArr(DeltaCl, all_Cl, maxdelta)

            do il=lSet%lmin,lSet%l(maxdelta)
                all_Cl(il) = all_Cl(il) +  highL_CL_template(il,template_index)
            end do

            if (maxdelta < max_ind) then
                !directly interpolate high L where no t  emplate (doesn't effect lensing spectrum much anyway)
                allocate(tmpall(lSet%lmin:lSet%l(max_ind)))
                call InterpolateClArr(lSet,iCl, tmpall, max_ind)
                !overlap to reduce interpolation artefacts
                all_cl(lSet%l(maxdelta-2):lSet%l(max_ind) ) = tmpall(lSet%l(maxdelta-2):lSet%l(max_ind))
                deallocate(tmpall)
            end if
            return
        end if
    end if

    call InterpolateClArr(lSet,iCl, all_Cl, max_ind)

    end subroutine InterpolateClArrTemplated


    subroutine Thermo_values(this,tau, a, cs2b, opacity, dopacity)
    !Compute unperturbed sound speed squared,
    !and ionization fraction by interpolating pre-computed tables.
    !If requested also get time derivative of opacity
    class(TThermoData) :: this
    real(dl), intent(in) :: tau
    real(dl), intent(out) :: a, cs2b, opacity
    real(dl), intent(out), optional :: dopacity
    integer i
    real(dl) d

    d=log(tau/this%tauminn)/this%dlntau+1._dl
    i=int(d)
    d=d-i
    if (i < 1) then
        !Linear interpolation if out of bounds (should not occur).
        write(*,*) 'tau, taumin = ', tau, this%tauminn
        call MpiStop('thermo out of bounds')
    else if (i >= this%nthermo) then
        cs2b=this%cs2(this%nthermo)
        opacity=this%dotmu(this%nthermo)
        a=1
        if (present(dopacity)) then
            dopacity = this%ddotmu(this%nthermo)/(tau*this%dlntau)
        end if
    else
        cs2b=this%cs2(i)+d*(this%dcs2(i)+d*(3*(this%cs2(i+1)-this%cs2(i))  &
            -2*this%dcs2(i)-this%dcs2(i+1)+d*(this%dcs2(i)+this%dcs2(i+1)  &
            +2*(this%cs2(i)-this%cs2(i+1)))))
        opacity=this%dotmu(i)+d*(this%ddotmu(i)+d*(3*(this%dotmu(i+1)-this%dotmu(i)) &
            -2*this%ddotmu(i)-this%ddotmu(i+1)+d*(this%ddotmu(i)+this%ddotmu(i+1) &
            +2*(this%dotmu(i)-this%dotmu(i+1)))))
        a = (this%ScaleFactor(i)+d*(this%dScaleFactor(i)+d*(3*(this%ScaleFactor(i+1)-this%ScaleFactor(i)) &
            -2*this%dScaleFactor(i)-this%dScaleFactor(i+1)+d*(this%dScaleFactor(i)+this%dScaleFactor(i+1) &
            +2*(this%ScaleFactor(i)-this%ScaleFactor(i+1))))))*tau
        if (present(dopacity)) then
            dopacity=(this%ddotmu(i)+d*(this%dddotmu(i)+d*(3*(this%ddotmu(i+1)  &
                -this%ddotmu(i))-2*this%dddotmu(i)-this%dddotmu(i+1)+d*(this%dddotmu(i) &
                +this%dddotmu(i+1)+2*(this%ddotmu(i)-this%ddotmu(i+1))))))/(tau*this%dlntau)
        end if
    end if
    end subroutine Thermo_values

    subroutine Thermo_expansion_values(this, tau, a, adot, opacity)
    class(TThermoData) :: this
    real(dl), intent(in) :: tau
    real(dl), intent(out) :: a, adot, opacity
    integer i
    real(dl) d

    d=log(tau/this%tauminn)/this%dlntau+1._dl
    i=int(d)
    d=d-i
    if (i < 1) then
        call MpiStop('thermo out of bounds')
    else if (i >= this%nthermo) then
        opacity=this%dotmu(this%nthermo)
        a=1
        adot=this%adot(this%nthermo)
    else
        a = (this%ScaleFactor(i)+d*(this%dScaleFactor(i)+d*(3*(this%ScaleFactor(i+1)-this%ScaleFactor(i)) &
            -2*this%dScaleFactor(i)-this%dScaleFactor(i+1)+d*(this%dScaleFactor(i)+this%dScaleFactor(i+1) &
            +2*(this%ScaleFactor(i)-this%ScaleFactor(i+1))))))*tau

        adot = (this%adot(i)+d*(this%dadot(i)+d*(3*(this%adot(i+1)-this%adot(i)) &
            -2*this%dadot(i)-this%dadot(i+1)+d*(this%dadot(i)+this%dadot(i+1) &
            +2*(this%adot(i)-this%adot(i+1))))))

        opacity=this%dotmu(i)+d*(this%ddotmu(i)+d*(3*(this%dotmu(i+1)-this%dotmu(i)) &
            -2*this%ddotmu(i)-this%ddotmu(i+1)+d*(this%ddotmu(i)+this%ddotmu(i+1) &
            +2*(this%dotmu(i)-this%dotmu(i+1)))))
    end if

    end subroutine Thermo_expansion_values

    function Thermo_OpacityToTime(this,opacity)
    class(TThermoData) :: this
    real(dl), intent(in) :: opacity
    integer j
    real(dl) Thermo_OpacityToTime
    !Do this the bad slow way for now..
    !The answer is approximate
    j =1
    do while(this%dotmu(j)> opacity)
        j=j+1
    end do

    Thermo_OpacityToTime = exp((j-1)*this%dlntau)*this%tauminn

    end function Thermo_OpacityToTime

    subroutine Thermo_Init(this, State,taumin)
    !  Compute and save unperturbed baryon temperature and ionization fraction
    !  as a function of time.  With nthermo=10000, xe(tau) has a relative
    ! accuracy (numerical integration precision) better than 1.e-5.
    use constants
    use StringUtils
    class(TThermoData) :: this
    class(CAMBdata), target :: State
    real(dl), intent(in) :: taumin
    integer nthermo
    real(dl) tau01,a0,barssc,dtau
    real(dl) tau,a,a2
    real(dl) adot,fe,thomc0
    real(dl) dtbdla,vfi,cf1,maxvis, vis, z_scale
    integer ncount,i,j1,iv,ns
    real(dl), allocatable :: spline_data(:)
    real(dl) last_dotmu, om
    real(dl) a_verydom
    real(dl) awin_lens1p,awin_lens2p,dwing_lens, rs, DA
    real(dl) a_eq, rs_eq, tau_eq, rstar
    integer noutput
    Type(CalWins), dimension(:), allocatable, target :: RW
    real(dl) awin_lens1(State%num_redshiftwindows),awin_lens2(State%num_redshiftwindows)
    real(dl) Tspin, Trad, rho_fac, window, tau_eps
    integer transfer_ix(State%CP%Transfer%PK_num_redshifts)
    integer RW_i, j2
    real(dl) Tb21cm, winamp, z, background_boost
    character(len=:), allocatable :: outstr
    real(dl), allocatable ::  taus(:)
    real(dl), allocatable :: xe_a(:), sdotmu(:), opts(:)
    real(dl), allocatable :: scale_factors(:), times(:), dt(:)
    Type(TCubicSpline) :: dotmuSp
    integer ninverse, nlin
    real(dl) dlna, zstar_min, zstar_max
    real(dl) reion_z_start, reion_z_complete
    Type(CAMBParams), pointer :: CP

    CP => State%CP

    !Allocate memory outside parallel region to keep ifort happy
    background_boost = CP%Accuracy%BackgroundTimeStepBoost*CP%Accuracy%AccuracyBoost
    if (background_boost > 20) then
        write(*,*) 'Warning: very small time steps can give less accurate spline derivatives'
        write(*,*) 'e.g. around reionization if not matched very smoothly'
    end if
    !Higher q starts earlier; scale by log(taumin) so actual step size is not made worse by increasing k_max
    nthermo = nint(thermal_history_def_timesteps*log(1.4e4/taumin)/log(1.4e4/2e-4)*background_boost)
    this%tauminn=0.95d0*taumin
    this%dlntau=log(State%tau0/this%tauminn)/(nthermo-1)

    do RW_i = 1, State%num_redshiftwindows
        !Make sure steps small enough for any features in source window functions
        associate (Win => State%Redshift_w(RW_i))
            if ((Win%kind /= window_21cm .or. .not. CP%transfer_21cm_cl) .and. &
                Win%sigma_tau/5/background_boost < Win%tau*(exp(this%dlntau)-1)) then
                this%dlntau = log(Win%sigma_tau/5/background_boost/Win%tau+1)
                nthermo = nint(log(State%tau0/this%tauminn)/this%dlntau) + 1
                this%dlntau=log(State%tau0/this%tauminn)/(nthermo-1)
            end if
        end associate
    end do
    this%nthermo = nthermo
    allocate(spline_data(nthermo), sdotmu(nthermo))

    if (allocated(this%tb) .and. this%nthermo/=size(this%tb)) then
        deallocate(this%scaleFactor, this%cs2, this%dcs2, this%ddotmu)
        deallocate(this%dscaleFactor, this%adot, this%dadot)
        deallocate(this%tb, this%xe, this%emmu, this%dotmu)
        deallocate(this%demmu, this%dddotmu, this%ddddotmu)
        if (dowinlens .and. allocated(this%winlens)) deallocate(this%winlens, this%dwinlens)
    endif
    if (.not. allocated(this%tb)) then
        allocate(this%scaleFactor(nthermo), this%cs2(nthermo), this%dcs2(nthermo), this%ddotmu(nthermo))
        allocate(this%dscaleFactor(nthermo), this%adot(nthermo), this%dadot(nthermo))
        allocate(this%tb(nthermo), this%xe(nthermo), this%emmu(nthermo),this%dotmu(nthermo))
        allocate(this%demmu(nthermo), this%dddotmu(nthermo), this%ddddotmu(nthermo))
        if (dowinlens) allocate(this%winlens(nthermo), this%dwinlens(nthermo))
    end if

    if (State%num_redshiftwindows >0) then
        allocate(this%redshift_time(nthermo),this%dredshift_time(nthermo))
        allocate(this%arhos_fac(nthermo), this%darhos_fac(nthermo), this%ddarhos_fac(nthermo))
        allocate(RW(State%num_redshiftwindows))
    end if


    do RW_i = 1, State%num_redshiftwindows
        associate (RedWin => State%Redshift_w(RW_i))
            RedWin%tau_start = 0
            RedWin%tau_end = State%tau0
            if (RedWin%kind == window_lensing .or.  RedWin%kind == window_counts .and. CP%SourceTerms%counts_lensing) then
                allocate(RW(RW_i)%awin_lens(nthermo))
                allocate(RW(RW_i)%dawin_lens(nthermo))
            end if
        end associate
    end do
    om = (State%grhob+State%grhoc)/&
        sqrt(3*(State%grhog+sum(State%grhormass(1:CP%Nu_mass_eigenstates))+State%grhornomass))
    a0=this%tauminn*State%adotrad*(1+om*this%tauminn/4)
    ninverse = nint(background_boost*log(1/a0)/log(1/2d-10)*4000)
    if (.not. CP%DarkEnergy%is_cosmological_constant) ninverse = ninverse*2

    nlin = ninverse/2
    allocate(scale_factors(ninverse+nlin))
    allocate(times(ninverse+nlin))
    allocate(dt(ninverse+nlin))
    allocate(taus(nthermo), xe_a(nthermo))

    !$OMP PARALLEL SECTIONS DEFAULT(SHARED)
    !$OMP SECTION
    call CP%Recomb%Init(State,WantTSpin=CP%Do21cm)    !almost all the time spent here

    if (CP%Evolve_delta_xe) this%recombination_saha_tau  = State%TimeOfZ(CP%Recomb%get_saha_z(), tol=1e-4_dl)
    if (CP%Evolve_baryon_cs .or. CP%Evolve_delta_xe .or. CP%Evolve_delta_Ts .or. CP%Do21cm) &
        this%recombination_Tgas_tau = State%TimeOfz(1/CP%Recomb%min_a_evolve_Tm-1, tol=1e-4_dl)

    !$OMP SECTION
    !Do other stuff while recombination calculating
    awin_lens1=0
    awin_lens2=0
    transfer_ix =0

    call splini(spline_data,nthermo)

    this%tight_tau = 0
    this%actual_opt_depth = 0
    ncount=0
    this%z_drag=0.d0
    thomc0= Compton_CT * CP%tcmb**4
    this%r_drag0 = 3.d0/4.d0*State%grhob/State%grhog
    last_dotmu = 0

    this%matter_verydom_tau = 0
    a_verydom = CP%Accuracy%AccuracyBoost*5*(State%grhog+State%grhornomass)/(State%grhoc+State%grhob)
    if (CP%Reion%Reionization) then
        call CP%Reion%get_timesteps(State%reion_n_steps, reion_z_start, reion_z_complete)
        State%reion_tau_start = max(0.05_dl, State%TimeOfZ(reion_z_start, 1d-3))
        !Time when a very small reionization fraction (assuming tanh fitting)
        State%reion_tau_complete = min(State%tau0, &
            State%reion_tau_start+ State%DeltaTime(1/(1+reion_z_start),1/(1.d0+reion_z_complete),1d-3))
    else
        State%reion_tau_start = State%tau0
        State%reion_tau_complete = State%tau0
    end  if
    !  Initial conditions: assume radiation-dominated universe.
    !  Assume that any entropy generation occurs before tauminn.
    !  This gives wrong temperature before pair annihilation, but
    !  the error is harmless.

    !Get scale factor as function of time by inverting tau(a)
    dlna = log(0.2_dl/a0)/(ninverse-1)
    do i=2, ninverse-1
        scale_factors(1+i) = a0*exp((i-1)*dlna)
    end do
    scale_factors(1) = a0
    scale_factors(2) = a0*exp(dlna/3)
    da = 0.8_dl/(nlin-2)
    do i=1, nlin-2
        scale_factors(ninverse+i) = 0.2_dl + (i-1)*da
    end do
    scale_factors(ninverse+nlin-1) = 0.9_dl + 0.1_dl*scale_factors(ninverse+nlin-2)
    scale_factors(ninverse+nlin) = 1
    do i=1, ninverse+nlin
        dt(i) = dtauda(State,scale_factors(i))
    end do
    call this%ScaleFactorAtTime%Init(scale_factors, dt)
    call this%ScaleFactorATTime%IntegralArray(times(2), first_index=2)
    times(1) = this%tauminn
    times(2:) = times(2:) + 2*(sqrt(1 + om*scale_factors(2)/ State%adotrad) -1)/om
    times(ninverse+nlin) = State%tau0
    call This%ScaleFactorAtTime%Init(times, scale_factors)
    taus(1) = this%tauminn
    do i=2,nthermo-1
        taus(i) = this%tauminn*exp((i-1)*this%dlntau)
    end do
    taus(nthermo) = State%tau0
    call this%ScaleFactorAtTime%Array(taus(2:), this%scaleFactor(2:))
    this%scaleFactor(1) = a0
    this%scaleFactor(nthermo) = 1
    this%adot(1) = 1/dtauda(State,a0)

    tau01=this%tauminn
    do i=2,nthermo
        !Get recombination-independent parts of background now as function of conformal time tau
        !Now at the log spaced time steps
        tau=taus(i)
        dtau = tau-tau01
        a = this%scaleFactor(i)
        adot = 1/dtauda(State,a)
        this%adot(i) = adot
        if (this%matter_verydom_tau ==0 .and. a > a_verydom) then
            this%matter_verydom_tau = tau
        end if
        z= 1._dl/a-1._dl
        if (State%num_redshiftwindows>0) then
            this%redshift_time(i) = z
            do RW_i = 1, State%num_redshiftwindows
                associate (Win => RW(RW_i), RedWin => State%Redshift_w(RW_i))
                    if (a > 1d-4) then
                        window = RedWin%Window%Window_f_a(a, winamp)

                        if  (RedWin%kind == window_lensing .or.  RedWin%kind == window_counts  &
                            .and. CP%SourceTerms%counts_lensing) then
                            if (State%tau0 - tau > 2) then
                                dwing_lens =  adot * window *dtau
                                awin_lens1(RW_i) = awin_lens1(RW_i) + dwing_lens
                                awin_lens2(RW_i) = awin_lens2(RW_i) + dwing_lens/(State%tau0-tau)
                                Win%awin_lens(i) = awin_lens1(RW_i)/(State%tau0-tau) - awin_lens2(RW_i)
                            else
                                Win%awin_lens(i) = 0
                            end if
                        end if

                        if (RedWin%tau_start ==0 .and. winamp > 1e-8) then
                            RedWin%tau_start = tau01
                        else if (RedWin%tau_start /=0 .and. RedWin%tau_end==State%tau0 .and. winamp < 1e-8) then
                            RedWin%tau_end = min(State%tau0,tau + dtau)
                            if (DebugMsgs) call WriteFormat('Window %d: tau1 = %f, tau2 = %f',&
                                RW_i, RedWin%tau_start, RedWin%tau_end)
                        end if
                    else
                        if (RedWin%kind == window_lensing .or.  RedWin%kind == window_counts &
                            .and. CP%SourceTerms%counts_lensing) then
                            Win%awin_lens(i)=0
                        end if
                    end if
                end associate
            end do
        end if
        if (CP%WantTransfer .and.  CP%do21cm .and. CP%transfer_21cm_cl) then
            do RW_i = 1, CP%Transfer%PK_num_redshifts
                if (z< CP%Transfer%PK_redshifts(RW_i) .and. transfer_ix(RW_i)==0) then
                    transfer_ix(RW_i) = i
                end if
            end do
        end if
        tau01 =tau
    end do
    do RW_i = 1, State%num_redshiftwindows
        associate(Win => RW(RW_i))
            if (State%Redshift_w(RW_i)%kind == window_lensing .or. &
                State%Redshift_w(RW_i)%kind == window_counts .and. CP%SourceTerms%counts_lensing) then
                this%has_lensing_windows = .true.
                State%Redshift_w(RW_i)%has_lensing_window = .true.
                if (FeedbackLevel>0)  write(*,'(I1," Int W              = ",f9.6)') RW_i, awin_lens1(RW_i)
                Win%awin_lens=Win%awin_lens/awin_lens1(RW_i)
            else
                State%Redshift_w(RW_i)%has_lensing_window = .false.
            end if
        end associate
    end do
    !$OMP END PARALLEL SECTIONS

    if (global_error_flag/=0) return

    call CP%Recomb%xe_tm(a0,this%xe(1), this%tb(1))
    barssc=barssc0*(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*this%xe(1))
    this%cs2(1)=4._dl/3._dl*barssc*this%tb(1)
    this%dotmu(1)=this%xe(1)*State%akthom/a0**2


    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC,16)
    do i=2,nthermo
        call CP%Recomb%xe_tm(this%scaleFactor(i), xe_a(i), this%tb(i))
    end do

    do i=2,nthermo
        tau =taus(i)
        a = this%scaleFactor(i)
        a2=a*a
        adot=this%adot(i)

        if (State%num_redshiftwindows>0) then
            if (a > 1d-4) then
                if (CP%Do21cm ) then
                    Tspin = CP%Recomb%T_s(a)
                    Trad = CP%TCMB/a
                    rho_fac = line21_const*State%NNow/a**3
                    tau_eps = a*line21_const*State%NNow/a**3/(adot/a)/Tspin/1000
                    this%arhos_fac(i) = (1-exp(-tau_eps))/tau_eps*a*rho_fac*(1 - Trad/Tspin)/(adot/a)
                    !         arhos_fac(i) = a*rho_fac*(1 - Trad/Tspin)/(adot/a)
                else
                    rho_fac = State%grhoc/(a2*a)
                    this%arhos_fac(i) = a*rho_fac/(adot/a)
                end if
            end if
        end if

        ! If there is re-ionization, smoothly increase xe to the
        ! requested value.
        if (CP%Reion%Reionization .and. tau > State%reion_tau_start) then
            if(ncount == 0) then
                ncount=i-1
            end if
            this%xe(i) = CP%Reion%x_e(1/a-1, tau, this%xe(ncount))
            if (CP%Accuracy%AccurateReionization .and. CP%WantDerivedParameters) then
                this%dotmu(i)=(xe_a(i) - this%xe(i))*State%akthom/a2

                if (last_dotmu /=0) then
                    this%actual_opt_depth = this%actual_opt_depth - 2._dl*(tau-taus(i-1))/(1._dl/this%dotmu(i)+1._dl/last_dotmu)
                end if
                last_dotmu = this%dotmu(i)
            end if
        else
            this%xe(i)=xe_a(i)
        end if

        !  approximate Baryon sound speed squared (over c**2).
        fe=(1._dl-CP%yhe)*this%xe(i)/(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*this%xe(i))
        dtbdla=-2._dl*this%tb(i)
        if (a*this%tb(i)-CP%tcmb < -1e-8) then
            dtbdla= dtbdla -thomc0*fe/adot*(a*this%tb(i)-CP%tcmb)/a**3
        end if
        barssc=barssc0*(1._dl-0.75d0*CP%yhe+(1._dl-CP%yhe)*this%xe(i))
        this%cs2(i)=barssc*this%tb(i)*(1-dtbdla/this%tb(i)/3._dl)

        ! Calculation of the visibility function
        this%dotmu(i)=this%xe(i)*State%akthom/a2

        if (this%tight_tau==0 .and. 1/(tau*this%dotmu(i)) > 0.005) this%tight_tau = tau !0.005
        !Tight coupling switch time when k/opacity is smaller than 1/(tau*opacity)
    end do

    if (CP%Reion%Reionization .and. (this%xe(nthermo) < 0.999d0)) then
        write(*,*)'Warning: xe at redshift zero is < 1'
        write(*,*) 'Check input parameters an Reionization_xe'
        write(*,*) 'function in the Reionization module'
    end if

    !Integrate for optical depth
    call dotmuSp%Init(taus(nthermo:1:-1), this%dotmu(nthermo:1:-1))
    allocate(opts(nthermo))
    call dotmuSp%IntegralArray(opts)
    sdotmu = opts(nthermo:1:-1)
    do j1=1,nthermo
        if (sdotmu(j1)< -69) then
            this%emmu(j1)=1.d-30
        else
            this%emmu(j1)=exp(sdotmu(j1))
            if (CP%Reion%Reionization .and. .not. CP%Accuracy%AccurateReionization .and. &
                this%actual_opt_depth==0 .and. this%xe(j1) < 1e-3) then
                this%actual_opt_depth = -sdotmu(j1)
            end if
        end if
    end do
    z_scale =  COBE_CMBTemp/CP%TCMB
    zstar_min = 700._dl * z_scale
    zstar_max = 2000._dl * z_scale
    if ((.not. CP%Reion%Reionization .or. CP%Accuracy%AccurateReionization) .and. CP%WantDerivedParameters) then
        do j1=nint(log(100/this%tauminn)/this%dlntau),nthermo
            if (-sdotmu(j1) - this%actual_opt_depth < 1) then
                !Bracket z_star
                zstar_min = 1/this%scaleFactor(j1+1)-1
                zstar_max = 1/this%scaleFactor(j1-2)-1
                exit
            end if
        end do
    end if

    if (CP%WantTransfer .and.  CP%do21cm .and. CP%transfer_21cm_cl) then
        if (allocated(State%optical_depths_for21cm)) deallocate(State%optical_depths_for21cm)
        allocate(State%optical_depths_for21cm(CP%Transfer%PK_num_redshifts))
        do RW_i = 1, CP%Transfer%PK_num_redshifts
            if (CP%Transfer%PK_Redshifts(RW_i) < 1e-3) then
                State%optical_depths_for21cm(RW_i) = 0 !zero may not be set correctly in transfer_ix
            else
                State%optical_depths_for21cm(RW_i) =  -sdotmu(transfer_ix(RW_i))
            end if
        end do
    end if

    if (CP%Reion%Reionization .and. CP%Accuracy%AccurateReionization &
        .and. FeedbackLevel > 0 .and. CP%WantDerivedParameters) then
        write(*,'("Reion opt depth      = ",f7.4)') this%actual_opt_depth
    end if

    iv=0
    vfi=0._dl
    ! Getting the starting and finishing times for decoupling and time of maximum visibility
    if (ncount == 0) then
        cf1=1._dl
        ns=nthermo
    else
        cf1=exp(-sdotmu(ncount))
        ns=ncount
    end if
    maxvis = 0
    do j1=1,ns
        vis = this%emmu(j1)*this%dotmu(j1)
        tau = taus(j1)
        vfi=vfi+vis*cf1*this%dlntau*tau
        if ((iv == 0).and.(vfi > 1.0d-7/CP%Accuracy%AccuracyBoost)) then
            State%taurst=9._dl/10._dl*tau
            iv=1
        elseif (iv == 1) then
            if (vis > maxvis) then
                maxvis=vis
                State%tau_maxvis = tau
            end if
            if (vfi > 0.995) then
                State%taurend=tau
                iv=2
                exit
            end if
        end if
    end do

    if (iv /= 2) then
        call GlobalError('ThemoData Init: failed to find end of recombination',error_reionization)
        return
    end if

    if (dowinlens) then
        vfi=0
        awin_lens1p=0
        awin_lens2p=0
        this%winlens=0
        do j1=1,nthermo-1
            vis = this%emmu(j1)*this%dotmu(j1)
            tau = this%tauminn* taus(j1)
            vfi=vfi+vis*cf1*this%dlntau*tau
            if (vfi < 0.995) then
                dwing_lens =  vis*cf1*this%dlntau*tau / 0.995

                awin_lens1p = awin_lens1p + dwing_lens
                awin_lens2p = awin_lens2p + dwing_lens/(State%tau0-tau)
            end if
            this%winlens(j1)= awin_lens1p/(State%tau0-tau) - awin_lens2p
        end do
    end if

    ! Calculating the timesteps during recombination.

    if (CP%WantTensors) then
        State%dtaurec=min(State%dtaurec,State%taurst/160)/CP%Accuracy%AccuracyBoost
    else
        State%dtaurec=min(State%dtaurec,State%taurst/40)/CP%Accuracy%AccuracyBoost
        if (do_bispectrum .and. hard_bispectrum) State%dtaurec = State%dtaurec / 4
    end if

    if (CP%Reion%Reionization) State%taurend=min(State%taurend,State%reion_tau_start)

    if (DebugMsgs) then
        write (*,*) 'taurst, taurend = ', State%taurst, State%taurend
    end if

    !$OMP PARALLEL SECTIONS DEFAULT(SHARED)
    !$OMP SECTION
    call splder(this%dotmu,this%ddotmu,nthermo,spline_data)
    call splder(this%ddotmu,this%dddotmu,nthermo,spline_data)
    call splder(this%dddotmu,this%ddddotmu,nthermo,spline_data)
    if (CP%want_zstar .or. CP%WantDerivedParameters) &
        this%z_star = State%binary_search(noreion_optdepth, 1.d0, zstar_min, zstar_max, &
        & 1d-3/background_boost, 100._dl*z_scale, 4000._dl*z_scale)
    !$OMP SECTION
    call splder(this%cs2,this%dcs2,nthermo,spline_data)
    call splder(this%emmu,this%demmu,nthermo,spline_data)
    call splder(this%adot,this%dadot,nthermo,spline_data)
    if (dowinlens) call splder(this%winlens,this%dwinlens,nthermo,spline_data)
    if (CP%want_zdrag .or. CP%WantDerivedParameters) &
        this%z_drag = State%binary_search(dragoptdepth, 1.d0, 800*z_scale, &
        & max(zstar_max*1.1_dl,1200._dl*z_scale), 2d-3/background_boost, 100.d0*z_scale, 4000._dl*z_scale)
    !$OMP SECTION
    this%ScaleFactor(:) = this%scaleFactor/taus !a/tau
    this%dScaleFactor(:) = (this%adot - this%ScaleFactor)*this%dlntau !derivative of a/tau
    if (State%num_redshiftwindows >0) then
        call splder(this%redshift_time,this%dredshift_time,nthermo,spline_data)
        call splder(this%arhos_fac,this%darhos_fac,nthermo,spline_data)
        call splder(this%darhos_fac,this%ddarhos_fac,nthermo,spline_data)
        do j2 = 1, State%num_redshiftwindows
            if (State%Redshift_w(j2)%has_lensing_window) then
                call splder(RW(j2)%awin_lens,RW(j2)%dawin_lens,nthermo,spline_data)
            end if
        end do
    end if
    call this%SetTimeSteps(State,State%TimeSteps)
    !$OMP END PARALLEL SECTIONS

    if (State%num_redshiftwindows>0) then
        !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC)
        do j2=1,State%TimeSteps%npoints
            call this%DoWindowSpline(State,j2,State%TimeSteps%points(j2), RW)
        end do
        !$OMP END PARALLEL DO
        call this%SetTimeStepWindows(State,State%TimeSteps)
    end if

    if (CP%WantDerivedParameters) then
        associate(ThermoDerivedParams => State%ThermoDerivedParams)
            !$OMP PARALLEL SECTIONS DEFAULT(SHARED)
            !$OMP SECTION
            ThermoDerivedParams( derived_Age ) = State%DeltaPhysicalTimeGyr(0.0_dl,1.0_dl)
            rstar =State%sound_horizon(this%z_star)
            ThermoDerivedParams( derived_rstar ) = rstar
            DA = State%AngularDiameterDistance(this%z_star)/(1/(this%z_star+1))
            ThermoDerivedParams( derived_zdrag ) = this%z_drag
            !$OMP SECTION
            rs =State%sound_horizon(this%z_drag)
            ThermoDerivedParams( derived_rdrag ) = rs
            ThermoDerivedParams( derived_kD ) =  &
                sqrt(1.d0/(Integrate_Romberg(State,ddamping_da, 1d-8, 1/(this%z_star+1), 1d-6)/6))
            !$OMP SECTION
            ThermoDerivedParams( derived_zEQ ) = State%z_eq
            a_eq = 1/(1+State%z_eq)
            ThermoDerivedParams( derived_kEQ ) = 1/(a_eq*dtauda(State,a_eq))
            rs_eq = State%sound_horizon(State%z_eq)
            tau_eq = State%timeOfz(State%z_eq)
            !$OMP SECTION
            !$OMP END PARALLEL SECTIONS

            ThermoDerivedParams( derived_zstar ) = this%z_star
            ThermoDerivedParams( derived_thetastar ) = 100*rstar/DA
            ThermoDerivedParams( derived_DAstar ) = DA/1000
            ThermoDerivedParams( derived_thetaEQ ) = 100*tau_eq/DA
            ThermoDerivedParams( derived_theta_rs_EQ ) = 100*rs_EQ/DA
            ThermoDerivedParams( derived_thetaD ) =  100*const_pi/ThermoDerivedParams( derived_kD )/DA

            if (allocated(CP%z_outputs)) then
                if (allocated(State%BackgroundOutputs%H)) &
                    deallocate(State%BackgroundOutputs%H, State%BackgroundOutputs%DA, State%BackgroundOutputs%rs_by_D_v)
                noutput = size(CP%z_outputs)
                allocate(State%BackgroundOutputs%H(noutput), State%BackgroundOutputs%DA(noutput), &
                    State%BackgroundOutputs%rs_by_D_v(noutput))
                !$OMP PARALLEL DO DEFAULT(shared)
                do i=1,noutput
                    State%BackgroundOutputs%H(i) = State%HofZ(CP%z_outputs(i))
                    State%BackgroundOutputs%DA(i) = State%AngularDiameterDistance(CP%z_outputs(i))
                    State%BackgroundOutputs%rs_by_D_v(i) = rs/BAO_D_v_from_DA_H(CP%z_outputs(i), &
                        State%BackgroundOutputs%DA(i),State%BackgroundOutputs%H(i))
                end do
            end if

            if (FeedbackLevel > 0) then
                write(*,'("Age of universe/GYr  = ",f7.3)') ThermoDerivedParams( derived_Age )
                write(*,'("zstar                = ",f8.2)') ThermoDerivedParams( derived_zstar )
                write(*,'("r_s(zstar)/Mpc       = ",f7.2)') ThermoDerivedParams( derived_rstar )
                write(*,'("100*theta            = ",f9.6)') ThermoDerivedParams( derived_thetastar )
                write(*,'("DA(zstar)/Gpc        = ",f9.5)') ThermoDerivedParams( derived_DAstar )

                write(*,'("zdrag                = ",f8.2)') ThermoDerivedParams( derived_zdrag )
                write(*,'("r_s(zdrag)/Mpc       = ",f7.2)') ThermoDerivedParams( derived_rdrag )

                write(*,'("k_D(zstar) Mpc       = ",f7.4)') ThermoDerivedParams( derived_kD )
                write(*,'("100*theta_D          = ",f9.6)') ThermoDerivedParams( derived_thetaD )

                write(*,'("z_EQ (if v_nu=1)     = ",f8.2)') ThermoDerivedParams( derived_zEQ )
                write(*,'("k_EQ Mpc (if v_nu=1) = ",f9.6)') ThermoDerivedParams( derived_kEQ )
                write(*,'("100*theta_EQ         = ",f9.6)') ThermoDerivedParams( derived_thetaEQ )
                write(*,'("100*theta_rs_EQ      = ",f9.6)') ThermoDerivedParams( derived_theta_rs_EQ )
            end if
        end associate
    end if

    !Sources
    if(State%num_redshiftwindows>0) then
        deallocate(RW,this%arhos_fac, this%darhos_fac, this%ddarhos_fac)
        deallocate(this%redshift_time, this%dredshift_time)
        do RW_i = 1, State%num_redshiftwindows
            associate (RedWin => State%Redshift_W(RW_i))
                if (RedWin%kind == window_21cm) then
                    outstr = 'z= '//trim(RealToStr(real(RedWin%Redshift),4))//': T_b = '//trim(RealToStr(real(RedWin%Fq),6))// &
                        'mK; tau21 = '//trim(RealToStr(real(RedWin%optical_depth_21),5))
                    write (*,*) RW_i,trim(outstr)
                end if
            end associate
        end do
    end if

    if (CP%Do21cm .and. CP%transfer_21cm_cl) then
        do RW_i=1,CP%Transfer%PK_num_redshifts
            a=1._dl/(1+CP%Transfer%PK_redshifts(RW_i))
            Tspin = CP%Recomb%T_s(a)
            Trad = CP%TCMB/a
            adot = 1/dtauda(State,a)
            tau_eps = a**2*line21_const*State%NNow/a**3/adot/Tspin/1000
            Tb21cm = 1000*(1-exp(-tau_eps))*a*(Tspin-Trad)
            if (FeedbackLevel>0) then
                outstr = 'z= '//trim(RealToStr(real(CP%Transfer%PK_redshifts(RW_i))))// &
                    ': tau_21cm = '//trim(RealToStr(real(tau_eps),5))//'; T_b = '//trim(RealToStr(real(Tb21cm),6))//'mK'
                write (*,*) trim(outstr)
            end if
        end do
    end if

    this%HasThermoData = .true.
    end subroutine Thermo_Init


    subroutine SetTimeSteps(this,State,TimeSteps)
    !Set time steps to use for sampling the source functions for the CMB power spectra
    class(TThermoData) :: this
    Type(TRanges) :: TimeSteps
    class(CAMBdata) State
    real(dl) dtau0
    integer nri0, nstep
    !Sources
    integer ix,i,nwindow, L_limb
    real(dl) keff, win_end, TimeSampleBoost, delta

    TimeSampleBoost = State%CP%Accuracy%AccuracyBoost*State%CP%Accuracy%TimeStepBoost
    call TimeSteps%Init()

    call TimeSteps%Add_delta(State%taurst, State%taurend, State%dtaurec)

    ! Calculating the timesteps after recombination
    if (State%CP%WantTensors) then
        dtau0=max(State%taurst/40,State%tau0/2000._dl/TimeSampleBoost)
    else
        dtau0=State%tau0/500._dl/TimeSampleBoost
        if (do_bispectrum) dtau0 = dtau0/3
        !Don't need this since adding in Limber on small scales
        !  if (CP%DoLensing) dtau0=dtau0/2
        !  if (CP%AccurateBB) dtau0=dtau0/3 !Need to get C_Phi accurate on small scales
    end if

    call TimeSteps%Add_delta(State%taurend, State%tau0, dtau0)

    !Sources

    this%tau_start_redshiftwindows = State%tau0
    this%tau_end_redshiftwindows = 0
    if (State%CP%WantScalars .or. State%CP%SourceTerms%line_reionization) then
        do ix=1, State%num_redshiftwindows
            associate (Win => State%Redshift_W(ix))

                Win%tau_start = max(Win%tau_start,state%taurst)

                if (Win%kind /= window_lensing) then
                    !Have to be careful to integrate dwinV as the window tails off
                    this%tau_end_redshiftwindows = max(Win%tau_end,this%tau_end_redshiftwindows)
                    nwindow = nint(150*TimeSampleBoost)
                    win_end = Win%tau_end
                else !lensing
                    nwindow = nint(TimeSampleBoost*Win%chi0/100)
                    win_end = State%tau0
                end if

                if (Win%kind == window_21cm .and. (State%CP%SourceTerms%line_phot_dipole .or. &
                    State%CP%SourceTerms%line_phot_quadrupole)) nwindow = nwindow *3

                L_limb = Win_limber_ell(Win,State%CP,State%CP%max_l)
                keff = WindowKmaxForL(Win,State%CP,L_limb)

                !Keep sampling in x better than Nyquist
                nwindow = max(nwindow, nint(TimeSampleBoost *(win_end- Win%tau_start)* keff/3))
                if (Win%kind /= window_lensing .and. Win%sigma_tau < (win_end - Win%tau_start)/nwindow*8) then
                    nwindow = nint(TimeSampleBoost*(win_end - Win%tau_start)/Win%sigma_tau*8)
                end if
                if (Feedbacklevel > 1 .or. DebugMsgs) call WriteFormat('nwindow %d: %d', ix, nwindow)
                delta = (win_end-Win%tau_start)/nwindow
                Win%tau_start = Win%tau_start - delta*3
                win_end = min(State%tau0, win_end+delta*2)

                this%tau_start_redshiftwindows = min(Win%tau_start,this%tau_start_redshiftwindows)

                call TimeSteps%Add(Win%tau_start, win_end, nwindow)
                !This should cover whole range where not tiny

                if (Win%kind /= window_lensing  .and. &
                    Win%tau_peakend-Win%tau_peakstart < nint(60*TimeSampleBoost) * delta) then
                    call TimeSteps%Add(Win%tau_peakstart,Win%tau_peakend, nint(60*TimeSampleBoost))
                    !This should be over peak
                end if
            end associate
        end do
    end if


    if (State%CP%Reion%Reionization) then
        nri0=int(State%reion_n_steps*State%CP%Accuracy%AccuracyBoost)
        !Steps while reionization going from zero to maximum
        call TimeSteps%Add(State%reion_tau_start,State%reion_tau_complete,nri0)
    end if

    !Sources
    if (.not. State%CP%Want_CMB .and. State%CP%WantCls) then
        if (State%num_redshiftwindows==0) then
            call GlobalError('Want_CMB=false and WantCls=true, but no redshift windows either', &
                error_unsupported_params)
        else
            call TimeSteps%Add_delta(this%tau_start_redshiftwindows, State%tau0, dtau0)
        endif
    end if

    if (global_error_flag/=0) then
        return
    end if



    !Create arrays out of the region information.
    call TimeSteps%GetArray()
    nstep = TimeSteps%npoints

    if (State%num_redshiftwindows > 0) then
        if (allocated(this%step_redshift)) deallocate(this%step_redshift, this%rhos_fac, this%drhos_fac)
        allocate(this%step_redshift(nstep), this%rhos_fac(nstep), this%drhos_fac(nstep))
        do i=1,State%num_redshiftwindows
            associate (Win => State%Redshift_W(i))
                allocate(Win%winF(nstep),Win%wing(nstep),Win%dwing(nstep),Win%ddwing(nstep), &
                    Win%winV(nstep),Win%dwinV(nstep),Win%ddwinV(nstep))
                allocate(Win%win_lens(nstep),Win%wing2(nstep),Win%dwing2(nstep),Win%ddwing2(nstep))
                allocate(Win%wingtau(nstep),Win%dwingtau(nstep),Win%ddwingtau(nstep))
                if (Win%kind == window_counts) then
                    allocate(Win%comoving_density_ev(nstep))
                end if
            end associate
        end do
    end if

    if (DebugMsgs .and. FeedbackLevel > 0) call WriteFormat('Set %d time steps', nstep)

    end subroutine SetTimeSteps

    subroutine SetTimeStepWindows(this,State,TimeSteps)
    use constants
    class(TThermoData) :: this
    class(CAMBdata) :: State
    Type(TRanges) :: TimeSteps
    integer i, j, jstart, ix
    real(dl) tau, a, a2
    real(dl) Tspin, Trad, rho_fac, tau_eps
    real(dl) window, winamp
    real(dl) z,rhos, adot, exp_fac
    real(dl) tmp(TimeSteps%npoints), tmp2(TimeSteps%npoints), hubble_tmp(TimeSteps%npoints)
    real(dl), allocatable , dimension(:,:) :: int_tmp, back_count_tmp
    integer ninterp

    ! Prevent false positive warnings for uninitialized
    Tspin = 0._dl
    Trad = 0._dl
    tau_eps = 0._dl
    exp_fac = 0._dl

    jstart = TimeSteps%IndexOf(this%tau_start_redshiftwindows)
    ninterp = TimeSteps%npoints - jstart + 1

    do i = 1, State%num_redshiftwindows
        associate (RedWin => State%Redshift_W(i))
            RedWin%wing=0
            RedWin%winV=0
            RedWin%winF=0
            RedWin%wing2=0
            RedWin%dwing=0
            RedWin%dwinV=0
            RedWin%dwing2=0
            RedWin%ddwing=0
            RedWin%ddwinV=0
            RedWin%ddwing2=0
            RedWin%wingtau=0
            RedWin%dwingtau=0
            RedWin%ddwingtau=0
            RedWin%Fq = 0
            if (RedWin%kind == window_counts) then
                RedWin%comoving_density_ev  = 0
            end if
        end associate
    end do

    allocate(int_tmp(jstart:TimeSteps%npoints,State%num_redshiftwindows))
    int_tmp = 0
    allocate(back_count_tmp(jstart:TimeSteps%npoints,State%num_redshiftwindows))
    back_count_tmp = 0

    do j=jstart, TimeSteps%npoints
        tau = TimeSteps%points(j)
        z = this%step_redshift(j)
        a = 1._dl/(1._dl+z)
        a2=a**2
        adot=1._dl/dtauda(State,a)


        if (State%CP%Do21cm) then
            Tspin = State%CP%Recomb%T_s(a)
            Trad = State%CP%TCMB/a
            rho_fac = line21_const*State%NNow/a**3 !neglect ionization fraction
            tau_eps = a*rho_fac/(adot/a)/Tspin/1000
            exp_fac =  (1-exp(-tau_eps))/tau_eps
        else
            rho_fac = State%grhoc/a**3
        end if

        hubble_tmp(j) = adot/a

        do i = 1, State%num_redshiftwindows
            associate (RedWin => State%Redshift_W(i))
                if (tau < RedWin%tau_start) cycle

                window = RedWin%Window%Window_f_a(a, winamp)

                if (RedWin%kind == window_21cm) then
                    rhos = rho_fac*(1 - Trad/Tspin)

                    !Want to integrate this...
                    int_tmp(j,i) = this%drhos_fac(j)*a*window

                    RedWin%WinV(j) = -exp(-tau_eps)*a2*rhos*window/(adot/a)

                    RedWin%wing(j) = exp_fac*a2*rhos*window

                    !The window that doesn't go to zero at T_s = T_gamma
                    RedWin%wing2(j) = exp_fac*a2*rho_fac*Trad/Tspin*window

                    !Window for tau_s for the self-absoption term
                    RedWin%wingtau(j) =  RedWin%wing(j)*(1 - exp(-tau_eps)/exp_fac)
                elseif (RedWin%kind == window_counts) then

                    !window is n(a) where n is TOTAL not fractional number
                    !delta = int wing(eta) delta(eta) deta
                    RedWin%wing(j) = adot *window

                    !Window with 1/H in
                    RedWin%wing2(j) = RedWin%wing(j)/(adot/a)

                    !winv is g/chi for the ISW and time delay terms
                    RedWin%WinV(j) = 0
                    if (tau < State%tau0 -0.1) then
                        int_tmp(j,i) = RedWin%wing(j)/(State%tau0 - tau)
                    else
                        int_tmp(j,i)=0
                    end if

                    if (State%CP%SourceTerms%counts_evolve) then
                        back_count_tmp(j,i) =  RedWin%Window%counts_background_z(1/a-1)/a
                        if (tau < State%tau0 -0.1) then
                            RedWin%comoving_density_ev(j) = back_count_tmp(j,i)*(adot/a)/(State%tau0 - tau)**2
                        else
                            RedWin%comoving_density_ev(j) = 0
                        end if
                    end if
                end if
            end associate
        end do
    end do

    do i = 1, State%num_redshiftwindows
        associate (RedWin => State%Redshift_W(i))

            ! int (a*rho_s/H)' a W_f(a) d\eta, or for counts int g/chi deta
            call spline_def(TimeSteps%points(jstart:),int_tmp(jstart:,i),ninterp,tmp)
            call spline_integrate(TimeSteps%points(jstart:),int_tmp(jstart:,i),tmp, tmp2(jstart:),ninterp)
            RedWin%WinV(jstart:TimeSteps%npoints) =  &
                RedWin%WinV(jstart:TimeSteps%npoints) + tmp2(jstart:TimeSteps%npoints)

            call spline_def(TimeSteps%points(jstart:),RedWin%WinV(jstart:),ninterp,RedWin%ddWinV(jstart:))
            call spline_deriv(TimeSteps%points(jstart:),RedWin%WinV(jstart:),RedWin%ddWinV(jstart:), RedWin%dWinV(jstart:), ninterp)

            call spline_def(TimeSteps%points(jstart:),RedWin%Wing(jstart:),ninterp,RedWin%ddWing(jstart:))
            call spline_deriv(TimeSteps%points(jstart:),RedWin%Wing(jstart:),RedWin%ddWing(jstart:), RedWin%dWing(jstart:), ninterp)

            call spline_def(TimeSteps%points(jstart:),RedWin%Wing2(jstart:),ninterp,RedWin%ddWing2(jstart:))
            call spline_deriv(TimeSteps%points(jstart:),RedWin%Wing2(jstart:),RedWin%ddWing2(jstart:), &
                RedWin%dWing2(jstart:), ninterp)

            call spline_integrate(TimeSteps%points(jstart:),RedWin%Wing(jstart:), &
                RedWin%ddWing(jstart:), RedWin%WinF(jstart:),ninterp)
            RedWin%Fq = RedWin%WinF(TimeSteps%npoints)

            if (RedWin%kind == window_21cm) then
                call spline_integrate(TimeSteps%points(jstart:),RedWin%Wing2(jstart:),&
                    RedWin%ddWing2(jstart:), tmp(jstart:),ninterp)
                RedWin%optical_depth_21 = tmp(TimeSteps%npoints) / (State%CP%TCMB*1000)
                !WinF not used.. replaced below

                call spline_def(TimeSteps%points(jstart:),RedWin%Wingtau(jstart:),ninterp,RedWin%ddWingtau(jstart:))
                call spline_deriv(TimeSteps%points(jstart:),RedWin%Wingtau(jstart:),RedWin%ddWingtau(jstart:), &
                    RedWin%dWingtau(jstart:), ninterp)
            elseif (RedWin%kind == window_counts) then

                if (State%CP%SourceTerms%counts_evolve) then
                    call spline_def(TimeSteps%points(jstart:),back_count_tmp(jstart:,i),ninterp,tmp)
                    call spline_deriv(TimeSteps%points(jstart:),back_count_tmp(jstart:,i),tmp,tmp2(jstart:),ninterp)
                    do ix = jstart, TimeSteps%npoints
                        if (RedWin%Wing(ix)==0._dl) then
                            RedWin%Wingtau(ix) = 0
                        else
                            !evo bias is computed with total derivative
                            RedWin%Wingtau(ix) =  -tmp2(ix) * RedWin%Wing(ix) / (back_count_tmp(ix,i)*hubble_tmp(ix)) &
                                !+ 5*RedWin%dlog10Ndm * ( RedWin%Wing(ix)- int_tmp(ix,i)/hubble_tmp(ix))
                                !The correction from total to partial derivative takes 1/adot(tau0-tau) cancels
                                + 10*RedWin%Window%dlog10Ndm * RedWin%Wing(ix)
                        end if
                    end do

                    !comoving_density_ev is d log(a^3 n_s)/d eta * window
                    call spline_def(TimeSteps%points(jstart:),RedWin%comoving_density_ev(jstart:),ninterp,tmp)
                    call spline_deriv(TimeSteps%points(jstart:),RedWin%comoving_density_ev(jstart:),tmp,tmp2(jstart:),ninterp)
                    do ix = jstart, TimeSteps%npoints
                        if (RedWin%Wing(ix)==0._dl) then
                            RedWin%comoving_density_ev(ix) = 0
                        elseif (RedWin%comoving_density_ev(ix)/=0._dl) then
                            !correction needs to be introduced from total derivative to partial derivative
                            RedWin%comoving_density_ev(ix) =   tmp2(ix) / RedWin%comoving_density_ev(ix) &
                                -5*RedWin%Window%dlog10Ndm * ( hubble_tmp(ix) + int_tmp(ix,i)/RedWin%Wing(ix))
                        end if
                    end do
                else
                    RedWin%comoving_density_ev=0
                    call spline_def(TimeSteps%points(jstart:),hubble_tmp(jstart:),ninterp,tmp)
                    call spline_deriv(TimeSteps%points(jstart:),hubble_tmp(jstart:),tmp, tmp2(jstart:), ninterp)

                    !assume d( a^3 n_s) of background population is zero, so remaining terms are
                    !wingtau =  g*(2/H\chi + Hdot/H^2)  when s=0; int_tmp = window/chi
                    RedWin%Wingtau(jstart:TimeSteps%npoints) = &
                        2*(1-2.5*RedWin%Window%dlog10Ndm)*int_tmp(jstart:TimeSteps%npoints,i)/&
                        hubble_tmp(jstart:TimeSteps%npoints)&
                        + 5*RedWin%Window%dlog10Ndm*RedWin%Wing(jstart:TimeSteps%npoints) &
                        + tmp2(jstart:TimeSteps%npoints)/hubble_tmp(jstart:TimeSteps%npoints)**2 &
                        *RedWin%Wing(jstart:TimeSteps%npoints)
                endif

                call spline_def(TimeSteps%points(jstart:),RedWin%Wingtau(jstart:),ninterp, &
                    RedWin%ddWingtau(jstart:))
                call spline_deriv(TimeSteps%points(jstart:),RedWin%Wingtau(jstart:),RedWin%ddWingtau(jstart:), &
                    RedWin%dWingtau(jstart:), ninterp)

                !WinF is int[ g*(...)]
                call spline_integrate(TimeSteps%points(jstart:),RedWin%Wingtau(jstart:),&
                    RedWin%ddWingtau(jstart:), RedWin%WinF(jstart:),ninterp)
            end if
        end associate
    end do

    end subroutine SetTimeStepWindows


    subroutine interp_window(TimeSteps,RedWin,tau,wing_t, wing2_t, winv_t)
    !for evolving sources for reionization we neglect wingtau self-absorption
    Type(TRanges) :: TimeSteps
    Type(TRedWin)  :: RedWin
    integer i
    real(dl) :: tau, wing_t, wing2_t,winv_t
    real(dl) a0,b0,ho

    i = TimeSteps%IndexOf(tau)
    if (i< TimeSteps%npoints) then
        ho=TimeSteps%points(i+1)-TimeSteps%points(i)
        a0=(TimeSteps%points(i+1)-tau)/ho
        b0=1-a0
        wing_t = a0*RedWin%wing(i)+ b0*RedWin%wing(i+1)+((a0**3-a0)* RedWin%ddwing(i) &
            +(b0**3-b0)*RedWin%ddwing(i+1))*ho**2/6
        wing2_t = a0*RedWin%wing2(i)+ b0*RedWin%wing2(i+1)+((a0**3-a0)* RedWin%ddwing2(i) &
            +(b0**3-b0)*RedWin%ddwing2(i+1))*ho**2/6
        winv_t = a0*RedWin%winv(i)+ b0*RedWin%winv(i+1)+((a0**3-a0)* RedWin%ddwinv(i) &
            +(b0**3-b0)*RedWin%ddwinv(i+1))*ho**2/6
    else
        wing_t = 0
        wing2_t = 0
        winv_t = 0
    end if
    end subroutine interp_window

    subroutine DoWindowSpline(this,State,j2,tau, RW)
    class(TThermoData) :: this
    class(CAMBdata) :: State
    integer j2, i, RW_i
    real(dl) d, tau
    Type(CalWins) :: RW(:)

    !     Cubic-spline interpolation.
    d=log(tau/this%tauminn)/this%dlntau+1._dl
    i=int(d)

    d=d-i
    if (i < this%nthermo) then

        this%step_redshift(j2) = this%redshift_time(i)+d*(this%dredshift_time(i)+ &
            d*(3._dl*(this%redshift_time(i+1)-this%redshift_time(i)) &
            -2._dl*this%dredshift_time(i)-this%dredshift_time(i+1)+d*(this%dredshift_time(i)+this%dredshift_time(i+1) &
            +2._dl*(this%redshift_time(i)-this%redshift_time(i+1)))))

        this%rhos_fac(j2) = this%arhos_fac(i)+d*(this%darhos_fac(i)+d*(3._dl*(this%arhos_fac(i+1)-this%arhos_fac(i)) &
            -2._dl*this%darhos_fac(i)-this%darhos_fac(i+1)+d*(this%darhos_fac(i)+this%darhos_fac(i+1) &
            +2._dl*(this%arhos_fac(i)-this%arhos_fac(i+1)))))
        this%drhos_fac(j2) = (this%darhos_fac(i)+d*(this%ddarhos_fac(i)+d*(3._dl*(this%darhos_fac(i+1)  &
            -this%darhos_fac(i))-2._dl*this%ddarhos_fac(i)-this%ddarhos_fac(i+1)+d*(this%ddarhos_fac(i) &
            +this%ddarhos_fac(i+1)+2._dl*(this%darhos_fac(i)-this%darhos_fac(i+1))))))/(tau &
            *this%dlntau)

        do RW_i=1, State%num_redshiftwindows
            if (State%Redshift_w(RW_i)%has_lensing_window) then
                associate(W => State%Redshift_W(RW_i), C=> RW(RW_i))

                    W%win_lens(j2) = C%awin_lens(i)+d*(C%dawin_lens(i)+d*(3._dl*(C%awin_lens(i+1)-C%awin_lens(i)) &
                        -2._dl*C%dawin_lens(i)-C%dawin_lens(i+1)+d*(C%dawin_lens(i)+C%dawin_lens(i+1) &
                        +2._dl*(C%awin_lens(i)-C%awin_lens(i+1)))))
                end associate
            end if
        end do

    else
        this%step_redshift(j2) = 0
        this%rhos_fac(j2)=0
        this%drhos_fac(j2)=0
        do RW_i=1, State%num_redshiftwindows
            associate (W => State%Redshift_W(RW_i))
                W%win_lens(j2)=0
            end associate
        end do
    end if

    end subroutine DoWindowSpline

    subroutine IonizationFunctionsAtTime(this,tau, a, opac, dopac, ddopac, &
        vis, dvis, ddvis, expmmu, lenswin)
    class(TThermoData) :: this
    real(dl), intent(in) :: tau
    real(dl), intent(out):: a, opac, dopac, ddopac, vis, dvis, ddvis, expmmu, lenswin
    real(dl) d, cs2
    integer i

    call this%Values(tau,a,cs2,opac,dopac)

    d=log(tau/this%tauminn)/this%dlntau+1._dl
    i=int(d)
    d=d-i

    if (i < this%nthermo) then
        ddopac=(this%dddotmu(i)+d*(this%ddddotmu(i)+d*(3._dl*(this%dddotmu(i+1) &
            -this%dddotmu(i))-2._dl*this%ddddotmu(i)-this%ddddotmu(i+1)  &
            +d*(this%ddddotmu(i)+this%ddddotmu(i+1)+2._dl*(this%dddotmu(i) &
            -this%dddotmu(i+1)))))-(this%dlntau**2)*tau*dopac) &
            /(tau*this%dlntau)**2
        expmmu=this%emmu(i)+d*(this%demmu(i)+d*(3._dl*(this%emmu(i+1)-this%emmu(i)) &
            -2._dl*this%demmu(i)-this%demmu(i+1)+d*(this%demmu(i)+this%demmu(i+1) &
            +2._dl*(this%emmu(i)-this%emmu(i+1)))))

        if (dowinlens) then
            lenswin=this%winlens(i)+d*(this%dwinlens(i)+d*(3._dl*(this%winlens(i+1)-this%winlens(i)) &
                -2._dl*this%dwinlens(i)-this%dwinlens(i+1)+d*(this%dwinlens(i)+this%dwinlens(i+1) &
                +2._dl*(this%winlens(i)-this%winlens(i+1)))))
        end if
        vis=opac*expmmu
        dvis=expmmu*(opac**2+dopac)
        ddvis=expmmu*(opac**3+3*opac*dopac+ddopac)
    else
        ddopac=this%dddotmu(this%nthermo)
        expmmu=this%emmu(this%nthermo)
        vis=opac*expmmu
        dvis=expmmu*(opac**2+dopac)
        ddvis=expmmu*(opac**3+3._dl*opac*dopac+ddopac)
    end if

    end subroutine IonizationFunctionsAtTime

    subroutine Init_ClTransfer(CTrans)
    !Need to set the Ranges array q before calling this
    Type(ClTransferData) :: CTrans
    integer st

    deallocate(CTrans%Delta_p_l_k, STAT = st)
    call CTrans%q%getArray(.true.)

    allocate(CTrans%Delta_p_l_k(CTrans%NumSources,&
        min(CTrans%max_index_nonlimber,CTrans%ls%nl), CTrans%q%npoints), STAT = st)
    if (st /= 0) call MpiStop('Init_ClTransfer: Error allocating memory for transfer functions')
    CTrans%Delta_p_l_k = 0

    end subroutine Init_ClTransfer

    subroutine Init_Limber(CTrans,State)
    Type(ClTransferData) :: CTrans
    class(CAMBdata) :: State

    call Free_Limber(Ctrans)
    allocate(CTrans%Limber_l_min(CTrans%NumSources))
    CTrans%Limber_l_min = 0
    if (State%num_redshiftwindows>0 .or. State%CP%SourceTerms%limber_phi_lmin>0) then
        allocate(CTrans%Limber_windows(CTrans%NumSources,CTrans%ls%nl))
    end if

    end subroutine Init_Limber

    subroutine Free_ClTransfer(CTrans)
    Type(ClTransferData) :: CTrans

    if (allocated(CTrans%Delta_p_l_k)) deallocate(CTrans%Delta_p_l_k)
    call CTrans%q%Free()
    call Free_Limber(CTrans)

    end subroutine Free_ClTransfer

    subroutine Free_Limber(CTrans)
    Type(ClTransferData) :: CTrans

    if (allocated(CTrans%Limber_l_min)) deallocate(CTrans%Limber_l_min)
    if (allocated(CTrans%Limber_windows)) deallocate(CTrans%Limber_windows)

    end subroutine Free_Limber


    function Win_Limber_ell(W,CP,lmax) result(ell_limb)
    Type(TRedWin) :: W
    Type(CAMBParams) :: CP
    integer, intent(in) :: lmax
    integer ell_limb
    real(dl) LimBoost

    if (CP%SourceTerms%limber_windows) then
        LimBoost = CP%Accuracy%AccuracyBoost*CP%Accuracy%SourceLimberBoost
        !Turn on limber when k is a scale smaller than window width
        if (W%kind==window_lensing) then
            ell_limb = max(CP%SourceTerms%limber_phi_lmin,nint(50*LimBoost))
        else
            ell_limb = max(CP%SourceTerms%limber_phi_lmin, nint(LimBoost*6*W%chi0/W%sigma_tau))
        end if
    else
        ell_limb = lmax
    end if
    end function Win_Limber_ell


    subroutine TCLdata_InitCls(this, State)
    class(TCLData) :: this
    class(CAMBdata) :: State

    associate(CP=>State%CP)
        call CheckLoadedHighLTemplate
        if (CP%WantScalars) then
            if (allocated(this%Cl_scalar)) deallocate(this%Cl_scalar)
            allocate(this%Cl_scalar(CP%Min_l:CP%Max_l, C_Temp:State%Scalar_C_last), source=0._dl)
            if (CP%want_cl_2D_array) then
                if (allocated(this%Cl_scalar_array)) deallocate(this%Cl_scalar_array)
                allocate(this%Cl_scalar_Array(CP%Min_l:CP%Max_l, &
                    3+State%num_redshiftwindows+CP%CustomSources%num_custom_sources, &
                    3+State%num_redshiftwindows+CP%CustomSources%num_custom_sources))
                this%Cl_scalar_array = 0
            end if
        end if

        if (CP%WantVectors) then
            if (allocated(this%Cl_vector)) deallocate(this%Cl_vector)
            allocate(this%Cl_vector(CP%Min_l:CP%Max_l, CT_Temp:CT_Cross), source=0._dl)
        end if

        if (CP%WantTensors) then
            if (allocated(this%Cl_tensor)) deallocate(this%Cl_tensor)
            allocate(this%Cl_tensor(CP%Max_l_tensor, CT_Temp:CT_Cross), source=0._dl)
        end if
    end associate

    end subroutine TCLdata_InitCls

    function open_file_header(filename, Col1, Columns, n) result(unit)
    character(LEN=*), intent(in) :: filename
    character(LEN=*), intent(in) :: col1
    character(LEN=name_tag_len), intent(in) :: Columns(:)
    integer, intent(in), optional :: n
    integer :: unit, nn

    nn = PresentDefault(6, n)

    open(newunit=unit,file=filename,form='formatted',status='replace')
    if (output_file_headers) then
        write(unit,'("#",1A'//Trim(IntToStr(nn-1))//'," ",*(A15))') Col1, Columns
    end if

    end function open_file_header


    function scalar_fieldname(i)
    integer, intent(in) :: i
    character(LEN=5) :: scalar_fieldname
    character(LEN=3), parameter :: scalar_fieldnames = 'TEP'

    if (i<=3) then
        scalar_fieldname = scalar_fieldnames(i:i)
    else
        scalar_fieldname = 'W'//trim(IntToStr(i-3))
    end if

    end function scalar_fieldname

    subroutine TCLdata_output_cl_files(this, State, ScalFile,ScalCovFile,TensFile, TotFile, LensFile, LensTotFile, factor)
    class(TCLData) :: this
    class(CAMBdata), target :: State
    character(LEN=*) ScalFile, TensFile, TotFile, LensFile, LensTotFile,ScalCovfile
    real(dl), intent(in), optional :: factor
    real(dl) :: fact
    integer :: last_C, il, i, j, unit
    real(dl), allocatable :: outarr(:,:)
    character(LEN=name_tag_len) :: cov_names((3+State%num_redshiftwindows)**2)
    Type(CAMBParams), pointer :: CP
    integer lmin

    CP=> State%CP
    lmin= CP%Min_l

    fact = PresentDefault(1._dl, factor)

    if (CP%WantScalars .and. ScalFile /= '') then
        last_C=min(C_PhiTemp,State%Scalar_C_last)
        unit = open_file_header(ScalFile, 'L', C_name_tags(:last_C))
        do il=lmin,min(10000,CP%Max_l)
            write(unit,trim(numcat('(1I6,',last_C))//'E15.6)')il ,fact*this%Cl_scalar(il,C_Temp:last_C)
        end do
        do il=10100,CP%Max_l, 100
            write(unit,trim(numcat('(1E15.6,',last_C))//'E15.6)') real(il),&
                fact*this%Cl_scalar(il,C_Temp:last_C)
        end do
        close(unit)
    end if

    if (CP%WantScalars .and. CP%want_cl_2D_array .and. ScalCovFile /= '' .and. this%CTransScal%NumSources>2) then
        allocate(outarr(1:3+State%num_redshiftwindows,1:3+State%num_redshiftwindows))

        do i=1, 3+State%num_redshiftwindows
            do j=1, 3+State%num_redshiftwindows
                cov_names(j + (i-1)*(3+State%num_redshiftwindows)) = trim(scalar_fieldname(i))//'x'//trim(scalar_fieldname(j))
            end do
        end do
        unit = open_file_header(ScalCovFile, 'L', cov_names)

        do il=lmin,min(10000,CP%Max_l)
            outarr=this%Cl_scalar_array(il,1:3+State%num_redshiftwindows,1:3+State%num_redshiftwindows)
            outarr(1:2,:)=sqrt(fact)*outarr(1:2,:)
            outarr(:,1:2)=sqrt(fact)*outarr(:,1:2)
            write(unit,trim(numcat('(1I6,',(3+State%num_redshiftwindows)**2))//'E15.6)') il, real(outarr)
        end do
        do il=10100,CP%Max_l, 100
            outarr=this%Cl_scalar_array(il,1:3+State%num_redshiftwindows,1:3+State%num_redshiftwindows)
            outarr(1:2,:)=sqrt(fact)*outarr(1:2,:)
            outarr(:,1:2)=sqrt(fact)*outarr(:,1:2)
            write(unit,trim(numcat('(1E15.5,',(3+State%num_redshiftwindows)**2))//'E15.6)') real(il), real(outarr)
        end do
        close(unit)
        deallocate(outarr)
    end if

    if (CP%WantTensors .and. TensFile /= '') then
        unit = open_file_header(TensFile, 'L', CT_name_tags)
        do il=lmin,CP%Max_l_tensor
            write(unit,'(1I6,4E15.6)')il, fact*this%Cl_tensor(il, CT_Temp:CT_Cross)
        end do
        close(unit)
    end if

    if (CP%WantTensors .and. CP%WantScalars .and. TotFile /= '') then
        unit = open_file_header(TotFile, 'L', CT_name_tags)
        do il=lmin,CP%Max_l_tensor
            write(unit,'(1I6,4E15.6)')il, fact*(this%Cl_scalar(il, C_Temp:C_E)+ this%Cl_tensor(il,C_Temp:C_E)), &
                fact*this%Cl_tensor(il, CT_B), fact*(this%Cl_scalar(il, C_Cross) + this%Cl_tensor(il, CT_Cross))
        end do
        do il=CP%Max_l_tensor+1,CP%Max_l
            write(unit,'(1I6,4E15.6)')il ,fact*this%Cl_scalar(il,C_Temp:C_E), 0._dl, fact*this%Cl_scalar(il,C_Cross)
        end do
        close(unit)
    end if

    if (CP%WantScalars .and. CP%DoLensing .and. LensFile /= '') then
        unit = open_file_header(LensFile, 'L', CT_name_tags)
        do il=lmin, this%lmax_lensed
            write(unit,'(1I6,4E15.6)')il, fact*this%Cl_lensed(il, CT_Temp:CT_Cross)
        end do
        close(unit)
    end if


    if (CP%WantScalars .and. CP%WantTensors .and. CP%DoLensing .and. LensTotFile /= '') then
        unit = open_file_header(LensTotFile, 'L', CT_name_tags)
        do il=lmin,min(CP%Max_l_tensor,this%lmax_lensed)
            write(unit,'(1I6,4E15.6)')il, fact*(this%Cl_lensed(il,CT_Temp:CT_Cross)+ &
                this%Cl_tensor(il, CT_Temp:CT_Cross))
        end do
        do il=min(CP%Max_l_tensor,this%lmax_lensed)+1,this%lmax_lensed
            write(unit,'(1I6,4E15.6)')il, fact*this%Cl_lensed(il, CT_Temp:CT_Cross)
        end do
        close(unit)
    end if
    end subroutine TCLdata_output_cl_files

    subroutine TCLdata_output_lens_pot_files(this,CP, LensPotFile, factor)
    !Write out L TT EE BB TE PP PT PE where P is the lensing potential, all unlensed
    !This input supported by LensPix from 2010
    class(TCLdata) :: this
    Type(CAMBParams), intent(in) :: CP
    integer :: il, unit
    real(dl), intent(in), optional :: factor
    real(dl) fact, scale, BB, TT, TE, EE
    character(LEN=*), intent(in) :: LensPotFile
    !output file of dimensionless [l(l+1)]^2 C_phi_phi/2pi and [l(l+1)]^(3/2) C_phi_T/2pi
    !This is the format used by Planck_like but original LensPix uses scalar_output_file.

    !(Cl_scalar and scalar_output_file numbers are instead l^4 C_phi and l^3 C_phi
    ! - for historical reasons)

    fact = PresentDefault(1._dl, factor)

    if (CP%WantScalars .and. CP%DoLensing .and. LensPotFile/='') then
        unit = open_file_header(LensPotFile, 'L', lens_pot_name_tags)
        do il=CP%Min_l, min(10000,CP%Max_l)
            TT = this%Cl_scalar(il, C_Temp)
            EE = this%Cl_scalar(il, C_E)
            TE = this%Cl_scalar(il, C_Cross)
            if (CP%WantTensors .and. il <= CP%Max_l_tensor) then
                TT= TT+this%Cl_tensor(il, CT_Temp)
                EE= EE+this%Cl_tensor(il, CT_E)
                TE= TE+this%Cl_tensor(il, CT_Cross)
                BB= this%Cl_tensor(il, CT_B)
            else
                BB=0
            end if
            scale = (real(il+1)/il)**2/OutputDenominator !Factor to go from old l^4 factor to new

            write(unit,'(1I6,7E15.6)') il , fact*TT, fact*EE, fact*BB, fact*TE, scale*this%Cl_scalar(il,C_Phi),&
                (real(il+1)/il)**1.5/OutputDenominator*sqrt(fact)*this%Cl_scalar(il,C_PhiTemp:C_PhiE)
        end do
        do il=10100,CP%Max_l, 100
            scale = (real(il+1)/il)**2/OutputDenominator
            write(unit,'(1E15.5,7E15.6)') real(il), fact*this%Cl_scalar(il,C_Temp:C_E),0.,&
                fact*this%Cl_scalar(il,C_Cross), scale*this%Cl_scalar(il,C_Phi),&
                (real(il+1)/il)**1.5/OutputDenominator*sqrt(fact)*this%Cl_scalar(il,C_PhiTemp:C_PhiE)
        end do
        close(unit)
    end if
    end subroutine TCLdata_output_lens_pot_files


    subroutine TCLdata_output_veccl_files(this, CP,VecFile, factor)
    class(TCLData) :: this
    integer :: il, unit
    Type(CAMBParams), intent(in) :: CP
    character(LEN=*), intent(in) :: VecFile
    real(dl), intent(in), optional :: factor
    real(dl) :: fact

    fact = PresentDefault(1._dl, factor)

    if (CP%WantVectors .and. VecFile /= '') then
        unit = open_file_header(VecFile, 'L', CT_name_tags)
        do il=CP%Min_l,CP%Max_l
            write(unit,'(1I6,4E15.6)')il, fact*this%Cl_vector(il, CT_Temp:CT_Cross)
        end do
        close(unit)
    end if

    end subroutine TCLdata_output_veccl_files

    subroutine TCLdata_NormalizeClsAtL(this,CP,lnorm)
    class(TCLData) :: this
    Type(CAMBParams), intent(in) :: CP
    integer, intent(IN) :: lnorm
    real(dl) Norm

    if (CP%WantScalars) then
        Norm=1/this%Cl_scalar(lnorm, C_Temp)
        this%Cl_scalar(CP%Min_l:CP%Max_l, C_Temp:C_Cross) = this%Cl_scalar(CP%Min_l:CP%Max_l, C_Temp:C_Cross) * Norm
    end if

    if (CP%WantTensors) then
        if (.not.CP%WantScalars) Norm = 1/this%Cl_tensor(lnorm, C_Temp)
        !Otherwise Norm already set correctly
        this%Cl_tensor(CP%Min_l:CP%Max_l_tensor, CT_Temp:CT_Cross) =  &
            this%Cl_tensor(CP%Min_l:CP%Max_l_tensor, CT_Temp:CT_Cross) * Norm
    end if

    end subroutine TCLdata_NormalizeClsAtL

    end module results


    module Transfer
    !Module for matter transfer function/matter power spectrum
    use results
    implicit none
    public
    integer, parameter :: Transfer_kh =1, Transfer_cdm=2,Transfer_b=3,Transfer_g=4, &
        Transfer_r=5, Transfer_nu = 6,  & !massless and massive neutrino
        Transfer_tot=7, Transfer_nonu=8, Transfer_tot_de=9,  &
        ! total perturbations with and without neutrinos, with neutrinos+dark energy in the numerator
        Transfer_Weyl = 10, & ! the Weyl potential, for lensing and ISW
        Transfer_Newt_vel_cdm=11, Transfer_Newt_vel_baryon=12,   & ! -k v_Newtonian/H
        Transfer_vel_baryon_cdm = 13 !relative velocity of baryons and CDM
    !Sources
    !Alternatively for 21cm
    integer, parameter :: Transfer_monopole=4, Transfer_vnewt=5, Transfer_Tmat = 6

    integer, parameter :: Transfer_max = Transfer_vel_baryon_cdm
    character(LEN=name_tag_len) :: Transfer_name_tags(Transfer_max-1) = &
        ['CDM     ', 'baryon  ', 'photon  ', 'nu      ', 'mass_nu ', 'total   ', &
        'no_nu   ', 'total_de', 'Weyl    ', 'v_CDM   ', 'v_b     ', 'v_b-v_c ']
    character(LEN=name_tag_len) :: Transfer21cm_name_tags(Transfer_max-1) = &
        ['CDM      ', 'baryon   ', 'photon   ', 'monopole ', 'v_newt   ', 'delta_T_g', &
        'no_nu    ', 'total_de ', 'Weyl     ', 'v_CDM    ', 'v_b      ', 'v_b-v_c  ']

    logical :: transfer_interp_matterpower  = .true. !output regular grid in log k
    !set to false to output calculated values for later interpolation

    integer :: transfer_power_var = Transfer_tot
    !What to use to calulcate the output matter power spectrum and sigma_8
    !Transfer_tot uses total matter perturbation

    !Sources
    Type Cl21cmVars
        Type(MatterPowerData), pointer :: PK
        integer l, itf
        logical logs
        real(dl) chi
    end Type Cl21cmVars

    interface Transfer_GetMatterPower
    module procedure Transfer_GetMatterPowerD,Transfer_GetMatterPowerS
    end interface

    contains

    subroutine Transfer_GetUnsplinedPower(State, M, PK,var1,var2, hubble_units)
    !Get 2pi^2/k^3 T_1 T_2 P_R(k)
    Type(MatterTransferData) :: M
    Type(CAMBdata) :: State
    real(dl), intent(inout):: PK(:,:)
    integer, optional, intent(in) :: var1
    integer, optional, intent(in) :: var2
    logical, optional, intent(in) :: hubble_units
    real(dl) :: h, k
    integer :: nz, nk, zix, ik, s1, s2
    logical :: hnorm

    s1 = PresentDefault (transfer_power_var, var1)
    s2 = PresentDefault (transfer_power_var, var2)
    hnorm = DefaultTrue (hubble_units)

    nk=M%num_q_trans
    nz=State%CP%Transfer%PK_num_redshifts
    if (nk/= size(PK,1) .or. nz/=size(PK,2)) call MpiStop('Trasfer_GetUnsplinedPower wrong size')
    h = State%CP%H0/100

    if (s1==transfer_power_var .and. s2==transfer_power_var .and. allocated(State%CAMB_Pk)) then
        !Already computed
        do zix=1,nz
            PK(:,zix) = exp(State%CAMB_pk%matpower(:, State%PK_redshifts_index(nz-zix+1)))
        end do
        if (.not. hnorm) PK=  PK / h**3
    else

        do ik=1,nk
            k = M%TransferData(Transfer_kh,ik,1)*h
            do zix=1,nz
                PK(ik,zix) = M%TransferData(s1,ik,State%PK_redshifts_index(nz-zix+1))*&
                    M%TransferData(s2,ik,State%PK_redshifts_index(nz-zix+1))*k*&
                    const_pi*const_twopi*State%CP%InitPower%ScalarPower(k)
            end do
        end do

        if (hnorm) PK=  PK * h**3
    end if

    end subroutine Transfer_GetUnsplinedPower

    subroutine Transfer_GetNonLinRatio_index(State,M, ratio, itf)
    Type(MatterTransferData), intent(in) :: M
    Type(CAMBdata) :: State
    real(dl), allocatable, intent(out) :: ratio(:)
    integer, intent(in) :: itf
    Type(MatterPowerData) :: PKdata

    if (allocated(State%CAMB_PK)) then
        allocate(ratio, source = State%CAMB_PK%nonlin_ratio(:,itf))
    else
        call Transfer_GetMatterPowerData(State, M, PKdata,itf)
        call State%CP%NonLinearModel%GetNonLinRatios(State,PKdata)
        allocate(ratio, source = PKdata%nonlin_ratio(:,1))
    end if
    end subroutine Transfer_GetNonLinRatio_index


    subroutine Transfer_GetUnsplinedNonlinearPower(State,M, PK,var1,var2, hubble_units)
    !Get 2pi^2/k^3 T_1 T_2 P_R(k) after re-scaling for non-linear evolution (if turned on)
    Type(MatterTransferData), intent(in) :: M
    Type(CAMBdata) :: State
    real(dl), intent(inout):: PK(:,:)
    integer, optional, intent(in) :: var1
    integer, optional, intent(in) :: var2
    logical, optional, intent(in) :: hubble_units
    integer zix
    real(dl), allocatable :: ratio(:)

    if (.not. allocated(State%CAMB_Pk) .and. State%CP%Transfer%PK_num_redshifts == State%num_transfer_redshifts &
        .and. .not. State%OnlyTransfer) then
        allocate(State%CAMB_PK)
        call Transfer_GetMatterPowerData(State, State%MT, State%CAMB_PK)
        call State%CP%NonLinearModel%GetNonLinRatios(State, State%CAMB_PK)
    end if

    call Transfer_GetUnsplinedPower(State,M,PK,var1,var2, hubble_units)
    do zix=1, State%CP%Transfer%PK_num_redshifts
        call Transfer_GetNonLinRatio_index(State, M, ratio,State%PK_redshifts_index(State%CP%Transfer%PK_num_redshifts-zix+1))
        PK(:,zix) =  PK(:,zix) *ratio**2
    end do

    end subroutine Transfer_GetUnsplinedNonlinearPower

    subroutine Transfer_GetMatterPowerData(State, MTrans, PK_data, itf_only, var1, var2)
    !Does *NOT* include non-linear corrections
    !Get total matter power spectrum in units of (h Mpc^{-1})^3 ready for interpolation.
    !Here the definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
    !spectrum is generated to beyond the CMB k_max
    class(CAMBdata) :: State
    Type(MatterTransferData), intent(in) :: MTrans
    Type(MatterPowerData) :: PK_data
    integer, intent(in), optional :: itf_only
    integer, intent(in), optional :: var1, var2
    real(dl) :: h, kh, k, power
    integer :: ik, nz, itf, itf_start, itf_end, s1, s2

    s1 = PresentDefault (transfer_power_var, var1)
    s2 = PresentDefault (transfer_power_var, var2)

    if (present(itf_only)) then
        itf_start=itf_only
        itf_end = itf_only
        nz = 1
    else
        itf_start=1
        nz= size(MTrans%TransferData,3)
        itf_end = nz
    end if
    PK_data%num_k = MTrans%num_q_trans
    PK_Data%num_z = nz

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%nonlin_ratio(PK_data%num_k,nz))
    allocate(PK_data%log_kh(PK_data%num_k))
    allocate(PK_data%redshifts(nz))
    PK_data%redshifts = State%Transfer_Redshifts(itf_start:itf_end)

    h = State%CP%H0/100

    do ik=1,MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,1)
        k = kh*h
        PK_data%log_kh(ik) = log(kh)
        power = State%CP%InitPower%ScalarPower(k)
        if (global_error_flag/=0) then
            call MatterPowerdata_Free(PK_data)
            return
        end if
        do itf = 1, nz
            PK_data%matpower(ik,itf) = &
                log(MTrans%TransferData(s1,ik,itf_start+itf-1)*&
                MTrans%TransferData(s2,ik,itf_start+itf-1)*k &
                *const_pi*const_twopi*h**3*power)
        end do
    end do

    call MatterPowerdata_getsplines(PK_data)

    end subroutine Transfer_GetMatterPowerData

    subroutine MatterPowerData_Load(PK_data,fname)
    !Loads in kh, P_k from file for one redshiftr and one initial power spectrum
    !Not redshift is not stored in file, so not set correctly
    !Also note that output _matterpower file is already interpolated, so re-interpolating is probs not a good idea

    !Get total matter power spectrum in units of (h Mpc^{-1})^3 ready for interpolation.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    use FileUtils
    character(LEN=*) :: fname
    type(MatterPowerData) :: PK_data
    type(TTextFile) :: F
    real(dl)kh, Pk
    integer ik
    integer nz

    nz = 1
    call F%Open(fname)

    PK_data%num_k = F%Lines()
    PK_Data%num_z = 1

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%nonlin_ratio(PK_data%num_k,nz))
    allocate(PK_data%log_kh(PK_data%num_k))

    allocate(PK_data%redshifts(nz))
    PK_data%redshifts = 0

    do ik=1,PK_data%num_k
        read (F%unit, *) kh, Pk
        PK_data%matpower(ik,1) = log(Pk)
        PK_data%log_kh(ik) = log(kh)
    end do

    call MatterPowerdata_getsplines(PK_data)
    call F%Close()

    end subroutine MatterPowerData_Load


    subroutine MatterPowerdata_getsplines(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i

    do i = 1,PK_Data%num_z
        call spline_def(PK_data%log_kh,PK_data%matpower(:,i),PK_data%num_k,&
            PK_data%ddmat(:,i))
    end do

    end subroutine MatterPowerdata_getsplines

    !Sources
    subroutine MatterPowerdata_getsplines21cm(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i

    do i = 1,PK_Data%num_z
        call spline_def(PK_data%log_k,PK_data%matpower(:,i),PK_data%num_k,&
            PK_data%ddmat(:,i))
        call spline_def(PK_data%log_k,PK_data%vvpower(:,i),PK_data%num_k,&
            PK_data%ddvvpower(:,i))
        call spline_def(PK_data%log_k,PK_data%vdpower(:,i),PK_data%num_k,&
            PK_data%ddvdpower(:,i))
    end do

    end subroutine MatterPowerdata_getsplines21cm

    subroutine MatterPowerdata_Free(PK_data)
    Type(MatterPowerData) :: PK_data
    integer i
    !this shouldn't be needed when releasing the object.
    deallocate(PK_data%log_kh,stat=i)
    deallocate(PK_data%matpower,stat=i)
    deallocate(PK_data%ddmat,stat=i)
    deallocate(PK_data%nonlin_ratio,stat=i)
    deallocate(PK_data%redshifts,stat=i)
    !Sources
    deallocate(PK_data%log_k,stat=i)
    deallocate(PK_data%nonlin_ratio_vv,stat=i)
    deallocate(PK_data%nonlin_ratio_vd,stat=i)
    deallocate(PK_data%vvpower,stat=i)
    deallocate(PK_data%ddvvpower,stat=i)
    deallocate(PK_data%vdpower,stat=i)
    deallocate(PK_data%ddvdpower,stat=i)

    end subroutine MatterPowerdata_Free

    function MatterPowerData_k(PK, kh, itf, index_cache) result(outpower)
    !Get matter power spectrum at particular k/h by interpolation
    Type(MatterPowerData) :: PK
    integer, intent(in) :: itf
    real (dl), intent(in) :: kh
    real(dl) :: logk
    integer llo,lhi
    real(dl) outpower, dp
    real(dl) ho,a0,b0
    integer, optional :: index_cache
    integer, save :: i_last = 1

    logk = log(kh)
    if (logk < PK%log_kh(1)) then
        dp = (PK%matpower(2,itf) -  PK%matpower(1,itf)) / &
            ( PK%log_kh(2)-PK%log_kh(1) )
        outpower = PK%matpower(1,itf) + dp*(logk - PK%log_kh(1))
    else if (logk > PK%log_kh(PK%num_k)) then
        !Do dodgy linear extrapolation on assumption accuracy of result won't matter

        dp = (PK%matpower(PK%num_k,itf) -  PK%matpower(PK%num_k-1,itf)) / &
            ( PK%log_kh(PK%num_k)-PK%log_kh(PK%num_k-1) )
        outpower = PK%matpower(PK%num_k,itf) + dp*(logk - PK%log_kh(PK%num_k))
    else
        llo=min(PresentDefault(i_last, index_cache),PK%num_k)
        do while (PK%log_kh(llo) > logk)
            llo=llo-1
        end do
        do while (PK%log_kh(llo+1) < logk)
            llo=llo+1
        end do
        if (present(index_cache)) then
            index_cache = llo
        else
            i_last =llo
        end if
        lhi=llo+1
        ho=PK%log_kh(lhi)-PK%log_kh(llo)
        a0=(PK%log_kh(lhi)-logk)/ho
        b0=1-a0

        outpower = a0*PK%matpower(llo,itf)+ b0*PK%matpower(lhi,itf)+&
            ((a0**3-a0)* PK%ddmat(llo,itf) &
            +(b0**3-b0)*PK%ddmat(lhi,itf))*ho**2/6
    end if

    outpower = exp(outpower)

    end function MatterPowerData_k

    !Sources
    subroutine MatterPower21cm_k(PK, k, itf, monopole, vv, vd)
    !Get monopole and velocity power at particular k by interpolation
    Type(MatterPowerData) :: PK
    integer, intent(in) :: itf
    real (dl), intent(in) :: k
    real(dl), intent(out) :: monopole, vv, vd
    real(dl) :: logk
    integer llo,lhi
    real(dl) ho,a0,b0,f1,f2,f3
    integer, save :: i_last = 1

    logk = log(k)
    if (logk < PK%log_k(1)) then
        monopole = 0
        vv=0
        return
    end if
    if (logk > PK%log_k(PK%num_k)) then
        monopole=0
        vv=0
        return
        !stop 'MatterPower21cm_k: out of bounds'
    else
        llo=min(i_last,PK%num_k)
        do while (PK%log_k(llo) > logk)
            llo=llo-1
        end do
        do while (PK%log_k(llo+1)< logk)
            llo=llo+1
        end do
        i_last =llo
        lhi=llo+1
        ho=PK%log_k(lhi)-PK%log_k(llo)
        a0=(PK%log_k(lhi)-logk)/ho
        b0=1-a0
        f1= (a0**3-a0)
        f2= (b0**3-b0)
        f3= ho**2/6


        monopole = a0*PK%matpower(llo,itf)+ b0*PK%matpower(lhi,itf)+&
            (f1* PK%ddmat(llo,itf) &
            +f2*PK%ddmat(lhi,itf))*f3
        vv = a0*PK%vvpower(llo,itf)+ b0*PK%vvpower(lhi,itf)+&
            (f1* PK%ddvvpower(llo,itf) &
            +f2*PK%ddvvpower(lhi,itf))*f3

        vd = a0*PK%vdpower(llo,itf)+ b0*PK%vdpower(lhi,itf)+&
            (f1* PK%ddvdpower(llo,itf) &
            +f2*PK%ddvdpower(lhi,itf))*f3
    end if

    monopole = exp(max(-30._dl,monopole))
    vv = exp(max(-30._dl,vv))
    vd = exp(max(-30._dl,vd))

    end subroutine MatterPower21cm_k


    subroutine Transfer_GetMatterPowerS(State, MTrans, outpower, itf, minkh, dlnkh, npoints, var1, var2)
    class(CAMBdata) :: state
    Type(MatterTransferData), intent(in) :: MTrans
    integer, intent(in) :: itf, npoints
    integer, intent(in), optional :: var1, var2
    real, intent(out) :: outpower(*)
    real, intent(in) :: minkh, dlnkh
    real(dl) :: outpowerd(npoints)
    real(dl):: minkhd, dlnkhd

    minkhd = minkh; dlnkhd = dlnkh
    call Transfer_GetMatterPowerD(State, MTrans, outpowerd, itf, minkhd, dlnkhd, npoints,var1, var2)
    outpower(1:npoints) = outpowerd(1:npoints)

    end subroutine Transfer_GetMatterPowerS

    !JD 08/13 for nonlinear lensing of CMB + LSS compatibility
    !Changed input variable from itf to itf_PK because we are looking for the itf_PK'th
    !redshift in the PK_redshifts array.  The position of this redshift in the master redshift
    !array, itf, is given by itf = CP%Transfer%Pk_redshifts_index(itf_PK)
    !Also changed (CP%NonLinear/=NonLinear_None) to
    !CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens)
    subroutine Transfer_GetMatterPowerD(State, MTrans, outpower, itf_PK, minkh, dlnkh, npoints, var1, var2)
    !Allows for non-smooth priordial spectra
    !if CP%Nonlinear/ = NonLinear_none includes non-linear evolution
    !Get total matter power spectrum at logarithmically equal intervals dlnkh of k/h starting at minkh
    !in units of (h Mpc^{-1})^3.
    !Here there definition is < Delta^2(x) > = 1/(2 pi)^3 int d^3k P_k(k)
    !We are assuming that Cls are generated so any baryonic wiggles are well sampled and that matter power
    !sepctrum is generated to beyond the CMB k_max
    class(CAMBdata) :: state
    Type(MatterTransferData), intent(in) :: MTrans

    integer, intent(in) :: itf_PK, npoints
    real(dl), intent(out) :: outpower(npoints)
    real(dl), intent(in) :: minkh, dlnkh
    integer, intent(in), optional :: var1, var2

    integer ik, llo,il,lhi,lastix
    real(dl) matpower(MTrans%num_q_trans), kh, kvals(MTrans%num_q_trans), ddmat(MTrans%num_q_trans)
    real(dl) atransfer,xi, a0, b0, ho, logmink,k, h
    integer itf
    integer :: s1,s2, sign
    logical log_interp
    real(dl), allocatable :: ratio(:)

    s1 = PresentDefault (transfer_power_var, var1)
    s2 = PresentDefault (transfer_power_var, var2)

    itf = State%PK_redshifts_index(itf_PK)

    if (npoints < 2) call MpiStop('Need at least 2 points in Transfer_GetMatterPower')

    if (minkh*exp((npoints-1)*dlnkh) > MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf) &
        .and. FeedbackLevel > 0 ) &
        write(*,*) 'Warning: extrapolating matter power in Transfer_GetMatterPower'


    if (State%CP%NonLinear/=NonLinear_none .and. State%CP%NonLinear/=NonLinear_Lens) then
        call Transfer_GetNonLinRatio_index(State, Mtrans, ratio, itf)
    end if

    h = State%CP%H0/100
    logmink = log(minkh)
    do ik=1,MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,itf)
        k = kh*h
        kvals(ik) = log(kh)
        atransfer=MTrans%TransferData(s1,ik,itf)*MTrans%TransferData(s2,ik,itf)
        if (State%CP%NonLinear/=NonLinear_none .and. State%CP%NonLinear/=NonLinear_Lens) &
            atransfer = atransfer* ratio(ik)**2 !only one element, this itf
        matpower(ik) = atransfer*k*const_pi*const_twopi*h**3
        !Put in power spectrum later: transfer functions should be smooth, initial power may not be
    end do
    sign = 1
    log_interp = .true.
    if (any(matpower <= 0)) then
        if (all(matpower < 0)) then
            sign = -1
        else
            log_interp = .false.
        endif
    endif
    if (log_interp) matpower = log(sign*matpower)
    call spline_def(kvals,matpower,MTrans%num_q_trans, ddmat)

    llo=1
    lastix = npoints + 1
    do il=1, npoints
        xi=logmink + dlnkh*(il-1)
        if (xi < kvals(1)) then
            outpower(il)=-30.
            cycle
        end if
        do while ((xi > kvals(llo+1)).and.(llo < MTrans%num_q_trans))
            llo=llo+1
            if (llo >= MTrans%num_q_trans) exit
        end do
        if (llo == MTrans%num_q_trans) then
            lastix = il
            exit
        end if
        lhi=llo+1
        ho=kvals(lhi)-kvals(llo)
        a0=(kvals(lhi)-xi)/ho
        b0=(xi-kvals(llo))/ho

        outpower(il) = a0*matpower(llo)+ b0*matpower(lhi)+((a0**3-a0)* ddmat(llo) &
            +(b0**3-b0)*ddmat(lhi))*ho**2/6
    end do

    do while (lastix <= npoints)
        !Do linear extrapolation in the log
        !Obviouly inaccurate, non-linear etc, but OK if only using in tails of window functions
        outpower(lastix) = 2*outpower(lastix-1) - outpower(lastix-2)
        lastix = lastix+1
    end do

    if (log_interp) then
        outpower = sign*exp(max(-30.d0,outpower))
    end if
    associate(InitPower => State%CP%InitPower)
        do il = 1, npoints
            k = exp(logmink + dlnkh*(il-1))*h
            outpower(il) = outpower(il) * InitPower%ScalarPower(k)
            if (global_error_flag /= 0) exit
        end do
    end associate

    end subroutine Transfer_GetMatterPowerD

    subroutine Transfer_Get_SigmaR(State, MTrans, R, outvals, var1, var2, root)
    !Calculate MTrans%sigma_8^2 = int dk/k win**2 T_k**2 P(k), where win is the FT of a spherical top hat
    !of radius R h^{-1} Mpc, for all requested redshifts
    !set va1, var2 e.g. to get the value from some combination of transfer functions rather than total
    class(CAMBdata) :: State
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in) :: R
    integer, intent(in), optional :: var1, var2
    logical, intent(in), optional :: root !if true, give sigma8, otherwise sigma8^2
    real(dl), intent(out) :: outvals(:)
    real(dl) :: kh, k, h, x, win, lnk, dlnk, lnko, powers
    real(dl), dimension(State%CP%Transfer%PK_num_redshifts) :: dsig8, dsig8o, sig8, sig8o
    integer :: s1, s2, ik

    s1 = PresentDefault(transfer_power_var, var1)
    s2 = PresentDefault(transfer_power_var, var2)
    H=State%CP%h0/100._dl
    lnko=0
    dsig8o=0
    sig8=0
    sig8o=0
    do ik=1, MTrans%num_q_trans
        kh = MTrans%TransferData(Transfer_kh,ik,1)
        if (kh==0) cycle
        k = kh*H

        dsig8 = MTrans%TransferData(s1,ik, State%PK_redshifts_index(1:State%CP%Transfer%PK_num_redshifts))
        if (s1==s2) then
            dsig8 = dsig8**2
        else
            dsig8 = dsig8*MTrans%TransferData(s2,ik, State%PK_redshifts_index(1:State%CP%Transfer%PK_num_redshifts))
        end if
        x= kh *R
        if (x < 1e-2_dl) then
            win = 1._dl - x**2/10
        else
            win = 3*(sin(x)-x*cos(x))/x**3
        end if
        lnk=log(k)
        if (ik==1) then
            dlnk=0.5_dl
            !Approx for 2._dl/(Params%InitPower%an(in)+3)  [From int_0^k_1 dk/k k^4 P(k)]
            !Contribution should be very small in any case
        else
            dlnk=lnk-lnko
        end if
        powers = State%CP%InitPower%ScalarPower(k)
        dsig8=(win*k**2)**2*powers*dsig8
        sig8=sig8+(dsig8+dsig8o)*dlnk/2
        dsig8o=dsig8
        lnko=lnk
    end do

    if (present(root)) then
        if (root) sig8 =sqrt(sig8)
    else
        sig8 =sqrt(sig8)
    end if
    outvals(1:State%CP%Transfer%PK_num_redshifts) = sig8

    end subroutine Transfer_Get_SigmaR

    subroutine Transfer_GetSigmaRArray(State, MTrans, R, sigmaR, redshift_ix, var1, var2)
    !Get array of SigmaR at (by default) redshift zero, for all values of R (in h^{-1}Mpc units)
    class(CAMBdata), target :: State
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in) :: R(:)
    real(dl), intent(out) :: SigmaR(:)
    integer, intent(in), optional :: redshift_ix, var1, var2
    integer red_ix, ik, subk
    real(dl) kh, k, h, dkh, k_step
    real(dl) lnk, dlnk, lnko, minR, maxR
    real(dl), dimension(size(R)) ::  x, win, dsig8, dsig8o, sig8, sig8o
    type(MatterPowerData), target:: PKspline
    type(MatterPowerData), pointer :: PK
    integer PK_ix
    integer :: nsub
    integer index_cache, nextra

    index_cache = 1
    nsub = 5 !interpolation steps
    h=State%CP%h0/100._dl
    minR = minval(R)/ h
    maxR = maxval(R)
    red_ix = PresentDefault(State%PK_redshifts_index(State%CP%Transfer%PK_num_redshifts), redshift_ix)

    if (allocated(State%CAMB_PK) .and. var1==transfer_power_var .and. var2==transfer_power_var) then
        PK => State%CAMB_PK
        PK_ix = red_ix
    else
        call Transfer_GetMatterPowerData(State, MTrans, PKspline, red_ix, var1, var2)
        PK => PKspline
        PK_ix = 1
    end if
    dkh = 0._dl
    lnko=0
    dsig8o=0
    sig8=0
    sig8o=0
    if (MTrans%TransferData(Transfer_kh,1,1)==0) call MpiStop('Transfer_GetSigmaRArray kh zero')

    !Steps to extrapolate beyond kmax for tail [could do analytically]
    nextra = (4 /minR - State%CP%Transfer%kmax)/h/ &
        (MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,1)- MTrans%TransferData(Transfer_kh,MTrans%num_q_trans-1,1))
    do ik=1, MTrans%num_q_trans + max(2, nextra)
        if (ik < MTrans%num_q_trans) then
            k_step= MTrans%TransferData(Transfer_kh,ik+1,1)-MTrans%TransferData(Transfer_kh,ik,1)
            kh = MTrans%TransferData(Transfer_kh,ik,1)
            nsub = max(1, nint(k_step*min(maxR,4/(kh*h))/0.5))
        else
            !after last step just extrapolate with previous size
            nsub = max(1, nint(k_step*min(maxR,4/(kh*h))))
        end if
        nsub = nint(nsub*State%CP%Accuracy%AccuracyBoost)
        dkh = k_step/nsub
        do subk = 1, nsub
            k = kh*h
            lnk=log(k)

            x= kh *R
            where (x < 1e-2_dl)
                win = 1._dl - x**2/5
            elsewhere
                win =(3*(sin(x)-x*cos(x))/x**3)**2
            end where
            if (ik==1 .and. subk==1) then
                dlnk=0.5_dl
                !Approx for 2._dl/(Params%InitPower%an(in)+3)  [From int_0^k_1 dk/k k^4 P(k)]
                !Contribution should be very small in any case
            else
                dlnk=lnk-lnko
            end if
            dsig8=win*(MatterPowerData_k(PK, kh,PK_ix,index_cache)*k**3)
            sig8=sig8+(dsig8+dsig8o)*dlnk/2
            dsig8o=dsig8
            lnko=lnk
            kh = kh + dkh
        end do
    end do

    SigmaR=sqrt(sig8/(const_pi*const_twopi*h**3))

    end subroutine Transfer_GetSigmaRArray

    subroutine Transfer_Get_sigma8(State, MTrans, R, var1, var2)
    !Calculate MTrans%sigma_8^2 = int dk/k win**2 T_k**2 P(k), where win is the FT of a spherical top hat
    !of radius R h^{-1} Mpc
    ! set va1, var2 e.g. to get the value from some combination of transfer functions rather than total
    class(CAMBdata) :: State
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in), optional :: R
    integer, intent(in), optional :: var1, var2
    real(dl) :: radius

    if (global_error_flag /= 0) return

    radius = PresentDefault (8._dl, R)

    call Transfer_Get_SigmaR(State, MTrans, radius, MTrans%sigma_8, var1,var2)

    end subroutine Transfer_Get_sigma8

    subroutine Transfer_Get_sigmas(State, MTrans, R, var_delta, var_v)
    !Get sigma8 and sigma_{delta v} (for growth, like f sigma8 in LCDM)
    class(CAMBdata) :: State
    Type(MatterTransferData) :: MTrans
    real(dl), intent(in), optional :: R
    integer, intent(in), optional :: var_delta, var_v
    real(dl) :: radius
    integer :: s1, s2

    if (global_error_flag /= 0) return

    radius = PresentDefault (8._dl, R)
    s1 = PresentDefault (transfer_power_var, var_delta)
    s2 = PresentDefault (Transfer_Newt_vel_cdm, var_v)

    call Transfer_Get_SigmaR(State, MTrans, radius, MTrans%sigma_8, s1,s1)
    if (State%get_growth_sigma8) call Transfer_Get_SigmaR(State, MTrans, radius, &
        MTrans%sigma2_vdelta_8(:), s1, s2, root=.false.)

    end subroutine Transfer_Get_sigmas

    subroutine Transfer_output_Sig8(MTrans, State)
    Type(MatterTransferData), intent(in) :: MTrans
    Type(CAMBdata), intent(in) :: State
    integer j_PK

    do j_PK=1, State%CP%Transfer%PK_num_redshifts
        write(*,'("at z =",f7.3," sigma8 (all matter) = ",f7.4)') &
            State%CP%Transfer%PK_redshifts(j_PK), MTrans%sigma_8(j_PK)
    end do
    if (State%get_growth_sigma8) then
        do j_PK=1, State%CP%Transfer%PK_num_redshifts
            write(*,'("at z =",f7.3," sigma8^2_vd/sigma8  = ",f7.4)') &
                State%CP%Transfer%PK_redshifts(j_PK), MTrans%sigma2_vdelta_8(j_PK)/MTrans%sigma_8(j_PK)
        end do
    end if

    end subroutine Transfer_output_Sig8


    subroutine Transfer_Allocate(MTrans, State)
    Type(MatterTransferData) :: MTrans
    class(CAMBdata) :: State

    call MTrans%Free()
    allocate(MTrans%q_trans(MTrans%num_q_trans))
    allocate(MTrans%TransferData(Transfer_max,MTrans%num_q_trans,State%num_transfer_redshifts))
    allocate(MTrans%sigma_8(State%CP%Transfer%PK_num_redshifts))
    if (State%get_growth_sigma8) allocate(MTrans%sigma2_vdelta_8(State%CP%Transfer%PK_num_redshifts))

    end subroutine Transfer_Allocate

    subroutine Transfer_SaveToFiles(MTrans,State,FileNames)
    use constants
    Type(MatterTransferData), intent(in) :: MTrans
    class(CAMBdata) :: State
    integer i,ik
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)
    integer i_PK
    integer unit

    do i_PK=1, State%CP%Transfer%PK_num_redshifts
        if (FileNames(i_PK) /= '') then
            i = State%PK_redshifts_index(i_PK)
            if (State%CP%do21cm) then
                unit = open_file_header(FileNames(i_PK), 'k/h', Transfer21cm_name_tags, 14)
            else
                unit = open_file_header(FileNames(i_PK), 'k/h', transfer_name_tags, 14)
            end if
            do ik=1,MTrans%num_q_trans
                if (MTrans%TransferData(Transfer_kh,ik,i)/=0) then
                    write(unit,'(*(E15.6))') MTrans%TransferData(Transfer_kh:Transfer_max,ik,i)
                end if
            end do
            close(unit)
        end if
    end do

    end subroutine Transfer_SaveToFiles

    subroutine Transfer_SaveMatterPower(MTrans, State,FileNames, all21cm)
    use constants
    !Export files of total  matter power spectra in h^{-1} Mpc units, against k/h.
    Type(MatterTransferData), intent(in) :: MTrans
    Type(CAMBdata) :: State
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)
    character(LEN=name_tag_len) :: columns(3)
    integer itf, i, unit
    integer points
    real, dimension(:,:), allocatable :: outpower
    real minkh,dlnkh
    Type(MatterPowerData) :: PK_data
    integer ncol
    logical, intent(in), optional :: all21cm
    logical all21
    !JD 08/13 Changes in here to PK arrays and variables
    integer itf_PK

    all21 = DefaultFalse(all21cm)
    if (all21) then
        ncol = 3
    else
        ncol = 1
    end if

    do itf=1, State%CP%Transfer%PK_num_redshifts
        if (FileNames(itf) /= '') then
            if (.not. transfer_interp_matterpower ) then
                itf_PK = State%PK_redshifts_index(itf)

                points = MTrans%num_q_trans
                allocate(outpower(points,ncol))

                !Sources
                if (all21) then
                    call Transfer_Get21cmPowerData(MTrans, State, PK_data, itf_PK)
                else
                    call Transfer_GetMatterPowerData(State, MTrans, PK_data, itf_PK)
                    !JD 08/13 for nonlinear lensing of CMB + LSS compatibility
                    !Changed (CP%NonLinear/=NonLinear_None) to CP%NonLinear/=NonLinear_none .and. CP%NonLinear/=NonLinear_Lens)
                    if(State%CP%NonLinear/=NonLinear_none .and. State%CP%NonLinear/=NonLinear_Lens) then
                        call State%CP%NonLinearModel%GetNonLinRatios(State, PK_data)
                        PK_data%matpower = PK_data%matpower +  2*log(PK_data%nonlin_ratio)
                        call MatterPowerdata_getsplines(PK_data)
                    end if
                end if

                outpower(:,1) = exp(PK_data%matpower(:,1))
                !Sources
                if (all21) then
                    outpower(:,3) = exp(PK_data%vvpower(:,1))
                    outpower(:,2) = exp(PK_data%vdpower(:,1))

                    outpower(:,1) = outpower(:,1)/1d10*const_pi*const_twopi/MTrans%TransferData(Transfer_kh,:,1)**3
                    outpower(:,2) = outpower(:,2)/1d10*const_pi*const_twopi/MTrans%TransferData(Transfer_kh,:,1)**3
                    outpower(:,3) = outpower(:,3)/1d10*const_pi*const_twopi/MTrans%TransferData(Transfer_kh,:,1)**3
                end if

                call MatterPowerdata_Free(PK_Data)
                columns = ['P   ', 'P_vd','P_vv']
                unit = open_file_header(FileNames(itf), 'k/h', columns(:ncol), 15)
                do i=1,points
                    write (unit, '(*(E15.6))') MTrans%TransferData(Transfer_kh,i,1),outpower(i,:)
                end do
                close(unit)
            else
                if (all21) stop 'Transfer_SaveMatterPower: if output all assume not interpolated'
                minkh = 1e-4
                dlnkh = 0.02
                points = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/dlnkh+1
                !             dlnkh = log(MTrans%TransferData(Transfer_kh,MTrans%num_q_trans,itf)/minkh)/(points-0.999)
                allocate(outpower(points,1))
                call Transfer_GetMatterPowerS(State, MTrans, outpower(1,1), itf, minkh,dlnkh, points)

                columns(1) = 'P'
                unit = open_file_header(FileNames(itf), 'k/h', columns(:1), 15)

                do i=1,points
                    write (unit, '(*(E15.6))') minkh*exp((i-1)*dlnkh),outpower(i,1)
                end do
                close(unit)
            end if

            deallocate(outpower)
        end if
    end do

    end subroutine Transfer_SaveMatterPower


    subroutine Transfer_Get21cmPowerData(MTrans, State, PK_data, z_ix)
    !In terms of k, not k/h, and k^3 P_k /2pi rather than P_k
    Type(MatterTransferData), intent(in) :: MTrans
    Type(CAMBdata) :: State
    Type(MatterPowerData) :: PK_data, PK_cdm
    real(dl) h, k, pow
    integer ik
    integer z_ix,nz

    nz = 1
    PK_data%num_k = MTrans%num_q_trans
    PK_Data%num_z = nz

    allocate(PK_data%matpower(PK_data%num_k,nz))
    allocate(PK_data%ddmat(PK_data%num_k,nz))
    allocate(PK_data%vvpower(PK_data%num_k,nz))
    allocate(PK_data%ddvvpower(PK_data%num_k,nz))
    allocate(PK_data%vdpower(PK_data%num_k,nz))
    allocate(PK_data%ddvdpower(PK_data%num_k,nz))
    allocate(PK_data%log_k(PK_data%num_k))
    allocate(PK_data%redshifts(nz))

    PK_data%redshifts = State%Transfer_Redshifts(z_ix)

    h = State%CP%H0/100

    if (State%CP%NonLinear/=NonLinear_None .and. State%CP%NonLinear/=NonLinear_Lens) then
        if (z_ix>1) stop 'not tested more than one redshift with Nonlinear 21cm'
        call Transfer_GetMatterPowerData(State, MTrans, PK_cdm, z_ix)
        call State%CP%NonLinearModel%GetNonLinRatios_All(State,PK_cdm)
    end if

    do ik=1,MTrans%num_q_trans
        k = MTrans%TransferData(Transfer_kh,ik,z_ix)*h
        PK_data%log_k(ik) = log(k)
        pow = State%CP%InitPower%ScalarPower(k)*1d10

        PK_data%matpower(ik,1) = &
            log( (MTrans%TransferData(Transfer_monopole,ik,z_ix)*k**2)**2 * pow)
        PK_data%vvpower(ik,1) = &
            log( (MTrans%TransferData(Transfer_vnewt ,ik,z_ix)*k**2)**2 * pow)
        PK_data%vdpower(ik,1) = &
            log( abs((MTrans%TransferData(Transfer_vnewt ,ik,z_ix)*k**2)*&
            (MTrans%TransferData(Transfer_monopole,ik,z_ix)*k**2))* pow)

        if (State%CP%NonLinear/=NonLinear_None) then
            PK_data%matpower(ik,1) = PK_data%matpower(ik,1) + 2*log(PK_cdm%nonlin_ratio(ik,z_ix))
            PK_data%vvpower(ik,1) = PK_data%vvpower(ik,1) + 2*log(PK_cdm%nonlin_ratio_vv(ik,z_ix))
            PK_data%vdpower(ik,1) = PK_data%vdpower(ik,1) + 2*log(PK_cdm%nonlin_ratio_vd(ik,z_ix))
        end if

    end do

    if (State%CP%NonLinear/=NonLinear_None)  call MatterPowerdata_Free(PK_cdm)


    call MatterPowerdata_getsplines21cm(PK_data)

    end subroutine Transfer_Get21cmPowerData

    function Get21cmCl_l(Vars,kin)
    !Direct integration with j^2/r, etc.
    class(Cl21cmVars) Vars
    real(dl) kin, x, jl,ddJl,k, jlm1
    real(dl) Get21cmCl_l
    real(dl) monopole, vv , vd
    external BJL_EXTERNAL
    if (Vars%logs) then
        k = exp(kin)
    else
        k = kin
    end if
    x= Vars%chi*k

    call MatterPower21cm_k(Vars%PK, k, Vars%itf, monopole, vv, vd)
    call bjl_external(Vars%l, x, jl)
    call bjl_external(Vars%l-1, x, jlm1)
    ddjl = -( 2/x*jlm1-(Vars%l+2)*real(Vars%l+1,dl)/x**2*jl + jl)

    Get21cmCl_l = jl**2*monopole + ddjl**2*vv - 2._dl *ddjl*jl*vd
    if (.not. Vars%logs)  Get21cmCl_l =  Get21cmCl_l / k

    end function Get21cmCl_l


    function Get21cmCl_l_avg(Vars,kin)
    !Asymptotic results where we take <cos^2>=1/2 assuming smooth power spectrum
    class(Cl21cmVars) Vars
    real(dl) kin, x, jl,ddJl,cross,k
    real(dl) Get21cmCl_l_avg
    real(dl) monopole, vv , vd,lphalf
    external BJL_EXTERNAL

    if (Vars%logs) then
        k = exp(kin)
    else
        k = kin
    end if
    x= Vars%chi*k

    call MatterPower21cm_k(Vars%PK, k, Vars%itf, monopole, vv, vd)
    lphalf=Vars%l+0.5_dl

    jl = 1/(2*x**2) /sqrt(1-(lphalf/x)**2)

    !  ddjl = (4/x**4+1)/(2*x**2)
    !
    ddjl = (x**4-2*x**2*lphalf**2+lphalf**4)/(x**4*sqrt(x**2-lphalf**2)*x)/2

    !    cross = (2-x**2)/(2*x**4)

    cross = (-x**2+lphalf**2)/(x**2*sqrt(x**2-lphalf**2)*x)/2

    Get21cmCl_l_avg = jl*monopole + ddjl*vv - 2._dl *cross*vd
    if (.not. Vars%logs)  Get21cmCl_l_avg =  Get21cmCl_l_avg / k

    !       Get21cmCl_l_avg=Get21cmCl_l_avg
    end function Get21cmCl_l_avg


    subroutine Transfer_Get21cmCls(MTrans, State,FileNames)
    use constants
    !Get 21cm C_l from sharp shell, using only monopole source and redshift distortions
    Type(MatterTransferData), intent(in) :: MTrans
    Type(CAMBdata), target :: State
    character(LEN=Ini_max_string_len), intent(IN) :: FileNames(*)
    integer itf,ik, itf_PK
    integer points
    character(LEN=name_tag_len), dimension(3), parameter :: Transfer_21cm_name_tags = &
        ['CL  ','P   ','P_vv']
    Type(MatterPowerData), target ::PK_data
    real(dl)  tol,atol, chi, Cl
    integer l, lastl, unit
    real(dl) k_min, k_max,k, avg_fac
    Type(Cl21cmVars) vars
    Type(CAMBParams), pointer :: CP

    CP=>State%CP

    tol = 1e-5/exp(CP%Accuracy%AccuracyBoost*CP%Accuracy%IntTolBoost-1)
    do itf_PK=1, CP%Transfer%PK_num_redshifts
        itf = State%PK_redshifts_index(itf_PK)
        if (FileNames(itf) /= '') then
            chi = State%tau0-State%TimeOfz(CP%Transfer%PK_redshifts(itf_PK))

            points = MTrans%num_q_trans

            lastl=0

            call Transfer_Get21cmPowerData(MTrans, State, PK_data, itf)

            unit = open_file_header(FileNames(itf_PK), 'L', Transfer_21cm_name_tags, 8)

            do ik =1, points-1
                k =exp(PK_data%log_k(ik))
                l=nint(k*chi)
                !This is not an approximation, we are just chosing to sample l at values around (k samples)*chi

                if (l>1 .and. l/= lastl) then
                    lastl=l
                    Vars%l=l
                    Vars%chi = chi
                    Vars%PK => PK_data
                    Vars%itf = 1
                    Cl=0
                    atol = tol
                    avg_fac = 200
                    k_min = max(exp(PK_data%log_k(1)), k*(1-20*CP%Accuracy%AccuracyBoost/chi))
                    k_max = CP%Accuracy%AccuracyBoost*max(k*(1+avg_fac/chi), k*(1._dl+real(l,dl)**(-0.666_dl)))

                    if (k_max*chi < l+10) k_max = (l+10)/chi

                    Vars%logs = .false.
                    if (k_max < exp(PK_data%log_k(points))) then
                        !Integrate bessels properly
                        Cl = Integrate_Romberg(Vars,Get21cmCl_l,k_min,k_max, atol, 25)

                        Vars%logs = .true.
                        k_min = log(k_max)


                        if (l>2e6) then
                            !In baryon damping
                            !                     Vars%logs = .false.
                            !                     atol = tol/10
                            !                     k_min = max(exp(PK_data%log_k(1)), k*(1-10/chi) )
                            !                     k_max = k*(1+100/chi)

                            k_max = min(log(5*k), PK_data%log_k(points))

                        elseif (l>1e4) then
                            Vars%logs = .false.
                            k_min = k_max

                            k_max = min(k*35*CP%Accuracy%AccuracyBoost, exp(PK_data%log_k(points)))
                        else
                            !In white noise regime
                            k_max = min(log(max(0.3_dl,k)*18*CP%Accuracy%AccuracyBoost), PK_data%log_k(points))
                        end if

                        Cl = Cl+Integrate_Romberg(Vars,Get21cmCl_l_avg,k_min,k_max, atol, 25)
                    else
                        k_max = exp(PK_data%log_k(points))
                        Cl = Integrate_Romberg(Vars,Get21cmCl_l,k_min,k_max, atol, 25)
                    end if


                    Cl=exp(-2*State%optical_depths_for21cm(itf_PK))*const_fourpi*Cl* &
                        real(l,dl)*(l+1)/const_twopi/1d10

                    write (unit, '(1I8,3E15.5)') l, Cl, exp(PK_data%matpower(ik,1)/1d10), exp(PK_data%vvpower(ik,1)/1d10)
                end if
            end do

            close(unit)

            call MatterPowerdata_Free(PK_Data)
        end if
    end do

    end subroutine Transfer_Get21cmCls


    end module Transfer

    module handles
    use CAMB
    use Precision
    use results
    use iso_c_binding
    use DarkEnergyFluid
    use DarkEnergyPPF
    use ObjectLists
    use classes
    use Interpolation
    implicit none

    Type c_MatterTransferData
        integer   ::  num_q_trans   !    number of steps in k for transfer calculation
        type(c_ptr) :: q_trans, sigma_8, sigma2_vdelta_8, TransferData
        integer :: sigma_8_size
        integer :: sigma2_vdelta_8_size
        integer :: TransferData_size(3)
    end Type c_MatterTransferData


    Type c_ClTransferData
        integer :: NumSources
        integer :: q_size
        type(c_ptr) :: q
        integer delta_size(3)
        type(c_ptr) Delta_p_l_k
        integer l_size
        type(c_ptr) ls
        !skip limber for now...
    end Type c_ClTransferData

    Type RealAllocatableArray
        double precision, allocatable :: R(:)
    end Type

    Type IntAllocatableArray
        integer, allocatable :: R(:)
    end Type

    Type PythonClassAllocatableArray
        Type(PythonClassAllocatable), allocatable :: R(:)
    end Type PythonClassAllocatableArray

    abstract interface
    subroutine TSelfPointer(cptr, P)
    use iso_c_binding
    import
    Type(c_ptr) :: cptr
    class (TPythonInterfacedClass), pointer :: P
    end subroutine TSelfPointer
    end interface

    integer, private, save, target :: dummy

    contains


    subroutine GetAllocatableSize(sz, sz_array, sz_object_array)
    Type(PythonClassAllocatable) :: T
    Type(RealAllocatableArray) :: T2
    Type(PythonClassAllocatableArray) :: T3
    integer, intent(out) :: sz, sz_array, sz_object_array

    sz = storage_size(T) / 8
    sz_array = storage_size(T2) / 8
    sz_object_array = storage_size(T3) / 8

    end subroutine GetAllocatableSize

    function better_c_loc(R)
    !Longwinded way to get pointer to R (needed in gfortran, can do directly in ifort)
    class(TPythonInterfacedClass), target :: R
    Type(c_ptr) better_c_loc
    type(PythonClassPtr), target :: P
    Type Dummy
        integer :: Self
    end type Dummy
    Type DummyClassPtr
        class(Dummy), pointer :: Ref
    end type
    type(DummyClassPtr), pointer :: mock

    P%Ref => R
    call c_f_pointer(c_loc(P), mock)
    better_c_loc = c_loc(mock%Ref%Self)

    end function better_c_loc

    function get_allocatable_1D_array(array, ptr) result(sz)
    Type(RealAllocatableArray), target :: array
    Type(c_Ptr), intent(out) :: ptr
    integer sz

    if (allocated(array%R)) then
        ptr = c_loc(array%R)
        sz = size(array%R)
    else
        sz=0
    end if

    end function get_allocatable_1D_array

    subroutine set_allocatable_1D_array(array, vals, sz)
    Type(RealAllocatableArray), target :: array
    integer, intent(in) :: sz
    real(dl) :: vals(sz)

    if (allocated(array%R)) deallocate(array%R)
    if (sz>0) then
        allocate(array%R, source = vals)
    end if

    end subroutine set_allocatable_1D_array

    function get_allocatable_1D_array_int(array, ptr) result(sz)
    Type(IntAllocatableArray), target :: array
    Type(c_Ptr), intent(out) :: ptr
    integer sz

    if (allocated(array%R)) then
        ptr = c_loc(array%R)
        sz = size(array%R)
    else
        sz=0
    end if

    end function get_allocatable_1D_array_int

    subroutine set_allocatable_1D_array_int(array, vals, sz)
    Type(IntAllocatableArray), target :: array
    integer, intent(in) :: sz
    integer :: vals(sz)

    if (allocated(array%R)) deallocate(array%R)
    if (sz>0) then
        allocate(array%R, source = vals)
    end if

    end subroutine set_allocatable_1D_array_int

    function get_allocatable_object_1D_array(array, ptr) result(sz)
    Type(PythonClassAllocatableArray), target :: array
    Type(c_Ptr), intent(out) :: ptr
    integer sz

    if (allocated(array%R)) then
        ptr = c_loc(array%R)
        sz = size(array%R)
    else
        sz=0
    end if

    end function get_allocatable_object_1D_array


    subroutine set_allocatable_object_1D_array(array, vals, sz)
    Type(PythonClassAllocatableArray), target :: array
    integer, intent(in) :: sz
    Type(PythonClassAllocatable) :: vals(sz)

    if (allocated(array%R)) deallocate(array%R)
    if (sz>0) then
        allocate(array%R(sz))
        array%R = vals
    end if

    end subroutine set_allocatable_object_1D_array

    function get_effective_null()
    type(c_ptr) get_effective_null

    !Can use actual null pointer in gfortran. ifort requires non-null (but doesn't have to be valid memory)
    get_effective_null = c_loc(dummy)

    end function get_effective_null

    subroutine F2003Class_get_id(SelfPtr, pSource)
    TYPE(C_FUNPTR), INTENT(IN) :: SelfPtr
    procedure(TSelfPointer), pointer :: SelfFunc
    class(TPythonInterfacedClass), pointer :: pSource

    CALL C_F_PROCPOINTER (SelfPtr, SelfFunc)
    call SelfFunc(get_effective_null(), pSource)

    end subroutine F2003Class_get_id

    subroutine F2003Class_GetAllocatable(classobject, id, handle)
    Type(PythonClassAllocatable), target :: classobject
    type(c_ptr), intent(out)  :: handle
    class (TPythonInterfacedClass), pointer :: id

    if (allocated(classobject%P)) then
        call classobject%P%SelfPointer(get_effective_null(), id)
        ! handle =  c_loc(classobject%P) ! only works in ifort
        handle =  better_c_loc(classobject%P)
    else
        handle = c_null_ptr
    end if

    end subroutine F2003Class_GetAllocatable

    subroutine F2003Class_SetAllocatable(f_allocatable, source)
    Type(PythonClassAllocatable), target :: f_allocatable
    class(TPythonInterfacedClass), optional :: source

    if (allocated(f_allocatable%P)) deallocate(f_allocatable%P)
    if (present(Source)) then
        allocate(f_allocatable%P,source = source)
    end if

    end subroutine F2003Class_SetAllocatable

    subroutine F2003Class_new(handle, selfPtr)
    type(c_ptr), intent(inout) :: handle
    TYPE(C_FUNPTR), INTENT(IN) :: SelfPtr
    procedure(TSelfPointer), pointer :: SelfFunc
    class(TPythonInterfacedClass), pointer :: pSource
    class(TPythonInterfacedClass), pointer :: p

    CALL C_F_PROCPOINTER (SelfPtr, SelfFunc)
    if (C_ASSOCIATED(handle)) then
        call SelfFunc(handle, pSource)
        allocate(p, source=pSource)
    else
        call SelfFunc(get_effective_null(), pSource)
        allocate(p, mold = pSource)
    end if
    handle = better_c_loc(p)

    end subroutine F2003Class_new

    subroutine F2003Class_free(cptr,SelfPtr)
    type(c_ptr)  :: cptr
    TYPE(C_FUNPTR), INTENT(IN) :: SelfPtr
    procedure(TSelfPointer), pointer :: SelfFunc
    class(TPythonInterfacedClass), pointer :: pSource

    CALL C_F_PROCPOINTER (SelfPtr, SelfFunc)
    call SelfFunc(cptr, pSource)
    if (.not. associated(pSource)) error stop 'Null in F2003Class_free'
    deallocate(pSource)

    end subroutine F2003Class_free

    function CAMBdata_GetTransfers(State, Params, onlytransfer, onlytimesources) result(error)
    Type (CAMBdata):: State
    type(CAMBparams) :: Params
    logical :: onlytransfer, onlytimesources
    integer :: error

    error = 0
    call CAMB_GetResults(State, Params, error, onlytransfer, onlytimesources)

    end function CAMBdata_GetTransfers

    function CAMBdata_CalcBackgroundTheory(State, P) result(error)
    use cambmain, only: initvars
    Type (CAMBdata):: State
    type(CAMBparams) :: P
    integer error

    global_error_flag = 0
    call State%SetParams(P)
    if (global_error_flag==0) call InitVars(State) !calculate thermal history, e.g. z_drag etc.
    error=global_error_flag

    end function CAMBdata_CalcBackgroundTheory

    subroutine CAMBdata_GetSigma8(State, s8, i)
    Type(CAMBdata) :: State
    integer i
    real(dl) s8(State%CP%Transfer%PK_num_redshifts)

    if (i==0) then
        s8= State%MT%sigma_8
    elseif (i==1 .and. allocated(State%MT%sigma2_vdelta_8)) then
        s8 = State%MT%sigma2_vdelta_8/State%MT%sigma_8
    else
        s8 = 0
    end if

    end subroutine CAMBdata_GetSigma8

    subroutine CAMBdata_GetSigmaRArray(State, sigma, R, nR, z_ix, nz, var1, var2)
    Type(CAMBdata) :: State
    integer, intent(in) :: nR, nz  
    real(dl) :: sigma(nR,nz)
    real(dl) :: R(nR)
    integer var1, var2, z_ix(nz)
    integer i, ix

    !$OMP PARALLEL DO DEFAULT(SHARED), PRIVATE(ix)
    do i=1, nz
        ix = z_ix(i)
        if (ix==-1) ix = State%PK_redshifts_index(State%CP%Transfer%PK_num_redshifts)
        call Transfer_GetSigmaRArray(State, State%MT, R, sigma(:,i), ix, var1, var2)
    end do

    end subroutine CAMBdata_GetSigmaRArray


    subroutine CAMBdata_GetMatterTransferks(State, nk, ks)
    Type(CAMBdata) :: State
    integer nk
    real(dl) ks(nk)

    if (nk/=0) then
        ks =  State%MT%TransferData(Transfer_kh,:,1) * (State%CP%H0/100)
    end if
    nk = State%MT%num_q_trans

    end subroutine CAMBdata_GetMatterTransferks

    subroutine CAMBdata_MatterTransferData(State, cData)
    Type(CAMBdata), target :: State
    Type(c_MatterTransferData) :: cData

    if (allocated(State%MT%sigma2_vdelta_8)) then
        cData%sigma2_vdelta_8_size = size(State%MT%sigma2_vdelta_8)
        cData%sigma2_vdelta_8 = c_loc(State%MT%sigma2_vdelta_8)
    else
        cData%sigma2_vdelta_8_size =0
    end if
    cData%sigma_8_size = size(State%MT%sigma_8)
    cData%sigma_8 = c_loc(State%MT%sigma_8)
    cData%TransferData_size = shape(State%MT%TransferData)
    cData%num_q_trans = State%MT%num_q_trans
    cData%q_trans = c_loc(State%MT%q_trans)
    cData%TransferData = c_loc(State%MT%TransferData)
    cData%q_trans = c_loc(State%MT%q_trans)

    end subroutine CAMBdata_MatterTransferData

    subroutine CAMBdata_ClTransferData(State, cData, i)
    Type(CAMBdata), target :: State
    Type(c_ClTransferData) :: cData
    integer, intent(in) :: i

    if (i==0) then
        call Convert_ClTransferData(State%CLdata%CTransScal, cData)
    else if (i==1) then
        call Convert_ClTransferData(State%CLdata%CTransVec, cData)
    else if (i==2) then
        call Convert_ClTransferData(State%CLdata%CTransTens, cData)
    else
        error stop 'Unknown ClTransferData index'
    end if

    end subroutine CAMBdata_ClTransferData

    subroutine Convert_ClTransferData(CTrans, cData)
    Type(ClTransferData), target :: CTrans
    Type(c_ClTransferData) :: cData

    cData%NumSources = CTrans%NumSources
    if (allocated(CTrans%q%points)) then
        cData%q_size = size(CTrans%q%points)
        cData%q = c_loc(CTrans%q%points)
    else
        cData%q_size = 0
    end if
    if (allocated(CTrans%Delta_p_l_k)) then
        cData%delta_size = shape(CTrans%Delta_p_l_k)
        cData%delta_p_l_k = c_loc(CTrans%Delta_p_l_k)
    else
        cData%delta_size = 0
    end if
    cData%l_size = CTrans%ls%nl
    cData%ls = c_loc(CTrans%ls%l)

    end subroutine Convert_ClTransferData


    subroutine CAMBdata_GetLinearMatterPower(State, PK, var1, var2, hubble_units)
    Type(CAMBdata) :: State
    real(dl) :: PK(State%MT%num_q_trans,State%CP%Transfer%PK_num_redshifts)
    integer, intent(in) :: var1, var2
    logical :: hubble_units

    call Transfer_GetUnsplinedPower(State, State%MT, PK, var1, var2, hubble_units)

    end subroutine CAMBdata_GetLinearMatterPower

    subroutine CAMBdata_GetNonLinearMatterPower(State, PK, var1, var2, hubble_units)
    Type(CAMBdata) :: State
    real(dl) :: PK(State%MT%num_q_trans,State%CP%Transfer%PK_num_redshifts)
    integer, intent(in) :: var1, var2
    logical :: hubble_units

    call Transfer_GetUnsplinedNonlinearPower(State, State%MT, PK, var1, var2, hubble_units)

    end subroutine CAMBdata_GetNonLinearMatterPower


    subroutine CAMBdata_GetMatterPower(State, outpower, minkh, dlnkh, npoints, var1, var2)
    Type(CAMBdata) :: State
    integer, intent(in) :: npoints, var1, var2
    real(dl), intent(out) :: outpower(npoints,State%CP%Transfer%PK_num_redshifts)
    real(dl), intent(in) :: minkh, dlnkh
    integer i

    do i=1,State%CP%Transfer%PK_num_redshifts
        call Transfer_GetMatterPowerD(State, State%MT, outpower(:,i), &
            State%CP%Transfer%PK_num_redshifts-i+1, minkh, dlnkh, npoints, var1, var2)
    end do

    end subroutine CAMBdata_GetMatterPower

    subroutine CAMB_SetTotCls(State,lmax, tot_scalar_Cls)
    type(CAMBdata) State
    integer, intent(IN) :: lmax
    real(dl), intent(OUT) :: tot_scalar_cls(4, 0:lmax)
    integer l

    tot_scalar_cls = 0
    do l=State%CP%Min_l, lmax
        if (State%CP%WantScalars .and. l<= State%CP%Max_l) then
            if (State%CP%DoLensing) then
                if (l<=State%CLData%lmax_lensed) &
                    tot_scalar_cls(1:4,l) = State%CLData%Cl_lensed(l, CT_Temp:CT_Cross)
            else
                tot_scalar_cls(1:2,l) = State%CLData%Cl_scalar(l,C_Temp:C_E)
                tot_scalar_cls(4,l) = State%CLData%Cl_scalar(l, C_Cross)
            endif
        end if
        if (State%CP%WantTensors .and. l <= State%CP%Max_l_tensor) then
            tot_scalar_cls(1:4,l) = tot_scalar_cls(1:4,l) &
                + State%CLData%Cl_tensor(l, CT_Temp:CT_Cross)
        end if
    end do

    end subroutine CAMB_SetTotCls

    subroutine CAMB_SetUnlensedCls(State,lmax, unlensed_cls)
    Type(CAMBdata) :: State
    integer, intent(IN) :: lmax
    real(dl), intent(OUT) :: unlensed_cls(4,0:lmax)
    integer l

    unlensed_cls = 0
    do l=State%CP%Min_l, lmax
        if (State%CP%WantScalars .and. l<= State%CP%Max_l) then
            unlensed_cls(1:2,l) = State%CLData%Cl_scalar(l, C_Temp:C_E)
            unlensed_cls(4,l) = State%CLData%Cl_scalar(l, C_Cross)
        end if
        if (State%CP%WantTensors &
            .and. l <= State%CP%Max_l_tensor) then
            unlensed_cls(1:4,l) = unlensed_cls(1:4,l) &
                + State%CLData%Cl_tensor(l, CT_Temp:CT_Cross)
        end if
    end do

    end subroutine CAMB_SetUnlensedCls

    subroutine CAMB_SetLensPotentialCls(State,lmax, cls)
    use constants
    Type(CAMBdata) :: State
    integer, intent(IN) :: lmax
    real(dl), intent(OUT) :: cls(3, 0:lmax) !phi-phi, phi-T, phi-E
    integer l

    cls = 0
    if (State%CP%WantScalars .and. State%CP%DoLensing) then
        do l=State%CP%Min_l, min(lmax,State%CP%Max_l)
            cls(1,l) = State%CLData%Cl_scalar(l,C_Phi) * (real(l+1)/l)**2/const_twopi
            cls(2:3,l) = State%CLData%Cl_scalar(l,C_PhiTemp:C_PhiE) &
                * ((real(l+1)/l)**1.5/const_twopi)
        end do
    end if

    end subroutine CAMB_SetLensPotentialCls

    subroutine CAMB_SetUnlensedScalCls(State,lmax, scalar_Cls)
    Type(CAMBdata) :: State
    integer, intent(IN) :: lmax
    real(dl), intent(OUT) :: scalar_Cls(4, 0:lmax)
    integer lmx

    scalar_Cls = 0
    if (State%CP%WantScalars) then
        lmx = min(State%CP%Max_l, lmax)
        scalar_Cls(1:2,State%CP%Min_l:lmx) = &
            transpose(State%CLData%Cl_Scalar(State%CP%Min_l:lmx, C_Temp:C_E))
        scalar_Cls(4,State%CP%Min_l:lmx) = State%CLData%Cl_Scalar(State%CP%Min_l:lmx, C_Cross)
    end if

    end subroutine CAMB_SetUnlensedScalCls

    subroutine CAMB_SetlensedScalCls(State,lmax, lensed_Cls)
    type(CAMBdata) State
    integer, intent(IN) :: lmax
    real(dl), intent(OUT) :: lensed_Cls(4, 0:lmax)
    integer lmx

    lensed_Cls = 0
    if (State%CP%WantScalars .and. State%CP%DoLensing) then
        lmx = min(lmax,State%CLData%lmax_lensed)
        lensed_Cls(1:4,State%CP%Min_l:lmx) = &
            transpose(State%CLData%Cl_lensed(State%CP%Min_l:lmx, CT_Temp:CT_Cross))
    end if

    end subroutine CAMB_SetlensedScalCls

    subroutine CAMB_SetTensorCls(State,lmax, tensor_Cls)
    Type(CAMBdata) :: State
    integer, intent(IN) :: lmax
    real(dl), intent(OUT) :: tensor_Cls(4, 0:lmax)
    integer lmx

    tensor_Cls = 0
    if (State%CP%WantTensors) then
        lmx = min(lmax,State%CP%Max_l_tensor)
        tensor_Cls(1:4,State%CP%Min_l:lmx) = &
            transpose(State%CLData%Cl_Tensor(State%CP%Min_l:lmx, CT_Temp:CT_Cross))
    end if

    end subroutine CAMB_SetTensorCls


    subroutine CAMB_SetUnlensedScalarArray(State,lmax, ScalarArray, n)
    Type(CAMBdata) :: State
    integer, intent(IN) :: lmax, n
    real(dl), intent(OUT) :: ScalarArray(n, n, 0:lmax)
    integer l

    ScalarArray = 0
    if (State%CP%WantScalars) then
        do l=State%CP%Min_l, min(lmax,State%CP%Max_l)
            ScalarArray(1:n,1:n,l) = State%CLData%Cl_scalar_array(l, 1:n,1:n)
        end do
    end if

    end subroutine CAMB_SetUnlensedScalarArray

    subroutine CAMB_GetBackgroundOutputs(State,outputs, n)
    use constants
    Type(CAMBdata) :: State
    integer, intent(in) :: n
    real(dl), intent(out) :: outputs(4,n)
    integer i

    if (allocated(State%CP%z_outputs)) then
        do i=1, size(State%CP%z_outputs)
            outputs(1,i) = State%BackgroundOutputs%rs_by_D_v(i)
            outputs(2,i) = State%BackgroundOutputs%H(i)*c/1e3_dl
            outputs(3,i) = State%BackgroundOutputs%DA(i)
            outputs(4,i) = (1+State%CP%z_outputs(i))* &
                State%BackgroundOutputs%DA(i) * State%BackgroundOutputs%H(i) !F_AP parameter
        end do
    end if

    end subroutine CAMB_GetBackgroundOutputs


    subroutine set_cls_template(cls_template)
    character(len=*), intent(in) :: cls_template

    if (allocated(highL_CL_template)) deallocate(highL_CL_template)
    highL_unlensed_cl_template = trim(cls_template)
    call CheckLoadedHighLTemplate

    end subroutine set_cls_template

    subroutine GetOutputEvolutionFork(State, EV, times, outputs, nsources,ncustomsources)
    use CAMBmain
    type(CAMBdata) :: State
    type(EvolutionVars) EV
    real(dl), intent(in) :: times(:)
    real(dl), intent(out) :: outputs(:,:,:)
    integer, intent(in) :: nsources, ncustomsources
    real(dl) tau,tol1,tauend, taustart
    integer j,ind
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar), cs2, opacity
    real(dl) yprime(EV%nvar), ddelta, delta, adotoa,growth, a
    real(dl), target :: sources(nsources), custom_sources(ncustomsources)
    real, target :: Arr(Transfer_max)
    procedure(obj_function) :: dtauda

    w=0
    y=0
    taustart = GetTauStart(min(500._dl,EV%q))
    call initial(EV,y, taustart)

    tau=taustart
    ind=1
    tol1=tol/exp(CP%Accuracy%AccuracyBoost*CP%Accuracy%IntTolBoost-1)
    do j=1,size(times)
        tauend = times(j)
        if (tauend<taustart) cycle

        call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
        yprime = 0
        EV%OutputTransfer =>  Arr
        EV%OutputSources => sources
        EV%OutputStep = 0
        if (ncustomsources>0) EV%CustomSources => custom_sources
        call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)
        nullify(EV%OutputTransfer, EV%OutputSources, EV%CustomSources)
        call State%ThermoData%Values(tau,a, cs2,opacity)
        outputs(1:Transfer_Max, j, EV%q_ix) = Arr
        outputs(Transfer_Max+1, j, EV%q_ix) = a
        outputs(Transfer_Max+2, j, EV%q_ix) = y(ix_etak) !etak
        adotoa = 1/(a*dtauda(State,a))
        ddelta= (yprime(ix_clxc)*State%grhoc+yprime(ix_clxb)*State%grhob)/(State%grhob+State%grhoc)
        delta=(State%grhoc*y(ix_clxc)+State%grhob*y(ix_clxb))/(State%grhob+State%grhoc)
        growth= ddelta/delta/adotoa
        outputs(Transfer_Max+3, j, EV%q_ix) = adotoa !hubble
        outputs(Transfer_Max+4, j, EV%q_ix) = growth
        if (.not. EV%no_phot_multpoles) then
            outputs(Transfer_Max+5, j, EV%q_ix) = y(EV%g_ix+1) !v_g
            if (EV%TightCoupling) then
                outputs(Transfer_Max+6, j, EV%q_ix) = EV%pig
                outputs(Transfer_Max+7, j, EV%q_ix) = EV%pig/4 !just first order result
            else
                outputs(Transfer_Max+6, j, EV%q_ix) = y(EV%g_ix+2) !pi_g
                outputs(Transfer_Max+7, j, EV%q_ix) = y(EV%polind+2) !E_2
            end if
        end if
        if (.not. EV%no_nu_multpoles) then
            outputs(Transfer_Max+8, j, EV%q_ix) = y(EV%r_ix+1) !v_r
        end if
        outputs(Transfer_max + 9:Transfer_max + 9 + nsources-1, j, EV%q_ix) = sources
        if (ncustomsources > 0) then
            outputs(Transfer_max + 9+nsources: &
                Transfer_max + 9 + nsources + ncustomsources-1, j, EV%q_ix) = custom_sources
        end if

        if (global_error_flag/=0) return
    end do
    end subroutine GetOutputEvolutionFork

    function CAMB_TimeEvolution(this,nq, q, ntimes, times, noutputs, outputs, &
        ncustomsources,c_source_func) result(err)
    use GaugeInterface
    use CAMBmain
    Type(CAMBdata),target :: this
    integer, intent(in) :: nq, ntimes, noutputs, ncustomsources
    real(dl), intent(in) :: q(nq), times(ntimes)
    real(dl), intent(out) :: outputs(noutputs, ntimes, nq)
    TYPE(C_FUNPTR), INTENT(IN) :: c_source_func
    integer err, q_ix
    real(dl) taustart
    Type(EvolutionVars) :: Ev
    Type(TCUstomSourceParams) :: Old

    call SetActiveState(this)
    if (ncustomsources > 0) then
        ! Convert C to Fortran procedure pointer.
        Old = State%CP%CustomSources
        State%CP%CustomSources%c_source_func = c_source_func
        State%CP%CustomSources%num_custom_sources = ncustomsources
    end if

    global_error_flag = 0
    outputs = 0
    taustart = min(times(1),GetTauStart(maxval(q)))
    if (.not. this%ThermoData%HasTHermoData .or. taustart < this%ThermoData%tauminn) call this%ThermoData%Init(this,taustart)
    !$OMP PARALLEL DO DEFAUlT(SHARED),SCHEDUlE(DYNAMIC), PRIVATE(EV, q_ix)
    do q_ix= 1, nq
        if (global_error_flag==0) then
            EV%q_ix = q_ix
            EV%q = q(q_ix)
            EV%TransferOnly=.false.
            EV%q2=EV%q**2
            EV%ThermoData => this%ThermoData
            call GetNumEqns(EV)
            call GetOutputEvolutionFork(State,EV, times, outputs, 3, ncustomsources)
        end if
    end do
    !$OMP END PARALLEL DO
    if (ncustomsources>0) State%CP%CustomSources = Old
    err = global_error_flag

    end function CAMB_TimeEvolution


    subroutine GetBackgroundThermalEvolution(this, ntimes, times, outputs)
    use splines
    Type(CAMBdata) :: this
    integer, intent(in) :: ntimes
    real(dl), intent(in) :: times(ntimes)
    real(dl) :: outputs(9, ntimes)
    real(dl), allocatable :: spline_data(:), ddxe(:), ddTb(:)
    real(dl) :: a, d, tau, cs2b, opacity, Tbaryon, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow
    integer i, ix

    if (.not. this%ThermoData%HasTHermoData) call this%ThermoData%Init(this,min(1d-3,max(1d-5,minval(times))))

    associate(T=>this%ThermoData)
        allocate(spline_data(T%nthermo), ddxe(T%nthermo), ddTb(T%nthermo))
        call splini(spline_data,T%nthermo)
        call splder(T%xe,ddxe,T%nthermo,spline_data)
        call splder(T%Tb,ddTb,T%nthermo,spline_data)

        outputs = 0
        do ix = 1, ntimes
            tau = times(ix)
            if (tau < T%tauminn*1.01) cycle
            d=log(tau/T%tauminn)/T%dlntau+1._dl
            i=int(d)
            d=d-i
            call T%Values(tau,a,cs2b, opacity)
            call T%IonizationFunctionsAtTime(tau, a, opacity, dopacity, ddopacity, &
                visibility, dvisibility, ddvisibility, exptau, lenswindow)

            if (i < T%nthermo) then
                outputs(1,ix)=T%xe(i)+d*(ddxe(i)+d*(3._dl*(T%xe(i+1)-T%xe(i)) &
                    -2._dl*ddxe(i)-ddxe(i+1)+d*(ddxe(i)+ddxe(i+1) &
                    +2._dl*(T%xe(i)-T%xe(i+1)))))
                Tbaryon = T%tb(i)+d*(ddtb(i)+d*(3._dl*(T%tb(i+1)-T%tb(i)) &
                    -2._dl*ddtb(i)-ddtb(i+1)+d*(ddtb(i)+ddtb(i+1) &
                    +2._dl*(T%tb(i)-T%tb(i+1)))))
            else
                outputs(1,ix)=T%xe(T%nthermo)
                Tbaryon = T%Tb(T%nthermo)
            end if

            outputs(2, ix) = opacity
            outputs(3, ix) = visibility
            outputs(4, ix) = cs2b
            outputs(5, ix) = Tbaryon
            outputs(6, ix) = dopacity
            outputs(7, ix) = ddopacity
            outputs(8, ix) = dvisibility
            outputs(9, ix) = ddvisibility
        end do
    end associate

    end subroutine GetBackgroundThermalEvolution

    end module handles

    !This module provides the initial power spectra, parameterized as an expansion in ln k
    !
    ! ln P_s = ln A_s + (n_s -1)*ln(k/k_0_scalar) + n_{run}/2 * ln(k/k_0_scalar)^2 + n_{runrun}/6 * ln(k/k_0_scalar)^3
    !
    ! so if n_{run} = 0, n_{runrun}=0
    !
    ! P_s = A_s (k/k_0_scalar)^(n_s-1)
    !
    !for the scalar spectrum, when n_s=an(in) is the in'th spectral index. k_0_scalar
    !is a pivot scale, fixed here to 0.05/Mpc (change it below as desired or via .ini file).
    !
    !The tensor spectrum has three different supported parameterizations giving
    !
    ! ln P_t = ln A_t + n_t*ln(k/k_0_tensor) + n_{t,run}/2 * ln(k/k_0_tensor)^2
    !
    ! tensor_parameterization==tensor_param_indeptilt (=1) (default, same as CAMB pre-April 2014)
    !
    ! A_t = r A_s
    !
    ! tensor_parameterization==tensor_param_rpivot (=2)
    !
    ! A_t = r P_s(k_0_tensor)
    !
    ! tensor_parameterization==tensor_param_AT (=3)
    !
    ! A_t =  tensor_amp
    !
    !The absolute normalization of the Cls is unimportant here, but the relative ratio
    !of the tensor and scalar Cls generated with this module will be correct for general models
    !
    !December 2003 - changed default tensor pivot to 0.05 (consistent with CMBFAST 4.5)
    !April 2014 added different tensor parameterizations, running of running and running of tensors

    module InitialPower
    use Precision
    use AMLutils
    implicit none

    private

    character(LEN=*), parameter :: Power_Name = 'power_tilt'

    integer, parameter :: nnmax= 5
    !Maximum possible number of different power spectra to use

    integer, parameter, public :: tensor_param_indeptilt=1,  tensor_param_rpivot = 2, tensor_param_AT = 3

    Type InitialPowerParams
        integer :: tensor_parameterization = tensor_param_indeptilt
        integer nn  !Must have this variable
        !The actual number of power spectra to use

        !For the default implementation return power spectra based on spectral indices
        real(dl) an(nnmax) !scalar spectral indices
        real(dl) n_run(nnmax) !running of spectral index
        real(dl) n_runrun(nnmax) !running of spectral index
        real(dl) ant(nnmax) !tensor spectral indices
        real(dl) nt_run(nnmax) !tensor spectral index running
        real(dl) rat(nnmax) !ratio of scalar to tensor initial power spectrum amplitudes
        real(dl) k_0_scalar, k_0_tensor !pivot scales
        real(dl) ScalarPowerAmp(nnmax)
        real(dl) TensorPowerAmp(nnmax) !A_T at k_0_tensor if tensor_parameterization==tensor_param_AT
    end Type InitialPowerParams

    real(dl) curv  !Curvature contant, set in InitializePowers

    Type(InitialPowerParams), save :: P

    !Make things visible as neccessary...

    public InitialPowerParams, InitialPower_ReadParams, InitializePowers, ScalarPower, TensorPower
    public nnmax,Power_Descript, Power_Name, SetDefPowerParams
    contains


    subroutine SetDefPowerParams(AP)
    Type (InitialPowerParams) :: AP

    AP%nn     = 1 !number of initial power spectra
    AP%an     = 1 !scalar spectral index
    AP%n_run   = 0 !running of scalar spectral index
    AP%n_runrun   = 0 !running of running of scalar spectral index
    AP%ant    = 0 !tensor spectra index
    AP%nt_run   = 0 !running of tensor spectral index
    AP%rat    = 1
    AP%k_0_scalar = 0.05
    AP%k_0_tensor = 0.05
    AP%ScalarPowerAmp = 1
    AP%TensorPowerAmp = 1
    AP%tensor_parameterization = tensor_param_indeptilt

    end subroutine SetDefPowerParams

    subroutine InitializePowers(AParamSet,acurv)
    Type (InitialPowerParams) :: AParamSet
    !Called before computing final Cls in cmbmain.f90
    !Could read spectra from disk here, do other processing, etc.

    real(dl) acurv

    if (AParamSet%nn > nnmax) then
        write (*,*) 'To use ',AParamSet%nn,'power spectra you need to increase'
        write (*,*) 'nnmax in power_tilt.f90, currently ',nnmax
    end if
    P = AParamSet

    curv=acurv

    !Write implementation specific code here...

    end subroutine InitializePowers


    function ScalarPower(k,ix)

    !"ix" gives the index of the power to return for this k
    !ScalarPower = const for scale invariant spectrum
    !The normalization is defined so that for adiabatic perturbations the gradient of the 3-Ricci
    !scalar on co-moving hypersurfaces receives power
    ! < |D_a R^{(3)}|^2 > = int dk/k 16 k^6/S^6 (1-3K/k^2)^2 ScalarPower(k)
    !In other words ScalarPower is the power spectrum of the conserved curvature perturbation given by
    !-chi = \Phi + 2/3*\Omega^{-1} \frac{H^{-1}\Phi' - \Psi}{1+w}
    !(w=p/\rho), so < |\chi(x)|^2 > = \int dk/k ScalarPower(k).
    !Near the end of inflation chi is equal to 3/2 Psi.
    !Here nu^2 = (k^2 + curv)/|curv|

    !This power spectrum is also used for isocurvature modes where
    !< |\Delta(x)|^2 > = \int dk/k ScalarPower(k)
    !For the isocurvture velocity mode ScalarPower is the power in the neutrino heat flux.

    real(dl) ScalarPower,k, lnrat
    integer ix

    lnrat = log(k/P%k_0_scalar)
    ScalarPower=P%ScalarPowerAmp(ix)*exp(lnrat*( P%an(ix)-1 + lnrat*(P%n_run(ix)/2 + P%n_runrun(ix)/6*lnrat)))

    !         ScalarPower = ScalarPower * (1 + 0.1*cos( lnrat*30 ) )

    end function ScalarPower


    function TensorPower(k,ix)

    !TensorPower= const for scale invariant spectrum
    !The normalization is defined so that
    ! < h_{ij}(x) h^{ij}(x) > = \sum_nu nu /(nu^2-1) (nu^2-4)/nu^2 TensorPower(k)
    !for a closed model
    ! < h_{ij}(x) h^{ij}(x) > = int d nu /(nu^2+1) (nu^2+4)/nu^2 TensorPower(k)
    !for an open model
    !"ix" gives the index of the power spectrum to return
    !Here nu^2 = (k^2 + 3*curv)/|curv|

    real(dl) TensorPower,k
    real(dl), parameter :: PiByTwo=3.14159265d0/2._dl
    integer ix
    real(dl) lnrat, k_dep

    lnrat = log(k/P%k_0_tensor)
    k_dep = exp(lnrat*(P%ant(ix) + P%nt_run(ix)/2*lnrat))
    if (P%tensor_parameterization==tensor_param_indeptilt) then
        TensorPower = P%rat(ix)*P%ScalarPowerAmp(ix)*k_dep
    else if (P%tensor_parameterization==tensor_param_rpivot) then
        TensorPower = P%rat(ix)*ScalarPower(P%k_0_tensor,ix) * k_dep
    else if (P%tensor_parameterization==tensor_param_AT) then
        TensorPower = P%TensorPowerAmp(ix) * k_dep
    end if
    if (curv < 0) TensorPower=TensorPower*tanh(PiByTwo*sqrt(-k**2/curv-3))

    end function TensorPower

    !Get parameters describing parameterisation (for FITS file)
    !Does not support running extensions
    function Power_Descript(in, Scal, Tens, Keys, Vals)
    character(LEN=8), intent(out) :: Keys(*)
    real(dl), intent(out) :: Vals(*)
    integer, intent(IN) :: in
    logical, intent(IN) :: Scal, Tens
    integer num, Power_Descript
    num=0
    if (Scal) then
        num=num+1
        Keys(num) = 'n_s'
        Vals(num) = P%an(in)
        num=num+1
        Keys(num) = 'n_run'
        Vals(num) = P%n_run(in)
        num=num+1
        Keys(num) = 's_pivot'
        Vals(num) = P%k_0_scalar
    end if
    if (Tens) then
        num=num+1
        Keys(num) = 'n_t'
        Vals(num) = P%ant(in)
        num=num+1
        Keys(num) = 't_pivot'
        Vals(num) = P%k_0_tensor
        if (Scal) then
            num=num+1
            Keys(num) = 'p_ratio'
            Vals(num) = P%rat(in)
        end if
    end if
    Power_Descript = num

    end  function Power_Descript

    subroutine InitialPower_ReadParams(InitPower, Ini, WantTensors)
    use IniFile
    Type(InitialPowerParams) :: InitPower
    Type(TIniFile) :: Ini
    logical, intent(in) :: WantTensors
    integer i

    InitPower%k_0_scalar = Ini_Read_Double_File(Ini,'pivot_scalar',InitPower%k_0_scalar)
    InitPower%k_0_tensor = Ini_Read_Double_File(Ini,'pivot_tensor',InitPower%k_0_tensor)
    InitPower%nn = Ini_Read_Int_File(Ini,'initial_power_num',1)
    if (InitPower%nn>nnmax) call MpiStop('Too many initial power spectra - increase nnmax in InitialPower')
    if (WantTensors) then
        InitPower%tensor_parameterization =  Ini_Read_Int_File(Ini, 'tensor_parameterization',tensor_param_indeptilt)
        if (InitPower%tensor_parameterization < tensor_param_indeptilt .or. &
            & InitPower%tensor_parameterization > tensor_param_AT) &
            & call MpiStop('InitialPower: unknown tensor_parameterization')
    end if
    InitPower%rat(:) = 1
    do i=1, InitPower%nn
        InitPower%an(i) = Ini_Read_Double_Array_File(Ini,'scalar_spectral_index', i)
        InitPower%n_run(i) = Ini_Read_Double_Array_File(Ini,'scalar_nrun',i,0._dl)
        InitPower%n_runrun(i) = Ini_Read_Double_Array_File(Ini,'scalar_nrunrun',i,0._dl)

        if (WantTensors) then
            InitPower%ant(i) = Ini_Read_Double_Array_File(Ini,'tensor_spectral_index',i)
            InitPower%nt_run(i) = Ini_Read_Double_Array_File(Ini,'tensor_nrun',i,0._dl)
            if (InitPower%tensor_parameterization == tensor_param_AT) then
                InitPower%TensorPowerAmp(i) = Ini_Read_Double_Array_File(Ini,'tensor_amp',i)
            else
                InitPower%rat(i) = Ini_Read_Double_Array_File(Ini,'initial_ratio',i)
            end if
        end if

        InitPower%ScalarPowerAmp(i) = Ini_Read_Double_Array_File(Ini,'scalar_amp',i,1._dl)
        !Always need this as may want to set tensor amplitude even if scalars not computed
    end do

    end  subroutine InitialPower_ReadParams


    end module InitialPower

    module classes
    use precision
    use MpiUtils
    use interpolation, only : TSpline1D, TCubicSpline, TLogRegularCubicSpline
    use IniObjects
    implicit none

    Type MatterTransferData
        !Computed data
        integer   ::  num_q_trans   !    number of steps in k for transfer calculation
        real(dl), dimension (:), allocatable :: q_trans
        real(dl), dimension (:), allocatable ::  sigma_8
        real(dl), dimension (:), allocatable ::  sigma2_vdelta_8 !growth from sigma_{v delta}
        real, dimension(:,:,:), allocatable :: TransferData
        !TransferData(entry,k_index,z_index) for entry=Tranfer_kh.. Transfer_tot
    contains
    procedure :: Free => MatterTransferData_Free
    end Type MatterTransferData

    Type MatterPowerData
        !everything is a function of k/h
        integer   ::  num_k, num_z
        real(dl), dimension(:), allocatable :: log_kh, redshifts
        !matpower is log(P_k)
        real(dl), dimension(:,:), allocatable :: matpower, ddmat
        !if NonLinear, nonlin_ratio =  sqrt(P_nonlinear/P_linear)
        !function of k and redshift NonLinearScaling(k_index,z_index)
        real(dl), dimension(:,:), allocatable :: nonlin_ratio
        !Sources
        real(dl), dimension(:), allocatable :: log_k
        real(dl), dimension(:,:), allocatable :: vvpower, ddvvpower
        real(dl), dimension(:,:), allocatable :: vdpower, ddvdpower

        real(dl), dimension(:,:), allocatable :: nonlin_ratio_vv
        real(dl), dimension(:,:), allocatable :: nonlin_ratio_vd

    end Type MatterPowerData

    !Classes that can be accessed from python and contain allocatable objects and arrays or other classes
    !In Python inherited from F2003Class (defined in baseconfig)
    !All python-accessible inherited classes must define SelfPointer, and use @fortran_class decorator in python
    !Allocatable objects can only contain instances of python-accessible classes so they can be identified from python.
    !Class could be abstract and SelfPointer deferred, but Fortran then doesn't allow called inherited "super()"
    !methods implemented in abstract classes
    Type TPythonInterfacedClass
    contains
    !SelfPointer msust be overriden for each class to be referenced from python.
    !Gets a class pointer from an untyped pointer.
    procedure, nopass :: SelfPointer
    !PythonClass gets string of python class name; not actually used internally
    procedure, nopass :: PythonClass
    !Replace is for copying over this type with an instance of the same type
    !It must be defined for any class used as a non-allocatable python structure field that can be assigned to
    procedure :: Replace
    end type TPythonInterfacedClass

    Type PythonClassPtr
        class(TPythonInterfacedClass), pointer :: Ref => null()
    end type

    Type PythonClassAllocatable
        class(TPythonInterfacedClass), allocatable :: P
    end Type PythonClassAllocatable


    type, extends(TPythonInterfacedClass) :: TCambComponent
    contains
    procedure :: ReadParams => TCambComponent_ReadParams
    procedure :: Validate =>  TCambComponent_Validate
    end type TCambComponent


    type, extends(TPythonInterfacedClass) :: TCAMBParameters
        !Actual type defined in model.f90
    end type TCAMBParameters

    Type, extends(TPythonInterfacedClass) :: TCAMBdata
        !Actual type defined in results.f90
    end type TCAMBdata

    type, extends(TCambComponent) :: TNonLinearModel
        real(dl) :: Min_kh_nonlinear  = 0.005_dl
    contains
    procedure :: Init => TNonLinearModel_init
    procedure :: GetNonLinRatios => TNonLinearModel_GetNonLinRatios
    procedure :: GetNonLinRatios_All => TNonLinearModel_GetNonLinRatios_All
    end type TNonLinearModel

    type, extends(TCambComponent) :: TInitialPower
    contains
    procedure :: ScalarPower => TInitialPower_ScalarPower
    procedure :: TensorPower => TInitialPower_TensorPower
    procedure :: Init => TInitialPower_Init
    procedure :: Effective_ns => TInitalPower_Effective_ns
    end type TInitialPower

    Type, extends(TCambComponent) :: TRecombinationModel
        real(dl) :: min_a_evolve_Tm = 1/(1+900.) !scale factor at which to start evolving Delta_TM
    contains
    procedure :: Init => TRecombinationModel_init
    procedure :: x_e => TRecombinationModel_xe !ionization fraction
    procedure :: xe_Tm => TRecombinationModel_xe_Tm !ionization fraction and baryon temperature
    procedure :: T_m => TRecombinationModel_tm !baryon temperature
    procedure :: T_s => TRecombinationModel_ts !Spin temperature
    procedure :: Version => TRecombinationModel_version
    procedure :: dDeltaxe_dtau => TRecombinationModel_dDeltaxe_dtau
    procedure :: get_Saha_z => TRecombinationModel_Get_Saha_z
    end type

    Type, extends(TCambComponent) :: TReionizationModel
        logical  :: Reionization = .true.
    contains
    procedure :: Init => TReionizationModel_Init
    procedure :: x_e => TReionizationModel_xe
    procedure :: get_timesteps => TReionizationModel_get_timesteps
    end Type TReionizationModel


    interface
    subroutine TClassDverk (this,n, fcn, x, y, xend, tol, ind, c, nw, w)
    use Precision
    import
    class(TCambComponent), target :: this
    integer n, ind
    real(dl) x, y(n), xend, tol, c(*), w(nw,9)
    external fcn
    end subroutine
    end interface

    contains

    subroutine TCambComponent_ReadParams(this, Ini)
    class(TCambComponent) :: this
    class(TIniFile), intent(in) :: Ini

    end subroutine TCambComponent_ReadParams

    subroutine  TCambComponent_Validate(this, OK)
    class(TCambComponent),intent(in) :: this
    logical, intent(inout) :: OK

    end subroutine TCambComponent_Validate


    function PythonClass()
    character(LEN=:), allocatable :: PythonClass

    PythonClass = ''
    error stop 'PythonClass Not implemented'

    end function PythonClass

    subroutine SelfPointer(cptr, P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TPythonInterfacedClass), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType
    error stop 'Class must define SelfPointer function returning pointer to actual type'

    end subroutine SelfPointer

    subroutine Replace(this, replace_with)
    class(TPythonInterfacedClass), target :: this
    class(TPythonInterfacedClass) :: replace_with

    error stop 'Assignment not implemented for this class'

    end subroutine Replace

    subroutine TNonLinearModel_Init(this, State)
    class(TNonLinearModel) :: this
    class(TCAMBdata), target :: State
    end subroutine TNonLinearModel_Init

    subroutine TNonLinearModel_GetNonLinRatios(this,State,CAMB_Pk)
    class(TNonLinearModel) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk
    error stop 'GetNonLinRatios Not implemented'
    end subroutine TNonLinearModel_GetNonLinRatios

    subroutine TNonLinearModel_GetNonLinRatios_All(this,State,CAMB_Pk)
    class(TNonLinearModel) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk
    error stop 'GetNonLinRatios_all  not supported (no non-linear velocities)'
    end subroutine TNonLinearModel_GetNonLinRatios_All


    function TInitialPower_ScalarPower(this, k)
    class(TInitialPower) :: this
    real(dl), intent(in) ::k
    real(dl) TInitialPower_ScalarPower

    TInitialPower_ScalarPower = 0
    error stop 'ScalarPower not implemented'
    end function TInitialPower_ScalarPower

    function TInitialPower_TensorPower(this, k)
    class(TInitialPower) :: this
    real(dl), intent(in) ::k
    real(dl) TInitialPower_TensorPower

    TInitialPower_TensorPower = 0
    error stop 'TensorPower not implemented'
    end function TInitialPower_TensorPower


    subroutine TInitialPower_Init(this, Params)
    class(TInitialPower) :: this
    class(TCAMBParameters), intent(in) :: Params
    end subroutine TInitialPower_Init

    function TInitalPower_Effective_ns(this)
    class(TInitialPower) :: this
    real(dl) :: TInitalPower_Effective_ns

    TInitalPower_Effective_ns=1
    call MpiStop('Power spectrum does not support an effective n_s for halofit')

    end function TInitalPower_Effective_ns


    subroutine MatterTransferData_Free(this)
    class(MatterTransferData):: this
    integer st

    deallocate(this%q_trans, STAT = st)
    deallocate(this%TransferData, STAT = st)
    deallocate(this%sigma_8, STAT = st)
    deallocate(this%sigma2_vdelta_8, STAT = st)

    end subroutine MatterTransferData_Free


    function TRecombinationModel_tm(this,a)
    class(TRecombinationModel) :: this
    real(dl), intent(in) :: a
    real(dl) TRecombinationModel_tm

    call MpiStop('TRecombinationModel_tm not implemented')
    TRecombinationModel_tm=0

    end function TRecombinationModel_tm


    function TRecombinationModel_ts(this,a)
    class(TRecombinationModel) :: this
    !zrec(1) is zinitial-delta_z
    real(dl), intent(in) :: a
    real(dl) TRecombinationModel_ts

    call MpiStop('TRecombinationModel_ts not implemented')
    TRecombinationModel_ts=0

    end function TRecombinationModel_ts

    function TRecombinationModel_xe(this,a)
    class(TRecombinationModel) :: this
    real(dl), intent(in) :: a
    real(dl) TRecombinationModel_xe

    call MpiStop('TRecombinationModel_xe not implemented')
    TRecombinationModel_xe=0

    end function TRecombinationModel_xe

    subroutine TRecombinationModel_xe_Tm(this,a, xe, Tm)
    !Not required to implement, but may be able to optimize
    class(TRecombinationModel) :: this
    real(dl), intent(in) :: a
    real(dl), intent(out) :: xe, Tm

    xe = this%x_e(a)
    Tm = this%T_m(a)

    end subroutine TRecombinationModel_xe_Tm

    function TRecombinationModel_version(this) result(version)
    class(TRecombinationModel) :: this
    character(LEN=:), allocatable :: version

    version = ''

    end function TRecombinationModel_version

    subroutine TRecombinationModel_init(this,State, WantTSpin)
    class(TRecombinationModel), target :: this
    class(TCAMBdata), target :: State
    logical, intent(in), optional :: WantTSpin
    end subroutine TRecombinationModel_init

    function TRecombinationModel_dDeltaxe_dtau(this,a, Delta_xe,Delta_nH, Delta_Tm, hdot, kvb,adotoa)
    !d x_e/d tau
    class(TRecombinationModel) :: this
    real(dl) TRecombinationModel_dDeltaxe_dtau
    real(dl), intent(in):: a, Delta_xe,Delta_nH, Delta_Tm, hdot, kvb,adotoa

    call MpiStop('TRecombinationModel_dDeltaxe_dtau not implemented')
    TRecombinationModel_dDeltaxe_dtau=0

    end function TRecombinationModel_dDeltaxe_dtau

    real(dl) function TRecombinationModel_Get_Saha_z(this)
    class(TRecombinationModel) :: this
    call MpiStop('TRecombinationModel_Get_Saha_z not implemented')
    TRecombinationModel_Get_Saha_z = 0
    end function

    function TReionizationModel_xe(this, z, tau, xe_recomb)
    !a and time tau and redundant, both provided for convenience
    !xe_recomb is xe(tau_start) from recombination (typically very small, ~2e-4)
    !xe should map smoothly onto xe_recomb
    class(TReionizationModel) :: this
    real(dl), intent(in) :: z
    real(dl), intent(in), optional :: tau, xe_recomb
    real(dl) TReionizationModel_xe

    call MpiStop('TReionizationModel_xe not implemented')
    TReionizationModel_xe=0

    end function TReionizationModel_xe

    subroutine TReionizationModel_get_timesteps(this, n_steps, z_start, z_complete)
    !minimum number of time steps to use between tau_start and tau_complete
    !Scaled by AccuracyBoost later
    !steps may be set smaller than this anyway
    class(TReionizationModel) :: this
    integer, intent(out) :: n_steps
    real(dl), intent(out):: z_start, z_Complete
    call MpiStop('TReionizationModel_get_timesteps not implemented')
    n_steps=0
    z_start=0
    z_complete=0
    end subroutine TReionizationModel_get_timesteps

    subroutine TReionizationModel_Init(this, State)
    class(TReionizatioNModel) :: this
    class(TCAMBdata), target :: State
    end subroutine TReionizationModel_Init

    end module classes

    !Module to read in name/value pairs from a file, with each line of the form line 'name = value'
    !Should correctly interpret FITS headers
    !Antony Lewis (http://cosmologist.info/). Released to the public domain.
    !2014 using Fortran 2003/2008

    module IniObjects
    use FileUtils
    use StringUtils
    use MiscUtils
    implicit none
    private

    character(LEN=0), target :: Empty_String = ''
    integer, parameter :: Ini_Enumeration_Len = 64

    type TNameValue
        character(LEN=:), allocatable :: Name
        character(LEN=:), allocatable :: Value
    end type TNameValue

    type TNameValue_pointer
        Type(TNameValue), pointer :: P
    end type TNameValue_pointer

    Type TNameValueList
        integer :: Count = 0
        integer :: Delta = 128
        integer :: Capacity = 0
        logical :: ignoreDuplicates = .false.
        logical :: AllowDuplicateKeys = .false.
        !Use pointer so arrays can be moved around quickly without deep copies
        type(TNameValue_pointer), dimension(:), allocatable :: Items
    contains
    procedure :: Init => TNameValueList_Init
    procedure :: Clear => TNameValueList_Clear
    procedure :: ValueOf => TNameValueList_ValueOf
    procedure :: IndexOf => TNameValueList_IndexOf
    procedure :: HasKey => TNameValueList_HasKey
    procedure :: SetCapacity => TNameValueList_SetCapacity
    procedure :: Delete => TNameValueList_Delete
    procedure :: Error => TNameValueList_Error
    procedure :: FailStop => TNameValueList_FailStop
    procedure :: AddString => TNameValueList_Add
    procedure :: Name => TNameValueList_Name
    procedure :: Value => TNameValueList_Value
    procedure :: Override => TNameValueList_Override
    procedure :: TNameValueList_AddDouble
    procedure :: TNameValueList_AddReal
    procedure :: TNameValueList_AddInt
    procedure :: TNameValueList_AddLogical
    generic :: Add => AddString, TNameValueList_AddDouble, &
        &                 TNameValueList_AddReal, TNameValueList_AddInt,&
        &                 TNameValueList_AddLogical
    final :: TNameValueList_Free
    end Type TNameValueList

    Type, extends(TNameValueList) :: TIniFile
        logical :: SlashComments = .false.
        logical :: Echo_Read = .false.
        logical :: Fail_on_not_found = .false.
        logical :: ExpandEnvironmentVariables = .true.
        character(LEN=:), allocatable :: Original_filename
        Type(TNameValueList) :: ReadValues
    contains
    procedure :: Open => Ini_Open
    procedure :: Open_Fromlines => Ini_Open_Fromlines
    procedure :: Close => Ini_Close
    procedure :: Read_String => Ini_Read_String
    procedure :: Read_String_Default => Ini_Read_String_Default
    procedure :: Read_String_Array => Ini_Read_String_Array
    procedure :: Read_Int_Array => Ini_Read_Int_Array
    procedure :: Read_Int => Ini_Read_Int
    procedure :: Read_Double => Ini_Read_Double
    procedure :: Read_Double_Array => Ini_Read_Double_Array
    procedure :: Read_Real => Ini_Read_Real
    procedure :: Read_Real_Array => Ini_Read_Real_Array
    procedure :: Read_Logical => Ini_Read_Logical
    procedure :: Read_Enumeration => Ini_Read_Enumeration
    procedure :: Read_Enumeration_List => Ini_Read_Enumeration_List
    procedure :: TestEqual => Ini_TestEqual
    procedure :: SaveReadValues => Ini_SaveReadValues
    procedure :: Key_To_Arraykey => Ini_Key_To_Arraykey
    procedure :: EnumerationValue => Ini_EnumerationValue
    procedure :: ResolveLinkedFile => Ini_ResolveLinkedFile
    procedure :: ExpandEnvironment => Ini_ExpandEnvironment
    procedure, private :: NameValue_AddLine => Ini_NameValue_AddLine
    procedure, private :: EmptyCheckDefault => Ini_EmptyCheckDefault
    procedure, private :: Ini_Read_Real_Change
    procedure, private :: Ini_Read_Double_Change
    procedure, private :: Ini_Read_Int_Change
    procedure, private :: Ini_Read_Logical_Change
    procedure, private :: Ini_Read_String_Change
    generic :: Read => Ini_Read_Real_Change, Ini_Read_Double_Change, Ini_Read_Int_Change, &
        &                  Ini_Read_Logical_Change, Ini_Read_String_Change
    end Type TIniFile


    public TNameValueList, TIniFile, Ini_Enumeration_Len
    contains

    subroutine TNameValueList_Init(this, ignoreDuplicates)
    class(TNameValueList) :: this
    logical, intent(in), optional :: ignoreDuplicates

    this%Count = 0
    this%Capacity = 0
    this%Delta = 128
    this%ignoreDuplicates = DefaultFalse(ignoreDuplicates)

    end subroutine TNameValueList_Init

    subroutine TNameValueList_Clear(this)
    class(TNameValueList) :: this
    integer i, status

    do i=this%count,1,-1
        deallocate (this%Items(i)%P, stat = status)
    end do
    deallocate (this%Items, stat = status)
    call this%Init()

    end subroutine TNameValueList_Clear

    subroutine TNameValueList_Free(this)
    Type(TNameValueList) :: this
    call this%Clear()
    end subroutine TNameValueList_Free

    function TNameValueList_ValueOf(this, AName) result(AValue)
    class(TNameValueList), intent(in) :: this
    character(LEN=*), intent(in) :: AName
    character(LEN=:), pointer :: AValue
    integer i

    i = this%IndexOf(AName)
    if (i/=-1) then
        AValue => this%Items(i)%P%Value
    else
        AValue => Empty_String
    end if

    end function TNameValueList_ValueOf

    function TNameValueList_Name(this, i) result(Name)
    class(TNameValueList), intent(in) :: this
    integer i
    character(LEN=:), pointer :: Name

    Name => this%Items(i)%P%Name

    end function TNameValueList_Name

    function TNameValueList_Value(this, i) result(Value)
    class(TNameValueList), intent(in) :: this
    integer i
    character(LEN=:), pointer :: Value

    Value => this%Items(i)%P%Value

    end function TNameValueList_Value


    function TNameValueList_IndexOf(this, AName) result (AValue)
    class(TNameValueList), intent(in) :: this
    character(LEN=*), intent(in) :: AName
    integer :: AValue
    integer i

    do i=1, this%Count
        if (this%Items(i)%P%Name == AName) then
            AValue = i
            return
        end if
    end do
    AValue = -1

    end function TNameValueList_IndexOf

    function TNameValueList_HasKey(this, AName) result (AValue)
    class(TNameValueList), intent(in) :: this
    character(LEN=*), intent(in) :: AName
    logical :: AValue

    AValue = this%IndexOf(AName) /= -1

    end function TNameValueList_HasKey

    subroutine TNameValueList_Override(this, Settings, only_if_exists)
    class(TNameValueList) :: this
    class(TNameValueList), intent(in) :: Settings
    logical, intent(in), optional :: only_if_exists
    integer i, ix
    character(LEN=:), pointer :: name

    do i=1, Settings%Count
        name => Settings%Name(i)
        ix = this%IndexOf(name)
        if (ix/=-1) then
            this%Items(ix)%P%Value = Settings%Value(i)
        elseif (.not. DefaultFalse(only_if_exists)) then
            call this%Add(name, Settings%Value(i))
        end if
    end do

    end subroutine TNameValueList_Override

    subroutine TNameValueList_Add(this, AName, AValue, only_if_undefined)
    class(TNameValueList) :: this
    character(LEN=*), intent(in) :: AName, AValue
    logical, optional, intent(in) :: only_if_undefined
    logical isDefault

    isDefault = DefaultTrue(only_if_undefined)

    if ((.not. this%AllowDuplicateKeys .or. isDefault) .and. this%HasKey(AName)) then
        if (this%ignoreDuplicates .or. isDefault) return
        call this%Error('duplicate key name',AName)
    end if
    if (this%Count == this%Capacity) call this%SetCapacity(this%Capacity + this%Delta)
    this%Count = this%Count + 1
    allocate(this%Items(this%Count)%P)
    this%Items(this%Count)%P%Name = trim(adjustl(AName))
    this%Items(this%Count)%P%Value = trim(adjustl(AValue))

    end subroutine TNameValueList_Add

    subroutine TNameValueList_AddReal(this, AName, AValue)
    class(TNameValueList) :: this
    character(LEN=*), intent(in) :: AName
    real, intent(in) :: AValue
    character(LEN=32) tmp

    write(tmp,*) AValue
    call this%AddString(AName, Tmp)

    end subroutine TNameValueList_AddReal

    subroutine TNameValueList_AddDouble(this, AName, AValue)
    class(TNameValueList) :: this
    character(LEN=*), intent(in) :: AName
    double precision, intent(in) :: AValue
    character(LEN=32) tmp

    write(tmp,*) AValue
    call this%AddString(AName, Tmp)

    end subroutine TNameValueList_AddDouble


    subroutine TNameValueList_AddInt(this, AName, AValue)
    class(TNameValueList) :: this
    character(LEN=*), intent(in) :: AName
    integer, intent(in) :: AValue
    character(LEN=32) tmp

    write(tmp,*) AValue
    call this%AddString(AName, Tmp)

    end subroutine TNameValueList_AddInt


    subroutine TNameValueList_AddLogical(this, AName, AValue)
    class(TNameValueList) :: this
    character(LEN=*), intent(in) :: AName
    logical, intent(in) :: AValue
    character(LEN=32) tmp

    write(tmp,*) AValue
    call this%AddString(AName, Tmp)

    end subroutine TNameValueList_AddLogical


    subroutine TNameValueList_SetCapacity(this, C)
    class(TNameValueList) :: this
    integer C
    type(TNameValue_pointer), dimension(:), allocatable :: TmpItems

    if (this%Count > 0) then
        if (C < this%Count) call this%Error('TNameValueList_SetCapacity, smaller than Count')
        allocate(TmpItems(C))
        TmpItems(:this%Count) = this%Items(:this%Count)
        call move_alloc(TmpItems, this%Items)
    else
        allocate(this%Items(C))
    end if
    this%Capacity = C

    end subroutine TNameValueList_SetCapacity

    subroutine TNameValueList_Delete(this, i)
    class(TNameValueList) :: this
    integer, intent(in) :: i

    deallocate(this%Items(i)%P)
    if (this%Count > 1) this%Items(i:this%Count-1) = this%Items(i+1:this%Count)
    this%Count = this%Count -1

    end subroutine TNameValueList_Delete

    subroutine TNameValueList_FailStop(this)
    class(TNameValueList) :: this

    error stop

    end subroutine TNameValueList_FailStop

    subroutine TNameValueList_Error(this, Msg, Key)
    class(TNameValueList) :: this
    character(LEN=*) :: Msg
    character(LEN=*), optional :: Key

    if (present(Key)) then
        write(*,*) 'Error for key "'//trim(Key)//'" : '//Msg
    else
        write(*,*) 'Error :'//Msg
    end if
    call this%FailStop()

    end subroutine TNameValueList_Error

    subroutine Ini_EmptyCheckDefault(this, Key, Default)
    class(TIniFile) :: this
    character(LEN=*), intent(in) :: Key
    class(*), optional, intent(in) :: Default

    if (.not. present(Default)) call this%Error('missing key',Key)

    end subroutine Ini_EmptyCheckDefault

    function Ini_ExpandEnvironment(this, InValue) result(res)
    !expand $(PLACEHOLDER) with environment variables, as Makefile
    class(TIniFile) :: this
    character(LEN=:), allocatable, intent(in) :: InValue
    character(LEN=:), allocatable :: res, S
    integer i

    i = index(InValue,'$(')
    if (i > 0) then
        res = InValue(:i-1)
        S = InValue(i:)
        i=1
        do while (i <= len(S))
            if (S(i:i)=='$') then
                if (S(i+1:i+1)=='$') then
                    res = res // '$'
                    i = i + 1
                else if (S(i+1:i+1)=='(') then
                    S = S(i+2:)
                    i = index(S,')')
                    if (i==0) then
                        call this%Error('bad environment placeholder: '//InValue)
                    end if
                    res = res //GetEnvironmentVariable(S(:i-1))
                end if
            else
                res = res // S(i:i)
            end if
            i = i + 1
        end do
    else
        res = InValue
    end if

    end function Ini_ExpandEnvironment

    subroutine Ini_NameValue_AddLine(this,AInLine,only_if_undefined)
    class(TIniFile) :: this
    character (LEN=*), intent(IN) :: AInLine
    integer EqPos, slashpos, lastpos
    logical, optional, intent(in) :: only_if_undefined
    logical isDefault
    character (LEN=len(AInLine)) :: AName, InLine
    character(LEN=:), allocatable ::  val

    isDefault = DefaultFalse(only_if_undefined)

    InLine=trim(adjustl(AInLine))
    EqPos = scan(InLine,'=')
    if (EqPos/=0 .and. InLine(1:1)/='#' .and. .not. StringStarts(InLine,'COMMENT')) then
        AName = trim(InLine(1:EqPos-1))

        val = adjustl(InLine(EqPos+1:))
        if (this%SlashComments) then
            slashpos=scan(val,'/')
            if (slashpos /= 0) then
                val  = val(1:slashpos-1)
            end if
        end if
        if (this%ExpandEnvironmentVariables) then
            val = this%ExpandEnvironment(val)
        end if
        lastpos=len_trim(val)
        if (lastpos>1) then
            if (val(1:1)=='''' .and. val(lastpos:lastpos)=='''') then
                val = val(2:lastpos-1)
            end if
        end if
        call this%Add(AName, val, only_if_undefined = isDefault)
    end if

    end subroutine Ini_NameValue_AddLine

    function Ini_ResolveLinkedFile(this, name, thisfilename) result(IncludeFile)
    class(TIniFile) :: this
    character(LEN=*), intent(in) :: name, thisfilename
    character(LEN=:), allocatable :: IncludeFile

    if (.not. File%IsFullPath(name)) then
        IncludeFile= File%ExtractPath(thisfilename)//trim(name)
        if (File%Exists(IncludeFile)) then
            if (File%Exists(name) .and. name/=IncludeFile) &
                call this%Error(trim(thisfilename)// &
                ' , ambiguous multiple matches to include file: '//trim(name))
        else
            IncludeFile= name
        end if
    else
        IncludeFile= name
    end if
    if (.not. File%Exists(IncludeFile)) then
        call this%Error(trim(thisfilename)//' , include file not found: '//trim(name))
    end if

    end function Ini_ResolveLinkedFile

    recursive subroutine Ini_Open(this, filename, error, slash_comments, append,only_if_undefined)
    class(TIniFile) :: this
    character (LEN=*), intent(IN) :: filename
    logical, intent(OUT), optional :: error
    logical, optional, intent(IN) :: slash_comments
    logical, optional, intent(in) :: append, only_if_undefined
    character (LEN=:), allocatable :: IncludeFile
    character(LEN=:), allocatable :: InLine
    integer lastpos, i, status
    Type(TNameValueList) IncudeFiles, DefaultValueFiles
    logical isDefault
    Type(TTextFile) :: F


    isDefault = DefaultFalse(only_if_undefined)

    if (.not. DefaultFalse(append)) then
        call this%TNameValueList%Init()
        call this%ReadValues%Init(.true.)
        this%Original_filename = filename
    end if

    this%SlashComments = DefaultFalse(slash_comments)

    call F%Open(filename, status=status)
    if (status/=0) then
        if (present(error)) then
            error=.true.
            return
        else
            call this%Error('Ini_Open, file not found: '//trim(filename))
        end if
    end if

    call IncudeFiles%Init()
    call DefaultValueFiles%Init()

    do
        if (.not. F%ReadLineSkipEmptyAndComments(InLine)) exit
        if (InLine == 'END') exit
        if (StringStarts(InLine,'INCLUDE(')) then
            lastpos = scan(InLine,')')
            if (lastpos/=0) then
                call IncudeFiles%Add(InLine(9:lastpos-1),'')
            else
                call this%Error('Ini_Open, error in INCLUDE line: '//trim(filename))
            end if
        elseif (StringStarts(InLine,'DEFAULT(')) then
            !Settings to read in as defaults, overridden by subsequent re-definitions
            lastpos = scan(InLine,')')
            if (lastpos/=0) then
                call DefaultValueFiles%Add(InLine(9:lastpos-1),'')
            else
                call this%Error('Ini_Open, error in DEFAULT line: '//trim(filename))
            end if
        elseif (InLine /= '') then
            call this%NameValue_AddLine(InLine, only_if_undefined=isDefault)
        end if
    end do

    call F%Close()
    if (present(error)) error=.false.

    do i=1, IncudeFiles%Count
        if (DefaultFalse(error)) exit
        IncludeFile = this%ResolveLinkedFile(IncudeFiles%Items(i)%P%Name, filename)
        call this%Open(IncludeFile, error, slash_comments, append=.true.,only_if_undefined=isDefault)
    end do
    do i=1, DefaultValueFiles%Count
        if (DefaultFalse(error)) exit
        IncludeFile = this%ResolveLinkedFile(DefaultValueFiles%Items(i)%P%Name, filename)
        call this%Open(IncludeFile, error, slash_comments, append=.true., only_if_undefined=.true.)
    end do
    call IncudeFiles%Clear()
    call DefaultValueFiles%Clear()

    end subroutine Ini_Open

    subroutine Ini_Open_Fromlines(this, Lines, NumLines, slash_comments)
    class(TIniFile) :: this
    integer, intent(IN) :: NumLines
    character (LEN=*), dimension(NumLines), intent(IN) :: Lines
    logical, intent(IN), optional :: slash_comments
    integer i

    call this%TNameValueList%Init()
    call this%ReadValues%Init(.true.)

    if (present(slash_comments)) then
        this%SlashComments = slash_comments
    end if

    do i=1,NumLines
        call this%NameValue_AddLine(Lines(i))
    end do

    end  subroutine Ini_Open_Fromlines


    subroutine Ini_Close(this)
    class(TIniFile) :: this

    call this%TNameValueList%Clear()
    call this%ReadValues%Clear()

    end  subroutine Ini_Close

    function Ini_Read_String(this, Key, NotFoundFail) result(AValue)
    class(TIniFile) :: this
    character (LEN=*), intent(IN) :: Key
    logical, optional, intent(IN) :: NotFoundFail
    character(LEN=:), pointer :: AValue

    AValue => this%ValueOf(Key)

    if (AValue/='') then
        call  this%ReadValues%Add(Key, AValue)
        if (this%Echo_Read) write (*,*) trim(Key)//' = ',trim(AValue)
        return
    end if
    if (PresentDefault(this%fail_on_not_found, NotFoundFail)) then
        call this%Error('key not found',Key)
    end if

    end function Ini_Read_String

    function Ini_Read_String_Default(this, Key, Default, AllowBlank, EnvDefault) result(AValue)
    !Returns from this first; if not found tries environment variable if EnvDefault is true,
    !If not found returns Default (unless not present, in which case gives error)
    !AllBlank specifies whether an empty string counts as a valid result to give instead of Default
    class(TIniFile) :: this
    character (LEN=*), intent(IN) :: Key
    character (LEN=*), intent(IN), optional ::Default
    logical, intent(in), optional :: AllowBlank
    logical, optional, intent(IN) :: EnvDefault
    character(LEN=:), allocatable :: AValue
    logical is_present

    if (this%HasKey(Key)) then
        AValue = this%Read_String(Key, .false.)
        if (AValue/='' .or. DefaultFalse(AllowBlank)) return
    else
        AValue=''
    end if
    if (DefaultFalse(EnvDefault)) then
        AValue = GetEnvironmentVariable(Key,is_present)
        if (DefaultFalse(AllowBlank) .and. is_present) return
    end if
    if (AValue=='') then
        if (.not. present(Default)) call this%Error('key not found',Key)
        AValue = Default
    end if
    call  this%ReadValues%Add(Key, AValue)
    if (this%Echo_Read) write (*,*) trim(Key)//' = ',trim(AValue)

    end function Ini_Read_String_Default

    function Ini_TestEqual(this, Key, value, EmptyOK) result(OK)
    class(TIniFile) :: this
    character (LEN=*), intent(IN) :: Key, value
    logical, intent(in), optional :: EmptyOK
    character(LEN=:), pointer :: val
    logical :: OK

    val => this%ValueOf(Key)
    OK = val == value
    if (.not. OK .and. present(EmptyOK)) then
        OK = EmptyOK .and. val==''
    end if

    end function Ini_TestEqual

    function Ini_Key_To_Arraykey(this,Key, index)  result(AValue)
    class(TIniFile), intent(in) :: this
    character (LEN=*), intent(IN) :: Key
    integer, intent(in) :: index
    character(LEN=:), allocatable :: AValue
    character(LEN=32) :: numstr

    write (numstr,*) index
    numstr=adjustl(numstr)
    AValue = trim(Key) // '(' // trim(numStr) // ')'

    end function Ini_Key_To_Arraykey

    function Ini_Read_String_Array(this, Key, index, NotFoundFail) result(AValue)
    class(TIniFile) :: this
    integer, intent(in) :: index
    character (LEN=*), intent(IN) :: Key
    logical, optional, intent(IN) :: NotFoundFail
    character(LEN=:), pointer :: AValue
    character(LEN=:), allocatable :: ArrayKey

    ArrayKey = this%Key_To_Arraykey(Key,index)
    AValue => this%Read_String(ArrayKey, NotFoundFail)

    end function Ini_Read_String_Array

    function Ini_Read_Int_Array(this,Key, index, Default)
    !Reads Key(1), Key(2), etc.
    class(TIniFile) :: this
    integer Ini_Read_Int_Array
    integer, optional, intent(IN) :: Default
    integer, intent(in) :: index
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), allocatable :: ArrayKey

    ArrayKey = this%Key_To_Arraykey(Key,index)
    Ini_Read_Int_Array = this%Read_Int(ArrayKey, Default)

    end function Ini_Read_Int_Array

    function Ini_Read_Int(this, Key, Default, min, max, OK)
    class(TIniFile) :: this
    integer Ini_Read_Int
    integer, optional, intent(IN) :: Default, min, max
    logical, intent(out), optional :: OK
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), pointer :: S
    integer status

    S => this%Read_String(Key,.not. present(Default))
    if (S == '') then
        call this%EmptyCheckDefault(Key,Default)
        Ini_Read_Int = Default
        call  this%ReadValues%Add(Key, Default)
    else
        if (verify(trim(S),'-+0123456789') /= 0) then
            status=1
            if (present(OK)) then
                Ini_Read_Int=-1
                OK = .false.
                return
            end if
        else
            read (S,*, iostat=status) Ini_Read_Int
        end if
        if (status/=0) call this%Error('error reading integer',Key)
        if (present(max)) then
            if (Ini_Read_Int > max) call this%Error('value > max',Key)
        end if
        if (present(min)) then
            if (Ini_Read_Int < min) call this%Error('value < min',Key)
        end if
    end if
    if (present(OK)) OK = .true.

    end function Ini_Read_Int

    integer function Ini_EnumerationValue(this, S, Names)
    class(TIniFile) :: this
    character(LEN=*) :: S
    character(LEN=Ini_Enumeration_Len), intent(in) :: Names(:)
    integer i

    do i=1, size(Names)
        if (S==Names(i)) then
            Ini_EnumerationValue = i
            return
        end if
    end do
    Ini_EnumerationValue = -1

    end function Ini_EnumerationValue

    function Ini_Read_Enumeration(this, Key, Names, Default)
    class(TIniFile) :: this
    character(LEN=*), intent(in) :: Key
    character(LEN=Ini_Enumeration_Len), intent(in) :: Names(:)
    integer, optional, intent(in) :: Default
    integer Ini_Read_Enumeration
    character(LEN=:), pointer :: S
    logical OK

    Ini_Read_Enumeration = this%Read_Int(Key, Default, OK = OK)
    if (OK) then
        if (Ini_Read_Enumeration<1 .or. Ini_Read_Enumeration> size(Names)) &
            & call this%Error('enumeration value not valid',Key)
    else
        S => this%ValueOf(Key)
        Ini_Read_Enumeration = this%EnumerationValue(S, Names)
        if (Ini_Read_Enumeration<0) call this%Error('"'//S//'" enumeration name not recognised',Key)
    end if

    end function Ini_Read_Enumeration

    subroutine Ini_Read_Enumeration_List(this, Key, Names, Enums, nvalues, max_enums, Default)
    class(TIniFile) :: this
    character(LEN=*), intent(in) :: Key
    character(LEN=Ini_Enumeration_Len), intent(in) :: Names(:)
    integer, allocatable, intent(out) :: Enums(:)
    character(LEN=*), optional, intent(in) :: Default
    integer, intent(in), optional :: nvalues, max_enums
    integer, parameter :: defmax = 128
    integer :: maxvalues
    integer, allocatable :: Values(:)
    character(LEN=Ini_Enumeration_Len+8) part
    character(LEN=:), allocatable :: InLine
    integer i, slen, pos, n, status

    InLine = this%Read_String_Default(Key, Default)
    pos = 1
    slen = len_trim(InLine)
    n=0
    maxvalues = PresentDefault(PresentDefault(defmax, max_enums), nvalues)
    allocate(Values(maxvalues))
    do
        do while (pos <= slen)
            if (IsWhiteSpace(InLine(pos:pos))) then
                pos = pos+1
            else
                exit
            endif
        end do
        read(InLine(pos:), *, iostat=status) part
        if (status/=0) exit
        pos = pos + len_trim(part)
        i= this%EnumerationValue(part, Names)
        if (i<0) call this%Error('"'//part//'" enumeration name not recognised',Key)
        n=n+1
        if (n > defmax) call this%Error('More than maximum enumeration values', Key)
        values(n) = i
        if (n == maxvalues) exit
    end do
    if (present(nvalues)) then
        if (n==1) then
            !Fill whole array with same value
            allocate(Enums(nvalues), source= values(1))
            return
        elseif (n/=nvalues) then
            call this%Error('Wrong number of enumeration values', Key)
        end if
    end if
    allocate(Enums, source= values(:n))

    end subroutine Ini_Read_Enumeration_List

    function Ini_Read_Double(this,Key, Default, min, max)
    class(TIniFile) :: this
    double precision Ini_Read_Double
    double precision, optional, intent(IN) :: Default, min,max
    character (LEN=*), intent(IN) :: Key
    character(LEN=:), pointer :: S
    integer status

    S => this%Read_String(Key,.not. present(Default))
    if (S == '') then
        call this%EmptyCheckDefault(Key,Default)
        Ini_Read_Double = Default
        call  this%ReadValues%Add(Key, Default)
    else
        read (S,*, iostat=status) Ini_Read_Double
        if (status/=0) call this%Error('error reading double',Key)
    end if
    if (present(max)) then
        if (Ini_Read_Double > max) call this%Error('value > max',Key)
    end if
    if (present(min)) then
        if (Ini_Read_Double < min) call this%Error('value < min',Key)
    end if

    end function Ini_Read_Double

    function Ini_Read_Double_Array(this,Key, index, Default, min, max)
    !Reads Key(1), Key(2), etc.
    class(TIniFile) :: this
    double precision Ini_Read_Double_Array
    double precision, optional, intent(IN) :: Default, min, max
    integer, intent(in) :: index
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), allocatable :: ArrayKey

    ArrayKey = this%Key_To_Arraykey(Key,index)
    Ini_Read_Double_Array = this%Read_Double(ArrayKey, Default, min, max)

    end function Ini_Read_Double_Array


    function Ini_Read_Real(this,Key, Default, min, max)
    class(TIniFile) :: this
    real Ini_Read_Real
    real, optional, intent(IN) :: Default, min, max
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), pointer :: S
    integer status

    S => this%Read_String(Key,.not. present(Default))
    if (S == '') then
        call this%EmptyCheckDefault(Key,Default)
        Ini_Read_Real = Default
        call  this%ReadValues%Add(Key, Default)
    else
        read (S,*, iostat=status) Ini_Read_Real
        if (status/=0) call this%Error('error reading real',Key)
    end if
    if (present(max)) then
        if (Ini_Read_Real > max) call this%Error('value > max',Key)
    end if
    if (present(min)) then
        if (Ini_Read_Real < min) call this%Error('value < min',Key)
    end if

    end function Ini_Read_Real


    function Ini_Read_Real_Array(this,Key, index, Default, min, max)
    !Reads Key(1), Key(2), etc.
    class(TIniFile) :: this
    real Ini_Read_Real_Array
    real, optional, intent(IN) :: Default, min, max
    integer, intent(in) :: index
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), allocatable :: ArrayKey

    ArrayKey = this%Key_To_Arraykey(Key,index)
    Ini_Read_Real_Array = this%Read_Real(ArrayKey, Default,min,max)

    end function Ini_Read_Real_Array

    function Ini_Read_Logical(this, Key, Default)
    class(TIniFile) :: this
    logical Ini_Read_Logical
    logical, optional, intent(IN) :: Default
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), pointer :: S
    integer status

    S => this%Read_String(Key,.not. present(Default))
    if (S == '') then
        call this%EmptyCheckDefault(Key,Default)
        Ini_Read_Logical = Default
        call  this%ReadValues%Add(Key, Default)
    else
        if (verify(trim(S),'10TF') /= 0) then
            status=1
        else
            read (S,*, iostat=status) Ini_Read_Logical
        end if
        if (status/=0) call this%Error('error reading logical',Key)
    end if

    end function Ini_Read_Logical


    subroutine Ini_SaveReadValues(this, afile)
    class(TIniFile) :: this
    character(LEN=*), intent(in) :: afile
    integer i
    Type(TTextFile) :: F

    call F%CreateFile(afile)

    do i=1, this%ReadValues%Count
        call F%Write(this%ReadValues%Items(i)%P%Name, ' = ', this%ReadValues%Items(i)%P%Value)
    end do

    call F%Close()

    end subroutine Ini_SaveReadValues


    subroutine Ini_Read_Int_Change(this, Key, Current, min, max)
    class(TIniFile) :: this
    character(LEN=*), intent(IN) :: Key
    integer, intent(inout) :: Current
    integer, optional, intent(IN) :: min, max
    Current = this%Read_Int(Key,Current,min,max)
    end subroutine Ini_Read_Int_Change

    subroutine Ini_Read_Double_Change(this,Key, Current, min, max)
    class(TIniFile) :: this
    character(LEN=*), intent(IN) :: Key
    double precision, intent(inout) :: Current
    double precision, optional, intent(IN) :: min,max
    Current = this%Read_Double(Key, Current, min, max)
    end subroutine Ini_Read_Double_Change

    subroutine Ini_Read_Real_Change(this,Key, Current, min, max)
    class(TIniFile) :: this
    character(LEN=*), intent(IN) :: Key
    real, intent(inout) :: Current
    real, optional, intent(IN) :: min,max
    Current = this%Read_Real(Key, Current, min, max)
    end subroutine Ini_Read_Real_Change

    subroutine Ini_Read_Logical_Change(this,Key, Current)
    class(TIniFile) :: this
    character(LEN=*), intent(IN) :: Key
    logical, intent(inout) :: Current
    Current = this%Read_Logical(Key, Current)
    end subroutine Ini_Read_Logical_Change

    subroutine Ini_Read_String_Change(this,Key, Current)
    class(TIniFile) :: this
    character(LEN=*), intent(IN) :: Key
    character(LEN=:), allocatable, intent(inout) :: Current

    Current = this%Read_String_Default(Key, Current)

    end subroutine Ini_Read_String_Change

    end module IniObjects

    module SourceWindows
    use precision
    use Classes
    use MpiUtils
    use Interpolation, only : TCubicSpline, TInterpGrid2D
    implicit none

    integer, parameter :: window_21cm = 1, window_counts = 2, window_lensing = 3

    Type, extends(TPythonInterfacedClass) :: TSourceWindow
        integer :: source_type = window_counts
        real(dl) :: bias = 1._dl
        real(dl) :: dlog10Ndm = 0._dl
    contains
    procedure :: count_obs_window_z
    procedure :: Window_f_a
    procedure :: counts_background_z
    procedure :: GetScales
    procedure :: GetBias
    end Type TSourceWindow

    Type, extends(TSourceWindow) :: TGaussianSourceWindow
        real(dl) :: redshift
        real(dl) :: sigma !for 21cm, width in a, otherwise width in z
    contains
    procedure, nopass :: SelfPointer => TGaussianSourceWindow_SelfPointer
    procedure :: count_obs_window_z => TGaussianSourceWindow_count_obs_window_z
    procedure :: Window_f_a => TGaussianSourceWindow_Window_f_a
    procedure :: GetScales => TGaussianSourceWindow_GetScales
    end Type TGaussianSourceWindow

    Type, extends(TSourceWindow) :: TSplinedSourceWindow
        Type(TCubicSpline), allocatable :: Window
        Type(TCubicSpline), allocatable :: Bias_z
        Type(TInterpGrid2D), allocatable :: Bias_zk
        real(dl) :: maxwin
    contains
    procedure, nopass :: SelfPointer => TSplinedSourceWindow_SelfPointer
    procedure :: count_obs_window_z => TSplinedSourceWindow_count_obs_window_z
    procedure :: GetScales => TSplinedSourceWindow_GetScales
    procedure :: SetTable => TSplinedSourceWindow_SetTable
    procedure :: SetTable2DBias => TSplinedSourceWindow_SetTable2DBias
    procedure :: GetBias => TSplinedSourceWindow_GetBias
    end Type TSplinedSourceWindow

    Type TSourceWindowHolder
        class(TSourceWindow), allocatable :: Window
    end Type TSourceWindowHolder

    Type SourceTermParams
        logical :: limber_windows = .true.
        integer :: limber_phi_lmin = 100
        !for l>limber_phi use limber approx for lensing potential when sourceTerms%LimberWindows=True;
        !Limber is also used if LimberWindows=False but via the time integrals instead.
        logical :: counts_density = .true.
        logical :: counts_redshift = .true.
        logical :: counts_lensing = .false.
        logical :: counts_velocity  = .true.
        logical :: counts_radial = .false. !does not include time delay; subset of counts_velocity, just 1/(chi*H) term
        logical :: counts_timedelay = .true. !time delay terms * 1/(H*chi)
        logical :: counts_ISW = .true.
        logical :: counts_potential = .true. !terms in potentials at source
        logical :: counts_evolve = .false.
        logical :: line_phot_dipole = .false.
        logical :: line_phot_quadrupole= .false.
        logical :: line_basic = .true.
        logical :: line_distortions = .true.
        logical :: line_extra = .false.
        logical :: line_reionization = .false.
        logical :: use_21cm_mK = .true.
    end type SourceTermParams

    Type TRedWin !internal type
        class(TSourceWindow), pointer :: Window => null()
        integer kind
        real(dl) Redshift
        real(dl) tau, tau_start, tau_end, tau_peakstart, tau_peakend
        real(dl) sigma_tau !approx width in conformal time (set by code)
        real(dl) chi0, chimin
        integer :: mag_index =0 !The index into the extra sources used for adding magnification to counts
        real(dl), dimension(:), allocatable :: winF, wing,wing2,wingtau,dwing,dwing2,dwingtau,ddwing,ddwing2,ddwingtau,&
            winV,dwinV,ddwinV, win_lens, comoving_density_ev
        real(dl) Fq, optical_depth_21
        logical has_lensing_window
    end Type TRedWin

    contains

    function count_obs_window_z(this, z, winamp)
    !distribution function W(z) for the observed sources, used for lensing and number count spectrum
    !Winamp is amplitude normalized to 1 so the code can tell when the window is very small
    !note this is the total count distribution observed, not a fractional selection function on an underlying distribution
    class(TSourceWindow) :: this
    real(dl), intent(in) :: z
    real(dl) count_obs_window_z, winamp
    count_obs_window_z =0
    end function count_obs_window_z


    function counts_background_z(this, z)
    !if counts_evolve = T this function is used to get n(z) for the source population
    !(not the same as the number actually observed)
    class(TSourceWindow) :: this
    real(dl), intent(in) :: z
    real(dl) counts_background_z, winamp

    counts_background_z = this%count_obs_window_z(z, winamp)
    !This is the special case where you observe all of the sources

    end function counts_background_z

    subroutine GetScales(this, zpeak, sigma_z, zpeakstart, zpeakend)
    class(TSourceWindow) :: this
    real(dl), intent(out) :: zpeak, sigma_z, zpeakstart, zpeakend

    zpeak=0
    sigma_z=0
    zpeakstart=0
    zpeakend=0
    call MpiStop('Must define GetScales function')

    end subroutine GetScales

    real(dl) function GetBias(this,k,a)
    class(TSourceWindow) :: this
    real(dl), intent(in) :: k,a
    GetBias = this%Bias !Simplest scale-independent and time independent model
    end function

    function Window_f_a(this, a, winamp)
    !distribution function as function of scale factor a
    !Winamp is amplitude normalized to 1 so the code can tell when the window is very small
    class(TSourceWindow) :: this
    real(dl), intent(in) :: a
    real(dl) Window_f_a, winamp

    if (this%source_type == window_21cm) then
        call MpiStop('Must define Window_f_a function for 21cm')
    else
        Window_f_a = this%count_obs_window_z(1/a-1,winamp)/a**2
    end if

    end function Window_f_a

    subroutine TGaussianSourceWindow_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TGaussianSourceWindow), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TGaussianSourceWindow_SelfPointer

    function TGaussianSourceWindow_count_obs_window_z(this, z, winamp)
    !distribution function W(z) for the observed sources, used for lensing and number count spectrum
    !Winamp is amplitude normalized to 1 so the code can tell when the window is very small
    !note this is the total count distribution observed, not a fractional selection function on an underlying distribution
    class(TGaussianSourceWindow) :: this
    real(dl), intent(in) :: z
    real(dl) TGaussianSourceWindow_count_obs_window_z, dz,winamp
    real(dl), parameter :: root2pi = 2.506628274_dl

    dz = z-this%Redshift
    winamp =  exp(-(dz/this%sigma)**2/2)
    TGaussianSourceWindow_count_obs_window_z =winamp/this%sigma/root2pi

    end function TGaussianSourceWindow_count_obs_window_z

    function TGaussianSourceWindow_Window_f_a(this, a, winamp)
    !distribution function as function of scale factor a
    !Winamp is amplitude normalized to 1 so the code can tell when the window is very small
    class(TGaussianSourceWindow) :: this
    real(dl), intent(in) :: a
    real(dl) TGaussianSourceWindow_Window_f_a, winamp
    real(dl), parameter :: root2pi = 2.506628274_dl

    if (this%source_type == window_21cm) then
        !Take W_T(S) = W_f(S)/S to be Gaussain, for frequency integration of T_b
        winamp =  exp(-((a-(1/(this%redshift+1)))/this%sigma)**2/2)
        TGaussianSourceWindow_Window_f_a = a*winamp/this%sigma/root2pi
    else
        TGaussianSourceWindow_Window_f_a = this%count_obs_window_z(1/a-1,winamp)/a**2
    end if

    end function TGaussianSourceWindow_Window_f_a


    subroutine TGaussianSourceWindow_GetScales(this, zpeak, sigma_z,  zpeakstart, zpeakend)
    class(TGaussianSourceWindow) :: this
    real(dl), intent(out) :: zpeak, sigma_z, zpeakstart, zpeakend

    if (this%source_type == Window_21cm) then
        sigma_z = this%sigma* (1 + this%RedShift) **2
    else
        sigma_z = this%sigma
    end if
    zpeak = this%redshift
    zpeakstart = this%redshift + sigma_z*3
    zpeakend = max(0._dl,this%redshift - sigma_z*3)

    end subroutine TGaussianSourceWindow_GetScales


    subroutine TSplinedSourceWindow_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TSplinedSourceWindow), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TSplinedSourceWindow_SelfPointer

    real(dl) function TSplinedSourceWindow_GetBias(this,k,a)
    class(TSplinedSourceWindow) :: this
    real(dl), intent(in) :: k,a
    real(dl) z
    integer error

    if (allocated(this%bias_zk)) then
        z = 1/a-1
        if (z > this%Window%X(this%Window%n) .or. z < this%Window%X(1)) then
            TSplinedSourceWindow_GetBias = 0
        else
            error = 0
            TSplinedSourceWindow_GetBias = this%bias_zk%value(z, k, error)
            if (error /= 0) TSplinedSourceWindow_GetBias = 0
        end if
    elseif (allocated(this%bias_z))  then
        z = 1/a-1
        if (z > this%Window%X(this%Window%n) .or. z < this%Window%X(1)) then
            TSplinedSourceWindow_GetBias = 0
        else
            TSplinedSourceWindow_GetBias = this%bias_z%value(z)
        end if
    else
        TSplinedSourceWindow_GetBias = this%Bias !Simplest scale-independent and time independent model
    end if
    end function


    subroutine  TSplinedSourceWindow_SetTable(this, n, z, W, bias_z)
    class(TSplinedSourceWindow) :: this
    integer, intent(in) :: n
    real(dl), intent(in) :: z(n), W(n)
    real(dl), intent(in), optional :: bias_z(n)

    if (allocated(this%Window)) deallocate(this%Window)
    if (n>0) then
        allocate(this%Window)
        call this%Window%Init(z,W)
        this%maxwin = maxval(this%Window%F)
    end if
    if (present(bias_z)) then
        if (allocated(this%Bias_z)) deallocate(this%Bias_z)
        if (allocated(this%Bias_zk)) deallocate(this%Bias_zk)
        if (n>0) then
            allocate(this%Bias_z)
            call this%Bias_z%Init(z,bias_z)
        end if
    end if
    end subroutine TSplinedSourceWindow_SetTable

    subroutine  TSplinedSourceWindow_SetTable2DBias(this, n, nk, z, k, W, bias_zk)
    class(TSplinedSourceWindow) :: this
    integer, intent(in) :: n, nk
    real(dl), intent(in) :: z(n), W(n), k(nk)
    real(dl), intent(in) :: bias_zk(n,nk)

    if (allocated(this%Window)) deallocate(this%Window)
    if (n>0) then
        allocate(this%Window)
        call this%Window%Init(z,W)
        this%maxwin = maxval(this%Window%F)
    end if
    if (allocated(this%Bias_zk)) deallocate(this%Bias_zk)
    if (n>0 .and. nk>0) then
        allocate(this%Bias_zk)
        call this%Bias_zk%Init(z,k,bias_zk)
    end if

    end subroutine TSplinedSourceWindow_SetTable2DBias


    function TSplinedSourceWindow_count_obs_window_z(this, z, winamp)
    !distribution function W(z) for the observed sources, used for lensing and number count spectrum
    !Winamp is amplitude normalized to 1 so the code can tell when the window is very small
    !note this is the total count distribution observed, not a fractional selection function on an underlying distribution
    class(TSplinedSourceWindow) :: this
    real(dl), intent(in) :: z
    real(dl) TSplinedSourceWindow_count_obs_window_z, winamp

    if (z > this%Window%X(this%Window%n) .or. z < this%Window%X(1)) then
        TSplinedSourceWindow_count_obs_window_z =0
    else
        TSplinedSourceWindow_count_obs_window_z = this%Window%Value(z)
    end if
    winamp = TSplinedSourceWindow_count_obs_window_z/this%maxwin

    end function TSplinedSourceWindow_count_obs_window_z

    subroutine TSplinedSourceWindow_GetScales(this, zpeak, sigma_z, zpeakstart, zpeakend)
    class(TSplinedSourceWindow) :: this
    real(dl), intent(out) :: zpeak, sigma_z, zpeakstart, zpeakend
    integer i, j
    real(dl) z1, zstart, zend, targ

    associate(z => this%Window%X, W => this%Window%F, n=>this%Window%n)
        zstart = z(n)
        zend = z(1)
        zpeak = z(maxloc(W, dim=1))
        zpeakstart = zstart
        do i=n,1,-1
            if (W(i) > this%maxwin/15) then
                zpeakstart = z(i)
                exit
            end if
        end do
        zpeakend = zend
        do i=1,n
            if (W(i) > this%maxwin/15) then
                if (zpeakstart > z(i)) zpeakend = z(i)
                exit
            end if
        end do
        z1 = 0._dl
        !sigma_z sets the scale of structure in the window function
        !Used for determining when Limber should be valid and required time step size
        !Try minimum of some simple heuristics
        sigma_z = (zpeakstart - zpeakend)/3
        do i = 1, n
            if (W(i) > this%maxwin/2 .and. z1==0._dl) then
                z1 = z(i)
            else if (W(i) < this%maxwin/2 .and. z1/= 0._dl) then
                sigma_z = min(sigma_z, z(i)-z1)
                z1 = 0._dl
            end if
        end do
        do i = 1, n
            if (W(i) < this%maxwin*0.45) then
                targ = w(i) + this%maxwin/2
                do j=i+1, n
                    if (W(j) >= targ) then
                        sigma_z = min(sigma_z, (z(j)-z(i))/0.85)
                        exit
                    end if
                end do
                do j=i-1, 1,-1
                    if (W(j) >= targ) then
                        sigma_z = min(sigma_z, (z(i)-z(j))/0.85)
                        exit
                    end if
                end do
            end if
        end do
    end associate

    end subroutine TSplinedSourceWindow_GetScales

    end module SourceWindows

    module ExternalNonLinearRatio
    ! Non-linear model that applies a user-supplied ratio sqrt(P_NL/P_L)
    ! from an external source (e.g. CCL, axionHMcode).
    ! The ratio is stored as a 2D interpolation grid over (k/h, z).
    use results
    use transfer
    use Interpolation, only : TInterpGrid2D
    implicit none
    private

    type, extends(TNonLinearModel) :: TExternalNonLinearRatio
        Type(TInterpGrid2D) :: Ratio
        logical :: ratio_set = .false.
    contains
    procedure :: GetNonLinRatios => TExternalNonLinearRatio_GetNonLinRatios
    procedure :: GetNonLinRatios_All => TExternalNonLinearRatio_GetNonLinRatios_All
    procedure :: SetRatio => TExternalNonLinearRatio_SetRatio
    procedure :: ClearRatio => TExternalNonLinearRatio_ClearRatio
    procedure, nopass :: SelfPointer => TExternalNonLinearRatio_SelfPointer
    end type TExternalNonLinearRatio

    public TExternalNonLinearRatio
    contains

    subroutine TExternalNonLinearRatio_SelfPointer(cptr, P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type(TExternalNonLinearRatio), pointer :: PType
    class(TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TExternalNonLinearRatio_SelfPointer

    subroutine TExternalNonLinearRatio_SetRatio(this, nk, nz, k_h_arr, z_arr, ratio_arr)
    ! Set the non-linear ratio grid sqrt(P_NL/P_L)
    class(TExternalNonLinearRatio) :: this
    integer, intent(in) :: nk, nz
    real(dl), intent(in) :: k_h_arr(nk)
    real(dl), intent(in) :: z_arr(nz)
    real(dl), intent(in) :: ratio_arr(nk, nz)

    call this%Ratio%Init(k_h_arr, z_arr, ratio_arr)
    this%ratio_set = .true.

    end subroutine TExternalNonLinearRatio_SetRatio

    subroutine TExternalNonLinearRatio_ClearRatio(this)
    ! Clear the stored ratio, releasing interpolation data
    class(TExternalNonLinearRatio) :: this

    call this%Ratio%Clear()
    this%ratio_set = .false.

    end subroutine TExternalNonLinearRatio_ClearRatio

    subroutine TExternalNonLinearRatio_GetNonLinRatios(this, State, CAMB_Pk)
    ! Fill CAMB_Pk%nonlin_ratio from the stored interpolation grid.
    ! Clamps k and z to the grid range to prevent unreliable polynomial extrapolation.
    class(TExternalNonLinearRatio) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk
    integer :: ik, iz
    real(dl) :: kh, z, kh_clamped, z_clamped
    real(dl) :: k_min, k_max, z_min, z_max

    if (.not. this%ratio_set) &
        error stop 'ExternalNonLinearRatio: ratio not set. Call SetRatio first.'

    ! Get bounds of the ratio grid to clamp values
    k_min = this%Ratio%x(1)
    k_max = this%Ratio%x(this%Ratio%nx)
    z_min = this%Ratio%y(1)
    z_max = this%Ratio%y(this%Ratio%ny)

    CAMB_Pk%nonlin_ratio = 1.0_dl
    do iz = 1, CAMB_Pk%num_z
        z = CAMB_Pk%redshifts(iz)
        z_clamped = max(z_min, min(z_max, z))
        do ik = 1, CAMB_Pk%num_k
            kh = exp(CAMB_Pk%log_kh(ik))
            kh_clamped = max(k_min, min(k_max, kh))
            CAMB_Pk%nonlin_ratio(ik, iz) = this%Ratio%Value(kh_clamped, z_clamped)
        end do
    end do

    end subroutine TExternalNonLinearRatio_GetNonLinRatios

    subroutine TExternalNonLinearRatio_GetNonLinRatios_All(this, State, CAMB_Pk)
    class(TExternalNonLinearRatio) :: this
    class(TCAMBdata) :: State
    type(MatterPowerData), target :: CAMB_Pk

    error stop 'ExternalNonLinearRatio: GetNonLinRatios_All not supported (no velocity corrections)'

    end subroutine TExternalNonLinearRatio_GetNonLinRatios_All

    end module ExternalNonLinearRatio

    program tester
    use ListTests
    use InterpolationTests
    use IniTests
    use FileTests
    use StringTests
    use ArrayTests
    use RangesTests
    implicit none

    integer :: fails =0

    !If anything fails it is quite likely to be a compiler bug
    !Over the years many compiler bugs have appeared.
    fails = fails + RunArrayTests()
    fails = fails + RunListTests()
    fails = fails + RunInterpolationTests()
    fails = fails + RunStringTests()
    fails = fails + RunFileTests()
    fails = fails + RunRangesTests()
    fails = fails + RunIniTests()

    print *, 'Total fails: ', fails
    if (fails>0) error stop 'More than one test failed'

    end program

    !Lensing the C_l using the deflection angle from the computed lensing potential
    !power spectrum.
    !lensing_method=1: using an accurate curved-sky correlation function method
    !lensing_method=2: using the flat-sky lower order result of astro-ph/9505109
    !                  and astro-ph/9803150 as in CMBFAST
    !lensing_method=3: using inaccurate full sky harmonic method of astro-ph/0001303

    !The flat sky result is accurate to about 0.1% in TT, and 0.4% in EE and is
    !about a factor of two faster than lensing_method=1.
    !lensing_method=3 is only present for comparison and is not recommended in any regime

    !Set accurate_BB=T if you want BB accurately by integrating the full angular range
    !otherwise it saves a large amount of time by only integrating the small scales
    !accute_BB only does *not* include any non-linear corrections or ensure you have
    !chosen sufficiently high l_max and k_max, so does not neccessarily give an accurate
    !result

    !Uses the un-lensed Cls and the computed lensing potential power spectrum.
    !Usual values of k_max are fine for all but the lensed BB Cls
    !To get the lensed BB accurate around l=1000 you need to go to l_max >2000, and
    !higher for higher l. Since this probes small scales in the lensing power spectrum you
    !also need to go to higher k_max - for concordance models something like
    !k_eta_max_scalar=10000. At l>1000 you can expect to need higher k_max, and for
    !non-linear evolution to cause a significant error.

    !Correlation function routines by AL+AC Nov 2004 with flat-sky borrowings from CMBFAST
    !Curved sky results use the method of astro-ph/xxx.

    !Full sky harmonic lensing routines by Gayoung Chon and AC.
    !Ref: astro-ph/0001303 by W. Hu.
    !For better derivations see also astro-ph/0301064 and astro-ph/0301031
    !Adapted for CAMB and optimized by AL.
    !Uses f90 version of "J1-RECURSION OF 3J-COEFFICIENTS" by K. Schulten and R.G. Gordon
    !obtainable from the CPC program library (www.cpc.cs.qub.ac.uk).

    !March 2006: fixed problem with l_max when generating with tensors (thanks Chad Fendt)

    module lensing
    use Precision
    use results
    use constants, only : const_pi, const_twopi, const_fourpi
    use splines
    implicit none
    integer, parameter :: lensing_method_curv_corr=1,lensing_method_flat_corr=2, &
        lensing_method_harmonic=3

    integer :: lensing_method = lensing_method_curv_corr

    real(dl) :: lensing_sanity_check_amplitude = 1e-7_dl

    real(dl) :: ALens_Fiducial = 0._dl
    !Change from zero to set lensing smoothing by scaling amplitude of fiducial template

    private

    logical  :: lensing_includes_tensors = .false.

    !flat method stores
    real(dl), parameter :: dbessel = 0.05_dl
    integer, parameter :: maxbessel = 9
    real(dl), dimension(:,:), allocatable :: Bess, ddBess

    !Harmonic method stores
    integer :: lmax_donelnfa = 0
    real(dl), dimension(:), allocatable  :: lnfa

    public lens_Cls, lensing_includes_tensors, lensing_method, lensing_method_flat_corr,&
        lensing_method_curv_corr,lensing_method_harmonic, BessI, ALens_Fiducial, &
        lensing_sanity_check_amplitude, lensClsWithSpectrum, &
        GetFlatSkyCGrads, GetFlatSkyCgradsWithSpectrum
    contains


    subroutine lens_Cls(State)
    class(CAMBdata) :: State

    if (lensing_method == lensing_method_curv_corr) then
        call CorrFuncFullSky(State)
    elseif (lensing_method == lensing_method_flat_corr) then
        call CorrFuncFlatSky(State)
    elseif (lensing_method == lensing_method_harmonic) then
        call BadHarmonic(State)
    else
        error stop 'Unknown lensing method'
    end if
    end subroutine lens_Cls

    subroutine CorrFuncFullSky(State)
    class(CAMBdata) :: State
    integer :: lmax_extrap,l
    real(dl) CPP(0:State%CP%max_l)

    lmax_extrap = State%CP%Max_l - lensed_convolution_margin + 750
    lmax_extrap = min(lmax_extrap_highl,lmax_extrap)
    do l= State%CP%min_l,State%CP%max_l
        ! Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
        CPP(l) = State%CLdata%Cl_scalar(l,C_Phi)*(l+1)**2/real(l,dl)**2/const_twopi
    end do
    call CorrFuncFullSkyImpl(State, State%ClData, State%ClData, CPP, &
        State%CP%min_l,max(lmax_extrap,State%CP%max_l))

    end subroutine CorrFuncFullSky

    subroutine lensClsWithSpectrum(State, CPP, lensedCls, lmax_lensed)
    !Get lensed CL using CPP as the lensing specturm
    !CPP is [L(L+1)]^2C_phi_phi/2/pi
    type(CAMBdata) :: State
    real(dl), intent(in) :: CPP(0:State%CP%max_l)
    real(dl) :: lensedCls(4, 0:State%CP%Max_l)
    integer :: lmax_lensed
    Type(TCLData) :: CLout
    integer :: lmax_extrap, l

    lmax_extrap = State%CP%Max_l - lensed_convolution_margin + 750
    lmax_extrap = min(lmax_extrap_highl,lmax_extrap)
    call CorrFuncFullSkyImpl(State, State%ClData, CLout, CPP, &
        State%CP%min_l,max(lmax_extrap,State%CP%max_l))
    lmax_lensed = CLout%lmax_lensed

    do l=State%CP%min_l, lmax_lensed
        lensedCls(:,l) = CLout%Cl_lensed(l,:)
    end do

    end subroutine lensClsWithSpectrum

    subroutine AmplitudeError

    call GlobalError('You need to normalize realistically to use lensing. ' &
        //'See http://cosmocoffee.info/viewtopic.php?t=94')

    end subroutine AmplitudeError

    subroutine CorrFuncFullSkyImpl(State,CL,CLout,CPP,lmin,lmax)
    !Accurate curved sky correlation function method
    !Uses non-perturbative isotropic term with 2nd order expansion in C_{gl,2}
    !Neglects C_{gl}(theta) terms (very good approx)
    class(CAMBdata), target :: State
    Type(TCLData) :: CL, CLout
    real(dl) :: CPP(0:State%CP%max_l) ! [L(L+1)]^2 C_L_phi_phi/2pi
    integer, intent(in) :: lmin,lmax
    integer l, i
    integer :: npoints
    real(dl) corr(4), Cg2, sigmasq, theta
    real(dl) dtheta
    real(dl) llp1,fac, fac1,fac2,fac3, rootllp1, rootfac1, rootfac2, rootfac3
    real(dl) P(lmax),dP(lmax)
    real(dl) sinth,halfsinth, x, T2,T4
    real(dl) roots(-1:lmax+4), lfacs(lmax), lfacs2(lmax), lrootfacs(lmax)
    integer max_lensed_ix
    real(dl) d_11(lmax),d_m11(lmax)
    real(dl) d_22(lmax),d_2m2(lmax),d_20(lmax)
    real(dl) Cphil3(lmin:lmax), CTT(lmin:lmax), CTE(lmin:lmax),CEE(lmin:lmax)
    real(dl) ls(lmax)
    real(dl) xl(lmax)
    real(dl), allocatable :: ddcontribs(:,:),corrcontribs(:,:)
    real(dl), allocatable :: lens_contrib(:,:,:)
    integer thread_ix
    real(dl) pmm, pmmp1
    real(dl) d4m4,d11,dm11,d2m2,d22,d20,d23,d2m3,d33,d3m3,d04,d1m2,d12,d13,d1m3,d2m4
    real(dl) sinfac, Cg2sq
    real(dl) X000,X022,X220,X121,X132,X242
    real(dl) dX000,dX022
    integer  interp_fac
    integer j,jmax
    integer llo, lhi
    real(dl) a0,b0,ho, sc
    integer apodize_point_width
    logical :: short_integral_range
    real(dl) range_fac
    logical, parameter :: approx = .false.
    real(dl) theta_cut(lmax), LensAccuracyBoost
    Type(TTimer) :: Timer

    !$ integer  OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS
    !$ external OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS

    if (lensing_includes_tensors) call MpiStop('Haven''t implemented tensor lensing')
    associate(lSamp => State%CLData%CTransScal%ls, CP=>State%CP)

        LensAccuracyBoost = CP%Accuracy%AccuracyBoost*CP%Accuracy%LensingBoost
        max_lensed_ix = lSamp%nl-1
        do while(lSamp%l(max_lensed_ix) > CP%Max_l - lensed_convolution_margin)
            max_lensed_ix = max_lensed_ix -1
        end do
        !150 is the default margin added in python by set_for_lmax
        CLout%lmax_lensed = max(lSamp%l(max_lensed_ix), CP%Max_l - 150)

        if (allocated(CLout%Cl_lensed)) deallocate(CLout%Cl_lensed)
        allocate(CLout%Cl_lensed(lmin:CLout%lmax_lensed,1:4), source = 0._dl)

        npoints = CP%Max_l  * 2 *LensAccuracyBoost
        short_integral_range = .not. CP%Accuracy%AccurateBB
        dtheta = const_pi / npoints
        if (CP%Max_l > 3500) dtheta=dtheta/1.3
        apodize_point_width = nint(0.003 / dtheta)
        npoints = int(const_pi/dtheta)
        if (short_integral_range) then
            range_fac= max(1._dl,32/LensAccuracyBoost) !fraction of range to integrate
            npoints = int(npoints /range_fac)
            !OK for TT, EE, TE but inaccurate for low l BB
            !this induces high frequency ringing on very small scales
            !which is then mitigated by the apodization below
        else
            range_fac=1
        end if

        if (DebugMsgs) call Timer%Start()

        interp_fac = max(1,min(nint(10/LensAccuracyBoost),int(range_fac*2)-1))

        jmax = 0
        do l=lmin,lmax
            if (l<=15 .or. mod(l-15,interp_fac)==interp_fac/2) then
                jmax =jmax+1
                ls(jmax)=l
                xl(jmax)=l
            end if
            lfacs(l) = real(l*(l+1),dl)
            lfacs2(l) = real((l+2)*(l-1),dl)
            lrootfacs(l) = sqrt(lfacs(l)*lfacs2(l))
        end do
        do l=2,lmax
            theta_cut(l) = 0.244949_dl/sqrt(3._dl*lfacs(l) - 8._dl)
        end do

        roots(-1)=0 !just so dipole doesn't screw up
        do l=0,lmax+4
            roots(l) = sqrt(real(l,dl))
        end do

        thread_ix = 1
        !$ thread_ix = OMP_GET_MAX_THREADS()
        allocate(lens_contrib(4,CLout%lmax_lensed,thread_ix))
        allocate(ddcontribs(lmax,4),corrcontribs(lmax,4))

        do l=lmin,CP%Max_l
            ! (2*l+1)l(l+1)/4pi C_phi_phi: Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
            Cphil3(l) = CPP(l)*(l+0.5_dl)/real((l+1)*l, dl)
            fac = (2*l+1)/const_fourpi * const_twopi/(l*(l+1))
            CTT(l) =  CL%Cl_scalar(l,C_Temp)*fac
            CEE(l) =  CL%Cl_scalar(l,C_E)*fac
            CTE(l) =  CL%Cl_scalar(l,C_Cross)*fac
        end do
        if (Cphil3(10) > lensing_sanity_check_amplitude) then
            call AmplitudeError()
            return
        end if
        if (lmax > CP%Max_l) then
            l=CP%Max_l
            sc = (2*l+1)/const_fourpi * const_twopi/(l*(l+1))
            fac2=CTT(CP%Max_l)/(sc*highL_CL_template(CP%Max_l, C_Temp))
            fac=Cphil3(CP%Max_l)/(sc*highL_CL_template(CP%Max_l, C_Phi))
            do l=CP%Max_l+1, lmax
                !Fill in tail from template
                sc = (2*l+1)/const_fourpi * const_twopi/(l*(l+1))
                Cphil3(l) = highL_CL_template(l, C_Phi)*fac*sc

                CTT(l) =  highL_CL_template(l, C_Temp)*fac2*sc
                CEE(l) =  highL_CL_template(l, C_E)*fac2 *sc
                CTE(l) =  highL_CL_template(l, C_Cross)*fac2*sc
                if (Cphil3(CP%Max_l+1) > 1e-7) then
                    call MpiStop('You need to normalize the high-L template so it is dimensionless')
                end if
            end do
        end if
        if (ALens_Fiducial > 0) then
            do l=2, lmax
                sc = (2*l+1)/const_fourpi * const_twopi/(l*(l+1))
                Cphil3(l) =  sc * highL_CL_template(l, C_Phi) * ALens_Fiducial
            end do
        end if

        lens_contrib=0

        !$OMP PARALLEL DO DEFAULT(PRIVATE),  &
        !$OMP SHARED(lfacs,lfacs2,lrootfacs,Cphil3,CTT,CTE,CEE,lens_contrib,theta_cut), &
        !$OMP SHARED(lmin, lmax,dtheta,CL,CLout,roots, npoints,interp_fac), &
        !$OMP SHARED(jmax,ls,xl,short_integral_range,apodize_point_width)
        do i=1,npoints-1

            theta = i * dtheta
            x = cos(theta)
            sinth = sin(theta)
            halfsinth = sinth/2

            pmm=1
            pmmp1=x

            Cg2=0
            sigmasq=0
            if (lmin==1) then
                d_11(1) = cos(theta/2)**2
                d_m11(1) = sin(theta/2)**2
                sigmasq = sigmasq  +  (1-d_11(1))*Cphil3(lmin)
                Cg2 = Cg2  + d_m11(1)*Cphil3(lmin)
                P(1) = x
                d_22(1)=0
                d_2m2(1)=0
                d_20(1)=0
            end if
            do l=2,lmax

                P(l)= ((2*l-1)* x *pmmp1 - (l-1)*Pmm)/ l
                dP(l) = l*(pmmp1-x*P(l))/sinth**2
                Pmm=pmmp1
                pmmp1=P(l)
                llp1 = lfacs(l)

                fac1 = (1-x)
                fac2 = (1+x)
                fac = fac1/fac2

                d_11(l) =  fac1*dP(l)/llp1 + P(l)
                d_m11(l) = fac2*dP(l)/llp1 - P(l)

                sigmasq = sigmasq  +  (1-d_11(l))*Cphil3(l)
                Cg2 = Cg2  + d_m11(l)*Cphil3(l)

                d_22(l) = ( ((4*x-8)/fac2 + llp1)*P(l) &
                    + 4*fac*( fac2 + (x - 2)/llp1)*dP(l) )/ lfacs2(l)

                !For small theta use Taylor expansion for better stability (thanks Pavel Motloch)
                if (theta > theta_cut(l)) then
                    d_2m2(l) = ( (llp1- (4*x+8)/fac1) *P(l) &
                        +4/fac*( -fac1 + (x+2)/llp1) *dP(l) )/lfacs2(l)
                else
                    d_2m2(l) = lfacs(l)*lfacs2(l)*theta**4*(1._dl/384._dl &
                        - (3._dl*lfacs(l) - 8._dl)/23040._dl*theta**2)
                endif

                d_20(l) = (2*x*dP(l) - llp1*P(l) ) / lrootfacs(l)

            end do

            do j=1,jmax
                l =ls(j)

                fac1 = (1-x)
                fac2 = (1+x)
                llp1 = lfacs(l)

                rootllp1 = roots(l)*roots(l+1)
                rootfac1 = roots(l+2)*roots(l-1)
                rootfac2 = roots(l+3)*roots(l-2)

                llp1=lfacs(l)
                dm11=d_m11(l)
                d11=d_11(l)
                if (l<2) then
                    d2m2=0
                    d22=0
                    d20=0
                    d1m2 = 0
                    d12 =  0
                else
                    d2m2=d_2m2(l)
                    d22=d_22(l)
                    d20=d_20(l)
                    d1m2 = sinth/rootfac1*(dP(l) -2/fac1*dm11)
                    d12 =  sinth/rootfac1*(dP(l) -2/fac2*d11)
                end if
                if (l<3) then
                    d1m3=0
                    d2m3=0
                    d3m3=0
                    d13 =0
                    d23 =0
                    d33 =0
                else
                    sinfac=4/sinth
                    d1m3 = (-(x+0.5_dl)*d1m2*sinfac - lfacs2(l)*dm11/rootfac1 )/rootfac2
                    d2m3 = (-fac2*d2m2*sinfac - rootfac1*d1m2)/rootfac2
                    d3m3 = (-(x+1.5_dl)*d2m3*sinfac - rootfac1*d1m3)/rootfac2
                    d13  =  ((x-0.5_dl)*d12*sinfac - lfacs2(l)*d11/rootfac1 ) /rootfac2
                    d23  = (-fac1*d22*sinfac + rootfac1*d12 ) / rootfac2
                    d33  = (-(x-1.5_dl)*d23*sinfac - rootfac1*d13)/rootfac2
                end if
                if (l<4) then
                    d04=0
                    d2m4=0
                    d4m4=0
                    rootfac3=0
                else
                    rootfac3=roots(l-3)*roots(l+4)
                    d04=( (-llp1 + (18*x**2 + 6)/sinth**2 )*d20  -&
                        6*x*lfacs2(l)*dP(l)/lrootfacs(l) ) / (rootfac2*rootfac3)
                    d2m4= (-(6*x+4)*d2m3/sinth - rootfac2*d2m2 ) / rootfac3
                    d4m4 = (-7/5._dl*(llp1-6)*d2m2 + &
                        12/5._dl*( -llp1+(9*x+26)/fac1)*d3m3 ) / (llp1-12)
                end if

                !Non perturbative isotropic integrals
                !these are approx, but extremely good approximations
                X000 = exp(-llp1*sigmasq/4)
                if (approx) then

                    X022 = X000
                    X220 = rootllp1**2/4*X000
                    X121 = -0.5_dl*rootllp1*X000
                    X132 = -0.5_dl*rootllp1*X000
                    X242 = 0.25_dl*rootllp1**2*X022

                    dX000 = -llp1/4*X000
                    dX022 = -llp1/4*X022
                else
                    X022 = X000*(1+sigmasq)   !exp(-(llp1-4)*sigmasq/4)
                    X220 = lrootfacs(l)/4*X000
                    X121 = -0.5_dl*rootfac1*X000
                    X132 = -0.5_dl*rootfac2*X000
                    X242 = 0.25_dl*rootfac2*rootfac3*X022

                    dX000 = -llp1/4*X000
                    dX022 = (1-llp1/4)*X022
                end if
                !second order
                !TT
                fac1 = dX000**2
                fac3 = X220**2
                Cg2sq = Cg2**2

                !Here we drop terms in Cgt which are down by powers of l
                !Approx good to 1e-4 level
                fac = ( (X000**2-1) + Cg2sq*fac1)*P(l)+ Cg2sq*fac3*d2m2 &
                    + 8/llp1* fac1*Cg2*dm11

                corrcontribs(j,1)=  CTT(l) * fac

                fac2=(Cg2*dX022)**2+(X022**2-1)
                !Q+U
                fac = 2*Cg2*X121*X132*d13 + fac2*d22 +Cg2sq*X242*X220*d04

                corrcontribs(j,2)= CEE(l) * fac

                !Q-U
                fac = ( fac3*P(l) + X242**2*d4m4)*Cg2sq/2 &
                    + Cg2*(X121**2*dm11+ X132**2*d3m3) + fac2*d2m2

                corrcontribs(j,3)= CEE(l) * fac

                !TE
                fac = (X000*X022-1)*d20+ &
                    2*dX000*Cg2*(X121*d11 + X132*d1m3)/rootllp1 &
                    + Cg2sq*(X220/2*d2m4*X242 +( fac3/2 + dX022*dX000)*d20)

                corrcontribs(j,4)= CTE(l) * fac

            end do

            do j=1,4
                corr(j) = sum(corrcontribs(1:14,j))+interp_fac*sum(corrcontribs(15:jmax,j))
            end do

            !if (short_integral_range .and. i>npoints-20) &
            !        corr=corr*exp(-(i-npoints+20)**2/150.0) !taper the end to help prevent ringing

            if (short_integral_range .and. i>npoints-apodize_point_width*3) &
                corr=corr*exp(-(i-npoints+apodize_point_width*3)**2/real(2*apodize_point_width**2))
            !taper the end to help prevent ringing


            !Interpolate contributions
            !Increasing interp_fac and using this seems to be slower than above
            if (.false.) then
                if (abs(sum(corrcontribs(1:jmax,1)))>1e-11) print *,i,sum(corrcontribs(1:jmax,1))
                do j=1,4
                    call spline_def(xl,corrcontribs(:,j),jmax,ddcontribs(:,j))
                end do
                corr=0
                llo=1
                do l=lmin,lmax
                    if ((l > ls(llo+1)).and.(llo < jmax)) then
                        llo=llo+1
                    end if
                    lhi=llo+1
                    ho=ls(lhi)-ls(llo)
                    a0=(ls(lhi)-l)/ho
                    b0=(l-ls(llo))/ho
                    fac1 = ho**2/6
                    fac2 = (b0**3-b0)*fac1
                    fac1 = (a0**3-a0)*fac1

                    corr(1) = Corr(1)+ a0*corrcontribs(llo,1)+ b0*corrcontribs(lhi,1)+ &
                        fac1* ddcontribs(llo,1) +fac2*ddcontribs(lhi,1)
                    corr(2) = Corr(2)+ a0*corrcontribs(llo,2)+ b0*corrcontribs(lhi,2)+ &
                        fac1* ddcontribs(llo,2) +fac2*ddcontribs(lhi,2)
                    corr(3) = Corr(3)+ a0*corrcontribs(llo,3)+ b0*corrcontribs(lhi,3)+ &
                        fac1* ddcontribs(llo,3) +fac2*ddcontribs(lhi,3)
                    corr(4) = Corr(4)+ a0*corrcontribs(llo,4)+ b0*corrcontribs(lhi,4)+ &
                        fac1* ddcontribs(llo,4) +fac2*ddcontribs(lhi,4)

                end do
            end if

            !$  thread_ix = OMP_GET_THREAD_NUM()+1

            do l=lmin, CLout%lmax_lensed
                !theta factors were put in earlier (already in corr)

                lens_contrib(C_Temp, l, thread_ix)= lens_contrib(C_Temp,l, thread_ix) + &
                    corr(1)*P(l)*sinth

                T2 = corr(2)* d_22(l)
                T4 = corr(3)* d_2m2(l)


                lens_contrib(CT_E, l, thread_ix)= lens_contrib(CT_E,l, thread_ix) + &
                    (T2+T4)*halfsinth
                lens_contrib(CT_B, l, thread_ix)= lens_contrib(CT_B,l, thread_ix) + &
                    (T2-T4)*halfsinth

                lens_contrib(CT_Cross, l, thread_ix)= lens_contrib(CT_Cross,l, thread_ix) + &
                    corr(4)*d_20(l)*sinth

            end do

        end do
        !$OMP END PARALLEL DO

        do l=lmin, CLout%lmax_lensed
            !sign from d(cos theta) = -sin theta dtheta
            fac = l*(l+1)/OutputDenominator*dtheta*const_twopi
            CLout%Cl_lensed(l,CT_Temp) = sum(lens_contrib(CT_Temp,l,:))*fac &
                + CL%Cl_scalar(l,C_Temp)
            CLout%Cl_lensed(l,CT_E) = sum(lens_contrib(CT_E,l,:))*fac &
                + CL%Cl_scalar(l,C_E)
            CLout%Cl_lensed(l,CT_B) = sum(lens_contrib(CT_B,l,:))*fac
            CLout%Cl_lensed(l,CT_Cross) = sum(lens_contrib(CT_Cross,l,:))*fac &
                + CL%Cl_scalar(l,C_Cross)

        end do

        if (DebugMsgs) call Timer%WriteTime('Time for corr lensing')
    end associate

    end subroutine CorrFuncFullSkyImpl

    subroutine CorrFuncFlatSky(State)
    !Do flat sky approx partially non-perturbative lensing, lensing_method=2
    class(CAMBdata) :: State
    integer l, i
    integer :: npoints
    real(dl) Cgl2,  sigmasq, theta
    real(dl) dtheta
    real(dl) dbessfac, fac, fac1,fac2,  C2term, expsig, corr(4)
    real(dl) Bessel(State%CP%Min_l:State%CP%Max_l,0:maxbessel)
    real(dl) Cphil3(State%CP%Min_l:State%CP%Max_l), CTT(State%CP%Min_l:State%CP%Max_l), &
        CTE(State%CP%Min_l:State%CP%Max_l),CEE(State%CP%Min_l:State%CP%Max_l)
    integer max_lensed_ix
    integer b_lo, ix
    real(dl) T2,T4,a0, b0
    real(dl) lfacs(State%CP%Max_l), LensAccuracyBoost
    real(dl), allocatable, dimension(:,:,:) :: lens_contrib(:,:,:)
    integer, parameter :: bess_need(4) = (/ 0,2,4,6 /)
    integer thread_ix
    Type(TTimer) :: Timer

    !$ integer OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS
    !$ external OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS

    if (lensing_includes_tensors) stop 'Haven''t implemented tensor lensing'

    associate(lSamp => State%CLData%CTransScal%ls, CP=>State%CP, CL=> State%ClData, lmin => State%CP%Min_l)

        LensAccuracyBoost = CP%Accuracy%AccuracyBoost*CP%Accuracy%LensingBoost

        max_lensed_ix = lSamp%nl-1
        do while(lSamp%l(max_lensed_ix) > CP%Max_l - 250)
            !Wider margin here as not using template
            max_lensed_ix = max_lensed_ix -1
        end do
        CL%lmax_lensed = lSamp%l(max_lensed_ix)
        if (allocated(CL%Cl_lensed)) deallocate(CL%Cl_lensed)
        allocate(CL%Cl_lensed(lmin:CL%lmax_lensed,1:4), source=0._dl)

        npoints = CP%Max_l  * 2
        if (CP%Accuracy%AccurateBB) npoints = npoints * 2

        dtheta = const_pi / npoints
        if (.not. CP%Accuracy%AccurateBB) then
            npoints = int(npoints /32 *min(32._dl,LensAccuracyBoost))
            !OK for TT, EE, TE but inaccurate for low l BB
            !this induces high frequency ringing on very small scales
        end if

        call GetBessels(npoints*dtheta*CP%Max_l)

        if (DebugMsgs) call Timer%Start()

        dbessfac = dbessel**2/6

        thread_ix = 1
        !$  thread_ix = OMP_GET_MAX_THREADS()
        allocate(lens_contrib(4,CL%lmax_lensed,thread_ix))

        do l=lmin,CP%Max_l
            ! l^3 C_phi_phi/2/pi: Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
            Cphil3(l) = CL%Cl_scalar(l,C_Phi)/l /const_twopi
            fac = l/const_twopi*const_twopi/(l*(l+1))
            CTT(l) =  CL%Cl_scalar(l,C_Temp)*fac
            CEE(l) =  CL%Cl_scalar(l,C_E)*fac
            CTE(l) =  CL%Cl_scalar(l,C_Cross)*fac
            lfacs(l) = l**2*0.5_dl
        end do

        if (Cphil3(10) > 1e-7) then
            call AmplitudeError()
            return
        end if

        lens_contrib=0

        !$OMP PARALLEL DO DEFAULT(SHARED), &
        !$OMP PRIVATE(theta, sigmasq,cgl2,b_lo,a0,b0,fac,fac1,fac2), &
        !$OMP PRIVATE(Bessel,ix,corr,expsig,C2term,T2,T4,i,l, thread_ix)
        do i=1,npoints-1

            theta = i * dtheta
            sigmasq =0
            Cgl2=0
            fac = theta /dbessel

            do l=lmin,CP%Max_l

                !Interpolate the Bessel functions, and compute sigma^2 and C_{gl,2}
                b0 = l*fac
                b_lo = int(b0) +1
                a0=  b_lo - b0
                b0=  1._dl - a0
                fac1 = a0*b0*dbessfac
                fac2 = fac1*(a0-2)
                fac1 = fac1*(b0-2)

                do ix=1,size(bess_need)
                    Bessel(l,bess_need(ix)) = a0*Bess(b_lo,bess_need(ix))+ b0*Bess(b_lo+1,bess_need(ix)) &
                        +fac1*ddBess(b_lo,bess_need(ix)) + fac2*ddBess(b_lo+1,bess_need(ix))
                end do
                sigmasq = sigmasq + (1-Bessel(l,0))*Cphil3(l)
                Cgl2 =  Cgl2 + Bessel(l,2)*Cphil3(l)

            end do

            !Get difference between lensed and unlensed correlation function
            corr = 0
            do l=lmin,CP%Max_l
                !For 2nd order perturbative result use
                !         expsig = 1 -sigmasq*l**2/2._dl
                !         C2term = l**2*Cgl2/2._dl
                fac = sigmasq*lfacs(l)
                expsig = exp(-fac)
                C2term = Cgl2*lfacs(l)
                !Put theta factor later  in here
                fac1 = expsig*theta
                fac2 = C2term*fac1
                fac1 = fac1 - theta  !we want expsig-1 to get lensing difference

                fac = fac1*Bessel(l,0) + fac2*Bessel(l,2)

                !TT
                corr(1) = corr(1) + CTT(l) * fac

                !Q + U
                corr(2) = corr(2) + CEE(l) * fac
                fac2 = fac2*0.5_dl
                !Q-U
                corr(3) = corr(3) + CEE(l) * &
                    (fac1*Bessel(l,4) + fac2*(Bessel(l,2)+Bessel(l,6)))
                !Cross
                corr(4) = corr(4) + CTE(l) * &
                    (fac1*Bessel(l,2) + fac2*(Bessel(l,0)+Bessel(l,4)))


            end do

            !$ thread_ix = OMP_GET_THREAD_NUM()+1

            do l=lmin, CL%lmax_lensed
                !theta factors were put in earlier (already in corr)
                lens_contrib(C_Temp, l, thread_ix)= lens_contrib(C_Temp,l, thread_ix) + &
                    corr(1)*Bessel(l,0)
                T2 = corr(2)*Bessel(l,0)
                T4 = corr(3)*Bessel(l,4)
                lens_contrib(CT_E,l,thread_ix)  = lens_contrib(CT_E,l, thread_ix) + T2+T4
                lens_contrib(CT_B,l,thread_ix)  = lens_contrib(CT_B,l, thread_ix) + T2-T4
                lens_contrib(CT_Cross,l, thread_ix) = lens_contrib(CT_Cross,l, thread_ix) + &
                    corr(4)*Bessel(l,2)
            end do

        end do
        !$OMP END PARALLEL DO

        do l=lmin, CL%lmax_lensed
            fac = l*(l+1)* const_twopi/OutputDenominator*dtheta
            CL%Cl_lensed(l,CT_Temp) = sum(lens_contrib(CT_Temp,l,:))*fac &
                + CL%Cl_scalar(l,CT_Temp)
            CL%Cl_lensed(l,CT_Cross) = sum(lens_contrib(CT_Cross,l,:))*fac &
                +CL%Cl_scalar(l,C_Cross)
            fac = fac /2 !(factor of 1/2 should have been in T2+/-T4 above
            CL%Cl_lensed(l,CT_E) = sum(lens_contrib(CT_E,l,:))*fac &
                + CL%Cl_scalar(l,CT_E)
            CL%Cl_lensed(l,CT_B) = sum(lens_contrib(CT_B,l,:))*fac
        end do

        deallocate(lens_contrib)

        if (DebugMsgs) call Timer%WriteTime('Time for corr lensing')
    end associate
    end subroutine CorrFuncFlatSky


    subroutine GetFlatSkyCgrads(State, lmax, CGrads)
    type(CAMBdata) :: State
    integer, intent(in) :: lmax
    integer, parameter :: ncorr = 8
    real(dl) :: CGrads(ncorr,0:lmax)
    real(dl) CPP(0:State%CP%max_l)
    integer l

    do l= State%CP%min_l,State%CP%max_l
        ! Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
        CPP(l) = State%CLdata%Cl_scalar(l,C_Phi)*(l+1)**2/real(l,dl)**2/const_twopi
    end do
    call GetFlatSkyCgradsWithSpectrum(State, CPP, lmax, CGrads)

    end subroutine GetFlatSkyCgrads


    subroutine GetFlatSkyCgradsWithSpectrum(State, CPP, lmax, CGrads)
    !Do flat skyapprox calculation of gradient spectra C^(T\grad T) etc.
    !See Appendix C of https://arxiv.org/abs/1101.2234
    type(CAMBdata) :: State
    real(dl), intent(in) :: CPP(0:State%CP%max_l)
    integer, intent(in) :: lmax
    integer, parameter :: ncorr = 8
    real(dl) :: CGrads(ncorr,0:lmax)
    integer l, i
    integer :: npoints
    real(dl) Cgl2,  sigmasq, theta
    real(dl) dtheta
    real(dl) dbessfac, fac, fac1,fac2,  C2term, expsig, corr(ncorr)
    real(dl) Bessel(State%CP%Min_l:State%CP%Max_l,0:maxbessel)
    real(dl) Cphil3(State%CP%Min_l:State%CP%Max_l), CTT(State%CP%Min_l:State%CP%Max_l), &
        CTE(State%CP%Min_l:State%CP%Max_l),CEE(State%CP%Min_l:State%CP%Max_l)
    integer b_lo, ix
    real(dl) T2,T4,a0, b0
    real(dl) lfacs(State%CP%Max_l), LensAccuracyBoost
    real(dl), allocatable, dimension(:,:,:) :: lens_contrib(:,:,:)
    integer, parameter :: bess_need(8) = (/ 0,1,2,3,4, 5,7,9 /)
    integer thread_ix
    Type(TTimer) :: Timer

    !$ integer OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS
    !$ external OMP_GET_THREAD_NUM, OMP_GET_MAX_THREADS

    if (lensing_includes_tensors) stop 'Haven''t implemented tensor lensing'

    associate(lSamp => State%CLData%CTransScal%ls, CP=>State%CP, CL=> State%ClData, lmin => State%CP%Min_l)

        LensAccuracyBoost = CP%Accuracy%AccuracyBoost*CP%Accuracy%LensingBoost

        npoints = CP%Max_l  * 2 *2

        dtheta = const_pi / npoints

        call GetBessels(npoints*dtheta*CP%Max_l)

        if (DebugMsgs) call Timer%Start()

        dbessfac = dbessel**2/6

        thread_ix = 1
        !$  thread_ix = OMP_GET_MAX_THREADS()
        allocate(lens_contrib(ncorr,CL%lmax_lensed,thread_ix), source=0._dl)

        do l=lmin,CP%Max_l
            ! l^3 C_phi_phi/2/pi: Cl_scalar(l,1,C_Phi) is l^4 C_phi_phi
            Cphil3(l) = CPP(l)*l/real((l+1)**2, dl)
            fac = l/const_twopi*const_twopi/(l*(l+1))
            CTT(l) =  CL%Cl_scalar(l,C_Temp)*fac
            CEE(l) =  CL%Cl_scalar(l,C_E)*fac
            CTE(l) =  CL%Cl_scalar(l,C_Cross)*fac
            lfacs(l) = l**2*0.5_dl
        end do

        if (Cphil3(10) > 1e-7) then
            call AmplitudeError()
            return
        end if

        !$OMP PARALLEL DO DEFAULT(SHARED), &
        !$OMP PRIVATE(theta, sigmasq,cgl2,b_lo,a0,b0,fac,fac1,fac2), &
        !$OMP PRIVATE(Bessel,ix,corr,expsig,C2term,T2,T4,i,l, thread_ix)
        do i=1,npoints-1

            theta = i * dtheta
            sigmasq =0
            Cgl2=0
            fac = theta /dbessel

            do l=lmin,CP%Max_l

                !Interpolate the Bessel functions, and compute sigma^2 and C_{gl,2}
                b0 = l*fac
                b_lo = int(b0) +1
                a0=  b_lo - b0
                b0=  1._dl - a0
                fac1 = a0*b0*dbessfac
                fac2 = fac1*(a0-2)
                fac1 = fac1*(b0-2)

                do ix=1,size(bess_need)
                    Bessel(l,bess_need(ix)) = a0*Bess(b_lo,bess_need(ix))+ b0*Bess(b_lo+1,bess_need(ix)) &
                        +fac1*ddBess(b_lo,bess_need(ix)) + fac2*ddBess(b_lo+1,bess_need(ix))
                end do
                sigmasq = sigmasq + (1-Bessel(l,0))*Cphil3(l)
                Cgl2 =  Cgl2 + Bessel(l,2)*Cphil3(l)

            end do

            !Get difference between lensed and unlensed correlation function
            corr = 0
            do l=lmin,CP%Max_l
                !For 2nd order perturbative result use
                !         expsig = 1 -sigmasq*l**2/2._dl
                !         C2term = l**2*Cgl2/2._dl
                fac = sigmasq*lfacs(l)
                expsig = exp(-fac)
                C2term = Cgl2*lfacs(l)
                !Put theta factor later  in here
                fac1 = expsig*theta
                fac2 = C2term*fac1
                fac1 = fac1 - theta  !we want expsig-1 to get lensing difference

                fac = -(l*theta) * (fac1*Bessel(l,1) + fac2*(Bessel(l,3)-Bessel(l,1))/2 &
                    +( Bessel(l,5)-Bessel(l,3)+2*Bessel(l,1))/8*fac2*C2term  )

                !Tgrad T
                corr(1) = corr(1) + CTT(l) * fac

                !\gradT\cdot\grad T
                corr(7) = corr(7) + CTT(l) * l**2 * (fac1*Bessel(l,0) + fac2*Bessel(l,2))
                !\gradT_{<a}\grad T_{b>}
                corr(8) = corr(8) + CTT(l) * l**2 * (fac1*Bessel(l,2) + fac2/2*(Bessel(l,0)+Bessel(l,4)))

                !Q + U
                corr(2) = corr(2) + CEE(l) * fac
                fac2 = fac2*0.5_dl

                corr(3) = corr(3) - CEE(l) * (l*theta) * (fac1*(Bessel(l,5)) + &
                    fac2*(Bessel(l,3)+Bessel(l,7))   + fac2*c2term*(Bessel(l,1)+Bessel(l,9)+2*Bessel(l,5))/4 )

                corr(4) = corr(4) + CEE(l) * (l*theta) * (fac1*(Bessel(l,3)) + &
                    fac2*(Bessel(l,1)+Bessel(l,5)) + fac2*c2term*(-Bessel(l,1)+Bessel(l,7)+2*Bessel(l,3))/4  )

                corr(5) = corr(5) + CTE(l) *  (l*theta) * (fac1*(Bessel(l,3)) + &
                    fac2*(Bessel(l,5)+Bessel(l,1)))

                corr(6) = corr(6) - CTE(l) *  (l*theta) * (fac1*(Bessel(l,1)) + &
                    fac2*(Bessel(l,3)-Bessel(l,1)))


            end do

            !$ thread_ix = OMP_GET_THREAD_NUM()+1

            do l=lmin, CL%lmax_lensed
                !theta factors were put in earlier (already in corr)

                lens_contrib(1, l, thread_ix)= lens_contrib(1,l, thread_ix) - &
                    corr(1)*Bessel(l,1)/(l*theta)

                lens_contrib(7, l, thread_ix)= lens_contrib(7,l, thread_ix) + &
                    corr(7)*Bessel(l,0)/(l**2)

                lens_contrib(8, l, thread_ix)= lens_contrib(8,l, thread_ix) + &
                    corr(8)*Bessel(l,2)/(l**2)

                T2 = -corr(2)*Bessel(l,1)/(l*theta)
                T4 = (corr(4)*(Bessel(l,3)) - corr(3)*(Bessel(l,5)) )/(l*theta)/2
                lens_contrib(2,l,thread_ix)  = lens_contrib(2,l, thread_ix) + (T2+T4)/2
                lens_contrib(3,l,thread_ix)  = lens_contrib(3,l, thread_ix) + (T2-T4)/2

                lens_contrib(4,l,thread_ix)  = lens_contrib(4,l, thread_ix) + &
                    (corr(4)*(Bessel(l,3)) + corr(3)*(Bessel(l,5)) )/(l*theta)/2

                !T\grad E
                lens_contrib(5,l, thread_ix) = lens_contrib(5,l, thread_ix) + &
                    (corr(5)*Bessel(l,3)- corr(6)*(Bessel(l,1)))/(l*theta)/2
                !TE\perp
                lens_contrib(6,l, thread_ix) = lens_contrib(6,l, thread_ix) - &
                    (corr(5)*Bessel(l,3) + corr(6)*(Bessel(l,1)))/(l*theta)/2
            end do

        end do
        !$OMP END PARALLEL DO

        CGrads = 0
        do l=lmin, min(CL%lmax_lensed, lmax)
            fac = l*(l+1)* const_twopi/OutputDenominator*dtheta
            CGrads(1,l) = sum(lens_contrib(1,l,:))*fac + CL%Cl_scalar(l,CT_Temp)
            CGrads(2,l) = sum(lens_contrib(2,l,:))*fac + CL%Cl_scalar(l,CT_E)
            CGrads(3,l) = sum(lens_contrib(3,l,:))*fac !BB
            CGrads(4,l) = sum(lens_contrib(4,l,:))*fac !Perp
            CGrads(5,l) = sum(lens_contrib(5,l,:))*fac + CL%Cl_scalar(l,C_Cross)
            CGrads(6,l) = sum(lens_contrib(6,l,:))*fac
            CGrads(7,l) = sum(lens_contrib(7,l,:))*fac + CL%Cl_scalar(l,CT_Temp)
            CGrads(8,l) = sum(lens_contrib(8,l,:))*fac + CL%Cl_scalar(l,CT_Temp)
        end do

        deallocate(lens_contrib)

        if (DebugMsgs) call Timer%WriteTime('Time for GetFlatSkyCgrads')
    end associate

    end subroutine GetFlatSkyCgradsWithSpectrum

    subroutine BadHarmonic(State)
    use MathUtils
    class(CAMBdata) :: State
    integer maxl, i, almin, max_lensed_ix, maxl_phi
    real(dl) , dimension (:,:), allocatable :: bare_cls
    real(dl) pp(State%CP%Max_l)
    real(dl) asum, RR, roots(State%CP%Max_l)
    real(dl) asum_TE, asum_EE, asum_BB
    integer l1,l2,al,j, j1, k, hk, llp_1, llp_al, g1
    real(dl)  F, fct
    real(dl) g2l,g2l1, norm
    real(dl) a3j(State%CP%Max_l*2+1), tF, expF
    logical DoPol
    real(dl), allocatable :: iContribs(:,:), intcontrib(:)
    real(dl) , dimension (:,:), allocatable :: iCl_lensed
    integer max_j_contribs

    !Otherwise use second order perturbative harmonic method

    associate(lSamp => State%CLData%CTransScal%ls, CP=>State%CP, CL=> State%ClData, lmin => State%CP%Min_l)

        DoPol = CP%Accuracy%AccuratePolarization

        maxl = CP%Max_l

        if (allocated(CL%Cl_lensed)) deallocate(CL%Cl_lensed)

        allocate(iContribs(lSamp%nl, 1:4), intcontrib(lmin:lSamp%l(lSamp%nl)))

        allocate(bare_cls(maxl,1:4))

        RR = 0
        do j=lmin,maxl
            norm = OutputDenominator/(j*(j+1))
            if (lensing_includes_tensors .and. CP%WantTensors .and. j<= CP%Max_l_tensor) then !Use total Cls
                bare_cls(j,CT_Temp:CT_E) = (CL%Cl_scalar(j,C_Temp:C_E) + &
                    CL%Cl_tensor(j,CT_Temp:CT_E))*norm
                bare_cls(j,CT_B) = CL%Cl_tensor(j,CT_B)*norm
                bare_cls(j,CT_Cross) =  (CL%Cl_scalar(j,C_Cross) + &
                    CL%Cl_tensor(j,CT_Cross))*norm
            else
                bare_cls(j,CT_Temp:CT_E) = CL%Cl_scalar(j,C_Temp:C_E)*norm
                bare_cls(j,CT_B) = 0
                bare_cls(j,CT_Cross) =  CL%Cl_scalar(j,C_Cross)*norm
            end if
            pp(j) = CL%Cl_scalar(j,C_Phi)/real(j**2,dl)**2
            RR = RR + j*(j+1)*real(2*j+1,dl)*pp(j)
            roots(j) = sqrt(real(2*j+1,dl))
        end do

        RR = RR/2/const_fourpi
        if (RR > 1e-5) then
            write (*,*) 'You need to normalize realistically to use lensing.'
            write (*,*) 'see http://cosmocoffee.info/viewtopic.php?t=94'
            call MpiStop('Lensing error')
        end if
        if (maxl > lmax_donelnfa) then
            !Get ln factorials
            if (allocated(lnfa)) deallocate(lnfa)
            allocate(lnfa(0:maxl*3+1))
            lmax_donelnfa = maxl
            lnfa(0) = 0
            do i=1,CP%Max_l*3+1
                lnfa(i)=lnfa(i-1) + log(real(i,dl))
            end do
        end if

        max_lensed_ix = lSamp%nl-1
        do while(lSamp%l(max_lensed_ix) > maxl -250)
            max_lensed_ix = max_lensed_ix -1
        end do
        CL%lmax_lensed = lSamp%l(max_lensed_ix)

        allocate(iCl_lensed(max_lensed_ix,  1:4))

        max_j_contribs = lSamp%nl-1
        if (.not. DoPol) then
            maxl_phi = min(maxl,nint(max(600,(maxl*2)/5)*State%scale*CP%Accuracy%AccuracyBoost))
            do while (lSamp%l(max_j_contribs) > maxl_phi)
                max_j_contribs=max_j_contribs-1
            end do
        end if

        !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(DYNAMIC), SHARED(max_j_contribs) &
        !$OMP PRIVATE(al,g1,llp_al,llp_1,g2l,asum,l1,g2l1,l2,k,hk,F,fct,almin), &
        !$OMP PRIVATE(asum_EE,asum_BB,asum_TE,expF,tF, a3j, iContribs,intcontrib)
        do j=max_lensed_ix,1,-1
            !Only compute lensed spectra at lSamp%l(j). Start with slow ones.

            al=lSamp%l(j)

            llp_al = al*(al+1)
            g2l=sqrt((2*al+1)/const_fourpi)

            asum = 0
            asum_EE = 0
            asum_BB = 0
            asum_TE = 0


            do j1 = 1, max_j_contribs
                !  Contributions to C_al are a smooth function of l_1 - so interpolate
                l1=lSamp%l(j1)

                llp_1 = l1*(l1+1)
                g2l1=roots(l1)

                almin = max(abs(al-l1),2)

                if (DoPol) then
                    call GetThreeJs(a3j(almin),l1,al,0,2)
                    do l2= almin, min(maxl,al+l1)
                        g1 = llp_1+l2*(l2+1)-llp_al
                        if (g1 == 0 ) cycle

                        k=al+l1+l2
                        fct=g1*g2l*g2l1*roots(l2)/2
                        tF = fct*a3j(l2)

                        if (mod(k,2)==0) then

                            hk = k/2
                            F = lnfa(hk)-lnfa(hk-al)-lnfa(hk-l1)-lnfa(hk-l2)+(lnfa(k-2*al)+lnfa(k-2*l1)&
                                & +lnfa(k-2*l2)-lnfa(k+1))/2

                            expF = exp(F)

                            asum=asum + bare_cls(l2,C_Temp)*(expF*fct)**2

                            asum_EE = asum_EE + bare_cls(l2,CT_E)*tF**2
                            asum_BB = asum_BB + bare_cls(l2,CT_B)*tF**2
                            if (mod(hk,2)/=0) tF=-tF
                            asum_TE = asum_TE + bare_cls(l2,CT_Cross)*expF*fct*tF

                        else

                            asum_BB = asum_BB + bare_cls(l2,CT_E)*tF**2
                            asum_EE = asum_EE +bare_cls(l2,CT_B)*tF**2

                        end if

                    end do

                else !No polarization
                    do l2= almin +mod(al+l1+almin,2),min(maxl,al+l1), 2
                        !Only do lSamp%l's where al + l1 + l2 is even

                        g1 = llp_1+l2*(l2+1)-llp_al

                        if (g1 == 0 ) cycle  !Contribution is zero

                        k=al+l1+l2
                        hk=k/2

                        fct=g1*g2l*g2l1*roots(l2)/2
                        expF = exp(2*(lnfa(hk)-lnfa(hk-al)-lnfa(hk-l1)-lnfa(hk-l2))+lnfa(k-2*al)+lnfa(k-2*l1)&
                            & +lnfa(k-2*l2)-lnfa(k+1))
                        asum=asum + bare_cls(l2,CT_Temp)*expF *fct**2

                    end do
                end if !No polarization


                iContribs(j1,CT_Temp) = asum*pp(l1)
                if (DoPol) then
                    iContribs(j1,CT_E) = asum_EE*pp(l1)
                    iContribs(j1,CT_B) = asum_BB*pp(l1)
                    iContribs(j1,CT_Cross) = asum_TE*pp(l1)
                end if
                asum = 0
                asum_EE = 0
                asum_BB = 0
                asum_TE = 0


            end do


            !Interpolate contributions to sum and add up

            call InterpolateClArr(lSamp,iContribs(1,CT_Temp),intcontrib,max_j_contribs)
            asum = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
            if (DoPol) then
                call lSamp%InterpolateClArr(iContribs(1,CT_E),intcontrib,max_j_contribs)
                asum_EE = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
                call lSamp%InterpolateClArr(iContribs(1,CT_B),intcontrib,max_j_contribs)
                asum_BB = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
                call lSamp%InterpolateClArr(iContribs(1,CT_Cross),intcontrib,max_j_contribs)
                asum_TE = sum(intcontrib(lmin:lSamp%l(max_j_contribs)))
            end if

            iCl_lensed(j,CT_Temp) =  ((1-al*(al+1)*RR)*bare_cls(al,CT_Temp)  & !Linear part
                + asum/(2*al+1))*llp_al/OutputDenominator !add quadratic part and *l(l+1)/2pi
            if (DoPol) then
                iCl_lensed(j,CT_E) = ((1-(al**2+al-4)*RR)*bare_cls(al,CT_E)  &
                    + asum_EE/(2*al+1))*llp_al/OutputDenominator
                iCl_lensed(j,CT_B) = ((1-(al**2+al-4)*RR)*bare_cls(al,CT_B)  &
                    + asum_BB/(2*al+1))*llp_al/OutputDenominator
                iCl_lensed(j,CT_Cross) =  ((1-(al**2+al-2)*RR)*bare_cls(al,CT_Cross) &
                    + asum_TE/(2*al+1))*llp_al/OutputDenominator

            else
                iCl_lensed(j,CT_E:CT_Cross) = bare_cls(al,CT_E:CT_Cross)
            end if

        end do
        !$OMP END PARALLEL DO

        deallocate(bare_cls)

        allocate(CL%Cl_lensed(lmin:CL%lmax_lensed,1:4))

        !Interpolate to get final spectrum
        do j = CT_Temp, CT_Cross
            call lSamp%InterpolateClArr(iCl_lensed(1,j),CL%Cl_lensed(lmin, j),max_lensed_ix)
        end do

    end associate

    end subroutine BadHarmonic

    subroutine GetBessels(MaxArg)
    real(dl), intent(in):: MaxArg
    integer i
    real(dl), allocatable, dimension(:) :: x
    integer max_bes_ix,ix
    integer, save :: last_max = 0

    max_bes_ix = nint(MaxArg / dbessel) + 3
    if (max_bes_ix > last_max) then
        last_max = max_bes_ix
        if (allocated(Bess)) then
            deallocate(Bess,ddBess)
        end if
        allocate(Bess(max_bes_ix,0:maxbessel),ddBess(max_bes_ix,0:maxbessel))

        allocate(x(max_bes_ix))
        Bess(1,1:maxbessel)=0
        Bess(1,0)=1
        x(1)=0
        do i=2, max_bes_ix
            x(i) = (i-1)*dbessel
            Bess(i,:)=Bessel_jn(0, maxbessel,x(i))
        end do
        do ix=0,maxbessel
            call spline_def(x,Bess(:,ix),max_bes_ix,ddBess(:,ix))
        end do

        deallocate(x)
    end if

    end subroutine GetBessels

    ! ----------------------------------------------------------------------
    ! Auxiliary Bessel functions for N=0, N=1
    FUNCTION BESSI0(X)
    double precision X,BESSI0,Y,P1,P2,P3,P4,P5,P6,P7,  &
        Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9,AX,BX
    DATA P1,P2,P3,P4,P5,P6,P7/1.D0,3.5156229D0,3.0899424D0,1.2067429D0,  &
        0.2659732D0,0.360768D-1,0.45813D-2/
    DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1, &
        0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,  &
        0.2635537D-1,-0.1647633D-1,0.392377D-2/
    IF(ABS(X).LT.3.75D0) THEN
        Y=(X/3.75D0)**2
        BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7)))))
    ELSE
        AX=ABS(X)
        Y=3.75D0/AX
        BX=EXP(AX)/SQRT(AX)
        AX=Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9)))))))
        BESSI0=AX*BX
    ENDIF
    RETURN
    END FUNCTION BESSI0
    ! ----------------------------------------------------------------------
    FUNCTION BESSI1(X)
    double precision X,BESSI1,Y,P1,P2,P3,P4,P5,P6,P7,  &
        Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9,AX,BX
    DATA P1,P2,P3,P4,P5,P6,P7/0.5D0,0.87890594D0,0.51498869D0,  &
        0.15084934D0,0.2658733D-1,0.301532D-2,0.32411D-3/
    DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,-0.3988024D-1, &
        -0.362018D-2,0.163801D-2,-0.1031555D-1,0.2282967D-1, &
        -0.2895312D-1,0.1787654D-1,-0.420059D-2/
    IF(ABS(X).LT.3.75D0) THEN
        Y=(X/3.75D0)**2
        BESSI1=X*(P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
    ELSE
        AX=ABS(X)
        Y=3.75D0/AX
        BX=EXP(AX)/SQRT(AX)
        AX=Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9)))))))
        BESSI1=AX*BX
    ENDIF
    RETURN
    END FUNCTION BESSI1


    FUNCTION BESSI(N,X)
    !from http://perso.orange.fr/jean-pierre.moreau/Fortran/tbessi_f90.txt
    !
    !     This subroutine calculates the first kind modified Bessel function
    !     of integer order N, for any REAL X. We use here the classical
    !     recursion formula, when X > N. For X < N, the Miller's algorithm
    !     is used to avoid overflows.
    !     REFERENCE:
    !     C.W.CLENSHAW, CHEBYSHEV SERIES FOR MATHEMATICAL FUNCTIONS,
    !     MATHEMATICAL TABLES, VOL.5, 1962.
    integer, intent(in) :: N
    integer, PARAMETER :: IACC = 40
    integer m,j
    double precision, parameter ::  BIGNO = 1.D10, BIGNI = 1.D-10
    double precision X,BESSI,TOX,BIM,BI,BIP
    IF (N.EQ.0) THEN
        BESSI = BESSI0(X)
        RETURN
    ENDIF
    IF (N.EQ.1) THEN
        BESSI = BESSI1(X)
        RETURN
    ENDIF
    IF(X.EQ.0.D0) THEN
        BESSI=0.D0
        RETURN
    ENDIF
    TOX = 2.D0/X
    BIP = 0.D0
    BI  = 1.D0
    BESSI = 0.D0
    M = 2*((N+INT(SQRT(FLOAT(IACC*N)))))
    DO J = M,1,-1
        BIM = BIP+ J*TOX*BI
        BIP = BI
        BI  = BIM
        IF (ABS(BI).GT.BIGNO) THEN
            BI  = BI*BIGNI
            BIP = BIP*BIGNI
            BESSI = BESSI*BIGNI
        ENDIF
        IF (J.EQ.N) BESSI = BIP
    END DO
    BESSI = BESSI*BESSI0(X)/BI
    RETURN
    END FUNCTION BESSI


    end module lensing

    module Reionization
    use Precision
    use MiscUtils
    use classes
    use results
    implicit none
    private
    
    !Default tanh reionization, and an alternative exponential model with fixed minimum z_re
    
    !This module has smooth tanh reionization of specified mid-point (z_{re}) and width
    !The tanh function is in the variable (1+z)**Rionization_zexp
    !Rionization_zexp=1.5 has the property that for the same z_{re}
    !the optical depth agrees with infinitely sharp model for matter domination
    !So tau and zre can be mapped into each other easily (for any symmetric window)
    !However for generality the module maps tau into z_{re} using a binary search
    !so could be easily modified for other monatonic parameterizations.
    
    !The ionization history must be twice differentiable.

    !AL March 2008
    !AL July 2008 - added trap for setting optical depth without use_optical_depth
    !AL Aug 2023 - added exponential model and refactored classes
    
    !See CAMB notes for further discussion: http://cosmologist.info/notes/CAMB.pdf

    real(dl), parameter :: Reionization_DefFraction = -1._dl
    !if -1 set from YHe assuming Hydrogen and first ionization of Helium follow each other

    real(dl) :: Tanh_zexp = 1.5_dl

    type, extends(TReionizationModel) :: TBaseTauWithHeReionization
        ! Parameterization that can take tau as an input, using redshift as a one-parameter mapping to tau
        ! includes simple tanh fitting of second reionization of helium
        logical    :: use_optical_depth = .false.
        real(dl)   :: redshift = 10._dl
        real(dl)   :: optical_depth = 0._dl
        real(dl)   :: fraction = Reionization_DefFraction
        !Parameters for the second reionization of Helium
        logical    :: include_helium_fullreion  = .true.
        real(dl)   :: helium_redshift  = 3.5_dl
        real(dl)   :: helium_delta_redshift  = 0.4_dl
        real(dl)   :: helium_redshiftstart  = 5.5_dl
        real(dl)   :: tau_solve_accuracy_boost = 1._dl
        real(dl)   :: timestep_boost =  1._dl
        real(dl)   :: max_redshift = 50._dl
        real(dl)   :: min_redshift = 0._dl
        !The rest are internal to this module.
        real(dl), private ::  fHe
        class(CAMBdata), pointer :: State
    contains
    procedure :: ReadParams => TBaseTauWithHeReionization_ReadParams
    procedure :: Init => TBaseTauWithHeReionization_Init
    procedure, nopass ::  GetZreFromTau => TBaseTauWithHeReionization_GetZreFromTau
    procedure, private :: zreFromOptDepth => TBaseTauWithHeReionization_zreFromOptDepth
    procedure :: SecondHelium_xe => TBaseTauWithHeReionization_SecondHelium_xe
    procedure :: SetParamsForZre => TBaseTauWithHeReionization_SetParamsForZre
    procedure :: Validate => TBaseTauWithHeReionization_Validate
    end type TBaseTauWithHeReionization

    type, extends(TBaseTauWithHeReionization) :: TTanhReionization
        real(dl)   :: delta_redshift = 0.5_dl
        !The rest are internal to this module.
        real(dl), private ::  WindowVarMid, WindowVarDelta
    contains
    procedure :: x_e => TTanhReionization_xe
    procedure :: get_timesteps => TTanhReionization_get_timesteps
    procedure :: ReadParams => TTanhReionization_ReadParams
    procedure :: Validate => TTanhReionization_Validate
    procedure :: SetParamsForZre => TTanhReionization_SetParamsForZre
    procedure, nopass :: SelfPointer => TTanhReionization_SelfPointer
    end type TTanhReionization

    type, extends(TBaseTauWithHeReionization) :: TExpReionization
        ! An ionization fraction that decreases exponentially at high z, saturating to fully inionized at fixed redshift.
        ! This model has a minimum non-zero tau
        ! Similar to e.g.  arXiv:1509.02785, arXiv:2006.16828
        real(dl)   :: reion_redshift_complete = 6.1_dl
        real(dl)   :: reion_exp_smooth_width = 0.02_dl !modifies expential at reion_redshift_complete so derivatives continuous
        real(dl)   :: reion_exp_power = 1._dl  !scaling propto exp(-lambda (z-reion_redshift_complete)**reion_exp_power) at high z
    contains
    procedure :: x_e => TExpReionization_xe
    procedure :: get_timesteps => TExpReionization_get_timesteps
    procedure :: Init => TExpReionization_Init
    procedure :: ReadParams => TExpReionization_ReadParams
    procedure, nopass :: SelfPointer => TExpReionization_SelfPointer
    end type TExpReionization

    public TBaseTauWithHeReionization, TTanhReionization, TExpReionization
    contains

    subroutine TBaseTauWithHeReionization_Init(this, State)
    use constants
    use MathUtils
    class(TBaseTauWithHeReionization) :: this
    class(TCAMBdata), target :: State
    procedure(obj_function) :: dtauda

    select type (State)
    class is (CAMBdata)
        this%State => State

        this%fHe =  State%CP%YHe/(mass_ratio_He_H*(1.d0-State%CP%YHe))
        if (this%Reionization) then

            if (this%optical_depth /= 0._dl .and. .not. this%use_optical_depth) &
                write (*,*) 'WARNING: You seem to have set the optical depth, but use_optical_depth = F'

            if (this%use_optical_depth.and.this%optical_depth<0.001 &
                .or. .not.this%use_optical_depth .and. this%Redshift<0.001) then
                this%Reionization = .false.
            end if

        end if

        if (this%Reionization) then

            if (this%fraction==Reionization_DefFraction) &
                this%fraction = 1._dl + this%fHe  !H + singly ionized He

            if (this%use_optical_depth) then
                call this%zreFromOptDepth()
                if (global_error_flag/=0) return
                if (FeedbackLevel > 0) write(*,'("Reion redshift       =  ",f6.3)') this%redshift
            end if

            call this%SetParamsForZre()

            !this is a check, agrees very well in default parameterization
            if (FeedbackLevel > 1) write(*,'("Integrated opt depth = ",f7.4)') this%State%GetReionizationOptDepth()

        end if
    end select
    end subroutine TBaseTauWithHeReionization_Init

    function TBaseTauWithHeReionization_SecondHelium_xe(this, z) result(xe)
    class(TBaseTauWithHeReionization) :: this
    real(dl), intent(in) :: z
    real(dl) xe, tgh, xod

    if (this%include_helium_fullreion .and. z < this%helium_redshiftstart) then
        !Effect of Helium becoming fully ionized is small so details not important
        xod = (this%helium_redshift - z)/this%helium_delta_redshift
        if (xod > 100) then
            tgh=1.d0
        else
            tgh=tanh(xod)
        end if

        xe = this%fHe*(tgh+1._dl)/2._dl
    else
        xe = 0.d0
    end if

    end function TBaseTauWithHeReionization_SecondHelium_xe


    subroutine TBaseTauWithHeReionization_ReadParams(this, Ini)
    use IniObjects
    class(TBaseTauWithHeReionization) :: this
    class(TIniFile), intent(in) :: Ini

    this%Reionization = Ini%Read_Logical('reionization')
    if (this%Reionization) then

        this%use_optical_depth = Ini%Read_Logical('re_use_optical_depth')

        if (this%use_optical_depth) then
            this%optical_depth = Ini%Read_Double('re_optical_depth')
        else
            this%redshift = Ini%Read_Double('re_redshift')
        end if

        call Ini%Read('re_ionization_frac',this%fraction)
        call Ini%Read('re_helium_redshift',this%helium_redshift)
        call Ini%Read('re_helium_delta_redshift',this%helium_delta_redshift)

        this%helium_redshiftstart  = Ini%Read_Double('re_helium_redshiftstart', &
            this%helium_redshift + 5*this%helium_delta_redshift)

    end if

    end subroutine TBaseTauWithHeReionization_ReadParams


    subroutine TBaseTauWithHeReionization_SetParamsForZre(this)
    class(TBaseTauWithHeReionization) :: this

    end subroutine TBaseTauWithHeReionization_SetParamsForZre

    subroutine TBaseTauWithHeReionization_Validate(this, OK)
    class(TBaseTauWithHeReionization),intent(in) :: this
    logical, intent(inout) :: OK

    if (this%Reionization) then
        if (this%use_optical_depth) then
            if (this%optical_depth<0 .or. this%optical_depth > 0.9  .or. &
                this%include_helium_fullreion .and. this%optical_depth<0.01) then
                OK = .false.
                write(*,*) 'Optical depth is strange. You have:', this%optical_depth
            end if
        end if
        if (this%fraction/= Reionization_DefFraction .and. (this%fraction < 0 .or. this%fraction > 1.5)) then
            OK = .false.
            write(*,*) 'Reionization fraction strange. You have: ',this%fraction
        end if
    end if

    end subroutine TBaseTauWithHeReionization_Validate

    subroutine TBaseTauWithHeReionization_zreFromOptDepth(this)
    !General routine to find zre parameter given optical depth
    class(TBaseTauWithHeReionization) :: this
    real(dl) try_b, try_t
    real(dl) tau, last_top, last_bot
    integer i

    try_b = this%min_redshift
    try_t = this%max_redshift
    i=0
    do
        i=i+1
        this%redshift = (try_t + try_b)/2
        call this%SetParamsForZre()
        tau = this%State%GetReionizationOptDepth()

        if (tau > this%optical_depth) then
            try_t = this%redshift
            last_top = tau
        else
            try_b = this%redshift
            last_bot = tau
        end if
        if (abs(try_b - try_t) < 1e-2_dl/this%tau_solve_accuracy_boost) then
            if (try_b==this%min_redshift) last_bot = this%min_redshift
            if (try_t/=this%max_redshift) this%redshift  = &
                (try_t*(this%optical_depth-last_bot) + try_b*(last_top-this%optical_depth))/(last_top-last_bot)
            exit
        end if
        if (i>100) call GlobalError('TBaseTauWithHeReionization_zreFromOptDepth: failed to converge',error_reionization)
    end do

    if (abs(tau - this%optical_depth) > 0.002 .and. global_error_flag==0) then
        write (*,*) 'TBaseTauWithHeReionization_zreFromOptDepth: Did not converge to optical depth'
        write (*,*) 'tau =',tau, 'optical_depth = ', this%optical_depth
        write (*,*) try_t, try_b
        write (*,*) '(If running a chain, have you put a constraint on tau?)'
        call GlobalError('Reionization did not converge to optical depth',error_reionization)
    end if

    end subroutine TBaseTauWithHeReionization_zreFromOptDepth

    real(dl) function TBaseTauWithHeReionization_GetZreFromTau(P, tau)
    type(CAMBparams) :: P, P2
    real(dl) tau
    integer error
    type(CAMBdata) :: State

    P2 = P

    select type(Reion=>P2%Reion)
    class is (TBaseTauWithHeReionization)
        Reion%Reionization = .true.
        Reion%use_optical_depth = .true.
        Reion%optical_depth = tau
    end select
    call State%SetParams(P2,error)
    if (error/=0)  then
        TBaseTauWithHeReionization_GetZreFromTau = -1
    else
        select type(Reion=>State%CP%Reion)
        class is (TBaseTauWithHeReionization)
            TBaseTauWithHeReionization_GetZreFromTau = Reion%redshift
        end select
    end if

    end function  TBaseTauWithHeReionization_GetZreFromTau

    function TTanhReionization_xe(this, z, tau, xe_recomb)
    !a and time tau are redundant, both provided for convenience
    !xe_recomb is xe(tau_start) from recombination (typically very small, ~2e-4)
    !xe should map smoothly onto xe_recomb
    class(TTanhReionization) :: this
    real(dl), intent(in) :: z
    real(dl), intent(in), optional :: tau, xe_recomb
    real(dl) TTanhReionization_xe
    real(dl) tgh, xod
    real(dl) xstart

    xstart = PresentDefault(0._dl, xe_recomb)

    xod = (this%WindowVarMid - (1+z)**Tanh_zexp)/this%WindowVarDelta
    if (xod > 100) then
        tgh=1.d0
    else
        tgh=tanh(xod)
    end if
    TTanhReionization_xe =(this%fraction-xstart)*(tgh+1._dl)/2._dl+xstart + &
        this%SecondHelium_xe(z)

    end function TTanhReionization_xe

    subroutine TTanhReionization_get_timesteps(this, n_steps, z_start, z_complete)
    !minimum number of time steps to use between tau_start and tau_complete
    !Scaled by AccuracyBoost later
    !steps may be set smaller than this anyway
    class(TTanhReionization) :: this
    integer, intent(out) :: n_steps
    real(dl), intent(out):: z_start, z_Complete

    n_steps = nint(50 * this%timestep_boost)
    z_start = this%redshift + this%delta_redshift*8
    z_complete = max(0.d0,this%redshift-this%delta_redshift*8)

    end subroutine TTanhReionization_get_timesteps

    subroutine TTanhReionization_SetParamsForZre(this)
    class(TTanhReionization) :: this

    this%WindowVarMid = (1._dl+this%redshift)**Tanh_zexp
    this%WindowVarDelta = Tanh_zexp*(1._dl+this%redshift)**(Tanh_zexp-1._dl)*this%delta_redshift

    end subroutine TTanhReionization_SetParamsForZre

    subroutine TTanhReionization_ReadParams(this, Ini)
    use IniObjects
    class(TTanhReionization) :: this
    class(TIniFile), intent(in) :: Ini

    call this%TBaseTauWithHeReionization%ReadParams(Ini)
    if (this%Reionization) call Ini%Read('re_delta_redshift',this%delta_redshift)

    end subroutine TTanhReionization_ReadParams

    subroutine TTanhReionization_Validate(this, OK)
    class(TTanhReionization),intent(in) :: this
    logical, intent(inout) :: OK

    call this%TBaseTauWithHeReionization%Validate(OK)
    if (this%Reionization) then
        if (.not. this%use_optical_depth) then
            if (this%redshift < 0 .or. this%Redshift +this%delta_redshift*3 > this%max_redshift .or. &
                this%include_helium_fullreion .and. this%redshift < this%helium_redshift) then
                OK = .false.
                write(*,*) 'Reionization redshift strange. You have: ',this%Redshift
            end if
        end if
        if (this%delta_redshift > 3 .or. this%delta_redshift<0.1 ) then
            !Very narrow windows likely to cause problems in interpolation etc.
            !Very broad likely to conflict with quasar data at z=6
            OK = .false.
            write(*,*) 'Reionization delta_redshift is strange. You have: ',this%delta_redshift
        end if
    end if

    end subroutine TTanhReionization_Validate

    subroutine TTanhReionization_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TTanhReionization), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TTanhReionization_SelfPointer

    subroutine TExpReionization_Init(this, State)
    class(TExpReionization) :: this
    class(TCAMBdata), target :: State

    this%min_redshift = this%reion_redshift_complete
    call this%TBaseTauWithHeReionization%Init(State)

    end subroutine TExpReionization_Init


    function TExpReionization_xe(this, z, tau, xe_recomb)
    !a and time tau are redundant, both provided for convenience
    !xe_recomb is xe(tau_start) from recombination (typically very small, ~2e-4)
    !xe should map smoothly onto xe_recomb
    class(TExpReionization) :: this
    real(dl), intent(in) :: z
    real(dl), intent(in), optional :: tau, xe_recomb
    real(dl) TExpReionization_xe
    real(dl) lam, xstart, smoothing

    xstart = PresentDefault(0._dl, xe_recomb)

    if (z <= this%reion_redshift_complete + 1d-6) then
        TExpReionization_xe = this%fraction
    else
        lam = -log(0.5)/(this%redshift - this%reion_redshift_complete)**this%reion_exp_power
        smoothing = 1/(1+this%reion_exp_smooth_width/(z-this%reion_redshift_complete)**2)
        TExpReionization_xe = exp(-lam*(z-this%reion_redshift_complete)**this%reion_exp_power*smoothing) &
            *(this%fraction-xstart) + xstart
    end if

    TExpReionization_xe = TExpReionization_xe +  this%SecondHelium_xe(z)

    end function TExpReionization_xe

    subroutine TExpReionization_get_timesteps(this, n_steps, z_start, z_complete)
    !minimum number of time steps to use between tau_start and tau_complete
    !Scaled by AccuracyBoost later
    !steps may be set smaller than this anyway
    class(TExpReionization) :: this
    integer, intent(out) :: n_steps
    real(dl), intent(out):: z_start, z_complete
    real(dl) lam

    n_steps = nint(50 * this%timestep_boost)
    lam = -log(0.5)/(this%redshift - this%reion_redshift_complete)**this%reion_exp_power
    z_start = this%reion_redshift_complete  + (-log(0.0001)/lam)**(1/this%reion_exp_power)
    z_complete = this%reion_redshift_complete

    end subroutine TExpReionization_get_timesteps

    subroutine TExpReionization_ReadParams(this, Ini)
    use IniObjects
    class(TExpReionization) :: this
    class(TIniFile), intent(in) :: Ini

    call this%TBaseTauWithHeReionization%ReadParams(Ini)
    if (this%Reionization)then
        call Ini%Read('reion_redshift_complete',this%reion_redshift_complete)
        call Ini%Read('reion_exp_smooth_width',this%reion_exp_smooth_width)
        call Ini%Read('reion_exp_power',this%reion_exp_power)
    end if

    end subroutine TExpReionization_ReadParams

    subroutine TExpReionization_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TExpReionization), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TExpReionization_SelfPointer

    end module Reionization

    module DarkAge21cm
    use constants
    use splines
    !Functions for collision rates.
    implicit none
    contains

    function kappa_HH_21cm(T, deriv)
    !Polynomial fit to Hydrogen-Hydrogen collision rate as function of Tmatter, from astro-ph/0608032
    !if deriv return d log kappa / d log T
    real(dl), intent(in) :: T
    logical, intent(in) :: deriv
    !        real(dl), dimension(8), parameter :: fit = &
    !         (/ 0.00120402_dl, -0.0322247_dl,0.339581_dl, -1.75094_dl,4.3528_dl,-4.03562_dl, 1.26899_dl, -29.6113_dl /)
    integer, parameter :: n_table = 27
    integer, dimension(n_table), parameter :: Temps = &
        (/ 1, 2, 4, 6,8,10,15,20,25,30,40,50,60,70,80,90,100,200,300,500,700,1000,2000,3000,5000,7000,10000/)
    real, dimension(n_table), parameter :: rates = &
        (/ 1.38e-13, 1.43e-13,2.71e-13, 6.60e-13,1.47e-12,2.88e-12,9.10e-12,1.78e-11,2.73e-11,&
        3.67e-11,5.38e-11,6.86e-11,8.14e-11,9.25e-11, &
        1.02e-10,1.11e-10,1.19e-10,1.75e-10,2.09e-10,2.56e-10,2.91e-10,3.31e-10,4.27e-10,&
        4.97e-10,6.03e-10,6.87e-10,7.87e-10/)

    real(dl) kappa_HH_21cm, logT, logRate
    real(dl), save, dimension(:), allocatable :: logRates, logTemps, ddlogRates
    integer xlo, xhi
    real(dl) :: a0, b0, ho

    if (.not. allocated(logRates)) then

        allocate(logRates(n_table),logTemps(n_table),ddlogRates(n_table))
        logRates = log(real(rates,dl)*0.01**3)
        logTemps = log(real(Temps,dl))
        call spline_def(logTemps,logRates,n_table,ddlogRates)
    end if

    if (T<=Temps(1)) then
        if (deriv) then
            kappa_HH_21cm = 0
        else
            kappa_HH_21cm = rates(1)*0.01**3
        end if
        return
    elseif (T >=Temps(n_table)) then
        if (deriv) then
            kappa_HH_21cm = 0
        else
            kappa_HH_21cm = rates(n_table)*0.01**3
        end if
        return
    end if

    logT = log(T)
    xlo=0
    do xhi=2, n_table
        if (logT < logTemps(xhi)) then
            xlo = xhi-1
            exit
        end  if
    end do
    xhi = xlo+1

    ho=logTemps(xhi)-logTemps(xlo)
    a0=(logTemps(xhi)-logT)/ho
    b0=1-a0

    if (deriv) then
        kappa_HH_21cm  = (logRates(xhi) - logRates(xlo))/ho + &
            ( ddlogRates(xhi)*(3*b0**2-1) - ddlogRates(xlo)*(3*a0**2-1))*ho/6
        !          kappa_HH_21cm = derivpolevl(logT,fit,7)
    else
        logRate = a0*logRates(xlo)+ b0*logRates(xhi)+ ((a0**3-a0)* ddlogRates(xlo) +(b0**3-b0)*ddlogRates(xhi))*ho**2/6
        kappa_HH_21cm = exp(logRate)
        !          kappa_HH_21cm = exp(polevl(logT,fit,7))*0.01**3

    end if

    end function kappa_HH_21cm


    function kappa_eH_21cm(T, deriv)
    !Polynomail fit to electron-Hydrogen collision rate as function of Tmatter; from astro-ph/0608032
    !if deriv return d log kappa / d log T
    ! from astro-ph/0608032
    !    1 2.39e-10
    !    2 3.37e-10
    !    5 5.3e-10
    !    10 7.46e-10
    !    20 1.05e-9
    !    50 1.63e-9
    !    100 2.26e-9
    !    200 3.11e-9
    !    500 4.59e-9
    !    1000 5.92e-9
    !    2000 7.15e-9
    !    5000 8.17e-9
    !    10000 8.37e-9
    !    15000 8.29e-9
    !    20000 8.11e-9
    real(dl), intent(in) :: T
    logical, intent(in) :: deriv
    real(dl), dimension(6), parameter :: fit = &
        (/5.86236d-005,  -0.00171375_dl, 0.0137303_dl, -0.0435277_dl, 0.540905_dl,-22.1596_dl /)
    real(dl) kappa_eH_21cm, logT

    logT = log(T)
    if (deriv) then
        kappa_eH_21cm = derivpolevl(logT,fit,5)
    else
        kappa_eH_21cm = exp(polevl(logT,fit,5))*0.01**3
    end if

    end function kappa_eH_21cm

    function kappa_pH_21cm(T, deriv) ! from astro-ph/0702487
    !Not actually used
    !Polynomail fit to proton-Hydrogen collision rate as function of Tmatter
    !if deriv return d log kappa / d log T
    real(dl), intent(in) :: T
    logical, intent(in) :: deriv
    integer, parameter :: n_table = 17
    integer, dimension(n_table), parameter :: Temps = &
        (/ 1, 2, 5, 10,20,50,100,200,500,1000,2000,3000,5000,7000,10000,15000,20000/)
    real, dimension(n_table), parameter :: rates = &
        (/ 0.4028, 0.4517,0.4301,0.3699,0.3172,0.3047, 0.3379, 0.4043, 0.5471, 0.7051, 0.9167, 1.070, &
        1.301, 1.48,1.695,1.975,2.201/)

    real(dl) kappa_pH_21cm, logT, logRate
    real(dl), save, dimension(:), allocatable :: logRates, logTemps, ddlogRates
    integer xlo, xhi
    real(dl) :: a0, b0, ho
    real(dl):: factor = 0.01**3*1e-9

    if (.not. allocated(logRates)) then

        allocate(logRates(n_table),logTemps(n_table),ddlogRates(n_table))
        logRates = log(real(rates,dl)*factor)
        logTemps = log(real(Temps,dl))
        call spline_def(logTemps,logRates,n_table,ddlogRates)
    end if

    if (T<=Temps(1)) then
        if (deriv) then
            kappa_pH_21cm = 0
        else
            kappa_pH_21cm = rates(1)*factor
        end if
        return
    elseif (T >=Temps(n_table)) then
        if (deriv) then
            kappa_pH_21cm = 0
        else
            kappa_pH_21cm = rates(n_table)*factor
        end if
        return
    end if

    logT = log(T)
    xlo=0
    do xhi=2, n_table
        if (logT < logTemps(xhi)) then
            xlo = xhi-1
            exit
        end  if
    end do
    xhi = xlo+1

    ho=logTemps(xhi)-logTemps(xlo)
    a0=(logTemps(xhi)-logT)/ho
    b0=1-a0

    if (deriv) then
        kappa_pH_21cm  = (logRates(xhi) - logRates(xlo))/ho + &
            ( ddlogRates(xhi)*(3*b0**2-1) - ddlogRates(xlo)*(3*a0**2-1))*ho/6
    else
        logRate = a0*logRates(xlo)+ b0*logRates(xhi)+ ((a0**3-a0)* ddlogRates(xlo) +(b0**3-b0)*ddlogRates(xhi))*ho**2/6
        kappa_pH_21cm = exp(logRate)
    end if

    end function kappa_pH_21cm

    function polevl(x,coef,N)
    integer N
    real(dl) polevl
    real(dl) x,ans
    real(dl) coef(N+1)
    integer i

    ans=coef(1)
    do i=2,N+1
        ans=ans*x+coef(i)
    end do
    polevl=ans

    end function polevl


    function derivpolevl(x,coef,N)
    integer N
    real(dl) derivpolevl
    real(dl) x,ans
    real(dl) coef(N+1)
    integer i

    ans=coef(1)*N
    do i=2,N
        ans=ans*x+coef(i)*(N-i+1)
    end do
    derivpolevl=ans

    end function derivpolevl

    end module DarkAge21cm

    !This module provides the initial power spectra

    !TInitialPowerLaw is parameterized as an expansion in ln k
    !
    ! ln P_s = ln A_s + (n_s -1)*ln(k/k_0_scalar) + n_{run}/2 * ln(k/k_0_scalar)^2 + n_{runrun}/6 * ln(k/k_0_scalar)^3
    !
    ! so if n_{run} = 0, n_{runrun}=0
    !
    ! P_s = A_s (k/k_0_scalar)^(n_s-1)
    !
    !for the scalar spectrum, when n_s=an(in) is the in'th spectral index. k_0_scalar
    !is a pivot scale, fixed here to 0.05/Mpc (change it below as desired or via .ini file).
    !
    !The tensor spectrum has three different supported parameterizations giving
    !
    ! ln P_t = ln A_t + n_t*ln(k/k_0_tensor) + n_{t,run}/2 * ln(k/k_0_tensor)^2
    !
    ! tensor_parameterization==tensor_param_indeptilt (=1) (default, same as CAMB pre-April 2014)
    !
    ! A_t = r A_s
    !
    ! tensor_parameterization==tensor_param_rpivot (=2)
    !
    ! A_t = r P_s(k_0_tensor)
    !
    ! tensor_parameterization==tensor_param_AT (=3)
    !
    ! A_t =  tensor_amp
    !
    !The absolute normalization of the Cls is unimportant here, but the relative ratio
    !of the tensor and scalar Cls generated with this module will be correct for general models

    module InitialPower
    use Precision
    use MpiUtils, only : MpiStop
    use classes
    implicit none

    private

    integer, parameter, public :: tensor_param_indeptilt=1,  tensor_param_rpivot = 2, tensor_param_AT = 3

    Type, extends(TInitialPower) :: TInitialPowerLaw
        integer :: tensor_parameterization = tensor_param_indeptilt
        !For the default implementation return power spectra based on spectral indices
        real(dl) :: ns = 1._dl !scalar spectral indices
        real(dl) :: nrun = 0._dl !running of spectral index
        real(dl) :: nrunrun  = 0._dl !running of spectral index
        real(dl) :: nt  = 0._dl !tensor spectral indices
        real(dl) :: ntrun  = 0._dl !tensor spectral index running
        real(dl) :: r  = 0._dl !ratio of scalar to tensor initial power spectrum amplitudes
        real(dl) :: pivot_scalar = 0.05_dl !pivot scales in Mpc^{-1}
        real(dl) :: pivot_tensor = 0.05_dl
        real(dl) :: As = 1._dl
        real(dl) :: At = 1._dl !A_T at k_0_tensor if tensor_parameterization==tensor_param_AT
        real(dl), private :: curv = 0._dl !curvature parameter
    contains
    procedure :: Init => TInitialPowerLaw_Init
    procedure, nopass :: PythonClass => TInitialPowerLaw_PythonClass
    procedure, nopass :: SelfPointer => TInitialPowerLaw_SelfPointer
    procedure :: ScalarPower => TInitialPowerLaw_ScalarPower
    procedure :: TensorPower => TInitialPowerLaw_TensorPower
    procedure :: ReadParams => TInitialPowerLaw_ReadParams
    procedure :: Effective_ns => TInitalPowerLaw_Effective_ns
    end Type TInitialPowerLaw

    Type, extends(TInitialPower) :: TSplinedInitialPower
        real(dl) :: effective_ns_for_nonlinear = -1._dl !used for halofit
        real(dl) :: kmin_scalar, kmax_scalar
        real(dl) :: kmin_tensor, kmax_tensor
        class(TSpline1D), allocatable :: Pscalar, Ptensor
    contains
    procedure :: SetScalarTable => TSplinedInitialPower_SetScalarTable
    procedure :: SetTensorTable => TSplinedInitialPower_SetTensorTable
    procedure :: SetScalarLogRegular => TSplinedInitialPower_SetScalarLogRegular
    procedure :: SetTensorLogRegular => TSplinedInitialPower_SetTensorLogRegular
    procedure :: ScalarPower => TSplinedInitialPower_ScalarPower
    procedure :: TensorPower => TSplinedInitialPower_TensorPower
    procedure :: HasTensors => TSplinedInitialPower_HasTensors
    procedure :: Effective_ns => TSplinedInitialPower_Effective_ns
    procedure, nopass :: PythonClass => TSplinedInitialPower_PythonClass
    procedure, nopass :: SelfPointer => TSplinedInitialPower_SelfPointer
    end Type TSplinedInitialPower


    public TInitialPowerLaw, TSplinedInitialPower
    contains

    function TInitialPowerLaw_PythonClass()
    character(LEN=:), allocatable :: TInitialPowerLaw_PythonClass
    TInitialPowerLaw_PythonClass = 'InitialPowerLaw'
    end function TInitialPowerLaw_PythonClass

    subroutine TInitialPowerLaw_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TInitialPowerLaw), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TInitialPowerLaw_SelfPointer

    subroutine TInitialPowerLaw_Init(this, Params)
    use classes
    use results
    use constants, only : c
    class(TInitialPowerLaw) :: this
    class(TCAMBParameters), intent(in) :: Params

    select type(Params)
    class is (CAMBParams)
        !Curvature parameter if non-flat
        this%curv = -Params%Omk/((c/1000)/Params%H0)**2
    end select

    end subroutine TInitialPowerLaw_Init

    function TInitialPowerLaw_ScalarPower(this, k)
    class(TInitialPowerLaw) :: this
    real(dl), intent(in) :: k
    real(dl) TInitialPowerLaw_ScalarPower
    real(dl) lnrat
    !ScalarPower = const for scale invariant spectrum
    !The normalization is defined so that for adiabatic perturbations the gradient of the 3-Ricci
    !scalar on co-moving hypersurfaces receives power
    ! < |D_a R^{(3)}|^2 > = int dk/k 16 k^6/S^6 (1-3K/k^2)^2 ScalarPower(k)
    !In other words ScalarPower is the power spectrum of the conserved curvature perturbation given by
    !-chi = \Phi + 2/3*\Omega^{-1} \frac{H^{-1}\Phi' - \Psi}{1+w}
    !(w=p/\rho), so < |\chi(x)|^2 > = \int dk/k ScalarPower(k).
    !Near the end of inflation chi is equal to 3/2 Psi.
    !Here nu^2 = (k^2 + curv)/|curv|

    !This power spectrum is also used for isocurvature modes where
    !< |\Delta(x)|^2 > = \int dk/k ScalarPower(k)
    !For the isocurvture velocity mode ScalarPower is the power in the neutrino heat flux.


    lnrat = log(k/this%pivot_scalar)
    TInitialPowerLaw_ScalarPower = this%As * exp(lnrat * (this%ns - 1 + &
        &             lnrat * (this%nrun / 2 + this%nrunrun / 6 * lnrat)))

    end function TInitialPowerLaw_ScalarPower


    function TInitialPowerLaw_TensorPower(this,k)
    use constants
    class(TInitialPowerLaw) :: this
    !TensorPower= const for scale invariant spectrum
    !The normalization is defined so that
    ! < h_{ij}(x) h^{ij}(x) > = \sum_nu nu /(nu^2-1) (nu^2-4)/nu^2 TensorPower(k)
    !for a closed model
    ! < h_{ij}(x) h^{ij}(x) > = int d nu /(nu^2+1) (nu^2+4)/nu^2 TensorPower(k)
    !for an open model
    !Here nu^2 = (k^2 + 3*curv)/|curv|
    real(dl), intent(in) :: k
    real(dl) TInitialPowerLaw_TensorPower
    real(dl), parameter :: PiByTwo=const_pi/2._dl
    real(dl) lnrat, k_dep

    lnrat = log(k/this%pivot_tensor)
    k_dep = exp(lnrat*(this%nt + this%ntrun/2*lnrat))
    if (this%tensor_parameterization==tensor_param_indeptilt) then
        TInitialPowerLaw_TensorPower = this%r*this%As*k_dep
    else if (this%tensor_parameterization==tensor_param_rpivot) then
        TInitialPowerLaw_TensorPower = this%r*this%ScalarPower(this%pivot_tensor) * k_dep
    else if (this%tensor_parameterization==tensor_param_At) then
        TInitialPowerLaw_TensorPower = this%At * k_dep
    end if
    if (this%curv < 0) TInitialPowerLaw_TensorPower= &
        TInitialPowerLaw_TensorPower*tanh(PiByTwo*sqrt(-k**2/this%curv-3))
    end function TInitialPowerLaw_TensorPower

    function CompatKey(Ini, name)
    class(TIniFile), intent(in) :: Ini
    character(LEN=*), intent(in) :: name
    character(LEN=:), allocatable :: CompatKey
    !Allow backwards compatibility with old .ini files where initial power parameters were arrays

    if (Ini%HasKey(name//'(1)')) then
        CompatKey = name//'(1)'
        if (Ini%HasKey(name)) call MpiStop('Must have one of '//trim(name)//' or '//trim(name)//'(1)')
    else
        CompatKey = name
    end if
    end function CompatKey

    subroutine TInitialPowerLaw_ReadParams(this, Ini)
    use IniObjects
    class(TInitialPowerLaw) :: this
    class(TIniFile), intent(in) :: Ini
    logical :: WantTensors

    WantTensors = Ini%Read_Logical('get_tensor_cls', .false.)

    call Ini%Read('pivot_scalar', this%pivot_scalar)
    call Ini%Read('pivot_tensor', this%pivot_tensor)
    if (Ini%Read_Int('initial_power_num', 1) /= 1) call MpiStop('initial_power_num>1 no longer supported')
    if (WantTensors) then
        this%tensor_parameterization =  Ini%Read_Int('tensor_parameterization', tensor_param_indeptilt)
        if (this%tensor_parameterization < tensor_param_indeptilt .or. &
            &   this%tensor_parameterization > tensor_param_AT) &
            &   call MpiStop('InitialPower: unknown tensor_parameterization')
    end if
    this%r = 1
    this%ns = Ini%Read_Double(CompatKey(Ini,'scalar_spectral_index'))
    call Ini%Read(CompatKey(Ini,'scalar_nrun'), this%nrun)
    call Ini%Read(CompatKey(Ini,'scalar_nrunrun'), this%nrunrun)

    if (WantTensors) then
        this%nt = Ini%Read_Double(CompatKey(Ini,'tensor_spectral_index'))
        call Ini%Read(CompatKey(Ini,'tensor_nrun'),this%ntrun)
        if (this%tensor_parameterization == tensor_param_AT) then
            this%At = Ini%Read_Double(CompatKey(Ini,'tensor_amp'))
        else
            this%r = Ini%Read_Double(CompatKey(Ini,'initial_ratio'))
        end if
    else
        this%r =0
        this%At=0
    end if

    call Ini%Read(CompatKey(Ini,'scalar_amp'),this%As)
    !Always need this as may want to set tensor amplitude even if scalars not computed

    end subroutine TInitialPowerLaw_ReadParams

    function TInitalPowerLaw_Effective_ns(this)
    class(TInitialPowerLaw) :: this
    real(dl) :: TInitalPowerLaw_Effective_ns

    TInitalPowerLaw_Effective_ns = this%ns

    end function TInitalPowerLaw_Effective_ns


    subroutine TSplinedInitialPower_SelfPointer(cptr, P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TSplinedInitialPower), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TSplinedInitialPower_SelfPointer

    logical function TSplinedInitialPower_HasTensors(this)
    class(TSplinedInitialPower) :: this

    TSplinedInitialPower_HasTensors = allocated(this%Ptensor)

    end function TSplinedInitialPower_HasTensors

    function TSplinedInitialPower_ScalarPower(this, k)
    class(TSplinedInitialPower) :: this
    real(dl), intent(in) ::k
    real(dl) TSplinedInitialPower_ScalarPower

    if (k <= this%kmin_scalar) then
        TSplinedInitialPower_ScalarPower = this%Pscalar%F(1)
    elseif (k >= this%kmax_scalar) then
        TSplinedInitialPower_ScalarPower = this%Pscalar%F(this%Pscalar%n)
    else
        TSplinedInitialPower_ScalarPower = this%Pscalar%Value(k)
    end if

    end function TSplinedInitialPower_ScalarPower

    function TSplinedInitialPower_TensorPower(this, k)
    class(TSplinedInitialPower) :: this
    real(dl), intent(in) ::k
    real(dl) TSplinedInitialPower_TensorPower

    if (k <= this%kmin_tensor) then
        TSplinedInitialPower_TensorPower = this%Ptensor%F(1)
    elseif (k >= this%kmax_tensor) then
        TSplinedInitialPower_TensorPower = this%Ptensor%F(this%Ptensor%n)
    else
        TSplinedInitialPower_TensorPower = this%Ptensor%Value(k)
    end if

    end function TSplinedInitialPower_TensorPower

    function TSplinedInitialPower_PythonClass()
    character(LEN=:), allocatable :: TSplinedInitialPower_PythonClass

    TSplinedInitialPower_PythonClass = 'SplinedInitialPower'

    end function TSplinedInitialPower_PythonClass

    subroutine TSplinedInitialPower_SetScalarTable(this, n, k, PK)
    class(TSplinedInitialPower) :: this
    integer, intent(in) :: n
    real(dl), intent(in) :: k(n), PK(n)

    if (allocated(this%Pscalar)) deallocate(this%Pscalar)
    if (n>0) then
        allocate(TCubicSpline::this%Pscalar)
        select type (Sp => this%Pscalar)
        class is (TCubicSpline)
            call Sp%Init(k,PK)
        end select
        this%kmin_scalar = k(1)
        this%kmax_scalar = k(n)
    end if

    end subroutine TSplinedInitialPower_SetScalarTable


    subroutine TSplinedInitialPower_SetTensorTable(this, n, k, PK)
    class(TSplinedInitialPower) :: this
    integer, intent(in) :: n
    real(dl), intent(in) :: k(n), PK(n)

    if (allocated(this%PTensor)) deallocate(this%PTensor)
    if (n>0) then
        allocate(TCubicSpline::this%PTensor)
        select type (Sp => this%PTensor)
        class is (TCubicSpline)
            call Sp%Init(k,PK)
        end select
        this%kmin_tensor = k(1)
        this%kmax_tensor = k(n)
    end if

    end subroutine TSplinedInitialPower_SetTensorTable

    subroutine TSplinedInitialPower_SetScalarLogRegular(this, kmin, kmax, n, PK)
    class(TSplinedInitialPower) :: this
    integer, intent(in) :: n
    real(dl), intent(in) ::kmin, kmax, PK(n)

    if (allocated(this%Pscalar)) deallocate(this%Pscalar)
    if (n>0) then
        allocate(TLogRegularCubicSpline::this%Pscalar)
        select type (Sp => this%Pscalar)
        class is (TLogRegularCubicSpline)
            call Sp%Init(kmin, kmax, n, PK)
        end select
        this%kmin_scalar = kmin
        this%kmax_scalar = kmax
    end if

    end subroutine TSplinedInitialPower_SetScalarLogRegular


    subroutine TSplinedInitialPower_SetTensorLogRegular(this, kmin, kmax, n, PK)
    class(TSplinedInitialPower) :: this
    integer, intent(in) :: n
    real(dl), intent(in) ::kmin, kmax, PK(n)

    if (allocated(this%Ptensor)) deallocate(this%Ptensor)
    if (n>0) then
        allocate(TLogRegularCubicSpline::this%Ptensor)
        select type (Sp => this%Ptensor)
        class is (TLogRegularCubicSpline)
            call Sp%Init(kmin, kmax, n, PK)
        end select
        this%kmin_tensor = kmin
        this%kmax_tensor = kmax
    end if

    end subroutine TSplinedInitialPower_SetTensorLogRegular

    function TSplinedInitialPower_Effective_ns(this)
    use config
    class(TSplinedInitialPower) :: this
    real(dl) :: TSplinedInitialPower_Effective_ns

    if (this%effective_ns_for_nonlinear==-1._dl) then
        call GlobalError('TSplinedInitialPower: effective_ns_for_nonlinear not set',error_inital_power)
    else
        TSplinedInitialPower_Effective_ns = this%effective_ns_for_nonlinear
    end if
    end function TSplinedInitialPower_Effective_ns



    end module InitialPower

    module IniTests
    use IniObjects
    use StringUtils
    use FileUtils
    use FileTests
    implicit none
    character(LEN=0), target :: Empty_String = ''

    contains

    function RunIniTests() result (fails)
    integer fails
    fails = 0

    call test_readini(fails)
    call test_Read_env(fails)

    end function RunIniTests

    subroutine test_readini(fails)
    integer fails
    Type(TIniFile) :: Ini
    character (LEN=200), dimension(2) :: Lines
    real x
    double precision y
    Type(TTextFile) T

    call T%CreateFile(temp_file)
    Lines(1) = 'parameter = ../tester'
    Lines(2) = 'x = 3.04'
    call T%Write(Lines(1))
    call T%Write(Lines(2))
    call T%Close()
    print *, 'Wrote ini OK'
    call Ini%Open(temp_file)
    print *, 'Read ini OK'
    call File%Delete(temp_file)
    if (Ini%Read_String('parameter')/='../tester') then
        print *, 'error reading '//trim(Lines(1))
        fails = fails + 1
    else
        print *, 'Ini OK read'
    end if
    if (Ini%Read_String('parameter', NotFoundFail=.true.) /='../tester') then
        print *, 'error reading '//trim(Lines(1))
        fails = fails + 1
    end if
    call Ini%Read('x', x)
    call Ini%Read('x', y)
    if (x/=3.04 .or. y/=3.04d0) then
        print *, 'Ini error reading real'
        fails = fails + 1
    else
        print *, 'Ini OK read real'
    end if
    call Ini%Close()
    call Ini%Open_FromLines(Lines,2)
    if (Ini%Read_String('parameter')/='../tester') then
        print *, 'error reading lines '//trim(Lines(1))
        fails = fails + 1
    else
        print *, 'Ini OK read lines'
    end if

    call Ini%close()

    end subroutine test_readini

    subroutine test_read_env(fails)
    integer fails
    Type(TIniFile) :: Ini
    character(LEN=:), allocatable :: S
    character (LEN=200), dimension(1) :: Lines

    Lines(1) = 'parameter = test$(PATH)/mypath$(PATH)'

    call Ini%Open_FromLines(Lines,1)
    S = Ini%Read_String('parameter')
    if (S /= 'test'//GetEnvironmentVariable('PATH')//'/mypath'//GetEnvironmentVariable('PATH')) then
        fails = fails + 1
        print *, 'error'
    else
        print *, 'OK Ini path'
    end if

    end subroutine test_read_env

    end module IniTests

    !Recombination module for CAMB, using RECFAST

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !C Integrator for Cosmic Recombination of Hydrogen and Helium,
    !C developed by Douglas Scott (dscott@astro.ubc.ca)
    !C based on calculations in the paper Seager, Sasselov & Scott
    !C (ApJ, 523, L1, 1999).
    !and "fudge" updates in Wong, Moss & Scott (2008).
    !C
    !C Permission to use, copy, modify and distribute without fee or royalty at
    !C any tier, this software and its documentation, for any purpose and without
    !C fee or royalty is hereby granted, provided that you agree to comply with
    !C the following copyright notice and statements, including the disclaimer,
    !C and that the same appear on ALL copies of the software and documentation,
    !C including modifications that you make for internal use or for distribution:
    !C
    !C Copyright 1999-2010 by University of British Columbia.  All rights reserved.
    !C
    !C THIS SOFTWARE IS PROVIDED "AS IS", AND U.B.C. MAKES NO
    !C REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
    !C BY WAY OF EXAMPLE, BUT NOT LIMITATION,
    !c U.B.C. MAKES NO REPRESENTATIONS OR WARRANTIES OF
    !C MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT
    !C THE USE OF THE LICENSED SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE
    !C ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.
    !C
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !
    !CN     Name:        RECFAST
    !CV     Version: 1.5.2
    !C
    !CP     Purpose:  Calculate ionised fraction as a function of redshift.
    !CP            Solves for H and He simultaneously, and includes
    !CP           H "fudge factor" for low z effect, as well as
    !CP           HeI fudge factor.
    !C
    !CD     Description: Solves for ionisation history since recombination
    !CD     using the equations in Seager, Sasselov & Scott (ApJ, 1999).
    !CD     The Cosmological model can be flat or open.
    !CD  The matter temperature is also followed, with an update from
    !CD  Scott & Scott (2009).
    !CD  The values for \alpha_B for H are from Hummer (1994).
    !CD  The singlet HeI coefficient is a fit from the full code.
    !CD  Additional He "fudge factors" are as described in Wong, Moss
    !CD  and Scott (2008).
    !CD  Extra fitting function included (in optical depth) to account
    !CD  for extra H physics described in Rubino-Martin et al. (2010).
    !CD  Care is taken to use the most accurate constants.
    !C
    !CA     Arguments:
    !CA     Name, Description
    !CA     real(dl) throughout
    !CA
    !CA     z is redshift - W is sqrt(1+z), like conformal time
    !CA     x is total ionised fraction, relative to H
    !CA     x_H is ionized fraction of H - y(1) in R-K routine
    !CA     x_He is ionized fraction of He - y(2) in R-K routine
    !CA       (note that x_He=n_He+/n_He here and not n_He+/n_H)
    !CA     Tmat is matter temperature - y(3) in R-K routine
    !CA     f's are the derivatives of the Y's
    !CA     alphaB is case B recombination rate
    !CA     alpHe is the singlet only HeII recombination rate
    !CA     a_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
    !CA     b_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
    !CA     c_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
    !CA     d_PPB is Pequignot, Petitjean & Boisson fitting parameter for Hydrogen
    !CA     a_VF is Verner and Ferland type fitting parameter for Helium
    !CA     b_VF is Verner and Ferland type fitting parameter for Helium
    !CA     T_0 is Verner and Ferland type fitting parameter for Helium
    !CA     T_1 is Verner and Ferland type fitting parameter for Helium
    !CA     Tnow is the observed CMB temperature today
    !CA     Yp is the primordial helium abundace
    !CA     fHe is He/H number ratio = Yp/4(1-Yp)
    !CA     Trad and Tmat are radiation and matter temperatures
    !CA     epsilon is the approximate difference (=Trad-Tmat) at high z
    !CA     OmegaB is Omega in baryons today
    !CA     H is Hubble constant in units of 100 km/s/Mpc
    !CA     HO is Hubble constant in SI units
    !CA     bigH is 100 km/s/Mpc in SI units
    !CA     Hz is the value of H at the specific z (in ION)
    !CA     G is grvitational constant
    !CA     n is number density of hydrogen
    !CA     Nnow is number density today
    !CA     x0 is initial ionized fraction
    !CA     x_H0 is initial ionized fraction of Hydrogen
    !CA     x_He0 is initial ionized fraction of Helium
    !CA     rhs is dummy for calculating x0
    !CA     zinitial and zfinal are starting and ending redshifts
    !CA     zeq is the redshift of matter-radiation equality
    !CA     zstart and zend are for each pass to the integrator
    !CA     C,k_B,h_P: speed of light, Boltzmann's and Planck's constants
    !CA     m_e,m_H: electron mass and mass of H atom in SI
    !CA     not4: ratio of 4He atomic mass to 1H atomic mass
    !CA     sigma: Thomson cross-section
    !CA     a_rad: radiation constant for u=aT^4
    !CA     Lambda: 2s-1s two photon rate for Hydrogen
    !CA     Lambda_He: 2s-1s two photon rate for Helium
    !CA     DeltaB: energy of first excited state from continuum = 3.4eV
    !CA     DeltaB_He: energy of first excited state from cont. for He = 3.4eV
    !CA     L_H_ion: level for H ionization in m^-1
    !CA     L_H_alpha: level for H Ly alpha in m^-1
    !CA     L_He1_ion: level for HeI ionization
    !CA     L_He2_ion: level for HeII ionization
    !CA     L_He_2s: level for HeI 2s
    !CA     L_He_2p: level for HeI 2p (21P1-11S0) in m^-1
    !CA     Lalpha: Ly alpha wavelength in SI
    !CA     Lalpha_He: Helium I 2p-1s wavelength in SI
    !CA     mu_H,mu_T: mass per H atom and mass per particle
    !CA     H_frac: follow Tmat when t_Compton / t_Hubble > H_frac
    !CA     CDB=DeltaB/k_B                     Constants derived from B1,B2,R
    !CA     CDB_He=DeltaB_He/k_B  n=2-infinity for He in Kelvin
    !CA     CB1=CDB*4.         Lalpha and sigma_Th, calculated
    !CA     CB1_He1: CB1 for HeI ionization potential
    !CA     CB1_He2: CB1 for HeII ionization potential
    !CA     CR=2*Pi*(m_e/h_P)*(k_B/h_P)  once and passed in a common block
    !CA     CK=Lalpha**3/(8.*Pi)
    !CA     CK_He=Lalpha_He**3/(8.*Pi)
    !CA     CL=C*h_P/(k_B*Lalpha)
    !CA     CL_He=C*h_P/(k_B*Lalpha_He)
    !CA     CT=(8./3.)*(sigma/(m_e*C))*a
    !CA     Bfact=exp((E_2p-E_2s)/kT)    Extra Boltzmann factor
    !CA b_He= "fudge factor" for HeI, to approximate higher z behaviour
    !CA Heswitch=integer for modifying HeI recombination
    !CA Parameters and quantities to describe the extra triplet states
    !CA  and also the continuum opacity of H, with a fitting function
    !CA  suggested by KIV, astro-ph/0703438
    !CA a_trip: used to fit HeI triplet recombination rate
    !CA b_trip: used to fit HeI triplet recombination rate
    !CA L_He_2Pt: level for 23P012-11S0 in m^-1
    !CA L_He_2St: level for 23S1-11S0 in m^-1
    !CA L_He2St_ion: level for 23S1-continuum in m^-1
    !CA A2P_s: Einstein A coefficient for He 21P1-11S0
    !CA A2P_t: Einstein A coefficient for He 23P1-11S0
    !CA sigma_He_2Ps: H ionization x-section at HeI 21P1-11S0 freq. in m^2
    !CA sigma_He_2Pt: H ionization x-section at HeI 23P1-11S0 freq. in m^2
    !CA CL_PSt = h_P*C*(L_He_2Pt - L_He_2st)/k_B
    !CA CfHe_t: triplet statistical correction
    !CA Hswitch is an boolean for modifying the H recombination
    !CA AGauss1 is the amplitude of the 1st Gaussian for the H fudging
    !CA AGauss2 is the amplitude of the 2nd Gaussian for the H fudging
    !CA zGauss1 is the ln(1+z) central value of the 1st Gaussian
    !CA zGauss2 is the ln(1+z) central value of the 2nd Gaussian
    !CA wGauss1 is the width of the 1st Gaussian
    !CA wGauss2 is the width of the 2nd Gaussian


    !CA     tol: tolerance for the integrator
    !CA     cw(24),w(3,9): work space for DVERK
    !CA     Ndim: number of d.e.'s to solve (integer)
    !CA     Nz: number of output redshitf (integer)
    !CA     I: loop index (integer)
    !CA     ind,nw: work-space for DVERK (integer)
    !C
    !CF     File & device access:
    !CF     Unit /I,IO,O  /Name (if known)
    !C
    !CM     Modules called:
    !CM     DVERK (numerical integrator)
    !CM     GET_INIT (initial values for ionization fractions)
    !CM     ION (ionization and Temp derivatives)
    !C
    !CC     Comments:
    !CC     none
    !C
    !CH     History:
    !CH     CREATED            (simplest version) 19th March 1989
    !CH     RECREATED    11th January 1995
    !CH               includes variable Cosmology
    !CH               uses DVERK integrator
    !CH               initial conditions are Saha
    !CH     TESTED              a bunch, well, OK, not really
    !CH     MODIFIED     January 1995 (include Hummer's 1994 alpha table)
    !CH               January 1995 (include new value for 2s-1s rate)
    !CH               January 1995 (expand comments)
    !CH               March 1995 (add Saha for Helium)
    !CH               August 1997 (add HeII alpha table)
    !CH               July 1998 (include OmegaT correction and H fudge factor)
    !CH               Nov 1998 (change Trad to Tmat in Rup)
    !CH               Jan 1999 (tidied up for public consumption)
    !CH               Sept 1999 (switch to formula for alpha's, fix glitch)
    !CH                  Sept 1999 modified to CMBFAST by US & MZ
    !CH                     Nov 1999 modified for F90 and CAMB (AML)
    !CH                     Aug 2000 modified to prevent overflow erorr in He_Boltz (AML)
    !CH                     Feb 2001 corrected fix of Aug 2000 (AML)
    !CH                     Oct 2001 fixed error in hubble parameter, now uses global function (AML)
    !                       March 2003 fixed bugs reported by savita gahlaut
    !                       March 2005 added option for corrections from astro-ph/0501672.
    !                                  thanks to V.K.Dubrovich, S.I.Grachev
    !                       June 2006 defined RECFAST_fudge as free parameter (AML)
    !                       October 2006 (included new value for G)
    !                       October 2006 (improved m_He/m_H to be "not4")
    !                       October 2006 (fixed error, x for x_H in part of f(1))
    !CH              January 2008 (improved HeI recombination effects,
    !CH                       including HeI rec. fudge factor)
    !                Feb 2008   Recfast 1.4 changes above added (AML)
    !                           removed Dubrovich option (wrong anyway)
    !CH              Sept 2008 (added extra term to make transition, smoother for Tmat evolution)
    !                Sept 2008 Recfast 1.4.2 changes above added (AML)
    !                          General recombination module structure, fix to make He x_e smooth also in recfast (AML)
    !CH      Jan 2010 (added fitting function to modify K
    !CH              to match x_e(z) for new H physics)
    !AL             June 2012 updated fudge parameters to match HyRec and CosmoRec (AML)
    !AL             Sept 2012 changes now in public recfast, version number changed to match Recfast 1.5.2.



    module Recombination
    use constants
    use classes
    use DarkAge21cm
    use MathUtils
    use results
    use MpiUtils, only : MpiStop
    implicit none
    private

    real(dl), parameter ::  zinitial = 1e4_dl !highest redshift
    real(dl), parameter ::  zfinal=0._dl
    integer,  parameter :: Nz=10000
    real(dl), parameter :: delta_z = (zinitial-zfinal)/Nz

    integer, parameter ::  RECFAST_Heswitch_default = 6
    real(dl), parameter :: RECFAST_fudge_He_default = 0.86_dl !Helium fudge parameter
    logical, parameter  :: RECFAST_Hswitch_default = .true. !include H corrections (v1.5, 2010)
    real(dl), parameter :: RECFAST_fudge_default = 1.14_dl !1.14_dl
    real(dl), parameter :: RECFAST_fudge_default2 = 1.105d0 + 0.02d0

    Type RecombinationData
        real(dl) :: Recombination_saha_z !Redshift at which saha OK
        real(dl), private :: NNow, fHe
        real(dl), private :: zrec(Nz),xrec(Nz),dxrec(Nz), Tsrec(Nz) ,dTsrec(Nz), tmrec(Nz),dtmrec(Nz)
        real(dl), private :: DeltaB,DeltaB_He,Lalpha,mu_H,mu_T

        real(dl), private :: HO, Tnow, fu
        integer, private :: n_eq = 3
        logical :: doTspin = .false.

        !The following only used for approximations where small effect
        real(dl) :: OmegaK, OmegaT, z_eq
        class(CAMBdata), pointer :: State
    end Type RecombinationData

    type, extends(TRecombinationModel) :: TRecfast
        real(dl) :: RECFAST_fudge  = RECFAST_fudge_default2
        real(dl) :: RECFAST_fudge_He = RECFAST_fudge_He_default
        integer  :: RECFAST_Heswitch = RECFAST_Heswitch_default
        logical  :: RECFAST_Hswitch = RECFAST_Hswitch_default
        !0) no change from old Recfast'
        !1) full expression for escape probability for singlet'
        !'   1P-1S transition'
        !2) also including effect of contiuum opacity of H on HeI'
        !'   singlet (based in fitting formula suggested by'
        !'   Kholupenko, Ivanchik & Varshalovich, 2007)'
        !3) only including recombination through the triplets'
        !4) including 3 and the effect of the contiuum '
        !'   (although this is probably negligible)'
        !5) including only 1, 2 and 3'
        !6) including all of 1 to 4'

        !fudge parameter if RECFAST_Hswitch
        !Gaussian fits for extra H physics (fit by Adam Moss , modified by Antony Lewis)
        real(dl) :: AGauss1 =      -0.14D0  !Amplitude of 1st Gaussian
        real(dl) :: AGauss2 =       0.079D0 ! 0.05D0  !Amplitude of 2nd Gaussian
        real(dl) :: zGauss1 =       7.28D0  !ln(1+z) of 1st Gaussian
        real(dl) :: zGauss2=        6.73D0  !ln(1+z) of 2nd Gaussian
        real(dl) :: wGauss1=        0.18D0  !Width of 1st Gaussian
        real(dl) :: wGauss2=        0.33D0  !Width of 2nd Gaussian
        Type(RecombinationData), allocatable :: Calc
    contains
    procedure :: ReadParams => TRecfast_ReadParams
    procedure :: Validate => TRecfast_Validate
    procedure :: Init => TRecfast_init
    procedure :: x_e => TRecfast_xe
    procedure :: xe_Tm => TRecfast_xe_Tm !ionization fraction and baryon temperature
    procedure :: T_m => TRecfast_tm !baryon temperature
    procedure :: T_s => TRecfast_ts !Spin temperature
    procedure :: Version => TRecfast_version
    procedure :: dDeltaxe_dtau => TRecfast_dDeltaxe_dtau
    procedure :: get_Saha_z => TRecfast_Get_Saha_z
    procedure, nopass :: SelfPointer => TRecfast_SelfPointer

    end type TRecfast

    character(LEN=*), parameter :: Recfast_Version = 'Recfast_1.5.2'

    logical, parameter :: evolve_Ts = .false. !local equilibrium is very accurate
    real(dl), parameter :: Do21cm_minev = 1/(1+400.) !at which to evolve T_s

    real(dl), parameter :: bigH=100.0D3/Mpc !Ho in s-1
    real(dl), parameter :: sigma = sigma_thomson
    real(dl), parameter :: not4  = mass_ratio_He_H    !mass He/H atom

    real(dl), parameter :: B01 = 3*B10
    !Fundamental constants in SI units
    !      ("not4" pointed out by Gary Steigman)

    real(dl), parameter ::  Lambda = 8.2245809d0
    real(dl), parameter :: Lambda_He = 51.3d0    !new value from Dalgarno
    real(dl), parameter :: L_H_ion   = 1.096787737D7 !level for H ion. (in m^-1)
    real(dl), parameter :: L_H_alpha = 8.225916453D6 !averaged over 2 levels
    real(dl), parameter :: L_He1_ion = 1.98310772D7  !from Drake (1993)
    real(dl), parameter :: L_He2_ion = 4.389088863D7 !from JPhysChemRefData (1987)
    real(dl), parameter :: L_He_2s   = 1.66277434D7  !from Drake (1993)
    real(dl), parameter :: L_He_2p   = 1.71134891D7  !from Drake (1993)
    !   2 photon rates and atomic levels in SI units

    real(dl), parameter :: A2P_s     = 1.798287D9    !Morton, Wu & Drake (2006)
    real(dl), parameter :: A2P_t     = 177.58D0      !Lach & Pachuski (2001)
    real(dl), parameter :: L_He_2Pt  = 1.690871466D7 !Drake & Morton (2007)
    real(dl), parameter :: L_He_2St  = 1.5985597526D7 !Drake & Morton (2007)
    real(dl), parameter :: L_He2St_ion  =3.8454693845D6 !Drake & Morton (2007)
    real(dl), parameter :: sigma_He_2Ps  = 1.436289D-22  !Hummer & Storey (1998)
    real(dl), parameter :: sigma_He_2Pt  = 1.484872D-22  !Hummer & Storey (1998)
    !    Atomic data for HeI

    !       Set up some constants so they don't have to be calculated later
    real(dl), parameter :: Lalpha = 1.d0/L_H_alpha
    real(dl), parameter :: Lalpha_He = 1.d0/L_He_2p
    real(dl), parameter :: DeltaB = h_P*C*(L_H_ion-L_H_alpha)
    real(dl), parameter :: CDB = DeltaB/k_B
    real(dl), parameter :: DeltaB_He = h_P*C*(L_He1_ion-L_He_2s)   !2s, not 2p
    real(dl), parameter :: CDB_He = DeltaB_He/k_B
    real(dl), parameter :: CB1 = h_P*C*L_H_ion/k_B
    real(dl), parameter :: CB1_He1 = h_P*C*L_He1_ion/k_B   !ionization for HeI
    real(dl), parameter :: CB1_He2 = h_P*C*L_He2_ion/k_B   !ionization for HeII
    real(dl), parameter :: CR = const_twopi*(m_e/h_P)*(k_B/h_P)
    real(dl), parameter :: CK = Lalpha**3/(const_eightpi)
    real(dl), parameter :: CK_He = Lalpha_He**3/(const_eightpi)
    real(dl), parameter :: CL = C*h_P/(k_B*Lalpha)
    real(dl), parameter :: CL_He = C*h_P/(k_B/L_He_2s) !comes from det.bal. of 2s-1s
    real(dl), parameter :: CT = Compton_CT / MPC_in_sec

    real(dl), parameter :: Bfact = h_P*C*(L_He_2p-L_He_2s)/k_B

    !       Matter departs from radiation when t(Th) > H_frac * t(H)
    !       choose some safely small number
    real(dl), parameter :: H_frac = 1D-3

    procedure(obj_function), private :: dtauda

    public TRecfast,  CB1

    contains

    subroutine TRecfast_ReadParams(this, Ini)
    use IniObjects
    class(TRecfast) :: this
    class(TIniFile), intent(in) :: Ini

    this%RECFAST_fudge_He = Ini%Read_Double('RECFAST_fudge_He', RECFAST_fudge_He_default)
    this%RECFAST_Heswitch = Ini%Read_Int('RECFAST_Heswitch', RECFAST_Heswitch_default)
    this%RECFAST_Hswitch = Ini%Read_Logical('RECFAST_Hswitch', RECFAST_Hswitch_default)
    this%RECFAST_fudge = Ini%Read_Double('RECFAST_fudge', RECFAST_fudge_default)
    call Ini%Read('AGauss1',this%AGauss1)
    call Ini%Read('AGauss2',this%AGauss2)
    call Ini%Read('zGauss1',this%zGauss1)
    call Ini%Read('zGauss2',this%zGauss2)
    call Ini%Read('wGauss1',this%wGauss1)
    call Ini%Read('wGauss2',this%wGauss2)
    if (this%RECFAST_Hswitch) then
        this%RECFAST_fudge = this%RECFAST_fudge - (RECFAST_fudge_default - RECFAST_fudge_default2)
    end if
    end subroutine TRecfast_ReadParams

    subroutine TRecfast_Validate(this, OK)
    class(TRecfast),intent(in) :: this
    logical, intent(inout) :: OK

    if (this%RECFAST_Heswitch<0 .or. this%RECFAST_Heswitch > 6) then
        OK = .false.
        write(*,*) 'RECFAST_Heswitch unknown'
    end if

    end subroutine TRecfast_Validate


    function TRecfast_tm(this,a)
    class(TRecfast) :: this
    real(dl), intent(in) :: a
    real(dl) zst,z,az,bz,TRecfast_tm
    integer ilo,ihi

    z=1/a-1
    associate( Calc => this%Calc)
        if (z >= Calc%zrec(1)) then
            TRecfast_tm=Calc%Tnow/a
        else
            if (z <=Calc%zrec(nz)) then
                TRecfast_tm=Calc%Tmrec(nz)
            else
                zst=(zinitial-z)/delta_z
                ihi= int(zst)
                ilo = ihi+1
                az=zst - ihi
                bz=1-az
                TRecfast_tm=az*Calc%Tmrec(ilo)+bz*Calc%Tmrec(ihi)+ &
                    ((az**3-az)*Calc%dTmrec(ilo)+(bz**3-bz)*Calc%dTmrec(ihi))/6._dl
            endif
        endif
    end associate

    end function TRecfast_tm


    function TRecfast_ts(this,a)
    class(TRecfast) :: this
    !zrec(1) is zinitial-delta_z
    real(dl), intent(in) :: a
    real(dl) zst,z,az,bz,TRecfast_ts
    integer ilo,ihi

    z=1/a-1
    associate(Calc => this%Calc)
        if (z.ge.Calc%zrec(1)) then
            TRecfast_ts=Calc%tsrec(1)
        else
            if (z.le.Calc%zrec(nz)) then
                TRecfast_ts=Calc%tsrec(nz)
            else
                zst=(zinitial-z)/delta_z
                ihi= int(zst)
                ilo = ihi+1
                az=zst - ihi
                bz=1-az

                TRecfast_ts=az*Calc%tsrec(ilo)+bz*Calc%tsrec(ihi)+ &
                    ((az**3-az)*Calc%dtsrec(ilo)+(bz**3-bz)*Calc%dtsrec(ihi))/6._dl
            endif
        endif
    end associate
    end function TRecfast_ts

    function TRecfast_xe(this,a)
    class(TRecfast) :: this
    real(dl), intent(in) :: a
    real(dl) zst,z,az,bz,TRecfast_xe
    integer ilo,ihi

    z=1/a-1
    associate(Calc => this%Calc)
        if (z.ge.Calc%zrec(1)) then
            TRecfast_xe=Calc%xrec(1)
        else
            if (z.le.Calc%zrec(nz)) then
                TRecfast_xe=Calc%xrec(nz)
            else
                zst=(zinitial-z)/delta_z
                ihi= int(zst)
                ilo = ihi+1
                az=zst - ihi
                bz=1-az
                TRecfast_xe=az*Calc%xrec(ilo)+bz*Calc%xrec(ihi)+ &
                    ((az**3-az)*Calc%dxrec(ilo)+(bz**3-bz)*Calc%dxrec(ihi))/6._dl
            endif
        endif
    end associate
    end function TRecfast_xe

    subroutine TRecfast_xe_Tm(this,a, xe, Tm)
    class(TRecfast) :: this
    real(dl), intent(in) :: a
    real(dl), intent(out) :: xe, Tm
    real(dl) zst,z,az,bz
    integer ilo,ihi

    z=1/a-1
    associate(Calc => this%Calc)
        if (z.ge.Calc%zrec(1)) then
            xe=Calc%xrec(1)
            Tm = Calc%Tnow/a
        else
            if (z.le.Calc%zrec(nz)) then
                xe=Calc%xrec(nz)
                TM =  Calc%Tmrec(nz)
            else
                zst=(zinitial-z)/delta_z
                ihi= int(zst)
                ilo = ihi+1
                az=zst - ihi
                bz=1-az
                xe=az*Calc%xrec(ilo)+bz*Calc%xrec(ihi)+ &
                    ((az**3-az)*Calc%dxrec(ilo)+(bz**3-bz)*Calc%dxrec(ihi))/6._dl
                Tm=az*Calc%Tmrec(ilo)+bz*Calc%Tmrec(ihi)+ &
                    ((az**3-az)*Calc%dTmrec(ilo)+(bz**3-bz)*Calc%dTmrec(ihi))/6._dl

            endif
        endif
    end associate
    end subroutine TRecfast_xe_Tm

    function TRecfast_version(this) result(version)
    class(TRecfast) :: this
    character(LEN=:), allocatable :: version

    version = Recfast_Version

    end function TRecfast_version

    subroutine TRecfast_init(this,State, WantTSpin)
    use MiscUtils
    implicit none
    class(TRecfast), target :: this
    class(TCAMBdata), target :: State
    real(dl) :: Trad,Tmat,Tspin
    integer :: I
    Type(RecombinationData), pointer :: Calc
    logical, intent(in), optional :: WantTSpin
    real(dl) :: z,n,x,x0,rhs,x_H,x_He,x_H0,x_He0,H, Yp
    real(dl) :: zstart,zend,z_scale
    real(dl) :: cw(24)
    real(dl), dimension(:,:), allocatable :: w
    real(dl) :: y(4)
    real(dl) :: C10, tau_21Ts
    integer :: ind, nw
    real(dl), parameter :: tol=1.D-5                !Tolerance for R-K
    procedure(TClassDverk) :: dverk


    if (.not. allocated(this%Calc)) allocate(this%Calc)
    Calc => this%Calc

    select type(State)
    class is (CAMBdata)
        Calc%State => State
        Calc%doTspin = DefaultFalse(WantTSpin)


        !       write(*,*)'recfast version 1.0'
        !       write(*,*)'Using Hummer''s case B recombination rates for H'
        !       write(*,*)' with fudge factor = 1.14'
        !       write(*,*)'and tabulated HeII singlet recombination rates'
        !       write(*,*)

        Calc%n_eq = 3
        if (Evolve_Ts) Calc%n_eq=4
        allocate(w(Calc%n_eq,9))

        Calc%Recombination_saha_z=0.d0

        Calc%Tnow = State%CP%tcmb
        !       These are easy to inquire as input, but let's use simple values
        z = zinitial
        !       will output every 1 in z, but this is easily changed also

        H = State%CP%H0/100._dl

        !Not general, but only for approx
        Calc%OmegaT=(State%CP%omch2+State%CP%ombh2)/H**2        !total dark matter + baryons
        Calc%OmegaK=State%CP%omk       !curvature


        !       convert the Hubble constant units
        Calc%HO = H*bigH
        Yp = State%CP%Yhe

        !       sort out the helium abundance parameters
        Calc%mu_H = 1.d0/(1.d0-Yp)           !Mass per H atom
        Calc%mu_T = not4/(not4-(not4-1.d0)*Yp)   !Mass per atom
        Calc%fHe = Yp/(not4*(1.d0-Yp))       !n_He_tot / n_H_tot


        Calc%Nnow = 3._dl*bigH**2*State%CP%ombh2/(const_eightpi*G*Calc%mu_H*m_H)

        n = Calc%Nnow * (1._dl+z)**3
        Calc%z_eq = State%z_eq

        !       Fudge factor to approximate for low z out of equilibrium effect
        Calc%fu=this%RECFAST_fudge

        !       Set initial matter temperature
        y(3) = Calc%Tnow*(1._dl+z)            !Initial rad. & mat. temperature
        Tmat = y(3)
        y(4) = Tmat
        Tspin = Tmat

        call get_init(Calc,z,x_H0,x_He0,x0)

        y(1) = x_H0
        y(2) = x_He0

        !       OK that's the initial conditions, now start writing output file

        !       Set up work-space stuff for DVERK
        ind  = 1
        nw   = Calc%n_eq
        do i = 1,24
            cw(i) = 0._dl
        end do

        do i = 1,Nz
            !       calculate the start and end redshift for the interval at each z
            !       or just at each z
            zstart = zinitial  - real(i-1,dl)*delta_z
            zend   = zinitial  - real(i,dl)*delta_z

            ! Use Saha to get x_e, using the equation for x_e for ionized helium
            ! and for neutral helium.
            ! Everything ionized above z=8000.  First ionization over by z=5000.
            ! Assume He all singly ionized down to z=3500, then use He Saha until
            ! He is 99% singly ionized, and *then* switch to joint H/He recombination.

            z = zend
            z_scale = Calc%Tnow/COBE_CMBTemp * (1+z) -1

            if (z_scale > 8000._dl) then

                x_H0 = 1._dl
                x_He0 = 1._dl
                x0 = 1._dl+2._dl*Calc%fHe
                y(1) = x_H0
                y(2) = x_He0
                y(3) = Calc%Tnow*(1._dl+z)
                y(4) = y(3)

            else if(z_scale > 5000._dl)then

                x_H0 = 1._dl
                x_He0 = 1._dl
                rhs = exp( 1.5d0 * log(CR*Calc%Tnow/(1._dl+z)) &
                    - CB1_He2/(Calc%Tnow*(1._dl+z)) ) / Calc%Nnow
                rhs = rhs*1._dl            !ratio of g's is 1 for He++ <-> He+
                x0 = 0.5d0 * ( sqrt( (rhs-1._dl-Calc%fHe)**2 &
                    + 4._dl*(1._dl+2._dl*Calc%fHe)*rhs) - (rhs-1._dl-Calc%fHe) )
                y(1) = x_H0
                y(2) = x_He0
                y(3) = Calc%Tnow*(1._dl+z)
                y(4) = y(3)

            else if(z_scale > 3500._dl)then

                x_H0 = 1._dl
                x_He0 = 1._dl
                x0 = x_H0 + Calc%fHe*x_He0
                y(1) = x_H0
                y(2) = x_He0
                y(3) = Calc%Tnow*(1._dl+z)
                y(4) = y(3)

            else if(y(2) > 0.99)then

                x_H0 = 1._dl
                rhs = exp( 1.5d0 * log(CR*Calc%Tnow/(1._dl+z)) &
                    - CB1_He1/(Calc%Tnow*(1._dl+z)) ) / Calc%Nnow
                rhs = rhs*4._dl            !ratio of g's is 4 for He+ <-> He0
                x_He0 = 0.5d0 * ( sqrt( (rhs-1._dl)**2 &
                    + 4._dl*(1._dl+Calc%fHe)*rhs )- (rhs-1._dl))
                x0 = x_He0
                x_He0 = (x0 - 1._dl)/Calc%fHe
                y(1) = x_H0
                y(2) = x_He0
                y(3) = Calc%Tnow*(1._dl+z)
                y(4) = y(3)

            else if (y(1) > 0.99d0) then

                rhs = exp( 1.5d0 * log(CR*Calc%Tnow/(1._dl+z)) &
                    - CB1/(Calc%Tnow*(1._dl+z)) ) / Calc%Nnow
                x_H0 = 0.5d0 * (sqrt( rhs**2+4._dl*rhs ) - rhs )

                call DVERK(this,3,ION,zstart,y,zend,tol,ind,cw,nw,w)
                y(1) = x_H0
                x0 = y(1) + Calc%fHe*y(2)
                y(4)=y(3)
            else

                call DVERK(this,nw,ION,zstart,y,zend,tol,ind,cw,nw,w)

                x0 = y(1) + Calc%fHe*y(2)

            end if

            Trad = Calc%Tnow * (1._dl+zend)
            Tmat = y(3)
            x_H = y(1)
            x_He = y(2)
            x = x0

            Calc%zrec(i)=zend
            Calc%xrec(i)=x
            Calc%tmrec(i) = Tmat


            if (Calc%doTspin) then
                if (Evolve_Ts .and. zend< 1/Do21cm_minev-1 ) then
                    Tspin = y(4)
                else
                    C10 = Calc%Nnow * (1._dl+zend)**3*(kappa_HH_21cm(Tmat,.false.)*(1-x_H) &
                        + kappa_eH_21cm(Tmat,.false.)*x)
                    tau_21Ts = line21_const*Calc%NNow*(1+zend)*dtauda(State,1/(1+zend))/1000

                    Tspin = Trad*( C10/Trad + A10/T_21cm)/(C10/Tmat + A10/T_21cm) + &
                        tau_21Ts/2*A10*( 1/(C10*T_21cm/Tmat+A10) -  1/(C10*T_21cm/Trad+A10) )

                    y(4) = Tspin
                end if

                Calc%tsrec(i) = Tspin

            end if

            !          write (*,'(5E15.5)') zend, Trad, Tmat, Tspin, x
        end do

        call spline_def(Calc%zrec,Calc%xrec,nz,Calc%dxrec)
        call spline_def(Calc%zrec,Calc%tmrec,nz,Calc%dtmrec)
        if (Calc%doTspin) then
            call spline_def(Calc%zrec,Calc%tsrec,nz,Calc%dtsrec)
        end if
    class default
        call MpiStop('Wrong state type')
    end select

    end subroutine TRecfast_init

    !       ===============================================================
    subroutine GET_INIT(Calc,z,x_H0,x_He0,x0)

    !       Set up the initial conditions so it will work for general,
    !       but not pathological choices of zstart
    !       Initial ionization fraction using Saha for relevant species
    Type(RecombinationData) :: Calc
    real(dl) z,x0,rhs,x_H0,x_He0, z_scale

    z_scale = Calc%Tnow/COBE_CMBTemp*(z+1)-1

    if(z_scale > 8000._dl)then
        x_H0 = 1._dl
        x_He0 = 1._dl
        x0 = 1._dl+2._dl*Calc%fHe

    else if(z_scale > 3500._dl)then

        x_H0 = 1._dl
        x_He0 = 1._dl
        rhs = exp( 1.5d0 * log(CR*Calc%Tnow/(1._dl+z)) &
            - CB1_He2/(Calc%Tnow*(1._dl+z)) ) / Calc%Nnow
        rhs = rhs*1._dl    !ratio of g's is 1 for He++ <-> He+
        x0 = 0.5d0 * ( sqrt( (rhs-1._dl-Calc%fHe)**2 &
            + 4._dl*(1._dl+2._dl*Calc%fHe)*rhs) - (rhs-1._dl-Calc%fHe) )

    else if(z_scale > 2000._dl)then

        x_H0 = 1._dl
        rhs = exp( 1.5d0 * log(CR*Calc%Tnow/(1._dl+z)) &
            - CB1_He1/(Calc%Tnow*(1._dl+z)) ) / Calc%Nnow
        rhs = rhs*4._dl    !ratio of g's is 4 for He+ <-> He0
        x_He0 = 0.5d0  * ( sqrt( (rhs-1._dl)**2 + 4._dl*(1._dl+Calc%fHe)*rhs )- (rhs-1._dl))
        x0 = x_He0
        x_He0 = (x0 - 1._dl)/Calc%fHe

    else

        rhs = exp( 1.5d0 * log(CR*Calc%Tnow/(1._dl+z)) &
            - CB1/(Calc%Tnow*(1._dl+z)) ) / Calc%Nnow
        x_H0 = 0.5d0 * (sqrt( rhs**2+4._dl*rhs ) - rhs )
        x_He0 = 0._dl
        x0 = x_H0
    end if

    end subroutine GET_INIT

    subroutine ION(this,Ndim,z,Y,f)
    class(TRecfast), target :: this
    integer Ndim

    real(dl) z,x,n,n_He,Trad,Tmat,Tspin,x_H,x_He, Hz
    real(dl) y(Ndim),f(Ndim)
    real(dl) Rup,Rdown,K,K_He,Rup_He,Rdown_He,He_Boltz
    real(dl) timeTh,timeH
    real(dl) a_VF,b_VF,T_0,T_1,sq_0,sq_1,a_PPB,b_PPB,c_PPB,d_PPB
    real(dl) tauHe_s,pHe_s
    real(dl) a_trip,b_trip,Rdown_trip,Rup_trip
    real(dl) Doppler,gamma_2Ps,pb,qb,AHcon
    real(dl) tauHe_t,pHe_t,CL_PSt,CfHe_t,gamma_2Pt
    real(dl) epsilon
    integer Heflag
    real(dl) C10, dHdz, z_scale
    type(RecombinationData), pointer :: Recomb

    Recomb => this%Calc

    !       the Pequignot, Petitjean & Boisson fitting parameters for Hydrogen
    a_PPB = 4.309d0
    b_PPB = -0.6166d0
    c_PPB = 0.6703d0
    d_PPB = 0.5300d0
    !       the Verner and Ferland type fitting parameters for Helium
    !       fixed to match those in the SSS papers, and now correct
    a_VF = 10.d0**(-16.744d0)
    b_VF = 0.711d0
    T_0 = 10.d0**(0.477121d0)   !3K
    T_1 = 10.d0**(5.114d0)
    !      fitting parameters for HeI triplets
    !      (matches Hummer's table with <1% error for 10^2.8 < T/K < 10^4)

    a_trip = 10.d0**(-16.306d0)
    b_trip = 0.761D0


    x_H = y(1)
    x_He = y(2)
    x = x_H + Recomb%fHe * x_He
    Tmat = y(3)
    !        Tspin = y(4)

    n = Recomb%Nnow * (1._dl+z)**3
    n_He = Recomb%fHe * Recomb%Nnow * (1._dl+z)**3
    Trad = Recomb%Tnow * (1._dl+z)

    Hz = 1/dtauda(Recomb%State,1/(1._dl+z))*(1._dl+z)**2/MPC_in_sec


    !       Get the radiative rates using PPQ fit, identical to Hummer's table

    Rdown=1.d-19*a_PPB*(Tmat/1.d4)**b_PPB &
        /(1._dl+c_PPB*(Tmat/1.d4)**d_PPB)
    Rup = Rdown * (CR*Tmat)**(1.5d0)*exp(-CDB/Tmat)

    !       calculate He using a fit to a Verner & Ferland type formula
    sq_0 = sqrt(Tmat/T_0)
    sq_1 = sqrt(Tmat/T_1)
    !       typo here corrected by Wayne Hu and Savita Gahlaut
    Rdown_He = a_VF/(sq_0*(1.d0+sq_0)**(1.d0-b_VF))
    Rdown_He = Rdown_He/(1.d0+sq_1)**(1.d0+b_VF)
    Rup_He = Rdown_He*(CR*Tmat)**(1.5d0)*exp(-CDB_He/Tmat)
    Rup_He = 4.d0*Rup_He    !statistical weights factor for HeI
    !       Avoid overflow (pointed out by Jacques Roland)
    if((Bfact/Tmat) > 680.d0)then
        He_Boltz = exp(680.d0)
    else
        He_Boltz = exp(Bfact/Tmat)
    end if
    !   now deal with H and its fudges
    if (.not. this%RECFAST_Hswitch) then
        K = CK/Hz !Peebles coefficient K=lambda_a^3/8piH
    else
        !c  fit a double Gaussian correction function
        z_scale = this%Calc%Tnow/COBE_CMBTemp*(1+z)-1
        K = CK/Hz*(1.0d0 &
            +this%AGauss1*exp(-((log(1.0d0+z_scale)-this%zGauss1)/this%wGauss1)**2.d0) &
            +this%AGauss2*exp(-((log(1.0d0+z_scale)-this%zGauss2)/this%wGauss2)**2.d0))
    end if


    !  add the HeI part, using same T_0 and T_1 values
    Rdown_trip = a_trip/(sq_0*(1.d0+sq_0)**(1.0-b_trip))
    Rdown_trip = Rdown_trip/((1.d0+sq_1)**(1.d0+b_trip))
    Rup_trip = Rdown_trip*dexp(-h_P*C*L_He2St_ion/(k_B*Tmat))
    Rup_trip = Rup_trip*((CR*Tmat)**(1.5d0))*(4.d0/3.d0)
    !   last factor here is the statistical weight

    !       try to avoid "NaN" when x_He gets too small
    if ((x_He.lt.5.d-9) .or. (x_He.gt.0.98d0)) then
        Heflag = 0
    else
        Heflag = this%RECFAST_Heswitch
    end if
    if (Heflag.eq.0)then        !use Peebles coeff. for He
        K_He = CK_He/Hz
    else    !for Heflag>0       !use Sobolev escape probability
        tauHe_s = A2P_s*CK_He*3.d0*n_He*(1.d0-x_He)/Hz
        pHe_s = (1.d0 - dexp(-tauHe_s))/tauHe_s
        K_He = 1.d0/(A2P_s*pHe_s*3.d0*n_He*(1.d0-x_He))
        !      if (((Heflag.eq.2) .or. (Heflag.ge.5)) .and. x_H < 0.99999d0) then
        if (((Heflag.eq.2) .or. (Heflag.ge.5)) .and. x_H < 0.9999999d0) then
            !AL changed July 08 to get smoother Helium

            !   use fitting formula for continuum opacity of H
            !   first get the Doppler width parameter
            Doppler = 2.D0*k_B*Tmat/(m_H*not4*C*C)
            Doppler = C*L_He_2p*dsqrt(Doppler)
            gamma_2Ps = 3.d0*A2P_s*Recomb%fHe*(1.d0-x_He)*C*C &
                /(dsqrt(const_pi)*sigma_He_2Ps*const_eightpi*Doppler*(1.d0-x_H)) &
                /((C*L_He_2p)**2.d0)
            pb = 0.36d0  !value from KIV (2007)
            qb = this%RECFAST_fudge_He
            !   calculate AHcon, the value of A*p_(con,H) for H continuum opacity
            AHcon = A2P_s/(1.d0+pb*(gamma_2Ps**qb))
            K_He=1.d0/((A2P_s*pHe_s+AHcon)*3.d0*n_He*(1.d0-x_He))
        end if
        if (Heflag.ge.3) then     !include triplet effects
            tauHe_t = A2P_t*n_He*(1.d0-x_He)*3.d0
            tauHe_t = tauHe_t /(const_eightpi*Hz*L_He_2Pt**(3.d0))
            pHe_t = (1.d0 - dexp(-tauHe_t))/tauHe_t
            CL_PSt = h_P*C*(L_He_2Pt - L_He_2st)/k_B
            if ((Heflag.eq.3) .or. (Heflag.eq.5).or.(x_H.gt.0.99999d0)) then !Recfast 1.4.2 (?)
                !        if ((Heflag.eq.3) .or. (Heflag.eq.5) .or. x_H >= 0.9999999d0) then    !no H cont. effect
                CfHe_t = A2P_t*pHe_t*dexp(-CL_PSt/Tmat)
                CfHe_t = CfHe_t/(Rup_trip+CfHe_t)   !"C" factor for triplets
            else                  !include H cont. effect
                Doppler = 2.d0*k_B*Tmat/(m_H*not4*C*C)
                Doppler = C*L_He_2Pt*dsqrt(Doppler)
                gamma_2Pt = 3.d0*A2P_t*Recomb%fHe*(1.d0-x_He)*C*C &
                    /(dsqrt(const_pi)*sigma_He_2Pt*const_eightpi*Doppler*(1.d0-x_H)) &
                    /((C*L_He_2Pt)**2.d0)
                !   use the fitting parameters from KIV (2007) in this case
                pb = 0.66d0
                qb = 0.9d0
                AHcon = A2P_t/(1.d0+pb*gamma_2Pt**qb)/3.d0
                CfHe_t = (A2P_t*pHe_t+AHcon)*dexp(-CL_PSt/Tmat)
                CfHe_t = CfHe_t/(Rup_trip+CfHe_t)   !"C" factor for triplets
            end if
        end if
    end if


    !       Estimates of Thomson scattering time and Hubble time
    timeTh=(1._dl/(CT*Trad**4))*(1._dl+x+Recomb%fHe)/x       !Thomson time
    timeH=2./(3.*Recomb%HO*(1._dl+z)**1.5)      !Hubble time

    !       calculate the derivatives
    !       turn on H only for x_H<0.99, and use Saha derivative for 0.98<x_H<0.99
    !       (clunky, but seems to work)
    if (x_H > 0.99) then   !don't change at all
        f(1) = 0._dl
        !!        else if (x_H > 0.98_dl) then
    else if (x_H.gt.0.985d0) then     !use Saha rate for Hydrogen
        f(1) = (x*x_H*n*Rdown - Rup*(1.d0-x_H)*dexp(-CL/Tmat)) /(Hz*(1.d0+z))
        Recomb%Recombination_saha_z = z
        !AL: following commented as not used
        !   for interest, calculate the correction factor compared to Saha
        !   (without the fudge)
        !       factor=(1.d0 + K*Lambda*n*(1.d0-x_H))
        !       /(Hz*(1.d0+z)*(1.d0+K*Lambda*n*(1.d0-x)
        !       +K*Rup*n*(1.d0-x)))
    else !use full rate for H

        f(1) = ((x*x_H*n*Rdown - Rup*(1.d0-x_H)*exp(-CL/Tmat)) &
            *(1.d0 + K*Lambda*n*(1.d0-x_H))) &
            /(Hz*(1.d0+z)*(1.d0/Recomb%fu+K*Lambda*n*(1.d0-x_H)/Recomb%fu &
            +K*Rup*n*(1.d0-x_H)))

    end if

    !       turn off the He once it is small
    if (x_He < 1.e-15) then
        f(2)=0.d0
    else

        f(2) = ((x*x_He*n*Rdown_He &
            - Rup_He*(1-x_He)*exp(-CL_He/Tmat)) &
            *(1 + K_He*Lambda_He*n_He*(1.d0-x_He)*He_Boltz)) &
            /(Hz*(1+z) &
            * (1 + K_He*(Lambda_He+Rup_He)*n_He*(1.d0-x_He)*He_Boltz))

        !   Modification to HeI recombination including channel via triplets
        if (Heflag.ge.3) then
            f(2) = f(2)+ (x*x_He*n*Rdown_trip &
                - (1.d0-x_He)*3.d0*Rup_trip*dexp(-h_P*C*L_He_2st/(k_B*Tmat))) &
                *CfHe_t/(Hz*(1.d0+z))
        end if

    end if

    if (timeTh < H_frac*timeH) then
        !                f(3)=Tmat/(1._dl+z)      !Tmat follows Trad
        !   additional term to smooth transition to Tmat evolution,
        !   (suggested by Adam Moss)
        dHdz = (Recomb%HO**2/2.d0/Hz)*(4.d0*(1.d0+z)**3/(1.d0+Recomb%z_eq)*Recomb%OmegaT &
            + 3.d0*Recomb%OmegaT*(1.d0+z)**2 + 2.d0*Recomb%OmegaK*(1.d0+z) )

        epsilon = Hz*(1.d0+x+Recomb%fHe)/(CT*Trad**3*x)
        f(3) = Recomb%Tnow &
            + epsilon*((1.d0+Recomb%fHe)/(1.d0+Recomb%fHe+x))*((f(1)+Recomb%fHe*f(2))/x) &
            - epsilon* dHdz/Hz + 3.0d0*epsilon/(1.d0+z)

    else
        f(3)= CT * (Trad**4) * x / (1._dl+x+Recomb%fHe) &
            * (Tmat-Trad) / (Hz*(1._dl+z)) + 2._dl*Tmat/(1._dl+z)
    end if

    if (evolve_Ts) then

        !       follow the matter temperature once it has a chance of diverging
        if (timeTh < H_frac*timeH) then
            f(4) = Recomb%Tnow !spin follows Trad and Tmat
        else
            if (z< 1/Do21cm_minev-1) then

                Tspin = y(4)
                C10 = n*(kappa_HH_21cm(Tmat,.false.)*(1-x_H) + kappa_eH_21cm(Tmat,.false.)*x)

                f(4) = 4*Tspin/Hz/(1+z)*( (Tspin/Tmat-1._dl)*C10 + Trad/T_21cm*(Tspin/Trad-1._dl)*A10) - f(1)*Tspin/(1-x_H)
            else
                f(4)=f(3)
            end if
        end if

    end if

    end subroutine ION


    function TRecfast_dDeltaxe_dtau(this,a, Delta_xe,Delta_nH, Delta_Tm, hdot, kvb,adotoa)
    !d x_e/d tau assuming Helium all neutral and temperature perturbations negligible
    !it is not accurate for x_e of order 1
    class(TRecfast) :: this
    real(dl) TRecfast_dDeltaxe_dtau
    real(dl), intent(in):: a, Delta_xe,Delta_nH, Delta_Tm, hdot, kvb,adotoa
    real(dl) Delta_Tg
    real(dl) xedot,z,x,n,n_He,Trad,Tmat,x_H,Hz, C_r, dlnC_r
    real(dl) Rup,Rdown,K
    real(dl) a_PPB,b_PPB,c_PPB,d_PPB
    real(dl) delta_alpha, delta_beta, delta_K, clh
    real(dl) xe

    associate(Calc=>this%Calc)
        Delta_tg =Delta_Tm
        call this%xe_Tm(a, xe, Tmat)
        x_H = min(1._dl,xe)

        !       the Pequignot, Petitjean & Boisson fitting parameters for Hydrogen
        a_PPB = 4.309d0
        b_PPB = -0.6166d0
        c_PPB = 0.6703d0
        d_PPB = 0.5300d0

        z=1/a-1

        x = x_H

        n = Calc%Nnow /a**3
        n_He = Calc%fHe * n
        Trad = Calc%Tnow /a
        clh = adotoa !conformal time Hubble
        Hz = clh/a/MPC_in_sec !normal time in seconds

        !       Get the radiative rates using PPQ fit, identical to Hummer's table

        Rdown=1.d-19*a_PPB*(Tmat/1.d4)**b_PPB &
            /(1._dl+c_PPB*(Tmat/1.d4)**d_PPB)   !alpha
        Rup = Rdown * (CR*Tmat)**(1.5d0)*exp(-CDB/Tmat)

        K = CK/Hz              !Peebles coefficient K=lambda_a^3/8piH


        Rdown = Rdown*Calc%fu
        Rup = Rup*Calc%fu
        C_r =  a*(1.d0 + K*Lambda*n*(1.d0-x_H)) /( 1.d0+K*(Lambda+Rup)*n*(1.d0-x_H) )*MPC_in_sec

        xedot = -(x*x_H*n*Rdown - Rup*(1.d0-x_H)*exp(-CL/Tmat))*C_r

        delta_alpha = (b_PPB + c_PPB*(Tmat/1d4)**d_PPB*(b_PPB-d_PPB))/(1+c_PPB*(Tmat/1d4)**d_PPB)*Delta_Tg
        delta_beta = delta_alpha + (3./2 + CDB/Tmat)*delta_Tg !(Rup = beta)
        delta_K = - hdot/clh - kvb/clh/3


        dlnC_r = -Rup*K*n*( (Delta_nH+Delta_K + Delta_beta*(1+K*Lambda*n*(1-x_H)))*(1-x_H) - x_H*Delta_xe) &
            / ( 1.d0+K*(Lambda+Rup)*n*(1.d0-x_H) ) /(1.d0 + K*Lambda*n*(1.d0-x_H))

        TRecfast_dDeltaxe_dtau= xedot/x_H*(dlnC_r +Delta_alpha - Delta_xe) &
            - C_r*( (2*Delta_xe + Delta_nH)*x_H*n*Rdown + (Delta_xe - (3./2+ CB1/Tmat)*(1/x_H-1)*Delta_Tg)*Rup*exp(-CL/Tmat))
    end associate

    !Approximate form valid at late times
    !        dDeltaxe_dtau= xedot/x_H*(Delta_alpha + Delta_xe + Delta_nH)


    end function TRecfast_dDeltaxe_dtau

    real(dl) function TRecfast_Get_Saha_z(this)
    class(TRecfast) :: this
    TRecfast_Get_Saha_z =  this%Calc%recombination_saha_z
    end function


    subroutine TRecfast_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (TRecfast), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine TRecfast_SelfPointer

    end module Recombination

    module StringTests
    use StringUtils
    implicit none
    contains


    function RunStringTests() result (fails)
    integer fails
    character(LEN=:), allocatable :: S, S2
    fails = 0

    if (UpperCase('Low@er')/='LOW@ER' .or. LowerCase('1L oW@eR')/='1l ow@er') then
        print *, 'Error in uppercase/lowercase'
        fails = fails+1
    end if

    S = FormatString('Test %d for %f %s', 91, 3.04, 'result')
    if (S/='Test 91 for 3.0400 result') then
        fails = fails+1
        print *, 'Error in FormatString: ', S
    end if
    
    S2 = Join(',', S,'XP')
    if (S2 /= S//',XP') then
        fails = fails+1
        print *, 'Error in Join: ', S2
    end if
    
    if (fails==0) print *, 'OK string tests'
    

    end function

    end module

    module ListTests
    use ObjectLists
    use FileUtils
    use FileTests
    implicit none
    character(LEN=0), target :: Empty_String = ''

    contains

    function RunListTests() result (fails)
    integer fails
    fails = 0
    call test_TRealArrayList(fails)
    call test_TRealList(fails)
    call test_TStringLIst(fails)
    call test_TObjectList(fails)
    end function RunListTests

    subroutine test_TObjectList(fails)
    !This will stop if internal error
    integer fails
    Type(TObjectList) :: L
    Type(TBinaryFile) F
    double precision arr(9)
    real arr2(9)
    integer arr3(3)
    logical arr4(1)

    arr=1
    call L%Add(arr)
    arr2=2
    call L%Add(arr2)
    arr3=3
    call L%Add(arr3)
    arr4 = .true.
    call L%Add(arr4)
    call checkL()

    call F%CreateFile(temp_file)
    call L%SaveBinary(F%unit)
    call F%Close()
    call L%Clear()
    call F%Open(temp_file)
    call L%ReadBinary(F%unit)
    call F%Close()
    call F%CreateFile(temp_file)
    call L%SaveBinary(F%unit)
    call F%Close(del = .true.)
    call checkL()
    contains

    subroutine checkL()
    class(*), pointer :: PP(:)

    PP => L%ArrayItem(1)
    select type(P=> PP)
    type is (double precision)
        if (all(P==1)) then
            print *, 'OK list double'
        else
            fails = fails+1
            print *, 'Error double value'
        end if
        class default
        fails = fails+1
        print *,'Error getting double real'
    end select
    PP => L%ArrayItem(2)
    select type(P=>PP)
    type is (real)
        if (all(P==2)) then
            print *, 'OK list real'
        else
            fails = fails+1
            print *, 'Error real value'
        end if
        class default
        fails = fails+1
        print *,'Error getting list real'
    end select
    PP => L%ArrayItem(3)
    select type(P=>PP)
    type is (integer)
        if (all(P==3)) then
            print *, 'OK list int'
        else
            fails = fails+1
            print *, 'Error int value'
        end if
        class default
        fails = fails+1
        print *,'Error getting int real'
    end select
    PP=>L%ArrayItem(4)
    select type(P=>PP)
    type is (logical)
        if (all(P .eqv. .true.)) then
            print *, 'OK list logical'
        else
            fails = fails+1
            print *, 'Error logical value'
        end if
        class default
        fails = fails+1
        print *,'Error getting list logical'
    end select
    select type(P=>L%ArrayItemIndex(2,2))
    type is (real)
        if (P/=2.0) then
            fails = fails +1
            print *, 'Error with ArrayItemIndex'
        end if
        class default
        fails = fails+1
        print *, 'Error getting ArrayItemIndex'
    end select
    end subroutine checkL

    end  subroutine test_TObjectList

    subroutine test_TRealLIst(fails)
    Type(TRealList) T
    integer i, fails

    print *, 'test_TRealLIst'
    call T%Add(0.5d0)
    call T%Add(-3.d0)
    call T%Add(12.d0)
    do i=1, 40
        call T%Add(i*1.d0)
    end do
    call T%Add(-5.d0)

    call T%Sort()
    if (T%Item(1) == -5.d0 .and. T%item(3) ==0.5d0) then
        print *,'test_TRealLIst OK'
    else
        fails= fails + 1
        print *,'error'
        print *, T%AsArray()
    end if

    end subroutine

    subroutine test_TRealArrayList(fails)
    Type(TRealArrayList) T
    integer fails

    print *, 'test_TRealArrayList'
    call T%Add([0.5d0])
    call T%Add([-3.d0, 1.d0])
    if (all(T%Item(1) == [0.5d0]) .and. T%item(2,2) ==1.d0) then
        print *,'test_TRealArrayList OK'
    else
        fails= fails+1
        print *,'error'
    end if

    end subroutine test_TRealArrayList


    subroutine ReadWrite(T)
    class(TObjectList) T
    integer unit

    open (newunit=unit,file=temp_file,status='replace', form='unformatted')
    call T%SaveBinary(unit)
    close(unit)
    open (newunit=unit,file=temp_file,status='old', form='unformatted')
    call T%Clear()
    call T%ReadBinary(unit)
    close(unit, status = 'DELETE')

    end subroutine

    subroutine test_TStringLIst(fails)
    Type(TStringList) :: T
    integer i, fails

    print *, 'test_TStringLIst'
    call T%Add('here')
    call T%Add('there')
    call T%Add('alpha')
    call T%sort()

    do i=1,2
        if (T%Item(1) /= 'alpha' .or. T%Item(3) /='there') then
            print *, 'Error'
            fails = fails + 1
            call T%WriteItems()
        else
            print *, 'test_TStringLIst OK'
        end if
        if (i==2) exit
        call ReadWrite(T)
    end do
    call T%Clear()
    call T%Add('here','there')
    call T%Add('hot','alpha')
    if (T%ValueOf('here')/='there') then
        print *,'value Of error'
        fails = fails + 1
    else
        print *,'Value of OK'
    end if

    end subroutine test_TStringLIst

    end module ListTests

    module model
    use Precision
    use classes
    use SourceWindows
    use constants, only : COBE_CMBTemp, default_nnu
    use DarkEnergyInterface
    use MassiveNu
    use config
    use iso_c_binding
    implicit none

    integer, parameter :: outNone=1

    integer, parameter :: neutrino_hierarchy_normal = 1, neutrino_hierarchy_inverted = 2, neutrino_hierarchy_degenerate = 3

    integer, parameter :: Nu_int = 0, Nu_trunc=1, Nu_approx = 2, Nu_best = 3
    !For CAMBparams%MassiveNuMethod
    !Nu_int: always integrate distribution function
    !Nu_trunc: switch to expansion in velocity once non-relativistic
    !Nu_approx: approximate scheme - good for CMB, but not formally correct and no good for matter power
    !Nu_best: automatically use mixture which is fastest and most accurate

    integer, parameter :: max_Nu = 5 !Maximum number of neutrino species
    integer, parameter :: max_transfer_redshifts = 256

    type TransferParams
        logical     ::  high_precision = .false.
        logical     ::  accurate_massive_neutrinos = .false.
        real(dl)    ::  kmax = 0.9_dl        !these are acutally q values, but same as k for flat
        integer     ::  k_per_logint =0
        integer     ::  PK_num_redshifts = 1
        real(dl)    ::  PK_redshifts(max_transfer_redshifts) = 0._dl
    end type TransferParams

    type AccuracyParams
        !Parameters for checking/changing overall accuracy
        !parameters equal to 1 corresponds to ~0.1% scalar C_l accuracy (at L>600)

        real(dl) :: AccuracyBoost =1._dl
        !Decrease step sizes, etc. by this parameter. Useful for checking accuracy.
        !Can also be used to improve speed significantly if less accuracy is required.
        !or improving accuracy for extreme models.
        !Note this does not increase lSamp%l sampling or massive neutrino q-sampling


        real(dl) :: lSampleBoost=1._dl
        !Increase lSampleBoost to increase sampling in lSamp%l for Cl interpolation

        real(dl) :: lAccuracyBoost=1._dl
        !Boost number of multipoles integrated in Boltzman heirarchy

        logical   :: AccuratePolarization = .true.
        !Do you care about the accuracy of the polarization Cls?

        logical   :: AccurateBB = .false.
        !Do you care about BB accuracy (e.g. in lensing)

        !Reionization settings - used if Reion%Reionization=.true.
        logical   :: AccurateReionization = .true.
        !Do you care about pecent level accuracy on EE signal from reionization?
       
        !The following allow separate tweaking (all also affected by AccuracyBoost above)

        real(dl) :: TimeStepBoost = 1._dl !sampling timesteps

        real(dl) :: BackgroundTimeStepBoost = 1._dl !number of time steps for background thermal history interpolation

        real(dl) :: IntTolBoost = 1._dl !Tolerances for integrating differential equations

        real(dl) :: SourcekAccuracyBoost = 1._dl !Accuracy of k sampling for source time integration

        real(dl) :: IntkAccuracyBoost = 1._dl !Accuracy of k sampling for integration

        real(dl) :: TransferkBoost = 1._dl !Accuracy of k sampling for transfer functions

        real(dl) :: NonFlatIntAccuracyBoost = 1._dl !Accuracy of non-flat time integration

        real(dl) :: BessIntBoost = 1._dl !Accuracy of bessel integration truncation

        real(dl) :: LensingBoost = 1._dl !Accuracy for CMB lensing of CMB power spectra

        real(dl) :: NonlinSourceBoost = 1._dl !Steps and kmax for the non-linear correction

        real(dl) :: BesselBoost = 1._dl !accuracy of bessel pre-computation sampling

        real(dl) :: LimberBoost = 1._dl !Accuracy of Limber approximation use

        real(dl) :: SourceLimberBoost = 1._dl !Scales when to switch to Limber for source windows

        real(dl) :: KmaxBoost = 1._dl !Boost max k for source window functions

        real(dl) :: neutrino_q_boost = 1._dl !number of momenta integrated for neutrino perturbations

    end type AccuracyParams

    !For holding custom CMB source functions (use via python interface)
    Type TCustomSourceParams
        integer :: num_custom_sources = 0
        Type(C_FUNPTR) :: c_source_func = c_null_funptr
        integer, allocatable :: custom_source_ell_scales(:)
    end Type TCustomSourceParams

    !Non-linear corrections, either just P(k), or just CMB lensing/sources, or both
    integer, parameter :: NonLinear_none=0, NonLinear_Pk =1, NonLinear_Lens=2
    integer, parameter :: NonLinear_both=3

    ! Main parameters type
    type, extends (TCAMBParameters) :: CAMBparams
        logical   :: WantCls  = .true.
        logical   :: WantTransfer = .false.

        logical   :: WantScalars = .true.
        logical   :: WantTensors = .false.
        logical   :: WantVectors = .false.

        logical   :: WantDerivedParameters = .true.!calculate various derived parameters  (ThermoDerivedParams)
        logical   :: Want_cl_2D_Array = .true.
        logical   :: Want_CMB = .true.
        logical   :: Want_CMB_lensing = .true.
        logical   :: DoLensing  = .true.
        integer   :: NonLinear = NonLinear_none
        type(TransferParams) :: Transfer

        logical   :: want_zstar = .false.
        logical   :: want_zdrag = .false.     !!JH for updated BAO likelihood.

        integer   :: Min_l = 2 ! 1 or larger, usually 1 or 2
        integer   :: Max_l = 2500
        integer   :: Max_l_tensor = 600
        real(dl)  :: Max_eta_k = 5000
        real(dl)  :: Max_eta_k_tensor = 1200
        ! _tensor settings only used in initialization,
        !Max_l and Max_eta_k are set to the tensor variables if only tensors requested

        real(dl)  :: ombh2 = 0._dl !baryon density Omega_b h^2
        real(dl)  :: omch2 = 0._dl !cold dark matter density Omega_c h^2
        real(dl)  :: omk = 0._dl !Omega_K
        real(dl)  :: omnuh2 = 0._dl !massive neutino Omega_nu h^2
        real(dl)  :: H0 = 67._dl !Hubble parameter in km/s/Mpc
        real(dl)  :: TCMB = COBE_CMBTemp
        real(dl)  :: Yhe = 0.24_dl
        real(dl)  :: Num_Nu_massless = default_nnu
        integer   :: Num_Nu_massive = 0 !sum of Nu_mass_numbers below
        integer   :: Nu_mass_eigenstates = 0  !1 for degenerate masses
        logical   :: share_delta_neff = .false. !take fractional part to heat all eigenstates the same
        real(dl)  :: Nu_mass_degeneracies(max_nu)
        real(dl)  :: Nu_mass_fractions(max_nu) !The ratios of the total densities
        integer   :: Nu_mass_numbers(max_nu) !physical number per eigenstate

        class(TInitialPower), allocatable :: InitPower
        class(TRecombinationModel), allocatable :: Recomb
        class(TReionizationModel), allocatable :: Reion
        class(TDarkEnergyModel), allocatable :: DarkEnergy
        class(TNonLinearModel), allocatable :: NonLinearModel
        type(AccuracyParams)     :: Accuracy
        type(SourceTermParams)   :: SourceTerms

        real(dl), allocatable :: z_outputs(:) !Redshifts to output background outputs

        integer   :: Scalar_initial_condition = 1 !adiabatic
        !must be one of the initial_xxx values defined in GaugeInterface
        real(dl), allocatable  :: InitialConditionVector(:) !ignored unless Scalar_initial_condition == initial_vector

        integer   :: OutputNormalization = outNone
        !outNone, or C_OutputNormalization=1 if > 1

        real(dl)  :: Alens = 1._dl !Unphysical rescaling parameter of the CMB lensing power

        integer   :: MassiveNuMethod = Nu_best

        logical :: DoLateRadTruncation = .true.
        !if true, use smooth approx to radition perturbations after decoupling on
        !small scales, saving evolution of irrelevant osciallatory multipole equations

        logical :: Evolve_baryon_cs = .false.
        !if true, evolves equation for Delta_{T_m} to get cs_2 = \delta p /\delta\rho for perfect gas

        logical :: Evolve_delta_xe = .false. !Include ionization fraction perturbations

        logical :: Evolve_delta_Ts =.false. !Equilibrium result agrees to sub-percent level

        logical :: Do21cm = .false.
        logical :: transfer_21cm_cl = .false.
        logical :: Log_lvalues  = .false. !useful for smooth results at very high L
        logical :: use_cl_spline_template = .true.    
        integer :: min_l_logl_sampling = 5000 ! increase to use linear sampling for longer
    
        Type(TSourceWindowHolder), allocatable :: SourceWindows(:)

        Type(TCustomSourceParams) :: CustomSources
    contains
    procedure, nopass :: PythonClass => CAMBparams_PythonClass
    procedure, nopass :: SelfPointer => CAMBparams_SelfPointer
    procedure :: Replace => CAMBParams_Replace
    procedure :: SetNeutrinoHierarchy => CAMBparams_SetNeutrinoHierarchy
    procedure :: Validate => CAMBparams_Validate
    procedure :: PrimordialPower => CAMBparams_PrimordialPower
    procedure :: SetCustomSourcesFunc => CAMBparams_SetCustomSourcesFunc
    procedure :: N_eff => CAMBparams_N_eff
    end type CAMBparams

    contains

    function CAMBparams_PythonClass()
    character(LEN=:), allocatable :: CAMBparams_PythonClass
    CAMBparams_PythonClass = 'CAMBparams'
    end function CAMBparams_PythonClass

    subroutine CAMBparams_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (CAMBparams), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine CAMBparams_SelfPointer

    subroutine CAMBparams_Replace(this, replace_with)
    class(CAMBParams), target :: this
    Type(CAMBParams), pointer :: p
    class(TPythonInterfacedClass) :: replace_with

    select type(this)
    type is (CAMBParams)
        p => this
        select type(replace_with)
        type is (CAMBParams)
            p = replace_with
        class default
            error stop 'Wrong assignment type'
        end select
    end select
    end subroutine CAMBparams_Replace

    subroutine CAMBparams_SetNeutrinoHierarchy(this, omnuh2, omnuh2_sterile, nnu, neutrino_hierarchy, num_massive_neutrinos)
    !Set neutrino hierarchy in the approximate two-eigenstate model (treating two as exactly degenerate, and assuming non-relativistic),
    !or use degenerate mass approximation.
    !omnuh2 is the massive total neutrino density today, omnuh2_sterile is the component of that due to steriles
    use MathUtils
    use constants
    class(CAMBparams), intent(inout) :: this
    real(dl), intent(in) :: omnuh2, omnuh2_sterile, nnu
    integer, intent(in) :: neutrino_hierarchy
    integer, intent(in), optional :: num_massive_neutrinos  !for degenerate hierarchy
    real(dl) normal_frac, m3, neff_massive_standard, mnu, m1

    this%omnuh2 = omnuh2
    if (omnuh2==0) then
        this%Num_Nu_Massless = nnu
        return
    end if
    this%Nu_mass_eigenstates=0
    if (omnuh2 > omnuh2_sterile) then
        normal_frac =  (omnuh2-omnuh2_sterile)/omnuh2
        if (neutrino_hierarchy == neutrino_hierarchy_degenerate) then
            neff_massive_standard = num_massive_neutrinos*default_nnu/3
            this%Num_Nu_Massive = num_massive_neutrinos
            this%Nu_mass_eigenstates=this%Nu_mass_eigenstates+1
            if (nnu > neff_massive_standard) then
                this%Num_Nu_Massless = nnu - neff_massive_standard
            else
                this%Num_Nu_Massless = 0
                neff_massive_standard=nnu
            end if
            this%Nu_mass_numbers(this%Nu_mass_eigenstates) = num_massive_neutrinos
            this%Nu_mass_degeneracies(this%Nu_mass_eigenstates) = neff_massive_standard
            this%Nu_mass_fractions(this%Nu_mass_eigenstates) = normal_frac
        else
            !Use normal or inverted hierarchy, approximated as two eigenstates in physical regime, 1 at minimum and below
            mnu = (omnuh2 - omnuh2_sterile)*neutrino_mass_fac*(COBE_CMBTemp/this%TCMB)**3/ (default_nnu / 3) ** 0.75_dl
            if (neutrino_hierarchy == neutrino_hierarchy_normal) then
                if (mnu > mnu_min_normal + 1e-4_dl) then
                    !Two eigenstate approximation.
                    m1=Newton_Raphson2(0._dl, mnu, sum_mnu_for_m1, mnu, 1._dl)
                    this%Num_Nu_Massive = 3
                else
                    !One eigenstate
                    this%Num_Nu_Massive = 1
                end if
            else if (neutrino_hierarchy == neutrino_hierarchy_inverted) then
                if (mnu > sqrt(delta_mnu31)+sqrt(delta_mnu31+delta_mnu21) + 1e-4_dl ) then
                    !Valid case, two eigenstates
                    m1=Newton_Raphson2(sqrt(delta_mnu31)+1e-6_dl, mnu, sum_mnu_for_m1, mnu, -1._dl)
                    this%Num_Nu_Massive = 3
                else
                    !Unphysical low mass case: take one (2-degenerate) eigenstate
                    this%Num_Nu_Massive = 2
                end if
            else
                error stop 'Unknown neutrino_hierarchy setting'
            end if
            neff_massive_standard = this%Num_Nu_Massive *default_nnu/3
            if (nnu > neff_massive_standard) then
                this%Num_Nu_Massless = nnu - neff_massive_standard
            else
                this%Num_Nu_Massless = 0
                neff_massive_standard=nnu
            end if
            if (this%Num_Nu_Massive==3) then
                !two with mass m1, one with m3
                this%Nu_mass_eigenstates = 2
                this%Nu_mass_degeneracies(1) = neff_massive_standard*2/3._dl
                this%Nu_mass_degeneracies(2) = neff_massive_standard*1/3._dl
                m3 = mnu - 2*m1
                this%Nu_mass_fractions(1) = 2*m1/mnu*normal_frac
                this%Nu_mass_fractions(2) = m3/mnu*normal_frac
                this%Nu_mass_numbers(1) = 2
                this%Nu_mass_numbers(2) = 1
            else
                this%Nu_mass_degeneracies(1) = neff_massive_standard
                this%Nu_mass_numbers(1) = this%Num_Nu_Massive
                this%Nu_mass_eigenstates = 1
                this%Nu_mass_fractions(1) = normal_frac
            end if
        end if
    else
        neff_massive_standard=0
    end if
    if (omnuh2_sterile>0) then
        if (nnu<default_nnu) call MpiStop('nnu < 3.044 with massive sterile')
        this%Num_Nu_Massless = default_nnu - neff_massive_standard
        this%Num_Nu_Massive=this%Num_Nu_Massive+1
        this%Nu_mass_eigenstates=this%Nu_mass_eigenstates+1
        this%Nu_mass_numbers(this%Nu_mass_eigenstates) = 1
        this%Nu_mass_degeneracies(this%Nu_mass_eigenstates) = max(1d-6,nnu - default_nnu)
        this%Nu_mass_fractions(this%Nu_mass_eigenstates) = omnuh2_sterile/omnuh2
    end if
    end subroutine CAMBparams_SetNeutrinoHierarchy

    real(dl) function CAMBparams_N_eff(this)
    class(CAMBparams), intent(in) :: this

    CAMBparams_N_eff = this%Num_Nu_Massless+sum(this%Nu_mass_degeneracies(1:this%Nu_mass_eigenstates))

    end function CAMBparams_N_eff

    function CAMBparams_Validate(this) result(OK)
    class(CAMBparams), intent(in) :: this
    logical OK

    OK = .true.
    if (.not. this%WantTransfer .and. .not. this%WantCls) then
        OK = .false.
        write(*,*) 'There is nothing to do! Do transfer functions or Cls.'
    end if

    if (this%h0 < 20._dl.or.this%h0 > 100._dl) then
        OK = .false.
        write(*,*) '  Warning: H0 has units of km/s/Mpc. You have:', this%h0
    end if
    if (this%tcmb < 2.7d0.or.this%tcmb > 2.8d0) then
        write(*,*) '  Warning: Tcmb has units of K.  Your have:', this%tcmb
    end if

    if (this%yhe < 0.2d0.or.this%yhe > 0.8d0) then
        OK = .false.
        write(*,*) &
            '  Warning: YHe is the Helium fraction of baryons.', &
            '  Your have:', this%yhe
    end if
    if (this%Num_Nu_massive < 0) then
        OK = .false.
        write(*,*) &
            'Warning: Num_Nu_massive is strange:',this%Num_Nu_massive
    end if
    if (this%Num_Nu_massless < 0) then
        OK = .false.
        write(*,*) &
            'Warning: Num_nu_massless is strange:', this%Num_Nu_massless
    end if
    if (this%Num_Nu_massive < 1 .and. this%omnuh2 > 0.0) then
        OK = .false.
        write(*,*) &
            'Warning: You have omega_neutrino > 0, but no massive species'
    end if


    if (this%ombh2<0.0005 .or. this%omch2<0 .or. this%ombh2>0.5 .or. this%omch2>2) then
        OK = .false.
        write(*,*) 'Your matter densities are strange (may not have been set)'
    end if

    if (this%WantScalars .and. this%Max_eta_k < this%Max_l .or.  &
        this%WantTensors .and. this%Max_eta_k_tensor < this%Max_l_tensor) then
        OK = .false.
        write(*,*) 'You need Max_eta_k larger than Max_l to get good results'
    end if

    call this%Reion%Validate(OK)
    call this%Recomb%Validate(OK)

    if (this%WantTransfer) then
        if (this%transfer%PK_num_redshifts > max_transfer_redshifts .or. this%transfer%PK_num_redshifts<1) then
            OK = .false.
            write(*,*) 'Maximum ',  max_transfer_redshifts, &
                'redshifts. You have: ', this%transfer%PK_num_redshifts
        end if
        if (this%transfer%kmax < 0.01 .or. this%transfer%kmax > 50000 .or. &
            this%transfer%k_per_logint>0 .and.  this%transfer%k_per_logint <1) then
            !            OK = .false.
            write(*,*) 'Strange transfer function settings.'
        end if
    end if

    end function CAMBparams_Validate


    subroutine CAMBParams_SetCustomSourcesFunc(this, ncustomsources, c_source_func, ell_scales)
    class(CAMBParams) :: this
    integer, intent(in) :: ncustomsources
    integer, intent(in) :: ell_scales(ncustomsources)
    TYPE(C_FUNPTR), INTENT(IN) :: c_source_func

    this%CustomSources%num_custom_sources = ncustomsources
    if (allocated(this%CustomSources%custom_source_ell_scales)) deallocate(this%CustomSources%custom_source_ell_scales)
    if (ncustomsources > 0) then
        this%CustomSources%c_source_func = c_source_func
        allocate(this%CustomSources%custom_source_ell_scales(ncustomsources), source=ell_scales)
    else
        this%CustomSources%c_source_func = c_null_funptr
    end if

    end subroutine CAMBParams_SetCustomSourcesFunc

    function CAMBparams_PrimordialPower(this, k, powers, n,  i) result(err)
    class(CAMBparams) :: this
    integer, intent(in) :: i,n
    real(dl), intent(in) :: k(n)
    real(dl), intent(out) :: powers(n)
    integer err,ix

    global_error_flag = 0
    call this%InitPower%Init(this)
    if (global_error_flag==0) then
        do ix =1, n
            if (i==0) then
                powers(ix) = this%InitPower%ScalarPower(k(ix))
            elseif (i==2) then
                powers(ix) = this%InitPower%TensorPower(k(ix))
            else
                error stop 'Unknown power type index'
            end if
            if (global_error_flag /= 0) exit
        end do
    end if
    err= global_error_flag

    end function CAMBparams_PrimordialPower

    end module model

    module config
    use precision
    use constants, only: const_twopi
    implicit none

    character(LEN=*), parameter :: version = '1.5.5'

    integer :: FeedbackLevel = 0 !if >0 print out useful information about the model

    logical :: output_file_headers = .true.

    logical :: DebugMsgs =.false. !Set to true to view progress and timing

    logical, parameter :: DebugEvolution = .false. !Set to true to do all the evolution for all k

    real(dl) :: DebugParam = 0._dl !not used but read in, useful for parameter-dependent tests

    integer :: ThreadNum = 0
    !If zero assigned automatically, obviously only used if parallelised

    logical ::  do_bispectrum  = .false.
    logical, parameter :: hard_bispectrum = .false. ! e.g. warm inflation where delicate cancellations

    logical, parameter :: full_bessel_integration = .false. !(go into the tails when calculating the sources)

    real(dl), parameter ::  OutputDenominator = const_twopi
    !When using outNone the output is l(l+1)Cl/OutputDenominator

    !Computed output power spectra data

    integer, parameter :: C_Temp = 1, C_E = 2, C_Cross =3, C_Phi = 4, C_PhiTemp = 5, C_PhiE=6
    integer, parameter :: CT_Temp =1, CT_E = 2, CT_B = 3, CT_Cross=  4
    integer, parameter :: name_tag_len = 12
    character(LEN=name_tag_len), dimension(C_PhiE), parameter :: C_name_tags = ['TT','EE','TE','PP','TP','EP']
    character(LEN=name_tag_len), dimension(CT_Cross), parameter :: CT_name_tags = ['TT','EE','BB','TE']
    character(LEN=name_tag_len), dimension(7), parameter :: lens_pot_name_tags = ['TT','EE','BB','TE','PP','TP','EP']

    real(dl), parameter :: OmegaKFlat = 5e-7_dl !Value at which to use flat code

    real(dl), parameter :: tol=1.0d-4 !Base tolerance for perturbation integrations

    character(LEN=1024) :: highL_unlensed_cl_template = 'HighLExtrapTemplate_lenspotentialCls.dat'
    !fiducial high-accuracy high-L C_L used for making small cosmology-independent numerical corrections
    !to lensing and C_L interpolation. Ideally close to models of interest, but dependence is weak.
    integer, parameter :: lmax_extrap_highl = 8000
    real(dl), allocatable :: highL_CL_template(:,:)

    integer, parameter :: lensed_convolution_margin = 100
    !Number of L less than L max at which the lensed power spectrum is calculated

    integer :: global_error_flag=0

    character(LEN=1024) :: global_error_message = ''

    integer, parameter :: error_reionization=1
    integer, parameter :: error_recombination=2
    integer, parameter :: error_inital_power=3
    integer, parameter :: error_evolution=4
    integer, parameter :: error_unsupported_params=5
    integer, parameter :: error_darkenergy=6
    integer, parameter :: error_ini=7
    integer, parameter :: error_nonlinear=8

    contains

    subroutine GlobalError(message, id)
    use MiscUtils, only : PresentDefault
    character(LEN=*), intent(IN), optional :: message
    integer, intent(in), optional :: id

    global_error_message = PresentDefault('', message)
    if (present(id)) then
        if (id==0) error stop 'Error id must be non-zero'
        global_error_flag=id
    else
        global_error_flag=-1
    end if

    end subroutine GlobalError

    subroutine CheckLoadedHighLTemplate
    use FileUtils
    use MpiUtils
    integer :: L
    real(dl) :: array(7)
    type(TTextFile) :: F
    character(LEN=:), allocatable :: InLine

    if (.not. allocated(highL_CL_template)) then
        allocate(highL_CL_template(1:lmax_extrap_highl, C_Temp:C_Phi))
        highL_CL_template(1,:)=0

        do while (F%ReadNextContentLine(highL_unlensed_cl_template, InLine))
            read(InLine, *) L, array
            if (L>lmax_extrap_highl) exit
            highL_CL_template(L, C_Temp:C_E) =array(1:2)
            highL_CL_template(L, C_Cross) =array(4)
            highL_CL_template(L, C_Phi) =array(5)
        end do
        if (L< lmax_extrap_highl) &
            call MpiStop('CheckLoadedHighLTemplate: template file does not go up to lmax_extrap_highl')
    end if

    end subroutine CheckLoadedHighLTemplate

    end module config

    !---------------------------------------------------------------------------------------------------
    ! Recombination module for CAMB, using HYREC-2 (July 2020)
    ! HYREC-2 is available at https://github.com/nanoomlee/HYREC-2 
    ! Download HYREC-2 and place it in the parent directory of CAMB
    ! If the model defined in history.h of HYREC-2 is not the default one, SWIFT,
    ! then Nz should be changed (See line 21 and 22)
    !---------------------------------------------------------------------------------------------------

    module HyRec
    use precision
    use constants
    use classes
    use MathUtils
    use results
    use config
    use MpiUtils, only : MpiStop
    implicit none
    private
    
	real(dl), parameter ::  zinitial = 8e3_dl !highest redshift
    real(dl), parameter ::  zfinal=0._dl
    integer, parameter :: Nz=2248            !For SWIFT model of HYREC-2
    !integer,  parameter :: Nz=105859          !For the rest of models
    
    Type RecombinationData
        real(dl), private :: xhyrec(Nz), tmhyrec(Nz)
        real(dl), private :: Tnow
    end Type RecombinationData

    type, extends(TRecombinationModel) :: THyRec
        Type(RecombinationData), allocatable :: Calc
    contains
    procedure :: Init => THyRec_init
    procedure :: x_e => THyRec_xe
    procedure :: T_m => THyRec_tm !baryon temperature
    procedure :: xe_Tm => THyRec_xe_Tm
    procedure, nopass :: SelfPointer => THyRec_SelfPointer
    end type THyRec

    class(CAMBdata), pointer :: CurrentState

    public THyRec
    contains


    function THyRec_tm(this,a)
    class(THyRec) :: this
    real(dl), intent(in) :: a
    real(dl) THyRec_tm,hyrec_tm
	real(dl) z
    external hyrec_tm

    z=1/a-1
    associate( Calc => this%Calc)
        if (z >= 8000) then
            THyRec_tm=Calc%Tnow/a
        else
            if (z <= 0) then
                THyRec_tm=Calc%tmhyrec(nz)
            else
                THyRec_tm=hyrec_tm(a,Calc%tmhyrec)
            endif
        endif
    end associate

    end function THyRec_tm


    function THyRec_xe(this,a)
    class(THyRec) :: this
    real(dl), intent(in) :: a
    real(dl) THyRec_xe,hyrec_xe
	real(dl) z
    external hyrec_xe
    
    z=1/a-1
    associate( Calc => this%Calc)
        if (z >= zinitial) then
            THyRec_xe=Calc%xhyrec(1)
        else
            if (z <= zfinal) then
                THyRec_xe=Calc%xhyrec(nz)
            else
                THyRec_xe=hyrec_xe(a,Calc%xhyrec)
            endif
        endif
    end associate

    end function THyRec_xe

    subroutine THyRec_xe_Tm(this,a, xe, Tm)
    class(THyRec) :: this
    real(dl), intent(in) :: a
    real(dl), intent(out) :: xe, Tm
    real(dl) hyrec_xe, hyrec_tm
    real(dl) z
    external hyrec_xe, hyrec_tm

    z=1/a-1
    associate(Calc => this%Calc)
        if (z >= zinitial) then
            xe=Calc%xhyrec(1)
            Tm=Calc%Tnow/a
        else
            if (z <= zfinal) then
                xe=Calc%xhyrec(nz)
                Tm=Calc%tmhyrec(nz)
            else
                xe=hyrec_xe(a,Calc%xhyrec)
                Tm=hyrec_tm(a,Calc%tmhyrec)
            endif
        endif
    
    end associate
    end subroutine THyRec_xe_Tm


    real(dl) function THyrec_dtauda(a) BIND(C, NAME='exported_dtauda')
    real(dl), intent(in) :: a
    procedure(obj_function) :: dtauda

    THyrec_dtauda = dtauda(CurrentState,a)
    end function THyrec_dtauda

    subroutine THyRec_init(this,State, WantTSpin)
    class(THyRec), target :: this
    class(TCAMBdata), target :: State
    Type(RecombinationData), pointer :: Calc
	logical, intent(in), optional :: WantTSpin
    real(dl) OmegaB, OmegaC, OmegaN, h2
    external rec_build_history_camb

    if (DefaultFalse(WantTSpin)) call MpiStop('HyRec does not support 21cm')

    if (.not. allocated(this%Calc)) allocate(this%Calc)
    Calc => this%Calc

    select type(State)
    class is (CAMBdata)
        CurrentState => State

        if (State%CP%Evolve_delta_xe) &
            call MpiStop('HyRec currently does not support evolving Delta x_e')

        h2 = (State%CP%H0/100)**2
        OmegaB = State%CP%ombh2/h2
        OmegaC = State%CP%omch2/h2
        
        Calc%Tnow=State%CP%tcmb

        call rec_build_history_camb(OmegaC, OmegaB, &
            State%CP%H0, State%CP%tcmb, State%CP%Yhe, State%CP%N_eff(), &
            this%Calc%xhyrec, this%Calc%tmhyrec, Nz)
    end select
    end subroutine THyRec_init

    subroutine THyRec_SelfPointer(cptr,P)
    use iso_c_binding
    Type(c_ptr) :: cptr
    Type (THyRec), pointer :: PType
    class (TPythonInterfacedClass), pointer :: P

    call c_f_pointer(cptr, PType)
    P => PType

    end subroutine THyRec_SelfPointer

    end module HyRec

    module MiscUtils
    implicit none

    INTERFACE PresentDefault
    module procedure PresentDefault_S, PresentDefault_L, PresentDefault_I, PresentDefault_R, PresentDefault_D
    END INTERFACE PresentDefault

    INTERFACE IfThenElse
    module procedure IfThenElse_S, IfThenElse_L, IfThenElse_I, IfThenElse_R, IfThenElse_D
    END INTERFACE IfThenElse

    INTERFACE IsFloat
    module procedure IsFloat0, IsFloat1, IsFloat2
    END INTERFACE IsFloat

    contains

    function DefaultFalse(S) result(Sout)
    logical, intent(in), optional :: S
    logical :: Sout

    if (present(S)) then
        SOut = S
    else
        SOut = .false.
    end if

    end function DefaultFalse

    function DefaultTrue(S) result(Sout)
    logical, intent(in), optional :: S
    logical :: Sout

    if (present(S)) then
        SOut = S
    else
        SOut = .true.
    end if

    end function DefaultTrue


    function PresentDefault_S(default, S) result(Sout)
    character(LEN=*), intent(in), target :: default
    character(LEN=*), intent(in), target, optional :: S
    character(LEN=:), pointer :: Sout

    if (present(S)) then
        SOut => S
    else
        SOut => default
    end if
    end function PresentDefault_S

    function PresentDefault_L(default, S) result(Sout)
    logical, intent(in) :: default
    logical, intent(in), optional :: S
    logical :: Sout

    if (present(S)) then
        SOut = S
    else
        SOut = default
    end if
    end function PresentDefault_L

    function PresentDefault_I(default, S) result(Sout)
    integer, intent(in) :: default
    integer, intent(in), optional :: S
    integer :: Sout

    if (present(S)) then
        SOut = S
    else
        SOut = default
    end if
    end function PresentDefault_I

    function PresentDefault_R(default, S) result(Sout)
    real, intent(in) :: default
    real, intent(in), optional :: S
    real:: Sout

    if (present(S)) then
        SOut = S
    else
        SOut = default
    end if
    end function PresentDefault_R

    function PresentDefault_D(default, S) result(Sout)
    double precision, intent(in) :: default
    double precision, intent(in), optional :: S
    double precision:: Sout

    if (present(S)) then
        SOut = S
    else
        SOut = default
    end if
    end function PresentDefault_D


    function IfThenElse_S(flag, either, or) result(IfThenElse)
    logical, intent(in) :: flag
    character(LEN=:), pointer :: IfThenElse
    character(LEN=*), target :: either, or

    if (flag) then
        IfThenElse => either
    else
        IfThenElse => or
    end if

    end function

    function IfThenElse_L(flag, either, or) result(IfThenElse)
    logical, intent(in) :: flag
    logical :: IfThenElse, either, or

    if (flag) then
        IfThenElse = either
    else
        IfThenElse = or
    end if

    end function

    function IfThenElse_I(flag, either, or) result(IfThenElse)
    logical, intent(in) :: flag
    integer :: IfThenElse, either, or

    if (flag) then
        IfThenElse = either
    else
        IfThenElse = or
    end if

    end function

    function IfThenElse_R(flag, either, or) result(IfThenElse)
    logical, intent(in) :: flag
    real :: IfThenElse, either, or

    if (flag) then
        IfThenElse = either
    else
        IfThenElse = or
    end if

    end function

    function IfThenElse_D(flag, either, or) result(IfThenElse)
    logical, intent(in) :: flag
    double precision :: IfThenElse, either, or

    if (flag) then
        IfThenElse = either
    else
        IfThenElse = or
    end if

    end function

    logical function isFloat0(R)
    class(*), intent(in) :: R

    select type(R)
    type is (real)
        isFloat0 = .true.
    type is (double precision)
        isFloat0 = .true.
    class default
        isFloat0 = .false.
    end select
    end function isFloat0

    logical function isFloat1(R)
    class(*), intent(in) :: R(:)

    isFloat1 = isFloat0(R(LBOUND(R,1)))

    end function isFloat1

    logical function isFloat2(R)
    class(*), intent(in) :: R(:,:)

    isFloat2 = isFloat0(R(LBOUND(R,1),LBOUND(R,2)))

    end function isFloat2

    end module MiscUtils

    !Simple demo program to get the scalar and tensor temperature Cls, and print them out (and the sum)
    !Usually it's easier to do things like this via the python wrapper

    program tester
    use CAMB
    implicit none
    integer l
    real(dl) ratio

    type(CAMBparams) P !defined in model.f90
    type(CAMBdata) results !contains computed quantities and functions for results (results.f90)

    !Need to set default classes for initial power spectrum, recombination etc.
    call CAMB_SetDefParams(P)

    !Set one massive neutrino with mass~ 0.06eV
    call P%SetNeutrinoHierarchy(0.00064_dl, 0._dl, 3.046_dl, neutrino_hierarchy_normal)


    P%ombh2  = .0222_dl
    P%omk  = 0._dl
    P%H0      = 67._dl
    select type(InitPower=>P%InitPower)
    class is (TInitialPowerLaw)
        InitPower%As = 2.1e-9
        InitPower%ns  = 1
        InitPower%r = 1
        !we don't use r here since we generate the Cls separately
        !so set to 1, and then put in the ratio after calculating the Cls
    end select

    P%WantScalars = .true.
    P%WantTensors = .true.

    P%Max_l=2500
    P%Max_eta_k=6000
    P%Max_l_tensor=200
    P%Max_eta_k_tensor=500

    call CAMB_GetResults(results, P)

    ratio =0.1
    associate(CL_scalar => results%CLData%CL_scalar, &
        CL_tensor => results%CLData%CL_tensor)
        do l=2,P%Max_l
            !print out scalar and tensor temperature, then sum. Units are dimensionless here.
            if (l <= P%Max_l_tensor) then
                !The indices of the Cl_xxx arrays are L, Cl type
                write(*,'(1I5,3E15.5)') l, Cl_scalar(l, C_Temp), ratio*Cl_tensor(l,CT_Temp), &
                    ratio*Cl_tensor(l,C_Temp)+Cl_scalar(l,C_Temp)
            else
                write(*,'(1I5,3E15.5)') l,  Cl_scalar(l,C_Temp),0._dl,Cl_scalar(l,C_Temp)
            end if
        end do
    end associate

    end program Tester

    !Interface module for CAMB. Call CAMB_GetResults to do the work.

    module CAMB
    use Precision
    use results
    use GaugeInterface
    use InitialPower
    use Reionization
    use Recombination
    use lensing
    use DarkEnergyFluid
    implicit none
    contains

    subroutine CAMB_TransfersToPowers(CData)
    !From Delta_p_l_k or time transfers to CMB powers and transfers to P(k)
    use CAMBmain
    use lensing
    type (CAMBdata) :: CData
    logical :: want_tensors, want_vectors

    call SetActiveState(CData)
    CData%OnlyTransfer = .false.
    call CData%CP%InitPower%Init(CData%CP)
    if (global_error_flag/=0) return
    if (allocated(Cdata%CAMB_Pk)) deallocate(Cdata%CAMB_PK)

    if (CData%CP%WantCls) then
        if (allocated(CData%ScalarTimeSources) .and. CData%CP%WantScalars) then
            want_tensors = CData%CP%WantTensors
            want_vectors = CData%CP%WantVectors
            Cdata%OnlyTransfer = .true. !prevent ClTransferToCl
            Cdata%CP%WantTensors = .false.
            CData%CP%WantVectors = .false.
            call TimeSourcesToCl(CData%ClData%CTransScal)
            Cdata%CP%WantTensors = want_tensors
            CData%CP%WantVectors = want_vectors
            Cdata%OnlyTransfer = .false.
        end if
        call ClTransferToCl(CData)
        if (State%CP%DoLensing .and. global_error_flag==0) call lens_Cls(Cdata)
        if (global_error_flag/=0) return
    end if

    if (CData%CP%WantTransfer) call Transfer_Get_sigmas(Cdata, Cdata%MT)

    end subroutine CAMB_TransfersToPowers

    !Call this routine with a set of parameters to generate the results you want.
    subroutine CAMB_GetResults(OutData, Params, error, onlytransfer, onlytimesources)
    use CAMBmain
    use lensing
    use Bispectrum
    type(CAMBdata)  :: OutData
    type(CAMBparams) :: Params
    integer, optional :: error !Zero if OK
    logical, optional :: onlytransfer, onlytimesources
    type(CAMBparams) P
    logical :: call_again

    global_error_flag = 0
    call_again = .false.
    call OutData%Free()
    call SetActiveState(OutData)
    OutData%HasScalarTimeSources= DefaultFalse(onlytimesources)
    OutData%OnlyTransfer = DefaultFalse(onlytransfer) .or. OutData%HasScalarTimeSources

    !Vector and tensors first, so at end time steps in state are for scalars
    if (Params%WantCls .and. Params%WantTensors) then
        P=Params
        P%WantTransfer = .false.
        P%Transfer%high_precision = .false.
        P%WantScalars = .false.
        P%WantVectors = .false.
        call OutData%SetParams(P, call_again=call_again)
        if (global_error_flag==0) call cmbmain
        if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return
        end if
        call_again = .true.
    end if

    if (Params%WantCls .and. Params%WantVectors) then
        P=Params
        P%WantTransfer = .false.
        P%Transfer%high_precision = .false.
        P%WantScalars = .false.
        P%WantTensors = .false.
        call OutData%SetParams(P, call_again=call_again)
        if (global_error_flag==0) call cmbmain
        if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return
        end if
        call_again = .true.
    end if

    if (Params%WantCls .and. Params%WantScalars) then
        P = Params
        P%Max_eta_k=max(min(P%max_l,3000)*2.5_dl,P%Max_eta_k)
        P%WantTensors = .false.
        P%WantVectors = .false.
        if ((P%NonLinear==NonLinear_lens .or. P%NonLinear==NonLinear_both) .and. &
            (P%DoLensing .or. State%num_redshiftwindows > 0)) then
            P%WantTransfer  = .true.
        end if
        call OutData%SetParams(P)
        if (global_error_flag==0) call cmbmain
        if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return
        end if
        call_again = .true.
    end if


    if (Params%WantTransfer .and. .not. (Params%WantCls .and. Params%WantScalars)) then
        P=Params
        P%WantCls = .false.
        P%WantScalars = .false.
        P%WantTensors = .false.
        P%WantVectors = .false.
        call OutData%SetParams(P, call_again=call_again)
        if (global_error_flag==0) call cmbmain
        if (global_error_flag/=0) then
            if (present(error)) error =global_error_flag
            return
        end if
    end if
    OutData%CP%WantCls = Params%WantCls
    OutData%CP%WantScalars = Params%WantScalars
    OutData%CP%WantTensors = Params%WantTensors
    OutData%CP%WantVectors = Params%WantVectors
    OutData%CP%WantTransfer = Params%WantTransfer
    OutData%CP%Accuracy = Params%Accuracy
    OutData%CP%Reion%Reionization = Params%Reion%Reionization
    OutData%CP%Transfer%high_precision = Params%Transfer%high_precision
    OutData%CP%WantDerivedParameters = Params%WantDerivedParameters

    if (.not. OutData%OnlyTransfer .and. Params%WantCls .and. Params%WantScalars) then
        if (Params%DoLensing .and. global_error_flag==0) then
            call lens_Cls(OutData)
        end if

        if (do_bispectrum .and. global_error_flag==0) &
            call GetBispectrum(OutData,OutData%CLData%CTransScal)
    end if
    if (global_error_flag/=0 .and. present(error)) error =global_error_flag

    end subroutine CAMB_GetResults


    !Return real (NOT double precision) arrays of the computed CMB  Cls
    !Output is l(l+1)C_l/2pi
    !If GC_Conventions = .false. use E-B conventions (as the rest of CAMB does)
    !Used by WriteFits only
    subroutine CAMB_GetCls(State, Cls, lmax,GC_conventions)
    Type(CAMBdata) :: State
    integer, intent(IN) :: lmax
    logical, intent(IN) :: GC_conventions
    real, intent(OUT) :: Cls(2:lmax,1:4)
    integer l

    Cls = 0
    do l=2, lmax
        if (State%CP%WantScalars .and. l<= State%CP%Max_l) then
            if (State%CP%DoLensing) then
                if (l<=State%CLData%lmax_lensed) &
                    Cls(l,1:4) = State%CLData%Cl_lensed(l, CT_Temp:CT_Cross)
            else
                Cls(l,1:2) = State%CLData%Cl_scalar(l, C_Temp:C_E)
                Cls(l,4) = State%CLData%Cl_scalar(l, C_Cross)
            endif
        end if
        if (State%CP%WantTensors .and. l <= State%CP%Max_l_tensor) then
            Cls(l,1:4) = Cls(l,1:4) + State%CLData%Cl_tensor(l, CT_Temp:CT_Cross)
        end if
    end do
    if (GC_conventions) then
        Cls(:,2:3) = Cls(:,2:3)/2
        Cls(:,4)   = Cls(:,4)/sqrt(2.0)
    end if

    end subroutine CAMB_GetCls

    function CAMB_GetAge(P)
    !Return age in Julian gigayears, returns -1 on error
    type(CAMBparams), intent(in) :: P
    real(dl) CAMB_GetAge
    integer error
    Type(CAMBdata) :: State

    call  State%SetParams(P, error, .false., .false., .true.)

    if (error/=0) then
        CAMB_GetAge = -1
    else
        CAMB_GetAge = State%DeltaPhysicalTimeGyr(0.0_dl,1.0_dl)
    end if

    end function CAMB_GetAge

    subroutine CAMB_SetDefParams(P)
    use NonLinear
    use Recombination
    type(CAMBparams), intent(inout), target :: P
    type(CAMBparams) :: emptyP

    P= emptyP !Set default values set in type definitions
    P%Nu_mass_numbers=0
    P%Nu_mass_degeneracies=0
    P%Nu_mass_fractions=0

    allocate(THalofit::P%NonLinearModel)
    allocate(TDarkEnergyFluid::P%DarkEnergy)
    allocate(TInitialPowerLaw::P%InitPower)
    allocate(TRecfast::P%Recomb)
    allocate(TTanhReionization::P%Reion)

    end subroutine CAMB_SetDefParams

    logical function CAMB_ReadParamFile(P, InputFile, InpLen)
    Type(CAMBParams) :: P
    integer, intent(in) :: InpLen
    character(LEN=InpLen), intent(in) :: InputFile
    character(LEN=len(global_error_message)) :: ErrMsg
    Type(TIniFile) :: Ini
    logical bad

    call Ini%Open(InputFile, bad, .false.)
    ErrMsg = ''
    CAMB_ReadParamFile = CAMB_ReadParams(P, Ini, ErrMsg)
    call Ini%Close()
    if (ErrMsg/='') call GlobalError(ErrMsg,error_ini)

    end function CAMB_ReadParamFile

    logical function CAMB_ReadParams(P, Ini, ErrMsg)
    use NonLinear
    use DarkEnergyFluid
    use DarkEnergyPPF
    use Quintessence
    use results
#ifdef COSMOREC
    use CosmoRec
#endif
#ifdef HYREC
    use HyRec
#endif
    class(TIniFile) :: Ini
    Type(CAMBParams) :: P
    integer num_redshiftwindows
    logical PK_WantTransfer
    integer i, status
    real(dl) nmassive
    character(LEN=*), intent(inout) :: ErrMsg
    character(LEN=:), allocatable :: NumStr, S, DarkEneryModel, RecombinationModel
    logical :: DoCounts

    CAMB_ReadParams = .false.
    call CAMB_SetDefParams(P)

    P%WantScalars = Ini%Read_Logical('get_scalar_cls')
    P%WantVectors = Ini%Read_Logical('get_vector_cls', .false.)
    P%WantTensors = Ini%Read_Logical('get_tensor_cls', .false.)

    P%Want_CMB =  Ini%Read_Logical('want_CMB',.true.)
    P%Want_CMB_lensing =  P%Want_CMB .or. Ini%Read_Logical('want_CMB_lensing',.true.)

    if (P%WantScalars) then
        num_redshiftwindows = Ini%Read_Int('num_redshiftwindows',0)
    else
        num_redshiftwindows = 0
    end if
    call Ini%Read('limber_windows', P%SourceTerms%limber_windows)
    if (P%SourceTerms%limber_windows) call Ini%Read('limber_phiphi', P%SourceTerms%limber_phi_lmin)
    if (num_redshiftwindows > 0) then
        allocate(P%SourceWindows(num_redshiftwindows))
        P%SourceTerms%counts_lensing = Ini%Read_Logical('DoRedshiftLensing', .false.)
        call Ini%Read('Kmax_Boost', P%Accuracy%KmaxBoost)
    end if
    P%Do21cm = Ini%Read_Logical('Do21cm', .false.)
    DoCounts = .false.
    do i=1, num_redshiftwindows
        allocate(TGaussianSourceWindow::P%SourceWindows(i)%Window)
        select type (RedWin=>P%SourceWindows(i)%Window)
        class is (TGaussianSourceWindow)
            RedWin%Redshift = Ini%Read_Double_Array('redshift', i)
            S = Ini%Read_String_Array('redshift_kind', i)
            if (S == '21cm') then
                RedWin%source_type = window_21cm
            elseif (S == 'counts') then
                RedWin%source_type = window_counts
            elseif (S == 'lensing') then
                RedWin%source_type = window_lensing
            else
                ErrMsg = 'Error: unknown type of window '//trim(S)
                return
            end if
            if (RedWin%source_type /= window_21cm) then
                RedWin%sigma = Ini%Read_Double_Array('redshift_sigma', i)
            else
                P%Do21cm = .true.
                RedWin%sigma = Ini%Read_Double_Array('redshift_sigma_Mhz', i)
                if (RedWin%sigma < 0.003) then
                    write(*,*) 'WARNING:Window very narrow.'
                    write(*,*) ' --> use transfer functions and transfer_21cm_cl =T ?'
                end if
                !with 21cm widths are in Mhz, make dimensionless scale factor
                RedWin%sigma = RedWin%sigma / (f_21cm / 1e6)
                if (FeedbackLevel>0) write(*,*) i,'delta_z = ',  RedWin%sigma * (1 + RedWin%RedShift) ** 2
            end if
            if (RedWin%source_type == window_counts) then
                DoCounts = .true.
                RedWin%bias = Ini%Read_Double_Array('redshift_bias', i)
                RedWin%dlog10Ndm = Ini%Read_Double_Array('redshift_dlog10Ndm', i ,0.d0)
            end if
        class default
            call MpiStop('Probable compiler bug')
        end select
    end do


    if (P%Do21cm) then
        call Ini%Read('line_basic',P%SourceTerms%line_basic)
        call Ini%Read('line_distortions',P%SourceTerms%line_distortions)
        call Ini%Read('line_extra',P%SourceTerms%line_extra)
        call Ini%Read('line_phot_dipole',P%SourceTerms%line_phot_dipole)
        call Ini%Read('line_phot_quadrupole',P%SourceTerms%line_phot_quadrupole)
        call Ini%Read('line_reionization',P%SourceTerms%line_reionization)

        call Ini%Read('use_mK',P%SourceTerms%use_21cm_mK)
        if (DebugMsgs) then
            write (*,*) 'Doing 21cm'
            write (*,*) 'dipole = ',P%SourceTerms%line_phot_dipole, ' quadrupole =', P%SourceTerms%line_phot_quadrupole
        end if
    else
        P%SourceTerms%line_extra = .false.
    end if

    if (DoCounts) then
        call Ini%Read('counts_density', P%SourceTerms%counts_density)
        call Ini%Read('counts_redshift', P%SourceTerms%counts_redshift)
        call Ini%Read('counts_radial', P%SourceTerms%counts_radial)
        call Ini%Read('counts_evolve', P%SourceTerms%counts_evolve)
        call Ini%Read('counts_timedelay', P%SourceTerms%counts_timedelay)
        call Ini%Read('counts_ISW', P%SourceTerms%counts_ISW)
        call Ini%Read('counts_potential', P%SourceTerms%counts_potential)
        call Ini%Read('counts_velocity', P%SourceTerms%counts_velocity)
    end if

    P%OutputNormalization=outNone

    P%WantCls= P%WantScalars .or. P%WantTensors .or. P%WantVectors

    PK_WantTransfer = Ini%Read_Logical('get_transfer')

    call Ini%Read('accuracy_boost', P%Accuracy%AccuracyBoost)
    call Ini%Read('l_accuracy_boost', P%Accuracy%lAccuracyBoost)

    P%NonLinear = Ini%Read_Int('do_nonlinear', NonLinear_none)

    P%Evolve_baryon_cs = Ini%Read_Logical('evolve_baryon_cs', .false.)
    P%Evolve_delta_xe = Ini%Read_Logical('evolve_delta_xe', .false.)
    P%Evolve_delta_Ts = Ini%Read_Logical('evolve_delta_ts', .false.)

    P%DoLensing = .false.
    P%Min_l = Ini%Read_int('l_min',2)
    if (P%WantCls) then
        if (P%WantScalars  .or. P%WantVectors) then
            P%Max_l = Ini%Read_Int('l_max_scalar')
            P%Max_eta_k = Ini%Read_Double('k_eta_max_scalar', P%Max_l*2._dl)
            if (P%WantScalars) then
                P%DoLensing = Ini%Read_Logical('do_lensing', .false.)
                if (P%DoLensing) lensing_method = Ini%Read_Int('lensing_method', 1)
            end if
            if (P%WantVectors) then
                if (P%WantScalars .or. P%WantTensors) then
                    ErrMsg = 'Must generate vector modes on their own'
                    return
                end if
                i = Ini%Read_Int('vector_mode')
                if (i==0) then
                    vec_sig0 = 1
                    Magnetic = 0
                else if (i==1) then
                    Magnetic = -1
                    vec_sig0 = 0
                else
                    ErrMsg = 'vector_mode must be 0 (regular) or 1 (magnetic)'
                    return
                end if
            end if
        end if

        if (P%WantTensors) then
            P%Max_l_tensor = Ini%Read_Int('l_max_tensor')
            P%Max_eta_k_tensor = Ini%Read_Double('k_eta_max_tensor', Max(500._dl, P%Max_l_tensor * 2._dl))
        end if
    endif

    !  Read initial parameters.
    DarkEneryModel = UpperCase(Ini%Read_String_Default('dark_energy_model', 'fluid'))
    if (allocated(P%DarkEnergy)) deallocate(P%DarkEnergy)
    if (DarkEneryModel == 'FLUID') then
        allocate (TDarkEnergyFluid::P%DarkEnergy)
    else if (DarkEneryModel == 'PPF') then
        allocate (TDarkEnergyPPF::P%DarkEnergy)
    else if (DarkEneryModel == 'AXIONEFFECTIVEFLUID') then
        allocate (TAxionEffectiveFluid::P%DarkEnergy)
    else if (DarkEneryModel == 'EARLYQUINTESSENCE') then
        allocate (TEarlyQuintessence::P%DarkEnergy)
    else
        ErrMsg = 'Unknown dark energy model: '//trim(DarkEneryModel)
        return
    end if
    call P%DarkEnergy%ReadParams(Ini)

    P%h0 = Ini%Read_Double('hubble')

    if (Ini%Read_Logical('use_physical', .true.)) then
        P%ombh2 = Ini%Read_Double('ombh2')
        P%omch2 = Ini%Read_Double('omch2')
        P%omnuh2 = Ini%Read_Double('omnuh2')
        P%omk = Ini%Read_Double('omk')
    else
        ErrMsg = 'use_physical = F no longer supported. Use ombh2, omch2, omnuh2, omk'
        return
    end if

    P%tcmb = Ini%Read_Double('temp_cmb', COBE_CMBTemp)
    P%yhe = Ini%Read_Double('helium_fraction', 0.24_dl)
    P%Num_Nu_massless = Ini%Read_Double('massless_neutrinos')

    P%Nu_mass_eigenstates = Ini%Read_Int('nu_mass_eigenstates', 1)
    if (P%Nu_mass_eigenstates > max_nu) then
        ErrMsg = 'too many mass eigenstates'
        return
    end if

    numstr = Ini%Read_String('massive_neutrinos')
    read(numstr, *) nmassive
    if (abs(nmassive-nint(nmassive))>1e-6) then
        ErrMsg =  'massive_neutrinos should now be integer (or integer array)'
        return
    end if
    read(numstr,*, iostat=status) P%Nu_Mass_numbers(1:P%Nu_mass_eigenstates)
    if (status/=0) then
        ErrMsg = 'Must give num_massive number of integer physical neutrinos for each eigenstate'
        return
    end if
    P%Num_Nu_massive = sum(P%Nu_Mass_numbers(1:P%Nu_mass_eigenstates))

    if (P%Num_Nu_massive>0) then
        P%share_delta_neff = Ini%Read_Logical('share_delta_neff', .true.)
        numstr = Ini%Read_String('nu_mass_degeneracies')
        if (P%share_delta_neff) then
            if (numstr/='') write (*,*) 'WARNING: nu_mass_degeneracies ignored when share_delta_neff'
        else
            if (numstr=='') then
                ErrMsg = 'must give degeneracies for each eigenstate if share_delta_neff=F'
                return
            end if
            read(numstr,*) P%Nu_mass_degeneracies(1:P%Nu_mass_eigenstates)
        end if
        numstr = Ini%Read_String('nu_mass_fractions')
        if (numstr=='') then
            if (P%Nu_mass_eigenstates >1) then
                ErrMsg =  'must give nu_mass_fractions for the eigenstates'
                return
            end if
            P%Nu_mass_fractions(1)=1
        else
            read(numstr,*) P%Nu_mass_fractions(1:P%Nu_mass_eigenstates)
        end if
    end if

    if (((P%NonLinear==NonLinear_lens .or. P%NonLinear==NonLinear_both) .and. P%DoLensing) .or. PK_WantTransfer) then
        P%Transfer%high_precision = Ini%Read_Logical('transfer_high_precision', .false.)
    else
        P%transfer%high_precision = .false.
    endif
    if (PK_WantTransfer) then
        P%Transfer%accurate_massive_neutrinos = Ini%Read_Logical('accurate_massive_neutrino_transfers',.false.)
    else
        P%Transfer%accurate_massive_neutrinos = .false.
    end if
    if (P%NonLinear/=NonLinear_none) call P%NonLinearModel%ReadParams(Ini)

    if (PK_WantTransfer)  then
        P%WantTransfer  = .true.
        P%transfer%kmax = Ini%Read_Double('transfer_kmax')*(P%h0 / 100._dl)
        P%transfer%k_per_logint = Ini%Read_Int('transfer_k_per_logint')
        P%transfer%PK_num_redshifts = Ini%Read_Int('transfer_num_redshifts')

        if (P%Do21cm) P%transfer_21cm_cl = Ini%Read_Logical('transfer_21cm_cl',.false.)
        if (P%transfer_21cm_cl .and. P%transfer%kmax > 800) then
            !Actually line widths are important at significantly larger scales too
            write (*,*) 'WARNING: kmax very large. '
            write(*,*) ' -- Neglected line width effects will dominate'
        end if

        call Ini%Read('transfer_interp_matterpower', transfer_interp_matterpower)
        call Ini%Read('transfer_power_var', transfer_power_var)
        if (P%transfer%PK_num_redshifts > max_transfer_redshifts) then
            ErrMsg = 'Too many redshifts, increase max_transfer_redshifts'
            return
        end if
        do i=1, P%transfer%PK_num_redshifts
            P%transfer%PK_redshifts(i)  = Ini%Read_Double_Array('transfer_redshift', i, 0._dl)
        end do
    else
        P%Transfer%PK_num_redshifts = 1
        P%Transfer%PK_redshifts = 0
    end if

    call Ini%Read('Alens', P%Alens)

    call P%Reion%ReadParams(Ini)
    call P%InitPower%ReadParams(Ini)

    RecombinationModel = UpperCase(Ini%Read_String_Default('recombination_model', 'Recfast'))
    if (RecombinationModel == 'COSMOREC') then
#ifdef COSMOREC
        deallocate(P%Recomb)
        allocate(TCosmoRec::P%Recomb)
#else
        ErrMsg = 'Compile with CosmoRec to use recombination_model=CosmoRec'
        return
#endif
    else if (RecombinationModel == 'HYREC') then
#ifdef HYREC
        deallocate(P%Recomb)
        allocate(THyRec::P%Recomb)
#else
        ErrMsg = 'Compile with HyRec to use recombination_model=HyRec'
        return
#endif
    else if (RecombinationModel /= 'RECFAST') then
        ErrMsg =  'Unknown recombination_model: '//trim(RecombinationModel)
        return
    end if

    call P%Recomb%ReadParams(Ini)

    if (P%WantScalars .or. P%WantTransfer) then
        P%Scalar_initial_condition = Ini%Read_Int('initial_condition', initial_adiabatic)
        if (P%Scalar_initial_condition == initial_vector) then
            allocate(P%InitialCOnditionVector(initial_nummodes))
            numstr = Ini%Read_String('initial_vector', .true.)
            read (numstr,*) P%InitialConditionVector
        end if
        if (P%Scalar_initial_condition/= initial_adiabatic) P%use_cl_spline_template = .false.
    end if
    if (P%Scalar_initial_condition== initial_adiabatic) &
        call Ini%Read('use_cl_spline_template', P%use_cl_spline_template)

    P%WantDerivedParameters = Ini%Read_Logical('derived_parameters', .true.)

    !optional parameters controlling the computation

    P%Accuracy%AccuratePolarization = Ini%Read_Logical('accurate_polarization', .true.)
    P%Accuracy%AccurateReionization = Ini%Read_Logical('accurate_reionization', .true.)
    P%Accuracy%AccurateBB = Ini%Read_Logical('accurate_BB', .false.)
    if (P%Accuracy%AccurateBB .and. P%WantCls .and. (P%Max_l < 3500 .or. &
        (P%NonLinear/=NonLinear_lens .and. P%NonLinear/=NonLinear_both) .or. P%Max_eta_k < 18000)) &
        write(*,*) 'WARNING: for accurate lensing BB you need high l_max_scalar, k_eta_max_scalar and non-linear lensing'

    !Mess here to fix typo with backwards compatibility
    if (Ini%HasKey('do_late_rad_trunction')) then
        P%DoLateRadTruncation = Ini%Read_Logical('do_late_rad_trunction', .true.)
        if (Ini%HasKey('do_late_rad_truncation')) error stop 'check do_late_rad_xxxx'
    else
        P%DoLateRadTruncation = Ini%Read_Logical('do_late_rad_truncation', .true.)
    end if
    P%MassiveNuMethod = Ini%Read_Int('massive_nu_approx', Nu_best)

    call Ini%Read('l_sample_boost', P%Accuracy%lSampleBoost)

    CAMB_ReadParams = .true.

    end function CAMB_ReadParams

    logical function CAMB_RunFromIni(Ini, InputFile, ErrMsg)
    use IniObjects
    use Lensing
    use constants
    use Bispectrum
    use CAMBmain
    class(TIniFile) :: Ini
    character(LEN=*), intent(in) :: InputFile
    character(LEN=*), intent(inout) :: ErrMsg
    type(CAMBparams) P
    character(len=:), allocatable :: outroot, VectorFileName, &
        ScalarFileName, TensorFileName, TotalFileName, LensedFileName,&
        LensedTotFileName, LensPotentialFileName, ScalarCovFileName, &
        version_check
    integer :: i
    character(len=Ini_max_string_len), allocatable :: TransferFileNames(:), &
        MatterPowerFileNames(:), TransferClFileNames(:)
    real(dl) :: output_factor
#ifdef WRITE_FITS
    character(LEN=Ini_max_string_len) FITSfilename
#endif
    logical PK_WantTransfer
    Type(CAMBdata) :: ActiveState

    call SetActiveState(ActiveState)
    CAMB_RunFromIni = .false.

    if (.not. CAMB_ReadParams(P, Ini, ErrMsg)) return

    outroot = Ini%Read_String('output_root')
    if (outroot /= '') outroot = trim(outroot) // '_'

    PK_WantTransfer = Ini%Read_Logical('get_transfer')
    if (PK_WantTransfer)  then
        call Ini%Read('transfer_interp_matterpower', transfer_interp_matterpower)
        call Ini%Read('transfer_power_var', transfer_power_var)
        allocate (TransferFileNames(P%Transfer%PK_num_redshifts))
        allocate (MatterPowerFileNames(P%Transfer%PK_num_redshifts))
        allocate (TransferClFileNames(P%Transfer%PK_num_redshifts))
        do i=1, P%transfer%PK_num_redshifts
            transferFileNames(i)     = Ini%Read_String_Array('transfer_filename', i)
            MatterPowerFilenames(i)  = Ini%Read_String_Array('transfer_matterpower', i)
            if (TransferFileNames(i) == '') then
                TransferFileNames(i) =  trim(numcat('transfer_',i))//'.dat'
            end if
            if (MatterPowerFilenames(i) == '') then
                MatterPowerFilenames(i) =  trim(numcat('matterpower_',i))//'.dat'
            end if
            if (TransferFileNames(i)/= '') &
                TransferFileNames(i) = trim(outroot)//TransferFileNames(i)
            if (MatterPowerFilenames(i) /= '') &
                MatterPowerFilenames(i)=trim(outroot)//MatterPowerFilenames(i)

            if (P%Do21cm) then
                TransferClFileNames(i) = Ini%Read_String_Array('transfer_cl_filename',i)
                if (TransferClFileNames(i) == '') &
                    TransferClFileNames(i) =  trim(numcat('sharp_cl_',i))//'.dat'
            else
                TransferClFileNames(i) = ''
            end if

            if (TransferClFileNames(i)/= '') &
                TransferClFileNames(i) = trim(outroot)//TransferClFileNames(i)
        end do
    end if

    call Bispectrum_ReadParams(BispectrumParams, Ini, outroot)

    output_factor = Ini%Read_Double('CMB_outputscale', 1.d0)

    if (P%WantScalars) then
        ScalarFileName = trim(outroot) // Ini%Read_String('scalar_output_file')
        LensedFileName = trim(outroot) // Ini%Read_String('lensed_output_file')
        LensPotentialFileName = Ini%Read_String('lens_potential_output_file')
        if (LensPotentialFileName/='') LensPotentialFileName = concat(outroot,LensPotentialFileName)
        ScalarCovFileName = Ini%Read_String_Default('scalar_covariance_output_file', &
            'scalarCovCls.dat', .false.)
        if (ScalarCovFileName /= '') then
            P%want_cl_2D_array = .true.
            ScalarCovFileName = concat(outroot, ScalarCovFileName)
        end if
    else
        ScalarFileName = ''
        LensedFileName = ''
        LensPotentialFileName = ''
        ScalarCovFileName = ''
    end if
    if (P%WantTensors) then
        TensorFileName = trim(outroot) // Ini%Read_String('tensor_output_file')
        if (P%WantScalars) then
            TotalFileName = trim(outroot) // Ini%Read_String('total_output_file')
            LensedTotFileName = Ini%Read_String('lensed_total_output_file')
            if (LensedTotFileName /= '') LensedTotFileName = trim(outroot) // trim(LensedTotFileName)
        else
            TotalFileName = ''
            LensedTotFileName = ''
        end if
    else
        TensorFileName = ''
        TotalFileName = ''
        LensedTotFileName = ''
    end if
    if (P%WantVectors) then
        VectorFileName = trim(outroot) // Ini%Read_String('vector_output_file')
    else
        VectorFileName = ''
    end if

#ifdef WRITE_FITS
    if (P%WantCls) then
        FITSfilename = trim(outroot) // Ini%Read_String('FITS_filename', .true.)
        if (FITSfilename /= '') then
            inquire(file=FITSfilename, exist=bad)
            if (bad) then
                open(unit=18, file=FITSfilename, status='old')
                close(18, status='delete')
            end if
        end if
    end if
#endif

    version_check = Ini%Read_String('version_check')
    if (version_check == '') then
        !tag the output used parameters .ini file with the version of CAMB being used now
        call Ini%ReadValues%Add('version_check', version)
    else if (version_check /= version) then
        write(*,*) 'WARNING: version_check does not match this CAMB version'
    end if

    call Ini%Read('output_file_headers', output_file_headers)

    if (do_bispectrum) then
        P%Accuracy%lSampleBoost   = 50
    end if
    if (outroot /= '') then
        if (InputFile /= trim(outroot) // 'params.ini') then
            call Ini%SaveReadValues(trim(outroot) // 'params.ini')
        else
            write(*,*) 'Output _params.ini not created as would overwrite input'
        end if
    end if

    if (.not. P%Validate()) then
        ErrMsg = 'Invalid parameter value'
        return
    end if

    if (global_error_flag==0) call CAMB_GetResults(State,P)
    if (global_error_flag/=0) then
        ErrMsg =  trim(global_error_message)
        return
    endif

    if (PK_WantTransfer) then
        call Transfer_SaveToFiles(State%MT,State, TransferFileNames)
        call Transfer_SaveMatterPower(State%MT,State,MatterPowerFileNames)
        call Transfer_output_sig8(State%MT, State)
        if (P%do21cm .and. P%transfer_21cm_cl) call Transfer_Get21cmCls(State%MT, State,TransferClFileNames)
    end if

    if (P%WantCls) then
        call State%CLData%output_cl_files(State,ScalarFileName, ScalarCovFileName, TensorFileName, TotalFileName, &
            LensedFileName, LensedTotFilename, output_factor)

        call State%CLData%output_lens_pot_files(State%CP,LensPotentialFileName, output_factor)

        if (P%WantVectors) then
            call State%CLData%output_veccl_files(State%CP,VectorFileName, output_factor)
        end if

#ifdef WRITE_FITS
        if (FITSfilename /= '') call WriteFitsCls(State, FITSfilename, CP%Max_l)
#endif
    end if

    CAMB_RunFromIni = .true.

    end function CAMB_RunFromIni

    logical function CAMB_RunIniFile(InputFile, InpLen)
    integer, intent(in) :: InpLen
    character(LEN=InpLen), intent(in) :: InputFile
    character(LEN=len(global_error_message)) :: ErrMsg
    Type(TIniFile) :: Ini
    logical bad

    !Same as CAMB_CommandLineRun but does not read variables that change global state
    !Intended for use from python

    call Ini%Open(InputFile, bad, .false.)
    Ini%Fail_on_not_found = .false.
    ErrMsg = ''
    CAMB_RunIniFile = CAMB_RunFromIni(Ini, InputFile, ErrMsg)
    call Ini%Close()
    if (ErrMsg/='') call GlobalError(ErrMsg,error_ini)

    end function CAMB_RunIniFile

    subroutine CAMB_CommandLineValidate(InputFile)
    !Error stop if any problem
    character(LEN=*), intent(in) :: InputFile
    Type(TIniFile) :: Ini
    logical bad
    Type(CAMBParams) :: P
    character(LEN=1024) :: ErrMsg

    call Ini%Open(InputFile, bad, .false.)
    if (bad) then
        error stop 'File does not exist'
    end if
    if (.not. CAMB_ReadParams(P, Ini, ErrMsg)) then
        write(*,*) trim(ErrMsg)
        error stop
    end if

    call Ini%Close()

    end subroutine CAMB_CommandLineValidate

    subroutine CAMB_CommandLineRun(InputFile)
    character(LEN=*), intent(in) :: InputFile
    Type(TIniFile) :: Ini
    character(LEN=1024) :: ErrMsg
    logical bad

    call Ini%Open(InputFile, bad, .false.)
    if (bad) then
        write(*,*) 'File not found: '//trim(InputFile)
        error stop
    end if

    highL_unlensed_cl_template = Ini%Read_String_Default( &
        'highL_unlensed_cl_template', highL_unlensed_cl_template)
    call Ini%Read('number_of_threads', ThreadNum)
    call Ini%Read('DebugParam', DebugParam)
    call Ini%Read('feedback_level', FeedbackLevel)
    if (Ini%HasKey('DebugMsgs')) call Ini%Read('DebugMsgs', DebugMsgs)

    Ini%Fail_on_not_found = .false.
    if (.not. CAMB_RunFromIni(Ini, InputFile, ErrMsg)) then
        write(*,*) trim(ErrMsg)
        error stop 'Invalid parameter'
    end if
    call Ini%Close()

    end subroutine CAMB_CommandLineRun

    subroutine CAMB_GetVersion(ver)
    character(LEN=*) :: ver
    ver = version
    end subroutine CAMB_GetVersion

    end module CAMB

    !     This this is the main CAMB program module.
    !
    !     Code for Anisotropies in the Microwave Background
    !     by Antony lewis (http://cosmologist.info) and Anthony Challinor
    !     See readme.html for documentation.

    !     Note that though the code is internally parallelised, it is not thread-safe
    !     so you cannot generate more than one model at the same time in different threads.
    !
    !     Based on CMBFAST  by  Uros Seljak and Matias Zaldarriaga, itself based
    !     on Boltzmann code written by Edmund Bertschinger, Chung-Pei Ma and Paul Bode.
    !     Original CMBFAST copyright and disclaimer:
    !
    !     Copyright 1996 by Harvard-Smithsonian Center for Astrophysics and
    !     the Massachusetts Institute of Technology.  All rights reserved.
    !
    !     THIS SOFTWARE IS PROVIDED "AS IS", AND M.I.T. OR C.f.A. MAKE NO
    !     REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPlIED.
    !     By way of example, but not limitation,
    !     M.I.T. AND C.f.A MAKE NO REPRESENTATIONS OR WARRANTIES OF
    !     MERCHANTABIlITY OR FITNESS FOR ANY PARTICUlAR PURPOSE OR THAT
    !     THE USE OF THE lICENSED SOFTWARE OR DOCUMENTATION WIll NOT INFRINGE
    !     ANY THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS.
    !
    !     portions of this software are based on the COSMICS package of
    !     E. Bertschinger.  See the lICENSE file of the COSMICS distribution
    !     for restrictions on the modification and distribution of this software.

    module CAMBmain

    !     This code evolves the linearized perturbation equations of general relativity,
    !     the Boltzmann equations and the fluid equations for perturbations
    !     of a Friedmann-Robertson-Walker universe with a supplied system of gauge-dependent equation
    !     in a modules called GaugeInterface.  The sources for the line of sight integral are
    !     computed at sampled times during the evolution for various of wavenumbers. The sources
    !     are then interpolated to a denser wavenumber sampling for computing the line of
    !     sight integrals of the form Integral d(conformal time) source_k * bessel_k_l.
    !     For flat models the bessel functions are interpolated from a pre-computed table, for
    !     non-flat models the hyperspherical Bessel functions are computed by integrating their
    !     differential equation. Both phases ('Evolution' and 'Integration') can do separate
    !     wavenumbers in parallel.

    !     The time variable is conformal  time dtau=dt/a(t) and the spatial dependence is Fourier transformed
    !     with q=sqrt(k**2 + (|m|+1)K), comoving distances are x=r/a(t), with a(t)=1 today.
    !     The units of both length and time are Mpc.

    !    Many elements are part of derived types (to make thread safe or to allow non-sequential code use
    !    CP = CAMB parameters
    !    EV = Time evolution variables
    !    IV = Source integration variables
    !    CT = Cl transfer data
    !    MT = matter transfer data


    use precision
    use results
    use GaugeInterface
    use SpherBessels
    use MassiveNu
    use InitialPower
    use SourceWindows
    use Recombination
    use RangeUtils
    use constants
    use DarkEnergyInterface
    use MathUtils
    implicit none
    private

    logical :: WantLateTime = .false. !if lensing or redshift windows

    logical ExactClosedSum  !do all nu values in sum for Cls for Omega_k>0.1

    !Variables for integrating the sources with the bessel functions for each wavenumber
    type IntegrationVars
        integer q_ix
        real(dl) q, dq    !q value we are doing and delta q
        !Contribution to C_l integral from this k
        real(dl), dimension(:,:), pointer :: Source_q, ddSource_q
        !Interpolated sources for this k
        integer SourceSteps !number of steps up to where source is zero
    end type IntegrationVars

    real(dl), dimension(:,:), allocatable :: iCl_scalar, iCl_vector, iCl_tensor
    ! Cls at the l values we actually compute,  iCl_xxx(l_index, Cl_type, initial_power_index)

    real(dl), dimension(:,:,:), allocatable :: iCl_Array
    !Full covariance at each L (alternative more general arrangement to above)

    real(dl),parameter :: qmin0=0.1_dl

    real(dl) :: dtaurec_q

    !     qmax - CP%Max_eta_k/State%tau0, qmin = qmin0/State%tau0 for flat case
    real(dl) qmin, qmax

    real(dl) max_etak_tensor , max_etak_vector, max_etak_scalar
    !     Will only be calculated if k*tau < max_etak_xx

    integer maximum_l !Max value of l to compute
    real(dl) :: maximum_qeta = 3000._dl

    integer :: l_smooth_sample = 3000 !assume transfer functions effectively small for k*chi0>2*l_smooth_sample

    integer :: max_bessels_l_index  = 1000000
    real(dl) :: max_bessels_etak = 1000000*2

    Type(TTimeSources) , pointer :: ThisSources => null()
    Type(TTimeSources), allocatable, target :: TempSources

    real(dl), dimension(:,:,:), allocatable :: ddScaledSrc !temporary source second derivative array
    real(dl), dimension(:,:,:), pointer ::  ScaledSrc => null() !linear source with optional non-linear scaling

    integer n_source_points ! number of CL source wavenumbers (for use when calculted remaining non-CL transfers)

    procedure(obj_function), private :: dtauda

    public cmbmain, TimeSourcesToCl, ClTransferToCl, InitVars, GetTauStart !InitVars for BAO hack

    contains


    subroutine cmbmain
    integer q_ix
    type(EvolutionVars) EV
    Type(TTimer) :: Timer
    real(dl) starttime
    Type(ClTransferData), pointer :: ThisCT 

    WantLateTime =  CP%DoLensing .or. State%num_redshiftwindows > 0 .or. CP%CustomSources%num_custom_sources>0

    if (CP%WantCls) then
        if (CP%WantTensors .and. CP%WantScalars) call MpiStop('CMBMAIN cannot generate tensors and scalars')
        !Use CAMB_GetResults instead

        if (CP%WantTensors) then
            maximum_l = CP%Max_l_tensor
            maximum_qeta = CP%Max_eta_k_tensor
        else
            maximum_l = CP%Max_l
            maximum_qeta = CP%Max_eta_k
        end if
    end if

    if (DebugMsgs .and. Feedbacklevel > 0) call Timer%Start(starttime)

    call InitVars(State) !Most of single thread time spent here (in InitRECFAST)
    if (global_error_flag/=0) return

    if (DebugMsgs .and. Feedbacklevel > 0) then
        call Timer%WriteTime('Timing for InitVars')
        if (.not. State%flat) call WriteFormat('r = %f, scale = %f',State%curvature_radius, State%scale)
    end if

    if (.not. State%HasScalarTimeSources .and. (.not. State%OnlyTransfer .or. &
        CP%NonLinear==NonLinear_Lens .or. CP%NonLinear==NonLinear_both)) &
        call CP%InitPower%Init(CP)
    if (global_error_flag/=0) return

    !Calculation of the CMB and other sources.
    if (CP%WantCls) then
        if (CP%WantScalars) then
            !Allow keeping time source for scalars, so e.g. different initial power spectra
            ! and non-linear corrections can be applied later
            if (.not. allocated(State%ScalarTimeSources)) allocate(State%ScalarTimeSources)
            ThisSources => State%ScalarTimeSources
        else
            if (.not. allocated(TempSources)) allocate(TempSources)
            ThisSources => TempSources
        end if
        call SetkValuesForSources
    end if

    if (CP%WantTransfer) call InitTransfer

    !***note that !$ is the prefix for conditional multi-processor compilation***
    !$ if (ThreadNum /=0) call OMP_SET_NUM_THREADS(ThreadNum)

    if (CP%WantCls) then
        if (DebugMsgs .and. Feedbacklevel > 0) call WriteFormat('Set %d source k values', &
            ThisSources%Evolve_q%npoints)

        if (CP%WantScalars) then
            ThisCT => State%ClData%CTransScal
        else if (CP%WantVectors) then
            ThisCT => State%ClData%CTransVec
        else
            ThisCT => State%ClData%CTransTens
        end if

        call GetSourceMem

        ThisCT%NumSources = ThisSources%SourceNum
        call ThisCT%ls%Init(State,CP%Min_l, maximum_l)

        !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(DYNAMIC), PRIVATE(EV, q_ix)
        do q_ix= ThisSources%Evolve_q%npoints,1,-1
            if (global_error_flag==0) call DoSourcek(EV,q_ix)
        end do
        !$OMP END PARALLEL DO

        if (DebugMsgs .and. Feedbacklevel > 0) call Timer%WriteTime('Timing for source calculation')

    endif !WantCls

    ! If transfer functions are requested, set remaining k values and output
    if (CP%WantTransfer .and. global_error_flag==0) then
        call TransferOut
        if (DebugMsgs .and. Feedbacklevel > 0) call Timer%WriteTime('Timing for transfer k values')
    end if

    if (CP%WantTransfer .and. .not. State%OnlyTransfer .and. global_error_flag==0) &
        call Transfer_Get_sigmas(State, State%MT)

    !     if CMB calculations are requested, calculate the Cl by
    !     integrating the sources over time and over k.

    if (CP%WantCls .and. (.not. CP%WantScalars .or. .not. State%HasScalarTimeSources)) then
        call TimeSourcesToCl(ThisCT)

        if (CP%WantScalars) then
            deallocate(State%ScalarTimeSources)
        else
            deallocate(TempSources)
        end if
        nullify(ThisSources)
    end if
    if (DebugMsgs .and. Feedbacklevel > 0) then
        call Timer%WriteTime('Timing for whole of cmbmain', starttime)
    end if

    end subroutine cmbmain

    subroutine TimeSourcesToCl(ThisCT)
    Type(ClTransferData) :: ThisCT 
    integer q_ix
    Type(TTimer) :: Timer

    if (CP%WantScalars) ThisSources => State%ScalarTimeSources

    if (DebugMsgs .and. Feedbacklevel > 0) call Timer%Start()

    if (CP%WantScalars .and. WantLateTime &
        .and. (CP%NonLinear==NonLinear_Lens .or. CP%NonLinear==NonLinear_both) .and. global_error_flag==0) then
        call MakeNonlinearSources
        if (DebugMsgs .and. Feedbacklevel > 0) call Timer%WriteTime('Timing for NonLinear sources')
    else
        ScaledSrc => ThisSources%LinearSrc
    end if

    if (global_error_flag==0) then
        call InitSourceInterpolation

        ExactClosedSum = State%curv > 5e-9_dl .or. State%scale < 0.93_dl

        max_bessels_l_index = ThisCT%ls%nl
        max_bessels_etak  = maximum_qeta

        if (CP%WantScalars) call GetLimberTransfers(ThisCT)
        ThisCT%max_index_nonlimber = max_bessels_l_index

        if (State%flat) call InitSpherBessels(ThisCT%ls, CP, max_bessels_l_index,max_bessels_etak )
        !This is only slow if not called before with same (or higher) Max_l, Max_eta_k
        !Preferably stick to Max_l being a multiple of 50

        call SetkValuesForInt(ThisCT)

        if (DebugMsgs .and. Feedbacklevel > 0) call WriteFormat('Set %d integration k values',ThisCT%q%npoints)

        !Begin k-loop and integrate Sources*Bessels over time
        !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC,4)
        do q_ix=1,ThisCT%q%npoints
            call SourceToTransfers(ThisCT, q_ix)
        end do !q loop
        !$OMP END PARALLEL DO

        if (DebugMsgs .and. Feedbacklevel > 0) call Timer%WriteTime('Timing for Integration')
    end if

    if (allocated(ddScaledSrc)) deallocate(ddScaledSrc)
    if (associated(ScaledSrc) .and. .not. associated(ScaledSrc,ThisSources%LinearSrc)) then
        deallocate(ScaledSrc)
        nullify(ScaledSrc)
    end if

    !Final calculations for CMB output unless want the Cl transfer functions only.
    if (.not. State%OnlyTransfer .and. global_error_flag==0) &
        call ClTransferToCl(State)

    if (DebugMsgs .and. Feedbacklevel > 0) call Timer%WriteTime('Timing for final CL output')

    end subroutine TimeSourcesToCl

    subroutine ClTransferToCl(State)
    class(CAMBdata) :: State

    call SetActiveState(State)
    if (State%CP%WantScalars .and. State%CP%WantCls .and. global_error_flag==0) then
        allocate(iCl_Scalar(State%CLdata%CTransScal%ls%nl,C_Temp:State%Scalar_C_last), source=0._dl)
        if (State%CP%want_cl_2D_array) then
            allocate(iCl_Array(State%CLdata%CTransScal%ls%nl, &
                State%CLdata%CTransScal%NumSources,State%CLdata%CTransScal%NumSources))
            iCl_Array = 0
        end if

        call CalcLimberScalCls(State%CLdata%CTransScal)
        call CalcScalCls(State%CLdata%CTransScal)
        if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'CalcScalCls'
    end if

    if (State%CP%WantVectors .and. global_error_flag==0) then
        allocate(iCl_vector(State%CLdata%CTransVec%ls%nl,C_Temp:CT_Cross), source=0._dl)
        call CalcVecCls(State%CLdata%CTransVec,GetInitPowerArrayVec)
        if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'CalcVecCls'
    end if

    if (CP%WantTensors .and. global_error_flag==0) then
        allocate(iCl_Tensor(State%CLdata%CTransTens%ls%nl,CT_Temp:CT_Cross), source=0._dl)
        call CalcTensCls(State%CLdata%CTransTens,GetInitPowerArrayTens)
        if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'CalcTensCls'
    end if

    if (global_error_flag==0) then
        call State%CLdata%InitCls(State)
        !     Calculating Cls for every l.
        call InterpolateCls()
        if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'InterplolateCls'
    end if

    if (CP%WantScalars .and. allocated(iCl_Scalar)) deallocate(iCl_scalar)
    if (CP%WantScalars .and. allocated(iCl_Array)) deallocate(iCl_Array)
    if (CP%WantVectors .and. allocated(iCl_Vector)) deallocate(iCl_vector)
    if (CP%WantTensors .and. allocated(iCl_Tensor)) deallocate(iCl_tensor)

    if (global_error_flag/=0) return

    if (CP%OutputNormalization >=2) call State%CLData%NormalizeClsAtl(CP,CP%OutputNormalization)
    !Normalize to C_l=1 at l=OutputNormalization

    end subroutine ClTransferToCl

    subroutine CalcLimberScalCls(CTrans)
    Type(ClTransferData), target :: CTrans
    integer ell, i, s_ix
    real(dl) CL, reall,fac
    integer s_ix2,j,n
    integer winmin
    Type(LimberRec), pointer :: LimbRec, LimbRec2

    if (CTrans%NumSources <3) return
    if (CP%SourceTerms%limber_phi_lmin>0) then
        winmin = 0
    else
        winmin = 1
    end if

    do i =winmin, State%num_redshiftwindows
        s_ix = 3+i
        if (CTrans%limber_l_min(s_ix) /=0) then
            do j= i, State%num_redshiftwindows
                s_ix2 = 3+j
                if (CTrans%limber_l_min(s_ix2) /=0) then
                    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), PRIVATE(Cl,ell,reall,fac,n, LimbRec, LimbRec2)
                    do ell = max(CTrans%limber_l_min(s_ix), CTrans%limber_l_min(s_ix2)), Ctrans%ls%nl
                        !Don't use associate to avoid ifort omp bug
                        LimbRec => CTrans%Limber_windows(s_ix,ell)
                        LimbRec2 => CTrans%Limber_windows(s_ix2,ell)
                        Cl = 0

                        do n = max(LimbRec%n1,LimbRec2%n1), min(LimbRec%n2,LimbRec2%n2)
                            !Actually integral over chi; source has sqrt( chi dchi)
                            !Same n corresponds to same k since ell fixed here
                            Cl = Cl + LimbRec%Source(n)*LimbRec2%Source(n) * CP%InitPower%ScalarPower(LimbRec%k(n))
                        end do

                        reall = real(CTrans%ls%l(ell),dl)
                        fac = (2 * const_pi ** 2)/const_fourpi/(reall+0.5_dl)**3 !fourpi because multipled by fourpi later
                        if (j >= 1) then
                            if (State%Redshift_w(j)%kind == window_lensing) &
                                fac = fac / 2 * reall * (reall + 1)
                        end if
                        if (i >= 1) then
                            if (State%Redshift_w(i)%kind == window_lensing) &
                                fac = fac / 2 * reall * (reall + 1)
                        end if
                        Cl = Cl*fac

                        if(j==0 .and. i==0) iCl_scalar(ell,C_Phi) = Cl
                        if (State%CP%want_cl_2D_array) then
                            iCl_Array(ell,s_ix,s_ix2) = Cl
                            if (i/=j) iCl_Array(ell,s_ix2,s_ix) = Cl
                        end if
                    end do
                    !$OMP END PARALLEL DO
                end if
            end do
        end if
    end do

    end subroutine CalcLimberScalCls

    subroutine GetLimberTransfers(ThisCT)
    Type(ClTransferData), target :: ThisCT 
    integer ell, ell_needed
    integer i, s_ix, s_ix_lens
    type(TRedWin), pointer :: W
    integer n1,n2,n, ell_limb
    real(dl) int,k, chi
    integer klo, khi
    real(dl) a0,b0,ho2o6,a03,b03,ho,reall
    Type(LimberRec), pointer :: LimbRec

    call Init_Limber(ThisCT,State)

    if (.not. CP%SourceTerms%limber_windows .or. State%num_redshiftwindows==0 &
        .and. CP%SourceTerms%limber_phi_lmin==0) return

    if (ThisCT%ls%l(ThisCT%ls%nl) > 5000) then
        max_bessels_l_index = ThisCT%ls%indexOf(5000)
    else
        max_bessels_l_index = ThisCT%ls%nl
    end if

    if (CP%Want_CMB) then
        max_bessels_etak= min(ThisCT%ls%l(ThisCT%ls%nl),3000)*2.5_dl*CP%Accuracy%AccuracyBoost
    else
        max_bessels_etak = 5000
    end if

    do i = 0, State%num_redshiftwindows
        s_ix = 3+i

        if (i==0) then
            ell_limb = CP%SourceTerms%limber_phi_lmin
        else
            W => State%Redshift_w(i)
            ell_limb = Win_limber_ell(W, CP,ThisCT%ls%l(ThisCT%ls%nl))
        end if

        ell_needed = ThisCT%ls%l(ThisCT%ls%nl)
        do ell = 1, ThisCT%ls%nl
            if (ThisCT%ls%l(ell) >= ell_limb) then
                ThisCT%limber_l_min(s_ix) =  ell
                ell_needed = ThisCT%ls%l(ell)
                max_bessels_l_index = max(max_bessels_l_index,ThisCT%limber_l_min(s_ix)-1)
                if (FeedbackLevel > 1 .or. DebugMsgs) &
                    call WriteFormat('Limber switch %d: %d', i,  ell_needed)
                exit
            end if
        end do

        if (i==0) then
            if (CP%Want_CMB_lensing) &
                max_bessels_etak = max(max_bessels_etak, min(CP%Max_eta_k, &
                ell_needed * 25._dl * CP%Accuracy%AccuracyBoost))
        else
            max_bessels_etak = max(max_bessels_etak, WindowKmaxForL(W,CP,ell_needed)*State%tau0)
        end if

        if (ThisCT%limber_l_min(s_ix)/=0) then
            s_ix_lens = 0
            if (i == 0) then
                n1 = State%TimeSteps%IndexOf(State%tau_maxvis)
                n2 = State%TimeSteps%npoints - 1
            else
                n1 = State%TimeSteps%IndexOf(W%tau_start)
                if (W%kind == window_lensing .or. W%kind == window_counts &
                    .and. CP%SourceTerms%counts_lensing) then
                    n2 = State%TimeSteps%npoints - 1
                else
                    n2 = min(State%TimeSteps%npoints - 1, State%TimeSteps%IndexOf(W%tau_end))
                end if
                if (W%kind == window_counts .and. CP%SourceTerms%counts_lensing) then
                    s_ix_lens = 3 + W%mag_index + State%num_redshiftwindows
                end if
            end if

            do ell = ThisCT%limber_l_min(s_ix), ThisCT%ls%nl
                LimbRec => ThisCT%Limber_windows(s_ix,ell)
                LimbRec%n1 = n1
                LimbRec%n2 = n2
                reall = ThisCT%ls%l(ell)

                allocate(LimbRec%k(n1:n2))
                allocate(LimbRec%Source(n1:n2))

                int = 0
                do n = n1,n2
                    chi = (State%tau0-State%TimeSteps%points(n))
                    k = (reall + 0.5_dl) / chi
                    LimbRec%k(n) = k
                    if (k<=qmax) then
                        klo = ThisSources%Evolve_q%IndexOf(k)
                        khi=klo+1
                        ho=ThisSources%Evolve_q%points(khi)-ThisSources%Evolve_q%points(klo)
                        a0=(ThisSources%Evolve_q%points(khi)-k)/ho
                        b0=(k-ThisSources%Evolve_q%points(klo))/ho
                        ho2o6 = ho**2/6
                        a03=(a0**3-a0)
                        b03=(b0**3-b0)

                        LimbRec%Source(n)= sqrt(chi*State%TimeSteps%dpoints(n))* (a0*ScaledSrc(klo,s_ix,n)+&
                            b0*ScaledSrc(khi,s_ix,n)+(a03 *ddScaledSrc(klo,s_ix,n)+ b03*ddScaledSrc(khi,s_ix,n)) *ho2o6)
                        if (s_ix_lens>0) then
                            LimbRec%Source(n) = LimbRec%Source(n) + reall * (reall + 1) * &
                                sqrt(chi * State%TimeSteps%dpoints(n)) * (a0 * ScaledSrc(klo, s_ix_lens, n) + &
                                b0 * ScaledSrc(khi, s_ix_lens, n) + (a03 * ddScaledSrc(klo, s_ix_lens, n) + &
                                b03 * ddScaledSrc(khi, s_ix_lens, n)) * ho2o6)
                        end if
                    else
                        LimbRec%Source(n)=0
                    end if
                end do
            end do
        else
            max_bessels_l_index = ThisCT%ls%nl
        end if
    end do

    end subroutine GetLimberTransfers

    subroutine SourceToTransfers(ThisCT, q_ix)
    type(ClTransferData), target :: ThisCT 
    integer q_ix
    type(IntegrationVars) :: IV

    allocate(IV%Source_q(State%TimeSteps%npoints,ThisSources%SourceNum))
    if (.not.State%flat) allocate(IV%ddSource_q(State%TimeSteps%npoints,ThisSources%SourceNum))

    call IntegrationVars_init(IV)

    IV%q_ix = q_ix
    IV%q =ThisCT%q%points(q_ix)
    IV%dq= ThisCT%q%dpoints(q_ix)

    call InterpolateSources(IV)

    call DoSourceIntegration(IV, ThisCT)

    if (.not.State%flat) deallocate(IV%ddSource_q)
    deallocate(IV%Source_q)

    end subroutine SourceToTransfers


    subroutine InitTransfer
    integer nu,lastnu, ntodo, nq, q_ix, first_i
    real(dl) dlog_lowk1,dlog_lowk, d_osc,dlog_osc, dlog_highk, boost
    real(dl) amin,q_switch_lowk,q_switch_lowk1,q_switch_osc,q_switch_highk
    real(dl), dimension(:), allocatable :: q_transfer
    Type(MatterTransferData), pointer :: MT
    real(dl) k_per_logint

    MT => State%MT
    if (CP%Transfer%k_per_logint==0 .or. State%needs_good_pk_sampling) then
        !Optimized spacing
        !Large log spacing on superhorizon scales
        !Linear spacing for horizon scales and first few baryon oscillations
        !Log spacing for last few oscillations
        !large log spacing for small scales
        !All have at least k_per_logint steps per log k

        boost = CP%Accuracy%AccuracyBoost * CP%Accuracy%TransferkBoost
        k_per_logint =CP%Transfer%k_per_logint
        if (CP%Transfer%high_precision) boost = boost*1.5

        q_switch_lowk1 = 0.7/State%taurst
        dlog_lowk1=max(2*boost, k_per_logint)

        q_switch_lowk = 8/State%taurst
        dlog_lowk=max(8*boost*2.5, k_per_logint)

        q_switch_osc = min(CP%Transfer%kmax,30/State%taurst)
        d_osc= 200*boost*1.8

        if (CP%Transfer%k_per_logint>0) then
            ! only keep linear steps where smaller than needed for k_per_logint
            q_switch_lowk =  min(q_switch_osc, max(q_switch_lowk,  &
                1/d_osc/(exp(1./k_per_logint)-1)))
        end if

        dlog_osc = max(17*boost, k_per_logint)
        q_switch_highk = min(CP%Transfer%kmax,90/State%taurst)

        !Then up to kmax
        dlog_highk = max(3*boost,k_per_logint)

        amin = 5e-5_dl

        nq=int((log(CP%Transfer%kmax/amin))*max(d_osc, k_per_logint))+1
        allocate(q_transfer(nq))

        nq=int((log(q_switch_lowk1/amin))*dlog_lowk1)+1
        do q_ix=1, nq
            q_transfer(q_ix) = amin*exp((q_ix-1)/dlog_lowk1)
        end do
        MT%num_q_trans = nq

        nq=int(log( q_switch_lowk/q_transfer(MT%num_q_trans))*dlog_lowk) +1
        do q_ix=1, nq
            q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)*exp(q_ix/dlog_lowk)
        end do
        MT%num_q_trans = MT%num_q_trans + nq

        if (q_switch_osc> q_switch_lowk) then
            nq=int((q_switch_osc-q_transfer(MT%num_q_trans))*d_osc)+1
            do q_ix=1, nq
                q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)+ q_ix/d_osc
            end do
            MT%num_q_trans = MT%num_q_trans + nq
        end if

        if (CP%Transfer%kmax > q_transfer(MT%num_q_trans)) then
            nq=int(log( q_switch_highk/q_transfer(MT%num_q_trans))*dlog_osc) +1
            do q_ix=1, nq
                q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)*exp(q_ix/dlog_osc)
            end do
            MT%num_q_trans = MT%num_q_trans + nq
        end if

        if (CP%Transfer%kmax > q_transfer(MT%num_q_trans)) then
            nq=int(log(CP%Transfer%kmax/q_transfer(MT%num_q_trans))*dlog_highk)+1
            dlog_highk = nq/log(CP%Transfer%kmax*1.05/q_transfer(MT%num_q_trans)) !Don't go more than 5% past kmax
            do q_ix=1, nq
                q_transfer(MT%num_q_trans+q_ix) = q_transfer(MT%num_q_trans)*exp(q_ix/dlog_highk)
            end do
            MT%num_q_trans = MT%num_q_trans + nq
        end if

    else
        !Fixed spacing
        MT%num_q_trans=int((log(CP%Transfer%kmax)-log(qmin))*CP%Transfer%k_per_logint)+1
        allocate(q_transfer(MT%num_q_trans))
        do q_ix=1, MT%num_q_trans
            q_transfer(q_ix) = qmin*exp(real(q_ix,dl)/CP%Transfer%k_per_logint)
        end do
    end if

    if (State%closed) then
        lastnu=0
        ntodo = 0
        do q_ix=1,MT%num_q_trans
            nu =nint(State%curvature_radius*q_transfer(q_ix))
            if (.not. ((nu<3).or.(nu<=lastnu))) then
                ntodo=ntodo+1
                q_transfer(ntodo)= nu/State%curvature_radius
                lastnu=nu
            end if
        end do
        MT%num_q_trans = ntodo
    end if

    if (CP%WantCls) then
        ntodo = MT%num_q_trans
        first_i = ntodo+1
        n_source_points = ThisSources%Evolve_q%npoints

        do q_ix = 1,ntodo
            if (q_transfer(q_ix) > ThisSources%Evolve_q%highest+1d-4) then
                !Feb13 fix for case with closed universe where qmax is not neccessarily right quantized value
                !   if (q_transfer(q_ix) > qmax) then
                first_i=q_ix
                exit
            end if
        end do

        if (first_i > ntodo) then
            MT%num_q_trans = ThisSources%Evolve_q%npoints
        else
            MT%num_q_trans = ThisSources%Evolve_q%npoints + (ntodo - first_i+1)
        end if
        call Transfer_Allocate(MT,State)

        MT%q_trans(1:n_source_points) = ThisSources%Evolve_q%points(1:n_source_points)
        if (MT%num_q_trans > n_source_points) then
            MT%q_trans(n_source_points+1:MT%num_q_trans) = q_transfer(first_i:ntodo)
        end if
    else
        n_source_points = 0
        call Transfer_Allocate(MT,State)
        MT%q_trans = q_transfer(1:MT%num_q_trans)
    end if

    deallocate(q_transfer)

    end subroutine InitTransfer

    function GetTauStart(q)
    real(dl), intent(IN) :: q
    real(dl) taustart, GetTauStart

    !     Begin when wave is far outside horizon.
    !     Conformal time (in Mpc) in the radiation era, for photons plus 3 species
    !     of relativistic neutrinos.
    if (State%flat) then
        taustart=0.001_dl/q
    else
        taustart=0.001_dl/sqrt(q**2-State%curv)
    end if

    !     Make sure to start early in the radiation era.
    taustart=min(taustart,0.1_dl)

    !     Start when massive neutrinos are strongly relativistic.
    if (CP%Num_nu_massive>0 .and. any(State%nu_masses(1:CP%Nu_mass_eigenstates)/=0)) then
        taustart=min(taustart,1.d-3/maxval(State%nu_masses(1:CP%Nu_mass_eigenstates))/State%adotrad)
    end if

    GetTauStart=taustart
    end function GetTauStart

    subroutine DoSourcek(EV,q_ix)
    integer q_ix
    real(dl) taustart
    type(EvolutionVars) EV

    EV%q=ThisSources%Evolve_q%points(q_ix)

    EV%q2=EV%q**2

    EV%q_ix = q_ix
    EV%TransferOnly=.false.

    EV%ThermoData => State%ThermoData

    taustart = GetTauStart(EV%q)

    call GetNumEqns(EV)

    if (CP%WantScalars .and. global_error_flag==0) call CalcScalarSources(EV,taustart)
    if (CP%WantVectors .and. global_error_flag==0) call CalcVectorSources(EV,taustart)
    if (CP%WantTensors .and. global_error_flag==0) call CalcTensorSources(EV,taustart)

    end subroutine DoSourcek

    subroutine GetSourceMem
    integer :: err

    if (CP%WantScalars) then
        if (WantLateTime) then
            ThisSources%SourceNum=3
            State%Scalar_C_last = C_PhiE
            ThisSources%NonCustomSourceNum=ThisSources%SourceNum + State%num_redshiftwindows + &
                State%num_extra_redshiftwindows
            ThisSources%SourceNum = ThisSources%NonCustomSourceNum + CP%CustomSources%num_custom_sources
        else
            ThisSources%SourceNum=2
            ThisSources%NonCustomSourceNum = ThisSources%SourceNum
            State%Scalar_C_last = C_Cross
        end if
    else
        ThisSources%SourceNum=3
        ThisSources%NonCustomSourceNum = ThisSources%SourceNum
    end if

    if (allocated(ThisSources%LinearSrc)) &
        deallocate(ThisSources%LinearSrc)
    allocate(ThisSources%LinearSrc(ThisSources%Evolve_q%npoints,&
        ThisSources%SourceNum,State%TimeSteps%npoints), source=0._dl, stat=err)
    if (err/=0) call GlobalError('Sources requires too much memory to allocate', &
        error_unsupported_params)                                                                               

    end subroutine GetSourceMem



    !  initial variables, number of steps, etc.
    subroutine InitVars(state)
    type(CAMBdata) :: state
    real(dl) taumin, maxq, initAccuracyBoost
    integer itf

    call SetActiveState(state)

    initAccuracyBoost = CP%Accuracy%AccuracyBoost * CP%Accuracy%TimeStepBoost

    ! Maximum and minimum k-values.
    if (State%flat) then
        qmax=maximum_qeta/State%tau0
        qmin=qmin0/State%tau0/initAccuracyBoost
    else
        qmax=maximum_qeta/State%curvature_radius/State%chi0
        qmin=qmin0/State%curvature_radius/State%chi0/initAccuracyBoost
    end if
    !     Timesteps during recombination (tentative, the actual
    !     timestep is the minimum between this value and taurst/40,
    !     where taurst is the time when recombination starts - see inithermo

    dtaurec_q=4/qmax/initAccuracyBoost
    if (.not. State%flat) dtaurec_q=dtaurec_q/6
    !AL:Changed Dec 2003, dtaurec feeds back into the non-flat integration via the step size
    State%dtaurec = dtaurec_q
    !dtau rec may be changed by ThermoData_init

    max_etak_tensor = initAccuracyBoost*maximum_qeta /10
    max_etak_scalar = initAccuracyBoost*max(1700._dl,maximum_qeta) /20
    if (maximum_qeta <3500 .and. CP%Accuracy%AccuracyBoost < 2) max_etak_scalar = max_etak_scalar * 1.5
    !tweak to get large scales right
    max_etak_vector = max_etak_scalar

    if (CP%WantCls) then
        maxq = qmax
    else
        maxq=CP%Transfer%kmax
    end if
    if (CP%WantTransfer .and. CP%Transfer%k_per_logint==0) then
        maxq = max(maxq, CP%Transfer%kmax*1.05)
    elseif (CP%WantTransfer .and. CP%Transfer%k_per_logint/=0) then
        maxq = max(maxq, CP%Transfer%kmax*exp(1._dl/CP%Transfer%k_per_logint))
    end if

    taumin=GetTauStart(maxq)

    !     Initialize baryon temperature and ionization fractions vs. time.
    !     This subroutine also fixes the timesteps where the sources are
    !     saved in order to do the integration. So TimeSteps is set here.
    !These routines in ThermoData (modules.f90)
    call State%ThermoData%Init(State,taumin)
    if (global_error_flag/=0) return

    if (DebugMsgs .and. Feedbacklevel > 0) write (*,*) 'ThermoData.Init'

    !Do any array initialization for propagation equations
    call GaugeInterface_Init

    if (Feedbacklevel > 0)  &
        write(*,'("tau_recomb/Mpc       = ",f7.2,"  tau_now/Mpc = ",f8.1)') State%tau_maxvis,State%tau0

    do itf=1, State%num_redshiftwindows
        associate (Win => State%Redshift_w(itf))
            if (Feedbacklevel > 0) &
                write(*,'("z = ", f7.2,"  tau = ",f8.1,"  chi = ",f8.1, " tau_min =",f7.1, " tau_max =",f7.1)') &
                Win%Redshift, Win%tau,Win%chi0, Win%tau_start,Win%tau_end
        end associate
    end do

    ! Calculating the times for the outputs of the transfer functions.
    if (CP%WantTransfer .or. .not. allocated(State%Transfer_times)) then
        if (allocated(State%Transfer_times)) deallocate(State%Transfer_times)
        !allocate even if no transfer to prevent debugging access errors
        allocate(State%Transfer_Times(0:State%num_transfer_redshifts+1))
        if (CP%WantTransfer) &
            call State%TimeOfzArr(State%Transfer_times(1:),  State%Transfer_redshifts, State%num_transfer_redshifts)
    endif

    end subroutine InitVars

    subroutine SetkValuesForSources
    implicit none
    real(dl) dlnk0, dkn1, dkn2, q_switch, q_cmb, dksmooth
    real(dl) qmax_log
    real(dl) SourceAccuracyBoost
    !     set k values for which the sources for the anisotropy and
    !     polarization will be calculated. For low values of k we
    !     use a logarithmic spacing. closed case dealt with by SetClosedkValues

    SourceAccuracyBoost = CP%Accuracy%AccuracyBoost * CP%Accuracy%SourcekAccuracyBoost
    if (CP%WantScalars .and. CP%Reion%Reionization .and. CP%Accuracy%AccuratePolarization) then
        dlnk0=2._dl/10/SourceAccuracyBoost
        !Need this to get accurate low l polarization
    else
        dlnk0=5._dl/10/SourceAccuracyBoost
        if (State%closed) dlnk0=dlnk0/2
    end if

    if (CP%Accuracy%AccurateReionization) dlnk0 = dlnk0/2

    dkn1=0.6_dl/State%taurst/SourceAccuracyBoost
    dkn2=0.9_dl/State%taurst/SourceAccuracyBoost/1.2
    if (CP%WantTensors .or. CP%WantVectors) then
        dkn1=dkn1  *0.8_dl
        dlnk0=dlnk0/2 !*0.3_dl
        dkn2=dkn2*0.85_dl
    end if

    qmax_log = dkn1/dlnk0
    q_switch = 2*6.3/State%taurst
    !Want linear spacing for wavenumbers which come inside horizon
    !Could use sound horizon, but for tensors that is not relevant

    q_cmb = 2*l_smooth_sample/State%chi0*SourceAccuracyBoost  !assume everything is smooth at l > l_smooth_sample
    if (CP%Want_CMB .and. maximum_l > 5000 .and. CP%Accuracy%AccuratePolarization) q_cmb = q_cmb*1.4
    q_cmb = max(q_switch*2, q_cmb)
    !prevent EE going wild in tail
    dksmooth = q_cmb/2/(SourceAccuracyBoost)**2
    if (CP%Want_CMB) dksmooth = dksmooth/6

    associate(Evolve_q => ThisSources%Evolve_q)
        call Evolve_q%Init()
        call Evolve_q%Add_delta(qmin, qmax_log, dlnk0, IsLog = .true.)
        if (qmax > qmax_log) &
            call Evolve_q%Add_delta(qmax_log, min(qmax,q_switch), dkn1)
        if (qmax > q_switch) then
            call Evolve_q%Add_delta(q_switch, min(q_cmb,qmax), dkn2)
            if (qmax > q_cmb) then
                dksmooth = log(1 + dksmooth/q_cmb)
                call Evolve_q%Add_delta(q_cmb, qmax, dksmooth, IsLog = .true.)
            end if
        end if

        call Evolve_q%GetArray(.false.)

        if (State%closed) call SetClosedkValuesFromArr(Evolve_q, .false.)
    end associate

    end subroutine SetkValuesForSources


    subroutine SetClosedkValuesFromArr(R, forInt)
    type(TRanges), intent(inout) :: R
    integer i,nu,lastnu,nmax
    !nu = 3,4,5... in State%closed case, so set nearest integers from arr array
    logical, intent(in) :: forInt
    integer ix
    real(dl) dnu
    integer, allocatable :: nu_array(:)

    if (forInt .and. nint(R%points(1)*State%curvature_radius)<=3) then
        !quantization is important
        call R%Getdpoints(half_ends = .false.)
        R%dpoints = max(1,int(R%dpoints*State%curvature_radius+0.02))
        lastnu=2
        ix=1
        dnu =R%dpoints(ix)
        nmax=0
        lastnu=2
        allocate(nu_array(R%npoints*2))
        do
            do while (R%dpoints(ix)==dnu .and. ix <R%npoints)
                ix=ix+1
            end do
            do nu=lastnu+1,nint(R%points(ix)*State%curvature_radius), nint(dnu)
                nmax=nmax+1
                nu_array(nmax)= nu
            end do
            lastnu=nu_array(nmax) + nint(dnu)-1
            if (ix==R%npoints) exit
            dnu = R%dpoints(ix)
        end do
        if (nint(R%points(R%npoints)*State%curvature_radius) > nu_array(nmax)) then
            nmax=nmax+1
            nu_array(nmax) = nint(R%points(R%npoints)*State%curvature_radius)
        end if
        deallocate(R%points)
        allocate(R%points(nmax))
        R%points = nu_array(1:nmax)/State%curvature_radius
        deallocate(nu_array)
    else
        lastnu=3
        nmax=1

        do i=2,R%npoints
            nu=nint(R%points(i)*State%curvature_radius)
            if (nu > lastnu) then
                nmax=nmax+1
                lastnu=nu
                R%points(nmax)=nu/State%curvature_radius
            end if
        end do
        R%points(1)=3/State%curvature_radius
    end if

    R%Lowest = R%points(1)
    R%Highest = R%points(nmax)
    R%npoints=nmax

    end subroutine SetClosedkValuesFromArr

    subroutine CalcScalarSources(EV,taustart)
    use FileUtils
    use MpiUtils
    implicit none
    type(EvolutionVars) EV
    real(dl) tau,tol1,tauend, taustart
    integer j,ind,itf
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar), sources(ThisSources%SourceNum)

    w=0
    y=0
    call initial(EV,y, taustart)
    if (global_error_flag/=0) return

    tau=taustart
    ind=1

    !     Begin timestep loop.
    itf=1
    tol1=tol/exp(CP%Accuracy%AccuracyBoost*CP%Accuracy%IntTolBoost-1)
    if (CP%WantTransfer) then
        if  (CP%Transfer%high_precision) tol1=tol1/100
        do while (itf <= State%num_transfer_redshifts .and. State%TimeSteps%points(2) > State%Transfer_Times(itf))
            !Just in case someone wants to get the transfer outputs well before recombination
            call GaugeInterface_EvolveScal(EV,tau,y,State%Transfer_Times(itf),tol1,ind,c,w)
            if (global_error_flag/=0) return
            call outtransf(EV,y, tau, State%MT%TransferData(:,EV%q_ix,itf))
            itf = itf+1
        end do
    end if

    do j=2,State%TimeSteps%npoints
        tauend=State%TimeSteps%points(j)

        if (.not. DebugEvolution .and. (EV%q*tauend > max_etak_scalar .and. tauend > State%taurend) &
            .and. .not. WantLateTime .and. (.not.CP%WantTransfer.or.tau > State%Transfer_Times(State%num_transfer_redshifts))) then
            ThisSources%LinearSrc(EV%q_ix,:,j)=0
        else
            !Integrate over time, calulate end point derivs and calc output
            call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
            if (global_error_flag/=0) return

            call output(EV,y,j, tau,sources, CP%CustomSources%num_custom_sources)
            ThisSources%LinearSrc(EV%q_ix,:,j)=sources

            !     Calculation of transfer functions.
101         if (CP%WantTransfer.and.itf <= State%num_transfer_redshifts) then
                if (j < State%TimeSteps%npoints) then
                    if (tauend < State%Transfer_Times(itf) .and. State%TimeSteps%points(j+1)  > State%Transfer_Times(itf)) then
                        call GaugeInterface_EvolveScal(EV,tau,y,State%Transfer_Times(itf),tol1,ind,c,w)
                        if (global_error_flag/=0) return
                    endif
                end if
                !     output transfer functions for this k-value.

                if (abs(tau-State%Transfer_Times(itf)) < 1.e-5_dl .or. j==State%TimeSteps%npoints) then
                    call outtransf(EV,y, tau, State%MT%TransferData(:,EV%q_ix,itf))
                    itf=itf+1
                    if (j < State%TimeSteps%npoints) then
                        if (itf <= State%num_transfer_redshifts.and. &
                            State%TimeSteps%points(j+1) > State%Transfer_Times(itf)) goto 101
                    else
                        if (abs(tau-State%Transfer_Times(itf-1)) > 5.e-5_dl) then
                            write(*,*) 'WARNING: mismatch in integrated times (CAMB: CalcScalarSources)'
                        end if
                    end if
                endif
            end if
        end if
    end do !time step loop

    end subroutine CalcScalarSources


    subroutine CalcTensorSources(EV,taustart)
    implicit none
    type(EvolutionVars) EV
    real(dl) tau,tol1,tauend, taustart
    integer j,ind
    real(dl) c(24),wt(EV%nvart,9), yt(EV%nvart)

    call initialt(EV,yt, taustart)

    tau=taustart
    ind=1
    tol1=tol/exp(CP%Accuracy%AccuracyBoost*CP%Accuracy%IntTolBoost-1)

    !     Begin timestep loop.
    do j=2,State%TimeSteps%npoints
        tauend=State%TimeSteps%points(j)
        if (EV%q*tauend > max_etak_tensor) then
            ThisSources%LinearSrc(EV%q_ix,:,j) = 0
        else
            call GaugeInterface_EvolveTens(EV,tau,yt,tauend,tol1,ind,c,wt)

            call outputt(EV,yt,EV%nvart,tau,ThisSources%LinearSrc(EV%q_ix,CT_Temp,j),&
                ThisSources%LinearSrc(EV%q_ix,CT_E,j),ThisSources%LinearSrc(EV%q_ix,CT_B,j))
        end if
    end do

    end subroutine CalcTensorSources


    subroutine CalcVectorSources(EV,taustart)
    implicit none
    type(EvolutionVars) EV
    real(dl) tau,tol1,tauend, taustart
    integer j,ind
    real(dl) c(24),wt(EV%nvarv,9), yv(EV%nvarv)

    call initialv(EV,yv, taustart)

    tau=taustart
    ind=1
    tol1=tol*0.01/exp(CP%Accuracy%AccuracyBoost*CP%Accuracy%IntTolBoost-1)


    !     Begin timestep loop.
    do j=2,State%TimeSteps%npoints
        tauend=State%TimeSteps%points(j)

        if ( EV%q*tauend > max_etak_vector) then
            ThisSources%LinearSrc(EV%q_ix,:,j) = 0
        else
            call dverk(EV,EV%nvarv,derivsv,tau,yv,tauend,tol1,ind,c,EV%nvarv,wt) !tauend

            call outputv(EV,yv,EV%nvarv,tau,ThisSources%LinearSrc(EV%q_ix,CT_Temp,j),&
                ThisSources%LinearSrc(EV%q_ix,CT_E,j),ThisSources%LinearSrc(EV%q_ix,CT_B,j))
        end if
    end do

    end subroutine CalcVectorSources


    subroutine TransferOut
    !Output transfer functions for k larger than used for C_l computation
    implicit none
    integer q_ix
    real(dl) tau
    type(EvolutionVars) EV


    if (DebugMsgs .and. Feedbacklevel > 0) &
        call WriteFormat('Transfer k values: %d',State%MT%num_q_trans-n_source_points)

    !     loop over wavenumbers.
    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(DYNAMIC), PRIVATE(EV, tau, q_ix)
    do q_ix=State%MT%num_q_trans, n_source_points+1, -1
        EV%TransferOnly=.true. !in case we want to do something to speed it up

        EV%q= State%MT%q_trans(q_ix)

        EV%q2=EV%q**2
        EV%q_ix = q_ix
        EV%ThermoData => State%ThermoData

        tau = GetTauStart(EV%q)

        call GetNumEqns(EV)

        call GetTransfer(EV, tau)
    end do
    !$OMP END PARALLEL DO

    end subroutine TransferOut

    subroutine GetTransfer(EV,tau)
    type(EvolutionVars) EV
    real(dl) tau
    integer ind, i
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar)
    real(dl) atol

    atol=tol/exp(CP%Accuracy%AccuracyBoost*CP%Accuracy%IntTolBoost-1)
    if (CP%Transfer%high_precision) atol=atol/10000 !CHECKTHIS

    ind=1
    call initial(EV,y, tau)
    if (global_error_flag/=0) return

    do i=1,State%num_transfer_redshifts
        call GaugeInterface_EvolveScal(EV,tau,y,State%Transfer_Times(i),atol,ind,c,w)
        if (global_error_flag/=0) return
        call outtransf(EV,y,tau,State%MT%TransferData(:,EV%q_ix,i))
    end do

    end subroutine GetTransfer


    subroutine MakeNonlinearSources
    !Scale lensing and any other source terms by non-linear scaling at each redshift and wavenumber
    use NonLinear
    integer i,ik,first_step
    real (dl) tau
    real(dl) scaling(State%num_transfer_redshifts), ddScaling(State%num_transfer_redshifts)
    real(dl) ho,a0,b0, ascale
    integer tf_lo, tf_hi

    if (allocated(State%CAMB_Pk)) deallocate(State%CAMB_PK)
    allocate(State%CAMB_PK)
    call Transfer_GetMatterPowerData(State, State%MT, State%CAMB_PK)

    call CP%NonLinearModel%GetNonLinRatios(State, State%CAMB_PK)
    first_step=1
    do while(State%TimeSteps%points(first_step) < State%Transfer_Times(1))
        first_step = first_step + 1
    end do
    allocate(ScaledSrc, source = ThisSources%LinearSrc)

    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), &
    !$OMP & PRIVATE(i, scaling, ddScaling, tf_lo, tf_hi, tau, ho, a0, b0, ascale)
    do ik=1, ThisSources%Evolve_q%npoints
        if (CP%Do21cm) then
            ScaledSrc(ik, 4:, :) = ScaledSrc(ik, 4:, :) * State%CAMB_Pk%nonlin_ratio(ik,1)
        elseif (ThisSources%Evolve_q%points(ik)/(CP%H0/100) >  CP%NonLinearModel%Min_kh_nonlinear) then
            !Interpolate non-linear scaling in conformal time
            !Do not use an associate for scaling. It does not work.
            scaling = State%CAMB_Pk%nonlin_ratio(ik,1:State%num_transfer_redshifts)
            if (all(abs(scaling-1) < 5e-4)) cycle
            call spline_def(State%Transfer_Times, scaling, State%num_transfer_redshifts,ddScaling)

            tf_lo=1
            tf_hi=tf_lo+1

            do i= first_step, State%TimeSteps%npoints-1
                tau = State%TimeSteps%points(i)

                do while (tau > State%Transfer_Times(tf_hi))
                    tf_lo = tf_lo + 1
                    tf_hi = tf_hi + 1
                end do

                ho=State%Transfer_Times(tf_hi)-State%Transfer_Times(tf_lo)
                a0=(State%Transfer_Times(tf_hi)-tau)/ho
                b0=1-a0

                ascale = a0*scaling(tf_lo)+ b0*scaling(tf_hi)+&
                    ((a0**3-a0)* ddscaling(tf_lo) &
                    +(b0**3-b0)*ddscaling(tf_hi))*ho**2/6

                ScaledSrc(ik,3:,i) = ScaledSrc(ik,3:,i) * ascale
            end  do
        end if
    end do
    !$OMP END PARALLEL DO

    end subroutine MakeNonlinearSources


    subroutine InitSourceInterpolation
    integer i,j
    !     get the interpolation matrix for the sources to interpolate them
    !     for other k-values

    if (allocated(ddScaledSrc)) deallocate(ddScaledSrc)
    allocate(ddScaledSrc(ThisSources%Evolve_q%npoints,ThisSources%SourceNum,State%TimeSteps%npoints))
    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC), PRIVATE(i,j)
    do  i=1,State%TimeSteps%npoints
        do j=1, ThisSources%SourceNum
            call spline_def(ThisSources%Evolve_q%points,ScaledSrc(:,j,i), &
                ThisSources%Evolve_q%npoints, ddScaledSrc(:,j,i))
        end do
    end do
    !$OMP END PARALLEL DO

    end subroutine InitSourceInterpolation


    subroutine SetkValuesForInt(ThisCT)
    Type(ClTransferData) :: ThisCT 
    integer no
    real(dl) dk,dk0,dlnk1, dk2, max_k_dk, k_max_log, k_max_0
    integer lognum
    real(dl)  qmax_int,IntSampleBoost


    qmax_int = min(qmax,max_bessels_etak/State%tau0)

    IntSampleBoost=CP%Accuracy%AccuracyBoost*CP%Accuracy%IntkAccuracyBoost
    if (do_bispectrum) then
        IntSampleBoost = IntSampleBoost * 2
        if (hard_bispectrum) IntSampleBoost = IntSampleBoost * 2
    end if

    !     Fixing the # of k for the integration.

    call ThisCT%q%Init()

    if (State%closed.and.ExactClosedSum) then
        call ThisCT%q%Add(3/State%curvature_radius, nint(qmax_int*State%curvature_radius)/State%curvature_radius, &
            nint(qmax_int*State%curvature_radius)-3) !fix jun08
        call Init_ClTransfer(ThisCT)
        call ThisCT%q%Getdpoints(half_ends = .false.) !Jun08
    else
        !Split up into logarithmically spaced intervals from qmin up to k=lognum*dk0
        !then no-lognum*dk0 linearly spaced at dk0 up to no*dk0
        !then at dk up to max_k_dk, then dk2 up to qmax_int
        lognum=nint(10*IntSampleBoost)
        dlnk1=1._dl/lognum
        no=nint(600*IntSampleBoost)
        dk0=1.8_dl/State%curvature_radius/State%chi0/IntSampleBoost
        dk=3._dl/State%curvature_radius/State%chi0/IntSampleBoost/1.6

        k_max_log = lognum*dk0
        k_max_0  = no*dk0

        if (do_bispectrum) k_max_0 = max(10.d0,k_max_0)

        dk2 = 0.04/IntSampleBoost  !very small scales
        if (State%num_redshiftwindows>0) dk2 = dk  !very small scales

        call ThisCT%q%Add_delta(qmin, k_max_log, dlnk1, IsLog = .true.)
        call ThisCT%q%Add_delta(k_max_log, min(qmax_int,k_max_0), dk0)

        if (qmax_int > k_max_0) then
            max_k_dk = max(3000, 2*maximum_l)/State%tau0

            call ThisCT%q%Add_delta(k_max_0, min(qmax_int, max_k_dk), dk)
            if (qmax_int > max_k_dk) then
                !This allows inclusion of high k modes for computing BB lensed spectrum accurately
                !without taking ages to compute.
                call ThisCT%q%Add_delta(max_k_dk, qmax_int, dk2)
            end if
        end if

        call Init_ClTransfer(ThisCT)

        if (State%closed) then
            call SetClosedkValuesFromArr(ThisCT%q,.true.)
            call ThisCT%q%Getdpoints(half_ends = .false.)
            ThisCT%q%dpoints(1) = 1/State%curvature_radius
            deallocate(ThisCT%Delta_p_l_k) !Re-do this from Init_ClTransfer because number of points changed
            allocate(ThisCT%Delta_p_l_k(ThisCT%NumSources, &
                min(ThisCT%max_index_nonlimber,ThisCT%ls%nl), ThisCT%q%npoints))
            ThisCT%Delta_p_l_k = 0
        end if

    end if !ExactClosedSum


    end subroutine setkValuesForInt

    subroutine InterpolateSources(IV)
    implicit none
    integer i,khi,klo, step
    real(dl) xf,b0,ho,a0,ho2o6,a03,b03
    type(IntegrationVars) IV
    Type(TRanges), pointer :: Evolve_q

    Evolve_q => ThisSources%Evolve_q

    !     finding position of k in table Evolve_q to do the interpolation.

    !Can't use the following in closed case because regions are not set up (only points)
    !           klo = min(Evolve_q%npoints-1,Evolve_q%IndexOf(IV%q))
    !This is a bit inefficient, but thread safe
    klo=1
    do while ((IV%q > Evolve_q%points(klo+1)).and.(klo < (Evolve_q%npoints-1)))
        klo=klo+1
    end do

    khi=klo+1


    ho=Evolve_q%points(khi)-Evolve_q%points(klo)
    a0=(Evolve_q%points(khi)-IV%q)/ho
    b0=(IV%q-Evolve_q%points(klo))/ho
    ho2o6 = ho**2/6
    a03=(a0**3-a0)
    b03=(b0**3-b0)
    IV%SourceSteps = 0

    !     Interpolating the source as a function of time for the present
    !     wavelength.
    step=2
    do i=2, State%TimeSteps%npoints
        xf=IV%q*(State%tau0-State%TimeSteps%points(i))
        if (CP%WantTensors) then
            if (IV%q*State%TimeSteps%points(i) < max_etak_tensor.and. xf > 1.e-8_dl) then
                step=i
                IV%Source_q(i,:) =a0*scaledSrc(klo,:,i)+&
                    b0*scaledSrc(khi,:,i)+(a03 *ddScaledSrc(klo,:,i)+ &
                    b03*ddScaledSrc(khi,:,i)) *ho2o6
            else
                IV%Source_q(i,:) = 0
            end if
        end if
        if (CP%WantVectors) then
            if (IV%q*State%TimeSteps%points(i) < max_etak_vector.and. xf > 1.e-8_dl) then
                step=i
                IV%Source_q(i,:) =a0*ScaledSrc(klo,:,i) + b0*ScaledSrc(khi,:,i)+(a03 *ddScaledSrc(klo,:,i)+ &
                    b03*ddScaledSrc(khi,:,i)) *ho2o6
            else
                IV%Source_q(i,:) = 0
            end if
        end if

        if (CP%WantScalars) then
            if ((DebugEvolution .or. WantLateTime .or. IV%q*State%TimeSteps%points(i) < max_etak_scalar) &
                .and. xf > 1.e-8_dl) then
                step=i
                IV%Source_q(i,:) = a0 * ScaledSrc(klo,:,i) +  b0 * ScaledSrc(khi,:,i) + (a03*ddScaledSrc(klo,:,i) + &
                    b03 * ddScaledSrc(khi,:,i)) * ho2o6
            else
                IV%Source_q(i,:) = 0
            end if
        end if
    end do
    IV%SourceSteps = step

    if (.not.State%flat) then
        do i=1, ThisSources%SourceNum
            call spline_def(State%TimeSteps%points,IV%Source_q(:,i),State%TimeSteps%npoints,&
                IV%ddSource_q(:,i))
        end do
    end if

    end subroutine


    subroutine IntegrationVars_Init(IV)
    type(IntegrationVars), intent(INOUT) :: IV

    IV%Source_q(1,:)=0
    IV%Source_q(State%TimeSteps%npoints,:) = 0
    IV%Source_q(State%TimeSteps%npoints-1,:) = 0

    end  subroutine IntegrationVars_Init


    subroutine DoSourceIntegration(IV, ThisCT) !for particular wave number q
    type(IntegrationVars) IV
    Type(ClTransferData) :: ThisCT    
    integer j,ll,llmax
    real(dl) nu
    real(dl) :: sixpibynu

    nu=IV%q*State%curvature_radius
    sixpibynu  = 6._dl*const_pi/nu

    if (State%closed) then
        if (nu<20 .or. State%tau0/State%curvature_radius+sixpibynu > const_pi/2) then
            llmax=nint(nu)-1
        else
            llmax=nint(nu*State%rofChi(State%tau0/State%curvature_radius + sixpibynu))
            llmax=min(llmax,nint(nu)-1)  !nu >= l+1
        end if
    else
        llmax=nint(nu*State%chi0)
        if (llmax<15) then
            llmax=17 !AL Sept2010 changed from 15 to get l=16 smooth
        else
            llmax=nint(nu*State%rofChi(State%tau0/State%curvature_radius + sixpibynu))
        end if
    end if

    if (State%flat) then
        call DoFlatIntegration(IV,ThisCT, llmax)
    else
        do j=1,ThisCT%ls%nl
            ll=ThisCT%ls%l(j)
            if (ll>llmax) exit
            call IntegrateSourcesBessels(IV,ThisCT,j,ll,nu)
        end do !j loop
    end if

    end subroutine DoSourceIntegration

    function UseLimber(l)
    !Calculate lensing potential power using Limber rather than j_l integration
    !even when sources calculated as part of temperature calculation
    !(Limber better on small scales unless step sizes made much smaller)
    !This affects speed, esp. of non-flat case
    logical :: UseLimber
    integer l

    !note increasing non-limber is not neccessarily more accurate unless AccuracyBoost much higher
    !use **0.5 to at least give some sensitivity to Limber effects
    !Could be lower but care with phi-T correlation at lower L
    if (CP%SourceTerms%limber_windows) then
        UseLimber = l >= CP%SourceTerms%limber_phi_lmin
    else
        UseLimber = l > 400 * (CP%Accuracy%AccuracyBoost * CP%Accuracy%LimberBoost)** 0.5
    end if

    end function UseLimber

    !flat source integration
    subroutine DoFlatIntegration(IV, ThisCT, llmax)
    implicit none
    type(IntegrationVars) IV
    Type(ClTransferData) :: ThisCT 
    integer llmax
    integer j
    logical DoInt
    real(dl) xlim,xlmax1
    real(dl) tmin, tmax
    real(dl) a2, J_l, aa(IV%SourceSteps), fac(IV%SourceSteps)
    real(dl) xf, sums(ThisSources%SourceNum)
    real(dl) qmax_int
    integer bes_ix,n, bes_index(IV%SourceSteps)
    integer custom_source_off, s_ix
    integer nwin
    real(dl) :: BessIntBoost

    BessIntBoost = CP%Accuracy%AccuracyBoost*CP%Accuracy%BessIntBoost
    custom_source_off = State%num_redshiftwindows + State%num_extra_redshiftwindows + 4

    !     Find the position in the xx table for the x correponding to each
    !     timestep

    do j=1,IV%SourceSteps !Precompute arrays for this k
        xf=abs(IV%q*(State%tau0-State%TimeSteps%points(j)))
        bes_index(j)=BessRanges%IndexOf(xf)
        !Precomputed values for the interpolation
        bes_ix= bes_index(j)
        fac(j)=BessRanges%points(bes_ix+1)-BessRanges%points(bes_ix)
        aa(j)=(BessRanges%points(bes_ix+1)-xf)/fac(j)
        fac(j)=fac(j)**2*aa(j)/6
    end do

    do j=1,max_bessels_l_index
        if (ThisCT%ls%l(j) > llmax) return
        xlim=xlimfrac*ThisCT%ls%l(j)
        xlim=max(xlim,xlimmin)
        xlim=ThisCT%ls%l(j)-xlim
        if (full_bessel_integration .or. do_bispectrum) then
            tmin = State%TimeSteps%points(2)
        else
            xlmax1=80*ThisCT%ls%l(j)*BessIntBoost
            if (State%num_redshiftwindows>0 .and. CP%WantScalars) then
                xlmax1=80*ThisCT%ls%l(j)*8*BessIntBoost !Have to be careful if sharp spikes due to late time sources
            end if
            tmin=State%tau0-xlmax1/IV%q
            tmin=max(State%TimeSteps%points(2),tmin)
        end if
        tmax=State%tau0-xlim/IV%q
        tmax=min(State%tau0,tmax)
        tmin=max(State%TimeSteps%points(2),tmin)
        if (.not. CP%Want_CMB .and. .not. CP%Want_CMB_lensing) &
            tmin = max(tmin, State%ThermoData%tau_start_redshiftwindows)


        if (tmax < State%TimeSteps%points(2)) exit
        sums = 0

        !As long as we sample the source well enough, it is sufficient to
        !interpolate the Bessel functions only

        if (ThisSources%SourceNum==2) then
            !This is the innermost loop, so we separate the no lensing scalar case to optimize it
            do n= State%TimeSteps%IndexOf(tmin),min(IV%SourceSteps,State%TimeSteps%IndexOf(tmax))
                a2=aa(n)
                bes_ix=bes_index(n)

                J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                    *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac(n)) !cubic spline

                J_l = J_l*State%TimeSteps%dpoints(n)
                sums(1) = sums(1) + IV%Source_q(n,1)*J_l
                sums(2) = sums(2) + IV%Source_q(n,2)*J_l
            end do
        else
            qmax_int= max(850,ThisCT%ls%l(j))*3*BessIntBoost/State%tau0*1.2
            DoInt = .not. CP%WantScalars .or. IV%q < qmax_int
            !Do integral if any useful contribution to the CMB, or large scale effects

            if (DoInt) then
                if (CP%CustomSources%num_custom_sources==0 .and. State%num_redshiftwindows==0) then
                    do n= State%TimeSteps%IndexOf(tmin),min(IV%SourceSteps,State%TimeSteps%IndexOf(tmax))
                        !Full Bessel integration
                        a2=aa(n)
                        bes_ix=bes_index(n)

                        J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                            *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac(n)) !cubic spline
                        J_l = J_l*State%TimeSteps%dpoints(n)

                        !The unwrapped form is faster
                        sums(1) = sums(1) + IV%Source_q(n,1)*J_l
                        sums(2) = sums(2) + IV%Source_q(n,2)*J_l
                        sums(3) = sums(3) + IV%Source_q(n,3)*J_l
                    end do
                else
                    if (State%num_redshiftwindows>0) then
                        nwin = State%TimeSteps%IndexOf(State%ThermoData%tau_start_redshiftwindows)
                    else
                        nwin = State%TimeSteps%npoints+1
                    end if
                    if (CP%CustomSources%num_custom_sources==0) then
                        do n= State%TimeSteps%IndexOf(tmin),min(IV%SourceSteps,State%TimeSteps%IndexOf(tmax))
                            !Full Bessel integration
                            a2=aa(n)
                            bes_ix=bes_index(n)

                            J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                                *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac(n)) !cubic spline
                            J_l = J_l*State%TimeSteps%dpoints(n)

                            !The unwrapped form is faster
                            sums(1) = sums(1) + IV%Source_q(n,1)*J_l
                            sums(2) = sums(2) + IV%Source_q(n,2)*J_l
                            sums(3) = sums(3) + IV%Source_q(n,3)*J_l
                            if (n >= nwin) then
                                do s_ix = 4, ThisSources%SourceNum
                                    sums(s_ix) = sums(s_ix) + IV%Source_q(n,s_ix)*J_l
                                end do
                            end if
                        end do
                    else
                        do n= State%TimeSteps%IndexOf(tmin),min(IV%SourceSteps,State%TimeSteps%IndexOf(tmax))
                            !Full Bessel integration
                            a2=aa(n)
                            bes_ix=bes_index(n)

                            J_l=a2*ajl(bes_ix,j)+(1-a2)*(ajl(bes_ix+1,j) - ((a2+1) &
                                *ajlpr(bes_ix,j)+(2-a2)*ajlpr(bes_ix+1,j))* fac(n)) !cubic spline
                            J_l = J_l*State%TimeSteps%dpoints(n)

                            !The unwrapped form is faster
                            sums(1) = sums(1) + IV%Source_q(n,1)*J_l
                            sums(2) = sums(2) + IV%Source_q(n,2)*J_l
                            sums(3) = sums(3) + IV%Source_q(n,3)*J_l
                            sums(custom_source_off) = sums(custom_source_off) +  IV%Source_q(n,custom_source_off)*J_l
                            if (n >= nwin) then
                                do s_ix = 4, ThisSources%NonCustomSourceNum
                                    sums(s_ix) = sums(s_ix) + IV%Source_q(n,s_ix)*J_l
                                end do
                            end if
                            do s_ix = custom_source_off+1, custom_source_off+CP%CustomSources%num_custom_sources -1
                                sums(s_ix) = sums(s_ix)  + IV%Source_q(n,s_ix)*J_l
                            end do
                        end do
                    end if
                end if
            end if
            if (.not. DoInt .or. UseLimber(ThisCT%ls%l(j)) .and. CP%WantScalars) then
                !Limber approximation for small scale lensing (better than poor version of above integral)
                xf = State%tau0-(ThisCT%ls%l(j)+0.5_dl)/IV%q
                if (xf < State%TimeSteps%Highest .and. xf > State%TimeSteps%Lowest) then
                    n=State%TimeSteps%IndexOf(xf)
                    xf= (xf-State%TimeSteps%points(n))/(State%TimeSteps%points(n+1)-State%TimeSteps%points(n))
                    sums(3) = (IV%Source_q(n,3)*(1-xf) + xf*IV%Source_q(n+1,3))*&
                        sqrt(const_pi/2/(ThisCT%ls%l(j)+0.5_dl))/IV%q
                else
                    sums(3)=0
                end if
            end if
            if (.not. DoInt .and. ThisSources%NonCustomSourceNum>3) then
                if (any(ThisCT%limber_l_min(4:ThisSources%NonCustomSourceNum)==0 .or. &
                    ThisCT%limber_l_min(4:ThisSources%NonCustomSourceNum) > j)) then
                    !When CMB does not need integral but other sources do
                    do n= State%TimeSteps%IndexOf(State%ThermoData%tau_start_redshiftwindows), &
                        min(IV%SourceSteps, State%TimeSteps%IndexOf(tmax))
                        !Full Bessel integration
                        a2 = aa(n)
                        bes_ix = bes_index(n)

                        J_l = a2 * ajl(bes_ix, j) + (1 - a2) * (ajl(bes_ix + 1, j) -&
                            ((a2 + 1) * ajlpr(bes_ix, j) + (2 - a2) * &
                            ajlpr(bes_ix + 1, j)) * fac(n)) !cubic spline
                        J_l = J_l * State%TimeSteps%dpoints(n)

                        sums(4) = sums(4) + IV%Source_q(n, 4) * J_l
                        do s_ix = 5, ThisSources%NonCustomSourceNum
                            sums(s_ix) = sums(s_ix) + IV%Source_q(n, s_ix) * J_l
                        end do
                    end do
                end if
            end if
        end if

        ThisCT%Delta_p_l_k(:,j,IV%q_ix) = ThisCT%Delta_p_l_k(:,j,IV%q_ix) + sums
    end do

    end subroutine DoFlatIntegration



    !non-flat source integration

    subroutine IntegrateSourcesBessels(IV,ThisCT,j,l,nu)
    use SpherBessels
    type(IntegrationVars) IV
    Type(ClTransferData) :: ThisCT 
    logical DoInt
    integer l,j, nstart,nDissipative,ntop,nbot,nrange,nnow
    real(dl) nu,ChiDissipative,ChiStart,tDissipative,y1,y2,y1dis,y2dis
    real(dl) xf,x,chi, miny1
    real(dl) sums(ThisSources%SourceNum),out_arr(ThisSources%SourceNum), qmax_int
    real(dl) BessIntBoost

    BessIntBoost = CP%Accuracy%AccuracyBoost*CP%Accuracy%BessIntBoost

    !Calculate chi where for smaller chi it is dissipative
    x=sqrt(real(l*(l+1),dl))/nu

    ChiDissipative=State%invsinfunc(x)

    ChiStart=ChiDissipative
    !Move down a bit to get smaller value (better accuracy integrating up from small values)
    if (nu<300) ChiStart = max(ChiDissipative-1._dl/nu,1d-6)   !max(ChiDissipative-1._dl/nu,1d-6)

    !Then get nearest source point with lower Chi...
    tDissipative=State%tau0 - State%curvature_radius*ChiStart
    if (tDissipative<State%TimeSteps%points(1)) then
        nDissipative=2
    else
        nDissipative = State%TimeSteps%IndexOf(tDissipative)+1
    endif
    nDissipative=min(nDissipative,State%TimeSteps%npoints-1)

    tDissipative = State%TimeSteps%points(nDissipative)

    ChiStart =  max(1d-8,(State%tau0-tDissipative)/State%curvature_radius)

    !Get values at ChiStart

    call USpherBesselWithDeriv(State%closed,CP,ChiStart,l,nu,y1dis,y2dis)

    nstart=nDissipative
    chi=ChiStart

    if (CP%WantScalars) then !Do Scalars
        if (ThisSources%SourceNum > 3) call MpiStop('Non-flat not implemented for extra sources')
        !Integrate chi down in dissipative region
        ! cuts off when ujl gets small
        miny1= 0.5d-4/l/BessIntBoost
        sums=0
        qmax_int= max(850,ThisCT%ls%l(j))*3*BessIntBoost/(State%chi0*State%curvature_radius)*1.2
        DoInt =  ThisSources%SourceNum/=3 .or. IV%q < qmax_int
        if (DoInt) then
            if ((nstart < min(State%TimeSteps%npoints-1,IV%SourceSteps)).and.(y1dis > miny1)) then
                y1=y1dis
                y2=y2dis
                nnow=nstart
                do nrange = 1,State%TimeSteps%Count
                    if (nrange == State%TimeSteps%count) then
                        ntop = State%TimeSteps%npoints -1
                    else
                        ntop = State%TimeSteps%R(nrange+1)%start_index
                    end if
                    if (nnow < ntop) then
                        call DoRangeInt(IV,chi,ChiDissipative,nnow,ntop,State%TimeSteps%R(nrange)%delta, &
                            nu,l,y1,y2,out_arr)
                        sums  = sums + out_arr
                        nnow = ntop
                        if (chi==0) exit !small enough to cut off
                    end if
                end do
            end if !integrate down chi

            !Integrate chi up in oscillatory region
            if (nstart > 2) then
                y1=y1dis
                y2=y2dis
                chi=ChiStart
                nnow=nstart
                do nrange = State%TimeSteps%Count,1,-1
                    nbot = State%TimeSteps%R(nrange)%start_index
                    if (nnow >  nbot) then
                        call DoRangeInt(IV,chi,ChiDissipative,nnow,nbot,State%TimeSteps%R(nrange)%delta, &
                            nu,l,y1,y2,out_arr)
                        sums=sums+out_arr
                        if (chi==0) exit !small for remaining region
                        nnow = nbot
                    end if
                end do
            end if
        end if !DoInt
        if (ThisSources%SourceNum==3 .and. (.not. DoInt .or. UseLimber(l))) then
            !Limber approximation for small scale lensing (better than poor version of above integral)
            xf = State%tau0-State%invsinfunc((l+0.5_dl)/nu)*State%curvature_radius
            if (xf < State%TimeSteps%Highest .and. xf > State%TimeSteps%Lowest) then
                nbot=State%TimeSteps%IndexOf(xf)
                xf= (xf-State%TimeSteps%points(nbot))/(State%TimeSteps%points(nbot+1)-State%TimeSteps%points(nbot))
                sums(3) = (IV%Source_q(nbot,3)*(1-xf) + xf*IV%Source_q(nbot+1,3))*&
                    sqrt(const_pi/2/(l+0.5_dl)/sqrt(1-State%Ksign*real(l**2)/nu**2))/IV%q
            else
                sums(3) = 0
            end if
        end if

        ThisCT%Delta_p_l_k(:,j,IV%q_ix)=ThisCT%Delta_p_l_k(:,j,IV%q_ix)+sums

    end if !Do Scalars

    if ((CP%WantTensors)) then !Do Tensors
        chi=ChiStart

        !Integrate chi down in dissipative region
        !DoRangeInt cuts off when ujl gets small
        miny1= 1.d-6/l/BessIntBoost
        if ((nstart < State%TimeSteps%npoints-1).and.(y1dis>miny1)) then
            y1=y1dis
            y2=y2dis
            nnow=nstart
            do nrange = 1,State%TimeSteps%Count
                if (nrange == State%TimeSteps%count) then
                    ntop = State%TimeSteps%npoints -1
                else
                    ntop = State%TimeSteps%R(nrange+1)%start_index
                end if
                if (nnow < ntop) then
                    call DoRangeIntTensor(IV,chi,ChiDissipative,nnow,ntop,State%TimeSteps%R(nrange)%delta, &
                        nu,l,y1,y2,out_arr)

                    ThisCT%Delta_p_l_k(:,j,IV%q_ix) = ThisCT%Delta_p_l_k(:,j,IV%q_ix) + out_arr

                    nnow = ntop
                    if (chi==0) exit
                end if
            end do
        end if


        !Integrate chi up in oscillatory region
        if (nstart > 2) then
            y1=y1dis
            y2=y2dis
            chi=ChiStart

            nnow=nstart
            do nrange = State%TimeSteps%Count,1,-1
                nbot = State%TimeSteps%R(nrange)%start_index
                if (nnow >  nbot) then
                    call DoRangeIntTensor(IV,chi,ChiDissipative,nnow,nbot,State%TimeSteps%R(nrange)%delta, &
                        nu,l,y1,y2,out_arr)
                    ThisCT%Delta_p_l_k(:,j,IV%q_ix) = ThisCT%Delta_p_l_k(:,j,IV%q_ix) + out_arr

                    nnow = nbot
                    if (chi==0) exit !small for remaining region
                end if
            end do
        end if

    end if !Do Tensors

    end subroutine IntegrateSourcesBessels



    subroutine DoRangeInt(IV,chi,chiDisp,nstart,nend,dtau,nu,l,y1,y2,out)
    !Non-flat version

    !returns chi at end of integral (where integral stops, not neccessarily end)
    ! This subroutine integrates the source*ujl for steps nstart to nend
    ! It calculates ujl by integrating a second order
    ! differential equation from initial values.
    ! dtau is the spacing of the timesteps (they must be equally spaced)

    use precision
    type(IntegrationVars) IV
    integer l,nIntSteps,nstart,nend,nlowest,isgn,i,is,Startn
    real(dl) nu,dtau,num1,num2,Deltachi,aux1,aux2
    real(dl) a,b,tmpa,tmpb,hh,h6,xh,delchi,taui
    real(dl) nu2,chi,chiDisp,dydchi1,dydchi2,yt1,yt2,dyt1,dyt2,dym1,dym2

    real(dl) tmp,dtau2o6,y1,y2,ap1,sh,ujl,chiDispTop
    real(dl) dchimax,dchisource,sgn,sgndelchi,minujl
    real(dl), parameter:: MINUJl1 = 0.5d-4  !cut-off point for small ujl l=1
    logical Interpolate
    real(dl) scalel
    real(dl) IntAccuracyBoost
    real(dl) sources(ThisSources%SourceNum), out(ThisSources%SourceNum)

    IntAccuracyBoost=CP%Accuracy%AccuracyBoost*CP%Accuracy%NonFlatIntAccuracyBoost

    ! atau0 is the array with the time where the sources are stored.
    if (nend==nstart) then
        out = 0
        return
    end if

    dchisource=dtau/State%curvature_radius

    num1=1._dl/nu

    scalel=l/State%scale
    if (scalel>=2400) then
        num2=num1*2.5
    else if (scalel< 50) then
        num2=num1*0.8_dl
    else
        num2=num1*1.5_dl
    end if
    !Dec 2003, since decrease dtaurec, can make this smaller
    if (dtau==dtaurec_q) then
        num2=num2/4
    end if

    if (scalel<1500 .and. scalel > 150) &
        IntAccuracyBoost=IntAccuracyBoost*(1+(2000-scalel)*0.6/2000 )

    if (num2*IntAccuracyBoost < dchisource .and. (.not. WantLateTime .or. UseLimber(l)) &
        .or. (nstart>IV%SourceSteps.and.nend>IV%SourceSteps)) then
        out = 0
        y1=0._dl !So we know to calculate starting y1,y2 if there is next range
        y2=0._dl
        chi=(State%tau0-State%TimeSteps%points(nend))/State%curvature_radius
        return
    end if

    Startn=nstart
    if (nstart>IV%SourceSteps .and. nend < IV%SourceSteps) then
        chi=(State%tau0-State%TimeSteps%points(IV%SourceSteps))/State%curvature_radius
        Startn=IV%SourceSteps
        call USpherBesselWithDeriv(State%closed,State%CP,chi,l,nu,y1,y2)
    else if ((y2==0._dl).and.(y1==0._dl)) then
        call USpherBesselWithDeriv(State%closed,State%CP,chi,l,nu,y1,y2)
    end if

    if (State%closed) then
        !Need to cut off when ujl gets exponentially small as it approaches Pi
        chiDispTop = const_pi - chiDisp
    else
        chiDispTop = 1d20
    end if

    minujl=MINUJl1/l/IntAccuracyBoost
    isgn=sign(1,Startn-nend)!direction of chi integration
    !higher n, later time, smaller chi

    sgn= isgn

    nlowest=min(Startn,nend)
    aux1=1._dl*State%curvature_radius/dtau  !used to calculate nearest timestep quickly
    aux2=(State%tau0-State%TimeSteps%points(nlowest))/dtau + nlowest

    nu2=nu*nu
    ap1=l*(l+1)
    sh=State%rofChi(chi)

    if (scalel < 1100) then
        dchimax= 0.3*num1
    else if (scalel < 1400) then
        dchimax=0.25_dl*num1 *1.5
    else
        dchimax=0.35_dl*num1 *1.5
    end if

    dchimax=dchimax/IntAccuracyBoost

    ujl=y1/sh
    sources = IV%Source_q(Startn, :)

    out = 0.5_dl*ujl*sources

    Interpolate = dchisource > dchimax
    if (Interpolate) then !split up smaller than source step size
        delchi=dchimax
        Deltachi=sgn*(State%TimeSteps%points(Startn)-State%TimeSteps%points(nend))/State%curvature_radius
        nIntSteps=int(Deltachi/delchi+0.99_dl)
        delchi=Deltachi/nIntSteps
        dtau2o6=(State%curvature_radius*delchi)**2/6._dl
    else !step size is that of source
        delchi=dchisource
        nIntSteps=isgn*(Startn-nend)
    end if

    sgndelchi=delchi*sgn
    tmp=(ap1/sh**2 - nu2)
    hh=0.5_dl*sgndelchi
    h6=sgndelchi/6._dl


    do i=1,nIntSteps
        ! One step in the ujl integration
        ! fourth-order Runge-Kutta method to integrate equation for ujl

        dydchi1=y2         !deriv y1
        dydchi2=tmp*y1     !deriv y2
        xh=chi+hh          !midpoint of step
        yt1=y1+hh*dydchi1  !y1 at midpoint
        yt2=y2+hh*dydchi2  !y2 at midpoint
        dyt1=yt2           !deriv y1 at mid
        tmp=(ap1/State%rofChi(xh)**2 - nu2)


        dyt2=tmp*yt1       !deriv y2 at mid

        yt1=y1+hh*dyt1     !y1 at mid
        yt2=y2+hh*dyt2     !y2 at mid

        dym1=yt2           !deriv y1 at mid
        dym2=tmp*yt1       !deriv y2 at mid
        yt1=y1+sgndelchi*dym1 !y1 at end
        dym1=dyt1+dym1
        yt2=y2+sgndelchi*dym2 !y2 at end
        dym2=dyt2+dym2

        chi=chi+sgndelchi     !end point
        sh=State%rofChi(chi)
        dyt1=yt2           !deriv y1 at end
        tmp=(ap1/sh**2 - nu2)
        dyt2=tmp*yt1       !deriv y2 at end
        y1=y1+h6*(dydchi1+dyt1+2*dym1) !add up
        y2=y2+h6*(dydchi2+dyt2+2*dym2)

        ujl=y1/sh
        if ((isgn<0).and.(y1*y2<0._dl).or.((chi>chiDispTop).and.((chi>3.14).or.(y1*y2>0)))) then
            chi=0._dl
            exit   !If this happens we are small, so stop integration
        end if


        if (Interpolate) then
            ! Interpolate the source
            taui=aux2-aux1*chi
            is=int(taui)
            b=taui-is

            if (b > 0.998) then
                !may save time, and prevents numerical error leading to access violation of IV%Source_q(0)
                sources = IV%Source_q(is+1,:)
            else
                a=1._dl-b
                tmpa=(a**3-a)
                tmpb=(b**3-b)
                sources=a*IV%Source_q(is,:)+b*IV%Source_q(is+1,:)+ &
                    (tmpa*IV%ddSource_q(is,:)+ &
                    tmpb*IV%ddSource_q(is+1,:))*dtau2o6
            end if
        else
            sources = IV%Source_q(Startn - i*isgn,:)
        end if

        out = out + ujl*sources

        if (((isgn<0).or.(chi>chiDispTop)).and.(abs(ujl) < minujl)) then
            chi=0
            exit !break when getting  exponentially small in dissipative region
        end if
    end do

    out = (out - sources*ujl/2)*delchi*State%curvature_radius

    end subroutine DoRangeInt

    subroutine DoRangeIntTensor(IV,chi,chiDisp,nstart,nend,dtau,nu,l,y1,y2,out)
    ! It calculates ujl by integrating a second order
    ! differential equation from initial values for calculating ujl.
    ! nstart and nend are the starting and finishing values of the
    ! integration.
    ! dtau is the spacing of the timesteps (they must be equally spaced)

    type(IntegrationVars), target :: IV
    integer l,nIntSteps,nstart,nend,nlowest,isgn,i,is
    real(dl) nu,dtau,num1,num2,Deltachi,aux1,aux2
    real(dl) a,b,tmpa,tmpb,hh,h6,xh,delchi,taui,scalel
    real(dl) nu2,chi,chiDisp,chiDispTop
    real(dl) dydchi1,dydchi2,yt1,yt2,dyt1,dyt2,dym1,dym2

    real(dl) tmp,dtau2o6,y1,y2,ap1,sh,ujl
    real(dl) dchimax,dchisource,sgn,sgndelchi,minujl
    real(dl), parameter:: MINUJl1 = 1.D-6  !cut-off point for smal ujl l=1
    logical Interpolate
    real(dl) out(ThisSources%SourceNum), source(ThisSources%SourceNum)
    real(dl), dimension(:,:), pointer :: sourcep, ddsourcep
    real(dl) IntAccuracyBoost

    sourcep => IV%Source_q(:,1:)
    ddsourcep => IV%ddSource_q(:,1:)


    if (nend==nstart) then
        out=0
        return
    end if

    IntAccuracyBoost=CP%Accuracy%AccuracyBoost*CP%Accuracy%NonFlatIntAccuracyBoost
    minujl=MINUJL1*IntAccuracyBoost/l
    isgn=sign(1,nstart-nend)!direction of chi integration
    !higher n, later time, smaller chi

    if (State%closed) then
        !Need to cut off when ujl gets exponentially small as it approaches Pi
        chiDispTop = const_pi - chiDisp
    else
        chiDispTop = 1d20
    end if

    num1=1._dl/nu
    dchisource=dtau/State%curvature_radius

    scalel=l/State%scale
    if (scalel>=2000) then
        num2=num1*4
    else if (scalel>=1000) then
        num2=num1*2.5
    else if (scalel< 75) then
        num2=num1*0.1_dl
    else if (scalel<180) then
        num2=num1*0.3_dl
    else if (scalel < 600) then
        num2=num1*0.8_dl
    else
        num2=num1
    end if

    if ((isgn==1).and.(num2*IntAccuracyBoost < dchisource)) then  !Oscillating fast
        out = 0
        y1=0._dl !!So we know to calculate starting y1,y2 if there is next range
        y2=0._dl
        chi=(State%tau0-State%TimeSteps%points(nend))/State%curvature_radius
        return
    end if
    if ((y2==0._dl).and.(y1==0._dl)) call USpherBesselWithDeriv(State%closed,State%CP,chi,l,nu,y1,y2)

    sgn=isgn

    nlowest=min(nstart,nend)
    aux1=1._dl*State%curvature_radius/dtau  !used to calculate nearest timestep quickly
    aux2=(State%tau0-State%TimeSteps%points(nlowest))/dtau + nlowest


    nu2=nu*nu
    ap1=l*(l+1)

    sh=State%rofChi(chi)

    if (scalel < 120) then
        dchimax=0.6_dl*num1
    else if (scalel < 1400) then
        dchimax=0.25_dl*num1
    else
        dchimax=0.35_dl*num1
    end if

    dchimax=dchimax/IntAccuracyBoost

    ujl=y1/sh
    out = ujl * sourcep(nstart,:)/2

    Interpolate = dchisource > dchimax
    if (Interpolate) then !split up smaller than source step size
        delchi=dchimax
        Deltachi=sgn*(State%TimeSteps%points(nstart)-State%TimeSteps%points(nend))/State%curvature_radius
        nIntSteps=int(Deltachi/delchi+0.99_dl)
        delchi=Deltachi/nIntSteps
        dtau2o6=(State%curvature_radius*delchi)**2/6._dl
    else !step size is that of source
        delchi=dchisource
        nIntSteps=isgn*(nstart-nend)
    end if


    sgndelchi=delchi*sgn
    tmp=(ap1/sh**2 - nu2)
    hh=0.5_dl*sgndelchi
    h6=sgndelchi/6._dl


    do i=1,nIntSteps
        ! One step in the ujl integration
        ! fourth-order Runge-Kutta method to integrate equation for ujl

        dydchi1=y2         !deriv y1
        dydchi2=tmp*y1     !deriv y2
        xh=chi+hh          !midpoint of step
        yt1=y1+hh*dydchi1  !y1 at midpoint
        yt2=y2+hh*dydchi2  !y2 at midpoint
        dyt1=yt2           !deriv y1 at mid
        tmp=(ap1/State%rofChi(xh)**2 - nu2)


        dyt2=tmp*yt1       !deriv y2 at mid
        yt1=y1+hh*dyt1     !y1 at mid
        yt2=y2+hh*dyt2     !y2 at mid

        dym1=yt2           !deriv y1 at mid
        dym2=tmp*yt1       !deriv y2 at mid
        yt1=y1+sgndelchi*dym1 !y1 at end
        dym1=dyt1+dym1
        yt2=y2+sgndelchi*dym2 !y2 at end
        dym2=dyt2+dym2

        chi=chi+sgndelchi     !end point
        sh=State%rofChi(chi)
        dyt1=yt2           !deriv y1 at end
        tmp=(ap1/sh**2 - nu2)
        dyt2=tmp*yt1       !deriv y2 at end
        y1=y1+h6*(dydchi1+dyt1+2._dl*dym1) !add up
        y2=y2+h6*(dydchi2+dyt2+2._dl*dym2)

        ujl=y1/sh
        if ((isgn<0).and.(y1*y2<0._dl).or.((chi>chiDispTop).and.((chi>3.14).or.(y1*y2>0)))) then
            chi=0._dl
            exit   !exit because ujl now small
        end if

        if (Interpolate) then
            ! Interpolate the source
            taui=aux2-aux1*chi
            is=int(taui)
            b=taui-is
            if (b > 0.995) then
                !may save time, and prevents numerical error leading to access violation of zero index
                is=is+1
                source = sourcep(is,:)
            else
                a=1._dl-b
                tmpa=(a**3-a)
                tmpb=(b**3-b)
                source = a*sourcep(is,:)+b*sourcep(is+1,:)+ &
                    (tmpa*ddsourcep(is,:) +  tmpb*ddsourcep(is+1,:))*dtau2o6
            end if
        else
            source = sourcep(nstart - i*isgn,:)
        end if
        out = out + source * ujl

        if (((isgn<0).or.(chi>chiDispTop)).and.(abs(ujl) < minujl)) then
            chi=0
            exit  !break when getting  exponentially small in dissipative region
        end if
    end do

    out = (out - source * ujl /2)*delchi*State%curvature_radius

    end subroutine DoRangeIntTensor

    subroutine GetInitPowerArrayVec(pows,ks, numks)
    integer, intent(in) :: numks
    real(dl) pows(numks), ks(numks)
    integer i

    do i = 1, numks
        !!change to vec...
        pows(i) =  CP%InitPower%ScalarPower(ks(i))
        if (global_error_flag/=0) exit
    end do

    end subroutine GetInitPowerArrayVec


    subroutine GetInitPowerArrayTens(pows,ks, numks)
    integer, intent(in) :: numks
    real(dl) pows(numks), ks(numks)
    integer i

    do i = 1, numks
        pows(i) =  CP%InitPower%TensorPower(ks(i))
        if (global_error_flag/=0) exit
    end do

    end subroutine GetInitPowerArrayTens


    subroutine CalcScalCls(CTrans)
    use Bispectrum
    implicit none
    Type(ClTransferData) :: CTrans
    integer j, q_ix, w_ix, w_ix2
    real(dl) apowers
    real(dl) dlnk, ell, ctnorm, dbletmp, Delta1, Delta2
    real(dl), allocatable :: ks(:), dlnks(:), pows(:)
    real(dl) fac(3 + State%num_redshiftwindows + State%CP%CustomSources%num_custom_sources)
    integer nscal, i

    allocate(ks(CTrans%q%npoints),dlnks(CTrans%q%npoints), pows(CTrans%q%npoints))
    do q_ix = 1, CTrans%q%npoints
        if (State%flat) then
            ks(q_ix) = CTrans%q%points(q_ix)
            dlnks(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
        else
            ks(q_ix) = sqrt(CTrans%q%points(q_ix)**2 - State%curv)
            dlnks(q_ix) = CTrans%q%dpoints(q_ix)*CTrans%q%points(q_ix)/ks(q_ix)**2
        end if
        pows(q_ix) = CP%InitPower%ScalarPower(ks(q_ix))
        if (global_error_flag/=0) return
    end do

#ifndef __INTEL_COMPILER
    !Can't use OpenMP here on ifort. Does not terminate.
    !$OMP PARALLEL DO DEFAULT(SHARED), SCHEDULE(STATIC,4), &
    !$OMP PRIVATE(ell,q_ix,dlnk,apowers,ctnorm,dbletmp,Delta1,Delta2,w_ix,w_ix2,fac, nscal, i)
#endif
    do j=1,CTrans%ls%nl
        !Integrate dk/k Delta_l_q**2 * Power(k)
        ell = real(CTrans%ls%l(j),dl)
        if (j<= CTrans%max_index_nonlimber) then
            do q_ix = 1, CTrans%q%npoints
                if (.not.(State%closed.and.nint(CTrans%q%points(q_ix)*State%curvature_radius)<=CTrans%ls%l(j))) then
                    !cut off at nu = l + 1
                    dlnk = dlnks(q_ix)
                    apowers = pows(q_ix)

                    iCl_scalar(j,C_Temp:C_E) = iCl_scalar(j,C_Temp:C_E) +  &
                        apowers*CTrans%Delta_p_l_k(1:2,j,q_ix)**2*dlnk
                    iCl_scalar(j,C_Cross) = iCl_scalar(j,C_Cross) + &
                        apowers*CTrans%Delta_p_l_k(1,j,q_ix)*CTrans%Delta_p_l_k(2,j,q_ix)*dlnk

                    if (CTrans%NumSources>2 .and. State%CP%want_cl_2D_array) then

                        do w_ix=1,3 + State%num_redshiftwindows
                            Delta1= CTrans%Delta_p_l_k(w_ix,j,q_ix)
                            if (w_ix>3) then
                                associate (Win => State%Redshift_w(w_ix - 3))
                                    if (Win%kind == window_lensing) &
                                        Delta1 = Delta1 / 2 * ell * (ell + 1)
                                    if (Win%kind == window_counts .and. CP%SourceTerms%counts_lensing) then
                                        !want delta f/f - 2kappa;
                                        ! grad^2 = -l(l+1);
                                        Delta1 = Delta1 + ell * (ell + 1) * &
                                            CTrans%Delta_p_l_k(3 + Win%mag_index + &
                                            State%num_redshiftwindows, j, q_ix)
                                    end if
                                end associate
                            end if
                            do w_ix2=w_ix,3 + State%num_redshiftwindows
                                if (w_ix2>= 3.and. w_ix>=3) then
                                    !Skip if the auto or cross-correlation is included in direct Limber result
                                    !Otherwise we need to include the sources e.g. to get counts-Temperature correct
                                    if (CTrans%limber_l_min(w_ix2)/= 0 .and. j>=CTrans%limber_l_min(w_ix2) &
                                        .and. CTrans%limber_l_min(w_ix)/= 0 .and. j>=CTrans%limber_l_min(w_ix)) cycle

                                end if
                                Delta2 = CTrans%Delta_p_l_k(w_ix2, j, q_ix)
                                if (w_ix2 > 3) then
                                    associate (Win => State%Redshift_w(w_ix2 - 3))
                                        if (Win%kind == window_lensing) &
                                            Delta2 = Delta2 / 2 * ell * (ell + 1)
                                        if (Win%kind == window_counts .and. CP%SourceTerms%counts_lensing) then
                                            !want delta f/f - 2kappa;
                                            ! grad^2 = -l(l+1);
                                            Delta2 = Delta2 + ell * (ell + 1) * &
                                                CTrans%Delta_p_l_k(3 + Win%mag_index + &
                                                State%num_redshiftwindows, j, q_ix)
                                        end if
                                    end associate
                                end if
                                iCl_Array(j,w_ix,w_ix2) = iCl_Array(j,w_ix,w_ix2)+Delta1*Delta2*apowers*dlnk
                            end do
                        end do
                        if (CP%CustomSources%num_custom_sources >0) then
                            do w_ix=1,3 + State%num_redshiftwindows + CP%CustomSources%num_custom_sources
                                if (w_ix > 3 + State%num_redshiftwindows) then
                                    Delta1= CTrans%Delta_p_l_k(w_ix+State%num_extra_redshiftwindows,j,q_ix)
                                else
                                    Delta1= CTrans%Delta_p_l_k(w_ix,j,q_ix)
                                end if
                                do w_ix2=max(w_ix,3 + State%num_redshiftwindows +1), &
                                    3 + State%num_redshiftwindows +CP%CustomSources%num_custom_sources
                                    Delta2=  CTrans%Delta_p_l_k(w_ix2+State%num_extra_redshiftwindows,j,q_ix)
                                    iCl_Array(j,w_ix,w_ix2) = iCl_Array(j,w_ix,w_ix2) &
                                        +Delta1*Delta2*apowers*dlnk
                                end do
                            end do
                        end if
                    end if

                    if (CTrans%NumSources>2 ) then
                        if (CP%SourceTerms%limber_phi_lmin==0 .or.  &
                            CTrans%limber_l_min(3)== 0 .or. j<CTrans%limber_l_min(3)) then
                            iCl_scalar(j,C_Phi) = iCl_scalar(j,C_Phi) +  &
                                apowers*CTrans%Delta_p_l_k(3,j,q_ix)**2*dlnk
                            iCl_scalar(j,C_PhiTemp) = iCl_scalar(j,C_PhiTemp) +  &
                                apowers*CTrans%Delta_p_l_k(3,j,q_ix)*CTrans%Delta_p_l_k(1,j,q_ix)*dlnk
                            iCl_scalar(j,C_PhiE) = iCl_scalar(j,C_PhiE) +  &
                                apowers*CTrans%Delta_p_l_k(3,j,q_ix)*CTrans%Delta_p_l_k(2,j,q_ix)*dlnk
                        end if
                    end if
                end if
            end do

        end if !limber (j<= max_bessels_l_index)

        !Output l(l+1)C_l/OutputDenominator
        ctnorm=(ell*ell-1)*(ell+2)*ell
        dbletmp=(ell*(ell+1))/OutputDenominator*const_fourpi
        if (State%CP%want_cl_2D_array) then
            fac=1
            fac(2) = sqrt(ctnorm)
            if (CTrans%NumSources > 2) then
                fac(3) = sqrt(ell*(ell+1)*CP%ALens) !Changed Dec18 for consistency
                do w_ix=3 + State%num_redshiftwindows+1,3 + State%num_redshiftwindows + CP%CustomSources%num_custom_sources
                    nscal= CP%CustomSources%custom_source_ell_scales(w_ix - State%num_redshiftwindows -3)
                    do i=1, nscal
                        fac(w_ix) = fac(w_ix)*(ell+i)*(ell-i+1)
                    end do
                    fac(w_ix) = sqrt(fac(w_ix))
                end do
            end if

            do w_ix=1, CTrans%NumSources - State%num_extra_redshiftwindows
                do w_ix2=w_ix,CTrans%NumSources - State%num_extra_redshiftwindows
                    iCl_Array(j,w_ix,w_ix2) =iCl_Array(j,w_ix,w_ix2) &
                        *fac(w_ix)*fac(w_ix2)*dbletmp
                    iCl_Array(j,w_ix2,w_ix) = iCl_Array(j,w_ix,w_ix2)
                end do
            end do
        end if

        iCl_scalar(j,C_Temp)  =  iCl_scalar(j,C_Temp)*dbletmp
        iCl_scalar(j,C_E) =  iCl_scalar(j,C_E)*dbletmp*ctnorm
        iCl_scalar(j,C_Cross) =  iCl_scalar(j,C_Cross)*dbletmp*sqrt(ctnorm)
        if (CTrans%NumSources>2) then
            iCl_scalar(j,C_Phi) = CP%ALens*iCl_scalar(j,C_Phi)*const_fourpi*ell**4
            !The lensing power spectrum computed is l^4 C_l^{\phi\phi}
            !We put pix extra factors of l here to improve interpolation in l
            iCl_scalar(j,C_PhiTemp) = sqrt(CP%ALens)*  iCl_scalar(j,C_PhiTemp)*const_fourpi*ell**3
            !Cross-correlation is CTrans%ls%l^3 C_l^{\phi T}
            iCl_scalar(j,C_PhiE) = sqrt(CP%ALens)*  iCl_scalar(j,C_PhiE)*const_fourpi*ell**3*sqrt(ctnorm)
            !Cross-correlation is CTrans%ls%l^3 C_l^{\phi E}
        end if
    end do
#ifndef __INTEL_COMPILER
    !$OMP END PARALLEL DO
#endif

    end subroutine CalcScalCls

    subroutine CalcScalCls2(CTrans)
    !Calculate C_ll' for non-isotropic models
    !Run with l_sample_boost=50 to get every l
    !not used in normal CAMB
    use FileUtils
    implicit none
    Type(ClTransferData) :: CTrans
    integer j,j2
    real(dl) apowers, pows(CTrans%q%npoints)
    integer q_ix
    real(dl)  ks(CTrans%q%npoints),dlnks(CTrans%q%npoints),dlnk
    real(dl) ctnorm,dbletmp
    real(dl), allocatable :: iCl_Scalar2(:,:,:)
    type(TTextFile) :: F

    allocate(iCl_Scalar2(CTranS%ls%nl,CTrans%ls%nl,C_Temp:State%Scalar_C_last))
    iCl_scalar2 = 0

    do q_ix = 1, CTrans%q%npoints
        if (State%flat) then
            ks(q_ix) = CTrans%q%points(q_ix)
            dlnks(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
        else
            ks(q_ix) = sqrt(CTrans%q%points(q_ix)**2 - State%curv)
            dlnks(q_ix) = CTrans%q%dpoints(q_ix)*CTrans%q%points(q_ix)/ks(q_ix)**2
        end if

        pows(q_ix) =  CP%InitPower%ScalarPower(ks(q_ix))
        if (global_error_flag/=0) return
    end do

    do j=1,CTrans%ls%nl
        do j2=1,CTrans%ls%nl
            !Integrate dk/k Delta_l_q**2 * Power(k)
            do q_ix = 1, CTrans%q%npoints
                if (.not.(State%closed.and.nint(CTrans%q%points(q_ix)*State%curvature_radius)<= CTrans%ls%l(j))) then
                    !cut off at nu = l + 1
                    dlnk = dlnks(q_ix)
                    apowers = pows(q_ix)

                    iCl_scalar2(j,j2,C_Temp:C_E) = iCl_scalar2(j,j2,C_Temp:C_E) +  &
                        apowers*CTrans%Delta_p_l_k(1:2,j,q_ix)*CTrans%Delta_p_l_k(1:2,j2,q_ix)*dlnk
                    iCl_scalar2(j,j2,C_Cross) = iCl_scalar2(j,j2,C_Cross) + &
                        apowers*CTrans%Delta_p_l_k(1,j,q_ix)*CTrans%Delta_p_l_k(2,j2,q_ix)*dlnk
                end if
            end do

            !Output l(l+1)C_l/OutputDenominator

            !ctnorm = (CTrans%ls%l+2)!/(CTrans%ls%l-2)! - beware of int overflow
            ctnorm=(CTrans%ls%l(j)*CTrans%ls%l(j)-1)*real((CTrans%ls%l(j)+2)*CTrans%ls%l(j),dl)
            ctnorm=sqrt(ctnorm*(CTrans%ls%l(j2)*CTrans%ls%l(j2)-1)*real((CTrans%ls%l(j2)+2)*CTrans%ls%l(j2),dl))

            dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*const_fourpi
            dbletmp=sqrt(dbletmp*(CTrans%ls%l(j2)*(CTrans%ls%l(j2)+1))/OutputDenominator*const_fourpi)

            iCl_scalar2(j,j2,C_Temp)  =  iCl_scalar2(j,j2,C_Temp)*dbletmp
            iCl_scalar2(j,j2,C_E)     =  iCl_scalar2(j,j2,C_E)*dbletmp*ctnorm
            iCl_scalar2(j,j2,C_Cross) =  iCl_scalar2(j,j2,C_Cross)*dbletmp*sqrt(ctnorm)
        end do
    end do

    call F%CreateFile('cl2.dat')
    do j=1,CTrans%ls%nl
        do j2=1,CTrans%ls%nl
            call F%write(CTrans%ls%l(j),CTrans%ls%l(j2),iCl_scalar2(j,j2,1)*7.4311e12)
        end do
    end do
    call F%close()
    call F%CreateFile('cl1l2.dat')
    do j=1,999
        call F%write(iCl_scalar2(j,1:999,1)*7.4311e12)
    end do
    call F%close()
    stop

    end subroutine CalcScalCls2


    subroutine CalcTensCls(CTrans, GetInitPowers)
    implicit none
    Type(ClTransferData) :: CTrans
    external GetInitPowers
    integer j, q_ix
    real(dl) nu
    real(dl) apowert,  measure
    real(dl) ctnorm,dbletmp
    real(dl) pows(CTrans%q%npoints)
    real(dl)  ks(CTrans%q%npoints),measures(CTrans%q%npoints)

    !For tensors we want Integral dnu/nu (nu^2-3)/(nu^2-1) Delta_l_k^2 P(k) for State%closed

    do q_ix = 1, CTrans%q%npoints
        if (State%flat) then
            ks(q_ix) = CTrans%q%points(q_ix)
            measures(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
        else
            nu = CTrans%q%points(q_ix)*State%curvature_radius
            ks(q_ix) = sqrt(CTrans%q%points(q_ix)**2 - 3*State%curv)
            measures(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)*(nu**2-3*State%Ksign)/(nu**2-State%Ksign)
        end if
    end do

    call GetInitPowers(pows,ks,CTrans%q%npoints)

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC,4) &
    !$OMP & PRIVATE(q_ix, measure, apowert, ctnorm, dbletmp)
    do j=1,CTrans%ls%nl
        do q_ix = 1, CTrans%q%npoints
            if (.not.(State%closed.and. nint(CTrans%q%points(q_ix)*State%curvature_radius)<=CTrans%ls%l(j))) then
                !cut off at nu = l+1
                apowert = pows(q_ix)
                measure = measures(q_ix)

                iCl_tensor(j,CT_Temp:CT_B) = iCl_tensor(j,CT_Temp:CT_B) + &
                    apowert*CTrans%Delta_p_l_k(CT_Temp:CT_B,j,q_ix)**2*measure

                iCl_tensor(j,CT_cross ) = iCl_tensor(j,CT_cross) &
                    +apowert*CTrans%Delta_p_l_k(CT_Temp,j,q_ix)*CTrans%Delta_p_l_k(CT_E,j,q_ix)*measure
            end if
        end do

        ctnorm=(CTrans%ls%l(j)*CTrans%ls%l(j)-1)*real((CTrans%ls%l(j)+2)*CTrans%ls%l(j),dl)
        dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*const_pi/4
        iCl_tensor(j, CT_Temp) = iCl_tensor(j, CT_Temp)*dbletmp*ctnorm
        if (CTrans%ls%l(j)==1) dbletmp=0
        iCl_tensor(j, CT_E:CT_B) = iCl_tensor(j, CT_E:CT_B)*dbletmp
        iCl_tensor(j, CT_Cross)  = iCl_tensor(j, CT_Cross)*dbletmp*sqrt(ctnorm)
    end do
    !$OMP END PARALLEL DO

    end subroutine CalcTensCls


    subroutine CalcVecCls(CTrans, GetInitPowers)
    implicit none
    Type(ClTransferData) :: CTrans
    external GetInitPowers
    integer j, q_ix
    real(dl) power,  measure
    real(dl) ctnorm,lfac,dbletmp
    real(dl) pows(CTrans%q%npoints)
    real(dl)  ks(CTrans%q%npoints),measures(CTrans%q%npoints)

    do q_ix = 1, CTrans%q%npoints
        ks(q_ix) = CTrans%q%points(q_ix)
        measures(q_ix) = CTrans%q%dpoints(q_ix)/CTrans%q%points(q_ix)
    end do

    call GetInitPowers(pows,ks,CTrans%q%npoints)

    !$OMP PARALLEL DO DEFAULT(SHARED),SCHEDULE(STATIC,4), &
    !$OMP & PRIVATE(j,q_ix,measure,power,ctnorm,dbletmp,lfac)
    do j=1,CTrans%ls%nl
        do q_ix = 1, CTrans%q%npoints
            if (.not.(State%closed.and. nint(CTrans%q%points(q_ix)*State%curvature_radius)<=CTrans%ls%l(j))) then
                !cut off at nu = l+1
                power = pows(q_ix)
                measure = measures(q_ix)

                iCl_vector(j,CT_Temp:CT_B) = iCl_vector(j,CT_Temp:CT_B) + &
                    power*CTrans%Delta_p_l_k(CT_Temp:CT_B,j,q_ix)**2*measure

                iCl_vector(j,CT_cross) = iCl_vector(j,CT_cross) &
                    +power*CTrans%Delta_p_l_k(CT_Temp,j,q_ix)*CTrans%Delta_p_l_k(CT_E,j,q_ix)*measure
            end if
        end do

        ctnorm=CTrans%ls%l(j)*(CTrans%ls%l(j)+1)
        dbletmp=(CTrans%ls%l(j)*(CTrans%ls%l(j)+1))/OutputDenominator*const_pi/8
        iCl_vector(j, CT_Temp)   = iCl_vector(j, CT_Temp)*dbletmp*ctnorm
        lfac = (CTrans%ls%l(j) + 2)*(CTrans%ls%l(j) - 1)
        iCl_vector(j, CT_E:CT_B) = iCl_vector(j, CT_E:CT_B)*dbletmp*lfac
        iCl_vector(j, CT_Cross)  = iCl_vector(j, CT_Cross)*dbletmp*sqrt(lfac*ctnorm)
    end do
    !$OMP END PARALLEL DO

    end subroutine CalcVecCls


    subroutine InterpolateCls()
    implicit none
    integer i,j
    integer, dimension(2,2), parameter :: ind = reshape( (/ 1,3,3,2 /), shape(ind))
    !use verbose form above for gfortran consistency  [[1,3],[3,2]]

    !Note using log interpolation is worse

    if (CP%WantScalars) then
        associate(lSet=>State%CLdata%CTransScal%ls)
            do i = C_Temp, State%Scalar_C_last
                call lSet%InterpolateClArrTemplated(iCl_scalar(1,i),State%CLData%Cl_scalar(lSet%lmin, i), &
                    lSet%nl,i)
            end do

            if (State%CLdata%CTransScal%NumSources>2 .and. State%CP%want_cl_2D_array) then
                do i=1,3+State%num_redshiftwindows + CP%CustomSources%num_custom_sources
                    do j=i,3+State%num_redshiftwindows + CP%CustomSources%num_custom_sources
                        if (i<3 .and. j<3) then
                            State%CLData%Cl_scalar_array(:,i,j) = State%CLData%Cl_scalar(:, ind(i,j))
                        else
                            call lSet%InterpolateClArr(iCl_array(1,i,j), &
                                State%CLData%Cl_scalar_array(lSet%lmin, i,j))
                        end if
                        if (i/=j) State%CLData%Cl_scalar_array(:,j,i) = State%CLData%Cl_scalar_array(:,i,j)
                    end do
                end do
            end if
        end associate
    end if

    if (CP%WantVectors) then
        associate(ls=>State%CLdata%CTransVec%ls)
            do i = C_Temp, CT_cross
                call ls%InterpolateClArr(iCl_vector(1,i),State%CLData%Cl_vector(ls%lmin, i))
            end do
        end associate
    end if

    if (CP%WantTensors) then
        associate(ls=>State%CLdata%CTransTens%ls)
            do i = CT_Temp, CT_Cross
                call ls%InterpolateClArr(iCl_tensor(1,i),State%CLData%Cl_tensor(ls%lmin, i))
            end do
        end associate
    end if

    end subroutine InterpolateCls


    end module CAMBmain

    module StringUtils
    use MiscUtils
    use MpiUtils
    implicit none

    character(26), parameter, private :: AlphUpper = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
    character(26), parameter, private :: AlphLower = 'abcdefghijklmnopqrstuvwxyz'


    INTERFACE RealToStr
    module procedure SingleToStr, DoubleToStr
    END INTERFACE RealToStr

    contains

    function IsWhiteSpace(C)
    character, intent(in) :: C
    logical IsWhiteSpace

    IsWhiteSpace = (C==' ') .or. (C==char(9))

    end function IsWhiteSpace

    function UpperCase(str) result (string)
    !   Changes an ascii string to upper case
    ! https://stackoverflow.com/questions/10759375/how-can-i-write-a-to-upper-or-to-lower-function-in-f90
    character(*), Intent(In) :: str
    character(LEN(str))      :: string
    Integer :: ic, i

    string = str
    do i = 1, LEN_TRIM(str)
        ic = INDEX(AlphLower, str(i:i))
        if (ic > 0) string(i:i) = AlphUpper(ic:ic)
    end do

    end Function UpperCase

    function LowerCase(str) result (string)
    !https://stackoverflow.com/questions/10759375/how-can-i-write-a-to-upper-or-to-lower-function-in-f90
    Character(*), Intent(In) :: str
    Character(LEN(str))      :: string
    Integer :: ic, i

    string = str
    do i = 1, LEN_TRIM(str)
        ic = INDEX(AlphUpper, str(i:i))
        if (ic > 0) string(i:i) = AlphLower(ic:ic)
    end do

    end Function LowerCase


    function GetParamCount()
    integer GetParamCount

    GetParamCount = command_argument_count()

    end function GetParamCount

    function GetParam(i)
    character(LEN=:), allocatable :: GetParam
    integer, intent(in) :: i
    character(LEN=:), allocatable :: tmp
    integer l

    if (GetParamCount() < i) then
        GetParam = ''
    else
        call get_command_argument(i,length=l)
        allocate(character(l)::tmp)
        call get_command_argument(i,value=tmp)
        GetParam = trim(tmp)
    end if

    end function GetParam

    function GetEnvironmentVariable(name, is_present) result(value)
    character(LEN=*), intent(in) :: name
    character(LEN=:), allocatable :: value
    logical, intent(out), optional :: is_present
    integer L, status

    call get_environment_variable(name, length=L, status=status)
    if (present(is_present)) is_present = status==0
    if (status==0) then
        allocate(character(L)::value)
        call get_environment_variable(name, value, status=status)
    end if
    if (status/=0) value=''

    end function GetEnvironmentVariable


    function StringStarts(S, substring, index) result(OK)
    character(LEN=*), intent(in) :: S, substring
    integer, intent(in), optional :: index
    logical OK
    integer start

    if (present(index)) then
        start = index
    else
        start =1
    end if

    OK = S(start:min(len(S),start+len_trim(substring)-1))==substring

    end function StringStarts

    function StringTrimmed(S, trimmed) result(newS)
    character(LEN=*), intent(in) :: S
    logical, intent(in), optional :: trimmed
    character(LEN=:), allocatable :: newS

    if (DefaultFalse(trimmed)) then
        newS = trim(S)
    else
        newS = S
    end if

    end function StringTrimmed

    subroutine StringReplace(FindS, RepS, S)
    character(LEN=*), intent(in) :: FindS, RepS
    character(LEN=:), allocatable, intent(inout) :: S
    integer i

    i = index(S,FindS)
    if (i>0) then
        S = S(1:i-1)//trim(RepS)//S(i+len_trim(FindS):len_trim(S))
    end if

    end subroutine StringReplace

    function StringEscape(S, C, escape) result(newS)
    character(LEN=*), intent(in) :: S
    character, intent(in) :: C
    character, intent(in), optional :: escape
    character(LEN=:), allocatable :: newS, esc
    integer i
    character, parameter :: backslash = char(92)

    if (present(escape)) then
        esc= escape
    else
        esc = backslash
    end if
    newS = ''
    do i=1, len_trim(S)
        if (S(i:i)==C) then
            newS = newS //esc// C
        else
            newS = newS //S(i:i)
        end if
    end do

    end function StringEscape

    function Join(separator, S, S1,S2,S3,S4,S5,S6, trimmed) result(newS)
    character(LEN=*), intent(in) :: Separator, S, S1
    character(LEN=*), optional :: S2,S3,S4,S5,S6
    character(LEN=:), allocatable :: newS
    logical, intent(in), optional :: trimmed

    newS = StringTrimmed(S,trimmed)//Separator//StringTrimmed(S1,trimmed)
    if (present(S2)) newS = newS //Separator //StringTrimmed(S2,trimmed)
    if (present(S3)) newS = newS //Separator //StringTrimmed(S3,trimmed)
    if (present(S4)) newS = newS //Separator //StringTrimmed(S4,trimmed)
    if (present(S5)) newS = newS //Separator //StringTrimmed(S5,trimmed)
    if (present(S6)) newS = newS //Separator //StringTrimmed(S6,trimmed)

    end function Join

    function numcat(S, num)
    character(LEN=*) S
    character(LEN=:), allocatable :: numcat
    integer num

    numcat = concat(S,num)
    end function numcat

    function IntToStr(I, minlen)
    integer , intent(in) :: I
    character(LEN=:), allocatable :: IntToStr
    integer, intent(in), optional :: minlen
    integer n
    character (LEN=128) :: form, tmp

    if (present(minlen)) then
        n = minlen
        if (I<0) n=n+1
        form = concat('(I',n,'.',minlen,')')
        write (tmp,form) i
        IntToStr = trim(tmp)
    else
        write (tmp,*) i
        IntToStr = trim(adjustl(tmp))
    end if

    end function IntToStr

    function StrToInt(S)
    integer :: StrToInt
    character(LEN=*), intent(in) :: S

    read(S,*) StrToInt

    end function StrToInt

    subroutine StringAppend(S,X)
    character(LEN=:), allocatable, intent(inout) :: S
    class(*), intent(in) :: X

    if (.not. allocated(S)) S=''
    select type (X)
    type is (character(LEN=*))
        S = S // trim(X)
    type is (integer)
        S = S // IntToStr(X)
    type is (real)
        S = S // RealToStr(X)
    type is (double precision)
        S=S //RealToStr(X)
    class default
        call MpiStop('StringAppend: Unknown type')
    end select
    end subroutine

    function concat(S1,S2,S3,S4,S5,S6,S7,S8) result(outstr)
    character(LEN=*), intent(in) :: S1
    class(*), intent(in) :: S2
    class(*), intent(in), optional :: S3, S4, S5, S6,S7,S8
    character(LEN=:), allocatable :: outstr

    outstr=S1
    call StringAppend(outstr,S2)
    if (present(S3)) then
        call StringAppend(outstr,S3)
        if (present(S4)) then
            call StringAppend(outstr,S4)
            if (present(S5)) then
                call StringAppend(outstr,S5)
                if (present(S6)) then
                    call StringAppend(outstr,S6)
                    if (present(S7)) then
                        call StringAppend(outstr,S7)
                        if (present(S8)) then
                            call StringAppend(outstr,S8)
                        end if
                    end if
                end if
            end if
        end if
    end if

    end function concat


    function DoubleToStr(R, figs)
    double precision, intent(in) :: R
    integer, intent(in), optional :: figs
    character(LEN=:), allocatable :: DoubleToStr

    DoubleToStr = SingleToStr(real(R),figs)

    end function DoubleToStr

    function SingleToStr(R, figs)
    real, intent(in) :: R
    integer, intent(in), optional :: figs
    character(LEN=:), allocatable :: SingleToStr
    character(LEN=30) tmp

    if (abs(R)>=0.001 .or. R==0.) then
        write (tmp,'(f12.6)') R

        tmp = adjustl(tmp)
        if (present(figs)) then
            SingleToStr = tmp(1:figs)
        else
            if (abs(R)>10000) then
                write(tmp,*) R
                SingleToStr =  trim(adjustl(tmp))
            else
                SingleToStr = tmp(1:6)
            end if
        end if
    else
        if (present(figs)) then
            write (tmp,trim(numcat('(E',figs))//'.2)') R
        else
            write (tmp,'(G9.2)') R
        end if
        SingleToStr = trim(adjustl(tmp))
    end if

    end function SingleToStr

    function SubNextFormat(S, X) result(OK)
    character(LEN=:), allocatable :: S
    class(*) X
    logical OK
    integer ix, P, n
    character c
    character(LEN=:), allocatable :: form, fform, rep

    P=1
    do
        ix=scan(S(P:),'%')
        OK = ix/=0 .and. ix < len(S)
        if (.not. OK) return
        c = S(ix+P:ix+P)
        if (c=='%') then
            P=P+Ix+1
        else
            exit
        end if
    end do
    form = ''
    do while( verify(c,'0123456789') == 0)
        form = form // c
        P=P+1
        c= S(ix+P:ix+P)
    end do
    select type (X)
    type is (integer)
        if (len(form)>0) then
            n= StrToInt(form)
            fform = 'I'//IntToStr(n)
            if (form(1:1)=='0') fform=fform//'.'//IntToStr(n)
            allocate(character(n)::rep)
            write(rep,'('//fform//')') X
        else
            rep = IntToStr(X)
        end if
        if (c=='d' .or. c=='u') then
            call StringReplace('%'//form//c, rep, S)
        else
            write(*,*) 'Wrong format for type: '//trim(S)
            call error
        end if
    type is (Character(LEN=*))
        if (c/='s') then
            write(*,*) 'Wrong format for type: '//trim(S)
            call error
        end if
        call StringReplace('%s', X, S)
    type is (double precision)
        if (c/='f') then
            write(*,*) 'Wrong format for type: '//trim(S)
            call error
        end if
        call StringReplace('%f', RealToStr(X),S)
    type is (real)
        if (c/='f') then
            write(*,*) 'Wrong format for type: '//trim(S)
            call error
        end if
        call StringReplace('%f', RealToStr(X),S)
    class default
        write(*,*) 'Unsupported format type'
        call error
    end select

    contains
    subroutine error
    call MpiStop('FormatString error')
    end subroutine

    end function SubNextFormat

    function FormatString(formatst, i1,i2,i3,i4,i5,i6,i7,i8, allow_unused) result(S)
    character(LEN=*), intent(in) :: formatst
    class(*), intent(in),optional :: i1,i2,i3,i4,i5,i6,i7,i8
    logical, optional, intent(in) :: allow_unused
    character(LEN=:), allocatable :: S
    logical OK
    !Note that this routine is incomplete and very simple (so buggy in complex cases)
    !(should not substitute on the previously substituted string, etc, etc..)
    !Can do things like FormatString('case %d, ans = %03d%%',i,percent)
    S = formatst
    OK = .true.
    if (present(i1)) OK = SubNextFormat(S, i1)
    if (OK .and. present(i2)) OK = SubNextFormat(S, i2)
    if (OK .and. present(i3)) OK = SubNextFormat(S, i3)
    if (OK .and. present(i4)) OK = SubNextFormat(S, i4)
    if (OK .and. present(i5)) OK = SubNextFormat(S, i5)
    if (OK .and. present(i6)) OK = SubNextFormat(S, i6)
    if (OK .and. present(i7)) OK = SubNextFormat(S, i7)
    if (OK .and. present(i8)) OK = SubNextFormat(S, i8)
    if (.not. OK .and. .not. DefaultFalse(allow_unused)) &
        call MpiStop('FormatString: Wrong number or kind of formats in string')
    call StringReplace('%%', '%', S)

    end function FormatString

    subroutine WriteFormat(formatst, i1,i2,i3,i4,i5,i6,i7,i8, allow_unused, unit)
    character(LEN=*), intent(in) :: formatst
    class(*), intent(in), optional :: i1,i2,i3,i4,i5,i6,i7,i8
    logical, optional, intent(in) :: allow_unused
    integer, optional:: unit
    character(LEN=:), allocatable :: S

    S=FormatString(formatst,i1,i2,i3,i4,i5,i6,i7,i8,allow_unused)
    if (present(unit)) then
        write(unit,'(a)') S
    else
        write(*,*) S
    end if

    end subroutine WriteFormat

    end module StringUtils

    module Precision
    implicit none

    integer, parameter :: dl = KIND(1.d0)
    integer, parameter :: sp = KIND(1.0)
    end module Precision

    module constants
    use precision
    implicit none

    real(dl), parameter :: const_pi = 3.1415926535897932384626433832795_dl
    real(dl), parameter :: const_twopi=2._dl*const_pi, const_fourpi=4._dl*const_pi
    real(dl), parameter :: const_eightpi=8._dl*const_pi
    real(dl), parameter :: const_sqrt6=2.4494897427831780981972840747059_dl
    real(dl), parameter  :: zeta3  = 1.2020569031595942853997_dl
    real(dl), parameter  :: zeta5  = 1.0369277551433699263313_dl
    real(dl), parameter  :: zeta7  = 1.0083492773819228268397_dl

    !Constants from particle data book 2022

    real(dl), parameter :: c = 2.99792458e8_dl
    real(dl), parameter :: h_P = 6.62607015e-34_dl
    real(dl), parameter :: hbar = h_P/const_twopi

    real(dl), parameter :: G = 6.67430e-11_dl ! last two digit +/-15
    real(dl), parameter :: sigma_thomson = 6.6524587321e-29_dl
    real(dl), parameter :: sigma_boltz = 5.670374419e-8_dl
    real(dl), parameter :: k_B = 1.380649e-23_dl
    real(dl), parameter :: eV = 1.602176634e-19_dl

    real(dl), parameter :: m_p = 1.67262192369e-27_dl
    real(dl), parameter :: m_e = 9.1093837015e-31_dl

    !Isotopic masses from https://www.ciaaw.org/
    real(dl), parameter :: m_H = 1.673575e-27_dl !av. H atom for D/H=2.527e-5
    real(dl), parameter :: m_He4 = 6.646479073e-27_dl
    real(dl), parameter :: mass_ratio_He_H = m_He4/m_H

    real(dl), parameter :: Gyr = 365.25e9_dl*86400 !Julian gigayear
    real(dl), parameter :: Mpc = 3.085677581e22_dl
    real(dl), parameter :: MPC_in_sec = Mpc/c ! Mpc/c = 1.029271250e14 in SI units

    real(dl), parameter :: barssc0= k_B / m_p / c**2
    real(dl), parameter :: kappa=8._dl*const_pi*G
    real(dl), parameter :: a_rad = 8._dl*const_pi**5*k_B**4/15/c**3/h_p**3
    !7.565914e-16_dl !radiation constant for u=aT^4


    real(dl), parameter :: Compton_CT = MPC_in_sec*(8.d0/3.d0)*(sigma_thomson/(m_e*c))*a_rad
    !Compton_CT is CT in Mpc units, (8./3.)*(sigma_T/(m_e*C))*a_R in Mpc
    !Used to get evolution of matter temperature

    !For 21cm
    real(dl), parameter :: f_21cm = 1420.40575e6_dl, l_21cm= c/f_21cm, T_21cm = h_P*f_21cm/k_B
    real(dl), parameter :: A10 = 2.869e-15, B10 = l_21cm**3/2/h_P/c*A10

    real(dl), parameter :: line21_const = 3*l_21cm**2*C*h_P/32/const_pi/k_B*A10 * Mpc_in_sec * 1000
    !1000 to get in MiliKelvin
    real(dl), parameter :: COBE_CMBTemp = 2.7255_dl !(Fixsen 2009) used as default value

    ! zeta3*3/2/pi^2*4/11*((k_B*COBE_CMBTemp/hbar/c)^3* 8*pi*G/3/(100*km/s/megaparsec)^2/(c^2/eV)
    real(dl), parameter :: inv_neutrino_mass_fac = zeta3*3._dl/2/const_pi**2*4._dl/11*((k_B*COBE_CMBTemp/hbar/c)**3* &
        kappa/3/(100*1000/Mpc)**2/(c**2/eV))
    !converts omnuh2 into sum m_nu in eV for non-relativistic but thermal neutrinos (no 0.046 factor); ~ 94.07
    real(dl), parameter :: neutrino_mass_fac= 1/inv_neutrino_mass_fac

    !Effective number of neutrinos, arXiv:2008.01074, arXiv:2012.02726
    real(dl), parameter :: default_nnu = 3.044_dl
    !Neutrino mass splittings
    real(dl), parameter :: delta_mnu21 = 7.54e-5_dl !eV^2 Particle Data Group 2015 (-0.22, + 0.26)
    real(dl), parameter :: delta_mnu31 = 2.46e-3_dl !eV^2 Particle Data Group 2015 (+- 0.06)
    !Round up to 0.06, so consistent with cosmomc's 1 neutrino default
    real(dl), parameter :: mnu_min_normal = 0.06_dl ! sqrt(delta_mnu31)+sqrt(delta_mnu21)

    !This constant initially was in inifile.f90.
    integer, parameter :: Ini_max_string_len = 1024
    end module constants

    module ObjectLists
    !Implement lists of arbitrary objects
    !AL Feb 2014
    use FileUtils
    implicit none

    private

    type Object_pointer
        class(*), pointer :: p => null()
        class(*), pointer :: Object => null()
    end type Object_pointer

    type Object_array_pointer
        class(*), pointer :: p(:) => null()
    end type Object_array_pointer

#ifdef SINGLE
    integer, parameter :: list_prec = Kind(1.0)
#else
    integer, parameter :: list_prec = Kind(1.d0)
#endif

    Type, abstract :: TSaveLoadStateObject
    contains
    procedure :: SaveState
    procedure :: LoadState
    end Type TSaveLoadStateObject

    Type, extends(TSaveLoadStateObject) :: TObjectList
        integer :: Count =0
        integer :: Delta = 32
        integer :: DeltaScale = 10
        !expanding expanding Items, expand array by Delta + Count/DeltaScale
        integer :: Capacity = 0
        logical :: OwnsObjects = .true.
        Type(Object_pointer), allocatable :: Items(:)
    contains
    procedure :: AddArray
    procedure :: AddArrayPointer
    procedure :: AddItem
    procedure :: AddItemPointer
    procedure :: AddCopy
    procedure :: AssignPointers
    procedure :: DeleteItem
    procedure :: DeleteRange
    procedure :: FreeItem
    procedure :: SetCapacity
    procedure :: ArrayItem
    procedure :: ArrayItemIndex
    procedure :: SaveBinary
    procedure :: ReadBinary
    procedure :: Thin
    procedure :: Sort
    procedure :: SortArr
    procedure :: Swap
    procedure :: Compare
    procedure :: Clear
    procedure :: DeltaSize
    procedure :: QuickSort
    procedure :: QuickSortArr
    procedure :: RemoveDuplicates
    procedure :: CheckIndex
    procedure :: Error
    procedure :: SaveState => TObjectList_SaveState
    procedure :: LoadState => TObjectList_LoadState
    procedure :: Object => TObjectList_Object !Secondary object associated with index
    FINAL :: finalize
    generic :: Add => AddItem, AddArray
    end Type TObjectList

    Type, extends(TObjectList) :: TOwnedIntrinsicList
    contains
    procedure :: AddItem => TOwnedIntrinsicList_AddItem
    procedure :: LoadState => TOwnedIntrinsicList_LoadState
    procedure :: SaveState => TOwnedIntrinsicList_SaveState
    end type

    Type, extends(TOwnedIntrinsicList):: TRealCompareList
    contains
    procedure :: Compare => CompareReal
    end Type TRealCompareList

    Type, extends(TRealCompareList):: TRealList
    contains
    procedure :: TRealList_Item
    procedure :: AddArrayItems => TRealList_AddArrayItems
    procedure :: AsArray =>TRealList_AsArray
    generic :: Item => TRealList_Item
    !could add read and save state here
    end Type TRealList

    Type, extends(TRealCompareList):: TRealArrayList
    contains
    procedure :: Value => TRealArrayList_Value
    procedure :: RealArrItem => TRealArrayList_Item
    generic :: Item => Value, RealArrItem
    end Type TRealArrayList

    Type, extends(TObjectList):: TIntegerArrayList
    contains
    procedure :: Value => TIntegerArrayList_Value
    procedure :: IntegerArrItem => TIntegerArrayList_Item
    generic :: Item => Value, IntegerArrItem
    end Type TIntegerArrayList


    Type, extends(TOwnedIntrinsicList) :: TStringList
    contains
    procedure :: CharAt => TStringList_CharAt
    procedure :: Compare => TStringList_Compare
    procedure :: StringItem  => TStringList_Item
    procedure :: SetFromString => TStringList_SetFromString
    procedure :: ReadColumnsGetArray => TStringList_ReadColumnsGetArray
    procedure :: IndexOf => TStringList_IndexOf
    procedure :: ValueOf => TStringList_ValueOf
    procedure :: AddItems
    procedure :: WriteItems
    procedure :: AddFromFile => TStringList_AddFromFile
    generic :: Item => StringItem
    end Type TStringList


    public list_prec, TSaveLoadStateObject, TObjectList, TRealArrayList, TRealList, TIntegerArrayList, TStringList
    contains

    subroutine LoadState(this,F)
    class(TSaveLoadStateObject) :: this
    class(TFileStream) :: F
    end subroutine LoadState

    subroutine SaveState(this,F)
    class(TSaveLoadStateObject) :: this
    class(TFileStream) :: F
    end subroutine SaveState


    subroutine Clear(this, itemsOnly)
    Class(TObjectList) :: this
    integer i
    logical, intent(in), optional :: itemsOnly
    logical eachItem

    if (allocated(this%Items)) then
        eachItem = .true.
        if (present(itemsOnly)) eachItem=.not. itemsOnly
        if (eachItem) then
            do i=1,this%count
                call this%FreeItem(i)
            end do
        end if
        deallocate (this%Items)
    end if
    this%Count = 0
    this%Capacity = 0

    end subroutine Clear

    subroutine finalize(this)
    Type(TObjectList) :: this
    call this%Clear()
    end subroutine finalize

    subroutine Error(this, msg)
    Class(TObjectList) :: this
    character(LEN=*), intent(in) :: msg

    write(*,*) msg
    error stop

    end subroutine Error

    subroutine AddItem(this, C, Object)
    Class(TObjectList) :: this
    class(*), intent(in), target :: C
    class(*), intent(in), target, optional :: Object
    class(*), pointer :: CP
    class(*), pointer :: ObjectP

    !This all looks a bit unneccessary, just trying to avoid ifort bugs, c.f.
    !http://software.intel.com/en-us/forums/topic/390944
    !This subroutine does *not* help directly, but derived types can use AddItemPointer which is OK.

    CP=> C
    if (present(Object)) then
        ObjectP => Object
    else
        nullify(ObjectP)
    end if
    call this%AddItemPointer(CP, ObjectP)

    end subroutine AddItem


    subroutine AddItemPointer(this, C, Object)
    Class(TObjectList) :: this
    class(*), intent(in), pointer :: C
    class(*), intent(in), pointer, optional :: Object

    if (this%Count == this%Capacity) call this%SetCapacity(this%Capacity + this%DeltaSize())
    this%Count = this%Count + 1
    this%Items(this%Count)%P=>C
    if (present(Object)) this%Items(this%Count)%Object=> Object

    end subroutine AddItemPointer

    subroutine AddCopy(this, C, Object)
    Class(TObjectList) :: this
    class(*), intent(in) :: C
    class(*), intent(in), optional :: Object
    class(*), pointer :: P
    class(*), pointer :: PO

    nullify(PO)
    if (this%OwnsObjects) then
        allocate(P, source=C)
        if (present(Object)) allocate(PO, source=Object)
    else
        call this%Error('ObjectLists: Cannot add copy to un-owned list')
    end if
    call this%AddItemPointer(P, PO)

    end subroutine AddCopy

    subroutine AssignPointers(this, L2, ixmin, ixmax)
    Class(TObjectList) :: this, L2
    integer, intent(in), optional :: ixmin, ixmax
    integer i1,i2

    call this%Clear()
    i1=1
    i2=L2%Count
    if (present(ixmin)) i1=ixmin
    if (present(ixmax)) i2=ixmax
    call this%SetCapacity(i2-i1+1)
    this%Items = L2%Items(i1:i2)
    this%Count = i2-i1+1
    this%OwnsObjects = .false.

    end subroutine AssignPointers

    integer function DeltaSize(this)
    Class(TObjectList) :: this

    DeltaSize= this%Delta + this%Count/this%DeltaScale

    end  function

    subroutine SetCapacity(this, C)
    Class(TObjectList) :: this
    integer C
    Type(Object_pointer), dimension(:), allocatable :: TmpItems

    if (this%Count > 0) then
        if (C < this%Count) call this%Error('ObjectLists: SetCapacity: smaller than Count')
        allocate(TmpItems(C))
        TmpItems(:this%Count) = this%Items(:this%Count)
        call move_alloc(TmpItems, this%Items)
    else
        allocate(this%Items(C))
    end if
    this%Capacity = C
    end subroutine SetCapacity

    subroutine FreeItem(this, i)
    Class(TObjectList) :: this
    integer, intent(in) :: i
    logical want_Dealloc

    if (associated(this%Items(i)%P)) then
        want_Dealloc =  this%OwnsObjects
        select type (point => this%Items(i)%P)
        class is (object_array_pointer)
            if (this%OwnsObjects .and. associated(Point%P)) deallocate(Point%P)
            want_Dealloc = .true.
            !type is (real(kind=list_prec))
            !         want_Dealloc = .false.
        end select
        if (want_Dealloc) deallocate(this%Items(i)%P)
        this%Items(i)%P=> null()
    end if

    if (associated(this%Items(i)%Object) .and. this%OwnsObjects) deallocate(this%Items(i)%Object)
    this%Items(i)%Object=> null()

    end subroutine FreeItem

    subroutine DeleteItem(this, i)
    Class(TObjectList) :: this
    integer, intent(in) :: i

    call this%FreeItem(i)
    if (this%Count > 1) this%Items(i:this%Count-1) = this%Items(i+1:this%Count)
    this%Items(this%Count)%P => null()
    this%Items(this%Count)%Object => null()
    this%Count = this%Count -1

    end subroutine DeleteItem

    subroutine DeleteRange(this, i1,i2)
    Class(TObjectList) :: this
    integer, intent(in) :: i1,i2
    integer i, dN

    do i=i1,i2
        call this%FreeItem(i)
    end do
    dN= i2-i1+1
    if (i2<this%Count) this%Items(i1:this%Count-dN) = this%Items(i2+1:this%Count)
    do i=this%Count-dN+1,this%Count
        this%Items(i)%P => null()
        this%Items(i)%Object => null()
    end do
    this%Count = this%Count - dN

    end subroutine DeleteRange

    subroutine AddArray(this, P)
    Class (TObjectList) :: this
    class(*), target, intent(in) :: P(:)
    class(*), pointer :: Pt

    allocate(object_array_pointer::Pt)
    call this%AddItemPointer(Pt)
    select type (Pt)
    type is (object_array_pointer)
        if (this%ownsObjects) then
            allocate(Pt%P, source= P)
        else
            !This would work on ifort, but may not be standard and does not with gfortran
            !Pt%P => P
            call this%Error('Use AddArrayPointer to add array when ownsObjects if false')
        end if
    end select
    end subroutine AddArray

    subroutine AddArrayPointer(this, P)
    Class (TObjectList) :: this
    class(*), pointer, intent(in) :: P(:)
    class(*), pointer :: Pt

    allocate(object_array_pointer::Pt)
    call this%AddItemPointer(Pt)
    select type (Pt)
    type is (object_array_pointer)
        if (this%ownsObjects) then
            allocate(Pt%P, source= P)
        else
            Pt%P => P
        end if
    end select
    end subroutine AddArrayPointer

    subroutine CheckIndex(this,i)
    Class(TObjectList) :: this
    integer, intent(in) :: i

    if (i>this%Count .or. i<1) call this%Error('Item out of range')

    end subroutine CheckIndex

    !why this crashes in ifort 13 I do not know..
    !subroutine AddArray(this, P)
    !Class (TObjectList) :: this
    !class(*), target, intent(in) :: P(:)
    !Type(object_array_pointer), pointer :: Pt
    !
    !allocate(Pt)
    !call this%AddItem(Pt)
    !if (this%ownsObjects) then
    !    allocate(Pt%P(1:SIZE(P)), source= P)
    !else
    !    Pt%P => P
    !end if
    !end subroutine AddArray

    function ArrayItem(this, i) result(P)
    Class(TObjectList) :: this
    integer, intent(in) :: i
    Class(*), pointer :: P(:)

    call this%CheckIndex(i)
    select type (Point=> this%Items(i)%P)
    class is (object_array_pointer)
        P => Point%P
    class default
        call this%Error('ObjectLists: item is not array item')
    end select

    end function ArrayItem

    function ArrayItemIndex(this, i, j) result(P)
    Class(TObjectList) :: this
    integer, intent(in) :: i, j
    Class(*), pointer :: P
    Class(*), pointer :: Arr(:)

    Arr => this%ArrayItem(i)
    P => Arr(j)

    end function ArrayItemIndex

    function TObjectList_Object(this, i)
    class(TObjectList) :: this
    integer, intent(in) :: i
    class(*), pointer :: TObjectList_Object

    call this%CheckIndex(i)
    TObjectList_Object => this%Items(i)%Object

    end function TObjectList_Object

    subroutine SaveBinary(this,fid)
    Class(TObjectList) :: this
    integer, intent(in) :: fid
    integer i,k, sz
    class(*), pointer :: P(:)
#if __GNUC__ == 6
    logical, save :: warned = .false.

    if (.not. warned) then
        write(*,*) '** WARNING **: TObjectList_SaveBinary: ' &
            // 'optimized gfortran 6 has bugs giving invalid saved binary data. Try 7.3.1+.'
        warned = .true.
    end if
#endif

    write (fid) this%Count
    do i=1,this%Count
        select type (Item=> this%Items(i)%P)
        class is (object_array_pointer)
            P => this%ArrayItem(i)
            select type (Point=> P)
            Type is (real)
                k=1
                write(fid) size(P),k
                write(fid) Point
            Type is (double precision)
                k=2
                write(fid) size(P),k
                write(fid) Point
            Type is (integer)
                k=3
                write(fid) size(P),k
                write(fid) Point
            Type is (logical)
                k=4
                write(fid) size(P),k
                write(fid) Point
            class default
                !see e.g. https://cosmocoffee.info/viewtopic.php?f=11&t=2827
                call this%Error('TObjectList: Unknown type to save (if gfortran, check 7.3.1 or higher)')
            end select
        Type is (character(LEN=*))
            k=5
            sz = len(item) !len may return kind=8 in latest gfortran
            write(fid) sz, k
            write(fid) Item
        class default
            call this%Error('TObjectList: not implemented non-array save')
        end select
    end do

    end subroutine SaveBinary

    subroutine ReadBinary(this,fid)
    Class(TObjectList) :: this
    integer, intent(in) :: fid
    integer num,i,sz, k
    real, pointer :: ArrR(:)
    double precision, pointer :: ArrD(:)
    integer, pointer :: ArrI(:)
    logical, pointer :: ArrL(:)
    class(*), pointer :: St, P(:)

    call this%Clear()
    this%OwnsObjects = .false.
    read (fid) num
    call this%SetCapacity(num)
    do i=1,num
        read(fid) sz, k
        if (k==1) then
            allocate(ArrR(sz))
            read(fid) ArrR
            P => arrR
            call this%AddArrayPointer(P)
        else if (k==2) then
            allocate(ArrD(sz))
            read(fid) ArrD
            P => arrD
            call this%AddArrayPointer(P)
        else if (k==3) then
            allocate(ArrI(sz))
            read(fid) ArrI
            P => arrI
            call this%AddArrayPointer(P)
        else if (k==4) then
            allocate(ArrL(sz))
            read(fid) ArrL
            P => arrL
            call this%AddArrayPointer(P)
        else if (k==5) then
            allocate(character(sz)::St)
            select type (St)
            type is (character(LEN=*))
                read(fid) St
            end select
            call this%AddItemPointer(St)
        else
            call this%Error('TObjectList ReadBinary - unknown object type')
        end if
    end do
    this%Count = num
    this%OwnsObjects = .true.

    end subroutine ReadBinary

    subroutine Thin(this, i)
    Class(TObjectList):: this
    integer, intent(in) :: i
    integer newCount, j
    Type(Object_pointer), dimension(:), pointer :: TmpItems

    if (this%Count > 1) then
        newCount = (this%Count-1)/i+1
        allocate(TmpItems(newCount))
        TmpItems= this%Items(1:this%Count:i)
        if (this%OwnsObjects) then
            do j=1,this%count
                if (mod(j-1,i)/=0) call this%FreeItem(j)
            end do
        end if
        deallocate(this%Items)
        this%Capacity = newCount
        allocate(this%Items, source = TmpItems)
        this%Count = newCount
        deallocate(TmpItems)
    end if

    end subroutine Thin

    subroutine Swap(this, i, j)
    Class(TObjectList) :: this
    integer, intent(in) :: i, j
    type(Object_pointer) :: temp

    temp = this%Items(i)
    this%Items(i) = this%Items(j)
    this%Items(j) = temp

    end subroutine Swap

    recursive subroutine QuickSortArr(this, Lin, R, index)
    !Sorts an array of pointers by the value of the index'th entry
    Class(TObjectList) :: this
    integer, intent(in) :: Lin, R, index
    integer I, J, L
    class(*), pointer :: P

    L = Lin
    do
        I = L
        J = R
        P => this%ArrayItemIndex((L + R)/2, index)
        do
            do while (this%Compare(this%ArrayItemIndex(I, Index),P) <  0)
                I = I + 1
            end do

            do while (this%Compare(this%ArrayItemIndex(J,Index), P) > 0)
                J = J - 1
            end do

            if (I <= J) then
                call this%Swap(I,J)
                I = I + 1
                J = J - 1
            end if
            if (I > J) exit

        end do
        if (L < J) call this%QuickSortArr(L, J, index)
        L  = I
        if (I >= R) exit
    end do

    end subroutine QuickSortArr

    subroutine SortArr(this, index)
    Class(TObjectList) :: this
    integer, intent(in) :: index

    if (this%Count>1) call this%QuickSortArr(1, this%Count, index)

    end subroutine SortArr


    recursive subroutine QuickSort(this, Lin, R)
    Class(TObjectList) :: this
    integer, intent(in) :: Lin, R
    integer I, J, L
    class(*), pointer :: P

    L= Lin
    do
        I = L
        J = R
        P => this%Items((L + R)/2)%P
        do
            do while (this%Compare(this%Items(I)%P,P) <  0)
                I = I + 1
            end do

            do while (this%Compare(this%Items(J)%P, P) > 0)
                J = J - 1
            end do

            if (I <= J) then
                call this%Swap(I,J)
                I = I + 1
                J = J - 1
            end if
            if (I > J) exit
        end do
        if (L < J) call this%QuickSort(L, J)
        L = I
        if (I >= R) exit
    end do

    end subroutine QuickSort

    subroutine Sort(this)
    Class(TObjectList) :: this

    if (this%Count>1) call this%QuickSort(1, this%Count)

    end subroutine Sort

    integer function Compare(this, R1, R2) result(comp)
    Class(TObjectList) :: this
    class(*) R1,R2

    comp=0 !equality
    call this%Error('TObjectList: Compare must be defined for derived type')

    end function Compare

    subroutine RemoveDuplicates(this)
    Class(TObjectList) :: this
    integer i

    do i=this%Count-1, 1, -1
        if (this%Compare(this%Items(i+1)%P, this%Items(i)%P)==0) call this%DeleteItem(i+1)
    end do

    end subroutine RemoveDuplicates

    subroutine TObjectList_SaveState(this,F)
    class(TObjectList) :: this
    class(TFileStream) :: F
    integer i

    call F%Write(this%Count)
    do i=1,this%Count
        select type (item => this%Items(i)%P)
        class is (TSaveLoadStateObject)
            call item%SaveState(F)
        class default
            call this%Error('TObjectList_SaveState: List contains non-TSaveLoadStateObject item')
        end select
    end do

    end subroutine TObjectList_SaveState

    subroutine TObjectList_LoadState(this,F)
    class(TObjectList) :: this
    class(TFileStream) :: F
    integer i, count

    if (.not. F%ReadItem(count) .or. count/=this%Count) &
        & call this%Error('TObjectList_LoadState count mismatch (objects must exist before load)')
    do i=1,this%Count
        select type (item => this%Items(i)%P)
        class is (TSaveLoadStateObject)
            call item%LoadState(F)
        class default
            call this%Error('List contains non-TSaveLoadStateObject item')
        end select
    end do

    end subroutine TObjectList_LoadState


    !TOwnedIntrinsicList

    subroutine TOwnedIntrinsicList_LoadState(this,F)
    class(TOwnedIntrinsicList) :: this
    class(TFileStream) :: F
    call this%ReadBinary(F%unit)
    end subroutine TOwnedIntrinsicList_LoadState

    subroutine TOwnedIntrinsicList_SaveState(this,F)
    class(TOwnedIntrinsicList) :: this
    class(TFileStream) :: F
    call this%SaveBinary(F%unit)
    end subroutine TOwnedIntrinsicList_SaveState


    subroutine TOwnedIntrinsicList_AddItem(this, C, Object)
    Class(TOwnedIntrinsicList) :: this
    class(*), intent(in), target :: C
    class(*), intent(in), target, optional :: Object

    call this%TObjectList%AddCopy(C, Object)

    end subroutine TOwnedIntrinsicList_AddItem

    !TRealCompareList
    integer function CompareReal(this, R1, R2) result(comp)
    Class(TRealCompareList) :: this
    class(*) R1,R2
    real(list_prec) R

    select type (RR1 => R1)
    type is (real(list_prec))
        select type (RR2 => R2)
        type is (real(list_prec))
            R = RR1-RR2
            if (R< 0) then
                comp =-1
            elseif (R>0) then
                comp = 1
            else
                comp = 0
            end if
            return
        end select
    class default
        call this%Error('TRealList: Compare not defined for this type')
    end select

    end function CompareReal


    !TRealList: List of reals
    function TRealList_Item(this,i) result(R)
    Class(TRealList) :: this
    integer, intent(in) :: i
    real(list_prec) R

    call this%CheckIndex(i)
    select type (pt=>this%Items(i)%P)
    type is (real(kind=list_prec))
        R = pt
    class default
        call this%Error('TRealList: object of wrong type')
    end select

    end function TRealList_Item

    subroutine TRealList_AddArrayItems(this, A)
    Class(TRealList) :: this
    real(kind=list_prec), intent(in) :: A(:)
    integer i

    do i=1, size(A)
        call this%AddItem(A(i))
    end do

    end subroutine TRealList_AddArrayItems

    function TRealList_AsArray(this) result(A)
    Class(TRealList) :: this
    real(kind=list_prec):: A(this%Count)
    integer i

    do i=1, size(A)
        A(i) = this%Item(i)
    end do

    end function TRealList_AsArray

    !TRealArrayList: List of arrays of reals

    function TRealArrayList_Item(this, i) result(P)
    Class(TRealArrayList) :: this
    integer, intent(in) :: i
    real(list_prec), pointer :: P(:)
    class(*), pointer :: Item(:)

    Item => this%ArrayItem(i)
    select type (pt=>Item)
    type is (real(kind=list_prec))
        P=> pt
    class default
        call this%Error('TRealArrayList: object of wrong type')
    end select

    end function TRealArrayList_Item

    function TRealArrayList_Value(this, i, j) result(P)
    Class(TRealArrayList) :: this
    integer, intent(in) :: i, j
    real(list_prec) :: P
    class(*), pointer :: C

    C => this%ArrayItemIndex(i,j)
    select type (Arr=> C)
    Type is (real(list_prec))
        P = Arr
    class default
        call this%Error('TRealArrayList_Value: object of wrong type (eg. ifort 2017.0.4 bug)')
    end select

    end function TRealArrayList_Value

    !TIntegerArrayList: List of arrays of reals

    function TIntegerArrayList_Item(this, i) result(P)
    Class(TIntegerArrayList) :: this
    integer, intent(in) :: i
    integer, pointer :: P(:)
    class(*), pointer :: Item(:)

    Item => this%ArrayItem(i)
    select type (pt=>Item)
    type is (integer)
        P=> pt
    class default
        call this%Error('TIntegerArrayList: object of wrong type')
    end select

    end function TIntegerArrayList_Item

    function TIntegerArrayList_Value(this, i, j) result(P)
    Class(TIntegerArrayList) :: this
    integer, intent(in) :: i, j
    Integer :: P
    class(*), pointer :: C

    C => this%ArrayItemIndex(i,j)
    select type (Arr=> C)
    Type is (integer)
        P = Arr
    end select

    end function TIntegerArrayList_Value

    !!! TStringList

    function TStringList_Item(this,i) result(S)
    Class(TStringList) :: this
    integer, intent(in) :: i
    character(LEN=:), pointer :: S

    call this%CheckIndex(i)
    select type (pt=>this%Items(i)%P)
    type is (character(LEN=*))
        S => pt
    class default
        call this%Error('TStringList: object of wrong type')
    end select

    end function TStringList_Item

    function TStringList_ValueOf(this, key)
    class(TStringList) :: this
    character(LEN=*), intent(in) :: key
    integer :: i
    character(LEN=:), pointer :: TStringList_ValueOf

    i = this%IndexOf(key)
    if (i==-1) call this%Error('TStringList_ValueOf key not found:'//key)
    select type (value=>this%Items(i)%Object)
    type is (character(LEN=*))
        TStringList_ValueOf=> value
    class default
        call this%Error('TStringList_ValueOf Object is not a string')
    end select

    end function TStringList_ValueOf


    subroutine TStringList_SetFromString(this, S, valid_chars_in)
    class(TStringList) :: this
    character(Len=*), intent(in) :: S
    character(Len=*), intent(in), optional :: valid_chars_in
    character(LEN=:), allocatable :: item
    integer i,j
    character(LEN=:), allocatable :: valid_chars

    if (present(valid_chars_in)) then
        valid_chars = trim(valid_chars_in)
    else
        valid_chars='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-.'
    endif

    call this%Clear()
    allocate(item, source=S)
    j=0
    do i=1, len_trim(S)
        if (verify(S(i:i),valid_chars) == 0) then
            j=j+1
            item(j:j) = S(i:i)
        else
            if (trim(S(i:i))/='') then
                write (*,*) 'Invalid character in: '//trim(S)
            end if
            if (j>0) call this%Add(item(1:j))
            j=0
        end if
    end do
    if (j>0) call this%Add(item(1:j))

    end subroutine TStringList_SetFromString


    subroutine TStringList_ReadColumnsGetArray(this, filename, array)
    class(TStringList) :: this
    character(LEN=*), intent(in) :: filename
    real(list_prec), intent(out), allocatable :: array(:,:)
    character(LEN=:), allocatable :: comment

    call File%LoadTxt(filename, array,comment = comment)
    call this%SetFromString(comment)
    if (this%Count /= size(array,1)) &
        call this%Error('Column header does not match number of columns: ' //trim(filename))

    end subroutine TStringList_ReadColumnsGetArray

    function TStringList_IndexOf(this, S) result(index)
    class(TStringList) :: this
    character(LEN=*), intent(in) :: S
    integer index, i

    do i=1,this%Count
        if (this%Item(i)==S) then
            index = i
            return
        end if
    end do
    index=-1

    end function TStringList_IndexOf

    function TStringList_CharAt(this, i, j) result(C)
    Class(TStringList) :: this
    integer, intent(in) :: i, j
    character :: C
    character(LEN=:), pointer :: P

    call this%CheckIndex(i)
    P => this%Item(i)
    C = P(j:j)

    end function TStringList_CharAt

    integer function TStringList_Compare(this, R1, R2) result(comp)
    Class(TStringList) :: this
    class(*) R1,R2

    select type (RR1 => R1)
    type is (character(LEN=*))
        select type (RR2 => R2)
        type is (character(LEN=*))
            if (RR1 < RR2) then
                comp =-1
            elseif (RR1>RR2) then
                comp = 1
            else
                comp = 0
            end if
            return
        end select
    class default
        call this%Error('TStringList_Compare: not defined for this type')
    end select

    end function TStringList_Compare

    subroutine WriteItems(this, unit)
    use, intrinsic :: iso_fortran_env, only : output_unit
    Class(TStringList) :: this
    integer, optional, intent(in) :: unit
    integer i, aunit

    if (present(unit)) then
        aunit = unit
    else
        aunit = output_unit
    end if
    do i=1, this%Count
        write(aunit,*) this%Item(i)
    end do

    end subroutine WriteItems

    subroutine AddItems(this, List, nodups)
    Class(TStringList) :: this, List
    logical, intent(in) :: nodups
    integer i

    do i = 1, List%Count
        if (nodups) then
            if (this%IndexOf(List%Item(i)) /= -1) cycle
        end if
        if (associated(List%Items(i)%Object)) then
            call this%Add(List%Items(i)%P,List%Items(i)%Object)
        else
            call this%Add(List%Items(i)%P)
        end if
    end do

    end subroutine AddItems

    subroutine TStringList_AddFromFile(this, fname, nodups)
    Class(TStringList) :: this
    character(LEN=*), intent(in) :: fname
    character(LEN=:), allocatable :: InLine
    logical, intent(in) :: nodups
    Type(TTextFile) :: F

    call F%Open(fname)
    do while (F%ReadLineSkipEmptyAndComments(InLine))
        if (nodups) then
            if (this%IndexOf(InLine) /= -1) cycle
        end if
        call this%Add(InLine)
    end do
    call F%close()

    end subroutine TStringList_AddFromFile

    end module ObjectLists

    module FileUtils
    use MpiUtils
    use MiscUtils
    use StringUtils
    use, intrinsic :: ISO_FORTRAN_ENV, only : INT64
    implicit none
    !Utils using F2008 features
    private

    integer, parameter :: File_size_int = KIND(INT64)

    Type :: TFileStream
        integer :: unit = 0
        logical :: ReadOnly = .true.
        character(LEN=:), allocatable :: mode
        character(LEN=:), allocatable :: access !sequential (fortran or text) or stream (binary, with file position)
        character(LEN=:), allocatable :: FileName
    contains
    procedure :: SetDefaultModes
    procedure :: Open => TFileStream_Open
    procedure :: OpenFile => TFileStream_OpenFile
    procedure :: Flush => TFileStream_Flush
    procedure :: CreateFile
    procedure :: CreateOpenFile
    procedure :: Position => TFileStream_Position
    procedure :: Size => TFileStream_Size
    procedure :: Close => TFileStream_Close
    procedure :: Rewind => TFileStream_Rewind
    procedure :: Error
    procedure :: Opened
    procedure :: WriteTrim
    procedure :: CheckOpen
    procedure, private :: ReadStringFunc
    procedure, private :: ReadStringSub
    procedure, private :: ReadItemSub
    procedure, private :: ReadItemFunc
    procedure, private :: ReadItems
    procedure, private :: ReadArray
    procedure, private :: ReadArray2
    procedure, private :: ReadArray2Func
    procedure, private :: ReadArrayFunc
    procedure, private :: WriteItemSub
    procedure, private :: WriteArray
    procedure, private :: WriteOneAndArray
    procedure, private :: WriteArray2
    procedure, private :: WriteItems
    procedure, private  :: WriteSizedArray1
    procedure, private  :: WriteSizedArray2
    procedure, private  :: ReadSizedArray_R
    procedure, private  :: ReadSizedArray_D
    procedure, private  :: ReadSizedArray_I
    procedure, private  :: ReadSizedArray2_I
    procedure, private  :: ReadSizedArray2_D
    procedure, private  :: ReadSizedArray2_R
    generic :: Write => WriteItems, WriteArray, WriteArray2, WriteOneAndArray
    generic :: Read => ReadItems, ReadArray, ReadArray2
    generic :: ReadItem => ReadItemFunc, ReadArrayFunc, ReadArray2Func
    generic :: ReadString => ReadStringSub
    generic :: ReadStringItem => ReadStringFunc
    generic :: WriteSizedArray => WriteSizedArray1,WriteSizedArray2
    generic :: ReadSizedArray => ReadSizedArray_R,ReadSizedArray_D,ReadSizedArray_I, &
        & ReadSizedArray2_I, ReadSizedArray2_R, ReadSizedArray2_D
    final :: TFileStream_Free
    end type

    Type, extends(TFileStream) :: TBinaryFile
    end type

    Type, extends(TFileStream) :: TSequentialFile
    contains
    procedure :: SetDefaultModes => TSequentialFile_SetDefaultModes
    end type TSequentialFile

    Type, extends(TSequentialFile) :: TTextFile
        character(LEN=20) :: RealFormat = '(*(E17.7))'
        character(LEN=20) :: IntegerFormat = '(*(I10))'
        logical :: AdvanceDefault = .true.
    contains
    procedure :: SetDefaultModes => TTextFile_SetDefaultModes
    procedure :: ReadLine
    procedure :: ReadLineSkipEmptyAndComments
    procedure :: ReadNextContentLine !as above, but opens and closes file
    procedure :: NewLine
    procedure :: SkipLines
    procedure :: Lines
    procedure :: Columns
    procedure :: WriteLeftAligned
    procedure :: WriteItemTxt
    procedure :: WriteArrayTxt
    procedure :: WriteInLineItems
    procedure :: WriteInLineTrim
    procedure :: WriteFormat => File_WriteFormat
    procedure :: WriteTrim => WriteTrimTxt
    procedure, private :: ReadStringSub => ReadStringTxt
    procedure, private :: ReadItemTxt
    procedure, private :: ReadArrayTxt
    procedure, private :: WriteInLineItem
    procedure, private :: WriteInLineArray
    procedure, private :: DefaultAdvance
    procedure, private :: WriteItem => TTextFile_WriteItem
    procedure, private :: WriteArray => TTextFile_WriteArray
    procedure, private :: WriteOneAndArray => TTextFile_WriteOneAndArray
    procedure, private :: WriteArray2 => WriteArray2Txt
    procedure, private :: ReadItemSub => ReadItemTxt
    procedure, private :: ReadArray => ReadArrayTxt
    procedure, private :: ReadArray2 => ReadArray2Txt
    procedure, private :: WriteItems => WriteItemsTxt
    generic :: WriteInLine => WriteInLineItem, WriteInLineArray
    end type

    !Functions on filenames and text
    !File instance below acts as a namespace
    Type TFile
    contains
    procedure, nopass :: TxtNumberColumns
    procedure, nopass :: TxtColumns
    procedure, nopass :: TxtFileColumns
    procedure, nopass :: TxtFileLines
    procedure, nopass :: LastTopComment
    procedure, nopass :: TopCommentLine
    procedure, nopass :: LastLine => LastFileLine
    procedure, nopass :: Size => FileSize
    procedure, nopass :: Exists => FileExists
    procedure, nopass :: ExtractName => ExtractFileName
    procedure, nopass :: ExtractPath => ExtractFilePath
    procedure, nopass :: Join => File_Join
    procedure, nopass :: ChangeExt => ChangeFileExt
    procedure, nopass :: CheckTrailingSlash
    procedure, nopass :: IsFullPath
    procedure, nopass :: ExtractExt => ExtractFileExt
    procedure, nopass :: Delete => DeleteFile
    procedure, nopass :: ReadTextMatrix
    procedure, nopass :: ReadTextVector
    procedure, nopass :: WriteTextMatrix
    procedure, nopass :: WriteTextVector
    procedure, nopass :: LoadTxt_1D
    procedure, nopass :: LoadTxt_2D
    procedure, nopass :: LoadTxt_int_1D
    procedure, nopass :: LoadTxt_int_2D
    procedure, nopass :: OpenTextFile
    procedure, nopass :: CreateTextFile
    procedure, nopass :: CharIsSlash
    generic  :: LoadTxt => LoadTxt_2D, LoadTxt_1D, LoadTxt_int_1D, LoadTxt_int_2D
    generic  :: SaveTxt => WriteTextMatrix, WriteTextVector
    end type

    type(TFile), public, save :: File

    public TFileStream, TBinaryFile, TTextFile, TFile, File_size_int
    contains

    function FileExists(aname)
    character(LEN=*), intent(IN) :: aname
    logical FileExists

    inquire(file=aname, exist = FileExists)

    end function FileExists

    function FileSize(name) result(fsize)
    integer(file_size_int) fsize
    character(LEN=*), intent(in)::name

    inquire(file=name, size=fsize)

    end function FileSize

    function TxtNumberColumns(InLine) result(n)
    character(LEN=*) :: InLine
    integer n,i
    logical isNum

    n=0
    isNum=.false.
    do i=1, len_trim(InLIne)
        if (verify(InLine(i:i),'-+eE.0123456789') == 0) then
            if (.not. IsNum) n=n+1
            IsNum=.true.
        else
            IsNum=.false.
        end if
    end do

    end function TxtNumberColumns

    function TxtColumns(InLine) result(n)
    character(LEN=*) :: InLine
    integer n,i
    logical isNum

    n=0
    isNum=.false.
    do i=1, len_trim(InLine)
        if (InLine(i:i) > char(32)) then
            if (.not. IsNum) n=n+1
            IsNum=.true.
        else
            IsNum=.false.
        end if
    end do

    end function TxtColumns


    subroutine SetDefaultModes(this)
    class(TFileStream) :: this

    if (.not. allocated(this%mode)) this%mode = 'unformatted'
    if (.not. allocated(this%access)) this%access = 'stream'

    end subroutine SetDefaultModes

    subroutine TSequentialFile_SetDefaultModes(this)
    class(TSequentialFile) :: this

    if (.not. allocated(this%access)) this%access= 'sequential'
    call this%TFileStream%SetDefaultModes

    end subroutine TSequentialFile_SetDefaultModes

    subroutine TTextFile_SetDefaultModes(this)
    class(TTextFile) :: this

    if (.not. allocated(this%mode)) this%mode = 'formatted'
    call this%TSequentialFile%SetDefaultModes

    end subroutine TTextFile_SetDefaultModes


    subroutine CheckOpen(this, forWrite)
    class(TFileStream) :: this
    logical, intent(in), optional :: forWrite

    if (this%unit/=0) return
    if (DefaultFalse(forWrite) .and. this%ReadOnly) then
        call this%Error('File not open for write')
    else
        call this%Error('File not opened')
    end if

    end subroutine

    function Opened(this)
    class(TFileStream) :: this
    logical Opened
    Opened = this%unit /=0
    end function Opened

    subroutine Error(this, msg, errormsg)
    class(TFileStream) :: this
    character(LEN=*), intent(IN) :: msg
    character(LEN=*), intent(IN), optional :: errormsg
    character(LEN=:), allocatable :: Filename

    if (.not. allocated(this%FileName)) then
        FileName = '(no filename set)'
    else
        FileName = this%FileName
    end if
    if (present(errormsg)) then
        call MpiStop(trim(errormsg)//' : '//FileName )
    else
        call MpiStop(trim(msg)//' : '// FileName )
    end if

    end subroutine

    subroutine TFileStream_Close(this, del)
    class(TFileStream) :: this
    logical, optional :: del

    if (this%unit/=0) then
        if (DefaultFalse(del)) then
            close(this%unit, status='DELETE')
        else
            close(this%unit)
        end if
    end if
    this%unit=0
    end subroutine TFileStream_Close

    subroutine TFileStream_Free(this)
    Type(TFileStream) :: this

    call this%Close()
    end subroutine TFileStream_Free

    subroutine TFileStream_Flush(this)
    class(TFileStream) :: this

    call this%CheckOpen
    flush(this%unit)

    end subroutine TFileStream_Flush

    subroutine TFileStream_Rewind(this)
    class(TFileStream) :: this

    if (this%Opened()) rewind(this%unit)

    end subroutine TFileStream_Rewind

    function TFileStream_Position(this)
    class(TFileStream) :: this
    integer(file_size_int) TFileStream_Position

    call this%CheckOpen
    if (this%access /= 'stream') call this%Error('Position requires access=stream')
    inquire(this%unit, pos=TFileStream_Position)

    end function TFileStream_Position


    function TFileStream_Size(this)
    class(TFileStream) :: this
    integer(file_size_int) TFileStream_Size

    if (this%Opened()) then
        inquire(this%unit, size=TFileStream_Size)
    else if (allocated(this%FileName)) then
        TFileStream_Size = File%Size(this%FileName)
    else
        call this%Error('File not defined for size')
    end if

    end function TFileStream_Size

    subroutine TFileStream_Open(this, aname, errormsg, status)
    class(TFileStream) :: this
    character(LEN=*), intent(IN) :: aname
    character(LEN=*), intent(IN), optional :: errormsg
    integer, intent(out), optional :: status

    call this%OpenFile(aname,errormsg=errormsg, status=status)

    end subroutine TFileStream_Open

    subroutine TFileStream_OpenFile(this, aname, mode, errormsg, forwrite, append, status)
    class(TFileStream) :: this
    character(LEN=*), intent(IN) :: aname
    character(LEN=*), intent(IN), optional :: mode
    character(LEN=*), intent(IN), optional :: errormsg
    integer, intent(out), optional :: status
    logical, intent(in), optional :: forwrite, append
    character(LEN=:), allocatable :: amode, state, action, pos
    integer out_status

    call this%Close()
    call this%SetDefaultModes()

    this%FileName = trim(aname)

    amode = PresentDefault(this%mode, mode)
    if (DefaultFalse(forwrite)) then
        state = 'replace'
        action = 'readwrite'
        this%ReadOnly = .false.
    else
        state = 'old'
        action = 'read'
        this%ReadOnly = .true.
    end if
    if (DefaultFalse(append) .and. FileExists(aname)) then
        pos = 'append'
        state = 'old'
        action = 'readwrite'
        this%ReadOnly = .false.
    else
        pos='asis'
    end if

    open(file=aname,form=amode,status=state, action=action, newunit=this%unit, &
        & iostat=out_status, position =pos,  access=this%access)
    if (present(status)) then
        status=out_status
        if (out_status/=0) this%unit = 0
    else
        if (out_status/=0) then
            if (state == 'replace') then
                call this%Error('Error creating file', errormsg)
            else
                call this%Error('File not found', errormsg)
            end if
            this%unit = 0
        end if
    end if
    end subroutine TFileStream_OpenFile

    subroutine CreateFile(this,aname, errormsg)
    class(TFileStream) :: this
    character(LEN=*), intent(IN) :: aname
    character(LEN=*), intent(IN), optional :: errormsg

    call this%OpenFile(aname, errormsg=errormsg, forwrite =.true.)

    end subroutine CreateFile

    subroutine CreateOpenFile(this, aname, append, errormsg)
    class(TFileStream) :: this
    character(LEN=*), intent(IN) :: aname
    logical, optional, intent(in) :: append
    character(LEN=*), intent(IN), optional :: errormsg

    call this%OpenFile(aname, forwrite =.true., append=append, errormsg=errormsg)

    end subroutine CreateOpenFile


    subroutine ReadStringSub(this, S, OK)
    class(TFileStream) :: this
    character(LEN=:), allocatable :: S
    logical, optional :: OK
    logical isOK
    integer i, status

    call this%CheckOpen
    read(this%unit, iostat=status) i
    isOK = status==0
    if (isOK) then
        if (allocated(S)) deallocate(S)
        allocate(character(LEN=i)::S)
        read(this%unit, iostat=status) S
        isOK = status==0
    end if
    if (present(OK)) OK = isOK
    end subroutine ReadStringSub

    function ReadStringFunc(this) result(S)
    class(TFileStream) :: this
    character(LEN=:), allocatable :: S
    call this%ReadString(S)
    end function ReadStringFunc

    subroutine ReadItemSub(this, R, OK)
    class(TFileStream) :: this
    class(*), intent(out) :: R
    logical, optional :: OK
    logical res
    integer status

    call this%CheckOpen
    select type(R)
    type is (real)
        read(this%unit, iostat=status) R
    type is (double precision)
        read(this%unit, iostat=status) R
    type is (integer)
        read(this%unit, iostat=status) R
    type is (logical)
        read(this%unit, iostat=status) R
    type is (character(LEN=*))
        read(this%unit, iostat=status) R
    class default
        call this%Error('Unknown type to read')
    end select

    res = status==0
    if (status/=0 .and. (.not. IS_IOSTAT_END(status) .or. .not. present(OK))) &
        & call this%Error('Error reading item')
    if (present(OK)) OK = res
    end subroutine ReadItemSub


    function ReadItemFunc(this, R) result(res)
    class(TFileStream) :: this
    class(*), intent(out) :: R
    logical :: res

    call this%ReadItemSub(R, res)
    end function ReadItemFunc

    subroutine ReadArray(this, R, n, OK)
    class(TFileStream) :: this
    class(*) :: R(1:)
    integer, intent(in), optional :: n
    logical, optional :: OK
    integer status

    call this%CheckOpen
    select type(R)
    type is (real)
        read(this%unit, iostat=status) R(1:PresentDefault(size(R),n))
    type is (double precision)
        read(this%unit, iostat=status) R(1:PresentDefault(size(R),n))
    type is (integer)
        read(this%unit, iostat=status) R(1:PresentDefault(size(R),n))
    type is (logical)
        read(this%unit, iostat=status) R(1:PresentDefault(size(R),n))
    class default
        call this%Error('Unknown type to read')
    end select
    if (status/=0 .and. (.not. IS_IOSTAT_END(status) .or. .not. present(OK))) &
        & call this%Error('Error reading item')
    if (present(OK)) OK = status==0
    end subroutine ReadArray


    function ReadArrayFunc(this, R, n) result(res)
    class(TFileStream) :: this
    class(*) :: R(1:)
    integer, intent(in), optional :: n
    logical :: res

    call this%ReadArray(R,n,res)

    end function ReadArrayFunc


    function ReadArray2Func(this, R) result(res)
    class(TFileStream) :: this
    class(*) :: R(:,:)
    logical :: res
    call this%ReadArray2(R,res)
    end function ReadArray2Func


    subroutine ReadArray2(this, R, OK)
    class(TFileStream) :: this
    class(*) :: R(:,:)
    logical, optional :: OK
    integer status

    call this%CheckOpen
    select type(R)
    type is (real)
        read(this%unit, iostat=status) R
    type is (double precision)
        read(this%unit, iostat=status) R
    type is (integer)
        read(this%unit, iostat=status) R
    type is (logical)
        read(this%unit, iostat=status) R
    class default
        call this%Error('Unknown type to read')
    end select
    if (status/=0 .and. (.not. IS_IOSTAT_END(status) .or. .not. present(OK))) &
        & call this%Error('Error reading item')
    if (present(OK)) OK = status==0
    end subroutine ReadArray2

    subroutine ReadSizedArray_R(this, R)
    class(TFileStream) :: this
    Real, allocatable :: R(:)
    integer sz

    call this%Read(sz)
    if (allocated(R)) deallocate(R)
    allocate(R(sz))
    call this%ReadArray(R)

    end subroutine ReadSizedArray_R


    subroutine ReadSizedArray_D(this, R)
    class(TFileStream) :: this
    double precision, allocatable :: R(:)
    integer sz

    call this%Read(sz)
    if (allocated(R)) deallocate(R)
    allocate(R(sz))
    call this%ReadArray(R)

    end subroutine ReadSizedArray_D

    subroutine ReadSizedArray_I(this, R)
    class(TFileStream) :: this
    integer, allocatable :: R(:)
    integer sz

    call this%Read(sz)
    if (allocated(R)) deallocate(R)
    allocate(R(sz))
    call this%ReadArray(R)

    end subroutine ReadSizedArray_I

    subroutine ReadSizedArray2_R(this, R)
    class(TFileStream) :: this
    real, allocatable :: R(:,:)
    integer sz1, sz2

    call this%Read(sz1)
    call this%Read(sz2)
    if (allocated(R)) deallocate(R)
    allocate(R(sz1,sz2))
    call this%ReadArray2(R)

    end subroutine ReadSizedArray2_R

    subroutine ReadSizedArray2_D(this, R)
    class(TFileStream) :: this
    double precision, allocatable :: R(:,:)
    integer sz1, sz2

    call this%Read(sz1)
    call this%Read(sz2)
    if (allocated(R)) deallocate(R)
    allocate(R(sz1,sz2))
    call this%ReadArray2(R)

    end subroutine ReadSizedArray2_D

    subroutine ReadSizedArray2_I(this, R)
    class(TFileStream) :: this
    integer, allocatable :: R(:,:)
    integer sz1, sz2

    call this%Read(sz1)
    call this%Read(sz2)
    if (allocated(R)) deallocate(R)
    allocate(R(sz1,sz2))
    call this%ReadArray2(R)

    end subroutine ReadSizedArray2_I

    subroutine WriteItemSub(this, R)
    class(TFileStream) :: this
    class(*), intent(in) :: R

    call this%CheckOpen(.true.)
    select type(R)
    type is (real)
        Write(this%unit) R
    type is (double precision)
        Write(this%unit) R
    type is (integer)
        Write(this%unit) R
    type is (logical)
        Write(this%unit) R
    type is (character(LEN=*))
        Write(this%unit) len(R)
        Write(this%unit) R
    class default
        call this%Error('Unknown type to Write')
    end select

    end subroutine WriteItemSub

    subroutine WriteTrim(this, S)
    class(TFileStream) :: this
    character(LEN=*), intent(in) :: S
    call this%WriteItemSub(trim(S))
    end subroutine WriteTrim

    subroutine WriteSizedArray1(this, R, n)
    class(TFileStream) :: this
    class(*), intent(in) :: R(1:)
    integer, intent(in), optional :: n
    integer sz

    sz=PresentDefault(size(R),n)
    call this%Write(sz)
    call this%WriteArray(R,n)

    end subroutine WriteSizedArray1

    subroutine WriteSizedArray2(this, R)
    class(TFileStream) :: this
    class(*), intent(in) :: R(:,:)

    call this%Write(size(R,dim=1))
    call this%Write(size(R,dim=2))
    call this%WriteArray2(R)

    end subroutine WriteSizedArray2

    subroutine WriteOneAndArray(this, I, R)
    class(TFileStream) :: this
    class(*), intent(in) :: I
    class(*), intent(in) :: R(:)

    call this%WriteItemSub(I)
    call this%WriteArray(R)

    end subroutine WriteOneAndArray

    subroutine WriteArray(this, R, n)
    class(TFileStream) :: this
    class(*), intent(in) :: R(1:)
    integer, intent(in), optional :: n
    integer sz

    sz=PresentDefault(size(R),n)
    call this%CheckOpen(.true.)
    select type(R)
    type is (real)
        Write(this%unit) R(1:sz)
    type is (double precision)
        Write(this%unit) R(1:sz)
    type is (integer)
        Write(this%unit) R(1:sz)
    type is (logical)
        Write(this%unit) R(1:sz)
    class default
        call this%Error('Unknown type to Write')
    end select

    end subroutine WriteArray

    subroutine WriteArray2(this, R)
    class(TFileStream) :: this
    class(*), intent(in) :: R(:,:)

    call this%CheckOpen(.true.)
    select type(R)
    type is (real)
        Write(this%unit) R
    type is (double precision)
        Write(this%unit) R
    type is (integer)
        Write(this%unit) R
    type is (logical)
        Write(this%unit) R
    class default
        call this%Error('Unknown type to Write')
    end select

    end subroutine WriteArray2

    subroutine WriteItems(this, S1, S2,S3,S4,S5,S6)
    class(TFileStream) :: this
    class(*), intent(in) :: S1
    class(*), intent(in), optional :: S2, S3,S4,S5,S6

    call this%WriteItemSub(S1)
    if (present(S2)) call this%WriteItemSub(S2)
    if (present(S3)) call this%WriteItemSub(S3)
    if (present(S4)) call this%WriteItemSub(S4)
    if (present(S5)) call this%WriteItemSub(S5)
    if (present(S6)) call this%WriteItemSub(S6)

    end subroutine WriteItems

    subroutine ReadItems(this, S1, S2,S3,S4,S5,S6,OK)
    class(TFileStream) :: this
    class(*) S1
    class(*), optional :: S2,S3,S4,S5,S6
    logical, optional :: OK

    call this%ReadItemSub(S1,OK)
    if (present(S2) .and. DefaultTrue(OK)) call this%ReadItemSub(S2,OK)
    if (present(S3) .and. DefaultTrue(OK)) call this%ReadItemSub(S3,OK)
    if (present(S4) .and. DefaultTrue(OK)) call this%ReadItemSub(S4,OK)
    if (present(S5) .and. DefaultTrue(OK)) call this%ReadItemSub(S5,OK)
    if (present(S6) .and. DefaultTrue(OK)) call this%ReadItemSub(S6,OK)

    end subroutine ReadItems

    !Text unformatted files

    function ReadLine(this, InLine, trimmed) result(OK)
    class(TTextFile) :: this
    character(LEN=:), allocatable, optional :: InLine
    logical, intent(in), optional :: trimmed
    integer, parameter :: line_buf_len= 1024*4
    character(LEN=line_buf_len) :: InS
    logical :: OK, set
    integer status, size

    call this%CheckOpen
    OK = .false.
    set = .true.
    do
        read (this%unit,'(a)',advance='NO',iostat=status, size=size) InS
        OK = .not. IS_IOSTAT_END(status)
        if (.not. OK) return
        if (present(InLine)) then
            if (set) then
                InLine = InS(1:size)
                set=.false.
            else
                InLine = InLine // InS(1:size)
            end if
        end if
        if (IS_IOSTAT_EOR(status)) exit
    end do
    if (present(trimmed) .and. present(InLine)) then
        if (trimmed) InLine = trim(adjustl(InLine))
    end if

    end function ReadLine

    function ReadLineSkipEmptyAndComments(this, InLine, comment) result(OK)
    class(TTextFile) :: this
    logical :: OK
    character(LEN=:), allocatable :: InLine
    character(LEN=:), allocatable, optional, intent(inout) :: comment

    if (present(comment)) then
        if (.not. allocated(comment)) comment=''
    end if
    do
        OK = this%ReadLine(InLine, trimmed=.true.)
        if (.not. OK) return
        if (InLine=='') cycle
        if (InLine(1:1)/='#') then
            return
        else
            if (present(comment)) comment = trim(InLine(2:))
        end if
    end do

    end function ReadLineSkipEmptyAndComments

    function ReadNextContentLine(this, filename, InLine) result(OK)
    class(TTextFile) :: this
    character(LEN=*), intent(in) :: filename
    character(LEN=:), intent(out), allocatable :: InLine
    logical :: OK

    if (.not. this%Opened()) call this%Open(filename)
    OK = this%ReadLineSkipEmptyAndComments(InLine)
    if (.not. OK) call this%Close()

    end function ReadNextContentLine

    function SkipLines(this, n) result(OK)
    class(TTextFile) :: this
    integer, intent(in) :: n
    logical OK
    integer ix

    do ix = 1, n
        if (.not. this%ReadLine()) then
            OK = .false.
            return
        end if
    end do
    OK = .true.

    end function SkipLines

    function Columns(this) result(n)
    class(TTextFile) :: this
    integer n
    character(LEN=:), allocatable :: InLine

    if (this%ReadLineSkipEmptyAndComments(InLine)) then
        n = File%TxtNumberColumns(InLine)
    else
        n=0
    end if
    call this%Rewind()

    end function Columns

    function Lines(this, nocomments) result(n)
    class(TTextFile) :: this
    logical, intent(in), optional :: nocomments
    integer n
    character(LEN=:), allocatable :: InLine

    n=0
    if (DefaultTrue(nocomments)) then
        do while (this%ReadLineSkipEmptyAndComments(InLine))
            n = n+1
        end do
    else
        do while (this%ReadLine())
            n = n+1
        end do
    end if
    call this%Rewind()

    end function Lines

    function DefaultAdvance(this,advance)
    class(TTextFile) :: this
    logical, intent(in), optional :: advance
    character(3) :: DefaultAdvance

    if (PresentDefault(this%AdvanceDefault,advance)) then
        DefaultAdvance='YES'
    else
        DefaultAdvance='NO'
    end if

    end function

    subroutine NewLine(this)
    class(TTextFile) :: this
    call this%WriteItemTxt('')
    end subroutine

    subroutine WriteLeftAligned(this, Form, str)
    class(TTextFile) :: this
    character(LEN=*) str, Form
    Character(LEN=max(len(str),128)) tmp

    call this%CheckOpen(.true.)
    tmp = str
    write(this%unit,form, advance='NO') tmp

    end subroutine WriteLeftAligned


    subroutine WriteInLineItems(this, S1, S2,S3,S4,S5,S6)
    class(TTextFile) :: this
    class(*), intent(in) :: S1
    class(*), intent(in), optional :: S2, S3,S4,S5,S6

    call this%WriteInLine(S1)
    if (present(S2)) call this%WriteInLine(S2)
    if (present(S3)) call this%WriteInLine(S3)
    if (present(S4)) call this%WriteInLine(S4)
    if (present(S5)) call this%WriteInLine(S5)
    if (present(S6)) call this%WriteInLine(S6)

    end subroutine WriteInLineItems

    subroutine WriteItemsTxt(this, S1, S2,S3,S4,S5,S6)
    class(TTextFile) :: this
    class(*), intent(in) :: S1
    class(*), intent(in), optional :: S2, S3,S4,S5,S6

    call this%WriteInLineItems(S1, S2,S3,S4,S5,S6)
    call this%NewLine()

    end subroutine WriteItemsTxt

    subroutine WriteInLineItem(this,str,form)
    class(TTextFile) :: this
    class(*), intent(in) :: str
    character(LEN=*), intent(in), optional :: form
    call this%WriteItemTxt(str,form,.false.)
    end subroutine WriteInLineItem

    subroutine WriteInLineArray(this,str,form,n)
    class(TTextFile) :: this
    class(*), intent(in) :: str(:)
    character(LEN=*), intent(in), optional :: form
    integer, intent(in), optional :: n

    call this%WriteArrayTxt(str,form,.false.,number=n)
    end subroutine WriteInLineArray

    subroutine TTextFile_WriteItem(this,R)
    class(TTextFile) :: this
    class(*), intent(in) :: R
    call this%WriteItemTxt(R,advance=.true.)
    end subroutine TTextFile_WriteItem

    subroutine TTextFile_WriteArray(this,R,n)
    class(TTextFile) :: this
    class(*), intent(in) :: R(:)
    integer, intent(in), optional :: n
    call this%WriteArrayTxt(R,number=n,advance=.true.)
    end subroutine TTextFile_WriteArray


    subroutine TTextFile_WriteOneAndArray(this, I, R)
    class(TTextFile) :: this
    class(*), intent(in) :: I
    class(*), intent(in) :: R(:)

    call this%WriteInlineItem(I)
    call this%WriteArrayTxt(R)

    end subroutine TTextFile_WriteOneAndArray

    subroutine WriteItemTxt(this, str, form, advance)
    class(TTextFile) :: this
    class(*), intent(in) :: str
    character(LEN=*), intent(in), optional :: form
    logical, intent(in), optional :: advance
    character(LEN=3) :: Ad

    call this%CheckOpen(.true.)
    Ad = this%DefaultAdvance(advance)
    select type(str)
    type is (character(LEN=*))
        if (Ad=='YES') then
            write(this%unit,PresentDefault('(a)',form)) trim(str)
        else
            write(this%unit,PresentDefault('(a)',form), advance=Ad) str
        end if
    type is (real)
        write(this%unit,PresentDefault(this%RealFormat,form), advance=Ad) str
    type is (double precision)
        write(this%unit,PresentDefault(this%RealFormat,form), advance=Ad) str
    type is (integer)
        write(this%unit,PresentDefault(this%IntegerFormat,form), advance=Ad) str
    type is (logical)
        write(this%unit,PresentDefault('(L2)',form), advance=Ad) str
    class default
        call this%Error('unknown type to write')
    end select

    end subroutine WriteItemTxt

    subroutine WriteArrayTxt(this, str, form, advance, number)
    class(TTextFile) :: this
    class(*), intent(in) :: str(:)
    character(LEN=*), intent(in), optional :: form
    logical, intent(in), optional :: advance
    integer, intent(in), optional :: number
    integer n
    character(LEN=3) :: Ad

    Ad = this%DefaultAdvance(advance)
    n = PresentDefault(size(str),number)
    call this%CheckOpen(.true.)
    select type(str)
    type is (character(LEN=*))
        write(this%unit,PresentDefault('(a)',form), advance=Ad) str(1:n)
    type is (real)
        write(this%unit,PresentDefault(this%RealFormat,form), advance=Ad) str(1:n)
    type is (double precision)
        write(this%unit,PresentDefault(this%RealFormat,form), advance=Ad) str(1:n)
    type is (integer)
        write(this%unit,PresentDefault(this%IntegerFormat,form), advance=Ad) str(1:n)
    type is (logical)
        write(this%unit,PresentDefault('(*(L2))',form), advance=Ad) str(1:n)
    class default
        call this%Error('unknown type to write')
    end select

    end subroutine WriteArrayTxt

    subroutine WriteArray2Txt(this, R)
    class(TTextFile) :: this
    class(*), intent(in) :: R(:,:)
    integer i

    do i=1, size(R,1)
        call this%WriteArrayTxt(R(i,:))
    end do

    end subroutine WriteArray2Txt


    subroutine WriteTrimTxt(this, S)
    class(TTextFile) :: this
    character(LEN=*), intent(in) :: S

    call this%WriteItemTxt(S, advance=.true.)

    end subroutine WriteTrimTxt

    subroutine WriteInLineTrim(this, string)
    class(TTextFile) :: this
    character(LEN=*), intent(in) :: string

    call this%WriteItemTxt(trim(string), advance=.false.)
    end subroutine WriteInLineTrim


    subroutine ReadArray2Txt(this, R, OK)
    class(TTextFile) :: this
    class(*) ::  R(:,:)
    logical, optional :: OK
    integer i

    do i=1, size(R,1)
        call this%ReadArrayTxt(R(i,:), OK=OK)
        if (present(OK)) then
            if (.not. OK) return
        end if
    end do

    end subroutine ReadArray2Txt


    subroutine ReadItemTxt(this, R, OK)
    class(TTextFile) :: this
    class(*), intent(out) :: R
    logical, optional :: OK
    integer status

    call this%CheckOpen
    select type(R)
    type is (character(LEN=*))
        Read(this%unit,'(a)', iostat=status) R
    type is (real)
        Read(this%unit,*, iostat=status) R
    type is (double precision)
        Read(this%unit,*, iostat=status) R
    type is (integer)
        Read(this%unit,*, iostat=status) R
    class default
        call this%Error('unknown type to Read')
    end select
    if (status/=0 .and. (.not. IS_IOSTAT_END(status) .or. .not. present(OK))) &
        & call this%Error('Error reading item')
    if (present(OK)) OK = status==0

    end subroutine ReadItemTxt

    subroutine ReadArrayTxt(this, R, n, OK)
    class(TTextFile) :: this
    class(*) :: R(1:)
    integer, intent(in), optional :: n
    logical, optional :: OK
    integer status

    call this%CheckOpen
    select type(R)
    type is (real)
        Read(this%unit,*, iostat=status) R(1:PresentDefault(size(R),n))
    type is (double precision)
        Read(this%unit,*, iostat=status) R(1:PresentDefault(size(R),n))
    type is (integer)
        Read(this%unit,*, iostat=status) R(1:PresentDefault(size(R),n))
    class default
        call this%Error('unknown type to Read')
    end select

    if (status/=0 .and. (.not. IS_IOSTAT_END(status) .or. .not. present(OK))) &
        & call this%Error('Error reading item')
    if (present(OK)) OK = status==0

    end subroutine ReadArrayTxt

    subroutine ReadStringTxt(this, S, OK)
    class(TTextFile) :: this
    character(LEN=:), allocatable :: S
    logical, optional :: OK
    logical isOK

    isOK = this%ReadLine(S)
    if (present(OK)) OK = isOK

    end subroutine  ReadStringTxt

    subroutine File_WriteFormat(this, formatst, i1,i2,i3,i4,i5,i6,i7,i8)
    class(TTextFile) :: this
    character(LEN=*), intent(in) :: formatst
    class(*), intent(in) :: i1
    class(*), intent(in),optional :: i2,i3,i4,i5,i6,i7,i8

    call this%CheckOpen(.true.)
    write(this%unit,'(a)') FormatString(formatst,i1,i2,i3,i4,i5,i6,i7,i8)

    end subroutine File_WriteFormat

    !Misc functions

    function TopCommentLine(aname) result(res)
    !Get top comment line in file, including #
    character(LEN=*), intent(IN) :: aname
    character(LEN=:), allocatable :: res
    Type(TTextFile) :: F

    call F%Open(aname)
    res=''
    do while (res == '')
        if (.not. F%ReadLine(res)) exit
    end do
    If (res(1:1)/='#') then
        res = ''
    end if
    call F%Close()

    end function TopCommentLine


    function LastTopComment(aname) result(res)
    !Get content of last commented line at the top of file (e.g. column header), without #
    character(LEN=*), intent(IN) :: aname
    character(LEN=:), allocatable :: res, InLine
    Type(TTextFile) :: F

    call F%Open(aname)
    res=''
    do while (F%ReadLine(InLine))
        if (trim(InLine)=='') cycle
        if (InLine(1:1)=='#') then
            res = trim(adjustl(InLine(2:)))
        else
            exit
        end if
    end do
    call F%Close()

    end function LastTopComment


    function TxtFileColumns(aname) result(n)
    character(LEN=*), intent(IN) :: aname
    integer n
    Type(TTextFile) :: F

    call F%Open(aname)
    n = F%Columns()
    call F%Close()

    end function TxtFileColumns

    function TxtFileLines(aname) result(n)
    character(LEN=*), intent(IN) :: aname
    integer n
    Type(TTextFile) :: F

    call F%Open(aname)
    n = F%Lines()
    call F%Close()

    end function TxtFileLines


    function LastFileLine(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=:), allocatable :: LastFileLine
    Type(TTextFile) :: F

    LastFileLine = ''
    call F%Open(aname)
    do while (F%ReadLine(LastFileLine))
    end do
    call F%Close()
    end function LastFileLine


    function CharIsSlash(C)
    character, intent(in) :: C
    logical CharIsSlash
    character, parameter :: win_slash = char(92)

    CharIsSlash = C == win_slash .or. C == '/'

    end function CharIsSlash

    function IsFullPath(aname)
    character(LEN=*), intent(IN) :: aname
    logical IsFullPath

    IsFullPath = aname/=''
    if (.not. IsFullPath) return
    IsFullPath = CharIsSlash(aname(1:1))

    end function IsFullpath

    function ExtractFilePath(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=:), allocatable :: ExtractFilePath
    integer i

    do i = len_trim(aname), 1, -1
        if (CharIsSlash(aname(i:i))) then
            ExtractFilePath = aname(1:i)
            return
        end if
    end do
    ExtractFilePath = ''

    end function ExtractFilePath

    function ExtractFileExt(aname)
    character(LEN=*), intent(IN) :: aname
    character(LEN=:), allocatable :: ExtractFileExt
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (CharIsSlash(aname(i:i))) then
            ExtractFileExt = ''
            return
        else if (aname(i:i)=='.') then
            ExtractFileExt= aname(i:len)
            return
        end if
    end do
    ExtractFileExt = ''

    end function ExtractFileExt


    function ExtractFileName(aname, no_ext, all_ext)
    character(LEN=*), intent(IN) :: aname
    character(LEN=:), allocatable :: ExtractFileName
    logical, intent(in), optional :: no_ext, all_ext
    integer alen, i

    alen = len_trim(aname)
    do i = alen, 1, -1
        if (CharIsSlash(aname(i:i))) then
            ExtractFileName = aname(i+1:alen)
            exit
        end if
    end do
    if (.not. allocated(ExtractFileName)) ExtractFileName = trim(aname)
    if (DefaultFalse(no_ext)) then
        do i = len(ExtractFileName), 1, -1
            if (ExtractFileName(i:i)=='.') then
                ExtractFileName = ExtractFileName(1:i-1)
                if (.not. DefaultFalse(all_ext)) exit
            end if
        end do
    end if

    end function ExtractFileName

    function ChangeFileExt(aname,ext)
    character(LEN=*), intent(IN) :: aname,ext
    character(LEN=:), allocatable :: ChangeFileExt
    integer len, i

    len = len_trim(aname)
    do i = len, 1, -1
        if (aname(i:i)=='.') then
            ChangeFileExt = aname(1:i) // trim(ext)
            return
        end if
    end do
    ChangeFileExt = trim(aname) // '.' // trim(ext)

    end function ChangeFileExt

    function CheckTrailingSlash(aname)
    character(LEN=*), intent(in) :: aname
    character(LEN=:), allocatable :: CheckTrailingSlash
    integer alen

    alen = len_trim(aname)
    if (CharIsSlash(aname(alen:alen))) then
        CheckTrailingSlash = aname(1:alen)
    else
        CheckTrailingSlash = trim(aname)//'/'
    end if

    end function CheckTrailingSlash


    function File_Join(path, aname)
    character(LEN=*), intent(in) :: path, aname
    character(LEN=:), allocatable :: File_Join

    File_Join = CheckTrailingSlash(path)//trim(aname)

    end function File_Join


    subroutine DeleteFile(aname)
    character(LEN=*), intent(IN) :: aname
    integer file_id, status

    if (FileExists(aname)) then
        open(newunit = file_id, file = aname, iostat=status)
        if (status/=0) return
        close(unit = file_id, status = 'DELETE')
    end if

    end subroutine DeleteFile


    subroutine ReadTextVector(aname, vec, n)
    character(LEN=*), intent(IN) :: aname
    integer, intent(in) :: n
    class(*), intent(out) :: vec(n)
    integer j
    Type(TTextFile) :: F

    call F%Open(aname)
    do j=1,n
        call F%Read(vec(j))
    end do
    call F%Close()

    end subroutine ReadTextVector

    subroutine WriteTextVector(aname, vec, n, fmt)
    character(LEN=*), intent(IN) :: aname
    integer, intent(in), optional :: n
    class(*), intent(in) :: vec(:)
    character(LEN=*), intent(in), optional :: fmt
    integer j
    Type(TTextFile) :: F

    call F%CreateFile(aname)
    if (present(fmt)) then
        if (isFLoat(vec)) then
            F%RealFormat = fmt
        else
            F%IntegerFormat = fmt
        end if
    end if
    do j=1, PresentDefault(size(vec),n)
        call F%Write(vec(j))
    end do
    call F%Close()

    end subroutine WriteTextVector

    subroutine WriteTextMatrix(aname, mat, m, n, fmt)
    character(LEN=*), intent(IN) :: aname
    integer, intent(in), optional :: m, n
    character(LEN=*), intent(in), optional :: fmt
    class(*), intent(in) :: mat(:,:)
    Type(TTextFile) :: F

    call F%CreateFile(aname)
    if (present(fmt)) then
        if (isFLoat(mat)) then
            F%RealFormat = fmt
        else
            F%IntegerFormat = fmt
        end if
    end if
    if (present(m) .or. present(n)) then
        call F%Write(mat(1:PresentDefault(size(mat,1),m),1:PresentDefault(size(mat,2),n)))
    else
        call F%Write(mat)
    end if
    call F%Close()

    end subroutine WriteTextMatrix


    subroutine ReadTextMatrix(aname, mat, inm,inn)
    character(LEN=*), intent(IN) :: aname
    integer, intent(in), optional :: inm,inn
    real(kind(1.d0)), intent(out) :: mat(:,:)
    character(LEN=:), allocatable :: InLine
    real(kind(1.d0)), allocatable :: readarr(:)
    integer j,k, status, n,m
    Type(TTextFile) :: F

    m = PresentDefault(size(mat,dim=1),inm)
    n = PresentDefault(size(mat,dim=2),inn)
    call F%Open(aname)
    allocate(readarr(n))
    do j=1,m
        status = 1
        if (.not. F%ReadLineSkipEmptyAndComments(InLine)) exit
        read (InLine,*, iostat=status) readarr
        if (status/=0) exit
        mat(j,1:n) = readarr
    end do
    if (status/=0) then
        call F%Rewind()  !Try other possible format
        do j=1,m
            do k=1,n
                status = 1
                if (.not. F%ReadLineSkipEmptyAndComments(InLine)) exit
                read (InLine,*, iostat=status) mat(j,k)
                if (status/=0) call F%Error( 'matrix file is the wrong size')
            end do
        end do
    end if

    if (F%ReadLineSkipEmptyAndComments(InLine)) call F%Error( 'matrix file is the wrong size (too big)')

    call F%Close()

    end subroutine ReadTextMatrix

    subroutine LoadTxt_2D(aname, mat, m, n, comment)
    character(LEN=*), intent(IN) :: aname
    real(kind(1.d0)), allocatable, intent(out) :: mat(:,:)
    integer mm, nn, j
    Type(TTextFile) :: F
    character(LEN=:), allocatable :: InLine
    integer, optional, intent(out) :: m, n
    character(LEN=:), allocatable, optional, intent(out) :: comment
    integer status
    real(kind(1.d0)), allocatable :: readarr(:)

    call F%Open(aname)
    nn = F%Columns()
    mm = F%Lines()
    allocate(mat(mm,nn))
    allocate(readarr(nn))
    j=1
    do while (F%ReadLineSkipEmptyAndComments(InLine, comment = comment))
        read (InLine,*, iostat=status) readarr
        if (status/=0) call F%Error( 'LoadTxt: error reading line:' //trim(InLine))
        mat(j,1:nn) = readarr
        j = j+1
    end do
    call F%Close()
    if (present(m)) m = mm
    if (present(n)) n = nn

    end subroutine LoadTxt_2D

    subroutine LoadTxt_1D(aname, vec, n, comment)
    character(LEN=*), intent(IN) :: aname
    real(kind(1.d0)), allocatable, intent(out) :: vec(:)
    integer nn, j
    Type(TTextFile) :: F
    character(LEN=:), allocatable :: InLine
    integer, optional, intent(out) :: n
    character(LEN=:), allocatable, optional, intent(out) :: comment
    integer status

    call F%Open(aname)
    nn = F%Lines()
    allocate(vec(nn))
    j=1
    do while (F%ReadLineSkipEmptyAndComments(InLine, comment = comment))
        read (InLine,*, iostat=status) vec(j)
        if (status/=0) call F%Error( 'LoadTxt: error reading line:' //trim(InLine))
        j = j+1
    end do
    call F%Close()
    if (present(n)) n = nn

    end subroutine LoadTxt_1D


    subroutine LoadTxt_int_2D(aname, mat, m, n, comment)
    character(LEN=*), intent(IN) :: aname
    integer, allocatable, intent(out) :: mat(:,:)
    integer mm, nn, j
    Type(TTextFile) :: F
    character(LEN=:), allocatable :: InLine
    integer, optional, intent(out) :: m, n
    character(LEN=:), allocatable, optional, intent(out) :: comment
    integer, allocatable :: readarr(:)
    integer status

    call F%Open(aname)
    nn = F%Columns()
    mm = F%Lines()
    allocate(mat(mm,nn))
    allocate(readarr(nn))
    j=1
    do while (F%ReadLineSkipEmptyAndComments(InLine, comment = comment))
        read (InLine,*, iostat=status) readarr
        if (status/=0) call F%Error( 'LoadTxt: error reading line:' //trim(InLine))
        mat(j,1:nn) = readarr
        j = j+1
    end do
    call F%Close()
    if (present(m)) m = mm
    if (present(n)) n = nn

    end subroutine LoadTxt_int_2D

    subroutine LoadTxt_int_1D(aname, vec, n, comment)
    character(LEN=*), intent(IN) :: aname
    integer, allocatable, intent(out) :: vec(:)
    integer nn, j
    Type(TTextFile) :: F
    character(LEN=:), allocatable :: InLine
    integer, optional, intent(out) :: n
    character(LEN=:), allocatable, optional, intent(out) :: comment
    integer status

    call F%Open(aname)
    nn = F%Lines()
    allocate(vec(nn))
    j=1
    do while (F%ReadLineSkipEmptyAndComments(InLine, comment = comment))
        read (InLine,*, iostat=status) vec(j)
        if (status/=0) call F%Error( 'LoadTxt: error reading line:' //trim(InLine))
        j = j+1
    end do
    call F%Close()
    if (present(n)) n = nn

    end subroutine LoadTxt_int_1D

    function CreateTextFile(fname)
    character(LEN=*), intent(in) :: fname
    Type(TTextFile) :: CreateTextFile

    call CreateTextFile%CreateFile(fname)

    end function CreateTextFile

    function OpenTextFile(fname)
    character(LEN=*), intent(in) :: fname
    Type(TTextFile) :: OpenTextFile

    call OpenTextFile%OpenFile(fname)

    end function OpenTextFile


    end module FileUtils

    ! Equations module for background and ! To avoid circular module issues, some things are not part of module

    ! Background evolution, return d tau/ d a, where tau is the conformal time
    function dtauda(this,a)
    use results
    use DarkEnergyInterface
    implicit none
    class(CAMBdata) :: this
    real(dl), intent(in) :: a
    real(dl) :: dtauda, grhoa2, grhov_t

    call this%CP%DarkEnergy%BackgroundDensityAndPressure(this%grhov, a, grhov_t)

    !  8*pi*G*rho*a**4.
    grhoa2 = this%grho_no_de(a) +  grhov_t * a**2
    if (grhoa2 <= 0) then
        call GlobalError('Universe stops expanding before today (recollapse not supported)', error_unsupported_params)
        dtauda = 0
    else
        dtauda = sqrt(3 / grhoa2)
    end if

    end function dtauda

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

    !Gauge-dependent perturbation equations

    module GaugeInterface
    use precision
    use results
    use MassiveNu
    use DarkEnergyInterface
    use Transfer
    implicit none
    public

    ! Equations and relation to synchronous gauge variables documented in the notes:
    ! https://cosmologist.info/notes/CAMB.pdf

    !Description of this file. Change if you make modifications.
    character(LEN=*), parameter :: Eqns_name = 'cdm_gauge'

    logical, parameter :: plot_evolve = .false. !for outputing time evolution

    integer, parameter :: basic_num_eqns = 4
    integer, parameter :: ix_etak=1, ix_clxc=2, ix_clxb=3, ix_vb=4 !Scalar array indices for each quantity
    integer, parameter :: ixt_H = 1, ixt_shear = 2 !tensor indices

    logical :: DoTensorNeutrinos = .true.

    logical, parameter :: second_order_tightcoupling = .true.

    real(dl) :: Magnetic = 0._dl
    !Vector mode anisotropic stress in units of rho_gamma
    real(dl) :: vec_sig0 = 1._dl
    !Vector mode shear
    integer, parameter :: max_l_evolve = 256 !Maximum l we are ever likely to propagate
    !Note higher values increase size of Evolution vars, hence memory

    !Supported scalar initial condition flags
    integer, parameter :: initial_adiabatic=1, initial_iso_CDM=2, &
        initial_iso_baryon=3,  initial_iso_neutrino=4, initial_iso_neutrino_vel=5, initial_vector = 0
    integer, parameter :: initial_nummodes =  initial_iso_neutrino_vel

    type EvolutionVars
        real(dl) q, q2
        real(dl) k_buf,k2_buf ! set in initial
        logical :: is_cosmological_constant

        integer w_ix !Index of two quintessence equations
        integer Tg_ix !index of matter temerature perturbation
        integer reion_line_ix !index of matter temerature perturbation

        integer xe_ix !index of x_e perturbation
        integer Ts_ix !index of Delta_{T_s}

        integer r_ix !Index of the massless neutrino hierarchy
        integer g_ix !Index of the photon neutrino hierarchy

        integer q_ix !index into q_evolve array that gives the value q
        logical TransferOnly

        !       nvar  - number of scalar (tensor) equations for this k
        integer nvar,nvart, nvarv

        !Max_l for the various hierarchies
        integer lmaxg,lmaxnr,lmaxnu,lmaxgpol,MaxlNeeded
        integer lmaxnrt, lmaxnut, lmaxt, lmaxpolt, MaxlNeededt
        logical EvolveTensorMassiveNu(max_nu)
        integer lmaxnrv, lmaxv, lmaxpolv
        integer lmaxline !21cm multipoles for getting reionization effect

        integer polind  !index into scalar array of polarization hierarchy

        !array indices for massive neutrino equations
        integer nu_ix(max_nu), nu_pert_ix
        integer nq(max_nu), lmaxnu_pert
        logical has_nu_relativistic

        !Initial values for massive neutrino v*3 variables calculated when switching
        !to non-relativistic approx
        real(dl) G11(max_nu),G30(max_nu)
        !True when using non-relativistic approximation
        logical MassiveNuApprox(max_nu)
        real(dl) MassiveNuApproxTime(max_nu)

        !True when truncating at l=2,3 when k*tau>>1 (see arXiv:1104.2933)
        logical high_ktau_neutrino_approx

        !Massive neutrino scheme being used at the moment
        integer NuMethod

        !True when using tight-coupling approximation (required for stability at early times)
        logical TightCoupling, TensTightCoupling
        real(dl) TightSwitchoffTime

        !Numer of scalar equations we are propagating
        integer ScalEqsToPropagate
        integer TensEqsToPropagate
        !beta > l for closed models
        integer FirstZerolForBeta
        !Tensor vars
        real(dl) aux_buf

        real(dl) pig, pigdot
        real(dl) poltruncfac

        logical no_nu_multpoles, no_phot_multpoles
        integer lmaxnu_tau(max_nu)  !lmax for massive neutinos at time being integrated
        logical nu_nonrelativistic(max_nu)

        real(dl) denlk(max_l_evolve),denlk2(max_l_evolve), polfack(max_l_evolve)
        real(dl) Kf(max_l_evolve)

        integer E_ix, B_ix !tensor polarizatisdon indices
        real(dl) denlkt(4,max_l_evolve),Kft(max_l_evolve)

        logical :: saha !still high x_e
        logical :: evolve_TM !\delta T_g evolved separately
        logical :: evolve_baryon_cs !evolving sound speed rather than using background approx

        !Workaround for ifort, gives class pointer to avoid creating temps and huge slow down
        class(TThermoData), pointer :: ThermoData => null()

        real, pointer :: OutputTransfer(:) => null()
        real(dl), pointer :: OutputSources(:) => null()
        real(dl), pointer :: CustomSources(:) => null()
        integer :: OutputStep = 0

    end type EvolutionVars

    ABSTRACT INTERFACE
    SUBROUTINE TSource_func(sources, tau, a, adotoa, grho, gpres,w_lam, cs2_lam,  &
        grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,grhonu_t, &
        k,etak, etakdot, phi, phidot, sigma, sigmadot, &
        dgrho, clxg,clxb,clxc,clxr, clxnu, clxde, delta_p_b, &
        dgq, qg, qr, qde, vb, qgdot, qrdot, vbdot, &
        dgpi, pig, pir, pigdot, pirdot, diff_rhopi, &
        polter, polterdot, polterddot, octg, octgdot, E, Edot, &
        opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau, &
        tau0, tau_maxvis, Kf, f_K)
    use precision
    real(dl), intent(out) :: sources(:)
    real(dl), intent(in) :: tau, a, adotoa, grho, gpres,w_lam, cs2_lam,  &
        grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,grhonu_t, &
        k,etak, etakdot, phi, phidot, sigma, sigmadot, &
        dgrho, clxg,clxb,clxc, clxr, clxnu, clxde, delta_p_b, &
        dgq, qg, qr, qde, vb, qgdot, qrdot, vbdot, &
        dgpi, pig, pir, pigdot, pirdot, diff_rhopi, &
        polter, polterdot, polterddot, octg, octgdot, E(2:3), Edot(2:3), &
        opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau, &
        tau0, tau_maxvis
    REAL(dl), intent(in) :: Kf(*)
    real(dl), external :: f_K
    END SUBROUTINE TSource_func
    END INTERFACE

    class(CAMBdata), pointer :: State !Current state.
    !(Due to ifort bug State needs to be class pointer to avoid making temp class pointers when calling functions)
    type(CAMBParams), pointer :: CP   !Current parameters (part of state)

    !precalculated arrays
    real(dl) polfac(max_l_evolve),denl(max_l_evolve),vecfac(max_l_evolve),vecfacpol(max_l_evolve)

    real(dl), parameter :: ep0=1.0d-2
    integer, parameter :: lmaxnu_high_ktau=4 !Jan2015, increased from 3 to fix mpk for mnu~6eV

    real(dl) epsw
    real(dl), allocatable :: nu_tau_notmassless(:,:)
    real(dl) nu_tau_nonrelativistic(max_nu), nu_tau_massive(max_nu)

    procedure(state_function), private :: dtauda
    contains

    subroutine SetActiveState(P)
    class(CAMBdata), target :: P

    State => P
    CP => P%CP

    end subroutine SetActiveState


    subroutine GaugeInterface_ScalEv(EV,y,tau,tauend,tol1,ind,c,w)
    type(EvolutionVars) EV
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar), tol1, tau, tauend
    integer ind

    call dverk(EV,EV%ScalEqsToPropagate,derivs,tau,y,tauend,tol1,ind,c,EV%nvar,w)
    if (ind==-3) then
        call GlobalError('Dverk error -3: the subroutine was unable  to  satisfy  the  error ' &
            //'requirement  with a particular step-size that is less than or * ' &
            //'equal to hmin, which may mean that tol is too small' &
            //'--- but most likely you''ve messed up the y array indexing; ' &
            //'compiling with bounds checking may (or may not) help find the problem.',error_evolution)
    end if
    end subroutine GaugeInterface_ScalEv

    function f_K(x)
    real(dl) :: f_K
    real(dl), intent(in) :: x

    f_K = State%curvature_radius*State%rofChi(x/State%curvature_radius)

    end function f_K

    function next_nu_nq(nq) result (next_nq)
    integer, intent(in) :: nq
    integer q, next_nq

    if (nq==0) then
        next_nq=1
    else
        q = int(State%NuPerturbations%nu_q(nq))
        if (q>=10) then
            next_nq = State%NuPerturbations%nqmax
        else
            next_nq = nq+1
        end if
    end if

    end function next_nu_nq

    recursive subroutine GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
    use Recombination, only : CB1
    type(EvolutionVars) EV, EVout
    real(dl) c(24),w(EV%nvar,9), y(EV%nvar), yout(EV%nvar), tol1, tau, tauend
    integer ind, nu_i
    real(dl) cs2, opacity, dopacity
    real(dl) tau_switch_ktau, tau_switch_nu_massless, tau_switch_nu_massive, next_switch
    real(dl) tau_switch_no_nu_multpoles, tau_switch_no_phot_multpoles,tau_switch_nu_nonrel
    real(dl) noSwitch, smallTime
    !Sources
    real(dl) tau_switch_saha, Delta_TM, xe,a,tau_switch_evolve_TM

    noSwitch= State%tau0+1
    smallTime =  min(tau, 1/EV%k_buf)/100

    tau_switch_ktau = noSwitch
    tau_switch_no_nu_multpoles= noSwitch
    tau_switch_no_phot_multpoles= noSwitch

    !Massive neutrino switches
    tau_switch_nu_massless = noSwitch
    tau_switch_nu_nonrel = noSwitch
    tau_switch_nu_massive= noSwitch

    !Sources
    tau_switch_saha=noSwitch
    if (CP%Evolve_delta_xe .and. EV%saha)  tau_switch_saha = EV%ThermoData%recombination_saha_tau
    tau_switch_evolve_TM=noSwitch
    if (EV%Evolve_baryon_cs .and. .not. EV%Evolve_tm) tau_switch_evolve_TM = EV%ThermoData%recombination_Tgas_tau

    !Evolve equations from tau to tauend, performing switches in equations if necessary.

    if (.not. EV%high_ktau_neutrino_approx .and. .not. EV%no_nu_multpoles ) then
        tau_switch_ktau=  max(20, EV%lmaxnr-4)/EV%k_buf
    end if

    if (CP%Num_Nu_massive /= 0) then
        do nu_i = 1, CP%Nu_mass_eigenstates
            if (EV%nq(nu_i) /= State%NuPerturbations%nqmax) then
                tau_switch_nu_massless = min(tau_switch_nu_massless,nu_tau_notmassless(next_nu_nq(EV%nq(nu_i)),nu_i))
            else if (.not. EV%nu_nonrelativistic(nu_i)) then
                tau_switch_nu_nonrel = min(nu_tau_nonrelativistic(nu_i),tau_switch_nu_nonrel)
            else if (EV%NuMethod==Nu_trunc .and..not. EV%MassiveNuApprox(nu_i)) then
                tau_switch_nu_massive = min(tau_switch_nu_massive,EV%MassiveNuApproxTime(nu_i))
            end if
        end do
    end if

    if (CP%DoLateRadTruncation) then
        if (.not. EV%no_nu_multpoles) & !!.and. .not. EV%has_nu_relativistic .and. tau_switch_nu_massless ==noSwitch)  &
            tau_switch_no_nu_multpoles= &
            max(15/EV%k_buf*CP%Accuracy%AccuracyBoost,min(State%taurend,EV%ThermoData%matter_verydom_tau))

        if (.not. EV%no_phot_multpoles .and. (.not.CP%WantCls .or. EV%k_buf>0.03*CP%Accuracy%AccuracyBoost)) &
            tau_switch_no_phot_multpoles =max(15/EV%k_buf,State%taurend)*CP%Accuracy%AccuracyBoost
    end if

    next_switch = min(tau_switch_ktau, tau_switch_nu_massless,EV%TightSwitchoffTime, tau_switch_nu_massive, &
        tau_switch_no_nu_multpoles, tau_switch_no_phot_multpoles, tau_switch_nu_nonrel, noSwitch, &
        tau_switch_saha, tau_switch_evolve_TM)

    if (next_switch < tauend) then
        if (next_switch > tau+smallTime) then
            call GaugeInterface_ScalEv(EV, y, tau,next_switch,tol1,ind,c,w)
            if (global_error_flag/=0) return
        end if

        EVout=EV

        if (next_switch == EV%TightSwitchoffTime) then
            !TightCoupling
            EVout%TightCoupling=.false.
            EVout%TightSwitchoffTime = noSwitch
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            EV=EVout
            y=yout
            ind=1
            !Set up variables with their tight coupling values
            y(EV%g_ix+2) = EV%pig
            call EV%ThermoData%Values(tau,a, cs2,opacity,dopacity)

            if (second_order_tightcoupling) then
                ! Francis-Yan Cyr-Racine November 2010

                y(EV%g_ix+3) = (3._dl/7._dl)*y(EV%g_ix+2)*(EV%k_buf/opacity)*(1._dl+dopacity/opacity**2) + &
                    (3._dl/7._dl)*EV%pigdot*(EV%k_buf/opacity**2)*(-1._dl)

                y(EV%polind+2) = EV%pig/4 + EV%pigdot*(1._dl/opacity)*(-5._dl/8._dl- &
                    (25._dl/16._dl)*dopacity/opacity**2) + &
                    EV%pig*(EV%k_buf/opacity)**2*(-5._dl/56._dl)
                y(EV%polind+3) = (3._dl/7._dl)*(EV%k_buf/opacity)*y(EV%polind+2)*(1._dl + &
                    dopacity/opacity**2) + (3._dl/7._dl)*(EV%k_buf/opacity**2)*((EV%pigdot/4._dl)* &
                    (1._dl+(5._dl/2._dl)*dopacity/opacity**2))*(-1._dl)
            else
                y(EV%g_ix+3) = 3./7*y(EV%g_ix+2)*EV%k_buf/opacity
                y(EV%polind+2) = EV%pig/4
                y(EV%polind+3) =y(EV%g_ix+3)/4
            end if
        else if (next_switch==tau_switch_ktau) then
            !k tau >> 1, evolve massless neutrino effective fluid up to l=2
            EVout%high_ktau_neutrino_approx=.true.
            EVout%nq(1:CP%Nu_mass_eigenstates) = State%NuPerturbations%nqmax
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
        else if (next_switch == tau_switch_nu_massless) then
            !Mass starts to become important, start evolving next momentum mode
            do nu_i = 1, CP%Nu_mass_eigenstates
                if (EV%nq(nu_i) /= State%NuPerturbations%nqmax) then
                    if (next_switch == nu_tau_notmassless(next_nu_nq(EV%nq(nu_i)),nu_i)) then
                        EVOut%nq(nu_i) = next_nu_nq(EV%nq(nu_i))
                        call SetupScalarArrayIndices(EVout)
                        call CopyScalarVariableArray(y,yout, EV, EVout)
                        EV=EVout
                        y=yout
                        exit
                    endif
                end if
            end do
        else if (next_switch == tau_switch_nu_nonrel) then
            !Neutrino becomes non-relativistic, don't need high L
            do nu_i = 1, CP%Nu_mass_eigenstates
                if (.not. EV%nu_nonrelativistic(nu_i) .and.  next_switch==nu_tau_nonrelativistic(nu_i) ) then
                    EVout%nu_nonrelativistic(nu_i)=.true.
                    call SetupScalarArrayIndices(EVout)
                    call CopyScalarVariableArray(y,yout, EV, EVout)
                    EV=EVout
                    y=yout
                    exit
                end if
            end do
        else if (next_switch == tau_switch_nu_massive) then
            !Very non-relativistic neutrinos, switch to truncated velocity-weight hierarchy
            call EV%ThermoData%Values(tau,a, cs2,opacity)
            do nu_i = 1, CP%Nu_mass_eigenstates
                if (.not. EV%MassiveNuApprox(nu_i) .and.  next_switch== EV%MassiveNuApproxTime(nu_i) ) then
                    call SwitchToMassiveNuApprox(EV, a, y, nu_i)
                    exit
                end if
            end do
        else if (next_switch==tau_switch_no_nu_multpoles) then
            !Turn off neutrino hierarchies at late time where slow and not needed.
            ind=1
            EVout%no_nu_multpoles=.true.
            EVOut%nq(1:CP%Nu_mass_eigenstates ) = State%NuPerturbations%nqmax
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
        else if (next_switch==tau_switch_no_phot_multpoles) then
            !Turn off photon hierarchies at late time where slow and not needed.
            ind=1
            EVout%no_phot_multpoles=.true.
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
        else if (next_switch==tau_switch_saha) then
            !Sources
            ind=1
            EVout%saha = .false.
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            call EV%ThermoData%Values(tau,a, cs2,opacity)
            y=yout
            EV=EVout
            Delta_Tm = y(EV%g_ix)/4 ! assume delta_TM = delta_T_gamma
            xe= CP%Recomb%x_e(a)
            y(EV%xe_ix) = (1-xe)/(2-xe)*(-y(ix_clxb) + (3./2+  CB1/(CP%TCMB/a))*Delta_TM)
        else if (next_switch==tau_switch_evolve_TM) then
            !Sources
            ind=1
            EVout%evolve_TM = .true.
            call SetupScalarArrayIndices(EVout)
            call CopyScalarVariableArray(y,yout, EV, EVout)
            y=yout
            EV=EVout
            y(EV%Tg_ix) =y(EV%g_ix)/4 ! assume delta_TM = delta_T_gamma
        end if

        call GaugeInterface_EvolveScal(EV,tau,y,tauend,tol1,ind,c,w)
        return
    end if

    call GaugeInterface_ScalEv(EV,y,tau,tauend,tol1,ind,c,w)

    end subroutine GaugeInterface_EvolveScal

    subroutine GaugeInterface_EvolveTens(EV,tau,y,tauend,tol1,ind,c,w)
    type(EvolutionVars) EV, EVOut
    real(dl) c(24),w(EV%nvart,9), y(EV%nvart),yout(EV%nvart), tol1, tau, tauend
    integer ind
    real(dl) opacity, cs2, a

    if (EV%TensTightCoupling .and. tauend > EV%TightSwitchoffTime) then
        if (EV%TightSwitchoffTime > tau) then
            call dverk(EV,EV%TensEqsToPropagate, derivst,tau,y,EV%TightSwitchoffTime,tol1,ind,c,EV%nvart,w)
        end if
        EVOut=EV
        EVOut%TensTightCoupling = .false.
        call SetupTensorArrayIndices(EVout)
        call CopyTensorVariableArray(y,yout,Ev, Evout)
        Ev = EvOut
        y=yout
        call EV%ThermoData%Values(tau,a,cs2,opacity)
        y(EV%g_ix+2)= 32._dl/45._dl*EV%k_buf/opacity*y(ixt_shear)
        y(EV%E_ix+2) = y(EV%g_ix+2)/4
    end if

    call dverk(EV,EV%TensEqsToPropagate, derivst,tau,y,tauend,tol1,ind,c,EV%nvart,w)

    end subroutine GaugeInterface_EvolveTens

    function DeltaTimeMaxed(a1,a2, tol) result(t)
    real(dl) a1,a2,t
    real(dl), optional :: tol
    if (a1>1._dl) then
        t=0
    elseif (a2 > 1._dl) then
        t = State%DeltaTime(a1,1.01_dl, tol)
    else
        t = State%DeltaTime(a1,a2, tol)
    end if
    end function DeltaTimeMaxed

    subroutine GaugeInterface_Init
    !Precompute various arrays and other things independent of wavenumber
    integer j, nu_i
    real(dl) a_nonrel, a_mass,a_massive, time, nu_mass

    epsw = 100/State%tau0

    if (CP%WantScalars) then
        do j=2,max_l_evolve
            polfac(j)=real((j+3)*(j-1),dl)/(j+1)
        end do
    end if

    if (CP%WantVectors) then
        do j=2,max_l_evolve
            vecfac(j)=real((j+2),dl)/(j+1)
            vecfacpol(j)=real((j+3)*j,dl)*(j-1)*vecfac(j)/(j+1)**2
        end do
    end if

    do j=1,max_l_evolve
        denl(j)=1._dl/(2*j+1)
    end do

    if (CP%Nu_Mass_eigenstates>0) then
        associate(nqmax => State%NuPerturbations%nqmax, nu_q => State%NuPerturbations%nu_q)
            if (allocated(nu_tau_notmassless)) deallocate(nu_tau_notmassless)
            allocate(nu_tau_notmassless(nqmax,max_nu))
            do nu_i=1, CP%Nu_Mass_eigenstates
                nu_mass = max(0.1_dl,State%nu_masses(nu_i))
                a_mass =  1.e-1_dl/nu_mass/CP%Accuracy%lAccuracyBoost
                time=State%DeltaTime(0._dl,State%NuPerturbations%nu_q(1)*a_mass)
                nu_tau_notmassless(1, nu_i) = time
                do j=2,nqmax
                    !times when each momentum mode becomes signficantly nonrelativistic
                    time= time + DeltaTimeMaxed(nu_q(j-1)*a_mass,nu_q(j)*a_mass, 0.01_dl)
                    nu_tau_notmassless(j, nu_i) = time
                end do

                a_nonrel =  2.5d0/nu_mass*CP%Accuracy%AccuracyBoost
                nu_tau_nonrelativistic(nu_i) =DeltaTimeMaxed(0._dl,a_nonrel)
                a_massive =  17.d0/nu_mass*CP%Accuracy%AccuracyBoost
                nu_tau_massive(nu_i) =nu_tau_nonrelativistic(nu_i) + DeltaTimeMaxed(a_nonrel,a_massive)
            end do
        end associate
    end if

    end subroutine GaugeInterface_Init


    subroutine SetupScalarArrayIndices(EV, max_num_eqns)
    !Set up array indices after the lmax have been decided
    use MassiveNu
    !Set the numer of equations in each hierarchy, and get total number of equations for this k
    type(EvolutionVars) EV
    integer, intent(out), optional :: max_num_eqns
    integer neq, maxeq, nu_i

    neq=basic_num_eqns
    maxeq=neq
    if (.not. EV%no_phot_multpoles) then
        !Photon multipoles
        EV%g_ix=basic_num_eqns+1
        if (EV%TightCoupling) then
            neq=neq+2
        else
            neq = neq+ (EV%lmaxg+1)
            !Polarization multipoles
            EV%polind = neq -1 !polind+2 is L=2, for polarizationthe first calculated
            neq=neq + EV%lmaxgpol-1
        end if
    end if
    if (.not. EV%no_nu_multpoles) then
        !Massless neutrino multipoles
        EV%r_ix= neq+1
        if (EV%high_ktau_neutrino_approx) then
            neq=neq + 3
        else
            neq=neq + (EV%lmaxnr+1)
        end if
    end if
    maxeq = maxeq +  (EV%lmaxg+1)+(EV%lmaxnr+1)+EV%lmaxgpol-1

    !Dark energy
    if (.not. CP%DarkEnergy%is_cosmological_constant) then
        EV%w_ix = neq + 1
        neq = neq + CP%DarkEnergy%num_perturb_equations
        maxeq = maxeq + CP%DarkEnergy%num_perturb_equations
    else
        EV%w_ix = 0
    end if

    !Sources
    if (CP%Evolve_delta_xe) then
        if (.not. EV%saha) then
            EV%xe_ix = neq+1
            neq=neq+1
        end if
        maxeq=maxeq+1
    end if

    if (EV%Evolve_baryon_cs) then
        if (EV%Evolve_TM) then
            EV%Tg_ix = neq+1
            neq=neq+1
        end if
        maxeq=maxeq+1
        if (CP%Do21cm .and. CP%SourceTerms%line_reionization) then
            EV%reion_line_ix = neq+1
            neq=neq+ EV%lmaxline+1 +  EV%lmaxline-1
            maxeq=maxeq+EV%lmaxline+1 +  EV%lmaxline-1
        end if
    end if

    if (CP%Evolve_delta_Ts) then
        EV%Ts_ix = neq+1
        neq=neq+1
        maxeq=maxeq+1
    end if

    !Massive neutrinos
    if (CP%Num_Nu_massive /= 0) then
        EV%has_nu_relativistic = any(EV%nq(1:CP%Nu_Mass_eigenstates)/=State%NuPerturbations%nqmax)
        if (EV%has_nu_relativistic) then
            EV%lmaxnu_pert=EV%lmaxnu
            EV%nu_pert_ix=neq+1
            neq = neq+ EV%lmaxnu_pert+1
            maxeq=maxeq+ EV%lmaxnu_pert+1
        else
            EV%lmaxnu_pert=0
        end if

        do nu_i=1, CP%Nu_Mass_eigenstates
            if (EV%high_ktau_neutrino_approx) then
                EV%lmaxnu_tau(nu_i) = int(lmaxnu_high_ktau *CP%Accuracy%lAccuracyBoost)
                if (CP%Transfer%accurate_massive_neutrinos) EV%lmaxnu_tau(nu_i) = EV%lmaxnu_tau(nu_i) *3
            else
                EV%lmaxnu_tau(nu_i) =max(min(nint(0.8_dl*EV%q*nu_tau_nonrelativistic(nu_i) &
                    *CP%Accuracy%lAccuracyBoost),EV%lmaxnu),3)
                !!!Feb13tweak
                if (EV%nu_nonrelativistic(nu_i)) EV%lmaxnu_tau(nu_i)= &
                    min(EV%lmaxnu_tau(nu_i),nint(4*CP%Accuracy%lAccuracyBoost))
            end if
            if (State%nu_masses(nu_i) > 5000 .and. CP%Transfer%high_precision) &
                EV%lmaxnu_tau(nu_i) = EV%lmaxnu_tau(nu_i)*2 !megadamping
            EV%lmaxnu_tau(nu_i)=min(EV%lmaxnu,EV%lmaxnu_tau(nu_i))

            EV%nu_ix(nu_i)=neq+1
            if (EV%MassiveNuApprox(nu_i)) then
                neq = neq+4
            else
                neq = neq+ EV%nq(nu_i)*(EV%lmaxnu_tau(nu_i)+1)
            endif
            maxeq = maxeq + State%NuPerturbations%nqmax*(EV%lmaxnu+1)
        end do
    else
        EV%has_nu_relativistic = .false.
    end if

    EV%ScalEqsToPropagate = neq
    if (present(max_num_eqns)) then
        max_num_eqns=maxeq
    end if

    end subroutine SetupScalarArrayIndices

    subroutine CopyScalarVariableArray(y,yout, EV, EVout)
    type(EvolutionVars) EV, EVOut
    real(dl), intent(in) :: y(EV%nvar)
    real(dl), intent(out) :: yout(EVout%nvar)
    integer lmax,i, nq
    integer nnueq,nu_i, ix_off, ix_off2, ind, ind2
    real(dl) q, pert_scale

    yout=0
    yout(1:basic_num_eqns) = y(1:basic_num_eqns)

    ! DarkEnergy
    if (CP%DarkEnergy%num_perturb_equations > 0) &
        yout(EVOut%w_ix:EVOut%w_ix + CP%DarkEnergy%num_perturb_equations - 1) = &
        y(EV%w_ix:EV%w_ix + CP%DarkEnergy%num_perturb_equations - 1)

    if (.not. EV%no_phot_multpoles .and. .not. EVout%no_phot_multpoles) then
        if (EV%TightCoupling .or. EVOut%TightCoupling) then
            lmax=1
        else
            lmax = min(EV%lmaxg,EVout%lmaxg)
        end if
        yout(EVout%g_ix:EVout%g_ix+lmax)=y(EV%g_ix:EV%g_ix+lmax)
        if (.not. EV%TightCoupling .and. .not. EVOut%TightCoupling) then
            lmax = min(EV%lmaxgpol,EVout%lmaxgpol)
            yout(EVout%polind+2:EVout%polind+lmax)=y(EV%polind+2:EV%polind+lmax)
        end if
    end if

    if (.not. EV%no_nu_multpoles .and. .not. EVout%no_nu_multpoles) then
        if (EV%high_ktau_neutrino_approx .or. EVout%high_ktau_neutrino_approx) then
            lmax=2
        else
            lmax = min(EV%lmaxnr,EVout%lmaxnr)
        end if
        yout(EVout%r_ix:EVout%r_ix+lmax)=y(EV%r_ix:EV%r_ix+lmax)
    end if

    if (CP%Num_Nu_massive /= 0) then
        do nu_i=1,CP%Nu_mass_eigenstates
            ix_off=EV%nu_ix(nu_i)
            ix_off2=EVOut%nu_ix(nu_i)
            if (EV%MassiveNuApprox(nu_i) .and. EVout%MassiveNuApprox(nu_i)) then
                nnueq=4
                yout(ix_off2:ix_off2+nnueq-1)=y(ix_off:ix_off+nnueq-1)
            else if (.not. EV%MassiveNuApprox(nu_i) .and. .not. EVout%MassiveNuApprox(nu_i)) then
                lmax=min(EV%lmaxnu_tau(nu_i),EVOut%lmaxnu_tau(nu_i))
                nq = min(EV%nq(nu_i), EVOut%nq(nu_i))
                do i=1,nq
                    ind= ix_off + (i-1)*(EV%lmaxnu_tau(nu_i)+1)
                    ind2=ix_off2+ (i-1)*(EVOut%lmaxnu_tau(nu_i)+1)
                    yout(ind2:ind2+lmax) = y(ind:ind+lmax)
                end do
                do i=nq+1, EVOut%nq(nu_i)
                    lmax = min(EVOut%lmaxnu_tau(nu_i), EV%lmaxnr)
                    ind2=ix_off2+ (i-1)*(EVOut%lmaxnu_tau(nu_i)+1)
                    yout(ind2:ind2+lmax) = y(EV%r_ix:EV%r_ix+lmax)

                    !Add leading correction for the mass
                    q=State%NuPerturbations%nu_q(i)
                    pert_scale=(State%nu_masses(nu_i)/q)**2/2
                    lmax = min(lmax,EV%lmaxnu_pert)
                    yout(ind2:ind2+lmax) = yout(ind2:ind2+lmax) &
                        + y(EV%nu_pert_ix:EV%nu_pert_ix+lmax)*pert_scale
                end do
            end if
        end do

        if (EVOut%has_nu_relativistic .and. EV%has_nu_relativistic) then
            lmax = min(EVOut%lmaxnu_pert, EV%lmaxnu_pert)
            yout(EVout%nu_pert_ix:EVout%nu_pert_ix+lmax)=  y(EV%nu_pert_ix:EV%nu_pert_ix+lmax)
        end if
    end if
    !Sources
    if (.not. EV%saha .and. .not. EVOut%saha) then
        yout(EVOut%xe_ix) =y(EV%xe_ix)
    end if
    if (EV%Evolve_baryon_cs) then
        if (EV%Evolve_TM .and. EVout%Evolve_TM) yout(EVOut%Tg_ix) = y(EV%Tg_ix)
        if (CP%Do21cm .and. CP%SourceTerms%line_reionization) then
            yout(EVOut%reion_line_ix:EVOut%reion_line_ix+EVout%lmaxline +  EVout%lmaxline-1) = &
                y(EV%reion_line_ix:EV%reion_line_ix+EV%lmaxline +  EV%lmaxline-1)
        end if
    end if
    if (CP%Evolve_delta_Ts) then
        yout(EVOut%Ts_ix) = y(EV%Ts_ix)
    end if

    end subroutine CopyScalarVariableArray


    subroutine SetupTensorArrayIndices(EV, maxeq)
    type(EvolutionVars) EV
    integer nu_i, neq
    integer, optional, intent(out) :: maxeq
    neq=2
    EV%g_ix = neq-1 !EV%g_ix+2 is quadrupole
    if (.not. EV%TensTightCoupling) then
        EV%E_ix = EV%g_ix + (EV%lmaxt-1)
        EV%B_ix = EV%E_ix + (EV%lmaxpolt-1)
        neq = neq+ (EV%lmaxt-1)+(EV%lmaxpolt-1)*2
    end if
    if (present(maxeq)) then
        maxeq = 2 + (EV%lmaxt-1)+(EV%lmaxpolt-1)*2
    end if
    EV%r_ix = neq -1
    if (DoTensorNeutrinos) then
        neq = neq + EV%lmaxnrt-1
        if (present(maxeq)) maxeq = maxeq+EV%lmaxnrt-1
        if (CP%Num_Nu_massive /= 0 ) then
            do nu_i=1, CP%nu_mass_eigenstates
                EV%EvolveTensorMassiveNu(nu_i) = &
                    nu_tau_nonrelativistic(nu_i) < 0.8*State%tau_maxvis*CP%Accuracy%AccuracyBoost
                if (EV%EvolveTensorMassiveNu(nu_i)) then
                    EV%nu_ix(nu_i)=neq-1
                    neq = neq+ State%NuPerturbations%nqmax*(EV%lmaxnut-1)
                    if (present(maxeq)) maxeq = maxeq + State%NuPerturbations%nqmax*(EV%lmaxnut-1)
                end if
            end do
        end if
    end if

    EV%TensEqsToPropagate = neq

    end  subroutine SetupTensorArrayIndices

    subroutine CopyTensorVariableArray(y,yout, EV, EVout)
    type(EvolutionVars) EV, EVOut
    real(dl), intent(in) :: y(EV%nvart)
    real(dl), intent(out) :: yout(EVout%nvart)
    integer lmaxpolt, lmaxt, nu_i, ind, ind2, i

    yout=0
    yout(1:2) = y(1:2)
    if (.not. EVOut%TensTightCoupling .and. .not.EV%TensTightCoupling) then
        lmaxt = min(EVOut%lmaxt,EV%lmaxt)
        yout(EVout%g_ix+2:EVout%g_ix+lmaxt)=y(EV%g_ix+2:EV%g_ix+lmaxt)
        lmaxpolt = min(EV%lmaxpolt, EVOut%lmaxpolt)
        yout(EVout%E_ix+2:EVout%E_ix+lmaxpolt)=y(EV%E_ix+2:EV%E_ix+lmaxpolt)
        yout(EVout%B_ix+2:EVout%B_ix+lmaxpolt)=y(EV%B_ix+2:EV%B_ix+lmaxpolt)
    end if
    if (DoTensorNeutrinos) then
        lmaxt=min(EV%lmaxnrt,EVOut%lmaxnrt)
        yout(EVout%r_ix+2:EVout%r_ix+lmaxt)=y(EV%r_ix+2:EV%r_ix+lmaxt)
        do nu_i =1, CP%nu_mass_eigenstates
            if (EV%EvolveTensorMassiveNu(nu_i)) then
                lmaxt=min(EV%lmaxnut,EVOut%lmaxnut)
                do i=1,State%NuPerturbations%nqmax
                    ind= EV%nu_ix(nu_i) + (i-1)*(EV%lmaxnut-1)
                    ind2=EVOut%nu_ix(nu_i)+ (i-1)*(EVOut%lmaxnut-1)
                    yout(ind2+2:ind2+lmaxt) = y(ind+2:ind+lmaxt)
                end do
            end if
        end do
    end if

    end subroutine CopyTensorVariableArray

    subroutine GetNumEqns(EV)
    use MassiveNu
    !Set the numer of equations in each hierarchy, and get total number of equations for this k
    type(EvolutionVars) EV
    real(dl) scal, max_nu_mass
    integer nu_i,q_rel,j

    if (CP%Num_Nu_massive == 0) then
        EV%lmaxnu=0
        max_nu_mass=0
    else
        max_nu_mass = maxval(State%nu_masses(1:CP%Nu_mass_eigenstates))
        do nu_i = 1, CP%Nu_mass_eigenstates
            !Start with momentum modes for which t_k ~ time at which mode becomes non-relativistic
            q_rel=0
            do j=1, State%NuPerturbations%nqmax
                !two different q's here EV%q ~k
                if (State%NuPerturbations%nu_q(j) > State%nu_masses(nu_i)*State%adotrad/EV%q) exit
                q_rel = q_rel + 1
            end do

            if (q_rel>= State%NuPerturbations%nqmax-2 .or. CP%WantTensors) then
                EV%nq(nu_i)=State%NuPerturbations%nqmax
            else
                EV%nq(nu_i)=q_rel
            end if
            !q_rel = nint(nu_masses(nu_i)*adotrad/EV%q) !two dffierent q's here EV%q ~k
            !EV%nq(nu_i)=max(0,min(nqmax0,q_rel)) !number of momentum modes to evolve intitially
            EV%nu_nonrelativistic(nu_i) = .false.
        end do

        EV%NuMethod = CP%MassiveNuMethod
        if (EV%NuMethod == Nu_Best) EV%NuMethod = Nu_Trunc
        !l_max for massive neutrinos
        if (CP%Transfer%high_precision) then
            EV%lmaxnu=nint(25*CP%Accuracy%lAccuracyBoost)
        else
            EV%lmaxnu=max(3,nint(10*CP%Accuracy%lAccuracyBoost))
            if (max_nu_mass>700) EV%lmaxnu=max(3,nint(15*CP%Accuracy%lAccuracyBoost)) !Feb13 tweak
        endif
    end if

    if (State%closed) then
        EV%FirstZerolForBeta = nint(EV%q*State%curvature_radius)
    else
        EV%FirstZerolForBeta= 100000 !a large number
    end if

    EV%high_ktau_neutrino_approx = .false.
    if (CP%WantScalars) then
        EV%TightCoupling=.true.
        EV%no_phot_multpoles =.false.
        EV%no_nu_multpoles =.false.
        EV%MassiveNuApprox=.false.
        !Sources
        EV%saha = .true.
        EV%Evolve_TM = .false.

        if (CP%Accuracy%AccuratePolarization) then
            EV%lmaxg  = max(nint(11*CP%Accuracy%lAccuracyBoost),3)
        else
            EV%lmaxg  = max(nint(8*CP%Accuracy%lAccuracyBoost),3)
        end if
        EV%lmaxnr = max(nint(14*CP%Accuracy%lAccuracyBoost),3)
        if (max_nu_mass>700) EV%lmaxnr = max(nint(32*CP%Accuracy%lAccuracyBoost),3) !Feb13 tweak

        EV%lmaxgpol = EV%lmaxg
        if (.not.CP%Accuracy%AccuratePolarization) EV%lmaxgpol=max(nint(4*CP%Accuracy%lAccuracyBoost),3)

        if (EV%q < 0.05) then
            !Large scales need fewer equations
            scal  = 1
            if (CP%Accuracy%AccuratePolarization) scal = 4  !But need more to get polarization right
            EV%lmaxgpol=max(3,nint(min(8,nint(scal* 150* EV%q))*CP%Accuracy%lAccuracyBoost))
            EV%lmaxnr=max(3,nint(min(7,nint(sqrt(scal)* 150 * EV%q))*CP%Accuracy%lAccuracyBoost))
            if (EV%lmaxnr < EV%lmaxnu) then
                ! Nov 2020 change following Pavel Motloch report
                EV%lmaxnr = EV%lmaxnu
                !EV%lmaxnu = min(EV%lmaxnu, EV%lmaxnr) ! may be better but have not tested and makes small result changes
            endif
            EV%lmaxg=max(3,nint(min(8,nint(sqrt(scal) *300 * EV%q))*CP%Accuracy%lAccuracyBoost))
            !Sources
            if (CP%SourceTerms%line_phot_quadrupole) then
                EV%lmaxg=EV%lmaxg*8
                EV%lmaxgpol=EV%lmaxgpol*4
            elseif (CP%Accuracy%AccurateReionization) then
                EV%lmaxg=EV%lmaxg*4
                EV%lmaxgpol=EV%lmaxgpol*2
            end if
        end if

        if (EV%TransferOnly) then
            EV%lmaxgpol = min(EV%lmaxgpol,nint(5*CP%Accuracy%lAccuracyBoost))
            EV%lmaxg = min(EV%lmaxg,nint(6*CP%Accuracy%lAccuracyBoost))
        end if
        if (CP%Transfer%high_precision .or. CP%Do21cm) then
            EV%lmaxnr=max(nint(45*CP%Accuracy%lAccuracyBoost),3)
            if (EV%q > 0.04 .and. EV%q < 0.5) then !baryon oscillation scales
                EV%lmaxg=max(EV%lmaxg,10)
            end if
        end if

        if (CP%Do21cm .and. CP%SourceTerms%line_reionization) then
            EV%lmaxg =  EV%lmaxg*8
            EV%lmaxgpol = EV%lmaxgpol*3
        end if

        EV%Evolve_baryon_cs = CP%Do21cm .or.CP%Evolve_delta_xe .or. CP%Evolve_delta_Ts

        if (CP%Do21cm .and. CP%SourceTerms%line_reionization) then
            EV%lmaxline  = EV%lmaxg
        end if

        if (State%closed) then
            EV%lmaxnu=min(EV%lmaxnu, EV%FirstZerolForBeta-1)
            EV%lmaxnr=min(EV%lmaxnr, EV%FirstZerolForBeta-1)
            EV%lmaxg=min(EV%lmaxg, EV%FirstZerolForBeta-1)
            EV%lmaxgpol=min(EV%lmaxgpol, EV%FirstZerolForBeta-1)
        end if

        EV%poltruncfac=real(EV%lmaxgpol,dl)/max(1,(EV%lmaxgpol-2))
        EV%MaxlNeeded=max(EV%lmaxg,EV%lmaxnr,EV%lmaxgpol,EV%lmaxnu)
        if (EV%MaxlNeeded > max_l_evolve) call MpiStop('Need to increase max_l_evolve')
        call SetupScalarArrayIndices(EV,EV%nvar)
        if (State%closed) EV%nvar=EV%nvar+1 !so can reference lmax+1 with zero coefficient
        EV%lmaxt=0
    else
        EV%nvar=0
    end if

    if (CP%WantTensors) then
        EV%TensTightCoupling = .true.
        EV%lmaxt=max(3,nint(8*CP%Accuracy%lAccuracyBoost))
        EV%lmaxpolt = max(3,nint(4*CP%Accuracy%lAccuracyBoost))
        ! if (EV%q < 1e-3) EV%lmaxpolt=EV%lmaxpolt+1
        if (DoTensorNeutrinos) then
            EV%lmaxnrt=nint(6*CP%Accuracy%lAccuracyBoost)
            EV%lmaxnut=EV%lmaxnrt
        else
            EV%lmaxnut=0
            EV%lmaxnrt=0
        end if
        if (State%closed) then
            EV%lmaxt=min(EV%FirstZerolForBeta-1,EV%lmaxt)
            EV%lmaxpolt=min(EV%FirstZerolForBeta-1,EV%lmaxpolt)
            EV%lmaxnrt=min(EV%FirstZerolForBeta-1,EV%lmaxnrt)
            EV%lmaxnut=min(EV%FirstZerolForBeta-1,EV%lmaxnut)
        end if
        EV%MaxlNeededt=max(EV%lmaxpolt,EV%lmaxt, EV%lmaxnrt, EV%lmaxnut)
        if (EV%MaxlNeededt > max_l_evolve) call MpiStop('Need to increase max_l_evolve')
        call SetupTensorArrayIndices(EV, EV%nvart)
    else
        EV%nvart=0
    end if


    if (CP%WantVectors) then
        EV%lmaxv=max(10,nint(8*CP%Accuracy%lAccuracyBoost))
        EV%lmaxpolv = max(5,nint(5*CP%Accuracy%lAccuracyBoost))

        EV%nvarv=(EV%lmaxv)+(EV%lmaxpolv-1)*2+3

        EV%lmaxnrv=nint(30*CP%Accuracy%lAccuracyBoost)

        EV%nvarv=EV%nvarv+EV%lmaxnrv
        if (CP%Num_Nu_massive /= 0 ) then
            call MpiStop('massive neutrinos not supported for vector modes')
        end if
    else
        EV%nvarv=0
    end if

    end subroutine GetNumEqns

    subroutine SwitchToMassiveNuApprox(EV,a, y, nu_i)
    !When the neutrinos are no longer highly relativistic we use a truncated
    !energy-integrated hierarchy going up to third order in velocity dispersion
    type(EvolutionVars) EV, EVout
    integer, intent(in) :: nu_i
    real(dl) a,a2,pnu,clxnu,dpnu,pinu,rhonu
    real(dl) qnu
    real(dl) y(EV%nvar), yout(EV%nvar)

    a2=a*a
    EVout=EV
    EVout%MassiveNuApprox(nu_i)=.true.
    call SetupScalarArrayIndices(EVout)
    call CopyScalarVariableArray(y,yout, EV, EVout)

    !Get density and pressure as ratio to massles by interpolation from table
    call ThermalNuBack%rho_P(a*State%nu_masses(nu_i),rhonu,pnu)

    !Integrate over q
    call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu,dpnu,pinu)
    !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
    dpnu=dpnu/rhonu
    qnu=qnu/rhonu
    clxnu = clxnu/rhonu
    pinu=pinu/rhonu

    yout(EVout%nu_ix(nu_i))=clxnu
    yout(EVout%nu_ix(nu_i)+1)=dpnu
    yout(EVout%nu_ix(nu_i)+2)=qnu
    yout(EVout%nu_ix(nu_i)+3)=pinu

    call Nu_Intvsq(EV,y, a, nu_i, EVout%G11(nu_i),EVout%G30(nu_i))
    !Analytic solution for higher moments, proportional to a^{-3}
    EVout%G11(nu_i)=EVout%G11(nu_i)*a2*a/rhonu
    EVout%G30(nu_i)=EVout%G30(nu_i)*a2*a/rhonu

    EV=EVout
    y=yout

    end subroutine SwitchToMassiveNuApprox

    subroutine MassiveNuVarsOut(EV,y,yprime,a,adotoa,grho,gpres,dgrho,dgq,dgpi, dgpi_diff,pidot_sum,clxnu_all)
    implicit none
    type(EvolutionVars) EV
    real(dl) :: y(EV%nvar), yprime(EV%nvar),a, adotoa
    real(dl), optional :: grho,gpres,dgrho,dgq,dgpi, dgpi_diff,pidot_sum,clxnu_all
    !grho = a^2 kappa rho
    !gpres = a^2 kappa p
    !dgrho = a^2 kappa \delta\rho
    !dgp =  a^2 kappa \delta p
    !dgq = a^2 kappa q (heat flux)
    !dgpi = a^2 kappa pi (anisotropic stress)
    !dgpi_diff = a^2 kappa (3*p -rho)*pi

    integer nu_i
    real(dl) pinudot,grhormass_t, rhonu, pnu,  rhonudot
    real(dl) grhonu_t,gpnu_t
    real(dl) clxnu, qnu, pinu, dpnu, grhonu, dgrhonu

    grhonu=0
    dgrhonu=0
    do nu_i = 1, CP%Nu_mass_eigenstates
        grhormass_t=State%grhormass(nu_i)/a**2

        !Get density and pressure as ratio to massless by interpolation from table
        call ThermalNuBack%rho_P(a*State%nu_masses(nu_i),rhonu,pnu)

        if (EV%MassiveNuApprox(nu_i)) then
            clxnu=y(EV%nu_ix(nu_i))
            !dpnu = y(EV%iq0+1+off_ix)
            qnu=y(EV%nu_ix(nu_i)+2)
            pinu=y(EV%nu_ix(nu_i)+3)
            pinudot=yprime(EV%nu_ix(nu_i)+3)
        else
            !Integrate over q
            call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu,dpnu,pinu)
            !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
            !dpnu=dpnu/rhonu
            qnu=qnu/rhonu
            clxnu = clxnu/rhonu
            pinu=pinu/rhonu
            rhonudot = ThermalNuBack%drho(a*State%nu_masses(nu_i),adotoa)

            call Nu_pinudot(EV,y, yprime, a,adotoa, nu_i,pinudot)
            pinudot=pinudot/rhonu - rhonudot/rhonu*pinu
        endif

        grhonu_t=grhormass_t*rhonu
        gpnu_t=grhormass_t*pnu

        grhonu = grhonu  + grhonu_t
        if (present(gpres)) gpres= gpres + gpnu_t

        dgrhonu= dgrhonu + grhonu_t*clxnu
        if (present(dgq)) dgq  = dgq   + grhonu_t*qnu
        if (present(dgpi)) dgpi = dgpi  + grhonu_t*pinu
        if (present(dgpi_diff)) dgpi_diff = dgpi_diff + pinu*(3*gpnu_t-grhonu_t)
        if (present(pidot_sum)) pidot_sum = pidot_sum + grhonu_t*pinudot
    end do
    if (present(grho)) grho = grho  + grhonu
    if (present(dgrho)) dgrho= dgrho + dgrhonu
    if (present(clxnu_all)) clxnu_all = dgrhonu/grhonu

    end subroutine MassiveNuVarsOut

    subroutine Nu_Integrate_L012(EV,y,a,nu_i,drhonu,fnu,dpnu,pinu)
    type(EvolutionVars) EV
    !  Compute the perturbations of density and energy flux
    !  of one eigenstate of massive neutrinos, in units of the mean
    !  density of one eigenstate of massless neutrinos, by integrating over
    !  momentum.
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a, y(EV%nvar)
    real(dl), intent(OUT) ::  drhonu,fnu
    real(dl), optional, intent(OUT) :: dpnu,pinu
    real(dl) tmp, am, aq,v, pert_scale
    integer iq, ind

    !  q is the comoving momentum in units of k_B*T_nu0/c.

    drhonu=0
    fnu=0
    if (present(dpnu)) then
        dpnu=0
        pinu=0
    end if
    am=a*State%nu_masses(nu_i)
    ind=EV%nu_ix(nu_i)
    associate(nu_q=>State%NuPerturbations%nu_q, nu_int_kernel=>State%NuPerturbations%nu_int_kernel)
        do iq=1,EV%nq(nu_i)
            aq=am/nu_q(iq)
            v=1._dl/sqrt(1._dl+aq*aq)
            drhonu=drhonu+ nu_int_kernel(iq)* y(ind)/v
            fnu=fnu+nu_int_kernel(iq)* y(ind+1)
            if (present(dpnu)) then
                dpnu=dpnu+  nu_int_kernel(iq)* y(ind)*v
                pinu=pinu+ nu_int_kernel(iq)*y(ind+2)*v
            end if
            ind=ind+EV%lmaxnu_tau(nu_i)+1
        end do
        ind = EV%nu_pert_ix
        do iq=EV%nq(nu_i)+1,State%NuPerturbations%nqmax
            !Get the rest from perturbatively relativistic expansion
            aq=am/nu_q(iq)
            v=1._dl/sqrt(1._dl+aq*aq)
            pert_scale=(State%nu_masses(nu_i)/nu_q(iq))**2/2
            tmp = nu_int_kernel(iq)*(y(EV%r_ix)  + pert_scale*y(ind))
            drhonu=drhonu+ tmp/v
            fnu=fnu+nu_int_kernel(iq)*(y(EV%r_ix+1)+ pert_scale*y(ind+1))
            if (present(dpnu)) then
                dpnu=dpnu+ tmp*v
                pinu = pinu+ nu_int_kernel(iq)*(y(EV%r_ix+2)+ pert_scale*y(ind+2))*v
            end if
        end do
    end associate
    if (present(dpnu)) then
        dpnu = dpnu/3
    end if

    end subroutine Nu_Integrate_L012

    subroutine Nu_pinudot(EV,y, ydot, a,adotoa, nu_i,pinudot)
    type(EvolutionVars) EV
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a,adotoa, y(EV%nvar), ydot(EV%nvar)

    !  Compute the time derivative of the mean density in massive neutrinos
    !  and the shear perturbation.
    real(dl) pinudot
    real(dl) aq,q,v,aqdot,vdot
    real(dl) psi2,psi2dot
    real(dl) am, pert_scale
    integer iq,ind

    !  q is the comoving momentum in units of k_B*T_nu0/c.
    pinudot=0._dl
    ind=EV%nu_ix(nu_i)+2
    am=a*State%nu_masses(nu_i)
    do iq=1,EV%nq(nu_i)
        q=State%NuPerturbations%nu_q(iq)
        aq=am/q
        aqdot=aq*adotoa
        v=1._dl/sqrt(1._dl+aq*aq)
        vdot=-aq*aqdot/(1._dl+aq*aq)**1.5d0
        pinudot=pinudot+State%NuPerturbations%nu_int_kernel(iq)*(ydot(ind)*v+y(ind)*vdot)
        ind=ind+EV%lmaxnu_tau(nu_i)+1
    end do
    ind = EV%nu_pert_ix+2
    do iq=EV%nq(nu_i)+1,State%NuPerturbations%nqmax
        q=State%NuPerturbations%nu_q(iq)
        aq=am/q
        aqdot=aq*adotoa
        pert_scale=(State%nu_masses(nu_i)/q)**2/2
        v=1._dl/sqrt(1._dl+aq*aq)
        vdot=-aq*aqdot/(1._dl+aq*aq)**1.5d0
        psi2dot=ydot(EV%r_ix+2)  + pert_scale*ydot(ind)
        psi2=y(EV%r_ix+2)  + pert_scale*y(ind)
        pinudot=pinudot+State%NuPerturbations%nu_int_kernel(iq)*(psi2dot*v+psi2*vdot)
    end do

    end subroutine Nu_pinudot

    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    function Nu_pi(EV, y, a, nu_i) result(pinu)
    type(EvolutionVars) EV
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a, y(EV%nvart)
    real(dl) :: am
    real(dl) pinu,q,aq,v
    integer iq, ind

    if (EV%nq(nu_i)/=State%NuPerturbations%nqmax) call MpiStop('Nu_pi: nq/=nqmax')
    pinu=0
    ind=EV%nu_ix(nu_i)+2
    am=a*State%nu_masses(nu_i)
    do iq=1, EV%nq(nu_i)
        q=State%NuPerturbations%nu_q(iq)
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        pinu=pinu+State%NuPerturbations%nu_int_kernel(iq)*y(ind)*v
        ind =ind+EV%lmaxnut+1
    end do

    end function Nu_pi

    !cccccccccccccccccccccccccccccccccccccccccccccc
    subroutine Nu_Intvsq(EV,y, a, nu_i, G11,G30)
    type(EvolutionVars) EV
    integer, intent(in) :: nu_i
    real(dl), intent(in) :: a, y(EV%nvar)
    real(dl), intent(OUT) ::  G11,G30

    !  Compute the third order variables (in velocity dispersion)
    !by integrating over momentum.
    real(dl) aq,q,v, am
    integer iq, ind

    !  q is the comoving momentum in units of k_B*T_nu0/c.
    am=a*State%nu_masses(nu_i)
    ind=EV%nu_ix(nu_i)
    G11=0._dl
    G30=0._dl
    if (EV%nq(nu_i)/=State%NuPerturbations%nqmax) call MpiStop('Nu_Intvsq nq/=nqmax0')
    do iq=1, EV%nq(nu_i)
        q=State%NuPerturbations%nu_q(iq)
        aq=am/q
        v=1._dl/sqrt(1._dl+aq*aq)
        G11=G11+State%NuPerturbations%nu_int_kernel(iq)*y(ind+1)*v**2
        if (EV%lmaxnu_tau(nu_i)>2) then
            G30=G30+State%NuPerturbations%nu_int_kernel(iq)*y(ind+3)*v**2
        end if
        ind = ind+EV%lmaxnu_tau(nu_i)+1
    end do

    end subroutine Nu_Intvsq


    subroutine MassiveNuVars(EV,y,a,grho,gpres,dgrho,dgq, wnu_arr)
    implicit none
    type(EvolutionVars) EV
    real(dl) :: y(EV%nvar), a, grho,gpres,dgrho,dgq
    real(dl), intent(out), optional :: wnu_arr(max_nu)
    !grho = a^2 kappa rho
    !gpres = a^2 kappa p
    !dgrho = a^2 kappa \delta\rho
    !dgp =  a^2 kappa \delta p
    !dgq = a^2 kappa q (heat flux)
    integer nu_i
    real(dl) grhormass_t, rhonu, qnu, clxnu, grhonu_t, gpnu_t, pnu

    do nu_i = 1, CP%Nu_mass_eigenstates
        grhormass_t=State%grhormass(nu_i)/a**2

        !Get density and pressure as ratio to massless by interpolation from table
        call ThermalNuBack%rho_P(a*State%nu_masses(nu_i),rhonu,pnu)

        if (EV%MassiveNuApprox(nu_i)) then
            clxnu=y(EV%nu_ix(nu_i))
            qnu=y(EV%nu_ix(nu_i)+2)
        else
            !Integrate over q
            call Nu_Integrate_L012(EV, y, a, nu_i, clxnu,qnu)
            !clxnu_here  = rhonu*clxnu, qnu_here = qnu*rhonu
            qnu=qnu/rhonu
            clxnu = clxnu/rhonu
        endif

        grhonu_t=grhormass_t*rhonu
        gpnu_t=grhormass_t*pnu

        grho = grho  + grhonu_t
        gpres= gpres + gpnu_t
        dgrho= dgrho + grhonu_t*clxnu
        dgq  = dgq   + grhonu_t*qnu

        if (present(wnu_arr)) then
            wnu_arr(nu_i) =pnu/rhonu
        end if
    end do

    end subroutine MassiveNuVars


    function Get21cm_source2(a,Delta_source,Delta_TCMB,Delta_Tm,Delta_xe,Tmat,Trad,xe, vterm )
    !Delta_Tspin - Delta_TCMB
    use constants
    use DarkAge21cm
    !vterm = hdot/clh + k*n/3/clh
    real(dl), intent(in) :: a,Delta_source,Delta_TCMB,Delta_Tm,Tmat,Trad,xe, Delta_xe, vterm
    real(dl) :: Get21cm_source2
    real(dl) Rgamma,Rm
    real(dl) dC10, n_H,C10, C10_HH, C10_eH
    real(dl) kappa_HH,kappa_eH
    real(dl) tau_eps
    real(dl) H
    real(dl) TSpin
    n_H = State%NNow/a**3
    kappa_HH = kappa_HH_21cm(Tmat, .false.)
    kappa_eH = kappa_eH_21cm(Tmat, .false.)
    C10_HH = n_H*kappa_HH* (1- xe)
    C10_eH = n_H*kappa_eH*xe
    C10 = C10_HH + C10_eH    !only relevant when He ionization is negligible
    Rgamma = 1._dl/(C10+A10*Trad/T_21cm)
    Rm = 1._dl/(C10+A10*Tmat/T_21cm)

    !          TSpin=TsRecfast(a)
    !          write(*,'(9e15.5)') 1/a-1,Tmat,Tspin, Trad,C10_HH,C10_eH,A10*Trad/T_21cm,xe,&
    !                  n_H*kappa_pH_21cm(Tmat, .false.)*xe
    !          if (a>0.5) stop

    dC10 = (C10*Delta_source + (C10_HH*kappa_HH_21cm(Tmat, .true.) &
        + C10_eH*kappa_eH_21cm(Tmat, .true.)) * &
        Delta_Tm + (kappa_eH-kappa_HH)*xe*n_H*Delta_xe)

    Get21cm_source2 =  dC10*(Rgamma-Rm) +  C10*(Rm*Delta_tm - Delta_TCMB*Rgamma)

    TSpin=CP%Recomb%T_s(a)
    H = (1/(a*dtauda(State,a)))
    tau_eps = a*line21_const*State%NNow/a**3/H/Tspin/1000

    Get21cm_source2 = Get21cm_source2 + &
        tau_eps/2*A10*( 1/(C10*T_21cm/Tmat+A10) -  1/(C10*T_21cm/Trad+A10) ) * &
        (Delta_source -vterm + dC10/C10 + 2*( - Rgamma*dC10 + Delta_TCMB*(C10*Rgamma-1)) &
        + Trad/(Tmat-Trad)*(Delta_tm-Delta_TCMB)   )

    end function Get21cm_source2


    function Get21cm_dTs(a,Delta_n,Delta_Ts,Delta_TCMB,Delta_Tm,Tmat,Trad,xe )
    !d Delta T_s / d eta dropping small \Delta_xe terms
    use constants
    use DarkAge21cm
    real(dl), intent(in) :: a,Delta_n,Delta_Ts,Delta_TCMB,Delta_Tm,Tmat,Trad,xe
    real(dl) :: Get21cm_dTs
    real(dl) n_H,C10, C10_HH, C10_eH, delta_C10
    real(dl) kappa_HH,kappa_eH, TSpin

    n_H = State%NNow/a**3
    kappa_HH = kappa_HH_21cm(Tmat, .false.)
    kappa_eH = kappa_eH_21cm(Tmat, .false.)
    C10_HH = n_H*kappa_HH* (1- xe)
    C10_eH = n_H*kappa_eH*xe
    C10 = C10_HH + C10_eH    !only relevant when He ionization is negligible
    TSpin=CP%Recomb%T_s(a)
    delta_C10 = C10*Delta_n + (C10_HH*kappa_HH_21cm(Tmat, .true.) &
        +C10_eH*kappa_eH_21cm(Tmat, .true.))*Delta_Tm

    !          write(*,'(9e15.5)') 1/a-1,Tmat,Tspin, Trad,C10_HH,C10_eH,A10*Trad/T_21cm,xe,&
    !                  n_H*kappa_pH_21cm(Tmat, .false.)*xe

    Get21cm_dTs =  4*a*( TSpin/TMat*(Delta_Tm-Delta_ts)*C10 + (1-TSpin/TMat)*delta_C10 + &
        (Trad*Delta_TCMB - Tspin*Delta_Ts)*A10/T_21cm ) * MPC_in_sec

    end function Get21cm_dTs


    subroutine output_window_sources(EV, sources, y, yprime, &
        tau, a, adotoa, grho, gpres, &
        k, etak, z, etakdot, phi, phidot, sigma, sigmadot, &
        dgrho, clxg,clxb,clxc,clxnu, Delta_TM, Delta_xe,  &
        dgq, qg,  vb, qgdot, vbdot, &
        dgpi, pig, pigdot, diff_rhopi, &
        polter, polterdot, polterddot, octg, octgdot, E, Edot, &
        opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau)
    !Line of sight sources for number counts, lensing and 21cm redshift windows
    type(EvolutionVars) EV
    real(dl) y(EV%nvar), yprime(EV%nvar)
    real(dL), intent(out) :: sources(:)
    real(dL), intent(in) :: tau, a, adotoa, grho, gpres, &
        k,etak, z, etakdot, phi, phidot, sigma, sigmadot, &
        dgrho, clxg,clxb,clxc,clxnu,  &
        dgq, qg, vb, qgdot, vbdot, &
        dgpi, pig, pigdot, diff_rhopi, &
        polter, polterdot, polterddot, octg, octgdot, E(2:3), Edot(2:3), &
        opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau
    real(dl), intent(in) :: Delta_TM, Delta_xe
    real(dl) s(0:10), t(0:10)
    real(dl) counts_radial_source, counts_velocity_source, counts_density_source, counts_ISW_source, &
        counts_redshift_source, counts_timedelay_source, counts_potential_source
    integer w_ix, lineoff,lineoffpol
    real(dl) Delta_TCMB
    integer j
    real(dl) Tmat,Trad, Delta_source, Delta_source2
    real(dl) xe, chi, polter_line

    j = EV%OutputStep
    if (CP%SourceTerms%line_reionization) sources(2)=0

    if (tau <= EV%ThermoData%tau_start_redshiftwindows) return

    !There are line of sight contributions...
    if (CP%Do21cm) then
        Delta_TCMB = clxg/4
        Delta_source = clxb
        Trad = CP%TCMB/a

        xe = CP%Recomb%x_e(a)
        Tmat = CP%Recomb%T_m(a)

        Delta_source2 = Get21cm_source2(a,Delta_source,Delta_TCMB,Delta_Tm,Delta_xe,Tmat,Trad,xe, &
            k*(z+vb)/adotoa/3)
    end if

    do w_ix = 1, State%num_redshiftwindows
        associate (W => State%Redshift_W(w_ix))

            if (W%kind == window_lensing) then
                sources(3+w_ix) =-2*phi*W%win_lens(j)
            elseif (W%kind == window_counts) then
                !assume zero velocity bias and relevant tracer is CDM perturbation
                !neglect anisotropic stress in some places

                !Main density source
                if (CP%SourceTerms%counts_density) then
                    counts_density_source= W%wing(j)*(clxc*W%Window%GetBias(k,a) + (W%comoving_density_ev(j) - 3*adotoa)*sigma/k)
                    !Newtonian gauge count density; bias assumed to be on synchronous gauge CDM density
                else
                    counts_density_source= 0
                endif

                if (CP%SourceTerms%counts_redshift) then
                    !Main redshift distortion from kV_N/H j'' integrated by parts twice (V_N = sigma in synch gauge)
                    counts_redshift_source = ((4.D0*adotoa**2+gpres+grho/3.D0)/k*W%wing2(j)+ &
                        (-4.D0*W%dwing2(j)*adotoa+W%ddwing2(j))/k)*sigma+(-etak/adotoa*k/3.D0-dgrho/ &
                        adotoa/6.D0+(etak/adotoa*k/3.D0+dgrho/adotoa/6.D0+(dgq/2.D0-2.D0*etak*adotoa)/k) &
                        /EV%Kf(1))*W%wing2(j)+2.D0*W%dwing2(j)*etak/k/EV%Kf(1)
                else
                    counts_redshift_source= 0
                end if

                ! 2v j'/(H\chi) geometric term
                if (State%tau0-tau > 0.1_dl .and. CP%SourceTerms%counts_radial) then
                    chi =State%tau0-tau
                    counts_radial_source= (1-2.5*W%Window%dlog10Ndm)*((-4.D0*W%wing2(j)/chi*adotoa &
                        -2.D0*(-W%dwing2(j)*chi-W%wing2(j))/chi**2)/ &
                        k*sigma+2.D0*W%wing2(j)*etak/chi/k/EV%Kf(1))
                else
                    counts_radial_source = 0
                end if

                if (CP%SourceTerms%counts_timedelay) then
                    !time delay; WinV is int g/chi
                    counts_timedelay_source= 2*(1-2.5*W%Window%dlog10Ndm)*W%WinV(j)*2*phi
                else
                    counts_timedelay_source = 0
                end if

                if (CP%SourceTerms%counts_ISW) then
                    !WinF is int wingtau
                    counts_ISW_source = W%WinF(j)*2*phidot
                else
                    counts_ISW_source = 0
                end if

                if (CP%SourceTerms%counts_potential) then
                    !approx phi = psi
                    counts_potential_source = ( phidot/adotoa + phi +(5*W%Window%dlog10Ndm-2)*phi ) * W%wing(j) &
                        + phi * W%wingtau(j)
                else
                    counts_potential_source = 0
                end if

                if (CP%SourceTerms%counts_velocity) then
                    counts_velocity_source =  (-2.D0*W%wingtau(j)*adotoa+W%dwingtau(j))/k*sigma &
                        +W%wingtau(j)*etak/k/EV%Kf(1) &
                        - counts_radial_source  !don't double count terms; counts_radial is part of counts_velocity with 1/H/chi
                else
                    counts_velocity_source = 0
                end if

                sources(3+w_ix)=  counts_radial_source +  counts_density_source + counts_redshift_source &
                    + counts_timedelay_source + counts_potential_source &
                    + counts_ISW_source + counts_velocity_source

                sources(3+w_ix)=sources(3+w_ix)/W%Fq

                if (CP%SourceTerms%counts_lensing) &
                    sources(3+W%mag_index+State%num_redshiftwindows) = phi*W%win_lens(j)*(2-5*W%Window%dlog10Ndm)
            elseif (W%kind == window_21cm) then
                if (CP%SourceTerms%line_basic) then
                    sources(3+w_ix)= exptau*(W%wing(j)*Delta_source + W%wing2(j)*Delta_source2 &
                        - W%Wingtau(j)*(clxb - (Delta_source2+clxg/4)))
                    !!    sources(3+w_ix)= exptau*W%wing(j)*phi
                else
                    sources(3+w_ix)= 0
                end if

                if (CP%SourceTerms%line_distortions ) then
                    !With baryon velocity, dropping small terms
                    s(1) =  (sigma/adotoa/3.D0-etak/adotoa**2/3.D0)*W%wing(j)*exptau*k
                    s(2) =  -1.D0/adotoa**2*exptau*W%wing(j)*dgrho/6.D0+((((4.D0*sigma+ &
                        vb)*adotoa+(-grho*sigma/2.D0-vb*grho/3.D0)/adotoa+(sigma*grho**2/18.D0+ &
                        vb*grho**2/18.D0)/adotoa**3)*W%wing(j)-4.D0*W%dwing(j)*sigma+(W%ddwing(j)*sigma+ &
                        W%ddwing(j)*vb)/adotoa+(W%dwing(j)*sigma*grho/3.D0+W%dwing(j)*vb*grho/3.D0)/ &
                        adotoa**2-2.D0*W%dwing(j)*vb+((-2.D0*etak+etak*grho/adotoa**2/3.D0)*W%wing(j) &
                        + 2.D0*W%dwing(j)*etak/adotoa)/EV%Kf(1))*exptau+ &
                        (-4.D0*visibility*sigma- 2.D0*visibility*vb+ &
                        (dvisibility*sigma+dvisibility*vb)/adotoa+(visibility*grho*sigma/3.D0+ &
                        visibility*vb*grho/3.D0)/adotoa**2)*W%wing(j)+2.D0*visibility*etak/adotoa*W%wing(j)/ &
                        EV%Kf(1)+(2.D0*visibility*W%dwing(j)*sigma+2.D0*visibility*W%dwing(j)*vb)/adotoa)/k
                    t(0) =  s(1)+s(2)

                    sources(3+w_ix)= sources(3+w_ix) + t(0)
                end if


                if (CP%SourceTerms%line_extra) then
                    !All sources except below
                    if (CP%SourceTerms%line_basic .and. CP%SourceTerms%line_distortions) then
                        sources(3+w_ix) =  (-2.D0/3.D0*sigma+2.D0/3.D0*etak/adotoa)*W%winV(j)*exptau*k+ &
                            (W%wing2(j)*Delta_source2+W%wing(j)*Delta_source+1.D0/adotoa*W%winV(j)*dgrho/3.D0)* &
                            exptau+((-W%dwing(j)*vb+(-(3.D0*gpres+grho)*sigma/3.D0 &
                            - 4.D0*adotoa**2*sigma)*W%winV(j)+4.D0*adotoa*W%dwinV(j)*sigma+(-sigma- &
                            vb)*W%ddWinV(j)-vbdot*W%wing(j)-W%dwinV(j)*vbdot+(-2.D0*W%dwinV(j)*etak &
                            + 2.D0*etak*adotoa*W%winV(j))/EV%Kf(1))*exptau-2.D0*visibility*sigma*W%dwinV(j)+ &
                            (4.D0*visibility*sigma*adotoa-dvisibility*sigma)*W%winV(j)-2.D0*visibility*W%winV(j)*etak/ &
                            EV%Kf(1)-visibility*W%dwinV(j)*vb-visibility*W%wing(j)*vb)/k+((2.D0*W%dwinV(j)*dgpi+ &
                            diff_rhopi*W%winV(j))*exptau+2.D0*visibility*W%winV(j)*dgpi)/k**2
                    else
                        s(1) =  ((-2.D0/3.D0*sigma+2.D0/3.D0*etak/adotoa)*W%winV(j)+(-sigma/adotoa/3.D0+ &
                            etak/adotoa**2/3.D0)*W%wing(j))*exptau*k+(1.D0/adotoa*W%winV(j)*dgrho/3.D0 &
                            + 1.D0/adotoa**2*W%wing(j)*dgrho/6.D0)*exptau
                        s(2) =  s(1)
                        s(6) =  ((-vb-sigma)*W%ddWinV(j)+(-4.D0*adotoa**2*sigma-&
                            (18.D0*gpres+ 6.D0*grho)*sigma/18.D0)*W%winV(j)+((-4.D0*sigma-vb)*adotoa-vbdot+&
                            (grho*sigma/ 2.D0+vb*grho/3.D0)/adotoa+(-grho**2*sigma/18.D0-vb*grho**2/18.D0)/ &
                            adotoa**3)*W%wing(j)+W%dwing(j)*vb+(-W%ddwing(j)*sigma-W%ddwing(j)*vb)/adotoa &
                            + 4.D0*W%dwinV(j)*sigma*adotoa+4.D0*W%dwing(j)*sigma+(-W%dwing(j)*grho*sigma/3.D0- &
                            W%dwing(j)*vb*grho/3.D0)/adotoa**2-W%dwinV(j)*vbdot+((2.D0*etak-etak*grho/ &
                            adotoa**2/3.D0)*W%wing(j)-2.D0*W%dwing(j)*etak/adotoa-2.D0*W%dwinV(j)*etak &
                            + 2.D0*etak*adotoa*W%winV(j))/EV%Kf(1))*exptau-visibility*W%dwinV(j)*vb+ &
                            (4.D0*visibility*sigma*adotoa-dvisibility*sigma)*W%winV(j)
                        s(5) =  s(6)+(-2.D0*visibility*etak/adotoa*W%wing(j)-2.D0*visibility*W%winV(j)*etak)/ &
                            EV%Kf(1)+(4.D0*visibility*sigma+(-visibility*grho*sigma/3.D0-visibility*vb*grho/3.D0)/ &
                            adotoa**2+visibility*vb+(-dvisibility*sigma-dvisibility*vb)/adotoa)*W%wing(j)+ &
                            (-2.D0*visibility*W%dwing(j)*sigma-2.D0*visibility*W%dwing(j)*vb)/adotoa &
                            - 2.D0*visibility*W%dwinV(j)*sigma
                        s(6) =  1.D0/k
                        s(4) =  s(5)*s(6)
                        s(5) =  ((diff_rhopi*W%winV(j)+2.D0*W%dwinV(j)*dgpi)*exptau &
                            + 2.D0*visibility*dgpi*W%winV(j))/k**2
                        s(3) =  s(4)+s(5)
                        t(0) =  s(2)+s(3)

                        sources(3+w_ix) =   sources(3+w_ix) + t(0)
                    end if
                end if


                if (CP%SourceTerms%line_reionization) then
                    if (State%num_redshiftwindows>1) stop 'reionization only for one window at the mo'
                    lineoff=EV%reion_line_ix
                    lineoffpol = lineoff+EV%lmaxline-1

                    if (tau  < State%tau0) then
                        polter_line = 0.1_dl*y(lineoff+2)+9._dl/15._dl*y(lineoffpol+2)
                        sources(2)=visibility*polter_line*(15._dl/2._dl)/(f_K(State%tau0-tau)*k)**2
                    else
                        sources(2)=0
                    end if

                    if (.not. CP%SourceTerms%use_21cm_mK) sources(2)= sources(2) /W%Fq

                    s(1) =  visibility*y(lineoff+2)/4.D0+visibility*y(lineoff)
                    s(2) =  s(1)
                    s(4) =  (-1.D0/EV%Kf(1)*visibility*W%winV(j)*etak/10.D0-visibility*sigma*W%dwinV(j)/10.D0 &
                        - 9.D0/20.D0*visibility*yprime(lineoff+2)-27.D0/100.D0*visibility*opacity*y(lineoff+1) &
                        - 9.D0/10.D0*dvisibility*y(lineoff+3)-3.D0/20.D0*visibility*opacity*EV%Kf(2)*y(lineoffpol+3)+ &
                        visibility*W%dwinV(j)*vb+81.D0/200.D0*visibility*opacity*y(lineoff+3) &
                        +3.D0/5.D0*dvisibility*y(lineoff+1)+3.D0/10.D0*visibility*yprime(lineoff+1)+ &
                        (visibility*adotoa*sigma/5.D0+(36.D0*visibility*opacity-80.D0*dvisibility)*sigma/400.D0+ &
                        dvisibility*vb+visibility*vbdot)*W%winV(j))/k
                    s(5) =  (visibility*W%winV(j)*dgpi/10.D0+9.D0/20.D0*visibility*dopacity*y(lineoffpol+2) &
                        + 261.D0/400.D0*visibility*opacity**2.D0*y(lineoff+2)&
                        -117.D0/200.D0*visibility*opacity**2.D0*y(lineoffpol+2)+3.D0/4.D0*ddvisibility*y(lineoff+2) &
                        - 27.D0/20.D0*dvisibility*opacity*y(lineoff+2)+9.D0/10.D0*dvisibility*opacity*y(lineoffpol+2)&
                        -27.D0/40.D0*visibility*dopacity*y(lineoff+2))/k**2
                    s(3) =  s(4)+s(5)
                    t(0) =  s(2)+s(3)

                    sources(3+w_ix)= sources(3+w_ix) + t(0)
                end if

                if (CP%SourceTerms%line_phot_quadrupole) then
                    s(1) =  (EV%kf(1)*W%wing2(j)*pig/2.D0+(-clxg/4.D0-5.D0/8.D0*pig)*W%wing2(j))*exptau
                    s(3) =  ((-1.D0/EV%kf(1)*W%wing2(j)*etak+(-sigma+9.D0/8.D0*EV%kf(2)*y(9) &
                        -3.D0/4.D0*qg)*W%dwing2(j)+(-opacity*vb+2.D0*adotoa*sigma+9.D0/8.D0*EV%kf(2)*yprime(9) &
                        + 3.D0/8.D0*opacity*EV%kf(2)*E(3)+3.D0/4.D0*opacity*qg)*W%wing2(j))*exptau+ &
                        (-3.D0/4.D0*visibility*qg-visibility*sigma+9.D0/8.D0*visibility*EV%kf(2)*y(9))*W%wing2(j))/k
                    s(4) =  (((27.D0/16.D0*opacity*pig-15.D0/8.D0*pigdot &
                        -9.D0/8.D0*opacity*E(2))*W%dwing2(j)+(27.D0/16.D0*dopacity*pig &
                        +9.D0/8.D0*opacity**2.D0*E(2)-9.D0/8.D0*opacity**2.D0*polter &
                        +27.D0/16.D0*opacity*pigdot+dgpi-9.D0/8.D0*dopacity*E(2))*W%wing2(j)&
                        -15.D0/8.D0*W%ddwing2(j)*pig)*exptau-15.D0/4.D0*visibility*W%dwing2(j)*pig+(- &
                        (-27.D0*visibility*opacity+30.D0*dvisibility)*pig/16.D0-9.D0/8.D0*visibility*opacity*E(2) &
                        - 15.D0/8.D0*visibility*pigdot)*W%wing2(j))/k**2
                    s(2) =  s(3)+s(4)
                    t(0) =  s(1)+s(2)

                    sources(3+w_ix)= sources(3+w_ix)+ t(0)
                end if


                if (CP%SourceTerms%line_phot_dipole) then
                    sources(3+w_ix)=sources(3+w_ix) + (EV%kf(1)*W%wing2(j)*pig/2.D0-W%wing2(j)*clxg/4.D0)*exptau &
                        +(((vbdot- opacity*vb+3.D0/4.D0*opacity*qg)*&
                        W%wing2(j)+(vb-3.D0/4.D0*qg)*W%dwing2(j))*exptau+&
                        (visibility*vb-3.D0/4.D0*visibility*qg)*W%wing2(j))/k
                end if

                if (.not. CP%SourceTerms%use_21cm_mK) sources(3+w_ix)= sources(3+w_ix) /W%Fq
            end if
        end associate
    end do
    end subroutine output_window_sources

    subroutine output(EV, y, j, tau,sources, num_custom_sources)
    type(EvolutionVars) EV
    real(dl) y(EV%nvar), yprime(EV%nvar)
    integer, intent(in) :: j
    real(dl) tau
    real(dl), target :: sources(:)
    integer, intent(in) :: num_custom_sources

    yprime = 0
    EV%OutputSources => Sources
    EV%OutputStep = j
    if (num_custom_sources>0) &
        EV%CustomSources => sources(State%CLdata%CTransScal%NumSources - num_custom_sources+1:)
    call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)
    nullify(EV%OutputSources, EV%CustomSources)

    end subroutine output

    subroutine outputt(EV,yt,n,tau,dt,dte,dtb)
    !calculate the tensor sources for open and closed case
    implicit none
    integer n
    type(EvolutionVars) :: EV
    real(dl), target :: yt(n), ytprime(n)
    real(dl) tau,dt,dte,dtb,x,polterdot,polterddot,prefac
    real(dl) pig, pigdot, octg, aux, polter, shear, adotoa,a
    real(dl) sinhxr,cothxor
    real(dl) k,k2
    real(dl), dimension(:),pointer :: E,Bprime,Eprime
    real(dl), target :: pol(3),polEprime(3), polBprime(3)
    real(dl) opacity, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow

    call derivst(EV,EV%nvart,tau,yt,ytprime)

    k2=EV%k2_buf
    k=EV%k_buf
    aux=EV%aux_buf
    shear = yt(ixt_shear)

    x=(State%tau0-tau)/State%curvature_radius
    call EV%ThermoData%IonizationFunctionsAtTime(tau, a, opacity, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow)

    !  And the electric part of the Weyl.
    if (.not. EV%TensTightCoupling) then
        !  Use the full expression for pigdt
        pig=yt(EV%g_ix+2)
        pigdot=ytprime(EV%g_ix+2)
        E => yt(EV%E_ix+1:)
        Eprime=> ytprime(EV%E_ix+1:)
        Bprime => ytprime(EV%B_ix+1:)
        octg=ytprime(EV%g_ix+3)
    else
        !  Use the tight-coupling approximation
        adotoa = 1/(a*dtauda(State,a))
        pigdot=32._dl/45._dl*k/opacity*(2._dl*adotoa*shear+ytprime(ixt_shear))
        pig = 32._dl/45._dl*k/opacity*shear
        pol=0
        polEprime=0
        polBprime=0
        E=>pol
        EPrime=>polEPrime
        BPrime=>polBPrime
        E(2)=pig/4._dl
        EPrime(2)=pigdot/4
        octg=0
    endif

    sinhxr=State%rofChi(x)*State%curvature_radius

    if (EV%q*sinhxr > 1.e-8_dl) then
        prefac=sqrt(EV%q2*State%curvature_radius*State%curvature_radius-State%Ksign)
        cothxor=State%cosfunc(x)/sinhxr

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)
        polterdot=9._dl/15._dl*Eprime(2) + 0.1_dl*pigdot
        polterddot = 9._dl/15._dl*(-dopacity*(E(2)-polter)-opacity*(  &
            Eprime(2)-polterdot) + k*(2._dl/3._dl*Bprime(2)*aux - 5._dl/27._dl*Eprime(3)*EV%Kft(2))) &
            +0.1_dl*(k*(-octg*EV%Kft(2)/3._dl + 8._dl/15._dl*ytprime(ixt_shear)) - &
            dopacity*(pig - polter) - opacity*(pigdot-polterdot))

        dt=(shear*exptau + (15._dl/8._dl)*polter*visibility/k)*State%curvature_radius/sinhxr**2/prefac

        dte=State%curvature_radius*15._dl/8._dl/k/prefac* &
            ((ddvisibility*polter + 2._dl*dvisibility*polterdot + visibility*polterddot)  &
            + 4._dl*cothxor*(dvisibility*polter + visibility*polterdot) - &
            visibility*polter*(k2 -6*cothxor**2))

        dtb=15._dl/4._dl*EV%q*State%curvature_radius/k/prefac*(visibility*(2._dl*cothxor*polter + polterdot) + dvisibility*polter)
    else
        dt=0._dl
        dte=0._dl
        dtb=0._dl
    end if

    end subroutine outputt


    subroutine outputv(EV,yv,n,tau,dt,dte,dtb)
    !calculate the vector sources
    implicit none
    integer n
    type(EvolutionVars) :: EV
    real(dl), target :: yv(n), yvprime(n)
    real(dl) tau,dt,dte,dtb,x,polterdot
    real(dl) vb,qg, pig, polter, sigma
    real(dl) k,k2
    real(dl), dimension(:),pointer :: E,Eprime
    real(dl) a, opacity, dopacity, ddopacity, &
        visibility, dvisibility, ddvisibility, exptau, lenswindow


    call derivsv(EV,EV%nvarv,tau,yv,yvprime)

    k2=EV%k2_buf
    k=EV%k_buf
    sigma = yv(2)
    vb  = yv(3)
    qg  = yv(4)
    pig = yv(5)


    x=(State%tau0-tau)*k

    if (x > 1.e-8_dl) then
        E => yv(EV%lmaxv+3:)
        Eprime=> yvprime(EV%lmaxv+3:)

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)
        polterdot=9._dl/15._dl*Eprime(2) + 0.1_dl*yvprime(5)

        call EV%ThermoData%IonizationFunctionsAtTime(tau, a, opacity, dopacity, ddopacity, &
            visibility, dvisibility, ddvisibility, exptau, lenswindow)

        if (yv(1) < 1e-3) then
            dt = 1
        else
            dt =0
        end if
        dt= (4*(vb+sigma)*visibility + 15._dl/2/k*( visibility*polterdot + dvisibility*polter) &
            + 4*(exptau*yvprime(2)) )/x

        dte= 15._dl/2*2*polter/x**2*visibility + 15._dl/2/k*(dvisibility*polter + visibility*polterdot)/x

        dtb= -15._dl/2*polter/x*visibility
    else
        dt=0
        dte=0
        dtb=0
    end if

    end subroutine outputv

    subroutine initial(EV,y, tau)
    !  Scalar initial conditions.
    implicit none

    type(EvolutionVars) EV
    real(dl) y(EV%nvar)
    real(dl) Rp15,tau,x,x2,x3,om,omtau, &
        Rc,Rb,Rv,Rg,grhonu,chi
    real(dl) k,k2
    real(dl) a,a2, iqg, rhomass,a_massive, ep
    integer l,i, nu_i, j, ind
    integer, parameter :: i_clxg=1,i_clxr=2,i_clxc=3, i_clxb=4, &
        i_qg=5,i_qr=6,i_vb=7,i_pir=8, i_eta=9, i_aj3r=10,i_clxde=11,i_vde=12
    integer, parameter :: i_max = i_vde
    real(dl) initv(6,1:i_max), initvec(1:i_max)

    nullify(EV%OutputTransfer) !Should not be needed, but avoids issues in ifort 14
    nullify(EV%OutputSources)
    nullify(EV%CustomSources)

    EV%is_cosmological_constant = State%CP%DarkEnergy%is_cosmological_constant

    if (State%flat) then
        EV%k_buf=EV%q
        EV%k2_buf=EV%q2
        EV%Kf(1:EV%MaxlNeeded)=1._dl
    else
        EV%k2_buf=EV%q2-State%curv
        EV%k_buf=sqrt(EV%k2_buf)

        do l=1,EV%MaxlNeeded
            EV%Kf(l)=1._dl-State%curv*(l*(l+2))/EV%k2_buf
        end do
    end if

    k=EV%k_buf
    k2=EV%k2_buf

    do j=1,EV%MaxlNeeded
        EV%denlk(j)=denl(j)*k*j
        EV%denlk2(j)=denl(j)*k*EV%Kf(j)*(j+1)
        EV%polfack(j)=polfac(j)*k*EV%Kf(j)*denl(j)
    end do

    !Get time to switch off tight coupling
    !The numbers here are a bit of guesswork
    !The high k increase saves time for very small loss of accuracy
    !The lower k ones are more delicate. Nead to avoid instabilities at same time
    !as ensuring tight coupling is accurate enough
    if (EV%k_buf > epsw) then
        if (EV%k_buf > epsw*5) then
            ep=ep0*5/CP%Accuracy%AccuracyBoost*0.65
        else
            ep=ep0
        end if
    else
        ep=ep0
    end if
    if (second_order_tightcoupling) ep=ep*2
    EV%TightSwitchoffTime = min(EV%ThermoData%tight_tau, EV%ThermoData%OpacityToTime(EV%k_buf/ep))

    y=0

    !  k*tau, (k*tau)**2, (k*tau)**3
    x=k*tau
    x2=x*x
    x3=x2*x
    rhomass =  sum(State%grhormass(1:CP%Nu_mass_eigenstates))
    grhonu=rhomass+State%grhornomass

    om = (State%grhob+State%grhoc)/sqrt(3*(State%grhog+grhonu))
    omtau=om*tau
    Rv=grhonu/(grhonu+State%grhog)

    Rg = 1-Rv
    Rc=CP%omch2/(CP%omch2+CP%ombh2)
    Rb=1-Rc
    Rp15=4*Rv+15

    if (CP%Scalar_initial_condition > initial_nummodes) &
        call MpiStop('Invalid initial condition for scalar modes')

    a=tau*State%adotrad*(1+omtau/4)
    a2=a*a

    initv=0

    !  Set adiabatic initial conditions

    chi=1  !Get transfer function for chi
    initv(1,i_clxg)=-chi*EV%Kf(1)/3*x2*(1-omtau/5)
    initv(1,i_clxr)= initv(1,i_clxg)
    initv(1,i_clxb)=0.75_dl*initv(1,i_clxg)
    initv(1,i_clxc)=initv(1,i_clxb)
    initv(1,i_qg)=initv(1,i_clxg)*x/9._dl
    initv(1,i_qr)=-chi*EV%Kf(1)*(4*Rv+23)/Rp15*x3/27
    initv(1,i_vb)=0.75_dl*initv(1,i_qg)
    initv(1,i_pir)=chi*4._dl/3*x2/Rp15*(1+omtau/4*(4*Rv-5)/(2*Rv+15))
    initv(1,i_aj3r)=chi*4/21._dl/Rp15*x3
    initv(1,i_eta)=-chi*2*EV%Kf(1)*(1 - x2/12*(-10._dl/Rp15 + EV%Kf(1)))

    if (CP%Scalar_initial_condition/= initial_adiabatic) then
        !CDM isocurvature

        initv(2,i_clxg)= Rc*omtau*(-2._dl/3 + omtau/4)
        initv(2,i_clxr)=initv(2,i_clxg)
        initv(2,i_clxb)=initv(2,i_clxg)*0.75_dl
        initv(2,i_clxc)=1+initv(2,i_clxb)
        initv(2,i_qg)=-Rc/9*omtau*x
        initv(2,i_qr)=initv(2,i_qg)
        initv(2,i_vb)=0.75_dl*initv(2,i_qg)
        initv(2,i_pir)=-Rc*omtau*x2/3/(2*Rv+15._dl)
        initv(2,i_eta)= Rc*omtau*(1._dl/3 - omtau/8)*EV%Kf(1)
        initv(2,i_aj3r)=0
        !Baryon isocurvature
        if (Rc==0) call MpiStop('Isocurvature initial conditions assume non-zero dark matter')

        initv(3,:) = initv(2,:)*(Rb/Rc)
        initv(3,i_clxc) = initv(3,i_clxb)
        initv(3,i_clxb)= initv(3,i_clxb)+1

        !neutrino isocurvature density mode

        initv(4,i_clxg)=Rv/Rg*(-1 + x2/6)
        initv(4,i_clxr)=1-x2/6
        initv(4,i_clxc)=-omtau*x2/80*Rv*Rb/Rg
        initv(4,i_clxb)= Rv/Rg/8*x2
        iqg = - Rv/Rg*(x/3 - Rb/4/Rg*omtau*x)
        initv(4,i_qg) =iqg
        initv(4,i_qr) = x/3
        initv(4,i_vb)=0.75_dl*iqg
        initv(4,i_pir)=x2/Rp15
        initv(4,i_eta)=EV%Kf(1)*Rv/Rp15/3*x2

        !neutrino isocurvature velocity mode

        initv(5,i_clxg)=Rv/Rg*x - 2*x*omtau/16*Rb*(2+Rg)/Rg**2
        initv(5,i_clxr)=-x -3*x*omtau*Rb/16/Rg
        initv(5,i_clxc)=-9*omtau*x/64*Rv*Rb/Rg
        initv(5,i_clxb)= 3*Rv/4/Rg*x - 9*omtau*x/64*Rb*(2+Rg)/Rg**2
        iqg = Rv/Rg*(-1 + 3*Rb/4/Rg*omtau+x2/6 +3*omtau**2/16*Rb/Rg**2*(Rg-3*Rb))
        initv(5,i_qg) =iqg
        initv(5,i_qr) = 1 - x2/6*(1+4*EV%Kf(1)/(4*Rv+5))
        initv(5,i_vb)=0.75_dl*iqg
        initv(5,i_pir)=2*x/(4*Rv+5)+omtau*x*6/Rp15/(4*Rv+5)
        initv(5,i_eta)=2*EV%Kf(1)*x*Rv/(4*Rv+5) + omtau*x*3*EV%Kf(1)*Rv/32*(Rb/Rg - 80/Rp15/(4*Rv+5))
        initv(5,i_aj3r) = 3._dl/7*x2/(4*Rv+5)

        !quintessence isocurvature mode
    end if

    if (CP%Scalar_initial_condition==initial_vector) then
        InitVec = 0
        do i=1,initial_nummodes
            InitVec = InitVec+ initv(i,:)*CP%InitialConditionVector(i)
        end do
    else
        InitVec = initv(CP%Scalar_initial_condition,:)
        if (CP%Scalar_initial_condition==initial_adiabatic) InitVec = -InitVec
        !So we start with chi=-1 as before
    end if

    y(ix_etak)= -InitVec(i_eta)*k/2
    !get eta_s*k, where eta_s is synchronous gauge variable

    !  CDM
    y(ix_clxc)=InitVec(i_clxc)

    !  Baryons
    y(ix_clxb)=InitVec(i_clxb)
    y(ix_vb)=InitVec(i_vb)

    !  Photons
    y(EV%g_ix)=InitVec(i_clxg)
    y(EV%g_ix+1)=InitVec(i_qg)

    ! DarkEnergy: This initializes also i_vq, when num_perturb_equations is set
    !             to 2.
    if (CP%DarkEnergy%num_perturb_equations > 0) then
        call CP%DarkEnergy%PerturbationInitial(InitVec(i_clxde:i_clxde + CP%DarkEnergy%num_perturb_equations - 1), &
            a, tau,  k)
        y(EV%w_ix:EV%w_ix + CP%DarkEnergy%num_perturb_equations - 1) = &
            InitVec(i_clxde:i_clxde + CP%DarkEnergy%num_perturb_equations - 1)
    end if

    if (CP%Evolve_delta_Ts) then
        y(EV%Ts_ix) = y(EV%g_ix)/4
    end if

    !  Neutrinos
    y(EV%r_ix)=InitVec(i_clxr)
    y(EV%r_ix+1)=InitVec(i_qr)
    y(EV%r_ix+2)=InitVec(i_pir)

    if (EV%lmaxnr>2) then
        y(EV%r_ix+3)=InitVec(i_aj3r)
    endif

    if (CP%Num_Nu_massive == 0) return

    do nu_i = 1, CP%Nu_mass_eigenstates
        EV%MassiveNuApproxTime(nu_i) = Nu_tau_massive(nu_i)
        a_massive =  20000*k/State%nu_masses(nu_i)*CP%Accuracy%AccuracyBoost*CP%Accuracy%lAccuracyBoost
        if (a_massive >=0.99) then
            EV%MassiveNuApproxTime(nu_i)=State%tau0+1
        else if (a_massive > 17.d0/State%nu_masses(nu_i)*CP%Accuracy%AccuracyBoost) then
            EV%MassiveNuApproxTime(nu_i)=max(EV%MassiveNuApproxTime(nu_i),State%DeltaTime(0._dl,a_massive, 0.01_dl))
        end if
        ind = EV%nu_ix(nu_i)
        do  i=1,EV%nq(nu_i)
            y(ind:ind+2)=y(EV%r_ix:EV%r_ix+2)
            if (EV%lmaxnu_tau(nu_i)>2) y(ind+3)=InitVec(i_aj3r)
            ind = ind + EV%lmaxnu_tau(nu_i)+1
        end do
    end do

    end subroutine initial


    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine initialt(EV,yt,tau)
    !  Initial conditions for tensors
    implicit none
    real(dl) bigR,tau,x,aj3r,elec, pir, rhomass
    integer l
    type(EvolutionVars) EV
    real(dl) k,k2 ,a, omtau
    real(dl) yt(EV%nvart)
    real(dl) tens0, ep, tensfac

    if (State%flat) then
        EV%aux_buf=1._dl
        EV%k2_buf=EV%q2
        EV%k_buf=EV%q
        EV%Kft(1:EV%MaxlNeededt)=1._dl !initialize for flat case
    else
        EV%k2_buf=EV%q2-3*State%curv
        EV%k_buf=sqrt(EV%k2_buf)
        EV%aux_buf=sqrt(1._dl+3*State%curv/EV%k2_buf)
    endif

    k=EV%k_buf
    k2=EV%k2_buf

    do l=1,EV%MaxlNeededt
        if (.not. State%flat) EV%Kft(l)=1._dl-State%curv*((l+1)**2-3)/k2
        EV%denlkt(1,l)=k*denl(l)*l !term for L-1
        tensfac=real((l+3)*(l-1),dl)/(l+1)
        EV%denlkt(2,l)=k*denl(l)*tensfac*EV%Kft(l) !term for L+1
        EV%denlkt(3,l)=k*denl(l)*tensfac**2/(l+1)*EV%Kft(l) !term for polarization
        EV%denlkt(4,l)=k*4._dl/(l*(l+1))*EV%aux_buf !other for polarization
    end do

    if (k > 0.06_dl*epsw) then
        ep=ep0
    else
        ep=0.2_dl*ep0
    end if

    !    finished_tightcoupling = ((k/opacity > ep).or.(1._dl/(opacity*tau) > ep))
    EV%TightSwitchoffTime = min(EV%ThermoData%tight_tau,EV%ThermoData%OpacityToTime(EV%k_buf/ep))

    rhomass =  sum(State%grhormass(1:CP%Nu_mass_eigenstates))
    omtau = tau*(State%grhob+State%grhoc)/sqrt(3*(State%grhog+rhomass+State%grhornomass))
    a=tau*State%adotrad*(1+omtau/4)

    if (DoTensorNeutrinos) then
        bigR = (rhomass+State%grhornomass)/(rhomass+State%grhornomass+State%grhog)
    else
        bigR = 0._dl
    end if

    x=k*tau

    tens0 = 1

    yt(ixt_H)= tens0
    !commented things are for the compensated mode with magnetic fields; can be neglected
    !-15/28._dl*x**2*(bigR-1)/(15+4*bigR)*Magnetic*(1-5./2*omtau/(2*bigR+15))

    elec=-tens0*(1+2*State%curv/k2)*(2*bigR+10)/(4*bigR+15) !elec, with H=1

    !shear
    yt(ixt_shear)=-5._dl/2/(bigR+5)*x*elec
    !          + 15._dl/14*x*(bigR-1)/(4*bigR+15)*Magnetic*(1 - 15./2*omtau/(2*bigR+15))

    yt(ixt_shear+1:EV%nvart)=0._dl

    !  Neutrinos
    if (DoTensorNeutrinos) then
        pir=-2._dl/3._dl/(bigR+5)*x**2*elec
        !           + (bigR-1)/bigR*Magnetic*(1-15./14*x**2/(15+4*bigR))
        aj3r=  -2._dl/21._dl/(bigR+5)*x**3*elec !&
        !           + 3._dl/7*x*(bigR-1)/bigR*Magnetic
        yt(EV%r_ix+2)=pir
        yt(EV%r_ix+3)=aj3r
        !Should set up massive too, but small anyway..
    end if

    end subroutine initialt

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    subroutine initialv(EV,yv,tau)
    !  Initial conditions for vectors

    implicit none
    real(dl) bigR,Rc,tau,x,pir
    type(EvolutionVars) EV
    real(dl) k,k2 ,a, omtau
    real(dl) yv(EV%nvarv)

    if (State%flat) then
        EV%k2_buf=EV%q2
        EV%k_buf=EV%q
    else
        call MpiStop('Vectors not supported in non-flat models')
    endif

    k=EV%k_buf
    k2=EV%k2_buf

    omtau = tau*(State%grhob+State%grhoc)/sqrt(3*(State%grhog+State%grhornomass))

    a=tau*State%adotrad*(1+omtau/4)

    x=k*tau

    bigR = (State%grhornomass)/(State%grhornomass+State%grhog)
    Rc=CP%omch2/(CP%omch2+CP%ombh2)

    yv(1)=a !Could eliminate this, but rarely used anyway

    yv(2)= vec_sig0*(1- 15._dl/2*omtau/(4*bigR+15)) + 45._dl/14*x*Magnetic*(BigR-1)/(4*BigR+15)
    !qg
    yv(4)= vec_sig0/3* (4*bigR + 5)/(1-BigR)*(1  -0.75_dl*omtau*(Rc-1)/(bigR-1)* &
        (1 - 0.25_dl*omtau*(3*Rc-2-bigR)/(BigR-1))) &
        -x/2*Magnetic
    yv(3)= 3._dl/4*yv(4)

    yv(5:EV%nvarv) = 0

    !        if (.false.) then
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1) = vec_sig0/6/bigR*x**2*(1+2*bigR*omtau/(4*bigR+15))
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+2) = -2/3._dl*vec_sig0/bigR*x*(1 +3*omtau*bigR/(4*bigR+15))
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+3) = 1/4._dl*vec_sig0/bigR*(5+4*BigR)
    !         yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+4) =1/9.*x*vec_sig0*(5+4*bigR)/bigR
    !         yv(4) = 0
    !         yv(3)= 3._dl/4*yv(4)
    !          return
    !        end if

    !  Neutrinos
    !q_r
    yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1) = -1._dl/3*vec_sig0*(4*BigR+5)/bigR &
        + x**2*vec_sig0/6/BigR +0.5_dl*x*(1/bigR-1)*Magnetic
    !pi_r
    pir=-2._dl/3._dl*x*vec_sig0/BigR - (1/bigR-1)*Magnetic
    yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1 +1)=pir
    yv((EV%lmaxv-1+1)+(EV%lmaxpolv-1)*2+3+1 +2)=3._dl/7*x*Magnetic*(1-1/BigR)

    end subroutine initialv


    subroutine outtransf(EV, y,tau, Arr)
    !write out clxc, clxb, clxg, clxn
    use Transfer
    implicit none
    type(EvolutionVars) EV
    real(dl), intent(in) :: tau
    real, target :: Arr(:)
    real(dl) y(EV%nvar),yprime(EV%nvar)

    yprime = 0
    EV%OutputTransfer =>  Arr
    call derivs(EV,EV%ScalEqsToPropagate,tau,y,yprime)
    nullify(EV%OutputTransfer)
    Arr(Transfer_kh+1:Transfer_max) = Arr(Transfer_kh+1:Transfer_max)/EV%k2_buf

    end subroutine outtransf

    subroutine derivs(EV,n,tau,ay,ayprime)
    !  Evaluate the time derivatives of the scalar perturbations
    use constants, only : barssc0, Compton_CT, line21_const
    use MassiveNu
    use Recombination
    implicit none
    type(EvolutionVars) EV
    integer n,nu_i
    real(dl) ay(n),ayprime(n)
    real(dl) tau, w
    real(dl) k,k2
    real(dl) opacity
    real(dl) photbar,cs2,pb43,grho,slip,clxgdot, &
        clxcdot,clxbdot,adotdota,gpres,clxrdot,etak
    real(dl) q,aq,v
    real(dl) G11_t,G30_t, wnu_arr(max_nu)

    real(dl) dgq,grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,grhonu_t,sigma,polter
    real(dl) w_dark_energy_t !equation of state of dark energy
    real(dl) gpres_noDE !Pressure with matter and radiation, no dark energy
    real(dl) qgdot,qrdot,pigdot,pirdot,vbdot,dgrho,adotoa
    real(dl) a,a2,z,clxc,clxb,vb,clxg,qg,pig,clxr,qr,pir
    real(dl) E2, dopacity
    integer l,i,ind, ind2, off_ix, ix
    real(dl) dgs,sigmadot,dz
    real(dl) dgpi,dgrho_matter,grho_matter, clxnu, gpres_nu
    !non-flat vars
    real(dl) cothxor !1/tau in flat case
    real(dl) xe,Trad, Delta_TM, Tmat, Delta_TCMB
    real(dl) delta_p_b, wing_t, wing2_t,winv_t
    real(dl) Delta_source2, polter_line
    real(dl) Delta_xe, Tspin, tau_eps, tau_fac, Tb
    integer lineoff,lineoffpol
    !Variables for source calculation
    real(dl) diff_rhopi, pidot_sum, dgpi_diff, phi
    real(dl) E(2:3), Edot(2:3)
    real(dl) phidot, polterdot, polterddot, octg, octgdot
    real(dl) ddopacity, visibility, dvisibility, ddvisibility, exptau, lenswindow
    real(dl) ISW, quadrupole_source, doppler, monopole_source, tau0, ang_dist
    real(dl) dgrho_de, dgq_de, cs2_de

    k=EV%k_buf
    k2=EV%k2_buf

    !  Get background scale factor, sound speed and ionisation fraction.
    if (EV%TightCoupling) then
        call EV%ThermoData%Values(tau,a,cs2,opacity,dopacity)
    else
        call EV%ThermoData%Values(tau,a,cs2,opacity)
    end if
    a2=a*a

    etak=ay(ix_etak)

    !  CDM variables
    clxc=ay(ix_clxc)

    !  Baryon variables
    clxb=ay(ix_clxb)
    vb=ay(ix_vb)
    !  Compute expansion rate from: grho 8*pi*rho*a**2

    grhob_t=State%grhob/a
    grhoc_t=State%grhoc/a
    grhor_t=State%grhornomass/a2
    grhog_t=State%grhog/a2

    if (EV%is_cosmological_constant) then
        grhov_t = State%grhov * a2
        w_dark_energy_t = -1_dl
    else
        call State%CP%DarkEnergy%BackgroundDensityAndPressure(State%grhov, a, grhov_t, w_dark_energy_t)
    end if

    !total perturbations: matter terms first, then add massive nu, de and radiation
    !  8*pi*a*a*SUM[rho_i*clx_i]
    dgrho_matter=grhob_t*clxb+grhoc_t*clxc
    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    dgq=grhob_t*vb

    gpres_nu=0
    grhonu_t=0

    if (State%CP%Num_Nu_Massive > 0) then
        call MassiveNuVars(EV,ay,a,grhonu_t,gpres_nu,dgrho_matter,dgq, wnu_arr)
    end if

    grho_matter=grhonu_t+grhob_t+grhoc_t
    grho = grho_matter+grhor_t+grhog_t+grhov_t
    gpres_noDE = gpres_nu + (grhor_t + grhog_t)/3

    if (State%flat) then
        adotoa=sqrt(grho/3)
        cothxor=1._dl/tau
    else
        adotoa=sqrt((grho+State%grhok)/3._dl)
        cothxor=1._dl/State%tanfunc(tau/State%curvature_radius)/State%curvature_radius
    end if

    dgrho = dgrho_matter

    if (EV%no_nu_multpoles) then
        !RSA approximation of arXiv:1104.2933, dropping opactity terms in the velocity
        !Approximate total density variables with just matter terms
        z=(0.5_dl*dgrho/k + etak)/adotoa
        dz= -adotoa*z - 0.5_dl*dgrho/k
        clxr=-4*dz/k
        qr=-4._dl/3*z
        pir=0
    else
        !  Massless neutrinos
        clxr=ay(EV%r_ix)
        qr  =ay(EV%r_ix+1)
        pir =ay(EV%r_ix+2)
    endif

    pig=0
    if (EV%no_phot_multpoles) then
        if (.not. EV%no_nu_multpoles) then
            z=(0.5_dl*dgrho/k + etak)/adotoa
            dz= -adotoa*z - 0.5_dl*dgrho/k
            clxg=-4*dz/k-4/k*opacity*(vb+z)
            qg=-4._dl/3*z
        else
            clxg=clxr-4/k*opacity*(vb+z)
            qg=qr
        end if
    else
        !  Photons
        clxg=ay(EV%g_ix)
        qg=ay(EV%g_ix+1)
        if (.not. EV%TightCoupling) pig=ay(EV%g_ix+2)
    end if

    !  8*pi*a*a*SUM[rho_i*clx_i] - radiation terms
    dgrho=dgrho + grhog_t*clxg+grhor_t*clxr

    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    dgq=dgq + grhog_t*qg+grhor_t*qr

    !  Photon mass density over baryon mass density
    photbar=grhog_t/grhob_t
    pb43=4._dl/3*photbar

    if (.not. EV%is_cosmological_constant) then
        call State%CP%DarkEnergy%PerturbedStressEnergy(dgrho_de, dgq_de, &
            a, dgq, dgrho, grho, grhov_t, w_dark_energy_t, gpres_noDE, etak, &
            adotoa, k, EV%Kf(1), ay, ayprime, EV%w_ix)
        dgrho = dgrho + dgrho_de
        dgq = dgq + dgq_de
    end if

    !  Get sigma (shear) and z from the constraints
    ! have to get z from eta for numerical stability
    z=(0.5_dl*dgrho/k + etak)/adotoa
    if (State%flat) then
        !eta*k equation
        sigma=(z+1.5_dl*dgq/k2)
        ayprime(ix_etak)=0.5_dl*dgq
    else
        sigma=(z+1.5_dl*dgq/k2)/EV%Kf(1)
        ayprime(ix_etak)=0.5_dl*dgq + State%curv*z
    end if

    if (.not. EV%is_cosmological_constant) &
        call State%CP%DarkEnergy%PerturbationEvolve(ayprime, w_dark_energy_t, &
        EV%w_ix, a, adotoa, k, z, ay)

    !  CDM equation of motion
    clxcdot=-k*z
    ayprime(ix_clxc)=clxcdot

    !  Baryon equation of motion.
    clxbdot=-k*(z+vb)
    ayprime(ix_clxb)=clxbdot
    !  Photon equation of motion
    clxgdot=-k*(4._dl/3._dl*z+qg)

    !Sources
    if (EV%Evolve_baryon_cs) then
        if (a > State%CP%Recomb%min_a_evolve_Tm) then
            Tmat = State%CP%Recomb%T_m(a)
        else
            Tmat = State%CP%TCMB/a
        end if
        if (EV%Evolve_TM) then
            Delta_TM = ay(EV%Tg_ix)
        else
            Delta_TM = clxg/4
        end if
        delta_p_b = barssc0*(1._dl-0.75d0*State%CP%yhe+(1._dl-State%CP%yhe)*opacity*a2/State%akthom)*Tmat*(clxb + delta_tm)
    else
        Delta_TM = clxg/4
        delta_p_b = cs2*clxb
    end if

    if (State%CP%Evolve_delta_xe) then
        if (EV%saha) then
            xe=State%CP%Recomb%x_e(a)
            Delta_xe = (1-xe)/(2-xe)*(-clxb + (3._dl/2+  CB1/Tmat)*Delta_TM)
        else
            Delta_xe = ay(EV%xe_ix)
        end if
    else
        Delta_xe = 0
    end if

    ! Easy to see instability in k \sim 1e-3 by tracking evolution of vb

    !  Use explicit equation for vb if appropriate

    if (EV%TightCoupling) then
        !  ddota/a
        gpres = gpres_noDE + w_dark_energy_t*grhov_t
        adotdota=(adotoa*adotoa-gpres)/2

        pig = 32._dl/45/opacity*k*(sigma+vb)

        !  First-order approximation to baryon-photon splip
        slip = - (2*adotoa/(1+pb43) + dopacity/opacity)* (vb-3._dl/4*qg) &
            +(-adotdota*vb-k/2*adotoa*clxg +k*(cs2*clxbdot-clxgdot/4))/(opacity*(1+pb43))

        if (second_order_tightcoupling) then
            ! by Francis-Yan Cyr-Racine simplified (inconsistently) by AL assuming flat
            !AL: First order slip seems to be fine here to 2e-4

            !  8*pi*G*a*a*SUM[rho_i*sigma_i]
            dgs = grhog_t*pig+grhor_t*pir

            ! Define shear derivative to first order
            sigmadot = -2*adotoa*sigma-dgs/k+etak

            !Once know slip, recompute qgdot, pig, pigdot
            qgdot = k*(clxg/4._dl-pig/2._dl) +opacity*slip

            pig = 32._dl/45/opacity*k*(sigma+3._dl*qg/4._dl)*(1+(dopacity*11._dl/6._dl/opacity**2)) &
                + (32._dl/45._dl/opacity**2)*k*(sigmadot+3._dl*qgdot/4._dl)*(-11._dl/6._dl)

            pigdot = -(32._dl/45._dl)*(dopacity/opacity**2)*k*(sigma+3._dl*qg/4._dl)*(1 + &
                dopacity*11._dl/6._dl/opacity**2 ) &
                + (32._dl/45._dl/opacity)*k*(sigmadot+3._dl*qgdot/4._dl)*(1+(11._dl/6._dl) &
                *(dopacity/opacity**2))

            EV%pigdot = pigdot

        end if

        !  Use tight-coupling approximation for vb
        !  zeroth order approximation to vbdot + the pig term
        vbdot=(-adotoa*vb+cs2*k*clxb + k/4*pb43*(clxg-2*EV%Kf(1)*pig))/(1+pb43)

        vbdot=vbdot+pb43/(1+pb43)*slip
        EV%pig = pig

    else
        vbdot=-adotoa*vb+k*delta_p_b-photbar*opacity*(4._dl/3*vb-qg)
    end if

    ayprime(ix_vb)=vbdot

    if (.not. EV%no_phot_multpoles) then
        !  Photon equations of motion
        ayprime(EV%g_ix)=clxgdot
        qgdot=4._dl/3*(-vbdot-adotoa*vb+delta_p_b*k)/pb43 &
            +EV%denlk(1)*clxg-EV%denlk2(1)*pig
        ayprime(EV%g_ix+1)=qgdot

        !  Use explicit equations for photon moments if appropriate
        if (.not. EV%tightcoupling) then
            E2=ay(EV%polind+2)
            polter = pig/10+9._dl/15*E2 !2/15*(3/4 pig + 9/2 E2)
            ix= EV%g_ix+2
            if (EV%lmaxg>2) then
                pigdot=EV%denlk(2)*qg-EV%denlk2(2)*ay(ix+1)-opacity*(pig - polter) &
                    +8._dl/15._dl*k*sigma
                ayprime(ix)=pigdot
                do  l=3,EV%lmaxg-1
                    ix=ix+1
                    ayprime(ix)=(EV%denlk(l)*ay(ix-1)-EV%denlk2(l)*ay(ix+1))-opacity*ay(ix)
                end do
                ix=ix+1
                !  Truncate the photon moment expansion
                ayprime(ix)=k*ay(ix-1)-(EV%lmaxg+1)*cothxor*ay(ix) -opacity*ay(ix)
            else !closed case
                pigdot=EV%denlk(2)*qg-opacity*(pig - polter) +8._dl/15._dl*k*sigma
                ayprime(ix)=pigdot
            endif
            !  Polarization
            !l=2
            ix=EV%polind+2
            if (EV%lmaxgpol>2) then
                ayprime(ix) = -opacity*(ay(ix) - polter) - k/3._dl*ay(ix+1)
                do l=3,EV%lmaxgpol-1
                    ix=ix+1
                    ayprime(ix)=-opacity*ay(ix) + (EV%denlk(l)*ay(ix-1)-EV%polfack(l)*ay(ix+1))
                end do
                ix=ix+1
                !truncate
                ayprime(ix)=-opacity*ay(ix) + &
                    k*EV%poltruncfac*ay(ix-1)-(EV%lmaxgpol+3)*cothxor*ay(ix)
            else !closed case
                ayprime(ix) = -opacity*(ay(ix) - polter)
            endif
        end if
    end if

    if (.not. EV%no_nu_multpoles) then
        !  Massless neutrino equations of motion.
        clxrdot=-k*(4._dl/3._dl*z+qr)
        ayprime(EV%r_ix)=clxrdot
        qrdot=EV%denlk(1)*clxr-EV%denlk2(1)*pir
        ayprime(EV%r_ix+1)=qrdot
        if (EV%high_ktau_neutrino_approx) then
            !ufa approximation for k*tau>>1, more accurate when there are reflections from lmax
            !Method from arXiv:1104.2933
            !                if (.not. EV%TightCoupling) then
            !                 gpres=gpres+ (grhog_t+grhor_t)/3 +grhov_t*w_lam
            !                 adotdota=(adotoa*adotoa-gpres)/2
            !                end if
            !                ddz=(2*adotoa**2 - adotdota)*z  &
            !                  + adotoa/(2*k)*( 6*(grhog_t*clxg+grhor_t*clxr) + 2*(grhoc_t*clxc+grhob_t*clxb) ) &
            !                   - 1._dl/(2*k)*( 2*(grhog_t*clxgdot+grhor_t*clxrdot) + grhoc_t*clxcdot + grhob_t*clxbdot )
            !                dz= -adotoa*z - 0.5_dl*dgrho/k
            !                pirdot= -3*pir*cothxor + k*(qr+4._dl/3*z)
            pirdot= -3*pir*cothxor - clxrdot
            ayprime(EV%r_ix+2)=pirdot

            !                pirdot=k*(0.4_dl*qr-0.6_dl*ay(EV%lmaxg+10)+8._dl/15._dl*sigma)
            !                ayprime(EV%lmaxg+9)=pirdot
            !                ayprime(3+EV%lmaxg+7)=k*ay(3+EV%lmaxg+6)- &
            !                                      (3+1)*cothxor*ay(3+EV%lmaxg+7)
            !               ayprime(3+EV%lmaxg+7+1:EV%lmaxnr+EV%lmaxg+7)=0
        else
            ix=EV%r_ix+2
            if (EV%lmaxnr>2) then
                pirdot=EV%denlk(2)*qr- EV%denlk2(2)*ay(ix+1)+8._dl/15._dl*k*sigma
                ayprime(ix)=pirdot
                do l=3,EV%lmaxnr-1
                    ix=ix+1
                    ayprime(ix)=(EV%denlk(l)*ay(ix-1) - EV%denlk2(l)*ay(ix+1))
                end do
                !  Truncate the neutrino expansion
                ix=ix+1
                ayprime(ix)=k*ay(ix-1)- (EV%lmaxnr+1)*cothxor*ay(ix)
            else
                pirdot=EV%denlk(2)*qr +8._dl/15._dl*k*sigma
                ayprime(ix)=pirdot
            end if
        end if
    end if ! no_nu_multpoles

    if (EV%Evolve_baryon_cs) then
        if (EV%Evolve_TM) then
            Delta_TCMB = clxg/4
            xe = State%CP%Recomb%x_e(a)
            Trad = State%CP%TCMB/a

            !Matter temperature
            !Recfast_CT = (8./3.)*(sigma_T/(m_e*C))*a_R in Mpc [a_R = radiation constant]
            ayprime(EV%Tg_ix) = -2*k*(z+vb)/3 - a*  Compton_CT * (Trad**4) * xe / (1._dl+xe+State%fHe) * &
                ((1- Trad/Tmat)*(Delta_TCMB*4 + Delta_xe/(1+xe/(1+State%fHe))) &
                + Trad/Tmat*(Delta_Tm - Delta_TCMB)  )

            if (State%CP%Evolve_delta_Ts) then
                ayprime(EV%Ts_ix) =  Get21cm_dTs(a,clxb,ay(EV%Ts_ix),Delta_TCMB,Delta_Tm,Tmat,Trad,xe )
            end if
        else
            if (State%CP%Evolve_delta_Ts) then
                ayprime(EV%Ts_ix) = -k*(4._dl/3._dl*z+qg)/4  !Assume follows Delta_TM which follows clxg
            end if
        end if
    end if

    if (State%CP%Evolve_delta_xe .and. .not. EV%saha) then
        ayprime(EV%xe_ix) = &
            State%CP%Recomb%dDeltaxe_dtau(a, Delta_xe,clxb, Delta_Tm, k*z/3,k*vb, adotoa)
    end if

    if (State%CP%Do21cm) then
        if (a > State%CP%Recomb%min_a_evolve_Tm) then
            if (State%CP%SourceTerms%line_reionization) then
                lineoff = EV%reion_line_ix+1
                lineoffpol = lineoff+EV%lmaxline-1

                if (tau> EV%ThermoData%tau_start_redshiftwindows) then
                    !Multipoles of 21cm

                    polter_line = ay(lineoff+2)/10+9._dl/15*ay(lineoffpol+2)

                    call interp_window(State%TimeSteps,State%Redshift_W(1),tau,wing_t,wing2_t,winv_t)

                    delta_source2 = Get21cm_source2(a,clxb,Delta_TCMB,Delta_Tm,Delta_xe,Tmat,Trad,xe,k*(z+vb)/adotoa/3)


                    !Drop some small terms since mulipoles only enter into reionzation anyway
                    !monopole
                    ayprime(lineoff) = -k*ay(lineoff+1) +  wing_t * clxb + wing2_t*delta_source2 + k*z/3*winV_t


                    !dipole
                    ayprime(lineoff+1)= EV%denlk(1)*ay(lineoff)-EV%denlk2(1)*ay(lineoff+2) - opacity*ay(lineoff+1) &
                        -wing2_t * ( qg/4 - vb/3)   ! vb/3*WinV_t)

                    !quadrupole
                    ayprime(lineoff+2)= EV%denlk(2)*ay(lineoff+1)-EV%denlk2(2)*ay(lineoff+3) &
                        +opacity*(polter_line -ay(lineoff+2) ) -   2._dl/15*k*sigma*winV_t &
                        - wing2_t * ay(EV%g_ix+2)/4

                    do  l=3,EV%lmaxline-1
                        ayprime(lineoff+l)=EV%denlk(l)*ay(lineoff+l-1)-EV%denlk2(l)*ay(lineoff+l+1)-opacity*ay(lineoff+l) &
                            - wing2_t * ay(EV%g_ix+l)/4
                    end do
                    !truncate
                    ayprime(lineoff+EV%lmaxline)=k*ay(lineoff+EV%lmaxline-1)-(EV%lmaxline+1)*cothxor*ay(lineoff+EV%lmaxline)  &
                        -opacity*ay(lineoff+EV%lmaxline) - wing2_t * ay(EV%g_ix+EV%lmaxline)/4

                    !  21cm Polarization
                    !l=2
                    ayprime(lineoffpol+2) = -opacity*(ay(lineoffpol+2) - polter_line) - k/3._dl*ay(lineoffpol+3)
                    !and the rest
                    do l=3,EV%lmaxline-1
                        ayprime(lineoffpol+l)=-opacity*ay(lineoffpol+l) + EV%denlk(l)*ay(lineoffpol+l-1) -&
                            EV%polfack(l)*ay(lineoffpol+l+1)
                    end do

                    !truncate
                    ayprime(lineoffpol+EV%lmaxline)=-opacity*ay(lineoffpol+EV%lmaxline) + &
                        k*EV%poltruncfac*ay(lineoffpol+EV%lmaxline-1)-(EV%lmaxline+3)*cothxor*ay(lineoffpol+EV%lmaxline)
                else
                    ayprime(lineoff:lineoffpol+EV%lmaxline)=0
                end if
            end if
        end if
    end if



    !  Massive neutrino equations of motion.
    if (State%CP%Num_Nu_massive >0) then
        !DIR$ LOOP COUNT MIN(1), AVG(1)
        do nu_i = 1, State%CP%Nu_mass_eigenstates
            if (EV%MassiveNuApprox(nu_i)) then
                !Now EV%iq0 = clx, EV%iq0+1 = clxp, EV%iq0+2 = G_1, EV%iq0+3=G_2=pinu
                !see astro-ph/0203507
                G11_t=EV%G11(nu_i)/a/a2
                G30_t=EV%G30(nu_i)/a/a2
                off_ix = EV%nu_ix(nu_i)
                w=wnu_arr(nu_i)
                ayprime(off_ix)=-k*z*(w+1) + 3*adotoa*(w*ay(off_ix) - ay(off_ix+1))-k*ay(off_ix+2)
                ayprime(off_ix+1)=(3*w-2)*adotoa*ay(off_ix+1) - 5._dl/3*k*z*w - k/3*G11_t
                ayprime(off_ix+2)=(3*w-1)*adotoa*ay(off_ix+2) - k*(2._dl/3*EV%Kf(1)*ay(off_ix+3)-ay(off_ix+1))
                ayprime(off_ix+3)=(3*w-2)*adotoa*ay(off_ix+3) + 2*w*k*sigma - k/5*(3*EV%Kf(2)*G30_t-2*G11_t)
            else
                ind=EV%nu_ix(nu_i)
                !DIR$ LOOP COUNT MIN(3), AVG(3)
                do i=1,EV%nq(nu_i)
                    q=State%NuPerturbations%nu_q(i)
                    aq=a*State%nu_masses(nu_i)/q
                    v=1._dl/sqrt(1._dl+aq*aq)

                    ayprime(ind)=-k*(4._dl/3._dl*z + v*ay(ind+1))
                    ind=ind+1
                    ayprime(ind)=v*(EV%denlk(1)*ay(ind-1)-EV%denlk2(1)*ay(ind+1))
                    ind=ind+1
                    if (EV%lmaxnu_tau(nu_i)==2) then
                        ayprime(ind)=-ayprime(ind-2) -3*cothxor*ay(ind)
                    else
                        ayprime(ind)=v*(EV%denlk(2)*ay(ind-1)-EV%denlk2(2)*ay(ind+1)) &
                            +k*8._dl/15._dl*sigma
                        do l=3,EV%lmaxnu_tau(nu_i)-1
                            ind=ind+1
                            ayprime(ind)=v*(EV%denlk(l)*ay(ind-1)-EV%denlk2(l)*ay(ind+1))
                        end do
                        !  Truncate moment expansion.
                        ind = ind+1
                        ayprime(ind)=k*v*ay(ind-1)-(EV%lmaxnu_tau(nu_i)+1)*cothxor*ay(ind)
                    end if
                    ind = ind+1
                end do
            end if
        end do

        if (EV%has_nu_relativistic) then
            ind=EV%nu_pert_ix
            ayprime(ind)=+k*a2*qr -k*ay(ind+1)
            ind2= EV%r_ix
            do l=1,EV%lmaxnu_pert-1
                ind=ind+1
                ind2=ind2+1
                ayprime(ind)= -a2*(EV%denlk(l)*ay(ind2-1)-EV%denlk2(l)*ay(ind2+1)) &
                    +   (EV%denlk(l)*ay(ind-1)-EV%denlk2(l)*ay(ind+1))
            end do
            ind=ind+1
            ind2=ind2+1
            ayprime(ind)= k*(ay(ind-1) -a2*ay(ind2-1)) -(EV%lmaxnu_pert+1)*cothxor*ay(ind)
        end if
    end if

    if (associated(EV%OutputTransfer) .or. associated(EV%OutputSources)) then
        if (EV%TightCoupling .or. EV%no_phot_multpoles) then
            E=0
            Edot=0
        else
            E = ay(EV%polind+2:EV%polind+3)
            Edot = ayprime(EV%polind+2:EV%polind+3)
        end if
        if (EV%no_nu_multpoles) then
            pirdot=0
            qrdot = -4*dz/3
        end if
        if (EV%no_phot_multpoles) then
            pigdot=0
            octg=0
            octgdot=0
            qgdot = -4*dz/3
        else
            if (EV%TightCoupling) then
                if (second_order_tightcoupling) then
                    octg = (3._dl/7._dl)*pig*(EV%k_buf/opacity)
                    E(2) = pig/4 + pigdot*(1._dl/opacity)*(-5._dl/8._dl)
                    E(3) = (3._dl/7._dl)*(EV%k_buf/opacity)*E(2)
                    Edot(2)= (pigdot/4._dl)*(1+(5._dl/2._dl)*(dopacity/opacity**2))
                else
                    pigdot = -dopacity/opacity*pig + 32._dl/45*k/opacity*(-2*adotoa*sigma  &
                        +etak/EV%Kf(1)-  dgpi/k +vbdot )
                    Edot(2) = pigdot/4
                    E(2) = pig/4
                    octg=0
                end if
                octgdot=0
            else
                octg=ay(EV%g_ix+3)
                octgdot=ayprime(EV%g_ix+3)
            end if
        end if
        if (EV%is_cosmological_constant) then
            dgrho_de=0
            dgq_de=0
        end if

        dgpi  = grhor_t*pir + grhog_t*pig
        dgpi_diff = 0  !sum (3*p_nu -rho_nu)*pi_nu
        pidot_sum = grhog_t*pigdot + grhor_t*pirdot
        clxnu =0
        if (State%CP%Num_Nu_Massive /= 0) then
            call MassiveNuVarsOut(EV,ay,ayprime,a, adotoa, dgpi=dgpi, clxnu_all=clxnu, &
                dgpi_diff=dgpi_diff, pidot_sum=pidot_sum)
        end if
        gpres = gpres_noDE + w_dark_energy_t*grhov_t
        diff_rhopi = pidot_sum - (4*dgpi+ dgpi_diff)*adotoa + &
            State%CP%DarkEnergy%diff_rhopi_Add_Term(dgrho_de, dgq_de, grho, &
            gpres, w_dark_energy_t, State%grhok, adotoa, &
            EV%kf(1), k, grhov_t, z, k2, ayprime, ay, EV%w_ix)
        phi = -((dgrho +3*dgq*adotoa/k)/EV%Kf(1) + dgpi)/(2*k2)

        if (associated(EV%OutputTransfer)) then
            EV%OutputTransfer(Transfer_kh) = k/(State%CP%h0/100._dl)
            EV%OutputTransfer(Transfer_cdm) = clxc
            EV%OutputTransfer(Transfer_b) = clxb
            EV%OutputTransfer(Transfer_g) = clxg
            EV%OutputTransfer(Transfer_r) = clxr
            EV%OutputTransfer(Transfer_nu) = clxnu
            EV%OutputTransfer(Transfer_tot) =  dgrho_matter/grho_matter !includes neutrinos
            EV%OutputTransfer(Transfer_nonu) = (grhob_t*clxb+grhoc_t*clxc)/(grhob_t + grhoc_t)
            EV%OutputTransfer(Transfer_tot_de) =  dgrho/grho_matter
            !Transfer_Weyl is k^2Phi, where Phi is the Weyl potential
            EV%OutputTransfer(Transfer_Weyl) = k2*phi
            EV%OutputTransfer(Transfer_Newt_vel_cdm)=  -k*sigma/adotoa
            EV%OutputTransfer(Transfer_Newt_vel_baryon) = -k*(vb + sigma)/adotoa
            EV%OutputTransfer(Transfer_vel_baryon_cdm) = vb
            if (State%CP%do21cm) then
                Tspin = State%CP%Recomb%T_s(a)
                xe = State%CP%Recomb%x_e(a)

                tau_eps = a*line21_const*State%NNow/a**3/adotoa/Tspin/1000
                delta_source2 = Get21cm_source2(a,clxb,clxg/4,Delta_Tm,Delta_xe,Tmat,&
                    State%CP%TCMB/a,xe,k*(z+vb)/adotoa/3)
                tau_fac = tau_eps/(exp(tau_eps)-1)
                EV%OutputTransfer(Transfer_monopole) = ( clxb + Trad/(Tspin-Trad)*delta_source2 )  &
                    + (tau_fac-1)*(clxb - (delta_source2 + clxg/4)  )

                EV%OutputTransfer(Transfer_vnewt) = tau_fac*k*(vb+sigma)/adotoa
                EV%OutputTransfer(Transfer_Tmat) =  delta_TM
                if (State%CP%SourceTerms%use_21cm_mK) then
                    Tb = (1-exp(-tau_eps))*a*(Tspin-Trad)*1000

                    EV%OutputTransfer(Transfer_monopole) = EV%OutputTransfer(Transfer_monopole)*Tb
                    EV%OutputTransfer(Transfer_vnewt) = EV%OutputTransfer(Transfer_vnewt)*Tb
                    EV%OutputTransfer(Transfer_Tmat) = EV%OutputTransfer(Transfer_Tmat)*Tb
                end if
            end if
        end if
        if (associated(EV%OutputSources)) then

            EV%OutputSources = 0
            call EV%ThermoData%IonizationFunctionsAtTime(tau, a, opacity, dopacity, ddopacity, &
                visibility, dvisibility, ddvisibility, exptau, lenswindow)

            tau0 = State%tau0
            phidot = (1.0d0/2.0d0)*(adotoa*(-dgpi - 2*k2*phi) + dgq*k - &
                diff_rhopi+ k*sigma*(gpres + grho))/k2
            !time derivative of shear
            sigmadot = -adotoa*sigma - 1.0d0/2.0d0*dgpi/k + k*phi
            !quadrupole source derivatives; polter = pi_g/10 + 3/5 E_2
            polter = pig/10+9._dl/15*E(2)
            polterdot = (1.0d0/10.0d0)*pigdot + (3.0d0/5.0d0)*Edot(2)
            polterddot = -2.0d0/25.0d0*adotoa*dgq/(k*EV%Kf(1)) - 4.0d0/75.0d0*adotoa* &
                k*sigma - 4.0d0/75.0d0*dgpi - 2.0d0/75.0d0*dgrho/EV%Kf(1) - 3.0d0/ &
                50.0d0*k*octgdot*EV%Kf(2) + (1.0d0/25.0d0)*k*qgdot - 1.0d0/5.0d0 &
                *k*EV%Kf(2)*Edot(3) + (-1.0d0/10.0d0*pig + (7.0d0/10.0d0)* &
                polter - 3.0d0/5.0d0*E(2))*dopacity + (-1.0d0/10.0d0*pigdot &
                + (7.0d0/10.0d0)*polterdot - 3.0d0/5.0d0*Edot(2))*opacity
            !Temperature source terms, after integrating by parts in conformal time

            !2phi' term (\phi' + \psi' in Newtonian gauge), phi is the Weyl potential
            ISW = 2*phidot*exptau
            monopole_source =  (-etak/(k*EV%Kf(1)) + 2*phi + clxg/4)*visibility
            doppler = ((sigma + vb)*dvisibility + (sigmadot + vbdot)*visibility)/k
            quadrupole_source = (5.0d0/8.0d0)*(3*polter*ddvisibility + 6*polterdot*dvisibility &
                + (k**2*polter + 3*polterddot)*visibility)/k**2

            EV%OutputSources(1) = ISW + doppler + monopole_source + quadrupole_source
            ang_dist = f_K(tau0-tau)
            if (tau < tau0) then
                !E polarization source
                EV%OutputSources(2)=visibility*polter*(15._dl/8._dl)/(ang_dist**2*k2)
                !factor of four because no 1/16 later
            end if

            if (size(EV%OutputSources) > 2) then
                !Get lensing sources
                if (tau>State%tau_maxvis .and. tau0-tau > 0.1_dl) then
                    EV%OutputSources(3) = -2*phi*f_K(tau-State%tau_maxvis)/(f_K(tau0-State%tau_maxvis)*ang_dist)
                    !We include the lensing factor of two here
                end if
            end if
            if (State%num_redshiftwindows > 0) then
                call output_window_sources(EV, EV%OutputSources, ay, ayprime, &
                    tau, a, adotoa, grho, gpres, &
                    k, etak, z, ayprime(ix_etak), phi, phidot, sigma, sigmadot, &
                    dgrho, clxg,clxb,clxc,clxnu, Delta_TM, Delta_xe, &
                    dgq, qg, vb, qgdot, vbdot, &
                    dgpi, pig, pigdot, diff_rhopi, &
                    polter, polterdot, polterddot, octg, octgdot, E, Edot, &
                    opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau)
            end if
            if (associated(EV%CustomSources)) then
                select type(DE=>State%CP%DarkEnergy)
                class is (TDarkEnergyEqnOfState)
                    cs2_de = DE%cs2_lam
                class default
                    cs2_de=1
                end select
                block
                    procedure(TSource_func), pointer :: custom_sources_func

                    call c_f_procpointer(CP%CustomSources%c_source_func,custom_sources_func)

                    call custom_sources_func(EV%CustomSources, tau, a, adotoa, grho, gpres,w_dark_energy_t, cs2_de, &
                        grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,grhonu_t, &
                        k, etak, ayprime(ix_etak), phi, phidot, sigma, sigmadot, &
                        dgrho, clxg,clxb,clxc,clxr,clxnu, dgrho_de/grhov_t, delta_p_b, &
                        dgq, qg, qr, dgq_de/grhov_t, vb, qgdot, qrdot, vbdot, &
                        dgpi, pig, pir, pigdot, pirdot, diff_rhopi, &
                        polter, polterdot, polterddot, octg, octgdot, E, Edot, &
                        opacity, dopacity, ddopacity, visibility, dvisibility, ddvisibility, exptau, &
                        tau0, State%tau_maxvis, EV%Kf,f_K)
                end block
            end if
        end if
    end if

    end subroutine derivs



    subroutine derivsv(EV,n,tau,yv,yvprime)
    !  Evaluate the time derivatives of the vector perturbations, flat case
    use MassiveNu
    implicit none
    type(EvolutionVars) EV
    integer n,l
    real(dl), target ::  yv(n),yvprime(n)
    real(dl) ep,tau,grho,rhopi,cs2,opacity,gpres
    logical finished_tightcoupling
    real(dl), dimension(:),pointer :: neut,neutprime,E,B,Eprime,Bprime
    real(dl)  grhob_t,grhor_t,grhoc_t,grhog_t,grhov_t,polter
    real(dl) sigma, qg,pig, qr, vb, rhoq, vbdot, photbar, pb43
    real(dl) k,k2,a,a2, adotdota
    real(dl) pir,adotoa
    real(dl) w_dark_energy_t

    k2=EV%k2_buf
    k=EV%k_buf

    !E and B start at l=2. Set up pointers accordingly to fill in y arrays
    E => yv(EV%lmaxv+3:)
    Eprime=> yvprime(EV%lmaxv+3:)
    B => E(EV%lmaxpolv:)
    Bprime => Eprime(EV%lmaxpolv:)
    neutprime => Bprime(EV%lmaxpolv+1:)
    neut => B(EV%lmaxpolv+1:)

    a=yv(1)

    sigma=yv(2)


    !  Get sound speed and opacity, and see if should use tight-coupling

    call EV%ThermoData%Values(tau,a, cs2,opacity)
    if (k > 0.06_dl*epsw) then
        ep=ep0
    else
        ep=0.2_dl*ep0
    end if
    a2=a*a

    finished_tightcoupling = &
        ((k/opacity > ep).or.(1._dl/(opacity*tau) > ep .and. k/opacity > 1d-4))


    ! Compute expansion rate from: grho=8*pi*rho*a**2
    ! Also calculate gpres: 8*pi*p*a**2
    grhob_t=State%grhob/a
    grhoc_t=State%grhoc/a
    grhor_t=State%grhornomass/a2
    grhog_t=State%grhog/a2
    call CP%DarkEnergy%BackgroundDensityAndPressure(State%grhov, a, grhov_t, w_dark_energy_t)

    grho=grhob_t+grhoc_t+grhor_t+grhog_t+grhov_t
    gpres=(grhog_t+grhor_t)/3._dl+grhov_t*w_dark_energy_t

    adotoa=sqrt(grho/3._dl)
    adotdota=(adotoa*adotoa-gpres)/2

    photbar=grhog_t/grhob_t
    pb43=4._dl/3*photbar

    yvprime(1)=adotoa*a

    vb = yv(3)
    qg = yv(4)
    qr = neut(1)

    !  8*pi*a*a*SUM[(rho_i+p_i)*v_i]
    rhoq=grhob_t*vb+grhog_t*qg+grhor_t*qr
    !  sigma = 2*rhoq/k**2
    !for non-large k this expression for sigma is unstable at early times
    !so propagate sigma equation separately (near total cancellation in rhoq)

    if (finished_tightcoupling) then
        !  Use explicit equations:

        pig = yv(5)

        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)

        vbdot = -adotoa*vb-photbar*opacity*(4._dl/3*vb-qg) - 0.5_dl*k*photbar*Magnetic

        !  Equation for the photon heat flux stress

        yvprime(4)=-0.5_dl*k*pig + opacity*(4._dl/3*vb-qg)

        !  Equation for the photon anisotropic stress
        yvprime(5)=k*(2._dl/5*qg -8/15._dl*yv(6))+8._dl/15._dl*k*sigma  &
            -opacity*(pig - polter)
        ! And for the moments
        do  l=3,EV%lmaxv-1
            yvprime(l+3)=k*denl(l)*l*(yv(l+2)-   &
                vecfac(l)*yv(l+4))-opacity*yv(l+3)
        end do
        !  Truncate the hierarchy
        yvprime(EV%lmaxv+3)=k*EV%lmaxv/(EV%lmaxv-1._dl)*yv(EV%lmaxv+2)- &
            (EV%lmaxv+2._dl)*yv(EV%lmaxv+3)/tau-opacity*yv(EV%lmaxv+3)

        !E equations

        Eprime(2) = - opacity*(E(2) - polter) + k*(1/3._dl*B(2) - 8._dl/27._dl*E(3))
        do l=3,EV%lmaxpolv-1
            Eprime(l) =-opacity*E(l) + k*(denl(l)*(l*E(l-1) - &
                vecfacpol(l)*E(l+1)) + 2._dl/(l*(l+1))*B(l))
        end do
        !truncate
        Eprime(EV%lmaxpolv)=0._dl

        !B-bar equations

        do l=2,EV%lmaxpolv-1
            Bprime(l) =-opacity*B(l) + k*(denl(l)*(l*B(l-1) - &
                vecfacpol(l)*B(l+1)) - 2._dl/(l*(l+1))*E(l))
        end do
        !truncate
        Bprime(EV%lmaxpolv)=0._dl
    else
        !Tight coupling expansion results

        pig = 32._dl/45._dl*k/opacity*(vb + sigma)

        EV%pig = pig

        vbdot=(-adotoa*vb  -3._dl/8*pb43*k*Magnetic  -3._dl/8*k*pb43*pig &
            - pb43/(1+pb43)/opacity*(0.75_dl*k*adotoa*pb43**2/(pb43+1)*Magnetic + vb*&
            ( 2*pb43*adotoa**2/(1+pb43) + adotdota)) &
            )/(1+pb43)

        !  Equation for the photon heat flux
        ! Get drag from vbdot expression
        yvprime(4)=-0.5_dl*k*pig - &
            (vbdot+adotoa*vb)/photbar - 0.5_dl*k*Magnetic

        !  Set the derivatives to zero
        yvprime(5:n)=0._dl
        yv(5)=pig
        E(2)=  pig/4
    endif

    yvprime(3) = vbdot

    !  Neutrino equations:

    !  Massless neutrino anisotropic stress
    pir=neut(2)
    neutprime(1)= -0.5_dl*k*pir
    neutprime(2)=2._dl/5*k*qr -8._dl/15._dl*k*neut(3)+ 8._dl/15._dl*k*sigma
    !  And for the moments
    do  l=3,EV%lmaxnrv-1
        neutprime(l)=k*denl(l)*l*(neut(l-1)- vecfac(l)*neut(l+1))
    end do

    !  Truncate the hierarchy
    neutprime(EV%lmaxnrv)=k*EV%lmaxnrv/(EV%lmaxnrv-1._dl)*neut(EV%lmaxnrv-1)-  &
        (EV%lmaxnrv+2._dl)*neut(EV%lmaxnrv)/tau


    !  Get the propagation equation for the shear

    rhopi=grhog_t*pig+grhor_t*pir+ grhog_t*Magnetic

    yvprime(2)=-2*adotoa*sigma -rhopi/k

    end subroutine derivsv


    subroutine derivst(EV,n,tau,ayt,aytprime)
    !  Evaluate the time derivatives of the tensor perturbations.
    use MassiveNu
    implicit none
    type(EvolutionVars) EV
    integer n,l,i,ind, nu_i
    real(dl), target ::  ayt(n),aytprime(n)
    real(dl) tau, rhopi,opacity,pirdt
    real(dl), dimension(:),pointer :: neut,neutprime,E,B,Eprime,Bprime
    real(dl) q,aq,v
    real(dl) Hchi,pinu, pig, polter
    real(dl) k,k2,a,a2,grhog_t, grhor_t
    real(dl) pir, adot, adotoa, rhonu, shear
    real(dl) cothxor

    k2=EV%k2_buf
    k= EV%k_buf

    call EV%ThermoData%Expansion_Values(tau,a, adot,opacity)

    Hchi=ayt(ixt_H)

    shear=ayt(ixt_shear)

    a2=a*a
    adotoa = adot/a

    if (State%flat) then
        cothxor=1._dl/tau
    else
        cothxor=1._dl/State%tanfunc(tau/State%curvature_radius)/State%curvature_radius
    end if

    if (.not. EV%TensTightCoupling) then
        !  Don't use tight coupling approx - use explicit equations:
        !  Equation for the photon anisotropic stress


        !E and B start at l=2. Set up pointers accordingly to fill in ayt arrays
        E => ayt(EV%E_ix+1:)
        B => ayt(EV%B_ix+1:)
        Eprime=> aytprime(EV%E_ix+1:)
        Bprime => aytprime(EV%B_ix+1:)

        ind = EV%g_ix+2

        !  Photon anisotropic stress
        pig=ayt(ind)
        polter = 0.1_dl*pig + 9._dl/15._dl*E(2)

        if (EV%lmaxt > 2) then
            aytprime(ind)=-EV%denlkt(2,2)*ayt(ind+1)+k*8._dl/15._dl*shear  &
                -opacity*(pig - polter)

            do l=3, EV%lmaxt -1
                ind = ind+1
                aytprime(ind)=EV%denlkt(1,L)*ayt(ind-1)-EV%denlkt(2,L)*ayt(ind+1)-opacity*ayt(ind)
            end do

            !Truncate the hierarchy
            ind=ind+1
            aytprime(ind)=k*EV%lmaxt/(EV%lmaxt-2._dl)*ayt(ind-1)- &
                (EV%lmaxt+3._dl)*cothxor*ayt(ind)-opacity*ayt(ind)

            !E and B-bar equations

            Eprime(2) = - opacity*(E(2) - polter) + EV%denlkt(4,2)*B(2) - &
                EV%denlkt(3,2)*E(3)

            do l=3, EV%lmaxpolt-1
                Eprime(l) =(EV%denlkt(1,L)*E(l-1)-EV%denlkt(3,L)*E(l+1) + EV%denlkt(4,L)*B(l)) &
                    -opacity*E(l)
            end do
            l= EV%lmaxpolt
            !truncate: difficult, but setting l+1 to zero seems to work OK
            Eprime(l) = (EV%denlkt(1,L)*E(l-1) + EV%denlkt(4,L)*B(l)) -opacity*E(l)

            Bprime(2) =-EV%denlkt(3,2)*B(3) - EV%denlkt(4,2)*E(2)  -opacity*B(2)
            do l=3, EV%lmaxpolt-1
                Bprime(l) =(EV%denlkt(1,L)*B(l-1) -EV%denlkt(3,L)*B(l+1) - EV%denlkt(4,L)*E(l)) &
                    -opacity*B(l)
            end do
            l=EV%lmaxpolt
            !truncate
            Bprime(l) =(EV%denlkt(1,L)*B(l-1) - EV%denlkt(4,L)*E(l))  -opacity*B(l)

        else !lmax=2
            aytprime(ind)=k*8._dl/15._dl*shear-opacity*(pig - polter)
            Eprime(2) = - opacity*(E(2) - polter) + EV%denlkt(4,2)*B(2)
            Bprime(2) = - EV%denlkt(4,2)*E(2)  -opacity*B(2)
        end if

    else  !Tight coupling
        pig = 32._dl/45._dl*k/opacity*shear
    endif
    grhor_t=State%grhornomass/a2
    grhog_t=State%grhog/a2

    rhopi=grhog_t*pig

    !  Neutrino equations:
    !  Anisotropic stress
    if (DoTensorNeutrinos) then
        neutprime => aytprime(EV%r_ix+1:)
        neut => ayt(EV%r_ix+1:)

        !  Massless neutrino anisotropic stress
        pir=neut(2)

        rhopi=rhopi+grhor_t*pir

        if (EV%lmaxnrt>2) then
            pirdt=-EV%denlkt(2,2)*neut(3) + 8._dl/15._dl*k*shear
            neutprime(2)=pirdt
            !  And for the moments
            do  l=3, EV%lmaxnrt-1
                neutprime(l)= EV%denlkt(1,L)*neut(l-1) -EV%denlkt(2,L)*neut(l+1)
            end do

            !  Truncate the hierarchy
            neutprime(EV%lmaxnrt)=k*EV%lmaxnrt/(EV%lmaxnrt-2._dl)*neut(EV%lmaxnrt-1)-  &
                (EV%lmaxnrt+3._dl)*cothxor*neut(EV%lmaxnrt)
        else
            pirdt= 8._dl/15._dl*k*shear
            neutprime(2)=pirdt
        end if

        !  Massive neutrino equations of motion and contributions to anisotropic stress.
        if (State%CP%Num_Nu_massive > 0) then
            do nu_i=1,State%CP%Nu_mass_eigenstates
                if (.not. EV%EvolveTensorMassiveNu(nu_i)) then
                    rhopi=rhopi+ State%grhormass(nu_i)/a2*pir !- good approx, note no rhonu weighting
                else
                    ind=EV%nu_ix(nu_i)+2

                    pinu= Nu_pi(EV, ayt, a, nu_i)
                    rhopi=rhopi+ State%grhormass(nu_i)/a2*pinu

                    do i=1,State%NuPerturbations%nqmax
                        q=State%NuPerturbations%nu_q(i)
                        aq=a*State%nu_masses(nu_i)/q
                        v=1._dl/sqrt(1._dl+aq*aq)
                        if (EV%lmaxnut>2) then
                            aytprime(ind)=-v*EV%denlkt(2,2)*ayt(ind+1)+8._dl/15._dl*k*shear
                            do l=3,EV%lmaxnut-1
                                ind=ind+1
                                aytprime(ind)=v*(EV%denlkt(1,L)*ayt(ind-1)-EV%denlkt(2,L)*ayt(ind+1))
                            end do
                            ind = ind+1
                            !Truncate moment expansion.
                            aytprime(ind)=k*v*EV%lmaxnut/(EV%lmaxnut-2._dl)*ayt(ind-1)-(EV%lmaxnut+3)*cothxor*ayt(ind)
                        else
                            aytprime(ind)=8._dl/15._dl*k*shear
                        end if
                        ind=ind+1
                    end do
                end if
            end do
        end if
    end if

    !  Get the propagation equation for the shear

    if (State%flat) then
        aytprime(ixt_shear)=-2*adotoa*shear+k*Hchi-rhopi/k
    else
        aytprime(ixt_shear)=-2*adotoa*shear+k*Hchi*(1+2*State%curv/k2)-rhopi/k
    endif

    aytprime(ixt_H)=-k*shear

    end subroutine derivst

    end module GaugeInterface

    module RandUtils
    use MpiUtils
    implicit none

    integer :: rand_inst = 0
    integer, parameter :: krand = KIND(1.d0)
    integer :: Rand_Feedback = 1

    interface RandRotation
    module procedure RandRotationS, RandRotationD
    end interface

    contains


    !subroutine init_random_seed()
    !integer, allocatable :: seed(:)
    !integer :: i, n, un, istat, dt(8), pid, t(2), s
    !integer(8) :: count, tms
    !
    !call random_seed(size = n)
    !allocate(seed(n))
    !! First try if the OS provides a random number generator
    !! Fallback to XOR:ing the current time and pid. The PID is
    !! useful in case one launches multiple instances of the same
    !! program in parallel.
    !call system_clock(count)
    !if (count /= 0) then
    !    t = transfer(count, t)
    !else
    !    call date_and_time(values=dt)
    !    tms = (dt(1) - 1970) * 365_8 * 24 * 60 * 60 * 1000 &
    !    + dt(2) * 31_8 * 24 * 60 * 60 * 1000 &
    !    + dt(3) * 24 * 60 * 60 * 60 * 1000 &
    !    + dt(5) * 60 * 60 * 1000 &
    !    + dt(6) * 60 * 1000 + dt(7) * 1000 &
    !    + dt(8)
    !    t = transfer(tms, t)
    !end if
    !s = ieor(t(1), t(2))
    !pid = getpid() + 1099279 ! Add a prime
    !s = ieor(s, pid)
    !if (n >= 3) then
    !    seed(1) = t(1) + 36269
    !    seed(2) = t(2) + 72551
    !    seed(3) = pid
    !    if (n > 3) then
    !        seed(4:) = s + 37 * (/ (i, i = 0, n - 4) /)
    !    end if
    !else
    !    seed = s + 37 * (/ (i, i = 0, n - 1 ) /)
    !end if
    !call random_seed(put=seed)
    !end subroutine init_random_seed



    subroutine initRandom(i, i2)
    implicit none
    integer, optional, intent(in) :: i
    integer, optional, intent(in) :: i2
    integer seed_in,kl,ij
    character(len=10) :: fred
    real(krand) :: klr

    if (present(i)) then
        seed_in = i
    else
        seed_in = -1
    end if
    if (seed_in /=-1) then
        if (present(i2)) then
            kl=i2
            if (i2 > 30081) call MpiStop('initRandom:second seed too large')
        else
            kl = 9373
        end if
        ij = i
    else
        call system_clock(count=ij)
        ij = mod(ij + rand_inst*100, 31328)
        call date_and_time(time=fred)
        read (fred,'(e10.3)') klr
        kl = mod(int(klr*1000), 30081)
    end if

    if (Rand_Feedback > 0 ) write(*,'(" Random seeds:",1I6,",",1I6," rand_inst:",1I4)') ij,kl,rand_inst
    call rmarin(ij,kl)

    end subroutine initRandom

    subroutine RandIndices(indices, nmax, n)
    integer, intent(in) :: nmax, n
    integer indices(n),i, ix
    integer tmp(nmax)

    if (n> nmax) call MpiStop('Error in RandIndices, n > nmax')
    do i=1, nmax
        tmp(i)=i
    end do
    do i=1, n
        ix = int(ranmar()*(nmax +1 -i)) + 1
        indices(i) = tmp(ix)
        tmp(ix) = tmp(nmax+1-i)
    end do

    end subroutine RandIndices

    subroutine RandRotationS(R, N)
    !this is most certainly not the world's most efficient or robust random rotation generator
    integer, intent(in) :: N
    real R(N,N), vec(N), norm
    integer i,j

    do j = 1, N
        do
            do i = 1, N
                vec(i) = real(Gaussian1())
            end do
            do i = 1, j-1
                vec = vec - sum(vec*R(i,:))*R(i,:)
            end do
            norm = sum(vec**2)
            if (norm > 1e-3) exit
        end do
        R(j,:) = vec / sqrt(norm)
    end do

    end subroutine RandRotationS


    subroutine RandRotationD(R, N)
    !this is most certainly not the world's most efficient or robust random rotation generator
    integer, intent(in) :: N
    double precision R(N,N), vec(N), norm
    integer i,j

    do j = 1, N
        do
            do i = 1, N
                vec(i) = Gaussian1()
            end do
            do i = 1, j-1
                vec = vec - sum(vec*R(i,:))*R(i,:)
            end do
            norm = sum(vec**2)
            if (norm > 1e-3) exit
        end do
        R(j,:) = vec / sqrt(norm)
    end do

    end subroutine RandRotationD


    double precision function GAUSSIAN1()
    implicit none
    double precision R, V1, V2, FAC
    integer, save :: iset = 0
    double precision, save :: gset

    !Box muller
    if (ISET==0) then
        R=2
        do while (R >= 1.d0)
            V1=2.d0*ranmar()-1.d0
            V2=2.d0*ranmar()-1.d0
            R=V1**2+V2**2
        end do
        FAC=sqrt(-2.d0*log(R)/R)
        GSET=V1*FAC
        GAUSSIAN1=V2*FAC
        ISET=1
    else
        GAUSSIAN1=GSET
        ISET=0
    endif
    end function GAUSSIAN1


    double precision function CAUCHY1()
    implicit none

    Cauchy1 = Gaussian1()/max(1d-15,abs(Gaussian1()))

    end function CAUCHY1


    real function RANDEXP1()
    !
    !     Random-number generator for the exponential distribution
    !     Algorithm EA from J. H. Ahrens and U. Dieter,
    !     Communications of the ACM, 31 (1988) 1330--1337.
    !     Coded by K. G. Hamilton, December 1996, with corrections.
    !
    real u, up, g, y

    real, parameter ::   alog2= 0.6931471805599453
    real, parameter ::      a = 5.7133631526454228
    real, parameter ::      b = 3.4142135623730950
    real, parameter ::     c = -1.6734053240284925
    real, parameter ::      p = 0.9802581434685472
    real, parameter ::     aa = 5.6005707569738080
    real, parameter ::     bb = 3.3468106480569850
    real, parameter ::     hh = 0.0026106723602095
    real, parameter ::     dd = 0.0857864376269050

    u = ranmar()
    do while (u<=0)                 ! Comment out this block
        u = ranmar()                    ! if your RNG can never
    enddo                             ! return exact zero
    g = c
    u = u+u
    do while (u<1.0)
        g = g + alog2
        u = u+u
    enddo
    u = u-1.0
    if (u<=p) then
        randexp1 = g + aa/(bb-u)
        return
    endif
    do
        u = ranmar()
        y = a/(b-u)
        up = ranmar()
        if ((up*hh+dd)*(b-u)**2 <= exp(-(y+c))) then
            randexp1 = g+y
            return
        endif
    enddo

    end function RANDEXP1


    ! This random number generator originally appeared in ''Toward a Universal
    ! Random Number Generator'' by George Marsaglia and Arif Zaman.
    ! Florida State University Report: FSU-SCRI-87-50 (1987)
    !
    ! It was later modified by F. James and published in ''A Review of Pseudo-
    ! random Number Generators''
    !
    ! THIS IS THE BEST KNOWN RANDOM NUMBER GENERATOR AVAILABLE.
    !    (However, a newly discovered technique can yield
    !        a period of 10^600. But that is still in the development stage.)
    !
    ! It passes ALL of the tests for random number generators and has a period
    !   of 2^144, is completely portable (gives bit identical results on all
    !   machines with at least 24-bit mantissas in the floating point
    !   representation).
    !
    ! The algorithm is a combination of a Fibonacci sequence (with lags of 97
    !   and 33, and operation "subtraction plus one, modulo one") and an
    !   "arithmetic sequence" (using subtraction).
    !
    ! On a Vax 11/780, this random number generator can produce a number in
    !    13 microseconds.
    !========================================================================
    !
    !      PROGRAM TstRAN
    !     INTEGER IJ, KL, I
    ! Thee are the seeds needed to produce the test case results
    !      IJ = 1802
    !      KL = 9373
    !
    !
    ! Do the initialization
    !      call rmarin(ij,kl)
    !
    ! Generate 20000 random numbers
    !      do 10 I = 1, 20000
    !         x = RANMAR()
    !10    continue
    !
    ! If the random number generator is working properly, the next six random
    !    numbers should be:
    !          6533892.0  14220222.0  7275067.0
    !    6172232.0  8354498.0   10633180.0
    !
    !
    !
    !      write(6,20) (4096.0*4096.0*RANMAR(), I=1,6)
    !20    format (3f12.1)
    !      end
    !
    subroutine RMARIN(IJ,KL)
    ! This is the initialization routine for the random number generator RANMAR()
    ! NOTE: The seed variables can have values between:    0 <= IJ <= 31328
    !                                                      0 <= KL <= 30081
    !The random number sequences created by these two seeds are of sufficient
    ! length to complete an entire calculation with. For example, if sveral
    ! different groups are working on different parts of the same calculation,
    ! each group could be assigned its own IJ seed. This would leave each group
    ! with 30000 choices for the second seed. That is to say, this random
    ! number generator can create 900 million different subsequences -- with
    ! each subsequence having a length of approximately 10^30.
    !
    ! Use IJ = 1802 & KL = 9373 to test the random number generator. The
    ! subroutine RANMAR should be used to generate 20000 random numbers.
    ! Then display the next six random numbers generated multiplied by 4096*4096
    ! If the random number generator is working properly, the random numbers
    !    should be:
    !           6533892.0  14220222.0  7275067.0
    !           6172232.0  8354498.0   10633180.0
    double precision U(97), C, CD, CM, S, T
    integer I97, J97,i,j,k,l,m
    integer ij,kl
    integer ii,jj


    !      INTEGER IRM(103)

    common /RASET1/ U, C, CD, CM, I97, J97
    if( IJ < 0  .or.  IJ > 31328  .or. &
        KL < 0  .or.  KL > 30081 ) then
    print '(A)', ' The first random number seed must have a value  between 0 and 31328'
    print '(A)',' The second seed must have a value between 0 and   30081'
    call MpiStop('Error in RMARIN')
    endif
    I = mod(IJ/177, 177) + 2
    J = mod(IJ    , 177) + 2
    K = mod(KL/169, 178) + 1
    L = mod(KL,     169)
    do II = 1, 97
        S = 0.0
        T = 0.5
        do JJ = 1, 24
            M = mod(mod(I*J, 179)*K, 179)
            I = J
            J = K
            K = M
            L = mod(53*L+1, 169)
            if (mod(L*M, 64) >= 32) then
                S = S + T
            endif
            T = 0.5 * T
3           continue
        end do
        U(II) = S
2       continue
    end do
    C = 362436.0 / 16777216.0
    CD = 7654321.0 / 16777216.0
    CM = 16777213.0 /16777216.0
    I97 = 97
    J97 = 33

    end subroutine RMARIN

    double precision function RANMAR()
    ! This is the random number generator proposed by George Marsaglia in
    ! Florida State University Report: FSU-SCRI-87-50
    ! It was slightly modified by F. James to produce an array of pseudorandom
    ! numbers.
    double precision U(97), C, CD, CM
    integer I97, J97
    double precision uni

    common /RASET1/ U, C, CD, CM, I97, J97
    !      INTEGER IVEC
    UNI = U(I97) - U(J97)
    if( UNI < 0.0 ) UNI = UNI + 1.0
    U(I97) = UNI
    I97 = I97 - 1
    if(I97 == 0) I97 = 97
    J97 = J97 - 1
    if(J97 == 0) J97 = 97
    C = C - CD
    if( C < 0.d0 ) C = C + CM
    UNI = UNI - C
    if( UNI < 0.d0 ) UNI = UNI + 1.0 ! bug?
    RANMAR = UNI

    end function RANMAR


    end module RandUtils

#!/bin/bash

if [[ `uname` == "Linux" ]] && [[ "${GFORTRAN}" != "gfortran" ]]; then
    ln -s ${GFORTRAN} ${BUILD_PREFIX}/bin/gfortran
fi

rm -rf forutils

if [[ ${target_platform} == "osx-arm64" ]]; then
    # help it find the right compiler
    export F90C=${F90}
    rm -f ${BUILD_PREFIX}/bin/gfortran
    ln -s ${F90} ${BUILD_PREFIX}/bin/gfortran
fi

${PYTHON} setup.py build_cluster

${PYTHON} -m pip install . -vv --no-deps --install-option="--skip-build"
